/*************************************************************************
 *
 *  $RCSfile: demo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif

#pragma hdrstop

#define DEMO_IMPL
#include "demo.hxx"
#include "svtools.hrc"
#include "reginfo.hxx"
#include "svtdata.hxx"


#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SHL_HXX //autogen
#include <tools/shl.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#include <tools/datetime.hxx>

#ifndef _RC_HXX //autogen
#include <vcl/rc.hxx>
#endif

#ifndef _BITMAP_HXX //autogen
#include <vcl/bitmap.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _OUTDEV_HXX //autogen
#include <vcl/outdev.hxx>
#endif


#include "iniprop.hxx"
#include "iniman.hxx"

#ifndef _SVTOOLS_TTPROPS_HXX
#include <ttprops.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#include <tools/urlobj.hxx>

#include "pver.hxx"

const sal_Char pSpoilString[] = "TestVersion";

SV_IMPL_PTRARR(DemoAppDataArr_Impl, DemoAppDataPtr_Impl);

// #define ___DO_REGDATABASE_CHECK					1

#define ___SFX_SID_ONLINE_REGISTRATION 			6537
#define ___SFX_SID_ONLINE_REGISTRATION_DLG		6540
#define ___SFX_SID_OFFICE_INVALIDATE_TITLE		6609

///////////////////////////////////////////////////////////////////////////////
//
//		LimitedDialog_Impl
//

class LimitedDialog_Impl : public ModalDialog
{
	FixedImage		_aLogo;
	FixedText		_aTopInfo;
	FixedText		_aInfo;
	FixedLine 		_aFixedLine;

	OKButton		_aOKBtn;
	CancelButton	_aCancelBtn;
	HelpButton		_aHelpBtn;

	String 			_aDays;
	String 			_aDay;
public:
		LimitedDialog_Impl( Window* pParent );

	void 		SetLimitedDate(const Date& rDate);
};

LimitedDialog_Impl::LimitedDialog_Impl( Window* pParent ) :
		ModalDialog			( pParent, SvtResId( RID_LIMITED_DIALOG ) ),
		_aLogo				( this, ResId( 1 ) ),
		_aTopInfo			( this, ResId( 2 ) ),
		_aInfo				( this, ResId( 3 ) ),
		_aFixedLine			( this, ResId( 9 ) ),
		_aOKBtn				( this, ResId( 7 ) ),
		_aCancelBtn			( this, ResId( 8 ) ),
		_aHelpBtn			( this, ResId( 10 ) ),
		_aDays				( ResId( 5 ) ),
		_aDay				( ResId( 6 ) )
{
	FreeResource();
}

void LimitedDialog_Impl::SetLimitedDate(const Date& rDate)
{
	XubString aText( _aTopInfo.GetText() );

	aText.SearchAndReplace( UniString::CreateFromAscii("%1"),
							Application::GetAppInternational().GetDate(rDate) );

	DateTime	aLimitedDate( rDate, Time(0,0,0) );
	Date		aDate;
	DateTime	aToday( aDate, Time(0,0,0) );
	Date 		aBaseDate(1, 1, 1990);

	ULONG		nSec = aLimitedDate.GetSecFromDateTime(aBaseDate) - aToday.GetSecFromDateTime(aBaseDate);
	USHORT 		nDays = (USHORT)(nSec / 86400);

	aText.SearchAndReplace( UniString::CreateFromAscii("%2"), nDays );
	aText.SearchAndReplace( UniString::CreateFromAscii("%3"), nDays == 1 ? _aDay : _aDays );

	_aTopInfo.SetText( aText );
}


///////////////////////////////////////////////////////////////////////////////
//
//		RegisterDialog_Impl
//

class RegisterDialog_Impl : public ModalDialog
{
	friend long CheckButtonImpl( void*, void*);
	FixedImage	 _aLogo;
	FixedText    _aDescription;
	FixedLine    _aUpperFixedLine;
	FixedText    _aCustomerNrFT;
	Edit         _aCustomerNr;
	FixedText    _aEnableKeyFT;
	PatternField _aEnableKey;
	FixedLine    _aLowerFixedLine;
	OKButton     _aRegister;
	CancelButton _aTryBuy;
public:
		RegisterDialog_Impl( Window* pParent );

	String   GetEnableKey() const;
	String   GetCustomerNr() const { return _aCustomerNr.GetText(); }
};

long CheckButtonImpl( void* pObj, void* )
{
	RegisterDialog_Impl* pThis = (RegisterDialog_Impl*)pObj;
	XubString aPALK(pThis->GetEnableKey());
	XubString aCustNr(pThis->GetCustomerNr());
	if( !aCustNr.Len() )
		aCustNr = UniString::CreateFromAscii("nothing");

	BOOL bEnable = aPALK.Len() && SvDemo::CheckPALK(aPALK, aCustNr);
	pThis->_aRegister.Enable( bEnable );

	return 0;
}

RegisterDialog_Impl::RegisterDialog_Impl( Window* pParent )
	: ModalDialog			( pParent, SvtResId( RID_REGISTER_DIALOG ) ),
	  _aLogo				( this, ResId( 12 ) ),
	  _aDescription			( this, ResId( 1 ) ),
	  _aUpperFixedLine		( this, ResId( 2 ) ),
	  _aCustomerNrFT		( this, ResId( 10 ) ),
	  _aCustomerNr			( this, ResId( 11 ) ),
	  _aEnableKeyFT			( this, ResId( 5 ) ),
	  _aEnableKey			( this, ResId( 6 ) ),
	  _aLowerFixedLine		( this, ResId( 7 ) ),
	  _aRegister			( this, ResId( 8 ) ),
	  _aTryBuy				( this, ResId( 9 ) )
{
	FreeResource();
	CheckButtonImpl( this, 0 );

	SfxAppIniManagerProperty aProp;
	GetpApp()->Property( aProp );
	SfxIniManager* pMgr = aProp.GetIniManager();
	if( pMgr )
		_aCustomerNr.SetText( pMgr->Get(SFX_KEY_CUSTOMERNUMBER) );

	_aEnableKey.SetMask( ByteString("CCCCLCCCCLCCCCCCLCCCCCCLCCCCLCCCC"),
						 UniString::CreateFromAscii("    -    -      -      -    -    ") );

	_aEnableKey.SetStyle( _aEnableKey.GetStyle() | WB_NOHIDESELECTION );
	_aEnableKey.SetStrictFormat( TRUE );

	Font aFont = System::GetStandardFont( STDFONT_FIXED );
	aFont.SetSize( _aEnableKey.GetPointFont().GetSize() );
	_aEnableKey.SetControlFont( aFont );
	_aCustomerNr.SetControlFont( aFont );

	long nWidth = _aEnableKey.GetTextWidth( _aEnableKey.GetLiteralMask() );
	_aEnableKey.SetPosSizePixel( 0, 0, nWidth+12, 0, WINDOW_POSSIZE_WIDTH );
	_aCustomerNr.SetPosSizePixel( 0, 0, nWidth+12, 0, WINDOW_POSSIZE_WIDTH );

	_aCustomerNr.SetModifyHdl(Link(this, &CheckButtonImpl));
	_aEnableKey.SetModifyHdl(Link(this, &CheckButtonImpl));
}

String RegisterDialog_Impl::GetEnableKey() const
{
	XubString aRet( _aEnableKey.GetText() );
	while( aRet.SearchAndReplace( UniString::CreateFromAscii("-"), UniString::CreateFromAscii("")) != STRING_NOTFOUND )
		;
	aRet.EraseTrailingChars();
	aRet.EraseLeadingChars();
	return aRet;
}

///////////////////////////////////////////////////////////////////////////////
//
//		DemoData_Impl
//

DemoData_Impl::DemoData_Impl( BOOL bAuth, const ByteString &rPath,
							  const ByteString& rGroup, const UniString* pApp )
{
	aGroup	= rGroup;
	aPath	= rPath;

	BOOL bLoadErr = !Load(bAuth);

	if( bAuth )
	{
		BOOL bSave=FALSE;
		USHORT nCount = aDemoAppDataArr.Count();
		for( USHORT n=0; n<nCount; n++ )
		{
			DemoAppData_Impl* pLineData = aDemoAppDataArr[n];

			UniString aUNISysName( UniString::CreateFromAscii(pLineData->aSystemName.GetBuffer() ) );
			BOOL bIsApp = !pApp || pApp->CompareTo(aUNISysName) == COMPARE_EQUAL;

			if(pLineData->nCalcSum!=pLineData->nLoadSum)
			{
				pLineData->nDemoKind=SFX_DEMOKIND_INVALID;
				continue;
			}
			if(pLineData->aInvalidateDay==Date(0,0,0))
			{
				Date aDate;
				aDate+=pLineData->nDaysToRun;
				pLineData->aInvalidateDay=aDate;
				pLineData->bSaveSum=TRUE;
				bSave=TRUE;
			}
			if( pLineData->nDemoKind==SFX_DEMOKIND_TRYBUY &&
				pLineData->aInvalidateDay <= Date() && bIsApp )
			{
				pLineData->nDemoKind=SFX_DEMOKIND_OLDTRYBUY;
				pLineData->bSaveSum=TRUE;
				bSave=TRUE;
			}
			else if( pLineData->nDemoKind == SFX_DEMOKIND_OLDTRYBUY && bIsApp )
			{
				pLineData->bSaveSum=TRUE;
				pLineData->nDemoKind = SFX_DEMOKIND_INVALID;
				bSave = TRUE;
			}
			if( pLineData->nDemoKind == SFX_DEMOKIND_TRYBUY &&
				pLineData->aInvalidateDay -
				pLineData->nDaysToRun > Date() )
			{
				pLineData->nDemoKind=SFX_DEMOKIND_INVALID;
				bSave=TRUE;
			}
		}

		DemoAppData_Impl *pData = GetDemoData( ByteString(pSpoilString) );
		if( !pData || pData->nDemoKind==SFX_DEMOKIND_INVALID )
		{
			for(USHORT i=0; i<nCount; i++)
				aDemoAppDataArr[i]->nDemoKind=SFX_DEMOKIND_INVALID;
			bSave = TRUE;
		}

		if( bSave && !Save(FALSE) || bLoadErr)
			for( USHORT i=0; i<nCount; i++)
				aDemoAppDataArr[i]->nDemoKind=SFX_DEMOKIND_INVALID;
	}
	else
		Save(TRUE);
}

DemoAppData_Impl *DemoData_Impl::GetDemoData(const ByteString& aSystemName)
{
	USHORT nCount=aDemoAppDataArr.Count();
	for(USHORT n=0;n<nCount;n++)
	{
		DemoAppData_Impl* pLineData=aDemoAppDataArr[n];
		if(aSystemName.CompareTo(pLineData->aSystemName)==COMPARE_EQUAL)
			return pLineData;
	}
	return 0;
}

BOOL DemoData_Impl::Save(BOOL bCreateSum)
{
	INetURLObject aObj( String::CreateFromAscii( aPath.GetBuffer() ), INET_PROT_FILE );
	aObj.insertName( String::CreateFromAscii( aGroup.GetBuffer() ) );
	SvFileStream aStream( aObj.PathToFileName(), STREAM_STD_WRITE | STREAM_TRUNC );

	if( ERRCODE_NONE != aStream.GetError() || !aStream.IsWritable() )
		return FALSE;

#ifdef ___DO_REGDATABASE_CHECK
	RegInfo aRegInfo;
	aRegInfo.SetAppGroup( aGroup );
#endif

	USHORT nCount( aDemoAppDataArr.Count() );
	ByteString aLine;
	for(USHORT n=0; n<nCount; n++)
	{
		const DemoAppData_Impl& rLineData = *aDemoAppDataArr[n];
		aLine=':';
		aLine += rLineData.aSystemName;	aLine += ':';
		aLine += rLineData.nDemoKind;	aLine += ':';
		aLine += rLineData.nDaysToRun; 	aLine += ':';

		const Date &rDate=rLineData.aInvalidateDay;
		aLine += rDate.GetDay();		aLine += ':';
		aLine += rDate.GetMonth();		aLine += ':';
		aLine += rDate.GetYear();

		if( bCreateSum || rLineData.bSaveSum )
			aLine.Insert( CalcSum(aLine),0 );
		else
			aLine.Insert( rLineData.nLoadSum,0 );

		#ifdef ___DO_REGDATABASE_CHECK
		aRegInfo.WriteKey(rLineData.aSystemName, aLine);
		#endif

		aStream.WriteLine( aLine );
		aLine.Erase();
	}
	return TRUE;
}

UINT32 DemoData_Impl::CalcSum(const ByteString &rStr) const
{
	UINT32 nSum=0;
	const USHORT nLen=rStr.Len();
	const int nStart=rStr.Search(':');
	if(nStart!=STRING_NOTFOUND)
		for(USHORT n=nStart+1;n<nLen;n++)
		{
			nSum += rStr.GetChar(n)  % 't';
			nSum += (rStr.GetChar(n) % 'l') * (UINT32)'t';
			nSum += (rStr.GetChar(n) % 'x') * (UINT32)'t' * 'l';
		}
	return nSum;
}

BOOL DemoData_Impl::Load(BOOL bCheckReg)
{
	ByteString aLine;
	BOOL bWriteInfo = FALSE;

	// Wenn noch keine RegInfo da, Reginfo schreiben
#ifdef ___DO_REGDATABASE_CHECK
	RegInfo aRegInfo;
	aRegInfo.SetAppGroup( aGroup );
	if( !aRegInfo.GetKeyCount() && bCheckReg)
		bWriteInfo = TRUE;
#endif

	INetURLObject aObj( String::CreateFromAscii( aPath.GetBuffer() ), INET_PROT_FILE );
	aObj.insertName( UniString::CreateFromAscii( aGroup.GetBuffer() ) );
	SvFileStream aStream( aObj.PathToFileName(), STREAM_STD_READ );

	if ( aStream.GetError() )
		return FALSE;
	while ( !aStream.IsEof() )
	{
		if ( !aStream.ReadLine( aLine ) )
			break;
		DemoAppData_Impl* pLineData = new DemoAppData_Impl;

		BOOL bStop = FALSE;
		while( TRUE )
		{
			USHORT nCount=aLine.GetTokenCount(':');
			if(nCount<7)
			{
				delete pLineData;
				bStop = TRUE;
				break;
			}

			pLineData->nCalcSum		= CalcSum( aLine );
			pLineData->nLoadSum		= aLine.GetToken(0,':').ToInt32();
			pLineData->aSystemName	= aLine.GetToken(1,':');

			#ifdef ___DO_REGDATABASE_CHECK
			if( bWriteInfo )
			{
				aRegInfo.WriteKey( pLineData->aSystemName, aLine );
			}
			else
			{
				if( bCheckReg )
				{

					String aRegString = aRegInfo.ReadKey( pLineData->aSystemName );
					// Falls nicht an der Pruefsumme gedreht wurde Eintrag aus
					// der Ini nehmen
					if( pLineData->nCalcSum == pLineData->nLoadSum )
					{
						aLine = aRegString;
						bCheckReg = FALSE;
						continue;
					}
				}
			}
			#endif
			break;
		}

		// Continue ^ 2
		if( bStop ) continue;

		pLineData->nDemoKind	= aLine.GetToken(2,':').ToInt32();
		pLineData->nDaysToRun	= aLine.GetToken(3,':').ToInt32();
		pLineData->bSaveSum		= FALSE;

		USHORT nDay		= aLine.GetToken(4,':').ToInt32();
		USHORT nMonth	= aLine.GetToken(5,':').ToInt32();
		USHORT nYear	= aLine.GetToken(6,':').ToInt32();

		pLineData->aInvalidateDay=Date( nDay, nMonth, nYear );
		aDemoAppDataArr.Insert( pLineData, aDemoAppDataArr.Count() );
	}
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//
//		SvDemo_Impl
//

Timer* SvDemo_Impl::pRestartTimer		= NULL;
DemoArg_Impl* SvDemo_Impl::pSaveArg		= NULL;

SvDemo_Impl::~SvDemo_Impl()
{
	pConfig->Flush();

	delete pConfig;
	delete pDemoData;
}

DemoData_Impl& SvDemo_Impl::GetDemoData()
{
	if( !pDemoData )
	{
		DBG_ASSERT( aGroup.Len(), "Bitte Group setzen (TLX fragen)" );
		INetURLObject aObj;
		aObj.SetSmartProtocol( INET_PROT_FILE );
		if ( aDemoDataDir.Len() )
			aObj.SetSmartURL( aDemoDataDir );
		else
		{
			SfxAppIniManagerProperty aProp;
			GetpApp()->Property( aProp );
			if ( aProp.GetIniManager() )
				aObj.SetSmartURL( aProp.GetIniManager()->SubstPathVars( UniString::CreateFromAscii("$(user)") ) );
			else
			{
				aObj.SetSmartURL( Application::GetAppFileName() );
				aObj.removeSegment();
			}
		}
#if defined(MAC)
		aObj.insertName( UniString::CreateFromAscii( "shared" ) );
#endif
#if defined(UNX)
		aObj.insertName( UniString::CreateFromAscii( "bin" ) );
#endif
		String aAppName = Application::GetAppName();
		ByteString aBStr( aObj.PathToFileName(), osl_getThreadTextEncoding() );
		ByteString aBGroup( aGroup, osl_getThreadTextEncoding() );
		pDemoData = new DemoData_Impl( TRUE, aBStr, aBGroup, &aAppName );
	}
	return *pDemoData;
}

Config& SvDemo_Impl::GetRegistryConfig()
{
	if( !pConfig )
	{
		String* pPath = NULL;
		if( aConfigDir.Len() )
			pPath = &aConfigDir;
		pConfig = SvDemo::GetNewAuthConfig(pPath);
	}
	return *pConfig;
}

IMPL_STATIC_LINK( SvDemo_Impl, RestartHdl, void*, EMPTYARG )
{
	delete pRestartTimer;
	pRestartTimer = NULL;

	Application::PostUserEvent( STATIC_LINK( pThis, SvDemo_Impl, ShowMessage ), pSaveArg );
	return 0;
}

IMPL_STATIC_LINK( SvDemo_Impl, ShowMessage, DemoArg_Impl*, pArg )
{
	if( Application::IsInModalMode() )
	{
		pSaveArg = pArg;
		if( !pRestartTimer )
			pRestartTimer = new Timer;

		pRestartTimer->SetTimeout( 10 );
		pRestartTimer->SetTimeoutHdl( STATIC_LINK(pThis, SvDemo_Impl, RestartHdl) );
		pRestartTimer->Start();

		return 0;
	}

	BOOL bQuit = FALSE;

	switch( pArg->eResponse )
	{
		case DEMO_INVALID:
		{
			InfoBox( NULL, String( SvtResId( STR_INVALIDTRYBUY ) ) ).Execute();
			bQuit = TRUE;
			break;
		}
		case DEMO_OLDTRYBUY:
		{
			String aStr( SvtResId( STR_TRYBUY ) );

			ByteString aBStr( pArg->aSystem, osl_getThreadTextEncoding() );
			DemoAppData_Impl* pDemo = pThis->GetDemoData().GetDemoData( aBStr );
			aStr.SearchAndReplace( UniString::CreateFromAscii("$(ARG)"),
								   Application::GetAppInternational().GetDate(pDemo->aInvalidateDay) );

			InfoBox( NULL, aStr ).Execute();
			bQuit = FALSE;
			break;
		}
		case DEMO_EXPIREDTRYBUY:
		{
			InfoBox( NULL, String( SvtResId( STR_OLDTRYBUY ) ) ).Execute();
			bQuit = FALSE;
			break;
		}
		case DEMO_PUFF_EXPIRED:
		{
			bQuit = TRUE;
			break;
		}
		case DEMO_PUFF_LASTLIMITED:
		case DEMO_PUFF_LIMITED:
		{
			BOOL bRegister = FALSE;
			if( pArg->eResponse == DEMO_PUFF_LASTLIMITED )
			{
				InfoBox( NULL, String( SvtResId( STR_OLDLIMITEDPUFF ) ) ).Execute();
				bRegister = TRUE;
			}
			if( !bRegister )
			{
				String aQuery( SvtResId( STR_LIMITEDPUFF ) );
				ByteString aBStr( pArg->aSystem, osl_getThreadTextEncoding() );
				DemoAppData_Impl *pDemo = pThis->GetDemoData().GetDemoData( aBStr );
				aQuery.SearchAndReplace( UniString::CreateFromAscii("$(ARG1)"),
								Application::GetAppInternational().GetDate(pDemo->aInvalidateDay) );

				LimitedDialog_Impl aDlg( NULL );
				aDlg.SetLimitedDate( pDemo->aInvalidateDay );
				bRegister = aDlg.Execute() == RET_OK;
			}
			if( bRegister )
			{
				TTProperties aProp;
				aProp.ExecuteFunction(___SFX_SID_ONLINE_REGISTRATION);
			}
			break;
		}
		case DEMO_PUFF_INVALID:
		{
			// Hier eine gehackt Meldung zeigen
			InfoBox( NULL, String( SvtResId( STR_INVALIDPUFF ) ) ).Execute();
			bQuit = TRUE;
			break;
		}
	}
	delete pArg;
	if( bQuit )
		Application::Quit();
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//
//		SvDemo
//

SvDemo_Impl& SvDemo::GetDemo()
{
	SvDemo_Impl*& rpDemo = ImpSvtData::GetSvtData().pDemo;
	if( !rpDemo ) rpDemo = new SvDemo_Impl;
	return *rpDemo;
}

void SvDemo::Init( const char* pDemoIndicator, const char* pGroup )
{
	SvDemo_Impl& rDemo = GetDemo();
	DBG_ASSERT( !rDemo.pDemoData, "SetDemoIndicator zu spaet gerufen" );
	rDemo.SetPuffVersion();
	rDemo.SetGroup( UniString::CreateFromAscii(pGroup) );
}

BOOL SvDemo::IsInited()
{
	SvDemo_Impl& rDemo = GetDemo();
	return rDemo.GetGroup().Len()? TRUE : FALSE;
}

Date SvDemo::GetExpireDate(const XubString& rStr)
{
	SvDemo_Impl& rDemo = GetDemo();
	ByteString aBStr( rStr, osl_getThreadTextEncoding() );

	Date aRet = rDemo.GetDemoData().GetDemoData(aBStr)?
				rDemo.GetDemoData().GetDemoData(aBStr)->aInvalidateDay : Date();
	return aRet;
}

SvDemoKind SvDemo::GetDemoKind( const String& rSystem )
{
	return SFX_DEMOKIND_FULL;

	SvDemo_Impl& rDemo = GetDemo();
	if( rDemo.IsFullVersion() )
		return SFX_DEMOKIND_FULL;
	ByteString aBStr( rSystem, osl_getThreadTextEncoding() );
	DemoAppData_Impl *pDemo = rDemo.GetDemoData().GetDemoData( aBStr );
	SvDemoKind nKind = pDemo ? pDemo->nDemoKind : SFX_DEMOKIND_INVALID;
	if( !rDemo.IsPuffVersion() ) return nKind;
	else
	{
		if( nKind == SFX_DEMOKIND_OLDTRYBUY )
			nKind = SFX_DEMOKIND_TRYBUY;
		if( !CheckPLK( ) ) return SFX_DEMOKIND_INVALID;
		// Falls kein PALK oder PALK nicht passend gehen wir ueber
		// den traditionellen Mechanismus
		else if( !GetPALK().Len() || !CheckPALK(GetPALK(), UniString::CreateFromAscii("")) )
			return nKind;
		else return SFX_DEMOKIND_FULL;
	}
}


void SvDemo::ShowDemoMessagesAndQuitAppOnExpiredVersion(
	const String& rSystem )
{
	DemoResponse eResponse = DEMO_NONE;
	if( !GetDemo().IsPuffVersion() )
	{
		SvDemoKind nDemoKind = GetDemoKind( rSystem );

		if( nDemoKind != SFX_DEMOKIND_FULL )
		{
			SvDemo_Impl& rDemo = GetDemo();

			ByteString aBStr( rSystem, osl_getThreadTextEncoding() );
			DemoAppData_Impl *pDemo = rDemo.GetDemoData().GetDemoData( aBStr );
			switch( nDemoKind )
			{
				case SFX_DEMOKIND_INVALID:
				{
					eResponse = DEMO_INVALID;
					break;
				}
				case SFX_DEMOKIND_OLDTRYBUY:
				{
					eResponse = DEMO_EXPIREDTRYBUY;
					break;
				}
				case SFX_DEMOKIND_TRYBUY:
				{
					if( pDemo->aInvalidateDay - Date() <= 5 )
						eResponse = DEMO_OLDTRYBUY;
					break;
				}
			}
		}
	}
	else // Puffversion
	{
		String aPALK = GetPALK();
		// PALK stimmt nicht, ist aber da -> Unauthorized werden mit neuer
		// Ablaufzeit und PALK loeschen
		if( aPALK.Len() && !CheckPALK(aPALK, UniString::CreateFromAscii("")) )
		{
			SetUnauthorizedState( rSystem, CreatePLK() );
			eResponse = DEMO_PUFF_LIMITED;
		}
		else if( !aPALK.Len() && GetDemoKind( rSystem ) == SFX_DEMOKIND_FULL )
		{
			SetInvalidState( rSystem );
			eResponse = DEMO_PUFF_INVALID;
		}
		// Falls jetzt der PLK nicht stimmt, hat der Benutzer bei T&B an
		// den Benutzerdaten gedreht (inis geaendert)
		else if( !CheckPLK() )
		{
			SetInvalidState( rSystem );
			eResponse = DEMO_PUFF_INVALID;
		}
		else
		{
			SvDemoKind nDemoKind = GetDemoKind( rSystem );
			if( nDemoKind == SFX_DEMOKIND_TRYBUY )
			{
				ByteString aBStr( rSystem, osl_getThreadTextEncoding() );
				DemoAppData_Impl *pDemo = GetDemo().GetDemoData().GetDemoData( aBStr );
				SvDemoKind nKind = pDemo ? pDemo->nDemoKind : SFX_DEMOKIND_INVALID;
				eResponse = nKind == SFX_DEMOKIND_OLDTRYBUY ?
					DEMO_PUFF_LASTLIMITED : DEMO_PUFF_LIMITED;
			}
			else if( nDemoKind == SFX_DEMOKIND_INVALID )
			{
				RegisterDialog_Impl aDlg( NULL );
				if( aDlg.Execute() == RET_OK )
				{
					SfxAppIniManagerProperty aProp;
					GetpApp()->Property( aProp );
					SfxIniManager* pMgr = aProp.GetIniManager();
					if( pMgr )
						pMgr->Set(aDlg.GetCustomerNr(), SFX_KEY_CUSTOMERNUMBER);
					SetAuthorizedState( rSystem, aDlg.GetEnableKey() );
					// Hier den Registrierungsdialog schalten
				}
				else eResponse = DEMO_PUFF_EXPIRED;
			}
		}
	}

	if( eResponse != DEMO_NONE )
	{
		BOOL bShow = TRUE;
		SfxAppIniManagerProperty aProp;
		GetpApp()->Property( aProp );
		SfxIniManager* pMgr = aProp.GetIniManager();

		if( bShow )
		{
			DemoArg_Impl* pArg = new DemoArg_Impl;
			pArg->eResponse = eResponse;
			pArg->aSystem = rSystem;

			Application::PostUserEvent(
				STATIC_LINK( &GetDemo(), SvDemo_Impl, ShowMessage ),
				pArg );
		}
	}
}


void SvDemo::SpoilDemoOutput(
	const String& rSystem, OutputDevice &rDevice, const Rectangle& rRect)
{
	SvDemoKind nDemoKind = GetDemoKind( rSystem );
	if(nDemoKind==SFX_DEMOKIND_INVALID)
	{
		Bitmap aBitmap = Bitmap( SvtResId( BMP_DEMO_FINGER ) );
		rDevice.DrawBitmap(rRect.TopLeft(),rRect.GetSize(),aBitmap);
	}
	else if(nDemoKind==SFX_DEMOKIND_DEMO)
	{
		rDevice.Push();
		long nHeight=10;
		Font aFont(FAMILY_SWISS, Size(0,nHeight));
		aFont.SetTransparent(TRUE);
		aFont.SetColor(COL_GRAY);
		aFont.SetAlign(ALIGN_BASELINE);
		rDevice.SetFont(aFont);
		double nScale;
		long nWidth;
		for(int i=0;i<10;i++)
		{
			nWidth=rDevice.GetTextWidth( UniString::CreateFromAscii(pSpoilString) );
			nScale=rRect.GetWidth()*2.0/(nWidth*3);
			double nDiff=nScale-1;
			nDiff = nDiff < 0 ? -nDiff : nDiff;
			if(nDiff < 0.1)
				break;
			nHeight=(long)(nScale*nHeight);
			aFont.SetSize(Size(0,nHeight));
			rDevice.SetFont(aFont);
		}

		Point aMiddle( rRect.TopLeft() + (rRect.BottomRight()-rRect.TopLeft())/2 );

		rDevice.DrawText(
			Point(aMiddle + Point(-nWidth/2,0)),
			UniString::CreateFromAscii(pSpoilString) );

		rDevice.Pop();
	}
}

void SvDemo::SetInvalidState( const String& rSystem )
{
	ByteString aBStr( rSystem, osl_getThreadTextEncoding() );

	DemoAppData_Impl* pApp = GetDemo().GetDemoData().GetDemoData( aBStr );
	if( pApp )
	{
		pApp->nDemoKind = SFX_DEMOKIND_INVALID;
		GetDemo().GetDemoData().Save(FALSE);
		TTProperties aProp;
		aProp.ExecuteFunction(___SFX_SID_OFFICE_INVALIDATE_TITLE);
	}
}

void SvDemo::SetUnauthorizedState( const String& rSystem, const String& rPLK )
{
	ByteString aOldPALK( GetDemo().GetRegistryConfig().ReadKey("PALK") );
	if( aOldPALK.Len() )
	{
		GetDemo().GetRegistryConfig().WriteKey( "OLDPALK", aOldPALK );
		GetDemo().GetRegistryConfig().Flush();
	}

	ByteString aBStr( rPLK, osl_getThreadTextEncoding() );
	GetDemo().GetRegistryConfig().WriteKey( "PLK", aBStr );
	GetDemo().GetRegistryConfig().WriteKey( "PALK", "" );
	GetDemo().GetRegistryConfig().Flush();

	ByteString aBStr1( rSystem, osl_getThreadTextEncoding() );
	DemoAppData_Impl* pApp = GetDemo().GetDemoData().GetDemoData( aBStr1 );
	if( pApp )
	{
		pApp->nDemoKind = SFX_DEMOKIND_TRYBUY;
		pApp->bSaveSum = TRUE;
		pApp->aInvalidateDay = Date();
		pApp->aInvalidateDay += 30;
		pApp->nDaysToRun = 60;
		GetDemo().GetDemoData().Save(FALSE);
		TTProperties aProp;
		aProp.ExecuteFunction(___SFX_SID_OFFICE_INVALIDATE_TITLE);
	}
	GetDemo().GetRegistryConfig().Flush();
}

void SvDemo::SetAuthorizedState( const String& rSystem, const String& rPALK )
{
/*
 *	old licence
 *
 	XubString aSave(rPALK);
	::_ReplaceUnsaveChars(aSave);

	XubString rDecodedPALK( ::DecodeNativeKey(aSave) );
	rDecodedPALK.Cut( 28 );

	char pBuffer[28];
	::CodeNativeKey( pBuffer, rDecodedPALK.Len(), rDecodedPALK.GetStr() );

	GetDemo().GetRegistryConfig().WriteKey( "PLK", pBuffer );
	GetDemo().GetRegistryConfig().WriteKey( "PALK", rPALK );
	GetDemo().GetRegistryConfig().Flush();

	DemoAppData_Impl* pApp = GetDemo().GetDemoData().GetDemoData( rSystem );
	if( pApp )
	{
		pApp->nDemoKind = SFX_DEMOKIND_FULL;
		pApp->bSaveSum = TRUE;
		GetDemo().GetDemoData().Save(FALSE);
		TTProperties aProp;
		aProp.ExecuteFunction(___SFX_SID_OFFICE_INVALIDATE_TITLE);
	}
	GetDemo().GetRegistryConfig().Flush();
 *
 *
 */
}

String SvDemo::GetPLK( )
{
	ByteString aStr( GetDemo().GetRegistryConfig().ReadKey("PLK") );
	return UniString::CreateFromAscii( aStr.GetBuffer() );
}

String SvDemo::GetOldPALK( )
{
	ByteString aStr( GetDemo().GetRegistryConfig().ReadKey("OLDPALK") );
	return UniString::CreateFromAscii( aStr.GetBuffer() );
}

String SvDemo::GetPALK( )
{
	ByteString aStr( GetDemo().GetRegistryConfig().ReadKey("PALK") );
	return UniString::CreateFromAscii( aStr.GetBuffer() );
}

void SvDemo::SetConfigDir( const String& rDir )
{
	GetDemo().SetConfigDir( rDir );
}

void SvDemo::SetDemoDataDir( const String& rDir )
{
	GetDemo().SetDemoDataDir( rDir );
}

void SvDemo::InitDynamicKeyEdition(const XubString& rKey)
{
/*
 *	old licence
 *
	if( ProductVersion::GetLicenseModel() != LicenseCampus )
		return ;

	LicenseKeyInfo aKeyInfo;
	if( ::GetLicenseKeyInfo(rKey, aKeyInfo) )
	{
		switch( aKeyInfo.aSerialNumber.GetChar(2) )
		{
			case '0' : ProductVersion::SetDynamicKeyEdition( Campus );		break;
			case '1' : ProductVersion::SetDynamicKeyEdition( Partner );		break;
			case '2' : ProductVersion::SetDynamicKeyEdition( Enterprice );	break;
			case '3' : ProductVersion::SetDynamicKeyEdition( Business );	break;
		}
	}
 *
 *
 */
}

BOOL SvDemo::CheckPLK()
{
/*
 *	old licence
 *
	String aName;
	String aLastName;
	String aEmail;

	SfxAppIniManagerProperty aProp;
	GetpApp()->Property( aProp );
	SfxIniManager* pMgr = aProp.GetIniManager();

	if( pMgr )
	{
		aLastName	= pMgr->Get( SFX_KEY_USER_NAME );
		aName		= pMgr->Get( SFX_KEY_USER_FIRSTNAME );
		aEmail	= pMgr->GetAddressToken( ADDRESS_EMAIL );
	}

	InitDynamicKeyEdition( GetPLK() );
	return ::CheckPLK( GetPLK(), aName, aLastName, aEmail );
 *
 *
 */
	return FALSE;
}

BOOL SvDemo::CheckPALK( const String& rPALK, const XubString& rCustomerNr )
{
/*
 *	old licence
 *
	String aName;
	String aLastName;
	String aEmail;
	String aCompany;
	String aStreet;
	String aZip;
	String aCustomerNr;

	SfxAppIniManagerProperty aProp;
	GetpApp()->Property( aProp );
	SfxIniManager* pMgr = aProp.GetIniManager();
	if( pMgr )
	{
		aLastName = pMgr->Get( SFX_KEY_USER_NAME );
		aName = pMgr->Get( SFX_KEY_USER_FIRSTNAME );
		aEmail = pMgr->GetAddressToken( ADDRESS_EMAIL );
		aCompany = pMgr->GetAddressToken( ADDRESS_COMPANY );
		aStreet = pMgr->GetAddressToken( ADDRESS_STREET );
		aZip = pMgr->GetAddressToken( ADDRESS_PLZ );

		if( !rCustomerNr.Len() )
			aCustomerNr = pMgr->Get( SFX_KEY_CUSTOMERNUMBER );
		else
			if( rCustomerNr.ICompare("nothing") == COMPARE_EQUAL )
				aCustomerNr = "";
			else
				aCustomerNr = rCustomerNr;
	}

	// beim ersten start einer PALK-Installierten Version existiert
	//ein PALK jedoch kein PLK - der wird jetzt erzeugt.
	if( !GetPLK().Len() && GetPALK().Len() )
	{
		XubString aSave(GetPALK());
		::_ReplaceUnsaveChars(aSave);

		XubString rDecodedPALK( ::DecodeNativeKey(aSave) );
		rDecodedPALK.Cut( 28 );

		char pBuffer[28];
		::CodeNativeKey( pBuffer, rDecodedPALK.Len(), rDecodedPALK.GetStr() );

		GetDemo().GetRegistryConfig().WriteKey( "PLK", pBuffer );
		GetDemo().GetRegistryConfig().Flush();
	}

	LicenseKeyInfo aInf_PLK;
	LicenseKeyInfo aInf_PALK;
	if( !GetLicenseKeyInfo( GetPLK(), aInf_PLK ) || !GetLicenseKeyInfo(rPALK, aInf_PALK) )
		return FALSE;

	if( aInf_PLK.eProduct != aInf_PALK.eProduct		||
		aInf_PLK.nVersion != aInf_PALK.nVersion		||
		aInf_PLK.nRevision != aInf_PALK.nRevision	||
		aInf_PLK.nSystem != aInf_PALK.nSystem		||
		aInf_PLK.nLanguage != aInf_PALK.nLanguage	||
		aInf_PLK.eModel != aInf_PALK.eModel )
		// auf die Sernr. wird nicht geprueft, um Produktionsfehler auszubuegeln
		return FALSE;


	InitDynamicKeyEdition( GetPALK() );
	return ::CheckPALK( rPALK, aName, aLastName, aEmail, aCompany, aStreet, aZip, aCustomerNr );
 *
 *
 */
	return FALSE;
}

String SvDemo::CreatePLK()
{
/*
 *	old licence
 *
	String aName;
	String aLastName;
	String aEmail;

	SfxAppIniManagerProperty aProp;
	GetpApp()->Property( aProp );
	SfxIniManager* pMgr = aProp.GetIniManager();
	if( pMgr )
	{
		aLastName = pMgr->Get( SFX_KEY_USER_NAME );
		aName = pMgr->Get( SFX_KEY_USER_FIRSTNAME );
		aEmail = pMgr->GetAddressToken( ADDRESS_EMAIL );
	}
	return ::MakeNewPLK( GetPLK(), aName, aLastName, aEmail );
 *
 *
 */
	return XubString();
}

BOOL SvDemo::IsPuffVersion()
{
	return GetDemo().IsPuffVersion();
}

Config* SvDemo::GetNewAuthConfig(XubString* pPath)
{
/*
 *	old licence
 *
	String aDir;
	if( pPath )
		aDir = *pPath;

	if( !aDir.Len() )
	{
		SfxAppIniManagerProperty aProp;
		GetpApp()->Property( aProp );
		if( aProp.GetIniManager() )
			aDir = aProp.GetIniManager()->Get( SFX_KEY_CONFIG_DIR );
	}
	XubString aSectionName( "Keys" );
#if SUPD > 506
	aSectionName += "_";
	aSectionName += ProductVersion::GetSystemID();
#endif

	Config* pConfig = new Config( Config::GetConfigName( aDir, "auth" ) );
	pConfig->SetGroup( aSectionName );

	return pConfig;
 *
 *
 */
	return NULL;
}

XubString SvDemo::RequestErrorString( ErrorType eType )
{
/*
 *	old licence
 *
	XubString aErr;
	switch( eType )
	{
		case InvalidKey:			aErr = XubString(SvtResId(STR_KEYERR_INVALID_KEY)); 			break;
		case InvalidUserdata:		aErr = XubString(SvtResId(STR_KEYERR_INVALID_USERDATA)); 	break;
		case InvalidAddressdata:	aErr = XubString(SvtResId(STR_KEYERR_INVALID_ADDRESSDATA)); 	break;
		case InvalidLicense:		aErr = XubString(SvtResId(STR_KEYERR_INVALID_LICENSE)); 		break;
		case InvalidLanguage:		aErr = XubString(SvtResId(STR_KEYERR_INVALID_LANGUAGE)); 	break;
		case InvalidOS:				aErr = XubString(SvtResId(STR_KEYERR_INVALID_OS)); 			break;
		case InvalidCustomerNr:		aErr = XubString(SvtResId(STR_KEYERR_INVALID_NO_CNR)); 		break;
		case InvalidCustomerNrLen:	aErr = XubString(SvtResId(STR_KEYERR_INVALID_CNR)); 			break;
	}

	aErr += "\n\n";
	aErr += XubString(SvtResId(STR_KEYERR_GENERAL_HELP));
	return aErr;
 *
 *
 */
	return XubString();
}


