/*************************************************************************
 *
 *  $RCSfile: iniman.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mba $ $Date: 2000/09/22 10:53:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdlib.h>

#ifdef WNT
#include <tools/solar.h>
#include <tools/prewin.h>
#include <winreg.h>
#include <tools/postwin.h>
#endif

#include <tools/isolang.hxx>

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif
#ifndef _RESMGR_HXX
#include <tools/resmgr.hxx>
#endif
#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#include <tools/urlobj.hxx>
#ifndef _VOS_PROFILE_HXX_ //autogen
#include <vos/profile.hxx>
#endif
#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif
#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#include <vcl/system.hxx>

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_MERGECONFLICTEXCEPTION_HPP_
#include <com/sun/star/registry/MergeConflictException.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONFIGMANAGER_HPP_
#include <com/sun/star/frame/XConfigManager.hpp>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#include <vos/process.hxx>

#ifndef _VCL_STDTEXT_HXX
#include <vcl/stdtext.hxx>							// ShowServiceNotAvailableError
#endif

#include <osl/file.hxx>

#pragma hdrstop

#include "aeitem.hxx"
#include "iniman.hxx"
#include "inidef.hxx"
#include "svtools.hrc"
#include "svtdata.hxx"

//______________________________________________________________________________________________________________________________
//	namespaces
//______________________________________________________________________________________________________________________________

using namespace ::vos						;
using namespace ::rtl						;
using namespace ::osl						;
using namespace ::com::sun::star::uno		;
using namespace ::com::sun::star::registry	;
using namespace ::com::sun::star::lang		;
using namespace ::com::sun::star::frame		;

// old DirEntry support
#include <tools/fsys.hxx>
BOOL FileExists_Impl( const String rURL )
{
    INetURLObject aObj( rURL, INET_PROT_FILE );
    rtl::OUString aTmp( aObj.GetMainURL() );
    rtl::OUString aResult;
    if ( FileBase::getNormalizedPathFromFileURL( aTmp, aResult )  == FileBase::E_None )
    {
        FileBase::RC err = Directory::create( aResult );
        if ( err == FileBase::E_EXIST )
            return sal_True;
        else
            Directory::remove( aResult );
    }

    return sal_False;
}

//______________________________________________________________________________________________________________________________
//	typedefs, defines, macros
//______________________________________________________________________________________________________________________________

#ifdef MACOSX
#define DEFINE_CONST_UNICODE(CONSTASCII)        UniString(RTL_CONSTASCII_USTRINGPARAM(CONSTASCII))
#else
#define DEFINE_CONST_UNICODE(CONSTASCII)        UniString(RTL_CONSTASCII_USTRINGPARAM(CONSTASCII##))
#endif

SfxIniManager* SfxIniManager::pIniMgr = NULL;
const String* SfxIniManager::pVersionKey = NULL;

#if defined (UNX) || defined (MAC)
#include <limits.h>
#define _MAX_PATH PATH_MAX
#endif

#ifndef SFX_PATH_NOTCHANGED
#define SFX_PATH_NOTCHANGED " "
#endif

#define SFX_CONFIG_AUTOUPDATE       5000 // Allle 5sek flushen

#ifdef WNT
#define SFX_CONFIG_PATH				"?$"
#else
#define SFX_CONFIG_PATH				0
#endif

const char* __FAR_DATA sVerFileName = "sversion";
const char* __FAR_DATA sUseUserConfig = "UseUserConfig";

struct SfxIniGroup_Impl
{
	const char* __FAR_DATA	sName;
	sal_Bool					bUseOS;  // 0=no, 1=yes, 2=uninitialized
	sal_Bool					bUseApp; // 0=no, 1=yes
};

//AS: Deactivate system properties. Set flag from 2 to 0! MORE PERFORMANCE ...
SfxIniGroup_Impl aGroups_Impl[] =
{
	{ "Common",			0, 0 },		// SFX_GROUP_COMMON
	{ "Directories",	0, 0 },		// SFX_GROUP_DIR
	{ "User",			0, 0 },		// SFX_GROUP_USER
	{ "View",			0, 1 },		// SFX_GROUP_VIEW
	{ "Picklist",		0, 1 },		// SFX_GROUP_PICKLIST_IMPL
	{ "WorkingSet",		0, 1 },		// SFX_GROUP_WORKINGSET_IMPL
	{ "Graphic",		0, 0 },		// SFX_GROUP_GRAPHIC_FILTER_OPTIONS
	{ "INet",			0, 0 },		// SFX_GROUP_INET
	{ "Database",		0, 0 },		// SFX_GROUP_DATABASE
	{ "Security",		0, 0 },		// SFX_GROUP_SECURITY
	{ "ExtBrowser",		0, 0 },     // SFX_GROUP_EXTBRW
	{ "3D-Engine",		0, 0 },		// SFX_GROUP_3D_ENGINE
	{ "Apps",			0, 1 },		// SFX_GROUP_MODULES
	{ "Recent",			0, 1 },		// SFX_GROUP_RECENTEXECUTES
	{ "International",	0, 0 },		// SFX_GROUP_INTERNATIONAL
	{ "Java",			0, 0 },	    // SFX_GROUP_JAVA
	{ "Desktop",		0, 0 }	    // SFX_GROUP_DESKTOP
};

const char* __FAR_DATA sVersionGroup_Impl = "Versions";
#define STAROFFICE_INI		"soffice"

// -----------------------------------------------------------------------

struct SfxIniManager_Impl
{
	Reference< XSimpleRegistry > 		xIni;			// The new INIManager
	Reference< XRegistryKey > 			xRootKey;		// Rootkey of current open ini-file
	INetURLObject      					aProgPathObj;   // Pfad zum Executable
	String          					aProgPathStr;   // aProgPathObj als String
	String          					aInstRoot;      // Pfad zum Inst-Verzeichnis
	String          					aUserPath;      // Pfad zum IniFile
	String								aAppName;
	String								aTRUEStr;		// "1"
	SfxIniKey       					eLastKey;       // zuletzt gesuchter Key
	SfxIniGroup     					eLastGroup;     // zu eLastKey passende Gruppe
	long								nFeatures;
    sal_uInt16                  		nRefCount;
	sal_Bool                    		bIEAvailable;   // Internet Explorer available?
    sal_Bool                            bSpecial;

							SfxIniManager_Impl( const String* pAppName );
                            ~SfxIniManager_Impl();
};

// -----------------------------------------------------------------------

static const char __FAR_DATA pOS[] =
#if defined(WIN)
	  "Windows";
#elif defined(WNT)
	  "WindowsNT";
#elif defined(UNX)
	  "UNIX";
#elif defined(MAC)
	  "Macintosh";
#elif defined(OS2)
	  "OS/2";
#else
	  "GUI";
#endif

static const char __FAR_DATA *pKeys[] =
{
	/*   0: */  0,
	/*   1: */  "Last-Database",
	/*   2: */  "Show-Intro",
	/*   3: */  "PageQueueSize",
	/*   4: */  "PrintThreadPrio",
	/*   5: */  "BrowseReadOnly",
	/*   6: */  "LDAP-Server",
	/*   7: */  "MaxPreviewSize",
	/*   8: */  "Slots",
	/*   9: */  "BrowserRestore",
	/*  10: */  "DontPlugHelp",
	/*  11: */  "MetafilePrint",
	/*  12: */  "FileDialogExt",
	/*  13: */  "AddressBookFields",
	/*  14: */  "SAPEnable",
	/*  15: */  "SearchTemplate",
	/*  16: */  "HelpView",
	/*  17: */  "DontAskForDefaults",
	/*  18: */  "AllowFolderWebView",
	/*  19: */  "LogRules",
	/*  20: */  0,
	/*  21: */  0,
	/*  22: */  0,
	/*  23: */  0,
	/*  24: */  0,
	/*  25: */  0,
	/*  26: */  0,
	/*  27: */  0,
	/*  28: */  0,
	/*  29: */  0,
	/*  30: */  0,
	/*  31: */  0,
	/*  32: */  0,
	/*  33: */  0,
	/*  34: */  0,
	/*  35: */  0,
	/*  36: */  0,
	/*  37: */  0,
	/*  38: */  0,
	/*  39: */  0,
	/*  40: */  0,
	/*  41: */  0,
	/*  42: */  0,
	/*  43: */  0,
	/*  44: */  0,
	/*  45: */  0,
	/*  46: */  0,
	/*  47: */  0,
	/*  48: */  0,
	/*  49: */  0,
	/*  50: */  "Sub-Ini",
	/*  51: */  "Config-Dir",
	/*  52: */  "Work-Path",
	/*  53: */  "Graphics-Path",
	/*  54: */  "Bitmap-Path",
	/*  55: */  "Basic-Path",
	/*  56: */  "Database-Path",
	/*  57: */  "Palette-Path",
	/*  58: */  "Backup-Path",
	/*  59: */  "Modules-Path",
	/*  60: */  "Template-Path",
	/*  61: */  "Glossary-Path",
	/*  62: */  "Dictionary-Path",
	/*  63: */  "Desktop-Dir",
	/*  64: */  "Help-Dir",
	/*  65: */  "Bookmark-Dir",
	/*  66: */  "Gallery-Dir",
	/*  67: */  "New-Dir",
	/*  68: */  "Agent-Dir",
	/*  69: */  "Autopilot-Dir",
	/*  70: */  "Explorer",
	/*  71: */  "Trash-Dir",
	/*  72: */  "Storage-Dir",
	/*  73: */  "StartMenu-Dir",
	/*  74: */  "Download-Dir",
	/*  75: */  "Autostart-Dir",
	/*  76: */  "Quickstart-Dir",
	/*  77: */  "Group-Dir",
	/*  78: */  "Plugins-Dir",
	/*  79: */  "Favorites-Dir",
	/*  80: */  "Filter-Path",
	/*  81: */  "AddIns-Path",
	/*  82: */  "UserConfig-Path",
	/*  83: */  "UserDictionary-Dir",
	/*  84: */  "Linguistic-Dir",
	/*  85: */  "AutoCorrect-Dir",
	/*  86: */  0,
	/*  87: */  0,
	/*  88: */  0,
	/*  89: */  0,
	/*  90: */  0,
	/*  91: */  0,
	/*  92: */  0,
	/*  93: */  0,
	/*  94: */  0,
	/*  95: */  0,
	/*  96: */  0,
	/*  97: */  0,
	/*  98: */  0,
	/*  99: */  0,
	/* 100: */  "User-Name",
	/* 101: */  "User-Id",
	/* 102: */  "User-Adress",
	/* 103: */  "Country",
	/* 104: */  "Language",
	/* 105: */  "User-FirstName",
	/* 106: */  "HTMLFontSz",
	/* 107: */  "LinkPrefix",
	/* 108: */  "UsingOffice",
	/* 109: */  "CustomerNumber",
	/* 110: */  0,
	/* 111: */  0,
	/* 112: */  0,
	/* 113: */  0,
	/* 114: */  0,
	/* 115: */  0,
	/* 116: */  0,
	/* 117: */  0,
	/* 118: */	0,
	/* 119: */	0,
	/* 120: */	0,
	/* 121: */	0,
	/* 122: */ 	0,
	/* 123: */ 	0,
	/* 124: */ 	0,
	/* 125: */ 	0,
	/* 126: */ 	0,
	/* 127: */ 	0,
	/* 128: */	0,
	/* 129: */	0,
	/* 130: */  "App-Window",
	/* 131: */  "MailInbox",
	/* 132: */  "Helper",
	/* 133: */  "Dialog",
	/* 134: */  "Window",
	/* 135: */  "Page",
	/* 136: */  "SplitWindow",
	/* 137: */  "Open-Cont",
	/* 138: */  "Browser-Sets",
	/* 139: */	"IconView-GridSize",
	/* 140: */  "AutoOpen",
	/* 141: */  0,
	/* 142: */  0,
	/* 143: */  0,
	/* 144: */  0,
	/* 145: */  "Pick",
	/* 146: */  "Hist",
	/* 147: */  "Folder",
	/* 148: */  0,
	/* 149: */  0,
	/* 150: */  "WorkingSet",
	/* 151: */  0,
	/* 152: */  0,
	/* 153: */  0,
	/* 154: */  0,
	/* 155: */  0,
	/* 156: */  0,
	/* 157: */  0,
	/* 158: */  0,
	/* 159: */  0,
	/* 160: */  "Homepage",
	/* 161: */  "BMKFile",
	/* 162: */  "MailGateway",
	/* 163: */  "ProxyName",
	/* 164: */  "ProxyPort",
	/* 165: */  "ProxyType",
	/* 166: */  "Cookie",
	/* 167: */  "MemCache",
	/* 168: */  "DiskCache",
	/* 169: */  "CacheExpiration",
	/* 170: */  "SMTPServer",
	/* 171: */  "POPServer",
	/* 172: */  "MailUserName",
	/* 173: */  "MailPassword",
	/* 174: */  "NoProxy",
	/* 175: */  "HTTPProxyName",
	/* 176: */  "HTTPProxyPort",
	/* 177: */  "FTPProxyName",
	/* 178: */  "FTPProxyPort",
	/* 179: */  "SocksProxyName",
	/* 180: */  "SocksProxyPort",
	/* 181: */  "SecurityProxyName",
	/* 182: */  "SecurityProxyPort",
	/* 183: */  "NNTPServer",
	/* 184: */  "MaxNewsMessages",
	/* 185: */  "MaxHttpCons",
	/* 186: */  "MaxFtpCons",
	/* 187: */ 	"DNSServer",
	/* 188: */ 	"UserAgent",
	/* 189: */ 	"NonCached",
	/* 190: */ 	"JavaScript",
	/* 191: */ 	"PlugIn",
	/* 192: */ 	"Applets",
	/* 193: */	"MailTextFormat",
	/* 194: */	"Channels",
	/* 195: */	"CacheJavaScript",
	/* 196: */	"CacheExpired",
	/* 197: */	"CacheAborted",
	/* 198: */	"RevealMailAddress",
	/* 199: */	"ReadTimerOn",
	/* 200: */	"ReadTimerOut",
	/* 201: */	"AutoLoad",
	/* 202: */	"MailTextFontHeight",
	/* 203: */	0,
	/* 204: */	0,
	/* 205: */  0,
	/* 206: */  0,
	/* 207: */  0,
	/* 208: */	0,
	/* 209: */	0,
	/* 210: */	0,
	/* 211: */	0,
	/* 212: */	0,
	/* 213: */	0,
	/* 214: */	0,
	/* 215: */	0,
	/* 216: */	0,
	/* 217: */	0,
	/* 218: */	0,
	/* 219: */	0,
	/* 220: */	"AddressBook",
	/* 221: */  0,
	/* 222: */  0,
	/* 223: */	0,
	/* 224: */	0,
	/* 225: */	0,
	/* 226: */	0,
	/* 227: */	0,
	/* 228: */	0,
	/* 229: */	0,
	/* 230: */	"SecureURL",
	/* 231: */	"StarBASIC",
	/* 232: */	0,
	/* 233: */	0,
	/* 234: */	0,
	/* 235: */	0,
	/* 236: */	0,
	/* 237: */	0,
	/* 238: */	0,
	/* 239: */	0,
	/* 240: */  "ExtBrowserOn",
	/* 241: */  "ExtBrwOnException",
	/* 242: */  "ExtBrwOffException",
	/* 243: */	"ExtBrwNoHint",
	/* 244: */	"ExtBrwFile",
	/* 245: */	0,
	/* 246: */	0,
	/* 247: */	0,
	/* 248: */	0,
	/* 249: */	0,
	/* 250: */  "3D-OpenGL",
	/* 251: */  "3D-Dithering",
	/* 252: */  "3D-ShowFull",
	/* 253: */	"3D-OpenGL-Faster",
	/* 254: */	0,
	/* 255: */	0,
	/* 256: */	0,
	/* 257: */	0,
	/* 258: */	0,
	/* 259: */	0,
	/* 260: */ 	"AutoMnemonic",
	/* 261: */	"DialogScaleX",
	/* 262: */	0,
	/* 263: */	0,
	/* 264: */	0,
	/* 265: */	0,
	/* 266: */	0,
	/* 267: */	0,
	/* 268: */	0,
	/* 269: */	0,
	/* 270: */	"Java",
	/* 271: */	"Security",
	/* 272: */	"SystemClassPath",
	/* 273: */	"UserClassPath",
	/* 274: */	"NetAccess",
	/* 275: */	0,
	/* 276: */	0,
	/* 277: */	0,
	/* 278: */	0,
	/* 279: */	0,
	/* 280: */	0,
	/* 281: */	0,
	/* 282: */	0,
	/* 283: */	0,
	/* 284: */	0,
	/* 285: */	0,
	/* 286: */	0,
	/* 287: */	0,
	/* 288: */	0,
	/* 289: */	0,
	/* 290: */	0,
	/* 291: */	0,
	/* 292: */	0,
	/* 293: */	0,
	/* 294: */	0,
	/* 295: */	0,
	/* 296: */	0,
	/* 297: */	0,
	/* 298: */	0,
	/* 299: */	0,
	/* 300: */  "ExplorerRoot",
	/* 301: */  "EnableDocInfoRead",
	/* 302: */  "ShowFileExtension",
	/* 303: */  "ShowOnlyDrives",
	/* 304: */	"ShowFontBoxWYSIWYG",
	/* 305: */	"ForceBodyExport",
	/* 306: */	"DontHideDisabledEntries",
	/* 307: */	"FontHistory",
	/* 308: */	0
};

//============================================================================
// SfxIniManagerHint Implementation.
//============================================================================

TYPEINIT1( SfxIniManagerHint, SfxHint );

//-------------------------------------------------------------------------

static const char cToken = '#';

DBG_NAME(SfxIniManager);

//-------------------------------------------------------------------------

SfxIniManager_Impl::SfxIniManager_Impl( const String* pAppName ) :

	aTRUEStr		( '1' ),
	eLastKey		( SFX_KEY_UNKNOWN ),
	eLastGroup		( SFX_GROUP_UNKNOWN ),
	nFeatures		( 0 ),
    bIEAvailable    ( sal_False ),
    nRefCount       ( 0 )

{
	INetURLObject aApplName( GetpApp()->GetAppFileName(), INET_PROT_FILE );
	aProgPathObj.SetSmartProtocol( INET_PROT_FILE );
	aProgPathObj.SetSmartURL( GetpApp()->GetAppFileName() );
	aProgPathObj.removeSegment();
	aProgPathObj.removeFinalSlash();
	aProgPathStr = aProgPathObj.PathToFileName();
	INetURLObject aInstObj( aProgPathObj );
	aInstObj.removeSegment();
	aInstObj.removeFinalSlash();
	aInstRoot = aInstObj.PathToFileName();

	Reference< ::com::sun::star::lang::XMultiServiceFactory > xFactory( ::utl::getProcessServiceFactory() ) ;
	if ( pAppName )
	{
        bSpecial = sal_False;
		aAppName = *pAppName;
        ::rtl::OUString aIniName;
		INetURLObject aApplPath( aApplName );
		aApplPath.removeSegment();

        OProfile::getProfileName( aIniName, aAppName, aApplPath.getFSysPath(INetURLObject::FSYS_VOS) );
        ::rtl::OUString aIniFile;
        FileBase::getFileURLFromNormalizedPath( aIniName, aIniFile );
		INetURLObject aUserObj( aIniFile );
		aUserObj.removeSegment();
		aUserObj.removeFinalSlash();
        aUserPath = aUserObj.PathToFileName();
        xIni = Reference< XSimpleRegistry > ( xFactory->createInstance
			( ::rtl::OUString::createFromAscii("com.sun.star.config.ConfigManager") ), UNO_QUERY ) ;

		if ( xIni.is() )
		{
            String aURL = aIniFile;
			// Open INI-file with following flags:
			//		- not readonly				->	bReadOnly	= sal_False
			//		- create it, if not exist	->	bCreate		= sal_True
            try
            {
                xIni->open ( aURL, sal_False, sal_True ) ;
            }
            catch ( InvalidRegistryException e )
            {
                xIni->open ( aURL, sal_True, sal_True ) ;
            }
		}
	}
	else
	{
        bSpecial = sal_True;
        aAppName = String::CreateFromAscii(STAROFFICE_INI);
        ::rtl::OUString aIniName;
        OProfile::getProfileName( aIniName, aAppName, ::rtl::OUString::createFromAscii(STAROFFICE_SVERSION_KEY) );
        ::rtl::OUString aIniFile;
        FileBase::getFileURLFromNormalizedPath( aIniName, aIniFile );
		INetURLObject aUserObj( aIniFile );
		aUserObj.removeSegment();
		aUserObj.removeFinalSlash();
        aUserPath = aUserObj.PathToFileName();
        xIni = Reference< XSimpleRegistry > ( xFactory->createInstance
			( String::CreateFromAscii("com.sun.star.config.SpecialConfigManager") ), UNO_QUERY ) ;
	}

	DBG_ASSERT ( xIni.is(), "SfxIniManager_Impl::SfxIniManager_Impl()\nServicename of SpecialConfigManager is unknown!\n" ) ;

	// "Cache" rootkey! Now we don't must get this reference in every method of SfxIniManager => more performance!
    if ( xIni.is() )
        xRootKey = xIni->getRootKey () ;
	DBG_ASSERT ( xRootKey.is(), "SfxIniManager_Impl::SfxIniManager_Impl()\nCant get rootkey!\n" ) ;

#ifdef WNT
	// Internet Explorer installed? The version has to be >= 4.0.
	HKEY hKey;
	DWORD dwType, dwSize;
	if ( !Application::IsRemoteServer() && ::RegOpenKeyEx( HKEY_LOCAL_MACHINE,
#ifdef UNICODE
						 "Software\\Microsoft\\Internet Explorer",
#else
						 "Software\\Microsoft\\Internet Explorer",
#endif
						 0, KEY_READ, &hKey ) == ERROR_SUCCESS )
	{
		// die Existenz des Schl"ussels soll nach MS Doku
		// f"ur das Vorhanden sein von > IE3 ausreichen.
		bIEAvailable =
			( ::RegQueryValueEx( hKey,
#ifdef UNICODE
								 "Version",
#else
								 "Version",
#endif
								 NULL, &dwType, NULL, &dwSize ) == ERROR_SUCCESS );
		::RegCloseKey( hKey );
	}
#endif
}

SfxIniManager_Impl::~SfxIniManager_Impl()
{
    if ( xRootKey.is () )
    {
        xRootKey->closeKey  () ;
    }

    if ( xIni.is () )
    {
        if ( bSpecial )
        {
            Reference< XConfigManager > xConfig = Reference< XConfigManager > ( xIni, UNO_QUERY ) ;
            if ( xConfig.is () )
                xConfig->flush() ;
        }
        else
            xIni->close () ;
    }
}

// -----------------------------------------------------------------------
static ::osl::Mutex & getLocalMutex()
{
	static ::osl::Mutex *p = 0;
	if( ! p )
	{
		MutexGuard aGuard( Mutex::getGlobalMutex());
		if( ! p )
		{
			static ::osl::Mutex mutex;
			p = &mutex;
		}
	}
	return *p;
}

SfxIniManager* SfxIniManager::Get()
{
    if ( !pIniMgr )
        pIniMgr = Create();
    return pIniMgr;
}

SfxIniManager* SfxIniManager::Create( const String* pAppName, const String* pVersionName )
{
	MutexGuard aGuard( getLocalMutex() );
	if ( !pIniMgr )
	{
        pIniMgr = new SfxIniManager( pAppName );
		if ( !pIniMgr->IsValid() )
			DELETEZ( pIniMgr );
	}

    if (  pIniMgr )
        pIniMgr->pImp->nRefCount++;

	return pIniMgr;
}

void SfxIniManager::Close()
{
    if ( pIniMgr )
        if ( !--pIniMgr->pImp->nRefCount )
            DELETEZ( pIniMgr );
}

String GetUserID_Impl()
{
	// UserId uebergeben?
	String aUserID;
	sal_uInt16 nParCount = Application::GetCommandLineParamCount();
	for ( sal_uInt16 n = 0; n<nParCount && !aUserID.Len(); ++n )
		if ( ( COMPARE_EQUAL == Application::GetCommandLineParam(n).CompareToAscii( "-userid:", 8 ) ) ||
            ( COMPARE_EQUAL == Application::GetCommandLineParam(n).CompareToAscii( "/userid:", 8 ) ) )
				aUserID = String( Application::GetCommandLineParam(n) ).Copy( 8 );
#ifdef WNT
	if ( !aUserID.Len() )
	{
		HKEY hkResult;			// address of handle of open key
		DWORD dwType;			// address of buffer for value type
		char sCurUser[32];		// address of data buffer
		DWORD nBufSize = 31;	// of data buffer size

		// Windows95
		sal_Int32 nErr = RegOpenKeyEx( HKEY_LOCAL_MACHINE,
									"System\\CurrentControlSet\\Control",
									0, KEY_READ, &hkResult );
		if ( ERROR_SUCCESS == nErr )
			nErr = RegQueryValueEx( hkResult, "Current User", 0, &dwType,
									(unsigned char*) sCurUser, &nBufSize );
		if ( ERROR_SUCCESS != nErr )
		{
			RegCloseKey( hkResult );
			nErr = RegOpenKeyEx( HKEY_LOCAL_MACHINE,
									"SOFTWARE\\Microsoft\\Windows NT"
									"\\CurrentVersion\\Winlogon",
									0, KEY_READ, &hkResult );
			if ( ERROR_SUCCESS == nErr )
				nErr = RegQueryValueEx( hkResult, "DefaultUserName", 0, &dwType,
										(unsigned char*) sCurUser, &nBufSize );
		}

		if ( ERROR_SUCCESS == nErr && REG_SZ == dwType )
			aUserID = String::CreateFromAscii(sCurUser);
		RegCloseKey( hkResult );
	}
#endif

	return aUserID;
}


// -----------------------------------------------------------------------

SfxIniManager::SfxIniManager( const String* pAppName )

/*  [Beschreibung]

	Der Konstruktor der Klasse SfxIniManager sucht die Ini-Datei zun"achst
	in den Verzeichnis, in dem auch das Programm liegt, dann in dem
	systempezifisch daf"ur vorgesehenen Verzeichnis. In lezterem wird
	die Datei auch angelegt, wenn sie noch nicht existiert.

	Der Name der Ini-Datei bestimmt sich aus 'rAppName'; f"ur obiges
	Beispiel unter unter MS-Windows w"are es 'sdraw3.ini'.

	Die <Sub-Ini-Manager> werden automatisch mit angelegt, insofern
	entsprechende Eintr"age (<SFX_KEY_SUB_INI>) existieren.
*/

:   pImp( 0 ),
	pSub( 0 )
{
	DBG_CTOR(SfxIniManager, 0);

	// Programmverzeichnis bestimmen
	pImp = new SfxIniManager_Impl( pAppName );

    if ( pImp->xRootKey.is() )
    {
        // International auswerten
        International aOldInter( Application::GetAppInternational() );
        String aValue = Get( SFX_KEY_LANGUAGE );
        LanguageType eLanguage = ConvertIsoStringToLanguage( aValue, '_' );
        if ( eLanguage == LANGUAGE_SYSTEM || eLanguage == LANGUAGE_DONTKNOW )
            eLanguage = aOldInter.GetLanguage();
        else
            Application::SetAppInternational( International( eLanguage, eLanguage ) );

        // alte Proxy-Eintr"age vorhanden?
        String aOldProxyName = Get(SFX_KEY_INET_PROXYNAME);
        String aOldProxyPort = Get(SFX_KEY_INET_PROXYPORT);
        if ( aOldProxyName.Len() && aOldProxyPort.Len() )
        {
            // auf neue mappen
            SfxIniManager *pOffIni = pSub ? pSub : this;
            pOffIni->Set(aOldProxyName, SFX_KEY_INET_HTTPPROXYNAME);
            pOffIni->Set(aOldProxyPort, SFX_KEY_INET_HTTPPROXYPORT);
            pOffIni->Set(aOldProxyName, SFX_KEY_INET_FTPPROXYNAME);
            pOffIni->Set(aOldProxyPort, SFX_KEY_INET_FTPPROXYPORT);

            // die alten l"oschen
            pOffIni->Delete(SFX_KEY_INET_PROXYNAME);
            pOffIni->Delete(SFX_KEY_INET_PROXYPORT);
        }
    }
}

// -----------------------------------------------------------------------

SfxIniManager::~SfxIniManager()

/*  [Beschreibung]

	Der Desktruktor der Klasse SfxIniManager zerst"ort die von ihm automatisch
	angelegten <Sub-Ini-Manager> und die explizit mit <SfxIniManager::
	SetSubIniManager(const String& rIniName)> erzeugten ebenfalls.
*/

{
	DBG_DTOR(SfxIniManager, 0);
	delete pImp;
	delete pSub;
}

// ------------------------------------------------------------------------

sal_Bool SfxIniManager::IsValid () const
{
	return (
			( pImp != NULL		)	&&
			( pImp->xIni.is ()	)
		   ) ;
}

// ------------------------------------------------------------------------

sal_Bool SfxIniManager::IsReadOnly() const
{
	sal_Bool bReadOnly = pImp->xIni->isReadOnly () ;

	return bReadOnly ;
}

// ------------------------------------------------------------------------

void SfxIniManager::EnterLock()

/*	[Beschreibung]

	Z"ahlt den Lock-Count dieses und seiner Sub-IniManager um einen hoch.
	Siehe <Config::EnterLock()>.
*/

{
}

// ------------------------------------------------------------------------

void SfxIniManager::LeaveLock()

/*	[Beschreibung]

	Z"ahlt den Lock-Count dieses und seiner Sub-IniManager um einen runter.
	Siehe <Config::LeaveLock()>.
*/
{
}

// ------------------------------------------------------------------------

void SfxIniManager::ResetLock()

/*	[Beschreibung]

	Hebt den initialen Lock auf gesharete Config-Instanzen auf.
*/

{
}

// ------------------------------------------------------------------------

const String& SfxIniManager::GetProgramPath() const

/*  [Beschreibung]

	Liefert den Pfad zum ausf"uhrbaren Programm zur"uck. Dieser wird
	im Ini-Manager z.B. zur Bestimmung relativer Pfade etc. ben"otigt.
*/
{
	return pImp->aProgPathStr;
}

// ------------------------------------------------------------------------

String SfxIniManager::ToRel
(
	const String&   rPath       // in relativen Pfad umzuwandelnder Dateipfad
)   const

/*  [Beschreibung]

	Diese Methode wandelt den angegebenen Dateipfad in einen zum
	Programmpfad relativen um.


	[Beispiel]

	Ist der Programmpfad "c:\soffice3", so gilt:
	ToRel("c:\\soffice3\\vorlagen") == "vorlagen"
*/

{
	DBG_CHKTHIS(SfxIniManager, 0);
	String aRet;
#if 0
	DirEntry aEntry(rPath);
	aEntry.ToRel(pImp->aProgPath);
	if ( aEntry[aEntry.Level()-1] == DirEntry(FSYS_FLAG_PARENT) )
		return rPath;
	return aEntry.GetFull();
#endif
	DBG_ERRORFILE( "don't use this - ask PB" );
	return aRet;
}

// -----------------------------------------------------------------------

sal_Bool SfxIniManager::SearchFile( String& rIniFile, SfxIniKey eDirKey )
{
	// check parameters: empty inifile name or no directory key are invalid
	if ( !rIniFile.Len() || FindGroup( eDirKey ) != SFX_GROUP_DIR )
	{
		DBG_ERRORFILE( "SfxIniManager::SearchFile(): invalid parameters" );
		return sal_False;
	}

	String aIniFile = SubstPathVars( rIniFile );
	sal_Bool bRet = sal_False;

	switch ( eDirKey )
	{
		case SFX_KEY_CONFIG_DIR:
		case SFX_KEY_USERCONFIG_PATH:
		case SFX_KEY_DICTIONARY_PATH:
		case SFX_KEY_USERDICTIONARY_DIR:
		{
			SfxIniKey eKey =
				( SFX_KEY_CONFIG_DIR == eDirKey || SFX_KEY_USERCONFIG_PATH == eDirKey )
				? SFX_KEY_USERCONFIG_PATH : SFX_KEY_USERDICTIONARY_DIR;
			bRet = sal_True;
			INetURLObject aObj( Get( eKey ), INET_PROT_FILE );
			aObj.insertName( aIniFile );
			if ( !FileExists_Impl( aObj.GetMainURL() ) )
			{
				eKey =
					( SFX_KEY_CONFIG_DIR == eDirKey || SFX_KEY_USERCONFIG_PATH == eDirKey )
					? SFX_KEY_CONFIG_DIR : SFX_KEY_DICTIONARY_PATH;
				aObj.SetSmartURL( Get( eKey ) );
				aObj.insertName( aIniFile );
				bRet = FileExists_Impl( aObj.GetMainURL() );
			}

			if ( bRet )
				rIniFile = aObj.PathToFileName();

			break;
		}

		default:
		{
			String aPath = Get( eDirKey );
			sal_uInt16 i, nIdx = 0, nCount = aPath.GetTokenCount( SFX_SEARCHPATH_DELIMITER );
			for ( i = 0; i < nCount; ++i )
			{
				INetURLObject aObj;
				aObj.SetSmartProtocol( INET_PROT_FILE );
				aObj.SetSmartURL( aPath.GetToken( i, SFX_SEARCHPATH_DELIMITER, nIdx ) );
				aObj.insertName( aIniFile );
				bRet = FileExists_Impl( aObj.GetMainURL() );

				if ( bRet )
				{
					rIniFile = aObj.PathToFileName();
					break;
				}
			}
		}
	}

	return bRet;
}

// -----------------------------------------------------------------------

sal_Bool SfxIniManager::IsDontHideDisabledEntries()
{
	String aVal = Get( SFX_KEY_DONTHIDE_DISABLEDENTRIES );
	sal_Bool bRet = aVal.Len() ? (sal_Bool) aVal.ToInt32() : sal_False;
	return bRet;
}

// -----------------------------------------------------------------------

SfxIniGroup SfxIniManager::FindGroup
(
	SfxIniKey   eKey            /*  Schl"ussel-Id, dessen Gruppe gefunden
									werden soll */
)   const

/*  [Beschreibung]

	Diese Methode ermittelt die Gruppe, in der der "ubergeben Schl"ussel
	gespeichert wird.
*/

{
	// wie vorherige Gruppe?
	if ( eKey == pImp->eLastKey )
		return pImp->eLastGroup;

	// Gruppe suchen
	SfxIniGroup eGroup;
	if ( eKey <= SFX_KEY_GROUP_COMMON_END )
		eGroup = SFX_GROUP_COMMON;
	else if ( eKey <= SFX_KEY_GROUP_DIR_END )
		eGroup = SFX_GROUP_DIR;
	else if ( eKey <= SFX_KEY_GROUP_USER_END )
		eGroup = SFX_GROUP_USER;
	else if ( eKey <= SFX_KEY_GROUP_VIEW_END )
		eGroup = SFX_GROUP_VIEW;
	else if ( eKey <= SFX_KEY_GROUP_PICKLIST_END )
		eGroup = SFX_GROUP_PICKLIST_IMPL;
	else if ( eKey <= SFX_KEY_GROUP_WORKINGSET_END )
		eGroup = SFX_GROUP_WORKINGSET_IMPL;
	else if ( eKey <= SFX_KEY_GROUP_INET_END )
		eGroup = SFX_GROUP_INET;
	else if ( eKey <= SFX_KEY_GROUP_DATABASE_END )
		eGroup = SFX_GROUP_DATABASE;
	else if ( eKey <= SFX_KEY_GROUP_SECURITY_END )
		eGroup = SFX_GROUP_SECURITY;
	else if ( eKey <= SFX_KEY_GROUP_EXTBRW_END )
		eGroup = SFX_GROUP_EXTBRW;
	else if ( eKey <= SFX_KEY_GROUP_3D_ENGINE_END )
		eGroup = SFX_GROUP_3D_ENGINE;
	else if ( eKey <= SFX_KEY_GROUP_INTERNATIONAL_END )
		eGroup = SFX_GROUP_INTERNATIONAL;
	else if ( eKey <= SFX_KEY_GROUP_JAVA_END )
		eGroup = SFX_GROUP_JAVA;
	else if ( eKey <= SFX_KEY_GROUP_DESKTOP_END )
		eGroup = SFX_GROUP_DESKTOP;
	else
	{
		DBG_ERROR( "invalid Ini-Key" );
		eGroup = SFX_GROUP_UNKNOWN;
	}

	return eGroup;
}

//-----------------------------------------------------------------------
SfxIniManager* SfxIniManager::Find
(
	SfxIniKey       eKey,   // Id des Schl"ussels des Eintrags
	sal_uInt16          nIdx    // numerischer Anhang f"ur den Schl"ussel
)

/*  [Beschreibung]

	Diese Methode sucht in den Ini-Dateien den Wert, der unter
	dem durch 'eKey' bezeichneten Schl"sel steht.

	Wird er in keiner der verketteten Ini-Dateien gefunden, so wird
	ein 0-Pointer zur"uckgegben, sonst ein Pointer auf den SfxIniManger,
	in dem der Wert zuerst gesetzt ist.
*/

{
	return Find( FindGroup(eKey), String::CreateFromAscii(pKeys[eKey]), nIdx );
}

//-----------------------------------------------------------------------
SfxIniManager* SfxIniManager::Find
(
	SfxIniGroup     eGroup, // Id der Gruppe, in sich der Eintrag befindet
	const String&   rKey,   // textueller Schl"ussel des Eintrags
	sal_uInt16          nIdx    // numerischer Anhang f"ur den Schl"ussel
)

/*  [Beschreibung]

	Diese Methode sucht in den Ini-Dateien den Wert, der unter
	dem Schl"ssel 'rKey' in der durch 'eGroup' bezeichneten Gruppe
	steht.

	Wird er in keiner der verketteten Ini-Dateien gefunden, so wird
	ein 0-Pointer zur"uckgegben, sonst ein Pointer auf den SfxIniManger,
	in dem der Wert zuerst gesetzt ist.
*/

{
	// ggf. numerische Erweiterung anh"angen
	String aKey( rKey );
	if ( nIdx != USHRT_MAX )
        aKey.Insert( String::CreateFromInt32( nIdx ), 0 );

	// Key suchen
	for ( SfxIniManager *pIni = this;
		  pIni;
		  pIni = pIni->pSub )
	{
		// Build keyname
		String sKeyName ;

		sKeyName  = GetGroupName ( eGroup )	;
		sKeyName += '/';
		sKeyName += aKey					;

		// Search for right entry and open it.
//		Reference< XRegistryKey >  xRootKey	= pIni->pImp->xIni->getRootKey () ;
		Reference< XRegistryKey >  xEntryKey	= pIni->pImp->xRootKey->openKey ( sKeyName ) ;
//		xRootKey->closeKey  () ;
//		xRootKey = Reference< XRegistryKey >  () ;

		if (
			( xEntryKey.is () 									) &&
			( xEntryKey->getStringValue () .getLength () > 0	)
		   )
		{
			// We have found right key.
			// But first, we have to close used keys!
			xEntryKey->closeKey () ;
			xEntryKey = Reference< XRegistryKey >  () ;

			// return pointer to INIManager
			return pIni ;
		}
	}

	return 0;
}

//-----------------------------------------------------------------------

String SfxIniManager::GetKeyName( SfxIniKey eKey ) const
{
	return String::CreateFromAscii( pKeys[eKey] );
}

//-----------------------------------------------------------------------

String SfxIniManager::Get
(
	SfxIniKey       eKey,   // Id des Schl"ussels des Eintrags
	sal_uInt16          nIdx    // numerischer Anhang f"ur den Schl"ussel
)

/*  [Beschreibung]

	Diese Methode l"adt aus den Ini-Dateien den Wert, der unter
	dem durch 'eKey' bezeichneten Schl"sel steht.

	Wird er in keiner der verketteten Ini-Dateien gefunden, so wird
	ein Leerstring zur"uckgegeben.

	In System-"ubergreifende Gruppen des ini-Files wird der Inhalt immer
	im RTL_TEXTENCODING_IBM_850 geschrieben, der R"uckgabewert wird als RTL_TEXTENCODING_UTF8
	geliefert.
*/

{
	String aKey( String::CreateFromAscii(pKeys[eKey]) );
	if ( eKey == SFX_KEY_HTMLFONTSIZE )
	{
		// HTMLFontSz hat die Numerierung hinter (Kompat zum SW)
        aKey += String::CreateFromInt32( nIdx );
		nIdx = USHRT_MAX;
	}
	String aValue = Get_Impl( FindGroup(eKey), aKey, eKey, nIdx );

#if defined(OS2) || defined(DBG_MI)
	// Hack wegen OS/2-Fat, damit kein Folder 'Bookmark' (ohne 's') entsteht
	if ( ( eKey == SFX_KEY_BOOKMARK_DIR || eKey == SFX_KEY_WORK_PATH ) &&
		 aValue.Len() )
	{
		DirEntry aFolder( aValue );
		if ( !aFolder.Exists() )
		{
			String aName = aFolder.GetName().Copy( 0, 7 );
			aName += '*';
			aFolder.SetName( aName );
			if ( aFolder.First() )
				aValue = aFolder.GetFull();
		}
	}
#endif

	return aValue;
}

//-----------------------------------------------------------------------
String SfxIniManager::Get
(
	SfxIniGroup     eGroup, // Id der Gruppe, in sich der Eintrag befindet
	const String&   rKey,   // textueller Schl"ussel des Eintrags
	sal_uInt16          nIdx    // numerischer Anhang f"ur den Schl"ussel
)

/*  [Beschreibung]

	Diese Methode l"adt aus den Ini-Dateien den Wert, der unter
	dem Schl"ssel 'rKey' in der durch 'eGroup' bezeichneten Gruppe
	steht.

	Wird er in keiner der verketteten Ini-Dateien gefunden, so wird
	ein Leerstring zur"uckgegeben.

	In System-"ubergreifende Gruppen des ini-Files wird der Inhalt immer
	im RTL_TEXTENCODING_IBM_850 geschrieben, der R"uckgabewert wird als RTL_TEXTENCODING_UTF8
	geliefert.
*/

{
	return Get_Impl( eGroup, rKey, SFX_KEY_UNKNOWN, nIdx );
}

//-----------------------------------------------------------------------

String SfxIniManager::Get_Impl
(
	SfxIniGroup     eGroup, // Id der Gruppe, in sich der Eintrag befindet
	const String&   rKey,   // textueller Schl"ussel des Eintrags
	SfxIniKey       eKey,   // Id des Key f"ur Defaulting
	sal_uInt16          nIdx    // numerischer Anhang f"ur den Schl"ussel
)

{
	// ggf. numerische Erweiterung an die erste Position stellen
	String aKey( rKey );
	if ( nIdx != USHRT_MAX )
        aKey.Insert( String::CreateFromInt32( nIdx ), 0 );

	// Key suchen
	String aEntry;

	String aGroup( GetGroupName(eGroup) );

	for ( SfxIniManager *pIni = this; pIni; pIni = pIni->pSub )
	{
		// Key in dieser ini?
		// Build keyname
		String sKeyName ;

		sKeyName  = aGroup	;
		sKeyName += '/'		;
		sKeyName += aKey	;

		// Search for right entry and open it.
//		Reference< XRegistryKey >  xRootKey	= pIni->pImp->xIni->getRootKey () ;
		Reference< XRegistryKey >  xEntryKey	= pIni->pImp->xRootKey->openKey ( sKeyName ) ;
//		xRootKey->closeKey () ;
//		xRootKey = Reference< XRegistryKey >  () ;

		if ( xEntryKey.is () )
		{
			// Get value of entry.
			aEntry = xEntryKey->getStringValue () ;
			xEntryKey->closeKey () ;
			xEntryKey = Reference< XRegistryKey >  () ;
		}

/*
		if ( aEntry.Len() )
		{
			// ggf. Zeichensatz konvertieren
 			if ( eGroup == SFX_GROUP_USER || eGroup == SFX_GROUP_COMMON )
				aEntry = aEntry.Convert(RTL_TEXTENCODING_IBM_850, RTL_TEXTENCODING_UTF8);
			break;
		}
*/

		// gewisse Keys k"onnen gar nicht in einer anderen sein
		if ( eGroup >= SFX_GROUP_VIEW && eGroup <= SFX_GROUP_WORKINGSET_IMPL )
			break;;
	}

	// Pfade sind ggf. relativ angegeben
	if ( aEntry.Len() )
		aEntry = SubstPathVars( aEntry );

	return aEntry;
}

//-----------------------------------------------------------------------
String SfxIniManager::Get
(
	const String&   rGroup, // Gruppe, in sich der Eintrag befindet
	sal_Bool            bSysDep,// systemabh"angig
	sal_Bool            bAppDep,// applikationsabh"angig
	const String&   rKey,   // textueller Schl"ussel des Eintrags
	sal_uInt16          nIdx    // numerischer Anhang f"ur den Schl"ussel
)

/*  [Beschreibung]

	Diese Methode l"adt aus den Ini-Dateien den Wert, der unter
	dem Schl"ssel 'rKey' in der durch 'rGroup' bezeichneten Gruppe
	steht, die durch eine system- und/oder applikationsabh"angige
	Erweiterung erg"anzt werden kann.

	Wird er in keiner der verketteten Ini-Dateien gefunden, so wird
	ein Leerstring zur"uckgegeben.

	Ins ini-File wird der Inhalt immer im RTL_TEXTENCODING_IBM_850 geschrieben,
	der R"uckgabewert wird als RTL_TEXTENCODING_UTF8 geliefert.
*/

{
	String aEntry;

	// ggf. numerische Erweiterung anh"angen
	String aKey( rKey );
	if ( nIdx != USHRT_MAX )
        aKey.Insert( String::CreateFromInt32( nIdx ), 0 );

	// Key suchen
	String aGroup( GetGroupName( rGroup, bSysDep, bAppDep ) );
	for ( SfxIniManager *pIni = this;
		  pIni;
		  pIni = pIni->pSub )
	{
		// in dieser ini?
		// Build keyname
		String sKeyName ;

		sKeyName  = aGroup	;
		sKeyName += '/'		;
		sKeyName += aKey	;

		// Search for right entry and open it.
//		Reference< XRegistryKey >  xRootKey	= pIni->pImp->xIni->getRootKey () ;
		Reference< XRegistryKey >  xEntryKey	= pIni->pImp->xRootKey->openKey ( sKeyName ) ;
//		xRootKey->closeKey () ;
//		xRootKey = Reference< XRegistryKey >  () ;

		if ( xEntryKey.is () )
		{
			// Get value of entry.
			aEntry = xEntryKey->getStringValue () ;
			xEntryKey->closeKey () ;
			xEntryKey = Reference< XRegistryKey >  () ;
		}

		if ( aEntry.Len() )
		{
/*
			if ( bSysDep )
				return aEntry.Convert(RTL_TEXTENCODING_IBM_850, RTL_TEXTENCODING_UTF8);
			else
*/
				return aEntry;
		}
	}

	return aEntry;
}

//-----------------------------------------------------------------------

void SfxIniManager::Set
(
	const String&       rContent,   //  zu setzender Inhalt
	SfxIniKey           eKey,       //  Id des Schl"ussels des Eintrags
	sal_uInt16              nIdx
)

/*  [Beschreibung]

	Diese Methode setzt einen neuen Wert unter dem Schl"ssel, f"ur den
	'eKey' steht in die ebenfalls durch 'eKey' bestimmte Gruppe in der
	Master-Ini-Datei.

	Um Werte in den Sub-Ini-Managern zu setzen, mu"s dieser mit
	<SfxIniManager::GetSubManager() const> geholt und die Methode
	dort direkt aufgerufen werden.

	In systemanh"angigen Gruppen des ini-Files steht der Inhalt immer im
	RTL_TEXTENCODING_IBM_850, 'rContent' wird als RTL_TEXTENCODING_UTF8 erwartet.
*/

{
	String aKey( String::CreateFromAscii(pKeys[eKey]) );
	if ( eKey == SFX_KEY_HTMLFONTSIZE )
	{
		// HTMLFontSz hat die Numerierung hinter (Kompat zum SW)
        aKey += String::CreateFromInt32( nIdx );
		nIdx = USHRT_MAX;
	}

	// Gruppe ermitteln
	SfxIniGroup eGroup = FindGroup(eKey);
	sal_Bool bHasListeners = HasListeners();
	XubString aOldValue;

	if ( bHasListeners )
		aOldValue = Get( eKey, nIdx );

	Set( rContent, eGroup, aKey, nIdx );

	// ggf. "Anderungen broadcasten
	if ( bHasListeners )
	{
		XubString aNewValue = rContent;
		FASTBOOL bChanged = ( aNewValue != aOldValue );

		if ( bChanged && SFX_GROUP_DIR == eGroup )
		{
			INetURLObject aObj;
			aObj.SetSmartProtocol( INET_PROT_FILE );
			aObj.SetSmartURL( aOldValue );
			aOldValue = aObj.GetMainURL();
			aObj.SetSmartURL( SubstPathVars( aNewValue ) );
			aNewValue = aObj.GetMainURL();
		}

		if ( bChanged )
			Broadcast( SfxIniManagerHint( eKey, aOldValue, aNewValue ) );
	}
}

//-----------------------------------------------------------------------

void SfxIniManager::Set
(
	const String&       rContent,   //  zu setzender Inhalt

	SfxIniGroup         eGroup,     /*  Id der Gruppe, in der sich der
										Eintrag befindet */

	const String&       rKey,       /*  Schl"ussel dessen Inhalt gesetzt
										werden soll */

	sal_uInt16              nIdx        //  numerischer Anhang f"ur den Schl"ussel
)

/*  [Beschreibung]

	Diese Methode setzt einen neuen Wert unter dem Schl"ssel 'rKey' in
	der durch 'eGroup' bezeichneten Gruppe in der Master-Ini-Datei.

	Um Werte in den Sub-Ini-Managern zu setzen, mu"s dieser mit
	<SfxIniManager::GetSubManager() const> geholt und die Methode
	dort direkt aufgerufen werden.

	In systemanh"angigen Gruppen des ini-Files steht der Inhalt immer im
	RTL_TEXTENCODING_IBM_850, 'rContent' wird als RTL_TEXTENCODING_UTF8 erwartet.
*/

{
	// ggf. numerische Erweiterung anh"angen
	String aKey( rKey );
	if ( nIdx != USHRT_MAX )
        aKey.Insert( String::CreateFromInt32( nIdx ), 0 );

	// ggf. Zeichensatz konvertieren
	String aContent( rContent );
/*
 	if ( eGroup == SFX_GROUP_USER || eGroup == SFX_GROUP_COMMON )
		aContent = aContent.Convert(RTL_TEXTENCODING_UTF8, RTL_TEXTENCODING_IBM_850);
*/

	// Pfade werden ggf. relativ angegeben
	if ( aContent.Len() )
		aContent = UsePathVars( aContent );

	// Build keyname
	String sKey ;

	sKey  = GetGroupName ( eGroup )	;
	sKey += '/'						;
	sKey += aKey					;
	sKey += '/'						;
	sKey += aContent				;

	// Search for right entry. Create or open it and write new value.
	Reference< XRegistryKey >  xEntryKey	= pImp->xRootKey->createKey ( sKey ) ;	// "createKey()" will open key, if it already exist!
    if ( !xEntryKey.is() )
        // no write access
        return;

	if ( !aContent.Len() )
        // createKey() does not write empty contents
		xEntryKey->setStringValue( aContent );
	xEntryKey->closeKey () ;
	xEntryKey = Reference< XRegistryKey >  () ;
}

//-----------------------------------------------------------------------

void SfxIniManager::Delete
(
	SfxIniGroup         eGroup,     /*  Id der Gruppe, aus der ein Eintrag
										gel"oscht werden soll */

	const String&       rKey,       //  zu l"oschender Schl"ussel

	sal_uInt16              nIdx        /*  0 oder an den Schl"ussel anzuh"angender
										Index */
)

/*  [Beschreibung]

	Diese Methode l"scht einen neuen Wert unter dem Schl"ssel 'rKey' in
	der durch 'eGroup' bezeichneten Gruppe in der Master-Ini-Datei.
	Danach gilt ggf. wieder der Wert aus einer der Sub-Ini-Manager.

	Um Werte in den Sub-Ini-Managern zu setzen, mu"s dieser mit
	<SfxIniManager::GetSubManager()const> geholt und die Methode
	dort direkt aufgerufen werden.
*/

{
	// ggf. numerische Erweiterung anh"angen
	String aKey( rKey );
	if ( nIdx != USHRT_MAX )
        aKey.Insert( String::CreateFromInt32( nIdx ), 0 );

	// Werte werden immer im lokalen Ini-File gesetzt
	// Build keyname
	String sKeyName ;

	sKeyName  = GetGroupName ( eGroup )	;
	sKeyName += '/'						;
	sKeyName += aKey					;

	// Search for right entry and delete it (if it exist).
//	Reference< XRegistryKey >  xRootKey	= pImp->xIni->getRootKey () ;
	pImp->xRootKey->deleteKey ( sKeyName ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;
}

//-----------------------------------------------------------------------

void SfxIniManager::Delete
(
	SfxIniKey           eKey,       //  zu l"oschender Schl"ussel
	sal_uInt16              nIdx        /*  0 oder an den Schl"ussel anzuh"angender
										Index */
)

/*  [Beschreibung]

	Diese Methode l"scht einen neuen Wert unter dem Schl"ssel 'eKey'.
	Danach gilt ggf. wieder der Wert aus einer der Sub-Ini-Manager.

	Um Werte in den Sub-Ini-Managern zu setzen, mu"s dieser mit
	<SfxIniManager::GetSubManager()const> geholt und die Methode
	dort direkt aufgerufen werden.
*/

{
	// ggf. numerische Erweiterung anh"angen
	String aKey( String::CreateFromAscii(pKeys[eKey]) );
	if ( nIdx != USHRT_MAX )
        aKey.Insert( String::CreateFromInt32( nIdx ), 0 );

	// Werte werden immer im lokalen Ini-File gesetzt
	// Build keyname
	String sKeyName ;

	sKeyName  = GetGroupName ( FindGroup(eKey) )	;
	sKeyName += '/'									;
	sKeyName += aKey								;

	// Search for right entry and delete it (if it exist).
//	Reference< XRegistryKey >  xRootKey	= pImp->xIni->getRootKey () ;
	pImp->xRootKey->deleteKey ( sKeyName ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;
}

//-----------------------------------------------------------------------

void SfxIniManager::DeleteGroup
(
	SfxIniGroup         eGroup      /*  Id der zu l"oschenden Gruppe, die
										m"oglichen Ids k"onnen dem enum
										<SfxIniGroup> entnommen werden */
)

/*  [Beschreibung]

	Diese Methode l"oscht in der durch 'eGroup' bezeichneten Gruppe
	alle in der Master-Ini-Data befindlichen Eintr"age.

	Um die Eintr"age in den Sub-Ini-Managern zu l"oschen, mu"s dieser mit
	<SfxIniManager::GetSubManager()const> geholt und die Methode
	dort direkt aufgerufen werden.
*/

{
	// Werte werden immer im lokalen Ini-File gesetzt
	// Search for right section and delete it (if it exist).
//	Reference< XRegistryKey >  xRootKey	= pImp->xIni->getRootKey () ;
	pImp->xRootKey->deleteKey ( GetGroupName ( eGroup ) ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;
}

//-----------------------------------------------------------------------

void SfxIniManager::Fill
(
	SfxIniGroup eKey,                  /* Gruppe, dessen Werte erfragt werden sollen */
	SfxAllEnumItem &rNames,            /* die Namen der Eintr"age dieser Gruppe */
	SfxAllEnumItem &rValues            /* die Werte der Eintr"age dieser Gruppe */
)

/*  [Beschreibung]

	Diese Methode f"ullt die Werte eines Keys in 2 SfxAllEnumItems; aktuell
	nur implementiert f"ur SFX_GROUP_DIR.

*/

{
	switch( (int)eKey )
	{
		case SFX_GROUP_DIR:
		{
			sal_uInt16 i;

			for ( i = 0; i <= SFX_KEY_GROUP_DIR_END - (sal_uInt16)SFX_KEY_SUB_INI; ++i )
			{
				const String aName( SvtResId( CONFIG_PATH_START + i ) );
				const String aValue( Get( (SfxIniKey)( i + (sal_uInt16)SFX_KEY_SUB_INI ) ) );
				rNames.InsertValue( i, aName );
				rValues.InsertValue( i, SubstPathVars( aValue ) );
			}

			break;
		}

		default:
			DBG_ERRORFILE( "not implemented" );
			break;
	}
}

//-----------------------------------------------------------------------

void SfxIniManager::Set
(
	SfxIniGroup eKey,             /* Gruppe, dessen Werte gesetzt werden sollen */
	const SfxAllEnumItem &rValues /* die Werte der Eintr"age dieser Gruppe */
)

/*  [Beschreibung]

	Diese Methode schreibt die Werte eines Keys;
	nur implementiert f"ur SFX_GROUP_DIR.

	Enth"alt ein Eintrag einen Leerstring, so wird er gel"oscht, enth"alt
	er nur ein Space wird er nicht ber"ucksichtigt.
*/

{
	switch( (int)eKey )
	{
		case SFX_GROUP_DIR:
		{
			sal_uInt16 i, nCount;
			// ggf. ein Backup der Directory-Liste anlegen
			Reference< XRegistryKey >  xSectionKey	= pImp->xRootKey->openKey ( DEFINE_CONST_UNICODE(GROUPNAME_DIRBACKUP) ) ;
			sal_Bool bExists = (sal_Bool)xSectionKey.is();
			if ( !bExists )
				xSectionKey	= pImp->xRootKey->createKey( DEFINE_CONST_UNICODE( GROUPNAME_DIRBACKUP ) );
            if ( !xSectionKey.is() )
                // no write access
                return;
			nCount = 0 ;
			if ( bExists && xSectionKey.is () )
			{
				Sequence< OUString >seq_KeyList	= xSectionKey->getKeyNames	() ;
				nCount							= seq_KeyList.getLength		() ;
				// Do not close xSectionKey at this point!
				// We use it also later....
			}

			if ( !nCount )
			{
				FASTBOOL bChanged = sal_False;
				nCount = rValues.GetValueCount();
				for ( i = 0; !bChanged && i < nCount; ++i )
				{
					const String aValue( rValues.GetValueTextByPos(i) );
					bChanged = ( !aValue.Len() || aValue.CompareToAscii(SFX_PATH_NOTCHANGED) != COMPARE_EQUAL );
				}

				if ( bChanged )
				{
					// Items werden nur tempor"ar benutzt -> deshalb ist der Which-Wert egal
					SfxAllEnumItem aNames( rValues.Which() );
					SfxAllEnumItem aValues( rValues.Which() );
					Fill( SFX_GROUP_DIR, aNames, aValues );

					// At this point we use also xSectionKey! see below
					for ( i = 0; i < rValues.GetValueCount(); ++i )
					{
						String aKey		= GetKeyName( i + (sal_uInt16)SFX_KEY_SUB_INI );
						String aPath	= UsePathVars( aValues.GetValueTextByPos(i) );

						Reference< XRegistryKey >  xEntryKey = xSectionKey->createKey ( aKey ) ;
						if ( xEntryKey.is () )
						{
							xEntryKey->setStringValue ( aPath ) ;
							xEntryKey->closeKey () ;
							xEntryKey = Reference< XRegistryKey >  () ;
						}
					}

					xSectionKey->closeKey () ;
					xSectionKey = Reference< XRegistryKey >  () ;
				}
			}

			nCount = rValues.GetValueCount();
			for ( i = 0; i < nCount; ++i )
			{
				String aNewValue( rValues.GetValueTextByPos(i) );
				if ( aNewValue.CompareToAscii( SFX_PATH_NOTCHANGED ) != COMPARE_EQUAL )
				{
					SfxIniKey nIniKey = (SfxIniKey)( i + (sal_uInt16)SFX_KEY_SUB_INI );
					if ( !aNewValue.Len() )
						Delete( nIniKey );
					else
						Set( UsePathVars( aNewValue ), nIniKey );
				}
			}
			break;
		}

		default:
			DBG_ERRORFILE( "not implemented" );
			break;
	}
}

//-----------------------------------------------------------------------

String SfxIniManager::GetGroupName( SfxIniGroup eGroup ) const
{
	String aRet;
	if ( eGroup >= SFX_GROUP_UNKNOWN )
	{
		DBG_ERROR( "invalid Ini-Group" );
	}
	else
	{
		SfxIniGroup_Impl aGroup = aGroups_Impl[ (int) eGroup ];
		if ( 2 == aGroup.bUseOS )
		{
			// os-specific group not emty => use it!
			// Search for right section and open it.
//			Reference< XRegistryKey >  xRootKey	= pImp->xIni->getRootKey () ;
			Reference< XRegistryKey > 	xSectionKey	= pImp->xRootKey->openKey ( GetGroupName( String::CreateFromAscii(aGroup.sName), 1, aGroup.bUseApp ) ) ;
//			xRootKey->closeKey () ;
//			xRootKey = Reference< XRegistryKey >  () ;

			// A section can only exist with subkeys!
			aGroup.bUseOS = sal_False ; // Default!
			if ( xSectionKey.is () )
			{
				// When we have a valid sectionkey ... we have also valid subkeys!
				// But first, we have to close used keys!
				xSectionKey->closeKey () ;
				xSectionKey = Reference< XRegistryKey >  () ;

				aGroup.bUseOS = sal_True ;
			}
		}
		aRet = GetGroupName( String::CreateFromAscii(aGroup.sName), aGroup.bUseOS, aGroup.bUseApp );
	}

	return aRet;
}

//-----------------------------------------------------------------------
String SfxIniManager::GetGroupName
(
	const String&       rName,      //  frei zu vergebender Namensteil

	sal_Bool                bSysDepen,  /*  sal_True
										Der Gruppenname wird mit einem Zusatz
										erweitert, der systemabh"angig ist.

										sal_False
										Der Gruppenname nicht mit einem
										systemabh"angigen Zusatz erweitert. */

	sal_Bool                bAppDepen   /*  sal_True
										Der Gruppenname wird mit einem Zusatz
										erweitert, der applikationsspezifisch
										ist.

										sal_False
										Der Gruppenname nicht mit einem
										applikationsspezifischen Zusatz
										erweitert. */
)   const

/*  [Beschreibung]

	Diese Methode setzt einen Gruppen-Namen aus einem frei definierbaren
	Basis-Namen ('rName') sowie optional einem system- und/oder einem
	applikationsspezifischen Namensteil zusammen.


	[R"uckgabewert]

	Aus den einzelnen Teilen und trennenden '-' zusammengesetzter String.


	[Beispiel]

	SfxIniManager::GetGroupName( "Test", sal_True, sal_True ) == "SDraw3-Test-OS/2"
*/

{
	String aRet;

	if ( bAppDepen )
	{
		aRet += pImp->aAppName;
		aRet += '-';
	}

	aRet += rName;

	if ( bSysDepen )
	{
		if ( '-' != aRet.GetChar( aRet.Len() - 1 ) )
			aRet += '-';
		aRet += String::CreateFromAscii(pOS);
	}

	return aRet;
}

//-----------------------------------------------------------------------

String SfxIniManager::GetString
(
	const Point&    rPos,       // Point, der in einen String umzuwandeln ist
	const Size&     rSize       // Size, die in einen String umzuwandeln ist
)

/*  [Beschreibung]

	Diese Methode setzt aus einem Point 'rPos' und einer Size 'rSize'
	einen String zusammen, der die einzelnen Koordinaten durch einen '/'
	trennt.

	[Querverweise]
	<SfxIniManager::GetPosSize(const String&,Point&,Size&)>
*/

{
    String aRet = String::CreateFromInt32( rPos.X() );
	aRet += '/';
    aRet += String::CreateFromInt32( rPos.Y() );
	aRet += '/';
    aRet += String::CreateFromInt32( rSize.Width() );
	aRet += '/';
    aRet += String::CreateFromInt32( rSize.Height() );
    return aRet;
}

//-----------------------------------------------------------------------

sal_Bool SfxIniManager::GetPosSize
(
	const XubString&   rStr, /*  In: String, aus dem der Point und die Size
								gelesen  werden */

	Point&          rPos,   //  Out: Point aus den ersten beiden Token

	Size&           rSize   //  Out: Size aus den letzten beiden Token
)

/*  [Beschreibung]

	Diese Methode extrahiert einen Point und eine Size aus einem String, sie
	ist das Gegenst"uck zu <SfxIniManager::GetString(const Point&,const Size&)>.


	[R"uckgabewert]

	sal_Bool            sal_True
					es wurden vier durch '/' getrennte Token gefunden,
					'rPos' und 'rSize' wurden mit werden beschrieben und
					ein Fenster mit derartigen Koordinaten w"are auf dem
					Bildschrim sichtbar

					sal_False
					entweder enh"alt der String 'rStr' nicht exakt vier durch
					'/' getrennte Token, 'rPos' und 'rSize' sind dann
					unver"andert; oder 'rPos' und 'rSize' konnten ausgelesen
					werden, aber ein Fenster mit derartige Koordinaten l"age
					nicht sinnvoll auf dem Bildschirm oder h"atte eine
					negative Gr"o\se
*/

{
	if ( rStr.GetTokenCount('/') != 4 )
		return sal_False;

	rPos.X() = rStr.GetToken(0, '/').ToInt32();
	rPos.Y() = rStr.GetToken(1, '/').ToInt32();
	rSize.Width() = rStr.GetToken(2, '/').ToInt32();
	rSize.Height() = rStr.GetToken(3, '/').ToInt32();

	// negative Sizes sind unzul"assig
	if ( rSize.Width() < 0 || rSize.Height() < 0 )
		return sal_False;

	// w"are ein Fenster mit solchen Positionen auf dem Bildschirm
	WorkWindow* pWindow = NULL /*! no AppWin anymore Application::GetAppWindow() */;
	if ( !pWindow || !pWindow->IsVisible() )
		return sal_True;
	const Size aScreen( pWindow->GetDesktopRectPixel().GetSize() );
	if ( rPos.X() < aScreen.Width() - 40 && rPos.X() > -8 &&
		 rPos.Y() < aScreen.Height() - 20 && rPos.Y() > -8 )
		return sal_True;
	return sal_False;
}

// -----------------------------------------------------------------------

sal_Bool SfxIniManager::CheckPLZ( const XubString& rPLZ, Window* pBoxParent )

/*  [Beschreibung]

	Der "ubergebene String wird "uberpr"uft.
	Er muss mit einer Zahl oder einem Buchstabe beginnen und darf
	nur Zahlen, Buchstaben, Leerzeichen und Trennstriche beinhalten.
*/

{
	sal_Bool bRet = sal_True;
#if 0
	// PB: #64529# Pr"ufung f"ur die 5.1 erstmal auskommentiert
	const char* pChar = rPLZ.GetBuffer();

	if ( ' ' == *pChar || '-' == *pChar )
		// muss alphanummerisch beginnen
		bRet = sal_False;

	while ( bRet && *pChar )
	{
		if ( !(((*pChar >= 97) && (*pChar <= 122)) ||
			   ((*pChar >= 65) && (*pChar <=  90)) ||
			   ((*pChar >= 48) && (*pChar <=  57)) ||
			   ' ' == *pChar || '-' == *pChar ) )
			bRet = sal_False;
		pChar++;
	}

	if ( !bRet && SFX_NO_BOXPARENT != pBoxParent )
	{
		ErrorBox aBox( pBoxParent, SvtResId( ERRBOX_CHECK_PLZ ) );
		aBox.Execute();
	}
#endif
	return bRet;
}

//------------------------------------------------------------------------

String SfxIniManager::GetUserFullName()

/*  [Beschreibung]

	Liest Vor- und Nachname aus der Ini und liefert den zusammengesetzten
	Namen zur"uck.
*/

{
	String aFullName( Get(SFX_KEY_USER_FIRSTNAME) );
	aFullName += ' ';
	aFullName += Get(SFX_KEY_USER_NAME);
	return aFullName;
}

//------------------------------------------------------------------------

String SfxIniManager::GetAddressToken( AddressToken eToken )

/*  [Beschreibung]

	Liest den gesamten Adress-String aus der Ini und liefert
	den gew"unschten Token.
*/

{
	return SfxIniManagerAddressEntry::get(Get(SFX_KEY_USER_ADDRESS), eToken);
}

//------------------------------------------------------------------------

sal_uInt32 SfxIniManager::GetFeatures()
{
	if ( !pImp->nFeatures )
	{
		// Diese Module gelten momentan als immer installiert
		sal_uInt32 nFlags = SFX_FEATURE_MAIL_NEWS_IMAP | SFX_FEATURE_BASIC_IDE |
			SFX_FEATURE_DATABASE | SFX_FEATURE_SWRITER | SFX_FEATURE_SWRITERWEB |
			SFX_FEATURE_SWRITERGLOBAL | SFX_FEATURE_GALLERY;

		// Search for right section.
//		Reference< XRegistryKey >  	xRootKey	= pImp->xIni->getRootKey   () ;
		Reference< XRegistryKey > 		xSectionKey	= pImp->xRootKey->openKey( GetGroupName( SFX_GROUP_MODULES ) ) ;

//		xRootKey->closeKey () ;
//		xRootKey = Reference< XRegistryKey >  () ;

		sal_uInt16 				nCount		= 0 	;
		Sequence< OUString >	seq_SubKeys ( 0 )	;
		OUString*			pKeyList	= NULL	;

		if ( xSectionKey.is () )
		{
			// Get keynames of section-entries.
			seq_SubKeys	=	xSectionKey->getKeyNames	() ;
			pKeyList	=	seq_SubKeys.getArray		() ;

			// Get number of entries.
			nCount = seq_SubKeys.getLength () ;
		}

		if ( nCount )
		{
			// Wenn weitere Module installiert sind, abfragen
			for ( sal_uInt16 n=0; n<nCount; n++ )
			{
				// Get name and value of current key in sequence.
				Reference< XRegistryKey > 	xEntryKey	= xSectionKey->openKey ( pKeyList[n] ) ;
				String			aModNam		= xEntryKey->getKeyName	  () ;
				String			aValue		= xEntryKey->getStringValue () ;

				xEntryKey->closeKey () ;
	 			xEntryKey = Reference< XRegistryKey >  () ;

				if ( !aValue.ToInt32() )
					continue;

				if ( !(nFlags & SFX_FEATURE_MAIL_NEWS_IMAP) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_MAIL_NEWS_IMAP ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_MAIL_NEWS_IMAP;
				if ( !(nFlags & SFX_FEATURE_BASIC_IDE) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_BASIC_IDE ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_BASIC_IDE;
				if ( !(nFlags & SFX_FEATURE_DATABASE) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_DATABASE ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_DATABASE;
				if ( !(nFlags & SFX_FEATURE_SCHEDULE) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SCHEDULE ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SCHEDULE;
				if ( !(nFlags & SFX_FEATURE_SMATH) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SMATH ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SMATH;
				if ( !(nFlags & SFX_FEATURE_SCHART) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SCHART ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SCHART;
				if ( !(nFlags & SFX_FEATURE_SIMAGE ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SIMAGE ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SIMAGE;
				if ( !(nFlags & SFX_FEATURE_SCALC ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SCALC ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SCALC;
				if ( !(nFlags & SFX_FEATURE_SDRAW ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SDRAW ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SDRAW;
				if ( !(nFlags & SFX_FEATURE_SWRITER ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SWRITER ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SWRITER;
				if ( !(nFlags & SFX_FEATURE_SWRITERWEB ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SWRITERWEB ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SWRITERWEB;
				if ( !(nFlags & SFX_FEATURE_SIMPRESS ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SIMPRESS ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SIMPRESS;
				if ( !(nFlags & SFX_FEATURE_SWRITERGLOBAL ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_SWRITERGLOBAL ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_SWRITERGLOBAL;
				if ( !(nFlags & SFX_FEATURE_GALLERY ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_GALLERY ) == COMPARE_EQUAL )
					nFlags |= SFX_FEATURE_GALLERY;
                if ( !(nFlags & SFX_FEATURE_IEXPLORER ) && aModNam.CompareIgnoreCaseToAscii( SFX_MODULE_IEXPLORER ) == COMPARE_EQUAL )
                    nFlags |= SFX_FEATURE_IEXPLORER;
			}

			xSectionKey->closeKey () ;
			xSectionKey = Reference< XRegistryKey >  () ;
		}
		else
		{
			// Falls die Gruppe fehlt ( leider nicht unterscheidbar von
			// Gruppe leer ), wurde kein benutzerdefiniertes Setup verwendet,
			// also sind alle Module da
			nFlags 	|= SFX_FEATURE_SCHEDULE | SFX_FEATURE_SMATH | SFX_FEATURE_SCHART
					| SFX_FEATURE_SIMAGE | SFX_FEATURE_SCALC | SFX_FEATURE_SDRAW
                    | SFX_FEATURE_SIMPRESS | SFX_FEATURE_IEXPLORER;
		}

		pImp->nFeatures = nFlags;
	}

	return pImp->nFeatures;
}

//------------------------------------------------------------------------

sal_Bool SfxIniManager::IsInternetExplorerAvailable()

/*  [Beschreibung]

	Abfrage, ob der Internet Explorer installiert ist.
	Die Version muss >= 4.0 sein.
*/

{
    return pImp->bIEAvailable && ( pImp->nFeatures & SFX_FEATURE_IEXPLORER );
}

// -----------------------------------------------------------------------

String GetJavaIniKey_Impl( SfxIniKey eKey, SfxIniManager* pIniMgr )
{
	String aIniKey;
	INetURLObject aObj;
	aObj.SetSmartProtocol( INET_PROT_FILE );
	aObj.SetSmartURL( Config::GetConfigName(
		pIniMgr->Get( SFX_KEY_USERCONFIG_PATH ), DEFINE_CONST_UNICODE("java") ) );
	String aIniPath = aObj.getName();
	if ( pIniMgr->SearchFile( aIniPath ) )
	{
		Config aJavaCfg( aIniPath );
		aJavaCfg.SetGroup( "Java" );
		String aKeyName = pIniMgr->GetKeyName( eKey );
		aIniKey = String::CreateFromAscii( aJavaCfg.ReadKey( ByteString(aKeyName, RTL_TEXTENCODING_UTF8 ) ).GetBuffer() );
	}
	return aIniKey;
}

//------------------------------------------------------------------------

sal_Bool SfxIniManager::IsJavaEnabled()
{
#ifdef SOLAR_JAVA
	return ( GetJavaIniKey_Impl( SFX_KEY_JAVA_ENABLE, this ) == pImp->aTRUEStr );
#else
	return sal_False;
#endif
}

//------------------------------------------------------------------------
#if (SUPD < 582)
sal_Bool SfxIniManager::IsJavaScriptEnabled()
{
	return ( IsJavaEnabled() &&
			 ( GetJavaIniKey_Impl( SFX_KEY_INET_EXE_JAVASCRIPT, this ) == pImp->aTRUEStr ) );
}
#endif
//------------------------------------------------------------------------

sal_Bool SfxIniManager::IsAppletsEnabled()
{
	return ( IsJavaEnabled() &&
			 ( GetJavaIniKey_Impl( SFX_KEY_INET_EXE_APPLETS, this ) == pImp->aTRUEStr ) );
}

//-------------------------------------------------------------------------

#define MAX_COMPARE_LEN 11

String SfxIniManager::SubstPathVars( const String& rPath ) const
{
	// Cast xIni to XConfigManager-interface.
	Reference< XConfigManager >	xConfig	= Reference< XConfigManager >  ( pImp->xIni, UNO_QUERY ) ;

	// Safe impossible cases
	// We need this interface to work!
	DBG_ASSERT ( !( xConfig.is () == sal_False ), "SfxIniManager::SubstPathVars()\nCould not cast xIni to XConfigManager!?\n" ) ;

	String myPath ( rPath ) ;

	if ( xConfig.is () )
	{
		// Forward to ConfigManager !
		myPath = xConfig->substituteVariables ( rPath ) ;
	}

	return myPath ;

	// return aPath ;
}

//-------------------------------------------------------------------------

String SfxIniManager::UsePathVars( const String& rPath ) const
{
	String aPath( rPath ), aTemp( rPath );
	sal_uInt16 nPos;

	// $(prog) - directory of the executable file
	String aProgPath = pImp->aProgPathObj.PathToFileName();
	aProgPath.ToLowerAscii();
	while ( STRING_NOTFOUND != ( nPos = aTemp.ToLowerAscii().Search( aProgPath ) ) )
	{
		aPath.Erase( nPos, aProgPath.Len() );
		aPath.Insert( DEFINE_CONST_UNICODE("$(prog)"), nPos );
		aTemp = aPath;
	}

	// $(user) - directory of the user installation (== dir of soffice.ini)
	String aTestStr = pImp->aUserPath;
	aTestStr.ToLowerAscii();
	while ( STRING_NOTFOUND != ( nPos = aTemp.ToLowerAscii().Search( aTestStr ) ) )
	{
		aPath.Erase( nPos, pImp->aUserPath.Len() );
		aPath.Insert( DEFINE_CONST_UNICODE("$(user)"), nPos );
		aTemp = aPath;
	}

	// $(inst) - directory of the master (server) installation
	aTestStr = pImp->aInstRoot;
	aTestStr.ToLowerAscii();
	while ( STRING_NOTFOUND != ( nPos = aTemp.ToLowerAscii().Search( aTestStr ) ) )
	{
		aPath.Erase( nPos, pImp->aInstRoot.Len() );
		aPath.Insert( DEFINE_CONST_UNICODE("$(inst)"), nPos );
		aTemp = aPath;
	}

	// $(progurl) - directory of the executable file
	String aTestURL = pImp->aProgPathObj.GetMainURL();
	aTestURL.ToLowerAscii();
	while ( STRING_NOTFOUND != ( nPos = aTemp.ToLowerAscii().Search( aTestURL ) ) )
	{
		aPath.Erase( nPos, aTestURL.Len() );
		aPath.Insert( DEFINE_CONST_UNICODE("$(progurl)"), nPos );
		aTemp = aPath;
	}

	// $(userurl) - directory of the user installation (== dir of soffice.ini)
	INetURLObject aObj(	pImp->aUserPath, INET_PROT_FILE );
	aObj.removeFinalSlash();
	aTestURL = aObj.GetMainURL();
	aTestURL.ToLowerAscii();
	while ( STRING_NOTFOUND != ( nPos = aTemp.ToLowerAscii().Search( aTestURL ) ) )
	{
		aPath.Erase( nPos, aTestURL.Len() );
		aPath.Insert( DEFINE_CONST_UNICODE("$(userurl)"), nPos );
		aTemp = aPath;
	}

	// $(insturl) - directory of the master (server) installation
	aObj.SetSmartURL( pImp->aInstRoot );
	aObj.removeFinalSlash();
	aTestURL = aObj.GetMainURL();
	aTestURL.ToLowerAscii();
	while ( STRING_NOTFOUND != ( nPos = aTemp.ToLowerAscii().Search( aTestURL ) ) )
	{
		aPath.Erase( nPos, aTestURL.Len() );
		aPath.Insert( DEFINE_CONST_UNICODE("$(insturl)"), nPos );
		aTemp = aPath;
	}

	return aPath;
}

//-------------------------------------------------------------------------

void SfxIniManager::DeleteGroup( const String& rGroup )
{
	// Search for right section and delete it (if it exist).
//	Reference< XRegistryKey >  xRootKey = pImp->xIni->getRootKey () ;
	pImp->xRootKey->deleteKey ( rGroup ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;
}

//-------------------------------------------------------------------------

void SfxIniManager::DeleteKey( const String& rGroup, const String& rKey )
{
	// Build keyname.
	String sKeyName ;

	sKeyName	 =	rGroup	;
	sKeyName	+=	'/'		;
	sKeyName	+=	rKey	;

	// Search for right entry and delete it (if it exist).
//	Reference< XRegistryKey >  xRootKey = pImp->xIni->getRootKey () ;
	pImp->xRootKey->deleteKey ( sKeyName ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;
}

//-------------------------------------------------------------------------

String SfxIniManager::ReadKey( const String& rGroup, const String& rKey )
{
	// Build keyname.
	String sKeyName ;

	sKeyName	 =	rGroup	;
	sKeyName	+=	'/'		;
	sKeyName	+=	rKey	;

	// Search for right entry and open it.
//	Reference< XRegistryKey > 	xRootKey	=	pImp->xIni->getRootKey () ;
	Reference< XRegistryKey > 	xEntryKey	=	pImp->xRootKey->openKey ( sKeyName ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;

	// Get value of key.
	String sValue;
	if ( xEntryKey.is () )
	{
		sValue = xEntryKey->getStringValue () ;
		xEntryKey->closeKey () ;
		xEntryKey = Reference< XRegistryKey >  () ;
	}

	return sValue ;
}

//-------------------------------------------------------------------------

void SfxIniManager::WriteKey( const String& rGroup, const String& rKey, const String& rValue )
{
	// Build keyname.
	String sKey ;

	sKey	 =	rGroup	;
	sKey	+=	'/'	;
	sKey	+=	rKey	;
	sKey	+=	'/'		;
	sKey	+=	rValue	;

	// Search for right entry and open it.
	Reference< XRegistryKey > 	xEntryKey	=	pImp->xRootKey->createKey ( sKey ) ;
    if ( !xEntryKey.is() )
        // no write access
        return;
	xEntryKey->closeKey () ;
	xEntryKey = Reference< XRegistryKey >  () ;
}

//-------------------------------------------------------------------------

void SfxIniManager::Flush()
{
    // Cast xIni to XConfigManager-interface.
    Reference< XConfigManager > xConfig = Reference< XConfigManager >  ( pImp->xIni, UNO_QUERY ) ;
	if ( xConfig.is () )
		xConfig->flush() ;
}

//-------------------------------------------------------------------------

sal_uInt16 SfxIniManager::GetKeyCount( const String& rGroup )
{
	// Search for right section and open it.
//	Reference< XRegistryKey > 	xRootKey	=	pImp->xIni->getRootKey () ;
	Reference< XRegistryKey > 	xSectionKey	=	pImp->xRootKey->openKey ( rGroup ) ;
//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;

	// Get number of entries.
	sal_uInt16 nCount = 0 ;
	if ( xSectionKey.is () )
	{
		// Get keynames of all entries of this section.
		Sequence< OUString > seq_KeyList = xSectionKey->getKeyNames () ;
		// Number of entries = size of sequence.
		nCount = seq_KeyList.getLength () ;
		xSectionKey->closeKey () ;
		xSectionKey = Reference< XRegistryKey >  () ;
	}

	return nCount ;
}

//-------------------------------------------------------------------------

String	SfxIniManager::GetKeyName( const String& rGroup, sal_uInt16 nIndex )
{
	// Search for right section and open it (if it exist).
//	Reference< XRegistryKey > 	xRootKey	=	pImp->xIni->getRootKey () ;
	Reference< XRegistryKey > 	xSectionKey	=	pImp->xRootKey->openKey ( rGroup ) ;

//	xRootKey->closeKey () ;
//	xRootKey = Reference< XRegistryKey >  () ;

	String sValue;
	if ( xSectionKey.is () )
	{
		// Get all keynames of entries in section.
		Sequence< OUString > seq_KeyList = xSectionKey->getKeyNames () ;
		OUString*			pList		= seq_KeyList.getArray () ;

		xSectionKey->closeKey () ;
		xSectionKey = Reference< XRegistryKey >  () ;

		// Control index!
		if ( nIndex < seq_KeyList.getLength () )
		{
			 // Get value of right entry.
			 sValue = pList [ nIndex ] ;
		}
	}

	return sValue ;
}


