/*************************************************************************
 *
 *  $RCSfile: sdbsql.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVT_SDBSQL_HXX
#include <sdbsql.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XDATABASEMETADATA_HPP_
#include <com/sun/star/sdbc/XDatabaseMetaData.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTER_HPP_
#include <com/sun/star/util/XNumberFormatter.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTYPES_HPP_
#include <com/sun/star/util/XNumberFormatTypes.hpp>
#endif
#ifndef _TOOLS_INTN_HXX //autogen wg. International
#include <tools/intn.hxx>
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SVT_SDBPARSE_HXX
#include <sdbparse.hxx>
#endif
#ifndef _SVSQL_INTL_HXX_
#include "intl.hxx"
#endif

extern ::com::sun::star::uno::Any getNumberFormatProperty(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xFormatter, 
														  sal_Int32 nKey, 
														  const rtl::OUString& );
extern double ToDouble(const Time& rTime);
extern double ToDouble(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xSupplier, const Date& rDate);
extern String ConvertLikeToken(const SdbSqlParseNode* pTokenNode, const SdbSqlParseNode* pEscapeNode, sal_Bool bInternational);

//------------------------------------------------------------------
SdbSqlParseNode::SQLParseNodeParameter::SQLParseNodeParameter(const String& _rIdentifierQuote, const String& _rCatalogSep, const International& _rIntl,
		sal_Bool _bIntl, sal_Bool _bQuote, char _cDecSep, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _xField,
		const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & _xFormatter,
		sal_Bool _bPredicate) 
	:aIdentifierQuote(_rIdentifierQuote)
	,aCatalogSeparator(_rCatalogSep)
	,rIntl(_rIntl)
	,bInternational(_bIntl)
	,bQuote(_bQuote)
	,cDecSep(_cDecSep)
	,xField(_xField)
	,xFormatter(_xFormatter)
	,bPredicate(_bPredicate)
{
}

//------------------------------------------------------------------
String SetQuotation(const String& rValue, const String& rQuot, const String& rQuotToReplace)
{
	String rNewValue = rQuot;
	rNewValue += rValue;

	if (rQuot.Len())
		rNewValue.SearchAndReplaceAll(rQuot,rQuotToReplace);
	
	rNewValue += rQuot;
	return rNewValue;
}

//-----------------------------------------------------------------------------
String SdbSqlParseNode::ConvertDateString(const SQLParseNodeParameter& rParam, const String& rString) const
{
	xub_StrLen nIndex = 0;
	sal_Int32 nYear = rString.GetToken(0,'-', nIndex).ToInt32(),
		  nMonth = rString.GetToken(0,'-', nIndex).ToInt32(),
		  nDay = rString.GetToken(0,'-', nIndex).ToInt32();

	Date aDate(nDay,nMonth,nYear);
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier(rParam.xFormatter->getNumberFormatsSupplier());
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatTypes >  xTypes(xSupplier->getNumberFormats(), ::com::sun::star::uno::UNO_QUERY);

	String sLanguage, sCountry;
	ConvertLanguageToIsoNames(rParam.rIntl.GetLanguage(), sLanguage, sCountry);
	::com::sun::star::lang::Locale aLocale(sLanguage,sCountry,rtl::OUString());
	
	double fDate = ToDouble(xSupplier, aDate);
	sal_Int32 nKey = xTypes->getStandardIndex(aLocale) + 36; // XXX hack
	return rParam.xFormatter->convertNumberToString(nKey, fDate);
}

//-----------------------------------------------------------------------------
String SdbSqlParseNode::ConvertDateTimeString(const SQLParseNodeParameter& rParam, const String& rString) const
{
	xub_StrLen nIndex = 0;
	sal_Int32 nYear = rString.GetToken(0,'-', nIndex).ToInt32(),
		  nMonth = rString.GetToken(0,'-', nIndex).ToInt32(),
		  nDay = rString.GetToken(0,'-', nIndex).ToInt32();

	nIndex = 10;	// eat white space		  
	sal_Int32 nHour = rString.GetToken(0,':', nIndex).ToInt32(),
		  nMinute = rString.GetToken(0,':', nIndex).ToInt32(),
		  nSecond = rString.GetToken(0,':', nIndex).ToInt32();

	Date aDate(nDay,nMonth,nYear);
	Time aTime(nHour,nMinute,nSecond);
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier(rParam.xFormatter->getNumberFormatsSupplier());
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatTypes >  xTypes(xSupplier->getNumberFormats(), ::com::sun::star::uno::UNO_QUERY);

	String sLanguage, sCountry;
	ConvertLanguageToIsoNames(rParam.rIntl.GetLanguage(), sLanguage, sCountry);
	::com::sun::star::lang::Locale aLocale(sLanguage,sCountry,rtl::OUString());

	double fDateTime = ToDouble(xSupplier, aDate) + ToDouble(aTime);
	sal_Int32 nKey = xTypes->getStandardIndex(aLocale) + 51; // XXX hack	
	return rParam.xFormatter->convertNumberToString(nKey, fDateTime);
}

//-----------------------------------------------------------------------------
String SdbSqlParseNode::ConvertTimeString(const SQLParseNodeParameter& rParam, const String& rString) const
{
	xub_StrLen nIndex = 0;
	sal_Int32 nHour = rString.GetToken(0,':', nIndex).ToInt32(),
		  nMinute = rString.GetToken(0,':', nIndex).ToInt32(),
		  nSecond = rString.GetToken(0,':', nIndex).ToInt32();

	Time aTime(nHour,nMinute,nSecond);
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier(rParam.xFormatter->getNumberFormatsSupplier());

	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatTypes >  xTypes(xSupplier->getNumberFormats(), ::com::sun::star::uno::UNO_QUERY);

	String sLanguage, sCountry;
	ConvertLanguageToIsoNames(rParam.rIntl.GetLanguage(), sLanguage, sCountry);
	::com::sun::star::lang::Locale aLocale(sLanguage,sCountry,rtl::OUString());

	double fTime = ToDouble(aTime);
	sal_Int32 nKey = xTypes->getStandardIndex(aLocale) + 41; // XXX hack
	return rParam.xFormatter->convertNumberToString(nKey, fTime);
}

DBG_NAME(SdbSqlParseNode);
//-----------------------------------------------------------------------------
SdbSqlParseNode::SdbSqlParseNode(const sal_Unicode * pNewValue,
								 SdbSqlNodeType eNewNodeType,
								 sal_uInt32 nNewNodeID)
		: m_aNodeValue(pNewValue)
		, m_eNodeType(eNewNodeType)
		, m_nNodeID(nNewNodeID)		
		, m_pParent(NULL)
{
	DBG_CTOR(SdbSqlParseNode,NULL);
	DBG_ASSERT(m_eNodeType >= SDB_SQL_RULE && m_eNodeType <= SDB_SQL_ACCESS_DATE,"SdbSqlParseNode: mit unzulaessigem NodeType konstruiert");	
}
//-----------------------------------------------------------------------------
SdbSqlParseNode::SdbSqlParseNode(const String &_rNewValue,
								 SdbSqlNodeType eNewNodeType,
								 sal_uInt32 nNewNodeID)
		: m_aNodeValue(_rNewValue)
		, m_eNodeType(eNewNodeType)
		, m_nNodeID(nNewNodeID)		
		, m_pParent(NULL)
{
	DBG_CTOR(SdbSqlParseNode,NULL);
	DBG_ASSERT(m_eNodeType >= SDB_SQL_RULE && m_eNodeType <= SDB_SQL_ACCESS_DATE,"SdbSqlParseNode: mit unzulaessigem NodeType konstruiert");	
}
//-----------------------------------------------------------------------------
SdbSqlParseNode::SdbSqlParseNode(const SdbSqlParseNode& rParseNode)
{
	DBG_CTOR(SdbSqlParseNode,NULL);
	// klemm den Parent auf NULL
	m_pParent = NULL;

	// kopiere die member
	m_aNodeValue = rParseNode.m_aNodeValue;
	m_eNodeType  = rParseNode.m_eNodeType;
	m_nNodeID    = rParseNode.m_nNodeID;


	// denk dran, dass von Container abgeleitet wurde, laut SV-Help erzeugt
	// copy-Constructor des Containers einen neuen Container mit den gleichen
	// Zeigern als Inhalt -> d.h. nach dem Kopieren des Container wird fuer
	// alle Zeiger ungleich NULL eine Kopie hergestellt und anstelle des alten
	// Zeigers wieder eingehangen.

	// wenn kein Blatt, dann SubTrees bearbeiten
	for (::std::vector<SdbSqlParseNode*>::const_iterator i = rParseNode.m_aChilds.begin();
		 i != rParseNode.m_aChilds.end(); i++)
		Append(new SdbSqlParseNode(**i));						
}

//-----------------------------------------------------------------------------
SdbSqlParseNode& SdbSqlParseNode::operator=(const SdbSqlParseNode& rParseNode)
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);

	if (this != &rParseNode) 
	{	
		// kopiere die member - pParent bleibt der alte
		m_aNodeValue = rParseNode.m_aNodeValue;
		m_eNodeType  = rParseNode.m_eNodeType;
		m_nNodeID    = rParseNode.m_nNodeID;
		
		for (::std::vector<SdbSqlParseNode*>::const_iterator i = m_aChilds.begin();
			i != m_aChilds.end(); i++)
			delete *i;
		
		m_aChilds.clear();					

		for (::std::vector<SdbSqlParseNode*>::const_iterator j = rParseNode.m_aChilds.begin();
			 j != rParseNode.m_aChilds.end(); j++)
			Append(new SdbSqlParseNode(**j));		
	}								 
	return *this;
}

//-----------------------------------------------------------------------------
sal_Bool SdbSqlParseNode::operator==(SdbSqlParseNode& rParseNode) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);

	// die member muessen gleich sein
	sal_Bool bResult = (m_nNodeID  == rParseNode.m_nNodeID) &&
				   (m_eNodeType == rParseNode.m_eNodeType) && 
				   (m_aNodeValue == rParseNode.m_aNodeValue) &&
				    Count() == rParseNode.Count();
	
	// Parameters are not equal!
	bResult = bResult && !SDB_ISRULE(this, parameter);

	// compare childs
	for (sal_uInt32 i=0; bResult && i < Count(); i++) 
		bResult = *GetChild(i) == *rParseNode.GetChild(i);					
	
	return bResult;
}					

//-----------------------------------------------------------------------------
SdbSqlParseNode::~SdbSqlParseNode()
{
	DBG_DTOR(SdbSqlParseNode,NULL);	
			
	for (::std::vector<SdbSqlParseNode*>::const_iterator i = m_aChilds.begin();
		 i != m_aChilds.end(); i++)
		delete *i;	
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::Append(SdbSqlParseNode* pNewNode)
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);
	DBG_ASSERT(pNewNode != NULL, "SdbSqlParseNode: ungueltiger NewSubTree");
	DBG_ASSERT(pNewNode->Parent() == NULL, "SdbSqlParseNode: Knoten ist kein Waise");
	DBG_ASSERT(::std::find(m_aChilds.begin(), m_aChilds.end(), pNewNode) == m_aChilds.end(), 
			"SdbSqlParseNode::Append() Node already element of parent");

	// stelle Verbindung zum Parent her:
	pNewNode->SetParent( this );
	// und haenge den SubTree hinten an
	m_aChilds.push_back(pNewNode);
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToStr(String& rString, 
									 const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData > & xMeta,
									 sal_Bool _bIntl, 
									 sal_Bool _bQuote) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);	
	static ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >  xFormatter;
	static ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xField;

	ParseNodeToStr(rString, xMeta, xFormatter, xField, getStaticEnglishInternational(), _bIntl, _bQuote, '.', sal_False);
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToStr(String& rString, 
									 const ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor > & xMeta,
									 sal_Bool _bIntl, 
									 sal_Bool _bQuote) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);	
	static ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >  xFormatter;
	static ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xField;

	ParseNodeToStr(rString, xMeta, xFormatter, xField, getStaticEnglishInternational(), _bIntl, _bQuote, '.', sal_False);
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToPredicateStr(String& rString, 
											  const ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor > & xMeta,
											  const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,
											  const International& rIntl,
											  const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _xField) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);
	if (xFormatter.is())
		ParseNodeToStr(rString, xMeta, xFormatter, _xField, rIntl, sal_True, sal_True, rIntl.GetNumDecimalSep(), sal_True);			
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToPredicateStr(String& rString, 
											  const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData > & xMeta,
											  const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,
											  const International& rIntl,
											  const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _xField) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);
	if (xFormatter.is())
		ParseNodeToStr(rString, xMeta, xFormatter, _xField, rIntl, sal_True, sal_True, rIntl.GetNumDecimalSep(), sal_True);			
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToStr(String& rString, 
					  const ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor > & xMeta,
					  const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,
					  const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _xField,					  
					  const International& rIntl,
					  sal_Bool _bIntl, 
					  sal_Bool _bQuote, 
					  char _cDecSep,				 					  					  
					  sal_Bool bPredicate) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);
	if (xMeta.is())
	{
		::com::sun::star::uno::Any aValue = xMeta->getInfo(::com::sun::star::data::DatabaseInfo::IDENTIFIER_QUOTE_CHAR);
		rtl::OUString aString;
		aValue >>= aString;		
		String aIdentifierQuote(aString);

		aValue = xMeta->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_SEPARATOR);
		aValue >>= aString;		
		String aCatalogSeparator(aString);

		SdbSqlParseNode::ParseNodeToStr(rString, 
			SQLParseNodeParameter(aIdentifierQuote, aCatalogSeparator, rIntl, _bIntl, _bQuote, _cDecSep, _xField, xFormatter, bPredicate));
	}
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToStr(String& rString, 
					  const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData > & xMeta,
					  const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,
					  const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _xField,					  
					  const International& rIntl,
					  sal_Bool _bIntl, 
					  sal_Bool _bQuote, 
					  char _cDecSep,				 					  					  
					  sal_Bool bPredicate) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);
	if (xMeta.is())
	{
		String aIdentifierQuote(xMeta->getIdentifierQuoteString());
		String aCatalogSeparator(xMeta->getCatalogSeparator());

		SdbSqlParseNode::ParseNodeToStr(rString, 
			SQLParseNodeParameter(aIdentifierQuote, aCatalogSeparator, rIntl, _bIntl, _bQuote, _cDecSep, _xField, xFormatter, bPredicate));
	}
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::ParseNodeToStr(String& rString, const SQLParseNodeParameter& rParam) const
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);

	if (!IsToken())
	{
		// einmal auswerten wieviel Subtrees dieser Knoten besitzt
		sal_uInt32 nCount = Count();

		// parameter erhalten sonderbehandlung
		if (SDB_ISRULE(this,parameter))
		{
			if(rString.Len())
				rString += ' ';
			if (nCount == 1)	// ?
			   m_aChilds[0]->ParseNodeToStr(rString, rParam);
			else if (nCount == 2)	// :Name
			{
			   m_aChilds[0]->ParseNodeToStr(rString, rParam);
			   rString += m_aChilds[1]->m_aNodeValue;
			}				    // [Name]
			else
			{
			   m_aChilds[0]->ParseNodeToStr(rString, rParam);
			   rString += m_aChilds[1]->m_aNodeValue;
			   rString += m_aChilds[2]->m_aNodeValue;
			}
		}

		else if(SDB_ISRULE(this,table_ref) &&
			((nCount == 4 && SDB_ISPUNCTUATION(m_aChilds[0],"("))|| (nCount == 6 && SDB_ISPUNCTUATION(m_aChilds[0],"("))))
			TableRangeNodeToStr(rString, rParam);
		// je nachdem ob international angegeben wird oder nicht wird like anders behandelt
		// interanational: *, ? sind Platzhalter
		// sonst SQL92 konform: %, _
		else if (SDB_ISRULE(this,like_predicate))			
			LikeNodeToStr(rString, rParam);

		else if (SDB_ISRULE(this,general_set_fct)	|| SDB_ISRULE(this,set_fct_spec)	||
				SDB_ISRULE(this,position_exp)		|| SDB_ISRULE(this,extract_exp)		||
				SDB_ISRULE(this,length_exp)			|| SDB_ISRULE(this,char_value_fct))
		{
			if (!AddDateValue(rString, rParam))
			{			
				// Funktionsname nicht quoten
				SQLParseNodeParameter aNewParam(rParam);
				aNewParam.bQuote = sal_False;

				m_aChilds[0]->ParseNodeToStr(rString, aNewParam);
				String aStringPara;
				for (sal_uInt32 i=1; i<nCount; i++)
				{
					const SdbSqlParseNode * pSubTree = m_aChilds[i];
					if (pSubTree)
					{
						pSubTree->ParseNodeToStr(aStringPara, rParam);
						
						// bei den CommaListen zwischen alle Subtrees Commas setzen
						if ((m_eNodeType == SDB_SQL_COMMALISTRULE) 	&& (i < (nCount - 1)))
							aStringPara += String(',');
					}
				}
				aStringPara.EraseTrailingChars(' ');
				rString += aStringPara;
			}
		}				
		else
		{
			for (::std::vector<SdbSqlParseNode*>::const_iterator i = m_aChilds.begin();
				i != m_aChilds.end();)				
			{
				const SdbSqlParseNode* pSubTree = *i;
				if (pSubTree)
				{
					SQLParseNodeParameter aNewParam(rParam);					

					// don't replace the field for subqueries
					if (rParam.xField.is() && SDB_ISRULE(pSubTree,subquery))	
						aNewParam.xField = NULL;											

					// if there is a field given we don't display the fieldname, if there are any
					if (rParam.xField.is() && SDB_ISRULE(pSubTree,column_ref))
					{
						sal_Bool bFilter = sal_False;						
						// retrieve the fields name
						String aFieldName;
						try
						{
							// retrieve the fields name														
							rtl::OUString aString;
							rParam.xField->getPropertyValue(String::CreateFromAscii("Name")) >>= aString;
							aFieldName = aString.getStr();
						}
						catch ( ... )
						{
						}						

						const SdbSqlParseNode* pCol = pSubTree->m_aChilds[pSubTree->Count()-1];
						if ((SDB_ISRULE(pCol,column_val) && pCol->GetChild(0)->TokenValue().EqualsIgnoreCaseAscii(aFieldName)) ||
							pCol->TokenValue().EqualsIgnoreCaseAscii(aFieldName))
							bFilter = sal_True;

						// ok we found the field, if the following node is the 
						// comparision operator '=' we filter it as well
						if (bFilter)
						{
							if (SDB_ISRULE(this, comparison_predicate))
							{
								++i;
								if(i != m_aChilds.end())
								{
									pSubTree = *i;
									if (pSubTree && pSubTree->GetNodeType() == SDB_SQL_EQUAL)
										i++;
								}
							}
							else
								i++;
						}
						else
						{
							pSubTree->ParseNodeToStr(rString, aNewParam);
							i++;

							// bei den CommaListen zwischen alle Subtrees Commas setzen
							if ((m_eNodeType == SDB_SQL_COMMALISTRULE) 	&& (i != m_aChilds.end()))
								rString += String(',');
						}
					}				
					else
					{
						pSubTree->ParseNodeToStr(rString, aNewParam);
						i++;
												
						// bei den CommaListen zwischen alle Subtrees Commas setzen
						if ((m_eNodeType == SDB_SQL_COMMALISTRULE) 	&& (i != m_aChilds.end()))
						{
							if (SDB_ISRULE(this,value_exp_commalist) && rParam.bPredicate)
								rString += String(';');
							else
								rString += String(',');
						}
					}
				}
			}
		}
	}
	else
	{
		// ein Blatt ist gefunden
		// Inhalt dem Ausgabestring anfuegen
		switch (m_eNodeType)
		{
			case SDB_SQL_KEYWORD:
			{
				if (rString.Len())
					rString += ' ';

				rString += SdbSqlParser::TokenIDToStr(m_nNodeID, rParam.bInternational);
			}	break;
			case SDB_SQL_STRING:
				if (rString.Len())
					rString += ' ';
				rString += SetQuotation(m_aNodeValue,String::CreateFromAscii("\'"),String::CreateFromAscii("\'\'"));
				break;
			case SDB_SQL_NAME:
				if (rString.Len())
				{
					switch(ByteString::ConvertFromUnicode(rString.GetChar((rString.Len()-1)),RTL_TEXTENCODING_ASCII_US) )
					{
						case ' ' :
						case '.' : break;
						default  :
							if (!rParam.aCatalogSeparator.Len() || rString.GetChar((sal_uInt32)(rString.Len()-1)) != rParam.aCatalogSeparator.GetChar(0))
								rString += ' '; break;
					}
				}
				if (rParam.bQuote)
				{
					if (rParam.bPredicate)
					{
						rString.AppendAscii("[");
						rString += m_aNodeValue;
						rString.AppendAscii("]");
					}
					else						
						rString += SetQuotation(m_aNodeValue, rParam.aIdentifierQuote.GetChar(0), rParam.aIdentifierQuote.GetChar(0));
				}
				else
					rString += m_aNodeValue;
				break;			
			case SDB_SQL_ACCESS_DATE:
				if (rString.Len())
					rString += ' ';
				rString += '#';
				rString += m_aNodeValue;
				rString += '#';
				break;			
			case SDB_SQL_INTNUM:
			case SDB_SQL_APPROXNUM:
				{						
					String aTmp = m_aNodeValue;
					if (rParam.bInternational && rParam.bPredicate && rParam.cDecSep != '.')
						aTmp.SearchAndReplaceAll('.', rParam.cDecSep);						

					if (rString.Len())
						rString += ' ';
					rString += aTmp;
					
				}	break;
				// fall through
			default:
				if (rString.Len() && m_aNodeValue.GetChar(0) != '.' && m_aNodeValue.GetChar(0) != ':' )
				{
					switch( ByteString::ConvertFromUnicode(rString.GetChar(rString.Len()-1),RTL_TEXTENCODING_ASCII_US) )
					{
						case ' ' :
						case '.' : break;
						default  :
							if (!rParam.aCatalogSeparator.Len() || rString.GetChar(rString.Len()-1) != rParam.aCatalogSeparator.GetChar(0))
								rString += ' '; break;
					}
				}
				rString += m_aNodeValue;
		}
	}
}

//-----------------------------------------------------------------------------
sal_Bool SdbSqlParseNode::AddDateValue(String& rString, const SQLParseNodeParameter& rParam) const
{
	// special display for date/time values
	if (rParam.bPredicate && SDB_ISRULE(this,set_fct_spec) && SDB_ISPUNCTUATION(m_aChilds[0],"{"))
	{
		const SdbSqlParseNode* pODBCNode = m_aChilds[1];
		const SdbSqlParseNode* pODBCNodeChild = pODBCNode->m_aChilds[0];

		if (pODBCNodeChild->GetNodeType() == SDB_SQL_KEYWORD && (
			SDB_ISTOKEN(pODBCNodeChild,"D") ||
			SDB_ISTOKEN(pODBCNodeChild,"T") ||
			SDB_ISTOKEN(pODBCNodeChild,"TS") ))
		{
			if (rString.Len())
				rString += ' ';
			rString += '#';
			if (SDB_ISTOKEN(pODBCNodeChild,"D"))
				rString += ConvertDateString(rParam, pODBCNode->m_aChilds[1]->TokenValue());
			else if (SDB_ISTOKEN(pODBCNodeChild,"T"))
				rString += ConvertTimeString(rParam, pODBCNode->m_aChilds[1]->TokenValue());
			else
				rString += ConvertDateTimeString(rParam, pODBCNode->m_aChilds[1]->TokenValue());
				
			rString += '#';
			return sal_True;
		}
	}
	return sal_False;
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::Replace(const String& rTableAlias,const String& rColumnName)
{
	for(sal_uInt32 i=0;i<Count();++i)
	{
		if(SDB_ISRULE(this,column_ref) && Count() == 1 && GetChild(0)->TokenValue() == rColumnName)
		{
			SdbSqlParseNode * pCol = Remove((sal_uInt32)0);
			Append(new SdbSqlParseNode(rTableAlias,SDB_SQL_NAME));
			Append(new SdbSqlParseNode(String::CreateFromAscii("."),SDB_SQL_PUNCTUATION));
			Append(pCol);
		}
		else
			GetChild(i)->Replace(rTableAlias,rColumnName);
	}
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::TableRangeNodeToStr(String& rString, const SQLParseNodeParameter& rParam) const
{
	sal_uInt32 nCount(Count());
	rString += ' ';
	
	SQLParseNodeParameter aNewParam(rParam);
	aNewParam.bQuote = sal_False;
	if (nCount == 4)
	{			
		m_aChilds[0]->ParseNodeToStr(rString, rParam);
		m_aChilds[1]->ParseNodeToStr(rString, rParam);
		m_aChilds[2]->ParseNodeToStr(rString, aNewParam);
		m_aChilds[3]->ParseNodeToStr(rString, rParam);
	}
	else if(nCount == 6 && SDB_ISPUNCTUATION(m_aChilds[0],"("))
	{
		m_aChilds[0]->ParseNodeToStr(rString, rParam);
		m_aChilds[1]->ParseNodeToStr(rString, rParam);
		m_aChilds[2]->ParseNodeToStr(rString, rParam);
		m_aChilds[3]->ParseNodeToStr(rString, rParam);
		m_aChilds[4]->ParseNodeToStr(rString, aNewParam);
		m_aChilds[5]->ParseNodeToStr(rString, rParam);
	}
}

//-----------------------------------------------------------------------------
void SdbSqlParseNode::LikeNodeToStr(String& rString, const SQLParseNodeParameter& rParam) const
{
	DBG_ASSERT(Count() == 5,"Count != 5: Prepare for GPF");

	const SdbSqlParseNode* pEscNode = NULL;	
	const SdbSqlParseNode* pParaNode = NULL;

	SQLParseNodeParameter aNewParam(rParam);
	aNewParam.bQuote = sal_True;

	// if there is a field given we don't display the fieldname, if there are any
	sal_Bool bAddName = sal_True;
	if (rParam.xField.is())
	{					 		
		// retrieve the fields name
		String aFieldName;
		try
		{
			// retrieve the fields name														
			rtl::OUString aString;
			rParam.xField->getPropertyValue(String::CreateFromAscii("Name")) >>= aString;
			aFieldName = aString.getStr();
		}
		catch ( ... )
		{
		}						

		const SdbSqlParseNode* pCol = m_aChilds[0]->GetChild(m_aChilds[0]->Count()-1);
		if ((SDB_ISRULE(pCol,column_val) && pCol->GetChild(0)->TokenValue().EqualsIgnoreCaseAscii(aFieldName)) ||
			pCol->TokenValue().EqualsIgnoreCaseAscii(aFieldName) )
			bAddName = sal_False;
	}
	
	if (bAddName)
		m_aChilds[0]->ParseNodeToStr(rString, aNewParam);	
		
	m_aChilds[1]->ParseNodeToStr(rString, aNewParam);
	m_aChilds[2]->ParseNodeToStr(rString, aNewParam);

	pParaNode = m_aChilds[3];
	pEscNode = m_aChilds[4];						  
	
	if (pParaNode->IsToken() && rParam.bInternational)
	{			
		String aStr = ConvertLikeToken(pParaNode, pEscNode, sal_True);
		rString += ' ';		
		rString += SetQuotation(aStr,String::CreateFromAscii("\'"),String::CreateFromAscii("\'\'"));
	}
	else
		pParaNode->ParseNodeToStr(rString, aNewParam);

	pEscNode->ParseNodeToStr(rString, aNewParam);
}

//-----------------------------------------------------------------------------
SdbSqlParseNode* SdbSqlParseNode::FindRule(SdbSqlParseNode::Rule eRule) const
{
	SdbSqlParseNode* pRetNode = 0;
	if (IsRule() && SdbSqlParser::RuleID(eRule) == GetRuleID())
		pRetNode = (SdbSqlParseNode*)this;
	else
	{
		for (::std::vector<SdbSqlParseNode*>::const_iterator i = m_aChilds.begin();
			!pRetNode && i != m_aChilds.end(); i++)				
			pRetNode = (*i)->FindRule(eRule);		
	}
	return pRetNode;
}
//-----------------------------------------------------------------------------
SdbSqlParseNode* MakeANDNode(SdbSqlParseNode *pLeftLeaf,SdbSqlParseNode *pRightLeaf)
{
	SdbSqlParseNode* pNewNode = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_term));
	pNewNode->Append(pLeftLeaf);
	pNewNode->Append(new SdbSqlParseNode(String::CreateFromAscii("AND"),SDB_SQL_KEYWORD,SDB_TOKEN_AND));
	pNewNode->Append(pRightLeaf);
	return pNewNode;
}
//-----------------------------------------------------------------------------
SdbSqlParseNode* MakeORNode(SdbSqlParseNode *pLeftLeaf,SdbSqlParseNode *pRightLeaf)
{
	SdbSqlParseNode* pNewNode = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::search_condition));
	pNewNode->Append(pLeftLeaf);
	pNewNode->Append(new SdbSqlParseNode(String::CreateFromAscii("OR"),SDB_SQL_KEYWORD,SDB_TOKEN_OR));
	pNewNode->Append(pRightLeaf);
	return pNewNode;
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::DisjunctiveNormalForm(SdbSqlParseNode*& pSearchCondition)
{
	if(!pSearchCondition) // no where condition at entry point
		return;

	SdbSqlParseNode::Absorptions(pSearchCondition);
	// '(' search_condition ')'
	if (SDB_ISRULE(pSearchCondition,boolean_primary))
	{
		SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(1);
		DisjunctiveNormalForm(pLeft);
	}
	// search_condition SDB_TOKEN_OR boolean_term
	else if (SDB_ISRULE(pSearchCondition,search_condition))
	{
		SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0);
		DisjunctiveNormalForm(pLeft);

		SdbSqlParseNode* pRight = pSearchCondition->GetChild(2);
		DisjunctiveNormalForm(pRight);
	}
	// boolean_term SDB_TOKEN_AND boolean_factor
	else if (SDB_ISRULE(pSearchCondition,boolean_term))
	{
		SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0);		
		DisjunctiveNormalForm(pLeft);

		SdbSqlParseNode* pRight = pSearchCondition->GetChild(2);
		DisjunctiveNormalForm(pRight);

		SdbSqlParseNode* pNewNode = NULL;
		// '(' search_condition ')'
		if(pLeft->Count() == 3 && SDB_ISRULE(pLeft,boolean_primary) && SDB_ISRULE(pLeft->GetChild(1),search_condition))
		{
			// and-or tree	on left side
			SdbSqlParseNode* pOr = pLeft->GetChild(1);
			SdbSqlParseNode* pNewLeft = NULL;
			SdbSqlParseNode* pNewRight = NULL;

			// cut right from parent
			pSearchCondition->Remove(2);

			pNewRight	= MakeANDNode(pOr->Remove(2)		,pRight);
			pNewLeft	= MakeANDNode(pOr->Remove((sal_uInt32)0)	,new SdbSqlParseNode(*pRight));
			pNewNode	= MakeORNode(pNewLeft,pNewRight);
			// and append new Node
			pSearchCondition->Parent()->Replace(pNewNode,pSearchCondition);
			delete pSearchCondition;

			DisjunctiveNormalForm(pNewNode);
		}
		else if(pRight->Count() == 3 && SDB_ISRULE(pRight,boolean_primary) && SDB_ISRULE(pRight->GetChild(1),search_condition))
		{
			// and-or tree	on right side
			SdbSqlParseNode* pOr = pRight->GetChild(1);
			SdbSqlParseNode* pNewLeft = NULL;
			SdbSqlParseNode* pNewRight = NULL;

			// cut left from parent
			pSearchCondition->Remove((sal_uInt32)0);

			pNewRight	= MakeANDNode(pLeft,pOr->Remove(2));
			pNewLeft	= MakeANDNode(new SdbSqlParseNode(*pLeft),pOr->Remove((sal_uInt32)0));
			pNewNode	= MakeORNode(pNewLeft,pNewRight);

			// and append new Node
			pSearchCondition->Parent()->Replace(pNewNode,pSearchCondition);
			delete pSearchCondition;
			DisjunctiveNormalForm(pNewNode);
		}
		else if(SDB_ISRULE(pLeft,boolean_primary) && (!SDB_ISRULE(pLeft->GetChild(1),search_condition) || !SDB_ISRULE(pLeft->GetChild(1),boolean_term)))
			pSearchCondition->Replace(pLeft->Remove(1),pLeft);
		else if(SDB_ISRULE(pRight,boolean_primary) && (!SDB_ISRULE(pRight->GetChild(1),search_condition) || !SDB_ISRULE(pRight->GetChild(1),boolean_term)))
			pSearchCondition->Replace(pRight->Remove(1),pRight);
	}
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::NegateSearchCondition(SdbSqlParseNode*& pSearchCondition,sal_Bool bNegate)
{
	if(!pSearchCondition) // no where condition at entry point
		return;
	SdbSqlParseNode* pNode = NULL;
	// '(' search_condition ')'
	if (pSearchCondition->Count() == 3 && SDB_ISRULE(pSearchCondition,boolean_primary))
	{
		SdbSqlParseNode* pRight = pSearchCondition->GetChild(1);
		NegateSearchCondition(pRight,bNegate);
	}
	// search_condition SDB_TOKEN_OR boolean_term
	else if (SDB_ISRULE(pSearchCondition,search_condition))
	{
		SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0);
		SdbSqlParseNode* pRight = pSearchCondition->GetChild(2);
		if(bNegate)
		{
			SdbSqlParseNode* pNewNode = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_term));
			pNewNode->Append(pSearchCondition->Remove((sal_uInt32)0));
			pNewNode->Append(new SdbSqlParseNode(String::CreateFromAscii("AND"),SDB_SQL_KEYWORD,SDB_TOKEN_AND));
			pNewNode->Append(pSearchCondition->Remove((sal_uInt32)1));
			pSearchCondition->Parent()->Replace(pNewNode,pSearchCondition);
			delete pSearchCondition;
			pLeft	= pNewNode->GetChild(0);
			pRight	= pNewNode->GetChild(2);
		}

		NegateSearchCondition(pLeft,bNegate);
		NegateSearchCondition(pRight,bNegate);
	}
	// boolean_term SDB_TOKEN_AND boolean_factor
	else if (SDB_ISRULE(pSearchCondition,boolean_term))
	{
		SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0);
		SdbSqlParseNode* pRight = pSearchCondition->GetChild(2);
		if(bNegate)
		{
			SdbSqlParseNode* pNewNode = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::search_condition));
			pNewNode->Append(pSearchCondition->Remove((sal_uInt32)0));
			pNewNode->Append(new SdbSqlParseNode(String::CreateFromAscii("OR"),SDB_SQL_KEYWORD,SDB_TOKEN_OR));
			pNewNode->Append(pSearchCondition->Remove((sal_uInt32)1));
			pSearchCondition->Parent()->Replace(pNewNode,pSearchCondition);
			delete pSearchCondition;
			pLeft	= pNewNode->GetChild(0);
			pRight	= pNewNode->GetChild(2);
		}

		NegateSearchCondition(pLeft,bNegate);
		NegateSearchCondition(pRight,bNegate);
	}
	// SDB_TOKEN_NOT boolean_test
	else if (SDB_ISRULE(pSearchCondition,boolean_factor))
	{
		SdbSqlParseNode *pNot = pSearchCondition->Remove((sal_uInt32)0);
		delete pNot;
		SdbSqlParseNode *pBooleanTest = pSearchCondition->Remove((sal_uInt32)0);
		pBooleanTest->SetParent(NULL);
		pSearchCondition->Parent()->Replace(pBooleanTest,pSearchCondition);
		delete pSearchCondition;
		if (!bNegate)
			NegateSearchCondition(pBooleanTest,sal_True);	//  negate all deeper values
	}
	// row_value_constructor comparison row_value_constructor
	// row_value_constructor comparison any_all_some subquery
	else if(bNegate  && SDB_ISRULE(pSearchCondition,comparison_predicate) || SDB_ISRULE(pSearchCondition,all_or_any_predicate))
	{
		SdbSqlParseNode* pComparison = pSearchCondition->GetChild(1);
		SdbSqlParseNode* pNewComparison = NULL;
		switch(pComparison->GetNodeType())
		{
			case SDB_SQL_EQUAL:
				pNewComparison = new SdbSqlParseNode(String::CreateFromAscii("<>"),SDB_SQL_NOTEQUAL,NOTEQUAL);
				break;
			case SDB_SQL_LESS:
				pNewComparison = new SdbSqlParseNode(String::CreateFromAscii(">="),SDB_SQL_GREATEQ,GREATEQ);
				break;
			case SDB_SQL_GREAT:
				pNewComparison = new SdbSqlParseNode(String::CreateFromAscii("<="),SDB_SQL_LESSEQ,LESSEQ);
				break;
			case SDB_SQL_LESSEQ:
				pNewComparison = new SdbSqlParseNode(String::CreateFromAscii(">"),SDB_SQL_GREAT,GREAT);
				break;
			case SDB_SQL_GREATEQ:
				pNewComparison = new SdbSqlParseNode(String::CreateFromAscii("<"),SDB_SQL_LESS,LESS);
				break;
			case SDB_SQL_NOTEQUAL:
				pNewComparison = new SdbSqlParseNode(String::CreateFromAscii("="),SDB_SQL_EQUAL,EQUAL);
				break;
		}
		pSearchCondition->Replace(pNewComparison,pComparison);
		delete pComparison;
	}

	else if(bNegate && (SDB_ISRULE(pSearchCondition,test_for_null) || SDB_ISRULE(pSearchCondition,in_predicate) ||
						SDB_ISRULE(pSearchCondition,like_predicate) || SDB_ISRULE(pSearchCondition,between_predicate) ||
						SDB_ISRULE(pSearchCondition,boolean_test) ))
	{
		sal_uInt32 nNotPos = 0;
		// row_value_constructor not SDB_TOKEN_IN in_predicate_value
		// row_value_constructor not SDB_TOKEN_LIKE num_value_exp opt_escape
		// row_value_constructor not SDB_TOKEN_BETWEEN row_value_constructor SDB_TOKEN_AND row_value_constructor
		if(SDB_ISRULE(pSearchCondition,in_predicate) || SDB_ISRULE(pSearchCondition,like_predicate) ||
		   SDB_ISRULE(pSearchCondition,between_predicate))
			nNotPos = 1;
		// row_value_constructor SDB_TOKEN_IS not SDB_TOKEN_NULL
		// boolean_primary SDB_TOKEN_IS not truth_value
		else if(SDB_ISRULE(pSearchCondition,test_for_null) || SDB_ISRULE(pSearchCondition,boolean_test))
			nNotPos = 2;

		SdbSqlParseNode* pNot = pSearchCondition->GetChild(nNotPos);
		SdbSqlParseNode* pNotNot = NULL;
		if(pNot->IsRule())
			pNotNot = new SdbSqlParseNode(String::CreateFromAscii("NOT"),SDB_SQL_KEYWORD,SDB_TOKEN_NOT);
		else
			pNotNot = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::not));
		pSearchCondition->Replace(pNotNot,pNot);
		delete pNot;
	}
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::EraseBraces(SdbSqlParseNode*& pSearchCondition)
{
	if (pSearchCondition && (SDB_ISRULE(pSearchCondition,boolean_primary) || (pSearchCondition->Count() == 3 && SDB_ISPUNCTUATION(pSearchCondition->GetChild(0),"(") &&
		 SDB_ISPUNCTUATION(pSearchCondition->GetChild(2),")"))))
	{
		SdbSqlParseNode* pRight = pSearchCondition->GetChild(1);
		Absorptions(pRight);
		// if child is not a or or and tree then delete () around child
		if(!(SDB_ISRULE(pSearchCondition->GetChild(1),boolean_term) || SDB_ISRULE(pSearchCondition->GetChild(1),search_condition)) ||
			SDB_ISRULE(pSearchCondition->GetChild(1),boolean_term) || // and can always stand without ()
			(SDB_ISRULE(pSearchCondition->GetChild(1),search_condition) && SDB_ISRULE(pSearchCondition->Parent(),search_condition)))
		{
			SdbSqlParseNode* pNode = pSearchCondition->Remove(1);
			pSearchCondition->Parent()->Replace(pNode,pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNode;
		}
	}
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::Absorptions(SdbSqlParseNode*& pSearchCondition)
{
	if(!pSearchCondition) // no where condition at entry point
		return;

	EraseBraces(pSearchCondition);

	if(SDB_ISRULE(pSearchCondition,boolean_term) || SDB_ISRULE(pSearchCondition,search_condition))
	{
		SdbSqlParseNode* pLeft = pSearchCondition->GetChild(0);
		Absorptions(pLeft);
		SdbSqlParseNode* pRight = pSearchCondition->GetChild(2);
		Absorptions(pRight);
	}											

	// a and a || a or a
	SdbSqlParseNode* pNewNode = NULL;
	if(( SDB_ISRULE(pSearchCondition,boolean_term) || SDB_ISRULE(pSearchCondition,search_condition))
		&& *pSearchCondition->GetChild(0) == *pSearchCondition->GetChild(2))
	{
		pNewNode = pSearchCondition->Remove((sal_uInt32)0);
		pSearchCondition->Parent()->Replace(pNewNode,pSearchCondition);
		delete pSearchCondition;
		pSearchCondition = pNewNode;
	}
	// (a or b) and a
	else if(SDB_ISRULE(pSearchCondition,boolean_term) && SDB_ISRULE(pSearchCondition->GetChild(0),boolean_primary) &&
			SDB_ISRULE(pSearchCondition->GetChild(0)->GetChild(1),search_condition) &&
			*pSearchCondition->GetChild(0)->GetChild(1)->GetChild(0) == *pSearchCondition->GetChild(2))
	{
		pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove(2),pSearchCondition);
		delete pSearchCondition;
		pSearchCondition = pNewNode;
	}
	// a and ( a or b)
	else if(SDB_ISRULE(pSearchCondition,boolean_term) && SDB_ISRULE(pSearchCondition->GetChild(2),boolean_primary) &&
			SDB_ISRULE(pSearchCondition->GetChild(2)->GetChild(1),search_condition))

	{
		if(*pSearchCondition->GetChild(2)->GetChild(1)->GetChild(0) == *pSearchCondition->GetChild(0))
		{
			pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove((sal_uInt32)0),pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNewNode;
		}
		else if(*pSearchCondition->GetChild(2)->GetChild(1)->GetChild(2) == *pSearchCondition->GetChild(0))
		{
			pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove((sal_uInt32)2),pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNewNode;
		}
	}
	// a or a and b || a or b and a
	else if(SDB_ISRULE(pSearchCondition,search_condition) && SDB_ISRULE(pSearchCondition->GetChild(2),boolean_term))
	{
		if(*pSearchCondition->GetChild(2)->GetChild(0) == *pSearchCondition->GetChild(0))
		{
			pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove((sal_uInt32)0),pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNewNode;
		}
		else if(*pSearchCondition->GetChild(2)->GetChild(2) == *pSearchCondition->GetChild(0))
		{
			pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove((sal_uInt32)0),pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNewNode;
		}
	}
	// a and b or a || b and a or a
	else if(SDB_ISRULE(pSearchCondition,search_condition) && SDB_ISRULE(pSearchCondition->GetChild(0),boolean_term))
	{
		if(*pSearchCondition->GetChild(0)->GetChild(0) == *pSearchCondition->GetChild(2))
		{
			pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove((sal_uInt32)2),pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNewNode;
		}
		else if(*pSearchCondition->GetChild(0)->GetChild(2) == *pSearchCondition->GetChild(2))
		{
			pSearchCondition->Parent()->Replace(pNewNode = pSearchCondition->Remove((sal_uInt32)2),pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNewNode;
		}
	}
	EraseBraces(pSearchCondition);
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::Compress(SdbSqlParseNode *&pSearchCondition)
{
	if(!pSearchCondition) // no where condition at entry point
		return;

	SdbSqlParseNode::EraseBraces(pSearchCondition);

	if(SDB_ISRULE(pSearchCondition,boolean_term) || SDB_ISRULE(pSearchCondition,search_condition))
	{
		SdbSqlParseNode* pLeft = pSearchCondition->GetChild(0);
		Compress(pLeft);

		SdbSqlParseNode* pRight = pSearchCondition->GetChild(2);
		Compress(pRight);
	}
	else if( SDB_ISRULE(pSearchCondition,boolean_primary) || (pSearchCondition->Count() == 3 && SDB_ISPUNCTUATION(pSearchCondition->GetChild(0),"(") &&
			 SDB_ISPUNCTUATION(pSearchCondition->GetChild(2),")")))
	{
		SdbSqlParseNode* pRight = pSearchCondition->GetChild(1);
		Compress(pRight);
		// if child is not a or or and tree then delete () around child
		if(!(SDB_ISRULE(pSearchCondition->GetChild(1),boolean_term) || SDB_ISRULE(pSearchCondition->GetChild(1),search_condition)) ||
			(SDB_ISRULE(pSearchCondition->GetChild(1),boolean_term) && SDB_ISRULE(pSearchCondition->Parent(),boolean_term)) ||
			(SDB_ISRULE(pSearchCondition->GetChild(1),search_condition) && SDB_ISRULE(pSearchCondition->Parent(),search_condition)))
		{
			SdbSqlParseNode* pNode = pSearchCondition->Remove(1);
			pSearchCondition->Parent()->Replace(pNode,pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNode;
		}										
	}

	SdbSqlParseNode* pNewNode = NULL;
	// or with two and trees where one element of the and trees are equal
	if(SDB_ISRULE(pSearchCondition,search_condition) && SDB_ISRULE(pSearchCondition->GetChild(0),boolean_term) && SDB_ISRULE(pSearchCondition->GetChild(2),boolean_term))
	{
		if(*pSearchCondition->GetChild(0)->GetChild(0) == *pSearchCondition->GetChild(2)->GetChild(0))
		{
			SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0)->Remove(2);
			SdbSqlParseNode* pRight = pSearchCondition->GetChild(2)->Remove(2);
			SdbSqlParseNode* pNode	= MakeORNode(pLeft,pRight);

			SdbSqlParseNode* pNewRule = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_primary));
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii("("),SDB_SQL_PUNCTUATION));
			pNewRule->Append(pNode);
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii(")"),SDB_SQL_PUNCTUATION));

			SdbSqlParseNode::EraseBraces(pLeft);
			SdbSqlParseNode::EraseBraces(pRight);

			pNode = MakeANDNode(pSearchCondition->GetChild(0)->Remove((sal_uInt32)0),pNewRule);
			pSearchCondition->Parent()->Replace(pNode,pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNode;
		}
		else if(*pSearchCondition->GetChild(0)->GetChild(2) == *pSearchCondition->GetChild(2)->GetChild(0))
		{
			SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0)->Remove((sal_uInt32)0);
			SdbSqlParseNode* pRight = pSearchCondition->GetChild(2)->Remove(2);
			SdbSqlParseNode* pNode	= MakeORNode(pLeft,pRight);

			SdbSqlParseNode* pNewRule = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_primary));
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii("("),SDB_SQL_PUNCTUATION));
			pNewRule->Append(pNode);
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii(")"),SDB_SQL_PUNCTUATION));

			SdbSqlParseNode::EraseBraces(pLeft);
			SdbSqlParseNode::EraseBraces(pRight);

			pNode = MakeANDNode(pSearchCondition->GetChild(0)->Remove(1),pNewRule);
			pSearchCondition->Parent()->Replace(pNode,pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNode;
		}
		else if(*pSearchCondition->GetChild(0)->GetChild(0) == *pSearchCondition->GetChild(2)->GetChild(2))
		{
			SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0)->Remove(2);
			SdbSqlParseNode* pRight = pSearchCondition->GetChild(2)->Remove((sal_uInt32)0);
			SdbSqlParseNode* pNode	= MakeORNode(pLeft,pRight);

			SdbSqlParseNode* pNewRule = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_primary));
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii("("),SDB_SQL_PUNCTUATION));
			pNewRule->Append(pNode);
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii(")"),SDB_SQL_PUNCTUATION));

			SdbSqlParseNode::EraseBraces(pLeft);
			SdbSqlParseNode::EraseBraces(pRight);

			pNode = MakeANDNode(pSearchCondition->GetChild(0)->Remove((sal_uInt32)0),pNewRule);
			pSearchCondition->Parent()->Replace(pNode,pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNode;
		}
		else if(*pSearchCondition->GetChild(0)->GetChild(2) == *pSearchCondition->GetChild(2)->GetChild(2))
		{
			SdbSqlParseNode* pLeft	= pSearchCondition->GetChild(0)->Remove((sal_uInt32)0);
			SdbSqlParseNode* pRight = pSearchCondition->GetChild(2)->Remove((sal_uInt32)0);
			SdbSqlParseNode* pNode	= MakeORNode(pLeft,pRight);

			SdbSqlParseNode* pNewRule = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_primary));
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii("("),SDB_SQL_PUNCTUATION));
			pNewRule->Append(pNode);
			pNewRule->Append(new SdbSqlParseNode(String::CreateFromAscii(")"),SDB_SQL_PUNCTUATION));

			SdbSqlParseNode::EraseBraces(pLeft);
			SdbSqlParseNode::EraseBraces(pRight);

			pNode = MakeANDNode(pSearchCondition->GetChild(0)->Remove(1),pNewRule);
			pSearchCondition->Parent()->Replace(pNode,pSearchCondition);
			delete pSearchCondition;
			pSearchCondition = pNode;
		}
	}
}
//-----------------------------------------------------------------------------
void SdbSqlParseNode::ShowParseTree(String& rString, sal_uInt32 nLevel)
{
	DBG_CHKTHIS(SdbSqlParseNode,NULL);

	if (!IsToken())
	{
		for (sal_uInt32 j=0; j<nLevel; j++) {rString.AppendAscii("\t");};
		// Regelnamen als rule: ...
		rString.AppendAscii("RULE_ID:\t ");
		rString += (String) GetRuleID();
		rString.AppendAscii("(");
		rString += SdbSqlParser::RuleIDToStr(GetRuleID());
		rString.AppendAscii(")");
		rString.AppendAscii("\n");
		
		// einmal auswerten wieviel Subtrees dieser Knoten besitzt
		sal_uInt32 nStop = Count();
		// hol dir den ersten Subtree
		for (::std::vector<SdbSqlParseNode*>::const_iterator i = m_aChilds.begin();
			i != m_aChilds.end(); i++)				
			(*i)->ShowParseTree(rString, nLevel+1);
	}
	else {
		// ein Token gefunden
		// tabs fuer das Einruecken entsprechend nLevel
		for (sal_uInt32 j=0; j<nLevel; j++) {rString.AppendAscii("\t");};

		switch (m_eNodeType) {

		case SDB_SQL_KEYWORD:
			{rString.AppendAscii("SQL_KEYWORD:\t");
			 rString += SdbSqlParser::TokenIDToStr(GetTokenID());
			 rString.AppendAscii("\n");
			 break;}

		case SDB_SQL_COMPARISON:
			{rString.AppendAscii("SQL_COMPARISON:\t");
			rString += m_aNodeValue;	// haenge Nodevalue an
			rString.AppendAscii("\n");		// und beginne neu Zeile
			break;}

		case SDB_SQL_NAME:
			{rString.AppendAscii("SQL_NAME:\t");
			 rString.AppendAscii("\"");
			 rString += m_aNodeValue;
			 rString.AppendAscii("\"");
			 rString.AppendAscii("\n");
			 break;}

		case SDB_SQL_STRING:
			{rString .AppendAscii("SQL_STRING:\t'");
			 rString += m_aNodeValue;
			 rString .AppendAscii("'\n");
			 break;}

		case SDB_SQL_INTNUM:
			{rString .AppendAscii("SQL_INTNUM:\t");
			 rString += m_aNodeValue;
			 rString .AppendAscii("\n");
			 break;}

		case SDB_SQL_APPROXNUM:
			{rString .AppendAscii("SQL_APPROXNUM:\t");
			 rString += m_aNodeValue;
			 rString .AppendAscii("\n");
			 break;}

		case SDB_SQL_PUNCTUATION:
			{rString .AppendAscii("SQL_PUNCTUATION:\t");
			rString += m_aNodeValue;	// haenge Nodevalue an
			rString .AppendAscii("\n");		// und beginne neu Zeile
			break;}

		case SDB_SQL_AMMSC:
			{rString .AppendAscii("SQL_AMMSC:\t");
			rString += m_aNodeValue;	// haenge Nodevalue an
			rString .AppendAscii("\n");		// und beginne neu Zeile
			break;}

		default:
			DBG_ERROR("SdbSqlParser::ShowParseTree: unzulaessiger NodeType");
		}
	};
}

// Insert-Methoden
//-----------------------------------------------------------------------------
void SdbSqlParseNode::Insert(SdbSqlParseNode* pNewSubTree, sal_uInt32 nPos)
{
	DBG_ASSERT(pNewSubTree != NULL, "SdbSqlParseNode: ungueltiger NewSubTree");
	DBG_ASSERT(pNewSubTree->Parent() == NULL, "SdbSqlParseNode: Knoten ist kein Waise");

	// stelle Verbindung zum Parent her:
	pNewSubTree->SetParent( this );
	m_aChilds.insert(m_aChilds.begin() + nPos);
}

// Remove-Methoden
//-----------------------------------------------------------------------------
SdbSqlParseNode* SdbSqlParseNode::Remove(sal_uInt32 nPos)
{		
	::std::vector<SdbSqlParseNode*>::iterator aPos(m_aChilds.begin() + nPos);
	SdbSqlParseNode* pNode = *aPos;
	
	// setze den Parent des removeten auf NULL
	pNode->SetParent( NULL );
	
	m_aChilds.erase(aPos);
	return pNode;
}
//-----------------------------------------------------------------------------
SdbSqlParseNode* SdbSqlParseNode::Remove(SdbSqlParseNode* pSubTree)
{
	DBG_ASSERT(pSubTree != NULL, "SdbSqlParseNode: ungueltiger SubTree");	
	::std::vector<SdbSqlParseNode*>::iterator aPos = ::std::find(m_aChilds.begin(), m_aChilds.end(), pSubTree);
	if (aPos != m_aChilds.end())
	{
		// setze den Parent des removeten auf NULL
		pSubTree->SetParent( NULL );
		m_aChilds.erase(aPos);
		return pSubTree;
	}
	else
		return NULL;
}

// Replace-Methoden
//-----------------------------------------------------------------------------
SdbSqlParseNode* SdbSqlParseNode::Replace(SdbSqlParseNode* pNewSubNode, sal_uInt32 nPos)
{
	DBG_ASSERT(pNewSubNode != NULL, "SdbSqlParseNode: invalid nodes");
	DBG_ASSERT(pNewSubNode->Parent() == NULL, "SdbSqlParseNode: node already has Parent");
	DBG_ASSERT(nPos < m_aChilds.size(), "SdbSqlParseNode: invalid position");
	DBG_ASSERT(::std::find(m_aChilds.begin(), m_aChilds.end(), pNewSubNode) == m_aChilds.end(), 
			"SdbSqlParseNode::Replace() Node already element of parent");
	
	SdbSqlParseNode* pOldSubNode = m_aChilds[nPos];

	// stelle Verbindung zum Parent her:
	pNewSubNode->SetParent( this );
	pOldSubNode->SetParent( NULL );

	m_aChilds[nPos] = pNewSubNode;
	return pOldSubNode;	
}

//-----------------------------------------------------------------------------
SdbSqlParseNode* SdbSqlParseNode::Replace(SdbSqlParseNode* pNewSubNode, SdbSqlParseNode* pOldSubNode )
{
	DBG_ASSERT(pOldSubNode != NULL && pNewSubNode != NULL, "SdbSqlParseNode: invalid nodes");
	DBG_ASSERT(pNewSubNode->Parent() == NULL, "SdbSqlParseNode: node already has Parent");
	DBG_ASSERT(::std::find(m_aChilds.begin(), m_aChilds.end(), pOldSubNode) != m_aChilds.end(), 
			"SdbSqlParseNode::Replace() Node not element of parent");
	DBG_ASSERT(::std::find(m_aChilds.begin(), m_aChilds.end(), pNewSubNode) == m_aChilds.end(), 
			"SdbSqlParseNode::Replace() Node already element of parent");

	pOldSubNode->SetParent( NULL );
	pNewSubNode->SetParent( this );
	::std::replace(m_aChilds.begin(), m_aChilds.end(), pOldSubNode, pNewSubNode);
	return pOldSubNode;
}								   

//=============================================================================

