%{

//--------------------------------------------------------------------------
//
// $Header: /cvs/Archiv/svtools/source/svsql/sdbyacc.y,v 1.18 2000/07/27 08:11:08 obo Exp $
//
// (c) Copyright 1994,1995 by Star Division GmbH, Hamburg.
//
// Ersterstellung:
//	GH
//
// Letzte Aenderung:
//	$Author: obo $ $Date: 2000/07/27 08:11:08 $ $Revision: 1.18 $
//
//
// Beschreibung:
//		SQL-Parser (dynamisches SQL)



#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _SVT_SDBNODE_HXX
#include "sdbnode.hxx"
#endif

#ifndef _SVT_SDBPARSE_HXX
#include "sdbparse.hxx"
#endif

#ifndef __SGI_STL_VECTOR
#include <stl/vector>
#endif

static String aEmptyString;


static SqlInternalNode* newNode(const char* pNewValue,
							    const SdbSqlNodeType eNodeType,
								const UINT16 nNodeID = 0)
{

	return new SqlInternalNode(String::CreateFromAscii(pNewValue), eNodeType, nNodeID);
}

static SqlInternalNode* newNode(const String& _NewValue,
							    const SdbSqlNodeType eNodeType,
								const UINT16 nNodeID = 0)
{

	return new SqlInternalNode(_NewValue, eNodeType, nNodeID);
}

// yyi ist die interne Nr. der Regel, die gerade reduziert wird.
// Ueber die Mapping-Tabelle yyrmap wird daraus eine externe Regel-Nr.
#define SQL_NEW_RULE 			newNode(aEmptyString, SDB_SQL_RULE, yyr1[yyn])
#define SQL_NEW_LISTRULE 		newNode(aEmptyString, SDB_SQL_LISTRULE, yyr1[yyn])
#define SQL_NEW_COMMALISTRULE   newNode(aEmptyString, SDB_SQL_COMMALISTRULE, yyr1[yyn])

SdbSqlParser* xxx_pGLOBAL_SQLPARSER;

#define YYERROR_VERBOSE

#define SQLyyerror(s)						\
{											\
	xxx_pGLOBAL_SQLPARSER->error(s);		\
}
#define SQLyylex xxx_pGLOBAL_SQLPARSER->SQLlex

%}
	/* symbolic tokens */

%union {
	SdbSqlParseNode * pParseNode;
}
/* types */
%type <pParseNode> '(' ')' ',' ':' ';' '?' '[' ']' '{' '}' '.'

%token <pParseNode> SDB_TOKEN_STRING SDB_TOKEN_ACCESS_DATE SDB_TOKEN_INT SDB_TOKEN_REAL_NUM
%token <pParseNode> SDB_TOKEN_INTNUM SDB_TOKEN_APPROXNUM SDB_TOKEN_NOT SDB_TOKEN_NAME

	/* operators */
%left <pParseNode> SDB_TOKEN_NAME
%left <pParseNode> SDB_TOKEN_OR
%left <pParseNode> SDB_TOKEN_AND

%left <pParseNode> LESSEQ GREATEQ NOTEQUAL LESS GREAT EQUAL /* '<' '>' = <> < > <= >= != */
%left <pParseNode> '+' '-'
%left <pParseNode> '*' '/'
%left <pParseNode> SDB_TOKEN_NATURAL SDB_TOKEN_CROSS SDB_TOKEN_FULL SDB_TOKEN_LEFT SDB_TOKEN_RIGHT
%left <pParseNode> ')'
%right <pParseNode> '='
%right <pParseNode> '.'
%right <pParseNode> '('


%nonassoc <pParseNode> SDB_TOKEN_UMINUS



	/* literal keyword tokens */

%token <pParseNode> SDB_TOKEN_ALL SDB_TOKEN_ALTER SDB_TOKEN_AMMSC SDB_TOKEN_ANY SDB_TOKEN_AS SDB_TOKEN_ASC SDB_TOKEN_AT SDB_TOKEN_AUTHORIZATION SDB_TOKEN_AVG

%token <pParseNode> SDB_TOKEN_BETWEEN SDB_TOKEN_BIT SDB_TOKEN_BIT_LENGTH SDB_TOKEN_BOTH SDB_TOKEN_BY

%token <pParseNode> SDB_TOKEN_CAST SDB_TOKEN_CHARACTER SDB_TOKEN_CHAR_LENGTH SDB_TOKEN_CHECK SDB_TOKEN_COLLATE SDB_TOKEN_COMMIT SDB_TOKEN_CONTINUE SDB_TOKEN_CONVERT SDB_TOKEN_COUNT SDB_TOKEN_CREATE SDB_TOKEN_CROSS
%token <pParseNode> SDB_TOKEN_CURRENT SDB_TOKEN_CURRENT_DATE SDB_TOKEN_CURRENT_TIME SDB_TOKEN_CURRENT_TIMESTAMP SDB_TOKEN_CURSOR

%token <pParseNode> SDB_TOKEN_DATE SDB_TOKEN_DAY SDB_TOKEN_DEC SDB_TOKEN_DECIMAL SDB_TOKEN_DECLARE SDB_TOKEN_DEFAULT SDB_TOKEN_DELETE SDB_TOKEN_DESC
%token <pParseNode> SDB_TOKEN_DISTINCT SDB_TOKEN_DOUBLE SDB_TOKEN_DROP

%token <pParseNode> SDB_TOKEN_ESCAPE SDB_TOKEN_EXCEPT SDB_TOKEN_EXISTS SDB_TOKEN_EXTRACT SDB_TOKEN_FALSE SDB_TOKEN_FETCH SDB_TOKEN_FLOAT SDB_TOKEN_FOR SDB_TOKEN_FOREIGN SDB_TOKEN_FOUND SDB_TOKEN_FROM SDB_TOKEN_FULL

%token <pParseNode> SDB_TOKEN_GRANT SDB_TOKEN_GROUP SDB_TOKEN_HAVING SDB_TOKEN_HOUR SDB_TOKEN_IN SDB_TOKEN_INDICATOR SDB_TOKEN_INNER SDB_TOKEN_INSERT SDB_TOKEN_INTEGER SDB_TOKEN_INTO SDB_TOKEN_IS SDB_TOKEN_INTERSECT

%token <pParseNode> SDB_TOKEN_JOIN SDB_TOKEN_KEY SDB_TOKEN_LEADING SDB_TOKEN_LEFT SDB_TOKEN_LIKE SDB_TOKEN_LOCAL SDB_TOKEN_LOWER SDB_TOKEN_MINUTE SDB_TOKEN_MONTH
%token <pParseNode> SDB_TOKEN_MAX SDB_TOKEN_MIN SDB_TOKEN_NATURAL SDB_TOKEN_NCHAR SDB_TOKEN_NULL SDB_TOKEN_NUMERIC

%token <pParseNode> SDB_TOKEN_OCTECT_LENGTH SDB_TOKEN_OF SDB_TOKEN_ON SDB_TOKEN_OPTION SDB_TOKEN_ORDER SDB_TOKEN_OUTER

%token <pParseNode> SDB_TOKEN_POSITION SDB_TOKEN_PRECISION SDB_TOKEN_PRIMARY SDB_TOKEN_PRIVILEGES SDB_TOKEN_PROCEDURE SDB_TOKEN_PUBLIC
%token <pParseNode> SDB_TOKEN_REAL SDB_TOKEN_REFERENCES SDB_TOKEN_ROLLBACK SDB_TOKEN_RIGHT

%token <pParseNode> SDB_TOKEN_SCHEMA SDB_TOKEN_SECOND SDB_TOKEN_SELECT SDB_TOKEN_SET SDB_TOKEN_SIZE SDB_TOKEN_SMALLINT SDB_TOKEN_SOME SDB_TOKEN_SQLCODE SDB_TOKEN_SQLERROR SDB_TOKEN_SUBSTRING SDB_TOKEN_SUM

%token <pParseNode> SDB_TOKEN_TABLE SDB_TOKEN_TIME SDB_TOKEN_TIMESTAMP SDB_TOKEN_TIMEZONE_HOUR SDB_TOKEN_TIMEZONE_MINUTE SDB_TOKEN_TO SDB_TOKEN_TRAILING SDB_TOKEN_TRANSLATE SDB_TOKEN_TRIM SDB_TOKEN_TRUE SDB_TOKEN_UNION
%token <pParseNode> SDB_TOKEN_UNIQUE SDB_TOKEN_UNKNOWN SDB_TOKEN_UPDATE SDB_TOKEN_UPPER SDB_TOKEN_USAGE SDB_TOKEN_USER SDB_TOKEN_USING SDB_TOKEN_VALUES SDB_TOKEN_VIEW
%token <pParseNode> SDB_TOKEN_WHERE SDB_TOKEN_WITH SDB_TOKEN_WORK SDB_TOKEN_YEAR SDB_TOKEN_ZONE

/* ODBC KEYWORDS */
%token <pParseNode> SDB_TOKEN_CALL SDB_TOKEN_D SDB_TOKEN_FN SDB_TOKEN_T SDB_TOKEN_TS SDB_TOKEN_OJ


%token <pParseNode> SDB_TOKEN_INVALIDSYMBOL

/*%type <pParseNode> sql_single_statement */

%type <pParseNode> sql /*schema */
%type <pParseNode> column_def_opt_list column_def_opt table_constraint_def column_commalist
%type <pParseNode> view_def opt_with_check_option opt_column_commalist privilege_def
%type <pParseNode> opt_with_grant_option privileges operation_commalist operation
%type <pParseNode> grantee_commalist grantee opt_order_by_clause ordering_spec_commalist
%type <pParseNode> ordering_spec opt_asc_desc manipulative_statement commit_statement
%type <pParseNode> /*delete_statement_positioned*/ delete_statement_searched fetch_statement
%type <pParseNode> insert_statement values_or_query_spec
%type <pParseNode> rollback_statement select_statement_into opt_all_distinct
%type <pParseNode> /*update_statement_positioned*/ assignment_commalist assignment
%type <pParseNode> update_statement_searched target_commalist target opt_where_clause
%type <pParseNode> select_statement selection table_exp from_clause table_ref_commalist table_ref
%type <pParseNode> where_clause opt_group_by_clause column_ref_commalist opt_having_clause
%type <pParseNode> search_condition predicate comparison_predicate between_predicate
%type <pParseNode> like_predicate opt_escape test_for_null in_predicate
%type <pParseNode> all_or_any_predicate any_all_some existence_test subquery
%type <pParseNode> scalar_exp_commalist parameter_ref literal
%type <pParseNode> column_ref data_type column cursor parameter range_variable user /*like_check*/
/* neue Regeln bei OJ */
%type <pParseNode> derived_column as_clause table_name num_primary term num_value_exp
%type <pParseNode> value_exp_primary num_value_fct unsigned_value_spec cast_spec set_fct_spec  scalar_subquery
%type <pParseNode> position_exp extract_exp length_exp general_value_spec
%type <pParseNode> general_set_fct set_fct_type query_exp non_join_query_exp joined_table
%type <pParseNode> non_join_query_term non_join_query_primary simple_table
%type <pParseNode> table_value_const_list row_value_constructor row_value_const_list row_value_constructor_elem
%type <pParseNode> qualified_join value_exp query_term join_type outer_join_type join_condition boolean_term
%type <pParseNode> boolean_factor truth_value boolean_test boolean_primary named_columns_join join_spec
%type <pParseNode> cast_operand cast_target factor datetime_value_exp /*interval_value_exp*/ datetime_term datetime_factor
%type <pParseNode> datetime_primary datetime_value_fct time_zone time_zone_specifier /*interval_term*/ /*interval_qualifier*/
%type <pParseNode> /*start_field*/ non_second_datetime_field /*end_field*/ /*single_datetime_field*/ extract_field datetime_field time_zone_field
%type <pParseNode> extract_source char_length_exp octet_length_exp bit_length_exp select_sublist string_value_exp
%type <pParseNode> char_value_exp concatenation char_factor char_primary string_value_fct char_substring_fct fold
%type <pParseNode> form_conversion char_translation trim_fct trim_operands trim_spec bit_value_fct bit_substring_fct op_column_commalist
%type <pParseNode> /*bit_concatenation*/ bit_value_exp bit_factor bit_primary collate_clause char_value_fct unique_spec value_exp_commalist in_predicate_value unique_test update_source
%type <pParseNode> all query_primary as not for_length upper_lower comparison column_val  cross_union /*opt_schema_element_list*/
%type <pParseNode> /*op_authorization op_schema*/ nil_fkt schema_element base_table_def base_table_element base_table_element_commalist
%type <pParseNode> column_def odbc_fct_spec	odbc_call_spec odbc_fct_type op_parameter union_statement
%type <pParseNode> op_odbc_call_parameter odbc_parameter_commalist odbc_parameter
%%

/* Parse Tree an SdbSqlParser zurueckliefern
 * (der Zugriff ueber yyval nach Aufruf des Parsers scheitert,
 * da die Default-Regel $$=$1 im letzten Reduce-Schritt fehlerhaft
 * angewendet wird [vermutlich ein Bug in der von MKS Yacc erzeugten
 * "yyrlen"-Tabelle, denn dort ist fuer den letzten Reduce-Schritt
 * ein Pop von 0 Elementen vorgesehen, aber es wird trotzdem die
 * Default-Regel $$=$1 angewendet und damit ein falscher yyval
 * erzeugt :-(]).
 *
 */
sql_single_statement:
		sql
		{ xxx_pGLOBAL_SQLPARSER->SetParseTree( $1 ); }
	|	sql ';'
		{ xxx_pGLOBAL_SQLPARSER->SetParseTree( $1 ); }
	;
/*
sql_list:
		sql_ ';'
			{$$ = SQL_NEW_LISTRULE;
			$$->Append($1);
			pSqlParseTreeRoot = $1; -- obsolete - Ergebnis in yyval! rdm }
	|	sql_list sql ';'
			{$1->Append($2);
			$$ = $1;}
	;
*/


	/* schema definition language */
	/* Note: other ``sql:'' rules appear later in the grammar */
/***
sql:
	schema
	;

op_authorization:
		{$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_AUTHORIZATION user
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
op_schema:
		{$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_NAME
	|	SDB_TOKEN_NAME '.' SDB_TOKEN_NAME
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	;

schema:
		SDB_TOKEN_CREATE SDB_TOKEN_SCHEMA op_schema op_authorization opt_schema_element_list
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
		}
	;

opt_schema_element_list:
		/* empty * /     {$$ = SQL_NEW_RULE;}
	|       schema_glement_list
	;

schema_element_list:
		schema_element
			{$$ = SQL_NEW_LISTRULE;
			$$->Append($1);}
	|       schema_element_list schema_element
			{$1->Append($2);
			$$ = $1;}
	;
*/
sql:
		schema_element
		{$$ = SQL_NEW_RULE;
			$$->Append($1);
			}
	;

schema_element:
			base_table_def
	|       view_def
	|       privilege_def
	;

base_table_def:
		SDB_TOKEN_CREATE SDB_TOKEN_TABLE table_name '(' base_table_element_commalist ')'
		{$$ = SQL_NEW_RULE;
		$$->Append($1);
		$$->Append($2);
		$$->Append($3);
		$$->Append($4 = newNode("(", SDB_SQL_PUNCTUATION));
		$$->Append($5);
		$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));}
	;

base_table_element_commalist:
		base_table_element
		{$$ = SQL_NEW_COMMALISTRULE;
		$$->Append($1);}
	|   base_table_element_commalist ',' base_table_element
		{$1->Append($3);
		$$ = $1;}
	;

base_table_element:
		column_def
	|	table_constraint_def
	;

column_def:
		column data_type column_def_opt_list
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			}
	;

column_def_opt_list:
		/* empty */                 {$$ = SQL_NEW_LISTRULE;}
	|       column_def_opt_list column_def_opt
			{$1->Append($2);
			$$ = $1;}
	;

nil_fkt:
	datetime_value_fct
	;
unique_spec:
		SDB_TOKEN_UNIQUE
	|	SDB_TOKEN_PRIMARY SDB_TOKEN_KEY
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
column_def_opt:
		SDB_TOKEN_NOT SDB_TOKEN_NULL
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       unique_spec
	|       SDB_TOKEN_DEFAULT literal
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       SDB_TOKEN_DEFAULT SDB_TOKEN_NULL
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       SDB_TOKEN_DEFAULT SDB_TOKEN_USER
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|		SDB_TOKEN_DEFAULT nil_fkt
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
				$$->Append($2);
			}
	|       SDB_TOKEN_CHECK
	|       SDB_TOKEN_CHECK '(' search_condition ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_REFERENCES table_name
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       SDB_TOKEN_REFERENCES table_name '(' column_commalist ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($4);
			$$->Append($5 = newNode(")", SDB_SQL_PUNCTUATION));}
	;

table_constraint_def:
		unique_spec '(' column_commalist ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_FOREIGN SDB_TOKEN_KEY '(' column_commalist ')' SDB_TOKEN_REFERENCES table_name
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($4);
			$$->Append($5 = newNode(")", SDB_SQL_PUNCTUATION));
			$$->Append($6);
			$$->Append($7);}
	|       SDB_TOKEN_FOREIGN SDB_TOKEN_KEY '(' column_commalist ')' SDB_TOKEN_REFERENCES table_name '(' column_commalist ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($4);
			$$->Append($5 = newNode(")", SDB_SQL_PUNCTUATION));
			$$->Append($6);
			$$->Append($7);
			$$->Append($8 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($9);
			$$->Append($10 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_CHECK '(' search_condition ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	;
op_column_commalist:
	/* empty */ {$$ = SQL_NEW_RULE;}
	| '(' column_commalist ')'
		{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
column_commalist:
		column_commalist ',' column
			{$1->Append($3);
			$$ = $1;}
	|	column
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	;

view_def:
		SDB_TOKEN_CREATE SDB_TOKEN_VIEW table_name opt_column_commalist SDB_TOKEN_AS select_statement opt_with_check_option
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
			$$->Append($7);}
	;

opt_with_check_option:
		/* empty */         {$$ = SQL_NEW_RULE;}
	|       SDB_TOKEN_WITH SDB_TOKEN_CHECK SDB_TOKEN_OPTION
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);}
	;

opt_column_commalist:
		/* empty */         {$$ = SQL_NEW_RULE;}
	|       '(' column_commalist ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));}
	;

privilege_def:
		SDB_TOKEN_GRANT privileges SDB_TOKEN_ON table_name SDB_TOKEN_TO grantee_commalist
		opt_with_grant_option
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
			$$->Append($7);}
	;

opt_with_grant_option:
		/* empty */         {$$ = SQL_NEW_RULE;}
	|       SDB_TOKEN_WITH SDB_TOKEN_GRANT SDB_TOKEN_OPTION
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);}
	;

privileges:
		SDB_TOKEN_ALL SDB_TOKEN_PRIVILEGES
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       operation_commalist
	;

operation_commalist:
		operation
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       operation_commalist ',' operation
			{$1->Append($3);
			$$ = $1;}
	;

operation:
			SDB_TOKEN_SELECT
	|       SDB_TOKEN_INSERT opt_column_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       SDB_TOKEN_DELETE
	|       SDB_TOKEN_UPDATE opt_column_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|       SDB_TOKEN_REFERENCES opt_column_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|		SDB_TOKEN_USAGE
	;


grantee_commalist:
		grantee
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       grantee_commalist ',' grantee
			{$1->Append($3);
			$$ = $1;}
	;

grantee:
			SDB_TOKEN_PUBLIC
	|       user
	;

	/* module language */

opt_order_by_clause:
		/* empty */         {$$ = SQL_NEW_RULE;}
	|       SDB_TOKEN_ORDER SDB_TOKEN_BY ordering_spec_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);}
	;

ordering_spec_commalist:
		ordering_spec
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       ordering_spec_commalist ',' ordering_spec
			{$1->Append($3);
			$$ = $1;}
	;

ordering_spec:
/*		SDB_TOKEN_INTNUM opt_asc_desc
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
*/
		predicate opt_asc_desc
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}

	|	row_value_constructor_elem opt_asc_desc
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;

opt_asc_desc:
		{$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_ASC
	|	SDB_TOKEN_DESC
	;


/***
manipulative_statement_list:
		manipulative_statement
			{$$ = SQL_NEW_LISTRULE;
			$$->Append($1);}
	|       manipulative_statement_list manipulative_statement
			{$1->Append($2);
			$$ = $1;}
	;
***/

sql:
		{$$ = SQL_NEW_LISTRULE;}
	;
not:
	{$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_NOT
	;
	/* manipulative statements */

sql:    manipulative_statement
	;

manipulative_statement:
			commit_statement
/*	|       delete_statement_positioned*/
	|       delete_statement_searched
	|       fetch_statement
	|       insert_statement
	|       rollback_statement
	|       select_statement_into
/*	|       update_statement_positioned*/
	|       update_statement_searched
	|		union_statement
	|		'{' odbc_call_spec '}'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("{", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode("}", SDB_SQL_PUNCTUATION));
		}
	;

union_statement:
			select_statement
	|		union_statement SDB_TOKEN_UNION all select_statement
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	;
commit_statement:
		SDB_TOKEN_COMMIT SDB_TOKEN_WORK
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;
/*
delete_statement_positioned:
		SDB_TOKEN_DELETE SDB_TOKEN_FROM table_name SDB_TOKEN_WHERE SDB_TOKEN_CURRENT SDB_TOKEN_OF cursor
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
			$$->Append($7);}
	;
*/
delete_statement_searched:
		SDB_TOKEN_DELETE SDB_TOKEN_FROM table_name opt_where_clause
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);}
	;

fetch_statement:
		SDB_TOKEN_FETCH cursor SDB_TOKEN_INTO target_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);}
	;

insert_statement:
		SDB_TOKEN_INSERT SDB_TOKEN_INTO table_name opt_column_commalist values_or_query_spec
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);}
	;
values_or_query_spec:
		SDB_TOKEN_VALUES table_value_const_list
		{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;

table_value_const_list:
			row_value_constructor
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       table_value_const_list ',' row_value_constructor
			{$1->Append($3);
			$$ = $1;}
	;
row_value_const_list:
			row_value_constructor_elem
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       row_value_const_list ',' row_value_constructor_elem
			{$1->Append($3);
			$$ = $1;}
	;
row_value_constructor:
			row_value_constructor_elem
	  |		'(' row_value_const_list ')'
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
				$$->Append($2);
				$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
			}
/*      |		subquery
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
			}*/
	;
row_value_constructor_elem:
			value_exp /*[^')']*/
	|       SDB_TOKEN_NULL
	|		SDB_TOKEN_DEFAULT
	;


rollback_statement:
		SDB_TOKEN_ROLLBACK SDB_TOKEN_WORK
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;


		/* INTO target_commalist herausgenommen */
select_statement_into:
		SDB_TOKEN_SELECT opt_all_distinct selection SDB_TOKEN_INTO target_commalist table_exp
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6); }
	;

opt_all_distinct:
			{$$ = SQL_NEW_RULE;}
		|	SDB_TOKEN_ALL
		|	SDB_TOKEN_DISTINCT

	;
/*
update_statement_positioned:
		SDB_TOKEN_UPDATE table_name SDB_TOKEN_SET assignment_commalist
		SDB_TOKEN_WHERE SDB_TOKEN_CURRENT SDB_TOKEN_OF cursor
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
			$$->Append($7);
			$$->Append($8);}
	;
*/
assignment_commalist:
			assignment
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       assignment_commalist ',' assignment
			{$1->Append($3);
			$$ = $1;}
	;

assignment:
		column EQUAL update_source
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);}
	;
update_source:
		value_exp
	  | SDB_TOKEN_NULL
	  | SDB_TOKEN_DEFAULT
	;
update_statement_searched:
		SDB_TOKEN_UPDATE table_name SDB_TOKEN_SET assignment_commalist opt_where_clause
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);}
	;

target_commalist:
		target
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       target_commalist ',' target
			{$1->Append($3);
			$$ = $1;}
	;

target:
		parameter_ref
	;

opt_where_clause:
		/* empty */             {$$ = SQL_NEW_RULE;}
	|       where_clause
	;

	/* query expressions */

query_term:
		non_join_query_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
/*      | joined_table
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
*/	;
/* SELECT STATEMENT */
select_statement:
		SDB_TOKEN_SELECT opt_all_distinct selection table_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	;

selection:
		'*'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("*", SDB_SQL_PUNCTUATION));
		}
	|	scalar_exp_commalist
	;

table_exp:
		from_clause
		opt_where_clause
		opt_group_by_clause
		opt_having_clause
		opt_order_by_clause
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);}
	;

from_clause:
		SDB_TOKEN_FROM table_ref_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;

table_ref_commalist:
		table_ref
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       table_ref_commalist ',' table_ref /*[^SDB_TOKEN_CROSS SDB_TOKEN_FULL SDB_TOKEN_UNION SDB_TOKEN_LEFT SDB_TOKEN_RIGHT SDB_TOKEN_INNER SDB_TOKEN_NATURAL]*/
			{$1->Append($3);
			$$ = $1;}
	;
as:
		{$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_AS
		{
			$$ = SQL_NEW_RULE;
		}
	;
table_ref:
		table_name
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	table_name as range_variable op_column_commalist
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	|	'(' joined_table ')' as range_variable op_column_commalist
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
		}
	|	joined_table
	|	'{' SDB_TOKEN_OJ joined_table '}'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("{", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3);
			$$->Append($4 = newNode("}", SDB_SQL_PUNCTUATION));
		}
	;
where_clause:
		SDB_TOKEN_WHERE search_condition
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;

opt_group_by_clause:
		/* empty */      {$$ = SQL_NEW_RULE;}
	|       SDB_TOKEN_GROUP SDB_TOKEN_BY column_ref_commalist
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);}
	;

column_ref_commalist:
		column_ref
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       column_ref_commalist ',' column_ref
			{$1->Append($3);
			$$ = $1;}
	;

opt_having_clause:
		/* empty */                 {$$ = SQL_NEW_RULE;}
	|       SDB_TOKEN_HAVING search_condition
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;

	/* search conditions */
truth_value:
		SDB_TOKEN_TRUE
	  | SDB_TOKEN_FALSE
	  | SDB_TOKEN_UNKNOWN
	  ;
boolean_primary:
		predicate
	  | '(' search_condition ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
subroutine:
	{
			if(!xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
				YYERROR;
		}
	;
boolean_test:
		boolean_primary
	|	boolean_primary SDB_TOKEN_IS truth_value
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}
	|	boolean_primary SDB_TOKEN_IS SDB_TOKEN_NOT truth_value %prec SDB_TOKEN_IS
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	|	subroutine SDB_TOKEN_NOT SDB_TOKEN_LIKE string_value_exp opt_escape
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($2);
				$$->Append($3);
				if (xxx_pGLOBAL_SQLPARSER->BuildLikeRule($$,$4,$5))
					$$->Append($5);
				else
				{
					delete $$;
					YYABORT;
				}
			}
			else
				YYERROR;
		}
	;
boolean_factor:
		boolean_test
	|	SDB_TOKEN_NOT  boolean_test
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
boolean_term:
		boolean_factor
	|	boolean_term SDB_TOKEN_AND boolean_factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}
	|	row_value_constructor_elem '\n' /*[^')' ',']*/
		{
			$$ = SQL_NEW_RULE;
			INT16 nErg = xxx_pGLOBAL_SQLPARSER->BuildComparsionRule($$,$1);
			if(nErg == 1)
			{
				SdbSqlParseNode* pTemp = $$;
				$$ = pTemp->Remove((ULONG)0);
				delete pTemp;
			}
			else
			{
				delete $$;
				if(nErg)
					YYERROR;
				else
					YYABORT;
			}
		}
	|	boolean_term SDB_TOKEN_AND literal
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			INT16 nErg = xxx_pGLOBAL_SQLPARSER->BuildComparsionRule($$,$3);
			if(nErg < 1)
			{
				delete $$;
				if(nErg)
					YYERROR;
				else
					YYABORT;
			}

		}
	|	boolean_term SDB_TOKEN_AND SDB_TOKEN_STRING
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			INT16 nErg = xxx_pGLOBAL_SQLPARSER->BuildComparsionRule($$,$3);
			if(nErg < 1)
			{
				delete $$;
				if(nErg)
					YYERROR;
				else
					YYABORT;
			}

		}
	;
search_condition:
		boolean_term
	|	search_condition SDB_TOKEN_OR boolean_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}
	;
predicate:
		comparison_predicate
	|       between_predicate
	|       all_or_any_predicate
	|       existence_test
	|		unique_test
	|		test_for_null
	|       in_predicate
	|       like_predicate
	;

comparison_predicate:
		row_value_constructor comparison row_value_constructor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}
	|	comparison row_value_constructor
		{
			$$ = SQL_NEW_RULE;
			INT16 nErg = xxx_pGLOBAL_SQLPARSER->BuildComparsionRule($$,$2,$1);
			if(nErg == 1)
			{
				SdbSqlParseNode* pTemp = $$;
				$$ = pTemp->Remove((ULONG)0);
				delete pTemp;
			}
			else
			{
				delete $$;
				YYABORT;
			}
		}
	;
comparison:
		LESS
	  | NOTEQUAL
	  | EQUAL
	  | GREAT
	  | LESSEQ
	  | GREATEQ
	;
between_predicate:
		row_value_constructor SDB_TOKEN_BETWEEN row_value_constructor SDB_TOKEN_AND row_value_constructor
		{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
		}
	|	row_value_constructor SDB_TOKEN_NOT SDB_TOKEN_BETWEEN row_value_constructor SDB_TOKEN_AND row_value_constructor
		{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
		}
	|	subroutine SDB_TOKEN_NOT SDB_TOKEN_BETWEEN row_value_constructor SDB_TOKEN_AND row_value_constructor
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($2);
				$$->Append($3);
				$$->Append($4);
				$$->Append($5);
				$$->Append($6);
			}
			else
				YYERROR;
		}
	|	subroutine SDB_TOKEN_BETWEEN row_value_constructor SDB_TOKEN_AND row_value_constructor
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($2);
				$$->Append($3);
				$$->Append($4);
				$$->Append($5);
			}
			else
				YYERROR;
		}
	;

like_predicate:
		row_value_constructor SDB_TOKEN_NOT SDB_TOKEN_LIKE string_value_exp opt_escape
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
		}
	|	row_value_constructor SDB_TOKEN_LIKE string_value_exp opt_escape
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	|	row_value_constructor SDB_TOKEN_NOT SDB_TOKEN_LIKE value_exp_primary opt_escape
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
		}
	|	row_value_constructor SDB_TOKEN_LIKE value_exp_primary opt_escape
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	/*|	SDB_TOKEN_NOT
		{
			if(!xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
				YYERROR;
		} SDB_TOKEN_LIKE string_value_exp opt_escape
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($1);
				$$->Append($3);
				if (xxx_pGLOBAL_SQLPARSER->BuildLikeRule($$,$4,$5))
					$$->Append($5);
				else
				{
					delete $$;
					YYABORT;
				}
			}
			else
				YYERROR;
		}
	*/|	SDB_TOKEN_LIKE string_value_exp opt_escape
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($1);
				if (xxx_pGLOBAL_SQLPARSER->BuildLikeRule($$,$2,$3))
					$$->Append($3);
				else
				{
					delete $$;
					YYABORT;
				}
			}
			else
				YYERROR;
		}
	|	SDB_TOKEN_LIKE value_exp_primary opt_escape
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($1);
				if (xxx_pGLOBAL_SQLPARSER->BuildLikeRule($$,$2,$3))
					$$->Append($3);
				else
				{
					delete $$;
					YYABORT;
				}
			}
			else
				YYERROR;
		}
	|	subroutine SDB_TOKEN_NOT SDB_TOKEN_LIKE value_exp_primary opt_escape
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($2);
				$$->Append($3);
				if (xxx_pGLOBAL_SQLPARSER->BuildLikeRule($$,$4,$5))
					$$->Append($5);
				else
				{
					delete $$;
					YYABORT;
				}
			}
			else
				YYERROR;
		}
	;

opt_escape:
		/* empty */                 {$$ = SQL_NEW_RULE;}
	|   SDB_TOKEN_ESCAPE string_value_exp
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	|	'{' SDB_TOKEN_ESCAPE SDB_TOKEN_STRING '}'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("{", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3);
			$$->Append($4 = newNode("}", SDB_SQL_PUNCTUATION));
		}
	;

test_for_null:
		row_value_constructor SDB_TOKEN_IS not SDB_TOKEN_NULL
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	|	SDB_TOKEN_IS not SDB_TOKEN_NULL
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($1);
				$$->Append($2);
				$$->Append($3);
			}
			else
				YYERROR;
		}
	;
in_predicate_value:
		subquery
		{$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | '(' value_exp_commalist ')'
		{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
in_predicate:
		row_value_constructor not SDB_TOKEN_IN in_predicate_value
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
		|	subroutine  SDB_TOKEN_IN in_predicate_value
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($2);
				$$->Append($3);
				/*$$->Append($3);*/
			}
			else
				YYERROR;
		}
	;
all_or_any_predicate:
		row_value_constructor comparison any_all_some subquery
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	|	comparison any_all_some subquery
		{
			if(xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				SdbSqlParseNode* pColumnRef = newNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
				pColumnRef->Append(newNode(xxx_pGLOBAL_SQLPARSER->GetFieldName(),SDB_SQL_NAME));

				$$ = SQL_NEW_RULE;
				$$->Append(pColumnRef);
				$$->Append($1);
				$$->Append($2);
				$$->Append($3);
			}
			else
				YYERROR;
		}
	;

any_all_some:
			SDB_TOKEN_ANY
	|       SDB_TOKEN_ALL
	|       SDB_TOKEN_SOME
	;

existence_test:
		SDB_TOKEN_EXISTS subquery
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;
unique_test:
		SDB_TOKEN_UNIQUE subquery
		{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;
subquery:
		'(' query_exp ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));}
	;

	/* scalar expressions */
scalar_exp_commalist:
		select_sublist
		{
			$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);
		}
	|   scalar_exp_commalist ',' select_sublist
		{
			$1->Append($3);
			$$ = $1;
		}
	;
select_sublist:
		table_name '.' '*'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3 = newNode("*", SDB_SQL_PUNCTUATION));
		}
	|	derived_column

	;

parameter_ref:
		parameter
	;

/*
op_like:
		'*'
		{
			$$ = newNode("*", SDB_SQL_PUNCTUATION);
		}
	|	'?'
		{
			$$ = newNode("?", SDB_SQL_PUNCTUATION);
		}
	|   op_like	'*'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("*", SDB_SQL_PUNCTUATION));
			xxx_pGLOBAL_SQLPARSER->ReduceLiteral($$, FALSE);
		}
	|	op_like '?'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("?", SDB_SQL_PUNCTUATION));
			xxx_pGLOBAL_SQLPARSER->ReduceLiteral($$, FALSE);
		}
	;
*/

literal:
/*		SDB_TOKEN_STRING
	|   */SDB_TOKEN_INT
	|   SDB_TOKEN_REAL_NUM
	|   SDB_TOKEN_INTNUM
	|   SDB_TOKEN_APPROXNUM
	|	SDB_TOKEN_ACCESS_DATE
/*	rules for predicate check */
	|	literal SDB_TOKEN_STRING
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
				$$->Append($2);
				xxx_pGLOBAL_SQLPARSER->ReduceLiteral($$, TRUE);
			}
			else
				YYERROR;
		}
	|	literal SDB_TOKEN_INT
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
				$$->Append($2);
				xxx_pGLOBAL_SQLPARSER->ReduceLiteral($$, TRUE);
			}
			else
				YYERROR;
		}
	|	literal SDB_TOKEN_REAL_NUM
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
				$$->Append($2);
				xxx_pGLOBAL_SQLPARSER->ReduceLiteral($$, TRUE);
			}
			else
				YYERROR;
		}
	|	literal SDB_TOKEN_APPROXNUM
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
				$$->Append($2);
				xxx_pGLOBAL_SQLPARSER->ReduceLiteral($$, TRUE);
			}
			else
				YYERROR;
		}
	;

	/* miscellaneous */
as_clause:
		/* empty */ {$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_AS column
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	|	column
	;
position_exp:
		SDB_TOKEN_POSITION '(' string_value_exp SDB_TOKEN_IN string_value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
num_value_fct:
		position_exp
	|	extract_exp
	|	length_exp
	;
char_length_exp:
		SDB_TOKEN_CHAR_LENGTH '(' string_value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
octet_length_exp:
		SDB_TOKEN_OCTECT_LENGTH '(' string_value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
bit_length_exp:
		SDB_TOKEN_BIT_LENGTH '(' string_value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
length_exp:
		char_length_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | octet_length_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | bit_length_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
datetime_field:
		non_second_datetime_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_SECOND
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
extract_field:
		datetime_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | time_zone_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
time_zone_field:
		SDB_TOKEN_TIMEZONE_HOUR
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_TIMEZONE_MINUTE
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
extract_source:
		datetime_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
/*      | interval_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		} */
	;
extract_exp:
		SDB_TOKEN_EXTRACT '(' extract_field SDB_TOKEN_FROM extract_source ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
unsigned_value_spec:
		literal
	|	general_value_spec
	;
general_value_spec:
		parameter
	  | SDB_TOKEN_USER
	;
set_fct_spec:
		general_set_fct
	|	'{' odbc_fct_spec '}'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("{", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode("}", SDB_SQL_PUNCTUATION));
		}
	|	SDB_TOKEN_NAME '(' value_exp_commalist ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
op_parameter:
		{$$ = SQL_NEW_RULE;}
	|	'?' EQUAL
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("?", SDB_SQL_PUNCTUATION));
			$$->Append($2);
		}
	;
odbc_call_spec:
		op_parameter SDB_TOKEN_CALL table_name op_odbc_call_parameter
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	;

op_odbc_call_parameter:
		{$$ = SQL_NEW_RULE;}
	|	'(' odbc_parameter_commalist ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;

odbc_parameter_commalist:
		odbc_parameter
		{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|	odbc_parameter_commalist ',' odbc_parameter
		{
			$1->Append($3);
			$$ = $1;
		}
	;
odbc_parameter:
	/* empty */ 	{$$ = SQL_NEW_RULE;}
	|	literal
	|	parameter
	;

odbc_fct_spec:
		odbc_fct_type SDB_TOKEN_STRING
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;

odbc_fct_type:
		SDB_TOKEN_FN
	| 	SDB_TOKEN_D
	| 	SDB_TOKEN_T
	| 	SDB_TOKEN_TS
	;

general_set_fct:
		set_fct_type '(' opt_all_distinct value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	|	SDB_TOKEN_COUNT '(' '*' ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3 = newNode("*", SDB_SQL_PUNCTUATION));
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	|	SDB_TOKEN_COUNT '(' opt_all_distinct value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
set_fct_type:
		SDB_TOKEN_AVG
	|   SDB_TOKEN_MAX
	|   SDB_TOKEN_MIN
	|   SDB_TOKEN_SUM
	;

outer_join_type:
		SDB_TOKEN_LEFT %prec SDB_TOKEN_LEFT
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_RIGHT %prec SDB_TOKEN_RIGHT
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_FULL %prec SDB_TOKEN_FULL
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  ;
join_condition:
		SDB_TOKEN_ON search_condition
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
		;
join_spec:
		join_condition
	  | named_columns_join
	  ;
join_type:
		SDB_TOKEN_INNER
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | outer_join_type
	  | outer_join_type SDB_TOKEN_OUTER
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
cross_union:
		table_ref /*[SDB_TOKEN_CROSS]*/ SDB_TOKEN_CROSS SDB_TOKEN_JOIN table_ref %prec SDB_TOKEN_CROSS
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	;

qualified_join:
		/* wenn SDB_TOKEN_NATURAL, dann keine join_spec */
		table_ref /*[SDB_TOKEN_NATURAL]*/ SDB_TOKEN_NATURAL join_type SDB_TOKEN_JOIN table_ref %prec SDB_TOKEN_NATURAL
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
		}
	|	table_ref join_type SDB_TOKEN_JOIN table_ref join_spec
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
		}
	|	cross_union
	;
joined_table:
		qualified_join
/*	|	query_exp*/
	|	'(' joined_table ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}

	;
named_columns_join:
		SDB_TOKEN_USING '(' column_commalist ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
simple_table:
		select_statement
	  | values_or_query_spec
	  ;

non_join_query_primary:
		simple_table
	  | '(' non_join_query_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	  ;
non_join_query_term:
		non_join_query_primary
	|	query_term SDB_TOKEN_INTERSECT all query_primary
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	;
query_primary:
		non_join_query_primary
	 /*|	joined_table*/
	;
non_join_query_exp:
		non_join_query_term
	  | query_exp SDB_TOKEN_UNION all query_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	  | query_exp SDB_TOKEN_EXCEPT all query_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	;
all:
	/* empty*/ {$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_ALL
	;
query_exp:
		non_join_query_exp /*[^')']*/
	;
scalar_subquery:
		subquery
	;
cast_operand:
		value_exp
	  | SDB_TOKEN_NULL
	;
cast_target:
		table_name
	  | data_type
	;
cast_spec:
	  SDB_TOKEN_CAST '(' cast_operand SDB_TOKEN_AS cast_target ')'
	  {
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
value_exp_primary:
		unsigned_value_spec
	  | column_ref
	  | set_fct_spec
	  | scalar_subquery
	  | '(' value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	  | cast_spec
	;

num_primary:
		value_exp_primary
	  | num_value_fct
	;
factor:
		num_primary
	|	'-' num_primary  %prec SDB_TOKEN_UMINUS
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("-", SDB_SQL_PUNCTUATION));
			$$->Append($2);
		}
	|	'+' num_primary  %prec SDB_TOKEN_UMINUS
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($2);
		}
	;

term:
		factor
	  | term '*' factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("*", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | term '/' factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("/", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  ;

num_value_exp:
		term
	  | num_value_exp '+' term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | num_value_exp '-' term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("-", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  ;
datetime_primary:
/*		value_exp_primary
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  |*/ datetime_value_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
datetime_value_fct:
		SDB_TOKEN_CURRENT_DATE
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_CURRENT_TIME
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_CURRENT_TIMESTAMP
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
time_zone:
		SDB_TOKEN_AT time_zone_specifier
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
time_zone_specifier:
		SDB_TOKEN_LOCAL
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
/*      | SDB_TOKEN_TIME SDB_TOKEN_ZONE interval_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}*/
	  ;
datetime_factor:
		datetime_primary
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	datetime_primary time_zone
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
datetime_term:
		datetime_factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
/*
interval_term:
		literal
	  | interval_term '*' factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("*", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | interval_term '/' factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("/", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	;
*/
datetime_value_exp:
		datetime_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
/*      | interval_value_exp '+' datetime_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | datetime_value_exp '+' interval_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | datetime_value_exp '-' interval_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("-", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
*/	;
/*
interval_value_exp:
		interval_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | interval_value_exp '+' interval_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | interval_value_exp '-' interval_term
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("-", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	  | '(' datetime_value_exp '-' datetime_term ')' interval_qualifier
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode("-", SDB_SQL_PUNCTUATION));
			$$->Append($4);
			$$->Append($5 = newNode(")", SDB_SQL_PUNCTUATION));
			$$->Append($6);
		}
	;
*/
non_second_datetime_field:
		SDB_TOKEN_YEAR
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	SDB_TOKEN_MONTH
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	SDB_TOKEN_DAY
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	SDB_TOKEN_HOUR
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	SDB_TOKEN_MINUTE
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
/*start_field:
		non_second_datetime_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	non_second_datetime_field '(' SDB_TOKEN_INTNUM ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
end_field:
		non_second_datetime_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_SECOND
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | SDB_TOKEN_SECOND '(' SDB_TOKEN_INTNUM ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
*/
/*
single_datetime_field:
		non_second_datetime_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	non_second_datetime_field '(' SDB_TOKEN_INTNUM ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	|	SDB_TOKEN_SECOND
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	|	SDB_TOKEN_SECOND '(' SDB_TOKEN_INTNUM ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	|	SDB_TOKEN_SECOND '(' SDB_TOKEN_INTNUM ',' SDB_TOKEN_INTNUM ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(",", SDB_SQL_PUNCTUATION));
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
*/
/*
interval_qualifier:
		start_field SDB_TOKEN_TO end_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}
	  | single_datetime_field
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
*/
value_exp_commalist:
		value_exp
			{$$ = SQL_NEW_COMMALISTRULE;
			$$->Append($1);}
	|       value_exp_commalist ',' value_exp
			{$1->Append($3);
			$$ = $1;}
	/*	this rule is only valid if we check predicates */
	|   value_exp_commalist ';' value_exp
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				$1->Append($3);
				$$ = $1;
			}
			else
				YYERROR;
		}
	;
value_exp:
		num_value_exp /*[^')']*/
	  | string_value_exp
	  | datetime_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
string_value_exp:
		char_value_exp
/*      | bit_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
*/	;
char_value_exp:
		char_factor
	|	concatenation
	;
concatenation:
	  char_value_exp '+' char_factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	;

char_primary:
			SDB_TOKEN_STRING
	  |		string_value_fct
			{
				$$ = SQL_NEW_RULE;
				$$->Append($1);
			}
	;
collate_clause:
		SDB_TOKEN_COLLATE table_name
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
char_factor:
		char_primary
	|	char_primary collate_clause
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
string_value_fct:
		char_value_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | bit_value_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
bit_value_fct:
		bit_substring_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
bit_substring_fct:
		SDB_TOKEN_SUBSTRING '(' bit_value_exp SDB_TOKEN_FROM string_value_exp for_length ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
			$$->Append($7 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
bit_value_exp:
		bit_factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
/*
			bit_concatenation
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  |
bit_concatenation:
		bit_value_exp '+' bit_factor
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("+", SDB_SQL_PUNCTUATION));
			$$->Append($3);
		}
	;
*/
bit_factor:
		bit_primary
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
bit_primary:
	{$$ = SQL_NEW_RULE;}
/*		value_exp_primary
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | string_value_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}*/
	;
char_value_fct:
		char_substring_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | fold
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | form_conversion
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | char_translation
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	  | trim_fct
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
		}
	;
for_length:
		{$$ = SQL_NEW_RULE;}
	|	SDB_TOKEN_FOR string_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
char_substring_fct:
		SDB_TOKEN_SUBSTRING '(' string_value_exp SDB_TOKEN_FROM string_value_exp for_length ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6);
			$$->Append($7 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
upper_lower:
		SDB_TOKEN_UPPER
	|	SDB_TOKEN_LOWER
	;
fold:
		upper_lower '(' string_value_exp ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
form_conversion:
		SDB_TOKEN_CONVERT '(' string_value_exp SDB_TOKEN_USING table_name ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
char_translation:
		SDB_TOKEN_TRANSLATE '(' string_value_exp SDB_TOKEN_USING table_name ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4);
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
trim_fct:
		SDB_TOKEN_TRIM  '(' trim_operands ')'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));
		}
	;
trim_operands:
		string_value_exp
	|	trim_spec string_value_exp SDB_TOKEN_FROM string_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
			$$->Append($4);
		}
	|	 trim_spec SDB_TOKEN_FROM string_value_exp
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
			$$->Append($3);
		}
	;
trim_spec:
		SDB_TOKEN_BOTH
	|	SDB_TOKEN_LEADING
	|	SDB_TOKEN_TRAILING
	;

derived_column:
		value_exp as_clause
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);
		}
	;
/* Tabellenname */
table_name:
			SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);}
	|	    SDB_TOKEN_NAME '.' SDB_TOKEN_NAME %prec SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3);}
	|       SDB_TOKEN_NAME '.' SDB_TOKEN_NAME '.' SDB_TOKEN_NAME %prec SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2= newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);}
	|       SDB_TOKEN_NAME ':' SDB_TOKEN_NAME '.' SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2= newNode(":", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);}
/*	|       SDB_TOKEN_NAME ';' SDB_TOKEN_NAME '.' SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2= newNode(";", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);}
*/	;
column_ref:
			column
			{$$ = SQL_NEW_RULE;
			$$->Append($1);}
	|       SDB_TOKEN_NAME '.' column_val %prec '.'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3);}
	|       SDB_TOKEN_NAME '.' SDB_TOKEN_NAME '.' column_val %prec '.'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);}
	|       SDB_TOKEN_NAME '.' SDB_TOKEN_NAME '.' SDB_TOKEN_NAME '.' column_val %prec '.'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2= newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);
			$$->Append($6 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($7);
			}
	|       SDB_TOKEN_NAME ':' SDB_TOKEN_NAME '.' SDB_TOKEN_NAME '.' column_val %prec '.'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2= newNode(":", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);
			$$->Append($6 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($7);
			}
/*	|       SDB_TOKEN_NAME ';' SDB_TOKEN_NAME '.' SDB_TOKEN_NAME '.' column_val
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2= newNode(";", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($5);
			$$->Append($6 = newNode(".", SDB_SQL_PUNCTUATION));
			$$->Append($7);
			}
*/	;

		/* data types */
column_val:
		column
		{$$ = SQL_NEW_RULE;
			$$->Append($1);}
	|	'*'
		{
			$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("*", SDB_SQL_PUNCTUATION));
		}
	;
data_type:
			SDB_TOKEN_CHARACTER
	|       SDB_TOKEN_CHARACTER '(' SDB_TOKEN_INTNUM ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_NUMERIC
	|       SDB_TOKEN_NUMERIC '(' SDB_TOKEN_INTNUM ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_NUMERIC '(' SDB_TOKEN_INTNUM ',' SDB_TOKEN_INTNUM ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(",", SDB_SQL_PUNCTUATION));
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_DECIMAL
	|       SDB_TOKEN_DECIMAL '(' SDB_TOKEN_INTNUM ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_DECIMAL '(' SDB_TOKEN_INTNUM ',' SDB_TOKEN_INTNUM ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(",", SDB_SQL_PUNCTUATION));
			$$->Append($5);
			$$->Append($6 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_INTEGER
	|       SDB_TOKEN_SMALLINT
	|       SDB_TOKEN_FLOAT
	|       SDB_TOKEN_FLOAT '(' SDB_TOKEN_INTNUM ')'
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2 = newNode("(", SDB_SQL_PUNCTUATION));
			$$->Append($3);
			$$->Append($4 = newNode(")", SDB_SQL_PUNCTUATION));}
	|       SDB_TOKEN_REAL
	|       SDB_TOKEN_DOUBLE SDB_TOKEN_PRECISION
			{$$ = SQL_NEW_RULE;
			$$->Append($1);
			$$->Append($2);}
	;

	/* the various things you can name */

column:
		SDB_TOKEN_NAME
	|	SDB_TOKEN_POSITION
		{
			UINT16 nNod = $$->GetRuleID();
			delete $$;
			$$ = newNode(xxx_pGLOBAL_SQLPARSER->TokenIDToStr(nNod), SDB_SQL_NAME);
		}
	|	SDB_TOKEN_CHAR_LENGTH
		{
			UINT16 nNod = $$->GetRuleID();
			delete $$;
			$$ = newNode(xxx_pGLOBAL_SQLPARSER->TokenIDToStr(nNod), SDB_SQL_NAME);
		}
	|	SDB_TOKEN_EXTRACT
		{
			UINT16 nNod = $$->GetRuleID();
			delete $$;
			$$ = newNode(xxx_pGLOBAL_SQLPARSER->TokenIDToStr(nNod), SDB_SQL_NAME);
		}
	;

cursor:	SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);}
	;

/***
module:	SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);}
	;
***/

parameter:
		':' SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode(":", SDB_SQL_PUNCTUATION));
			$$->Append($2);}
	|	'?'
			{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("?", SDB_SQL_PUNCTUATION));}
	|	'['	SDB_TOKEN_NAME ']'
			{$$ = SQL_NEW_RULE;
			$$->Append($1 = newNode("[", SDB_SQL_PUNCTUATION));
			$$->Append($2);
			$$->Append($3 = newNode("]", SDB_SQL_PUNCTUATION));}
	;

/***
procedure:      SDB_TOKEN_NAME
			{$$ = SQL_NEW_RULE;
			$$->Append($1);}
	;
***/

range_variable: SDB_TOKEN_NAME
	;

user:	SDB_TOKEN_NAME
	;

/* PREDICATECHECK RULES */
sql:
		search_condition /* checking predicats */
		{
			if (xxx_pGLOBAL_SQLPARSER->InPredicateCheck())
			{
				$$ = $1;
			}
			else
				YYERROR;
		}
%%
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEFIELDTYPE_HPP_
#include <com/sun/star/data/DatabaseFieldType.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTER_HPP_
#include <com/sun/star/util/XNumberFormatter.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATS_HPP_
#include <com/sun/star/util/XNumberFormats.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTYPES_HPP_
#include <com/sun/star/util/XNumberFormatTypes.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#ifndef _TOOLS_SOLMATH_HXX //autogen wg. SolarMath
#include <tools/solmath.hxx>
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SVT_SDBPARSE_HXX
#include <sdbparse.hxx>
#endif
#ifndef _SVT_SDBSCAN_HXX
#include <sdbscan.hxx>
#endif
#ifndef _SVT_SDBNODE_HXX
#include <sdbnode.hxx>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif
#ifndef _TOOLS_INTN_HXX //autogen wg. International
#include <tools/intn.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_ //autogen wg. Mutex
#include <osl/mutex.hxx>
#endif
#ifndef _ZFORLIST_HXX //autogen
#include <zforlist.hxx>
#endif
#include <svtools.hrc>
#include <svtdata.hxx>

DBG_NAME(SdbSqlParser);

sal_uInt32 SdbSqlParser::nRuleIDs[SdbSqlParseNode::rule_count + 1];

// Der (leider globale) yylval fuer die Uebergabe von
// Werten vom Scanner an den Parser. Die globale Variable
// wird nur kurzzeitig verwendet, der Parser liest die Variable
// sofort nach dem Scanner-Aufruf in eine gleichnamige eigene
// Member-Variable.
// Dieser von MKS Lex/Yacc verwendete Mechanismus ist NICHT multithread-
// tauglich. DLLs sind aber kein so grosses Problem, da
//	- unter Windows die Ausfuehrung des Codes ohnehin nicht unterbrochen
//	  wird (cooperative multitasking, nicht preemptive)
//	- auf allen anderen Systemen DLLs fuer jeden Prozess einen eigenen
//	  Datenbereich fuer globale/statische Daten haben.

// static String aEmptyString;

// mutex for parsing
static ::osl::Mutex aMutex;
const double fMilliSecondsPerDay = 86400000.0;

//------------------------------------------------------------------------------
const International& getStaticEnglishInternational()
{
	static International aIntl(LANGUAGE_ENGLISH_US);
	static BOOL bInitialized = FALSE;
	if (!bInitialized)
	{	// ensure that the two members we're interested in are really set
		// (if the system doesn't know the locale en_US aIntl would be initialized with the
		// system language which may be anything - which we don't want ...)
		// 74342 - 21.03.00 - FS
		aIntl.SetNumThousandSep(',');
		aIntl.SetNumDecimalSep('.');
		bInitialized = TRUE;
	}
	return aIntl;
}

//------------------------------------------------------------------------------
Date getNULLDate(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > &xSupplier)
{
	static rtl::OUString NULLDATE = rtl::OUString::createFromAscii("NullDate");
	DBG_ASSERT(xSupplier.is(), "getNULLDate : the formatter doesn't implement a supplier !");
	if (xSupplier.is())
	{
		try
		{
			// get the null date
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSettings = xSupplier->getNumberFormatSettings();
			::com::sun::star::uno::Any aVal  = xSettings->getPropertyValue(NULLDATE);
			::com::sun::star::util::Date aDate;
			aVal >>= aDate;
			return Date(aDate.Day, aDate.Month, aDate.Year);
		}
		catch ( ... )
		{
		}
	}

	return Date(1,1,1900);
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Any getNumberFormatProperty(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > &xSupplier,
												   sal_Int32 nKey,
												   const rtl::OUString& aPropertyName)
{
	DBG_ASSERT(xSupplier.is(), "getNumberFormatProperty : the formatter doesn't implement a supplier !");
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormats >  xFormats = xSupplier->getNumberFormats();

	if (xFormats.is())
	{
		try
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > xProperties(xFormats->getByKey(nKey));
			return xProperties->getPropertyValue(aPropertyName);
		}
		catch( ... )
		{
		}
	}
	return ::com::sun::star::uno::Any();
}

// date time conversion
//------------------------------------------------------------------
DateTime ToDateTime(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xSupplier,
					const double& fSbxDate)
{

	long nDays     = (long)fSbxDate;
	long nMSeconds = long((fSbxDate - (double)nDays) * fMilliSecondsPerDay + 0.5);

	// Datum:
	DateTime x(getNULLDate(xSupplier));

	if (nDays >= 0)
		x += (sal_uInt32)nDays;
	else
		x -= (sal_uInt32)(-nDays);

	// Zeit:
	x.MakeTimeFromMS(nMSeconds);
	if (x.GetTime() < 0)
		x += Time(23,59,59,99);
	return x;
}

//------------------------------------------------------------------
double ToDouble(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xSupplier, const Date& rDate)
{
	long nDays = 0;
	Date aNullDate(getNULLDate(xSupplier));
	if (aNullDate >= rDate)
	{
		nDays = (long)(aNullDate - rDate);
		nDays *= -1;
	}
	else
		nDays = (long)(rDate - aNullDate);

	return (double)nDays;
}

//------------------------------------------------------------------
double ToDouble(const Time& rTime)
{
	return (double)rTime.GetMSFromTime() / fMilliSecondsPerDay;
}

//------------------------------------------------------------------
Date ToDate(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xSupplier, const double& fSbxDate)
{
	// count the days
	long nDays = (long)fSbxDate;
	Date aNullDate(getNULLDate(xSupplier));

	if (nDays >= 0)
		aNullDate += (sal_uInt32)nDays;
	else
		aNullDate -= (sal_uInt32)(-nDays);

	return aNullDate;
}

//------------------------------------------------------------------
Time ToTime(const double& fSbxDate)
{
	long nDays     = (long)fSbxDate;
	long nMSeconds = long((fSbxDate - (double)nDays) * fMilliSecondsPerDay + 0.5);

	Time x;
	x.MakeTimeFromMS(nMSeconds);
	if (x.GetTime() < 0)
		x += Time(23,59,59,99);
	return x;
}

//------------------------------------------------------------------
String ToDateString(const Date& rDate)
{
	sal_Char s[11];
	sprintf(s,"%04d-%02d-%02d",
				(int)rDate.GetYear(),
				(int)rDate.GetMonth(),
				(int)rDate.GetDay());
	s[10] = 0;
	return String::CreateFromAscii(s);
}

//------------------------------------------------------------------
String ToTimeString(const Time& rTime)
{
	sal_Char s[9];
	sprintf(s,"%02d:%02d:%02d",
			(int)rTime.GetHour(),
			(int)rTime.GetMin(),
			(int)rTime.GetSec());
	s[8] = 0;
	return String::CreateFromAscii(s);
}

//------------------------------------------------------------------
String ToDateTimeString(const DateTime& rDateTime)
{
	String aTemp(ToDateString(rDateTime));
	aTemp += String::CreateFromAscii(" ");
	aTemp += ToTimeString(rDateTime);
	return  aTemp;
}


//------------------------------------------------------------------
String ConvertLikeToken(const SdbSqlParseNode* pTokenNode, const SdbSqlParseNode* pEscapeNode, sal_Bool bInternational)
{
	String aMatchStr;
	if (pTokenNode->IsToken())
	{
		char cEscape = 0;
		if (pEscapeNode->Count())
			cEscape = pEscapeNode->GetChild(1)->TokenValue().GetChar(0);

		// Platzhalter austauschen
		aMatchStr = pTokenNode->TokenValue();
		sal_uInt16 nLen = aMatchStr.Len();
		const char* sSearch  = bInternational ? "%_" : "*?";
		const char* sReplace = bInternational ? "*?" : "%_";
		for (sal_uInt16 i = 0; i < nLen; i++)
		{
			char c = aMatchStr.GetChar(i);
			if (c == sSearch[0] || c == sSearch[1])
			{
				if (i > 0 && aMatchStr.GetChar(i-1) == cEscape)
					continue;
				else if (c == sSearch[0])
					aMatchStr.SetChar(i,sReplace[0]);
				else
					aMatchStr.SetChar(i,sReplace[1]);
			}
		}
	}
	return aMatchStr;
}


//-----------------------------------------------------------------------------
void SdbSqlParser::SetLanguage(LanguageType eType)
{
	m_eLanguage = eType;
	SdbSqlScanner::SetLanguage(m_eLanguage);
}

//-----------------------------------------------------------------------------
SdbSqlParser::SdbSqlParser(LanguageType eLanguage)
			 :m_pScanner(NULL)
			 ,m_pParseTree(NULL)
			 ,m_pIntl(NULL)
			 ,m_eLanguage(eLanguage)
{
	DBG_CTOR(SdbSqlParser,NULL);

	xxx_pGLOBAL_SQLPARSER = this;
#ifdef SDBYYDEBUG
#ifdef SDBYYDEBUG_ON
	SQLyydebug = 1;
#endif
#endif

	// auf 0 zuruecksetzen
	memset(SdbSqlParser::nRuleIDs,0,sizeof(sal_uInt16) * SdbSqlParseNode::rule_count+1);
}

//-----------------------------------------------------------------------------
SdbSqlParser::~SdbSqlParser()
{
	delete m_pScanner;
	delete m_pIntl;
	DBG_DTOR(SdbSqlParser,NULL);
}

//-----------------------------------------------------------------------------
SdbSqlParseNode * SdbSqlParser::ParseTree(String& rErrorMessage,
										  const String& rStatement,
										  sal_Bool bInternational)
{
	DBG_CHKTHIS(SdbSqlParser,NULL);

	// Guard the parsing
	::osl::MutexGuard aGuard( aMutex );

	// Einen Scanner anlegen und das SQL-Statement uebergeben ...
	// Scanner wird nicht im Ctor angelegt, da dieser zyklisch SdbEnvironment instanziert
	if (!m_pScanner)
	{
		m_pScanner = new SdbSqlScanner(m_eLanguage);
		m_pScanner->setScanner();
	}

	m_pScanner->SetRule(m_pScanner->GetSQLRule()); // initial
	m_pScanner->Initialize(rStatement, bInternational);

	SQLyylval.pParseNode = NULL;
	m_pParseTree = NULL;
	m_aErrorMessage.Erase();

	// ... und den Parser anwerfen ...
	if (SQLyyparse() != 0)
	{
		// only set the error message, if it's not already set
		if (!m_aErrorMessage.Len())
			m_aErrorMessage = m_pScanner->GetErrorMessage();
		if (!m_aErrorMessage.Len())
			m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ERROR, m_eLanguage);

		rErrorMessage = m_aErrorMessage;

		// clear the garbage collector
		while (!SqlInternalNode::aGarbageCollector.empty())
		{
			SdbSqlParseNode* pNode = *SqlInternalNode::aGarbageCollector.begin();
			while (pNode->Parent())
				pNode = pNode->Parent();
			delete pNode;
		}
		return NULL;
	}
	else
	{
		SqlInternalNode::aGarbageCollector.clear();

		// Das Ergebnis liefern (den Root Parse Node):

		//	DBG_ASSERT(SQLyyval.pParseNode != NULL,"SdbSqlParser: Parser hat keinen ParseNode geliefert");
		//	return SQLyyval.pParseNode;
		// geht nicht wegen Bug in MKS YACC-erzeugtem Code (es wird ein falscher ParseNode
		// geliefert).

		// Stattdessen setzt die Parse-Routine jetzt den Member pParseTree
		// - einfach diesen zurueckliefern:
		DBG_ASSERT(m_pParseTree != NULL,"SdbSqlParser: Parser hat keinen ParseTree geliefert");
		return m_pParseTree;
	}
}

static char* __READONLY_DATA PREDICATE_CHECK = "PREDICATE ";
//-----------------------------------------------------------------------------
SdbSqlParseNode* SdbSqlParser::PredicateTree(String& rErrorMessage, const String& rStatement,
										     const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,
										     const International& rIntl,
											 const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xField)
{
	DBG_CHKTHIS(SdbSqlParser,NULL);

	// mutex for parsing
	static ::osl::Mutex aMutex;

	// Guard the parsing
	::osl::MutexGuard aGuard( aMutex );

	// Den Parser zuruecksetzen


	// Einen Scanner anlegen und das SQL-Statement uebergeben ...
	// Scanner wird nicht im Ctor angelegt, da dieser zyklisch SdbEnvironment instanziert
	if (!m_pScanner)
	{
		m_pScanner = new SdbSqlScanner(m_eLanguage);
		m_pScanner->setScanner();
	}

	m_xField		= xField;
	m_xFormatter	= xFormatter;

	if (m_xField.is())
	{
		sal_Int32 nType=0;
		try
		{
			// get the field name
			rtl::OUString aString;

			// retrieve the fields name
			// #75243# use the RealName of the column if there is any otherwise the name which could be the alias
			// of the field
			if (m_xField->getPropertySetInfo()->hasPropertyByName(rtl::OUString::createFromAscii("RealName")))
				m_xField->getPropertyValue(rtl::OUString::createFromAscii("RealName")) >>= aString;
			else
				m_xField->getPropertyValue(rtl::OUString::createFromAscii("Name")) >>= aString;

			m_aFieldName = aString;

			// get the field format key
			m_xField->getPropertyValue(rtl::OUString::createFromAscii("FormatKey")) >>= m_nFormatKey;

			// get the field type
			{
				::com::sun::star::uno::Any aValue = m_xField->getPropertyValue(rtl::OUString::createFromAscii("Type"));
				if (aValue.getValueType().getTypeClass() == ::com::sun::star::uno::TypeClass_LONG)
					aValue >>= nType;
				else
				{
					// for old api
					sal_Int16 nVal;
					aValue >>= nVal;
					nType = nVal;
				}
			}
		}
		catch ( ... )
		{
		}

		if (!m_pIntl)
			m_pIntl = new International(getStaticEnglishInternational());

		if (m_nFormatKey && m_xFormatter.is())
		{
			static rtl::OUString LOCALE(rtl::OUString::createFromAscii("Locale"));
			::com::sun::star::uno::Any aValue = getNumberFormatProperty(m_xFormatter->getNumberFormatsSupplier(), m_nFormatKey, LOCALE);
			DBG_ASSERT(aValue.getValueType() == ::getCppuType((const ::com::sun::star::lang::Locale*)0), "SdbSqlParser::PredicateTree : invalid language property !");

			if (aValue.getValueType() == ::getCppuType((const ::com::sun::star::lang::Locale*)0))
			{
				com::sun::star::lang::Locale aLocale;
				aValue >>= aLocale;
				*m_pIntl = International(
					ConvertIsoNamesToLanguage(aLocale.Language.getStr(),
											  aLocale.Country.getStr()));
			}
		}
		else
			*m_pIntl = International(getStaticEnglishInternational());

		switch (nType)
		{
			case ::com::sun::star::data::DatabaseFieldType::DATE:
			case ::com::sun::star::data::DatabaseFieldType::TIME:
			case ::com::sun::star::data::DatabaseFieldType::DATETIME:
				m_pScanner->SetRule(m_pScanner->GetDATERule());
				break;
			case ::com::sun::star::data::DatabaseFieldType::CHAR:
			case ::com::sun::star::data::DatabaseFieldType::VARCHAR:
			case ::com::sun::star::data::DatabaseFieldType::LONGVARCHAR:
				m_pScanner->SetRule(m_pScanner->GetSTRINGRule());
				break;
			default:
				if (m_pIntl->GetNumDecimalSep() == ',')
					m_pScanner->SetRule(m_pScanner->GetGERRule());
				else
					m_pScanner->SetRule(m_pScanner->GetENGRule());
		}

	}
	else
		m_pScanner->SetRule(m_pScanner->GetSQLRule()); // initial

	m_pScanner->Initialize(rStatement, sal_True);

	SQLyylval.pParseNode = NULL;
	m_pParseTree = NULL;
	m_aErrorMessage.Erase();

	// ... und den Parser anwerfen ...
	if (SQLyyparse() != 0)
	{
		m_aFieldName.Erase();
		m_xField = NULL;
		m_xFormatter = NULL;
		m_nFormatKey = 0;

		// only set the error message, if it's not already set
		if (!m_aErrorMessage.GetChar(0))
			m_aErrorMessage = m_pScanner->GetErrorMessage();
		if (!m_aErrorMessage.GetChar(0))
			m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ERROR, m_eLanguage);

		rErrorMessage = m_aErrorMessage;

		// clear the garbage collector
		while (!SqlInternalNode::aGarbageCollector.empty())
		{
			SdbSqlParseNode* pNode = *SqlInternalNode::aGarbageCollector.begin();
			while (pNode->Parent())
				pNode = pNode->Parent();
			delete pNode;
		}
		return NULL;
	}
	else
	{
		SqlInternalNode::aGarbageCollector.clear();

		m_aFieldName.Erase();
		m_xField = NULL;
		m_xFormatter = NULL;
		m_nFormatKey = 0;

		// Das Ergebnis liefern (den Root Parse Node):

		//	DBG_ASSERT(SQLyyval.pParseNode != NULL,"SdbSqlParser: Parser hat keinen ParseNode geliefert");
		//	return SQLyyval.pParseNode;
		// geht nicht wegen Bug in MKS YACC-erzeugtem Code (es wird ein falscher ParseNode
		// geliefert).

		// Stattdessen setzt die Parse-Routine jetzt den Member pParseTree
		// - einfach diesen zurueckliefern:
		DBG_ASSERT(m_pParseTree != NULL,"SdbSqlParser: Parser hat keinen ParseTree geliefert");
		return m_pParseTree;
	}
}

//-----------------------------------------------------------------------------
String SdbSqlParser::TokenIDToStr(sal_uInt32 nTokenID, sal_Bool bInternational)
{
	String aStr;
	if (bInternational)
		aStr = SdbSqlScanner::GetInternationalKeywordString(nTokenID);
	else
		aStr = TokenIDToStr(nTokenID);
	return aStr;
}

//-----------------------------------------------------------------------------
String SdbSqlParser::TokenIDToStr(sal_uInt32 nTokenID)
{
	String aStr;
	// Gewuenschte Token-Nr. suchen:
	aStr = String::CreateFromAscii(yytname[YYTRANSLATE(nTokenID)]);
	if(aStr.EqualsIgnoreCaseAscii("SDB_TOKEN_",0,10))
		aStr.Erase(0,10);

	return aStr;
}

//-----------------------------------------------------------------------------
sal_uInt32 SdbSqlParser::StrToTokenID(const ByteString & rName)
{
	// Bei Bezeichnern Praefix "SDB_TOKEN_" hinzufuegen,
	// bei Sonderzeichen nicht:
	ByteString aName;

	// nyi: Bessere Unterscheidung von Token-Bezeichnern vs. Symbolen
	// (Problem ggf.: Sonderzeichen wie '_' IN Bezeichnern!)
	if (rName.CompareTo("SDB_TOKEN_",10) == COMPARE_EQUAL)
		aName = rName;
	else if (rName.IsAlphaNumericAscii())
	{
		aName = "SDB_TOKEN_";
		aName += rName;
	}
	else
	{
		aName = "'";
		aName += rName;
		aName += "'";
	}

	// Gewuenschten Token-Namen suchen:
	static sal_Int32 nLen = sizeof(yytranslate)/sizeof(yytranslate[0]);
	for (sal_uInt32 i = 0; i < (nLen-1); i++)
	{
		if (yytname && rName == yytname[YYTRANSLATE(i)])
			return i;
	}

	// Nicht gefunden
	return 0;
}

//-----------------------------------------------------------------------------
String SdbSqlParser::RuleIDToStr(sal_uInt32 nRuleID)
{
	return String::CreateFromAscii(yytname[nRuleID]);
}

//-----------------------------------------------------------------------------
sal_uInt32 SdbSqlParser::StrToRuleID(const ByteString & rValue)
{
	static sal_Int32 nLen = sizeof(yytname)/sizeof(yytname[0]);
	for (sal_uInt32 i = 0; i < (nLen-1); i++)
	{
		if (yytname && rValue == yytname[i])
			return i;
	}

	// Nicht gefunden
	return 0;
}

//-----------------------------------------------------------------------------
sal_uInt32 SdbSqlParser::RuleID(SdbSqlParseNode::Rule eRule)
{
	if (!nRuleIDs[eRule])
	{
		switch (eRule)
		{
			case SdbSqlParseNode::select_statement:
				nRuleIDs[eRule] = StrToRuleID("select_statement"); break;
			case SdbSqlParseNode::from_clause:
				nRuleIDs[eRule] = StrToRuleID("from_clause"); break;
			case SdbSqlParseNode::table_ref_commalist:
				nRuleIDs[eRule] = StrToRuleID("table_ref_commalist"); break;
			case SdbSqlParseNode::table_exp:
				nRuleIDs[eRule] = StrToRuleID("table_exp"); break;
			case SdbSqlParseNode::table_ref:
				nRuleIDs[eRule] = StrToRuleID("table_ref"); break;
			case SdbSqlParseNode::table_name:
				nRuleIDs[eRule] = StrToRuleID("table_name"); break;
			case SdbSqlParseNode::opt_column_commalist:
				nRuleIDs[eRule] = StrToRuleID("opt_column_commalist"); break;
			case SdbSqlParseNode::column_commalist:
				nRuleIDs[eRule] = StrToRuleID("column_commalist"); break;
			case SdbSqlParseNode::column_ref_commalist:
				nRuleIDs[eRule] = StrToRuleID("column_ref_commalist"); break;
			case SdbSqlParseNode::column_ref:
				nRuleIDs[eRule] = StrToRuleID("column_ref"); break;
			case SdbSqlParseNode::opt_order_by_clause:
				nRuleIDs[eRule] = StrToRuleID("opt_order_by_clause"); break;
			case SdbSqlParseNode::ordering_spec_commalist:
				nRuleIDs[eRule] = StrToRuleID("ordering_spec_commalist"); break;
			case SdbSqlParseNode::ordering_spec:
				nRuleIDs[eRule] = StrToRuleID("ordering_spec"); break;
			case SdbSqlParseNode::opt_asc_desc:
				nRuleIDs[eRule] = StrToRuleID("opt_asc_desc"); break;
			case SdbSqlParseNode::where_clause:
				nRuleIDs[eRule] = StrToRuleID("where_clause"); break;
			case SdbSqlParseNode::opt_where_clause:
				nRuleIDs[eRule] = StrToRuleID("opt_where_clause"); break;
			case SdbSqlParseNode::search_condition:
				nRuleIDs[eRule] = StrToRuleID("search_condition"); break;
			case SdbSqlParseNode::comparison_predicate:
				nRuleIDs[eRule] = StrToRuleID("comparison_predicate"); break;
			case SdbSqlParseNode::between_predicate:
				nRuleIDs[eRule] = StrToRuleID("between_predicate"); break;
			case SdbSqlParseNode::like_predicate:
				nRuleIDs[eRule] = StrToRuleID("like_predicate"); break;
			case SdbSqlParseNode::opt_escape:
				nRuleIDs[eRule] = StrToRuleID("opt_escape"); break;
			case SdbSqlParseNode::test_for_null:
				nRuleIDs[eRule] = StrToRuleID("test_for_null"); break;
			case SdbSqlParseNode::scalar_exp_commalist:
				nRuleIDs[eRule] = StrToRuleID("scalar_exp_commalist"); break;
			case SdbSqlParseNode::scalar_exp:
				nRuleIDs[eRule] = StrToRuleID("scalar_exp"); break;
			case SdbSqlParseNode::parameter_ref:
				nRuleIDs[eRule] = StrToRuleID("parameter_ref"); break;
			case SdbSqlParseNode::parameter:
				nRuleIDs[eRule] = StrToRuleID("parameter"); break;
			case SdbSqlParseNode::general_set_fct:
				nRuleIDs[eRule] = StrToRuleID("general_set_fct"); break;
			case SdbSqlParseNode::range_variable:
				nRuleIDs[eRule] = StrToRuleID("range_variable"); break;
			case SdbSqlParseNode::column:
				nRuleIDs[eRule] = StrToRuleID("column"); break;
			case SdbSqlParseNode::delete_statement_positioned:
				nRuleIDs[eRule] = StrToRuleID("delete_statement_positioned"); break;
			case SdbSqlParseNode::delete_statement_searched:
				nRuleIDs[eRule] = StrToRuleID("delete_statement_searched"); break;
			case SdbSqlParseNode::update_statement_positioned:
				nRuleIDs[eRule] = StrToRuleID("update_statement_positioned"); break;
			case SdbSqlParseNode::update_statement_searched:
				nRuleIDs[eRule] = StrToRuleID("update_statement_searched"); break;
			case SdbSqlParseNode::assignment_commalist:
				nRuleIDs[eRule] = StrToRuleID("assignment_commalist"); break;
			case SdbSqlParseNode::assignment:
				nRuleIDs[eRule] = StrToRuleID("assignment"); break;
			case SdbSqlParseNode::values_or_query_spec:
				nRuleIDs[eRule] = StrToRuleID("values_or_query_spec"); break;
			case SdbSqlParseNode::insert_statement:
				nRuleIDs[eRule] = StrToRuleID("insert_statement"); break;
			case SdbSqlParseNode::insert_atom_commalist:
				nRuleIDs[eRule] = StrToRuleID("insert_atom_commalist"); break;
			case SdbSqlParseNode::insert_atom:
				nRuleIDs[eRule] = StrToRuleID("insert_atom"); break;
			case SdbSqlParseNode::predicate_check:
				nRuleIDs[eRule] = StrToRuleID("predicate_check"); break;
			case SdbSqlParseNode::qualified_join:
				nRuleIDs[eRule] = StrToRuleID("qualified_join"); break;
			case SdbSqlParseNode::cross_union:
				nRuleIDs[eRule] = StrToRuleID("cross_union"); break;
			case SdbSqlParseNode::select_sublist:
				nRuleIDs[eRule] = StrToRuleID("select_sublist"); break;
			case SdbSqlParseNode::derived_column:
				nRuleIDs[eRule] = StrToRuleID("derived_column"); break;
			case SdbSqlParseNode::column_val:
				nRuleIDs[eRule] = StrToRuleID("column_val"); break;
			case SdbSqlParseNode::set_fct_spec:
				nRuleIDs[eRule] = StrToRuleID("set_fct_spec"); break;
			case SdbSqlParseNode::boolean_term:
				nRuleIDs[eRule] = StrToRuleID("boolean_term"); break;
			case SdbSqlParseNode::boolean_primary:
				nRuleIDs[eRule] = StrToRuleID("boolean_primary"); break;
			case SdbSqlParseNode::num_value_exp:
				nRuleIDs[eRule] = StrToRuleID("num_value_exp"); break;
			case SdbSqlParseNode::join_type:
				nRuleIDs[eRule] = StrToRuleID("join_type"); break;
			case SdbSqlParseNode::position_exp:
				nRuleIDs[eRule] = StrToRuleID("position_exp"); break;
			case SdbSqlParseNode::extract_exp:
				nRuleIDs[eRule] = StrToRuleID("extract_exp"); break;
			case SdbSqlParseNode::length_exp:
				nRuleIDs[eRule] = StrToRuleID("length_exp"); break;
			case SdbSqlParseNode::char_value_fct:
				nRuleIDs[eRule] = StrToRuleID("char_value_fct"); break;
			case SdbSqlParseNode::odbc_call_spec:
				nRuleIDs[eRule] = StrToRuleID("odbc_call_spec"); break;
			case SdbSqlParseNode::in_predicate:
				nRuleIDs[eRule] = StrToRuleID("in_predicate"); break;
			case SdbSqlParseNode::existence_test:
				nRuleIDs[eRule] = StrToRuleID("existence_test"); break;
			case SdbSqlParseNode::unique_test:
				nRuleIDs[eRule] = StrToRuleID("unique_test"); break;
			case SdbSqlParseNode::all_or_any_predicate:
				nRuleIDs[eRule] = StrToRuleID("all_or_any_predicate"); break;
			case SdbSqlParseNode::named_columns_join:
				nRuleIDs[eRule] = StrToRuleID("named_columns_join"); break;
			case SdbSqlParseNode::join_condition:
				nRuleIDs[eRule] = StrToRuleID("join_condition"); break;
			case SdbSqlParseNode::joined_table:
				nRuleIDs[eRule] = StrToRuleID("joined_table"); break;
			case SdbSqlParseNode::boolean_factor:
				nRuleIDs[eRule] = StrToRuleID("boolean_factor"); break;
			case SdbSqlParseNode::not:
				nRuleIDs[eRule] = StrToRuleID("not"); break;
			case SdbSqlParseNode::boolean_test:
				nRuleIDs[eRule] = StrToRuleID("boolean_test"); break;
			case SdbSqlParseNode::manipulative_statement:
				nRuleIDs[eRule] = StrToRuleID("manipulative_statement"); break;
			case SdbSqlParseNode::subquery:
				nRuleIDs[eRule] = StrToRuleID("subquery"); break;
			case SdbSqlParseNode::value_exp_commalist:
				nRuleIDs[eRule] = StrToRuleID("value_exp_commalist"); break;
			case SdbSqlParseNode::odbc_fct_spec:
				nRuleIDs[eRule] = StrToRuleID("odbc_fct_spec"); break;
			case SdbSqlParseNode::union_statement:
				nRuleIDs[eRule] = StrToRuleID("union_statement"); break;
			case SdbSqlParseNode::outer_join_type:
				nRuleIDs[eRule] = StrToRuleID("outer_join_type"); break;
			case SdbSqlParseNode::char_value_exp:
				nRuleIDs[eRule] = StrToRuleID("char_value_exp"); break;
			case SdbSqlParseNode::term:
				nRuleIDs[eRule] = StrToRuleID("term"); break;
			case SdbSqlParseNode::value_exp_primary:
				nRuleIDs[eRule] = StrToRuleID("value_exp_primary"); break;
			default:
				DBG_ERROR("interner Fehler: Regel nicht bekannt, in SdbSqlParser::RuleID nachtragen!");
		}
	}
	return nRuleIDs[(sal_uInt16)eRule];
}

//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildNode(SdbSqlParseNode*& pAppend,SdbSqlParseNode* pLiteral,SdbSqlParseNode*& pCompare)
{
	SdbSqlParseNode* pColumnRef = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
	pColumnRef->Append(new SqlInternalNode(m_aFieldName,SDB_SQL_NAME));
	SdbSqlParseNode* pComp = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::comparison_predicate));
	pComp->Append(pColumnRef);
	pComp->Append(pCompare);
	pComp->Append(pLiteral);
	pAppend->Append(pComp);
	return 1;
}

//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildNode_STR_NUM(SdbSqlParseNode*& pAppend,SdbSqlParseNode*& pLiteral,SdbSqlParseNode*& pCompare)
{
	SdbSqlParseNode* pColumnRef = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
	pColumnRef->Append(new SqlInternalNode(m_aFieldName,SDB_SQL_NAME));
	SdbSqlParseNode* pComp = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::comparison_predicate));
	pComp->Append(pColumnRef);
	pComp->Append(pCompare);

	if (m_nFormatKey)
	{
		sal_Int16 nScale = 0;
		try
		{
			::com::sun::star::uno::Any aValue = getNumberFormatProperty(m_xFormatter->getNumberFormatsSupplier(),
										m_nFormatKey, rtl::OUString::createFromAscii("Decimals"));
			aValue >>= nScale;
		}
		catch ( ... )
		{
		}

		int nErrno=0;
		double dValue = SolarMath::StringToDouble(pLiteral->TokenValue().GetBuffer(), *m_pIntl, nErrno);
		String aValue;
		SolarMath::DoubleToString(aValue, dValue, 'F', nScale, m_pIntl->GetNumDecimalSep(), sal_True);
		pComp->Append(new SqlInternalNode(aValue,SDB_SQL_STRING));
	}
	else
		pComp->Append(new SqlInternalNode(pLiteral->TokenValue(),SDB_SQL_STRING));

	pAppend->Append(pComp);

	delete pLiteral;
	pLiteral = NULL;

	return 1;
}

//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildNode_Date(const double& fValue, sal_Int16 nType, SdbSqlParseNode*& pAppend,SdbSqlParseNode* pLiteral,SdbSqlParseNode*& pCompare)
{
	SdbSqlParseNode* pColumnRef = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::column_ref));
	pColumnRef->Append(new SqlInternalNode(m_aFieldName,SDB_SQL_NAME));
	SdbSqlParseNode* pComp = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::comparison_predicate));
	pComp->Append(pColumnRef);
	pComp->Append(pCompare);

	SdbSqlParseNode* pNewNode = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::set_fct_spec));
	pNewNode->Append(new SqlInternalNode(String::CreateFromAscii("{"), SDB_SQL_PUNCTUATION));
	SdbSqlParseNode* pDateNode = new SqlInternalNode(aEmptyString, SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::odbc_fct_spec));
	pNewNode->Append(pDateNode);
	pNewNode->Append(new SqlInternalNode(String::CreateFromAscii("}"), SDB_SQL_PUNCTUATION));

	switch (nType)
	{
		case ::com::sun::star::data::DatabaseFieldType::DATE:
		{
			Date aDate = ToDate(m_xFormatter->getNumberFormatsSupplier(), fValue);
			String aString = ToDateString(aDate);
			pDateNode->Append(new SqlInternalNode(aEmptyString, SDB_SQL_KEYWORD, SDB_TOKEN_D));
			pDateNode->Append(new SqlInternalNode(aString, SDB_SQL_STRING));
			break;
		}
		case ::com::sun::star::data::DatabaseFieldType::TIME:
		{
			Time aTime = ToTime(fValue);
			String aString = ToTimeString(aTime);
			pDateNode->Append(new SqlInternalNode(aEmptyString, SDB_SQL_KEYWORD, SDB_TOKEN_T));
			pDateNode->Append(new SqlInternalNode(aString, SDB_SQL_STRING));
			break;
		}
		case ::com::sun::star::data::DatabaseFieldType::DATETIME:
		{
			DateTime aDateTime = ToDateTime(m_xFormatter->getNumberFormatsSupplier(), fValue);
			if (aDateTime.GetMSFromTime() / fMilliSecondsPerDay)
			{
				String aString = ToDateTimeString(aDateTime);
				pDateNode->Append(new SqlInternalNode(aEmptyString, SDB_SQL_KEYWORD, SDB_TOKEN_TS));
				pDateNode->Append(new SqlInternalNode(aString, SDB_SQL_STRING));
			}
			else
			{
				pDateNode->Append(new SqlInternalNode(aEmptyString, SDB_SQL_KEYWORD, SDB_TOKEN_D));
				pDateNode->Append(new SqlInternalNode(ToDateString(aDateTime), SDB_SQL_STRING));
			}
			break;
		}
	}

	pComp->Append(pNewNode);
	pAppend->Append(pComp);

	delete pLiteral;
	pLiteral = NULL;

	return 1;
}

//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildLikeRule(SdbSqlParseNode*& pAppend, SdbSqlParseNode*& pLiteral, const SdbSqlParseNode* pEscape)
{
	sal_Int16 nErg = 0;
	sal_Int32 nType = 0;

	if (!m_xField.is())
		return nErg;
	try
	{
		::com::sun::star::uno::Any aValue;
		{
			aValue = m_xField->getPropertyValue(rtl::OUString::createFromAscii("Type"));
			if (aValue.getValueType().getTypeClass() == ::com::sun::star::uno::TypeClass_LONG)
				aValue >>= nType;
			else
			{
				// for old api
				sal_Int16 nVal;
				aValue >>= nVal;
				nType = nVal;
			}
		}
	}
	catch ( ... )
	{
		return nErg;
	}

	switch (nType)
	{
		case ::com::sun::star::data::DatabaseFieldType::CHAR:
		case ::com::sun::star::data::DatabaseFieldType::VARCHAR:
		case ::com::sun::star::data::DatabaseFieldType::LONGVARCHAR:
			if(pLiteral->IsRule())
			{
				pAppend->Append(pLiteral);
				nErg = 1;
			}
			else
			{
				switch(pLiteral->GetNodeType())
				{
					case SDB_SQL_STRING:
						pLiteral->m_aNodeValue = ConvertLikeToken(pLiteral, pEscape, sal_False);
						pAppend->Append(pLiteral);
						nErg = 1;
						break;
					case SDB_SQL_APPROXNUM:
						if (m_xFormatter.is() && m_nFormatKey)
						{
							sal_Int16 nScale = 0;
							try
							{
								::com::sun::star::uno::Any aValue = getNumberFormatProperty(m_xFormatter->getNumberFormatsSupplier(),
															m_nFormatKey, rtl::OUString::createFromAscii("Decimals"));
								aValue >>= nScale;
							}
							catch ( ... )
							{
							}

							int nErrno=0;
							String aValue;
							double dValue = SolarMath::StringToDouble(pLiteral->TokenValue().GetBuffer(), getStaticEnglishInternational(), nErrno);
							SolarMath::DoubleToString(aValue, dValue, 'F', nScale, '.', sal_True);
							pAppend->Append(new SqlInternalNode(aValue,SDB_SQL_STRING));
						}
						else
							pAppend->Append(new SqlInternalNode(pLiteral->TokenValue(),SDB_SQL_STRING));

						delete pLiteral;
						nErg = 1;
						break;
					default:
					{
						m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_VALUE_NO_LIKE, m_eLanguage);
						m_aErrorMessage.SearchAndReplace(String::CreateFromAscii("#1"),pLiteral->TokenValue());
					}
				}
			}
			break;
		default:
			m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_FIELD_NO_LIKE, m_eLanguage);
	}
	return nErg;
}
//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildStringNodes(SdbSqlParseNode*& pLiteral)
{
	if(!pLiteral)
		return 1;

	if(SDB_ISRULE(pLiteral,set_fct_spec) || SDB_ISRULE(pLiteral,general_set_fct) || SDB_ISRULE(pLiteral,column_ref)
		|| SDB_ISRULE(pLiteral,subquery))
		return 1; // here I have a function that I can't transform into a string

	if(pLiteral->GetNodeType() == SDB_SQL_INTNUM || pLiteral->GetNodeType() == SDB_SQL_APPROXNUM || pLiteral->GetNodeType() == SDB_SQL_ACCESS_DATE)
	{
		SdbSqlParseNode* pParent = pLiteral->Parent();

		SdbSqlParseNode* pNewNode = new SqlInternalNode(pLiteral->TokenValue(), SDB_SQL_STRING);
		pParent->Replace(pNewNode,pLiteral);
		delete pLiteral;
		pLiteral = NULL;
		return 1;
	}

	for(sal_uInt32 i=0;i<pLiteral->Count();++i)
	{
		SdbSqlParseNode* pChild = pLiteral->GetChild(i);
		BuildStringNodes(pChild);
	}
	if(SDB_ISRULE(pLiteral,term) || SDB_ISRULE(pLiteral,value_exp_primary))
	{
		m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_CRIT_NO_COMPARE, m_eLanguage);
		return 0;
	}
	return 1;
}
//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildComparsionRule(SdbSqlParseNode*& pAppend,SdbSqlParseNode* pLiteral)
{
	SdbSqlParseNode* pComp = new SqlInternalNode(String('='), SDB_SQL_EQUAL);
	return BuildComparsionRule(pAppend,pLiteral,pComp);
}

//-----------------------------------------------------------------------------
sal_Int16 SdbSqlParser::BuildComparsionRule(SdbSqlParseNode*& pAppend,SdbSqlParseNode* pLiteral,SdbSqlParseNode*& pCompare)
{
	sal_Int16 nErg = 0;
	if (m_xField.is())
	{
		sal_Int32 nType = 0;
		try
		{
			::com::sun::star::uno::Any aValue;
			{
				aValue = m_xField->getPropertyValue(rtl::OUString::createFromAscii("Type"));
				if (aValue.getValueType().getTypeClass() == ::com::sun::star::uno::TypeClass_LONG)
					aValue >>= nType;
				else
				{
					// for old api
					sal_Int16 nVal;
					aValue >>= nVal;
					nType = nVal;
				}
			}
		}
		catch ( ... )
		{
			return nErg;
		}

		if (pLiteral->IsRule() && pLiteral->GetRuleID() != StrToRuleID("value_exp"))
		{
			switch(nType)
			{
				case ::com::sun::star::data::DatabaseFieldType::CHAR:
				case ::com::sun::star::data::DatabaseFieldType::VARCHAR:
				case ::com::sun::star::data::DatabaseFieldType::LONGVARCHAR:
					if(!SDB_ISRULE(pLiteral,char_value_exp) && !BuildStringNodes(pLiteral))
						break;
				default:
					nErg = BuildNode(pAppend,pLiteral,pCompare);
			}
		}
		else
		{
			switch(pLiteral->GetNodeType())
			{
				case SDB_SQL_STRING:
					switch(nType)
					{
						case ::com::sun::star::data::DatabaseFieldType::CHAR:
						case ::com::sun::star::data::DatabaseFieldType::VARCHAR:
						case ::com::sun::star::data::DatabaseFieldType::LONGVARCHAR:
							nErg = BuildNode(pAppend,pLiteral,pCompare);
							break;
						case ::com::sun::star::data::DatabaseFieldType::DATE:
						case ::com::sun::star::data::DatabaseFieldType::TIME:
						case ::com::sun::star::data::DatabaseFieldType::DATETIME:
							if (m_xFormatter.is())
							{
								try
								{
									// do we have a date
									double fValue = m_xFormatter->convertStringToNumber(m_nFormatKey, pLiteral->TokenValue().GetBuffer());
									nErg = BuildNode_Date(fValue, nType, pAppend,pLiteral,pCompare);
								}
								catch ( ... )
								{
									try
									{
										::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xFormatSup = m_xFormatter->getNumberFormatsSupplier();
										::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatTypes >  xFormatTypes(xFormatSup->getNumberFormats(),::com::sun::star::uno::UNO_QUERY);
										if (xFormatTypes.is())
										{
											String sLanguage, sCountry;
											ConvertLanguageToIsoNames(m_eLanguage, sLanguage, sCountry);
											::com::sun::star::lang::Locale aLocale(sLanguage.GetBuffer(),
																				   sCountry.GetBuffer(),
																				   rtl::OUString());

											double fValue = m_xFormatter->convertStringToNumber(
												xFormatTypes->getStandardFormat(NUMBERFORMAT_DATE, aLocale),
																				pLiteral->TokenValue().GetBuffer());
											nErg = BuildNode_Date(fValue, nType, pAppend,pLiteral,pCompare);
										}
										else
										{
											nErg = -1;
											m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_NO_NUM, m_eLanguage);
										}

									}
									catch ( ... )
									{
										nErg = -1;
										m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_NO_NUM, m_eLanguage);
									}
								}
							}
							else
								nErg = BuildNode(pAppend,pLiteral,pCompare);

							break;
						default:
							m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_NO_NUM, m_eLanguage);
					}
					break;
				case SDB_SQL_ACCESS_DATE:
					switch(nType)
					{
						case ::com::sun::star::data::DatabaseFieldType::DATE:
						case ::com::sun::star::data::DatabaseFieldType::TIME:
						case ::com::sun::star::data::DatabaseFieldType::DATETIME:
							if (m_xFormatter.is())
							{
								try
								{
									// do we have a date
									double fValue = m_xFormatter->convertStringToNumber(m_nFormatKey, pLiteral->TokenValue().GetBuffer());
									nErg = BuildNode_Date(fValue, nType, pAppend,pLiteral,pCompare);
								}
								catch ( ... )
								{
									try
									{
										::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xFormatSup = m_xFormatter->getNumberFormatsSupplier();
										::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatTypes >  xFormatTypes(xFormatSup->getNumberFormats(),::com::sun::star::uno::UNO_QUERY);
										if (xFormatTypes.is())
										{
											String sLanguage, sCountry;
											ConvertLanguageToIsoNames(m_eLanguage, sLanguage, sCountry);
											::com::sun::star::lang::Locale aLocale(sLanguage.GetBuffer(),
																				   sCountry.GetBuffer(),
																				   rtl::OUString());

											double fValue = m_xFormatter->convertStringToNumber(
												xFormatTypes->getStandardFormat(NUMBERFORMAT_DATE, aLocale),
																pLiteral->TokenValue().GetBuffer());
											nErg = BuildNode_Date(fValue, nType, pAppend,pLiteral,pCompare);
										}
										else
										{
											nErg = -1;
											m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ACCESS_DAT_NO_VALID, m_eLanguage);
										}

									}
									catch ( ... )
									{
										nErg = -1;
										m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ACCESS_DAT_NO_VALID, m_eLanguage);
									}
								}
							}
							else
							{
								nErg = -1;
								m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ACCESS_DAT_NO_VALID, m_eLanguage);
							}
							break;
						default:
							m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ACCESS_DAT_NO_VALID, m_eLanguage);
					}
					break;
				case SDB_SQL_INTNUM:
					switch(nType)
					{
						case ::com::sun::star::data::DatabaseFieldType::BOOL:
						case ::com::sun::star::data::DatabaseFieldType::DECIMAL:
						case ::com::sun::star::data::DatabaseFieldType::NUMERIC:
						case ::com::sun::star::data::DatabaseFieldType::TINYINT:
						case ::com::sun::star::data::DatabaseFieldType::SMALLINT:
						case ::com::sun::star::data::DatabaseFieldType::INTEGER:
						case ::com::sun::star::data::DatabaseFieldType::BIGINT:
						case ::com::sun::star::data::DatabaseFieldType::REAL:
						case ::com::sun::star::data::DatabaseFieldType::DOUBLE:
						case ::com::sun::star::data::DatabaseFieldType::CURRENCY:
							// kill thousand seperators if any
							if (m_pIntl->GetNumDecimalSep() == ',' )
							{
								pLiteral->m_aNodeValue.SearchAndReplaceAll('.', String());
								// and replace decimal
								pLiteral->m_aNodeValue.SearchAndReplaceAll(',', '.');
							}
							else
								pLiteral->m_aNodeValue.SearchAndReplaceAll(',', String());
							nErg = BuildNode(pAppend,pLiteral,pCompare);
							break;
						case ::com::sun::star::data::DatabaseFieldType::CHAR:
						case ::com::sun::star::data::DatabaseFieldType::VARCHAR:
						case ::com::sun::star::data::DatabaseFieldType::LONGVARCHAR:
							nErg = BuildNode_STR_NUM(pAppend,pLiteral,pCompare);
							break;
						default:
							m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_INT_NO_VALID, m_eLanguage);
					}
					break;
				case SDB_SQL_APPROXNUM:
					switch(nType)
					{
						case ::com::sun::star::data::DatabaseFieldType::DECIMAL:
						case ::com::sun::star::data::DatabaseFieldType::NUMERIC:
						case ::com::sun::star::data::DatabaseFieldType::REAL:
						case ::com::sun::star::data::DatabaseFieldType::DOUBLE:
						case ::com::sun::star::data::DatabaseFieldType::CURRENCY:
							if (InPredicateCheck())
							{
								// kill thousand seperators if any
								if (m_pIntl->GetNumDecimalSep() == ',' )
								{
									pLiteral->m_aNodeValue.SearchAndReplaceAll('.', String());
									// and replace decimal
									pLiteral->m_aNodeValue.SearchAndReplaceAll(',', '.');
								}
								else
									pLiteral->m_aNodeValue.SearchAndReplaceAll(',', String());
							}
							nErg = BuildNode(pAppend,pLiteral,pCompare);
							break;
						case ::com::sun::star::data::DatabaseFieldType::CHAR:
						case ::com::sun::star::data::DatabaseFieldType::VARCHAR:
						case ::com::sun::star::data::DatabaseFieldType::LONGVARCHAR:
							nErg = BuildNode_STR_NUM(pAppend,pLiteral,pCompare);
							break;
						case ::com::sun::star::data::DatabaseFieldType::INTEGER:
						default:
							m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_REAL_NO_INT, m_eLanguage);
					}
					break;
			}
		}
		if (!nErg)
			--nErg;
	}
	if (!pCompare->Parent()) // I have no parent so I was not used and I must die :-)
		delete pCompare;
	return nErg;
}

//-----------------------------------------------------------------------------
void SdbSqlParser::ReduceLiteral(SdbSqlParseNode*& pLiteral, sal_Bool bAppendBlank)
{
	DBG_ASSERT(pLiteral->IsRule(), "This is no ::com::sun::star::chaos::Rule");
	DBG_ASSERT(pLiteral->Count() == 2, "SdbSqlParser::ReduceLiteral() Invalid count");
	SdbSqlParseNode* pTemp = pLiteral;
	String aValue;
	if (bAppendBlank)
	{
		((aValue = pLiteral->GetChild(0)->TokenValue()) += String(' ')) +=
					pLiteral->GetChild(1)->TokenValue();
	}
	else
		(aValue = pLiteral->GetChild(0)->TokenValue()) +=
					pLiteral->GetChild(1)->TokenValue();

	pLiteral = new SqlInternalNode(aValue,SDB_SQL_STRING);
	delete pTemp;
}

String SdbSqlParser::GetInternationalKeywordString(sal_uInt32 nTokenID)
{
	return SdbSqlScanner::GetInternationalKeywordString(nTokenID);
}

void SdbSqlParser::error(char *fmt)
{
	m_aErrorMessage = SvtSimpleResId(STR_SVT_SQL_SYNTAX_ERROR, m_eLanguage);
	m_aErrorMessage.AppendAscii(": ");
	m_aErrorMessage += String(SvtSimpleResId(STR_SVT_SQL_SYNTAX_ERROR_BEFORE, m_eLanguage));
	m_aErrorMessage.SearchAndReplaceAscii("#",String::CreateFromAscii(fmt));	
}
int SdbSqlParser::SQLlex()
{
	return m_pScanner->SQLlex();
}
/*--------------------------------------------------------------------------*

Aenderungshistorie:
	$Log: sdbyacc.y,v $
	Revision 1.18  2000/07/27 08:11:08  obo
	#65293# OJ
	
	Revision 1.17  2000/07/25 10:07:58  oj
	use of bison and flex

	Revision 1.16  2000/04/05 09:27:08  oj
	unistring

	Revision 1.15  2000/01/12 10:41:53  oj
	#71765# lex modi for string

	Revision 1.14  1999/12/09 09:13:09  oj
	#70647# error in grammar

	Revision 1.13  1999/12/06 13:56:46  oj
	#70332# some rule are not used

	Revision 1.12  1999/11/17 14:02:36  oj
	#68403# some changes in grammar and new behaviar with string in predicate check

	Revision 1.11  1999/11/01 16:10:45  oj
	some changes

	Revision 1.10  1999/11/01 12:09:02  oj
	escape for like

	Revision 1.9  1999/11/01 07:04:09  oj
	odbc_parameter can be empty

	Revision 1.8  1999/10/29 15:07:17  oj
	some changes on sql syntax

	Revision 1.7  1999/09/30 14:47:45  oj
	#68524# new rule union

	Revision 1.6  1999/09/13 08:25:09  dg
	#68506# Replace of placeholders for like

	Revision 1.5  1999/09/06 08:43:44  dg
	DateTime Handling

	Revision 1.4  1999/09/01 16:44:05  dg
	Enhancements for predicate checking

	Revision 1.3  1999/08/30 08:11:45  dg
	#new improvements in the context of PredicateChecking

	Revision 1.2  1999/08/25 10:21:54  dg
	Errors of changing the container implementation fixed

	Revision 1.1  1999/08/20 14:54:03  dg
	SQLParser moved from SDB to svtools



 *--------------------------------------------------------------------------*/

