/*************************************************************************
 *
 *  $RCSfile: unoifac2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
#include <com/sun/star/frame/XStorable.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XCONNECTABLE_HPP_
#include <com/sun/star/io/XConnectable.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XDATAOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XDataOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATACONTROL_HPP_
#include <com/sun/star/io/XActiveDataControl.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XDATAINPUTSTREAM_HPP_
#include <com/sun/star/io/XDataInputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XMARKABLESTREAM_HPP_
#include <com/sun/star/io/XMarkableStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XINPUTSTREAM_HPP_
#include <com/sun/star/io/XInputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XSTREAMLISTENER_HPP_
#include <com/sun/star/io/XStreamListener.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#include <unoifac2.hxx>

#include <ctype.h>

#include <vcl/cursor.hxx>

#include <svtdata.hxx>

#ifndef _INETHIST_HXX
#include <inethist.hxx>
#endif
#ifndef _TEXTVIEW_HXX
#include <textview.hxx>
#endif
#ifndef _TEXTENG_HXX
#include <texteng.hxx>
#endif
#ifndef _TXTATTR_HXX
#include <txtattr.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _CACHESTR_HXX //autogen
#include <tools/cachestr.hxx>
#endif
#ifndef _SV_SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif
#ifndef _SV_COLOR_HXX
#include <vcl/color.hxx>
#endif
#ifndef _SV_CLIP_HXX //autogen
#include <vcl/clip.hxx>
#endif

#ifndef _SVT_UNO_UNOIFAC_HRC_
#include "unoifac2.hrc"
#endif

#include <vos/mutex.hxx>

#include <unotools/types.hxx>
#include <com/sun/star/uno/Reference.hxx>

#include <unotools/processfactory.hxx>


//	----------------------------------------------------
// Der ausdefinierte Teil wurde von SBI implementiert bevor wir dazu wechseln
// mussten den Text in 64kB Haeppchen immer hinten dran zu haengen.
// Falls sich hier mal das Interface aendern sollte kann der Code evtl wieder
// verwendet werden.
//	----------------------------------------------------

//	----------------------------------------------------
//	class SvtDataSink_Impl
//	----------------------------------------------------
// DataSink - implementation.
// -----------------------------------------------------

//  DataSink - Interface
class SvtDataSink_Impl :	public ::com::sun::star::io::XOutputStream,
							public ::cppu::OWeakObject
{
	::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource > xSource;
	::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > xRange;
public:
					SvtDataSink_Impl ( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & rRef );
	virtual 		~SvtDataSink_Impl (void);

	void			SetSource( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource > & rSource );

	// ::com::sun::star::uno::XInterface
    ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::release(); }

	// ::com::sun::star::io::XOutputStream
    virtual void SAL_CALL writeBytes( const ::com::sun::star::uno::Sequence< sal_Int8 >& aData ) throw(::com::sun::star::io::NotConnectedException, ::com::sun::star::io::BufferSizeExceededException, ::com::sun::star::io::IOException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL flush(  ) throw(::com::sun::star::io::NotConnectedException, ::com::sun::star::io::BufferSizeExceededException, ::com::sun::star::io::IOException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL closeOutput(  ) throw(::com::sun::star::io::NotConnectedException, ::com::sun::star::io::BufferSizeExceededException, ::com::sun::star::io::IOException, ::com::sun::star::uno::RuntimeException);
};

SvtDataSink_Impl::SvtDataSink_Impl ( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & rRef )
{
	xRange = rRef;
	xRange->setString(::rtl::OUString());
}

void SvtDataSink_Impl::SetSource ( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource > & rSource )
{
	xSource = rSource;

	::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataControl >  xControl(xSource, ::com::sun::star::uno::UNO_QUERY);
	if (xControl.is()) {
		xSource->setOutputStream( this );
		xControl->start();
	}
}

SvtDataSink_Impl::~SvtDataSink_Impl()
{
}

::com::sun::star::uno::Any SvtDataSink_Impl::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::io::XOutputStream*, this ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

void SvtDataSink_Impl::writeBytes (const ::com::sun::star::uno::Sequence<sal_Int8> &rBuffer) throw(::com::sun::star::io::NotConnectedException, ::com::sun::star::io::BufferSizeExceededException, ::com::sun::star::io::IOException, ::com::sun::star::uno::RuntimeException)
{
	if ( rBuffer.getLength() && xRange.is() )
	{
		// Dokument fuellen
		::com::sun::star::uno::Reference< ::com::sun::star::text::XText >  xText = xRange->getText();

		sal_uInt32 nLen = (sal_uInt32) rBuffer.getLength();
		sal_uInt32 nSlices = nLen / (sal_uInt32) USHRT_MAX;
		sal_uInt32 n = nLen % (sal_uInt32) USHRT_MAX;
		const char* pBuffer = ( const char*) rBuffer.getConstArray();

		for ( sal_uInt32 nSlice=0; nSlice<=nSlices; nSlice++ )
		{
			sal_uInt16 nBufLen = ( nSlice == nSlices ) ? (sal_uInt16) nLen : USHRT_MAX;
			if ( !nBufLen )
				break;

			sal_uInt16 nn = nSlice*USHRT_MAX;
			XubString aTextSlice ( &pBuffer[nn], nBufLen );
			::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  xEnd = xRange->getEnd();

			// hier mu das CHARSET passend zum CHARSET der mail gewaehlt werden
			// (sonst gehen z.B. Umlaute unter OS/2 verloren).
			xText->insertString(xEnd, aTextSlice, sal_True);
		}
	}
}

void SvtDataSink_Impl::flush (void) throw(::com::sun::star::io::NotConnectedException, ::com::sun::star::io::BufferSizeExceededException, ::com::sun::star::io::IOException, ::com::sun::star::uno::RuntimeException)
{
	if ( xRange.is() )
	{
		// An den Anfang
		::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  xStart = xRange->getStart();
		::com::sun::star::uno::Reference< ::com::sun::star::text::XText >  xText = xRange->getText();
		::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor >  xCursor = xText->createTextCursorByRange ( xStart );
		if ( xCursor.is() )
		{
			xCursor->collapseToStart();
			xCursor->gotoStart( sal_False );
		}
	}
}

void SvtDataSink_Impl::closeOutput() throw(::com::sun::star::io::NotConnectedException, ::com::sun::star::io::BufferSizeExceededException, ::com::sun::star::io::IOException, ::com::sun::star::uno::RuntimeException)
{
	xSource = ::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource > ();
	xRange = ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > ();
}

//	----------------------------------------------------
//	class SvtECParent
//  Dient dazu um bei Terminierung des Objekts in allen noch vorhandenen
//  fremden Objekten die Verweise auf es haben (den 'SvtECChild's diese Objekts)
//  diese Verweise zu loeschen, damit sie nicht auf ungueltigen Speicher zeigen.
//  (Die 'SvtECChild' Objekte koennen das 'SvtECParent' Objekt ueberdauern!)
//	----------------------------------------------------

SvtECParent::SvtECParent()
{
	mpChilds = NULL;
}


SvtECParent::~SvtECParent()
{
	if (mpChilds)
	{
		// loeschen der Verweise auf dieses Objekt
		for (sal_uInt16 i = mpChilds->Count(); i--; )
		{
			DBG_ASSERT(mpChilds->GetObject(i)->GetParent() == this,
				"falscher Parent geloescht");
			mpChilds->GetObject(i)->ClearParent();
		}

		delete mpChilds;
	}
}


void SvtECParent::AddChild( SvtECChild *pChild )
{
	// mehrfaches einfuegen erlaubt um das durchsuchen zu sparen
	if (!mpChilds)
		mpChilds = new ChildArray;
	mpChilds->C40_INSERT(SvtECChild, pChild, mpChilds->Count());

}


void SvtECParent::RemoveChild( SvtECChild *pChild )
{
	if (mpChilds)
	{
		// loeschen eines Vorkommens (entsprechend zu AddChild)
		sal_uInt16 i;
		for ( i = mpChilds->Count();  i--; )
			if (mpChilds->GetObject(i) == pChild)
				break;
		mpChilds->Remove(i);
	}
}


//	----------------------------------------------------
//	class SvtECChild
//  Dies sind die Objekte, die einen Verweis auf einen 'SvtECParent' haben.
//  Solange sie existieren und den Verweis auf ihn behalten sind sie beim Parent
//  "registriert", damit dieser bei seinem Ableben die Verweise auf sich loeschen
//  kann.
//	----------------------------------------------------
SvtECChild::SvtECChild( SvtECParentType *pParent )
{
	if ((mpParent = pParent))
		mpParent->AddChild(this);
}


SvtECChild::SvtECChild( const SvtECChild &rChild )
{
	if ((mpParent = rChild.mpParent))
		mpParent->AddChild(this);
}


SvtECChild::~SvtECChild()
{
	if (mpParent)
		mpParent->RemoveChild(this);
}


void SvtECChild::SetParent( SvtECParentType *pParent )
{
	if (pParent != mpParent)
	{
		if (mpParent)
			mpParent->RemoveChild(this);
		if ((mpParent = pParent))
			mpParent->AddChild(this);
	}
}


SvtECChild & SvtECChild::operator = ( const SvtECChild &rChild )
{
	SetParent( rChild.GetParent() );
	return *this;
}


//	----------------------------------------------------
//	class SvtXECTextCursor
//  Diese Klasse vereint die verschiedenen benoetigten Uno Cursor-Interfaces
//  in einer einzigen Klasse.
//	----------------------------------------------------
SvtXECTextCursor::SvtXECTextCursor( SvtXEditorControl* pEC )
:	SvtXECTextRange( pEC )
{
}


SvtXECTextCursor::SvtXECTextCursor( SvtXEditorControl* pEC, const TextSelection& rSelection )
:	SvtXECTextRange( pEC, rSelection )
{
// MT: Wozu an der ::com::sun::star::sdbcx::View?!
//	if (pEC)
//		pEC->GetECWindow()->GetTextView()->SetSelection( GetSelection() );
}


SvtXECTextCursor::SvtXECTextCursor( SvtXEditorControl* pEC, const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & xRange ) /* throw( ::com::sun::star::uno::RuntimeException )*/
:	SvtXECTextRange( pEC )
{
	SvtXECTextRange *pTextRange = GetRangeFrom( xRange );
	if (pTextRange)
		SetSelection( pTextRange->GetSelection() );

//	if (pEC)
//		pEC->GetECWindow()->GetTextView()->SetSelection( GetSelection() );
}


SvtXECTextCursor::~SvtXECTextCursor()
{
}

::com::sun::star::uno::Any SvtXECTextCursor::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::text::XTextCursor*, this ),
										SAL_STATIC_CAST( ::com::sun::star::text::XTextViewCursor*, this ),
										SAL_STATIC_CAST( ::com::sun::star::view::XScreenCursor*, this ),
										SAL_STATIC_CAST( ::com::sun::star::lang::XTypeProvider*, this ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

// ::com::sun::star::lang::XUnoTunnel
IMPL_XUNOTUNNEL( SvtXECTextCursor )

IMPL_XTYPEPROVIDER_START( SvtXECTextCursor )
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextViewCursor>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::view::XScreenCursor>* ) NULL )
IMPL_XTYPEPROVIDER_END


SvtXECTextRange * SvtXECTextCursor::GetRangeFrom( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  xRange ) const
	// gibt (sofern moeglich) die zu einer beliebigen '::com::sun::star::text::XTextRange' urspruengliche
	// 'SvtXECTextRange' zurueck, ansonsten NULL.
{
	SvtXECTextRange* pTextRange = SvtXECTextRange::GetImplementation( xRange );
	if ( pTextRange  &&  pTextRange->GetParent() == GetParent() )
		return pTextRange;
	else
		return NULL;
}


sal_Bool SvtXECTextCursor::Move( TextPaM& rPaM, sal_uInt16 nCount, sal_Bool bLeft ) throw( ::com::sun::star::uno::RuntimeException )
	// setzt die Position 'rPam' um 'nCount' Zeichen in die durch 'bLeft'
	// angegebene Richtung (dabei werden ggf Paragraphen gewechselt).
	// Falls die resultierende Position vor/nach dem Anfang/Ende liegt wird
	// sal_False zurueckgegeben und die Position auf den/das Anfang/Ende gesetzt.
	// Ansonsten wird die Position wie gewuenscht veraendert und sal_True zurueck-
	// gegeben.
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextPaM	 aOldPaM;
	while (nCount)
	{
		aOldPaM = rPaM;
		rPaM    = bLeft ? pView->CursorLeft(rPaM) : pView->CursorRight(rPaM);
		nCount--;
		if (rPaM == aOldPaM)
			return sal_False;
	}

	return sal_True;
}


void SvtXECTextCursor::collapseToStart() throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextSelection  aSelection (GetSelection());
	aSelection.GetEnd() = aSelection.GetStart();
}


void SvtXECTextCursor::collapseToEnd() throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextSelection  aSelection (GetSelection());
	aSelection.GetStart() = aSelection.GetEnd();
}


sal_Bool SvtXECTextCursor::isCollapsed() throw( ::com::sun::star::uno::RuntimeException )
{
	const TextSelection  &rSel = GetSelection();
	return rSel.GetStart() == rSel.GetEnd();
}


sal_Bool SvtXECTextCursor::goLeft( sal_Int16 nCount, sal_Bool bExpand ) throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextSelection  aSelection (GetSelection());
	sal_Bool  bSuccess = Move( aSelection.GetEnd(), nCount, sal_True );
	if ( !bExpand )
		aSelection.GetStart() = aSelection.GetEnd();

	return bSuccess;
}

sal_Bool SvtXECTextCursor::goRight( sal_Int16 nCount, sal_Bool bExpand ) throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextSelection  aSelection (GetSelection());
	sal_Bool bSuccess = Move( aSelection.GetEnd(), nCount, sal_False );
	if ( !bExpand )
		aSelection.GetStart() = aSelection.GetEnd();

	return bSuccess;
}


void SvtXECTextCursor::gotoStart( sal_Bool bExpand ) throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextSelection  aSelection (GetSelection());
	TextPaM  	   aStartPaM  (pView->CursorStartOfDoc());
	aSelection.GetEnd()   = bExpand ? aSelection.GetStart() : aStartPaM;
	aSelection.GetStart() = aStartPaM;
}


void SvtXECTextCursor::gotoEnd( sal_Bool bExpand ) throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	TextSelection  aSelection (GetSelection());
	TextPaM  	   aEndPaM    (pView->CursorEndOfDoc());
	aSelection.GetEnd()   = bExpand ? aSelection.GetStart() : aEndPaM;
	aSelection.GetStart() = aEndPaM;

//	pView->SetSelection( aSelection );
}


void SvtXECTextCursor::gotoRange( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & xRange, sal_Bool bExpand ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXECTextRange *pTextRange = GetRangeFrom( xRange );

	if ( !GetParent()  ||  !pTextRange)
		throw ::com::sun::star::uno::RuntimeException();

	TextSelection  aSelection (pTextRange->GetSelection());
	if (bExpand)
	{
		TextSelection  aSel (GetSelection());

		aSel.Justify();
		aSelection.Justify();
		if (aSel.GetStart() < aSelection.GetStart())
			aSelection.GetStart() = aSel.GetStart();
		if (aSel.GetEnd() > aSelection.GetEnd())
			aSelection.GetEnd() = aSel.GetEnd();
	}

	SetSelection( aSelection );

	TextView 	  *pView = GetParent()->GetECWindow()->GetTextView();
//	pView->SetSelection( aSelection );
}


sal_Bool SvtXECTextCursor::isVisible() throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	Cursor *pCursor = GetParent()->GetECWindow()->GetCursor();
	return pCursor ? pCursor->IsVisible() : sal_False;
}


void SvtXECTextCursor::setVisible( sal_Bool bVisible ) throw( ::com::sun::star::uno::RuntimeException )
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	TextView *pView = GetParent()->GetECWindow()->GetTextView();

	if (bVisible)
		pView->ShowCursor();
	else
		pView->HideCursor();
}


::com::sun::star::awt::Point SvtXECTextCursor::getPosition() throw( ::com::sun::star::uno::RuntimeException )
	// gibt die Cursorposition in 1/100 mm relativ zum Beginn des Dokuments
	// zurueck.
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	Point  aPos;

	SvtECWindow *pWin       = (SvtECWindow *) GetParent()->GetECWindow();
	TextView     *pView      = pWin->GetTextView();
	Point		  aCursorPos = pWin->GetPointerPosPixel();

	// Cursorposition in Pixeln relativ zum Beginn des Dokuments holen
	Point aPixelPos (pView->GetDocPos(aCursorPos));
	// und in 1/100 mm umrechnen
	aPos = pWin->PixelToLogic(aPixelPos, MapMode(MAP_100TH_MM));

	return ::com::sun::star::awt::Point( aPos.X(), aPos.Y() );
}

sal_Bool SvtXECTextCursor::screenDown(  ) throw(::com::sun::star::uno::RuntimeException)
{
	return ScreenUpDown(sal_False);
}

sal_Bool SvtXECTextCursor::screenUp(  ) throw(::com::sun::star::uno::RuntimeException)
{
	return ScreenUpDown(sal_True);

}

sal_Bool SvtXECTextCursor::ScreenUpDown(sal_Bool bScreenUp)
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	ScrollBar  *pScrollBar = GetParent()->GetECWindow()->GetVScrollBar();
	ScrollType  eType      = bScreenUp ? SCROLL_PAGEUP : SCROLL_PAGEDOWN;
	return pScrollBar->DoScrollAction(eType) != 0;
}


//	----------------------------------------------------
//	class SvtXECSearchDescriptor
//  In einem Objekt dieser Klasse werden alle moeglichen Parameter fuer eine
//  Suche eingestellt.
//	----------------------------------------------------

//! Die Map muss (nach den Strings) alphabetisch aufsteigend sortiert, und mit
//  den 0 Eintraegen terminiert sein!!
SfxItemPropertyMap* ImplGetSearchProperties( /* sal_uInt16& rElementCount */ )
{
	static SfxItemPropertyMap* pProperties = NULL;
	static sal_uInt16 nElements = 0;
	if( !pProperties )
	{
		::osl::Guard< ::osl::Mutex > aGuard( ::osl::Mutex::getGlobalMutex() );
		if( !pProperties )
		{
			static SfxItemPropertyMap __FAR_DATA aPropTable[] =
			{
				{ UPN_SEARCH_BACKWARDS,           strlen(UPN_SEARCH_BACKWARDS),			WID_BACKWARDS, 			&::getBooleanCppuType(),		PROPERTY_NONE, 0},
				{ UPN_SEARCH_CASE_SENSITIVE,      strlen(UPN_SEARCH_CASE_SENSITIVE),	WID_CASE_SENSITIVE, 	&::getBooleanCppuType(),		PROPERTY_NONE, 0},
				{ UPN_SEARCH_IN_SELECTION,        strlen(UPN_SEARCH_IN_SELECTION),		WID_IN_SELECTION, 		&::getBooleanCppuType(), 		PROPERTY_NONE, 0},
				{ UPN_SEARCH_REGULAR_EXPRESSION,  strlen(UPN_SEARCH_REGULAR_EXPRESSION),WID_REGULAR_EXPRESSION, &::getBooleanCppuType(), 		PROPERTY_NONE, 0},
				{ UPN_SEARCH_SIMILARITY,          strlen(UPN_SEARCH_SIMILARITY),		WID_SIMILARITY, 		&::getBooleanCppuType(), 		PROPERTY_NONE, 0},
				{ UPN_SEARCH_SIMILARITY_ADD,      strlen(UPN_SEARCH_SIMILARITY_ADD),	WID_SIMILARITY_ADD, 	&::getCppuType((const sal_Int16*)0), 	PROPERTY_NONE, 0},
				{ UPN_SEARCH_SIMILARITY_EXCHANGE, strlen(UPN_SEARCH_SIMILARITY_EXCHANGE),WID_SIMILARITY_EXCHANGE, &::getCppuType((const sal_Int16*)0), 	PROPERTY_NONE, 0},
				{ UPN_SEARCH_SIMILARITY_RELAX,    strlen(UPN_SEARCH_SIMILARITY_RELAX),	WID_SIMILARITY_RELAX, 	&::getBooleanCppuType(), 		PROPERTY_NONE, 0},
				{ UPN_SEARCH_SIMILARITY_REMOVE,   strlen(UPN_SEARCH_SIMILARITY_REMOVE),	WID_SIMILARITY_REMOVE, 	&::getCppuType((const sal_Int16*)0), 	PROPERTY_NONE, 0},
				{ UPN_SEARCH_WORDS,				  strlen(UPN_SEARCH_WORDS),				WID_WORDS, 				&::getBooleanCppuType(), 		PROPERTY_NONE, 0},
				{0,0,0,0, 0}
			};
			pProperties = aPropTable;
			nElements = sizeof( aPropTable ) / sizeof( SfxItemPropertyMap );

		}
	}
//	rElementCount = nElements;
	return pProperties;
}


#if SUPD>525
void SvtXECSearchDescriptor::SetSearchDefaults()
#else
void SvtXECSearchDescriptor::SetDefaultProperties()
#endif
{
	mbBackward = sal_False;

	maParam.SetSrchType( SearchParam::SRCH_NORMAL );
	maParam.SetSrchStr(String());
	maParam.SetReplaceStr(String());
	maParam.SetSrchWordOnly(sal_False);
	maParam.SetCaseSensitive(sal_False);
	maParam.SetSrchRelaxed(sal_False);
	maParam.SetLEVOther(2);
	maParam.SetLEVShorter(2);
	maParam.SetLEVLonger(2);

	sal_Bool  bInSel = sal_False;
	if (GetParent())
	{
		TextView *pView = GetParent()->GetECWindow()->GetTextView();
		if (pView  &&  pView->HasSelection())
			bInSel = sal_True;
	}
	maParam.SetSrchInSelection(bInSel);
}


SvtXECSearchDescriptor::SvtXECSearchDescriptor()
: 	SvtECChild	(NULL),
	maParam		( String(), SearchParam::SRCH_NORMAL)
{
	SetSearchDefaults();
}


SvtXECSearchDescriptor::SvtXECSearchDescriptor( SvtXEditorControl* pEC )
:	SvtECChild  (pEC),
	maParam		( String(), SearchParam::SRCH_NORMAL)
{
	SetSearchDefaults();
}


SvtXECSearchDescriptor::~SvtXECSearchDescriptor()
{
}

::com::sun::star::uno::Any SvtXECSearchDescriptor::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::beans::XPropertySet*, this ),
										SAL_STATIC_CAST( ::com::sun::star::util::XSearchDescriptor*, this ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

// ::com::sun::star::lang::XUnoTunnel
IMPL_XUNOTUNNEL( SvtXECSearchDescriptor )

::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  SvtXECSearchDescriptor::getPropertySetInfo() throw( ::com::sun::star::uno::RuntimeException )
{
	static SfxItemPropertySet  maPropertySet (ImplGetSearchProperties());
	return maPropertySet.getPropertySetInfo();
}


void SvtXECSearchDescriptor::setPropertyValue( const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::beans::PropertyVetoException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException)
{
	NAMESPACE_VOS(OGuard) aGuard( Application::GetSolarMutex()  );

    const SfxItemPropertyMap *pMap = SfxItemPropertyMap::GetByName( ImplGetSearchProperties(), aPropertyName );

	// default Such-Methode falls weder ueber "Regulaere Ausdruecke" noch
	// "hnlichkeit" gesucht wird
	SearchParam::SearchType  eType = SearchParam::SRCH_NORMAL;

	sal_Bool b;
	sal_Int16 n;

	if (pMap)
		switch (pMap->nWID)
		{
			case WID_REGULAR_EXPRESSION :
				if ( aValue >>= b )
					eType = SearchParam::SRCH_REGEXP;
				else if ( maParam.GetSrchType() == SearchParam::SRCH_LEVDIST )
					eType = SearchParam::SRCH_LEVDIST;
				maParam.SetSrchType( eType );
				break;

			case WID_SIMILARITY :
				if ( aValue >>= b )
					eType = SearchParam::SRCH_LEVDIST;
				else if ( maParam.GetSrchType() == SearchParam::SRCH_REGEXP )
					eType = SearchParam::SRCH_REGEXP;
				maParam.SetSrchType( eType );
				break;

			case WID_BACKWARDS :           aValue >>= mbBackward; break;
			case WID_WORDS :			   aValue >>= b; maParam.SetSrchWordOnly( b ); break;
			case WID_CASE_SENSITIVE :      aValue >>= b; maParam.SetCaseSensitive( b ); break;
			case WID_IN_SELECTION :        aValue >>= b; maParam.SetSrchInSelection( b ); break;
			case WID_SIMILARITY_RELAX :    aValue >>= b; maParam.SetSrchRelaxed( b ); break;
			case WID_SIMILARITY_EXCHANGE : aValue >>= n; maParam.SetLEVOther( n ); break;
			case WID_SIMILARITY_ADD :      aValue >>= n; maParam.SetLEVLonger( n ); break;
			case WID_SIMILARITY_REMOVE :   aValue >>= n; maParam.SetLEVShorter( n ); break;
			default : DBG_ASSERT(0, "unbekannte WID");
		}
}


::com::sun::star::uno::Any SvtXECSearchDescriptor::getPropertyValue( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException)
{
	NAMESPACE_VOS(OGuard) aGuard( Application::GetSolarMutex()  );

	::com::sun::star::uno::Any aRes;

    const SfxItemPropertyMap *pMap = SfxItemPropertyMap::GetByName( ImplGetSearchProperties(), PropertyName );

	if (pMap)
		switch (pMap->nWID)
		{
			case WID_BACKWARDS :           aRes <<= mbBackward; break;
			case WID_WORDS :			   aRes <<= (sal_Bool) ( maParam.IsSrchWordOnly() != 0 ); break;
			case WID_REGULAR_EXPRESSION :  aRes <<= (sal_Bool) ( maParam.GetSrchType() == SearchParam::SRCH_REGEXP ); break;
			case WID_CASE_SENSITIVE :      aRes <<= (sal_Bool) ( maParam.IsCaseSensitive() != 0 ); break;
			case WID_IN_SELECTION :        aRes <<= (sal_Bool) ( maParam.IsSrchInSelection() != 0 ); break;
			case WID_SIMILARITY :          aRes <<= (sal_Bool) ( maParam.GetSrchType() == SearchParam::SRCH_LEVDIST ); break;
			case WID_SIMILARITY_RELAX :    aRes <<= (sal_Bool) ( maParam.IsSrchRelaxed() != 0); break;
			case WID_SIMILARITY_EXCHANGE : aRes <<= (sal_Int16) maParam.GetLEVOther(); break;
			case WID_SIMILARITY_ADD :      aRes <<= (sal_Int16) maParam.GetLEVLonger(); break;
			case WID_SIMILARITY_REMOVE :   aRes <<= (sal_Int16) maParam.GetLEVShorter(); break;

			default : DBG_ASSERT(0, "unbekannte WID");
		}

	return aRes;
}


::rtl::OUString SvtXECSearchDescriptor::getSearchString() throw( ::com::sun::star::uno::RuntimeException )
{
	return maParam.GetSrchStr();
}


void SvtXECSearchDescriptor::setSearchString( const ::rtl::OUString& aString ) throw( ::com::sun::star::uno::RuntimeException )
{
	maParam.SetSrchStr( aString );
}


//	----------------------------------------------------
//	class SvtXECTextRange
//  Hier wird sich eine Selektion im Text gemerkt.
//  Es ist moeglich mehrere verschiedene Selektionen gleichzeitig zu haben.
//  Wenn jedoch eine dieser Selektionen geaendert wird (zB geloescht oder durch
//  einen laengeren Text ersetzt) werden die anderen bisher NICHT entsprechend
//  angepasst.
//	----------------------------------------------------
SvtXECTextRange::SvtXECTextRange()
:	SvtECChild(NULL)
{
}


SvtXECTextRange::SvtXECTextRange( SvtXEditorControl* pEC, const TextPaM &aStart, const TextPaM &aEnd )
:	SvtECChild	(pEC),
	maSelection (aStart, aEnd)
{
}


SvtXECTextRange::SvtXECTextRange( SvtXEditorControl* pEC, const TextSelection &aSelection )
:	SvtECChild	(pEC),
	maSelection (aSelection)
{
}


SvtXECTextRange::SvtXECTextRange( SvtXEditorControl* pEC )
:	SvtECChild(pEC)
{
	if (GetParent())
		SetSelection( GetParent()->GetECWindow()->GetTextView()->GetSelection() );
}


SvtXECTextRange::SvtXECTextRange( const SvtXECTextRange &rRange )
:	SvtECChild	(rRange),
	maSelection	(rRange.maSelection)
{
}


SvtXECTextRange::~SvtXECTextRange()
{
}


void SvtXECTextRange::SetSelection( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  &xRange ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXECTextRange *pRange = SvtXECTextRange::GetImplementation( xRange );
	if (!pRange)
		throw ::com::sun::star::uno::RuntimeException();
	SetSelection( pRange->GetSelection() );
}


::com::sun::star::uno::Any SvtXECTextRange::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::text::XTextRange*, this ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

// ::com::sun::star::lang::XUnoTunnel
IMPL_XUNOTUNNEL( SvtXECTextRange )



::com::sun::star::uno::Reference< ::com::sun::star::text::XText >  SvtXECTextRange::getText() throw( ::com::sun::star::uno::RuntimeException )
	// gibt eine '::com::sun::star::uno::Reference< ::com::sun::star::text::XText > ' auf den gesamten Text zurueck
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	::com::sun::star::uno::Reference< ::com::sun::star::text::XText >   xRef( (::cppu::OWeakObject*)GetParent(), ::com::sun::star::uno::UNO_QUERY );
	return xRef;
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  SvtXECTextRange::getStart() throw( ::com::sun::star::uno::RuntimeException )
	// gibt eine '::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > ' auf den Anfang von dieser zurueck
{
	TextPaM  aStart (maSelection.GetStart());
	return new SvtXECTextRange( GetParent(), aStart, aStart );
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  SvtXECTextRange::getEnd() throw( ::com::sun::star::uno::RuntimeException )
	// gibt eine '::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > ' auf das Ende von dieser zurueck
{
	TextPaM  aEnd (maSelection.GetEnd());
	return new SvtXECTextRange( GetParent(), aEnd, aEnd );
}


::rtl::OUString SvtXECTextRange::getString() throw( ::com::sun::star::uno::RuntimeException )
	// gibt einen ::rtl::OUString, der dem von dem Objekt (Selektion) "abgedeckten"
	// Teil des Textes entspricht, zurueck.
{
	if ( !GetParent() )
		throw ::com::sun::star::uno::RuntimeException();

	//! Problem: Die Selektion kann bereits nicht mehr gueltig sein, da inzw.
	//! der Text geaendert (insbes. ganz oder teilweise geloescht) sein koennte
	//! (Dasselbe gilt natuerlich fuer 'getStart' und 'getEnd' auch.)

	//
	// ::rtl::OUString passend (soweit moeglich) zur *gemerkten* Selektion holen
	//
	TextEngine* pEng = GetParent()->GetECWindow()->GetTextEngine();
	::rtl::OUString  aText( pEng->GetText( maSelection, (LineEnd)-1 ) );

	return aText;
}


void SvtXECTextRange::setString( const ::rtl::OUString& aString ) throw( ::com::sun::star::uno::RuntimeException )
	// setzt den von dem Objekt (Selektion) abgedeckten Teil des Textes auf den
	// durch 'aString' gegebenen Wert.
{
	SvtXEditorControl *pEC = GetParent();

	if ( !pEC )
		throw ::com::sun::star::uno::RuntimeException();

	TextView* pView = pEC->GetECWindow()->GetTextView();


	// sal_False als 2-tes Argument, damit es beim schnellen wdh Einfuegen nicht
	// zum flackern kommt.
	// AutoScroll abschalten, damit nicht zu dem eingefuegten Text gescrollt wird.
	sal_Bool bOldAutoScroll = pView->IsAutoScroll();
	pView->SetAutoScroll( sal_False );

	// Text bei *gemerkter* Selektion einfuegen und dann die neue Selektion der
	// ::com::sun::star::sdbcx::View merken
	pView->SetSelection( maSelection );

	// Anfangsparagraphen fuer die Suche nach HyperLinks ermitteln
	TextSelection  aTmpSel (pView->GetSelection());	// MT: ????
	aTmpSel.Justify();
	sal_uInt32  nBeginPara = aTmpSel.GetStart().GetPara();

	pView->InsertText( aString, sal_False );
	maSelection = pView->GetSelection();

	// ggf im neu eingefuegten Text die HyperLinkAttrib's setzen
	SvtECWindow *pWin = pEC->GetECWindow();
	if (pWin->IsMarkHyperLinks())
	{
		DBG_ASSERT(!(maSelection.GetStart() > maSelection.GetEnd()), "falsche Reihenfolge");
		pWin->SetHyperLinkAttribs( nBeginPara, maSelection.GetEnd().GetPara() );
	}

	pView->SetAutoScroll( bOldAutoScroll );

	//! hier mueten ggf noch die anderen SvtXECTextRanges des zugehoerigen
	//! SvtXEditorControl Objekts geupdatet werden, damit sie denselben Text
	//! markieren wie vorher.

	pEC->AutoShowVScrollBar();
	pEC->UpdateThumbPosVScrollBar();
}


//	----------------------------------------------------
//	class SvtXECTRIndexAccess
//  In den Objekten dieser Klasse befinden sich die Ergebnisse (Fundstellen)
//  von Suchen mit 'findAll'.
//  Bei den einzelnen Objekten handelt es sich um '::com::sun::star::text::XTextRange's (genauer gesagt
//  um 'SvtXECTextRange's).
//	----------------------------------------------------
#define INIT_SIZE	16

SvtXECTRIndexAccess::SvtXECTRIndexAccess()
:	SvtECChild(NULL)
{
	mnCount = 0;
	maSelections.realloc(INIT_SIZE);
}


SvtXECTRIndexAccess::SvtXECTRIndexAccess( SvtXEditorControl* pEC )
:	SvtECChild(pEC)
{
	mnCount = 0;
	maSelections.realloc(INIT_SIZE);
}


SvtXECTRIndexAccess::~SvtXECTRIndexAccess()
{
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  SvtXECTRIndexAccess::GetElement(sal_uInt16 nIndex) const
{
	return maSelections.getConstArray()[ nIndex ];
}


void SvtXECTRIndexAccess::InsertElementAtEnd(::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  &xRange)
{
	if (mnCount == maSelections.getLength())
		maSelections.realloc(2 * mnCount);
	maSelections.getArray()[ mnCount ] = xRange;
	mnCount++;
}

::com::sun::star::uno::Any SvtXECTRIndexAccess::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::container::XIndexAccess*, this ),
										SAL_STATIC_CAST( ::com::sun::star::container::XElementAccess*, this ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

::com::sun::star::uno::Type SvtXECTRIndexAccess::getElementType() throw( ::com::sun::star::uno::RuntimeException )
{
	return getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange>* ) NULL );
}


sal_Bool SvtXECTRIndexAccess::hasElements() throw( ::com::sun::star::uno::RuntimeException )
{
	return mnCount != 0;
}


sal_Int32 SvtXECTRIndexAccess::getCount() throw( ::com::sun::star::uno::RuntimeException )
{
	return mnCount;
}


::com::sun::star::uno::Any SvtXECTRIndexAccess::getByIndex( sal_Int32 Index ) throw(::com::sun::star::lang::IndexOutOfBoundsException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > xRange (GetElement(Index));
	::com::sun::star::uno::Any aAny;
	aAny <<= xRange;
	return aAny;
}


//	----------------------------------------------------
//	class SvtECWindow
//  Von "MultiLineEdit" abgeleitete Klasse die es zusaetzlich ermoeglicht
//  nach HyperLinks zu suchen, diese zu markieren (mit 'TextAttribHyperLink')
//  und auf anklicken derselben zu reagieren.
//  Es ist zZ nicht moeglich allein diese Text-Attribute wieder zu entfernen.
//	----------------------------------------------------
SvtECWindow::SvtECWindow( Window* pParent, WinBits nWinStyle )
:	MultiLineEdit( pParent, nWinStyle )
{
	const StyleSettings &rStyle = GetSettings().GetStyleSettings();
	SetControlBackground( rStyle.GetWindowColor() );

	bMarkHyperLinks = sal_False;

	aDispatchTimer.SetTimeoutHdl(LINK(this, SvtECWindow, DispatchTimerHdl));
	aDispatchTimer.SetTimeout(0);
}

SvtECWindow::~SvtECWindow()
{
}

IMPL_LINK( SvtECWindow, DispatchTimerHdl, Timer *, pTimer )
{
	DBG_ASSERT(pTimer == &aDispatchTimer, "falscher Timer");

	xDispatch->dispatch( aURL, aArgs );
	return 0;
}

void SvtECWindow::BuildSequence(::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue> &rArgs,
								sal_uInt16 nType,
								const TextAttribHyperLink *pAttr) const
{
	// bilden der Argument '::com::sun::star::uno::Sequence' die fuer den zu den Eintraegen des
	// Kontextmenues (siehe Resource File) gehoerenden dispatch Aufruf
	// benoetigt wird.

	sal_Int32 nLen = nType == SVTEC_SEQ_DEFAULT ? 1 : 2;
	rArgs.realloc( nLen );

	::com::sun::star::beans::PropertyValue* pArg = rArgs.getArray();

	pArg[0].Name = ::rtl::OUString::createFromAscii( "Referer" );
	pArg[0].Value <<= ((SvtECWindow *) this)->GetController()->getModel()->getURL();

	if (nType == SVTEC_SEQ_DOWNLOAD)
	{
		pArg[1].Name = ::rtl::OUString::createFromAscii( "FilterName" );
		pArg[1].Value <<= ::rtl::OUString::createFromAscii( "Plugin: StarDownload (*.dnl)" );
	}
	else if (nType == SVTEC_SEQ_ADD_BOOKMARK)
	{
		DBG_ASSERT(pAttr, "NULL pointer");
		pArg[1].Name = ::rtl::OUString::createFromAscii( "URL" );
		pArg[1].Value <<= ::rtl::OUString( pAttr->GetURL() );
	}
}

sal_Bool SvtECWindow::LaunchDispatch( const ::com::sun::star::util::URL &rURL, ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue> &rArgs, sal_Bool bOpenNewWin)
{
	sal_Bool  bRes = sal_False;

	// haben wir einen Controller mit Frame (ueber den wir ein Dispatch Objekt
	// holen koennen?)
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  xFrame;
	if (xController.is()  &&  (xFrame = xController->getFrame()).is() )
	{
		// merken der Argumente fuer den 'dispatch' Aufruf
		if (&aURL != &rURL)
			aURL  = rURL;
		if (&aArgs != &rArgs)
			aArgs = rArgs;

		::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xMSF = ::utl::getProcessServiceFactory();
		::com::sun::star::uno::Reference < ::com::sun::star::uno::XInterface > xI = xMSF->createInstance( ::rtl::OUString::createFromAscii( "com.sun.star.util.URLTransformer" ) );
		::com::sun::star::uno::Reference< ::com::sun::star::util::XURLTransformer > xTrans( xI, ::com::sun::star::uno::UNO_QUERY );
		xTrans->parseStrict( aURL );

		::rtl::OUString aText;
		if (bOpenNewWin)
			aText = ::rtl::OUString::createFromAscii( "_blank");
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  xProv( xFrame, ::com::sun::star::uno::UNO_QUERY );
		if ( xProv.is() )
			xDispatch = xProv->queryDispatch( aURL, aText, 0 );
		if (xDispatch.is())
		{
			//! in dem hier noetigen 'dispatch' Aufruf *kann* das Objekt
			//! zerstoert werden, waehrend wir die Routine noch nicht
			//! verlassen haben.
			//! Um dies zu verhindern erfolgt der Aufruf derselben ueber
			//! einen Timer mit TimeOut 0.
			aDispatchTimer.Start();
			bRes = sal_True;
		}
	}

	return bRes;
}

long SvtECWindow::PreNotify( NotifyEvent& rNEvt )
{
	long nDone = 0;

	sal_uInt16 nEvent = rNEvt.GetType();
	if ( nEvent == EVENT_COMMAND )
	{
		const CommandEvent* pCEvt = rNEvt.GetCommandEvent();
		if ( pCEvt && pCEvt->GetCommand() == COMMAND_CONTEXTMENU )
		{
			// Position im Text besorgen
			// und dort nach einem HyperLink Attribut suchen
			TextEngine *pEngine = GetTextEngine();
			TextPaM  aPos (pEngine->GetPaM( GetTextView()->GetDocPos( pCEvt->GetMousePosPixel() ) ));
			const TextAttribHyperLink *pAttr = (TextAttribHyperLink *) pEngine
											->FindAttrib(aPos, TEXTATTR_HYPERLINK);

			if (pAttr)
			{
				// Kontextmenue anzeigen und ::com::sun::star::sdbcx::User Aktion auswerten

				PopupMenu aMenu ( SvtResId(RID_CONTEXTMENU) );
				sal_uInt16 nId = aMenu.Execute( this, pCEvt->GetMousePosPixel() );

				switch (nId)
				{
					case RID_OPEN_LINK :
					case RID_OPEN_LINK_NEW :
						BuildSequence( aArgs, SVTEC_SEQ_DEFAULT, NULL );
						aURL.Complete = pAttr->GetURL();
						LaunchDispatch( aURL, aArgs, nId == RID_OPEN_LINK_NEW );
						break;

					case RID_DOWNLOAD :
						BuildSequence( aArgs, SVTEC_SEQ_DOWNLOAD, NULL );
						aURL.Complete = pAttr->GetURL();
						LaunchDispatch( aURL, aArgs, sal_False );
						break;

					case RID_ADD_BOOKMARK :
						BuildSequence( aArgs, SVTEC_SEQ_ADD_BOOKMARK, pAttr );
						aURL.Complete = ::rtl::OUString::createFromAscii( ".uno:AddBookmark" );
						LaunchDispatch( aURL, aArgs, sal_False );
						break;

					case RID_COPY_LINK :
						Clipboard::Clear();
						Clipboard::CopyString( pAttr->GetURL() );
						break;
				}
			}
			nDone = 1;
		}
	}
	return nDone ? nDone : MultiLineEdit::PreNotify( rNEvt );
}


long SvtECWindow::Notify( NotifyEvent& rNEvt )
{
	long nDone = 0;

	sal_uInt16 nEvent = rNEvt.GetType();

	if ( ( nEvent == EVENT_MOUSEBUTTONUP ) || ( nEvent == EVENT_MOUSEMOVE ) )
	{
		// Position des Mauszeigers im Text besorgen
		// und dort nach einem HyperLink Attribut suchen

		const MouseEvent* pMEvt = rNEvt.GetMouseEvent();

		const TextView* pView = GetTextView();
		TextEngine* pEngine = GetTextEngine();
		TextPaM aPos( pEngine->GetPaM( pView->GetDocPos( GetPointerPosPixel() ) ) );
		const TextAttribHyperLink* pAttr =
			(TextAttribHyperLink *) pEngine->FindAttrib(aPos, TEXTATTR_HYPERLINK);

		if( nEvent == EVENT_MOUSEBUTTONUP )
		{
			// Link oeffnen wenn linker Mausbutton ueber HyperLinkAttrib losgelassen
			// wurde und nicht gerade selektiert wurde (sonst wird beim selektieren
			// immer der Link geoeffnet!).
			if ( pAttr && pMEvt && pMEvt->IsLeft() && !pMEvt->IsMod2() && !pView->HasSelection())
			{
				aURL.Complete = pAttr->GetURL();
				BuildSequence( aArgs, SVTEC_SEQ_DEFAULT, NULL );
				nDone = LaunchDispatch( aURL, aArgs, pMEvt->IsMod1() ) ? 1 : 0;
			}
		}
		else if ( nEvent == EVENT_MOUSEMOVE )
		{
			// den PointerStyle setzen je nachdem ob er ueber einem HyperLink steht
			// oder nicht
			Window  &rWindow = *pView->GetWindow();
			PointerStyle nPtrStyle = ( pAttr && !pMEvt->IsMod2() ) ? POINTER_REFHAND : POINTER_TEXT;
			rWindow.SetPointer( Pointer( nPtrStyle ) );
			nDone = 1;
		}
	}

	return nDone ? nDone : MultiLineEdit::Notify( rNEvt );
}


void SvtECWindow::AutoShowVScrollBar() const
{
	// an- und abschalten der VScrollbar nach Bedarf

	sal_Bool bShow = sal_True;
	TextEngine *pEng = GetTextEngine();
	if (pEng->GetTextHeight() < GetOutputSizePixel().Height())
		bShow = sal_False;

	ScrollBar* pVScrollBar = GetVScrollBar();
	if (pVScrollBar)
		pVScrollBar->Show( bShow );
}


void SvtECWindow::UpdateThumbPosVScrollBar() const
{
	// die ThumbPos der VScrollBar updaten
	// (zur Zeit fehlt eine geeignetere Funktion am MultiLineEdit)

	ScrollBar* pVScrollBar = GetVScrollBar();
	if (pVScrollBar  &&  pVScrollBar->IsVisible())
		((SvtECWindow *) this)->MultiLineEdit::Resize();
}


void SvtECWindow::Resize()
{
	MultiLineEdit::Resize();
	AutoShowVScrollBar();
}


sal_uInt16 SvtECWindow::SetHyperLinkAttribs(sal_uInt32 nBeginPara, sal_uInt32 nEndPara)
	// modifizierte Version von 'DocumentHelper::HasLinks'
	// aus "sfx2/source/chaosdoc/cdochlp.cxx".
{
	sal_uInt16      nAttribs = 0;
	TextEngine *pEngine  = GetTextEngine();

	sal_uInt32  nParaCount = pEngine->GetParagraphCount();
	if ( nParaCount == 0 )
		return nAttribs;

	INetURLHistory* pHistory = INetURLHistory::GetOrCreate();
	INetURLObject   aURL;

	// URLs in den Paragraphen suchen
	if (nEndPara == ULONG_MAX)
		nEndPara = nParaCount - 1;
	for ( sal_uInt32 nPara = nBeginPara;  nPara <= nEndPara;  nPara++ )
	{
		String aText ( pEngine->GetText( nPara ) );
		FASTBOOL bFound = sal_False;
		sal_uInt16 nStart,		// Anfang und
			   nEnd,		// Ende in 'aText'.
			   nOff = 0;	// der Offset im Paragraphen
		const International& rInter = Application::GetAppInternational();

		sal_uInt16 nPos = 0;
		const sal_Unicode* pc = aText.GetBuffer();

		// vorweg alle nicht alpha Zeichen "uberspringen
		while ( *pc && rInter.IsAlpha( *pc ) )
		{
			pc++;
			nPos++;
		}
		nStart = nEnd = nPos;
		FASTBOOL bWWW = sal_False;
		FASTBOOL bMaybeLink = sal_False;

		while ( *pc )
		{
			if ( nPos && ( ' ' == *pc || '\t' == *pc || !*(pc+1) ) )
			{
				// Wort- oder Zeilenende gefunden
				nEnd = nPos;
				FASTBOOL bLineEnd = ( !*(pc+1) && *pc != ' ' && *pc != '\t' );

				if ( bLineEnd )
					nEnd++;

				String aMainURL;
				if ( 3 == bWWW  || bMaybeLink )
					aMainURL = INetURLObject::FindFirstURLInText( aText, nStart, nEnd, rInter );
				bWWW = bMaybeLink = sal_False;
				sal_Bool bLink = ( aMainURL.Len() > 0 );

				if ( bLink &&
					aMainURL.CompareIgnoreCaseToAscii( INET_MAILTO_SCHEME, 7 ) == COMPARE_EQUAL )
				{
					String aTest = aText.Copy( nStart, nEnd - nStart ).ToLowerAscii();

					if ( aTest.SearchAscii( INET_MAILTO_SCHEME ) == STRING_NOTFOUND )
						bLink = sal_False;
				}

				if ( bLink )
				{	// Link (::com::sun::star::util::URL) gefunden

					sal_uInt16  nLen = nEnd - nStart;

					bFound = sal_True;
					nAttribs++;
					nOff += nStart;

					// bilden der ::com::sun::star::util::URL aus dem gefundenen Substring. Wenn kein
					// Protokoll angegeben ist wird von 'SetSmartURL' http als
					// Protokoll gesetzt.
					aURL.SetSmartURL( aText.Copy( nStart, nLen ) );
					DBG_ASSERT( !aURL.HasError(), "keine richtige URL");

					// handelt es sich um eine bereits aufgesuchte ::com::sun::star::util::URL ?
					sal_Bool bVisited = pHistory  &&  pHistory->QueryUrl( aURL );

					// bilden des zu setzenden Textattributs
					TextAttribHyperLink  aAttr ( aURL.GetMainURL() );
					aAttr.SetColor( Color(bVisited ? COL_LIGHTRED : COL_LIGHTBLUE) );

					// setzen des Textattributs
					sal_Bool bWasModified = pEngine->IsModified();
					pEngine->SetAttrib( aAttr, nPara, nOff, nOff + nLen );
					pEngine->SetModified( bWasModified );

					aText = aText.Copy( nEnd );
					nOff += nLen;

					// Werte wieder initialisieren
					pc = aText.GetBuffer();
					nPos = nEnd = 0;
				}
				else
				{
					// Wort war kein Link; Positionen neu setzen
					nStart = nPos + 1;
					nEnd = nStart;
				}
			}
			else if ( 'w' == *pc || 'W' == *pc )
			{
				bWWW++;
			}
			else if ( !bMaybeLink &&
						( ':' == *pc || '@' == *pc ||
						'.' == *pc || '\\' == *pc || '/' == *pc ) )
			{
				if ( '.' != *pc || ' ' != *(pc+1) )
					bMaybeLink = sal_True;

				if ( bWWW < 3 )
					bWWW = sal_False;
			}
			else if ( bWWW < 3 )
				bWWW = sal_False;

			if ( !bFound )
			{
				pc++;
				nPos++;
			}
			else
				bFound = sal_False;
		}
	}

	return nAttribs;
}


void SvtECWindow::SetMarkHyperLinks(sal_Bool bVal)
{
	if (bVal && !bMarkHyperLinks)
		SetHyperLinkAttribs();
	bMarkHyperLinks = bVal;
}


// ----------------------------------------------------------------------------
// XTextHelper
// ----------------------------------------------------------------------------

void XTextHelper::acquire() throw(::com::sun::star::uno::RuntimeException)
{
	mpEC->acquire();
}

void XTextHelper::release() throw(::com::sun::star::uno::RuntimeException)
{
	mpEC->release();
}

::com::sun::star::uno::Reference< ::com::sun::star::text::XText >  XTextHelper::getText() throw( ::com::sun::star::uno::RuntimeException )
{
	return (XTextHelper*) this;
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  XTextHelper::getStart() throw( ::com::sun::star::uno::RuntimeException )
{
	return new SvtXECTextRange( mpEC );
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  XTextHelper::getEnd() throw( ::com::sun::star::uno::RuntimeException )
{
	TextPaM aEndPaM ( mpEC->GetECWindow()->GetTextView()->CursorEndOfDoc() );
	return new SvtXECTextRange( mpEC, aEndPaM , aEndPaM );
}


::rtl::OUString XTextHelper::getString() throw( ::com::sun::star::uno::RuntimeException )
{
	return mpEC->GetECWindow()->GetTextEngine()->GetText();
}


void XTextHelper::setString( const ::rtl::OUString& aString ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtECWindow *pWin = mpEC->GetECWindow();
	pWin->GetTextEngine()->SetText( aString );
	// Window updaten, damit der Text der gleich folgenden insertString()
	// nicht sofort wieder geloescht und neu ausgegeben wird. (Flackern...)
	pWin->GetTextView()->GetWindow()->Update();

	if (pWin->IsMarkHyperLinks())
		pWin->SetHyperLinkAttribs();

	mpEC->AutoShowVScrollBar();
	mpEC->UpdateThumbPosVScrollBar();
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor >  XTextHelper::createTextCursor() throw( ::com::sun::star::uno::RuntimeException )
{
	if (!mpEC->mxCursor.is())
		mpEC->mxCursor = (::cppu::OWeakObject*) new SvtXECTextCursor( mpEC );

	::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor >   xRef( mpEC->mxCursor, ::com::sun::star::uno::UNO_QUERY );
	DBG_ASSERT(xRef.is(), "NULL pointer")
	return xRef;
}


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor >  XTextHelper::createTextCursorByRange( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & xTextPosition ) throw( ::com::sun::star::uno::RuntimeException )
{
	sal_Bool bSelect = sal_False;
	if (!mpEC->mxCursor.is())
		mpEC->mxCursor = (cppu::OWeakObject*) new SvtXECTextCursor( mpEC, xTextPosition );
	else
		bSelect = sal_True;

	if (bSelect)
	{
		SvtXECTextCursor *pCursor = SvtXECTextCursor::GetImplementation( mpEC->mxCursor );
		pCursor->SetSelection( xTextPosition );
	}

	::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor >  xRef( mpEC->mxCursor, ::com::sun::star::uno::UNO_QUERY );
	return xRef;
}


void XTextHelper::insertString( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & xRange, const ::rtl::OUString& aString, sal_Bool bAbsorb ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXECTextRange* pTextRange = SvtXECTextRange::GetImplementation( xRange );
	// testen ob 'xRange' vom richtigen Typ ist (SvtXECTextRange) und
	// das gleiche 'XTextHelper' hat.
	if ( !pTextRange  ||  pTextRange->GetParent() != this )
		throw ::com::sun::star::uno::RuntimeException();

	pTextRange->setString( aString );
	if ( bAbsorb )
	{
		TextSelection rSelection = pTextRange->GetSelection();
		rSelection.GetStart() = rSelection.GetEnd();
	}
}


void XTextHelper::insertControlCharacter( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & xRange, sal_Int16 nControlCharacter, sal_Bool bAbsorb ) throw( ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::uno::RuntimeException )
{
	// testen ob 'xRange' vom richtigen Typ ist (SvtXECTextRange) und
	// das gleiche 'XTextHelper' hat.
	// ...
	DBG_ERROR("not implemented yet");
	//AutoShowVScrollBar();
	//UpdateThumbPosVScrollBar();
}

void XTextHelper::insertTextContent( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >& xRange, const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextContent >& xContent, sal_Bool bAbsorb ) throw(::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::uno::RuntimeException)
{
}

void XTextHelper::removeTextContent( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextContent >& xContent ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException)
{
}


//	----------------------------------------------------
//	class SvtXEditorControl
//  Die Klasse die die Textkomponente selbst darstellt.
//	----------------------------------------------------
SvtXEditorControl::SvtXEditorControl() : XTextHelper(this)
{
}

SvtXEditorControl::~SvtXEditorControl()
{
}


SvtECWindow* SvtXEditorControl::CreateWindow( Window* pParent )
{
	WinBits  mnStyle = WB_VSCROLL | WB_NOHIDESELECTION;
	SvtECWindow* pWin = new SvtECWindow( pParent, mnStyle );
	pWin->SetFont( System::GetStandardFont(STDFONT_FIXED) );

	pWin->GetTextEngine()->SetLeftMargin(8);

	SetWindow( pWin );
	return pWin;
}


void SvtXEditorControl::AutoShowVScrollBar() const
{
	((SvtXEditorControl *) this)->GetECWindow()->AutoShowVScrollBar();
}


void SvtXEditorControl::UpdateThumbPosVScrollBar() const
{
	((SvtXEditorControl *) this)->GetECWindow()->UpdateThumbPosVScrollBar();
}


void SvtXEditorControl::ImpSetSelection(const TextSelection &rSel, sal_Bool bForceAutoScroll)
{
	TextView *pView = GetECWindow()->GetTextView();

	if (pView)
	{
		sal_Bool  bOldAutoScroll = pView->IsAutoScroll();
		if (bForceAutoScroll)
			pView->SetAutoScroll( sal_True );
		pView->SetSelection( rSel );
		if (bForceAutoScroll)
			pView->SetAutoScroll( bOldAutoScroll );
	}
}

::com::sun::star::uno::Any SvtXEditorControl::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::text::XTextRange*, this ),
										SAL_STATIC_CAST( ::com::sun::star::text::XText*, this ),
										SAL_STATIC_CAST( ::com::sun::star::text::XSimpleText*, this ),
										SAL_STATIC_CAST( ::com::sun::star::text::XTextViewCursorSupplier*, this ),
										SAL_STATIC_CAST( ::com::sun::star::util::XSearchable*, this ) );
	return (aRet.hasValue() ? aRet : VCLXMultiLineEdit::queryInterface( rType ));
}

IMPL_XTYPEPROVIDER_START( SvtXEditorControl )
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XText>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XSimpleText>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextViewCursorSupplier>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchable>* ) NULL ),
	VCLXMultiLineEdit::getTypes()
IMPL_XTYPEPROVIDER_END


::com::sun::star::uno::Reference< ::com::sun::star::text::XTextViewCursor >  SvtXEditorControl::getViewCursor() throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXEditorControl *pThis = (SvtXEditorControl *) this;
	if (!mxCursor.is())
		pThis->mxCursor = (::cppu::OWeakObject*) new SvtXECTextCursor( pThis );

	::com::sun::star::uno::Reference< ::com::sun::star::text::XTextViewCursor >  xRef( mxCursor, ::com::sun::star::uno::UNO_QUERY );
	DBG_ASSERT(xRef.is(), "NULL pointer");
	return xRef;
}


::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor >  SvtXEditorControl::createSearchDescriptor() throw( ::com::sun::star::uno::RuntimeException )
{
	return new SvtXECSearchDescriptor( (SvtXEditorControl *) this );
}

::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess >  SvtXEditorControl::findAll( const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > & xDesc ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXECTRIndexAccess* pAll = new SvtXECTRIndexAccess;
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > 	 	 xPos = findFirst(xDesc);

	SvtXECTextRange *pRange;
	while (xPos.is())
	{
		pRange = SvtXECTextRange::GetImplementation( xPos );
		DBG_ASSERT(pRange, "NULL pointer");
		::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  xRange = new SvtXECTextRange(*pRange);
		pAll->InsertElementAtEnd( xRange );
		xPos = findNext(xPos, xDesc);
	}
	if (pAll->getCount()  &&  GetECWindow())
	{
		// Cursor auf die Position des ersten Fundes stellen
		SvtXECTextRange *pRange = SvtXECTextRange::GetImplementation( pAll->GetElement(0) );
		DBG_ASSERT(pRange, "NULL pointer");
		ImpSetSelection( pRange->GetSelection(), sal_True );
	}

	return pAll;
}


::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  SvtXEditorControl::findFirst( const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > & xDesc ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXECSearchDescriptor *pSearch = SvtXECSearchDescriptor::GetImplementation( xDesc );
	// testen ob der ::com::sun::star::util::SearchDescriptor vom passenden Typ ist
	if (!pSearch)
		throw ::com::sun::star::uno::RuntimeException();

	ExtTextView   *pView = GetECWindow()->GetTextView();
	ExtTextEngine *pEng  = GetECWindow()->GetTextEngine();
	DBG_ASSERT(pView, "keine ExtTextView");
	DBG_ASSERT(pEng,  "keine ExtTextEngine");

	TextPaM		   aStart (pView->CursorStartOfDoc());
	TextSelection  aSel (aStart, aStart);
	sal_Bool  bFound = pEng->Search(aSel, pSearch->GetSearchParam() , !pSearch->IsBackward());
	if (bFound)
		ImpSetSelection(aSel, sal_True);

	return bFound ? (::com::sun::star::text::XTextRange *) new SvtXECTextRange( this, aSel ) : NULL;
}


::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  SvtXEditorControl::findNext( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & xStartAt,
										   const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > & xDesc ) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtXECSearchDescriptor *pSearch = SvtXECSearchDescriptor::GetImplementation( xDesc );
	SvtXECTextRange *pRange = SvtXECTextRange::GetImplementation( xStartAt );

	// testen ob der ::com::sun::star::util::SearchDescriptor vom passenden Typ ist
	// und ob  xStartAt vom richtigen Typ ist mit gleichem Control
	if (!pSearch
		||  (!pRange || pRange->GetParent() != this))
		throw ::com::sun::star::uno::RuntimeException();

	ExtTextView   *pView = GetECWindow()->GetTextView();
	ExtTextEngine *pEng  = GetECWindow()->GetTextEngine();
	DBG_ASSERT(pView, "keine ExtTextView");
	DBG_ASSERT(pEng,  "keine ExtTextEngine");

	TextSelection  aSel (pRange->GetSelection());
	sal_Bool  bFound = pEng->Search(aSel, pSearch->GetSearchParam() , !pSearch->IsBackward());
	if (bFound)
		ImpSetSelection(aSel, sal_True);

	return bFound ? (::com::sun::star::text::XTextRange *) new SvtXECTextRange( this, aSel ) : NULL;
}


void SvtXEditorControl::setProperty( const ::rtl::OUString& rPropertyName, const ::com::sun::star::uno::Any& rValue) throw(::com::sun::star::uno::RuntimeException)
{
	::vos::OGuard aGuard( GetMutex() );

	SvtECWindow* pWin = (SvtECWindow*) GetECWindow();
	if ( pWin )
	{
		String aPropName = rPropertyName;
		if ( aPropName.EqualsAscii( "MarkHyperLinks" ) )
		{
			sal_Bool b;
			if ( rValue >>= b )
				pWin->SetMarkHyperLinks( b );

			// beim browsen in mail/news den ::com::sun::star::text::TextCursor ausschalten.
			//! Desweiteren fuehrt dies dazu, da mit CursorUp/Down automatisch
			//! gescrollt wird.
			// (Dies nicht generell in 'setEditable' tun, denn zB bei Verwendung
			// als Texteditor soll er auch im ReadOnly mode sichtbar sein).
			TextView *pView = GetECWindow()->GetTextView();
//			pView->SetAutoScroll(sal_False);	// So kein scrollen mit gedrueckter Maus moeglich
			pView->EnableCursor(sal_False);
			pView->HideCursor();
		}
		else if ( aPropName.EqualsAscii( "FontDescriptor" ) )
		{
			VCLXMultiLineEdit::setProperty( rPropertyName, rValue);

			// default TAB Weite auf 8 Zeichen setzen
			Window *pViewWin = GetECWindow()->GetTextView()->GetWindow();
			if (pViewWin)
			{
				static const sal_Unicode sampleText[] = { 'X', 'X', 'X', 'X', 'X', 'X', 'X', 'X', '\0' };
				sal_uInt16 nTabWidth = (sal_uInt16) pViewWin->GetTextWidth( sampleText );
				GetECWindow()->GetTextEngine()->SetDefTab( nTabWidth );
			}
		}
		else
			VCLXMultiLineEdit::setProperty( rPropertyName, rValue);
	}
}


::com::sun::star::uno::Any SvtXEditorControl::getProperty( const ::rtl::OUString& rPropertyName ) throw( ::com::sun::star::uno::RuntimeException )
{
	::vos::OGuard aGuard( GetMutex() );

	::com::sun::star::uno::Any aProp;
	SvtECWindow* pWin = (SvtECWindow*) GetECWindow();
	if ( pWin )
	{
		String aPropName = rPropertyName;
		if ( aPropName.EqualsAscii( "MarkHyperLinks" ) )
			aProp <<= pWin->IsMarkHyperLinks();
		else
			aProp <<= VCLXMultiLineEdit::getProperty( rPropertyName );
	}

	return aProp;
}

void SvtXEditorControl::ConnectDataSource( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource > & rSource )
{
	SvtDataSink_Impl *pSink = new SvtDataSink_Impl ( this  );
	mxSink = pSink;
	pSink->SetSource( rSource );
}
