/*************************************************************************
 *
 *  $RCSfile: unoifac3.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _TEXTENG_HXX //autogen
#include <texteng.hxx>
#endif

#ifndef _TEXTVIEW_HXX
#include <textview.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#include "unoiface.hxx"
#include "unoifac3.hxx"
#include <vcl/svapp.hxx>

#include <toolkit/helper/vclunohelper.hxx>

// ::com::sun::star::util::URL Protocol names
#define PROTOCOL_UNO	".uno:"

// UNO property names
#define UPN_CUT			"Cut"
#define UPN_COPY		"Copy"
#define UPN_PASTE		"Paste"
#define UPN_SELECT_ALL	"SelectAll"
#define UPN_SEARCH		"Search"

#include <osl/mutex.hxx>
#include <cppuhelper/weak.hxx>
#include <vcl/window.hxx>
#include <unotools/processfactory.hxx>


SvtTextLoader::SvtTextLoader()
{
}

SvtTextLoader::~SvtTextLoader()
{
}

::com::sun::star::uno::Any SvtTextLoader::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::frame::XFrameLoader*, this ),
										SAL_STATIC_CAST( ::com::sun::star::lang::XServiceInfo*, this ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

// ::com::sun::star::lang::XTypeProvider
IMPL_XTYPEPROVIDER_START( SvtTextLoader )
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameLoader>* ) NULL ),
	getCppuType( ( ::com::sun::star::uno::Reference< ::com::sun::star::lang::XServiceInfo>* ) NULL )
IMPL_XTYPEPROVIDER_END


// ::com::sun::star::lang::XServiceInfo
sal_Bool SvtTextLoader::supportsService(const ::rtl::OUString& ServiceName) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Sequence< ::rtl::OUString > aSNL = getSupportedServiceNames();
	const ::rtl::OUString * pArray = aSNL.getConstArray();
	for( sal_Int32 i = 0; i < aSNL.getLength(); i++ )
		if( pArray[i] == ServiceName )
			return sal_True;
	return sal_False;
}

// ::com::sun::star::lang::XServiceInfo
::com::sun::star::uno::Sequence< ::rtl::OUString > SvtTextLoader::getSupportedServiceNames(void) throw(com::sun::star::uno::RuntimeException)
{
	return getSupportedServiceNames_Static();
}

::rtl::OUString SvtTextLoader::getImplementationName(  ) throw(::com::sun::star::uno::RuntimeException)
{
	return getImplementationName_Static();
}


// ORegistryServiceManager_Static
::com::sun::star::uno::Sequence< ::rtl::OUString > SvtTextLoader::getSupportedServiceNames_Static(void) // throw(  )
{
	::com::sun::star::uno::Sequence< ::rtl::OUString > aSNS( 2 );
	aSNS.getArray()[0] = ::rtl::OUString::createFromAscii( "stardiv.one.frame.FrameLoader" );
	aSNS.getArray()[1] = ::rtl::OUString::createFromAscii("stardiv.one.frame.TextLoader" );
	return aSNS;
}


// -----------------------------------------------------------------------
void SvtTextLoader::cancel(void) throw(::com::sun::star::uno::RuntimeException)
{
	xListener = ::com::sun::star::uno::Reference< ::com::sun::star::frame::XLoadEventListener > ();
}

void SvtTextLoader::load(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xFrame, const ::rtl::OUString& rURL,
						 const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs,
						 const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XLoadEventListener > & xListener) throw( ::com::sun::star::uno::RuntimeException )
{
	SvtTextController *pTextCtrl = new SvtTextController;

	pTextCtrl->attachResource(rURL, aArgs);

	// ContainerWindow des Frames
	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  aRef ( xFrame->getContainerWindow() );

	Window* pParent = VCLUnoHelper::GetWindow( aRef );

	SvtECWindow* pWin = pTextCtrl->CreateWindow( pParent );
	pWin->SetController(pTextCtrl);
	pWin->Show();

	// an das VCLXMultiLineEdit (pTextCtrl) das MultiLineEdit (pWin) anbinden
    Application::GetUnoWrapper()->SetWindowInterface( pWin, pTextCtrl );
//    pTextCtrl->SetWindow(pWin);
	pTextCtrl->setEditable(sal_False);


	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  xWin = VCLUnoHelper::GetInterface( pWin );
	xFrame->setComponent( xWin, pTextCtrl );
	pTextCtrl->attachFrame( xFrame );

	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xMSF = ::utl::getProcessServiceFactory();
	::com::sun::star::uno::Reference < ::com::sun::star::uno::XInterface > xI = xMSF->createInstance( ::rtl::OUString::createFromAscii( "stardiv.one.frame.DataSourceFactory" ) );
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xFact( xI, ::com::sun::star::uno::UNO_QUERY );

	if ( xFact.is() )
	{
		INetURLObject aURL;
		aURL.SetSmartProtocol( INET_PROT_FILE );
		aURL.SetSmartURL( rURL );
		::com::sun::star::uno::Sequence < ::com::sun::star::uno::Any > aArgs(1);
		aArgs.getArray()[0] <<= ::rtl::OUString( aURL.GetMainURL() );
		String aProt( INetURLObject::GetScheme( aURL.GetProtocol() ) );
		::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource >  aSource( xFact->createInstanceWithArguments( aProt, aArgs ), ::com::sun::star::uno::UNO_QUERY );
		if ( aSource.is() )
			pTextCtrl->ConnectDataSource( aSource );
	}
	if ( xListener.is() )
		xListener->loadFinished( this );
}


//	----------------------------------------------------
//	class SvtTextController
//	----------------------------------------------------

SV_IMPL_VARARR(XEventListenerArray, ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > );
SV_IMPL_PTRARR(StatusListenerArray, StatusDispatch *);

SvtTextController::SvtTextController()
{
	pxEventListeners  = NULL;
	pxStatusListeners = NULL;
	bDisposing = sal_False;
}


SvtTextController::~SvtTextController()
{
	delete pxEventListeners;
	delete pxStatusListeners;
}

::com::sun::star::uno::Any SvtTextController::queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType,
										SAL_STATIC_CAST( ::com::sun::star::frame::XController*, this ),
										SAL_STATIC_CAST( ::com::sun::star::frame::XModel*, this ),
										SAL_STATIC_CAST( ::com::sun::star::frame::XDispatch*, this ),
										SAL_STATIC_CAST( ::com::sun::star::frame::XDispatchProvider*, this ) );
    return (aRet.hasValue() ? aRet : SvtXEditorControl::queryInterface( rType ));
}

void SvtTextController::dispose() throw( ::com::sun::star::uno::RuntimeException )
{
	bDisposing = sal_True;
	axFrame    = NULL;
	::com::sun::star::lang::EventObject aEvtObj ( (::cppu::OWeakObject*) this );

	if (pxEventListeners)
	{
		// allen EventListeners mitteilen, da dieses Objekt disposed wird.
		//! Dabei von hinten aufraeumen (weil ia die Anzahl der Elemente
		//! schon in der naechsten Iteration anders sein kann!)
		//! (Trotzdem noch nicht vollkommen thread safe.)
		for (sal_uInt16 i = pxEventListeners->Count();  i--; )
			pxEventListeners->GetObject(i)->disposing( aEvtObj );
	}

	if (pxStatusListeners)
	{
		// allen StatusListeners mitteilen, da dieses Objekt disposed wird.
		//! Dabei von hinten aufraeumen (siehe oben)
		for (sal_uInt16 i = pxStatusListeners->Count();  i--; )
			pxStatusListeners->GetObject(i)->xListener->disposing( aEvtObj );
	}

    SvtXEditorControl::dispose();
}


void SvtTextController::addEventListener( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & xListener ) throw( ::com::sun::star::uno::RuntimeException )
{
	if (!pxEventListeners)
		pxEventListeners = new XEventListenerArray;

	// suchen ob das Element bereits vorhanden ist...
	sal_uInt16 nCount = pxEventListeners->Count(),
		   i;
	for (i = 0;  i < nCount;  i++)
		if (pxEventListeners->GetObject(i) == xListener)
			break;

	// ...wenn nicht dann einfuegen
	if (i >= nCount)
		pxEventListeners->Insert(xListener, nCount);
}


void SvtTextController::removeEventListener( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & xListener ) throw( ::com::sun::star::uno::RuntimeException )
{
	if (pxEventListeners)
	{
		//! das Element kann maximal einmal drin sein (siehe addEventListener)

		// entfernen des Elements (sofern vorhanden)
		sal_uInt16 nCount = pxEventListeners->Count();
		for (sal_uInt16 i = 0;  i < nCount;  i++)
			if (pxEventListeners->GetObject(i) == xListener)
				pxEventListeners->Remove(i);
	}
}


void SvtTextController::attachFrame( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xFrame ) throw( ::com::sun::star::uno::RuntimeException )
{
	axFrame = xFrame;
}


sal_Bool SvtTextController::attachModel( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > & xModel ) throw( ::com::sun::star::uno::RuntimeException )
{
	// da wir selber das Model sind kann das nicht erfolgreich sein
	return sal_False;
}


sal_Bool SvtTextController::IsSupportedCommand(const ::com::sun::star::util::URL& rURL) const
{
	DBG_ASSERT(!rURL.Protocol.compareToAscii( PROTOCOL_UNO ), "kein Uno command");

	sal_Bool  bRes = sal_False;

	if ( ! rURL.Path.compareToAscii( UPN_CUT ) || ! rURL.Path.compareToAscii( UPN_PASTE ) )
		bRes = ((SvtTextController *) this)->isEditable();
	else if ( ! rURL.Path.compareToAscii( UPN_COPY ) ||
			  ! rURL.Path.compareToAscii( UPN_SEARCH )  ||
			  ! rURL.Path.compareToAscii( UPN_SELECT_ALL ) )
		bRes = sal_True;

	return bRes;
}


void SvtTextController::StatusChanged(const ::rtl::OUString &rCommand) const
{
	if (pxStatusListeners)
	{
		sal_uInt16 nCount = pxStatusListeners->Count();
		for (sal_uInt16 i = 0;  i < nCount;  i++)
		{
			StatusDispatch *pObj = pxStatusListeners->GetObject(i);
			if (    ! pObj->aURL.Protocol.compareToAscii( PROTOCOL_UNO )
				&&  pObj->aURL.Path == rCommand )
			{
				::com::sun::star::frame::FeatureStateEvent  aFSEvent;
				aFSEvent.FeatureURL = pObj->aURL;
				aFSEvent.IsEnabled  = IsSupportedCommand(pObj->aURL);
				aFSEvent.Requery    = sal_False;
				aFSEvent.Source     = (::com::sun::star::frame::XDispatch *) this;

				pObj->xListener->statusChanged(aFSEvent);
			}
		}
	}
}


::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  SvtTextController::queryDispatch( const ::com::sun::star::util::URL& rURL, const ::rtl::OUString& rTargetFrameName, sal_Int32 nSearchFlags ) throw( ::com::sun::star::uno::RuntimeException )
{
	sal_Bool bDispatch = sal_False;

	if ( ! rURL.Protocol.compareToAscii( PROTOCOL_UNO ) )
		bDispatch = IsSupportedCommand(rURL);

	return (bDispatch && !bDisposing) ? this : NULL;
}


::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  > SvtTextController::queryDispatches( const ::com::sun::star::uno::Sequence< ::com::sun::star::frame::DispatchDescriptor >& rDescripts ) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("not implemented");
	return ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  >();
}


sal_Bool SvtTextController::suspend( sal_Bool bSuspend ) throw( ::com::sun::star::uno::RuntimeException )
{
	return sal_True;
}


::com::sun::star::uno::Any SvtTextController::getViewData() throw( ::com::sun::star::uno::RuntimeException )
{
	return ::com::sun::star::uno::Any();
}


void SvtTextController::restoreViewData( const ::com::sun::star::uno::Any& rData ) throw( ::com::sun::star::uno::RuntimeException )
{
}


::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel >  SvtTextController::getModel() throw( ::com::sun::star::uno::RuntimeException )
{
	return (::com::sun::star::frame::XModel*) this;
}


::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  SvtTextController::getFrame() throw( ::com::sun::star::uno::RuntimeException )
{
	return axFrame;
}

/*
void SvtTextController::componentActivated() throw( ::com::sun::star::uno::RuntimeException )
{
	GetECWindow()->GrabFocus();
}


void SvtTextController::componentDeactivated() throw( ::com::sun::star::uno::RuntimeException )
{
}
*/

sal_Bool SvtTextController::attachResource( const ::rtl::OUString& rURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& rArgs ) throw( ::com::sun::star::uno::RuntimeException )
{
	aURL  = rURL;
	aArgs = rArgs;

	return sal_False;
}


::rtl::OUString SvtTextController::getURL() throw( ::com::sun::star::uno::RuntimeException )
{
	return aURL;
}


::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue > SvtTextController::getArgs() throw( ::com::sun::star::uno::RuntimeException )
{
	return aArgs;
}


void SvtTextController::connectController( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController > & xController ) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("not implemented");
}


void SvtTextController::disconnectController( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController > & xController ) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("not implemented");
}


void SvtTextController::lockControllers() throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("not implemented");
}


void SvtTextController::unlockControllers() throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("not implemented");
}


sal_Bool SvtTextController::hasControllersLocked() throw( ::com::sun::star::uno::RuntimeException )
{
	return sal_False;
}


::com::sun::star::uno::Reference< ::com::sun::star::frame::XController > SvtTextController::getCurrentController(  ) throw(::com::sun::star::uno::RuntimeException)
{
	return (::com::sun::star::frame::XController*) this;
}


void SvtTextController::setCurrentController( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >& xController ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException)
{
	DBG_WARNING("not implemented");
}


::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  SvtTextController::getCurrentSelection(  ) throw(::com::sun::star::uno::RuntimeException)
{
	return NULL;
}


void SvtTextController::dispatch(const ::com::sun::star::util::URL& aURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs) throw( ::com::sun::star::uno::RuntimeException )
{
	String aArg = aURL.Arguments;

	if( ! aURL.Protocol.compareToAscii( PROTOCOL_UNO ) )
	{
		TextView *pTextView = GetECWindow()->GetTextView();
		DBG_ASSERT(pTextView, "NULL pointer");

		sal_Bool bAutoShowVScrollBar = sal_True;

		if ( ! aURL.Path.compareToAscii( UPN_CUT ) )
			pTextView->Cut();
		else if ( ! aURL.Path.compareToAscii( UPN_COPY ) )
		{
			pTextView->Copy();
			bAutoShowVScrollBar = sal_False;
		}
		else if ( ! aURL.Path.compareToAscii( UPN_PASTE ) )
			pTextView->Paste();
		else if ( ! aURL.Path.compareToAscii( UPN_SELECT_ALL ) )
			pTextView->SetSelection( TextSelection(pTextView->CursorStartOfDoc(),
												   pTextView->CursorEndOfDoc()) );
		else if ( ! aURL.Path.compareToAscii( UPN_SEARCH ) )
		{	// immer von der aktuellen Cursorposition aus das naechste
			// Vorkommen suchen (unabh von dem Ergebnis von findFirst oder
			// findNext, damit es auch bei Cursorbewegungen durch den ::com::sun::star::sdbcx::User
			// funktioniert).

			if (aArgs.getLength() == 0)
				throw ::com::sun::star::uno::RuntimeException();
			::com::sun::star::uno::Any	aAny = aArgs.getConstArray()[0].Value;
			::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > xDesc;
			if ( aAny >>= xDesc )
			{
				TextView *pView = GetECWindow()->GetTextView();
				DBG_ASSERT(pView, "NULL pointer")
				::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  xStart = new SvtXECTextRange( this, pView->GetSelection() );
				findNext(xStart, xDesc);
			}
			else
				throw ::com::sun::star::uno::RuntimeException();
		}

		// ggf VScrollBar aktivieren/deaktivieren und ThumbPos anpassen
		if (bAutoShowVScrollBar)
		{
			AutoShowVScrollBar();
			UpdateThumbPosVScrollBar();
		}
	}
}


void SvtTextController::addStatusListener(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & xControl, const ::com::sun::star::util::URL& rURL) throw( ::com::sun::star::uno::RuntimeException )
{
	if (!pxStatusListeners)
		pxStatusListeners = new StatusListenerArray;

	StatusDispatch* pStatusDispatch = new StatusDispatch(rURL, xControl);
	pxStatusListeners->C40_INSERT(StatusDispatch, pStatusDispatch, pxStatusListeners->Count());

	// dem (neuen) Listener den aktuellen (initialen) Status mitteilen
	::com::sun::star::frame::FeatureStateEvent aEvent;
	aEvent.FeatureURL = rURL;
	aEvent.IsEnabled  = IsSupportedCommand(rURL);
	aEvent.Requery    = sal_False;
	aEvent.Source     = (::com::sun::star::frame::XDispatch *) this;

	xControl->statusChanged( aEvent );
}


void SvtTextController::removeStatusListener(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & xControl, const ::com::sun::star::util::URL& rURL) throw( ::com::sun::star::uno::RuntimeException )
{
	if (pxStatusListeners)
	{
		sal_uInt16 nCount = pxStatusListeners->Count();
		for ( sal_uInt16 i = nCount;  i--; )
		{
			StatusDispatch *pObj = pxStatusListeners->GetObject(i);
			if (pObj->xListener == xControl
				&& ( pObj->aURL.Complete == rURL.Complete/* || !rURL.Complete.len() */) )
				pxStatusListeners->DeleteAndDestroy(i);
		}
	}
}


void SvtTextController::setEditable(sal_Bool bEditable) throw(::com::sun::star::uno::RuntimeException)
{
	if (bEditable != VCLXMultiLineEdit::isEditable())
	{
		VCLXMultiLineEdit::setEditable(bEditable);
		StatusChanged(::rtl::OUString::createFromAscii( UPN_CUT) );
		StatusChanged(::rtl::OUString::createFromAscii( UPN_PASTE) );

		TextView   *pView = GetECWindow()->GetTextView();
		if (bEditable)
			pView->ShowCursor();
		else
			pView->HideCursor();
		pView->EnableCursor( bEditable );

		GetECWindow()->GetTextEngine()->EnableUndo( bEditable == sal_True );
	}
}


