/*************************************************************************
 *
 *  $RCSfile: adritem.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:00:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_ADRITEM_HXX
#define _SVX_ADRITEM_HXX

// include ---------------------------------------------------------------

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef SVTOOLS_INIADRTK_HXX
#include <svtools/iniadrtk.hxx>
#endif

// define ----------------------------------------------------------------

#define POS_COMPANY		((USHORT) 0)
#define POS_STREET		((USHORT) 1)
#define POS_COUNTRY		((USHORT) 2)
#define POS_PLZ			((USHORT) 3)
#define POS_CITY		((USHORT) 4)
#define POS_TITLE		((USHORT) 5)
#define POS_POSITION	((USHORT) 6)
#define POS_TEL_PRIVATE	((USHORT) 7)
#define POS_TEL_COMPANY	((USHORT) 8)
#define POS_FAX			((USHORT) 9)
#define POS_EMAIL		((USHORT)10)
#define POS_STATE		((USHORT)11)

#define SfxAddressItem 	SvxAddressItem

const char cAdrToken = '#';

// forward ---------------------------------------------------------------

class SfxIniManager;

// class SvxAddressItem --------------------------------------------------

class SvxAddressItem : public SfxStringItem
{
	String	aName;
	String	aFirstName;
	String	aShortName;

public:
	TYPEINFO();

	SvxAddressItem( USHORT nWhich = 0 );
	SvxAddressItem( const String& rAddress, const String& rShortName,
					const String& rFirstName, const String& rName,
					USHORT nWhich = 0 );
	SvxAddressItem( SvStream& rStrm, USHORT nWhich = 0 );
	SvxAddressItem( SfxIniManager& rManager, USHORT nWhich = 0 );
	SvxAddressItem( const SvxAddressItem& );
	~SvxAddressItem() {}

			void		 Store( SfxIniManager& rManager );

	virtual SfxPoolItem* Clone( SfxItemPool *pPool = 0 ) const;
	virtual SfxPoolItem* Create( SvStream&, USHORT nVersion ) const;
	virtual int 		 operator==( const SfxPoolItem& rAttr ) const;
	BOOL    SetToken( USHORT nPos, const String &rVal );
	BOOL    SetToken( AddressToken nToken, const String &rVal );
	String	GetToken( USHORT nPos ) const;
	String	GetToken( AddressToken nToken ) const;
	String	GetFirstName() const	{ return aFirstName; }
	String	GetName() const			{ return aName; }
	String	GetShortName() const   	{ return aShortName; }

#if __PRIVATE
	String	GetCompany() const 		{ return GetToken( ADDRESS_COMPANY ); }
	String	GetStreet() const		{ return GetToken( ADDRESS_STREET ); }
	String	GetCountry() const		{ return GetToken( ADDRESS_COUNTRY ); }
	String	GetPLZ() const			{ return GetToken( ADDRESS_PLZ ); }
	String	GetCity() const			{ return GetToken( ADDRESS_CITY ); }
	String	GetTitle() const		{ return GetToken( ADDRESS_TITLE ); }
	String	GetPosition() const		{ return GetToken( ADDRESS_POSITION ); }
	String	GetTelPriv() const	 	{ return GetToken( ADDRESS_TEL_PRIVATE ); }
	String	GetTelCompany() const	{ return GetToken( ADDRESS_TEL_COMPANY ); }
	String	GetFax() const			{ return GetToken( ADDRESS_FAX ); }
	String	GetEmail() const		{ return GetToken( ADDRESS_EMAIL ); }
	String	GetState() const		{ return GetToken( ADDRESS_STATE ); }
	String	GetFatherName() const	{ return GetToken( ADDRESS_FATHERSNAME ); }
	String	GetApartmentNr() const	{ return GetToken( ADDRESS_APARTMENT ); }
#endif
};

#endif // #ifndef _SVX_ADRITEM_HXX


