/*************************************************************************
 *
 *  $RCSfile: chardlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:00:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_CHARDLG_HXX
#define _SVX_CHARDLG_HXX

// include ---------------------------------------------------------------

#ifndef _SV_GROUP_HXX //autogen wg. GroupBox
#include <vcl/group.hxx>
#endif
#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_FNTCTRL_HXX
#include <fntctrl.hxx>
#endif

// forward ---------------------------------------------------------------

class SvxFontListItem;
class FontList;

// -----------------------------------------------------------------------

class SvxCharStdPage : public SfxTabPage

/*  {k:\svx\prototyp\dialog\charstd.bmp}

	[Beschreibung]
	TabPage zur Einstellung eines Fonts. Standard-Einstellungen wie Name, Stil,
	Groesse, Farbe, Sprache, ...

	[Items]
	<SvxFontItem>:          <SID_ATTR_CHAR_FONT>
	<SvxWeightItem>:        <SID_ATTR_CHAR_WEIGHT>
	<SvxPostureItem>:       <SID_ATTR_CHAR_POSTURE>
	<SvxFontHeightItem>:    <SID_ATTR_CHAR_FONTHEIGHT>
	<SvxColorItem>:         <SID_ATTR_CHAR_COLOR>
	<SvxUnderlineItem>:     <SID_ATTR_CHAR_UNDERLINE>
	<SvxCrossedOutItem>:    <SID_ATTR_CHAR_STRIKEOUT>
	<SvxContourItem>:       <SID_ATTR_CHAR_CONTOUR>
	<SvxShadowedItem>:      <SID_ATTR_CHAR_SHADOWED>
	<SvxLanguageItem>:      <SID_ATTR_CHAR_LANGUAGE>
	<SvxFontListItem>:      <SID_ATTR_CHAR_FONTLIST>
	<SvxColorItem>:         <SID_ATTR_CHAR_FILLCOLOR>
*/

{
friend class SvxDialogDll;
public:
	static SfxTabPage*  Create( Window* pParent ,const SfxItemSet& rSet );
	static USHORT*      GetRanges();

	virtual BOOL        FillItemSet( SfxItemSet& rOutSet );
	virtual void        Reset( const SfxItemSet& rSet );
	virtual void		DataChanged( const DataChangedEvent& rDCEvt );

	void                SetInfoItem( const SvxFontListItem& rItem );
	void                SetFontList( const SvxFontListItem& rItem )
							{ SetInfoItem( rItem ); }
	const FontList*		GetFontList() const;
	void                EnableRelativeMode();
	void				EnableSearchMode() { bInSearchMode = TRUE; }

						~SvxCharStdPage();

protected:
	virtual void        ActivatePage( const SfxItemSet& rSet );
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

private:
						SvxCharStdPage( Window* pParent, const SfxItemSet& rSet );

#ifdef _SVX_CHARDLG_CXX
	// Handler
	void                SetHandler_Impl();
	void                UpdateExample_Impl();
	void                FillStyleBox_Impl();
	void                FillSizeBox_Impl();
	void				Reset_Impl(
							ColorListBox& rBox,
							FixedText& rColorText,
							const SfxItemSet& rSet,
							USHORT nSlot );

	BOOL				FillItemSet_Impl(
							const ColorListBox& rBox,
							SfxItemSet& rSet,
							USHORT nSlot );


	DECL_LINK( TimeoutHdl_Impl, Timer* );
	DECL_LINK( BoxModifyHdl_Impl, void* );
	DECL_LINK( OutlineClickHdl_Impl, TriStateBox* );
	DECL_LINK( ShadowClickHdl_Impl, TriStateBox* );
	DECL_LINK( UnderlineClickHdl_Impl, TriStateBox* );
	DECL_LINK( StrikeoutClickHdl_Impl, TriStateBox* );
	DECL_LINK( ColorBoxSelectHdl_Impl, ColorListBox* );
#endif

	// Member
	const FontList*     _pFontList;
	Timer               aTimer;
	String				aStrTransparent;
	String				aNoStyleStr;
	FontUnderline       eUnderline;
	FontStrikeout       eStrikeout;

	// Controls
	FixedText           aFontText;
	FontNameBox         aFontBox;
	FixedText           aStyleText;
	FontStyleBox        aStyleBox;
	FixedText           aSizeText;
	FontSizeBox         aSizeBox;

	TriStateBox         aOutlineBtn;
	TriStateBox         aShadowBtn;
	TriStateBox         aUnderlineBtn;
	TriStateBox         aStrikeoutBtn;
	GroupBox            aCasemapBox;

	FixedText           aColorText;
	ColorListBox        aColorBox;
	FixedText           aFillColorText;
	ColorListBox        aFillColorBox;

	FixedText           aLanguageText;
	ListBox             aLanguageBox;
	FixedInfo           aFontTypeText;

	SvxFontPrevWindow   aExampleWin;
	GroupBox            aExampleBox;
	BOOL				bDeleteFontList;
	BOOL				bInSearchMode;
	USHORT				nExtraEntryPos;
};

// -----------------------------------------------------------------------

#define DISABLE_CASEMAP     ((USHORT)0x0001)
#define DISABLE_WORDLINE    ((USHORT)0x0002)
#define DISABLE_BLINK       ((USHORT)0x0004)

class SvxCharExtPage : public SfxTabPage

/*  {k:\svx\prototyp\dialog\charext.bmp}

	[Beschreibung]
	TabPage zur Einstellung eines Fonts. Spezial-Einstellungen wie Auszeichnung,
	Position, Positionszusaetze,Laufweite, ...

	[Items]
	<SvxWordLineModeItem>:  <SID_ATTR_CHAR_WORDLINEMODE>
	<SvxCaseMapItem>:       <SID_ATTR_CASEMAP>
	<SvxPropSizeItem>:      <SID_ATTR_CHAR_PROPSIZE>
	<SvxEscapementItem>:    <SID_ATTR_CAHR_ESCAPEMENT>
	<SvxKerningItem>:       <SID_ATTR_CHAR_KERNING>
	<SvxAutoKernItem>:      <SID_ATTR_CHAR_AUTOKERN>
*/

{
public:
	static SfxTabPage*  Create( Window* pParent, const SfxItemSet& rSet );
	static USHORT*      GetRanges();

	virtual BOOL        FillItemSet( SfxItemSet& rSet );
	virtual void        Reset( const SfxItemSet& rSet );
	virtual void        FillUserData();

	void                DisableControls( USHORT nDisable );

	void                EnableFlash();

protected:
	virtual void        ActivatePage( const SfxItemSet& rSet );
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

private:
	SvxCharExtPage( Window* pParent, const SfxItemSet& rSet );

#ifdef _SVX_CHARDLG_CXX
	void                SetHandler_Impl();
	void                SetCaseMap_Impl( USHORT eMap );
	void                EnablePairKerning_Impl();

	void                UpdatePos_Impl( BYTE nProp, short nEsc, BYTE nEscProp );
	void                SetEscapement_Impl( USHORT eEsc );

	// Handler
#if ( SUPD < 590 )
	DECL_LINK( CaseMapHdl_Impl, RadioButton* pBox );
#else
	DECL_LINK( CaseMapHdl_Impl, ListBox* pBox );
#endif
	DECL_LINK( EscapementHdl_Impl, RadioButton* pBtn );
	DECL_LINK( FontExtModifyHdl_Impl, MetricField* );
	DECL_LINK( KerningSelectHdl_Impl, ListBox* pBox );
	DECL_LINK( KerningModifyHdl_Impl, MetricField* pBox );
	DECL_LINK( UnderlineSelectHdl_Impl, ListBox* );
	DECL_LINK( StrikeoutSelectHdl_Impl, ListBox* );
	DECL_LINK( WordLineClickHdl_Impl, CheckBox* );
	DECL_LINK( TimeoutHdl_Impl, Timer* );
	DECL_LINK( LoseFocusHdl_Impl, MetricField* );
	DECL_LINK( AutoKernHdl_Impl, CheckBox* ); // wegen define im CXX
	DECL_LINK( AutoPosHdl_Impl, CheckBox* );
#endif

	// Member
#if ( SUPD < 590 )
	RadioButton         aNoneBtn;
	RadioButton         aCapsBtn;
	RadioButton         aLowercaseBtn;
	RadioButton         aSmallcapsBtn;
	RadioButton         aTitelBtn;
#else
	ListBox				aCapsLB;
#endif
	CheckBox            aFlashBox;
	GroupBox            aEffectBox;

	RadioButton         aHighBtn;
	RadioButton         aNormalBtn;
	RadioButton         aDeepBtn;
	GroupBox            aPositionBox;

	FixedText           aEscRelPosText;
	MetricField         aEscRelPosEdit;
	FixedText           aEscRelSizeText;
	MetricField         aEscRelSizeEdit;
	CheckBox            aAutoPosBox;
	GroupBox            aPosExtBox;

	ListBox             aKerningListBox;
	FixedText           aKerningText;
	MetricField         aKerningEdit;
	CheckBox            aAutoKernBtn;
	GroupBox            aKerningBox;

	FixedText           aUnderlineText;
	ListBox             aUnderlineBox;
	FixedText           aStrikeoutText;
	ListBox             aStrikeoutBox;
	CheckBox            aWordBox;

	SvxFontPrevWindow   aExampleWin;
	GroupBox            aExampleBox;

	Timer               aDelayTimer;
	FASTBOOL			bInReset;
	short               nSuperEsc;
	short               nSubEsc;
	BYTE                nSuperProp;
	BYTE                nSubProp;
	BOOL 				nHtmlMode;
};

#endif // #ifndef _SVX_CHARDLG_HXX


