/*************************************************************************
 *
 *  $RCSfile: optinet2.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:00:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_OPTINET_HXX
#define _SVX_OPTINET_HXX

#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif

/*
#ifndef _CNTAPI_HXX //autogen
#include <chaos/cntapi.hxx>
#endif
#ifndef TF_UCB
#ifndef _CNTCOOK_HXX //autogen
#include <chaos/cntcook.hxx>
#endif
#endif
*/

#ifdef _SVX_OPTINET2_CXX
#ifndef _HEADBAR_HXX //autogen
#include <svtools/headbar.hxx>
#endif
struct UiAgentItem;
#else
class HeaderBar;
#endif

class SfxFilter;

#ifndef SV_NODIALOG
#define PROXY_CONTROLS 	23
#define CACHE_CONTROLS 	20
#define INET_SEARCH 	19

#if defined(OS2) || defined(MAC)
#define TYPE_CONTROLS  20
#else
#define TYPE_CONTROLS  18
#endif

// class TwoString -------------------------------------------------------

#ifdef _SVX_OPTINET2_CXX
class TwoString
{
public:
	String 	aKeyName;
	String 	aKeyContent;

			TwoString(const String& rName, const String& rContent)
				{ aKeyName = rName; aKeyContent = rContent; }

	int 	operator ==(TwoString& rTwo) const
				{return aKeyName == rTwo.aKeyName;}

	int 	operator<(TwoString& rTwo) const
				{return aKeyName < rTwo.aKeyName;}
};
#else
class TwoString;
#endif

// class SvxNoSpaceEdit --------------------------------------------------

class SvxNoSpaceEdit : public Edit
{
private:
	BOOL			bOnlyNumeric;

public:
	SvxNoSpaceEdit(Window* pParent, ResId rResId, BOOL bNum = FALSE ) :
		Edit( pParent, rResId ), bOnlyNumeric( bNum ) {}

	virtual void	KeyInput( const KeyEvent& rKEvent );
	virtual void	Modify();
};

typedef TwoString* TwoStringPtr;
SV_DECL_PTRARR_SORT( TwoStringArr, TwoStringPtr, 0, 4 )
typedef SfxFilter* SfxFilterPtr;
SV_DECL_PTRARR( SfxFilterPtrArr, SfxFilterPtr, 0, 4 )

// class SvxProxyTabPage -------------------------------------------------

class SvxProxyTabPage : public SfxTabPage
{
private:
	GroupBox		aOptionGB;

	FixedText 		aProxyModeFT;
	ListBox			aProxyModeLB;

	FixedText		aHttpProxyFT;
	SvxNoSpaceEdit	aHttpProxyED;
	FixedText		aHttpPortFT;
	SvxNoSpaceEdit 	aHttpPortED;

	FixedText		aFtpProxyFT;
	SvxNoSpaceEdit	aFtpProxyED;
	FixedText		aFtpPortFT;
	SvxNoSpaceEdit 	aFtpPortED;

	FixedText		aSocksProxyFT;
	SvxNoSpaceEdit	aSocksProxyED;
	FixedText		aSocksPortFT;
	SvxNoSpaceEdit 	aSocksPortED;

	FixedText		aSecurityProxyFT;
	SvxNoSpaceEdit	aSecurityProxyED;
	FixedText		aSecurityPortFT;
	SvxNoSpaceEdit 	aSecurityPortED;

	FixedText		aNoProxyForFT;
	Edit			aNoProxyForED;
	FixedText		aNoProxyDescFT;
#ifdef _SVX_OPTINET2_CXX
	void 			EnableControls_Impl(BOOL bEnable);

	DECL_LINK( ProxyHdl_Impl, ListBox * );
	DECL_LINK( LoseFocusHdl_Impl, Edit * );
#endif

	SvxProxyTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxProxyTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class SvxCacheTabPage -------------------------------------------------

class SvxCacheTabPage : public SfxTabPage
{
private:
	GroupBox		aOptionGB;
	FixedText		aMemFT;
	NumericField	aMemED;
	FixedText		aDocsFT;
	PushButton		aDelMemPB;
	FixedText		aDiskFT;
	NumericField 	aDiskED;
	FixedText		aBytesFT;
	PushButton		aDelDiskPB;
	FixedText		aExpireFT;
	ListBox			aExpireLB;
	PushButton		aReorganizePB;
	CheckBox		aExpiredCB;
	GroupBox        aNoCacheGB;
	FixedText		aServerFT;
	SvxNoSpaceEdit 	aNoCacheED;
	FixedText		aDelimFT;

	BOOL			bOldExpired 	: 1;

#ifdef _SVX_OPTINET2_CXX
	DECL_LINK( DeleteHdl_Impl, PushButton * );
	void				SetExpireLBValue( USHORT );
	USHORT				GetExpireLBValue() const;
#endif

	SvxCacheTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxCacheTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class SvxSearchTabPage ------------------------------------------------

class SvxSearchTabPage : public SfxTabPage
{
private:
	GroupBox		aSearchGB;
	ListBox			aSearchLB;
	FixedText		aSearchNameFT;
	SvxNoSpaceEdit	aSearchNameED;

	FixedText		aSearchFT;
	RadioButton		aAndRB;
	RadioButton		aOrRB;
	RadioButton		aExactRB;

	FixedText		aURLFT;
	SvxNoSpaceEdit	aURLED;

	FixedText		aPostFixFT;
	SvxNoSpaceEdit	aPostFixED;
	FixedText		aSeparatorFT;
	SvxNoSpaceEdit	aSeparatorED;
	FixedText		aCaseFT;
	ListBox	 		aCaseED;

	PushButton		aNewPB;
	PushButton		aAddPB;
	PushButton		aChangePB;
	PushButton		aDeletePB;

	TwoStringArr	aSearchKeys;
	String			aCaseArr[3];
	String			sAndSave;
	String			sOrSave;
	String			sExactSave;

	String 			sLastSelectedEntry;
	String			sError;
	String			sErrorNoFile;
	String			sErrorNoGroup;

	Timer			aErrorTimer;

#ifdef _SVX_OPTINET2_CXX
	void 			FillSearchBox_Impl();
	String 			GetSearchString_Impl();

	DECL_LINK( NewSearchHdl_Impl, PushButton * );
	DECL_LINK( AddSearchHdl_Impl, PushButton * );
	DECL_LINK( ChangeSearchHdl_Impl, PushButton * );
	DECL_LINK( DeleteSearchHdl_Impl, PushButton * );
	DECL_LINK( SearchEntryHdl_Impl, ListBox * );
	DECL_LINK( SearchModifyHdl_Impl, SvxNoSpaceEdit * );
	DECL_LINK( SearchPartHdl_Impl, RadioButton * );
	DECL_LINK( ErrorHdl_Impl, Timer * );
#endif

	SvxSearchTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxSearchTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class SvxTypeTabPage --------------------------------------------------

class SvxTypeTabPage : public SfxTabPage
{
private:
	GroupBox		aTypeGB;
	SvTabListBox			aTypeLB		;
	FixedText		aTypeFT		;
	Edit 			aTypeED		;
	FixedText		aClipFT		;
	Edit			aClipED		;
	FixedText		aExtFT		;
	Edit			aExtED		;
#if defined( PM2 ) || defined (MAC)
	FixedText		aExtAttrFT	;
	Edit			aExtAttrED	;
#endif
	FixedText		aOpenFT		;
	ListBox			aOpenLB		;
	FixedText		aFilterFT	;
	ListBox			aFilterLB	;
	FixedText		aAppFT		;
	Edit            aAppED		;
	PushButton		aAddTypePB	;
	PushButton		aChgTypePB	;
	PushButton		aDelTypePB	;
	PushButton		aSearchAppPB;

	SfxFilterPtrArr	aNewFilters;
	SfxFilterPtrArr	aDelFilters;

#ifdef _SVX_OPTINET2_CXX
	void			InitTypeBox_Impl();

	DECL_LINK( SelectTypeHdl_Impl, 	ListBox * ); //Hdl fuer Listbox
	DECL_LINK( SelectOpenHdl_Impl, 	ListBox * ); //Gruppe auswaehlen
	DECL_LINK( SelectAppHdl_Impl, 	ListBox * ); //Applikation suchen
	DECL_LINK( AddChgTypeHdl_Impl, 	PushButton * );
	DECL_LINK( DelTypeHdl_Impl, 	PushButton * );
	DECL_LINK( SearchAppHdl_Impl, 		PushButton * );
	DECL_LINK( ModifyTypeCtrls_Impl, 	Edit*);
#endif

	SvxTypeTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxTypeTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class SvxBrowserOtherTabPage ------------------------------------------

/*--------------------------------------------------
	Browser/Sonstiges
--------------------------------------------------*/

class SvxBrowserOtherTabPage : public SfxTabPage
{
private:
	// Java
	GroupBox 			aJavaGB;
	CheckBox			aJavaEnableCB;
	CheckBox			aJavaSecurityCB;
	FixedText			aJavaAccessFT;
	ListBox				aJavaAccessLB;
	FixedText 	 		aJavaClassPathFT;
	Edit				aJavaClassPathED;
	PushButton			aJavaClassPathBtn;
	// Execute
	GroupBox			aExecuteGB;
	CheckBox			aExePlugCB;
	// Applets
	GroupBox            aExecuteAppletsGB;
	CheckBox            aExecuteAppletsCB;
	// Homepage
	GroupBox			aHomePageGB;
	FixedText			aHomePageFT;
	SvxNoSpaceEdit		aHomePageED;
	// UserAgent
	GroupBox			aUserAgentGB;
	FixedText			aUserAgentFT;
	Edit				aUserAgentED;
	PushButton			aUserAgentPB;

	BOOL				bNoWarning; // Javascript disable Warning
	BOOL                bJavaScriptCB; // Status der JavaScriptCB

#ifdef _SVX_OPTINET2_CXX
	void				EnableJava_Impl( BOOL bEnable = TRUE );

	DECL_LINK( JavaEnableHdl_Impl, CheckBox* );
	DECL_LINK( UserAgentHdl_Impl, PushButton* );
	DECL_LINK( ClassPathHdl_Impl, PushButton* );
#endif
				SvxBrowserOtherTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual 	~SvxBrowserOtherTabPage();

protected:
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class SvxOtherTabPage -------------------------------------------------

class SvxOtherTabPage : public SfxTabPage
{
private:
	// HTTP
	GroupBox			aHttpGB;
	FixedText			aHttpMaxConnFT;
	NumericField		aHttpMaxConnNF;
	CheckBox			aHttpSendMailAddrCB;

	// FTP
	GroupBox			aFtpGB;
	FixedText			aFtpMaxConnFT;
	NumericField		aFtpMaxConnNF;

	// DNS Server
	GroupBox			aDNSGB;
	RadioButton			aDNSAutoRB;
	RadioButton			aDNSManualRB;
	PatternField		aDNSED;

	// Auf Standardbrowser pr"ufen?
	GroupBox			aStandardGB;
	CheckBox			aStandardCB;

	String				sMsg255_0;
	String				sMsg255_1;

#ifdef _SVX_OPTINET2_CXX
	DECL_LINK( AutoDNSHdl_Impl, RadioButton* );
#endif
	SvxOtherTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxOtherTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class SvxScriptingTabPage ---------------------------------------------

class SvxScriptingTabPage : public SfxTabPage
{
private:
	// Execute
	Edit				aEdtScriptExec;
	ListBox				aLbScriptExec;
	PushButton			aBtnScriptExecInsert;
	PushButton			aBtnScriptExecDelete;
	PushButton			aBtnScriptExecDefault;
	GroupBox 			aGrpScriptExec;

	// Scripting
	CheckBox			aCbxScriptingJava;
	GroupBox			aGrpScriptingJava;

	RadioButton 		aRbtExecStarBasicAlways;
	RadioButton 		aRbtExecStarBasicList;
	RadioButton 		aRbtExecStarBasicNever;
	FixedInfo    		aFiExecStarBasicAlways;
	FixedInfo    		aFiExecStarBasicList;
	FixedInfo    		aFiExecStarBasicNever;
	GroupBox			aGrpScriptingStarBasic;

#ifdef _SVX_OPTINET2_CXX
	DECL_LINK( EditHdl_Impl, Edit* );
	DECL_LINK( LBHdl_Impl, ListBox* );
	DECL_LINK( BtnHdl_Impl, PushButton* );
	DECL_LINK( RadioBtnHdl_Impl, RadioButton* );

	void				FillListBox_Impl();
#endif
				SvxScriptingTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual 	~SvxScriptingTabPage();

protected:
	virtual void        ActivatePage( const SfxItemSet& rSet );
	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class HeaderTabListBox ------------------------------------------------

class HeaderTabListBox : public SvTabListBox
{
	BOOL		bFirstPaint;
	HeaderBar* 	pHead;
#ifdef _SVX_OPTINET2_CXX
	DECL_LINK(TabBoxScrollHdl_Impl, SvTabListBox*);
#endif
public:
		HeaderTabListBox(Window*, WinBits);
		virtual void Paint(const Rectangle&);
	void InitHeaderBar(HeaderBar* pNew);
};

// class SvxCookiesTabPage -----------------------------------------------

class CntHTTPCookie;
class CntHTTPCookieList;
class CntHTTPCookieManager;
struct CookiesPage_Impl;

class SvxCookiesTabPage : public SfxTabPage
{
private:
	GroupBox 			aGB_Handling;
	RadioButton 	   	aRB_Send;
	RadioButton 	   	aRB_Ignore;
	RadioButton 	   	aRB_Interactive;
	Window			   	aWin_ListBox;
	PushButton 			aPB_Delete;
	PushButton 			aPB_Dis_Enable;

	String				aSTR_Status;
	String				aSTR_Domain;
	String				aSTR_Path;
	String				aSTR_Name;
	String 				aSTR_Expires;
	String				aSTR_Content;
	String				aSTR_Secure;
	String				aSTR_EnableBtn;
	String				aSTR_DisableBtn;
	String				aSTR_DeleteCookie;

	HeaderBar*			pHeaderBar;
	HeaderTabListBox*  	pLB_Cookies;

/* chaos raus
	CntAnchorRef			xAnchor;
#ifndef TF_UCB
	CntHTTPCookieManagerRef	xCookMgr;
#endif
*/
	CntHTTPCookieList*		pCookLst;
	CookiesPage_Impl*		pImpl;

	Color					aTextColor;

	String 					GetEntryText_Impl(CntHTTPCookie* pAct);

#ifdef _SVX_OPTINET2_CXX
	DECL_LINK(HeaderEndDrag_Impl, HeaderBar*);
	DECL_LINK(CookieAction_Impl, PushButton*);
	DECL_LINK(SelectHdl_Impl, void*);
	DECL_LINK(HandlingHdl_Impl, RadioButton*);

	void 					UpdateButtons_Impl();
	void					FillListBox_Impl();
#endif

				SvxCookiesTabPage(Window* pParent, const SfxItemSet& rSet);
	virtual     ~SvxCookiesTabPage();

public:
	static SfxTabPage*  Create(Window* pParent, const SfxItemSet& rAttrSet);
	virtual BOOL        FillItemSet(SfxItemSet& rSet);
	virtual void        Reset(const SfxItemSet& rSet);
};

#endif

#endif // #ifndef _SVX_OPTINET_HXX


