/*************************************************************************
 *
 *  $RCSfile: optlingu.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:00:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_OPTLINGU_HXX
#define _SVX_OPTLINGU_HXX

// include ---------------------------------------------------------------

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_CHECKLBX_HXX //autogen
#include <checklbx.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

namespace com{namespace sun{namespace star{
namespace beans{
	class XPropertySet;
}
namespace linguistic{
	class XDictionary;
	class XSpellChecker1;
	class XOtherLingu;
	}}}}

// define ----------------------------------------------------------------

#define GROUP_SPELLING	((sal_uInt16)0x0001)
#define GROUP_HYPHEN	((sal_uInt16)0x0002)
#define GROUP_LANGUAGE	((sal_uInt16)0x0004)

// forward ---------------------------------------------------------------


// class SvxLinguTabPage -------------------------------------------------

class SvxLinguTabPage : public SfxTabPage
{
private:
	CheckBox			aCapsBtn;
	CheckBox			aNumsBtn;
	CheckBox			aUpLowBtn;
	CheckBox			aSpellSpecialBtn;
	CheckBox			aAllLangBtn;
	GroupBox			aAuditBox;
	SvxCheckListBox		aDictsLB;
	ToolBox				aDictsTbx;
	GroupBox			aDictsBox;
	CheckBox			aAutoCheckBtn;
	CheckBox			aMarkOffBtn;
	GroupBox			aAutoSpellBox;
	GroupBox			aGermanSpellBox;
	CheckBox			aGermanPreReformBtn;
	FixedText			aPreBreakText;
	NumericField		aPreBreakEdit;
	FixedText			aAfterBreakText;
	NumericField		aAfterBreakEdit;
	CheckBox			aAutoBtn;
	CheckBox			aSpecialBtn;
	GroupBox			aRulesBox;
	FixedText			aLanguageText;
	ListBox				aLanguageLB;

	String				aMaxWarning;
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::linguistic::XDictionary >  >	aDics;	//! snapshot copy to work with
	::com::sun::star::uno::Reference< ::com::sun::star::linguistic::XSpellChecker1 > 	xSpell;

	SvxLinguTabPage( Window* pParent, const SfxItemSet& rCoreSet );

#ifdef _SVX_OPTLINGU_CXX
	DECL_LINK( NewHdl_Impl, Button * );
	DECL_LINK( EditHdl_Impl, Button * );
	DECL_LINK( DeleteHdl_Impl, Button * );
	DECL_LINK( EraseHdl_Impl, Button * );
	DECL_LINK( CheckHdl_Impl, CheckBox * );
	DECL_LINK( BoxSelectHdl_Impl, ToolBox * );
	DECL_LINK( CheckDicHdl_Impl, SvxCheckListBox * );
	DECL_LINK( SelectDicHdl_Impl, SvxCheckListBox * );

	void				UpdateBox_Impl();
#endif

public:
	virtual				~SvxLinguTabPage();
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
	static sal_uInt16*		GetRanges();

	virtual	sal_Bool 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );

	void				HideGroups( sal_uInt16 nGrp );
	void				HideSpellCheckSpecial();
	void				EnableAutoSpelling();
};
/* -----------------------------27.01.00 12:08--------------------------------

 ---------------------------------------------------------------------------*/
class SvxExternalLinguTabPage : public SfxTabPage
{
	PushButton			aOptionsPB;
	ListBox				aLinguLB;
	GroupBox			aLinguGB;
	CheckBox			aStdSpellCB;
	CheckBox			aStdThesCB;
	CheckBox			aStdHyphCB;
	GroupBox			aSettingsGB;

	::com::sun::star::uno::Reference< ::com::sun::star::linguistic::XOtherLingu >  		xOtherLingu;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  	xLinguProps;

	DECL_LINK(LBSelectHdl_Impl, ListBox*);
	DECL_LINK(OptDlgHdl_Impl, PushButton*);

protected:
	SvxExternalLinguTabPage(Window* pParent, const SfxItemSet& rSet);
	~SvxExternalLinguTabPage();

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );

	virtual	sal_Bool 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};


#endif

