/*************************************************************************
 *
 *  $RCSfile: optmail.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:00:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_OPTMAIL_HXX
#define _SVX_OPTMAIL_HXX

// include ---------------------------------------------------------------

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
//#ifndef _CNTBASE_HXX //autogen
//#include <chaos/cntbase.hxx>
//#endif
#ifndef _CTRLBOX_HXX // FontSizeBox
#include <svtools/ctrlbox.hxx>
#endif

// class SfxINetTabPage -------------------------------------------------

#ifndef SV_NODIALOG

class FontList;

class SvxMailTabPage : public SfxTabPage
{
private:
	FixedText		aSendFT;
	Edit			aSendED;
	FixedText		aReceiveFT;
	Edit			aReceiveED;
	GroupBox		aServerGB;

	FixedText		aUserFT;
	Edit			aUserED;
	FixedText		aPasswdFT;
	Edit			aPasswdED;
	GroupBox		aUserGB;

	FixedText		aNewsServerFT;
	Edit        	aNewsServerED;
	GroupBox		aNewsGB;

	CheckBox		aHtmlCB;
	CheckBox		aRtfCB;
	CheckBox		aOfficeCB;
	FixedLine		aLine;
	FixedText		aFontSizeFT;
	FontSizeBox		aFontSizeBox;
	GroupBox		aFormatGB;

	CheckBox		aReadTimerOnCB;
	FixedText		aReadTimerOutFT;
	NumericField	aReadTimerOutED;
	FixedText		aReadTimerSecFT;
	GroupBox		aReadTimerBox;
	CheckBox		aAutoLoadCB;

	FontList*		pFontList;

	SvxMailTabPage( Window* pParent, const SfxItemSet& rSet );
	virtual ~SvxMailTabPage();

	BOOL				CheckEditValue( Edit& rEdit, sal_uInt32 eType, USHORT nSlot );

	DECL_LINK( CheckHdl_Impl, CheckBox * );

protected:
	virtual int			DeactivatePage( SfxItemSet* pSet );

public:
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

#endif // #ifndef SV_NODIALOG

#endif // #ifndef _SVX_OPTMAIL_HXX


