/*************************************************************************
 *
 *  $RCSfile: thesdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_THESDLG_HXX
#define _SVX_THESDLG_HXX

// include ---------------------------------------------------------------

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SVX_STDDLG_HXX //autogen
#include "stddlg.hxx"
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif

// forward ---------------------------------------------------------------

struct ThesDlg_Impl;

class SvxThesaurusLanguageDlg_Impl;
namespace com{namespace sun{namespace star{
namespace linguistic{
	class XThesaurus;
	class XMeaning;
	}}}}

// class SvxThesaurusDialog ----------------------------------------------

class SvxThesaurusDialog : public SvxStandardDialog
{
public:
	friend class SvxThesaurusLanguageDlg_Impl;

	SvxThesaurusDialog( Window* pParent, ::com::sun::star::uno::Reference< ::com::sun::star::linguistic::XThesaurus >  xThesaurus,
						const String &rWord, sal_Int16 nLanguage );
	~SvxThesaurusDialog();


#ifndef ENABLEUNICODE
	String 			GetWord() { return aReplaceEdit.GetText(); }
#else
	UniString			GetWord() { return aReplaceEdit.GetText(); }
#endif
	sal_uInt16			GetLanguage() const;

private:
	FixedText		aWordText;
	ListBox 		aWordLB;
	FixedText		aReplaceText;
	Edit  			aReplaceEdit;
	FixedText		aMeanText;
	ListBox			aMeanLB;
	FixedText		aSynonymText;
	ListBox			aSynonymLB;
	GroupBox	    aVarBox;

	OKButton		aOkBtn;
	CancelButton	aCancelBtn;
	PushButton		aLookUpBtn;
	PushButton		aLangBtn;
	HelpButton		aHelpBtn;

#ifndef ENABLEUNICODE
	String			aErrStr;
#else
	UniString			aErrStr;
#endif

	ThesDlg_Impl*	pImpl;		// always != NULL

	virtual void 	Apply();

#ifdef _SVX_THESDLG_CXX
	void 			UpdateSynonymBox_Impl();
	void 			UpdateMeaningBox_Impl( ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::linguistic::XMeaning >  > *pMeaningSeq = NULL );
	void			Init_Impl(sal_Int16 nLanguage);
	// Handler
	DECL_LINK( SelectHdl_Impl, ListBox * );
	DECL_LINK( SynonymHdl_Impl, ListBox * );
	DECL_LINK( LookUpHdl_Impl, Button * );
	DECL_LINK( LanguageHdl_Impl, Button * );
	DECL_LINK( EntryHdl_Impl, ListBox * );
	DECL_LINK( SpellErrorHdl_Impl, void * );
#endif
};


#endif

