/*************************************************************************
 *
 *  $RCSfile: unomid.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_UNOMID_HXX
#define _SVX_UNOMID_HXX

// SvxSizeItem
#define MID_SIZE_SIZE		0
#define MID_SIZE_WIDTH      1
#define MID_SIZE_HEIGHT     2

//LRSpaceItem
#define MID_LR_MARGIN		0
#define MID_LRP_MARGIN  	1
#define MID_LR_REL_MARGIN	2
#define MID_LRP_REL_MARGIN  3
#define MID_L_MARGIN		4
#define MID_R_MARGIN		5
#define MID_L_REL_MARGIN	6
#define MID_R_REL_MARGIN	7
#define MID_FIRST_LINE_INDENT	 	8
#define MID_FIRST_LINE_REL_INDENT   9
#define MID_FIRST_AUTO				10

//ULSpaceItem
#define MID_UL_MARGIN		0
#define MID_UL_REL_MARGIN	1
#define MID_UP_MARGIN		2
#define MID_LO_MARGIN		3
#define MID_UP_REL_MARGIN	4
#define MID_LO_REL_MARGIN	5

//SvxBoolItem
#define MID_BOLD			0
#define MID_WEIGHT          1

//SvxPostureItem
#define MID_ITALIC          0
#define MID_POSTURE         1

//SvxFontHeightItem
#define MID_FONTHEIGHT     	0
#define MID_FONTHEIGHT_PROP 1
#define MID_FONTHEIGHT_DIFF 2

//SvxFontWidthItem
#define MID_FONTWIDTH     	0
#define MID_FONTWIDTH_PROP  1

//SvxUnderlineItem
#define MID_UNDERLINED		0
#define MID_UNDERLINE		1

//SvxCrossedOutItem
#define MID_CROSSED_OUT		0
#define MID_CROSS_OUT       1

//SvxExcapementItem
#define MID_ESC			 0
#define MID_ESC_HEIGHT   1
#define MID_AUTO_ESC     2

//SvxLanguageItem
#define MID_LANGUAGE		0
#define MID_COUNTRY			1
#define MID_LANG_COUNTRY	2

//BrushItem
#define MID_BACK_COLOR			0
#define MID_GRAPHIC_POSITION    1
#define MID_GRAPHIC_LINK        2
#define MID_GRAPHIC             3
#define MID_GRAPHIC_TRANSPARENT 4
#define MID_GRAPHIC_URL        	5
#define MID_GRAPHIC_FILTER     	6
#define MID_GRAPHIC_REPEAT     	7

//ProtectItem
#define MID_PROTECT_CONTENT		0
#define MID_PROTECT_SIZE        1
#define MID_PROTECT_POSITION    2

//AdjustItem
#define MID_PARA_ADJUST			0
#define MID_LAST_LINE_ADJUST    1
#define MID_EXPAND_SINGLE       2

//SvxPageItem
#define MID_PAGE_NUMTYPE		0
#define MID_PAGE_ORIENTATION    1
#define MID_PAGE_LAYOUT         2

//SvxMarginItem
#define MID_MARGIN_LR_MARGIN	0
#define MID_MARGIN_UL_MARGIN	1
#define MID_MARGIN_L_MARGIN		2
#define MID_MARGIN_R_MARGIN		3
#define MID_MARGIN_UP_MARGIN	4
#define MID_MARGIN_LO_MARGIN	5

//SvxBoxItem
#define LEFT_BORDER  			0
#define RIGHT_BORDER            1
#define TOP_BORDER              2
#define BOTTOM_BORDER           3
#define BORDER_DISTANCE         4
#define LEFT_BORDER_DISTANCE    5
#define RIGHT_BORDER_DISTANCE   6
#define TOP_BORDER_DISTANCE     7
#define BOTTOM_BORDER_DISTANCE  8

#define ALL_BORDER					10
#define ALL_BORDER_PADDING			11
#define LEFT_BORDER_PADDING			12
#define RIGHT_BORDER_PADDING		13
#define TOP_BORDER_PADDING			14
#define BOTTOM_BORDER_PADDING		15
#define ALL_BORDER_LINE_WIDTH		16
#define LEFT_BORDER_LINE_WIDTH		17
#define RIGHT_BORDER_LINE_WIDTH		18
#define TOP_BORDER_LINE_WIDTH		19
#define BOTTOM_BORDER_LINE_WIDTH	20

//SvxFontItem
#define MID_FONT_FAMILY_NAME 	0
#define MID_FONT_STYLE_NAME     1
#define MID_FONT_FAMILY         2
#define MID_FONT_CHAR_SET       3
#define MID_FONT_PITCH          4

//SvxHyphenZoneItem
#define MID_IS_HYPHEN	      	0
#define MID_HYPHEN_MIN_LEAD     1
#define MID_HYPHEN_MIN_TRAIL    2
#define MID_HYPHEN_MAX_HYPHENS  3

//SvxFmtBreakItem
#define MID_BREAK_BEFORE		0
#define MID_BREAK_AFTER			1

//SvxCaseMapItem
#define MID_CASEMAP_VARIANT		0
#define MID_CASEMAP_TRANS		1

//SvxLineSpaceItem
#define MID_LS_FIXED			0
#define MID_LS_MINIMUM			1
#define MID_LS_DISTANCE			2

//SvxLanguageItem
#define MID_LANG_INT			0
#define MID_LANG_LOCALE			1

//NameOrIndex
#define MID_NAME				16
#define MID_GRAFURL				32


#endif

