/*************************************************************************
 *
 *  $RCSfile: ctrdial.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <math.h>
#pragma hdrstop

#include "ctrdial.hxx"

#ifndef _SV_BITMAP_HXX
#include <vcl/bitmap.hxx>
#endif
#ifndef _SV_SYSTEM_HXX
#include <vcl/system.hxx>
#endif

/*************************************************************************
#*	Member:		SvxCtrDial										Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Konstruktor der Klasse SvxCtrDial
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

SvxCtrDial::SvxCtrDial( Window* pParent,Size aWinSize, WinBits nWinStyle) :
					Control( pParent, nWinStyle ),
					aVDev()
{
	nDelta=0;
	if(pParent!=NULL)
	{
		aRotFont=pParent->GetFont();
		aBgColor=pParent->GetBackground().GetColor();
	}
	aRotFont.SetTransparent(TRUE);
	aRotFont.SetColor(Color(COL_BLUE));
	SetOutputSizePixel(aWinSize);
	aVDev.SetOutputSize(aWinSize);
	nCenterX=aWinSize.Width() / 2;
	nCenterY=aWinSize.Height() / 2;
	aDrawRect=Rectangle(Point(0,0),aWinSize);

	aVDev.SetFont(aRotFont);
	SetFont(aRotFont);

	aVDev.SetFillColor( aBgColor );
	SetBackground();
	SetFillColor( aBgColor );
	bFirstDraw=TRUE;
}

/*************************************************************************
#*	Member:		SvxCtrDial									Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Konstruktor der Klasse SvxCtrDial
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

SvxCtrDial::SvxCtrDial( Window* pParent,Size aWinSize, Font aFont, WinBits nWinStyle) :
					Control( pParent, nWinStyle ),
					aVDev()
{
	nDelta=0;
	if(pParent!=NULL)
		aBgColor=pParent->GetBackground().GetColor();
	aRotFont=aFont;
	aRotFont.SetTransparent(TRUE);
	aRotFont.SetColor(Color(COL_BLUE));
	SetOutputSizePixel(aWinSize);
	aVDev.SetOutputSize(aWinSize);
	nCenterX=aWinSize.Width() / 2;
	nCenterY=aWinSize.Height() / 2;
	aDrawRect=Rectangle(Point(0,0),aWinSize);

	aVDev.SetFont(aRotFont);
	SetFont(aRotFont);

	aVDev.SetFillColor( aBgColor );
	SetBackground();
	SetFillColor( aBgColor );
	bFirstDraw=TRUE;
}

/*************************************************************************
#*	Member:		SvxCtrDial									Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		MD_Test
#*
#*  Funktion:	Konstruktor der Klasse SvxCtrDial
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

SvxCtrDial::SvxCtrDial( Window* pParent, const ResId& rResId) :
					Control( pParent, rResId ),
					aVDev()
{
	nDelta = 0;
	aRotFont=System::GetStandardFont(STDFONT_SWISS);
	if(pParent!=NULL)
	{
		aBgColor = pParent->GetBackground().GetColor();
	}
	aRotFont.SetTransparent(TRUE);
	aRotFont.SetColor(Color(COL_BLUE));
	Size aWinSize  = GetOutputSizePixel();
	aVDev.SetOutputSize(aWinSize);
	nCenterX=aWinSize.Width() / 2;
	nCenterY=aWinSize.Height() / 2;
	aDrawRect=Rectangle(Point(0,0),aWinSize);

	aVDev.SetFillColor( aBgColor );
	aVDev.SetFont(aRotFont);
	SetFont(aRotFont);
	SetBackground();
	SetFillColor( aBgColor );
	bFirstDraw=TRUE;
}

/*************************************************************************
#*	Member:		DrawMyPoint									Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Zeichnet einen blauen 5x5 Punkt
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::DrawMyPoint(Point aPos,short PoiSize,Color aCol)
{
	Color aColor = GetFillColor();
	PoiSize=PoiSize>>1;

	SetFillColor( aCol );
	Rectangle aRect(aPos.X()-PoiSize,aPos.Y()-PoiSize,
						aPos.X()+PoiSize,aPos.Y()+PoiSize);
	DrawEllipse(aRect);
	SetFillColor(aColor);
}

/*************************************************************************
#*	Member:		DrawBackground								Datum:12.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Zeichnet den Hintergrund mit der Kreisscheibe.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::DrawBackground()
{
	aVDev.SetLineColor();
	aVDev.SetFillColor( aBgColor );
	aVDev.DrawRect( aDrawRect );

	aVDev.SetFillColor();
	aVDev.SetLineColor( Color( COL_BLACK ) );
}

/*************************************************************************
#*	Member:		DrawShadow									Datum:12.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Zeichnet den Hintergrund mit der Kreisscheibe.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::DrawShadow()
{
	Color aColor=Color(COL_WHITE);

	USHORT nRed=aColor.GetRed();
	USHORT nGreen=aColor.GetGreen();
	USHORT nBlue=aColor.GetBlue();

	aVDev.SetLineColor( aColor );
	aVDev.DrawArc(aDrawRect,aDrawRect.TopRight(),aDrawRect.BottomLeft());
	aVDev.SetLineColor();

	Rectangle a2Rect=aDrawRect;

	aColor.SetRed(nRed-0x10);
	aColor.SetGreen(nGreen-0x10);
	aColor.SetBlue(nBlue-0x10);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.TopLeft(),a2Rect.LeftCenter());

	aColor.SetRed(nRed-0x21);
	aColor.SetGreen(nGreen-0x21);
	aColor.SetBlue(nBlue-0x21);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.LeftCenter(),a2Rect.BottomLeft());

	aColor.SetRed(nRed-0x31);
	aColor.SetGreen(nGreen-0x31);
	aColor.SetBlue(nBlue-0x31);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.BottomLeft(),a2Rect.BottomCenter());

	aColor.SetRed(nRed-0x39);
	aColor.SetGreen(nGreen-0x39);
	aColor.SetBlue(nBlue-0x39);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.BottomCenter(),a2Rect.BottomRight());

	aColor.SetRed(nRed-(BYTE)0x4F);
	aColor.SetGreen(nGreen-(BYTE)0x4F);
	aColor.SetBlue(nBlue-(BYTE)0x4F);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.BottomRight(),a2Rect.RightCenter());

	aColor.SetRed(nRed-0x39);
	aColor.SetGreen(nGreen-0x39);
	aColor.SetBlue(nBlue-0x39);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.RightCenter(),a2Rect.TopRight());

	aColor.SetRed(nRed-0x31);
	aColor.SetGreen(nGreen-0x31);
	aColor.SetBlue(nBlue-0x31);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.TopRight(),a2Rect.TopCenter());

	aColor.SetRed(nRed-0x21);
	aColor.SetGreen(nGreen-0x21);
	aColor.SetBlue(nBlue-0x21);

	aVDev.SetFillColor( aColor );

	aVDev.DrawPie(a2Rect,a2Rect.TopCenter(),a2Rect.TopLeft());
}



/*************************************************************************
#*	Member:		DrawCalibration								Datum:12.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Zeichnet die Gradeinteilung
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::DrawCalibration()
{
	double pi = 3.1415926535;
	short  i=0;
	double nAlpha=nDelta/1800.*pi;
	short nX=(short)(-30* cos(nAlpha));
	short nY=(short)(30* sin(nAlpha));
	Point aStartPos( nCenterX,nCenterY);
	Point aPos( nCenterX-nX,nCenterY-nY);

	Color aWhiteColor( COL_WHITE );
	Color aBlackColor( COL_BLACK );

	Rectangle a3Rect(aDrawRect.Left()+3,aDrawRect.Top()+3,
					aDrawRect.Right()-3,aDrawRect.Bottom()-3);

	aVDev.SetFillColor( aBgColor );

	aVDev.SetLineColor( Color( COL_BLUE ) );

	for(i=0;i<360;i+=15)
	{
		nAlpha=i/180.*pi;
		nX=(short)(-nCenterX* cos(nAlpha));
		nY=(short)(nCenterY* sin(nAlpha));
		aStartPos=Point( nCenterX,nCenterY);
		if(nY>0)
			aPos=Point( nCenterX-nX,nCenterY-nY);
		else
			aPos=Point( nCenterX-nX,nCenterY-nY-1);

		aVDev.DrawLine(aStartPos,aPos);

	}
	Rectangle a4Rect(a3Rect.Left()+5,a3Rect.Top()+5,
					a3Rect.Right()-5,a3Rect.Bottom()-5);

	aVDev.SetLineColor( aBlackColor );


	aVDev.SetFillColor( Color(0xCF,0xCF,0xCF) );
	aVDev.DrawEllipse(a4Rect );

	aVDev.SetLineColor( aWhiteColor );
	aVDev.DrawArc(a4Rect,a4Rect.BottomLeft(),a4Rect.TopRight());

	aVDev.SetLineColor( aBlackColor );
	aVDev.SetFillColor();
	aVDev.DrawArc(aDrawRect,aDrawRect.BottomLeft(),aDrawRect.TopRight());
	aVDev.SetLineColor( aWhiteColor );
	aVDev.DrawArc(aDrawRect,aDrawRect.TopRight(),aDrawRect.BottomLeft());
}

/*************************************************************************
#*	Member:		OffScreenPaint								Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Zeichnet die Kreisscheibe im Hintergrund
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::OffScreenPaint()
{
	Point tl=aDrawRect.TopLeft();
	Size aSiz=aDrawRect.GetSize();

	DrawBackground();
	DrawShadow();
	DrawCalibration();
}

/*************************************************************************
#*	Member:		Paint										Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Aktualisiert den Control und zeichnet den
#*				gedrehten Text.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::Paint( const Rectangle& aRect )
{

	BOOL bEnabledFlag=IsEnabled();
	double pi = 3.1415926535;
	String aText=GetText();
	Rectangle a4Rect(aDrawRect.Left()+8,aDrawRect.Top()+8,
					aDrawRect.Right()-8,aDrawRect.Bottom()-8);


	//Control::Paint( aRect );

	Font aFont=aRotFont;
	aFont.SetColor(Color(COL_GRAY));
	Point tl(0,0);
	Size aSiz=aDrawRect.GetSize();

	if(bFirstDraw)
	{

		OffScreenPaint();
		bFirstDraw=FALSE;
	}
	DrawBitmap(tl,aVDev.GetBitmap(tl,aSiz));

	double nAlpha=nDelta/1800.*pi;
	double nWidth = GetTextWidth( aText );
	double nHeight = GetTextHeight();
	short nX=(short)(-(nCenterX-4)* cos(nAlpha));
	short nY=(short)((nCenterY-4)* sin(nAlpha));
	Point aStartPos( nCenterX,nCenterY);
	Point aPos( nCenterX-nX,nCenterY-nY);

	Point a2Pos( (short)(nCenterX-nWidth*cos(nAlpha)/2-sin(nAlpha)*nHeight/2),
				(short)(nCenterY+nWidth*sin(nAlpha)/2-cos(nAlpha)*nHeight/2));


	if (!bEnabledFlag)
	{

		SetFillColor( aBgColor );
		DrawEllipse(a4Rect );

		SetFont(aFont);
	}

	DrawText( a2Pos, aText );

	//DrawCtrlText( a2Pos, aText,0,STRING_LEN,CTRLTEXT_DRAW_DISABLE);

	if( nDelta==0    || nDelta == 450  || nDelta==900  || nDelta==1350 ||
		nDelta==1800 || nDelta == 2250 || nDelta==2700 || nDelta==3150 || nDelta==3600)
	{
		if(bEnabledFlag)
		{
			DrawMyPoint(aPos,6,COL_YELLOW);
		}
		else
		{
			DrawMyPoint(aPos,6,COL_GRAY);
		}
	}
	else
	{
		if(bEnabledFlag)
		{
			DrawMyPoint(aPos,4,COL_BLUE);
		}
		else
		{
			DrawMyPoint(aPos,4,COL_GRAY);
		}
	}
	if (!bEnabledFlag)
	{
		SetFont(aRotFont);
	}

}

/*************************************************************************
#*	Member:		KeyInput									Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Reagiert auf die Tasten '+' und '-'. Dadurch
#*				kann der Text gradweise gedreht werden.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::KeyInput( const KeyEvent& rKeyEvt )
{
	Size aSize(10,10);

	switch( rKeyEvt.GetCharCode() )
	{

		case '+':

				nDelta+=10;
				if(nDelta>3590) nDelta=0;
				break;

		case '-':

				nDelta-=10;
				if(nDelta<0) nDelta=3590;
				break;

		default:

		Control::KeyInput( rKeyEvt );
		return;
		break;
	}
	aRotFont.SetOrientation( nDelta );
	SetFont(aRotFont);
	//OffScreenPaint();
	Invalidate();
	Update();

}

/*************************************************************************
#*	Member:		MouseButtonDown								Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Reagiert auf einen einzelnen Mouse-Event. Hierbei
#*				wird die aktuelle Maus- Koordinate ermittelt und
#*				der entsprechende Winkel eingestellt. Anschliessend
#*				wird die Ausgabe aktualisiert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::MouseButtonDown( const MouseEvent& rMEvt )
{
	double pi = 3.1415926535;
	double x;
	double y;
	double h,h1;
	double nAlpha;
	Point aPos=rMEvt.GetPosPixel();

	CaptureMouse();

	if(rMEvt.IsLeft())
	{
		x=aPos.X()-nCenterX;
		y=nCenterY-aPos.Y();

		h=sqrt(x*x+y*y);

		if(h!=0)
		{
			h1=acos(x/h);
			nAlpha= 1800./pi*(h1);
			if(y>=0)
			{
				nDelta=(short) (150.*floor(nAlpha/150.+0.5));
			}
			else
			{
				nDelta=(short) (150.*floor((3600-nAlpha)/150.+0.5));
			}
			if(nDelta==3600) nDelta=0;
		}

		aRotFont.SetOrientation( nDelta );
		SetFont(aRotFont);
		Invalidate();
		Update();
		CtrModified();
	}
	Control::MouseButtonDown(rMEvt );
}

/*************************************************************************
#*	Member:		MouseButtonUp								Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Ende einer Benutzeraktion mit der Maus. Es werden
#*				die aktuelle Maus- Koordinate ermittelt und der
#*				entsprechende Winkel eingestellt. Anschliessend
#*				wird die Ausgabe aktualisiert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::MouseButtonUp( const MouseEvent& rMEvt )
{
	ReleaseMouse();

	Control::MouseButtonUp(rMEvt );
	CtrMouseUp();
}

/*************************************************************************
#*	Member:		MouseMove									Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Reagiert kontinuierlich auf Mausbewegungen. Hierbei
#*				wird die aktuelle Maus- Koordinate ermittelt und
#*				der entsprechende Winkel eingestellt. Anschliessend
#*				wird die Ausgabe aktualisiert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

void SvxCtrDial::MouseMove( const MouseEvent& rMEvt )
{

	double pi = 3.1415926535;
	double x;
	double y;
	double h,h1;
	double nAlpha;
	Point aPos=rMEvt.GetPosPixel();

	if(rMEvt.IsLeft() && IsMouseCaptured())
	{
		x=aPos.X()-nCenterX;
		y=nCenterY-aPos.Y();

		h=sqrt(x*x+y*y);

		if(h!=0)
		{
			h1=acos(x/h);
			nAlpha= 1800./pi*(h1);
			if(y>=0)
			{
				nDelta=(short) floor(nAlpha+0.5);
			}
			else
			{
				nDelta=(short) floor(3600.5-nAlpha);
			}
			if(nDelta==3600) nDelta=0;
		}

		aRotFont.SetOrientation( nDelta );
		SetFont(aRotFont);
		Invalidate();
		Update();
		CtrModified();
	}
	Control::MouseMove(rMEvt );

}

/*************************************************************************
#*	Member:		MouseMove									Datum:09.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Reagiert kontinuierlich auf Mausbewegungen. Hierbei
#*				wird die aktuelle Maus- Koordinate ermittelt und
#*				der entsprechende Winkel eingestellt. Anschliessend
#*				wird die Ausgabe aktualisiert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
USHORT SvxCtrDial::GetOrientation()
{
	return (USHORT ) nDelta/10;
}

/*************************************************************************
#*	Member:		MouseMove									Datum:08.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Reagiert kontinuierlich auf Mausbewegungen. Hierbei
#*				wird die aktuelle Maus- Koordinate ermittelt und
#*				der entsprechende Winkel eingestellt. Anschliessend
#*				wird die Ausgabe aktualisiert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
void SvxCtrDial::SetOrientation(short nAlpha)
{
	if(nAlpha>360)
	{
		nAlpha=nAlpha % 360;
	}
	else if(nAlpha<0)
	{
		nAlpha=nAlpha % 360;
		nAlpha=360+nAlpha;
	}

	nDelta=nAlpha*10;
	aRotFont.SetOrientation( nDelta );
	SetFont(aRotFont);
	Invalidate();
	Update();
}

/*************************************************************************
#*	Member:		CtrModified									Datum:11.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Teilt einem installierten Handler mit, dass
#*				eine Veraenderung eingetreten ist.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
void SvxCtrDial::CtrModified()
{
	aCtrModifiedLink.Call( this );
}

/*************************************************************************
#*	Member:		CtrModified									Datum:11.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Teilt einem installierten Handler mit, dass
#*				die Maus losgelassen wurde.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
void SvxCtrDial::CtrMouseUp()
{
	aMouseUpLink.Call( this );
}


