/*************************************************************************
 *
 *  $RCSfile: spldlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma hdrstop

// include ---------------------------------------------------------------
#include <tools/ref.hxx>

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SV_SYSTEM_HXX
#include <vcl/system.hxx>
#endif
#ifndef _SV_MENU_HXX
#include <vcl/menu.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _UNO_LINGU_HXX
#include <unolingu.hxx>
#endif

#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif
#ifndef _LINGU_LNGPROPS_HHX_
#include <lingu/lngprops.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_SPELLFAILURE_HPP_
#include <com/sun/star/linguistic/SpellFailure.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XOTHERLINGU_HPP_
#include <com/sun/star/linguistic/XOtherLingu.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XOTHERLINGU2_HPP_
#include <com/sun/star/linguistic/XOtherLingu2.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
#include <com/sun/star/frame/XStorable.hpp>
#endif


#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif


#define _SVX_SPLDLG_CXX

#include "dialogs.hrc"
#include "spldlg.hrc"

#define EXT_LINGU_DIC_ID	(sal_uInt16) (USHRT_MAX - 2)
#define ITEMID_SPELLCHECK	SID_ATTR_SPELL

#include "optitems.hxx"
#include "svxenum.hxx"
#include "spldlg.hxx"       // Der Dialog
#include "splwrap.hxx"      // Der Wrapper
#include "thesdlg.hxx"      // ThesaurusDlg
#include "dlgutil.hxx"		// language
#include "optlingu.hxx"
#include "dialmgr.hxx"
#include "svxerr.hxx"

using namespace ::rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::linguistic;

#define C2U(cChar) 					OUString::createFromAscii(cChar)
// misc functions ---------------------------------------------

void SvxPrepareAutoCorrect( String &rOldText, String &rNewText )
{
	// This function should be used to strip (or add) trailing '.' from
	// the strings before passing them on to the autocorrect function in
	// order that the autocorrect function will hopefully
	// works properly with normal words and abbreviations (with trailing '.')
	// independ of if they are at the end of the sentence or not.
	//
	// rOldText: text to be replaced
	// rNewText: replacement text

	xub_StrLen	nOldLen = rOldText.Len(),
				nNewLen = rNewText.Len();
	if (nOldLen && nNewLen)
	{
		sal_Bool bOldHasDot = sal_Unicode( '.' ) == rOldText.GetChar( nOldLen - 1 ),
			 bNewHasDot = sal_Unicode( '.' ) == rNewText.GetChar( nNewLen - 1 );
		if (bOldHasDot && !bNewHasDot
			/*this is: !(bOldHasDot && bNewHasDot) && bOldHasDot*/)
			rOldText.Erase( nOldLen - 1 );
	}
}

// class SvxClickInfoCtr ---------------------------------------------

SvxClickInfoCtr::SvxClickInfoCtr( SvxSpellCheckDialog* pParent, const ResId& rResId ) :
		Control( pParent, rResId ),
		aFixedInfo( this)
{
	aFixedInfo.SetSizePixel(GetOutputSizePixel());
	aFixedInfo.Show();
	pMyParent=pParent;
}

void SvxClickInfoCtr::MouseButtonDown( const MouseEvent& rMEvt )
{
	aActivateLink.Call(this);
}

long SvxClickInfoCtr::PreNotify( NotifyEvent& rNEvt )
{
	if(rNEvt.GetType()==EVENT_GETFOCUS || rNEvt.GetType()==EVENT_MOUSEBUTTONDOWN)
	{
		aActivateLink.Call(this);
	}

	return Control::PreNotify(rNEvt);
}

void SvxClickInfoCtr::SetText( const XubString& rStr )
{
	aFixedInfo.SetText(rStr );
}

XubString SvxClickInfoCtr::GetText() const
{
	return aFixedInfo.GetText();
}

__EXPORT SvxClickInfoCtr::~SvxClickInfoCtr()
{
}

// struct SpellCheckDlg_Impl ---------------------------------------------

struct SpellCheckDlg_Impl
{
	Sequence< Reference< XDictionary >  >	aDics;
	SvxSpellWrapper*			pSpellWrapper;
	FASTBOOL					bBtnLock;

	SpellCheckDlg_Impl() :
		pSpellWrapper	(NULL),
		bBtnLock		(sal_False)
	{
	}
};

static Window* pOldDefDialogParent;

// define ----------------------------------------------------------------

#define WRAPPER					pImpl->pSpellWrapper
#define BTN_LOCK				pImpl->bBtnLock
#define BTN_LOCKING( bLock )									\
	if ( bLock )												\
	{															\
		EnterWait();											\
		pOldDefDialogParent=Application::GetDefDialogParent();	\
		Application::SetDefDialogParent(this);					\
	}															\
	else														\
	{															\
		LeaveWait();											\
		Application::SetDefDialogParent(pOldDefDialogParent);	\
	}															\
	BTN_LOCK = bLock


	static void 				SetDefDialogParent( Window* pWindow );
	static Window*				GetDefDialogParent();

// statics ---------------------------------------------------------------

static const short NOACTDICT = -1;

/*
static SfxItemInfo __READONLY_DATA aItemInfos[] =
{
	{ 0, 0 }
};
*/
static sal_uInt16 pSpellInfos[] =
{
	SID_ATTR_SPELL,SID_ATTR_SPELL,
	0
};

// class SvxSpellCheckDialog ---------------------------------------------

SvxSpellCheckDialog::SvxSpellCheckDialog
(
	Window* 			pParent,
	Reference< XSpellChecker1 >  &	xChecker,
	SvxSpellWrapper* 	pWrapper
) :

	SfxModalDialog( pParent, SVX_RES( RID_SVXDLG_SPELLCHECK ) ),

	aWordText		( this,	ResId( FT_WORD ) ),
	aAktWord		( this,	ResId( FT_AKTWORD ) ),
	aNewWord		( this,	ResId( FT_NEWWORD ) ),
	aNewWordED		( this,	ResId( ED_NEWWORD ) ),
	aStateImage		( this,	ResId( FI_STATE) ),
	aTestBtn		( this,	ResId( IB_TEST ) ),
	aSuggestionFT	( this, ResId( FT_SUGGESTION ) ),
	aNewWordLB		( this,	ResId( LB_NEWWORD ) ),
	aLanguageText	( this,	ResId( FT_LANGUAGE ) ),
	aLangLB			( this,	ResId( LB_LANGUAGE ) ),
	aBookText		( this,	ResId( FT_BOOK ) ),
	aBookDLB		( this,	ResId( LB_BOOK ) ),
	aAuditBox		( this, ResId( GB_AUDIT ) ),

	aChangeAllBtn	( this,	ResId( BTN_CHANGEALL ) ),
	aChangeBtn		( this,	ResId( BTN_CHANGE ) ),
	aIgnoreAllBtn	( this,	ResId( BTN_IGNOREALL ) ),
	aIgnoreBtn		( this,	ResId( BTN_IGNORE ) ),
	aAutoCorrBtn	( this,	ResId( BTN_AUTOCORR ) ),
	aThesBtn		( this,	ResId( BTN_THES ) ),
	aOptionsBtn		( this,	ResId( BTN_OPTIONS ) ),
	aAddBtn			( this,	ResId( BTN_ADD ) ),
	aCancelBtn		( this,	ResId( BTN_SPL_CANCEL ) ),
	aBackWdBox		( this, ResId( CB_BACKWD ) ),
	aHelpBtn		( this,	ResId( BTN_SPL_HELP ) ),

	aStatusText		( this, ResId( FT_STATUS ) ),
	aErrorStr		(ResId( STR_ERROR) ),
	//aStatusBox		( this, ResId( GB_STATUS ) ),
	aDecoView		( this),
	aFalseStateIm	( ResId( IM_FALSE) ),
	aTrueStateIm	( ResId( IM_OK) ),
	xSpell			( xChecker ),
	nOldLang		( LANGUAGE_NONE ),
	nActDict		( NOACTDICT ),
	aStateStr		(aStateImage.GetQuickHelpText()),
	bModified		(sal_False)
{
	pImpl = new SpellCheckDlg_Impl;
	//pImpl->xSpellAlt = WRAPPER->GetLast(), UNO_QUERY);
	WRAPPER = pWrapper;
	BTN_LOCK = sal_False;

	aStateImage.SetImage(aFalseStateIm);

	Init_Impl();
	FreeResource();

	// disbale controls if service is missing
	if (!xSpell.is())
		Enable( sal_False );
}

// -----------------------------------------------------------------------

SvxSpellCheckDialog::~SvxSpellCheckDialog()
{
	delete pImpl;
}

void SvxSpellCheckDialog::Paint( const Rectangle& rRect )
{
	SfxModalDialog::Paint(rRect );

	Rectangle aRect(aAuditBox.GetPosPixel(),aAuditBox.GetSizePixel());

	sal_uInt16 nStyle=BUTTON_DRAW_NOFILL;
	aDecoView.DrawButton( aRect, nStyle);
}
// -----------------------------------------------------------------------

void SvxSpellCheckDialog::Init_Impl()
{
	// Handler initialisieren
	aCancelBtn	 .SetClickHdl( LINK( this, SvxSpellCheckDialog, CancelHdl ) );
	aChangeBtn	 .SetClickHdl( LINK( this, SvxSpellCheckDialog, ChgHdl ) );
	aChangeAllBtn.SetClickHdl( LINK( this, SvxSpellCheckDialog, ChgAllHdl ) );
	aIgnoreBtn	 .SetClickHdl( LINK( this, SvxSpellCheckDialog, IgnHdl ) );
	aIgnoreAllBtn.SetClickHdl( LINK( this, SvxSpellCheckDialog, IgnAllHdl ) );
	aAddBtn		 .SetClickHdl( LINK( this, SvxSpellCheckDialog, AddHdl ) );
	
	aAutoCorrBtn.SetClickHdl( LINK( this, SvxSpellCheckDialog, ExtClickHdl ) );
	aThesBtn	.SetClickHdl( LINK( this, SvxSpellCheckDialog, ExtClickHdl ) );
	aOptionsBtn .SetClickHdl( LINK( this, SvxSpellCheckDialog, ExtClickHdl ) );

	aBookDLB	 .SetSelectHdl( LINK( this, SvxSpellCheckDialog, SelectHdl ) );
	aLangLB		 .SetSelectHdl( LINK( this, SvxSpellCheckDialog, SelectHdl ) );
	
	aNewWordLB.SetGetFocusHdl( LINK( this, SvxSpellCheckDialog, WordSelectHdl ) );
	aNewWordLB.SetSelectHdl( LINK( this, SvxSpellCheckDialog, WordSelectHdl ) );
	aNewWordLB.SetDoubleClickHdl( LINK( this, SvxSpellCheckDialog, ChgHdl ) );
	
	aBackWdBox.SetClickHdl(LINK ( this, SvxSpellCheckDialog, DirectionHdl ) );
	aTestBtn  .SetClickHdl(LINK ( this, SvxSpellCheckDialog, AuditHdl) );
	aNewWordED.SetModifyHdl(LINK ( this, SvxSpellCheckDialog, ModifyHdl) );
	aAktWord  .SetActivateHdl( LINK ( this, SvxSpellCheckDialog, ClickHdl) );

	// "Uberschrift merken
	aTitel = GetText();

	// initialisieren der Sprachen-Listbox
	const sal_Int32 nLangCnt = SvxGetSelectableLanguages().getLength();
	const util::Language *pLang = SvxGetSelectableLanguages().getConstArray();
	for ( sal_Int32 i = 0; i < nLangCnt; ++i )
	{
		sal_uInt16 nPos = aLangLB.InsertEntry( ::GetLanguageString( pLang[i] ) );
		aLangLB.SetEntryData( nPos, (void*)(sal_uInt32)i );
	}

	Reference< XSpellAlternatives >  xAlt( WRAPPER->GetLast(), UNO_QUERY );
	if (xAlt.is())
	{
		nOldLang = SvxLocaleToLanguage( xAlt->getLocale() );
		aOldWord = String( xAlt->getWord() );
		WRAPPER->SetOldLang( nOldLang );
	}

	// aktuelle Sprache ermitteln
	UpdateBoxes_Impl();

	// Benutzerbuecher anzeigen
	InitUserDicts();

	Reference< XPropertySet >  xProp( SvxGetLinguPropertySet() );
	sal_Bool bWrapReverse = xProp.is() ?
		*(sal_Bool*)xProp->getPropertyValue( C2U(UPN_IS_WRAP_REVERSE) ).getValue() : sal_False;
	aBackWdBox.Check(0 != bWrapReverse);
}

// -----------------------------------------------------------------------

void SvxSpellCheckDialog::UpdateBoxes_Impl()
{
	sal_Int32 i;
	aNewWordLB.Clear();

	Reference< XSpellAlternatives >  xAlt( WRAPPER->GetLast(), UNO_QUERY );

	LanguageType nAltLanguage = LANGUAGE_NONE;
	String		 aAltWord;
	Sequence< OUString >	aNewWords;
	if (xAlt.is())
	{
		nAltLanguage	= SvxLocaleToLanguage( xAlt->getLocale() );
		aAltWord 		= String( xAlt->getWord() );
		aNewWords 		= xAlt->getAlternatives();
	}


	String aStr( aTitel );
	aStr.Append( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( " (" ) ) );
	if (xAlt.is())
		aStr.Append( ::GetLanguageString( nAltLanguage ) );
	aStr.Append( sal_Unicode( ')' ) );
	SetText( aStr );

	SetSelectedLang_Impl( nAltLanguage );

	// Das Wort Anzeigen und seine Alternativen
	aAktWord.SetText( aAltWord );

	SetAddBtnHelp(aAktWord.GetText());
	SetIgnoreHelp(aAktWord.GetText());

	// 1. Alternative in das Edit stellen
	aNewWordED.SetText( aAktWord.GetText() );
	aAutoCorrBtn.Enable( aNewWordED.GetText() != aAktWord.GetText() );

	// Alternativen eintragen
	const OUString *pNewWords = aNewWords.getConstArray();
	const sal_Int32 nSize = aNewWords.getLength();
	for ( i = 0; i < nSize; ++i )
	{
		String aTmp( pNewWords[i] );
		if ( LISTBOX_ENTRY_NOTFOUND == aNewWordLB.GetEntryPos( aTmp ) )
			aNewWordLB.InsertEntry( aTmp );
	}
	aNewWordED.GrabFocus();

	// display status message
	String aTmpText;
	if (xAlt.is())
	{
		int nRID;
		switch (xAlt->getFailureType())
		{
			case SpellFailure::IS_NEGATIVE_WORD : nRID = RID_SVXSTR_HMSTATUS_DONTUSE; break;
			case SpellFailure::CAPTION_ERROR : 	 nRID = RID_SVXSTR_HMSTATUS_CAPERROR; break;
			case SpellFailure::SPELLING_ERROR : 	 nRID = RID_SVXSTR_HMSTATUS_WRONG; break;
			default :
				DBG_ERROR("undefined SpellFailure type");
		}
		aTmpText = SVX_RESSTR( nRID );
	}
	aStatusText.SetText( aTmpText );

	if (aNewWordLB.GetEntryCount())
	{
		aNewWordLB.Enable();
		aNewWordLB.SelectEntryPos(0);
		//aNewWordLB.Select();	// Select-Handler rufen
		long nPos= aNewWordED.GetText().Len();
		Selection aSel(nPos, nPos);
		aNewWordED.SetSelection(aSel);	// Alles selektieren
		SetChangesHelp(aNewWordLB.GetSelectEntry());
	}
	else
	{
		SetChangesHelp(aNewWordED.GetText());
	}
	aStateImage.SetImage(aFalseStateIm);
	UniString aStrTmp( aStateStr );
	aStrTmp.Append(aStatusText.GetText());
	aStateImage.SetQuickHelpText( aStrTmp );

}

// -----------------------------------------------------------------------

void SvxSpellCheckDialog::SpellContinue_Impl()
{
	WRAPPER->FindSpellError();
	Reference< XSpellAlternatives >  xAlt( WRAPPER->GetLast(), UNO_QUERY );

	if (xAlt.is())
	{
		UpdateBoxes_Impl();
		nOldLang = GetSelectedLang_Impl();
		aOldWord = aAktWord.GetText();
//		aOldWord = aNewWordED.GetText();
	}
	else
		EndDialog( RET_OK );
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, ExtClickHdl, Button *, pBtn )
{
	if (&aOptionsBtn == pBtn)
		StartSpellOptDlg_Impl();
	else if (&aAutoCorrBtn == pBtn)
	{
		String aOldWord( aAktWord.GetText() ),
			   aNewWord( aNewWordED.GetText() );
		SvxPrepareAutoCorrect( aOldWord, aNewWord );
		WRAPPER->AutoCorrect( aOldWord, aNewWord );
	}
	else if (&aThesBtn == pBtn)
		StartThesaurus_Impl( sal_True );
	
	return 0;
}
// -----------------------------------------------------------------------

void SvxSpellCheckDialog::StartSpellOptDlg_Impl()
{

	SfxItemSet aSet( SFX_APP()->GetPool(), pSpellInfos);
	aSet.Put(SfxSpellCheckItem( xSpell ),SID_ATTR_SPELL );
	SfxSingleTabDialog* pDlg =
		new SfxSingleTabDialog( this, aSet, RID_SFXPAGE_LINGU );
	SfxTabPage* pPage = SvxLinguTabPage::Create( pDlg, aSet );
	( (SvxLinguTabPage*)pPage )->
		HideGroups( GROUP_HYPHEN | GROUP_LANGUAGE );
	pDlg->SetTabPage( pPage );
	pDlg->Execute();
	delete pDlg;

	// Benutzerb"ucher anzeigen
	aBookDLB.Clear();
	InitUserDicts();
}

// -----------------------------------------------------------------------

void SvxSpellCheckDialog::StartThesaurus_Impl( sal_Bool bInter )
{
	if ( !bInter )
	{
		QueryBox aBox( this, SVX_RES( RID_SVXQB_THESAURUS ) );

		if ( aBox.Execute() == RET_NO )
			return;
	}
	WRAPPER->StartThesaurus( GetNewEditWord(), GetSelectedLang_Impl() );
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, ChgHdl, Button *, EMPTYARG )
{
	if ( BTN_LOCK )
		return 0;
	BTN_LOCKING( sal_True );

	String aString=aNewWordED.GetText();
	if(aNewWordLB.IsEnabled() && aNewWordLB.GetSelectEntryCount()>0)
		aString=aNewWordLB.GetSelectEntry();

	WRAPPER->ChangeWord( aString, GetSelectedLang_Impl() );
	SpellContinue_Impl();
	BTN_LOCKING( sal_False );
	bModified=sal_False;
	return 1;
}


// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, ChgAllHdl, Button *, EMPTYARG )
{
	if ( BTN_LOCK )
		return 0;
	BTN_LOCKING( sal_True );

	// zuerst das aktuelle Wort "andern

	String aString=aNewWordED.GetText();
	if(aNewWordLB.IsEnabled() && aNewWordLB.GetSelectEntryCount()>0)
		aString=aNewWordLB.GetSelectEntry();

	LanguageType nLang = GetSelectedLang_Impl();

	// add new word to ChangeAll list
	String  aOldWord( aAktWord.GetText() );
	SvxPrepareAutoCorrect( aOldWord, aString );
	SvxAddEntryToDic( Reference< XDictionary > ( SvxGetChangeAllList(), UNO_QUERY ),
		::rtl::OUString( aOldWord ), sal_True,
			aString, nLang );

	WRAPPER->ChangeWord( aString, nLang );
	SpellContinue_Impl();
	BTN_LOCKING( sal_False );
	bModified=sal_False;
	return 1;
}


// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, IgnAllHdl, Button *, EMPTYARG )
{
	if ( BTN_LOCK )
		return 0;
	BTN_LOCKING( sal_True );

	// add word to IgnoreAll list
	SvxAddEntryToDic( Reference< XDictionary > ( SvxGetIgnoreAllList(), UNO_QUERY ),
		::rtl::OUString( aAktWord.GetText() ), sal_False,
		::rtl::OUString(), LANGUAGE_NONE );

	SpellContinue_Impl();
	BTN_LOCKING( sal_False );
	bModified=sal_False;
	return 1;
}


// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, IgnHdl, Button *, EMPTYARG )
{
	if ( BTN_LOCK )
		return 0;
	BTN_LOCKING( sal_True );
	// Das Wort wird einfach ignoriert
	SpellContinue_Impl();
	BTN_LOCKING( sal_False );
	bModified=sal_False;
	return 1;
}


// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, AddHdl, Button *, pButton )
{
	const sal_uInt16 nPos = aBookDLB.GetSelectEntryPos();

	String aNewWord;

	if(bModified)
		aNewWord= aNewWordED.GetText();
	else
		aNewWord= aAktWord.GetText();

	if ( nPos != LISTBOX_ENTRY_NOTFOUND )
	{
		sal_uInt16 nPos = aBookDLB.GetSelectEntry().nId;

		if (EXT_LINGU_DIC_ID == nPos)
		{
			Reference< lang::XMultiServiceFactory >  xMgr = utl::getProcessServiceFactory();
			Reference< XOtherLingu2 >  xOther2( xMgr->createInstance(
					C2U("com.sun.star.linguistic.OtherLingu") ), UNO_QUERY );
			if (xOther2.is())
				xOther2->addWord( 0, aNewWord, GetSelectedLang_Impl() );
		}
		else
		{
			Reference< XDictionary >  xDic( pImpl->aDics.getConstArray()[ nPos ], UNO_QUERY );
			sal_Int16 nAddRes = DIC_ERR_UNKNOWN;
			if (xDic.is())
			{
				String aTmpTxt( aNewWord );
				sal_Bool bNegEntry = xDic->getDictionaryType() == DictionaryType_NEGATIVE;
				nAddRes = SvxAddEntryToDic( xDic, aTmpTxt, bNegEntry,
						OUString(), LANGUAGE_NONE );

				// failed because there is already an entry?
				if (DIC_ERR_NONE != nAddRes && xDic->getEntry( aTmpTxt ).is())
					nAddRes = DIC_ERR_NONE;
			}
			if (DIC_ERR_NONE != nAddRes)
			{
				SvxDicError( this, nAddRes );
				return 0;   // Nicht weitermachen
			}
		}
	}
	// nach dem Aufnehmen ggf. '='-Zeichen entfernen
	aNewWord.EraseAllChars( sal_Unicode( '=' ) );
	aNewWordED.SetText( aNewWord );
	aAutoCorrBtn.Enable( aNewWordED.GetText() != aAktWord.GetText() );

	// Bei Bedarf Sprache "andern
	WRAPPER->ChangeLanguage( GetSelectedLang_Impl() );

	// und weiter...
	if ( aNewWordED.GetText() == aAktWord.GetText() )
	{
		SpellContinue_Impl();
	}
	else
	{
		ChgHdl(pButton);
	}

	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, SelectHdl, ListBox *, pBox )
{
	LanguageType  nSelectedLang = GetSelectedLang_Impl();

	if (&aLangLB == pBox)
	{
		BOOL bEnableThes = FALSE;
		Reference< XThesaurus > xThes( SvxGetThesaurus() );
		if (xThes.is())
			bEnableThes = xThes->hasLocale( SvxCreateLocale( nSelectedLang ) );
		aThesBtn.Enable( bEnableThes );
	
		Reference< XSpellAlternatives >  xAlt( WRAPPER->GetLast(), UNO_QUERY );
		if( &aLangLB == pBox && xAlt.is() )
			Audit_Impl();
	}
	else if (&aBookDLB == pBox)
	{
		sal_Bool bEnable = sal_False;
		if ( aBookDLB.GetSelectEntryPos() != LISTBOX_ENTRY_NOTFOUND )
		{
			nActDict = aBookDLB.GetSelectEntryPos();

			// Stimmt die Sprache "uberein, dann enable
			sal_uInt16 nPos = aBookDLB.GetEntry( nActDict ).nId;
			if (EXT_LINGU_DIC_ID == nPos)
				bEnable = sal_True;
			else
			{
				const sal_uInt16 nLang = SvxLocaleToLanguage(
								pImpl->aDics.getConstArray()[ nPos ]->getLocale() );

				if ( nLang == nSelectedLang ||
					nLang == LANGUAGE_NONE ) // LANGUAGE_DONTKNOW
					bEnable = sal_True;
			}
		}
		aAddBtn.Enable( bEnable );
	}

	return 0;
}

// -----------------------------------------------------------------------

sal_Bool SvxSpellCheckDialog::Close()
{
	if ( BTN_LOCK )
		return sal_False;

	BTN_LOCKING( sal_True );
	WRAPPER->SpellEnd();
	BTN_LOCKING( sal_False );
	return SfxModalDialog::Close();
}

// -----------------------------------------------------------------------

void SvxSpellCheckDialog::Audit_Impl()
{
	Reference< XSpellAlternatives >  xSpellAlt( WRAPPER->GetLast(), UNO_QUERY );

	DBG_ASSERT(xSpell.is() && xSpellAlt.is(), "unexpected behaviour");
	if (!(xSpell.is() && xSpellAlt.is()))
		return;

	// Fehlerkontext aufspannen
	SfxErrorContext aContext( ERRCTX_SVX_LINGU_SPELLING, String(), this,
							  RID_SVXERRCTX, DIALOG_MGR() );

	// Wort Direct pr"ufen
	String aTmp( aNewWordED.GetText() );
//	String aTmp2( U2S(xSpellAlt->getWord()) );
	String aTmp2( aOldWord );

	// Bitte warten ...
	EnterWait();

//	const sal_uInt16 nOld = xSpellAlt->getLanguage();
	const sal_uInt16 nOld = nOldLang;
	sal_uInt16 nLang = GetSelectedLang_Impl();

	// zeitweise die Sprache umschalten
	//
	FASTBOOL bAll = sal_False;
	sal_Int16	 nErr = -1;

	Reference< XSpellAlternatives >  xTmpSpellAlt;
	sal_Bool bTestOk=sal_True;
	sal_Bool bInvalidLang = sal_False;

	if ( ( nOld != nLang || aTmp != aTmp2 ) &&
		 nLang != LANGUAGE_DONTKNOW)
	{
		if (xSpell->hasLanguage( nLang ))
		{
			xTmpSpellAlt = xSpell->spell( aTmp, nLang );
			if(!xTmpSpellAlt.is())
				bTestOk = sal_False;
		}
		else
		{
			bInvalidLang = sal_True;
		}
	}
	else
		bAll = sal_True;

	nOldLang = nLang;
	aOldWord = aTmp;

	sal_Bool bIsSpellError 	= sal_False;
	sal_Int16 nAltCount 	= 0;
	if (xTmpSpellAlt.is())
	{
		bIsSpellError = sal_True;	//xTmpSpellAlt->getFailureType() == SpellFailure::SPELLING_ERROR;
		nAltCount 	  = xTmpSpellAlt->getAlternativesCount();
	}

	if ( bAll /*|| (bIsSpellError  &&  nAltCount == 0)*/ )
	{
		// ErrorLink ausschalten
		//Link aOldLnk( pSpell->ChgErrorLink( Link() ) );

		// andere Sprachen automatisch pr"ufen
		// auch wenn beliebiger Schwachsinn rauskommt
		// NUR: wenn Sprache KEINE oder die neue die Alte ist oder die Sprache
		// nicht vorhanden ist
		sal_uInt16 nMaxAlt			= 0;
		sal_uInt16 nMaxAltLangPos	= 0;

		sal_Int32 nLangCount = SvxGetSelectableLanguages().getLength();
		const util::Language *pLang = SvxGetSelectableLanguages().getConstArray();
		for ( sal_Int32 i = 1; i < nLangCount; ++i )
		{
			sal_uInt16 nNew = pLang[i];
			// Alle Sprachen ausprobieren in unserer Reihenfolge
			if ( xSpell->hasLanguage( nNew ) )
			{
				xTmpSpellAlt = xSpell->spell( aTmp, nNew );

				if ( !xTmpSpellAlt.is() )	// correct spelling?
				{
					// den richtigen Eintrag finden, da sortiert
					for ( sal_uInt16 j = 0; j < aLangLB.GetEntryCount(); ++j )
					{
						if ( (sal_uInt16)(sal_uInt32)aLangLB.GetEntryData(j) == i )
						{
							// dann selektieren
							aLangLB.SelectEntryPos(j);
							break;
						}
					}
					break;
				}
				else if ( xTmpSpellAlt->getAlternativesCount() > nMaxAlt )
				{
					nMaxAlt = xTmpSpellAlt->getAlternativesCount();
					nMaxAltLangPos = i;
				}
			}
		}

		// was the spelling of the word wrong in all the languages
		// checked above?
		if ( xTmpSpellAlt.is() )
		{
			if ( nMaxAlt > 0 )
			{
				// Die Sprache mit den meisten Alternativen anzeigen
				// den richtigen Eintrag finden, da sortiert
				LanguageType nSelLang = LANGUAGE_NONE;
				for ( sal_uInt16 i = 0; i < aLangLB.GetEntryCount(); ++i )
				{
					if ( (sal_uInt16)(sal_uInt32)aLangLB.GetEntryData(i)
						 == nMaxAltLangPos )
					{
						// dann selektieren
						aLangLB.SelectEntryPos(i);
						nSelLang = GetSelectedLang_Impl();
						break;
					}
				}
				DBG_ASSERT( nSelLang != LANGUAGE_NONE,
						"correct language not found" );
				nOldLang = nSelLang;
				xTmpSpellAlt = xSpell->spell( aTmp, nSelLang );
			}
			//else
			//	pSpell->SetActualLanguage( nLang );
		}
		// ErrorHandler wieder installieren
		//pSpell->ChgErrorLink(aOldLnk);
	}

	// Alternativen eintragen
	aNewWordLB.Clear();
	if(xTmpSpellAlt.is())
	{
		sal_uInt16 nCount = xTmpSpellAlt->getAlternativesCount();;
		Sequence< OUString > aAlt = xTmpSpellAlt->getAlternatives();
		const OUString *pStr = aAlt.getConstArray();
		for( sal_uInt16 i=0; i < nCount; ++i )
		{
			String aTmp( pStr[i] );
			if ( LISTBOX_ENTRY_NOTFOUND == aNewWordLB.GetEntryPos( aTmp ) )
				aNewWordLB.InsertEntry( aTmp );
		}
	}
	aNewWordED.GrabFocus();

	if (aNewWordLB.GetEntryCount())
	{
		aNewWordLB.Enable();

		long nPos= aNewWordED.GetText().Len();
		Selection aSel(nPos, nPos);
		aNewWordED.SetSelection(aSel);	// Alles selektieren
	}

	// Status anzeigen

	if (bInvalidLang)
	{
		aStatusText.SetText( SVX_RESSTR( RID_SVXSTR_HMSTATUS_INVALID_LANG ) );
		aStateImage.Hide();
	}
	else
	{
		String aTxt;
		aStateImage.Show();

		if(!xTmpSpellAlt.is())
		{
			aTxt = SVX_RESSTR( RID_SVXSTR_HMSTATUS_OK );
			aStateImage.SetImage(aTrueStateIm);
			SetChangesHelp(aNewWordED.GetText());
		}
		else
		{
			int nRID = RID_SVXSTR_HMSTATUS_OK;
			switch (xTmpSpellAlt->getFailureType())
			{
				case SpellFailure::IS_NEGATIVE_WORD : nRID = RID_SVXSTR_HMSTATUS_DONTUSE; break;
				case SpellFailure::CAPTION_ERROR : 	 nRID = RID_SVXSTR_HMSTATUS_CAPERROR; break;
				case SpellFailure::SPELLING_ERROR :	 nRID = RID_SVXSTR_HMSTATUS_WRONG; break;
				default :
					DBG_ERROR("unexpected SpellFailure type");
			}

			aTxt = SVX_RESSTR( nRID );
			aStateImage.SetImage(aFalseStateIm);
		}
		aStatusText.SetText( aTxt );
		UniString aStrTmp( aStateStr );
		aStrTmp.Append( aTxt );
		aStateImage.SetQuickHelpText( aStrTmp );
	}

	LeaveWait();

}

// -----------------------------------------------------------------------

String SvxSpellCheckDialog::AddPreAndPost_Impl( const String& rStr )
{
	return rStr;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSpellCheckDialog, WordSelectHdl, ListBox *, EMPTYARG )
{
	if(aNewWordLB.GetEntryCount()>0)
	{
		String aString=aNewWordLB.GetSelectEntry();
		aNewWordED.SetText(aString);
		bModified=sal_False;
		SetAddBtnHelp(aAktWord.GetText());
		SetChangesHelp(aString);
		aStateImage.SetImage(aTrueStateIm);
		String aStr = aStateStr;
		aStr += SVX_RESSTR( RID_SVXSTR_HMSTATUS_OK );
		aStateImage.SetQuickHelpText(aStr);

		aStateImage.Show();

		aAutoCorrBtn.Enable( aNewWordED.GetText() != aAktWord.GetText() );
	}
	return 0;
}


// -----------------------------------------------------------------------

void SvxSpellCheckDialog::HideAutoCorrect()

/*	[Beschreibung]

	Applikationen, die keine Autokorrektur unterst"utzen,
	k"onnen mit dieser Methode diesen Eintrag aus dem Men"u entfernen
*/

{
	aAutoCorrBtn.Hide();
}

// -----------------------------------------------------------------------

void SvxSpellCheckDialog::SetSelectedLang_Impl( LanguageType nLang )
{
	sal_Int32 nPos = SvxGetLanguagePos( SvxGetSelectableLanguages(), nLang );
	DBG_ASSERT(nPos >= 0, "language not found");

	for (sal_uInt16 i = 0;  i < aLangLB.GetEntryCount();  i++)
	{
		if ( (sal_Int32) aLangLB.GetEntryData(i) == nPos )
		{
			// dann selektieren
			aLangLB.SelectEntryPos(i);
			break;
		}
	}
}

// -----------------------------------------------------------------------

LanguageType SvxSpellCheckDialog::GetSelectedLang_Impl() const
{
	LanguageType nLang = LANGUAGE_NONE;

	sal_uInt16 nPos = aLangLB.GetSelectEntryPos();
	sal_Int32 nLangPos = (sal_Int32) aLangLB.GetEntryData( nPos );

	DBG_ASSERT( nLangPos < SvxGetSelectableLanguages().getLength(),
			"index out of range");
	if (nLangPos < SvxGetSelectableLanguages().getLength())
	{
		nLang = SvxGetSelectableLanguages().getConstArray()[ nLangPos ];
	}

	return nLang;
}

// -----------------------------------------------------------------------

void SvxSpellCheckDialog::SetLanguage( sal_uInt16 nLang )

/*	[Beschreibung]

	wenn die Sprache im Thesaurus umgestellt wurde,
	muss auch hier die Sprache umgestellt werden.
*/

{
	// Sprache erfragen
	const sal_uInt16 nPos = SvxGetLanguagePos( SvxGetSelectableLanguages(), nLang );

	String aStr( aTitel );
	aStr.Append( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( " (" ) ) );

	if ( 0 == nPos )
	{
		String aTmp( ::GetLanguageString( (LanguageType)nLang ) );
		aStr.Append( aTmp.Copy( 1, aTmp.Len() - 2 ) );
	}
	else
		aStr.Append( ::GetLanguageString( (LanguageType)nLang ) );
	aStr.Append( sal_Unicode( ')' ) );;
	SetText( aStr );

	// den richtigen Eintrag finden, da sortiert
	for ( sal_uInt16 i = 0; i < aLangLB.GetEntryCount(); ++i )
	{
		if ( (sal_uInt16)(sal_uInt32)aLangLB.GetEntryData(i)	== nPos )
		{
			// dann selektieren
			aLangLB.SelectEntryPos(i);
			break;
		}
	}
}

// -----------------------------------------------------------------------

IMPL_LINK(SvxSpellCheckDialog, DirectionHdl, CheckBox*, pBox)
{
	Reference< XPropertySet >  xProp( SvxGetLinguPropertySet() );
	if (xProp.is())
	{
		BOOL bVal = pBox->IsChecked();
		Any aBool(&bVal, ::getBooleanCppuType());
		xProp->setPropertyValue( C2U(UPN_IS_WRAP_REVERSE), aBool );
	}
	return 0;
};

void SvxSpellCheckDialog::SetAddBtnHelp(const String& rString)
{
	String aString=aAddBtn.GetText();
	aString.EraseAllChars( sal_Unicode( '~' ) );
	aString.Append( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( ": " ) ) );
	aString.Append( rString );
	aAddBtn.SetQuickHelpText(aString);
}

void SvxSpellCheckDialog::SetChangesHelp(const String& rString)
{

	String aInfoStr( RTL_CONSTASCII_USTRINGPARAM( ": " ));
	aInfoStr.Append( aAktWord.GetText() );
	aInfoStr.Append( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( " -> " ) ) );
	aInfoStr.Append( rString );

	String aString=aChangeAllBtn.GetText();
	aString.EraseAllChars( sal_Unicode( '~' ) );
	aString.Append( aInfoStr );
	aChangeAllBtn.SetQuickHelpText(aString);
	aString=aChangeBtn.GetText();
	aString.EraseAllChars( sal_Unicode( '~' ) );
	aString.Append( aInfoStr );
	aChangeBtn.SetQuickHelpText(aString);
}

void SvxSpellCheckDialog::SetIgnoreHelp(const String& rString)
{

	String aInfoStr( RTL_CONSTASCII_USTRINGPARAM( ": " ) );
	aInfoStr.Append( rString );

	String aString=aIgnoreAllBtn.GetText();
	aString.EraseAllChars( sal_Unicode( '~' ) );
	aString.Append( aInfoStr );
	aIgnoreAllBtn.SetQuickHelpText(aString);
	aString=aIgnoreBtn.GetText();
	aString.EraseAllChars( sal_Unicode( '~' ) );
	aString.Append( aInfoStr );
	aIgnoreBtn.SetQuickHelpText(aString);
}

void SvxSpellCheckDialog::InitUserDicts()
{
	const sal_uInt16 nLPos = aLangLB.GetSelectEntryPos();
	sal_uInt16 nLangPos = (sal_uInt16)(sal_uInt32)aLangLB.GetEntryData( nLPos );
	sal_uInt16 nLang = SvxGetSelectableLanguages().getConstArray()[ nLangPos ];

	sal_Int16 nOtherIndex 		= -1;
	sal_Bool  bHasOtherFunc 	= sal_False;
	sal_Bool  bIsStandardSpell	= sal_True;
	Reference< XPropertySet >  xProp( SvxGetLinguPropertySet() );
	if (xProp.is())
	{
		xProp->getPropertyValue(
				C2U(UPN_OTHER_LINGU_INDEX) ) >>= nOtherIndex;
		bIsStandardSpell = *(sal_Bool*)xProp->getPropertyValue(
				C2U(UPN_IS_STANDARD_SPELL_CHECKER) ).getValue();
	}

	if (nOtherIndex >= 0)
	{
		Reference< lang::XMultiServiceFactory >  xMgr = utl::getProcessServiceFactory();
		Reference< XOtherLingu >  xOther( xMgr->createInstance(
						C2U("com.sun.star.linguistic.OtherLingu") ), UNO_QUERY );
		if (xOther.is())
		{
			bHasOtherFunc = xOther->hasSpellChecker( nOtherIndex );
			if (/*nOtherIndex >= 0  &&*/  bHasOtherFunc)
			{
				aBookDLB.InsertEntry( SvxBoxEntry(
					xOther->getIdentifier( nOtherIndex ), EXT_LINGU_DIC_ID ) );
			}
		}
	}

	const Reference< XDictionary >  *pDic = 0;
	if (nOtherIndex < 0  ||  bIsStandardSpell)
	{
		// get list of dictionaries
		Reference< XDictionaryList >  xDicList( SvxGetDictionaryList() );
		if (xDicList.is())
		{
			// add active, positive dictionary to dic-list (if not already done).
			// This is to ensure that there is at least on dictionary to which
			// words could be added.
			Reference< XDictionary1 >  xDic( SvxGetOrCreatePosDic( xDicList ) );
			if (xDic.is())
				xDic->setActive( sal_True );

			pImpl->aDics = xDicList->getDictionaries();
		}
		
		// Benutzerbuecher anzeigen
		const sal_Int32 nSize = pImpl->aDics.getLength();
		pDic = pImpl->aDics.getConstArray();
		sal_Int32 i;
		for (i = 0; i < nSize; ++i )
		{
			Reference< XDictionary1 >  xDic( pDic[i], UNO_QUERY );
			if (!xDic.is() || SvxGetIgnoreAllList() == xDic)
				continue;

			// add only active and not read-only dictionaries to list
			// from which to choose from
			Reference< frame::XStorable > xStor( xDic, UNO_QUERY );
			if ( xDic->isActive()  &&  (!xStor.is() || !xStor->isReadonly()) )
			{
				sal_Bool bNegativ = xDic->getDictionaryType() == DictionaryType_NEGATIVE;
				aBookDLB.InsertEntry( SvxBoxEntry(
					::GetDicInfoStr( xDic->getName(),
									xDic->getLanguage(), bNegativ ), i ) );
			}
		}
	}

	aAddBtn.Disable();

	sal_uInt16 i;
	for ( i = 0; i < aBookDLB.GetEntryCount(); ++i )
	{
		sal_uInt16 nId = aBookDLB.GetEntry(i).nId;
		sal_Bool bFound = sal_False;

		if (EXT_LINGU_DIC_ID == nId)
			bFound = sal_True;
		else
		{
			const sal_uInt16 nDicLang  = SvxLocaleToLanguage( pDic[nId]->getLocale() );
			const sal_Bool bDicNegativ =
				pDic[nId]->getDictionaryType() == DictionaryType_NEGATIVE;
			// Stimmt die Sprache "uberein, dann enable
			if ((nDicLang == nLang || nDicLang == LANGUAGE_NONE) && !bDicNegativ)
				bFound = sal_True;
		}

		if (bFound)
		{
			aBookDLB.SelectEntryPos(i);
			aAddBtn.Enable();
			break;
		}
	}
}

IMPL_LINK(SvxSpellCheckDialog, ModifyHdl, Edit *, pEd)
{
	if (&aNewWordED == pEd)
	{
		bModified=sal_True;
		aStateImage.Hide();
		aStatusText.SetText( String() );
		aNewWordLB.SetNoSelection();
		aNewWordLB.Disable();
		aTestBtn.Enable();
		String aNew( aNewWordED.GetText() );
		SetAddBtnHelp( aNew );
		SetChangesHelp( aNew );

		aAutoCorrBtn.Enable( aNew != aAktWord.GetText() );
	}
	return 0;
};

IMPL_LINK(SvxSpellCheckDialog, AuditHdl, Button *, pButton )
{
	if(pButton!=NULL)
	{
		Audit_Impl();

		// ggf. wurde die aktuelle Sprache ge"andert,
		// dann mu/s vielleicht ein anderes W"orterbuch selektiert werden
		const sal_uInt16 nLPos = aLangLB.GetSelectEntryPos();
		sal_uInt16 nLangPos = (sal_uInt16)(sal_uInt32)aLangLB.GetEntryData( nLPos );
		sal_uInt16 nLang = SvxGetSelectableLanguages().getConstArray()[ nLangPos ];
		aAddBtn.Disable();

		for ( sal_uInt16 i = 0; i < aBookDLB.GetEntryCount(); ++i )
		{
			sal_uInt16 nDicPos = aBookDLB.GetEntry(i).nId;
			const sal_uInt16 nDicLang = SvxLocaleToLanguage(
					pImpl->aDics.getConstArray()[ nDicPos ]->getLocale() );

			// Stimmt die Sprache "uberein, dann enable
			if ( nDicLang == nLang || nDicLang == LANGUAGE_NONE )
			{
				// den ersten selektieren
				aBookDLB.SelectEntryPos(i);
				aAddBtn.Enable();
				break;
			}
		}
	}
	return 0;
};

IMPL_LINK(SvxSpellCheckDialog, CancelHdl, Button *, pButton )
{
	Close();
	return 0;
}

IMPL_LINK(SvxSpellCheckDialog, ClickHdl, SvxClickInfoCtr *, pCtr)
{
	if(pCtr!=NULL)
	{
		bModified=sal_True;
		aNewWordED.SetText(pCtr->GetText());
		aStateImage.SetImage(aFalseStateIm);
		aStateImage.Show();
		String aStr = aStateStr;
		aStr += SVX_RESSTR( RID_SVXSTR_HMSTATUS_WRONG );
		aStateImage.SetQuickHelpText(aStr);

		SetAddBtnHelp(pCtr->GetText());
		SetChangesHelp(aNewWordED.GetText());
		aNewWordED.GrabFocus();
		long nPos= aNewWordED.GetText().Len();
		Selection aSel(0, nPos);
		aNewWordED.SetSelection(aSel);

		aNewWordLB.SetNoSelection();
		aNewWordLB.Disable();
		
		aAutoCorrBtn.Enable( aNewWordED.GetText() != aAktWord.GetText() );
	}
	return 0;
};

IMPL_LINK(SvxSpellCheckDialog, ErrorHdl, void*, pDontKnow)
{
	aStateImage.SetImage(aFalseStateIm);
	aStateImage.Show();
	String aStr = aStateStr;
	aStr += SVX_RESSTR( RID_SVXSTR_HMSTATUS_WRONG );
	aStateImage.SetQuickHelpText(aStr);

	aStatusText.SetText(aErrorStr);
	return 0;
};


