/*************************************************************************
 *
 *  $RCSfile: dbbrowse.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma hdrstop
#include "dbbrowse.hxx"
#include "dbbrowse.hrc"

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _TOOLS_RESID_HXX //autogen
#include <tools/resid.hxx>
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#ifndef _SVX_DIALMGR_HXX
#include "dialmgr.hxx"
#endif

#ifndef _SV_SPINFLD_HXX //autogen
#include <vcl/spinfld.hxx>
#endif

#if SUPD<=511
	Window*	m_pFocusWhileRequest = NULL;
		// ab der 512 ist das ein Member der DbBrowseBox, aber da diese Aenderung inkombatibel ist, hier noch ein Fake fuer
		// die 511
#endif // SUPD<=511

TYPEINIT0(DbCellController);
TYPEINIT1(DbEditCellController, DbCellController);
TYPEINIT1(DbSpinCellController, DbCellController);
TYPEINIT1(DbCheckBoxCellController, DbCellController);

//==================================================================

#define HANDLE_ID	0

//==================================================================
// DbBrowseHeader
//------------------------------------------------------------------------------
void DbBrowseHeader::DoubleClick()
{
	sal_uInt16 nColId = GetCurItemId();
	if (nColId)
	{
		sal_uInt32 nAutoWidth = ((DbBrowseBox*)GetParent())->GetAutoColumnWidth(nColId);
		if (nAutoWidth != ((DbBrowseBox*)GetParent())->GetColumnWidth(nColId))
		{
			((DbBrowseBox*)GetParent())->SetColumnWidth(nColId, nAutoWidth);
			((DbBrowseBox*)GetParent())->ColumnResized(nColId);
		}
	}
}


//DbBrowseBox
//------------------------------------------------------------------------------
void DbBrowseBox::BrowserMouseEventPtr::Clear()
{
	DELETEZ(pEvent);
}

//------------------------------------------------------------------------------
void DbBrowseBox::BrowserMouseEventPtr::Set(const BrowserMouseEvent* pEvt, sal_Bool bIsDown)
{
	if (pEvt == pEvent)
	{
		bDown = bIsDown;
		return;
	}
	Clear();
	if (pEvt)
	{
		pEvent = new BrowserMouseEvent(pEvt->GetWindow(),
									   *pEvt,
									   pEvt->GetRow(),
									   pEvt->GetColumn(),
									   pEvt->GetColumnId(),
									   pEvt->GetRect());
		bDown = bIsDown;
	}
}


DBG_NAME(DbBrowseBox);
//------------------------------------------------------------------------------
DbBrowseBox::DbBrowseBox(Window* pParent, const ResId& rId, sal_Int32 nBrowserFlags, BrowserMode nMode)
			  :BrowseBox(pParent, rId, nMode)
			  ,nEditRow(-1)
			  ,nPaintRow(-1)
			  ,nOldEditRow(-1)
			  ,nEditCol(0)
			  ,nOldEditCol(0)
			  ,bHasFocus(sal_False)
			  ,bPaintStatus(sal_True)
			  ,nStartEvent(0)
			  ,nEndEvent(0)
			  ,nCellModifiedEvent(0)
			  ,m_nBrowserFlags(nBrowserFlags)
{
	DBG_CTOR(DbBrowseBox,NULL);

	SetCompoundControl(sal_True);
	SetLineColor(Color(COL_LIGHTGRAY));

	//////////////////////////////////////////////////////////////////////
	// HACK: BrowseBox invalidiert nicht ihre Childs, wie es eigentlich sein sollte.
	// Deshalb wird WB_CLIPCHILDREN zurueckgesetzt, wodurch das Invalidieren
	// der Childs erzwungen wird.
	WinBits aStyle = GetStyle();
	if( aStyle & WB_CLIPCHILDREN )
	{
		aStyle &= ~WB_CLIPCHILDREN;
		SetStyle( aStyle );
	}
	ImplInitSettings(sal_True, sal_True, sal_True);

	pCheckBoxPaint = new DbCheckBoxCtrl(&GetDataWindow());
	pCheckBoxPaint->SetPaintTransparent( sal_True );
	pCheckBoxPaint->SetBackground();
}

//==================================================================
DbBrowseBox::DbBrowseBox(Window* pParent, sal_Int32 nBrowserFlags, WinBits nBits, BrowserMode nMode)
			  :BrowseBox(pParent, nBits, nMode)
			  ,nEditRow(-1)
			  ,nPaintRow(-1)
			  ,nOldEditRow(-1)
			  ,nEditCol(0)
			  ,nOldEditCol(0)
			  ,bHasFocus(sal_False)
			  ,bPaintStatus(sal_True)
			  ,nStartEvent(0)
			  ,nEndEvent(0)
			  ,nCellModifiedEvent(0)
			  ,pHeader(NULL)
			  ,m_nBrowserFlags(nBrowserFlags)
{
	DBG_CTOR(DbBrowseBox,NULL);

	SetCompoundControl(sal_True);
	SetLineColor(Color(COL_LIGHTGRAY));

	//////////////////////////////////////////////////////////////////////
	// HACK: BrowseBox invalidiert nicht ihre Childs, wie es eigentlich sein sollte.
	// Deshalb wird WB_CLIPCHILDREN zurueckgesetzt, wodurch das Invalidieren
	// der Childs erzwungen wird.
	WinBits aStyle = GetStyle();
	if( aStyle & WB_CLIPCHILDREN )
	{
		aStyle &= ~WB_CLIPCHILDREN;
		SetStyle( aStyle );
	}
	ImplInitSettings(sal_True, sal_True, sal_True);

	pCheckBoxPaint = new DbCheckBoxCtrl(&GetDataWindow());
	pCheckBoxPaint->SetPaintTransparent( sal_True );
	pCheckBoxPaint->SetBackground();
}

//------------------------------------------------------------------------------
void DbBrowseBox::Init()
{
	// spaetes Construieren,
}

//------------------------------------------------------------------------------
DbBrowseBox::~DbBrowseBox()
{
	if (nStartEvent)
		Application::RemoveUserEvent(nStartEvent);
	if (nEndEvent)
		Application::RemoveUserEvent(nEndEvent);
	if (nCellModifiedEvent)
		Application::RemoveUserEvent(nCellModifiedEvent);

	delete pCheckBoxPaint;

	DBG_DTOR(DbBrowseBox,NULL);
}

//------------------------------------------------------------------------------
void DbBrowseBox::RemoveRows()
{
	BrowseBox::Clear();
	nOldEditRow = nEditRow = nPaintRow = -1;
	nEditCol = nOldEditCol = 0;
}

//------------------------------------------------------------------------------
BrowserHeader* DbBrowseBox::CreateHeaderBar(BrowseBox* pParent)
{
	pHeader = imp_CreateHeaderBar(pParent);
	if (!IsUpdateMode())
		pHeader->SetUpdateMode(sal_False);
	return pHeader;
}

//------------------------------------------------------------------------------
BrowserHeader* DbBrowseBox::imp_CreateHeaderBar(BrowseBox* pParent)
{
	return new DbBrowseHeader(pParent);
}

//------------------------------------------------------------------------------
void DbBrowseBox::LoseFocus()
{
	BrowseBox::LoseFocus();
	DetermineFocus();
}

//------------------------------------------------------------------------------
void DbBrowseBox::GetFocus()
{
	BrowseBox::GetFocus();
	// Dieses sollte den Fall abdecken, da die BrowseBox oder eines ihrer Controls
	// von auerhalb per Tab den Focus erhalten soll.
	if (IsEditing() && Controller()->GetWindow().IsVisible())
		Controller()->GetWindow().GrabFocus();

	DetermineFocus();
}

//------------------------------------------------------------------------------
sal_Bool DbBrowseBox::SeekRow(long nRow)
{
	nPaintRow = nRow;
	return sal_True;
}

//------------------------------------------------------------------------------
void DbBrowseBox::DetermineFocus()
{
	sal_Bool bFocus = sal_False;
	for (Window* pWindow = Application::GetFocusWindow();
		 pWindow && !bFocus;
		 pWindow = pWindow->GetParent())
		 bFocus = pWindow == this;

	if (bFocus != bHasFocus)
		bHasFocus = bFocus;
}

//------------------------------------------------------------------------------
IMPL_LINK(DbBrowseBox, StartEditHdl, void*, EMPTYTAG)
{
	nStartEvent = 0;
	if (IsEditing())
	{
		aController->GetWindow().Show();
		if (!aController->GetWindow().HasFocus() && (m_pFocusWhileRequest == Application::GetFocusWindow()))
			aController->GetWindow().GrabFocus();
	}
	return 0;
}

//------------------------------------------------------------------------------
void DbBrowseBox::PaintField( OutputDevice& rDev, const Rectangle& rRect,
								sal_uInt16 nColumnId ) const
{
	if (nColumnId == HANDLE_ID)
	{
		if (bPaintStatus)
			PaintStatusCell(rDev, rRect);
	}
	else
	{
		// don't paint the current cell
		if (&rDev == &GetDataWindow())
			// but only if we're painting onto our data win (which is the usual painting)
			if (nPaintRow == nEditRow)
			{
				if (IsEditing() && nEditCol == nColumnId && aController->GetWindow().IsVisible())
					return;
			}
		PaintCell(rDev, rRect, nColumnId);
	}
}

//------------------------------------------------------------------------------
Image DbBrowseBox::GetImage(RowStatus eStatus) const
{
	static ImageList aStatusList(SVX_RES(RID_SVXIMGLIST_DBBRW));
	Image aImage;
	switch (eStatus)
	{
		case CURRENT:
			aImage = aStatusList.GetImage(IMG_DBBRW_CURRENT);
			break;
		case CURRENTNEW:
			aImage = aStatusList.GetImage(IMG_DBBRW_CURRENTNEW);
			break;
		case MODIFIED:
			aImage = aStatusList.GetImage(IMG_DBBRW_MODIFIED);
			break;
		case NEW:
			aImage = aStatusList.GetImage(IMG_DBBRW_NEW);
			break;
		case DELETED:
			aImage = aStatusList.GetImage(IMG_DBBRW_DELETED);
			break;
		case PRIMARYKEY:
			aImage = aStatusList.GetImage(IMG_DBBRW_PRIMARYKEY);
			break;
		case CURRENT_PRIMARYKEY:
			aImage = aStatusList.GetImage(IMG_DBBRW_CURRENT_PRIMARYKEY);
			break;
		case FILTER:
			aImage = aStatusList.GetImage(IMG_DBBRW_FILTER);
			break;
	}
	return aImage;
}

//------------------------------------------------------------------------------
void DbBrowseBox::PaintStatusCell(OutputDevice& rDev, const Rectangle& rRect) const
{
	if (nPaintRow < 0)
		return;

	RowStatus eStatus = GetRowStatus( nPaintRow );
	if ( eStatus == CLEAN )
		return;

	if (GetBrowserFlags() & DBBF_NOROWPICTURE)
		return;

	if (rDev.GetOutDevType() == OUTDEV_WINDOW)
	{
		Image aImage(GetImage(eStatus));
		// ImagePosition berechnen
		Size aImageSize(aImage.GetSizePixel());
		aImageSize.Width() = CalcZoom(aImageSize.Width());
		aImageSize.Height() = CalcZoom(aImageSize.Height());
		Point aPos(rRect.TopLeft());

		if (aImageSize.Width() > rRect.GetWidth() ||
			aImageSize.Height() > rRect.GetHeight())
			rDev.SetClipRegion(rRect);

		if (aImageSize.Width() < rRect.GetWidth())
			aPos.X() += (rRect.GetWidth() - aImageSize.Width()) / 2;

		if (IsZoom())
			rDev.DrawImage(aPos, aImageSize, aImage, 0);
		else
			rDev.DrawImage(aPos, aImage, 0);

		if (rDev.IsClipRegion())
			rDev.SetClipRegion();
	}
}

//------------------------------------------------------------------------------
DbBrowseBox::RowStatus DbBrowseBox::GetRowStatus(long nRow) const
{
	return CLEAN;
}

//------------------------------------------------------------------------------
void DbBrowseBox::KeyInput( const KeyEvent& rEvt )
{
	sal_uInt16 nCode = rEvt.GetKeyCode().GetCode();
	sal_Bool   bShift = rEvt.GetKeyCode().IsShift();
	sal_Bool   bCtrl = rEvt.GetKeyCode().IsMod1();

	switch (nCode)
	{
		case KEY_RETURN:
			if (!bCtrl && !bShift && IsTabAllowed(sal_True))
			{
				Dispatch(BROWSER_CURSORRIGHT);
			}
			return;
		case KEY_TAB:
			if (!bCtrl && !bShift)
			{
				if (IsTabAllowed(sal_True))
					Dispatch(BROWSER_CURSORRIGHT);
				else
					// do NOT call BrowseBox::KeyInput : this would handle the tab, but we already now
					// that tab isn't allowed here. So give the Control class a chance
					Control::KeyInput(rEvt);
				return;
			}
			else if (!bCtrl && bShift)
			{
				if (IsTabAllowed(sal_False))
					Dispatch(BROWSER_CURSORLEFT);
				else
					// do NOT call BrowseBox::KeyInput : this would handle the tab, but we already now
					// that tab isn't allowed here. So give the Control class a chance
					Control::KeyInput(rEvt);
				return;
			}
		default:
			BrowseBox::KeyInput(rEvt);
	}
}

//------------------------------------------------------------------------------
void DbBrowseBox::MouseButtonDown(const BrowserMouseEvent& rEvt)
{
	sal_uInt16  nColPos = GetColumnPos( rEvt.GetColumnId() );
	long	nRow	= rEvt.GetRow();

	/* if (nRow > GetRowCount() || nColPos > ColCount()) // im ungueltigen Bereich
		return;
	*/

	// double clicks schlucken
	if (rEvt.GetClicks() > 1 && rEvt.GetRow() >= 0)
		return;

	// Wechsel auf neue Position
	if (IsEditing() && (nColPos != nEditCol || nRow != nEditRow) && (nColPos != BROWSER_INVALIDID) && (nRow < GetRowCount()))
	{
		HideAndDisable(Controller());
	}

	aMouseEvent.Set(&rEvt,sal_True);
	BrowseBox::MouseButtonDown(rEvt);
}

//------------------------------------------------------------------------------
void DbBrowseBox::MouseButtonUp( const BrowserMouseEvent& rEvt )
{
	sal_uInt16  nColPos = GetColumnPos( rEvt.GetColumnId() );
	long	nRow = rEvt.GetRow();

	/* if (nRow > GetRowCount() || nColPos > ColCount()) // im ungueltigen Bereich
		return;
	*/

	// double clicks schlucken
	if (rEvt.GetClicks() > 1 && rEvt.GetRow() >= 0)
		return;

	aMouseEvent.Set(&rEvt,sal_False);
	BrowseBox::MouseButtonUp(rEvt);
	aMouseEvent.Clear();

	if (!IsEditing())
		ActivateCell();
	else if (IsEditing() && !aController->GetWindow().IsEnabled())	 // Zelle wird nicht mehr benoetigt
		DeactivateCell();
	else if (IsEditing() && !aController->GetWindow().HasChildPathFocus())
		AsynchGetFocus();

	if (IsEditing() && aController->GetWindow().IsEnabled() && aController->WantMouseEvent())	   // weitergeben des Ereignisses an das Control
	{
		// Falls das Feld vorher verschoben wurde, muessen die Koordinaten angepat werden
		// keine Selektion zulassen
		aController->GetWindow().GrabFocus();
		Point aPos = rEvt.GetPosPixel() - rEvt.GetRect().TopLeft();
		MouseEvent aEvent(aPos, rEvt.GetClicks(), rEvt.GetMode(),
						  rEvt.GetButtons(),
						  rEvt.GetModifier());

		aController->GetWindow().MouseButtonDown(aEvent);
		aController->GetWindow().MouseButtonUp(aEvent);

		Window *pWin = &aController->GetWindow();
		if (!pWin->IsTracking())
		{
			for (pWin = pWin->GetWindow(WINDOW_FIRSTCHILD);
				 pWin && !pWin->IsTracking();
				 pWin = pWin->GetWindow(WINDOW_NEXT))
				 {}
		}
		if (pWin && pWin->IsTracking())
			pWin->EndTracking();
	}
}

//------------------------------------------------------------------------------
void DbBrowseBox::Dispatch(sal_uInt16 nId)
{
	BrowseBox::Dispatch(nId);
}

//------------------------------------------------------------------------------
long DbBrowseBox::PreNotify(NotifyEvent& rEvt)
{
	switch (rEvt.GetType())
	{
		case EVENT_KEYINPUT:
			if	(	(IsEditing() && Controller()->GetWindow().HasChildPathFocus())
				||	rEvt.GetWindow() == &GetDataWindow()
				||	(!IsEditing() && HasChildPathFocus())
				)
			{
				const KeyEvent* pKeyEvent =	rEvt.GetKeyEvent();
				sal_uInt16 nCode  = pKeyEvent->GetKeyCode().GetCode();
				sal_Bool   bShift = pKeyEvent->GetKeyCode().IsShift();
				sal_Bool   bCtrl  = pKeyEvent->GetKeyCode().IsMod1();
				sal_Bool   bAlt =	pKeyEvent->GetKeyCode().IsMod2();
				sal_Bool   bSelect=	sal_False;
				sal_Bool   bModify=	sal_False;
				sal_uInt16 nId = BROWSER_NONE;

				if (!bAlt && !bCtrl && !bShift )
					switch ( nCode )
					{
						case KEY_DOWN:          nId = BROWSER_CURSORDOWN; break;
						case KEY_UP:            nId = BROWSER_CURSORUP; break;
						case KEY_PAGEDOWN:      nId = BROWSER_CURSORPAGEDOWN; break;
						case KEY_PAGEUP:        nId = BROWSER_CURSORPAGEUP; break;
						case KEY_HOME:          nId = BROWSER_CURSORHOME; break;
						case KEY_END:           nId = BROWSER_CURSOREND; break;
						case KEY_TAB:
							// Tab nur wenn nicht auf der letzten Zelle
							if (IsTabAllowed(sal_True))
								nId = BROWSER_CURSORRIGHT;
							break;
						case KEY_RETURN:
							// Speichern eines Zellinhalts,
							if (IsEditing() && aController->IsModified() && !((DbBrowseBox *) this)->SaveModified())
							{
								// Falls nicht sichtbar
								EnableAndShow();
								aController->GetWindow().GrabFocus();
								return 1;
							}
							// Tab nur wenn nicht auf der letzten Zelle
							if (IsTabAllowed(sal_True))
								nId = BROWSER_CURSORRIGHT;

							break;
						case KEY_RIGHT:         nId = BROWSER_CURSORRIGHT; break;
						case KEY_LEFT:          nId = BROWSER_CURSORLEFT; break;
						case KEY_SPACE:         nId = BROWSER_SELECT; bModify = bSelect = sal_True;break;
					}

				if ( !bAlt && !bCtrl && bShift )
					switch ( nCode )
					{
						case KEY_DOWN:          nId = BROWSER_SELECTDOWN; bSelect = sal_True;break;
						case KEY_UP:            nId = BROWSER_SELECTUP; bSelect = sal_True;break;
						case KEY_HOME:          nId = BROWSER_SELECTHOME; bSelect = sal_True;break;
						case KEY_END:           nId = BROWSER_SELECTEND; bSelect = sal_True;break;
						case KEY_TAB:
							if (IsTabAllowed(sal_False))
								nId = BROWSER_CURSORLEFT;
							break;
					}


				if ( !bAlt && bCtrl && !bShift )
					switch ( nCode )
					{
						case KEY_DOWN:          nId = BROWSER_SCROLLUP; break;
						case KEY_UP:            nId = BROWSER_SCROLLDOWN; break;
						case KEY_PAGEDOWN:      nId = BROWSER_CURSORENDOFFILE; break;
						case KEY_PAGEUP:        nId = BROWSER_CURSORTOPOFFILE; break;
						case KEY_HOME:          nId = BROWSER_CURSORTOPOFSCREEN; break;
						case KEY_END:           nId = BROWSER_CURSORENDOFSCREEN; break;
						case KEY_SPACE:         nId = BROWSER_SELECT; bModify = bSelect = sal_True;break;
					}


				if (nId != BROWSER_NONE && (!IsEditing() || (!bModify && aController->MoveAllowed(*pKeyEvent))))
				{
					if (nId == BROWSER_SELECT)
					{
						// Speichern eines Zellinhalts
						if (IsEditing() && aController->IsModified() && !((DbBrowseBox *) this)->SaveModified())
						{
							// Falls nicht sichtbar
							EnableAndShow();
							aController->GetWindow().GrabFocus();
							return 1;
						}
					}

					Dispatch(nId);

					if (bSelect && (!GetSelectRowCount() || GetSelection() != NULL))
						ActivateCell();
					return 1;
				}
			}
	}
	return BrowseBox::PreNotify(rEvt);
}

//------------------------------------------------------------------------------
sal_Bool DbBrowseBox::IsTabAllowed(sal_Bool bRight) const
{
	return sal_True;
}

//------------------------------------------------------------------------------
long DbBrowseBox::Notify(NotifyEvent& rEvt)
{
	switch (rEvt.GetType())
	{
		case EVENT_GETFOCUS:
		case EVENT_LOSEFOCUS:
			DetermineFocus();
	}
	return BrowseBox::Notify(rEvt);
}

//------------------------------------------------------------------------------
void DbBrowseBox::StateChanged( StateChangedType nType )
{
	BrowseBox::StateChanged( nType );

	if ( nType == STATE_CHANGE_ZOOM )
	{
		ImplInitSettings( sal_True, sal_False, sal_False );
		if (IsEditing())
		{
			DeactivateCell();
			ActivateCell();
		}
	}
	else if ( nType == STATE_CHANGE_CONTROLFONT )
	{
		ImplInitSettings( sal_True, sal_False, sal_False );
		Invalidate();
	}
	else if ( nType == STATE_CHANGE_CONTROLFOREGROUND )
	{
		ImplInitSettings( sal_False, sal_True, sal_False );
		Invalidate();
	}
	else if ( nType == STATE_CHANGE_CONTROLBACKGROUND )
	{
		ImplInitSettings( sal_False, sal_False, sal_True );
		Invalidate();
	}
	else if (nType == STATE_CHANGE_STYLE)
	{
		WinBits nStyle = GetStyle();
		if (!(nStyle & WB_NOTABSTOP) )
			nStyle |= WB_TABSTOP;

		SetStyle(nStyle);
	}
}

//------------------------------------------------------------------------------
void DbBrowseBox::DataChanged( const DataChangedEvent& rDCEvt )
{
	BrowseBox::DataChanged( rDCEvt );

	if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS ) &&
		 (rDCEvt.GetFlags() & SETTINGS_STYLE) )
	{
		ImplInitSettings( sal_True, sal_True, sal_True );
		Invalidate();
	}
}

//------------------------------------------------------------------------------
void DbBrowseBox::ImplInitSettings( sal_Bool bFont, sal_Bool bForeground, sal_Bool bBackground )
{
	const StyleSettings& rStyleSettings = GetSettings().GetStyleSettings();

	if (bFont)
	{
		Font aFont = rStyleSettings.GetFieldFont();
		if (IsControlFont())
		{
			GetDataWindow().SetControlFont(GetControlFont());
			aFont.Merge(GetControlFont());
		}
		else
			GetDataWindow().SetControlFont();

		GetDataWindow().SetZoomedPointFont(aFont);
	}

	if ( bFont || bForeground )
	{
		Color aTextColor = rStyleSettings.GetFieldTextColor();
		if (IsControlForeground())
		{
			aTextColor = GetControlForeground();
			GetDataWindow().SetControlForeground(aTextColor);
		}
		else
			GetDataWindow().SetControlForeground();

		GetDataWindow().SetTextColor( aTextColor );
	}

	if ( bBackground )
	{
		if (GetDataWindow().IsControlBackground())
		{
			GetDataWindow().SetControlBackground(GetControlBackground());
			GetDataWindow().SetBackground(GetDataWindow().GetControlBackground());
			GetDataWindow().SetFillColor(GetDataWindow().GetControlBackground());
		}
		else
		{
			GetDataWindow().SetControlBackground();
			GetDataWindow().SetBackground( rStyleSettings.GetFieldColor() );
			GetDataWindow().SetFillColor( rStyleSettings.GetFieldColor() );
		}
	}
}

//------------------------------------------------------------------------------
sal_Bool DbBrowseBox::IsCursorMoveAllowed(long nNewRow, sal_uInt16 nNewColId) const
{
	sal_uInt16 nInfo = 0;

	if (GetSelectColumnCount() || (aMouseEvent.Is() && aMouseEvent->GetRow() < 0))
		nInfo |= COLSELECT;
	if ((GetSelection() != NULL && GetSelectRowCount()) ||
		(aMouseEvent.Is() && aMouseEvent->GetColumnId() == HANDLE_ID))
		nInfo |= ROWSELECT;
	if (!nInfo && nNewRow != nEditRow)
		nInfo |= ROWCHANGE;
	if (!nInfo && nNewColId != nEditCol)
		nInfo |= COLCHANGE;

	if (nInfo == 0)	  // nichts passiert
		return sal_True;

	//////////////////////////////////////////////////////////////////////
	// Speichern eines Zellinhalts
	if (IsEditing() && aController->IsModified() && !((DbBrowseBox *) this)->SaveModified())
	{
		// Falls nicht sichtbar
		EnableAndShow();

		aController->GetWindow().GrabFocus();
		return sal_False;
	}

	DbBrowseBox * pTHIS = (DbBrowseBox *) this;
	// Speichern der Zeile wenn
	// a.) Selektion vorgenommen wird
	// b.) Zeilenwechsel
	if (IsModified() && (nInfo & (ROWCHANGE | COLSELECT | ROWSELECT)) &&
		!pTHIS->SaveRow())
	{
		if (nInfo & COLSELECT ||
			nInfo & ROWSELECT)
		{
			// selektion abbrechen
			pTHIS->SetNoSelection();
		}

		if (IsEditing())
		{
			if (!Controller()->GetWindow().IsVisible())
			{
				EnableAndShow();
			}
			aController->GetWindow().GrabFocus();
		}
		return sal_False;
	}

	if (nNewRow != nEditRow)
	{
		Window& rWindow = GetDataWindow();
		// don't paint too much
		// update the status immediatly if possible				
		if ((nEditRow >= 0) && (GetBrowserFlags() & DBBF_NOROWPICTURE) == 0)
		{				
			Rectangle aRect = GetFieldRectPixel(nEditRow, 0, sal_False );						
			pTHIS->bPaintStatus = sal_False;
			rWindow.Paint(aRect);
			pTHIS->bPaintStatus = sal_True;			
		}		
		
		// don't paint during row change
		rWindow.EnablePaint(sal_False);		

		// the last veto chance for derived classes
		if (!pTHIS->CursorMoving(nNewRow, nNewColId))
		{
			pTHIS->InvalidateStatusCell(nEditRow);									
			rWindow.EnablePaint(sal_True);
			return sal_False;
		}
		else
			return sal_True;
	}			
	else
		return pTHIS->CursorMoving(nNewRow, nNewColId);
}

//------------------------------------------------------------------------------
void DbBrowseBox::ColumnMoved(sal_uInt16 nId)
{
	BrowseBox::ColumnMoved(nId);
	if (IsEditing())
	{
		Rectangle aRect( GetCellRect(nEditRow, nEditCol, sal_False));
		DbCellControllerRef aControllerRef = Controller();
		ResizeController(aControllerRef, aRect);
		Controller()->GetWindow().GrabFocus();
	}
}

//------------------------------------------------------------------------------
sal_Bool DbBrowseBox::SaveRow()
{
	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool DbBrowseBox::CursorMoving(long nNewRow, sal_uInt16 nNewCol)
{
	((DbBrowseBox *) this)->DeactivateCell(sal_False);
	return sal_True;
}

//------------------------------------------------------------------------------
void DbBrowseBox::CursorMoved()
{
	long nNewRow = GetCurRow();
	if (nEditRow != nNewRow)
	{
		if ((GetBrowserFlags() & DBBF_NOROWPICTURE) == 0)
			InvalidateStatusCell(nNewRow);		
		nEditRow = nNewRow;
	}
	ActivateCell();
	GetDataWindow().EnablePaint(sal_True);
}

//------------------------------------------------------------------------------
void DbBrowseBox::EndScroll()
{
	if (IsEditing())
	{
		Rectangle aRect = GetCellRect(nEditRow, nEditCol, sal_False);
		ResizeController(aController,aRect);
		AsynchGetFocus();
	}
	BrowseBox::EndScroll();
}

//------------------------------------------------------------------------------
void DbBrowseBox::ActivateCell(long nRow, sal_uInt16 nCol, sal_Bool bCellFocus)
{
	if (IsEditing())
		return;

	nEditCol = nCol;

	if ((GetSelectRowCount() && GetSelection() != NULL) || GetSelectColumnCount() ||
		(aMouseEvent.Is() && (aMouseEvent.IsDown() || aMouseEvent->GetClicks() > 1))) // bei MouseDown passiert noch nichts
	{
		return;
	}

	if (nEditRow >= 0 && nEditCol > HANDLE_ID)
	{
		aController = GetController(nRow, nCol);
		if (aController.Is())
		{
			Rectangle aRect( GetCellRect(nEditRow, nEditCol, sal_False));
			ResizeController(aController, aRect);

			InitController(aController, nEditRow, nEditCol);

			aController->ClearModified();
			aController->SetModifyHdl(LINK(this,DbBrowseBox,ModifyHdl));
			EnableAndShow();

			// nur wenn der Browser den Focus hat, das Editfeld aktivieren
			if (bHasFocus && bCellFocus)
				AsynchGetFocus();
		}
	}
}

//------------------------------------------------------------------------------
void DbBrowseBox::DeactivateCell(sal_Bool bUpdate)
{
	if (IsEditing())
	{
		aOldController = aController;
		aController.Clear();

		// zunaechst keine mods mitbekommen
		aOldController->SetModifyHdl(Link());

		if (bHasFocus)
			GrabFocus(); // Sicherstellen, da der Focus behalten wird

		HideAndDisable(aOldController);

		// Das hidden Window wird neu gezeichnet
		if (bUpdate)
			Update();

		nOldEditCol = nEditCol;
		nOldEditRow = nEditRow;

		if (nEndEvent)
			Application::RemoveUserEvent(nEndEvent);
		nEndEvent = Application::PostUserEvent(LINK(this,DbBrowseBox,EndEditHdl));
	}
}

//------------------------------------------------------------------------------
Rectangle DbBrowseBox::GetCellRect(long nRow, sal_uInt16 nColId, sal_Bool bRel) const
{
	Rectangle aRect( GetFieldRectPixel(nRow, nColId, bRel));
	if ((GetMode()  & BROWSER_CURSOR_WO_FOCUS) == BROWSER_CURSOR_WO_FOCUS)
	{
		aRect.Top() += 1;
		aRect.Bottom() -= 1;
	}
	return aRect;
}

//------------------------------------------------------------------------------
IMPL_LINK(DbBrowseBox, EndEditHdl, void*, EMPTYTAG)
{
	nEndEvent = 0;
	ReleaseController(aOldController, nOldEditRow, nOldEditCol);

	aOldController  = DbCellControllerRef();
	nOldEditRow		= -1;
	nOldEditCol		=  0;

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK(DbBrowseBox, ModifyHdl, void*, EMPTYTAG)
{
	if (nCellModifiedEvent)
		Application::RemoveUserEvent(nCellModifiedEvent);
	nCellModifiedEvent = Application::PostUserEvent(LINK(this,DbBrowseBox,CellModifiedHdl));
	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK(DbBrowseBox, CellModifiedHdl, void*, EMPTYTAG)
{
	nCellModifiedEvent = 0;
	CellModified();
	return 0;
}

//------------------------------------------------------------------------------
void DbBrowseBox::ColumnResized( sal_uInt16 nColId )
{
	if (IsEditing())
	{
		Rectangle aRect( GetCellRect(nEditRow, nEditCol, sal_False));
		DbCellControllerRef aControllerRef = Controller();
		ResizeController(aControllerRef, aRect);
		Controller()->GetWindow().GrabFocus();
	}
}

//------------------------------------------------------------------------------
sal_uInt16 DbBrowseBox::GetDefaultColumnWidth(const String& rName) const
{
	return GetDataWindow().GetTextWidth(rName) + GetDataWindow().GetTextWidth('0') * 4;
}

//------------------------------------------------------------------------------
void DbBrowseBox::InsertHandleColumn(sal_uInt16 nWidth)
{
	if (!nWidth)
		nWidth = GetDefaultColumnWidth(String());

	BrowseBox::InsertHandleColumn(nWidth, sal_True);
}

//------------------------------------------------------------------------------
sal_uInt16 DbBrowseBox::AppendColumn(const String& rName, sal_uInt16 nWidth, sal_uInt16 nPos, sal_uInt16 nId)
{
	if (nId == (sal_uInt16)-1)
	{
		// Suchen der naechsten freien ID
		for (nId = ColCount(); nId > 0 && GetColumnPos(nId) != BROWSER_INVALIDID; nId--)
			;

		if (!nId)
		{
			// wenn es keine HandleColumn gibt
			// Id um eins erhoehen
			if (!ColCount() || GetColumnId(0))
				nId = ColCount() + 1;
		}
	}

	DBG_ASSERT(nId, "Falsche Id vergeben");

	if (!nWidth)
		nWidth = GetDefaultColumnWidth(rName);

	InsertDataColumn(nId, rName, nWidth, (HIB_CENTER | HIB_VCENTER | HIB_CLICKABLE), nPos);
	return nId;
}

//------------------------------------------------------------------------------
void DbBrowseBox::Resize()
{
	BrowseBox::Resize();

	// Ist das Fenster kleiner als Titelzeile + Controlarea, dann abbrechen
	if (GetOutputSizePixel().Height() <
	   (GetControlArea().GetHeight() + GetDataWindow().GetPosPixel().Y()))
		return;

	// liefert die Groee der Reserved ControlArea
	Point aPoint(GetControlArea().TopLeft());
	sal_uInt16 nX = (sal_uInt16)aPoint.X();

	ArrangeControls(nX, (sal_uInt16)aPoint.Y());

	// Die ReservedControlArea auf den tatsaechlichen Wert setzen
	if (!nX)
		nX = /*USHRT_MAX;*/0;
		// wenn man USHRT_MAX benutzt und keine ControlArea hat, dann geht die horizontale ScrollBar erst direkt unter der
		// ersten Spalte los, nicht schon unter der HandleColumn
	ReserveControlArea((sal_uInt16)nX);
}

//------------------------------------------------------------------------------
void DbBrowseBox::ArrangeControls(sal_uInt16& nX, sal_uInt16 nY)
{
}

//------------------------------------------------------------------------------
DbCellController* DbBrowseBox::GetController(long, sal_uInt16)
{
	return NULL;
}

//-----------------------------------------------------------------------------
void DbBrowseBox::ResizeController(DbCellControllerRef& rController, const Rectangle& rRect)
{
	rController->GetWindow().SetPosSizePixel(rRect.TopLeft(), rRect.GetSize());
}

//------------------------------------------------------------------------------
void DbBrowseBox::InitController(DbCellControllerRef& rController, long nRow, sal_uInt16 nCol)
{
}

//------------------------------------------------------------------------------
void DbBrowseBox::ReleaseController(DbCellControllerRef& rController, long nRow, sal_uInt16 nCol)
{
}

//------------------------------------------------------------------------------
void DbBrowseBox::CellModified()
{
}


//------------------------------------------------------------------------------
sal_Bool DbBrowseBox::SaveModified()
{
	return sal_True;
}

//------------------------------------------------------------------------------
void DbBrowseBox::DoubleClick(const BrowserMouseEvent& rEvt)
{
	// Bei Doppelclick auf die Spalte wird die optimale Breite der Spalte errechnet
	// und angepat
	sal_uInt16 nColId = rEvt.GetColumnId();
	if (nColId != HANDLE_ID)
		SetColumnWidth(nColId, GetAutoColumnWidth(nColId));
}

//------------------------------------------------------------------------------
sal_uInt32 DbBrowseBox::GetAutoColumnWidth(sal_uInt16 nColId)
{
	sal_uInt32 nCurColWidth  = GetColumnWidth(nColId);
	sal_uInt32 nMinColWidth = CalcZoom(20);	// minimum
	sal_uInt32 nNewColWidth = nMinColWidth;
	long nMaxRows	   = Min(long(GetVisibleRows()), GetRowCount());
	long nLastVisRow   = GetTopRow() + nMaxRows - 1;

	if (GetTopRow() <= nLastVisRow)	// Spaltenbreite ueber die Zellinhalte
	{
		for (long i = GetTopRow(); i <= nLastVisRow; ++i)
			nNewColWidth = max(nNewColWidth,GetTotalCellWidth(i,nColId) + 12);

		if (nNewColWidth == nCurColWidth)	// Groesse hat sich nicht veraendert
			nNewColWidth = GetDefaultColumnWidth(GetColumnTitle(nColId));
	}
	else
		nNewColWidth = GetDefaultColumnWidth(GetColumnTitle(nColId));
	return nNewColWidth;
}

//------------------------------------------------------------------------------
sal_uInt32 DbBrowseBox::GetTotalCellWidth(long nRow, sal_uInt16 nColId)
{
	return 0;
}

//------------------------------------------------------------------------------
void DbBrowseBox::InvalidateHandleColumn()
{
	Rectangle aHdlFieldRect( GetFieldRectPixel( 0, 0 ));
	Rectangle aInvalidRect( Point(0,0), GetOutputSizePixel() );
	aInvalidRect.Right() = aHdlFieldRect.Right();
	Invalidate( aInvalidRect );
}

//------------------------------------------------------------------------------
void DbBrowseBox::PaintTristate(OutputDevice& rDev, const Rectangle& rRect,const TriState& eState,sal_Bool _bEnabled) const
{
	pCheckBoxPaint->GetBox().SetState(eState);
	pCheckBoxPaint->SetPosSizePixel(rRect.TopLeft(), rRect.GetSize());

	// Erstmal ein Update auf den Parent, damit nicht beim Update
	// auf dieses Fenster noch ein Paint vom Parent abgearbeitet wird,
	// wo dann ggf. dieses Fenster sofort wieder gehidet wird.
	if (pCheckBoxPaint->GetParent())
		pCheckBoxPaint->GetParent()->Update();

	pCheckBoxPaint->GetBox().Enable(_bEnabled);
	pCheckBoxPaint->Show();
	pCheckBoxPaint->Update();
	pCheckBoxPaint->SetParentUpdateMode( sal_False );
	pCheckBoxPaint->Hide();
	pCheckBoxPaint->SetParentUpdateMode( sal_True );
}

//------------------------------------------------------------------------------
void DbBrowseBox::AsynchGetFocus()
{
	if (nStartEvent)
		Application::RemoveUserEvent(nStartEvent);

	m_pFocusWhileRequest = Application::GetFocusWindow();
	nStartEvent = Application::PostUserEvent(LINK(this,DbBrowseBox,StartEditHdl));
}

//------------------------------------------------------------------------------
void DbBrowseBox::SetBrowserFlags(sal_Int32 nFlags)
{
	if (m_nBrowserFlags == nFlags)
		return;

	sal_Bool RowPicturesChanges = ((m_nBrowserFlags & DBBF_NOROWPICTURE) != (nFlags & DBBF_NOROWPICTURE));
	m_nBrowserFlags = nFlags;

	if (RowPicturesChanges)
		InvalidateStatusCell(GetCurRow());
}
//------------------------------------------------------------------------------
inline void DbBrowseBox::HideAndDisable(DbCellControllerRef& rController)
{
	rController->GetWindow().Hide();
	rController->GetWindow().Disable();
}
//------------------------------------------------------------------------------
inline void DbBrowseBox::EnableAndShow() const
{
	Controller()->GetWindow().Enable();
	Controller()->GetWindow().Show();
}
//===============================================================================

DBG_NAME(DbCellController);
//------------------------------------------------------------------------------
DbCellController::DbCellController(Window* pW)
			   :pWindow(pW)
{
	DBG_CTOR(DbCellController,NULL);

	DBG_ASSERT(pWindow, "kein Editierfenster angegeben!");
	DBG_ASSERT(!pWindow->IsVisible(), "Editierfenster darf nicht sichbar sein!");
}

//-----------------------------------------------------------------------------
DbCellController::~DbCellController()
{

	DBG_DTOR(DbCellController,NULL);
}

//-----------------------------------------------------------------------------
sal_Bool DbCellController::WantMouseEvent() const
{
	return sal_False;
}

//-----------------------------------------------------------------------------
void DbCellController::SetModified()
{
}

//-----------------------------------------------------------------------------
sal_Bool DbCellController::MoveAllowed(const KeyEvent& rEvt) const
{
	return sal_True;
}

//------------------------------------------------------------------------------
DbEditCellController::DbEditCellController(Edit* pWin)
					 :DbCellController(pWin)
{
}

//-----------------------------------------------------------------------------
void DbEditCellController::SetModified()
{
	GetEditWindow().SetModifyFlag();
}

//-----------------------------------------------------------------------------
void DbEditCellController::ClearModified()
{
	GetEditWindow().ClearModifyFlag();
}

//------------------------------------------------------------------------------
sal_Bool DbEditCellController::MoveAllowed(const KeyEvent& rEvt) const
{
	sal_Bool bResult;
	switch (rEvt.GetKeyCode().GetCode())
	{
		case KEY_END:
		case KEY_RIGHT:
		{
			Selection aSel = GetEditWindow().GetSelection();
			bResult = !aSel && aSel.Max() == GetEditWindow().GetText().Len();
		}	break;
		case KEY_HOME:
		case KEY_LEFT:
		{
			Selection aSel = GetEditWindow().GetSelection();
			bResult = !aSel && aSel.Min() == 0;
		}	break;
		default:
			bResult = sal_True;
	}
	return bResult;
}

//------------------------------------------------------------------------------
sal_Bool DbEditCellController::IsModified() const
{
	return GetEditWindow().IsModified();
}

//------------------------------------------------------------------------------
void DbEditCellController::SetModifyHdl(const Link& rLink)
{
	GetEditWindow().SetModifyHdl(rLink);
}

//------------------------------------------------------------------------------
DbSpinCellController::DbSpinCellController(SpinField* pWin)
					 :DbCellController(pWin)
{
}

//-----------------------------------------------------------------------------
void DbSpinCellController::SetModified()
{
	GetSpinWindow().SetModifyFlag();
}

//-----------------------------------------------------------------------------
void DbSpinCellController::ClearModified()
{
	GetSpinWindow().ClearModifyFlag();
}

//------------------------------------------------------------------------------
sal_Bool DbSpinCellController::MoveAllowed(const KeyEvent& rEvt) const
{
	sal_Bool bResult;
	switch (rEvt.GetKeyCode().GetCode())
	{
		case KEY_END:
		case KEY_RIGHT:
		{
			Selection aSel = GetSpinWindow().GetSelection();
			bResult = !aSel && aSel.Max() == GetSpinWindow().GetText().Len();
		}	break;
		case KEY_HOME:
		case KEY_LEFT:
		{
			Selection aSel = GetSpinWindow().GetSelection();
			bResult = !aSel && aSel.Min() == 0;
		}	break;
		default:
			bResult = sal_True;
	}
	return bResult;
}

//------------------------------------------------------------------------------
sal_Bool DbSpinCellController::IsModified() const
{
	return GetSpinWindow().IsModified();
}

//------------------------------------------------------------------------------
void DbSpinCellController::SetModifyHdl(const Link& rLink)
{
	GetSpinWindow().SetModifyHdl(rLink);
}

