/*************************************************************************
 *
 *  $RCSfile: dbbrwchk.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma hdrstop
#include "dbbrowse.hxx"

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SV_IMAGE_HXX //autogen
#include <vcl/image.hxx>
#endif

#ifndef _SV_DECOVIEW_HXX //autogen
#include <vcl/decoview.hxx>
#endif

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
DbCheckBoxCtrl::DbCheckBoxCtrl(Window* pParent, WinBits nWinStyle)
			   :Control(pParent, nWinStyle)
{
	const Wallpaper& rParentBackground = pParent->GetBackground();
	if ( (pParent->GetStyle() & WB_CLIPCHILDREN) || rParentBackground.IsFixed() )
		SetBackground( rParentBackground );
	else
	{
		SetPaintTransparent( sal_True );
		SetBackground();
	}

	pBox = new TriStateBox(this);
	pBox->SetSizePixel(CheckBox::GetCheckImage(pBox->GetSettings(), BUTTON_DRAW_CHECKED).GetSizePixel());
	pBox->SetClickHdl( LINK( this, DbCheckBoxCtrl, OnClick ) );
	pBox->Show();
}

//------------------------------------------------------------------------------
DbCheckBoxCtrl::~DbCheckBoxCtrl()
{
	delete pBox;
}

//------------------------------------------------------------------
IMPL_LINK( DbCheckBoxCtrl, OnClick, void*, EMPTYARG )
{
	m_aClickLink.Call(pBox);
	return m_aModifyLink.Call(pBox);
}

//------------------------------------------------------------------------------
void DbCheckBoxCtrl::Resize()
{
	Control::Resize();
	Rectangle aRect(Point(0,0) , GetSizePixel());
	Size aCheckSize = pBox->GetSizePixel();
	aFocusRect = aRect;
	aRect.Left() += max(0,(aRect.GetSize().Width() >> 1)  - (aCheckSize.Width() >> 1));
	aRect.Top()	 += max(0,(aRect.GetSize().Height() >> 1) - (aCheckSize.Height() >> 1));
	pBox->SetPosPixel(aRect.TopLeft());
}

//------------------------------------------------------------------------------
void DbCheckBoxCtrl::GetFocus()
{
	pBox->GrabFocus();
}

//------------------------------------------------------------------------------
void DbCheckBoxCtrl::Paint(const Rectangle& rClientRect)
{
	Control::Paint(rClientRect);
	if (HasFocus())
		ShowFocus(aFocusRect);
}

//------------------------------------------------------------------------------
long DbCheckBoxCtrl::PreNotify(NotifyEvent& rEvt)
{
	switch (rEvt.GetType())
	{
		case EVENT_GETFOCUS:
			ShowFocus(aFocusRect);
			break;
		case EVENT_LOSEFOCUS:
			HideFocus();
	}
	return Control::PreNotify(rEvt);
}

//------------------------------------------------------------------------------
sal_Bool DbCheckBoxCellController::WantMouseEvent() const
{
	return sal_True;
}

//------------------------------------------------------------------------------
CheckBox& DbCheckBoxCellController::GetCheckBox() const
{
	return ((DbCheckBoxCtrl &)GetWindow()).GetBox();
}

//------------------------------------------------------------------------------
sal_Bool DbCheckBoxCellController::IsModified() const
{
	return GetCheckBox().GetSavedValue() != GetCheckBox().GetState();
}

//------------------------------------------------------------------------------
void DbCheckBoxCellController::ClearModified()
{
	GetCheckBox().SaveValue();
}

//------------------------------------------------------------------------------
void DbCheckBoxCellController::SetModifyHdl(const Link& rLink)
{
	((DbCheckBoxCtrl &)GetWindow()).SetModifyHdl(rLink);
}


