/*************************************************************************
 *
 *  $RCSfile: adtabdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "tabwin.hxx"
#include "adtabdlg.hxx"
#include "fmresids.hrc"
#include "adtabdlg.hrc"

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#ifndef _SVX_DIALMGR_HXX //autogen
#include "dialmgr.hxx"
#endif

#ifndef _SVX_FMSHELL_HXX
#include "fmshell.hxx"
#endif

//------------------------------------------------------------------------------
SvxFmAddTableDlg::SvxFmAddTableDlg( Window* pParent, FmFormShell* pFormShell )
			 :ModelessDialog( pParent, SVX_RES(RID_SVXDLG_ADD_TABLE) )
			 ,aFTDatabase( this, ResId( FT_DATABASE ) )
			 ,aDatabaseList( this, ResId( LB_DATABASE ) )
			 ,aFTTable( this, ResId( FT_TABLE ) )
			 ,aTableList( this, ResId( LB_TABLE ) )
			 ,aAddButton( this, ResId( PB_ADDTABLE ) )
			 ,aCloseButton( this, ResId( PB_CLOSE ) )
			 ,aHelpButton( this, ResId( PB_HELP ) )
			 ,aGroupBoxTable( this, ResId( GB_TABLE ) )
			 ,aDefaultString( ResId( STR_DEFAULT ) )
			 ,pShell( pFormShell )
{
	//////////////////////////////////////////////////////////////////////
	// Handler setzen
	aAddButton.SetClickHdl( LINK(this,SvxFmAddTableDlg, AddClickHdl) );
	aCloseButton.SetClickHdl( LINK(this,SvxFmAddTableDlg, CloseClickHdl) );
	aDatabaseList.SetSelectHdl( LINK(this,SvxFmAddTableDlg, DatabaseListSelectHdl) );
	aTableList.SetDoubleClickHdl( LINK(this,SvxFmAddTableDlg, TableListDoubleClickHdl) );

	//////////////////////////////////////////////////////////////////////
	// Databaseliste initialisieren
	String aName;
	USHORT nPos = LISTBOX_ENTRY_NOTFOUND;
	USHORT nIdx = 0;
	BOOL bFirst = TRUE;

	aDatabaseList.InsertEntry( aDefaultString );

	/*
	// da die SDB-Datenbank zur Zeit nur eine physische datenbank handeln kann
	// wird diese liste noch nicht angeboten
	if( xDatabase->IsCapable(SDB_CAP_QUALIFIER_IN_DML) )
	{
		aDatabaseName = xDatabase->GetQualifier();
		while (rConnection.GetDatabaseName( aName, bFirst ) )
		{
			bFirst = FALSE;
			aDatabaseList.InsertEntry(aName);
			if (nPos == LISTBOX_ENTRY_NOTFOUND && aDatabaseName.ICompare(aName) == COMPARE_EQUAL)
				nPos = nIdx+1;// +1 wg. aDefString!
			nIdx++;
		}
	}
	*/

	if (nPos == LISTBOX_ENTRY_NOTFOUND)
		nPos = 0;
	aDatabaseList.SelectEntryPos(nPos);

	if (aDatabaseList.GetEntryCount() == 1) // keine Datenbanken gefunden
		aDatabaseList.Disable();

	//////////////////////////////////////////////////////////////////////
	// Tabellenliste initialisieren
	UpdateTableList();

	FreeResource();
}

//------------------------------------------------------------------------------
SvxFmAddTableDlg::~SvxFmAddTableDlg()
{
}

//------------------------------------------------------------------------------
void SvxFmAddTableDlg::AddTable()
{
	//////////////////////////////////////////////////////////////////
	// Tabelle hinzufuegen
	if( aTableList.GetSelectEntryCount() )
	{
		String aTableName = aTableList.GetSelectEntry();
		pShell->AddTabWin( "TestDB", aTableName );
		aAddButton.Enable( IsAddAllowed() );
	}
}

//------------------------------------------------------------------------------
IMPL_LINK( SvxFmAddTableDlg, AddClickHdl, Button*, pButton )
{
	AddTable();

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SvxFmAddTableDlg, TableListDoubleClickHdl, ListBox *, pListBox )
{
	AddTable();

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SvxFmAddTableDlg, CloseClickHdl, Button*, pButton )
{
//	((SbaJoinTabWinCont*)GetParent())->DestroyAddTabDlg();
	Hide();
	delete this;

	return 0;
}


//------------------------------------------------------------------------------
BOOL SvxFmAddTableDlg::IsAddAllowed()
{
	return TRUE;
//	return( xDatabase->IsCapable(SDB_CAP_JOIN) || !((SbaJoinTabWinCont*)GetParent())->GetTabWinCount() );
}

//------------------------------------------------------------------------------
void SvxFmAddTableDlg::UpdateTableList()
{
	aTableList.InsertEntry( "Testfenster" );
	//////////////////////////////////////////////////////////////////////
	// Datenbank- und Tabellennamen setzen
/*	String aTableName;
	String aQualifier;
	if( xDatabase->IsCapable(SDB_CAP_QUALIFIER_IN_DML) )
		aQualifier = xDatabase->GetQualifier();

	aTableList.Clear();

	//////////////////////////////////////////////////////////////////////
	// Tabellenliste updaten
	for( USHORT i=0; i<xDatabase->GetObjectCount(dbTable); i++ )
	{
		aTableName = xDatabase->GetObjectName( dbTable, i );

		//////////////////////////////////////////////////////////////////////
		// Qualifizierer aus Tabellennamen entfernen
		if( aQualifier.Len() )
			aTableName.Erase( 0, aQualifier.Len()+1 );

		aTableList.InsertEntry( aTableName );
	}

	//////////////////////////////////////////////////////////////////////
	// Ersten Eintrag selektieren
	if( aTableList.GetEntryCount() )
		aTableList.SelectEntryPos( 0 );
*/
}

//------------------------------------------------------------------------------
IMPL_LINK( SvxFmAddTableDlg, DatabaseListSelectHdl, ListBox *, pListBox )
{
	String aDatabaseName = "";
	if( aDatabaseList.GetSelectEntryPos() )
		aDatabaseName = aDatabaseList.GetSelectEntry();
//	xDatabase = SBA_MOD()->GetDatabase( aDatabaseName, TRUE );

	UpdateTableList();
	return 0;
}

