/*************************************************************************
 *
 *  $RCSfile: dbmsgbox.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma hdrstop

#ifndef _COM_SUN_STAR_SDBC_SQLEXCEPTION_HPP_
#include <com/sun/star/sdbc/SQLException.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_SQLCONTEXT_HPP_
#include <com/sun/star/sdb/SQLContext.hpp>
#endif

#ifndef _SVX_DBERRBOX_HXX
#include "dbmsgbox.hxx"
#endif
#ifndef _SVX_DBMSGBOX_HRC
#include "dbmsgbox.hrc"
#endif
//#ifndef _SVX_FMTOOLS_HXX
//#include "fmtools.hxx"
//#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#ifndef _TOOLS_RESID_HXX //autogen
#include <tools/resid.hxx>
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif

#ifndef _SVX_FMHELP_HRC
#include "fmhelp.hrc"
#endif

#ifndef _SVX_DIALMGR_HXX
#include "dialmgr.hxx"
#endif

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _SVTREEBOX_HXX
#include <svtools/svtreebx.hxx>
#endif

#ifndef _UTL_DB_EXCEPTION_HXX_
#include <unotools/dbexception.hxx>
#endif

#define S(aUniCode)				\
	::rtl::OUStringToOString(aUniCode, RTL_TEXTENCODING_ASCII_US)

#define BUTTONID_MORE	BUTTONID_RETRY + 1

#define DLG_LIMIT	320	// max Dialoggroesse
#define BTN_HEIGHT	14
#define BTN_WIDTH	50
#define BORDER_HEIGHT	6 // default Abstand von Control zu Dialog
#define BORDER_WIDTH	6 // default Abstand von Control zu Dialog

//==============================================================================
class SvxExceptionChainDialog : public ModalDialog
{
	GroupBox		m_aFrame;
	FixedText		m_aListLabel;
	SvTreeListBox	m_aExceptionList;
	FixedText		m_aDescLabel;
	MultiLineEdit	m_aExceptionText;
	OKButton		m_aOK;

public:
	SvxExceptionChainDialog(Window* pParent, const ::com::sun::star::uno::Any& _rStart);
	~SvxExceptionChainDialog();

protected:
	DECL_LINK(OnExceptionSelected, void*);
};

//------------------------------------------------------------------------------
SvxExceptionChainDialog::SvxExceptionChainDialog(Window* pParent, const ::com::sun::star::uno::Any& _rStart)
	:ModalDialog(pParent, SVX_RES(RID_SVX_DLG_SQLEXCEPTIONDETAILS))
	,m_aFrame			(this, ResId(1))
	,m_aListLabel		(this, ResId(1))
	,m_aExceptionList	(this, ResId(1))
	,m_aDescLabel		(this, ResId(2))
	,m_aExceptionText	(this, ResId(1))
	,m_aOK				(this, ResId(PB_OK))
{
	FreeResource();

	m_aExceptionList.SetSelectionMode(SINGLE_SELECTION);
	m_aExceptionList.SetDragDropMode(0);
	m_aExceptionList.EnableInplaceEditing(sal_False);
	m_aExceptionList.SetWindowBits(WB_HASLINES | WB_HASLINESATROOT | WB_HASBUTTONS | WB_HASBUTTONSATROOT | WB_HSCROLL);

	m_aExceptionList.SetSelectHdl(LINK(this, SvxExceptionChainDialog, OnExceptionSelected));
	ImageList aImages(SVX_RES(RID_SVXIMGLIST_FMEXPL));
	Image aCollapsedImage = aImages.GetImage(RID_SVXIMG_COLLAPSEDNODE);
	Image aExpandedImage = aImages.GetImage(RID_SVXIMG_EXPANDEDNODE);
	m_aExceptionList.SetNodeBitmaps(aCollapsedImage, aExpandedImage);

	m_aExceptionText.SetReadOnly(sal_True);

	::utl::SQLExceptionInfo aInfo(_rStart);
	DBG_ASSERT(aInfo.isValid(), "SvxExceptionChainDialog::SvxExceptionChainDialog : invalid chain start !");
	::utl::SQLExceptionIteratorHelper aIter(( const ::com::sun::star::sdbc::SQLException*)aInfo);
	UniString sExceptionTypes(SVX_RES(RID_STR_SQLEXCEPTIONTYPES));

	Image	aErrorImage(aImages.GetImage(RID_SVXIMG_ERROR)),
			aWarningImage(aImages.GetImage(RID_SVXIMG_WARNING)),
			aInfoImage(aImages.GetImage(RID_SVXIMG_INFO));

	while (aIter.hasMoreElements())
	{
		::utl::SQLExceptionInfo aCurrent(*aIter.next());
		if (aCurrent.isValid())
		{
			const ::com::sun::star::sdbc::SQLException* pCurrentException = (const ::com::sun::star::sdbc::SQLException*)aCurrent;
			SvLBoxEntry* pListEntry = NULL;
			::com::sun::star::sdbc::SQLException* pUserData;
			switch (aCurrent.getType())
			{
				case ::utl::SQLExceptionInfo::SQL_EXCEPTION:
					pListEntry = m_aExceptionList.InsertEntry(sExceptionTypes.GetToken(0, ';'),
						aErrorImage, aErrorImage);
					pUserData = new ::com::sun::star::sdbc::SQLException(*(const ::com::sun::star::sdbc::SQLException*)aCurrent);
					if (pUserData->SQLState.getLength())
					{
						UniString sTitle(sExceptionTypes.GetToken(4, ';'));
						sTitle.AppendAscii(" : ");
						sTitle += pUserData->SQLState.getStr();
						SvLBoxEntry* pSQLstateEntry = m_aExceptionList.InsertEntry(sTitle, aErrorImage, aErrorImage, pListEntry);
						pSQLstateEntry->SetUserData(pUserData);
						m_aExceptionList.Expand(pListEntry);
					}
					if (pUserData->ErrorCode != 0)
					{
						UniString sTitle(sExceptionTypes.GetToken(5, ';'));
						sTitle.AppendAscii(" : ");
						sTitle += pUserData->ErrorCode;
						SvLBoxEntry* pErrorCodeEntry = m_aExceptionList.InsertEntry(sTitle, aErrorImage, aErrorImage, pListEntry);
						pErrorCodeEntry->SetUserData(pUserData);
						m_aExceptionList.Expand(pListEntry);
					}
					break;
				case ::utl::SQLExceptionInfo::SQL_WARNING:
					pListEntry = m_aExceptionList.InsertEntry(sExceptionTypes.GetToken(1, ';'),
						aWarningImage, aWarningImage);
					pUserData = new ::com::sun::star::sdbc::SQLWarning(*(const ::com::sun::star::sdbc::SQLWarning*)aCurrent);
					break;
				case ::utl::SQLExceptionInfo::SQL_CONTEXT:
				{
					pListEntry = m_aExceptionList.InsertEntry(sExceptionTypes.GetToken(2, ';'),
						aInfoImage, aInfoImage);
					pUserData = new ::com::sun::star::sdb::SQLContext(*(const ::com::sun::star::sdb::SQLContext*)aCurrent);
					if (((const ::com::sun::star::sdb::SQLContext*)aCurrent)->Details.getLength())
					{
						SvLBoxEntry* pDetailsEntry = m_aExceptionList.InsertEntry(sExceptionTypes.GetToken(3, ';'), 
							aInfoImage, aInfoImage, pListEntry);
						pDetailsEntry->SetUserData(pUserData);
						m_aExceptionList.Expand(pListEntry);
					}
				}
				break;
				default:
					DBG_ERROR("SvxExceptionChainDialog::SvxExceptionChainDialog : valid ::com::sun::star::sdbc::SQLException but unknown type !");
					break;
			}
			if (pListEntry)
				pListEntry->SetUserData(pUserData);
		}
	}
}

//------------------------------------------------------------------------------
SvxExceptionChainDialog::~SvxExceptionChainDialog()
{
	SvLBoxEntry* pLoop = m_aExceptionList.First();
	while (pLoop)
	{
		if (!m_aExceptionList.GetParent(pLoop))
			// it's not the "details" entry for an ::com::sun::star::sdb::SQLContext object
			delete (::com::sun::star::sdbc::SQLException*)pLoop->GetUserData();
		pLoop = m_aExceptionList.Next(pLoop);
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SvxExceptionChainDialog, OnExceptionSelected, void*, EMPTYARG)
{
	SvLBoxEntry* pSelected = m_aExceptionList.FirstSelected();
	DBG_ASSERT(!pSelected || !m_aExceptionList.NextSelected(pSelected), "SvxExceptionChainDialog::OnExceptionSelected : multi selection ?");

	if (!pSelected)
		m_aExceptionText.SetText(UniString());
	else
	{
		::utl::SQLExceptionInfo aInfo(*(const ::com::sun::star::sdbc::SQLException*)pSelected->GetUserData());
		::rtl::OUString aText = ((const ::com::sun::star::sdbc::SQLException*)aInfo)->Message;

		if (m_aExceptionList.GetParent(pSelected))
			if (aInfo.isKindOf(::utl::SQLExceptionInfo::SQL_CONTEXT))
				// Context-Details
				aText = ((const ::com::sun::star::sdb::SQLContext*)aInfo)->Details;
			else 
				// all other children get the text of the parent
				aText = ((const ::com::sun::star::sdbc::SQLException*)aInfo)->Message;

		m_aExceptionText.SetText(aText);
	}

	return 0L;
}

//------------------------------------------------------------------------------
void SvxDBMsgBox::Construct(const UniString& rTitle,
						  const UniString& rMessage,
						  WinBits nStyle,
						  DlgImage eImage)
{
	SetText(String::CreateFromAscii("StarBase"));
	SetHelpId(HID_DLG_DBMSG);
	SetSizePixel(LogicToPixel(Size(220, 30),MAP_APPFONT));

	aInfoImage.SetPosSizePixel(LogicToPixel(Point(6, 6),MAP_APPFONT),
							   LogicToPixel(Size(20, 20),MAP_APPFONT));
	aInfoImage.Show();

	aFTTitle.SetPosSizePixel(LogicToPixel(Point(45, 6),MAP_APPFONT),
							 LogicToPixel(Size(169, 20),MAP_APPFONT));

	Font  aFont = aFTTitle.GetFont();
	aFont.SetWeight(WEIGHT_SEMIBOLD);
	aFTTitle.SetFont(aFont);
	aFTTitle.Show();

	aFTMessage.SetPosSizePixel(LogicToPixel(Point(45, 29),MAP_APPFONT),
							   LogicToPixel(Size(169, 1),MAP_APPFONT));
	aFTMessage.Show();

	m_pInfoButton = NULL;

	// Image festlegen
	switch (eImage)
	{
		case Info:
			aInfoImage.SetImage(InfoBox::GetStandardImage());
			break;
		case Warning:
			aInfoImage.SetImage(WarningBox::GetStandardImage());
			break;
		case Error:
			aInfoImage.SetImage(ErrorBox::GetStandardImage());
			break;
		case Query:
			aInfoImage.SetImage(QueryBox::GetStandardImage());
			break;
	}

	// Title setzen
	aFTTitle.SetText(rTitle);

	// Ermitteln der Hoehe des Textfeldes und des Dialogs
	Size aBorderSize = LogicToPixel(Size(BORDER_WIDTH, BORDER_HEIGHT),MAP_APPFONT);
	Rectangle aDlgRect(GetPosPixel(),GetSizePixel());
	Rectangle aMessageRect(aFTMessage.GetPosPixel(),aFTMessage.GetSizePixel());
	Rectangle aTextRect	 =
		GetTextRect(aMessageRect,rMessage, TEXT_DRAW_WORDBREAK |
										   TEXT_DRAW_MULTILINE | TEXT_DRAW_LEFT);

	long nHText	= aTextRect.Bottom() > aMessageRect.Bottom() ? aTextRect.Bottom() - aMessageRect.Bottom() : 0;

	aDlgRect.Bottom() += nHText + 2 * aBorderSize.Height();
	aMessageRect.Bottom() += nHText;

	// Dialog anpassen
	SetSizePixel(aDlgRect.GetSize());
	SetPageSizePixel(aDlgRect.GetSize());

	// Message Text anpassen und setzen
	aFTMessage.SetSizePixel(aMessageRect.GetSize());
	aFTMessage.SetText(rMessage);

	// Buttons anlegen
	long   nBtnCount = (m_sInfo.Len() != 0) ? 1 : 0;
	sal_Bool   bHelp = sal_False; //aHelpBtn.IsVisible();

	sal_uInt16 nDefId = 0;

	if (nStyle & WB_DEF_YES)
		nDefId = BUTTONID_YES;
	else if (nStyle & WB_DEF_NO)
		nDefId = BUTTONID_NO;
	else if (nStyle & WB_DEF_CANCEL)
		nDefId = BUTTONID_CANCEL;
	else if (nStyle & WB_DEF_RETRY)
		nDefId = BUTTONID_RETRY;
	else
		nDefId = BUTTONID_OK;

	if (nStyle & WB_YES_NO_CANCEL)
	{
		if (nStyle & WB_DEF_YES)
			AddButton(BUTTON_YES,BUTTONID_YES,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_YES,BUTTONID_YES,0);

		if (nStyle & WB_DEF_NO)
			AddButton(BUTTON_NO,BUTTONID_NO,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_NO,BUTTONID_NO, 0);

		if (nStyle & WB_DEF_CANCEL)
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL, 0);
	}
	else if (nStyle & WB_OK_CANCEL)
	{
		if (nStyle & WB_DEF_CANCEL)
		{
			AddButton(BUTTON_OK,BUTTONID_OK,0);
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		}
		else
		{
			AddButton(BUTTON_OK,BUTTONID_OK,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,0);
		}
	}
	else if (nStyle & WB_YES_NO)
	{
		if (nStyle & WB_DEF_YES)
			AddButton(BUTTON_YES,BUTTONID_YES,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_YES,BUTTONID_YES,0);

		if (nStyle & WB_DEF_NO)
			AddButton(BUTTON_NO,BUTTONID_NO,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_NO,BUTTONID_NO, 0);
	}
	else if (nStyle & WB_RETRY_CANCEL)
	{
		if (nStyle & WB_DEF_RETRY)
			AddButton(BUTTON_RETRY,BUTTONID_RETRY,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_YES,BUTTONID_YES,0);

		if (nStyle & WB_DEF_CANCEL)
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL, 0);
	}
	else
	{
		DBG_ASSERT(WB_OK & nStyle, "kein Button gesetzt");
		AddButton(BUTTON_OK,BUTTONID_OK,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
	}

	sal_Bool bAtLeastTwo = m_aNextChainElement.hasValue() && ((::com::sun::star::sdbc::SQLException*)m_aNextChainElement.getValue())->NextException.getValue();
	if (bAtLeastTwo)
	{
		m_pInfoButton = new PushButton(this);
		m_pInfoButton->SetText(Button::GetStandardText(BUTTON_MORE));
		m_pInfoButton->SetClickHdl(LINK(this,SvxDBMsgBox,ButtonClickHdl));
		m_pInfoButton->Show();
		AddButton(m_pInfoButton, BUTTONID_MORE, 0);
	}
}

//------------------------------------------------------------------------------
SvxDBMsgBox::SvxDBMsgBox(Window* _pParent, const UniString& _rTitle, const ::com::sun::star::sdbc::SQLException& _rError, WinBits _nStyle,
						DlgImage _eImage)
	:ButtonDialog(_pParent,WB_HORZ | WB_STDDIALOG)
	,aInfoImage(this)
	,aFTTitle(this,WB_WORDBREAK | WB_LEFT)
	,aFTMessage(this,WB_WORDBREAK | WB_LEFT)
	,m_pInfoButton(NULL)
	,m_aNextChainElement(::utl::SQLExceptionInfo(_rError).get())
{
	Construct(_rTitle, _rError.Message, _nStyle, _eImage);
}

//------------------------------------------------------------------------------
SvxDBMsgBox::SvxDBMsgBox(Window* _pParent, const ::com::sun::star::sdbc::SQLException& _rError, WinBits _nStyle, DlgImage _eImage)
	:ButtonDialog(_pParent,WB_HORZ | WB_STDDIALOG)
	,aInfoImage(this)
	,aFTTitle(this,WB_WORDBREAK | WB_LEFT)
	,aFTMessage(this,WB_WORDBREAK | WB_LEFT)
	,m_pInfoButton(NULL)
	,m_aNextChainElement(::utl::SQLExceptionInfo(_rError).get())
{
	// get the first two messages in the chain
	UniString sTitle = _rError.Message;	// we assume this to be not empty
	UniString sMessage;
	::utl::SQLExceptionIteratorHelper aIter(&_rError);
	::utl::SQLExceptionInfo aInfo(*aIter.next());
	if (aInfo.isKindOf(::utl::SQLExceptionInfo::SQL_CONTEXT))
	{	// check if we have a detailed message
		const ::com::sun::star::sdb::SQLContext* pContext = (const ::com::sun::star::sdb::SQLContext*)aInfo;
		sMessage = pContext->Details.getStr();
	}
	if (!sMessage.Len())
	{
		if (aIter.hasMoreElements())
		{
			sMessage = ((const ::com::sun::star::sdbc::SQLException*)aIter.next())->Message.getStr();
		}
	}
	if (!sMessage.Len())
	{	// use the only string we have as message and an default title
		sMessage = sTitle;
		sTitle = SVX_RES(RID_STR_READERROR);
	}
	Construct(sTitle, sMessage, _nStyle, _eImage);
}

//------------------------------------------------------------------------------
SvxDBMsgBox::SvxDBMsgBox(Window* pParent,
					 const UniString& rTitle,
					 const UniString& rMessage,
					 WinBits nStyle,
					 DlgImage eImage)
		  :ButtonDialog(pParent,WB_HORZ | WB_STDDIALOG)
		  ,aInfoImage(this)
		  ,aFTTitle(this,WB_WORDBREAK | WB_LEFT)
		  ,aFTMessage(this,WB_WORDBREAK | WB_LEFT)
		  ,m_pInfoButton(NULL)
{
	Construct(rTitle, rMessage, nStyle, eImage);
}

//------------------------------------------------------------------------------
SvxDBMsgBox::~SvxDBMsgBox()
{
	delete m_pInfoButton;
}

//--------------------------------------------------------------------------
IMPL_LINK( SvxDBMsgBox, ButtonClickHdl, Button *, pButton )
{
	SvxExceptionChainDialog aDlg(GetParent(), m_aNextChainElement);
	Hide();
	aDlg.Execute();
	Show();
	return 0;
}


