/*************************************************************************
 *
 *  $RCSfile: dialogservices.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase3.hxx>
#endif
#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _COM_SUN_STAR_AWT_XDIALOG_HPP_
#include <com/sun/star/awt/XDialog.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XINITIALIZATION_HPP_
#include <com/sun/star/lang/XInitialization.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
#include <com/sun/star/awt/XWindow.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif

#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif
#ifndef _CPPUHELPER_INTERFACECONTAINER_H_
#include <cppuhelper/interfacecontainer.h>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _UNOTOOLS_PROPERTY_ARRAY_HELPER_HXX_
#include <unotools/proparrhlp.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryinterface.hxx>
#endif
#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif
#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif
#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif
#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif
#ifndef _SVX_IMPGRF_HXX
#include <impgrf.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _FM_IMPLEMENTATION_IDS_HXX_
#include "fmimplids.hxx"
#endif

#ifndef _TOOLKIT_AWT_VCLXWINDOW_HXX_
#include <toolkit/awt/vclxwindow.hxx>
#endif

// --- needed because of the solar mutex
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
// ---

#if SUPD<583
#ifndef _USR_SMARTCONV_HXX_
#include <usr/smartconv.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HXX_
#include <smart/com/sun/star/lang/XMultiServiceFactory.hxx>
#endif
#endif

#ifndef _FM_STATIC_HXX_
#include "fmstatic.hxx"
#endif

//=========================================================================
//=========================================================================
// my properties
#define PROPERTY_ID_ASLINK						1
#define PROPERTY_ID_PREVIEWING					2
#define PROPERTY_ID_PATH						3
#define PROPERTY_ID_TITLE						4
#define PROPERTY_ID_ALLOW_LINK					5
#define PROPERTY_ID_ALLOW_EMPTY_FILENAMES		6
#define PROPERTY_ID_PARENT						7

namespace unambigouity {
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ASLINK, "ImportAsLink");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PREVIEWING, "PreviewActive");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PATH, "SelectedPath");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TITLE, "Title");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ALLOW_LINK, "AllowLink");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ALLOW_EMPTY_FILENAMES, "AllowEmptyFileNames");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PARENT, "ParentWindow");
}

using namespace unambigouity; 

//=========================================================================
//=========================================================================

namespace staruno	= ::com::sun::star::uno;
namespace starawt	= ::com::sun::star::awt;
namespace starlang	= ::com::sun::star::lang;
namespace starbeans	= ::com::sun::star::beans;

//=========================================================================
typedef	::cppu::WeakImplHelper3
			<starawt::XDialog
			,starlang::XServiceInfo
			,starlang::XInitialization
		> OImportGraphicsDialogBase;

class OImportGraphicsDialog
		:public OImportGraphicsDialogBase
		,public ::cppu::OPropertySetHelper
		,public ::utl::OPropertyArrayUsageHelper< OImportGraphicsDialog >
{
	friend ::utl::InterfaceRef OImportGraphicsDialog_CreateInstance(const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory);

	::osl::Mutex					m_aMutex;
	::osl::Mutex					m_aExecutionMutex;
	::cppu::OBroadcastHelper		m_aHelper;
	::form::OImplementationIdsRef	m_aHoldImplIdHelper;

	SvxImportGraphicDialog*		m_pDialog;
	sal_Bool					m_bExecuting : 1;
	sal_Bool					m_bCanceled : 1;	// endDialog was called while we were executing

	// <properties>
	sal_Bool								m_bAsLink;
	sal_Bool								m_bIsPreviewing;
	::rtl::OUString							m_sPath;
	::rtl::OUString							m_sTitle;
	sal_Bool								m_bAllowLink;
	sal_Bool								m_bAllowEmptyNames;
	staruno::Reference<starawt::XWindow>	m_xParent;
	// </properties>

	OImportGraphicsDialog();
	~OImportGraphicsDialog();

public:
	// UNO
	DECLARE_UNO3_DEFAULTS(OImportGraphicsDialog, OImportGraphicsDialogBase);
	virtual staruno::Any SAL_CALL queryInterface(const staruno::Type& _rType) throw (staruno::RuntimeException);

	// XTypeProvider
    virtual staruno::Sequence<staruno::Type> SAL_CALL getTypes(  ) throw(staruno::RuntimeException);
    virtual staruno::Sequence<sal_Int8> SAL_CALL getImplementationId(  ) throw(staruno::RuntimeException);

	// XServiceInfo
	virtual ::rtl::OUString SAL_CALL getImplementationName() throw(staruno::RuntimeException);
	virtual sal_Bool SAL_CALL supportsService(const ::rtl::OUString& ServiceName) throw(staruno::RuntimeException);
	virtual ::utl::StringSequence SAL_CALL getSupportedServiceNames() throw(staruno::RuntimeException);

	// XPropertySet
	virtual staruno::Reference<starbeans::XPropertySetInfo>  SAL_CALL getPropertySetInfo() throw(staruno::RuntimeException);
	virtual ::cppu::IPropertyArrayHelper& SAL_CALL getInfoHelper();

	// OPropertySetHelper
	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue ) throw(staruno::Exception);
	virtual sal_Bool SAL_CALL convertFastPropertyValue( staruno::Any& rConvertedValue, staruno::Any& rOldValue, sal_Int32 nHandle, const staruno::Any& rValue) throw(starlang::IllegalArgumentException);
	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

	// XDialog
    virtual void SAL_CALL setTitle( const ::rtl::OUString& Title ) throw(staruno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL getTitle(  ) throw(staruno::RuntimeException);
    virtual sal_Int16 SAL_CALL execute(  ) throw(staruno::RuntimeException);
    virtual void SAL_CALL endExecute(  ) throw(staruno::RuntimeException);

	// XInitialization
    virtual void SAL_CALL initialize( const staruno::Sequence< staruno::Any >& aArguments ) throw(staruno::Exception, staruno::RuntimeException);

	// OPropertyArrayUsageHelper
	virtual ::cppu::IPropertyArrayHelper* createArrayHelper( ) const;
};


//=========================================================================
//------------------------------------------------------------------
::utl::InterfaceRef OImportGraphicsDialog_CreateInstance(const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory)
{
	return *(new OImportGraphicsDialog());
}

//-------------------------------------------------------------------------
OImportGraphicsDialog::OImportGraphicsDialog()
		:OPropertySetHelper(m_aHelper)
		,m_aHelper(m_aMutex)
		,m_pDialog(NULL)
		,m_bAsLink(sal_False)
		,m_bIsPreviewing(sal_False)
		,m_bAllowLink(sal_False)
		,m_bAllowEmptyNames(sal_False)
		,m_bExecuting(sal_False)
		,m_bCanceled(sal_False)
{
}

//-------------------------------------------------------------------------
OImportGraphicsDialog::~OImportGraphicsDialog()
{
	{
		::osl::MutexGuard aGuard(m_aMutex);
		if (m_pDialog)
		{
			::vos::OGuard aSolarGuard(Application::GetSolarMutex());
			delete m_pDialog;
			m_pDialog = NULL;
		}
	}
}

//-------------------------------------------------------------------------
staruno::Any SAL_CALL OImportGraphicsDialog::queryInterface(const staruno::Type& _rType) throw (staruno::RuntimeException)
{
	staruno::Any aReturn = OImportGraphicsDialogBase::queryInterface(_rType);

	if (!aReturn.hasValue())
		aReturn = ::cppu::queryInterface(_rType
			,static_cast<starbeans::XPropertySet*>(this)
			,static_cast<starbeans::XMultiPropertySet*>(this)
			,static_cast<starbeans::XFastPropertySet*>(this)
		);

	return aReturn;
}

//-------------------------------------------------------------------------
staruno::Sequence<staruno::Type> SAL_CALL OImportGraphicsDialog::getTypes(  ) throw(staruno::RuntimeException)
{
	staruno::Sequence<staruno::Type> aTypes = OImportGraphicsDialogBase::getTypes();

	sal_Int32 nLen = aTypes.getLength();
	aTypes.realloc(nLen + 3);
	aTypes.getArray()[nLen++] = ::getCppuType(static_cast<staruno::Reference<starbeans::XPropertySet>*>(NULL));
	aTypes.getArray()[nLen++] = ::getCppuType(static_cast<staruno::Reference<starbeans::XFastPropertySet>*>(NULL));
	aTypes.getArray()[nLen++] = ::getCppuType(static_cast<staruno::Reference<starbeans::XMultiPropertySet>*>(NULL));

	return aTypes;
}

//-------------------------------------------------------------------------
staruno::Sequence<sal_Int8> SAL_CALL OImportGraphicsDialog::getImplementationId(  ) throw(staruno::RuntimeException)
{
	return form::OImplementationIds::getImplementationId(getTypes());
}

//-------------------------------------------------------------------------
::rtl::OUString SAL_CALL OImportGraphicsDialog::getImplementationName() throw(staruno::RuntimeException)
{
	return ::rtl::OUString::createFromAscii("com.sun.star.dialogs.OImportGraphicsDialog");
}

//-------------------------------------------------------------------------
sal_Bool SAL_CALL OImportGraphicsDialog::supportsService(const ::rtl::OUString& ServiceName) throw(staruno::RuntimeException)
{
	staruno::Sequence< ::rtl::OUString > aSupported(getSupportedServiceNames());
	const ::rtl::OUString* pArray = aSupported.getConstArray();
	for (sal_Int32 i = 0; i < aSupported.getLength(); ++i, ++pArray)
		if (pArray->equals(ServiceName))
			return sal_True;
	return sal_False;
}

//-------------------------------------------------------------------------
::utl::StringSequence SAL_CALL OImportGraphicsDialog::getSupportedServiceNames() throw(staruno::RuntimeException)
{
	::utl::StringSequence aSupported(1);

	aSupported.getArray()[0] = ::rtl::OUString::createFromAscii("com.sun.star.dialogs.ImportGraphicsDialog");

	return aSupported;
}

//-------------------------------------------------------------------------
staruno::Reference<starbeans::XPropertySetInfo>  SAL_CALL OImportGraphicsDialog::getPropertySetInfo() throw(staruno::RuntimeException)
{
	staruno::Reference<starbeans::XPropertySetInfo>  xInfo( createPropertySetInfo( getInfoHelper() ) );
	return xInfo;
}

//------------------------------------------------------------------------------
#define DECL_PROP1IMPL(varname, type) \
	pProperties[nPos++] = starbeans::Property(PROPERTY_##varname, PROPERTY_ID_##varname, ::getCppuType(reinterpret_cast< type* >(NULL)),

//------------------------------------------------------------------------------
#define DECL_BOOL_PROP1IMPL(varname) \
	pProperties[nPos++] = starbeans::Property(PROPERTY_##varname, PROPERTY_ID_##varname, ::getBooleanCppuType(),

//------------------------------------------------------------------------------
#define DECL_IFACE_PROP_IMPL(varname, type) \
	pProperties[nPos++] = starbeans::Property(PROPERTY_##varname, PROPERTY_ID_##varname, ::getCppuType(reinterpret_cast<staruno::Reference< type >*>(NULL)),

#define DECL_PROP0(varname, type)	\
	DECL_PROP1IMPL(varname, type) 0)

//------------------------------------------------------------------------------
#define DECL_PROP1(varname, type, attrib1)	\
	DECL_PROP1IMPL(varname, type) starbeans::PropertyAttribute::attrib1)

//------------------------------------------------------------------------------
#define DECL_PROP2(varname, type, attrib1, attrib2)	\
	DECL_PROP1IMPL(varname, type) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2)

//------------------------------------------------------------------------------
#define DECL_PROP3(varname, type, attrib1, attrib2, attrib3)	\
	DECL_PROP1IMPL(varname, type) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2 | starbeans::PropertyAttribute::attrib3)

//------------------------------------------------------------------------------
#define DECL_PROP4(varname, type, attrib1, attrib2, attrib3, attrib4)	\
	DECL_PROP1IMPL(varname, type) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2 | starbeans::PropertyAttribute::attrib3 | PropertyAttribute::attrib4)

//------------------------------------------------------------------------------
#define DECL_IFACE_PROP0(varname, type)	\
	DECL_IFACE_PROP_IMPL(varname, type) 0)

//------------------------------------------------------------------------------
#define DECL_IFACE_PROP1(varname, type, attrib1)	\
	DECL_IFACE_PROP_IMPL(varname, type) starbeans::PropertyAttribute::attrib1)

//------------------------------------------------------------------------------
#define DECL_IFACE_PROP2(varname, type, attrib1, attrib2)	\
	DECL_IFACE_PROP_IMPL(varname, type) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2)

//------------------------------------------------------------------------------
#define DECL_IFACE_PROP3(varname, type, attrib1, attrib2, attrib3)	\
	DECL_IFACE_PROP_IMPL(varname, type) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2 | starbeans::PropertyAttribute::attrib3)

//------------------------------------------------------------------------------
#define DECL_IFACE_PROP4(varname, type, attrib1, attrib2, attrib3, attrib4)	\
	DECL_IFACE_PROP_IMPL(varname, type) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2 | starbeans::PropertyAttribute::attrib3 | PropertyAttribute::attrib4)

//------------------------------------------------------------------------------
#define DECL_BOOL_PROP0(varname)	\
	DECL_BOOL_PROP1IMPL(varname) 0)

//------------------------------------------------------------------------------
#define DECL_BOOL_PROP1(varname, attrib1)	\
	DECL_BOOL_PROP1IMPL(varname) starbeans::PropertyAttribute::attrib1)

//------------------------------------------------------------------------------
#define DECL_BOOL_PROP2(varname, attrib1, attrib2)	\
	DECL_BOOL_PROP1IMPL(varname) starbeans::PropertyAttribute::attrib1 | starbeans::PropertyAttribute::attrib2)

//-------------------------------------------------------------------------
::cppu::IPropertyArrayHelper& OImportGraphicsDialog::getInfoHelper()
{
	return *const_cast<OImportGraphicsDialog*>(this)->getArrayHelper();
}

//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper* OImportGraphicsDialog::createArrayHelper( ) const
{
	staruno::Sequence< starbeans::Property > aProps(7);
	starbeans::Property* pProperties = aProps.getArray();
	sal_Int32 nPos = 0;
	DECL_BOOL_PROP2(ASLINK,										TRANSIENT, READONLY);
	DECL_BOOL_PROP1(PREVIEWING,									TRANSIENT);
	DECL_PROP2(PATH,						::rtl::OUString,	TRANSIENT, READONLY);
	DECL_PROP1(TITLE,						::rtl::OUString,	TRANSIENT);
	DECL_BOOL_PROP1(ALLOW_LINK,									TRANSIENT);
	DECL_BOOL_PROP1(ALLOW_EMPTY_FILENAMES,						TRANSIENT);
	DECL_IFACE_PROP1(PARENT,				starawt::XWindow,	TRANSIENT);

	return new ::cppu::OPropertyArrayHelper(aProps);
}

//-------------------------------------------------------------------------
void OImportGraphicsDialog::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue ) throw(staruno::Exception)
{
	// TODO : need some handling if we're currently executing ...

	switch (nHandle)
	{
		case PROPERTY_ID_ASLINK:
			m_bAsLink = ::utl::getBOOL(rValue);
			break;
		case PROPERTY_ID_PREVIEWING:
			m_bIsPreviewing = ::utl::getBOOL(rValue);
			break;
		case PROPERTY_ID_PATH:
			rValue >>= m_sPath;
			break;
		case PROPERTY_ID_TITLE:
			rValue >>= m_sTitle;
			break;
		case PROPERTY_ID_ALLOW_LINK:
			m_bAllowLink = ::utl::getBOOL(rValue);
			break;
		case PROPERTY_ID_ALLOW_EMPTY_FILENAMES:
			m_bAllowEmptyNames = ::utl::getBOOL(rValue);
			break;
		case PROPERTY_ID_PARENT:
			::cppu::extractInterface(m_xParent, rValue);
			// TODO : need to be a dispose listener on the interface ...
			break;
	}
}

//-------------------------------------------------------------------------
sal_Bool OImportGraphicsDialog::convertFastPropertyValue( staruno::Any& rConvertedValue, staruno::Any& rOldValue, sal_Int32 nHandle, const staruno::Any& rValue) throw(starlang::IllegalArgumentException)
{
	switch (nHandle)
	{
		case PROPERTY_ID_ASLINK:
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_bAsLink);
			break;
		case PROPERTY_ID_PREVIEWING:
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_bIsPreviewing);
			break;
		case PROPERTY_ID_PATH:
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_sPath);
			break;
		case PROPERTY_ID_TITLE:
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_sTitle);
			break;
		case PROPERTY_ID_ALLOW_LINK:
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_bAllowLink);
			break;
		case PROPERTY_ID_ALLOW_EMPTY_FILENAMES:
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_bAllowEmptyNames);
			break;
		case PROPERTY_ID_PARENT:
		{
			staruno::Reference<starawt::XWindow> xNew;
			::cppu::extractInterface(xNew, rValue);
			if (xNew != m_xParent)
				return sal_True;
		}
		break;
			return ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, m_bAsLink);
	}
	DBG_ERROR("OImportGraphicsDialog::convertFastPropertyValue : unknown handle !");
	return sal_False;
}

//-------------------------------------------------------------------------
void OImportGraphicsDialog::getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROPERTY_ID_ASLINK:
			rValue <<= m_bAsLink;
			break;
		case PROPERTY_ID_PREVIEWING:
			rValue <<= m_bIsPreviewing;
			break;
		case PROPERTY_ID_PATH:
			rValue <<= m_sPath;
			break;
		case PROPERTY_ID_TITLE:
			rValue <<= m_sTitle;
			break;
		case PROPERTY_ID_ALLOW_LINK:
			rValue <<= m_bAllowLink;
			break;
		case PROPERTY_ID_ALLOW_EMPTY_FILENAMES:
			rValue <<= m_bAllowEmptyNames;
			break;
		case PROPERTY_ID_PARENT:
			rValue = staruno::makeAny(m_xParent);
			break;
	}
}

//-------------------------------------------------------------------------
void SAL_CALL OImportGraphicsDialog::setTitle( const ::rtl::OUString& _rTitle ) throw(staruno::RuntimeException)
{
	setPropertyValue(PROPERTY_TITLE, staruno::makeAny(_rTitle));
}

//-------------------------------------------------------------------------
::rtl::OUString SAL_CALL OImportGraphicsDialog::getTitle(  ) throw(staruno::RuntimeException)
{
	return m_sTitle;
}

//-------------------------------------------------------------------------
sal_Int16 SAL_CALL OImportGraphicsDialog::execute(  ) throw(staruno::RuntimeException)
{
	SvxImportGraphicDialog* pDialog = NULL;
	// create the dialog, if neccessary
	{
		::osl::MutexGuard aGuard(m_aMutex);

		if (m_bExecuting)
			throw staruno::RuntimeException();

		if (!m_pDialog)
		{
			// get the parameters for the dialog from the current settings
			// the window
			Window* pParent = NULL;
			VCLXWindow* pImplementation = VCLXWindow::GetImplementation(m_xParent);
			if (pImplementation)
				pParent = pImplementation->GetWindow();
			// the title
			UniString sTitle = m_sTitle;
			// the enable bits
			USHORT nEnableBits = ENABLE_STANDARD;
			if (m_bAllowLink)
				nEnableBits |= ENABLE_LINK;
			if (m_bAllowEmptyNames)
				nEnableBits |= ENABLE_EMPTY_FILENAMES;

			{
				::vos::OGuard aGuard(Application::GetSolarMutex());
				m_pDialog = new SvxImportGraphicDialog(pParent, sTitle, nEnableBits);
				// do some initialisations
				m_pDialog->SetPreviewing(m_bIsPreviewing);
				// unfortunally the initial state of the "as link" check box (m_bAsLink) can't be set on the dialog
				// ...
				// the same counts for the path : SetPath a private member
				//m_pDialog->SetPath(UniString(m_sPath));
			}
			pDialog = m_pDialog;
		}

		m_bCanceled = sal_False;
		m_bExecuting = sal_True;
	}

	// start execution
	sal_Int16 nReturn(0);
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		nReturn = pDialog->Execute();

		::osl::MutexGuard aExecutionGuard(m_aExecutionMutex);
		if (m_bCanceled)
			nReturn = RET_CANCEL;
	}

	::osl::MutexGuard aGuard(m_aMutex);

	// get the settings of the dialog
	if (RET_OK == nReturn)
	{
		m_sPath = UniString(pDialog->GetPath());
		m_bIsPreviewing = pDialog->IsPreviewing();
		m_bAsLink = pDialog->AsLink();
	}

	m_bExecuting = sal_False;
	// outta here
	return nReturn;
}

//-------------------------------------------------------------------------
void SAL_CALL OImportGraphicsDialog::endExecute(  ) throw(staruno::RuntimeException)
{
	::osl::MutexGuard aGuard(m_aMutex);
	if (!m_bExecuting)
		throw staruno::RuntimeException();

	{
		::osl::MutexGuard aExecutionGuard(m_aExecutionMutex);
		DBG_ASSERT(m_pDialog, "OImportGraphicsDialog::endExecute : executing which dialog ?");
			// m_bExecuting is true but we have no dialog ?
		if (!m_pDialog)
			throw staruno::RuntimeException();

		if (!m_pDialog->IsInExecute())
			// we tighly missed it ... another thread finished the execution of the dialog,
			// but did not manage it to reset m_bExecuting, it currently tries to acquire
			// m_aMutex or m_aExecutionMutex
			// => nothing to do
			return;

		m_pDialog->EndDialog(RET_CANCEL);
		m_bCanceled = sal_True;
	}
}

//-------------------------------------------------------------------------
void SAL_CALL OImportGraphicsDialog::initialize( const staruno::Sequence< staruno::Any >& aArguments ) throw(staruno::Exception, staruno::RuntimeException)
{
	staruno::Reference<starbeans::XPropertySetInfo> xProps = getPropertySetInfo();
	if (!xProps.is())
		return;

//	staruno::Sequence<starbeans::Property> aProps = xProps->getProperties();
//	starbeans::Property* pProps = aProps.getConstArray();

	const staruno::Type aPropValueType = ::getCppuType(static_cast<starbeans::PropertyValue*>(NULL));

	const staruno::Any* pArguments = aArguments.getConstArray();
	for (sal_Int32 i=0; i<aArguments.getLength(); ++i, ++pArguments)
	{
		if (pArguments->getValueType().equals(aPropValueType))
		{
			starbeans::PropertyValue aCurrArg;
			*pArguments >>= aCurrArg;
			if (xProps->hasPropertyByName(aCurrArg.Name))
			{
				try
				{
					setPropertyValue(aCurrArg.Name, aCurrArg.Value);
				}
				catch(...)
				{
				}
			}
		}
	}
}

