/*************************************************************************
 *
 *  $RCSfile: fmcontr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma hdrstop

#ifndef _SVX_FMCONTR_HXX
#include "fmcontr.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif
#ifndef _SVX_FMPROP_HXX
#include "fmprop.hxx"
#endif
#ifndef _SVX_FMPROP_HRC
#include "fmprop.hrc"
#endif
#ifndef _USR_SERVICES_HXX
#include <usr/services.hxx>
#endif
#ifndef _SVX_FMSERVS_HXX
#include "fmservs.hxx"
#endif
#ifndef _SMART_COM_SUN_STAR_IO_WRONGFORMATEXCEPTION_HXX_
#include <smart/com/sun/star/io/WrongFormatException.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_FORM_XFORM_HXX_
#include <smart/com/sun/star/form/XForm.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XMARKABLESTREAM_HXX_
#include <smart/com/sun/star/io/XMarkableStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XOBJECTINPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XObjectInputStream.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XPERSISTOBJECT_HXX_
#include <smart/com/sun/star/io/XPersistObject.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XOBJECTOUTPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XObjectOutputStream.hxx>
#endif

#ifndef _TOOLS_RESID_HXX //autogen
#include <tools/resid.hxx>
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#ifndef _SVX_DIALMGR_HXX
#include "dialmgr.hxx"
#endif

#ifndef _TOOLKIT_UNOIFACE_HXX
#include <toolkit/unoiface.hxx>
#endif

#ifndef _VOS_NO_NAMESPACE
using namespace vos;
#endif

#ifdef _USE_NAMESPACE
using namespace usr;
#endif

//------------------------------------------------------------------
FmXInterfaceContainer::FmXInterfaceContainer(IMutex& _rMutex, InterfaceReflection* pElementReflection, const Uik& rUik)
					  :m_rMutex(_rMutex)
					  ,m_aContainerListeners(_rMutex)
					  ,m_pElementReflection(pElementReflection)
					  ,m_aElementUik(rUik)
{
	m_xEventAttacher = createEventAttacherManager();
}

//------------------------------------------------------------------------------
BOOL FmXInterfaceContainer::queryInterface(Uik aUik, XInterfaceRef& rOut)
{
	if (aUik == ((XNameAccess*) this)->XElementAccess::getSmartUik())
		rOut = (XElementAccess*) (XNameAccess*)this;
	else if (aUik == XIndexAccess::getSmartUik())
		rOut = (XIndexAccess*) this;
	else if (aUik == XNameAccess::getSmartUik())
		rOut = (XNameAccess*) this;
	else if (aUik == XIndexReplace::getSmartUik())
		rOut = (XIndexReplace*) this;
	else if (aUik == XNameReplace::getSmartUik())
		rOut = (XNameReplace*) this;
	else if (aUik == XIndexContainer::getSmartUik())
		rOut = (XIndexContainer*) this;
	else if (aUik == XNameContainer::getSmartUik())
		rOut = (XNameContainer*) this;
	else if (aUik == XEnumerationAccess::getSmartUik())
		rOut = (XEnumerationAccess*) this;
	else if (aUik == XContainer::getSmartUik())
		rOut = (XContainer*) this;
	else if (aUik == XEventListener::getSmartUik())
		rOut = (XEventListener*) this;
	else if (aUik == XPropertyChangeListener::getSmartUik())
		rOut = (XPropertyChangeListener*) this;
	else if (aUik == XEventAttacherManager::getSmartUik())
		rOut = (XEventAttacherManager*) this;
	else
		rOut = NULL;

	return rOut.is();
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::disposing(void)
{
	// dispose aller elemente
	for (INT32 i = m_aItems.size(); i > 0; i--)
	{
		XPropertySetRef xSet(m_aItems[i - 1], USR_QUERY);
		if (xSet.is())
			xSet->removePropertyChangeListener(FM_PROP_NAME, this);

		// Eventverknpfungen aufheben
		XInterfaceRef xIfc(xSet, USR_QUERY);
		m_xEventAttacher->detach(i - 1, xIfc);
		m_xEventAttacher->removeEntry(i - 1);

		XComponentRef xComponent(xSet, USR_QUERY);
		if (xComponent.is())
			xComponent->dispose();		
	}
	m_aMap.clear();
	m_aItems.clear();

	EventObject aEvt((XContainer*)this);
	m_aContainerListeners.disposeAndClear(aEvt);
}

// XPersistObject
//------------------------------------------------------------------------------
void FmXInterfaceContainer::writeEvents(const XObjectOutputStreamRef& OutStream)
{
	XMarkableStreamRef xMark(OutStream, USR_QUERY);
	INT32 nMark = xMark->createMark();

	INT32 nObjLen = 0;
	OutStream->writeLong(nObjLen);

	XPersistObjectRef xScripts(m_xEventAttacher, USR_QUERY);
	if (xScripts.is())
		xScripts->write(OutStream);

	// feststellen der Laenge
	nObjLen = xMark->offsetToMark(nMark) - 4;
	xMark->jumpToMark(nMark);
	OutStream->writeLong(nObjLen);
	xMark->jumpToFurthest();
	xMark->deleteMark(nMark);
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::readEvents(const XObjectInputStreamRef& InStream, INT32 nCount)
{
	OGuard aGuard( m_rMutex );
	if (nCount)
	{
		// Scripting Info lesen
		XMarkableStreamRef xMark(InStream, USR_QUERY);
		INT32 nObjLen = InStream->readLong();
		if (nObjLen)
		{
			INT32 nMark = xMark->createMark();
			XPersistObjectRef xObj(m_xEventAttacher, USR_QUERY);
			if (xObj.is())
				xObj->read(InStream);
			xMark->jumpToMark(nMark);
			InStream->skipBytes(nObjLen);
			xMark->deleteMark(nMark);
		}

		// Attachement lesen
		for (INT32 i = 0; i < nCount; i++)
		{
			XInterfaceRef xIfc(m_aItems[i], USR_QUERY);
			XPropertySetRef xSet(xIfc, USR_QUERY);
			UsrAny aHelper(&xSet, XPropertySet_getReflection());
			m_xEventAttacher->attach( i, xIfc, aHelper );
		}
	}
	else
	{
		// neuen EventManager
		m_xEventAttacher = createEventAttacherManager();
	}
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::write(const XObjectOutputStreamRef& OutStream)
{
	OGuard aGuard( m_rMutex );
	INT32 nLen = m_aItems.size();

	// schreiben der laenge
	OutStream->writeLong(nLen);

	if (nLen)
	{
		// 1. Version
		OutStream->writeShort(0x0001);

		// 2. Objekte
		for (INT32 i = 0; i < nLen; i++)
		{
			XPersistObjectRef xObj(m_aItems[i], USR_QUERY);
			if (xObj.is())
				OutStream->writeObject(xObj);
			else
			{
				// Error
			}
		}

		// 3. Scripts
		writeEvents(OutStream);
	}
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::read(const XObjectInputStreamRef& InStream)
{
	OGuard aGuard( m_rMutex );

	// after ::read the object is expected to be in the state it was when ::write was called, so we have
	// to empty ourself here
	// FS - 71598 - 12.01.00
	while (getCount())
		removeByIndex(0);

	// Schreibt nur in Abhaengigkeit der Lnge
	INT32 nLen = InStream->readLong();

	if (nLen)
	{
		// 1. Version
		UINT16 nVersion = InStream->readShort();

		// 2. Objekte
		for (INT32 i = 0; i < nLen; i++)
		{
			XPersistObjectRef xObj;
			TRY
			{
				xObj = InStream->readObject();
			}
			CATCH(WrongFormatException, e)
			{
				// the object could not be read
				xObj = NULL;
				// create a dummy HiddenControl (so the readEvents below will assign the events to the right controls)
				xObj = XPersistObjectRef(NAMESPACE_USR(getProcessServiceManager)()->createInstance(FM_COMPONENT_HIDDENCONTROL), USR_QUERY);
				DBG_ASSERT(xObj.Is(), "FmXInterfaceContainer::read : could not create a substitute for the unknown object !");
				if (!xObj.Is())
					// couldn't handle it ...
					THROW_AGAIN;

				// set some properties describing what we did
				XPropertySetRef xObjProps(xObj, USR_QUERY);
				if (xObjProps.Is())
				{
					TRY
					{
						xObjProps->setPropertyValue(FM_PROP_NAME, UsrAny(U(SVX_RES(RID_STR_CONTROL_SUBSTITUTED_NAME))));
						xObjProps->setPropertyValue(FM_PROP_TAG, UsrAny(U(SVX_RES(RID_STR_CONTROL_SUBSTITUTED_EPXPLAIN))));
					}
					CATCH_ALL()
					{
					}
					END_CATCH;
				}
				// 72133 - 09.02.00 - FS
			}
			AND_CATCH_ALL()
			{
				// unsere Map leeren
				while (!m_aItems.empty())
					removeElementsNoEvents(0);

				// und die Exception nach aussen
				THROW_AGAIN
			}
			END_CATCH

			if (xObj.is())
			{
				XInterfaceRef xElement;
				xObj->queryInterface(m_aElementUik, xElement);
				if (xElement.is())
					insert(m_aItems.size(), xElement, FALSE);
				else
					; // form konnte nicht gelesen werden; nyi
			}
		}
	}

	readEvents(InStream, nLen);
}

// XContainer
//------------------------------------------------------------------------------
void FmXInterfaceContainer::addContainerListener(const XContainerListenerRef& l) THROWS((UsrSystemException))
{
	m_aContainerListeners.addInterface(l);
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::removeContainerListener(const XContainerListenerRef& l) THROWS((UsrSystemException))
{
	m_aContainerListeners.removeInterface(l);
}

// XEventListener
//------------------------------------------------------------------------------
void FmXInterfaceContainer::disposing(const EventObject& evt) THROWS( (UsrSystemException) )
{
	OGuard aGuard( m_rMutex );

	OInterfaceArray::iterator j = find(m_aItems.begin(), m_aItems.end(), evt.Source);
	if (j != m_aItems.end())
	{
		OInterfaceMap::iterator i = m_aMap.begin();
		while (i != m_aMap.end() && (*i).second != evt.Source) ++i;

		m_aMap.erase(i);
		m_aItems.erase(j);	
	}
}

// XPropertyChangeListener
//------------------------------------------------------------------------------
void FmXInterfaceContainer::propertyChange(const PropertyChangeEvent& evt)
{
	if (evt.PropertyName == FM_PROP_NAME)
	{
		OGuard aGuard( m_rMutex );		
		OInterfaceMap::iterator i = find(m_aMap.begin(), m_aMap.end(), 
			pair<const UString, XInterfaceRef >(evt.OldValue.getString(),evt.Source));
		if (i != m_aMap.end())
		{
			XInterfaceRef xCorrectType((*i).second);
			m_aMap.erase(i);	
			m_aMap.insert(pair<const UString, XInterfaceRef >(evt.NewValue.getString(),xCorrectType));
		}
	}	
}

// XElementAccess
//------------------------------------------------------------------------------
BOOL FmXInterfaceContainer::hasElements(void) const THROWS((UsrSystemException))
{
	return !m_aMap.empty();
}

//------------------------------------------------------------------------------
XIdlClassRef FmXInterfaceContainer::getElementType(void) const THROWS((UsrSystemException))
{
	return m_pElementReflection->getIdlClass();
}

// XEnumerationAccess
//------------------------------------------------------------------------------
XEnumerationRef FmXInterfaceContainer::createEnumeration(void) THROWS((UsrSystemException))
{
	OGuard aGuard( m_rMutex );
	return new FmEnumerationByIndex((XIndexAccess*)this);
}

// XNameAccess
//------------------------------------------------------------------------------
UsrAny FmXInterfaceContainer::getByName(const UString& Name) const THROWS((NoSuchElementException, WrappedTargetException, UsrSystemException))
{
	pair <OInterfaceMap::const_iterator,
		  OInterfaceMap::const_iterator> aPair = m_aMap.equal_range(Name);
	
	if (aPair.first == aPair.second)
		THROW(NoSuchElementException());	

	return UsrAny(&(*aPair.first).second, m_pElementReflection);
}

//------------------------------------------------------------------------------
Sequence<UString> FmXInterfaceContainer::getElementNames(void) const THROWS((UsrSystemException))
{
	Sequence<UString> aNameList(m_aItems.size());
	UString* pStringArray = aNameList.getArray();

	for (OInterfaceMap::const_iterator i = m_aMap.begin(); i != m_aMap.end(); i++)
	{
		*pStringArray = (*i).first;
		++pStringArray;
	}
	return aNameList;
}

//------------------------------------------------------------------------------
BOOL FmXInterfaceContainer::hasByName(const UString& Name) const THROWS((UsrSystemException))
{
	pair <OInterfaceMap::const_iterator,
		  OInterfaceMap::const_iterator> aPair = m_aMap.equal_range(Name);
	return aPair.first != aPair.second;
}

// XIndexAccess
//------------------------------------------------------------------------------
INT32 FmXInterfaceContainer::getCount(void) const THROWS((UsrSystemException))
{
	return m_aItems.size();
}

//------------------------------------------------------------------------------
UsrAny FmXInterfaceContainer::getByIndex(INT32 Index) const THROWS((IndexOutOfBoundsException, WrappedTargetException, UsrSystemException))
{
	if (Index < 0 || Index >= m_aItems.size())
		THROW(IndexOutOfBoundsException());	

	return UsrAny(&m_aItems[Index], m_pElementReflection);
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::insert(INT32 Index, const XInterfaceRef& xElement, BOOL bEvents) THROWS((IllegalArgumentException))
{
	// das richtige Interface besorgen
	XInterfaceRef xCorrectType;
	if (!xElement->queryInterface(m_aElementUik, xCorrectType))
		THROW(IllegalArgumentException());
	
	UString sName;
	XPropertySetRef xSet(xElement, USR_QUERY);
	if (xSet.is())
	{
		if (!::hasProperty(FM_PROP_NAME, xSet))
			THROW(IllegalArgumentException());		

		UsrAny aValue = xSet->getPropertyValue(FM_PROP_NAME);
		sName = aValue.getString();
		xSet->addPropertyChangeListener(FM_PROP_NAME, this);
	}
	else
		THROW(IllegalArgumentException());
	
	if (Index > m_aItems.size()) // ermitteln des tatsaechlichen Indexs
	{
		Index = m_aItems.size();
		m_aItems.push_back(xCorrectType);
	}
	else
		m_aItems.insert(m_aItems.begin() + Index, xCorrectType);

	m_aMap.insert(pair<const UString, XInterfaceRef >(sName,xCorrectType));	

	XChildRef xChild(xElement, USR_QUERY);
	if (xChild.is())
		xChild->setParent((XContainer*)this);

	if (bEvents)
	{
		m_xEventAttacher->insertEntry(Index);
		XInterfaceRef xIfc(xElement, USR_QUERY);// wichtig
		UsrAny aHelper(&xSet, XPropertySet_getReflection());
		m_xEventAttacher->attach(Index, xIfc, aHelper);
	}

	// notify derived classes
	implInserted(xCorrectType);

	// notify listeners
	ContainerEvent aEvt;
	aEvt.Source   = (XContainer*)this;
	aEvt.Accessor = UsrAny(Index);
	aEvt.Element  = UsrAny(&xCorrectType, m_pElementReflection);
	NOTIFY_LISTENERS(m_aContainerListeners, XContainerListener, elementInserted, aEvt);	
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::removeElementsNoEvents(INT32 nIndex)
{
	OInterfaceArray::iterator i = m_aItems.begin() + nIndex;
	XInterfaceRef xElement(*i);	

	OInterfaceMap::iterator j = m_aMap.begin();
	while (j != m_aMap.end() && (*j).second != xElement) ++j;	
	
	m_aItems.erase(i);	
	m_aMap.erase(j);	
	
	XPropertySetRef xSet(xElement, USR_QUERY);
	if (xSet.is())
		xSet->removePropertyChangeListener(FM_PROP_NAME, this);

	XChildRef xChild(xElement, USR_QUERY);
	if (xChild.is())
		xChild->setParent(XInterfaceRef());	
}

// XIndexContainer
//------------------------------------------------------------------------------
void FmXInterfaceContainer::insertByIndex(INT32 Index, const UsrAny& Element) THROWS((IllegalArgumentException, IndexOutOfBoundsException, WrappedTargetException, UsrSystemException))
{
	if (Element.getReflection()->getTypeClass() != TypeClass_INTERFACE)
		THROW(IllegalArgumentException());	

	OGuard aGuard( m_rMutex );			  	
	insert(Index, XInterfaceRef(*(XInterfaceRef*)Element.get()), TRUE);
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::replaceByIndex(INT32 Index, const UsrAny& Element) THROWS((IllegalArgumentException, IndexOutOfBoundsException, WrappedTargetException, UsrSystemException))
{
	if (Element.getReflection()->getTypeClass() != TypeClass_INTERFACE)
		THROW(IllegalArgumentException());
	
	OGuard aGuard( m_rMutex );
	if (Index < 0 || Index >= m_aItems.size())
		THROW(IndexOutOfBoundsException());

	
	XInterfaceRef xOldElement(m_aItems[Index]);		
	XInterfaceRef xNewElement(*(XInterfaceRef*)Element.get());

	OInterfaceMap::iterator j = m_aMap.begin();
	while (j != m_aMap.end() && (*j).second != xOldElement) ++j;			
	
	// Eventverknpfungen aufheben
	XInterfaceRef xIfc(xOldElement, USR_QUERY);// wichtig
	m_xEventAttacher->detach(Index, xIfc);
	m_xEventAttacher->removeEntry(Index);

	XPropertySetRef xSet(xOldElement, USR_QUERY);
	if (xSet.is())
		xSet->removePropertyChangeListener(FM_PROP_NAME, this);

	XChildRef xChild(xOldElement, USR_QUERY);
	if (xChild.is())
		xChild->setParent(XInterfaceRef());
	
	// neue einfuegen
	UString sName;
	xSet = XPropertySetRef(xNewElement, USR_QUERY);
	if (xSet.is())
	{
		if (!::hasProperty(FM_PROP_NAME, xSet))
			THROW(IllegalArgumentException());		

		UsrAny aValue = xSet->getPropertyValue(FM_PROP_NAME);
		sName = aValue.getString();
		xSet->addPropertyChangeListener(FM_PROP_NAME, this);
	}
	else
		THROW(IllegalArgumentException());
	
	// remove the old one	
	m_aMap.erase(j);	

	// insert the new one
	m_aMap.insert(pair<const UString, XInterfaceRef >(sName,xNewElement));	
	m_aItems[Index] = xNewElement;		

	xChild = XChildRef(xNewElement, USR_QUERY);
	if (xChild.is())
		xChild->setParent((XContainer*)this);

	m_xEventAttacher->insertEntry(Index);
	xIfc = XInterfaceRef(xNewElement, USR_QUERY);// wichtig
	UsrAny aHelper(&xSet, XPropertySet_getReflection());
	m_xEventAttacher->attach(Index, xIfc, aHelper);

	// benachrichtigen
	ContainerEvent aEvt;
	aEvt.Source   = (XContainer*)this;
	aEvt.Accessor = UsrAny(Index);
	aEvt.Element  = UsrAny(&xNewElement, m_pElementReflection);
	aEvt.ReplacedElement = UsrAny(&xOldElement, m_pElementReflection);
	NOTIFY_LISTENERS(m_aContainerListeners, XContainerListener, elementReplaced, aEvt);	
}

//------------------------------------------------------------------------------
void FmXInterfaceContainer::removeByIndex(INT32 Index) THROWS((IndexOutOfBoundsException, WrappedTargetException, UsrSystemException))
{
	OGuard aGuard( m_rMutex );
	if (Index < 0 || Index >= m_aItems.size())
		THROW(IndexOutOfBoundsException());

	OInterfaceArray::iterator i = m_aItems.begin() + Index;
	XInterfaceRef xElement(*i);	
	
	OInterfaceMap::iterator j = m_aMap.begin();
	while (j != m_aMap.end() && (*j).second != xElement) ++j;				
	
	m_aItems.erase(i);	
	m_aMap.erase(j);	

	// Eventverknpfungen aufheben
	XInterfaceRef xIfc(xElement, USR_QUERY);// wichtig
	m_xEventAttacher->detach(Index, xIfc);
	m_xEventAttacher->removeEntry(Index);

	XPropertySetRef xSet(xElement, USR_QUERY);
	if (xSet.is())
		xSet->removePropertyChangeListener(FM_PROP_NAME, this);

	XChildRef xChild(xElement, USR_QUERY);
	if (xChild.is())
		xChild->setParent(XInterfaceRef());

	// notify derived classes
	implRemoved(xElement);

	// notify listeners
	ContainerEvent aEvt;
	aEvt.Source     = (XContainer*)this;
	aEvt.Element    = UsrAny(&xElement, m_pElementReflection);
	aEvt.Accessor   = UsrAny(Index);
	NOTIFY_LISTENERS(m_aContainerListeners, XContainerListener, elementRemoved, aEvt);	
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::insertByName(const UString& Name, const UsrAny& Element) THROWS((IllegalArgumentException, ElementExistException, WrappedTargetException, UsrSystemException))
{
	OGuard aGuard( m_rMutex );
	if (Element.getReflection()->getTypeClass() != TypeClass_INTERFACE)
		THROW(IllegalArgumentException());	

	XInterfaceRef xElement(*(XInterfaceRef*)Element.get());
	XPropertySetRef xSet(xElement, USR_QUERY);
	if (xSet.is())
	{
		if (!::hasProperty(FM_PROP_NAME, xSet))
			THROW(IllegalArgumentException());		

		xSet->setPropertyValue(FM_PROP_NAME, UsrAny(Name));
	}
	
	insertByIndex(m_aItems.size(), Element);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::replaceByName(const UString& Name, const UsrAny& Element) THROWS((IllegalArgumentException, NoSuchElementException, WrappedTargetException, UsrSystemException))
{
	OGuard aGuard( m_rMutex );
	pair <OInterfaceMap::iterator,
		  OInterfaceMap::iterator> aPair = m_aMap.equal_range(Name);
	if (aPair.first == aPair.second)
		THROW(NoSuchElementException());

	if (Element.getReflection()->getTypeClass() != TypeClass_INTERFACE)
		THROW(IllegalArgumentException());	
	
	XPropertySetRef xSet(*(XInterfaceRef*)Element.get(), USR_QUERY);
	if (xSet.is())
	{
		if (!::hasProperty(FM_PROP_NAME, xSet))
			THROW(IllegalArgumentException());		

		xSet->setPropertyValue(FM_PROP_NAME, UsrAny(Name));
	}

	// determine the element pos	
	INT32 nPos = find(m_aItems.begin(), m_aItems.end(), (*aPair.first).second) - m_aItems.begin();
	replaceByIndex(nPos, Element);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::removeByName(const UString& Name) THROWS((NoSuchElementException, WrappedTargetException, UsrSystemException))
{
	OGuard aGuard( m_rMutex );
	pair <OInterfaceMap::iterator,
		  OInterfaceMap::iterator> aPair = m_aMap.equal_range(Name);
	if (aPair.first == aPair.second)
		THROW(NoSuchElementException());

	INT32 nPos = find(m_aItems.begin(), m_aItems.end(), (*aPair.first).second) - m_aItems.begin();
	removeByIndex(nPos);
}


// XEventAttacherManager
//------------------------------------------------------------------------
void FmXInterfaceContainer::registerScriptEvent(INT32 nIndex, const ScriptEventDescriptor& ScriptEvent)
{
	m_xEventAttacher->registerScriptEvent(nIndex, ScriptEvent);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::registerScriptEvents(INT32 nIndex, const Sequence< ScriptEventDescriptor >& ScriptEvents)
{
	m_xEventAttacher->registerScriptEvents(nIndex, ScriptEvents);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::revokeScriptEvent(INT32 nIndex, const UString& ListenerType, const UString& EventMethod, const UString &rRemoveParam )
{
	m_xEventAttacher->revokeScriptEvent(nIndex,
						ListenerType, EventMethod, rRemoveParam );
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::revokeScriptEvents(INT32 nIndex)
{
	m_xEventAttacher->revokeScriptEvents(nIndex);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::insertEntry(INT32 nIndex)
{
	m_xEventAttacher->insertEntry(nIndex);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::removeEntry(INT32 nIndex)
{
	m_xEventAttacher->removeEntry(nIndex);
}

//------------------------------------------------------------------------
Sequence< ScriptEventDescriptor > FmXInterfaceContainer::getScriptEvents(INT32 nIndex)
{
	return m_xEventAttacher->getScriptEvents(nIndex);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::attach(INT32 nIndex, const XInterfaceRef& xObject, const UsrAny & rHelper )
{
	m_xEventAttacher->attach(nIndex, xObject, rHelper);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::detach(INT32 nIndex, const XInterfaceRef& xObject)
{
	m_xEventAttacher->detach(nIndex, xObject);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::addScriptListener(const XScriptListenerRef& aListener)
{
	m_xEventAttacher->addScriptListener(aListener);
}

//------------------------------------------------------------------------
void FmXInterfaceContainer::removeScriptListener(const XScriptListenerRef& aListener)
{
	m_xEventAttacher->removeScriptListener(aListener);
}

//------------------------------------------------------------------
SMART_UNO_IMPLEMENTATION(FmXForms, OComponentHelper);
DBG_NAME(FmXForms);

//------------------------------------------------------------------
XInterfaceRef FmXForms_NewInstance_Impl()
{
	return *(new FmXForms());
}

//------------------------------------------------------------------
Reflection* FmXForms_getReflection()
{
	static StandardClassReflection aRefl
	(
		FmXForms_NewInstance_Impl,
		createStandardClass
		   ( L"FmXForms",
			 OComponentHelper::getStaticIdlClass(),
			 7 ,
			 XChild_getReflection(),
			 XContainer_getReflection(),
			 XNameContainer_getReflection(),
			 XIndexContainer_getReflection(),
			 XEnumerationAccess_getReflection(),
			 XEventAttacherManager_getReflection(),
			 XPropertyChangeListener_getReflection())
	);
	return &aRefl;
}

//------------------------------------------------------------------
void* FmXForms::getImplementation(Reflection * pRef)
{
	if (pRef == FmXForms_getReflection() )
		return this;
	else
		return OComponentHelper::getImplementation(pRef);
}

//------------------------------------------------------------------
FmXForms::FmXForms()
		 :OComponentHelper(m_aMutex)
		 ,FmXInterfaceContainer(m_aMutex, (InterfaceReflection*)XForm_getReflection(), XForm::getSmartUik())
{
	DBG_CTOR(FmXForms, NULL);
}

//------------------------------------------------------------------------------
FmXForms::~FmXForms()
{
	DBG_DTOR(FmXForms, NULL);
	if (!OComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

//------------------------------------------------------------------------------
Sequence< XIdlClassRef > FmXForms::getIdlClasses()
{
	static XIdlClassRef xClass = FmXForms_getReflection()->getIdlClass();
	return Sequence< XIdlClassRef> (&xClass, 1);
}

//------------------------------------------------------------------------------
BOOL FmXForms::queryAggregation(Uik aUik, XInterfaceRef& rOut)
{
#if PRIV_DEBUG && SUPD<544
	if (aUik == XContent::getSmartUik())
	{
		DBG_ERROR("FmXForms::queryAggregation : somebody's requesting my old content interface !");
	}
#endif
	if (aUik == XChild::getSmartUik())
		rOut = (XChild*)this;
	else if (!FmXInterfaceContainer::queryInterface(aUik, rOut))
		OComponentHelper::queryAggregation(aUik, rOut);

	return rOut.is();
}

// OComponentHelper
//------------------------------------------------------------------------------
void FmXForms::disposing()
{
	FmXInterfaceContainer::disposing();
	m_xParent = NULL;
}

//XChild
//------------------------------------------------------------------------------
void FmXForms::setParent(const XInterfaceRef& Parent) THROWS( (NoSupportException, UsrSystemException) )
{
	OGuard aGuard( m_aMutex );
	m_xParent = Parent;
}

//------------------------------------------------------------------------------
XInterfaceRef FmXForms::getParent(void) const THROWS( (UsrSystemException) )
{
	return m_xParent;
}

//------------------------------------------------------------------
SMART_UNO_IMPLEMENTATION(FmXFormComponents, OComponentHelper);

//------------------------------------------------------------------------------
BOOL FmXFormComponents::queryAggregation(Uik aUik, XInterfaceRef& rOut)
{
#if PRIV_DEBUG && SUPD<544
	if (aUik == XContent::getSmartUik())
	{
		DBG_ERROR("FmXFormComponents::queryAggregation : somebody's requesting my old content interface !");
	}
#endif
	if (aUik == XFormComponent::getSmartUik() || aUik == XChild::getSmartUik())
		rOut = (XFormComponent*)this;
	else if (!FmXInterfaceContainer::queryInterface(aUik, rOut))
		OComponentHelper::queryAggregation(aUik, rOut);

	return rOut.is();
}

//------------------------------------------------------------------
XIdlClassRef FmXFormComponents::getStaticIdlClass()
{
	static XIdlClassRef xClass(
		createStandardClass
		   ( L"FmXFormComponents",
			 OComponentHelper::getStaticIdlClass(),
			 7 ,
			 XFormComponent_getReflection(),
			 XContainer_getReflection(),
			 XNameContainer_getReflection(),
			 XIndexContainer_getReflection(),
			 XEnumerationAccess_getReflection(),
			 XEventAttacherManager_getReflection(),
			 XPropertyChangeListener_getReflection()));

	return xClass;
}

//------------------------------------------------------------------------------
Sequence< XIdlClassRef > FmXFormComponents::getIdlClasses()
{
	static XIdlClassRef xClass(getStaticIdlClass());
	return Sequence< XIdlClassRef> (&xClass,1);
}

//------------------------------------------------------------------------------
FmXFormComponents::FmXFormComponents()
				  :OComponentHelper(m_aMutex)
				  ,FmXInterfaceContainer(m_aMutex, (InterfaceReflection*)XFormComponent_getReflection(), XFormComponent::getSmartUik())
{
}

//------------------------------------------------------------------------------
FmXFormComponents::~FmXFormComponents()
{
	if (!OComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

// OComponentHelper
//------------------------------------------------------------------------------
void FmXFormComponents::disposing()
{
	FmXInterfaceContainer::disposing();
	m_xParent = NULL;
}

//XChild
//------------------------------------------------------------------------------
void FmXFormComponents::setParent(const XInterfaceRef& Parent) THROWS( (NoSupportException, UsrSystemException) )
{
	OGuard aGuard( m_aMutex );
	m_xParent = Parent;
}

//------------------------------------------------------------------------------
XInterfaceRef FmXFormComponents::getParent(void) const THROWS( (UsrSystemException) )
{
	return m_xParent;
}



