/*************************************************************************
 *
 *  $RCSfile: fmfield.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma hdrstop

#ifdef TF_SDBAPI
#error "this file isn't needed for the new SDB-API"
#else // !TF_SDBAPI

#ifndef _SVX_FMFIELD_HXX
#include "fmfield.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif
#ifndef _SVX_FMPROP_HRC
#include "fmprop.hrc"
#endif

#ifndef _SVX_FMFORM_HXX
#include "fmform.hxx"
#endif

#ifndef _SMART_COM_SUN_STAR_DATA_DATABASEINFO_HXX_
#include <smart/com/sun/star/data/DatabaseInfo.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HXX_
#include <smart/com/sun/star/data/DatabaseIdentifierCase.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HXX_
#include <smart/com/sun/star/data/XDatabaseDescriptor.hxx>
#endif

#ifndef _SMART_COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HXX_
#include <smart/com/sun/star/lang/DisposedException.hxx>
#endif

#ifdef _USE_NAMESPACE
using namespace vos;
using namespace usr;
#endif

#define THROW_IF_NOFIELD()			\
	if (!m_xVariant.is())			\
	{								\
		THROW(DatabaseException());	\
	}

//------------------------------------------------------------------------------
FmXDbField::FmXDbField(FmXDbFields* pParent, const XPropertySetRef& _xField)
		   :OComponentHelper(m_aMutex)
		   ,FmXAggregatePropertySetHelper(OComponentHelper::rBHelper)
		   ,m_pParent(pParent)
		   ,m_pFieldPropertyArray(pParent->m_pFieldPropertyArray)
{
	setField(_xField);

	if (!m_pFieldPropertyArray)
		getInfoHelper();
}

//------------------------------------------------------------------------------
FmXDbField::~FmXDbField()
{
	if (!OComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

//------------------------------------------------------------------------------
void FmXDbField::setField(const XPropertySetRef& _xField)
{
	m_xVariant = XDatabaseVariantRef(_xField, USR_QUERY);
	setAggregation(_xField);
	startListening();
}

//------------------------------------------------------------------------------
void FmXDbField::startListening()
{
	if (!m_bListening && m_xAggregateSet.is())
	{
		OGuard aGuard( m_aMutex );

		// als einziger Listener anmelden
		Sequence<UString> aPropertyNames(1);
		aPropertyNames.getArray()[0] = FM_PROP_VALUE;

		m_xAggregateMultiSet->addPropertiesChangeListener(aPropertyNames, this);
		m_xAggregateSet->addVetoableChangeListener(UString(), this);

		m_bListening = TRUE;
	}
}


//------------------------------------------------------------------------------
Sequence< XIdlClassRef> FmXDbField::getIdlClasses(void)
{
	static XIdlClassRef xReturn = createStandardClass
		(	L"FmXDbField"
			,OWeakObject::getStaticIdlClass()
			,6
			,XPropertySet_getReflection()
			,XFastPropertySet_getReflection()
			,XMultiPropertySet_getReflection()
			,XNamed_getReflection()
			,XComponent_getReflection()
			,XDatabaseVariant_getReflection()
		);

	return Sequence< XIdlClassRef> (&xReturn, 1);
}

//------------------------------------------------------------------------------
BOOL FmXDbField::queryInterface(Uik aUik, XInterfaceRef& rOut)
{
	if (aUik == XAggregation::getSmartUik())	// nicht aggregierbar
		rOut = NULL;
	else if (aUik == XDatabaseVariant::getSmartUik())
		rOut = (XDatabaseVariant*)this;
	else if (aUik == XNamed::getSmartUik())
		rOut = (XNamed*)this;
	else if (!FmXAggregatePropertySetHelper::queryInterface(aUik, rOut))
		OComponentHelper::queryAggregation( aUik, rOut );
	return rOut.is();
}

// OComponentHelper
//-----------------------------------------------------------------------------
void FmXDbField::disposing()
{
	FmXAggregatePropertySetHelper::disposing();
	m_pParent = NULL;
	m_pFieldPropertyArray = NULL;
}

// XPropertiesChangeListener
//-----------------------------------------------------------------------------
void FmXDbField::propertiesChange(const Sequence< PropertyChangeEvent >& evts)  THROWS((UsrSystemException))
{
	DBG_ASSERT(evts.getLen() == 1 && evts.getConstArray()[0].PropertyName == FM_PROP_VALUE,
		"Nur ValueChanges zugelassen");

	// ohne Form wird alles geschluckt
	BOOL bForwardChanges = m_pParent && m_pParent->m_rParent.allowsValueChange();
	if (bForwardChanges)
	{
		m_pParent->m_rParent.changeStatus();
		FmXAggregatePropertySetHelper::propertiesChange(evts);
	}
}

//------------------------------------------------------------------------------
UString FmXDbField::getName(void) const THROWS((UsrSystemException))
{
	UsrAny aName;
	TRY
	{
		aName = getFastPropertyValue(FM_ATTR_NAME);
	}
	CATCH_ALL()
	{
	}
	END_CATCH
	if (aName.get())
		return aName.getString();
	else
		return UString();
}

//------------------------------------------------------------------------------
void FmXDbField::setName(const UString& Name_) THROWS((UsrSystemException, NoSupportException))
{
	THROW(NoSupportException());
}

// XDatabaseVariant
//------------------------------------------------------------------------------
BOOL FmXDbField::isNull(void) const THROWS( (DatabaseException, UsrSystemException) )
	{return m_xVariant.is() ? m_xVariant->isNull() : TRUE;}

//------------------------------------------------------------------------------
UString FmXDbField::getString(void) const THROWS( (DatabaseException, UsrSystemException) )
	{return m_xVariant.is() ? m_xVariant->getString() : UString();}

//------------------------------------------------------------------------------
BOOL FmXDbField::getBoolean(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getBoolean();
}

//------------------------------------------------------------------------------
BYTE FmXDbField::getByte(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getByte();
}

//------------------------------------------------------------------------------
INT16 FmXDbField::getShort(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getShort();
}

//------------------------------------------------------------------------------
INT32 FmXDbField::getLong(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getLong();
}

//------------------------------------------------------------------------------
float FmXDbField::getFloat(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getFloat();
}

//------------------------------------------------------------------------------
double FmXDbField::getDouble(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getDouble();
}

//------------------------------------------------------------------------------
Sequence< BYTE > FmXDbField::getBytes(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getBytes();
}

//------------------------------------------------------------------------------
Date FmXDbField::getDate(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getDate();
}

//------------------------------------------------------------------------------
Time FmXDbField::getTime(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getTime();
}

//------------------------------------------------------------------------------
DateTime FmXDbField::getDateTime(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getDateTime();
}

//------------------------------------------------------------------------------
XInputStreamRef FmXDbField::getBinaryStream(void) const THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	return m_xVariant->getBinaryStream();
}

//------------------------------------------------------------------------------
void FmXDbField::setNull(void) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setNull();
}

//------------------------------------------------------------------------------
void FmXDbField::setString(const UString& x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setString(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setBoolean(BOOL x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setBoolean(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setByte(BYTE x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setByte(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setShort(INT16 x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setShort(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setLong(INT32 x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setLong(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setFloat(float x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setFloat(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setDouble(double x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setDouble(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setBytes(const Sequence< BYTE >& x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setBytes(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setDate(const Date& x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setDate(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setTime(const Time& x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setTime(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setDateTime(const DateTime& x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setDateTime(x);
}

//------------------------------------------------------------------------------
void FmXDbField::setBinaryStream(const XInputStreamRef& x) THROWS( (DatabaseException, UsrSystemException) )
{
	THROW_IF_NOFIELD();
	m_xVariant->setBinaryStream(x);
}

//OPropertySetHelper
//------------------------------------------------------------------------------
XPropertySetInfoRef FmXDbField::getPropertySetInfo() const THROWS( (UsrSystemException) )
{
	XPropertySetInfoRef xInfo( createPropertySetInfo( getInfoHelper() ) );
	return xInfo;
}

//------------------------------------------------------------------------------
IPropertyArrayHelper& FmXDbField::getInfoHelper() const
{
	// Properties
	if (!m_pFieldPropertyArray)
	{
		Sequence<Property> aDescriptor;
		Sequence<Property> aAggProperties;

		if (m_pParent)
		{
			DBG_ASSERT(!m_pParent->m_pFieldPropertyArray, " keine PropertyInfo" );
			if (m_xAggregateSet.is())
				aAggProperties = m_xAggregateSet->getPropertySetInfo()->getProperties();
		}
		// Notwendiger const Cast
		((FmXDbField*)this)->m_pFieldPropertyArray = new FmXAggregatePropertyArrayHelper(aDescriptor, aAggProperties);
		if (m_pParent)
			m_pParent->m_pFieldPropertyArray = m_pFieldPropertyArray;
	}
	return *m_pFieldPropertyArray;
}

//------------------------------------------------------------------
SMART_UNO_IMPLEMENTATION(FmXDbFields, OWeakObject);

//------------------------------------------------------------------
FmXDbFields::~FmXDbFields()
{
	delete m_pFieldPropertyArray;
}

//------------------------------------------------------------------------------
BOOL FmXDbFields::queryInterface(Uik aUik, XInterfaceRef& rOut)
{
	if (aUik == ((XNameAccess*) this)->XElementAccess::getSmartUik())
		rOut = (XElementAccess*) (XNameAccess*)this;
	else if (aUik == XNameAccess::getSmartUik())
		rOut = (XNameAccess*) this;
	else if (aUik == XEnumerationAccess::getSmartUik())
		rOut = (XEnumerationAccess*) this;
	else if (aUik == XIndexAccess::getSmartUik())
		rOut = (XIndexAccess*) this;
	else if (aUik == XPropertySet::getSmartUik())
		rOut = (XPropertySet*) this;
	else if (aUik == XFastPropertySet::getSmartUik())
		rOut = (XFastPropertySet*) this;
	else
		OWeakObject::queryInterface( aUik, rOut );
	return rOut.is();
}

//------------------------------------------------------------------------------
Sequence< XIdlClassRef> FmXDbFields::getIdlClasses(void)
{
	static XIdlClassRef xClass =
		createStandardClass
		   ( L"FmXDbFields",
			 OWeakObject::getStaticIdlClass(),
			 5,
			 XPropertySet_getReflection(),
			 XFastPropertySet_getReflection(),
			 XNameAccess_getReflection(),
			 XIndexAccess_getReflection(),
			 XEnumerationAccess_getReflection());

	return Sequence< XIdlClassRef> (&xClass, 1 );
}

//------------------------------------------------------------------------------
void FmXDbFields::acquire() {m_rParent.acquire();}
void FmXDbFields::release() {m_rParent.release();}
void* FmXDbFields::getImplementation(Reflection * pRef)
	{ return OWeakObject::getImplementation(pRef); }

//------------------------------------------------------------------------------
void FmXDbFields::clear()
{
	m_xIndex = NULL;
	m_xName  = NULL;
	m_xFastSet = NULL;
	m_xPropertySet = NULL;
}

//------------------------------------------------------------------------------
void FmXDbFields::setDefinitions(const XNameAccessRef& _xFields)
{
	clear();

	m_xIndex = XIndexAccessRef(_xFields, USR_QUERY);
	m_xName  = _xFields;
	m_xFastSet = NULL;
}

//------------------------------------------------------------------------------
void FmXDbFields::setDefinitions(const XPropertySetRef& _xFields)
{
	clear();

	m_xIndex = XIndexAccessRef(_xFields, USR_QUERY);
	m_xName  = XNameAccessRef(m_xIndex, USR_QUERY);
	m_xFastSet = NULL;
	m_xPropertySet = _xFields;
}

//------------------------------------------------------------------------------
void FmXDbFields::load(const XPropertySetRef& _xFields)
{
	clear();

	// determine if we are case sensitive or not
	XDatabaseDescriptorRef xMeta = m_rParent.getConnection()->getMetaData();
	BOOL bCase = (xMeta->getInfo(DatabaseInfo_IDENT_CASE_QUOTED).getINT16() & DatabaseIdentifierCase_SENSITIVE) == DatabaseIdentifierCase_SENSITIVE;
	m_aFieldMap = OFieldMap(17, FmUStringMixHash(bCase), FmUStringMixEqual(bCase));		
	
	XIndexAccessRef xIndex(_xFields, USR_QUERY);
	INT32 nCount = xIndex->getCount();
	for (INT32 i = 0; i < nCount; i++)
	{
		XPropertySetRef xField(*(XPropertySetRef*)xIndex->getByIndex(i).get());
		UString aFieldName(xField->getPropertyValue(FM_PROP_NAME).getString());
		FmXDbField* pField = new FmXDbField(this,xField);

		pField->acquire();
		m_aFieldMap[aFieldName] = pField;
		m_aFields.push_back(pField);		
	}

	// nur das PropertySet wird gehalten
	m_xPropertySet = _xFields;
}

//------------------------------------------------------------------------------
void FmXDbFields::unload()
{
	// hier werden alle felder freigegeben
	clear();

	INT32 nCount = m_aFields.size();
	for (INT32 i = 0; i < nCount; i++)
	{
		FmXDbField* pField = m_aFields[i];
		pField->dispose();
		pField->release();
	}

	m_aFields.clear();
	m_aFieldMap.clear();
}

//------------------------------------------------------------------------------
void FmXDbFields::replaceFields(const XPropertySetRef& _xFields)
{
	DBG_ASSERT(m_aFields.size(), "Es existieren keine Felder");

	XIndexAccessRef xIndex(_xFields, USR_QUERY);
	INT32 nCount = xIndex->getCount();
	DBG_ASSERT(m_aFields.size() == nCount, "Falsche Anzahl Felder");

	for (INT32 i = 0; i < nCount; i++)
	{
		XPropertySetRef xField(*(XPropertySetRef*)xIndex->getByIndex(i).get());
		m_aFields[i]->setField(xField);
	}

	// nur das PropertySet wird gehalten
	m_xPropertySet = _xFields;
}

//------------------------------------------------------------------------------
void FmXDbFields::fireValues()
{
	DBG_ASSERT(m_aFields.size(), "Es existieren keine Felder");

	INT32 nCount = m_aFields.size();
	UsrAny aOld;
	for (INT32 i = 0; i < nCount; i++)
	{
		FmXDbField* pField = m_aFields[i];
		UsrAny aNew = pField->getFastPropertyValue(FM_ATTR_VALUE);
		pField->firePropertyChange(FM_ATTR_VALUE, aNew, aOld);
	}
}

//------------------------------------------------------------------------------
XFastPropertySetRef& FmXDbFields::getFastSet() const
{
	if (!m_xFastSet.is() && m_xIndex.is())
		((FmXDbFields*)this)->m_xFastSet = XFastPropertySetRef(m_xIndex, USR_QUERY);
	return ((FmXDbFields*)this)->m_xFastSet;
}

// XElementAccess
//------------------------------------------------------------------------------
BOOL FmXDbFields::hasElements(void) const THROWS( (UsrSystemException) )
{
	return m_xIndex.is() ? m_xIndex->hasElements() : !m_aFields.empty();
}

//------------------------------------------------------------------------------
XIdlClassRef FmXDbFields::getElementType(void) const THROWS( (UsrSystemException) )
{
	return XPropertySet_getReflection()->getIdlClass();
}

// XEnumerationAccess
//------------------------------------------------------------------------------
XEnumerationRef FmXDbFields::createEnumeration(void) THROWS( (UsrSystemException) )
{
	return new FmEnumerationByName((XNameAccess*)this);
}

// XIndexAccess
//------------------------------------------------------------------------------
INT32 FmXDbFields::getCount(void) const THROWS( (UsrSystemException) )
{
	return m_xIndex.is() ? m_xIndex->getCount() : m_aFields.size();
}

//------------------------------------------------------------------------------
UsrAny FmXDbFields::getByIndex(INT32 Index) const THROWS( (IndexOutOfBoundsException, WrappedTargetException, UsrSystemException) )
{
	if (m_xIndex.is())
		return m_xIndex->getByIndex(Index);
	else
	{
		XPropertySetRef xField(m_aFields[Index]);
		if (!xField.is())
			THROW(IndexOutOfBoundsException());

		return UsrAny(&xField, XPropertySet_getReflection());
	}
}

// XNameAccess
//------------------------------------------------------------------------------
UsrAny FmXDbFields::getByName(const UString& Name) const THROWS( (NoSuchElementException, WrappedTargetException, UsrSystemException) )
{
	if (m_xName.is())
		return m_xName->getByName(Name);
	else
	{
		OFieldMap::const_iterator i = m_aFieldMap.find(Name);
		if (i == m_aFieldMap.end())
			THROW(NoSuchElementException());
		
		XPropertySetRef xField((*i).second);
		return UsrAny(&xField, XPropertySet_getReflection());
	}
}

//------------------------------------------------------------------------------
Sequence<UString> FmXDbFields::getElementNames(void) const THROWS( (UsrSystemException) )
{
	if (m_xName.is())
		return m_xName->getElementNames();
	else
	{
		INT32 nCount = m_aFields.size();
		Sequence<UString> aNameList(nCount);
		UString* pStringArray = (UString*)aNameList.getConstArray();

		for (UINT32 i = 0; i < nCount; i++)
			pStringArray[i] = m_aFields[i]->getName();
		
		return aNameList;
	}
}

//------------------------------------------------------------------------------
BOOL FmXDbFields::hasByName(const UString& Name) const THROWS( (UsrSystemException) )
{
	if (m_xName.is())
		return m_xName->hasByName(Name);
	else
		return m_aFieldMap.find(Name) != m_aFieldMap.end();
}

// XPropertySet
//------------------------------------------------------------------------------
XPropertySetInfoRef FmXDbFields::getPropertySetInfo(void) const THROWS( (UsrSystemException) )
{
	if (!m_xPropertySet.is())
	{
		THROW(DisposedException());
	}
	return m_xPropertySet->getPropertySetInfo();
}

//------------------------------------------------------------------------------
void FmXDbFields::setPropertyValue(const UString& PropertyName, const UsrAny& aValue) THROWS( (UnknownPropertyException, PropertyVetoException, IllegalArgumentException, WrappedTargetException, UsrSystemException) )
{
	if (!m_xPropertySet.is())
	{
		THROW(UnknownPropertyException());
	}
	m_xPropertySet->setPropertyValue(PropertyName, aValue);
}

//------------------------------------------------------------------------------
UsrAny FmXDbFields::getPropertyValue(const UString& PropertyName) const THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) )
{
	if (!m_xPropertySet.is())
	{
		THROW(UnknownPropertyException());
	}
	return m_xPropertySet->getPropertyValue(PropertyName);
}

//------------------------------------------------------------------------------
void FmXDbFields::addPropertyChangeListener(const UString& PropertyName, const XPropertyChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) )
{
	if (!m_xPropertySet.is())
	{
		THROW(UnknownPropertyException());
	}

	m_xPropertySet->addPropertyChangeListener(PropertyName, aListener);
}

//------------------------------------------------------------------------------
void FmXDbFields::removePropertyChangeListener(const UString& PropertyName, const XPropertyChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) )
{
	if (!m_xPropertySet.is())
	{
		THROW(UnknownPropertyException());
	}
	m_xPropertySet->removePropertyChangeListener(PropertyName, aListener);
}

//------------------------------------------------------------------------------
void FmXDbFields::addVetoableChangeListener(const UString& PropertyName, const XVetoableChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) )
{}
//------------------------------------------------------------------------------
void FmXDbFields::removeVetoableChangeListener(const UString& PropertyName, const XVetoableChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) )
{}

// XFastPropertySet
//------------------------------------------------------------------------------
void FmXDbFields::setFastPropertyValue(INT32 nHandle, const UsrAny& aValue) THROWS( (UnknownPropertyException, PropertyVetoException, IllegalArgumentException, WrappedTargetException, UsrSystemException) )
{
	if (!getFastSet().is())
	{
		THROW(UnknownPropertyException());
	}
	m_xFastSet->setFastPropertyValue(nHandle, aValue);
}

//------------------------------------------------------------------------------
UsrAny FmXDbFields::getFastPropertyValue(INT32 nHandle) const THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) )
{
	if (!getFastSet().is())
	{
		THROW(UnknownPropertyException());
	}
	return m_xFastSet->getFastPropertyValue(nHandle);
}

#endif // !TF_SDBAPI


