/*************************************************************************
 *
 *  $RCSfile: multipro.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _MULTIPRO_HXX
#include "multipro.hxx"
#endif
#ifndef _SVDOGRP_HXX
#include <svdogrp.hxx>
#endif
#ifndef _SVDPAGE_HXX
#include <svdpage.hxx>
#endif
#ifndef _SVX_FMOBJ_HXX
#include "fmobj.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif
#ifndef _SVX_FMPROP_HXX
#include "fmprop.hxx"
#endif

#include <com/sun/star/container/XChild.hpp>

//	SV_IMPL_OBJARR(XPropertySetRefArray, ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > );


FmXMultiSet::FmXMultiSet(const SdrMarkList& rMarkList)
{
	MakeList(rMarkList);
	MakePropertySubSet();
}

FmXMultiSet::FmXMultiSet(const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > >& seqPropSets)
{
	const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > * pSets = seqPropSets.getConstArray();
	for (sal_uInt32 i=0; i<seqPropSets.getLength(); i++)
	{
		if (pSets[i].is())
			aPropSetList.push_back(pSets[i]);
	}
	MakePropertySubSet();
}

void FmXMultiSet::MakeList(const SdrMarkList& rMarkList)
{
	sal_uInt32 nMarkCount = rMarkList.GetMarkCount();
	for(sal_uInt32 i=0;i<nMarkCount;i++)
	{
		InsertElement(rMarkList.GetMark(i)->GetObj());
	}

}
void FmXMultiSet::InsertElement(SdrObject *pObj)
{
	if(pObj!=NULL)
	{
		if ( pObj->ISA( SdrObjGroup ) )
		{
			const SdrObjList *pLst = ((SdrObjGroup*)pObj)->GetSubList();
			for ( sal_uInt16 i = 0; i < pLst->GetObjCount(); ++i )
			{
				SdrObject *pObj2 = pLst->GetObj( i );

				InsertElement(pObj2 );
			}
		}
		else
		{
			FmFormObj* pSelFormObj =PTR_CAST(FmFormObj,pObj);

			if(pSelFormObj!=NULL)
			{
				::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xPropSetRef(pSelFormObj->GetUnoControlModel(),::com::sun::star::uno::UNO_QUERY);
				if (xPropSetRef.is())
					aPropSetList.push_back(xPropSetRef);
			}
		}

	}
}

void FmXMultiSet::MakePropertySubSet()
{
	sal_uInt32 nCount = aPropSetList.size();

	if(nCount>0)
	{

		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xPropSetRef = aPropSetList[0];

		::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> aTestSeq;

		if(xPropSetRef.is())
		{
			aTestSeq= xPropSetRef->getPropertySetInfo()->getProperties();
		}

		sal_uInt32 nTest=aTestSeq.getLength();
		const ::com::sun::star::beans::Property*	pTstProps = aTestSeq.getConstArray();

		::com::sun::star::uno::Sequence<sal_Bool> aTmpFlagSeq(nTest);

		sal_Bool*  pTmpFlags=aTmpFlagSeq.getArray();

		::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyState > aTmpStateSeq(nTest);

		::com::sun::star::beans::PropertyState* pTmpState=aTmpStateSeq.getArray();

		sal_uInt32 x;
		for(x=0;x<nTest;x++)
		{
			pTmpState[x]=::com::sun::star::beans::PropertyState_DIRECT_VALUE;
			pTmpFlags[x]=sal_True;
		}

		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xLoop;
		sal_uInt32 nTestLength;
		for(sal_uInt32 nIdx=0;nIdx<nTest;nIdx++)
		{
			const ::com::sun::star::beans::Property& rTstProp = pTstProps[nIdx];

			if(PROP_MULTI(PROP_ID(rTstProp.Name)))
			{
				for(sal_uInt32 i=1;i<nCount;i++)
				{
					xLoop = aPropSetList[i];

					nTestLength = xLoop->getPropertySetInfo()->getProperties().getLength();
					const ::com::sun::star::beans::Property*	pTstProps = xLoop->getPropertySetInfo()->getProperties().getConstArray();
					sal_uInt32 nI=0;
					for(;nI<nTestLength && pTstProps[nI].Name != rTstProp.Name;nI++)
						; // empty statement
					pTmpFlags[nIdx] = pTmpFlags[nIdx] && nI<nTestLength;
				}
			}
			else
			{
				pTmpFlags[nIdx]=sal_False;
			}
		}

		sal_uInt32 nPropCount=0;
		for(x=0;x<nTest;x++)
		{
			if(pTmpFlags[x]) 
				nPropCount++;
		}

		aPropSeq=::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>(nPropCount);

		::com::sun::star::beans::Property* pProps = aPropSeq.getArray();

		sal_uInt32 nProp=0;
		for(x=0;x<nTest;x++)
		{
			if(pTmpFlags[x])
			{
				pProps[nProp++]=pTstProps[x];
			}
		}

	}

	// initially set our parent, if all sets have one and have the same one
	m_xParent = NULL;
	for (sal_uInt32 i=0; i<aPropSetList.size(); ++i)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::container::XChild > xChild(aPropSetList[i], ::com::sun::star::uno::UNO_QUERY);
		if (xChild.is())
		{
			if (i == 0)
				m_xParent = xChild->getParent();
			else if (xChild->getParent() != m_xParent)
				m_xParent = NULL;
		}
		else
			m_xParent = NULL;
	}
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  SAL_CALL FmXMultiSet::getPropertySetInfo()
{
	return new FmXMultiPropInfo(aPropSeq);
}

//------------------------------------------------------------------------------
// ::com::sun::star::container::XChild
::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  SAL_CALL FmXMultiSet::getParent(void) 
{
	return m_xParent;
}

void FmXMultiSet::setParent(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & Parent)
{
	m_xParent = Parent;
}


//------------------------------------------------------------------------------
// ::com::sun::star::beans::XPropertyState
::com::sun::star::beans::PropertyState SAL_CALL FmXMultiSet::getPropertyState(const ::rtl::OUString& aPropertyName)
{
	sal_uInt32 nCount = aPropSetList.size();

	::com::sun::star::beans::PropertyState eState=::com::sun::star::beans::PropertyState_DIRECT_VALUE;

	if(nCount>0)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xFirstSet(aPropSetList[0]);

		::com::sun::star::uno::Any aValue;
		if(xFirstSet.is())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyState >  xPropStateRef(xFirstSet,::com::sun::star::uno::UNO_QUERY);
			aValue = xFirstSet->getPropertyValue(aPropertyName);

			if(xPropStateRef.is())
			{
				eState = xPropStateRef->getPropertyState(aPropertyName);
			}
		}

		::com::sun::star::beans::PropertyState e2State;
		for(sal_uInt32 i=1;i<nCount;i++)
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xLoopSet(aPropSetList[i]);
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyState >  xLoopStateRef(xLoopSet,::com::sun::star::uno::UNO_QUERY);

			e2State=::com::sun::star::beans::PropertyState_DIRECT_VALUE;

			if(xLoopStateRef.is()) 
				e2State=xLoopStateRef->getPropertyState(aPropertyName);

			::com::sun::star::uno::Any aValue2(xLoopSet->getPropertyValue(aPropertyName));
			if(e2State==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE || !::utl::compare(aValue,aValue2))
			{
				eState = ::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE;
				break;
			}
		}
	}
	else
	{
		eState=::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE;
	}

	return eState;
}

::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyState > SAL_CALL FmXMultiSet::getPropertyStates(const ::com::sun::star::uno::Sequence< ::rtl::OUString >& PropertyName)
{
	return ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyState >();
}

void FmXMultiSet::setPropertyToDefault(const ::rtl::OUString& aPropertyName)
{
	sal_uInt32 nCount = aPropSetList.size();

	for(sal_uInt32 i=0;i<nCount;i++)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xLoop = aPropSetList[i];
		if (xLoop.is())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyState >  xPropStateRef(xLoop, ::com::sun::star::uno::UNO_QUERY);
			if(xPropStateRef.is())
			{
				xPropStateRef->setPropertyToDefault(aPropertyName);
			}
		}
	}
}

::com::sun::star::uno::Any SAL_CALL FmXMultiSet::getPropertyDefault(const ::rtl::OUString& aPropertyName)
{
	return ::com::sun::star::uno::Any();
}

void SAL_CALL FmXMultiSet::addPropertyStateChangeListener(const ::rtl::OUString& aPropertyName,
												 const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyStateChangeListener > & aListener)
{
}

void SAL_CALL FmXMultiSet::removePropertyStateChangeListener(const ::rtl::OUString& aPropertyName,
													const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyStateChangeListener > & aListener)
{
}

//------------------------------------------------------------------------------
// XProperty
void SAL_CALL FmXMultiSet::setPropertyValue(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue)
{
	sal_uInt32 nCount = aPropSetList.size();

	for(sal_uInt32 i=0;i<nCount;i++)
	{
		if (aPropSetList[i].is())
		{
			aPropSetList[i]->setPropertyValue(aPropertyName,aValue);
		}
	}
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Any SAL_CALL FmXMultiSet::getPropertyValue(const ::rtl::OUString& aPropertyName)
{
	sal_uInt32 nCount = aPropSetList.size();

	if(nCount>0)
	{
		if (aPropSetList[0].is())
		{
			return aPropSetList[0]->getPropertyValue(aPropertyName);
		}
	}
	return ::com::sun::star::uno::Any();
}

//------------------------------------------------------------------------------
void SAL_CALL FmXMultiSet::addPropertyChangeListener(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & aListener)
{
}

//------------------------------------------------------------------------------
void SAL_CALL FmXMultiSet::removePropertyChangeListener(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & aListener)
{
}

//------------------------------------------------------------------------------
void SAL_CALL FmXMultiSet::addVetoableChangeListener(const ::rtl::OUString& aPropertyName,
											const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & aListener)
{}
//------------------------------------------------------------------------------
void SAL_CALL FmXMultiSet::removeVetoableChangeListener(const ::rtl::OUString& aPropertyName,
											   const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & aListener)
{}

//------------------------------------------------------------------------------
FmXMultiPropInfo::FmXMultiPropInfo(const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>& rSeq)
:	aPropSeq(rSeq)
{
	// nie wieder freigeben
	acquire();
}
//------------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> SAL_CALL FmXMultiPropInfo::getProperties()
{
	return aPropSeq;
}

//------------------------------------------------------------------------------
::com::sun::star::beans::Property SAL_CALL FmXMultiPropInfo::getPropertyByName(const ::rtl::OUString& aPropertyName)
{
	sal_uInt32 nLength=aPropSeq.getLength();

	const ::com::sun::star::beans::Property*	pProps = aPropSeq.getConstArray();

	for( sal_uInt32 i=0; i<nLength; i++ )
	{
		const ::com::sun::star::beans::Property& rProp = pProps[i];
		if(rProp.Name==aPropertyName) return rProp;
	}

	return ::com::sun::star::beans::Property();
}

sal_Bool SAL_CALL FmXMultiPropInfo::hasPropertyByName(const ::rtl::OUString& aPropertyName)
{
	sal_uInt32 nLength=aPropSeq.getLength();

	const ::com::sun::star::beans::Property*	pProps = aPropSeq.getConstArray();

	for( sal_uInt32 i=0; i<nLength; i++,++pProps )
	{
		if(pProps->Name==aPropertyName) 
			return sal_True;
	}

	return sal_False;
}

