/*************************************************************************
 *
 *  $RCSfile: propctrs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>

#ifndef SVX_PROPCTRS_HXX
#include "propctrs.hxx"
#endif

#ifndef _XTABLE_HXX
#include <xtable.hxx>
#endif

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _SV_FLOATWIN_HXX //autogen
#include <vcl/floatwin.hxx>
#endif

#include "dialogs.hrc"

#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#include "drawitem.hxx"

#ifndef _SVX_DIALMGR_HXX //autogen
#include "dialmgr.hxx"
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif
#ifndef _TOOLS_SOLMATH_HXX
#include <tools/solmath.hxx>
#endif

#define S(aUniCode)				\
	::rtl::OUStringToOString(aUniCode, RTL_TEXTENCODING_ASCII_US)
//------------------------------------------------------------------
#define FRAME_OFFSET 4
#define STD_HEIGHT	100
#define PRIV_SEP	"\";\""
#define LB_DEFAULT_COUNT 9

XubString MakeHexStr(sal_uInt32 nVal, sal_uInt32 nLength)
{
	XubString aStr;
	while (nVal>0) 
	{
		sal_uInt16 nDigit=sal_uInt16(nVal & 0x000F);
		char c=char(nVal & 0x000F);
		nVal>>=4;
		if (c<=9) c+='0';
		else c+='A'-10;
		aStr.Insert(c,0);
	}
	while (aStr.Len() < nLength) aStr.Insert('0',0);
	return aStr;
}

static ::rtl::OUString gStdString;

::rtl::OUString GetStandardStr()
{
	if(!gStdString.getLength())
		gStdString=::rtl::OUString(SVX_RESSTR(RID_STR_STANDARD));

	return gStdString;
}
//==================================================================
// class SvxPropEdit
//==================================================================

//------------------------------------------------------------------
SvxPropEdit::SvxPropEdit( Window* pParent, sal_Bool bPW, WinBits nWinStyle)
		:		Edit(pParent,nWinStyle)
{
	pListener=NULL;
	bDir=sal_True;
	bModified=sal_False;
	bLocked=sal_False;
	nLine=0;
	bPassWord=bPW;
	SetData((void *)pParent);

	SetModifyHdl(LINK( this, SvxPropEdit, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropEdit, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropEdit, LoseFocusHdl));

	ComboBox aComboBox(this,WB_DROPDOWN);
	aComboBox.SetPosSizePixel(Point(0,0),Size(100,100));
	Size aSize=aComboBox.GetSizePixel();

	SetSizePixel(aSize);

	if(bPassWord)
	{
	   SetMaxTextLen(1);
	}
}

//------------------------------------------------------------------
void SvxPropEdit::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropEdit::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropEdit::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropEdit::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
}

//------------------------------------------------------------------
void SvxPropEdit::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropEdit::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropEdit::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropEdit::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropEdit::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropEdit::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropEdit::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropEdit::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropEdit::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropEdit::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
void SvxPropEdit::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	UniString aStr;

	if(!bIsUnknown) 
		aStr=rString.getStr();

	if(bPassWord)
	{
		sal_Int32 nChar = aStr.ToInt32();
		sal_Unicode cChar = (sal_Unicode)nChar;
		aStr = cChar;
	}
	SetText(aStr);
}

//------------------------------------------------------------------
::rtl::OUString SvxPropEdit::GetProperty() const
{
	UniString aStr = GetText();

	if(bPassWord)
	{
		aStr = String::CreateFromInt32( (aStr.Len() != 0) ? (sal_Int32)aStr.GetChar(0) : 0 );
	}

	return aStr;
}
//------------------------------------------------------------------
sal_Bool SvxPropEdit::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
sal_Bool SvxPropEdit::HasList()
{
	return sal_False;
};


//------------------------------------------------------------------
void SvxPropEdit::ClearList()
{
	return;
}

//------------------------------------------------------------------
void SvxPropEdit::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	return;
}

//------------------------------------------------------------------
void SvxPropEdit::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropEdit::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropEdit::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropEdit::GetMyData()
{
	return pData;
}

Window* SvxPropEdit::GetMe()
{
	return (Window*)this;
}

sal_Bool SvxPropEdit::GetDirection()
{
	return bDir;
}

void SvxPropEdit::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropEdit::GetLine()
{
	return nLine;
}

long SvxPropEdit::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=Edit::PreNotify(rNEvt);
	}
	else
		nResult=Edit::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropEdit, ModifiedHdl, Edit*, pEd )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);

	if(bPassWord)
	{
		LoseFocusHdl(this);
	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropEdit, GetFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropEdit, LoseFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}


//==================================================================
// class SvxPropNumField
//==================================================================

//------------------------------------------------------------------
SvxPropNumField::SvxPropNumField( Window* pParent,sal_uInt16 nDigits, WinBits nWinStyle)
		:		NumericField(pParent,nWinStyle)
{
	pListener=NULL;
	bDir=sal_True;
	bModified=sal_False;
	bLocked=sal_False;
	nLine=0;
	SetData((void *)pParent);
	SetStrictFormat(sal_True);
	SetModifyHdl(LINK( this, SvxPropNumField, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropNumField, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropNumField, LoseFocusHdl));

	SetDecimalDigits(nDigits);
	ComboBox aComboBox(this,WB_DROPDOWN);
	aComboBox.SetPosSizePixel(Point(0,0),Size(100,100));
	Size aSize=aComboBox.GetSizePixel();
	EnableEmptyFieldValue(sal_True);
	SetMin(-GetMax());
	SetSizePixel(aSize);
}

//------------------------------------------------------------------
void SvxPropNumField::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropNumField::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropNumField::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropNumField::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
}

//------------------------------------------------------------------
void SvxPropNumField::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropNumField::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropNumField::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropNumField::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropNumField::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropNumField::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropNumField::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropNumField::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropNumField::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropNumField::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropNumField::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropNumField::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	

	if(bIsUnknown || rString==GetStandardStr())
	{
		SetText(XubString());
		SetEmptyFieldValue();
	}
	else
	{
		if(rString.getLength()>0)
		{
			UniString aStr(rString);
			SetValue(aStr.ToInt32());
		}
		else
			SetEmptyFieldValue();
	}
}

//------------------------------------------------------------------
::rtl::OUString SvxPropNumField::GetProperty() const
{
	if (GetText().Len() != 0)
	{
		return ::rtl::OUString::valueOf((sal_Int32)GetValue());
	}
	else return ::rtl::OUString();

}

//------------------------------------------------------------------
sal_Bool SvxPropNumField::HasList()
{
	return sal_False;
};


//------------------------------------------------------------------
void SvxPropNumField::ClearList()
{
	return;
}

//------------------------------------------------------------------
void SvxPropNumField::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	return;
}

//------------------------------------------------------------------
void SvxPropNumField::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropNumField::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropNumField::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropNumField::GetMyData()
{
	return pData;
}

Window* SvxPropNumField::GetMe()
{
	return (Window*)this;
}

sal_Bool SvxPropNumField::GetDirection()
{
	return bDir;
}

void SvxPropNumField::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropNumField::GetLine()
{
	return nLine;
}

long SvxPropNumField::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=NumericField::PreNotify(rNEvt);
	}
	else
		nResult=NumericField::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropNumField, ModifiedHdl, Edit*, pEd )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropNumField, GetFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropNumField, LoseFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}


//==================================================================
// class SvxPropNumField
//==================================================================

//------------------------------------------------------------------
SvxPropCurField::SvxPropCurField( Window* pParent,sal_uInt16 nDigits, WinBits nWinStyle)
		:		LongCurrencyField(pParent,nWinStyle)
{
	pListener=NULL;
	bDir=sal_True;
	bModified=sal_False;
	bLocked=sal_False;
	nLine=0;
	SetData((void *)pParent);
	SetStrictFormat(sal_True);
	SetModifyHdl(LINK( this, SvxPropCurField, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropCurField, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropCurField, LoseFocusHdl));

	International aInter=GetInternational();
	double nMax=GetMax();
	nMax=-nMax;
	BigInt aBigInt(nMax);
	SetMin(aBigInt);
	aInter.SetCurrSymbol(String());
	SetInternational(aInter);
	SetDecimalDigits(nDigits);
	ComboBox aComboBox(this,WB_DROPDOWN);
	aComboBox.SetPosSizePixel(Point(0,0),Size(100,100));
	Size aSize=aComboBox.GetSizePixel();
	EnableEmptyFieldValue(sal_True);
	//SetMin(-GetMax());
	SetSizePixel(aSize);
}

//------------------------------------------------------------------
void SvxPropCurField::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropCurField::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropCurField::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropCurField::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
}

//------------------------------------------------------------------
void SvxPropCurField::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropCurField::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropCurField::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropCurField::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropCurField::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropCurField::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropCurField::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropCurField::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropCurField::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropCurField::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

static double ImplCalcLongValue( double nValue, sal_uInt16 nDigits )
{
	double n = nValue;
	for ( sal_uInt16 d = 0; d < nDigits; d++ )
		n *= 10;
	return n;
}

static double ImplCalcDoubleValue( double nValue, sal_uInt16 nDigits )
{
	double n = nValue;
	for ( sal_uInt16 d = 0; d < nDigits; d++ )
		n /= 10;
	return n;
}

//------------------------------------------------------------------
sal_Bool SvxPropCurField::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropCurField::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	::rtl::OUString aStr;

	if(bIsUnknown || rString==GetStandardStr())
	{
		SetText(XubString());
		SetEmptyFieldValue();
	}
	else
	{
		if(rString.getLength())
		{
			int nErr=0;
			double nValue = SolarMath::StringToDouble(rString, GetInternational(),nErr );
			BigInt aBInt = ImplCalcLongValue(nValue,GetDecimalDigits());
			SetValue(aBInt);
		}
		else
			SetEmptyFieldValue();
	}
}


//------------------------------------------------------------------
::rtl::OUString SvxPropCurField::GetProperty() const
{
	if(GetText().Len()>0)
	{
		XubString aBuffer;
		BigInt aBInt=GetValue();
		double nValue=ImplCalcDoubleValue(aBInt,GetDecimalDigits());
		SolarMath::DoubleToString(aBuffer,nValue,'F',GetDecimalDigits());

		//	sprintf( pBuffer, "%f", nValue);
		return UniString(aBuffer);
	}
	else return ::rtl::OUString();

}

//------------------------------------------------------------------
sal_Bool SvxPropCurField::HasList()
{
	return sal_False;
};


//------------------------------------------------------------------
void SvxPropCurField::ClearList()
{
	return;
}

//------------------------------------------------------------------
void SvxPropCurField::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	return;
}

//------------------------------------------------------------------
void SvxPropCurField::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropCurField::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropCurField::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropCurField::GetMyData()
{
	return pData;
}

Window* SvxPropCurField::GetMe()
{
	return (Window*)this;
}

sal_Bool SvxPropCurField::GetDirection()
{
	return bDir;
}

void SvxPropCurField::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropCurField::GetLine()
{
	return nLine;
}

long SvxPropCurField::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=LongCurrencyField::PreNotify(rNEvt);
	}
	else
		nResult=LongCurrencyField::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropCurField, ModifiedHdl, Edit*, pEd )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropCurField, GetFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropCurField, LoseFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}

//==================================================================
// class SvxPropDateField
//==================================================================

//------------------------------------------------------------------
SvxPropDateField::SvxPropDateField( Window* pParent, WinBits nWinStyle)
		:		DateField(pParent,nWinStyle)
{
	pListener=NULL;
	bDir=sal_True;
	bModified=sal_False;
	bLocked=sal_False;
	nLine=0;
	SetData((void *)pParent);
	SetStrictFormat(sal_True);
	SetModifyHdl(LINK( this, SvxPropDateField, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropDateField, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropDateField, LoseFocusHdl));

	SetMin(Date(1,1,1600));
	SetFirst(Date(1,1,1600));
	SetLast(Date(1,1,9999));
	SetMax(Date(1,1,9999));
	ComboBox aComboBox(this,WB_DROPDOWN);
	aComboBox.SetPosSizePixel(Point(0,0),Size(100,100));
	Size aSize=aComboBox.GetSizePixel();
	SetExtFormat(XTDATEF_SYSTEM_SHORT_YYYY);
	SetSizePixel(aSize);
	EnableEmptyFieldValue(sal_True);
}

//------------------------------------------------------------------
void SvxPropDateField::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropDateField::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropDateField::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropDateField::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
}

//------------------------------------------------------------------
void SvxPropDateField::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropDateField::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropDateField::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropDateField::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropDateField::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropDateField::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropDateField::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropDateField::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropDateField::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropDateField::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropDateField::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropDateField::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	if(bIsUnknown || rString==GetStandardStr())
	{
		SetText(XubString());
		SetEmptyDate();
	}
	else
	{
		if(rString.getLength())
		{
			sal_uInt32 nDate = UniString(rString).ToInt32();

			SetDate(Date(nDate));
		}
		else
		{
			SetText(XubString());
			SetEmptyDate();
		}
	}
}

//------------------------------------------------------------------
::rtl::OUString SvxPropDateField::GetProperty() const
{
	if(GetText().Len()>0)
	{
		sal_uInt32 nDate=GetDate().GetDate();

		return ::rtl::OUString(nDate);
	}
	else return ::rtl::OUString();
}

//------------------------------------------------------------------
sal_Bool SvxPropDateField::HasList()
{
	return sal_False;
};


//------------------------------------------------------------------
void SvxPropDateField::ClearList()
{
	return;
}

//------------------------------------------------------------------
void SvxPropDateField::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	return;
}

//------------------------------------------------------------------
void SvxPropDateField::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropDateField::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropDateField::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropDateField::GetMyData()
{
	return pData;
}

Window* SvxPropDateField::GetMe()
{
	return (Window*)this;
}

sal_Bool SvxPropDateField::GetDirection()
{
	return bDir;
}

void SvxPropDateField::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropDateField::GetLine()
{
	return nLine;
}

long SvxPropDateField::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=DateField::PreNotify(rNEvt);
	}
	else
		nResult=DateField::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropDateField, ModifiedHdl, Edit*, pEd )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropDateField, GetFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropDateField, LoseFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}


//==================================================================
// class SvxPropTimeField
//==================================================================

//------------------------------------------------------------------
SvxPropTimeField::SvxPropTimeField( Window* pParent, WinBits nWinStyle)
		:		TimeField(pParent,nWinStyle)
{
	pListener=NULL;
	bDir=sal_True;
	bModified=sal_False;
	bLocked=sal_False;
	nLine=0;
	SetData((void *)pParent);
	SetStrictFormat(sal_True);
	SetModifyHdl(LINK( this, SvxPropTimeField, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropTimeField, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropTimeField, LoseFocusHdl));
	SetFormat(TIMEF_SEC);

	ComboBox aComboBox(this,WB_DROPDOWN);
	aComboBox.SetPosSizePixel(Point(0,0),Size(100,100));
	Size aSize=aComboBox.GetSizePixel();
	EnableEmptyFieldValue(sal_True);
	SetSizePixel(aSize);
}

//------------------------------------------------------------------
void SvxPropTimeField::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropTimeField::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropTimeField::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropTimeField::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
}

//------------------------------------------------------------------
void SvxPropTimeField::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropTimeField::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropTimeField::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropTimeField::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropTimeField::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropTimeField::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropTimeField::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropTimeField::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropTimeField::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropTimeField::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropTimeField::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropTimeField::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	if(bIsUnknown || rString==GetStandardStr())
	{
		SetText(XubString());
		SetEmptyTime();
	}
	else
	{
		if(rString.getLength())
		{
			sal_uInt32 nTime=UniString(rString).ToInt32();

			SetTime(Time(nTime));
		}
		else
		{
			SetText(XubString());
			SetEmptyTime();
		}
	}
}

//------------------------------------------------------------------
::rtl::OUString SvxPropTimeField::GetProperty() const
{
	if(GetText().Len()>0)
	{
	sal_uInt32 nTime=GetTime().GetTime();

	return ::rtl::OUString(nTime);
	}
	else return ::rtl::OUString();
}

//------------------------------------------------------------------
sal_Bool SvxPropTimeField::HasList()
{
	return sal_False;
};


//------------------------------------------------------------------
void SvxPropTimeField::ClearList()
{
	return;
}

//------------------------------------------------------------------
void SvxPropTimeField::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	return;
}

//------------------------------------------------------------------
void SvxPropTimeField::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropTimeField::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropTimeField::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropTimeField::GetMyData()
{
	return pData;
}

Window* SvxPropTimeField::GetMe()
{
	return (Window*)this;
}

sal_Bool SvxPropTimeField::GetDirection()
{
	return bDir;
}

void SvxPropTimeField::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropTimeField::GetLine()
{
	return nLine;
}

long SvxPropTimeField::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=TimeField::PreNotify(rNEvt);
	}
	else
		nResult=TimeField::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropTimeField, ModifiedHdl, Edit*, pEd )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropTimeField, GetFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropTimeField, LoseFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}

//==================================================================
// class PrivMEdit for SvxPropMultiEdit
//==================================================================

class PrivMEdit : public FloatingWindow
{
private:

	MultiLineEdit	MEdit;

protected:

	virtual void	Resize();

public:
					PrivMEdit( Window* pParent);

	virtual long	PreNotify( NotifyEvent& rNEvt );

	MultiLineEdit*  GetMEdit() {return &MEdit;}

};

PrivMEdit::PrivMEdit( Window* pParent)
:	FloatingWindow(pParent,WB_BORDER),
	MEdit(this,WB_VSCROLL|WB_IGNORETAB|WB_NOBORDER)
{
	MEdit.Show();
}

void PrivMEdit::Resize()
{
	MEdit.SetSizePixel(GetOutputSizePixel());
}


long PrivMEdit::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if((nKey==KEY_RETURN && !aKeyCode.IsShift())||
		   (nKey==KEY_UP && aKeyCode.IsMod2()))
		{
			EndPopupMode();
		}
		else
			nResult=FloatingWindow::PreNotify(rNEvt);
	}
	else
		nResult=FloatingWindow::PreNotify(rNEvt);

	return nResult;
}


//==================================================================
// class SvxPropMultiEdit
//==================================================================

//------------------------------------------------------------------
SvxPropMultiEdit::SvxPropMultiEdit( Window* pParent,sal_Bool bEd, WinBits nWinStyle)
		:		Control(pParent,((nWinStyle | WB_DIALOGCONTROL)& (~WB_READONLY| ~WB_DROPDOWN))),
				pMEdit(NULL),
				mpBtn(NULL),
				mpImplEdit(NULL)
{
	bDropDown=sal_False;
	pListener=NULL;
	bDir=sal_True;
	bLocked=sal_False;
	nLine=0;
	bModified=sal_False;
	bEdit=bEd;

	mpImplEdit=new MultiLineEdit(this,WB_TABSTOP|WB_IGNORETAB| WB_NOBORDER| nWinStyle& WB_READONLY);// Working-Edit
	mpImplEdit->Show();

	if(nWinStyle& WB_DROPDOWN)
	{
		mpBtn = new PushButton( this, WB_NOLIGHTBORDER | WB_RECTSTYLE | WB_NOTABSTOP);
		mpBtn->SetSymbol( SYMBOL_SPIN_DOWN );
		mpBtn->SetClickHdl( LINK( this, SvxPropMultiEdit, DropDownHdl ) );
		mpBtn->Show();
	}
	SetBackground(mpImplEdit->GetBackground());
	SetData((void *)pParent);

	pMEdit=new PrivMEdit(this); //FloatingWindow

	pMEdit->SetPopupModeEndHdl(LINK( this, SvxPropMultiEdit, ReturnHdl ));
	pMEdit->GetMEdit()->SetModifyHdl(LINK( this, SvxPropMultiEdit, ModifiedHdl));
	mpImplEdit->SetGetFocusHdl(LINK( this, SvxPropMultiEdit, GetFocusHdl));
	mpImplEdit->SetModifyHdl(LINK( this, SvxPropMultiEdit, ModifiedHdl));
	mpImplEdit->SetLoseFocusHdl(LINK( this, SvxPropMultiEdit, LoseFocusHdl));

	ComboBox aComboBox(this,WB_DROPDOWN);
	aComboBox.SetPosSizePixel(Point(0,0),Size(100,100));
	Size aSize=aComboBox.GetSizePixel();

	SetSizePixel(aSize);
}

SvxPropMultiEdit::~SvxPropMultiEdit()
{
	delete pMEdit;
	delete mpImplEdit;
	delete mpBtn;
}

//------------------------------------------------------------------
sal_Bool SvxPropMultiEdit::ShowDropDown( sal_Bool bShow )
{
	if(bShow)
	{
		Point aMePos= GetPosPixel();
		aMePos = GetParent()->OutputToScreenPixel( aMePos );
		Size aSize=GetSizePixel();
		Rectangle aRect(aMePos,aSize);
		aSize.Height()=STD_HEIGHT;
		pMEdit->SetOutputSizePixel(aSize);
		pMEdit->StartPopupMode( aRect, FLOATWIN_POPUPMODE_DOWN );

		pMEdit->Show();
		pMEdit->GetMEdit()->GrabFocus();
		pMEdit->GetMEdit()->SetSelection(
			Selection(pMEdit->GetMEdit()->GetText().Len()));
		bDropDown=sal_True;
		if(bEdit) pMEdit->GetMEdit()->SetText(mpImplEdit->GetText());
		mpImplEdit->SetText(XubString());
	}
	else
	{
		pMEdit->Hide();
		pMEdit->Invalidate();
		pMEdit->Update();
		//bModified=sal_True;
		UniString aOutput;
		UniString aStr=pMEdit->GetMEdit()->GetText();

		if(aStr.Len()>0)
		{
			xub_StrLen nCount = aStr.GetTokenCount('\n');

			UniString aInput=aStr.GetToken(0,'\n' );

			if(bEdit)
			{
				aOutput=aStr;
			}
			else
			{
				if(aInput.Len()>0)
				{
					aOutput+='\"';
					aOutput+=aInput;
					aOutput+='\"';
				}

				for (xub_StrLen i=1; i<nCount; ++i)
				{
					aInput = aStr.GetToken(i,'\n' );
					if (aInput.Len()>0)
					{
						aOutput += ';';
						aOutput += '\"';
						aOutput += aInput;
						aOutput += '\"';
					}
				}
			}
		}

		mpImplEdit->SetText(aOutput);
		GetParent()->Invalidate(INVALIDATE_CHILDREN);
		bDropDown=sal_False;
		mpImplEdit->GrabFocus();
	}
	return bDropDown;

}


//------------------------------------------------------------------
void SvxPropMultiEdit::Resize()
{
	Size aOutSz = GetOutputSizePixel();

	if(mpBtn!=NULL)
	{
		long nSBWidth = GetSettings().GetStyleSettings().GetScrollBarSize();
		nSBWidth = CalcZoom( nSBWidth );
		mpImplEdit->SetPosSizePixel( 0, 1, aOutSz.Width() - nSBWidth, aOutSz.Height()-2 );
		mpBtn->SetPosSizePixel( aOutSz.Width() - nSBWidth, 0, nSBWidth, aOutSz.Height() );
	}
	else
		mpImplEdit->SetPosSizePixel( 0, 1, aOutSz.Width(), aOutSz.Height()-2 );
}
//------------------------------------------------------------------
void SvxPropMultiEdit::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropMultiEdit::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropMultiEdit::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropMultiEdit::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropMultiEdit::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropMultiEdit::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropMultiEdit::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropMultiEdit::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();

	pMEdit->GetMEdit()->SetReadOnly(bFlag);

	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropMultiEdit::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropMultiEdit::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	UniString aStr;

	if(!bIsUnknown) 
		aStr=rString.getStr();

	pMEdit->GetMEdit()->SetText(aStr);

	if(bEdit)
	{
		mpImplEdit->SetText(aStr);
	}
	else
	{
		UniString aOutput;

		if(aStr.Len()>0)
		{
			if(aStr.Len()>0)
			{
				xub_StrLen nCount = aStr.GetTokenCount('\n');

				UniString aInput=aStr.GetToken(0,'\n' );
				if(aInput.Len()>0)
				{
					aOutput+='\"';
					aOutput+=aInput;
					aOutput+='\"';
				}

				for(xub_StrLen i=1;i<nCount;i++)
				{
					aInput=aStr.GetToken(i,'\n' );
					if(aInput.Len()>0)
					{
						aOutput += ';';
						aOutput += '\"';
						aOutput += aInput;
						aOutput += '\"';
					}
				}
			}
		}
		mpImplEdit->SetText(aOutput);
	}
}

//------------------------------------------------------------------
::rtl::OUString SvxPropMultiEdit::GetProperty() const
{
	if(bEdit)
		return mpImplEdit->GetText();
	else
		return pMEdit->GetMEdit()->GetText();
}

//------------------------------------------------------------------
sal_Bool SvxPropMultiEdit::HasList()
{
	return sal_False;
};


//------------------------------------------------------------------
void SvxPropMultiEdit::ClearList()
{
	return;
}

//------------------------------------------------------------------
void SvxPropMultiEdit::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	return;
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropMultiEdit::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropMultiEdit::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropMultiEdit::GetMyData()
{
	return pData;
}

Window* SvxPropMultiEdit::GetMe()
{
	return (Window*)this;
}

sal_Bool SvxPropMultiEdit::GetDirection()
{
	return bDir;
}

void SvxPropMultiEdit::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropMultiEdit::GetLine()
{
	return nLine;
}

void SvxPropMultiEdit::GetFocus()
{
	mpImplEdit->GetFocus();
}

long SvxPropMultiEdit::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();

		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(mpImplEdit);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if(nKey==KEY_DOWN && aKeyCode.IsMod2())
		{
			Invalidate();
			ShowDropDown(sal_True);
		}
		else if(KEYGROUP_CURSOR==aKeyCode.GetGroup()|| nKey==KEY_HELP 
				|| aKeyCode.GetGroup()==KEYGROUP_FKEYS  || bEdit)
		{
			nResult=Control::PreNotify(rNEvt);
		}
		else if(!bEdit)
		{
			Selection aSel=mpImplEdit->GetSelection();
			if(aSel.Min()!=aSel.Max())
			{
				aSel.Min()=FindPos(aSel.Min());
				aSel.Max()=FindPos(aSel.Max());
			}
			else
			{
				aSel.Min()=FindPos(aSel.Min());
				aSel.Max()=aSel.Min();
			}
			Invalidate();
			ShowDropDown(sal_True);
			pMEdit->GetMEdit()->GrabFocus();
			pMEdit->GetMEdit()->SetSelection(aSel);
			Window*	pFocusWin=Application::GetFocusWindow();
			pFocusWin->KeyInput(*rNEvt.GetKeyEvent());
		}
	}
	else
		nResult=Control::PreNotify(rNEvt);

	return nResult;
}

long SvxPropMultiEdit::FindPos(long nSinglePos)
{
	sal_uInt16 nPos=0;
	sal_uInt16 nDiff=0;
	XubString aOutput;
	XubString aStr=pMEdit->GetMEdit()->GetText();
	XubString aStr1=mpImplEdit->GetText();

	if ((nSinglePos == 0) || (nSinglePos == aStr1.Len()))
	{
		return nSinglePos;
	}

	if(aStr.Len()>0)
	{
		xub_StrLen nCount = aStr.GetTokenCount('\n');

		XubString aInput = aStr.GetToken(0,'\n' );

		if(aInput.Len()>0)
		{
			aOutput+='\"';
			nDiff++;
			aOutput+=aInput;
			aOutput+='\"';
		}

		if (nSinglePos <= aOutput.Len())
		{
			nPos=nSinglePos-nDiff;
		}
		else
		{
			for (xub_StrLen i=1; i<nCount; ++i)
			{
				aInput=aStr.GetToken(i,'\n' );
				if(aInput.Len()>0)
				{
					aOutput += ';';
					aOutput += '\"';
					nDiff += 2;
					aOutput += aInput;
					aOutput += '\"';

					if (nSinglePos <= aOutput.Len())
					{
						nPos=nSinglePos-nDiff;
						break;
					}
				}
			}
		}
	}
	return nPos;
}



IMPL_LINK( SvxPropMultiEdit, ReturnHdl,PrivMEdit*, pMEd)
{

	XubString aStr=pMEdit->GetMEdit()->GetText();
	XubString aStr2=mpImplEdit->GetText();
	ShowDropDown(sal_False);

	if(aStr!=aStr2 || !bEdit)
	{
		if(bModified) ModifiedHdl(mpImplEdit);
		LoseFocusHdl(mpImplEdit);
	}

	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropMultiEdit, DropDownHdl, PushButton*, pPb )
{
	ShowDropDown(!bDropDown);
	return 0;
}
//------------------------------------------------------------------
IMPL_LINK( SvxPropMultiEdit, ModifiedHdl, Edit*, pEd )
{
	bModified=sal_True;

	if(pEd!=pMEdit->GetMEdit())
	{
		if(pListener!=NULL)
			pListener->Modified(this);
	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropMultiEdit, GetFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropMultiEdit, LoseFocusHdl, Edit*, pEd )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}

//==================================================================
// class SvxPropListBox
//==================================================================

//------------------------------------------------------------------
SvxPropListBox::SvxPropListBox( Window* pParent, WinBits nWinStyle)
		:		ListBox(pParent,nWinStyle)
{
	pListener=NULL;
	bDir=sal_True;
	nLine=0;
	bLocked=sal_False;
	bModified=sal_False;

	SetData((void *)pParent);
	SetDropDownLineCount(9);
	SetSelectHdl(LINK( this, SvxPropListBox, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropListBox, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropListBox, LoseFocusHdl));
}

//------------------------------------------------------------------
void SvxPropListBox::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropListBox::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropListBox::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropListBox::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
	sal_uInt16 nCount=GetEntryCount();
	if(nCount>LB_DEFAULT_COUNT) nCount=LB_DEFAULT_COUNT;
	SetDropDownLineCount(nCount);
}

//------------------------------------------------------------------
void SvxPropListBox::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropListBox::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropListBox::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropListBox::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropListBox::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropListBox::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropListBox::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropListBox::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropListBox::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropListBox::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropListBox::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropListBox::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	if(!bIsUnknown)
	{
		XubString aTmp=rString;
		if(aTmp != GetSelectEntry())
			SelectEntry(aTmp);

		if(!IsEntrySelected(aTmp))
		{
			if(!rString.getLength())
			{
				SelectEntry(GetStandardStr());
			}
			else
			{
				
				InsertEntry(aTmp,0);
				SelectEntry(aTmp);
			}
		}
	}
	else
	{
		SetNoSelection();
	}
}

//------------------------------------------------------------------
::rtl::OUString SvxPropListBox::GetProperty()const
{
	UniString aResult;
	if(GetSelectEntryCount()>0)
	{
		aResult=GetSelectEntry();
	}
	return aResult;
}

//------------------------------------------------------------------
sal_Bool SvxPropListBox::HasList()
{
	return sal_True;
}

//------------------------------------------------------------------
void SvxPropListBox::ClearList()
{
	Clear();
}

//------------------------------------------------------------------
void SvxPropListBox::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	InsertEntry(rString,nPos);
}

//------------------------------------------------------------------
void SvxPropListBox::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropListBox::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropListBox::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropListBox::GetMyData()
{
	return pData;
}

Window* SvxPropListBox::GetMe()
{
	return (Window*)this;
}

void SvxPropListBox::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropListBox::GetLine()
{
	return nLine;
}

sal_Bool SvxPropListBox::GetDirection()
{
	return bDir;
}

long SvxPropListBox::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=ListBox::PreNotify(rNEvt);
	}
	else
		nResult=ListBox::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropListBox, ModifiedHdl, ListBox*, pLB )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);

	if(!IsTravelSelect())
	{
		LoseFocusHdl(this);
	}

	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropListBox, GetFocusHdl, ListBox*, pLB )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	bModified=sal_False;
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropListBox, LoseFocusHdl, ListBox*, pLB )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}

//==================================================================
// class SvxPropColorBox
//==================================================================

//------------------------------------------------------------------
SvxPropColorBox::SvxPropColorBox( Window* pParent,::rtl::OUString aStdStr, WinBits nWinStyle)
		:		ColorListBox(pParent,nWinStyle),
				aStandard(aStdStr)
{
	pListener=NULL;
	bDir=sal_True;
	nLine=0;
	bLocked=sal_False;
	bModified=sal_False;

	SetData((void *)pParent);

	SetSelectHdl(LINK( this, SvxPropColorBox, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropColorBox, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropColorBox, LoseFocusHdl));


	SfxObjectShell* pDocSh = SfxObjectShell::Current();
	DBG_ASSERT( pDocSh, "Keine DocShell!!!");

	SvxColorTableItem aItem( *(const SvxColorTableItem*)(
						pDocSh->GetItem( SID_COLOR_TABLE ) ) );
	XColorTable* pColorTbl = aItem.GetColorTable();
	DBG_ASSERT( pColorTbl, "Keine Farbtabelle vorhanden!" );

	SetUpdateMode( sal_False);

	if(aStandard.getLength()>0)
		InsertEntry(aStandard);

	for( sal_uInt16 i = 0; i < pColorTbl->Count(); ++i )
	{
		XColorEntry* pEntry = pColorTbl->Get( i );
		Color aColor = pEntry->GetColor();
		XubString sName = pEntry->GetName();

		InsertEntry( aColor, sName );
	}
	SetUpdateMode( sal_True );
	SelectEntryPos(0);
}

//------------------------------------------------------------------
void SvxPropColorBox::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
void SvxPropColorBox::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropColorBox::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropColorBox::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
	sal_uInt16 nCount=GetEntryCount();
	if(nCount>LB_DEFAULT_COUNT) nCount=LB_DEFAULT_COUNT;
	SetDropDownLineCount(nCount);
}

//------------------------------------------------------------------
void SvxPropColorBox::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropColorBox::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropColorBox::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropColorBox::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropColorBox::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropColorBox::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropColorBox::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropColorBox::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropColorBox::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
void SvxPropColorBox::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropColorBox::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropColorBox::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	if(!bIsUnknown)
	{
		if(rString.getLength() != 0 && rString != aStandard)
		{
			sal_uInt32 nColor = UniString(rString).ToInt32();
			Color aRgbCol((ColorData)nColor);

			if(!IsEntrySelected(aRgbCol))
			{
				SelectEntry(aRgbCol);
				if(!IsEntrySelected(aRgbCol))
				{
					String aStr = String::CreateFromAscii("0x");
					aStr += MakeHexStr(nColor,8);
					InsertEntry(aRgbCol,aStr);
					SelectEntry(aRgbCol);
				}
			}
		}
		else
		{
			SelectEntryPos(0);
		}
	}
	else
	{
		SetNoSelection();
	}
}

//------------------------------------------------------------------
::rtl::OUString SvxPropColorBox::GetProperty()const
{
	::rtl::OUString aResult;
	if(GetSelectEntryCount()>0)
	{
		aResult=GetSelectEntry();
		if(aResult != aStandard)
		{
			Color aRgbCol=GetSelectEntryColor();
			sal_Int32 nColor=aRgbCol.GetColor();
			aResult = ::rtl::OUString::valueOf(nColor);
		}
	}
	return aResult;
}

//------------------------------------------------------------------
sal_Bool SvxPropColorBox::HasList()
{
	return sal_False;
}

//------------------------------------------------------------------
void SvxPropColorBox::ClearList()
{
	Clear();
}

//------------------------------------------------------------------
void SvxPropColorBox::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	InsertEntry(rString,nPos);
}

//------------------------------------------------------------------
void SvxPropColorBox::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropColorBox::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropColorBox::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropColorBox::GetMyData()
{
	return pData;
}

Window* SvxPropColorBox::GetMe()
{
	return (Window*)this;
}

void SvxPropColorBox::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropColorBox::GetLine()
{
	return nLine;
}

sal_Bool SvxPropColorBox::GetDirection()
{
	return bDir;
}

long SvxPropColorBox::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=ColorListBox::PreNotify(rNEvt);
	}
	else
		nResult=ColorListBox::PreNotify(rNEvt);

	return nResult;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropColorBox, ModifiedHdl, ColorListBox*, pLB )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);

	if(!IsTravelSelect())
	{
		LoseFocusHdl(this);
	}

	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropColorBox, GetFocusHdl, ColorListBox*, pLB )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropColorBox, LoseFocusHdl, ColorListBox*, pLB )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}



//==================================================================
// class SvxPropComboBox
//==================================================================

//------------------------------------------------------------------
SvxPropComboBox::SvxPropComboBox( Window* pParent, WinBits nWinStyle)
		:		ComboBox(pParent,nWinStyle)
{
	bDir=sal_True;
	pListener=NULL;
	nLine=0;
	bLocked=sal_False;
	bModified=sal_False;

	SetData((void *)pParent);
	SetDropDownLineCount(9);
	SetModifyHdl(LINK( this, SvxPropComboBox, ModifiedHdl ));
	SetGetFocusHdl(LINK( this, SvxPropComboBox, GetFocusHdl));
	SetLoseFocusHdl(LINK( this, SvxPropComboBox, LoseFocusHdl));
}

//------------------------------------------------------------------
void SvxPropComboBox::SetLocked(sal_Bool bFlag)
{
	bLocked=bFlag;
	Font aFont=GetFont();
	if(bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont=GetParent()->GetFont();
	}
	SetFont(aFont);
}

//------------------------------------------------------------------
void SvxPropComboBox::SetCtrHelpId(sal_uInt32 nHelpId)
{
	SetHelpId(nHelpId);
}

//------------------------------------------------------------------
void SvxPropComboBox::SetSvxPropCtrListener(SvxPropCtrListener* pCtrListener)
{
	pListener=pCtrListener;
}

//------------------------------------------------------------------
SvxPropCtrListener*	SvxPropComboBox::GetSvxPropCtrListener()
{
	return pListener;
}

//------------------------------------------------------------------
void SvxPropComboBox::SetCtrSize(const Size& rSize)
{
	SetSizePixel(rSize);
	sal_uInt16 nCount=GetEntryCount();
	if(nCount>LB_DEFAULT_COUNT) nCount=LB_DEFAULT_COUNT;
	SetDropDownLineCount(nCount);
}

//------------------------------------------------------------------
void SvxPropComboBox::SetCtrPos(const Point& aPoint)
{
	SetPosPixel(aPoint);
}

//------------------------------------------------------------------
Point SvxPropComboBox::GetCtrPos() const
{
	return GetPosPixel();
}

//------------------------------------------------------------------
Size SvxPropComboBox::GetCtrSize() const
{
	return GetSizePixel();
}

//------------------------------------------------------------------
void SvxPropComboBox::ShowCtr(sal_Bool bFlag)
{
	Show(bFlag);
}

//------------------------------------------------------------------
void SvxPropComboBox::HideCtr()
{
	Hide();
}

//------------------------------------------------------------------
void SvxPropComboBox::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	SetZOrder(pRefWindow,nFlags);
}

//------------------------------------------------------------------
void SvxPropComboBox::SetCtrParent(Window *pParent)
{
	SetParent(pParent);
}

//------------------------------------------------------------------
void SvxPropComboBox::InvalidateCtr()
{
	Invalidate();
}

//------------------------------------------------------------------
void SvxPropComboBox::UpdateCtr()
{
	Update();
}

//------------------------------------------------------------------
sal_Bool SvxPropComboBox::IsModified()
{
	return bModified;
}
//------------------------------------------------------------------
void SvxPropComboBox::SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown)
{
	::rtl::OUString aStr;

	if(!bIsUnknown) aStr=rString;

	SetText(aStr);
}

//------------------------------------------------------------------
::rtl::OUString SvxPropComboBox::GetProperty()	const
{
	return GetText();
}

//------------------------------------------------------------------
sal_Bool SvxPropComboBox::HasList()
{
	return sal_True;
}

//------------------------------------------------------------------
void SvxPropComboBox::ClearList()
{
	Clear();
}

//------------------------------------------------------------------
void SvxPropComboBox::InsertCtrEntry( const ::rtl::OUString& rString,sal_uInt16 nPos)
{
	InsertEntry(rString,nPos);
}

//------------------------------------------------------------------
void SvxPropComboBox::SetMyName(const ::rtl::OUString &rString)
{
	aName=rString;
}

//------------------------------------------------------------------
::rtl::OUString SvxPropComboBox::GetMyName()const
{
	return aName;
}

//------------------------------------------------------------------
void SvxPropComboBox::SetMyData(void* pDat)
{
	pData=pDat;
}

//------------------------------------------------------------------
void* SvxPropComboBox::GetMyData()
{
	return pData;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropComboBox, ModifiedHdl, ComboBox*, pCB )
{
	bModified=sal_True;
	if(pListener!=NULL)
		pListener->Modified(this);

	/*
	if(!IsTravelSelect())
	{
		LoseFocusHdl(this);
	}
	*/
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropComboBox, GetFocusHdl, ComboBox*, pCB )
{
	if(pListener!=NULL)
		pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropComboBox, LoseFocusHdl, ComboBox*, pCB )
{
	if(pListener!=NULL && bModified)
		pListener->LoseFocus(this);
	bModified=sal_False;
	return 0;
}

Window* SvxPropComboBox::GetMe()
{
	return (Window*)this;
}

void SvxPropComboBox::SetLine(sal_uInt16 nL)
{
	nLine=nL;
}

sal_uInt16 SvxPropComboBox::GetLine()
{
	return nLine;
}

sal_Bool SvxPropComboBox::GetDirection()
{
	return bDir;
}

long SvxPropComboBox::PreNotify( NotifyEvent& rNEvt )
{
	long nResult=sal_True;

	sal_uInt16 nSwitch=rNEvt.GetType();
	if(nSwitch==EVENT_KEYINPUT)// || nSwitch==EVENT_KEYUP)
	{
		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey=aKeyCode.GetCode();
		if(nKey==KEY_RETURN &&!aKeyCode.IsShift())
		{
			LoseFocusHdl(this);
			bDir=sal_True;
			if(pListener!=NULL)
				pListener->GotoLine(this);
		}
		else if ((nKey != KEY_DELETE) || !bLocked)
			nResult=ComboBox::PreNotify(rNEvt);
	}
	else
		nResult=ComboBox::PreNotify(rNEvt);

	return nResult;
}

//==================================================================
// class SvxPropCommonControl
//==================================================================

//------------------------------------------------------------------
SvxPropCommonControl::SvxPropCommonControl(Window* pMeAsWin, const ::rtl::OUString& rStandard)
	:m_pListener(NULL)
	,m_pData(NULL)
	,m_bDir(sal_True)
	,m_bLocked(sal_False)
	,m_bModified(sal_False)
	,m_nLine(0)
	,m_sStandardString(rStandard)
	,m_pMeAsWindow(pMeAsWin)
{
	DBG_ASSERT(m_pMeAsWindow != NULL, "SvxPropCommonControl::SvxPropCommonControl : invalid window !");
}

//------------------------------------------------------------------
void SvxPropCommonControl::SetLocked(sal_Bool bFlag)
{
	m_bLocked = bFlag;
	Font aFont = m_pMeAsWindow->GetFont();
	if(m_bLocked)
	{
		aFont.SetColor(Color(COL_GRAY));
	}
	else
	{
		aFont = m_pMeAsWindow->GetParent()->GetFont();
	}
	m_pMeAsWindow->SetFont(aFont);
}

//------------------------------------------------------------------
sal_Bool SvxPropCommonControl::HandlePreNotify(NotifyEvent& rNEvt)
{
	if (EVENT_KEYINPUT == rNEvt.GetType())
	{
		const KeyCode& aKeyCode = rNEvt.GetKeyEvent()->GetKeyCode();
		sal_uInt16 nKey = aKeyCode.GetCode();

		if(nKey == KEY_RETURN && !aKeyCode.IsShift())
		{
			LoseFocusHdl(m_pMeAsWindow);
			m_bDir = sal_True;
			if(m_pListener != NULL)
				m_pListener->GotoLine(this);
			return sal_True;
		}
	}
	return sal_False;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropCommonControl, ModifiedHdl, Window*, pWin )
{
	m_bModified = sal_True;
	if(m_pListener != NULL)
		m_pListener->Modified(this);

	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropCommonControl, GetFocusHdl, Window*, pWin )
{
	if(m_pListener != NULL)
		m_pListener->GetFocus(this);
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxPropCommonControl, LoseFocusHdl, Window*, pWin )
{
	if(m_pListener != NULL && m_bModified)
		m_pListener->LoseFocus(this);
	m_bModified = sal_False;
	return 0;			 
}


