/*************************************************************************
 *
 *  $RCSfile: property.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef SVX_PROPERTY_HXX
#include "property.hxx"
#endif

#ifndef _XTABLE_HXX
#include <xtable.hxx>
#endif

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _SV_FLOATWIN_HXX //autogen
#include <vcl/floatwin.hxx>
#endif

#ifndef _SVX_DIALOGS_HRC
#include "dialogs.hrc"
#endif

#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#include "drawitem.hxx"

#ifndef _SVX_DIALMGR_HXX //autogen
#include "dialmgr.hxx"
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif
#define S(aUniCode)				\
	::rtl::OUStringToOString(aUniCode, RTL_TEXTENCODING_ASCII_US)
//------------------------------------------------------------------
#define FRAME_OFFSET 4
#define STD_HEIGHT	100
#define PRIV_SEP	"\";\""
#define LB_DEFAULT_COUNT 9

//==================================================================
// class SvxPropertyLine
//==================================================================

DBG_NAME(SvxPropertyLine);
//------------------------------------------------------------------

SvxPropertyLine::SvxPropertyLine( Window* pParent)
		:	aFtTitle(pParent)
			,pData(NULL)
			,pXButton(NULL)
			,pSvXPropertyControl(NULL)
			,bIsLocked(sal_False)
			,bIsHyperlink(sal_False)
			,nNameWidth(0)
			,pTheParent(pParent)
			,bNeedsRepaint(sal_True)
			,bHasXButton(sal_False)
			,eKindOfCtr(KOC_UNDEFINED)
{
	DBG_CTOR(SvxPropertyLine,NULL);
	aFtTitle.Show();
}
//------------------------------------------------------------------
SvxPropertyLine::~SvxPropertyLine()
{
	if(pXButton!=NULL)
	{
		pXButton->Hide();
		delete pXButton;
		pXButton=NULL;
	}
	DBG_DTOR(SvxPropertyLine,NULL);
}

//------------------------------------------------------------------
void SvxPropertyLine::SetHelpId(sal_uInt32 nHelpId,sal_uInt32 nBtUniqueId)
{
	if(pSvXPropertyControl!=NULL)
		pSvXPropertyControl->SetCtrHelpId(nHelpId);

	if(pXButton!=NULL)
	{
		pXButton->SetHelpId(nHelpId);
		pXButton->SetUniqueId(nBtUniqueId);
	}
}

//------------------------------------------------------------------
void SvxPropertyLine::SetSvxPropControl(SvxPropControl* pXControl)
{
	pSvXPropertyControl=pXControl;
	pSvXPropertyControl->ShowCtr();
	Resize();
}

//------------------------------------------------------------------
SvxPropControl* SvxPropertyLine::GetSvxPropControl()
{
	return pSvXPropertyControl;
}

void SvxPropertyLine::SetSizePixel(Size aSize)
{
	aOutputSize=aSize;
	Resize();
}

void SvxPropertyLine::SetPosPixel(Point aPosPoint)
{
	aLinePos=aPosPoint;
	Point aPos(aLinePos);
	aPos.Y()+=2;

	Point aTitlePos(aLinePos);
	aTitlePos.Y()+=8;
	Point aCtrPos(aPos);
	Point aBtnPos(aPos);

	if(pSvXPropertyControl!=NULL)
	{
		aCtrPos.X()=pSvXPropertyControl->GetCtrPos().X();
	}
	if(pXButton!=NULL)
	{
		aBtnPos.X()=pXButton->GetPosPixel().X();
	}
	aFtTitle.SetPosPixel(aTitlePos);

	if(pSvXPropertyControl!=NULL)
	{
		pSvXPropertyControl->SetCtrPos(aCtrPos);
	}

	if(pXButton!=NULL)
	{
		pXButton->SetPosPixel(aBtnPos);
	}
}

Window* SvxPropertyLine::GetRefWindow()
{
	Window* pRefWindow=&aFtTitle;

	if(pXButton!=NULL)
	{
		pRefWindow=(Window*)pXButton;
	}
	else if(pSvXPropertyControl!=NULL)
	{
		pRefWindow=pSvXPropertyControl->GetMe();
	}
	return pRefWindow;
}

void SvxPropertyLine::SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )
{
	aFtTitle.SetZOrder(pRefWindow,nFlags);
	if(pSvXPropertyControl!=NULL)
	{
		pSvXPropertyControl->
			SetTabOrder((Window*)&aFtTitle,WINDOW_ZORDER_BEHIND);
	}

	if(pXButton!=NULL)
	{
		pXButton->SetZOrder(pSvXPropertyControl->GetMe(),
						WINDOW_ZORDER_BEHIND);
	}
}

sal_Bool SvxPropertyLine::SetFocus()
{
	sal_Bool bRes=sal_False;

	if(pSvXPropertyControl!=NULL &&
		pSvXPropertyControl->GetMe()->IsEnabled())
	{
		pSvXPropertyControl->GetMe()->GrabFocus();
		bRes=sal_True;
	}
	else if(pXButton!=NULL && pXButton->IsEnabled())
	{
		pXButton->GrabFocus();
		bRes=sal_True;
	}
	return bRes;
}



void SvxPropertyLine::SetPosSizePixel(Point aPosPoint,Size aSize)
{
	if(aLinePos!=aPosPoint && aOutputSize!=aSize)
	{
		SetControlPosSize(aPosPoint,aSize);
	}
	else
	{
		aOutputSize=aSize;
		Resize();
	}
}

Size SvxPropertyLine::GetSizePixel()
{
	return aOutputSize;
}

void SvxPropertyLine::Show(sal_Bool bFlag)
{
	aFtTitle.Show(bFlag);
	if(pSvXPropertyControl!=NULL)
	{
		pSvXPropertyControl->ShowCtr(bFlag);
	}
	if(pXButton!=NULL)
	{
		pXButton->Show(bFlag);
	}
}

void SvxPropertyLine::Hide()
{
	Show(sal_False);
}

sal_Bool SvxPropertyLine::IsVisible()
{
	return aFtTitle.IsVisible();
}

void SvxPropertyLine::Invalidate()
{
	aFtTitle.Invalidate();
	if(pSvXPropertyControl!=NULL)
	{
		pSvXPropertyControl->InvalidateCtr();
	}
	if(pXButton!=NULL)
	{
		pXButton->Invalidate();
	}
}

void SvxPropertyLine::Update()
{
	aFtTitle.Update();
	if(pSvXPropertyControl!=NULL)
	{
		pSvXPropertyControl->UpdateCtr();
	}
	if(pXButton!=NULL)
	{
		pXButton->Update();
	}
}

void SvxPropertyLine::SetData(void *pPtr)
{
	pData=pPtr;
}

void* SvxPropertyLine::GetData()
{
	return pData;
}
//------------------------------------------------------------------
void SvxPropertyLine::SetControlPosSize(Point aPos,Size aSize)
{
	aLinePos=aPos;
	aOutputSize=aSize;
	Size a2Size(aSize);

	aSize.Width()=nNameWidth-3;
	a2Size.Width()-=nNameWidth;
	a2Size.Height() -=2;

	aPos.Y()+=2;
	Point aTitlePos(aLinePos);
	aTitlePos.Y()+=8;

	aFtTitle.SetPosSizePixel(aTitlePos,aSize);
	sal_uInt16 nXButtonWidth=0;

	nXButtonWidth=(sal_uInt16)aSize.Height()-4;

	a2Size.Width()=a2Size.Width()-nXButtonWidth;

	aPos.X()+=aSize.Width();

	if(pSvXPropertyControl!=NULL)
	{
		a2Size.Height()=pSvXPropertyControl->GetCtrSize().Height();
		pSvXPropertyControl->SetCtrPos(aPos);
		pSvXPropertyControl->SetCtrSize(a2Size);
	}

	if(bHasXButton)
	{
		long nx=aOutputSize.Width()-nXButtonWidth;
		if(nx>aPos.X())
		{
			aPos.X()=nx;
		}
		aSize.Width()=nXButtonWidth-3;
		aSize.Height()=nXButtonWidth-2;
		pXButton->SetPosSizePixel(aPos,aSize);
	}
}

void SvxPropertyLine::Resize()
{
	Size aSize(aOutputSize);
	Size a2Size(aSize);

	aSize.Width()=nNameWidth-3;
	a2Size.Width()-=nNameWidth;
	a2Size.Height() -=2;

	Point aPos(aLinePos);
	aPos.Y()+=2;
	Point aTitlePos(aLinePos);
	aTitlePos.Y()+=8;

	sal_uInt16 nXButtonWidth=0;

	nXButtonWidth=(sal_uInt16)aSize.Height()-4;

	a2Size.Width()=a2Size.Width()-nXButtonWidth;

	aPos.X()+=aSize.Width();

	if(pSvXPropertyControl!=NULL)
	{
		a2Size.Height() = pSvXPropertyControl->GetCtrSize().Height();
		pSvXPropertyControl->SetCtrSize(a2Size);
	}

	if(bHasXButton)
	{
		long nx=aOutputSize.Width()-nXButtonWidth;
		if(nx>aPos.X())
		{
			aPos.X()=nx;
		}
		aSize.Width()=nXButtonWidth-3;
		aSize.Height()=nXButtonWidth-2;
		pXButton->SetPosSizePixel(aPos,aSize);
	}
}

//------------------------------------------------------------------
void SvxPropertyLine::SetNeedsRepaint(sal_Bool bFlag)
{
	bNeedsRepaint=bFlag;
}

//------------------------------------------------------------------
sal_Bool SvxPropertyLine::NeedsRepaint()
{
	return bNeedsRepaint;
}

//------------------------------------------------------------------
void SvxPropertyLine::SetTitle(const XubString& rString )
{
	String aText(rString);
	aText.AppendAscii("......................................................");
	aFtTitle.SetText(aText);
}

//------------------------------------------------------------------
XubString SvxPropertyLine::GetTitle() const
{
	return aFtTitle.GetText();
}

//------------------------------------------------------------------
void SvxPropertyLine::SetKindOfControl(eKindOfControl eKOC)
{
	eKindOfCtr=eKOC;
}

//------------------------------------------------------------------
eKindOfControl SvxPropertyLine::GetKindOfControl()
{
	return eKindOfCtr;
}

//------------------------------------------------------------------
void SvxPropertyLine::ShowXButton()
{
	bHasXButton=sal_True;
	if(pXButton!=NULL) 
		delete pXButton;
	pXButton=new PushButton(pTheParent);
	pXButton->SetGetFocusHdl(LINK( this, SvxPropertyLine, GetFocusHdl));
	pXButton->SetData((void *)this);
	pXButton->SetText(String::CreateFromAscii("..."));
	pXButton->Show();
	Resize();
}

//------------------------------------------------------------------
void SvxPropertyLine::HideXButton()
{
	bHasXButton=sal_False;
	if(pXButton!=NULL)
	{
		pXButton->Hide();
		delete pXButton;
		pXButton=NULL;
	}
	Resize();
}

//------------------------------------------------------------------
sal_Bool SvxPropertyLine::IsVisibleXButton()
{
	return bHasXButton;
}

//------------------------------------------------------------------
void SvxPropertyLine::ShowAsHyperLink(sal_Bool nFlag)
{
	bIsHyperlink=nFlag;
	if(nFlag)
	{
		Font aFont(aFtTitle.GetFont());
		aFont.SetUnderline(UNDERLINE_SINGLE);
		aFont.SetColor(Color(COL_BLUE));
		aFtTitle.SetFont(aFont);
	}
	else
	{
		Font aFont=aFtTitle.GetFont();
		aFtTitle.SetFont(aFont);
	}
}

//------------------------------------------------------------------
sal_Bool SvxPropertyLine::IsShownAsHyperlink()
{
	return bIsHyperlink;
}

//------------------------------------------------------------------
void SvxPropertyLine::Locked(sal_Bool nFlag)
{
	bIsLocked=nFlag;
}

//------------------------------------------------------------------
sal_Bool SvxPropertyLine::IsLocked()
{
	return bIsLocked;
}

//------------------------------------------------------------------
void SvxPropertyLine::SetTitleWidth(sal_uInt16 nWidth)
{
	if (nNameWidth != nWidth+10)
	{
		nNameWidth = nWidth+10;
		SetControlPosSize(aLinePos,aOutputSize);
	}
}

//------------------------------------------------------------------
void SvxPropertyLine::SetClickHdl(const Link& rLink)
{
	if(pXButton!=NULL)
		pXButton->SetClickHdl(rLink );
}

IMPL_LINK( SvxPropertyLine, GetFocusHdl, PushButton*, pPB )
{
	if(pSvXPropertyControl!=NULL)
	{
		SvxPropCtrListener* pListener;
			pListener=pSvXPropertyControl->GetSvxPropCtrListener();
		if(pListener!=NULL)
			pListener->GetFocus(pSvXPropertyControl);
	}
	return 0;
}

//==================================================================
// class SvxPrivatEvtListener
//==================================================================

//----------------------------------------------------------
SvxPrivatEvtListener::SvxPrivatEvtListener() : pTheActiveControl(NULL)
{	
}

//------------------------------------------------------------------
void SvxPrivatEvtListener::Modified (SvxPropControl *pSvXPCtr)
{
	pTheActiveControl=pSvXPCtr;
	aModifyLink.Call(this);
}

//------------------------------------------------------------------
void SvxPrivatEvtListener::GetFocus (SvxPropControl *pSvXPCtr)
{
	pTheActiveControl=pSvXPCtr;
	aGetFocusLink.Call(this);
}

//------------------------------------------------------------------
void SvxPrivatEvtListener::LoseFocus (SvxPropControl *pSvXPCtr)
{
	pTheActiveControl=pSvXPCtr;
	aLoseFocusLink.Call(this);
}

//------------------------------------------------------------------
void SvxPrivatEvtListener::KeyInput (SvxPropControl *pSvXPCtr,const KeyCode& theKeyCode)
{
	pTheActiveControl=pSvXPCtr;
	aKeyCode=theKeyCode;
	aKeyInputLink.Call(this);
}

//------------------------------------------------------------------
void SvxPrivatEvtListener::GotoLine(SvxPropControl *pSvXPCtr)
{
	pTheActiveControl=pSvXPCtr;
	aGotoLineLink.Call(this);
}

//------------------------------------------------------------------
SvxPropControl *	SvxPrivatEvtListener::GetPropertyControl()
{
	return pTheActiveControl;
}

//------------------------------------------------------------------
KeyCode SvxPrivatEvtListener::GetKeyCode() const
{
	return aKeyCode;
}


//==================================================================
// class SvxLBoxForProps
//==================================================================
DBG_NAME(SvxLBoxForProps);
//------------------------------------------------------------------
SvxLBoxForProps::SvxLBoxForProps( Window* pParent, WinBits nWinStyle)
		:	Control(pParent,nWinStyle| WB_CLIPCHILDREN)
			,aVScroll(this,WB_VSCROLL|WB_REPEAT|WB_DRAG)
			,aPlayGround(this,WB_DIALOGCONTROL | WB_CLIPCHILDREN)
			,pPropDataControl(NULL)
			,bUpdate(sal_True)
			,aStandard(SVX_RESSTR(RID_STR_STANDARD))
			,bIsActiv(sal_False)
			,nYOffset(0)
			,nSelectedLine(0)
			,nTheNameSize(0)
{
	DBG_CTOR(SvxLBoxForProps,NULL);

	aListener.SetModifyHdl	 (LINK( this, SvxLBoxForProps,   ModifyHdl));
	aListener.SetGetFocusHdl (LINK( this, SvxLBoxForProps, GetFocusHdl));
	aListener.SetLoseFocusHdl(LINK( this, SvxLBoxForProps,LoseFocusHdl));
	aListener.SetKeyInputHdl (LINK( this, SvxLBoxForProps, KeyInputHdl));
	aListener.SetGotoLineHdl (LINK( this, SvxLBoxForProps, GotoLineHdl));
	
	ListBox aListBox(this,WB_DROPDOWN);
	aListBox.SetPosSizePixel(Point(0,0),Size(100,100));
	nRowHeight=(sal_uInt16)aListBox.GetSizePixel().Height()+2;
#ifndef NOOLDSV
	Brush aBrush(aPlayGround.GetBackgroundBrush());
	aBrush.SetTransparent( sal_True);
	aPlayGround.SetBackgroundBrush(aBrush);
#else
	// TODO : how to set a transparent background ?
	SetBackground(aPlayGround.GetBackground());
#endif
	aPlayGround.SetPosPixel(Point(0,0));
	aPlayGround.SetPaintTransparent(sal_True);
	aPlayGround.Show();
	aVScroll.Hide();
	aVScroll.SetScrollHdl(	LINK( this, SvxLBoxForProps, ScrollHdl ));

}

//------------------------------------------------------------------
SvxLBoxForProps::SvxLBoxForProps( Window* pParent, const ResId& rResId )
			:		Control(pParent,rResId)
					,aVScroll(this,WB_VSCROLL|WB_REPEAT|WB_DRAG)
					,aPlayGround(this,WB_CLIPCHILDREN)
					,pPropDataControl(NULL)
					,bUpdate(sal_True)
					,bIsActiv(sal_False)
					,nTheNameSize(0)
					,nYOffset(0)
{
	DBG_CTOR(SvxLBoxForProps,NULL);

	SetStyle(WB_CLIPCHILDREN | GetStyle());
	ListBox aListBox(this,WB_DROPDOWN);
	aListBox.SetPosSizePixel(Point(0,0),Size(100,100));
	nRowHeight=(sal_uInt16)aListBox.GetSizePixel().Height()+2;
#ifndef NOOLDSV
	Brush aBrush(aPlayGround.GetBackgroundBrush());
	aBrush.SetTransparent( sal_True);
	aPlayGround.SetBackgroundBrush(aBrush);
	SetBackgroundBrush(aBrush);
#else
	// TODO : how to set a transparent background ?
	SetBackground(aPlayGround.GetBackground());
#endif
	aPlayGround.SetPosPixel(Point(0,0));
	aPlayGround.SetPaintTransparent(sal_True);
	aPlayGround.Show();
	aVScroll.Hide();
	aVScroll.SetScrollHdl(	LINK( this, SvxLBoxForProps, ScrollHdl ));
	UpdateVScroll();
	Resize();
}

//------------------------------------------------------------------
SvxLBoxForProps::~SvxLBoxForProps()
{
	if(bIsActiv && PLineArray.Count()>nSelectedLine)
	{
		if(PLineArray[nSelectedLine]->GetSvxPropControl()->IsModified())
			aListener.LoseFocus(PLineArray[nSelectedLine]->GetSvxPropControl());
	}
	Hide();
	Clear();
	DBG_DTOR(SvxLBoxForProps,NULL);
}

//------------------------------------------------------------------
void SvxLBoxForProps::Clear()
{
	for(sal_uInt16 i=0;i<PLineArray.Count();i++)
	{
		SvxPropertyLine* pPropLine=PLineArray[i];
		pPropLine->Hide();
		pPropLine->GetSvxPropControl()->SetSvxPropCtrListener(NULL);

		switch(pPropLine->GetKindOfControl())
		{
			case    KOC_MEDIT:		delete (SvxPropMultiEdit*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_LISTBOX:	delete (SvxPropListBox*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_COLORBOX:	delete (SvxPropColorBox*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_COMBOBOX:	delete (SvxPropComboBox*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_EDIT:		delete (SvxPropEdit*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_NUMFIELD:	delete (SvxPropNumField*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_CURFIELD:	delete (SvxPropCurField*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_DATEFIELD:	delete (SvxPropDateField*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_TIMEFIELD:	delete (SvxPropTimeField*)pPropLine->GetSvxPropControl();
									break;

			case	KOC_USERDEFINED:	delete pPropLine->GetSvxPropControl();
										// we don't have to cast this, the destructor is virtual
										break;

		}
		delete pPropLine;
	}
	PLineArray.Remove(0,PLineArray.Count());
}

void SvxLBoxForProps::Activate(sal_Bool bFlag)
{
	bIsActiv=bFlag;

	if(bIsActiv)
	{
		aVScroll.SetThumbPos(100);
		MoveThumbTo(0);
		Resize();
	}
}
//------------------------------------------------------------------
void SvxLBoxForProps::Resize()
{
	sal_Bool bFlag=sal_False;
	Size aSize(GetOutputSizePixel());
	Size a2Size(aSize);
	Size aVScrollSize;

	aPlayGround.SetSizePixel(aSize);

	UpdateVScroll();

	long nThumbPos=aVScroll.GetThumbPos();

	long nLines=CalcVisibleLines();

	if(PLineArray.Count()<=nLines)
	{
		if(aVScroll.IsVisible()) aVScroll.Hide();
		nThumbPos=0;
		nYOffset=0;
		aPlayGround.SetSizePixel(aSize);
		aVScroll.SetThumbPos(nThumbPos);
	}
	else
	{
		Point aPos(0,0);
		aVScrollSize=aVScroll.GetSizePixel();
		aVScrollSize.Height()=aSize.Height();
		a2Size.Width()-=aVScrollSize.Width();
		aPos.X()=a2Size.Width();
		aVScroll.SetPosPixel(aPos);
		aVScroll.SetSizePixel(aVScrollSize);
		aPlayGround.SetSizePixel(a2Size);
	}
	for(sal_uInt16 i=0; i<PLineArray.Count();i++)
	{
		(PLineArray[i])->SetNeedsRepaint(sal_True);
	}

	EnablePaint(sal_False);
	UpdatePlayGround();
	EnablePaint(sal_True);

	if(PLineArray.Count()>nLines)
	{
		if(!aVScroll.IsVisible()) aVScroll.Show();
	}

}


//------------------------------------------------------------------
void SvxLBoxForProps::SetController( SvxPropDataListener *pPDC)
{
	pPropDataControl=pPDC;
}

//------------------------------------------------------------------
sal_uInt16 SvxLBoxForProps::CalcVisibleLines()
{
	Size aSize(aPlayGround.GetOutputSizePixel());
	sal_uInt16 nResult=0;
	if(nRowHeight!=0)
		nResult=(sal_uInt16) aSize.Height()/nRowHeight;

	return nResult;
}

//------------------------------------------------------------------
void SvxLBoxForProps::UpdateVScroll()
{
	sal_uInt16 nLines=CalcVisibleLines();
	aVScroll.SetPageSize(nLines-1);
	aVScroll.SetVisibleSize(nLines-1);
	sal_uInt16 nCount=PLineArray.Count();
	long nThumbPos=aVScroll.GetThumbPos();
	if(nCount>0)
	{
		aVScroll.SetRange(Range(0,nCount-1));
		nYOffset=-aVScroll.GetThumbPos()*nRowHeight;
	}
	else
	{
		aVScroll.SetRange(Range(0,0));
		nYOffset=0;
	}
}
//------------------------------------------------------------------
void SvxLBoxForProps::ShowLine(sal_uInt16 i)
{
	Size aSize(aPlayGround.GetOutputSizePixel());
	long nHeight=aSize.Height()-nRowHeight;
	aSize.Height()=nRowHeight;
	Point aPos(0,nYOffset);

	aPos.Y()+=i*nRowHeight;
	if(i<PLineArray.Count())
	{
		if ((PLineArray[i])->GetSizePixel() != aSize)
			(PLineArray[i])->SetPosSizePixel(aPos,aSize);
		else
			(PLineArray[i])->SetPosPixel(aPos);

		(PLineArray[i])->SetTitleWidth(nTheNameSize+2*FRAME_OFFSET);

		if(!((PLineArray[i])->IsVisible()))
			(PLineArray[i])->Show();
	}
}
//------------------------------------------------------------------
void SvxLBoxForProps::UpdatePosNSize()
{
	Size aSize(aPlayGround.GetOutputSizePixel());
	long nHeight=aSize.Height()-nRowHeight;
	aSize.Height()=nRowHeight;
	Point aPos(0,nYOffset);

	sal_uInt16 i;
	sal_Bool bFlag=sal_True;

	for(i=0; i<PLineArray.Count();i++)
	{
		if((PLineArray[i])->NeedsRepaint())
		{
			ShowLine(i);
		}
		aPos.Y()+=nRowHeight;
	}
	for(i=0; i<PLineArray.Count();i++)
	{
		(PLineArray[i])->SetNeedsRepaint(sal_False);
	}

}

//------------------------------------------------------------------
void SvxLBoxForProps::UpdatePlayGround()
{
	Point aPos(0,0);
	long nThumbPos=aVScroll.GetThumbPos();
	long nLines=CalcVisibleLines();
	sal_uInt16 nEnd=(sal_uInt16)(nThumbPos+nLines);
	if(nEnd>=PLineArray.Count())nEnd=PLineArray.Count()-1;
	if(PLineArray.Count()>0)
	{
		for(sal_uInt16 i=(sal_uInt16)nThumbPos; i<=nEnd;i++)
		{
			(PLineArray[i])->SetNeedsRepaint(sal_True);
		}
		UpdatePosNSize();
	}
}

//------------------------------------------------------------------
void SvxLBoxForProps::UpdateAll()
{
	Resize();
}

//------------------------------------------------------------------
void SvxLBoxForProps::DisableUpdate()
{
	bUpdate=sal_False;
}

//------------------------------------------------------------------
void SvxLBoxForProps::EnableUpdate()
{
	bUpdate=sal_True;
	UpdateAll();
}

//------------------------------------------------------------------
void SvxLBoxForProps::SetPropertyValue( const ::rtl::OUString & rEntryName,
											   const ::rtl::OUString & rValue )
{
	sal_uInt16 i, iEnd = PLineArray.Count();
	for( i = 0 ; i < iEnd ; i++ )
	{
		SvxPropertyLine* pPropLine = PLineArray[ i ];
		SvxPropControl* pSvXPCtr=pPropLine->GetSvxPropControl();
		if( pSvXPCtr && pSvXPCtr->GetMyName() == rEntryName )
		{
			pSvXPCtr->SetProperty( rValue );
			break;
		}
	}
}

//------------------------------------------------------------------------
::rtl::OUString SvxLBoxForProps::GetPropertyValue( const ::rtl::OUString& rEntryName )	const
{
	::rtl::OUString aRet;
	sal_uInt16 i, iEnd = PLineArray.Count();
	for( i = 0 ; i < iEnd ; i++ )
	{
		SvxPropertyLine* pPropLine = PLineArray[ i ];
		SvxPropControl* pSvXPCtr=pPropLine->GetSvxPropControl();
		if( pSvXPCtr && pSvXPCtr->GetMyName() == rEntryName )
		{
			aRet = pSvXPCtr->GetProperty();
			break;
		}
	}

	return aRet;
}

//------------------------------------------------------------------------
sal_uInt16 SvxLBoxForProps::GetPropertyPos( const ::rtl::OUString& rEntryName ) const
{
	sal_uInt16 i, iEnd = PLineArray.Count();
	sal_uInt16 nRet=LISTBOX_ENTRY_NOTFOUND;
	for( i = 0 ; i < iEnd ; i++ )
	{
		SvxPropertyLine* pPropLine = PLineArray[ i ];
		SvxPropControl* pSvXPCtr=pPropLine->GetSvxPropControl();
		if( pSvXPCtr && pSvXPCtr->GetMyName() == rEntryName )
		{
			nRet = i;
			break;
		}
	}

	return nRet;
}

//------------------------------------------------------------------------
SvxPropControl* SvxLBoxForProps::GetPropertyControl(const ::rtl::OUString& rEntryName)
{
	sal_uInt16 i, iEnd = PLineArray.Count();
	for( i = 0 ; i < iEnd ; i++ )
	{
		SvxPropertyLine* pPropLine = PLineArray[ i ];
		SvxPropControl* pSvXPCtr = pPropLine->GetSvxPropControl();
		if (pSvXPCtr && (pSvXPCtr->GetMyName() == rEntryName))
			return pSvXPCtr;
	}
	return NULL;
}

//------------------------------------------------------------------------
void SvxLBoxForProps::SetPropertyData(const ::rtl::OUString& rEntryName, void* pData)
{
	sal_uInt16 i, iEnd = PLineArray.Count();
	for( i = 0 ; i < iEnd ; i++ )
	{
		SvxPropertyLine* pPropLine = PLineArray[ i ];
		SvxPropControl* pSvXPCtr = pPropLine->GetSvxPropControl();
		if (pSvXPCtr && (pSvXPCtr->GetMyName() == rEntryName))
		{
			pSvXPCtr->SetMyData(pData);
			break;
		}
	}
}

//------------------------------------------------------------------------
sal_uInt16 SvxLBoxForProps::AppendEntry( const SvxPropData& aPropData)
{
	return InsertEntry(aPropData);
}

//------------------------------------------------------------------
sal_uInt16 SvxLBoxForProps::InsertEntry( const SvxPropData& aPropData, sal_uInt16 nPos)
{
	sal_uInt16 nInsPos=nPos;
	SvxPropertyLine* pPropLine=new SvxPropertyLine(&aPlayGround);

	long nThumbPos=aVScroll.GetThumbPos();
	long nLines=aVScroll.GetPageSize();

	if(nPos==LISTBOX_APPEND)
	{
		nInsPos=PLineArray.Count();
		PLineArray.Insert(pPropLine,nInsPos);
	}
	else
	{
		PLineArray.Insert(pPropLine,nPos);
	}
	pPropLine->SetTitleWidth(nTheNameSize);
	if(bUpdate)
	{
		UpdateVScroll();
		Invalidate();
	}
	ChangeEntry(aPropData,nInsPos);
	return nInsPos;
}

//------------------------------------------------------------------
void SvxLBoxForProps::ChangeEntry( const SvxPropData& aPropData, sal_uInt16 nPos)
{
	sal_Bool bNew=sal_True;
	if(nPos<PLineArray.Count())
	{
		Window*	pRefWindow=NULL;
		if(nPos>0)
		{
			pRefWindow=PLineArray[nPos-1]->GetRefWindow();
		}

		SvxPropertyLine* pPropLine=PLineArray[nPos];

		SvxPropControl* pSvXPCtr=pPropLine->GetSvxPropControl();

		Point aCtrPos;

		if(pSvXPCtr!=NULL)	aCtrPos=pSvXPCtr->GetCtrPos();

		if(pPropLine->GetKindOfControl()!=aPropData.eKind)
		{
			bNew=sal_True;
			switch(pPropLine->GetKindOfControl())
			{
				case    KOC_MEDIT:		delete (SvxPropMultiEdit*)pSvXPCtr;
										break;

				case	KOC_LISTBOX:	delete (SvxPropListBox*)pSvXPCtr;
										break;

				case	KOC_COLORBOX:	delete (SvxPropColorBox*)pSvXPCtr;
										break;

				case	KOC_COMBOBOX:	delete (SvxPropComboBox*)pSvXPCtr;
										break;

				case	KOC_EDIT:		delete (SvxPropEdit*)pSvXPCtr;
										break;

				case	KOC_NUMFIELD:	delete (SvxPropNumField*)pSvXPCtr;
										break;

				case	KOC_CURFIELD:	delete (SvxPropCurField*)pSvXPCtr;
										break;

				case	KOC_DATEFIELD:	delete (SvxPropDateField*)pSvXPCtr;
										break;

				case	KOC_TIMEFIELD:	delete (SvxPropTimeField*)pSvXPCtr;
										break;

				case	KOC_USERDEFINED:	delete pPropLine->GetSvxPropControl();
											// we don't have to cast thjis, the destructor is virtual
											break;
			}

			WinBits nWinBits=WB_BORDER;

			::rtl::OUString aStr;

			if(aPropData.bIsLocked) nWinBits|=WB_READONLY;

			pPropLine->SetKindOfControl(aPropData.eKind);	// may be overwritten
			switch(aPropData.eKind)
			{
				case    KOC_LEDIT:		pPropLine->SetSvxPropControl(
												new SvxPropMultiEdit(&aPlayGround,sal_False,
															nWinBits |WB_DROPDOWN| WB_TABSTOP));

										pPropLine->SetKindOfControl(KOC_MEDIT);
										break;

				case    KOC_MEDIT:		pPropLine->SetSvxPropControl(
												new SvxPropMultiEdit(&aPlayGround,sal_True,
															nWinBits |WB_DROPDOWN| WB_TABSTOP));

										pPropLine->SetKindOfControl(KOC_MEDIT);
										break;
				case	KOC_LISTBOX:
										pPropLine->SetSvxPropControl(
												new SvxPropListBox(&aPlayGround, nWinBits |
														WB_TABSTOP|WB_DROPDOWN));
										break;
				case	KOC_COMBOBOX:
										pPropLine->SetSvxPropControl(
												new SvxPropComboBox(&aPlayGround, nWinBits |
														WB_TABSTOP|WB_SORT|WB_DROPDOWN));
										break;
				case	KOC_EDIT:
										pPropLine->SetSvxPropControl(
												new SvxPropEdit(&aPlayGround,sal_False,nWinBits |
														WB_TABSTOP ));

										break;
				case	KOC_CHAREDIT:
										pPropLine->SetSvxPropControl(
												new SvxPropEdit(&aPlayGround,sal_True,nWinBits |
														WB_TABSTOP ));

										pPropLine->SetKindOfControl(KOC_EDIT);
										break;
				case    KOC_NUMFIELD:
										pPropLine->SetSvxPropControl(new SvxPropNumField(&aPlayGround,aPropData.nDigits,
														nWinBits | WB_TABSTOP|WB_SPIN));
										break;

				case	KOC_CURFIELD:
										pPropLine->SetSvxPropControl(new SvxPropCurField(&aPlayGround,aPropData.nDigits,
														nWinBits | WB_TABSTOP|WB_SPIN));
										break;
				case    KOC_DATEFIELD:
										pPropLine->SetSvxPropControl(
												new SvxPropDateField(&aPlayGround,nWinBits |
														WB_TABSTOP|WB_SPIN));

										break;
				case    KOC_TIMEFIELD:
										pPropLine->SetSvxPropControl(
												new SvxPropTimeField(&aPlayGround,nWinBits |
														WB_TABSTOP|WB_SPIN));

										break;
				case	KOC_COLORBOX:
										if (aPropData.bHasDefault)
											aStr = aStandard;
										pPropLine->SetSvxPropControl(
												new SvxPropColorBox(&aPlayGround, aStr, nWinBits | WB_TABSTOP | WB_DROPDOWN));

										break;
				case	KOC_USERDEFINED:
										pPropLine->SetSvxPropControl(aPropData.pControl);
										aPropData.pControl->SetCtrParent(&aPlayGround);
										break;

				default:
										pPropLine->SetSvxPropControl(NULL);
										pPropLine->SetKindOfControl(KOC_UNDEFINED);
										break;
			}
			pSvXPCtr=pPropLine->GetSvxPropControl();
			pSvXPCtr->SetCtrPos(aCtrPos);

			// forward the locking flag to the control
			pSvXPCtr->SetLocked(aPropData.bIsLocked);
		}
		else
		{
			bNew=sal_False;
			pSvXPCtr->ClearList();
		}

		if(pSvXPCtr!=NULL)
		{
			pSvXPCtr->SetSvxPropCtrListener(&aListener);
			pSvXPCtr->SetMyData(aPropData.pDataPtr);
			pSvXPCtr->SetMyName(aPropData.aName);
			pSvXPCtr->SetLine(nPos);

			if(aPropData.bHasDefault && KOC_COLORBOX!=aPropData.eKind)
				pSvXPCtr->InsertCtrEntry(aStandard);

			if(pSvXPCtr->HasList())
			{
				for(int i=0;i<aPropData.theValues.size();i++)
				{
					pSvXPCtr->InsertCtrEntry(aPropData.theValues[i]);
				}
			}
			pSvXPCtr->SetProperty(aPropData.aValue,aPropData.bIsUnknown);
		}

		pPropLine->SetTitle(aPropData.aTitle);

		sal_uInt16 nTextWidth = (sal_uInt16)aPlayGround.GetTextWidth(aPropData.aTitle);

		if(nTheNameSize< nTextWidth) nTheNameSize=nTextWidth;

		if(aPropData.bHasVisibleXButton)
		{
			pPropLine->ShowXButton();
			pPropLine->SetClickHdl(LINK( this, SvxLBoxForProps, ClickHdl ) );
		}
		else
			pPropLine->HideXButton();

		pPropLine->Locked(aPropData.bIsLocked);

		pPropLine->ShowAsHyperLink(aPropData.bIsHyperLink);
		pPropLine->SetData(aPropData.pDataPtr);

		if(bNew)
		{
			if(nPos>0)
				pPropLine->SetTabOrder(pRefWindow, WINDOW_ZORDER_BEHIND);
			else
				pPropLine->SetTabOrder(pRefWindow, WINDOW_ZORDER_FIRST );

			pPropLine->SetNeedsRepaint(sal_True);
			pPropLine->SetHelpId(aPropData.nHelpId,aPropData.nBtUniqueId);
		}
	}
}

//------------------------------------------------------------------
sal_uInt16 SvxLBoxForProps::GetFirstVisibleEntry()
{
	return (sal_uInt16) aVScroll.GetThumbPos();
}

//------------------------------------------------------------------
void SvxLBoxForProps::SetFirstVisibleEntry(sal_uInt16 nPos)
{
	if(nPos<PLineArray.Count())
	{
		MoveThumbTo(nPos);
	}
}

//------------------------------------------------------------------
void SvxLBoxForProps::SetSelectedEntry(sal_uInt16 nPos)
{
	if(nPos<PLineArray.Count())
	{
		nSelectedLine=nPos;
		ShowEntry(nPos);
		PLineArray[nPos]->SetFocus();
	}
}

//------------------------------------------------------------------
sal_uInt16 SvxLBoxForProps::GetSelectedEntry()
{
	return nSelectedLine;
}

//------------------------------------------------------------------
void SvxLBoxForProps::ShowEntry(sal_uInt16 nPos)
{
	if(nPos<PLineArray.Count())
	{
		long nThumbPos=aVScroll.GetThumbPos();
		long nLines=CalcVisibleLines();
		long nNewThumbPos=nThumbPos;

		if(nPos<nThumbPos)
		{
			nNewThumbPos=nPos;
			MoveThumbTo(nNewThumbPos);
		}
		else if(nPos>=nThumbPos+nLines)
		{
			nNewThumbPos=nPos-nLines+1;
			MoveThumbTo(nNewThumbPos);
		}
	}

}

void SvxLBoxForProps::MoveThumbTo(long nNewThumbPos)
{
	aPlayGround.EnablePaint(sal_False);

	long nThumbPos=aVScroll.GetThumbPos();

	long nDelta=nNewThumbPos-nThumbPos;
	aVScroll.SetThumbPos(nNewThumbPos);

	nThumbPos=nNewThumbPos;

	nYOffset=-aVScroll.GetThumbPos()*nRowHeight;

	long nLines=CalcVisibleLines();
	sal_uInt16 nEnd=(sal_uInt16)(nThumbPos+nLines);

	aPlayGround.Scroll(0,-nDelta*nRowHeight,SCROLL_CHILDREN);

	if(nDelta==1)
	{
		ShowLine(nEnd-1);
		ShowLine(nEnd);
	}
	else if(nDelta==-1)
	{
		ShowLine((sal_uInt16)nThumbPos);
	}
	else if(nDelta!=0)
	{
		UpdatePlayGround();
	}
	aPlayGround.EnablePaint(sal_True);
	aPlayGround.Invalidate(INVALIDATE_CHILDREN);
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, ScrollHdl,ScrollBar*, pSB )
{
	if(pSB!=NULL)
	{
		aPlayGround.EnablePaint(sal_False);
		long nDelta=aVScroll.GetDelta();
		nYOffset=-aVScroll.GetThumbPos()*nRowHeight;

		long nThumbPos=aVScroll.GetThumbPos();

		long nLines=CalcVisibleLines();
		sal_uInt16 nEnd=(sal_uInt16)(nThumbPos+nLines);

		aPlayGround.Scroll(0,-nDelta*nRowHeight,SCROLL_CHILDREN);


		if(nDelta==1)
		{
			ShowLine(nEnd-1);
			ShowLine(nEnd);
		}
		else if(nDelta==-1)
		{
			ShowLine((sal_uInt16)nThumbPos);
		}
		else if(nDelta!=0 || aVScroll.GetType()==SCROLL_DONTKNOW)
		{
			UpdatePlayGround();
		}
		aPlayGround.EnablePaint(sal_True);
	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, ClickHdl, PushButton*,pPB)
{
	if(pPB!=NULL)
	{
	   SvxPropertyLine *pPropLine=(SvxPropertyLine *)pPB->GetData();
	   SvxPropControl* pSvXPCtr=pPropLine->GetSvxPropControl();
	   pPropDataControl->Clicked(pSvXPCtr->GetMyName(),
							pSvXPCtr->GetProperty(),pSvXPCtr->GetMyData());
	   pPB->GrabFocus();
	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, ModifyHdl,SvxPrivatEvtListener*, pSvXPEvL)
{
	if(pSvXPEvL!=NULL && pPropDataControl!=NULL)
	{

		SvxPropControl* pSvXPCtr=aListener.GetPropertyControl();

		pPropDataControl->Modified(pSvXPCtr->GetMyName(),
							pSvXPCtr->GetProperty(),pSvXPCtr->GetMyData());

	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, GetFocusHdl,SvxPrivatEvtListener*, pSvXPEvL)
{
	if(pSvXPEvL!=NULL && pPropDataControl!=NULL)
	{
		SvxPropControl* pSvXPCtr=aListener.GetPropertyControl();

		pPropDataControl->Select(pSvXPCtr->GetMyName(),pSvXPCtr->GetMyData());

		nSelectedLine=pSvXPCtr->GetLine();

		ShowEntry(nSelectedLine);
	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, GotoLineHdl,SvxPrivatEvtListener*, pSvXPEvL)
{
	if(pSvXPEvL!=NULL)
	{
		SvxPropControl* pSvXPCtr=aListener.GetPropertyControl();
		long nLine = pSvXPCtr->GetLine();

		if(pSvXPCtr->GetDirection())
		{
			nLine++;
			while(nLine<PLineArray.Count())
			{
				if(PLineArray[(sal_uInt16)nLine]->SetFocus()) break;
				nLine++;
			}
			if(nLine>=PLineArray.Count() && PLineArray.Count()>0)
			{
				PLineArray[0]->SetFocus();
			}

		}
		else
		{
			nLine--;
			while(nLine>=0)
			{
				sal_uInt16 nP=(sal_uInt16)nLine;
				if(PLineArray[nP]->SetFocus()) break;
				nLine--;
			}
			if(nLine<0 && PLineArray.Count()>0)
			{
				sal_uInt16 nP=PLineArray.Count()-1;
				PLineArray[nP]->SetFocus();
			}

		}
	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, LoseFocusHdl,SvxPrivatEvtListener*, pSvXPEvL)
{
	if(pSvXPEvL!=NULL && pPropDataControl!=NULL)
	{
		SvxPropControl* pSvXPCtr=aListener.GetPropertyControl();

		pPropDataControl->Commit(pSvXPCtr->GetMyName(),
					pSvXPCtr->GetProperty(),pSvXPCtr->GetMyData());

	}
	return 0;
}

//------------------------------------------------------------------
IMPL_LINK( SvxLBoxForProps, KeyInputHdl,SvxPrivatEvtListener*, pSvXPEvL)
{
	if(pSvXPEvL!=NULL && pPropDataControl!=NULL)
	{
		SvxPropControl* pSvXPCtr=aListener.GetPropertyControl();
	}
	return 0;
}


//==================================================================
// class SvxTPageForProps
//==================================================================

//------------------------------------------------------------------
SvxTPageForProps::SvxTPageForProps(Window* pParent,WinBits nWinStyle)
			:	TabPage(pParent,nWinStyle),
				aLbProp(this)
{
#ifndef NOOLDSV
	Brush aBrush=GetBackgroundBrush();
	aBrush.SetTransparent( sal_True);
	SetBackgroundBrush(aBrush);
	aLbProp.SetBackgroundBrush(aBrush);
#else
	// TODO : how to set a transparent background ?
	aLbProp.SetBackground(GetBackground());
#endif
	Point aPos(3,3);
	aLbProp.SetPosPixel(aPos);
	aLbProp.Show();
}

//------------------------------------------------------------------
void SvxTPageForProps::Resize()
{
	Size aSize(GetOutputSizePixel());
	aSize.Width()-=6;
	aSize.Height()-=6;

	aLbProp.SetSizePixel(aSize);
}

//------------------------------------------------------------------
SvxLBoxForProps* SvxTPageForProps::GetTheListBox()
{
	return &aLbProp;
}


void SvxTPageForProps::ActivatePage()
{
	TabPage::ActivatePage();
}

void SvxTPageForProps::DeactivatePage()
{
	TabPage::DeactivatePage();
}

void SvxTPageForProps::StateChanged( StateChangedType nType)
{
	Window::StateChanged( nType);
	if(nType==STATE_CHANGE_VISIBLE)
	{
		aLbProp.Activate(IsVisible());
	}
}

//==================================================================
// class SvxPropertyBox
//==================================================================
DBG_NAME(SvxPropertyBox);
//------------------------------------------------------------------
SvxPropertyBox::SvxPropertyBox( Window* pParent, WinBits nWinStyle)
			: Control(pParent,nWinStyle)
			  ,aTabControl(this)
			  ,nNextId(1)
{
	DBG_CTOR(SvxPropertyBox,NULL);
	
	aTabControl.Show();
#ifndef NOOLDSV
	Brush aBrush=GetBackgroundBrush();
	aBrush.SetTransparent( sal_True);
	SetBackgroundBrush(aBrush);
	aTabControl.SetBackgroundBrush(aBrush);
#else
	// TODO : how to set a transparent background ?
	aTabControl.SetBackground(GetBackground());
#endif
}

//------------------------------------------------------------------
SvxPropertyBox::SvxPropertyBox( Window* pParent, const ResId& rResId )
			: Control(pParent,rResId)
			  ,aTabControl(this)
			  ,nNextId(1)
{
	DBG_CTOR(SvxPropertyBox,NULL);

	aTabControl.Show();

	SetHelpId(GetHelpId());

#ifndef NOOLDSV
	Brush aBrush=GetBackgroundBrush();
	aBrush.SetTransparent(sal_True);
	aTabControl.SetBackgroundBrush(aBrush);
#else
	// TODO : how to set a transparent background ?
	aTabControl.SetBackground(GetBackground());
#endif
	aTabControl.SetPaintTransparent(sal_True);

	Resize();
}

//------------------------------------------------------------------
SvxPropertyBox::~SvxPropertyBox()
{
	Hide();
	ClearAll();

	DBG_DTOR(SvxPropertyBox,NULL);
}

//------------------------------------------------------------------
void SvxPropertyBox::ClearAll()
{
	nNextId=1;
	sal_uInt16 nCount=aTabControl.GetPageCount();

	for(long i=nCount-1;i>=0;i--)
	{
		sal_uInt16 nID=aTabControl.GetPageId((sal_uInt16)i);
		SvxTPageForProps* pPage=(SvxTPageForProps*)
									aTabControl.GetTabPage(nID);

		if(pPage!=NULL)
		{
			pPage->EnableInput(sal_False);
			aTabControl.RemovePage(nID);
			delete pPage;
		}
	}
	aTabControl.Clear();
}

//------------------------------------------------------------------
void SvxPropertyBox::Resize()
{
	Point aPos(3,3);
	Size aSize(GetOutputSizePixel());
	aSize.Width()-=6;
	aSize.Height()-=6;

	aTabControl.SetSizePixel(aSize);

}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::AppendPage( const XubString & rText,sal_uInt32 nHelpId )
{
	sal_uInt16 nId=nNextId++;
	aTabControl.InsertPage( nId,rText);
	SvxTPageForProps* pPage=new SvxTPageForProps(&aTabControl);
	pPage->SetSizePixel(aTabControl.GetOutputSizePixel());
	pPage->GetTheListBox()->SetController(pThePropDataCtr);
	pPage->SetHelpId(nHelpId );
	aTabControl.SetTabPage( nId, pPage);
	aTabControl.SetCurPageId(nId);
	return nId;
}

void SvxPropertyBox::SetHelpId( sal_uInt32 nHelpId )
{
	Control::SetHelpId(0);
	aTabControl.SetHelpId(nHelpId);
}

void SvxPropertyBox::RemovePage(sal_uInt16 nID)
{

	SvxTPageForProps* pPage=(SvxTPageForProps*)
									aTabControl.GetTabPage(nID);

	if(pPage!=NULL) pPage->EnableInput(sal_False);

	aTabControl.RemovePage(nID);

	if(pPage!=NULL) delete pPage;
}
//------------------------------------------------------------------
void SvxPropertyBox::SetPage( sal_uInt16 nId)
{
	aTabControl.SetCurPageId(nId);
}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::GetCurPage()
{
	if(aTabControl.GetPageCount()>0)
		return aTabControl.GetCurPageId();
	else
		return 0;
}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::CalcVisibleLines()
{
	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());
	if (pPage!=NULL)
		return pPage->GetTheListBox()->CalcVisibleLines();
	else return 0;
}

//------------------------------------------------------------------
void SvxPropertyBox::EnableUpdate()
{
	sal_uInt16 nCount=aTabControl.GetPageCount();

	for(sal_uInt16 i=0;i<nCount;i++)
	{
		sal_uInt16 nID=aTabControl.GetPageId(i);

		SvxTPageForProps* pPage=(SvxTPageForProps*)
									aTabControl.GetTabPage(nID);

		if(pPage!=NULL)
			pPage->GetTheListBox()->EnableUpdate();
	}
}

//------------------------------------------------------------------
void SvxPropertyBox::DisableUpdate()
{
	sal_uInt16 nCount=aTabControl.GetPageCount();

	for(sal_uInt16 i=0;i<nCount;i++)
	{
		sal_uInt16 nID=aTabControl.GetPageId(i);

		SvxTPageForProps* pPage=(SvxTPageForProps*)
									aTabControl.GetTabPage(nID);

		if(pPage!=NULL)
			pPage->GetTheListBox()->DisableUpdate();
	}
}

//------------------------------------------------------------------
void SvxPropertyBox::SetController(SvxPropDataListener *pDataCtr)
{
	pThePropDataCtr=pDataCtr;
	sal_uInt16 nCount=aTabControl.GetPageCount();

	for(sal_uInt16 i=0;i<nCount;i++)
	{
		sal_uInt16 nID=aTabControl.GetPageId(i);
		SvxTPageForProps* pPage=(SvxTPageForProps*)
									aTabControl.GetTabPage(nID);

		if(pPage!=NULL)
			pPage->GetTheListBox()->SetController(pThePropDataCtr);
	}

}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::InsertEntry( const SvxPropData& rData, sal_uInt16 nPos)
{
	sal_uInt16 nEntry=LISTBOX_ENTRY_NOTFOUND;

	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		nEntry=pPage->GetTheListBox()->InsertEntry(rData,nPos);

	return nEntry;
}

//------------------------------------------------------------------
void SvxPropertyBox::ChangeEntry( const SvxPropData& rData, sal_uInt16 nPos)
{
	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		pPage->GetTheListBox()->ChangeEntry(rData,nPos);
}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::AppendEntry( const SvxPropData& rData)
{
	sal_uInt16 nEntry=LISTBOX_ENTRY_NOTFOUND;

	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		nEntry=pPage->GetTheListBox()->AppendEntry(rData);

	return nEntry;
}

//------------------------------------------------------------------
void SvxPropertyBox::SetPropertyValue( const ::rtl::OUString & rEntryName, const ::rtl::OUString & rValue )
{
	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if (pPage!=NULL)
		pPage->GetTheListBox()->SetPropertyValue( rEntryName, rValue );
}

//------------------------------------------------------------------
::rtl::OUString SvxPropertyBox::GetPropertyValue( const ::rtl::OUString& rEntryName ) const
{
	::rtl::OUString aString;

	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		aString=pPage->GetTheListBox()->GetPropertyValue( rEntryName );

	return aString;
}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::GetPropertyPos( const ::rtl::OUString& rEntryName ) const
{
	sal_uInt16 nVal=LISTBOX_ENTRY_NOTFOUND;

	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		nVal=pPage->GetTheListBox()->GetPropertyPos( rEntryName );

	return nVal;
}

//------------------------------------------------------------------
SvxPropControl* SvxPropertyBox::GetPropertyControl(const ::rtl::OUString& rEntryName)
{
	SvxTPageForProps* pPage = (SvxTPageForProps*) aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if (pPage)
		return pPage->GetTheListBox()->GetPropertyControl(rEntryName);

	return NULL;
}

//------------------------------------------------------------------
void SvxPropertyBox::SetPropertyData( const ::rtl::OUString& rEntryName, void* pData )
{
	SvxTPageForProps* pPage = (SvxTPageForProps*) aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if (pPage)
		pPage->GetTheListBox()->SetPropertyData(rEntryName, pData);

}

//------------------------------------------------------------------
void SvxPropertyBox::SetFirstVisibleEntry(sal_uInt16 nPos)
{
	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		pPage->GetTheListBox()->SetFirstVisibleEntry(nPos);
}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::GetFirstVisibleEntry()
{
	sal_uInt16 nEntry=LISTBOX_ENTRY_NOTFOUND;

	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		nEntry=pPage->GetTheListBox()->GetFirstVisibleEntry();

	return nEntry;
}

//------------------------------------------------------------------
void SvxPropertyBox::SetSelectedEntry(sal_uInt16 nPos)
{
	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		pPage->GetTheListBox()->SetSelectedEntry(nPos);
}

//------------------------------------------------------------------
sal_uInt16 SvxPropertyBox::GetSelectedEntry()
{
	sal_uInt16 nEntry=LISTBOX_ENTRY_NOTFOUND;

	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		nEntry=pPage->GetTheListBox()->GetSelectedEntry();

	return nEntry;
}

//------------------------------------------------------------------
void SvxPropertyBox::ClearTable()
{
	SvxTPageForProps* pPage=(SvxTPageForProps*)
				aTabControl.GetTabPage(aTabControl.GetCurPageId());

	if(pPage!=NULL)
		pPage->GetTheListBox()->Clear();
}


//==================================================================
// class SvxBasicPropDataListener
//==================================================================

//------------------------------------------------------------------
void SvxBasicPropDataListener::Modified(const XubString& aTitle,
								const XubString& aVal,void* pData)
{
	aEntryName=aTitle;
	aEntryProperty=aVal;
	pTheData=pData;
	aModifyLink.Call(this);
}

//------------------------------------------------------------------
void SvxBasicPropDataListener::Clicked(	const XubString& aTitle,
									const XubString& aVal,
									void* pData)		//Xtension-Button pressed
{
	aEntryName=aTitle;
	aEntryProperty=aVal;
	pTheData=pData;
	aClickedLink.Call(this);
}

//------------------------------------------------------------------
void SvxBasicPropDataListener::Commit(		const XubString& aTitle,
									const XubString& aVal,
									void* pData)		//User accept changes
{
	aEntryName=aTitle;
	aEntryProperty=aVal;
	pTheData=pData;
	aCommitLink.Call(this);
}

//------------------------------------------------------------------
void SvxBasicPropDataListener::Select(		const XubString& aTitle,
									void* pData)		//User select new Row
{
	aEntryName=aTitle;
	pTheData=pData;
	aSelectLink.Call(this);
}

//------------------------------------------------------------------
void SvxBasicPropDataListener::LinkClicked(const XubString& aTitle, void* pData)
{
}

//------------------------------------------------------------------
XubString	SvxBasicPropDataListener::GetName() const //Tell's the name of the ::com::sun::star::beans::Property
{
	return aEntryName;
}

//------------------------------------------------------------------
XubString	SvxBasicPropDataListener::GetProperty() const //Tell's the content of the ::com::sun::star::beans::Property
{
	return aEntryProperty;
}

//------------------------------------------------------------------
void*	SvxBasicPropDataListener::GetData() //Tell's the storage
{
	return pTheData;
}

//------------------------------------------------------------------
void SvxBasicPropDataListener::SetTheCorrectProperty(const XubString& aString)
{
	aCorrectProperty=aString;
}

//------------------------------------------------------------------
void SvxBasicPropDataListener::SetIsCorrect(sal_Bool nFlag)
{
	bCorrectness=nFlag;
}


