/*************************************************************************
 *
 *  $RCSfile: qryparam.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _UTL_STLTYPES_HXX_
#include "unotools/stl_types.hxx"
#endif

#ifndef _SVX_QRYPARAM_HXX
#include "qryparam.hxx"
#endif
#ifndef _SVX_QRYPARAM_HRC
#include "qryparam.hrc"
#endif
#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif
#ifndef _SVX_DIALMGR_HXX
#include "dialmgr.hxx"
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_POLY_HXX
#include <vcl/poly.hxx>
#endif
#ifndef _SVX_FMSERVS_HXX
#include "fmservs.hxx"
#endif
#ifndef _SVX_FMPROP_HRC
#include "fmprop.hrc"
#endif
#ifndef _SVX_FMPROP_HXX
#include "fmprop.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen wg. DBG_ASSERT
#include <tools/debug.hxx>
#endif
#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include <com/sun/star/sdbc/DataType.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_NUMBERFORMAT_HPP_
#include <com/sun/star/util/NumberFormat.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#ifndef _SV_SVAPP_HXX //autogen wg. Application
#include <vcl/svapp.hxx>
#endif

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _UTL_UNO3_DB_TOOLS_HXX_
#include <unotools/dbtools.hxx>
#endif

#define EF_VISITED		0x0001
#define EF_DIRTY		0x0002

//==============================================================================
// FmEnterParamDlg
//==============================================================================

DECLARE_STL_VECTOR(sal_Int8, ByteVector);

//------------------------------------------------------------------------------
#define INIT_MEMBERS()											\
	:ModalDialog( pParent, SVX_RES(RID_SVX_DLG_QUERYPARAMS))	\
	,m_aNamesFrame	(this, ResId(GB_PARAMS))					\
	,m_aAllParams	(this, ResId(LB_ALLPARAMS))					\
	,m_aValueFrame	(this, ResId(GB_DATA))						\
	,m_aParam		(this, ResId(ET_PARAM))						\
	,m_aTravelNext	(this, ResId(BT_TRAVELNEXT))				\
	,m_aDelimiter	(this, ResId(FT_DELIM))						\
	,m_aOKBtn		(this, ResId(BT_OK))						\
	,m_aCancelBtn	(this, ResId(BT_CANCEL))					\
	,m_nCurrentlySelected(LISTBOX_ENTRY_NOTFOUND)				\
	,m_pParser(new SdbSqlParser(Application::GetAppInternational().GetLanguage()))


//------------------------------------------------------------------------------

DBG_NAME(FmEnterParamDlg);
FmEnterParamDlg::FmEnterParamDlg(Window* pParent, const ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > & rParamContainer, const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection > & _rConnNFormats)
	INIT_MEMBERS()
	,m_bNeedErrorOnCurrent(sal_True)
	,m_xConnection(_rConnNFormats)
	,m_xFormatter(::utl::getProcessServiceFactory()->createInstance(FM_NUMBER_FORMATTER), ::com::sun::star::uno::UNO_QUERY)
{
	DBG_CTOR(FmEnterParamDlg,NULL);
	m_pVisitedParams = (void*)new ByteVector;

	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xNumberFormats = ::utl::getNumberFormats(m_xConnection, sal_True);
	if (!xNumberFormats.is())
		::utl::disposeComponent(m_xFormatter);
	else if (m_xFormatter.is())
		m_xFormatter->attachNumberFormatsSupplier(xNumberFormats);
	try
	{
		DBG_ASSERT(rParamContainer->getCount(), "FmEnterParamDlg::FmEnterParamDlg : can't handle empty containers !");

		::rtl::OUString aName;
		::com::sun::star::uno::Any aVal;
		for (sal_Int32 i = 0, nCount = rParamContainer->getCount(); i<nCount; ++i)
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xParamAsSet(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)rParamContainer->getByIndex(i).getValue(), ::com::sun::star::uno::UNO_QUERY);
			aName = ::utl::getString(xParamAsSet->getPropertyValue(FM_PROP_NAME));
			m_aAllParams.InsertEntry(aName);

			aVal = xParamAsSet->getPropertyValue(FM_PROP_VALUE);
			if (!aVal.hasValue())
				m_aAllParams.SetEntryData(i, new ::com::sun::star::uno::Any(::com::sun::star::uno::makeAny(::rtl::OUString())));
			else
				m_aAllParams.SetEntryData(i, new ::com::sun::star::uno::Any(::com::sun::star::uno::makeAny(aVal)));

			((ByteVector*)m_pVisitedParams)->push_back(0);
				// not visited, not dirty
		}

		m_xParams = rParamContainer;
	}
	catch(...)
	{
		DBG_ERROR("FmEnterParamDlg::FmEnterParamDlg : soemthing went wrong while retrieving the parameters !");
	}
	

	Construct();

	m_aResetVisitFlag.SetTimeoutHdl(LINK(this, FmEnterParamDlg, OnVisitedTimeout));

	FreeResource();
}

//------------------------------------------------------------------------------
FmEnterParamDlg::~FmEnterParamDlg()
{
	if (m_aResetVisitFlag.IsActive())
		m_aResetVisitFlag.Stop();

	while (m_aAllParams.GetEntryCount())
	{
		delete (::com::sun::star::uno::Any*)m_aAllParams.GetEntryData(0);
		m_aAllParams.RemoveEntry(0);
	}

	delete m_pParser;
	delete (ByteVector*)m_pVisitedParams;


	DBG_DTOR(FmEnterParamDlg,NULL);
}

//------------------------------------------------------------------------------
void FmEnterParamDlg::Construct()
{
	m_aAllParams.SetSelectHdl(LINK(this, FmEnterParamDlg, OnEntrySelected));
	m_aParam.SetLoseFocusHdl(LINK(this, FmEnterParamDlg, OnValueLoseFocus));
	m_aParam.SetModifyHdl(LINK(this, FmEnterParamDlg, OnValueModified));
	m_aTravelNext.SetClickHdl(LINK(this, FmEnterParamDlg, OnButtonClicked));
	m_aOKBtn.SetClickHdl(LINK(this, FmEnterParamDlg, OnButtonClicked));
	m_aCancelBtn.SetClickHdl(LINK(this, FmEnterParamDlg, OnButtonClicked));

	if (m_aAllParams.GetEntryCount())
	{
		m_aAllParams.SelectEntryPos(0);
		LINK(this, FmEnterParamDlg, OnEntrySelected).Call(&m_aAllParams);

		if (m_aAllParams.GetEntryCount() == 1) 
		{
			m_aTravelNext.Enable(sal_False);
		}

		if (m_aAllParams.GetEntryCount() > 1) 
		{
			m_aOKBtn.SetStyle(m_aOKBtn.GetStyle() & ~WB_DEFBUTTON);
			m_aTravelNext.SetStyle(m_aTravelNext.GetStyle() | WB_DEFBUTTON);
		}
	}

	m_aParam.GrabFocus();
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Any FmEnterParamDlg::GetParamValue(sal_uInt16 nPos)
{
	if ((nPos>=0) && (nPos<m_aAllParams.GetEntryCount()))
		return *(::com::sun::star::uno::Any*)m_aAllParams.GetEntryData(nPos);

	return ::com::sun::star::uno::Any();
}

//------------------------------------------------------------------------------
SdbSqlParseNode* FmEnterParamDlg::implPredicateTree(UniString& _rErrorMessage, const UniString& _rStatement, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _rxField)
{
	XubString aErr;
	SdbSqlParseNode* pReturn = m_pParser->PredicateTree(aErr, _rStatement, m_xFormatter, Application::GetAppInternational(), _rxField);
	_rErrorMessage = aErr;
	if (!pReturn)
	{	// is it a text field ?
		sal_Int32 nType = ::com::sun::star::sdbc::DataType::OTHER;
		try { nType = ::utl::getINT32(_rxField->getPropertyValue(FM_PROP_FIELDTYPE)); }
		catch(...) { } ;
		if ((::com::sun::star::sdbc::DataType::CHAR == nType) || (::com::sun::star::sdbc::DataType::VARCHAR == nType) || (::com::sun::star::sdbc::DataType::LONGVARCHAR == nType))
		{	// yes -> force a quoted text and try again
			UniString sQuoted(_rStatement);
			if	(	sQuoted.Len()
				&&	(	(sQuoted.GetChar(0) != '\'')
					||	(sQuoted.GetChar(sQuoted.Len() -1) != '\'')
					)
				)
			{
				sQuoted.SearchAndReplaceAll('\'', String::CreateFromAscii("''"));
				UniString sTemp('\'');
				(sTemp += sQuoted) += '\'';
				sQuoted = sTemp;
			}
			pReturn = m_pParser->PredicateTree(aErr, sQuoted, m_xFormatter, Application::GetAppInternational(), _rxField);
			_rErrorMessage = aErr;
		}
	}
	return pReturn;
}

//------------------------------------------------------------------------------
IMPL_LINK(FmEnterParamDlg, OnValueLoseFocus, Control*, pSource)
{
	if (m_nCurrentlySelected != LISTBOX_ENTRY_NOTFOUND)
	{
		if (((*(ByteVector*)m_pVisitedParams)[m_nCurrentlySelected] & EF_DIRTY) == 0)
			// nothing to do, the value isn't dirty
			return 0L;
	}

	DBG_ASSERT(pSource == &m_aParam, "FmEnterParamDlg::OnValueLoseFocus : invalid source !");

	// transform the current string according to the param field type
	XubString sTransformedText(m_aParam.GetText());
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xParamAsSet(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)m_xParams->getByIndex(m_nCurrentlySelected).getValue(), ::com::sun::star::uno::UNO_QUERY);
	if (xParamAsSet.is())
	{
		if (m_xConnection.is() && m_xFormatter.is() && m_pParser)
		{
			UniString sError;
			SdbSqlParseNode* pParseNode = implPredicateTree(sError, sTransformedText, xParamAsSet);
			if (pParseNode)
			{
				sTransformedText.Erase();
				pParseNode->ParseNodeToPredicateStr(sTransformedText, m_xConnection->getMetaData(), m_xFormatter, Application::GetAppInternational(), xParamAsSet);
				m_aParam.SetText(sTransformedText);
				delete pParseNode;

				// with this the value isn't dirty anymore
				if (m_nCurrentlySelected != LISTBOX_ENTRY_NOTFOUND)
					(*(ByteVector*)m_pVisitedParams)[m_nCurrentlySelected] &= ~EF_DIRTY;
			}
			else
			{
				if (!m_bNeedErrorOnCurrent)
					return 1L;

				m_bNeedErrorOnCurrent = sal_False;	// will be reset in OnValueModified

				::rtl::OUString sName;
				try 
				{ 
					sName = ::utl::getString(xParamAsSet->getPropertyValue(FM_PROP_NAME)); 
				} 
				catch(...) 
				{ 
				} 
				UniString sMessage(SVX_RES(RID_ERR_COULD_NOT_CONVERT_PARAM));
				sMessage.SearchAndReplaceAll(String::CreateFromAscii("$name$"), sName.getStr());
				ErrorBox(NULL, WB_OK, sMessage).Execute();
				m_aParam.GrabFocus();
				return 1L;
			}
		}
	}

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(FmEnterParamDlg, OnButtonClicked, PushButton*, pButton)
{
	if (&m_aCancelBtn == pButton)
	{
		// no interpreting of the given values anymore ....
		m_aParam.SetLoseFocusHdl(Link());	// no direct call from the control anymore ...
		m_bNeedErrorOnCurrent = sal_False;		// in case of any indirect calls -> no error message
		m_aCancelBtn.SetClickHdl(Link());
		m_aCancelBtn.Click();
	}
	else if (&m_aOKBtn == pButton)
	{
		// transfer the current values into the ::com::sun::star::uno::Any
		if (LINK(this, FmEnterParamDlg, OnEntrySelected).Call(&m_aAllParams) != 0L)
		{	// there was an error interpreting the current text
			m_bNeedErrorOnCurrent = sal_True;
				// we're are out of the complex web :) of direct and indirect calls to OnValueLoseFocus now,
				// so the next time it is called we need an error message, again ....
				// (TODO : there surely are better solutions for this ...)
			return 1L;
		}

		if (m_xParams.is())
		{
			// write the parameters
			try
			{
				::com::sun::star::uno::Any aParamValue;
				UniString sValue,sError;;
				International aAppInternational = Application::GetAppInternational();
				for (sal_Int32 i = 0, nCount = m_xParams->getCount(); i<nCount; ++i)
				{
					::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xParamAsSet(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)m_xParams->getByIndex(i).getValue(), ::com::sun::star::uno::UNO_QUERY);
					aParamValue = *(::com::sun::star::uno::Any*)m_aAllParams.GetEntryData(i);

					if (m_xConnection.is() && m_xFormatter.is() && m_pParser)
					{
						sValue = ::utl::getString(aParamValue).getStr();
						// a little problem : if the field was a text field the OnValueLoseFocus added two
						// '-characters to the text. If we would give this to PredicateTree this would add
						// two  additional '-characters which we don't want. So check the field format.
						// FS - 06.01.00 - 71532
						sal_Bool bValidQuotedText = (sValue.Len() >= 2) && (sValue.GetChar(0) == '\'') && (sValue.GetChar(sValue.Len() - 1) == '\'');
							// again : as OnValueLoseFocus always did a conversion on the value text, bValidQuotedText == sal_True
							// implies that we have a text field, as no other field values will be formatted with
							// the quote characters
						if (bValidQuotedText)
							sValue = sValue.Copy(1, sValue.Len() - 2);

						sError.Erase();
						SdbSqlParseNode* pParseNode = implPredicateTree(sError, sValue, xParamAsSet);
						if (pParseNode)
						{
							SdbSqlParseNode* pNearlyPure = pParseNode->FindRule(SdbSqlParseNode::odbc_fct_spec);
							if (pNearlyPure)
							{
								if ((pNearlyPure->Count() >= 2) && (SDB_SQL_STRING == pNearlyPure->GetChild(1)->GetNodeType()))
									aParamValue <<= ::rtl::OUString(pNearlyPure->GetChild(1)->TokenValue());
							}
							else if ((pParseNode->Count() >= 3) && (SDB_SQL_STRING == pParseNode->GetChild(2)->GetNodeType()))
								aParamValue <<= ::rtl::OUString(pParseNode->GetChild(2)->TokenValue());

							delete pParseNode;
						}
					}

					xParamAsSet->setPropertyValue(FM_PROP_VALUE, aParamValue);
				}
			}
			catch(...)
			{
			}
			
		}
		// to close the dialog (which is more code than a simple EndDialog)
		m_aOKBtn.SetClickHdl(Link());
		m_aOKBtn.Click();
	}
	else if (&m_aTravelNext == pButton)
	{
		sal_uInt16 nCurrent = m_aAllParams.GetSelectEntryPos();
		sal_uInt16 nCount = m_aAllParams.GetEntryCount();
		DBG_ASSERT(nCount == ((ByteVector*)m_pVisitedParams)->size(), "FmEnterParamDlg::OnButtonClicked : inconsistent lists !");

		// search the next entry in list we haven't visited yet
		sal_uInt16 nNext = (nCurrent + 1) % nCount;
		while ((nNext != nCurrent) && ( (*((ByteVector*)m_pVisitedParams))[nNext] & EF_VISITED ))
			nNext = (nNext + 1) % nCount;

		if ( (*((ByteVector*)m_pVisitedParams))[nNext] & EF_VISITED )
			// there is no such "not visited yet" entry -> simpy take the next one
			nNext = (nCurrent + 1) % nCount;

		m_aAllParams.SelectEntryPos(nNext);
		LINK(this, FmEnterParamDlg, OnEntrySelected).Call(&m_aAllParams);
		m_bNeedErrorOnCurrent = sal_True;
			// we're are out of the complex web :) of direct and indirect calls to OnValueLoseFocus now,
			// so the next time it is called we need an error message, again ....
			// (TODO : there surely are better solutions for this ...)
	}

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(FmEnterParamDlg, OnEntrySelected, ListBox*, pList)
{
	if (m_aResetVisitFlag.IsActive())
	{
		LINK(this, FmEnterParamDlg, OnVisitedTimeout).Call(&m_aResetVisitFlag);
		m_aResetVisitFlag.Stop();
	}
	// save the old values
	if (m_nCurrentlySelected != LISTBOX_ENTRY_NOTFOUND)
	{
		// do the transformation of the current text
		if (LINK(this, FmEnterParamDlg, OnValueLoseFocus).Call(&m_aParam) != 0L)
		{	// there was an error interpreting the text
			m_aAllParams.SelectEntryPos(m_nCurrentlySelected);
			return 1L;
		}

		::com::sun::star::uno::Any* pOld = (::com::sun::star::uno::Any*)m_aAllParams.GetEntryData(m_nCurrentlySelected);
		(*pOld) <<= ::rtl::OUString(m_aParam.GetText());
	}

	// initialize the controls with the new values
	sal_uInt16 nSelected = m_aAllParams.GetSelectEntryPos();
	DBG_ASSERT(nSelected != LISTBOX_ENTRY_NOTFOUND, "FmEnterParamDlg::OnEntrySelected : no current entry !");
	::com::sun::star::uno::Any* pNew = (::com::sun::star::uno::Any*)m_aAllParams.GetEntryData(nSelected);
	m_aParam.SetText(::utl::getString(*pNew));
	m_nCurrentlySelected = nSelected;

	// with this the value isn't dirty
	DBG_ASSERT(m_nCurrentlySelected < ((ByteVector*)m_pVisitedParams)->size(), "FmEnterParamDlg::OnEntrySelected : invalid current entry !");
	(*(ByteVector*)m_pVisitedParams)[m_nCurrentlySelected] &= ~EF_DIRTY;

	m_aResetVisitFlag.SetTimeout(1000);
	m_aResetVisitFlag.Start();

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(FmEnterParamDlg, OnVisitedTimeout, Timer*, pTimer)
{
	DBG_ASSERT(m_nCurrentlySelected != LISTBOX_ENTRY_NOTFOUND, "FmEnterParamDlg::OnVisitedTimeout : invalid call !");

	// mark the currently selected entry as visited
	DBG_ASSERT(m_nCurrentlySelected < ((ByteVector*)m_pVisitedParams)->size(), "FmEnterParamDlg::OnVisitedTimeout : invalid entry !");
	(*(ByteVector*)m_pVisitedParams)[m_nCurrentlySelected] |= EF_VISITED;

	// was it the last "not visited yet" entry ?
	ConstByteVectorIterator aIter;
	for	(	aIter = ((ByteVector*)m_pVisitedParams)->begin();
			aIter < ((ByteVector*)m_pVisitedParams)->end();
			++aIter
		)
	{
		if (((*aIter) & EF_VISITED) == 0)
			break;
	}
	if (aIter == ((ByteVector*)m_pVisitedParams)->end())
	{	// yes, there isn't another one -> change the "default button"
		m_aTravelNext.SetStyle(m_aTravelNext.GetStyle() & ~WB_DEFBUTTON);
		m_aOKBtn.SetStyle(m_aOKBtn.GetStyle() | WB_DEFBUTTON);
		
		// set to focus to one of the buttons temporary (with this their "default"-state is really updated)
		Window* pOldFocus = Application::GetFocusWindow();

		// if the old focus window is the value edit do some preparations ...
		Selection aSel;
		if (pOldFocus == &m_aParam)
		{
			m_aParam.SetLoseFocusHdl(Link());
			aSel = m_aParam.GetSelection();
		}
		m_aTravelNext.GrabFocus();
		if (pOldFocus)
			pOldFocus->GrabFocus();

		// restore the settings for the value edit
		if (pOldFocus == &m_aParam)
		{
			m_aParam.SetLoseFocusHdl(LINK(this, FmEnterParamDlg, OnValueLoseFocus));
			m_aParam.SetSelection(aSel);
		}
	}

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(FmEnterParamDlg, OnValueModified, Control*, pBox)
{
	// mark the currently selected entry as dirty
	DBG_ASSERT(m_nCurrentlySelected < ((ByteVector*)m_pVisitedParams)->size(), "FmEnterParamDlg::OnValueModified : invalid entry !");
	(*(ByteVector*)m_pVisitedParams)[m_nCurrentlySelected] |= EF_DIRTY;

	m_bNeedErrorOnCurrent = sal_True;

	return 0L;
}

