/*************************************************************************
 *
 *  $RCSfile: galcmp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _GALCMP_HXX
#define _GALCMP_HXX

#include <tools/debug.hxx>
#include <tools/urlobj.hxx>
#include <tools/fsys.hxx>
#include <vcl/bitmap.hxx>

#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE3_HXX_
#include <cppuhelper/implbase3.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE4_HXX_
#include <cppuhelper/implbase4.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP
#include <com/sun/star/awt/XBitmap.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XPROGRESSMONITOR_HPP
#include <com/sun/star/awt/XProgressMonitor.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_MENUDESCRIPTOR_HPP
#include <com/sun/star/chaos/MenuDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_MENUITEMDESCRIPTOR_HPP
#include <com/sun/star/chaos/MenuItemDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XURLCONTENT_HPP
#include <com/sun/star/chaos/XURLContent.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XCOMMANDEXECUTOR_HPP
#include <com/sun/star/chaos/XCommandExecutor.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP
#include <com/sun/star/frame/XController.hpp>
#endif

// -----------
// - Defines -
// -----------

#define NMSP_AWT			::com::sun::star::awt
#define NMSP_REGISTRY		::com::sun::star::registry
#define NMSP_LANG			::com::sun::star::lang
#define NMSP_UNO			::com::sun::star::uno
#define NMSP_BEANS			::com::sun::star::beans
#define NMSP_CHAOS			::com::sun::star::chaos
#define NMSP_FRAME			::com::sun::star::frame

#define REF( _def_Type )	NMSP_UNO::Reference< _def_Type >
#define SEQ( _def_Type )	NMSP_UNO::Sequence< _def_Type >
#define OUSTRING			::rtl::OUString
#define	ANY					NMSP_UNO::Any 

// --------------------
// - Global functions -
// --------------------

void LoadGallery();
void UnloadGallery();

// ------------------
// - GalPropertyMap -
// ------------------

class Reflection;

struct GalPropertyMap
{
	const char* 	pName;
	USHORT			nId;
	Reflection* 	(*pGetReflection)();
	long			nFlags;
	BYTE			nMemberId;
};

// ----------------------
// - GalPropertySetInfo	-
// ----------------------

class GalPropertySetInfo : public ::cppu::WeakImplHelper1< NMSP_BEANS::XPropertySetInfo >
{
	const GalPropertyMap*							mpMap;

public:

													GalPropertySetInfo( const GalPropertyMap* pMap );

    virtual SEQ( NMSP_BEANS::Property ) SAL_CALL	getProperties( ) throw( NMSP_UNO::RuntimeException );
    virtual NMSP_BEANS::Property SAL_CALL			getPropertyByName( const OUSTRING& rName ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_UNO::RuntimeException );
    virtual sal_Bool SAL_CALL						hasPropertyByName( const OUSTRING& rName ) throw( NMSP_UNO::RuntimeException );
};

// ----------------
// - GalComponent -
// ----------------

struct ExchangeData;

class GalComponent : public ::cppu::WeakImplHelper3< NMSP_CHAOS::XURLContent,
													 NMSP_CHAOS::XCommandExecutor,
													 NMSP_BEANS::XPropertySet > 
{
	OUSTRING							maUrl;
	OUSTRING							maName;
	::osl::Mutex						maMutex;
	::cppu::OInterfaceContainerHelper	maListeners;
	DirEntry							maGalConfigPath;
	ExchangeData*						mpData;

	void								ImplCreatePopupMenu( ANY& rAny ) const;
										
	void								ImplHandleOpenEvt( const REF( NMSP_CHAOS::XStatusCallback )& rxJob,
														   const NMSP_CHAOS::StatusCallbackEvent& rEvt );
										
	void								ImplHandleNewEvt( const REF( NMSP_CHAOS::XStatusCallback )& rxJob,
														  const NMSP_CHAOS::StatusCallbackEvent& rEvt );
										
	void								ImplHandleImportEvt( const REF( NMSP_CHAOS::XStatusCallback )& rxJob,
															 const NMSP_CHAOS::StatusCallbackEvent& rEvt );
										
public:

										GalComponent();
										~GalComponent();

    // interface XChild
	virtual REF( NMSP_UNO::XInterface ) SAL_CALL getParent() throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				setParent( const REF( NMSP_UNO::XInterface )& rxParent ) throw( NMSP_LANG::NoSupportException, NMSP_UNO::RuntimeException );

	// interface XURLContent
    virtual OUSTRING SAL_CALL			getURL() throw( NMSP_UNO::RuntimeException);
    virtual sal_Bool SAL_CALL			initialize( const REF( NMSP_CHAOS::XURLContent )& rxParent, const OUSTRING& rURL ) throw( NMSP_UNO::RuntimeException );

	// interface XCommandExecutor
    virtual SEQ( OUSTRING ) SAL_CALL	queryCommands() throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				execute( const OUSTRING& rCommand, const ANY& rArg, const REF( NMSP_CHAOS::XStatusCallback )& rxCallback ) throw( NMSP_CHAOS::UnknownCommandException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				cancel( const REF( NMSP_UNO::XInterface )& rxCommandId ) throw( NMSP_UNO::RuntimeException );

	// interface  XPropertySet
    virtual REF( NMSP_BEANS::XPropertySetInfo ) SAL_CALL getPropertySetInfo() throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				setPropertyValue( const OUSTRING& rPropertyName, const ANY& rValue ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual ANY SAL_CALL				getPropertyValue( const OUSTRING& rPropertyName ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				addPropertyChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XPropertyChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				removePropertyChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XPropertyChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				addVetoableChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XVetoableChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				removeVetoableChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XVetoableChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);

public:

	void								SetTitle( const String& rName ) { maName = rName; }
	String								GetTitle() const { return maName; }
	void								Load( BOOL bAdjustViews );
	void								Initialize( const DirEntry& rInitPath );
	void								Save();
	void								EditProperties();
	void								LoadGallery();
	void								CreateChilds( BOOL bAdjustViews );
	String								InsertUniqueTheme();
	BOOL								CheckImportFile( const String& rFileName, String& rThemeName );
	BOOL								InsertImportFile( const String& rFileName, String& rThemeName );
	BOOL								TitleEdited( const String& rNewTitle );
	ExchangeData*						GetData();
};

// -----------------------
// - GalThemePropertyMap -
// -----------------------

struct GalThemePropertyMap
{
	const char* 	pName;
	USHORT			nId;
	Reflection* 	(*pGetReflection)();
	long			nFlags;
	BYTE			nMemberId;
};

// ---------------------------
// - GalThemePropertySetInfo -
// ---------------------------

class GalThemePropertySetInfo : public ::cppu::WeakImplHelper1< NMSP_BEANS::XPropertySetInfo >
{
	const GalThemePropertyMap*						mpMap;

public:

													GalThemePropertySetInfo( const GalThemePropertyMap* pMap );

    virtual SEQ( NMSP_BEANS::Property ) SAL_CALL	getProperties( ) throw( NMSP_UNO::RuntimeException );
    virtual NMSP_BEANS::Property SAL_CALL			getPropertyByName( const OUSTRING& rName ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_UNO::RuntimeException );
    virtual sal_Bool SAL_CALL						hasPropertyByName( const OUSTRING& rName ) throw( NMSP_UNO::RuntimeException );
};

// ---------------------
// - GalThemeComponent -
// ---------------------

class SgaGallery;
class SgaTheme;

class GalThemeComponent : public ::cppu::WeakImplHelper4< NMSP_CHAOS::XURLContent,
														  NMSP_CHAOS::XCommandExecutor,
														  NMSP_BEANS::XPropertySet,
														  NMSP_AWT::XBitmap > 
{
	Bitmap								maBitmap;
	OUSTRING							maUrl;
	OUSTRING							maName;
	::osl::Mutex						maMutex;
	::cppu::OInterfaceContainerHelper	maListeners;
	SgaGallery*							mpGal;
	BOOL								mbReadOnly;
	BOOL								mbImported;
	BOOL								mbDefault;

	void								ImplCreatePopupMenu( ANY& rAny ) const;
	void								ImplSetBitmap( ANY& rAny, BOOL bBig );

	void								ImplHandleOpenEvt( const REF( NMSP_CHAOS::XStatusCallback )& rxJob,
														   const NMSP_CHAOS::StatusCallbackEvent& rxEvt );

	void								ImplHandleRemoveEvt();

	SgaTheme*							ImplSelect( String& rOldTheme );
	void								ImplReSelect( const String& rOldTheme );

public:

										GalThemeComponent();
										~GalThemeComponent();

    // interface XChild
	virtual REF( NMSP_UNO::XInterface ) SAL_CALL getParent() throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				setParent( const REF( NMSP_UNO::XInterface )& rxParent ) throw( NMSP_LANG::NoSupportException, NMSP_UNO::RuntimeException );

	// interface  XURLContent
    virtual OUSTRING SAL_CALL			getURL() throw( NMSP_UNO::RuntimeException);
    virtual sal_Bool SAL_CALL			initialize( const REF( NMSP_CHAOS::XURLContent )& rxParent, const OUSTRING& rURL ) throw( NMSP_UNO::RuntimeException );

	// interface  XCommandExecutor
    virtual SEQ( OUSTRING ) SAL_CALL	queryCommands() throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				execute( const OUSTRING& rCommand, const ANY& rArg, const REF( NMSP_CHAOS::XStatusCallback )& rxCallback ) throw( NMSP_CHAOS::UnknownCommandException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				cancel( const REF( NMSP_UNO::XInterface )& rxCommandId ) throw( NMSP_UNO::RuntimeException );

	// interface  XPropertySet
    virtual REF( NMSP_BEANS::XPropertySetInfo ) SAL_CALL getPropertySetInfo() throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL				setPropertyValue( const OUSTRING& rPropertyName, const ANY& rValue ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual ANY SAL_CALL				getPropertyValue( const OUSTRING& PropertyName ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				addPropertyChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XPropertyChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				removePropertyChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XPropertyChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				addVetoableChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XVetoableChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);
    virtual void SAL_CALL				removeVetoableChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XVetoableChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException);

	// interface XBitmap
    virtual NMSP_AWT::Size SAL_CALL		getSize() throw( NMSP_UNO::RuntimeException );
    virtual SEQ( sal_Int8 ) SAL_CALL	getDIB() throw( NMSP_UNO::RuntimeException );
    virtual SEQ( sal_Int8 ) SAL_CALL	getMaskDIB() throw( NMSP_UNO::RuntimeException );

public:

	virtual BOOL						TitleEdited( const String& rNewTitle );

	void								SetTitle( const String& rName ) { maName = rName; }
	String								GetTitle() const { return maName; }

	void								Actualize();
	void								AssignId();
	void								EditProperties();
};

// ------------------------
// - GalleryContentLoader -
// ------------------------

class SvxGallery;

class GalleryContentLoader : public ::cppu::WeakImplHelper2< NMSP_LANG::XServiceInfo,
															 NMSP_FRAME::XFrameLoader >
{
private:

	REF( NMSP_FRAME::XLoadEventListener )	mxListener;
	OUSTRING								maURL;
	SvxGallery*								mpWin;
	REF( NMSP_FRAME::XFrame )				mxFrame;

public:

	static OUSTRING							getImplementationName_Static() throw( NMSP_UNO::RuntimeException );
	static SEQ( OUSTRING )					getSupportedServiceNames_Static() throw( NMSP_UNO::RuntimeException );

public:
											
											GalleryContentLoader();
											~GalleryContentLoader();

	// XServiceInfo
    virtual OUSTRING SAL_CALL				getImplementationName() throw( NMSP_UNO::RuntimeException );
    virtual sal_Bool SAL_CALL				supportsService( const OUSTRING& rServiceName ) throw( NMSP_UNO::RuntimeException );
    virtual SEQ( OUSTRING )	SAL_CALL		getSupportedServiceNames() throw( NMSP_UNO::RuntimeException );

	// XFrameLoader
    virtual void SAL_CALL					load( const REF( NMSP_FRAME::XFrame )& rxFrame, const OUSTRING& rURL, 
												  const SEQ( NMSP_BEANS::PropertyValue )& rArgs, 
												  const REF( NMSP_FRAME::XLoadEventListener )& rxListener ) throw( NMSP_UNO::RuntimeException );
    virtual void SAL_CALL					cancel() throw( NMSP_UNO::RuntimeException );
};

#endif
