/*************************************************************************
 *
 *  $RCSfile: galcmp2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "galcmp.hxx"
#include "gallery1.hxx"
#include "gallery2.hxx"
#include "gallery.hrc"
#include "gallery.hrc"

#include <vos/mutex.hxx>
#include <vcl/msgbox.hxx>
#include <svtools/cntcmpmn.hxx>
#include <sfx2/inimgr.hxx>

// -----------
// - Defines -
// -----------

#define GALTHEME_PROP_ANZ		12

#define CMP_BIG_IMAGE			1
#define CMP_CONTENT_TYPE		2
#define	CMP_HAS_FOLDER			3
#define CMP_MASK_COLOR			4
#define CMP_MENU				5
#define CMP_OWN_URL				6
#define CMP_RENAME				7
#define CMP_SMALL_IMAGE			8
#define CMP_SORTING				9
#define CMP_TARGETS				10
#define CMP_TITLE				11
#define CMP_VIEWDESCRIPTION		12

// -----------
// - statics -
// -----------

extern SgaGallery*	pGlobalGal;
extern List*		pThemeCmpList;

const GalThemePropertyMap pGalThemeMap_Impl[] =
{
	{ "BigImage", CMP_BIG_IMAGE, NULL, 2, 0 /*!!!UNO3 &XBitmap_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "ContentType", CMP_CONTENT_TYPE, NULL, 2, 0 /*!!!UNO3 &OUString_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "HasFolder", CMP_HAS_FOLDER, NULL, 2, 0 /*!!!UNO3 &BOOL_getReflection,	PropertyAttribute_BOUND, 0 */ },
	{ "MaskColor", CMP_MASK_COLOR, NULL, 2, 0 /*!!!UNO3 &INT32_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "OwnURL", CMP_OWN_URL, NULL, 2, 0 /*!!!UNO3 &OUString_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "PopupMenu", CMP_MENU, NULL, 2, 0 /*!!!UNO3 &MenuDescriptor_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "Rename", CMP_RENAME, NULL, 2, 0 /*!!!UNO3 &OUString_getReflection,	PropertyAttribute_BOUND, 0 */ },
	{ "SmallImage", CMP_SMALL_IMAGE, NULL, 2, 0 /*!!!UNO3 &XBitmap_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "Sorting", CMP_SORTING, NULL, 2, 0 /*!!!UNO3 &SortingInfo_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "TargetFrames", CMP_TARGETS, NULL, 2, 0 /*!!!UNO3 &OUString_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "Title", CMP_TITLE, NULL, 2, 0 /*!!!UNO3 &OUString_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ "ViewDescription", CMP_VIEWDESCRIPTION, NULL, 2, 0 /*!!!UNO3 &OUString_getReflection, PropertyAttribute_BOUND, 0 */ },
	{ 0, 0 }
};

// ----------------
// - GalleryIdDlg -
// ----------------

class GalleryIdDlg : public ModalDialog
{
private:

	OKButton		aBtnOk;
	CancelButton	aBtnCancel;
	GroupBox		aGrpId;
	ListBox			aLbResName;
	SgaTheme*		pThm;

					DECL_LINK( ClickOkHdl, void* );
					DECL_LINK( ClickResNameHdl, void* );

public:

					GalleryIdDlg( Window* pParent, SgaTheme* pThm );
					~GalleryIdDlg() {}

	ULONG			GetId() const { return aLbResName.GetSelectEntryPos(); }
};

// -----------------------------------------------------------------------------

GalleryIdDlg::GalleryIdDlg( Window* pParent, SgaTheme* _pThm ) :
			ModalDialog	( pParent, GAL_RESID( RID_SVXDLG_GALLERY_THEMEID ) ),
			aBtnOk		( this, GAL_RESID( BTN_OK ) ),
			aBtnCancel	( this, GAL_RESID( BTN_CANCEL ) ),
			aGrpId		( this, GAL_RESID( GRP_ID ) ),
			aLbResName	( this, GAL_RESID( LB_RESNAME ) ),
			pThm		( _pThm )
{
	FreeResource();

	aLbResName.InsertEntry( String( RTL_CONSTASCII_USTRINGPARAM( "!!! No Id !!!" ) ) );

	for( USHORT i = RID_GALLERYSTR_THEME_FIRST; i <= RID_GALLERYSTR_THEME_LAST; i++ )
		aLbResName.InsertEntry( String( GAL_RESID( i ) ) );

	aLbResName.SelectEntryPos( pThm->GetId() );
	aLbResName.GrabFocus();

	aBtnOk.SetClickHdl( LINK( this, GalleryIdDlg, ClickOkHdl ) );
}

// -----------------------------------------------------------------------------

IMPL_LINK( GalleryIdDlg, ClickOkHdl, void*, p )
{
	SgaThemeFile* pEntry = pThm->GetGallery()->GetEntry( GetId() );

	if( pEntry && ( pEntry->GetThemeName() != pThm->GetName() ) )
	{
		String aStr( GAL_RESID( RID_SVXSTR_GALLERY_ID_EXISTS ) );

		aStr += String( RTL_CONSTASCII_USTRINGPARAM( " (" ) );
		aStr += pEntry->GetThemeName();
		aStr += ')';

		InfoBox aBox( this, aStr );
		aBox.Execute();
		aLbResName.GrabFocus();
	}
	else
		EndDialog( RET_OK );

	return 0L;
}

// --------------------------
// - GalleryThemeProperties -
// --------------------------

GalleryThemeProperties::GalleryThemeProperties( Window* pParent, ExchangeData* _pData, SfxItemSet* pItemSet  ) :
			SfxTabDialog    ( pParent, GAL_RESID( RID_SVXTABDLG_GALLERYTHEME ), pItemSet ),
			pData			( _pData )
{
	FreeResource();
	AddTabPage( RID_SVXTABPAGE_GALLERY_GENERAL, TPGalleryThemeGeneral::Create, 0 );
	AddTabPage( RID_SVXTABPAGE_GALLERYTHEME_FILES, SgaClipBrowser::Create, 0 );

	if( pData->bThemeReadOnly )
		RemoveTabPage( RID_SVXTABPAGE_GALLERYTHEME_FILES );

	String aText( GetText() );

	aText += pData->aThemeTitle;

	if( pData->pGal->GetActualTheme()->IsReadOnly() )
		aText += String( GAL_RESID( RID_SVXSTR_GALLERY_READONLY ) );

	SetText( aText );
}

// ------------------------------------------------------------------------

void GalleryThemeProperties::PageCreated( USHORT nId, SfxTabPage &rPage )
{
	if( RID_SVXTABPAGE_GALLERY_GENERAL == nId )
		( (TPGalleryThemeGeneral&) rPage ).SetXChgData( pData );
	else
		( (SgaClipBrowser&) rPage ).SetGalleries( pData->pGal, (SvxGallery*) GetParent() );
}

// -------------------------
// - TPGalleryThemeGeneral -
// -------------------------

TPGalleryThemeGeneral::TPGalleryThemeGeneral( Window* pParent, const SfxItemSet& rSet ) :
		TPGalleryGeneral( pParent, rSet )
{
}

// ------------------------------------------------------------------------

BOOL TPGalleryThemeGeneral::FillItemSet( SfxItemSet& rSet )
{
	pData->aThemeTitle = aEdtMSName.GetText();
	return TRUE;
}

// ------------------------------------------------------------------------

void TPGalleryThemeGeneral::InitControls()
{
	const International aInternational( Application::GetAppInternational() );
	SgaTheme*			pThm = pData->pGal->GetActualTheme();
	DirEntry            aFile( pThm->GetSdgPath() );
	String              aOutStr( pData->nObjCount );
	String              aObjStr( GAL_RESID( RID_SVXSTR_GALLERYPROPS_OBJECT ) );
	String              aAccess;
	String				aType( GAL_RESID( RID_SVXSTR_GALLERYPROPS_GALTHEME ) );
	BOOL				bReadOnly = pThm->IsReadOnly() && !pThm->IsImported();

	aEdtMSName.SetText( pData->aThemeTitle );
	aEdtMSName.SetReadOnly( bReadOnly );

	if( bReadOnly )
		aEdtMSName.Disable();
	else
		aEdtMSName.Enable();
		
	if( pThm->IsReadOnly() )
		aType += String( GAL_RESID( RID_SVXSTR_GALLERY_READONLY ) );
	
	aFtMSShowType.SetText( aType );
	aFtMSShowPath.SetText( aFile.GetFull() );

	// Ein- oder Mehrzahl?
	if ( 1 == pData->nObjCount )
		aObjStr = aObjStr.GetToken( 0 );
	else
		aObjStr = aObjStr.GetToken( 1 );

	aOutStr += ' ';
	aOutStr += aObjStr;

	aFtMSShowContent.SetText( aOutStr );

	// CreateDate/Time
	aAccess = aInternational.GetDate( pData->aThemeCreateDate );
	aAccess += String( RTL_CONSTASCII_USTRINGPARAM( ", " ) );
	aAccess += aInternational.GetTime( pData->aThemeCreateTime );
	aFtMSShowCreateDate.SetText( aAccess );

	// ChangeDate/Time
	aAccess = aInternational.GetDate( pData->aThemeChangeDate );
	aAccess += String( RTL_CONSTASCII_USTRINGPARAM( ", " ) );
	aAccess += aInternational.GetTime( pData->aThemeChangeTime );
	aFtMSShowChangeDate.SetText( aAccess );

	// Image setzen
	USHORT nId;

	if( pThm->IsImported() )
		nId = RID_SVXBMP_THEME_IMPORTED_BIG;
	else if( pThm->IsReadOnly() )
		nId = RID_SVXBMP_THEME_READONLY_BIG;
	else if( pThm->IsDefault() )
		nId = RID_SVXBMP_THEME_DEFAULT_BIG;
	else 
		nId = RID_SVXBMP_THEME_NORMAL_BIG;

	aFiMSImage.SetImage( Image( Bitmap( GAL_RESID( nId ) ), COL_LIGHTMAGENTA ) );
}

// ------------------------------------------------------------------------

SfxTabPage* TPGalleryThemeGeneral::Create( Window* pParent, const SfxItemSet& rSet )
{
	return new TPGalleryThemeGeneral( pParent, rSet );
}

// ----------------------
// - GalPropertySetInfo -
// ----------------------

GalThemePropertySetInfo::GalThemePropertySetInfo( const GalThemePropertyMap* pMap ) :
			mpMap( pMap )
{
}

// ------------------------------------------------------------------------

SEQ( NMSP_BEANS::Property ) SAL_CALL GalThemePropertySetInfo::getProperties() throw( NMSP_UNO::RuntimeException )
{
	SEQ( NMSP_BEANS::Property )	aPropSeq( GALTHEME_PROP_ANZ );
	USHORT						n = 0;

	for( const GalThemePropertyMap* pMap = mpMap; pMap->pName; ++pMap, n++ )
	{
		aPropSeq.getArray()[n].Name = OUSTRING::createFromAscii( pMap->pName );
		aPropSeq.getArray()[n].Handle = pMap->nId;
		aPropSeq.getArray()[n].Type = 0; /*!!!UNO3 pMap->pGetReflection()->getIdlClass();*/
		aPropSeq.getArray()[n].Attributes = pMap->nFlags;
	}

	return aPropSeq;
}

// ------------------------------------------------------------------------

NMSP_BEANS::Property SAL_CALL GalThemePropertySetInfo::getPropertyByName( const OUSTRING& rName ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_UNO::RuntimeException )
{
	NMSP_BEANS::Property aProp;

	for( const GalThemePropertyMap* pMap = mpMap; pMap->pName; ++pMap )
	{
		if( rName == OUSTRING::createFromAscii( pMap->pName ) )
		{
			aProp.Name = rName;
			aProp.Handle = pMap->nId;
			aProp.Type = 0; /*!!!UNO3 pMap->pGetReflection()->getIdlClass();*/
			aProp.Attributes = pMap->nFlags;
			break;
		}
	}

	return aProp;
}

// ------------------------------------------------------------------------

sal_Bool SAL_CALL GalThemePropertySetInfo::hasPropertyByName( const OUSTRING& rName ) throw( NMSP_UNO::RuntimeException )
{
	for( const GalThemePropertyMap* pMap = mpMap; pMap->pName; ++pMap )
		if( rName == OUSTRING::createFromAscii( pMap->pName ) )
			return TRUE;

	return FALSE;
}

// ---------------------
// - GalThemeComponent -
// ---------------------

GalThemeComponent::GalThemeComponent() :
		maName		( OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "Theme" ) ) ),
		maListeners	( maMutex ),
		mpGal		( NULL ),
		mbReadOnly	( FALSE ),
		mbImported	( FALSE ),
		mbDefault	( FALSE )
{
	pThemeCmpList->Insert( this );
}

// ------------------------------------------------------------------------

GalThemeComponent::~GalThemeComponent()
{
	if( maListeners.getLength() )
	{
		::com::sun::star::lang::EventObject aEvt;

		aEvt.Source = REF( NMSP_UNO::XInterface )( static_cast< ::cppu::OWeakObject* >( this ) );
		maListeners.disposeAndClear( aEvt );
	}

	pThemeCmpList->Remove( this );
}

// ------------------------------------------------------------------------

REF( NMSP_UNO::XInterface ) SAL_CALL GalThemeComponent::getParent() throw( NMSP_UNO::RuntimeException )
{
	return REF( NMSP_UNO::XInterface )();
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::setParent( const REF( NMSP_UNO::XInterface )& rxParent ) throw( NMSP_LANG::NoSupportException, NMSP_UNO::RuntimeException )
{
}

// ------------------------------------------------------------------------

OUSTRING SAL_CALL GalThemeComponent::getURL() throw( NMSP_UNO::RuntimeException )
{
	return maUrl;
}

// ------------------------------------------------------------------------

sal_Bool SAL_CALL GalThemeComponent::initialize( const REF( NMSP_CHAOS::XURLContent )& rxParent, const OUSTRING& rURL ) throw( NMSP_UNO::RuntimeException )
{
	UniString aThemeName( maUrl = rURL );

	// .component:Gallery/ThemeName.Theme
	// ==> ThemeName.Theme
	// ==> ThemeName
	aThemeName.Erase( 0, aThemeName.GetToken( 0, '/' ).Len() + 1 );
	aThemeName.Erase( aThemeName.Len() - 6 );
	maName = aThemeName;

	if( pGlobalGal )
	{
		mbImported = pGlobalGal->IsThemeImported( aThemeName );
		mbReadOnly = pGlobalGal->IsThemeReadOnly( aThemeName );
		mbDefault  = pGlobalGal->IsThemeDefault( aThemeName );
	}

	return TRUE;
}

// ------------------------------------------------------------------------

SEQ( OUSTRING ) SAL_CALL GalThemeComponent::queryCommands() throw( NMSP_UNO::RuntimeException )
{
	const BOOL			bChangeable = ( !mbReadOnly || mbImported );
	SEQ( OUSTRING )		aSeq( bChangeable ? ( mbDefault ? 5 : 6 ) : 4 );
	OUSTRING*			pArray = aSeq.getArray();
	ULONG				nPos = 0;

	pArray[ nPos++ ] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "initialize" ) );
	pArray[ nPos++ ] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "open" ) );
	pArray[ nPos++ ] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "close" ) );

	if( bChangeable )
	{
		pArray[ nPos++ ] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "rename" ) );

		if( !mbDefault )
			pArray[ nPos++ ] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "delete" ) );
	}

	pArray[ nPos++ ] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "showPropertyDialog" ) );

	return aSeq;
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::execute( const OUSTRING& rCommand, const ANY& rArg, const REF( NMSP_CHAOS::XStatusCallback )& rxCallback ) throw( NMSP_CHAOS::UnknownCommandException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException )
{
	NMSP_CHAOS::StatusCallbackEvent aEvt( REF( NMSP_UNO::XInterface )( static_cast< ::cppu::OWeakObject* >( this ) ), REF( NMSP_UNO::XInterface)(), rCommand, rArg );

	Application::GetSolarMutex().acquire();

	if( rCommand.compareToAscii( "open" ) == COMPARE_EQUAL )
		ImplHandleOpenEvt( rxCallback, aEvt );
	else if( rCommand.compareToAscii( "delete" ) == COMPARE_EQUAL )
		ImplHandleRemoveEvt();
	else if( rCommand.compareToAscii( "ActualizeTheme" ) == COMPARE_EQUAL )
		Actualize();
	else if( rCommand.compareToAscii( "DialogId" ) == COMPARE_EQUAL )
		AssignId();
	else if( rCommand.compareToAscii( "showPropertyDialog" ) == COMPARE_EQUAL )
		EditProperties();

	Application::GetSolarMutex().release();

	rxCallback->done( aEvt );
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::cancel( const REF( NMSP_UNO::XInterface )& rxCommandId ) throw( NMSP_UNO::RuntimeException )
{
}

// ------------------------------------------------------------------------

REF( NMSP_BEANS::XPropertySetInfo ) SAL_CALL GalThemeComponent::getPropertySetInfo() throw( NMSP_UNO::RuntimeException )
{
	const REF( NMSP_UNO::XInterface ) xIf( static_cast< ::cppu::OWeakObject* >( new GalThemePropertySetInfo( pGalThemeMap_Impl ) ) );
	return REF( NMSP_BEANS::XPropertySetInfo )( xIf, NMSP_UNO::UNO_QUERY );
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::setPropertyValue( const OUSTRING& rPropertyName, const ANY& rValue ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException )
{
	for( ULONG i = 0UL; i < GALTHEME_PROP_ANZ; i++ )
	{
		if( rPropertyName == OUSTRING::createFromAscii( pGalThemeMap_Impl[ i ].pName ) )
		{
			switch( pGalThemeMap_Impl[ i ].nId )
			{
				case( CMP_TITLE ):
				{
					String		aOldTheme;
					SgaTheme*	pThm = ImplSelect( aOldTheme );

					if( pThm )
					{
						OUSTRING		aValue; rValue >>= aValue;
						const String	aOldTitle( GetTitle() );
						const String	aNewTitle( aValue );

						if( aNewTitle.Len() && ( aNewTitle != aOldTitle ) )
							TitleEdited( aNewTitle );
					}
				}
				break;

				default:
				break;
			};
		}
	}
}

// ------------------------------------------------------------------------

ANY SAL_CALL GalThemeComponent::getPropertyValue( const OUSTRING& rPropertyName ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException)
{
	Application::GetSolarMutex().acquire();

	ANY aAny;

	for( ULONG i = 0UL; i < GALTHEME_PROP_ANZ; i++ )
	{
		if( rPropertyName == OUSTRING::createFromAscii( pGalThemeMap_Impl[ i ].pName ) )
		{
			switch( pGalThemeMap_Impl[ i ].nId )
			{
				case( CMP_CONTENT_TYPE ):
				{
					if( mbReadOnly )
						aAny <<= OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "component/GalleryTheme;ReadOnly" ) );
					else if( mbImported )
						 aAny <<= OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "component/GalleryTheme;Imported" ) );
					else if( mbDefault )
						 aAny <<= OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "component/GalleryTheme;Default" ) );
					else
						 aAny <<= OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "component/GalleryTheme;Normal" ) );
				}
				break;

				case CMP_SORTING:
				{
					const NMSP_CHAOS::SortingInfo aInfo( OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "Title" ) ), sal_True );
					aAny <<= SEQ( NMSP_CHAOS::SortingInfo )( &aInfo, 1 );
				}
				break;

				case( CMP_SMALL_IMAGE ):
				case( CMP_BIG_IMAGE ): 
				{
					ImplSetBitmap( aAny, CMP_BIG_IMAGE == pGalThemeMap_Impl[ i ].nId );
					aAny <<= REF( NMSP_AWT::XBitmap )( static_cast< ::cppu::OWeakObject* >( this ), NMSP_UNO::UNO_QUERY );
				}
				break;

				case( CMP_HAS_FOLDER ): aAny <<= (sal_Bool) sal_False; break;
				case( CMP_MASK_COLOR ): aAny <<= (sal_Int32) 0x00ff00ff; break;
				case( CMP_MENU ): ImplCreatePopupMenu( aAny ); break;
				case( CMP_OWN_URL ): aAny <<= maUrl; break;
				case( CMP_RENAME ): aAny <<= OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "Title" ) ); break;
				case( CMP_TARGETS ): aAny <<= OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "_beamer;_beamer;_beamer" ) ); break;
				case( CMP_TITLE ): aAny <<= maName; break;
				case( CMP_VIEWDESCRIPTION ): break;
			};

			break;
		}
	}

	Application::GetSolarMutex().release();

	return aAny;
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::addPropertyChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XPropertyChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException )
{
	maListeners.addInterface( rxListener );
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::removePropertyChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XPropertyChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException )
{
	maListeners.removeInterface( rxListener );
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::addVetoableChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XVetoableChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException )
{
}

// ------------------------------------------------------------------------

void SAL_CALL GalThemeComponent::removeVetoableChangeListener( const OUSTRING& rPropertyName, const REF( NMSP_BEANS::XVetoableChangeListener )& rxListener ) throw( NMSP_BEANS::UnknownPropertyException, NMSP_BEANS::PropertyVetoException, NMSP_LANG::IllegalArgumentException, NMSP_LANG::WrappedTargetException, NMSP_UNO::RuntimeException )
{
}

// ------------------------------------------------------------------------

NMSP_AWT::Size SAL_CALL GalThemeComponent::getSize() throw( NMSP_UNO::RuntimeException )
{
	const Size aSize( maBitmap.GetSizePixel() );
	return NMSP_AWT::Size( aSize.Width(), aSize.Height() );
}

// ------------------------------------------------------------------------

SEQ( sal_Int8 ) SAL_CALL GalThemeComponent::getDIB() throw( NMSP_UNO::RuntimeException )
{
	SEQ( sal_Int8 ) aRet;

	if( !!maBitmap )
	{
		SvMemoryStream aMemStm( 65535, 65535 );

		aMemStm << maBitmap;
		aRet = SEQ( sal_Int8 )( (sal_Int8*) aMemStm.GetData(), aMemStm.Tell() );
	}

	return aRet;
}

// ------------------------------------------------------------------------

SEQ( sal_Int8 ) SAL_CALL GalThemeComponent::getMaskDIB() throw( NMSP_UNO::RuntimeException )
{
	return SEQ( sal_Int8 )();
}

// ------------------------------------------------------------------------

void GalThemeComponent::ImplCreatePopupMenu( ANY& rAny ) const
{
	if( !mbReadOnly && !mbImported )
	{
		const BOOL						bIdDlg = SFX_INIMANAGER()->Get( SFX_GROUP_COMMON, String( RTL_CONSTASCII_USTRINGPARAM( "Peet's-Id-Dialog" ) ) ) == String( RTL_CONSTASCII_USTRINGPARAM( "TRUE" ) );
		NMSP_CHAOS::MenuDescriptor		aPopup;
		const ULONG						nMenuCount = bIdDlg ? 5 : 3;
		NMSP_CHAOS::MenuItemDescriptor*	aMenu = new NMSP_CHAOS::MenuItemDescriptor[ nMenuCount ];
		const String					aActStr( GAL_RESID( RID_SVXSTR_GALLERY_ACTUALIZE ) );
		const String					aDlgIdStr( GAL_RESID( RID_SVXSTR_GALLERY_DIALOGID ) );

		aMenu[0].ParentPos = 0;
		aMenu[0].InsertionPos = 0;
		aMenu[0].ItemFlags = CNT_COMPMENU_SEPARATOR;

		aMenu[1].ItemText = aActStr;
		aMenu[1].Command = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "ActualizeTheme" ) );
		aMenu[1].HelpUrl = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "help.ActualizeTheme.url" ) );
		aMenu[1].ParentPos = 0;
		aMenu[1].InsertionPos = 0;
		aMenu[1].ItemFlags = 0;

		aMenu[2].ParentPos = 0;
		aMenu[2].InsertionPos = 0;
		aMenu[2].ItemFlags = CNT_COMPMENU_SEPARATOR;

		if( bIdDlg )
		{
			aMenu[3].ItemText = aDlgIdStr;
			aMenu[3].Command = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "DialogId" ) );
			aMenu[3].HelpUrl = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "help.DialogId.url" ) );
			aMenu[3].ParentPos = 0;
			aMenu[3].InsertionPos = 0;
			aMenu[3].ItemFlags = 0;

			aMenu[4].ParentPos = 0;
			aMenu[4].InsertionPos = 0;
			aMenu[4].ItemFlags = CNT_COMPMENU_SEPARATOR;
		}

		aPopup.Items = SEQ( NMSP_CHAOS::MenuItemDescriptor )( aMenu, nMenuCount );
		rAny <<= aPopup;
		delete aMenu;
	}
}

// ------------------------------------------------------------------------

void GalThemeComponent::ImplSetBitmap( ANY& rAny, BOOL bBig )
{
	ULONG nId;

	if( mbImported )
		nId = bBig ? RID_SVXBMP_THEME_IMPORTED_BIG : RID_SVXBMP_THEME_IMPORTED;
	else if( mbReadOnly )
		nId = bBig ? RID_SVXBMP_THEME_READONLY_BIG : RID_SVXBMP_THEME_READONLY;
	else if( mbDefault )
		nId = bBig ? RID_SVXBMP_THEME_DEFAULT_BIG : RID_SVXBMP_THEME_DEFAULT;
	else
		nId = bBig ? RID_SVXBMP_THEME_NORMAL_BIG : RID_SVXBMP_THEME_NORMAL;

	maBitmap = Bitmap( GAL_RESID( nId ) );
}

// ------------------------------------------------------------------------

void GalThemeComponent::ImplHandleOpenEvt( const REF( NMSP_CHAOS::XStatusCallback )& rxJob, const NMSP_CHAOS::StatusCallbackEvent& rEvt )
{
	String		aOldTheme;
	SgaTheme*	pThm = ImplSelect( aOldTheme );

	if( pThm )
	{
	}
}

// ------------------------------------------------------------------------

void GalThemeComponent::ImplHandleRemoveEvt()
{
	String		aOldTheme;
	SgaTheme*	pThm = ImplSelect( aOldTheme );

	if( pThm )
	{
		mpGal->RemoveTheme( GetTitle() );

		SvxGallery* pView = ( (SvxGallery*) mpGal->GetCurView() );

		if( pView )
			pView->UpdateBrowser( OBJ_POS_FIRST );

		ImplReSelect( aOldTheme );
	}
}

// ------------------------------------------------------------------------

SgaTheme* GalThemeComponent::ImplSelect( String& rOldTheme )
{
	SgaTheme* pTheme = NULL;

	if( pGlobalGal )
	{
		const String	aTitle( GetTitle() );
		SgaTheme*		pActTheme = pGlobalGal->GetActualTheme();

		if( pActTheme && pActTheme->GetName() != aTitle )
			rOldTheme = pActTheme->GetName();

		mpGal = pGlobalGal;
		pTheme = mpGal->GetTheme( aTitle );
	}
	else
		mpGal = NULL;

	return pTheme;
}

// ------------------------------------------------------------------------

void GalThemeComponent::ImplReSelect( const String& rOldTheme )
{
	if( pGlobalGal && rOldTheme.Len() )
		pGlobalGal->GetTheme( rOldTheme );
}

// ------------------------------------------------------------------------

BOOL GalThemeComponent::TitleEdited( const String& rNewTitle )
{
	const String	aOldTitle( GetTitle() );
	BOOL			bRet = FALSE;

	if( rNewTitle != aOldTitle )
	{
		if( mpGal->IsInList( rNewTitle ) || !rNewTitle.Len() )
		{
			// Falls leerer Titel oder doppelter Eintrag
			// wiederholen wir die Eingabe
			if( mpGal->IsInList( rNewTitle ) )
			{
				InfoBox aInfoBox( NULL, String( GAL_RESID( RID_SVXSTR_GALLERY_THEMEERR ) ) );
				aInfoBox.Execute();
			}
		}
		else if( mpGal->RenameTheme( aOldTitle, rNewTitle ) )
		{
			// create new title
			::cppu::OInterfaceIteratorHelper	aIt( maListeners );
			NMSP_BEANS::PropertyChangeEvent		aEvt;

			SetTitle( rNewTitle );

			aEvt.PropertyName = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( "Title" ) );
			aEvt.PropertyHandle = 0;
			aEvt.OldValue <<= OUSTRING( aOldTitle );
			aEvt.NewValue <<= maName;

			while( aIt.hasMoreElements() )
			{
				REF( NMSP_BEANS::XPropertyChangeListener ) xListener( aIt.next(), NMSP_UNO::UNO_QUERY );

				if( xListener.is() )
					xListener->propertyChange( aEvt );
			}

			if( mpGal->GetCurView() )
				( (SvxGallery*) mpGal->GetCurView() )->ThemeRenamed( rNewTitle );

			bRet = TRUE;
		}
	}

	return bRet;
}

// ------------------------------------------------------------------------

void GalThemeComponent::Actualize()
{
	String		aOldTheme;
	SgaTheme*	pThm = ImplSelect( aOldTheme );

	if( pThm && !mbReadOnly && !mbImported )
	{
		ActualizeProgress* pActualizeProgress = new ActualizeProgress( NULL, pThm );

		// Aktualisierung durchfuehren
		if ( pActualizeProgress )
		{
			pActualizeProgress->Update();
			pActualizeProgress->Execute();
			delete pActualizeProgress;
		}

		if( pGlobalGal && pGlobalGal->GetCurView() )
			( (SvxGallery*) pGlobalGal->GetCurView() )->UpdateBrowser( OBJ_POS_FIRST );

		ImplReSelect( aOldTheme );
	}
}

// ------------------------------------------------------------------------

void GalThemeComponent::AssignId()
{
	String		aOldTheme;
	SgaTheme*	pThm = ImplSelect( aOldTheme );

	if( pThm && !mbReadOnly && !mbImported )
	{
		GalleryIdDlg aDlg( NULL, pThm );

		if( aDlg.Execute() == RET_OK )
			pThm->SetId( aDlg.GetId(), TRUE );
	}
}

// ------------------------------------------------------------------------

void GalThemeComponent::EditProperties()
{
	String		aOldTheme;
	SgaTheme*	pThm = ImplSelect( aOldTheme );

	if( pThm )
	{
		ExchangeData*	pData = new ExchangeData;
		const String	aTitle( GetTitle() );
		SfxItemSet		aSet( SFX_APP()->GetPool() );
		DirEntry		aFile( pThm->GetThmPath() );
		const FileStat	aFStat( aFile );

		pData->pGal = mpGal;
		pData->aThemeTitle = aTitle;
		pData->nObjCount = pThm->GetObjCount();
		pData->aThemeCreateDate = aFStat.DateCreated();
		pData->aThemeCreateTime = aFStat.TimeCreated();
		pData->aThemeChangeDate = aFStat.DateModified();
		pData->aThemeChangeTime = aFStat.TimeModified();
		pData->bThemeReadOnly = pThm->IsReadOnly();

		GalleryThemeProperties aThemeProps( NULL, pData, &aSet );
		aThemeProps.Execute();

		if( pData->aThemeTitle.Len() && ( pData->aThemeTitle != aTitle ) )
			TitleEdited( pData->aThemeTitle );

		delete pData;

		if( pGlobalGal && pGlobalGal->GetCurView() )
			( (SvxGallery*) pGlobalGal->GetCurView() )->UpdateBrowser( OBJ_POS_FIRST );

		ImplReSelect( aOldTheme );
	}
}
