/*************************************************************************
 *
 *  $RCSfile: gallery1.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_GALLERY1_HXX_
#define _SVX_GALLERY1_HXX_

#define ENABLE_BYTESTRING_STREAM_OPERATORS

#include <tools/stream.hxx>
#include <tools/fsys.hxx>
#include <tools/new.hxx>
#include <vcl/graph.hxx>
#include <vcl/sound.hxx>
#include <so3/dtrans.hxx>
#include <svtools/imap.hxx>
#include "svdobj.hxx"
#include "svdio.hxx"
#include "svdpage.hxx"
#include "svdograf.hxx"
#include "galtheme.hrc"
#include "galcmp.hxx"

class FmFormModel;
class SvData;
class GraphicFilter;
class SvStream;

// ------------------------------------------------------------------------

enum GalSoundType
{
	SOUND_STANDARD = 0,
	SOUND_COMPUTER = 1,
	SOUND_MISC = 2,
	SOUND_MUSIC = 3,
	SOUND_NATURE = 4,
	SOUND_SPEECH = 5,
	SOUND_TECHNIC = 6,
	SOUND_ANIMAL = 7
};

// ------------------------------------------------------------------------

#define S_THUMB             			80
#define SGAERR_NO_ERROR					0x00000000
#define SGAERR_THEME_NOT_VALID			0x00000001
#define SGAERR_OBJECT_NOT_VALID			0x00000002
#define SGAERR_IMPORTLIST_NOT_VALID		0x00000003

#define	SGA_IMPORT_NONE					0x0000
#define	SGA_IMPORT_FILE					0x0001
#define	SGA_IMPORT_INET					0x0002

#define SGA_FORMAT_NONE					0x00000000L
#define	SGA_FORMAT_STRING				0x00000001L
#define	SGA_FORMAT_GRAPHIC				0x00000010L
#define	SGA_FORMAT_SOUND				0x00000100L
#define	SGA_FORMAT_OLE					0x00001000L
#define	SGA_FORMAT_SVDRAW				0x00010000L
#define SGA_FORMAT_ALL					0xFFFFFFFFL

// ------------------------------------------------------------------------

#define IV_IMAPINFO			(UINT32('S')*0x00000001+UINT32('D')*0x00000100+UINT32('U')*0x00010000+UINT32('D')*0x01000000)
#define	ID_IMAPINFO			2
#define USERDATA_HDL()		(LINK(this,SgaUserDataFactory,MakeUserData))
#define SDR_IMAP_FORMAT_1	"SdrIMapFmt"
#define STREAMBUF_SIZE		16384L

// ------------------------------------------------------------------------

enum SgaObjKind
{
	SGA_OBJ_NONE = 0,	// Abstraktes Objekt
	SGA_OBJ_BMP	= 1,	// Bitmap-Objekt
	SGA_OBJ_SOUND =	2,	// Sound-Objekt
	SGA_OBJ_VIDEO =	3, 	// Video-Objekt
	SGA_OBJ_ANIM = 4,	// Animations-Objekt
	SGA_OBJ_SVDRAW = 5,	// Svdraw-Objekt
	SGA_OBJ_INET = 6	// Grafik aus dem Internet
};

// ------------------------------------------------------------------------

enum SgaBmpDepth
{
	DEPTH_UNKNOWN= 	0,
	DEPTH_1	= 1,
	DEPTH_4	= 3,
	DEPTH_8	= 4,
	DEPTH_24 = 5
};

// ------------------------------------------------------------------------

enum SgaBmpFormat
{
	FORMAT_UNKNOWN = 0,
	FORMAT_BMP = 1
};

// ------------------------------------------------------------------------

USHORT	SGAImport( const String& rFile, Graphic& rGraphic, String& rFilterName,
				   BOOL bShowProgress = FALSE, const USHORT nDepth = 0 );
BOOL	SGASvDrawImport( SvStream& rIStm, FmFormModel& rModel );
BOOL	SGAIsSoundFile( const String& rFile );
BOOL	CreateIMapGraphic( const FmFormModel& rModel, Graphic& rGraphic, ImageMap& rImageMap );
String	ReduceString( const String& rString );

// ------------------------------------------------------------------------

class SgaIMapInfo : public SdrObjUserData, public SfxListener
{
	ImageMap				aImageMap;

public:
							SgaIMapInfo() : SdrObjUserData( IV_IMAPINFO, ID_IMAPINFO, 0 ) {};

							SgaIMapInfo( const ImageMap& rImageMap) :
								SdrObjUserData( IV_IMAPINFO, ID_IMAPINFO, 0 ),
								aImageMap( rImageMap ) {};

	virtual 				~SgaIMapInfo() {};

	virtual SdrObjUserData* Clone( SdrObject* pObj ) const
							{
								SgaIMapInfo* pInfo = new SgaIMapInfo;
								pInfo->aImageMap = aImageMap;
								return pInfo;
							}

	virtual void			ReadData( SvStream& rIStm )
							{
								SdrObjUserData::ReadData( rIStm );
								SdrDownCompat	aIO( rIStm, STREAM_READ, TRUE );
								UINT16			nVer;
								rIStm >> nVer;
								rIStm >> aImageMap;
							}

	virtual void			WriteData( SvStream& rOStm )
							{
								SdrObjUserData::WriteData( rOStm );
								SdrDownCompat	aIO( rOStm, STREAM_WRITE, TRUE );
								const UINT16	nVer = 1;
								rOStm << nVer;
								rOStm << aImageMap;
							}

	const ImageMap&			GetImageMap() const { return aImageMap; }
};

// ------------------------------------------------------------------------

class SgaUserDataFactory
{
public:
		SgaUserDataFactory() { SdrObjFactory::InsertMakeUserDataHdl( USERDATA_HDL() ); }
		~SgaUserDataFactory() { SdrObjFactory::RemoveMakeUserDataHdl( USERDATA_HDL() ); }

		DECL_LINK( MakeUserData, SdrObjFactory* );
};

// ------------------------------------------------------------------------

class SgaObject
{
protected:

	Bitmap				aThumbBmp;
	GDIMetaFile			aThumbMtf;
	String				aPath;
	String				aUserName;
	String				aTitle;
	BOOL				bIsValid;
	BOOL				bIsThumbBmp;

	virtual void 		WriteData( SvStream& rOut ) const;
	virtual void 		ReadData( SvStream& rIn, UINT16& rReadVersion );

	BOOL				CreateThumb( const Bitmap& rBitmap );
	BOOL				CreateThumbMetaFile( const Graphic& rGraphic );

public:

						SgaObject();
	virtual				~SgaObject() {};

	virtual SgaObjKind	GetObjKind() const = 0;
	virtual UINT16		GetVersion() const = 0;

	virtual Bitmap 		GetThumbBmp() const { return aThumbBmp; }
	const GDIMetaFile&	GetThumbMtf() const { return aThumbMtf; }
	const String&		GetPath() const { return aPath; }
	BOOL				IsValid() const { return bIsValid; }
	BOOL				IsThumbBitmap() const { return bIsThumbBmp; }

	const String&		GetTitle() const { return aTitle; }
	void				SetTitle( const String& rTitle ) { aTitle = rTitle; }

	friend SvStream& 	operator<<( SvStream& rOut, const SgaObject& rObj );
	friend SvStream& 	operator>>( SvStream& rIn, SgaObject& rObj );
};

// ------------------------------------------------------------------------

class SgaObjectSound : public SgaObject
{
private:

	GalSoundType		eSoundType;

	virtual void 		WriteData( SvStream& rOut ) const;
	virtual void 		ReadData( SvStream& rIn, UINT16& rReadVersion );

	virtual UINT16		GetVersion() const { return 6; }

public:

						SgaObjectSound();
						SgaObjectSound( const String& rFile );
	virtual 	   	   ~SgaObjectSound();

	virtual SgaObjKind	GetObjKind() const { return SGA_OBJ_SOUND; }
	virtual Bitmap 		GetThumbBmp() const;
	GalSoundType		GetSoundType() const { return eSoundType; }
};

// ------------------------------------------------------------------------

class SgaObjectSvDraw : public SgaObject
{
private:

	BOOL				CreateThumb( FmFormModel& rModel );

	virtual void 		WriteData( SvStream& rOut ) const;
	virtual void 		ReadData( SvStream& rIn, UINT16& rReadVersion );

	virtual UINT16		GetVersion() const { return 5; }

public:

						SgaObjectSvDraw();
						SgaObjectSvDraw( FmFormModel& rModel, const String& rFile );
						SgaObjectSvDraw( SvStream& rIStm, const String& rFile );
	virtual 	   	   ~SgaObjectSvDraw() {};

	virtual SgaObjKind	GetObjKind() const { return SGA_OBJ_SVDRAW; }
};

// ------------------------------------------------------------------------

class SgaObjectBmp: public SgaObject
{
private:

	void				Init( const Graphic& rGraphic, const String& rFile );

	virtual void   		WriteData( SvStream& rOut ) const;
	virtual void   		ReadData( SvStream& rIn, UINT16& rReadVersion );

	virtual UINT16		GetVersion() const { return 5; }

public:

						SgaObjectBmp();
						SgaObjectBmp( const String& rFile );
						SgaObjectBmp( const Graphic& rGraphic, const String& rFile, const String& rFormat );
	virtual				~SgaObjectBmp() {};

	virtual SgaObjKind	GetObjKind() const { return SGA_OBJ_BMP; }
};

// ------------------------------------------------------------------------

class SgaObjectAnim : public SgaObjectBmp
{
private:

						SgaObjectAnim( const String& rFile ) {};

public:

						SgaObjectAnim();
						SgaObjectAnim( const Graphic& rGraphic, const String& rFile, const String& rFormatName );

	virtual 	   	   ~SgaObjectAnim() {};

	virtual SgaObjKind	GetObjKind() const { return SGA_OBJ_ANIM; }
};

// ------------------------------------------------------------------------

class SgaObjectINet : public SgaObjectAnim
{
private:

						SgaObjectINet( const String& rFile ) {};

public:

						SgaObjectINet();
						SgaObjectINet( const Graphic& rGraphic, const String& rURL, const String& rFormatName );

	virtual 	   	   ~SgaObjectINet() {};

	virtual SgaObjKind	GetObjKind() const { return SGA_OBJ_INET; }
};

// ------------------------------------------------------------------------

struct SgaObjList
{
	String		aPath;
	UINT32		nOffset;
	ULONG		nExtraFlag; // wird bei Eintraegen aus der Liste gebraucht; sonst niemals beruecksichtigt
	SgaObjKind	eObjKind;
};

DECLARE_LIST( ObjectList, SgaObjList* );

SvStream& operator<<( SvStream& rOut, const SgaObjList& rObj );
SvStream& operator>>( SvStream& rIn, SgaObjList& rObj );

// ------------------------------------------------------------------------

struct GalDragParams
{
	Region		aDragRegion;
	ULONG		nDragObjPos;
	String		aThemeName;
	String		aFileName;
	SgaObjKind	eObjKind;
};

// ------------------
// - SgaImportEntry -
// ------------------

struct SgaImportEntry
{
	String	aThemeName;
	String	aUIName;
	String	aFileName;
	String	aImportName;
	String	aRoot;
};

DECLARE_LIST( ImportList, SgaImportEntry* );

// ------------------------------------------------------------------------

SvStream& operator<<( SvStream& rOut, const SgaImportEntry& rEntry );
SvStream& operator>>( SvStream& rIn, SgaImportEntry& rEntry );

// ----------------
// - SgaThemeFile -
// ----------------

class SgaThemeFile
{
private:

	String			aName;
	String			aThmPath;
	String			aSdgPath;
	String			aSdvPath;
	UINT32			nFileNumber;
	UINT32			nId;
	BOOL			bReadOnly;
	BOOL			bImported;
	BOOL			bModified;
	BOOL			bThemeNameFromResource;

					SgaThemeFile();
	String			ImplGetFileNameIgnoreCase( const DirEntry& rFile ) const;
	void			ImplSetPath( const DirEntry& rPath );

public:
					SgaThemeFile( const DirEntry& rBasePath, const String& rName,
								  UINT32 nFileNumber, BOOL bReadOnly, BOOL bImported,
								  BOOL bNewFile, UINT32 nId, BOOL bThemeNameFromResource );

					~SgaThemeFile() {};

	const String&	GetThemeName() const { return aName; }
	UINT32			GetFileNumber() const { return nFileNumber; }

	const String&	GetThmPath() const { return aThmPath; }
	const String&	GetSdgPath() const { return aSdgPath; }
	const String&	GetSdvPath() const { return aSdvPath; }

	BOOL			IsImported() const { return bImported; }
	BOOL			IsReadOnly() const { return bReadOnly; }
	BOOL			IsDefault() const { return( ( nId > 0 ) && ( nId != ( RID_GALLERYSTR_THEME_MYTHEME - RID_GALLERYSTR_THEME_START ) ) ); }

	BOOL			IsHidden() const { return aName.Search( String( RTL_CONSTASCII_USTRINGPARAM( "private://gallery/hidden/" ) ) ) == 0; }

	BOOL			IsModified() const { return bModified; }
	void			SetModified( BOOL bSet ) { bModified = ( bSet && !IsImported() && !IsReadOnly() ); }

	void			SetName( const String& rNewName );
	void			SetBasePath( const DirEntry& rNewPath ) { ImplSetPath( rNewPath ); }
	BOOL			IsNameFromResource() const { return bThemeNameFromResource; }

	UINT32			GetId() const { return nId; }
	void			SetId( UINT32 nNewId, BOOL bResetThemeName );
};

DECLARE_LIST( ThemeList, SgaThemeFile* );

// --------------
// - SgaGallery -
// --------------

class SgaGallery;
class GalleryProgress;

class SgaTheme
{
private:

	ObjectList		aObjectList;
	String			aImportName;
	String			aActualizeFile;
	SvStorageRef	aSvDrawStorageRef;
	SgaGallery*		pParent;
	SgaThemeFile*	pThm;
	BOOL			bAbortActualize;

public:

	static SgaThemeFile* CreateThemeFile( const DirEntry& rFile, BOOL bReadOnly );

public:

					SgaTheme( SgaGallery* pGallery, SgaThemeFile* pThmFile );
					~SgaTheme();

	SgaObject*		GetObj( ULONG nPos );
	const ObjectList& GetObjList() const { return aObjectList; }
	const ULONG		GetObjCount() const { return aObjectList.Count(); }

	BOOL			InsertObj( const SgaObject& rObj, ULONG nPos = LIST_APPEND );
	BOOL			RemoveObj( ULONG nPos );
	BOOL			ChangeObjPos( ULONG nOldPos, ULONG nNewPos );

	void			Recover();

	const String&	GetName() const	{ return IsImported() ? aImportName : pThm->GetThemeName(); }
	const String&	GetRealName() const { return pThm->GetThemeName(); }
	const String&	GetImportName() const { return aImportName; }
	void			SetImportName(const String& rImportName) { aImportName = rImportName; }

	const String&	GetThmPath() const { return pThm->GetThmPath(); }
	const String&	GetSdgPath() const { return pThm->GetSdgPath(); }
	const String&	GetSdvPath() const { return pThm->GetSdvPath(); }

	UINT32			GetId() const { return pThm->GetId(); }
	void			SetId( UINT32 nNewId, BOOL bResetThemeName ) { pThm->SetId( nNewId, bResetThemeName ); }

	BOOL			IsThemeNameFromResource() const { return pThm->IsNameFromResource(); }

	SgaObject*		ReadSgaObject( SgaObjList* pEntry );
	BOOL			WriteSgaObject( const SgaObject& rObj, ULONG nPos, SgaObjList* pExistentEntry );

	BOOL			IsImported() const { return pThm->IsImported(); }
	BOOL			IsReadOnly() const { return pThm->IsReadOnly(); }
	BOOL			IsDefault() const { return pThm->IsDefault(); }
	BOOL			IsModified() const { return pThm->IsModified(); }

	void			Actualize( const Link& rActualizeLink, GalleryProgress* pProgress = NULL );
	void			AbortActualize() { bAbortActualize = TRUE; }
	const String&	GetActualizeFile() const { return aActualizeFile; }

	SgaGallery*		GetGallery() const { return pParent; }
	SvStorageRef	GetSvDrawStorage() const { return aSvDrawStorageRef; }

	void			Read();
	void			Write();

	friend SvStream& operator<<(SvStream& rOut, const SgaTheme& rObj);
	friend SvStream& operator>>(SvStream& rIn, SgaTheme& rObj);
};

// --------------
// - SgaGallery -
// --------------

class SgaGallery
{
	Graphic			aDropGraphic;
	ImageMap		aDropImageMap;
	String			aDropThemeName;
	Timer			aDropTimer;
	ULONG			nDropPos;
	GalDragParams	aDragParam;
	ThemeList		aThemeList;
	ImportList		aImportList;
	SgaTheme*		pActualTheme;
	void*			pDropDataBytes;
	void*			pCurView;
	UINT32			nDropDataSize;
	UINT32			nLastFileNumber;
	BOOL			bDragging;

					SgaGallery() {};

	void			ImpLoad();
	void			ImpLoadSubDirs( const DirEntry& rBase, BOOL bReadOnly );
	void			ImpLoadImports();

					DECL_LINK( DropGraphicHdl, void* );
					DECL_LINK( DropIMapGraphicHdl, void* );
					DECL_LINK( DropSvDrawHdl, void* );

	void 			WriteImportList();

public:

	static BOOL				bMultiPath;
	static String			aRelPathParent;
	static USHORT			nRelPathParentLen;
	static String			aUserPath;
	static USHORT			nUserPathLen;
	static rtl_TextEncoding	nReadTextEncoding;
	static String			aLastImportRoot;

public:

					SgaGallery( String* pStartUpTheme );
					~SgaGallery();

	SgaThemeFile* 	GetEntry( const String& rThemeName );
	SgaThemeFile* 	GetEntry( ULONG nThemeId );
	SgaImportEntry*	GetImportEntry( const String& rImportName );

	SgaTheme* 		CreateTheme( const String& rThemeName );
	SgaTheme*		CreateImportTheme( const DirEntry& rDirEntry, const String& rFileName );

	BOOL			InsertURL( const String& rURL, const String& rThemeName, const ULONG nSgaFormat, 
							   GalleryProgress* pProgress = NULL, ULONG nInsertPos = LIST_APPEND );
	BOOL			InsertFiles( List& rFileList, GalleryProgress* pProgress = NULL,
								 ULONG nInsertPos = LIST_APPEND );

	const String&	GetUserPath() const { return aUserPath; }

	const ULONG		GetThemeCount() const { return aThemeList.Count(); }
	SgaTheme*		GetTheme( const String& rThemeName );
	SgaTheme*		GetTheme( ULONG nThemeId );
	SgaTheme*		GetActualTheme() const { return pActualTheme; }

	BOOL			RemoveTheme( const String& rThemeName );

	BOOL			RenameTheme( const String& rOldName, const String& rNewName );
	BOOL 			IsRenamingPossible( const String& rThemeName );

	ThemeList		GetThemeList() const { return aThemeList; }
	BOOL			IsInList( const String& rThemeName );
	BOOL			IsInList( ULONG nThemeId );

	BOOL			IsThemeImported( const String& rThemeName );
	BOOL			IsThemeReadOnly( const String& rThemeName );
	BOOL			IsThemeDefault( const String& rThemeName );

	ImportList		GetImportList() const { return aImportList; }
	BOOL			IsImportThemeAvailable( const String& rImportTheme );
	String			GetImportFileName( const String& rThemeName );
	DirEntry 		GetImportPath( const String& rThemeName );
	BOOL 			SetImportPath( const String& rImportTheme, const DirEntry& rNewPath );

	BOOL			GetGraphicFromActualTheme( const ULONG nObjPos, Graphic& rGraphic, BOOL bProgress = TRUE );
	BOOL			GetSdrModelFromActualTheme( const ULONG nObjPos, FmFormModel& rModel, ULONG& rStmErr );
	String			GetPathFromActualTheme( const ULONG nObjPos );
	SgaObjKind		GetObjKindFromActualTheme( const ULONG nObjPos );
	SgaObjList*		GetObjFromActualTheme( ULONG nObjPos );
	String			GetCorrectPath( SgaObjList* pEntry );

	BOOL			SaveGraphic( const Graphic& rGraphic, String& rGraphicPath );

	void*			GetCurView() const { return pCurView; }
	void			SetCurView( void* pView ) { pCurView = pView; }

	void			StartDragServer( const Region& rRegion, ULONG nObjPos );
	SvDataTypeList	GetDragTypeList( const SvDataTypeList& rTypeList, ULONG nObjPos );
	BOOL			GetDragData( SvData* pData, ULONG nFormat, ULONG nObjPos );
	void			SetDragging( BOOL bDrag ) { bDragging = bDrag; }
	BOOL			IsDragging() const { return bDragging; }

	void					SetDragParams( const GalDragParams& rDragParam ) { aDragParam = rDragParam; }
	const GalDragParams&	GetDragParams() const { return aDragParam; }

					DECL_LINK( StartDragHdl, void* );

	BOOL			DoQueryDrop( DropEvent& rDEvt );
	BOOL			DoDrop( const DropEvent& rDEvt, const String& rThemeName, List& rFileList, ULONG nPos );

	DirEntry		CreateUniqueFileName( SgaObjKind eObjKind ) const;
};

// ------------------------------------------------------------------------

class GalleryProgress
{
	REF( NMSP_AWT::XProgressBar )	mxProgressBar;
	GraphicFilter*					mpFilter;

									DECL_LINK( Update, GraphicFilter * );

	public:
							
									GalleryProgress( GraphicFilter* pFilter = NULL );
									~GalleryProgress();

	void							Update( ULONG nVal, ULONG nMaxVal );
};

// ------------------------------------------------------------------------

class SgaDataObject : public SvDataObject
{
	SvDataTypeList					aTypeList;
	SgaGallery*						pGal;
	ULONG							nObjPos;

 public:

									SgaDataObject( SgaGallery* pGallery, ULONG nObjPos );
									~SgaDataObject();

	virtual BOOL					GetData( SvData* );
	virtual const SvDataTypeList&	GetTypeList() const;
};

SO2_DECL_IMPL_REF( SgaDataObject )

#endif // _SVX_GALLERY1_HXX_
