/*************************************************************************
 *
 *  $RCSfile: gallery2.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_GALLERY2_HXX_
#define _SVX_GALLERY2_HXX_

#define ITEMID_BRUSH 0

#include <vos/thread.hxx>
#include <bootstrp/sstring.hxx>
#include <tools/stream.hxx>
#include <vcl/graph.hxx>
#include <vcl/fixed.hxx>
#include <vcl/group.hxx>
#include <vcl/button.hxx>
#include <vcl/lstbox.hxx>
#include <vcl/menu.hxx>
#include <vcl/edit.hxx>
#include <svtools/valueset.hxx>
#include <svtools/slstitm.hxx>
#include <goodies/grfmgr.hxx>
#include <sfx2/bindings.hxx>
#include <sfx2/dispatch.hxx>
#include <sfx2/ctrlitem.hxx>
#include <sfx2/tabdlg.hxx>
#include <sfx2/hintpost.hxx>
#ifndef _IODLG_HXX
#include <sfx2/iodlg.hxx>
#endif
#include "brshitem.hxx"

#define STAR_GALLERY		"Gallery"
#define GAL_RESID( nId )	ResId( nId, GetGalleryResMgr() )

// ------------------------------------------------------------------------

#define OBJ_POS_FIRST		0
#define OBJ_POS_CURRENT		65534
#define OBJ_POS_LAST		65535

// ------------------------------------------------------------------------

ResMgr* GetGalleryResMgr();

// ------------------------------------------------------------------------

class	SgaGallery;
class	SgaTheme;
class 	SgaDirBrowser;
class	SvxGallery;
class	GalleryPathDlg;

// ------------------------------------------------------------------------

struct FilterEntry
{
	String	aFilterName;
	long	nMacType;
};

// ------------------------------------------------------------------------

struct ExchangeData
{
	SgaGallery* pGal;
	String		aGalleryTitle;
	ULONG		nThemeCount;
	Date		aGalleryCreateDate;
	Time		aGalleryCreateTime;
	Date		aGalleryChangeDate;
	Time		aGalleryChangeTime;
	String		aThemeTitle;
	Date		aThemeCreateDate;
	Time		aThemeCreateTime;
	Date		aThemeChangeDate;
	Time		aThemeChangeTime;
	BOOL		bThemeReadOnly;
	ULONG		nObjCount;
};

// ------------------------------------------------------------------------

inline SvStream& operator<<( SvStream& rOStm, const Time& rTime )
{
	return( rOStm << (UINT16) rTime.GetHour() << (UINT16) rTime.GetMin() << (UINT16) rTime.GetSec() );
}

// ------------------------------------------------------------------------

inline SvStream& operator>>( SvStream& rIStm, Time& rTime )
{
	UINT16 nTmp16;
	rIStm >> nTmp16; rTime.SetHour( nTmp16 );
	rIStm >> nTmp16; rTime.SetMin( nTmp16 );
	rIStm >> nTmp16; rTime.SetSec( nTmp16 );
	return rIStm;
}

// ------------------------------------------------------------------------

inline SvStream& operator<<( SvStream& rOStm, const Date& rDate )
{
	return( rOStm << (UINT16) rDate.GetDay() << (UINT16) rDate.GetMonth() << (UINT16) rDate.GetYear() );
}

// ------------------------------------------------------------------------

inline SvStream& operator>>( SvStream& rIStm, Date& rDate )
{
	UINT16 nTmp16;
	rIStm >> nTmp16; rDate.SetDay( nTmp16 );
	rIStm >> nTmp16; rDate.SetMonth( nTmp16 );
	rIStm >> nTmp16; rDate.SetYear( nTmp16 );
	return rIStm;
}

// ------------------------------------------------------------------------

class SvxClipValueSet : public ValueSet
{
	Size				aGallerySize;
	SgaGallery*			pGal;
	SvxGallery*			pSvxGallery;

						DECL_LINK( MenuSelectHdl, Menu * );

	virtual void 		UserDraw(const UserDrawEvent& rUDEvt);
	virtual void		Command(const CommandEvent& rCEvt);
	virtual	BOOL		QueryDrop( DropEvent& rEvt );
	virtual BOOL		Drop( const DropEvent& rEvt );

public:

						SvxClipValueSet(SvxGallery* pParent, WinBits nWinStyle);
						~SvxClipValueSet() {};

	void				SetGallery(SgaGallery* pGallery) { pGal = pGallery; }
	void				SetGallerySize( const Size& rSize ) { aGallerySize = rSize; }
	const Size& 		GetGallerySize() const { return aGallerySize; }

	void				UpdateItemText( USHORT nId, const SgaTheme* pThm,
										const SgaObjList* pEntry, const SgaObject* pObj );
};

// ------------------------------------------------------------------------

class GalleryWindow : public Window
{
	SvxGallery* 	pSvxGallery;
	GraphicObject	aGraphicObj;
	Rectangle		aPreviewRect;
	Sound			aSound;

	virtual void 	MouseButtonDown(const MouseEvent& rMEvt);
	virtual void 	Paint(const Rectangle& rRect);
	virtual void	Command(const CommandEvent& rCEvt);
	virtual	BOOL	QueryDrop( DropEvent& rEvt );
	virtual BOOL	Drop( const DropEvent& rEvt );

					DECL_LINK( MenuSelectHdl, Menu* );
					DECL_LINK( SoundEndHdl, Sound* );

public:

					GalleryWindow( SvxGallery* pParent, WinBits nWinStyle );
					~GalleryWindow();

	void			SetGraphic( const Graphic& rGraphic );
	void			PreviewSound( const String& rPath );
};

// ------------------------------------------------------------------------

class BrowserWindow : public Window
{
	Graphic			aGraphic;

	virtual void 	Paint( const Rectangle& rRect );

public:

					BrowserWindow( Window* pParent, const ResId& rId );
					~BrowserWindow() {};

	void			SetGraphic(const Graphic& rGraphic) { aGraphic = rGraphic; }
};

// ------------------------------------------------------------------------

class GalleryPathDlg : public SfxFileDialog
{
	CheckBox		aCbxSubDirs;

public:

					GalleryPathDlg( Window* pParent );
					~GalleryPathDlg() {};

	BOOL			IsSubDirs() const { return aCbxSubDirs.IsChecked(); }
};

// ------------------------------------------------------------------------

class SgaClipBrowser;
class SearchProgress;

class SearchThread : public NAMESPACE_VOS( OThread )
{
	SearchProgress*		mpProgress;
	SgaClipBrowser*		mpBrowser;

	void				ImplSearch( const DirEntry& rStartDir );
	void				ImplSearchRecursive( const DirEntry& rStartDir, ULONG nDepth );

public:

						SearchThread( SearchProgress* pProgess, SgaClipBrowser* pBrowser );
						~SearchThread() {};

	virtual void SAL_CALL run();
};

// ------------------------------------------------------------------------

class SearchProgress : public ModalDialog
{
	FixedText			aFtSearchDir;
	GroupBox			aGrpSearchDir;
	FixedText			aFtSearchType;
	GroupBox			aGrpSearchType;
	CancelButton		aBtnCancel;
	SearchThread		maSearchThread;

						DECL_LINK( ClickCancelBtn, void* );

public:
						SearchProgress( Window* pParent );
						~SearchProgress() {};

						DECL_LINK( CleanUpHdl, void* );

	virtual short		Execute();
	void 				SetFileType( const String& rType ) { aFtSearchType.SetText( rType ); }
	void 				SetDirectory( const String& rDir ) { aFtSearchDir.SetText( ReduceString( rDir ) ); }
};

// ------------------------------------------------------------------------

class TitleDialog : public ModalDialog
{
private:

	OKButton			maOk;
	CancelButton		maCancel;
	HelpButton			maHelp;
	GroupBox			maGrp;
	Edit				maEdit;

public:

						TitleDialog( Window* pParent, const String& rOldText );
	String				GetTitle() const { return maEdit.GetText(); }
};

// ------------------------------------------------------------------------

class SgaClipBrowser;
class TakeProgress;

class TakeThread : public NAMESPACE_VOS( OThread )
{
	TakeProgress*		mpProgress;
	SgaClipBrowser*		mpBrowser;
	List&				mrTakenList;

public:

						TakeThread( TakeProgress* pProgess, SgaClipBrowser* pBrowser, List& rTakenList );
							~TakeThread() {};

	virtual void SAL_CALL run();
};

// ------------------------------------------------------------------------

class TakeProgress : public ModalDialog
{
	FixedText			aFtTakeFile;
	GroupBox			aGrpTakeProgress;
	CancelButton		aBtnCancel;
	TakeThread			maTakeThread;
	List				maTakenList;

						DECL_LINK( ClickCancelBtn, void* );

public:

						TakeProgress( Window* pWindow );
						~TakeProgress() {};

						DECL_LINK( CleanUpHdl, void* );

	void 				SetFile( const String& rFile ) { aFtTakeFile.SetText( ReduceString( rFile ) ); }
	virtual short		Execute();
};

// ------------------------------------------------------------------------

class ActualizeProgress : public ModalDialog
{
	FixedText			aFtActualizeFile;
	GroupBox			aGrpActualizeProgress;
	CancelButton		aBtnCancel;
	Timer*				pTimer;
	SgaTheme*			pTheme;
	GalleryProgress		aStatusProgress;

						DECL_LINK( ClickCancelBtn, void* );
						DECL_LINK( TimeoutHdl, Timer* );
						DECL_LINK( ActualizeHdl, SgaTheme* pThm );

public:
						ActualizeProgress( Window* pWindow, SgaTheme* pThm );
						~ActualizeProgress() {};

	virtual short		Execute();
};

// ------------------------------------------------------------------------

#ifndef StringList
DECLARE_LIST( StringList, String* );
#endif

class SgaClipBrowser : public SfxTabPage
{
	friend class SearchThread;
	friend class TakeProgress;
	friend class TakeThread;

	ComboBox			aCbbFileType;
	PushButton			aBtnSearch;
	MultiListBox		aLbxFound;
	PushButton			aBtnTake;
	PushButton			aBtnTakeAll;
	CheckBox			aCbxPreview;
	FixedText			aFtFileType;
	Sound				aSound;
	StringList			aFoundList;
	List				aFilterEntryList;
	Timer				aPreviewTimer;
	String				aPreviewString;
	String				aPath;
	SgaGallery*			pGal;
	GalleryPathDlg*		pBrowser;
	SvxGallery*			pSvxGallery;
	BrowserWindow*		pWndPreview;
	USHORT				nCurFilterPos;
	USHORT				nFirstExtFilterPos;
	BOOL				bEntriesFound;
	BOOL				bInputAllowed;
	BOOL				bTakeAll;
	BOOL				bSearchRecursive;

	void				InitControls();
	virtual	void		Reset( const SfxItemSet& rSet ) {}
	virtual BOOL        FillItemSet( SfxItemSet& rSet ) { return TRUE; }
	void				FillFilterList( void* p );

	void				SearchFiles();
	void 				TakeFiles();

	void				DoPreview();

						DECL_LINK( ClickPreviewHdl, void* );
						DECL_LINK( ClickCloseBrowserHdl, void* );
						DECL_LINK( ClickSearchHdl, void* );
						DECL_LINK( ClickTakeHdl, void* );
						DECL_LINK( ClickTakeAllHdl, void* );
						DECL_LINK( SelectFoundHdl, void* );
						DECL_LINK( SelectThemeHdl, void* );
						DECL_LINK( SelectFileTypeHdl, void* );
						DECL_LINK( DClickFoundHdl, void* );
						DECL_LINK( PreviewTimerHdl, void* );
						DECL_LINK( SoundEndHdl, Sound* );

public:
						SgaClipBrowser( Window* pWindow, const SfxItemSet& rSet );
						~SgaClipBrowser();

	DirEntry			GetPath() const { return aPath; }
	void				SetGalleries( SgaGallery* pGallery, SvxGallery* pSvxGallery );
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
};

// ------------------------------------------------------------------------

class GalleryProperties : public SfxTabDialog
{
	ExchangeData*	pData;

	virtual void	PageCreated( USHORT nId, SfxTabPage &rPage );

public:

					GalleryProperties( Window* pParent, ExchangeData* pData, SfxItemSet* pItemSet );
					~GalleryProperties() {}
};

// ------------------------------------------------------------------------

class GalleryThemeProperties : public SfxTabDialog
{
	ExchangeData*	pData;

	virtual void	PageCreated( USHORT nId, SfxTabPage &rPage );

public:

					GalleryThemeProperties( Window* pParent, ExchangeData* pData, SfxItemSet* pItemSet  );
					~GalleryThemeProperties() {}
};

// ------------------------------------------------------------------------

class TPGalleryGeneral : public SfxTabPage
{
protected:

	FixedImage			aFiMSImage;
	Edit				aEdtMSName;
	FixedLine			aFlMSGeneralFirst;
	FixedText			aFtMSType;
	FixedText			aFtMSShowType;
	FixedText			aFtMSPath;
	FixedText			aFtMSShowPath;
	FixedText			aFtMSContent;
	FixedText			aFtMSShowContent;
	FixedLine			aFlMSGeneralSecond;
	FixedText			aFtMSCreateDate;
	FixedText			aFtMSShowCreateDate;
	FixedText			aFtMSChangeDate;
	FixedText			aFtMSShowChangeDate;
	ExchangeData*		pData;

	virtual void		InitControls();
	virtual void		Reset( const SfxItemSet& ) {}
	virtual BOOL        FillItemSet( SfxItemSet& rSet );


public:

						TPGalleryGeneral( Window* pParent, const SfxItemSet& rSet  );
						~TPGalleryGeneral() {}

	void				SetXChgData( ExchangeData* pData );
	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
};

// ------------------------------------------------------------------------

class TPGalleryThemeGeneral : public TPGalleryGeneral
{
	virtual void		InitControls();
	virtual BOOL        FillItemSet( SfxItemSet& rSet );


public:

						TPGalleryThemeGeneral( Window* pParent, const SfxItemSet& rSet );
						~TPGalleryThemeGeneral() {}

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
};

// ------------------------------------------------------------------------

class SgaBGPopup : public PopupMenu, public SfxControllerItem
{
	String			aFileName;
	BOOL			bINET;

	virtual void	Select();
	virtual void	StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );

public:

					SgaBGPopup() {}
					SgaBGPopup( const String& rObjFileName, BOOL bINET );
					~SgaBGPopup() {}
};

// ------------------------------------------------------------------------

class SgaPopup : public PopupMenu, public SfxControllerItem
{
	SgaBGPopup*		pBGPopup;

	virtual void	StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );

public:

					SgaPopup( SgaGallery* pGal, USHORT nSelPos, BOOL bPreview );
					~SgaPopup() { delete pBGPopup; }
};

// ------------------------------------------------------------------------

class SvxGallery : public Window
{
	friend 	SvxClipValueSet;
	friend 	GalleryWindow;
	friend	SgaClipBrowser;

	SfxHintPosterRef	aHintPosterRef;
	SgaGallery*			pGal;
	SvxClipValueSet*	pCtlGallery;
	GalleryWindow*		pWndPreview;
	DirEntry			aObjPath;
	DirEntry			aPath;
	String				aThemeName;
	Size				aLastSize;
	BOOL				bIsPreview;
	BOOL				bLinkage;

	void				StartDragServer(const Region& rRegion);

	virtual void 		Resize();
	virtual void		KeyInput( const KeyEvent& rKEvt );

	void 				AdjustControls( const Size& rWinSize );
	void 				SetPath( const DirEntry& rPath ) { aPath = rPath; }
	void				HidePreview();
	void				AddFile( BOOL bAsLinkage );
	void				DeleteSelectedObj();
	void				EditSelectedObjTitle();

						DECL_LINK( SelectBmpHdl, void* );
						DECL_LINK( DoubleClickBmpHdl, void* );


public:

						SvxGallery(	Window* pParent, SgaGallery* pGallery );
						~SvxGallery();

	const DirEntry&		GetPath() const;
	String				GetPathAsString() const;
	String				GetFilterName() const;
	Graphic				GetGraphic() const;
	BOOL				GetFmFormModel( FmFormModel& rModel ) const;
	BOOL				IsLinkage() const { return bLinkage; }

	void				UpdateBrowser( USHORT nSelectObjPos );
	void				AppendToValueSet();

	USHORT				GetSelection() const;
	void				SetSelection( const USHORT nSelection );

	static BOOL			GetGraphicCenterRect( const Graphic& rGraphic, const Window& rWin,
											  Rectangle& rResultRect );

	SgaTheme*			GetTheme() const;
	void				ThemeRenamed( const String& rNewThemeName ) { aThemeName = rNewThemeName; }

	void				SetGallery( SgaGallery* _pGal ) { pGal = _pGal; }
	SgaGallery*			GetGallery() const { return pGal; }
};

#endif // _SVX_GALLERY2_HXX_
