/*************************************************************************
 *
 *  $RCSfile: fmfield.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_FMFIELD_HXX
#define _SVX_FMFIELD_HXX

#ifdef TF_SDBAPI
#error "this file isn't needed for the new SDB-API"
#else // !TF_SDBAPI

#define USE_PROPERTY_HELPER

#ifndef _SVX_FMPROP_HXX
#include "fmprop.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif

#ifndef _SMART_COM_SUN_STAR_DATA_XDATABASEVARIANT_HXX_
#include <smart/com/sun/star/data/XDatabaseVariant.hxx>
#endif

#include <smart/com/sun/star/lang/NoSupportException.hxx>
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XINDEXACCESS_HXX_
#include <smart/com/sun/star/container/XIndexAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XNAMEACCESS_HXX_
#include <smart/com/sun/star/container/XNameAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HXX_
#include <smart/com/sun/star/container/XEnumerationAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XNAMED_HXX_
#include <smart/com/sun/star/container/XNamed.hxx>
#endif


#ifndef _USR_MRC_HXX
#include <usr/comphlp.hxx>
#endif

class FmXDatabaseForm;

//==================================================================
// FmXDbField
// allgemeine Felddefinition
//==================================================================
class FmXDbField :public NAMESPACE_USR(OComponentHelper)
				 ,public FmXAggregatePropertySetHelper
				 ,public XNamed
				 ,public XDatabaseVariant

{
	friend class FmXDbFields;

	NAMESPACE_VOS(OMutex)	m_aMutex;
	FmXDbFields*			m_pParent;
	XDatabaseVariantRef		m_xVariant;
	FmXAggregatePropertyArrayHelper *
							m_pFieldPropertyArray;

public:
	FmXDbField(FmXDbFields* pParent, const XPropertySetRef& _xField);
	~FmXDbField();

	SMART_UNO_DECLARATION(FmXDbField, OComponentHelper);
	virtual BOOL queryInterface(UsrUik, XInterfaceRef&);
	virtual Sequence< XIdlClassRef>	getIdlClasses(void);

// OComponentHelper
	virtual void disposing();

// XPropertiesChangeListener
	virtual void propertiesChange(const Sequence< PropertyChangeEvent >& evt)
		THROWS( (UsrSystemException) );

// XNamed
	virtual UString getName(void) const THROWS( (UsrSystemException) );
	virtual void setName(const UString& Name_) THROWS( (UsrSystemException, NoSupportException) );

// OPropertySetHelper
	virtual XPropertySetInfoRef getPropertySetInfo() const THROWS( (UsrSystemException) );
	virtual NAMESPACE_USR(IPropertyArrayHelper)& getInfoHelper() const;
	virtual BOOL convertFastPropertyValue(UsrAny & rConvertedValue, UsrAny & rOldValue,
										  INT32 nHandle, const UsrAny& rValue )
										THROWS( (IllegalArgumentException) ) {return FALSE;}
	virtual void setFastPropertyValue_NoBroadcast(INT32 nHandle, const UsrAny& rValue) {}

// XDatabaseVariant
	virtual BOOL isNull(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual UString getString(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual BOOL getBoolean(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual BYTE getByte(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual INT16 getShort(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual INT32 getLong(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual float getFloat(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual double getDouble(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual Sequence< BYTE > getBytes(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual Date getDate(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual Time getTime(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual DateTime getDateTime(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual XInputStreamRef getBinaryStream(void) const THROWS( (DatabaseException, UsrSystemException) );
	virtual void setNull(void) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setString(const UString& x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setBoolean(BOOL x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setByte(BYTE x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setShort(INT16 x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setLong(INT32 x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setFloat(float x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setDouble(double x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setBytes(const Sequence< BYTE >& x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setDate(const Date& x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setTime(const Time& x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setDateTime(const DateTime& x) THROWS( (DatabaseException, UsrSystemException) );
	virtual void setBinaryStream(const XInputStreamRef& x) THROWS( (DatabaseException, UsrSystemException) );

	void setField(const XPropertySetRef& rxField);
	void startListening();
};

typedef NAMESPACE_STD(hash_map)<UString, FmXDbField*, FmUStringMixHash, FmUStringMixEqual> OFieldMap;
typedef NAMESPACE_STD(vector)<FmXDbField*> OFieldArray;

//==================================================================
// FmXDbFields
//==================================================================
class FmXDbFields : public XIndexAccess,
					public XNameAccess,
					public XEnumerationAccess,
					public XPropertySet,
					public XFastPropertySet,
					public NAMESPACE_USR(OWeakObject)
{
	friend class FmXDatabaseForm;
	friend class FmXDbField;

	FmXDatabaseForm&	m_rParent;

	XIndexAccessRef		m_xIndex;
	XNameAccessRef		m_xName;
	XPropertySetRef		m_xPropertySet;
	XFastPropertySetRef m_xFastSet;

	OFieldArray			m_aFields;
	OFieldMap			m_aFieldMap;

	FmXAggregatePropertyArrayHelper *
						m_pFieldPropertyArray;

public:
	FmXDbFields(FmXDatabaseForm& rContext)
		:m_rParent(rContext)
		,m_pFieldPropertyArray(NULL){};
	~FmXDbFields();

	// XInterface
	virtual void	acquire();
	virtual void	release();
	virtual void*	getImplementation(Reflection * pRef);

	virtual BOOL queryInterface(Uik,XInterfaceRef&);
	virtual Sequence< XIdlClassRef>	getIdlClasses(void);

// XElementAccess
	virtual XIdlClassRef getElementType(void) const THROWS( (UsrSystemException) );
	virtual BOOL hasElements(void) const THROWS( (UsrSystemException) );

// XEnumerationAccess
	virtual XEnumerationRef createEnumeration(void) THROWS( (UsrSystemException) );

// XNameAccess
	virtual UsrAny getByName(const UString& Name) const THROWS( (NoSuchElementException, WrappedTargetException, UsrSystemException) );
	virtual Sequence< UString > getElementNames(void) const THROWS( (UsrSystemException) );
	virtual BOOL hasByName(const UString& Name) const THROWS( (UsrSystemException) );

// XPropertySet
	virtual XPropertySetInfoRef getPropertySetInfo(void) const THROWS( (UsrSystemException) );
	virtual void setPropertyValue(const UString& PropertyName, const UsrAny& aValue) THROWS( (UnknownPropertyException, PropertyVetoException, IllegalArgumentException, WrappedTargetException, UsrSystemException) ) ;
	virtual UsrAny getPropertyValue(const UString& PropertyName) const THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) );
	virtual void addPropertyChangeListener(const UString& PropertyName, const XPropertyChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) ) ;
	virtual void removePropertyChangeListener(const UString& PropertyName, const XPropertyChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) );
	virtual void addVetoableChangeListener(const UString& PropertyName, const XVetoableChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) );
	virtual void removeVetoableChangeListener(const UString& PropertyName, const XVetoableChangeListenerRef& aListener) THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) );

// XFastPropertySet
	virtual void setFastPropertyValue(INT32 nHandle, const UsrAny& aValue) THROWS( (UnknownPropertyException, PropertyVetoException, IllegalArgumentException, WrappedTargetException, UsrSystemException) );
	virtual UsrAny getFastPropertyValue(INT32 nHandle) const THROWS( (UnknownPropertyException, WrappedTargetException, UsrSystemException) );

// XIndexAccess Interface
	virtual INT32 getCount(void) const THROWS( (UsrSystemException) );
	virtual UsrAny getByIndex(INT32 Index) const THROWS( (IndexOutOfBoundsException, WrappedTargetException, UsrSystemException) );

protected:
	void setDefinitions(const XPropertySetRef& _xFields);
	void setDefinitions(const XNameAccessRef& _xFields);
	void load(const XPropertySetRef& _xFields);
	void unload();
	void replaceFields(const XPropertySetRef& _xFields);
	void clear();
	void fireValues();

	XFastPropertySetRef& getFastSet() const;
};


#endif // !TF_SDBAPI

#endif  // _SVX_FMFIELD_HXX


