/*************************************************************************
 *
 *  $RCSfile: fmfilter.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_FMFILTER_HXX
#define _SVX_FMFILTER_HXX

#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XDATABASEMETADATA_HPP_
#include <com/sun/star/sdbc/XDatabaseMetaData.hpp>
#endif

#ifndef _COM_SUN_STAR_FORM_XBOUNDCOMPONENT_HPP_
#include <com/sun/star/form/XBoundComponent.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTER_HPP_
#include <com/sun/star/util/XNumberFormatter.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XTEXTCOMPONENT_HPP_
#include <com/sun/star/awt/XTextComponent.hpp>
#endif

#ifndef _TOOLKIT_CONTROLS_UNOCONTROL_HXX_
#include <toolkit/controls/unocontrol.hxx>
#endif

#ifndef _TOOLKIT_AWT_LISTENERMULTIPLEXER_HXX_
#include <toolkit/helper/listenermultiplexer.hxx>
#endif

#ifndef _CPPUHELPER_IMPLBASE5_HXX_
#include <cppuhelper/implbase5.hxx>
#endif

#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

class Window;

//==================================================================
// FmXFilterControl
//==================================================================
class FmXFilterControl:	public UnoControl,
						public ::com::sun::star::awt::XTextComponent,
						public ::com::sun::star::awt::XFocusListener,
						public ::com::sun::star::awt::XItemListener,
						public ::com::sun::star::form::XBoundComponent
{
	//	friend Reflection* ::getCppuType((const FmXFilterControl*)0);
	//	friend ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  FmXFilterControl_NewInstance_Impl();

	TextListenerMultiplexer		m_aTextListeners;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > 				m_xField;
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > 			m_xFormatter;
	::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData > 		m_xMetaData;
	Window*						m_pWindow;

	::rtl::OUString						m_aText;
	sal_Int16						m_nControlClass;		// welche Art von Control wird eingesetzt
	sal_Bool						m_bFilterList : 1;
	sal_Bool						m_bMultiLine : 1;
	sal_Bool						m_bFilterListFilled : 1;

	FmXFilterControl():m_aTextListeners( *this ),m_pWindow(NULL){}

public:
	FmXFilterControl(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xModel,
					 const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xField,
					 const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XDatabaseMetaData > & xMetaData,
					 const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,
					 Window* pErrorWin);

	DECLARE_UNO3_AGG_DEFAULTS(FmXFilterControl,OWeakAggObject);
	//	virtual sal_Bool queryAggregation( ::com::sun::star::uno::Uik aUik, ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & rxInterface );

	static const ::com::sun::star::uno::Sequence< sal_Int8 > & getUnoTunnelId();
	sal_Int64 SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 > & rId );

	virtual ::rtl::OUString	GetComponentServiceName();
	virtual void SAL_CALL	createPeer( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit > & rxToolkit, const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer >  & rParentPeer );

// ::com::sun::star::lang::XComponent
	virtual void SAL_CALL	dispose(void) throw( ::com::sun::star::uno::RuntimeException );

// ::com::sun::star::awt::XTextComponent
	virtual void			SAL_CALL addTextListener( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTextListener > & l );
	virtual void			SAL_CALL removeTextListener( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTextListener > & l );
	virtual void			SAL_CALL setText( const ::rtl::OUString& aText );
	virtual void			SAL_CALL insertText( const ::com::sun::star::awt::Selection& rSel, const ::rtl::OUString& aText );
	virtual ::rtl::OUString	SAL_CALL getText();
	virtual ::rtl::OUString	SAL_CALL getSelectedText();
	virtual void			SAL_CALL setSelection( const ::com::sun::star::awt::Selection& aSelection );
	virtual ::com::sun::star::awt::Selection SAL_CALL getSelection();
	virtual sal_Bool		SAL_CALL isEditable();
	virtual void			SAL_CALL setEditable( sal_Bool bEditable );
	virtual void			SAL_CALL setMaxTextLen( sal_Int16 nLength );
	virtual sal_Int16		SAL_CALL getMaxTextLen();

// ::com::sun::star::form::XBoundComponent
	virtual void			SAL_CALL addUpdateListener(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XUpdateListener > & l) {}
	virtual void			SAL_CALL removeUpdateListener(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XUpdateListener > & l) {}
	virtual sal_Bool		SAL_CALL commit();

// ::com::sun::star::lang::XEventListener
	virtual void			SAL_CALL disposing(const ::com::sun::star::lang::EventObject& Source) throw( ::com::sun::star::uno::RuntimeException );

// ::com::sun::star::awt::XFocusListener
	virtual void			SAL_CALL focusGained(const ::com::sun::star::awt::FocusEvent& e) throw( ::com::sun::star::uno::RuntimeException );
	virtual void			SAL_CALL focusLost(const ::com::sun::star::awt::FocusEvent& e) throw( ::com::sun::star::uno::RuntimeException ){}

// ::com::sun::star::awt::XItemListener
	virtual void			SAL_CALL itemStateChanged(const ::com::sun::star::awt::ItemEvent& rEvent);

protected:
	virtual void PrepareWindowDescriptor( ::com::sun::star::awt::WindowDescriptor& rDesc );
	virtual void ImplSetPeerProperty( const ::rtl::OUString& rPropName, const ::com::sun::star::uno::Any& rVal );
};


#endif

