/*************************************************************************
 *
 *  $RCSfile: multipro.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _MULTIPRO_HXX
#define _MULTIPRO_HXX

#ifndef _COM_SUN_STAR_FORM_XFORMCOMPONENT_HPP_
#include <com/sun/star/form/XFormComponent.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYSTATE_HPP_
#include <com/sun/star/beans/PropertyState.hpp>
#endif
#include <com/sun/star/beans/XPropertyState.hpp>
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP_
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif

#include <com/sun/star/beans/XPropertyStateChangeListener.hpp>

#ifndef _SAL_TYPES_H
#include <sal/types.h>
#endif

#ifndef _SVDMARK_HXX //autogen
#include <svdmark.hxx>
#endif


#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif

#ifndef _SVX_FMOBJ_HXX
#include "fmobj.hxx"
#endif

#include <cppuhelper/implbase3.hxx>
#include <cppuhelper/implbase1.hxx>

#include <unotools/stl_types.hxx>
#include <unotools/types.hxx>
//========================================================================
//TF_ONE51
//========================================================================

typedef FmFormObj* FmFormObjPtr;

//SV_DECL_PTRARR(FmFormObjArray,FmFormObjPtr,1,1);
DECLARE_STL_VECTOR(::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>, XPropertySetRefArray);


namespace utl {
	sal_Bool compare(const ::com::sun::star::uno::Any& rValue1, const ::com::sun::star::uno::Any& rValue2);
}
//==================================================================
// FmXMultiSet
//==================================================================
class FmXMultiSet : public ::cppu::WeakImplHelper3<
													::com::sun::star::beans::XPropertySet,
													::com::sun::star::beans::XPropertyState,
													::com::sun::star::form::XFormComponent>
{
private:

//	FmFormObjArray			aList;
	::com::sun::star::uno::Any					aLastValue;
	XPropertySetRefArray	aPropSetList;
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>		aPropSeq;
	::rtl::OUString					aLastName;

	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface>	m_xParent;
	

protected:

	void			MakePropertySubSet();
	void			MakeList(const SdrMarkList& rMarkList);
	void			InsertElement(SdrObject *pObj);



public:
	FmXMultiSet(const SdrMarkList& rMarkList);
	FmXMultiSet(const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet> > & seqPropSets);


	//	SMART_UNO_DECLARATION(FmXMultiSet, ::cppu::OWeakObject);

	//	virtual sal_Bool						queryInterface( Uik aUik, ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface> & rOut );
	//	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass>>		getIdlClasses(void);

	// ::com::sun::star::container::XChild
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface> SAL_CALL getParent(void);
	virtual void SAL_CALL setParent(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface>& Parent);

	// ::com::sun::star::beans::XPropertyState
	virtual ::com::sun::star::beans::PropertyState SAL_CALL getPropertyState(const ::rtl::OUString& PropertyName);
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyState > SAL_CALL getPropertyStates(const ::com::sun::star::uno::Sequence< ::rtl::OUString >& PropertyName);
	virtual void SAL_CALL setPropertyToDefault(const ::rtl::OUString& aPropertyName);
	virtual ::com::sun::star::uno::Any SAL_CALL getPropertyDefault(const ::rtl::OUString& aPropertyName);
	virtual void SAL_CALL addPropertyStateChangeListener(const ::rtl::OUString& aPropertyName,
												const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyStateChangeListener>& aListener);
	virtual void SAL_CALL removePropertyStateChangeListener(const ::rtl::OUString& aPropertyName,
												const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyStateChangeListener>& aListener);

	// PropertySetInterface
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo> SAL_CALL getPropertySetInfo();
	virtual void SAL_CALL setPropertyValue(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue);
	virtual ::com::sun::star::uno::Any SAL_CALL getPropertyValue(const ::rtl::OUString& aPropertyName);

	virtual	void SAL_CALL addPropertyChangeListener(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener>& aListener);
	virtual void SAL_CALL removePropertyChangeListener(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener>& aListener);
	virtual void SAL_CALL addVetoableChangeListener(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener>& aListener);
	virtual void SAL_CALL removeVetoableChangeListener(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener>& aListener);
};


//==================================================================
// FmXMultiSetPropertySetInfo
//==================================================================
class FmXMultiPropInfo : public ::cppu::WeakImplHelper1< ::com::sun::star::beans::XPropertySetInfo>
{
private:

	::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>	aPropSeq;

public:

	FmXMultiPropInfo(const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> &aPropSeq);
	//	SMART_UNO_DECLARATION(FmXMultiSetPropertySetInfo,::cppu::OWeakObject);

	//	virtual sal_Bool					queryInterface( Uik aUik, ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface> & rOut );
	//	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass>>	getIdlClasses(void);
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>	SAL_CALL getProperties(void);
	virtual ::com::sun::star::beans::Property SAL_CALL getPropertyByName(const ::rtl::OUString& aPropertyName);
	virtual sal_Bool SAL_CALL hasPropertyByName(const ::rtl::OUString& Name);
};


#endif

