/*************************************************************************
 *
 *  $RCSfile: propbrw.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_PROPBRW_HXX
#define _SVX_PROPBRW_HXX

#ifndef _VCL_FONT_HXX
#include <vcl/font.hxx>
#endif

#ifndef _SV_FLOATWIN_HXX //autogen
#include <vcl/floatwin.hxx>
#endif

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _COM_SUN_STAR_FORM_XFORM_HPP_
#include <com/sun/star/form/XForm.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XINTROSPECTIONACCESS_HPP_
#include <com/sun/star/beans/XIntrospectionAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATE_HPP_
#include <com/sun/star/beans/XPropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYCHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertyChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYCHANGEEVENT_HPP_
#include <com/sun/star/beans/PropertyChangeEvent.hpp>
#endif

#ifndef SV_PROPERTY_HXX
#include "property.hxx"
#endif

#ifndef _BASEDLGS_HXX //autogen
#include <sfx2/basedlgs.hxx>
#endif

#ifndef _SFX_CHILDWIN_HXX //autogen
#include <sfx2/childwin.hxx>
#endif

#ifndef _SFXCTRLITEM_HXX //autogen
#include <sfx2/ctrlitem.hxx>
#endif

#ifndef _SVTREEBOX_HXX
#include <svtools/svtreebx.hxx>
#endif

#include <cppuhelper/implbase1.hxx>
#include <unotools/uno3.hxx>

//FORWARD_DECLARE_INTERFACE(uno,Reference)
FORWARD_DECLARE_INTERFACE(script,XEventAttacherManager)

class FmPropController;
class FmFormShell;

//========================================================================
::rtl::OUString GetUIHeadlineName(sal_Int16 nClassId, const ::com::sun::star::uno::Any& aUnoObj);

//	Listener fuer Properties
//========================================================================
class FmPropertyListener : public ::cppu::WeakImplHelper1< ::com::sun::star::beans::XPropertyChangeListener>

{
	FmPropController* pController;
	sal_uInt32 nLocks;

public:
	FmPropertyListener(FmPropController* _pController):pController(_pController),nLocks(0){}

	//	DECLARE_UNO3_AGG_DEFAULTS(FmPropertyListener, UsrObject);
	//	virtual sal_Bool queryInterface( ::com::sun::star::uno::Uik aUik, ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& rOut );

	//	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass > >	getIdlClasses();

	// ::com::sun::star::lang::XEventListener
	virtual void SAL_CALL disposing(const ::com::sun::star::lang::EventObject& Source);

	// ::com::sun::star::beans::XPropertyChangeListener
	virtual void SAL_CALL propertyChange(const  ::com::sun::star::beans::PropertyChangeEvent& evt);

	void Lock() {nLocks++;}
	void UnLock() {nLocks--;}
	sal_Bool IsLocked() const {return nLocks != 0;}
};

//========================================================================
class FmPropControl : public Window
{
	friend class FmPropController;
	friend class FmPropBrw;

	FmPropController*	pActiveController;
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > 		xObject;
	SvxPropertyBox*		pPropBox;
	sal_Bool				bFirstTime;

protected:
	virtual void Resize();

public:
	FmPropControl(Window* pParent, WinBits nBits = 0);
	FmPropControl(Window* pParent, const ResId& rId);

	FmPropController* GetActiveController() const { return pActiveController; }
	void SetActiveController( FmPropController* pController )
		{ pActiveController = pController; }

	void SetObject(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& _xIface) {xObject = _xIface;}
	const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& GetObject() const {return xObject;}

	virtual ~FmPropControl();

	// Controller fuer ::com::sun::star::form und Controls
	void UpdateController(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  _xObject, FmFormShell* _pShell = NULL);
	// Controller fuer GridColumns
	void UpdateController(::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  _xForm, ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  _xObject);
};


//========================================================================
class SvNumberFormatsSupplierObj;
class FmPropController : public SvxPropDataListener
{
	friend class FmPropertyListener;
protected:
	::com::sun::star::uno::Any					aUnoObj;
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>		aPropSeq;
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	aListenerSeq;
private:
	FmPropertyListener* pChangeListener;		// Listener um Aenderung von Propertys
													// zu registrieren
	FmPropControl*		pMasterController;
	FmFormShell*		pShell;

	sal_uInt32 nFontAttribsPos;
	sal_uInt32 nFontSizePos;
	sal_uInt32 nFontTypePos;
	sal_uInt32 nFontColorPos;

	::rtl::OUString			aStandard;

protected:
	SvxPropertyBox*			 pPropBox;

	::com::sun::star::uno::Reference< ::com::sun::star::script::XEventAttacherManager >  xEvManager;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyState > 		xPropertyState;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XIntrospectionAccess >  xUnoAccess;
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > 			xParentObjInter;
	::com::sun::star::uno::Reference< ::com::sun::star::form::XForm > 				xForm;

	sal_uInt16 nDefaultPage;
	sal_uInt16 nDataPage;
	sal_uInt16 nEventPage;

private:

	sal_uInt16 nControlId;

	sal_Bool bLongValue:1;
	sal_Bool bFontInserted : 1;
	sal_Bool bHasListSource : 1;
	sal_Bool bHasCursorSource : 1;
	sal_Bool bUI : 1;		// Wird auf sal_False gesetzt, wenn PropBox geschlossen wird,
						// damit im letzten Commit keine PropBox Funktionen
						// mehr gerufen werden. -> sonst GPF
protected:

	::com::sun::star::uno::Any StringToAny( const ::rtl::OUString& rString,const ::com::sun::star::beans::Property& rProp, sal_Int32 nPropId);
	::rtl::OUString AnyToString( const ::com::sun::star::uno::Any& rValue, const ::com::sun::star::beans::Property& rProp, sal_Int32 nPropId);
	xub_StrLen GetStringPos( const UniString& rEntry, const UniString& rEntries );
	::rtl::OUString GetEnumString( sal_uInt16 nAttrId );
	::com::sun::star::beans::Property GetProperty( const ::rtl::OUString& rName );

public:
	FmPropController( FmPropControl* pMasterContr,  ::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  _xForm, FmFormShell* _pShell);
	virtual ~FmPropController();

	virtual sal_Bool SetObject( const ::com::sun::star::uno::Any& aToEditObj,const ::com::sun::star::uno::Any& aToEditCtr );
	void UpdateUI();
	void InsertEvents();

	void SetEventManager(::com::sun::star::uno::Reference< ::com::sun::star::script::XEventAttacherManager >  xEvMan);
	void SetObjectParent(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  xInterface);

	void DisconnectUI() { bUI = sal_False; }
	sal_Bool IsUIDisconnected() const { return !bUI; }

	virtual void Modified( const XubString& aName, const XubString& aVal, void* pData );
	virtual void Clicked( const XubString& aName, const XubString& aVal, void* pData );
	virtual void Commit( const XubString& aName, const XubString& aVal, void* pData );
	virtual void Select( const XubString& aName, void* pData );
	virtual void LinkClicked( const XubString& aName, void* pData );

private:
	void SetCursorSource(sal_Bool bInit=sal_False);
	void SetListSource(sal_Bool bInit=sal_False);
	void SetStringSeq( const ::com::sun::star::beans::Property& rProperty, SvxPropData& rUIData );

	sal_uInt32 GetPropertyPos( const ::rtl::OUString& rPropName );
	::rtl::OUString GetPropertyValue( const ::rtl::OUString& rPropName );

	Font AnyToFont( const ::com::sun::star::uno::Any& rFontAttribsAny, const ::com::sun::star::uno::Any& rFontSizeAny,
								  const ::com::sun::star::uno::Any& rFontTypeAny );
	void FontToAny( const Font& rFont, ::com::sun::star::uno::Any& rFontAttribsAny, ::com::sun::star::uno::Any& rFontSizeAny,
								  ::com::sun::star::uno::Any& rFontTypeAny );

	void ChangeFontProperty( const ::rtl::OUString& rName );

	void ChangeEventProperty( const ::rtl::OUString& rName );

	void ChangeFormatProperty(const ::rtl::OUString& rName, const ::rtl::OUString& rCurVal);

	void SetTables( SvxPropData& rProperty );
	void SetQueries( SvxPropData& rProperty );
	void SetFields( SvxPropData& rProperty );
};

//========================================================================
// Controller speziell fuer Forms
class FmFormPropController : public FmPropController
{
public:
	FmFormPropController(FmPropControl* pMasterContr, ::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  _xForm,
						 FmFormShell* _pShell)
						 :FmPropController(pMasterContr, _xForm, _pShell){}

	virtual sal_Bool SetObject( const ::com::sun::star::uno::Any& aToEditObj, const ::com::sun::star::uno::Any& aToEditCtr);
};

//========================================================================
// Controller speziell fuer FormComponents
class FmFormComponentPropController : public FmPropController
{
public:
	FmFormComponentPropController(FmPropControl* pMasterContr, ::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  _xForm,
								  FmFormShell* _pShell)
								  :FmPropController(pMasterContr, _xForm, _pShell){}

	virtual sal_Bool SetObject( const ::com::sun::star::uno::Any& aToEditObj, const ::com::sun::star::uno::Any& aToEditCtr);
};

//========================================================================
// Controller speziell fuer GridColumns
class FmColumnPropController : public FmPropController
{
public:
	FmColumnPropController(FmPropControl* pMasterContr, ::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  _xForm,
						   FmFormShell* _pShell)
						:FmPropController(pMasterContr, _xForm, _pShell){}

	virtual sal_Bool SetObject( const ::com::sun::star::uno::Any& aToEditObj,const ::com::sun::star::uno::Any& aToEditCtr );
};


//========================================================================
class FmPropBrw : public SfxFloatingWindow, public SfxControllerItem
{
	FmPropControl*	pMasterController;
	sal_Bool			m_bInitialStateChange;

protected:
	virtual void Resize();
	virtual void StateChanged(sal_uInt16 nSID, SfxItemState eState, const SfxPoolItem* pState);
	virtual void FillInfo( SfxChildWinInfo& rInfo ) const;
	virtual sal_Bool Close();

public:
	FmPropBrw(SfxBindings *pBindings, SfxChildWindow *pMgr, Window* pParent);
	virtual ~FmPropBrw();
};

//========================================================================
class FmPropBrwMgr : public SfxChildWindow
{
public:
	FmPropBrwMgr(Window *pParent, sal_uInt16 nId,
		SfxBindings *pBindings, SfxChildWinInfo *pInfo);
	SFX_DECL_CHILDWINDOW(FmPropBrwMgr);
};

//========================================================================
class FmPropBrwDlg : public ModalDialog
{
	FmPropControl	aPropControl;
	PushButton		aPB_Close;

public:
	FmPropBrwDlg(Window* pParent, ::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  _xForm, ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  _xObject);

private:
	DECL_LINK( OnClose, Button* );
};

class EvtUiDesc
{
public:
	::rtl::OUString	aName;
	UniString	aTrans;
	sal_uInt32	nHelpId;
	sal_uInt16	nIndex;

	EvtUiDesc(sal_uInt16 nId, const ::rtl::OUString& aTmpName, const UniString& aTmpTrans, sal_uInt32 nTmpHelpId):
		nIndex (nId),
		aName  (aTmpName),
		aTrans (aTmpTrans),
		nHelpId(nTmpHelpId)
		{}
};

EvtUiDesc* GetEvtTranslation(const ::rtl::OUString& rName);

//========================================================================
class FmSelectLabelDialog : public ModalDialog
{
	FixedText		m_aMainDesc;
	SvTreeListBox	m_aControlTree;
	CheckBox		m_aNoAssignment;
	FixedLine		m_aSeparator;
	OKButton		m_aOk;
	CancelButton	m_aCancel;

	ImageList		m_aModelImages;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > 	m_xControlModel;
	::rtl::OUString			m_sRequiredService;
	Image			m_aRequiredControlImage;
	SvLBoxEntry*	m_pInitialSelection;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > 	m_xInitialLabelControl;

	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > 	m_xSelectedControl;
	SvLBoxEntry*	m_pLastSelected;

public:
	FmSelectLabelDialog(Window* pParent, ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  _xControlModel);
	~FmSelectLabelDialog();

	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  GetSelected() const { return m_aNoAssignment.IsChecked() ? ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > () : m_xSelectedControl; }

protected:
	sal_Int32 InsertEntries(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& _xContainer, SvLBoxEntry* pContainerEntry);

	DECL_LINK(OnEntrySelected, SvTreeListBox*);
	DECL_LINK(OnNoAssignmentClicked, Button*);
};

#endif

