/*************************************************************************
 *
 *  $RCSfile: propctrs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SVX_PROPCTRS_HXX
#define SVX_PROPCTRS_HXX

#ifndef _VIRDEV_HXX //autogen
#include <vcl/virdev.hxx>
#endif
#ifndef SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef SV_MOREBTN_HXX
#include <vcl/morebtn.hxx>
#endif
#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif

#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>

#ifndef _SV_VIRDEV_HXX //autogen
#include <vcl/virdev.hxx>
#endif

#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif

#ifndef _SVARRAY_HXX //autogen
#include <svarray.hxx>
#endif

#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif

#ifndef	_SVSTDARR_STRINGS
#define _SVSTDARR_STRINGS
#include <svtools/svstdarr.hxx>
#endif

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _SV_TABCTRL_HXX //autogen
#include <vcl/tabctrl.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef _LONGCURR_HXX //autogen
#include <vcl/longcurr.hxx>
#endif

//========================================================================
enum eKindOfControl {	KOC_UNDEFINED=0,	KOC_LISTBOX=1,	KOC_COMBOBOX=2,
						KOC_EDIT=3,			KOC_COLORBOX=4,	KOC_USERDEFINED=5,
						KOC_MEDIT=6,		KOC_NUMFIELD=7,	KOC_DATEFIELD=8,
						KOC_TIMEFIELD=9,	KOC_LEDIT=10,	KOC_CURFIELD=11,
						KOC_CHAREDIT=12
					};


//========================================================================
class SvxPropCtrListener;

class SvxPropControl
{
public:
		virtual							~SvxPropControl() { };
		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*)=0;

		virtual SvxPropCtrListener*		GetSvxPropCtrListener()=0;
		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False)=0;
		virtual ::rtl::OUString					GetProperty()const=0;
		virtual sal_Bool					HasList()=0;
		virtual void					ClearList()=0;
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND )=0;

		virtual void					SetCtrSize(const Size& rSize)=0;
		virtual void					SetCtrPos(const Point& aPoint)=0;
		virtual Point					GetCtrPos() const=0;
		virtual Size					GetCtrSize() const=0;
		virtual void					SetCtrHelpId(sal_uInt32 nHelpId)=0;

		virtual sal_Bool					IsModified()=0;
		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )=0;

		virtual	void					ShowCtr(sal_Bool bFlag=sal_True)=0;
		virtual	void					HideCtr()=0;

		virtual	void					SetCtrParent(Window *)=0;
		virtual	void					InvalidateCtr()=0;
		virtual	void					UpdateCtr()=0;

		virtual Window*					GetMe()=0;

		virtual void					SetLocked(sal_Bool bLocked=sal_True)=0;

		virtual void					SetMyName(const ::rtl::OUString &rString)=0;
		virtual ::rtl::OUString			GetMyName()const=0;

		virtual void					SetMyData(void*)=0;
		virtual void*					GetMyData()=0;

		virtual sal_Bool					GetDirection()=0;

		virtual void					SetLine(sal_uInt16 nLine)=0;
		virtual sal_uInt16					GetLine()=0;
};

//========================================================================
class SvxPropCtrListener
{

public:
		virtual void					Modified (SvxPropControl *pSvXPCtr)=0;
		virtual void					GetFocus (SvxPropControl *pSvXPCtr)=0;
		virtual void					LoseFocus(SvxPropControl *pSvXPCtr)=0;
		virtual void					KeyInput (SvxPropControl *pSvXPCtr ,const KeyCode&)=0;
		virtual void					GotoLine(SvxPropControl *pSvXPCtr)=0;
};

//========================================================================
class SvxPropEdit : public SvxPropControl,Edit
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		sal_Bool							bPassWord:1;
		

		DECL_LINK(ModifiedHdl,Edit*);
		DECL_LINK(GetFocusHdl,Edit*);
		DECL_LINK(LoseFocusHdl,Edit*);

protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropEdit( Window* pParent,sal_Bool bPassWord,
													WinBits nWinStyle = WB_TABSTOP);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);
		virtual Window*					GetMe();


		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropNumField : public SvxPropControl,NumericField
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,Edit*);
		DECL_LINK(GetFocusHdl,Edit*);
		DECL_LINK(LoseFocusHdl,Edit*);

protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropNumField( Window* pParent,sal_uInt16 nDigits,
													WinBits nWinStyle = WB_TABSTOP);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);
		virtual Window*					GetMe();


		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropCurField : public SvxPropControl,LongCurrencyField
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,Edit*);
		DECL_LINK(GetFocusHdl,Edit*);
		DECL_LINK(LoseFocusHdl,Edit*);

protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropCurField( Window* pParent,sal_uInt16 nDigits,
													WinBits nWinStyle = WB_TABSTOP);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);
		virtual Window*					GetMe();


		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropDateField : public SvxPropControl,DateField
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,Edit*);
		DECL_LINK(GetFocusHdl,Edit*);
		DECL_LINK(LoseFocusHdl,Edit*);

protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropDateField( Window* pParent,
													WinBits nWinStyle = WB_TABSTOP);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);
		virtual Window*					GetMe();


		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropTimeField: public SvxPropControl,TimeField
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,Edit*);
		DECL_LINK(GetFocusHdl,Edit*);
		DECL_LINK(LoseFocusHdl,Edit*);

protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropTimeField( Window* pParent,
													WinBits nWinStyle = WB_TABSTOP);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);
		virtual Window*					GetMe();


		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class PrivMEdit;

class SvxPropMultiEdit : public SvxPropControl,Control
{
private:

		::rtl::OUString							aName;
		PrivMEdit*						pMEdit;
		MultiLineEdit*					mpImplEdit;
		PushButton*						mpBtn;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;		
		sal_Bool							bModified:1;
		sal_Bool							bDropDown:1;
		sal_Bool							bEdit:1;

		DECL_LINK(ReturnHdl,PrivMEdit*);
		DECL_LINK(ModifiedHdl,Edit*);
		DECL_LINK(GetFocusHdl,Edit*);
		DECL_LINK(LoseFocusHdl,Edit*);
		DECL_LINK(DropDownHdl, PushButton*);

protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );
		void							Resize();

		long							FindPos(long nSinglePos);

public:
										SvxPropMultiEdit( Window* pParent,sal_Bool bEdit,
													WinBits nWinStyle = WB_TABSTOP | WB_DROPDOWN);

										~SvxPropMultiEdit();

		virtual void					GetFocus();
		virtual sal_Bool					ShowDropDown( sal_Bool bShow );

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);
		virtual Window*					GetMe();


		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropListBox : public SvxPropControl, ListBox
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,ListBox*);
		DECL_LINK(GetFocusHdl,ListBox*);
		DECL_LINK(LoseFocusHdl,ListBox*);


protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropListBox( Window* pParent,
												WinBits nWinStyle = WB_TABSTOP | WB_SORT
														|WB_DROPDOWN|WB_AUTOSIZE);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		ListBox*						GetListBox();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual Window*					GetMe();

		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);

		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};


//========================================================================
class SvxPropColorBox : public SvxPropControl, ColorListBox
{
private:

		::rtl::OUString							aName;
		::rtl::OUString							aStandard;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,ColorListBox*);
		DECL_LINK(GetFocusHdl,ColorListBox*);
		DECL_LINK(LoseFocusHdl,ColorListBox*);


protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );

public:
										SvxPropColorBox( Window* pParent,::rtl::OUString aStandard,
												WinBits nWinStyle = WB_TABSTOP |WB_DROPDOWN|
															WB_AUTOSIZE);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		ListBox*						GetListBox();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual Window*					GetMe();

		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);

		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropComboBox : public SvxPropControl, ComboBox
{
private:

		::rtl::OUString							aName;
		SvxPropCtrListener*				pListener;
		void*							pData;
		sal_uInt16							nLine;
		sal_Bool							bDir:1;
		sal_Bool							bLocked:1;
		sal_Bool							bModified:1;
		

		DECL_LINK(ModifiedHdl,ComboBox*);
		DECL_LINK(GetFocusHdl,ComboBox*);
		DECL_LINK(LoseFocusHdl,ComboBox*);


protected:

		virtual long					PreNotify( NotifyEvent& rNEvt );


public:
										SvxPropComboBox( Window* pParent,
												WinBits nWinStyle = WB_TABSTOP | WB_SORT |
																WB_DROPDOWN | WB_AUTOSIZE);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener*);

		virtual SvxPropCtrListener*		GetSvxPropCtrListener();

		ComboBox*						GetComboBox();

		virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown=sal_False);
		virtual ::rtl::OUString					GetProperty()const;
		virtual sal_Bool					IsModified();

		virtual sal_Bool					HasList();
		virtual void					ClearList();
		virtual	void					InsertCtrEntry( const ::rtl::OUString& rString,
												sal_uInt16 nPos = LISTBOX_APPEND );

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId);

		virtual void					SetCtrSize(const Size& rSize);
		virtual void					SetCtrPos(const Point& aPoint);
		virtual Point					GetCtrPos() const;
		virtual Size					GetCtrSize() const;

		virtual Window*					GetMe();

		virtual	void					ShowCtr(sal_Bool bFlag=sal_True);
		virtual	void					HideCtr();

		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );
		virtual	void					SetCtrParent(Window *);
		virtual	void					InvalidateCtr();
		virtual	void					UpdateCtr();

		virtual void					SetLocked(sal_Bool bLocked=sal_True);

		virtual void					SetMyName(const ::rtl::OUString &rString);
		virtual ::rtl::OUString			GetMyName()const;

		virtual void					SetMyData(void*);
		virtual void*					GetMyData();

		virtual sal_Bool					GetDirection();
		virtual void					SetLine(sal_uInt16 nLine);
		virtual sal_uInt16					GetLine();
};

//========================================================================
class SvxPropCommonControl : public SvxPropControl
{
protected:
		::rtl::OUString							m_sStandardString;
		::rtl::OUString							m_aName;
		Window*							m_pMeAsWindow;
		SvxPropCtrListener*				m_pListener;
		void*							m_pData;
		sal_uInt16							m_nLine;
		sal_Bool							m_bDir		: 1;
		sal_Bool							m_bLocked	: 1;
		sal_Bool							m_bModified	: 1;

public:
										SvxPropCommonControl(Window* pMeAsWin, const ::rtl::OUString& rStandard);

		virtual void					SetSvxPropCtrListener(SvxPropCtrListener* p){ m_pListener = p; }
		virtual SvxPropCtrListener*		GetSvxPropCtrListener()						{ return m_pListener; }

		virtual sal_Bool					HasList()									{ return sal_False; }
		virtual void					ClearList()									{ return; }
		virtual	void					InsertCtrEntry(const ::rtl::OUString& rString, sal_uInt16 nPos = LISTBOX_APPEND)	{ return; }

		virtual sal_Bool					IsModified() { return m_bModified; }

		virtual void					SetMyName(const ::rtl::OUString &rString)			{ m_aName = rString; }
		virtual ::rtl::OUString			GetMyName()const							{ return m_aName; }

		virtual void					SetMyData(void* pData)						{ m_pData = pData; }
		virtual void*					GetMyData()									{ return m_pData; }

		virtual sal_Bool					GetDirection()								{ return m_bDir; }

		virtual void					SetLine(sal_uInt16 nLine)						{ m_nLine = nLine; }
		virtual sal_uInt16					GetLine()									{ return m_nLine; }

		virtual void					SetLocked(sal_Bool bLocked=sal_True);

		virtual Window*					GetMe()										{ return m_pMeAsWindow; }

		virtual void					SetCtrSize(const Size& rSize)				{ m_pMeAsWindow->SetSizePixel(rSize); }
		virtual void					SetCtrPos(const Point& aPoint)				{ m_pMeAsWindow->SetPosPixel(aPoint); }
		virtual Point					GetCtrPos() const							{ return m_pMeAsWindow->GetPosPixel(); }
		virtual Size					GetCtrSize() const							{ return m_pMeAsWindow->GetSizePixel(); }
		virtual	void					ShowCtr(sal_Bool bFlag=sal_True)					{ m_pMeAsWindow->Show(bFlag); }
		virtual	void					HideCtr()									{ m_pMeAsWindow->Hide(); }

		virtual void					SetCtrHelpId(sal_uInt32 nHelpId)					{ m_pMeAsWindow->SetHelpId(nHelpId); }
		virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags )	{ m_pMeAsWindow->SetZOrder(pRefWindow,nFlags); }
		virtual	void					SetCtrParent(Window* pParent)				{ m_pMeAsWindow->SetParent(pParent); }
		virtual	void					InvalidateCtr()								{ m_pMeAsWindow->Invalidate(); }
		virtual	void					UpdateCtr()									{ m_pMeAsWindow->Update(); }

protected:
		/// may be used to implement the default handling in PreNotify; returns sal_True if handled
		sal_Bool HandlePreNotify(NotifyEvent& rNEvt);

		/// may be used by derived classes, they forward the event to the PropCtrListener
		DECL_LINK(ModifiedHdl,Window*);
		DECL_LINK(GetFocusHdl,Window*);
		DECL_LINK(LoseFocusHdl,Window*);
};


#endif

