/*************************************************************************
 *
 *  $RCSfile: property.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SVX_PROPERTY_HXX
#define SVX_PROPERTY_HXX

#ifndef _VIRDEV_HXX //autogen
#include <vcl/virdev.hxx>
#endif
#ifndef SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef SV_MOREBTN_HXX
#include <vcl/morebtn.hxx>
#endif
#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif

#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>

#ifndef _SV_VIRDEV_HXX //autogen
#include <vcl/virdev.hxx>
#endif

#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif

#ifndef _SVARRAY_HXX //autogen
#include <svarray.hxx>
#endif

#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif

#ifndef	_SVSTDARR_STRINGS
#define _SVSTDARR_STRINGS
#include <svtools/svstdarr.hxx>
#endif

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _SV_TABCTRL_HXX //autogen
#include <vcl/tabctrl.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef SVX_PROPCTRS_HXX
#include "propctrs.hxx"
#endif

#include <vector>

//========================================================================
class SvxPropertyLine// : public TabPage
{
private:
			FixedText			aFtTitle;
			Size				aOutputSize;
			Point				aLinePos;
			SvxPropControl*		pSvXPropertyControl;
			PushButton*			pXButton;
			Window*				pTheParent;
			void*				pData;
			eKindOfControl		eKindOfCtr;
			sal_uInt16			nNameWidth;
			sal_Bool			bNewNameWidth:1;
			sal_Bool			bNeedsRepaint:1;
			sal_Bool			bIsLocked:1;
			sal_Bool			bHasXButton:1;
			sal_Bool			bIsHyperlink:1;

			DECL_LINK(GetFocusHdl,PushButton*);


protected:
			virtual void		Resize();
			void				SetControlPosSize(Point aPos,Size aSize);

public:
			SvxPropertyLine( Window* pParent);
			~SvxPropertyLine();

			sal_Bool					NeedsRepaint();
			void						SetNeedsRepaint(sal_Bool bFlag);
			void						SetSvxPropControl(SvxPropControl*);
			SvxPropControl*				GetSvxPropControl();

			void						SetKindOfControl(eKindOfControl);
			eKindOfControl				GetKindOfControl();

			void						SetHelpId(sal_uInt32 nCtrHelpId,sal_uInt32 nBtUniqueId);

			void						SetTitle(const XubString& rString );
			XubString					GetTitle() const;
			void						SetTitleWidth(sal_uInt16);

			void						SetSizePixel(Size aSize);
			void						SetPosPixel(Point aPos);
			void						SetPosSizePixel(Point aPos,Size aSize);
			Size						GetSizePixel();
			void						Show(sal_Bool bFlag=sal_True);
			void						Hide();
			sal_Bool					IsVisible();
			void						Invalidate();
			void						Update();

			Window*						GetRefWindow();
			void						SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags );

			sal_Bool					SetFocus();
			void						ShowXButton();
			void						HideXButton();
			sal_Bool					IsVisibleXButton();
			void						ShowAsHyperLink(sal_Bool nFlag=sal_True);
			sal_Bool					IsShownAsHyperlink();

			void						Locked(sal_Bool nFlag=sal_True);
			sal_Bool					IsLocked();

			void						SetClickHdl(const Link&);
			void						SetData(void* pDat);
			void*						GetData();
};

//========================================================================
struct SvxPropData
{
	UniString					aName;	
	UniString					aTitle;
	UniString					aValue;
	::std::vector< UniString>	theValues; // ???
	void*						pDataPtr;
	SvxPropControl*				pControl;
	eKindOfControl				eKind;
	sal_uInt32					nHelpId;
	sal_uInt32					nBtUniqueId;
	sal_uInt16					nDigits;	// Fuer NumericFields
								
	sal_Bool					bIsUnknown:1;
	sal_Bool					bHasDefault:1;
	sal_Bool					bHasVisibleXButton:1;
	sal_Bool					bIsHyperLink:1;
	sal_Bool					bIsLocked:1;
		
	SvxPropData():eKind(KOC_UNDEFINED)
		,nHelpId(0)
		,bIsUnknown(sal_False)
		,bHasDefault(sal_False)
		,bHasVisibleXButton(sal_False)
		,bIsHyperLink(sal_False)
		,bIsLocked(sal_False)
		,pDataPtr(NULL)
		,pControl(NULL)
		,nDigits(0)
		,nBtUniqueId(0) { }
	// does not copy theValues
	SvxPropData(const SvxPropData& rData):eKind(rData.eKind)
		,aValue(rData.aValue)
		,aTitle(rData.aTitle)
		,aName(rData.aName)		
		,nHelpId(rData.nHelpId)
		,bIsUnknown(rData.bIsUnknown)
		,bHasDefault(rData.bHasDefault)
		,bHasVisibleXButton(rData.bHasVisibleXButton)
		,bIsHyperLink(rData.bIsHyperLink)
		,bIsLocked(rData.bIsLocked)
		,pDataPtr(rData.pDataPtr)
		,pControl(rData.pControl)
		,nDigits(rData.nDigits)
		,nBtUniqueId(rData.nBtUniqueId) 
	{}
};

//========================================================================
class SvxPropDataListener
{
public:					
		virtual void	Modified(	const XubString& aName,
									const XubString& aVal,
									void* pData)=0;
						
		virtual void	Clicked(	const XubString& aName,
									const XubString& aVal,
									void* pData)=0;
						
		virtual void	Commit(		const XubString& aName,
									const XubString& aVal,
									void* pData)=0;
						
		virtual void	Select(		const XubString& aName,
									void* pData)=0;
						
		virtual void	LinkClicked(const XubString& aName,
													void* pData)=0;
};

//========================================================================
class SvxPrivatEvtListener: public SvxPropCtrListener
{
		Link							aModifyLink;
		Link							aGetFocusLink;
		Link							aLoseFocusLink;
		Link							aKeyInputLink;
		Link							aGotoLineLink;
		XubString						aModifiedResult;

		SvxPropControl *				pTheActiveControl;
		KeyCode							aKeyCode;

public:
										SvxPrivatEvtListener();

		virtual void					Modified (SvxPropControl *pSvXPCtr);
		virtual void					GetFocus (SvxPropControl *pSvXPCtr);
		virtual void					LoseFocus(SvxPropControl *pSvXPCtr);
		virtual void					KeyInput(SvxPropControl *pSvXPCtr ,const KeyCode&);
		virtual void					GotoLine(SvxPropControl *pSvXPCtr);

		SvxPropControl *				GetPropertyControl();
		KeyCode							GetKeyCode() const;

		void							SetModifyHdl( const Link& rLink ) { aModifyLink = rLink; }
		const Link&						GetModifyHdl() const { return aModifyLink; }

		void							SetGetFocusHdl( const Link& rLink ) { aGetFocusLink = rLink; }
		const Link&						GetGetFocusHdl() const { return aGetFocusLink; }

		void							SetLoseFocusHdl( const Link& rLink ) { aLoseFocusLink = rLink; }
		const Link&						GetLoseFocusHdl() const { return aLoseFocusLink; }

		void							SetKeyInputHdl( const Link& rLink ) { aKeyInputLink = rLink; }
		const Link&						GetKeyInputHdl() const { return aKeyInputLink; }

		void							SetGotoLineHdl( const Link& rLink ) { aGotoLineLink = rLink; }
		const Link&						GetGotoLineHdl() const { return aGotoLineLink; }

};

typedef SvxPropertyLine * SvxPropertyLinePtr;

SV_DECL_PTRARR(SvxPropLineArray,SvxPropertyLinePtr,1,1);

//========================================================================
class SvxLBoxForProps: public Control
{
private:

			SvxPrivatEvtListener		aListener;
			Window						aPlayGround;
			ScrollBar					aVScroll;
			SvxPropLineArray			PLineArray;
			::rtl::OUString				aStandard;
			SvxPropDataListener*		pPropDataControl;
			long						nYOffset;
			sal_uInt16					nSelectedLine;
			sal_uInt16					nTheNameSize;
			sal_uInt16					nRowHeight;
			sal_Bool					bIsActiv:1;
			sal_Bool					bUpdate:1;

			DECL_LINK(   ScrollHdl,ScrollBar*);
			DECL_LINK(	 ClickHdl ,PushButton*);

			DECL_LINK(   ModifyHdl,SvxPrivatEvtListener*);
			DECL_LINK( GetFocusHdl,SvxPrivatEvtListener*);
			DECL_LINK(LoseFocusHdl,SvxPrivatEvtListener*);
			DECL_LINK( KeyInputHdl,SvxPrivatEvtListener*);
			DECL_LINK( GotoLineHdl,SvxPrivatEvtListener*);

protected:
			void						ShowLine(sal_uInt16 i);
			void						UpdatePosNSize();
			void						UpdatePlayGround();
			void						UpdateVScroll();
			void						ShowEntry(sal_uInt16 nPos);
			void						MoveThumbTo(long nNewThumbPos);
			void						Resize();


public:
										SvxLBoxForProps( Window* pParent, WinBits nWinStyle = WB_DIALOGCONTROL );
										SvxLBoxForProps( Window* pParent, const ResId& rResId );

										~SvxLBoxForProps();

			void						UpdateAll();

			virtual void				Activate(sal_Bool bFlag=sal_True);

			virtual sal_uInt16			CalcVisibleLines();
			virtual void				EnableUpdate();
			virtual void				DisableUpdate();

			virtual void				SetController(SvxPropDataListener *);

			virtual void				Clear();

			virtual sal_uInt16 			InsertEntry( const SvxPropData&, sal_uInt16 nPos = LISTBOX_APPEND );

			virtual void				ChangeEntry( const SvxPropData&, sal_uInt16 nPos);

			virtual sal_uInt16 			AppendEntry( const SvxPropData&);

			virtual void				SetPropertyValue( const ::rtl::OUString & rEntryName, const ::rtl::OUString & rValue );
			virtual ::rtl::OUString		GetPropertyValue( const ::rtl::OUString & rEntryName ) const;
			virtual sal_uInt16			GetPropertyPos( const ::rtl::OUString& rEntryName ) const;
			virtual void				SetPropertyData( const ::rtl::OUString& rEntryName, void* pData );
			virtual SvxPropControl*		GetPropertyControl( const ::rtl::OUString& rEntryName );

			virtual void				SetFirstVisibleEntry(sal_uInt16 nPos);
			virtual sal_uInt16			GetFirstVisibleEntry();

			virtual void				SetSelectedEntry(sal_uInt16 nPos);
			virtual sal_uInt16			GetSelectedEntry();
};

//========================================================================
class SvxTPageForProps: public TabPage
{

private:

			SvxLBoxForProps				aLbProp;

protected:

			virtual void				Resize();
			virtual void				StateChanged( StateChangedType nType);



public:
			SvxTPageForProps(Window* pParent,WinBits nWinStyle = 0 );

			SvxLBoxForProps*			GetTheListBox();

			virtual void				ActivatePage();
			virtual void				DeactivatePage();
};

//========================================================================
class SvxBasicPropDataListener: public SvxPropDataListener
{
private:

		Link							aModifyLink;
		Link							aClickedLink;
		Link							aCommitLink;
		Link							aSelectLink;
		XubString						aEntryName;
		XubString						aEntryProperty;
		XubString						aCorrectProperty;
		void*							pTheData;
		sal_Bool						bCorrectness;

public:

		virtual void					Modified(	const XubString& aName,
													const XubString& aVal,
													void* pData);		//User has modified ::com::sun::star::beans::Property

		virtual void					Clicked(	const XubString& aName,
													const XubString& aVal,
													void* pData);		//Xtension-Button pressed

		virtual void					Commit(		const XubString& aName,
													const XubString& aVal,
													void* pData);		//User accept changes

		virtual void					Select(		const XubString& aName,
													void* pData);		//User select new Row

		virtual void					LinkClicked(const XubString& aName,
													void* pData);

		virtual void					SetIsCorrect(sal_Bool nFlag);

		virtual void					SetTheCorrectProperty(const XubString& aName);

		XubString						GetName() const; //Tell's the name of the ::com::sun::star::beans::Property
		XubString						GetProperty() const; //Tell's the content of the ::com::sun::star::beans::Property
		void*							GetData(); //Tell's the storage


		void							SetModifyHdl( const Link& rLink ) { aModifyLink = rLink; }
		const Link&						GetModifyHdl() const { return aModifyLink; }

		void							SetClickedHdl( const Link& rLink ) { aClickedLink = rLink; }
		const Link&						GetClickedHdl() const { return aClickedLink; }

		void							SetCommitHdl( const Link& rLink ) { aCommitLink = rLink; }
		const Link&						GetCommitHdl() const { return aCommitLink; }

		void							SetSelectHdl( const Link& rLink ) { aSelectLink = rLink; }
		const Link&						GetSelectHdl() const { return aSelectLink; }

};

//========================================================================
class SvxPropertyBox: public Control
{
private:
			TabControl					aTabControl;
			SvxPropDataListener*		pThePropDataCtr;
			sal_uInt16					nNextId;

protected:
			virtual void				Resize();

public:
										SvxPropertyBox	( Window* pParent, WinBits nWinStyle = WB_DIALOGCONTROL );
										SvxPropertyBox	( Window* pParent, const ResId& rResId );

										~SvxPropertyBox();

			virtual sal_uInt16			CalcVisibleLines();
			virtual void				EnableUpdate();		// auch IDL?
			virtual void				DisableUpdate();	// auch IDL?

			// AB: Hier beginnt das 'offizielle' Interface, das in IDL uebernommen werden soll
			virtual void				SetController(SvxPropDataListener *);

			virtual void				SetHelpId( sal_uInt32 nHelpId );
			virtual sal_uInt16 			AppendPage( const XubString & r,sal_uInt32 nHelpId=0);
			virtual void				SetPage( sal_uInt16 );
			virtual void				RemovePage(sal_uInt16 nID);
			virtual sal_uInt16 			GetCurPage();
			virtual void				ClearAll();
			virtual void				ClearTable();

			virtual void				SetPropertyValue( const ::rtl::OUString & rEntryName, const ::rtl::OUString & rValue );
			virtual ::rtl::OUString		GetPropertyValue( const ::rtl::OUString & rEntryName ) const;
			virtual sal_uInt16			GetPropertyPos( const ::rtl::OUString& rEntryName ) const;
			virtual void				SetPropertyData( const ::rtl::OUString& rEntryName, void* pData );
			virtual SvxPropControl*		GetPropertyControl( const ::rtl::OUString& rEntryName );

			virtual sal_uInt16 			InsertEntry( const SvxPropData&, sal_uInt16 nPos = LISTBOX_APPEND );
			virtual void				ChangeEntry( const SvxPropData&, sal_uInt16 nPos);
			virtual sal_uInt16 			AppendEntry( const SvxPropData&);

			virtual void				SetFirstVisibleEntry(sal_uInt16 nPos);
			virtual sal_uInt16			GetFirstVisibleEntry();

			virtual void				SetSelectedEntry(sal_uInt16 nPos);
			virtual sal_uInt16			GetSelectedEntry();
};

#endif // SVX_PROPERTY_HXX


