/*************************************************************************
 *
 *  $RCSfile: optinet2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXSLSTITM_HXX //autogen
#include <svtools/slstitm.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <sfx2/docfilt.hxx>
#endif
#ifndef _SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _TOOLS_INETDEF_HXX
#include <tools/inetdef.hxx>
#endif

#ifndef TF_UCB
#ifndef _CNTCOOK_HXX //autogen
#include <chaos/cntcook.hxx>
#endif
#endif

#ifndef _IODLG_HXX //autogen
#include <sfx2/iodlg.hxx>
#endif
#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif

#if (SUPD < 580) //! needs ucb changes
#ifndef _CHAOS_HTTPITEM_HXX
#include <chaos/httpitem.hxx>
#endif
#ifndef _CSTRITEM_HXX
#include <chaos/cstritem.hxx>
#endif
#endif

#ifndef _SFX_INIMGR_HXX //autogen
#include <sfx2/inimgr.hxx>
#endif
#include <sfx2/viewfrm.hxx>
#include <tools/urlobj.hxx>
#pragma hdrstop

#define _SVX_OPTINET2_CXX

#include "dialmgr.hxx"
#include "optinet2.hxx"
#include "multipat.hxx"
#include "dialogs.hrc"
#include "optinet2.hrc"
#include "helpid.hrc"

// static ----------------------------------------------------------------

#define INET_SEARCH_TOKEN 	'"'
#define RET_ALL				((short)200)

SV_IMPL_OP_PTRARR_SORT( TwoStringArr, TwoStringPtr )
SV_IMPL_PTRARR( SfxFilterPtrArr, SfxFilterPtr )

const char* SEARCHENGINE_INI	= "srcheng.ini";
const char* SEARCHENGINE_GROUP	= "SearchEngines-$(vlang)";

// -----------------------------------------------------------------------

String lcl_MakeTabEntry(const SfxFilter* pFilter)
{
	String sEntry(pFilter->GetMimeType());
	sEntry += '\t';
	sEntry += pFilter->GetWildcard().GetWildCard();
	sEntry += '\t';
	sEntry += pFilter->GetName();
#if defined(OS2) || defined(MAC)
	sEntry += '\t';
	sEntry += pFilter->GetTypeName();
#endif
	return sEntry;
}

// -----------------------------------------------------------------------

BOOL IsJavaInstalled_Impl( SfxIniManager* pIniMgr )
{
	BOOL bRet = FALSE;
	String aIniEntry;
	String aFullName = Config::GetConfigName( pIniMgr->Get( SFX_KEY_USERCONFIG_PATH ),
											  String::CreateFromAscii("java") );
	INetURLObject aIniFileObj( aFullName, INET_PROT_FILE );
	String aIniPath = aIniFileObj.getName();
	if ( pIniMgr->SearchFile( aIniPath ) )
	{
		Config aJavaCfg( aIniPath );
		aJavaCfg.SetGroup( "Java" );
		ByteString sTemp = aJavaCfg.ReadKey( ByteString(::rtl::OUStringToOString(pIniMgr->GetKeyName( SFX_KEY_JAVA_SYSTEMCLASSPATH ),RTL_TEXTENCODING_UTF8)) );
		String aJavaSystemClassPath = ::rtl::OStringToOUString(sTemp,RTL_TEXTENCODING_UTF8);
		String aJavaRuntimeLib = ::rtl::OStringToOUString(aJavaCfg.ReadKey( "RuntimeLib" ),RTL_TEXTENCODING_UTF8);
		if ( aJavaSystemClassPath.Len() && aJavaRuntimeLib.Len() )
			bRet = TRUE;
	}
	return bRet;
}

// -----------------------------------------------------------------------

void SvxNoSpaceEdit::KeyInput( const KeyEvent& rKEvent )
{
	if ( bOnlyNumeric )
	{
		const KeyCode& rKeyCode = rKEvent.GetKeyCode();
		USHORT nGroup = rKeyCode.GetGroup();
		USHORT nKey = rKeyCode.GetCode();
		BOOL bValid = ( KEYGROUP_NUM == nGroup || KEYGROUP_CURSOR == nGroup ||
						( KEYGROUP_MISC == nGroup && ( nKey < KEY_ADD || nKey > KEY_EQUAL ) ) );
		if ( !bValid && ( rKeyCode.IsMod1() && (
			 KEY_A == nKey || KEY_C == nKey || KEY_V == nKey || KEY_X == nKey || KEY_Z == nKey ) ) )
			// Erase, Copy, Paste, Select All und Undo soll funktionieren
			bValid = TRUE;

		if ( bValid )
			Edit::KeyInput(rKEvent);
	}
	else if( rKEvent.GetKeyCode().GetCode() != KEY_SPACE )
		Edit::KeyInput(rKEvent);
}

// -----------------------------------------------------------------------

void SvxNoSpaceEdit::Modify()
{
	Edit::Modify();

	if ( bOnlyNumeric )
	{
		XubString aValue = GetText();

		if ( !ByteString(::rtl::OUStringToOString(aValue,RTL_TEXTENCODING_UTF8)).IsNumericAscii() || (long)aValue.ToInt32() > USHRT_MAX )
			// der Hchstwert einer Portnummer ist USHRT_MAX
			ErrorBox( this, SVX_RES( RID_SVXERR_OPT_PROXYPORTS ) ).Execute();
	}
}

/********************************************************************/
/********************************************************************/
/*                                                                  */
/* 	SvxProxyTabPage                                                 */
/*                                                                  */
/*                                                                  */
/********************************************************************/
/********************************************************************/

SvxProxyTabPage::SvxProxyTabPage(Window* pParent, const SfxItemSet& rSet ) :
	SfxTabPage( pParent, ResId( RID_SVXPAGE_INET_PROXY, DIALOG_MGR() ), rSet ),
	aOptionGB   (this, ResId(GB_SETTINGS)),

	aProxyModeFT  (this, ResId(FT_PROXYMODE)),
	aProxyModeLB  (this, ResId(LB_PROXYMODE)),

	aHttpProxyFT      (this, ResId( FT_HTTP_PROXY	  )),
	aHttpProxyED      (this, ResId( ED_HTTP_PROXY     )),
	aHttpPortFT       (this, ResId( FT_HTTP_PORT      )),
	aHttpPortED       (this, ResId( ED_HTTP_PORT      ), TRUE),

	aFtpProxyFT       (this, ResId( FT_FTP_PROXY      )),
	aFtpProxyED       (this, ResId( ED_FTP_PROXY      )),
	aFtpPortFT        (this, ResId( FT_FTP_PORT       )),
	aFtpPortED        (this, ResId( ED_FTP_PORT       ), TRUE),

	aSocksProxyFT     (this, ResId( FT_SOCKS_PROXY    )),
	aSocksProxyED     (this, ResId( ED_SOCKS_PROXY    )),
	aSocksPortFT      (this, ResId( FT_SOCKS_PORT     )),
	aSocksPortED      (this, ResId( ED_SOCKS_PORT     ), TRUE),

	aSecurityProxyFT  (this, ResId( FT_SECURITY_PROXY )),
	aSecurityProxyED  (this, ResId( ED_SECURITY_PROXY )),
	aSecurityPortFT   (this, ResId( FT_SECURITY_PORT  )),
	aSecurityPortED   (this, ResId( ED_SECURITY_PORT  ), TRUE),

	aNoProxyForFT     (this, ResId( FT_NOPROXYFOR     )),
	aNoProxyForED     (this, ResId( ED_NOPROXYFOR     )),
	aNoProxyDescFT    (this, ResId( ED_NOPROXYDESC    ))
{
	FreeResource();

	aHttpPortED.SetMaxTextLen(5);
	aFtpPortED.SetMaxTextLen(5);
	aSocksPortED.SetMaxTextLen(5);
	aSecurityPortED.SetMaxTextLen(5);
	Link aLink = LINK( this, SvxProxyTabPage, LoseFocusHdl_Impl );
	aHttpPortED.SetLoseFocusHdl( aLink );
	aFtpPortED.SetLoseFocusHdl( aLink );
	aSocksPortED.SetLoseFocusHdl( aLink );
	aSecurityPortED.SetLoseFocusHdl( aLink );

	aProxyModeLB.SetSelectHdl(LINK( this, SvxProxyTabPage, ProxyHdl_Impl ));
#if !defined(WNT) && !defined(MAC)
	aProxyModeLB.RemoveEntry(1); //automatisch nur WNT/W95;MAC benutzt IC
#endif
}

/*-----------------12.08.96 14.55-------------------

--------------------------------------------------*/

SvxProxyTabPage::~SvxProxyTabPage()
{
}

/*-----------------12.08.96 14.55-------------------

--------------------------------------------------*/

SfxTabPage*	SvxProxyTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SvxProxyTabPage(pParent, rAttrSet);
}

/*-----------------12.08.96 14.55-------------------

--------------------------------------------------*/

void SvxProxyTabPage::Reset(const SfxItemSet&)
{
		  SfxItemState		eItemState = SFX_ITEM_UNKNOWN;
	const SfxItemSet&		rSet = GetItemSet();
	const SfxPoolItem*		pAttr = NULL;
	for ( USHORT i = SID_INET_PROXY_TYPE; i <= SID_INET_SECURITY_PROXY_PORT; ++i  )
	{
		USHORT nWhich = GetWhich(i);
		eItemState = rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pAttr );

		if ( eItemState != SFX_ITEM_SET )
			pAttr = NULL;

		switch ( i )
		{
			case SID_INET_PROXY_TYPE:
			{
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxUInt16Item), "UInt16Item erwartet" );
				USHORT nProxy = pAttr ? ( (const SfxUInt16Item*)pAttr )->GetValue() : 0;
				BOOL bHasAutomatic = ( aProxyModeLB.GetEntryCount() == 3 );
				if ( bHasAutomatic )
					aProxyModeLB.SelectEntryPos( nProxy );
				else
					aProxyModeLB.SelectEntryPos( nProxy == 0 ? 0 : 1 );
				BOOL bEnableProxyControls = ( bHasAutomatic ? nProxy == 2 : nProxy > 0 );
				aProxyModeLB.SaveValue();
				EnableControls_Impl( bEnableProxyControls );
			}
			break;

			case SID_INET_HTTP_PROXY_NAME:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
				if ( pAttr )
					aHttpProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
				aHttpProxyED.SaveValue();
			break;

			case SID_INET_HTTP_PROXY_PORT:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
				if ( pAttr )
					aHttpPortED.SetText(
						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
				aHttpPortED.SaveValue();
			break;

			case SID_INET_FTP_PROXY_NAME:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
				if ( pAttr )
					aFtpProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
				aFtpProxyED.SaveValue();
			break;

			case SID_INET_FTP_PROXY_PORT:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
				if ( pAttr )
					aFtpPortED.SetText(
						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
				aFtpPortED.SaveValue();
			break;

			case SID_INET_SOCKS_PROXY_NAME:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
				if ( pAttr )
					aSocksProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
				aSocksProxyED.SaveValue();
			break;

			case SID_INET_SOCKS_PROXY_PORT:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
				if ( pAttr )
					aSocksPortED.SetText(
						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
				aSocksPortED.SaveValue();
			break;

			case SID_INET_SECURITY_PROXY_NAME:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
				if ( pAttr )
					aSecurityProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
				aSecurityProxyED.SaveValue();
			break;

			case SID_INET_SECURITY_PROXY_PORT:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
				if ( pAttr )
					aSecurityPortED.SetText(
						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
				aSecurityPortED.SaveValue();
			break;

			case SID_INET_NOPROXY:
				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
				if ( pAttr )
					aNoProxyForED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
				aNoProxyForED.SaveValue();
			break;
		}
		pAttr = NULL;
	}
}

/*-----------------12.08.96 16.34-------------------

--------------------------------------------------*/

BOOL SvxProxyTabPage::FillItemSet(SfxItemSet& rSet)
{
	BOOL bModified=FALSE;
	USHORT nSelPos = aProxyModeLB.GetSelectEntryPos();
	if(aProxyModeLB.GetSavedValue() != nSelPos)
	{
		if(aProxyModeLB.GetEntryCount() == 3)
			rSet.Put(SfxUInt16Item( SID_INET_PROXY_TYPE, nSelPos ));
		else
			rSet.Put(SfxUInt16Item( SID_INET_PROXY_TYPE, nSelPos == 0 ? 0 : 2));
		bModified = TRUE;
	}
	if(aHttpProxyED.GetSavedValue() != aHttpProxyED.GetText())
	{
		rSet.Put(SfxStringItem( SID_INET_HTTP_PROXY_NAME, aHttpProxyED.GetText()));
		bModified = TRUE;
	}

	if ( aHttpPortED.GetSavedValue() != aHttpPortED.GetText() )
	{
		rSet.Put(SfxInt32Item(SID_INET_HTTP_PROXY_PORT, aHttpPortED.GetText().ToInt32()));
		bModified = TRUE;
	}
	if(aFtpProxyED.GetSavedValue() != aFtpProxyED.GetText())
	{
		rSet.Put(SfxStringItem( SID_INET_FTP_PROXY_NAME, aFtpProxyED.GetText()));
		bModified = TRUE;
	}

	if ( aFtpPortED.GetSavedValue() != aFtpPortED.GetText() )
	{
		rSet.Put(SfxInt32Item(SID_INET_FTP_PROXY_PORT, aFtpPortED.GetText().ToInt32()));
		bModified = TRUE;
	}
	if(aSocksProxyED.GetSavedValue() != aSocksProxyED.GetText())
	{
		rSet.Put(SfxStringItem( SID_INET_SOCKS_PROXY_NAME, aSocksProxyED.GetText()));
		bModified = TRUE;
	}

	if ( aSocksPortED.GetSavedValue() != aSocksPortED.GetText() )
	{
		rSet.Put(SfxInt32Item(SID_INET_SOCKS_PROXY_PORT, aSocksPortED.GetText().ToInt32()));
		bModified = TRUE;
	}
	if(aSecurityProxyED.GetSavedValue() != aSecurityProxyED.GetText())
	{
		rSet.Put(SfxStringItem( SID_INET_SECURITY_PROXY_NAME, aSecurityProxyED.GetText()));
		bModified = TRUE;
	}

	if ( aSecurityPortED.GetSavedValue() != aSecurityPortED.GetText() )
	{
		rSet.Put(SfxInt32Item(SID_INET_SECURITY_PROXY_PORT, aSecurityPortED.GetText().ToInt32()));
		bModified = TRUE;
	}
	if ( aNoProxyForED.GetSavedValue() != aNoProxyForED.GetText() )
	{
		rSet.Put(SfxStringItem(SID_INET_NOPROXY, aNoProxyForED.GetText()));
		bModified = TRUE;
	}
	return bModified;
}

/*-----------------12.08.96 13.38-------------------

--------------------------------------------------*/


void SvxProxyTabPage::EnableControls_Impl(BOOL bEnable)
{
	aHttpProxyFT.Enable(bEnable);
	aHttpProxyED.Enable(bEnable);
	aHttpPortFT.Enable(bEnable);
	aHttpPortED.Enable(bEnable);

	aFtpProxyFT.Enable(bEnable);
	aFtpProxyED.Enable(bEnable);
	aFtpPortFT.Enable(bEnable);
	aFtpPortED.Enable(bEnable);

	aSocksProxyFT.Enable(bEnable);
	aSocksProxyED.Enable(bEnable);
	aSocksPortFT.Enable(bEnable);
	aSocksPortED.Enable(bEnable);

	aSecurityProxyFT.Enable(bEnable);
	aSecurityProxyED.Enable(bEnable);
	aSecurityPortFT.Enable(bEnable);
	aSecurityPortED.Enable(bEnable);

	aNoProxyForFT.Enable(bEnable);
	aNoProxyForED.Enable(bEnable);
	aNoProxyDescFT.Enable(bEnable);
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxProxyTabPage, ProxyHdl_Impl, ListBox *, pBox )
{
	BOOL bEnableProxyControls = pBox->GetEntryCount() - 1  == pBox->GetSelectEntryPos();
	EnableControls_Impl(bEnableProxyControls);

	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxProxyTabPage, LoseFocusHdl_Impl, Edit *, pEdit )
{
	XubString aValue = pEdit->GetText();

	if ( !ByteString(::rtl::OUStringToOString(aValue,RTL_TEXTENCODING_UTF8)).IsNumericAscii() || (long)aValue.ToInt32() > USHRT_MAX )
		pEdit->SetText( '0' );
	return 0;
}

/********************************************************************/
/********************************************************************/
/*                                                                  */
/* 	SvxCacheTabPage                                                 */
/*                                                                  */
/*                                                                  */
/********************************************************************/
/********************************************************************/

SvxCacheTabPage::SvxCacheTabPage(Window* pParent, const SfxItemSet& rSet ) :
		SfxTabPage( pParent, ResId( RID_SVXPAGE_INET_CACHE, DIALOG_MGR() ), rSet ),
		aOptionGB   (this, ResId(GB_SETTINGS)),
		aMemFT      (this, ResId(FT_MEM)),
		aMemED      (this, ResId(ED_MEM)),
		aBytesFT    (this, ResId(FT_BYTE)),
		aDelMemPB   (this, ResId(PB_DEL_MEM)),
		aDiskFT     (this, ResId(FT_DISK)),
		aDiskED     (this, ResId(ED_DISK)),
		aDocsFT    	(this, ResId(FT_DOCS)),
		aDelDiskPB  (this, ResId(PB_DEL_DISK)),
		aReorganizePB(this, ResId(PB_REORGANIZE_DISK)),
		aExpireFT   (this, ResId(FT_EXPIRE)),
		aExpireLB   (this, ResId(LB_EXPIRE)),
		aNoCacheGB	(this, ResId(GB_NOCACHE)),
		aServerFT	(this, ResId(FT_NOCACHE)),
		aDelimFT    (this, ResId(FT_NOCACHEDELIM)),
		aNoCacheED	(this, ResId(ED_NOCACHE)),
		aExpiredCB	(this, ResId(CB_EXPIRE)),
		bOldExpired   (FALSE)
{
	FreeResource();
	Link aLink( LINK( this, SvxCacheTabPage, DeleteHdl_Impl ));
	aDelMemPB.SetClickHdl( aLink );
	aDelDiskPB.SetClickHdl( aLink );
	aReorganizePB.SetClickHdl( aLink );
}

/*-----------------12.08.96 16.34-------------------

--------------------------------------------------*/

SvxCacheTabPage::~SvxCacheTabPage()
{
}

/*-----------------12.08.96 16.34-------------------

--------------------------------------------------*/

SfxTabPage*	SvxCacheTabPage::Create(Window* pParent,
						const SfxItemSet& rAttrSet )
{
	return new SvxCacheTabPage(pParent, rAttrSet);
}

/*-----------------21.06.98 9:39-------------------

--------------------------------------------------*/

void SvxCacheTabPage::Reset(const SfxItemSet&)
{
	const SfxItemSet& rSet = GetItemSet();
	const SfxPoolItem* pAttr = NULL;
	USHORT nWhich = GetWhich(SID_INET_MEMCACHE);
	SfxItemState eItemState = rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pAttr );
	if ( eItemState == SFX_ITEM_DEFAULT )
		pAttr = &( rSet.Get( nWhich ) );
	else if ( eItemState == SFX_ITEM_DONTCARE )
		pAttr = NULL;
	DBG_ASSERT(!pAttr || pAttr->ISA(SfxUInt16Item), "UInt16Item erwartet");
	if( pAttr )
	{
		aMemED.SetText(((const SfxUInt16Item*)pAttr)->GetValue());
		aMemED.SaveValue();
	}

#if (SUPD < 580) //! needs ucb changes
	CntAnchorRef xAnchor = new CntAnchor( NULL, "private:httpcache" );
	xAnchor->Put( SfxVoidItem(WID_GETDATA) );
	const SfxUInt32Item& rSizeLimit = (const SfxUInt32Item&)xAnchor->Get(WID_SIZE_LIMIT);
	ULONG nValue = rSizeLimit.GetValue();
	nValue /= 1024;
	aDiskED.SetText( nValue );
	aDiskED.SaveValue();

	const CntHTTPVerifyModeItem& rVerifyMode =
		(const CntHTTPVerifyModeItem&)xAnchor->Get(WID_HTTP_VERIFY_MODE);
	SetExpireLBValue( (USHORT)rVerifyMode.GetValue() );
	aExpireLB.SaveValue();

	const SfxBoolItem& rKeepExpiredItem =
		(const SfxBoolItem&)xAnchor->Get(WID_HTTP_KEEP_EXPIRED);
	aExpiredCB.Check( rKeepExpiredItem.GetValue() );
	aExpiredCB.SaveValue();

	const CntStringItem& rNoCacheListItem =
		(const CntStringItem&)xAnchor->Get(WID_HTTP_NOCACHE_LIST);
	aNoCacheED.SetText( rNoCacheListItem.GetValue());
	aNoCacheED.SaveValue();
#endif
}

/*-----------------12.08.96 13.41-------------------

--------------------------------------------------*/

BOOL SvxCacheTabPage::FillItemSet(SfxItemSet& rSet)
{
	BOOL bModified=FALSE;
	BOOL bCntModified = FALSE;
#if (SUPD < 580) //! needs ucb changes
	CntAnchorRef xAnchor = new CntAnchor( NULL, "private:httpcache" );
	xAnchor->Put( SfxVoidItem(WID_GETDATA) );
	SfxItemSet aCntResultSet( *xAnchor->GetPool(), TRUE );

	if ( (USHORT)aMemED.GetSavedValue() != aMemED.GetValue() )
	{
		rSet.Put(SfxUInt16Item(SID_INET_MEMCACHE, (USHORT)aMemED.GetValue()));
		bModified = TRUE;
	}
	if ( (ULONG)aDiskED.GetSavedValue() != (ULONG)aDiskED.GetValue() )
	{
		ULONG nValue = aDiskED.GetValue();
		nValue *= 1024;
		SfxUInt32Item aSizeLimit( WID_SIZE_LIMIT, nValue );
		aCntResultSet.Put( aSizeLimit );
		bCntModified = TRUE;
	}
	if( GetExpireLBValue() != aExpireLB.GetSavedValue())
	{
		CntHTTPVerifyMode eMode = (CntHTTPVerifyMode)GetExpireLBValue();
		CntHTTPVerifyModeItem aVerifyModeItem( WID_HTTP_VERIFY_MODE, eMode );
		aCntResultSet.Put( aVerifyModeItem );
		bCntModified = TRUE;
	}
	if( aNoCacheED.GetSavedValue() != aNoCacheED.GetText() )
	{
		CntStringItem aNoCacheItem( WID_HTTP_NOCACHE_LIST, aNoCacheED.GetText());
		aCntResultSet.Put( aNoCacheItem );
		bCntModified = TRUE;
	}
	if( aExpiredCB.IsChecked() != aExpiredCB.GetSavedValue() )
	{
		SfxBoolItem aKeepExpiredItem( WID_HTTP_KEEP_EXPIRED, aExpiredCB.IsChecked());
		aCntResultSet.Put( aKeepExpiredItem );
		bCntModified = TRUE;
	}
	if( bCntModified )
	{
		xAnchor->Put( aCntResultSet );
		bModified = TRUE;
	}
#endif
	return bModified;
}

/*-----------------12.08.96 13.41-------------------

--------------------------------------------------*/
/*
IMPL_LINK( SvxCacheTabPage, BrowseHdl_Impl, PushButton *, pBox )
{
	PathDialog* pDlg = new PathDialog( this, WB_3DLOOK );
	pDlg->SetPath( aPathED.GetText() );
	if ( pDlg->Execute() == RET_OK )
	{
		aPathED.SetText(pDlg->GetPath());
	}
	delete pDlg;
	return 0;
}
*/

/*-----------------12.08.96 13.19-------------------

--------------------------------------------------*/

IMPL_LINK( SvxCacheTabPage, DeleteHdl_Impl, PushButton *, pBtn )
{
	if ( SfxViewFrame::Current() && SfxViewFrame::Current()->GetDispatcher() )
		SfxViewFrame::Current()->GetDispatcher()->Execute( SID_CLEARMEMCACHE );
	return 0;
}

/*-----------------22.06.97 12.33-------------------

--------------------------------------------------*/

void SvxCacheTabPage::SetExpireLBValue( USHORT nExpire )
{
	ULONG nKey = CACHE_VERIFY_ONCE;
#if (SUPD < 580) //! needs ucb changes
	CntHTTPVerifyMode eMode = (CntHTTPVerifyMode)nExpire;
	switch( eMode )
	{
		case CNTHTTP_VERIFY_ALWAYS: nKey = CACHE_VERIFY_ALWAYS; break;
		case CNTHTTP_VERIFY_ONCE: nKey = CACHE_VERIFY_ONCE; break;
		case CNTHTTP_VERIFY_NEVER: nKey = CACHE_VERIFY_NEVER; break;
		default:
			nKey = CACHE_VERIFY_ONCE;
	}
#endif
	USHORT nPos = aExpireLB.GetEntryPos( (void*)nKey );
	aExpireLB.SelectEntryPos( nPos );
}

USHORT SvxCacheTabPage::GetExpireLBValue() const
{
#if (SUPD < 580) //! needs ucb changes
	ULONG nKey = (ULONG)aExpireLB.GetEntryData( aExpireLB.GetSelectEntryPos() );
	switch( nKey )
	{
		case CACHE_VERIFY_ALWAYS: return (USHORT)CNTHTTP_VERIFY_ALWAYS;
		case CACHE_VERIFY_ONCE: return (USHORT)CNTHTTP_VERIFY_ONCE;
		case CACHE_VERIFY_NEVER: return (USHORT)CNTHTTP_VERIFY_NEVER;
	}
	return (USHORT)CNTHTTP_VERIFY_ONCE;
#else
	return 0;
#endif
}

/********************************************************************/
/********************************************************************/
/*                                                                  */
/* 	SvxSearchTabPage                                                */
/*                                                                  */
/*                                                                  */
/********************************************************************/
/********************************************************************/

SvxSearchTabPage::SvxSearchTabPage(Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_INET_SEARCH ), rSet ),

	aSearchGB		( this, ResId( GB_SEARCH ) ),
	aSearchFT		( this, ResId( FT_SEARCH ) ),
	aSearchLB		( this, ResId( LB_SEARCH ) ),
	aSearchNameFT	( this, ResId( FT_SEARCH_NAME ) ),
	aSearchNameED	( this, ResId( ED_SEARCH_NAME ) ),
	aURLFT			( this, ResId( FT_URL ) ),
	aURLED			( this, ResId( ED_URL ) ),
	aAndRB			( this, ResId( RB_AND ) ),
	aOrRB			( this, ResId( RB_OR ) ),
	aExactRB		( this, ResId( RB_EXACT ) ),
	aSeparatorFT	( this, ResId( FT_SEPARATOR ) ),
	aSeparatorED	( this, ResId( ED_SEPARATOR ) ),
	aPostFixFT		( this, ResId( FT_POSTFIX ) ),
	aPostFixED		( this, ResId( ED_POSTFIX ) ),
	aCaseFT			( this, ResId( FT_CASE ) ),
	aCaseED			( this, ResId( ED_CASE ) ),
	aNewPB			( this, ResId( PB_NEW ) ),
	aAddPB			( this, ResId( PB_ADD ) ),
	aChangePB		( this, ResId( PB_CHANGE ) ),
	aDeletePB		( this, ResId( PB_DELETE ) ),
	sErrorNoFile	( 		ResId( STR_ERROR_NOFILE ) ),
	sErrorNoGroup	( 		ResId( STR_ERROR_NOGROUP ) )

{
	aCaseArr[0] = String(ResId(STR_CASE_NONE   ));
	aCaseArr[1] = String(ResId(STR_CASE_UPPER  ));
	aCaseArr[2] = String(ResId(STR_CASE_LOWER  ));
	FreeResource();
	aCaseED.SelectEntryPos(0); // falls kein Eintrag vorhanden ist, kann es sonst "Arger geben

	aNewPB.SetClickHdl(LINK( this, SvxSearchTabPage, NewSearchHdl_Impl ) );
	aAddPB.SetClickHdl(LINK( this, SvxSearchTabPage, AddSearchHdl_Impl ) );
	aChangePB.SetClickHdl(LINK( this, SvxSearchTabPage, ChangeSearchHdl_Impl ) );
	aDeletePB.SetClickHdl(LINK( this, SvxSearchTabPage, DeleteSearchHdl_Impl ) );
	aSearchLB.SetSelectHdl(LINK( this, SvxSearchTabPage, SearchEntryHdl_Impl ) );

	Link aLink = LINK( this, SvxSearchTabPage, SearchModifyHdl_Impl );
	aSearchNameED.SetModifyHdl( aLink );
	aURLED.SetModifyHdl( aLink );
	aSeparatorED.SetModifyHdl( aLink );
	aPostFixED.SetModifyHdl( aLink );
	aCaseED.SetSelectHdl( aLink );

	aLink = LINK( this, SvxSearchTabPage, SearchPartHdl_Impl );
	aAndRB.SetClickHdl( aLink );
	aOrRB.SetClickHdl( aLink );
	aExactRB.SetClickHdl( aLink );

	aErrorTimer.SetTimeout( 500 );
	aErrorTimer.SetTimeoutHdl( LINK( this, SvxSearchTabPage, ErrorHdl_Impl ) );
}

// -----------------------------------------------------------------------

SvxSearchTabPage::~SvxSearchTabPage()
{
}

// -----------------------------------------------------------------------

SfxTabPage*	SvxSearchTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SvxSearchTabPage(pParent, rAttrSet);
}

// -----------------------------------------------------------------------

void SvxSearchTabPage::Reset( const SfxItemSet& )
{
	String aIniFile( String::CreateFromAscii( SEARCHENGINE_INI ) );
	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	USHORT nCount = 0;
	sError.Erase();
	if ( pIniMgr->SearchFile( aIniFile ) )
	{
		Config aCfg( aIniFile );
		String aGroup = pIniMgr->SubstPathVars( String::CreateFromAscii( SEARCHENGINE_GROUP ) );
		if ( !aCfg.HasGroup( ByteString(aGroup,RTL_TEXTENCODING_UTF8) ) )
			aGroup.Erase( aGroup.Search( '-' ) );
		if ( aCfg.HasGroup( ByteString(aGroup,RTL_TEXTENCODING_UTF8) ) )
		{
			aCfg.SetGroup( ByteString(aGroup,RTL_TEXTENCODING_UTF8) );
			nCount = aCfg.GetKeyCount();
			for ( USHORT i = 0; i < nCount; i++ )
			{
				TwoString* pTwo = new TwoString( String(aCfg.GetKeyName(i),RTL_TEXTENCODING_UTF8), String(aCfg.ReadKey(i),RTL_TEXTENCODING_UTF8) );
				aSearchKeys.Insert( pTwo );
			}
		}
		else
		{
			sError = sErrorNoGroup;
			sError.SearchAndReplaceAscii( "%1", aGroup );
			sError.SearchAndReplaceAscii( "%2", aIniFile );
		}
	}
	else
	{
		sError = sErrorNoFile;
		sError.SearchAndReplaceAscii( "%1", aIniFile );
	}

	FillSearchBox_Impl();

	if ( nCount )
	{
		aSearchLB.SelectEntryPos(0);
		SearchEntryHdl_Impl( &aSearchLB );
	}
	else
		aDeletePB.Disable();

	aChangePB.Disable();
	aAddPB.Disable();
	aErrorTimer.Start();
}

// -----------------------------------------------------------------------

BOOL SvxSearchTabPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_ERRORFILE( "SvxSearchTabPage::FillItemSet() needs ucb" );
#if 0
	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	DirEntry aIniFile( pIniMgr->Get( SFX_KEY_USERCONFIG_PATH ) );
	String aIniName = String::CreateFromAscii( SEARCHENGINE_INI );
	aIniFile += DirEntry( aIniName );
	if ( !aIniFile.Exists() )
	{
		// if the user srcheng.ini not exists, first copy the share srcheng.ini
		DirEntry aSrcFile( pIniMgr->Get( SFX_KEY_CONFIG_DIR ) );
		aSrcFile += DirEntry( aIniName );
		if ( aSrcFile.Exists() )
			aSrcFile.CopyTo( aIniFile, FSYS_ACTION_COPYFILE );
	}
	Config aCfg( aIniFile.GetFull() );
	String aGroup = pIniMgr->SubstPathVars( String::CreateFromAscii( SEARCHENGINE_GROUP ) );
	aCfg.SetGroup( ByteString( aGroup, RTL_TEXTENCODING_UTF8 ) );
	USHORT i, nCount = aCfg.GetKeyCount();
	for ( i = nCount; i; i-- )
		aCfg.DeleteKey( aCfg.GetKeyName( i - 1 ) );
	nCount = aSearchKeys.Count();
	for ( i = 0; i < nCount; i++ )
	{
		TwoString* pTwo = aSearchKeys.GetObject(i);
		aCfg.WriteKey( ByteString( pTwo->aKeyName, RTL_TEXTENCODING_UTF8 ),
					   ByteString( pTwo->aKeyContent, RTL_TEXTENCODING_UTF8 ) );
	}
#endif
	return TRUE;
}

// -----------------------------------------------------------------------

void SvxSearchTabPage::FillSearchBox_Impl()
{
	aSearchLB.SetUpdateMode(FALSE);
	aSearchLB.Clear();
	TwoString* pTwo;
	USHORT nCount = aSearchKeys.Count();
	for( USHORT i = 0; i < nCount; i++  )
	{
		pTwo = aSearchKeys.GetObject(i);
		aSearchLB.InsertEntry(pTwo->aKeyName);
	}
	aSearchLB.SetUpdateMode(TRUE);
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, NewSearchHdl_Impl, PushButton *, EMPTYARG )
{
	aSearchNameED.SetText( String() );
	aSearchLB.SetNoSelection();
	sAndSave.Erase();
	sOrSave.Erase();
	sExactSave.Erase();
	aAndRB.Check( TRUE );
	SearchEntryHdl_Impl( &aSearchLB );
	SearchPartHdl_Impl( &aAndRB );
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, AddSearchHdl_Impl, PushButton *, EMPTYARG )
{
	TwoString* pTwo = new TwoString( aSearchNameED.GetText(), GetSearchString_Impl() );
	aSearchKeys.Insert( pTwo );
	aSearchLB.InsertEntry( pTwo->aKeyName );
	FillSearchBox_Impl();
	aSearchLB.SelectEntry( pTwo->aKeyName );
	SearchEntryHdl_Impl( &aSearchLB );
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, ChangeSearchHdl_Impl, PushButton *, EMPTYARG )
{
	USHORT nPos = aSearchLB.GetSelectEntryPos();
	if ( nPos != LISTBOX_ENTRY_NOTFOUND )
	{
		TwoString* pTwo =  aSearchKeys.GetObject(nPos);
		pTwo->aKeyContent = GetSearchString_Impl();
		FillSearchBox_Impl();
		aSearchLB.SelectEntry(pTwo->aKeyName);
		SearchEntryHdl_Impl(&aSearchLB);
	}
	else
	{
		SetUpdateMode(FALSE);
		String sEntry = aSearchNameED.GetText();
		// im AddHdl wird sLastSelectedEntry umgesetzt
		String sTemp(sLastSelectedEntry);
		AddSearchHdl_Impl(0);
		aSearchLB.SelectEntry(sTemp);
		DeleteSearchHdl_Impl(0);
		aSearchLB.SelectEntry(sEntry);
		SearchEntryHdl_Impl(&aSearchLB);
		SetUpdateMode(TRUE);
	}
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, DeleteSearchHdl_Impl, PushButton *, EMPTYARG)
{
	USHORT nPos = aSearchLB.GetSelectEntryPos();
	DBG_ASSERT(nPos != LISTBOX_ENTRY_NOTFOUND, "kein Eintrag selektiert!")
	aSearchLB.RemoveEntry(nPos);
	aSearchKeys.DeleteAndDestroy(nPos);
	FillSearchBox_Impl();
	aSearchLB.SelectEntryPos(0);
	SearchEntryHdl_Impl(&aSearchLB);
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, SearchEntryHdl_Impl, ListBox*, pBox )
{
	USHORT nEntryPos = pBox->GetSelectEntryPos();
	if ( nEntryPos != LISTBOX_ENTRY_NOTFOUND )
	{
		DBG_ASSERT(nEntryPos < aSearchKeys.Count(),"Index out of Range")
		TwoString* pTwo = aSearchKeys.GetObject(nEntryPos);
		aSearchNameED.SetText(pTwo->aKeyName);
		sLastSelectedEntry = pTwo->aKeyName;

		USHORT nRB = 0;
		if(aOrRB.IsChecked())
			nRB = 4;
		else if(aExactRB.IsChecked())
			nRB = 8;
		aURLED.SetText(pTwo->aKeyContent.GetToken(nRB,INET_SEARCH_TOKEN ));
		aSeparatorED.SetText( pTwo->aKeyContent.GetToken(nRB + 1,INET_SEARCH_TOKEN));
		aPostFixED.SetText(	pTwo->aKeyContent.GetToken(nRB + 2,INET_SEARCH_TOKEN));
		String sCase = pTwo->aKeyContent.GetToken(nRB + 3,INET_SEARCH_TOKEN);
		if(sCase.Len())
		{
			for(USHORT i = 0; i < 3; i++ )
			{
				if(sCase == aCaseArr[i])
				{
					aCaseED.SelectEntryPos(i);
					break;
				}
			}
		}
		else
			aCaseED.SelectEntryPos(0);

		sAndSave 	=  pTwo->aKeyContent.GetToken( 0,INET_SEARCH_TOKEN );
		sAndSave 	+= INET_SEARCH_TOKEN;
		sAndSave 	+= pTwo->aKeyContent.GetToken( 1,INET_SEARCH_TOKEN );
		sAndSave 	+= INET_SEARCH_TOKEN;
		sAndSave 	+= pTwo->aKeyContent.GetToken( 2,INET_SEARCH_TOKEN );
		sAndSave 	+= INET_SEARCH_TOKEN;
		sAndSave 	+= pTwo->aKeyContent.GetToken( 3,INET_SEARCH_TOKEN );

		sOrSave		=  pTwo->aKeyContent.GetToken( 4,INET_SEARCH_TOKEN );
		sOrSave		+= INET_SEARCH_TOKEN;
		sOrSave		+= pTwo->aKeyContent.GetToken( 5,INET_SEARCH_TOKEN );
		sOrSave		+= INET_SEARCH_TOKEN;
		sOrSave		+= pTwo->aKeyContent.GetToken( 6,INET_SEARCH_TOKEN );
		sOrSave		+= INET_SEARCH_TOKEN;
		sOrSave		+= pTwo->aKeyContent.GetToken( 7,INET_SEARCH_TOKEN );

		sExactSave 	=  pTwo->aKeyContent.GetToken( 8,INET_SEARCH_TOKEN );
		sExactSave 	+= INET_SEARCH_TOKEN;
		sExactSave 	+= pTwo->aKeyContent.GetToken( 9,INET_SEARCH_TOKEN );
		sExactSave 	+= INET_SEARCH_TOKEN;
		sExactSave 	+= pTwo->aKeyContent.GetToken(10,INET_SEARCH_TOKEN );
		sExactSave 	+= INET_SEARCH_TOKEN;
		sExactSave 	+= pTwo->aKeyContent.GetToken(11,INET_SEARCH_TOKEN );
		aDeletePB.Enable();
	}
	else
	{
		aDeletePB.Enable(FALSE);
		sLastSelectedEntry.Erase();
	}
	aChangePB.Enable(FALSE);
	aAddPB.Enable(FALSE);
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, SearchModifyHdl_Impl, SvxNoSpaceEdit*, pEdit )
{
	if ( pEdit == &aSearchNameED )
	{
		BOOL bTextLen = ( 0 != pEdit->GetText().Len() );
		BOOL bFound = FALSE;
		if ( bTextLen )
		{
			USHORT nEntryPos = aSearchLB.GetEntryPos( pEdit->GetText() );
			bFound = ( nEntryPos != LISTBOX_ENTRY_NOTFOUND );
			if ( bFound )
				aSearchLB.SelectEntryPos(nEntryPos);
			else
				aSearchLB.SetNoSelection();
		}
		aChangePB.Enable( sLastSelectedEntry.Len() > 0 );
		aDeletePB.Enable(bFound);
		aAddPB.Enable(bTextLen && !bFound);
	}
	else
	{
		if ( aSearchLB.GetSelectEntryCount() && sLastSelectedEntry.Len() > 0 )
			aChangePB.Enable();

		String sTemp = aURLED.GetText();
		sTemp += INET_SEARCH_TOKEN;
		sTemp += aSeparatorED.GetText();
		sTemp += INET_SEARCH_TOKEN;
		sTemp += aPostFixED.GetText();
		sTemp += INET_SEARCH_TOKEN;
		sTemp += aCaseArr[aCaseED.GetSelectEntryPos()];
		if ( aAndRB.IsChecked() )
			sAndSave = sTemp;
		else if ( aOrRB.IsChecked() )
			sOrSave = sTemp;
		else
			sExactSave = sTemp;
	}
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, SearchPartHdl_Impl, RadioButton *, pButton )
{
	String sTemp = sAndSave;
	if ( pButton == &aOrRB  )
		sTemp = sOrSave;
	else if ( pButton == &aExactRB )
		sTemp = sExactSave;
	aURLED.SetText(	sTemp.GetToken( 0, INET_SEARCH_TOKEN ) );
	aSeparatorED.SetText( sTemp.GetToken( 1, INET_SEARCH_TOKEN ) );
	aPostFixED.SetText( sTemp.GetToken( 2, INET_SEARCH_TOKEN ) );
	String sCase = sTemp.GetToken( 3, INET_SEARCH_TOKEN );
	if ( sCase.Len() )
	{
		for ( USHORT i = 0; i < 3; i++ )
		{
			if ( sCase == aCaseArr[i] )
			{
				aCaseED.SelectEntryPos(i);
				break;
			}
		}
	}
	else
		aCaseED.SelectEntryPos(0);
	return 0;
}

// -------------------------------------------------------------------

IMPL_LINK( SvxSearchTabPage, ErrorHdl_Impl, Timer *, EMPTYARG )
{
	if ( sError.Len() )
	{
		ErrorBox aBox( IsReallyVisible() ? this : NULL, WB_OK, sError );
		sError.Erase();
		aBox.SetText( GetText() );
		aBox.Execute();
	}

	return 0;
}

// -----------------------------------------------------------------------

String SvxSearchTabPage::GetSearchString_Impl()
{
	String sTemp = sAndSave;
	sTemp += INET_SEARCH_TOKEN;
	sTemp += sOrSave;
	sTemp += INET_SEARCH_TOKEN;
	sTemp += sExactSave;
	return sTemp;
}

/********************************************************************/
/********************************************************************/
/*                                                                  */
/* 	SvxTypeTabPage                                                 */
/*                                                                  */
/*                                                                  */
/********************************************************************/
/********************************************************************/


SvxTypeTabPage::SvxTypeTabPage(Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_INET_TYPE ), rSet ),

	aTypeGB		(this, ResId(GB_TYPES		)),
	aTypeLB		(this, ResId(LB_TYPES		)),
	aTypeFT     (this, ResId(FT_TYPE        )),
	aTypeED     (this, ResId(ED_TYPE        )),
	aClipFT     (this, ResId(FT_CLIP        )),
	aClipED     (this, ResId(ED_CLIP        )),
	aExtFT      (this, ResId(FT_EXT         )),
	aExtED      (this, ResId(ED_EXT         )),
#if defined(OS2) || defined(MAC)
	aExtAttrFT  (this, ResId(FT_EXT_ATTR    )),
	aExtAttrED  (this, ResId(ED_EXT_ATTR    )),
#endif
	aOpenFT     (this, ResId(FT_OPEN        )),
	aOpenLB     (this, ResId(LB_OPEN        )),
	aFilterFT   (this, ResId(FT_FILTER      )),
	aFilterLB   (this, ResId(LB_FILTER      )),
	aAppFT      (this, ResId(FT_APP         )),
	aAppED      (this, ResId(ED_APP         )),
	aSearchAppPB(this, ResId(PB_SEARCH_APP  )),
	aAddTypePB  (this, ResId(PB_ADD_TYPE    )),
	aChgTypePB  (this, ResId(PB_CHG_TYPE    )),
	aDelTypePB  (this, ResId(PB_DEL_TYPE    ))

{
	FreeResource();

	static long nTabs[] = { 6 /* Tab-Count */, 2, 200, 300 , 500, 650, 750};
	aTypeLB.SetTabs( &nTabs[0], MAP_PIXEL );
	aTypeLB.GetModel()->SetSortMode( SortNone );
	aTypeLB.SetWindowBits(WB_HSCROLL|WB_CLIPCHILDREN);
	Link aLink = LINK( this, SvxTypeTabPage, AddChgTypeHdl_Impl );
	aAddTypePB.SetClickHdl( aLink );
	aChgTypePB.SetClickHdl( aLink );
	aDelTypePB.SetClickHdl( LINK( this, SvxTypeTabPage, DelTypeHdl_Impl ) );
	aLink = LINK( this, SvxTypeTabPage, SelectOpenHdl_Impl );
	aOpenLB.SetSelectHdl( aLink );
	aFilterLB.SetSelectHdl( aLink );
	aSearchAppPB.SetClickHdl( LINK( this, SvxTypeTabPage, SearchAppHdl_Impl ) );
	aTypeLB.SetSelectHdl( LINK( this, SvxTypeTabPage, SelectTypeHdl_Impl ) );
	aLink = LINK( this, SvxTypeTabPage, ModifyTypeCtrls_Impl );
	aTypeED.SetModifyHdl( aLink );
	aClipED.SetModifyHdl( aLink );
	aExtED.SetModifyHdl( aLink );
#if defined(OS2) || defined(MAC)
	aExtAttrED.SetModifyHdl( aLink );
#endif
	aAppED.SetModifyHdl( aLink );
	InitTypeBox_Impl();
}

/*-----------------12.08.96 12.59-------------------

--------------------------------------------------*/

SvxTypeTabPage::~SvxTypeTabPage()
{
}

/*-----------------12.08.96 12.59-------------------

--------------------------------------------------*/

SfxTabPage*	SvxTypeTabPage::Create(Window* pParent,
						const SfxItemSet& rAttrSet )
{
	return new SvxTypeTabPage(pParent, rAttrSet);
}

/*-----------------12.08.96 12.59-------------------

--------------------------------------------------*/

void SvxTypeTabPage::Reset(const SfxItemSet&)
{
}

/*-----------------12.08.96 12.59-------------------

--------------------------------------------------*/

BOOL SvxTypeTabPage::FillItemSet(SfxItemSet& rSet)
{
	BOOL bSave = FALSE;
	//Filter in die passenden Container eintueten
	if( aNewFilters.Count() || aDelFilters.Count())
	{
		SfxFilterMatcher& rMatcher = SFX_APP()->GetFilterMatcher();
		SfxFilterContainer* pContainer = rMatcher.
						GetContainer(String::CreateFromAscii(SFX_FCONTNR_REDIRECTS));
		USHORT nCount;
		if((nCount = aNewFilters.Count()) != 0)
		{
			for ( USHORT i = nCount; i; i-- )
			{
				SfxFilter* pFilter = aNewFilters.GetObject(i - 1);
				pContainer->AddFilter(pFilter, 0);
				aNewFilters.Remove(i-1);
			}
			bSave = TRUE;
		}
		if((nCount = aDelFilters.Count()) != 0)
		{
			for ( USHORT i = nCount; i; i-- )
			{
				SfxFilter* pFilter = aDelFilters.GetObject(i - 1);
				pContainer->DeleteFilter(pFilter);
				aDelFilters.Remove(i-1);
			}
			bSave = TRUE;
		}
		if(bSave)
			pContainer->SaveFilters( pContainer->GetName(), 0);
	}
	return bSave;
}

/*-----------------12.08.96 13.22-------------------

--------------------------------------------------*/

IMPL_LINK( SvxTypeTabPage, AddChgTypeHdl_Impl, PushButton *, pButton )
{
	USHORT nPos = aOpenLB.GetSelectEntryPos();
	if(nPos != USHRT_MAX)
	{
		SfxFilterContainer* pContainer =
				SFX_APP()->GetFilterMatcher().GetContainer(aOpenLB.GetSelectEntry());
		if(pContainer)
		{

			String aFilterName;
			String aUserData;
#if defined(OS2) || defined(MAC)
			String aTypeName(aExtAttrED.GetText());
#else
			String aTypeName;
#endif
			aUserData = pContainer->GetName();
			aUserData += '|';
			if(pContainer->GetName().EqualsAscii(SFX_FCONTNR_EXTAPP))
			{
				aUserData += aAppED.GetText();
			}
			else
			{
				aUserData += aFilterLB.GetSelectEntry();

			}
			//alle Filter werden unter Redirect eingefuegt
			pContainer = SFX_APP()->GetFilterMatcher().GetContainer(String::CreateFromAscii(SFX_FCONTNR_REDIRECTS));
			//neuen Filter unter ExtApp erzeugen
			SfxFilter* pFilter = new SfxFilter(
									aFilterName,
									aExtED.GetText(),
									SFX_FILTER_REDIRECT,
									Exchange::RegisterFormatName(aClipED.GetText()),
									aTypeName,
									aTypeName,
									0, //nDocIcon,
									aTypeED.GetText(),
									pContainer,
									aUserData );
			aNewFilters.Insert(pFilter, 0);
			//Jetzt noch in die Listbox:
		aTypeLB.SetUpdateMode(FALSE);
			if(pButton == & aChgTypePB)
			{
				SvLBoxEntry* pDelEntry = aTypeLB.FirstSelected();
				SfxFilter* pDelFilter = (SfxFilter*) pDelEntry->GetUserData();
				aDelFilters.Insert(pDelFilter, 0);
				aTypeLB.GetModel()->Remove(pDelEntry);
			}
			SvLBoxEntry* pEntry = aTypeLB.InsertEntry(lcl_MakeTabEntry(pFilter), 0);
			pEntry->SetUserData((void*)pFilter);
			aTypeLB.Select(pEntry);
			aTypeLB.MakeVisible(pEntry);
		aTypeLB.SetUpdateMode(TRUE);
		aAddTypePB.Enable(FALSE);
		aChgTypePB.Enable(FALSE);
		}
	}
	return 0;
}

/*-----------------12.08.96 13.22-------------------

--------------------------------------------------*/


IMPL_LINK( SvxTypeTabPage, DelTypeHdl_Impl, PushButton *, pButton )
{
	SvLBoxEntry* pDelEntry = aTypeLB.FirstSelected();
	SfxFilter* pDelFilter = (SfxFilter*) pDelEntry->GetUserData();
	aTypeLB.SetUpdateMode(FALSE);
	aDelFilters.Insert(pDelFilter, 0);
	aTypeLB.GetModel()->Remove(pDelEntry);
	aTypeLB.SetUpdateMode(TRUE);
	return 0;
}

/*-----------------12.08.96 13.22-------------------
	Beschreibung: Applikation zu einem Datentyp zuordnen
--------------------------------------------------*/


IMPL_LINK( SvxTypeTabPage, SearchAppHdl_Impl, PushButton *, pButton )
{
	SfxFileDialog* pDlg = new SfxFileDialog( this, WB_OPEN | WB_3DLOOK );
	String aTxt = aAppED.GetText();

	if ( aTxt.Len() )
	{
		INetURLObject aObj( aTxt, INET_PROT_FILE );
		pDlg->SetPath( aObj.GetMainURL() );
	}

	if ( pDlg->Execute() == RET_OK )
	{
		aAppED.SetText( INetURLObject( pDlg->GetPath() ).getFSysPath( INetURLObject::FSYS_DETECT ) );
		ModifyTypeCtrls_Impl( &aAppED );
	}
	delete pDlg;
	return 0;
}

/*-----------------12.08.96 13.22-------------------
	Beschreibung: Auswahl eines Filters aus der TabListBox
--------------------------------------------------*/

IMPL_LINK( SvxTypeTabPage, SelectTypeHdl_Impl, ListBox *, pBox )
{
	SvLBoxEntry* pEntry = ((SvTabListBox*)pBox)->FirstSelected();
	if(pEntry)
	{
		SfxFilter* pFilter = (SfxFilter*) pEntry->GetUserData();
		DBG_ASSERT(pFilter, "Wo ist den der Filter* hin ?")

		if ( !pFilter )
			// kann unter VCL auftreten, da beim Einf"ugen
			// des ersten Eintrages gleich der SelectHdl gerufen wird.
			return 0;

		ULONG nFormat = pFilter->GetFormat();
		if(nFormat)
			aClipED.SetText(Exchange::GetFormatName(nFormat));
		else
			aClipED.SetText(String());
		aTypeED.SetText(pFilter->GetMimeType());
#if defined(OS2) || defined(MAC)
		aExtAttrED.SetText(pFilter->GetTypeName());
#endif
		aExtED.SetText(pFilter->GetWildcard().GetWildCard());
		String aContainerName = pFilter->GetFilterContainer()->GetName();
		//Loeschen nur fuer Redirect-Filter
		BOOL bRedirect = aContainerName.EqualsAscii(SFX_FCONTNR_REDIRECTS);
		aDelTypePB.Enable(bRedirect);

		if(bRedirect)
		{
			String sSelectString = pFilter->GetUserData().GetToken( 1, '|');
			String sParentContainer = pFilter->GetUserData().GetToken( 0, '|');
			aOpenLB.SelectEntry(sParentContainer);
			SelectOpenHdl_Impl(&aOpenLB);
			if(!sParentContainer.EqualsAscii(SFX_FCONTNR_EXTAPP))
				aFilterLB.SelectEntry(sSelectString);
			else
				aAppED.SetText(sSelectString);
		}
		else
		{
			aOpenLB.SelectEntry(aContainerName);
			SelectOpenHdl_Impl(&aOpenLB);
			aFilterLB.SelectEntry(pFilter->GetFilterName());
		}
		aAddTypePB.Enable(FALSE);
		aChgTypePB.Enable(FALSE);
	}
	return 0;
}
/*-----------------12.08.96 13.22-------------------
  Beschreibung: Auswahlbox "Oeffnen mit"
				schaltet um zwischen Filterliste, Suchen-Button
				und leerem Bereich fuer download

--------------------------------------------------*/


IMPL_LINK( SvxTypeTabPage, SelectOpenHdl_Impl, ListBox *, pBox )
{
	if ( pBox == &aOpenLB )
	{
		USHORT nPos = pBox->GetSelectEntryPos();
		aFilterLB.Clear();
		if ( nPos != USHRT_MAX )
		{
			SfxApplication* pApp = SFX_APP();
			SfxFilterContainer* pContainer = pApp->GetFilterMatcher().GetContainer( pBox->GetSelectEntry() );
			DBG_ASSERT( pContainer, "invalid container");
			String sContainerName = pContainer->GetName();
			if ( sContainerName.EqualsAscii(SFX_FCONTNR_EXTAPP) )
			{
				aAppFT.Show();
				aAppED.Show();
				aSearchAppPB.Show();
				aFilterFT.Hide();
				aFilterLB.Hide();
			}
			else
			{
				if ( sContainerName.EqualsAscii(SFX_FCONTNR_REDIRECTS) )
				{
					// f"ur Redirect alle Filter eintragen ausser Redirects
					SfxFilterMatcher* pMatch = &pApp->GetFilterMatcher();
					SfxFilterMatcherIter aMatchIter( pMatch );
					const SfxFilter* pFilter = aMatchIter.First();
					while ( pFilter )
					{
						if ( pContainer != pFilter->GetFilterContainer() )
							aFilterLB.InsertEntry( pFilter->GetName() );
						pFilter = aMatchIter.Next();
					}
				}
				else
				{
					USHORT nCount = pContainer->GetFilterCount();
					for ( USHORT i = 0; i < nCount; i++ )
					{
						const SfxFilter* pFilter = pContainer->GetFilter(i);
						SfxFilterFlags nFlags = pFilter->GetFilterFlags();
						if ( !( nFlags & SFX_FILTER_INTERNAL ) )
							aFilterLB.InsertEntry( pFilter->GetFilterName() );
					}
				}
				aAppFT.Hide();
				aAppED.Hide();
				aSearchAppPB.Hide();
				aFilterFT.Show();
				aFilterLB.Show();

			}
		}
	}
	if ( aDelTypePB.IsEnabled() )
		aChgTypePB.Enable();
	aAddTypePB.Enable();
	return 0;
}

/*-----------------12.08.96 13.23-------------------

--------------------------------------------------*/


IMPL_LINK( SvxTypeTabPage, SelectAppHdl_Impl, ListBox *, pBox )
{
	DBG_ERROR("n.i.")
	return 0;
}

/*-----------------12.08.96 13.23-------------------
	Beschreibung: Dateitypen-Box initialisieren
--------------------------------------------------*/

void SvxTypeTabPage::InitTypeBox_Impl()
{
	const SfxFilter* pFilter;
	SfxFilterMatcher* pMatch = &SFX_APP()->GetFilterMatcher();
	USHORT nContainer = pMatch->GetContainerCount();
	aOpenLB.Clear();
	for ( USHORT i = 0; i < nContainer; i++ )
	{
		SfxFilterContainer* pContainer = pMatch->GetContainer(i);
		String sContainerName = pContainer->GetName();
		// in die OpenBox kommen alle fuer redirect erlaubten Container
		// sowie externe und sonstige
		if ( pContainer->IsUsableForRedirects() || sContainerName.EqualsAscii(SFX_FCONTNR_EXTAPP) )
			aOpenLB.InsertEntry( pContainer->GetName() );
	}
	SfxFilterMatcherIter aMatchIter( pMatch );
	pFilter = aMatchIter.First();
	while( pFilter )
	{
		// Externe Filter werden unter Redirects angezeigt und d"urfen
		// danach nicht noch einmal erscheinen
		// Interne Filter auch nicht anzeigen
		if ( ! pFilter->GetFilterContainer()->GetName().EqualsAscii(SFX_FCONTNR_EXTAPP) &&
			 !( pFilter->GetFilterFlags() & SFX_FILTER_INTERNAL ) )
			aTypeLB.InsertEntry( lcl_MakeTabEntry( pFilter ) )->SetUserData( (void*)pFilter );
		pFilter = aMatchIter.Next();
	}
}

/*-----------------12.08.96 13.23-------------------

--------------------------------------------------*/


IMPL_LINK( SvxTypeTabPage, ModifyTypeCtrls_Impl, Edit*, pEdt )
{
	aAddTypePB.Enable();
	if(aDelTypePB.IsEnabled())
		aChgTypePB.Enable();
	return 0;
}

/********************************************************************/
/********************************************************************/
/*                                                                  */
/* 	SvxOtherTabPage                                                 */
/*                                                                  */
/********************************************************************/
/********************************************************************/

/*-----------------15.05.97 09:51-------------------

--------------------------------------------------*/
/*
SvxPatternField::SvxPatternField( Window* pParent, const ResId& rResId ) :

	PatternField( pParent, rResId ),

	sMsg233	( ResId( ST_MSG_233 ) ),
	sMsg255	( ResId( ST_MSG_255 ) )

{
	FreeResource();
	SelectFixedFont();
} */

/*-----------------15.05.97 09:51-------------------

--------------------------------------------------*/

/*void SvxPatternField::KeyInput( const KeyEvent& rKEvt )
{
	PatternField::KeyInput( rKEvt );
	BOOL bDelete = ( rKEvt.GetKeyCode().GetCode() == KEY_DELETE );
	String sEntry( GetText() );
	sEntry[(USHORT)3] = '.';
	sEntry[(USHORT)7] = '.';
	sEntry[(USHORT)11] = '.';
	Selection aSelection( GetSelection() );
	String sPart( sEntry.GetToken( 0, '.' ) );
	USHORT i, nPart( sPart.EraseLeadingChars() );
	BOOL bSet = FALSE;

	if ( sPart.Len() && ( !nPart || nPart > 255 ) )
	{
		// der erste Part darf nicht 0 und nicht gr"osser 255 sein
		String sMsg( sPart );
		sMsg += ' ';
		sMsg += sMsg233;
		InfoBox( this, sMsg ).Execute();

		if ( nPart == 0 )
			sPart = "  1";
		else
			sPart = "255";
		sEntry.SetToken( 0, '.', sPart );
		bSet = TRUE;
	};

	for ( i = 1; i < 4; i++ )
	{
		// die anderen Parts d"urfen nicht gr"osser 255 sein
		sPart = sEntry.GetToken( i, '.' );
		nPart = sPart.EraseLeadingChars();

		if ( nPart > 255 )
		{
			String sMsg( sPart );
			sMsg += ' ';
			sMsg += sMsg255;
			InfoBox( this, sMsg ).Execute();

			if ( nPart == 0 )
				sPart = "  1";
			else
				sPart = "255";
			sEntry.SetToken( i, '.', sPart );
			bSet = TRUE;
		};
	}

	if ( bSet )
	{
		SetText( sEntry );
		SetSelection( aSelection );
	}
}
*/
// -----------------------------------------------------------------------
#if 0
long SvxPatternField::Notify( NotifyEvent& rNEvt )
{
	return PatternField::Notify( rNEvt );
/*!	long nHandled = 0;

	if ( rNEvt.GetType() == EVENT_KEYUP )
	{
		const KeyEvent* pKEvt = rNEvt.GetKeyEvent();
		KeyInput( *pKEvt );
		nHandled = 1;
	}
	return nHandled;*/
}
#endif

// class JavaScriptDisableQueryBox_Impl --------------------------------------

class JavaScriptDisableQueryBox_Impl : public ModalDialog
{
private:
	FixedImage		aImage;
	FixedText		aWarningFT;
	CheckBox		aDisableCB;
	OKButton		aYesBtn;
	CancelButton	aNoBtn;

public:
	JavaScriptDisableQueryBox_Impl( Window* pParent );

	BOOL		IsWarningDisabled() const { return aDisableCB.IsChecked(); }
};

JavaScriptDisableQueryBox_Impl::JavaScriptDisableQueryBox_Impl( Window* pParent ) :

	ModalDialog( pParent, SVX_RES( RID_SVXDLG_OPT_JAVASCRIPT_DISABLE ) ),

	aImage		( this, ResId( IMG_JSCPT_WARNING ) ),
	aWarningFT	( this, ResId( FT_JSCPT_WARNING ) ),
	aDisableCB	( this, ResId( CB_JSCPT_DISABLE ) ),
	aYesBtn		( this, ResId( BTN_JSCPT_YES ) ),
	aNoBtn		( this, ResId( BTN_JSCPT_NO ) )

{
	FreeResource();

	aYesBtn.SetText( Button::GetStandardText( BUTTON_YES ) );
	aNoBtn.SetText( Button::GetStandardText( BUTTON_NO ) );
	aImage.SetImage( WarningBox::GetStandardImage() );
}

// class SvxBrowserOtherTabPage ------------------------------------------

SvxBrowserOtherTabPage::SvxBrowserOtherTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_BROWSER_OTHER ), rSet ),

	aJavaGB					(this, ResId(GB_JAVA)),
	aJavaEnableCB	 		(this, ResId(CB_ENABLEJAVA)),
	aJavaSecurityCB	 		(this, ResId(CB_JAVASECURITY)),
	aJavaAccessFT	 		(this, ResId(FT_NETACCESS)),
	aJavaAccessLB	 		(this, ResId(LB_NETACCESS)),
	aJavaClassPathFT 		(this, ResId(FT_CLASSPATH)),
	aJavaClassPathED 		(this, ResId(ED_CLASSPATH)),
	aJavaClassPathBtn		(this, ResId(PB_CLASSPATH)),
	aExecuteGB              (this, ResId(GB_EXECUTE)),
	aExePlugCB              (this, ResId(CB_EXECUTE_PLUGINS)),
	aExecuteAppletsGB       (this, ResId(GB_EXECUTE_APPLETS)),
	aExecuteAppletsCB       (this, ResId(CB_EXECUTE_APPLETS)),
	aHomePageGB             (this, ResId(GB_HOMEPAGE)),
	aHomePageFT             (this, ResId(FT_HOMEPAGE)),
	aHomePageED             (this, ResId(ED_HOMEPAGE)),
	aUserAgentGB            (this, ResId(GB_USERAGENT)),
	aUserAgentFT            (this, ResId(FT_USERAGENT)),
	aUserAgentPB            (this, ResId(PB_USERAGENT)),
	aUserAgentED            (this, ResId(ED_USERAGENT)),
	bNoWarning			    (FALSE)

{
	FreeResource();

	aUserAgentPB.SetClickHdl( LINK(this, SvxBrowserOtherTabPage, UserAgentHdl_Impl) );
	FASTBOOL bShowJavaControls = TRUE;
#ifdef SOLAR_JAVA
	// diese Page braucht dann ExchangeSupport
	SetExchangeSupport();
	aJavaEnableCB.SetClickHdl( LINK(this, SvxBrowserOtherTabPage, JavaEnableHdl_Impl) );
	aJavaClassPathBtn.SetClickHdl( LINK(this, SvxBrowserOtherTabPage, ClassPathHdl_Impl) );

	// Java installed?
	bShowJavaControls = IsJavaInstalled_Impl( SFX_INIMANAGER() );
#else
	bShowJavaControls = FALSE;
#endif

	if ( !bShowJavaControls )
	{
		aJavaGB.Show(FALSE);
		aJavaEnableCB.Show(FALSE);
		aJavaSecurityCB.Show(FALSE);
		aJavaAccessFT.Show(FALSE);
		aJavaAccessLB.Show(FALSE);
		aJavaClassPathFT.Show(FALSE);
		aJavaClassPathED.Show(FALSE);
		aJavaClassPathBtn.Show(FALSE);
		aExecuteAppletsGB.Show(FALSE);
		aExecuteAppletsCB.Show(FALSE);
	}

#ifndef SOLAR_PLUGIN
	aExecuteGB.Show(FALSE);
	aExePlugCB.Show(FALSE);
#endif
}

// -----------------------------------------------------------------------

SvxBrowserOtherTabPage::~SvxBrowserOtherTabPage()
{
}

// -----------------------------------------------------------------------

SfxTabPage*	SvxBrowserOtherTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SvxBrowserOtherTabPage(pParent, rAttrSet);
}

// -----------------------------------------------------------------------

int SvxBrowserOtherTabPage::DeactivatePage( SfxItemSet* pSet )
{
	const SfxPoolItem* pItem;

	if ( !bNoWarning &&
		 SFX_ITEM_SET == GetItemSet().GetItemState( SID_INET_JAVA_ENABLE, FALSE, &pItem ) )
	{
		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
		BOOL bCheck = aJavaEnableCB.IsChecked();
		SfxIniManager* pIniMgr = SFX_APP()->GetIniManager();

		if (!bNoWarning && !bCheck && bCheck != ((SfxBoolItem*)pItem )->GetValue())
		{
			JavaScriptDisableQueryBox_Impl aQBox( this );
			aQBox.SetText( GetText() );
			short nRet = aQBox.Execute();

			if ( RET_CANCEL == nRet )
			{
				aJavaEnableCB.Check( TRUE );
				return KEEP_PAGE;
			}
			else
			{
				bNoWarning = TRUE;
			}
		}
	}

	// IMMER PUTTEN -> SOLL EIGENTLICH INS EXAMPLESET
	pSet->Put( SfxBoolItem( SID_INET_JAVA_ENABLE, aJavaEnableCB.IsChecked() ) );

	if ( pSet )
		FillItemSet( *pSet );

	return LEAVE_PAGE;
}

// -----------------------------------------------------------------------
void SvxBrowserOtherTabPage::EnableJava_Impl( BOOL bEnable )
{
	aJavaSecurityCB.Enable( bEnable );
	aJavaAccessFT.Enable( bEnable );
	aJavaAccessLB.Enable( bEnable );
	aJavaClassPathFT.Enable( bEnable );
	aJavaClassPathED.Enable( bEnable );
	aJavaClassPathBtn.Enable( bEnable );
	aExecuteAppletsGB.Enable( bEnable );
	aExecuteAppletsCB.Enable( bEnable );
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxBrowserOtherTabPage, JavaEnableHdl_Impl, CheckBox*, pBox )
{
	EnableJava_Impl( pBox->IsChecked() );
	return 1;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxBrowserOtherTabPage, UserAgentHdl_Impl, PushButton*, pButton )
{
	aUserAgentED.SetText( String::CreateFromAscii(INET_DEF_CALLERNAME) );
	return 1;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxBrowserOtherTabPage, ClassPathHdl_Impl, PushButton*, EMPTYARG )
{
	SvxMultiPathDialog aDlg( this, TRUE );
	aDlg.ShowPathFiles();
	aDlg.SetPath( aJavaClassPathED.GetText() );
	if ( aDlg.Execute() == RET_OK )
		aJavaClassPathED.SetText( aDlg.GetPath() );
	return 1;
}

// -----------------------------------------------------------------------

BOOL SvxBrowserOtherTabPage::FillItemSet(SfxItemSet& rSet)
{
	BOOL bModified = FALSE;

	// Java
	if ( aJavaEnableCB.GetSavedValue() != aJavaEnableCB.IsChecked() )
	{
		rSet.Put( SfxBoolItem(SID_INET_JAVA_ENABLE, aJavaEnableCB.IsChecked()) );
		bModified = TRUE;
	}

	// Applets
	if ( aExecuteAppletsCB.IsEnabled() &&
		 aExecuteAppletsCB.GetSavedValue() != aExecuteAppletsCB.IsChecked() )
	{
		rSet.Put( SfxBoolItem( SID_INET_EXE_APPLETS, aExecuteAppletsCB.IsChecked() ) );
		bModified = TRUE;
	}

	USHORT nSelPos = aJavaAccessLB.GetSelectEntryPos();
	if( aJavaAccessLB.GetSavedValue() != nSelPos )
	{
		rSet.Put(SfxUInt16Item(SID_INET_JAVA_ACCESSTYPE, nSelPos) );
		bModified = TRUE;
	}
	if( aJavaSecurityCB.GetSavedValue() != aJavaSecurityCB.IsChecked() )
	{
		rSet.Put( SfxBoolItem(SID_INET_JAVA_SECURITY, aJavaSecurityCB.IsChecked()) );
		bModified = TRUE;
	}
	if( aJavaClassPathED.GetSavedValue() != aJavaClassPathED.GetText() )
	{
		String aNewPath = aJavaClassPathED.GetText();
		aNewPath.EraseLeadingChars().EraseTrailingChars();
		rSet.Put( SfxStringItem(SID_INET_JAVA_CLASSPATH, aNewPath) );
		bModified = TRUE;
	}

	//	Execute
	if( aExePlugCB.GetSavedValue() != aExePlugCB.IsChecked() )
	{
		rSet.Put( SfxBoolItem(SID_INET_EXE_PLUGIN, aExePlugCB.IsChecked()) );
		bModified = TRUE;
	}

	// HomePage
	if( aHomePageED.GetSavedValue() != aHomePageED.GetText() )
	{
		rSet.Put( SfxStringItem(SID_INET_HOMEPAGE, aHomePageED.GetText()) );
		bModified = TRUE;
	}

	//	UserAgent
	if( aUserAgentED.GetSavedValue() != aUserAgentED.GetText() )
	{
		rSet.Put( SfxStringItem(SID_INET_USERAGENT, aUserAgentED.GetText()) );
		bModified = TRUE;
	}

	return bModified;
}

// -----------------------------------------------------------------------

void SvxBrowserOtherTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;

	// Java
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_JAVA_ENABLE, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
		aJavaEnableCB.Check(((const SfxBoolItem*)pItem)->GetValue());
	}
#ifndef SOLAR_JAVA
	aJavaEnableCB.Check(FALSE);
#endif
	aJavaEnableCB.SaveValue();
	EnableJava_Impl( aJavaEnableCB.IsChecked() );

	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_JAVA_ACCESSTYPE, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxUInt16Item), "SfxUInt16Item erwartet");
		aJavaAccessLB.SelectEntryPos((USHORT)(((const SfxUInt16Item*)pItem)->GetValue()));
	}
	aJavaAccessLB.SaveValue();

	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_JAVA_SECURITY, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
		aJavaSecurityCB.Check(((const SfxBoolItem*)pItem)->GetValue());
	}
	aJavaSecurityCB.SaveValue();

	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_JAVA_CLASSPATH, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxStringItem), "SfxStringItem erwartet");
		aJavaClassPathED.SetText(((const SfxStringItem*)pItem)->GetValue());
	}
	aJavaClassPathED.SaveValue();

	// Execute
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_EXE_PLUGIN, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
		aExePlugCB.Check(((const SfxBoolItem*)pItem)->GetValue());
	}
	aExePlugCB.SaveValue();

	// Homepage
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_HOMEPAGE, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxStringItem), "SfxStringItem erwartet");
		aHomePageED.SetText(((const SfxStringItem*)pItem)->GetValue());
	}
	aHomePageED.SaveValue();
	// UserAgent
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_USERAGENT, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxStringItem), "SfxStringItem erwartet");
		aUserAgentED.SetText(((const SfxStringItem*)pItem)->GetValue());
	}
	aUserAgentED.SaveValue();

	// Execute Applets
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_EXE_APPLETS, FALSE, &pItem ) )
	{
		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
		aExecuteAppletsCB.Check( ( (const SfxBoolItem*)pItem )->GetValue() );
	}
	aExecuteAppletsCB.SaveValue();
}

/********************************************************************/
/*                                                                  */
/*     Internet - Protokolle                                        */
/*                                                                  */
/*                                                                  */
/********************************************************************/

SvxOtherTabPage::SvxOtherTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_INET_OTHER ), rSet ),

	aHttpGB  			( this, ResId( GB_HTTP ) ),
	aHttpSendMailAddrCB	( this, ResId( CB_EMAIL ) ),
	aHttpMaxConnFT		( this, ResId( FT_MAXHTTPCONN ) ),
	aHttpMaxConnNF		( this, ResId( NF_MAXHTTPCONN ) ),
	aFtpGB				( this, ResId( GB_FTP ) ),
	aFtpMaxConnFT		( this, ResId( FT_MAXFTPCONN ) ),
	aFtpMaxConnNF		( this, ResId( NF_MAXFTPCONN ) ),
	aDNSGB				( this, ResId( GB_DNS ) ),
	aDNSAutoRB			( this, ResId( RB_DNS_AUTO ) ),
	aDNSManualRB		( this, ResId( RB_DNS_MANUAL ) ),
	aDNSED				( this, ResId( ED_DNS ) ),
	aStandardGB			( this, ResId( GB_STD_BROWSER ) ),
	aStandardCB			( this, ResId( CB_STD_BROWSER ) ),
	sMsg255_0			(		ResId( ST_MSG_255_0 ) ),
	sMsg255_1			(		ResId( ST_MSG_255_1 ) )

{
	FreeResource();
	SetExchangeSupport();

	aDNSED.SelectFixedFont();
	aDNSED.SetFormatFlags(PATTERN_FORMAT_EMPTYLITERALS);
	aDNSAutoRB.SetClickHdl( LINK(this, SvxOtherTabPage, AutoDNSHdl_Impl) );
	aDNSManualRB.SetClickHdl( LINK(this, SvxOtherTabPage, AutoDNSHdl_Impl) );

#if (SUPD > 581)
	aStandardGB.Hide();
	aStandardCB.Hide();
#endif
}

/*-----------------21.06.97 13.47-------------------

--------------------------------------------------*/

SvxOtherTabPage::~SvxOtherTabPage()
{
}

/*-----------------21.06.97 13.47-------------------

--------------------------------------------------*/

IMPL_LINK( SvxOtherTabPage, AutoDNSHdl_Impl, RadioButton*, 	pBtn )
{
	if( pBtn == &aDNSAutoRB )
	{
		aDNSED.Enable( FALSE );
		aDNSManualRB.Check( FALSE );
	}
	else if( pBtn == &aDNSManualRB )
	{
		aDNSED.Enable( TRUE );
		aDNSED.GrabFocus();
		aDNSAutoRB.Check( FALSE );
	}
	return 1;
}
/*-----------------21.06.97 13.48-------------------

--------------------------------------------------*/
SfxTabPage*	SvxOtherTabPage::Create( Window* pParent,
								const SfxItemSet& rAttrSet )
{
	return new SvxOtherTabPage(pParent, rAttrSet);
}
/* -----------------16.04.99 08:17-------------------
 *  testen, ob DNS richtig gesetzt ist
 * --------------------------------------------------*/
int SvxOtherTabPage::DeactivatePage( SfxItemSet* pSet )
{
	if ( aDNSManualRB.IsChecked() && aDNSED.IsModified() )
	{
		ErrorBox aErrBox( this, WB_OK, String() );
		String sEntry( aDNSED.GetText() );
		String sPart( sEntry.GetToken( 0, '.' ) );
		USHORT i, nPart( sPart.EraseLeadingChars().ToInt32() );
		BOOL bSet = FALSE;
		if ( sPart.Len() && ( !nPart || nPart > 255 ) )
		{
			// der erste Part darf nicht 0 und nicht gr"osser 255 sein
			XubString sMsg( sPart );
			sMsg += ' ';
			sMsg += sMsg255_1;
			aErrBox.SetMessText( sMsg );
			aErrBox.Execute();

			if ( nPart == 0 )
				sPart = String::CreateFromAscii("  1");
			else
				sPart = String::CreateFromAscii("255");
			sEntry.SetToken( 0, '.', sPart );
			bSet = TRUE;
		};

		for ( i = 1; i < 4; i++ )
		{
			// die anderen Parts d"urfen nicht gr"osser 255 sein
			sPart = sEntry.GetToken( i, '.' );
			nPart = sPart.EraseLeadingChars().ToInt32();

			if ( nPart > 255 )
			{
				String sMsg( sPart );
				sMsg += ' ';
				sMsg += sMsg255_0;
				aErrBox.SetMessText( sMsg );
				aErrBox.Execute();

				if ( nPart == 0 )
					sPart = String::CreateFromAscii("  1");
				else
					sPart = String::CreateFromAscii("255");
				sEntry.SetToken( i, '.', sPart );
				bSet = TRUE;
			};
		}

		if ( bSet )
		{
			aDNSED.GrabFocus();
			aDNSED.SetText( sEntry );
			return KEEP_PAGE;
		}
	}

	if ( pSet )
		FillItemSet( *pSet );
	return LEAVE_PAGE;
}

/*-----------------21.06.97 13.48-------------------

--------------------------------------------------*/

BOOL SvxOtherTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;
	BOOL bCntModified = FALSE;

#if (SUPD < 580) //! needs ucb changes
	CntAnchorRef xAnchor = new CntAnchor( NULL, "private:httpcache" );
	xAnchor->Put( SfxVoidItem(WID_GETDATA) );
	SfxItemSet aCntResultSet( *xAnchor->GetPool(), TRUE );

	// HTTP
	if( (USHORT)aHttpMaxConnNF.GetSavedValue() != (USHORT)aHttpMaxConnNF.GetValue() )
	{
		SfxByteItem	aByte( WID_HTTP_CONNECTION_LIMIT, (unsigned char)aHttpMaxConnNF.GetValue());
		aCntResultSet.Put( aByte );
		bCntModified = TRUE;
	}
#endif

	if( aHttpSendMailAddrCB.GetSavedValue() != aHttpSendMailAddrCB.IsChecked() )
	{
		rSet.Put( SfxBoolItem(SID_INET_REVEAL_MAILADDR,
							  aHttpSendMailAddrCB.IsChecked()) );
		bModified = TRUE;
	}

	// FTP
	if( (USHORT)aFtpMaxConnNF.GetSavedValue().ToInt32() !=
		(USHORT)aFtpMaxConnNF.GetValue() )
	{
		rSet.Put( SfxUInt16Item(SID_INET_MAXFTPCONS,
								(USHORT)aFtpMaxConnNF.GetValue()) );
		bModified = TRUE;
	}

	// DNS Server
	// Flag muss auch geputtet werden, wenn sich nur der Wert im
	// Edit geaendert hat
	BOOL bDNSModified = aDNSED.GetSavedValue() != aDNSED.GetText();
	if( bDNSModified || aDNSAutoRB.GetSavedValue() != aDNSAutoRB.IsChecked() )
	{
		rSet.Put( SfxBoolItem(SID_INET_DNS_AUTO, aDNSAutoRB.IsChecked()) );
		bModified = TRUE;
	}
	if( bDNSModified )
	{
		String sValue(aDNSED.GetText());
		sValue.EraseAllChars(' ');
		rSet.Put( SfxStringItem(SID_INET_DNS_SERVER, sValue) );
		bModified = TRUE;
	}
	if( bCntModified )
	{
#if (SUPD < 580) //! needs ucb changes
		xAnchor->Put( aCntResultSet );
#endif
		bModified = TRUE;
	}

	BOOL bCheck = aStandardCB.IsChecked();

	if ( bCheck != aStandardCB.GetSavedValue() )
		SFX_INIMANAGER()->Set( bCheck ? String('0') : String('1'), SFX_KEY_DONTASKFORDEFAULTS );

	return bModified;
}
/*-----------------21.06.97 13.48-------------------

--------------------------------------------------*/
void SvxOtherTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;
#if (SUPD < 580) //! needs ucb changes
	CntAnchorRef xAnchor = new CntAnchor( NULL, "private:httpcache" );
	xAnchor->Put( SfxVoidItem(WID_GETDATA) );

	// HTTP
	const SfxByteItem& rByteItem = (const SfxByteItem&)xAnchor->Get(WID_HTTP_CONNECTION_LIMIT);
	aHttpMaxConnNF.SetValue( rByteItem.GetValue() );
	aHttpMaxConnNF.SaveValue();
#endif

	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_REVEAL_MAILADDR, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
		aHttpSendMailAddrCB.Check(((const SfxBoolItem*)pItem)->GetValue());
	}
	aHttpSendMailAddrCB.SaveValue();

	// FTP
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_MAXFTPCONS, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxUInt16Item), "SfxUInt16Item erwartet");
		aFtpMaxConnNF.SetValue(((const SfxUInt16Item*)pItem)->GetValue());
	}
	aFtpMaxConnNF.SaveValue();

	// DNS Server
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_DNS_AUTO, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
		aDNSAutoRB.Check(((const SfxBoolItem*)pItem)->GetValue());
	}
	aDNSAutoRB.SaveValue();
	if( aDNSAutoRB.IsChecked() )
	{
		aDNSManualRB.Check( FALSE );
		aDNSED.Enable( FALSE );
	}
	else
		aDNSManualRB.Check(TRUE);
	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_DNS_SERVER, FALSE, &pItem) )
	{
		DBG_ASSERT(pItem->ISA(SfxStringItem), "SfxStringItem erwartet");
		String sValue(((const SfxStringItem*)pItem)->GetValue());
		USHORT nCount = sValue.GetTokenCount('.');
		// Format soll wieder an das PatternField angepasst werden
		for( USHORT i = 0; i < nCount; i++ )
		{
			String sPart(sValue.GetToken(i, '.'));
			while(sPart.Len() < 3)
				sPart.Insert(' ', 0);
			sValue.SetToken(i ,'.', sPart);
		}
		aDNSED.SetText(sValue);
	}
	if(!aDNSED.GetText().Len())
		aDNSED.SetText(aDNSED.GetLiteralMask());
	aDNSED.SaveValue();

	BOOL bCheck = (BOOL)(USHORT)SFX_INIMANAGER()->Get( SFX_KEY_DONTASKFORDEFAULTS ).ToInt32();
	aStandardCB.Check( !bCheck );
	aStandardCB.SaveValue();
}

/********************************************************************/
/*                                                                  */
/* 	SvxScriptingTabPage                                                 */
/*                                                                  */
/********************************************************************/

SvxScriptingTabPage::SvxScriptingTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_INET_SCRIPTING ), rSet ),

	aEdtScriptExec			(this, ResId( ED_SCRIPT_EXEC )),
	aLbScriptExec			(this, ResId( LB_SCRIPT_EXEC )),
	aBtnScriptExecInsert	(this, ResId( PB_SCRIPT_INSERT )),
	aBtnScriptExecDelete	(this, ResId( PB_SCRIPT_DELETE )),
	aBtnScriptExecDefault   (this, ResId( PB_SCRIPT_DEFAULT ) ),
	aGrpScriptExec			(this, ResId( GB_SCRIPT_EXEC )),

	aCbxScriptingJava		(this, ResId( CB_SCRIPTING_JAVASCRIPT )),
	aGrpScriptingJava		(this, ResId( GB_JAVASCRIPT )),

	aRbtExecStarBasicAlways (this, ResId( RBT_STARBASIC_ALWAYS ) ),
	aRbtExecStarBasicList	(this, ResId( RBT_STARBASIC_LIST ) ),
	aRbtExecStarBasicNever	(this, ResId( RBT_STARBASIC_NEVER ) ),
	aFiExecStarBasicAlways	(this, ResId( FI_STARBASIC_DISCRIPTION_ALWAYS ) ),
	aFiExecStarBasicList	(this, ResId( FI_STARBASIC_DISCRIPTION_LIST ) ),
	aFiExecStarBasicNever	(this, ResId( FI_STARBASIC_DISCRIPTION_NEVER ) ),
	aGrpScriptingStarBasic	(this, ResId( GB_STARBASIC ) )

{
	FreeResource();

	FASTBOOL bShowJavaControls = TRUE;
#ifdef SOLAR_JAVA
#if (SUPD <= 581)
	// diese Page braucht dann ExchangeSupport
	SetExchangeSupport();

	// Java installed?
	bShowJavaControls = IsJavaInstalled_Impl( SFX_INIMANAGER() );
#else
	bShowJavaControls = FALSE;
#endif
#else
	bShowJavaControls = FALSE;
#endif

	if ( !bShowJavaControls )
	{
		aCbxScriptingJava.Enable(FALSE);
		aCbxScriptingJava.Show(FALSE);
		aGrpScriptingJava.Show(FALSE);
	}

	aEdtScriptExec.SetModifyHdl( LINK(this, SvxScriptingTabPage, EditHdl_Impl) );
	aLbScriptExec.SetSelectHdl( LINK(this, SvxScriptingTabPage, LBHdl_Impl) );

	Link aLink( LINK(this, SvxScriptingTabPage, BtnHdl_Impl) );
	aBtnScriptExecInsert.SetClickHdl( aLink );
	aBtnScriptExecDelete.SetClickHdl( aLink );
	aBtnScriptExecDefault.SetClickHdl( aLink );

	aLink = LINK( this, SvxScriptingTabPage, RadioBtnHdl_Impl );
	aRbtExecStarBasicAlways.SetClickHdl( aLink );
	aRbtExecStarBasicList.SetClickHdl( aLink );
	aRbtExecStarBasicNever.SetClickHdl( aLink );
	EditHdl_Impl( NULL );
	ActivatePage( rSet );
}

/*--------------------------------------------------------------------*/

SvxScriptingTabPage::~SvxScriptingTabPage()
{
}

/*--------------------------------------------------------------------*/

SfxTabPage*	SvxScriptingTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SvxScriptingTabPage(pParent, rAttrSet);
}

/*--------------------------------------------------------------------*/

void SvxScriptingTabPage::ActivatePage( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;
	BOOL bJava = 2;

	const SfxItemSet* pExampleSet =
		GetTabDialog() ? GetTabDialog()->GetExampleSet() : NULL;

	if(pExampleSet && SFX_ITEM_SET == pExampleSet->GetItemState(SID_INET_JAVA_ENABLE, FALSE, &pItem))
	{
		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
		bJava = ((SfxBoolItem*)pItem )->GetValue();
	}
	else if(SFX_ITEM_SET == rSet.GetItemState(SID_INET_JAVA_ENABLE, FALSE, &pItem))
	{
		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
		bJava = ((SfxBoolItem*)pItem )->GetValue();
	}
	else if (SFX_ITEM_AVAILABLE == GetItemSet().GetItemState(SID_INET_JAVA_ENABLE, FALSE, &pItem))
	{
		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
		bJava = ((SfxBoolItem*)pItem )->GetValue();
	}

	if ( bJava != 2 )
	{
		aGrpScriptingJava.Enable(bJava);
		aCbxScriptingJava.Enable(bJava);
	}
}

/*--------------------------------------------------------------------*/

int SvxScriptingTabPage::DeactivatePage( SfxItemSet* pSet )
{
	if ( pSet )
		FillItemSet( *pSet );
	return LEAVE_PAGE;
}

/*--------------------------------------------------------------------*/

void SvxScriptingTabPage::FillListBox_Impl()
{
}

/*--------------------------------------------------------------------*/

IMPL_LINK( SvxScriptingTabPage, EditHdl_Impl, Edit*, EMPTYARG )

/*	[Beschreibung]

	ModifyHandler vom Edit. Der 'Hinzuf"ugen'-Button wird nur enabled,
	wenn der Text im Edit vorhanden ist und nicht nur aus Blanks besteht.
*/

{
	String aTxt = aEdtScriptExec.GetText();
	aTxt.EraseLeadingChars().EraseTrailingChars();
	aBtnScriptExecInsert.Enable( aTxt.Len() > 0 );
	return 1L;
}

/*--------------------------------------------------------------------*/

IMPL_LINK( SvxScriptingTabPage, LBHdl_Impl, ListBox*, EMPTYARG )
{
	USHORT nPos = aLbScriptExec.GetSelectEntryPos();
	aBtnScriptExecDelete.Enable( nPos != LISTBOX_ENTRY_NOTFOUND );
	return 1L;
}

/*--------------------------------------------------------------------*/

IMPL_LINK( SvxScriptingTabPage, BtnHdl_Impl, PushButton*, pBtn )
{
	if( pBtn == &aBtnScriptExecInsert )
	{
		// Einf"ugen
		String aNewEntry = aEdtScriptExec.GetText();
		aNewEntry.EraseLeadingChars().EraseTrailingChars();
		aEdtScriptExec.SetText( aNewEntry );
		FASTBOOL bFound = !aNewEntry.Len();

		if ( !bFound )
		{
			for ( USHORT i = 0; i < aLbScriptExec.GetEntryCount(); ++i )
			{
				String aEntry = aLbScriptExec.GetEntry(i);

				if ( aEntry.CompareIgnoreCaseToAscii( aNewEntry ) == COMPARE_EQUAL )
				{
					bFound = TRUE;
					break;
				}
			}
		}

		if ( !bFound )
		{
			aLbScriptExec.InsertEntry( aNewEntry );
			aLbScriptExec.SelectEntry( aNewEntry );
		}
	}
	else if( pBtn == &aBtnScriptExecDelete )
	{
		// "oschen
		USHORT nPos = aLbScriptExec.GetSelectEntryPos();

		if ( nPos != LISTBOX_ENTRY_NOTFOUND )
		{
			aLbScriptExec.RemoveEntry( nPos );
			USHORT nCount = aLbScriptExec.GetEntryCount();

			if ( nCount > 0 )
			{
				if ( nPos >= nCount )
					nPos = nCount - 1;
			}
			aLbScriptExec.SelectEntryPos( nPos );
		}
	}
	else if ( pBtn == &aBtnScriptExecDefault )
	{
		// Zur"ucksetzen (Standard)
		aLbScriptExec.Clear();
		aLbScriptExec.InsertEntry( String::CreateFromAscii("file:/") );
		aLbScriptExec.InsertEntry( String::CreateFromAscii("private:explorer") );
		aLbScriptExec.InsertEntry( String::CreateFromAscii("private:help") );
		aLbScriptExec.InsertEntry( String::CreateFromAscii("private:newmenu") );
		aLbScriptExec.InsertEntry( String::CreateFromAscii("private:schedule") );
		aLbScriptExec.InsertEntry( String::CreateFromAscii("private:user") );
		aLbScriptExec.InsertEntry( String::CreateFromAscii("private:searchfolder") );
	}
	LBHdl_Impl( NULL );
	EditHdl_Impl( NULL );

	return 1;
}

/*--------------------------------------------------------------------*/

IMPL_LINK( SvxScriptingTabPage, RadioBtnHdl_Impl, RadioButton*, pBtn )
{
	BOOL bAlways = aRbtExecStarBasicAlways.IsChecked();
	BOOL bList   = aRbtExecStarBasicList.IsChecked();
	BOOL bNever  = aRbtExecStarBasicNever.IsChecked();

	if( bAlways )
	{
		aFiExecStarBasicAlways.Show();
		aFiExecStarBasicList.Hide();
		aFiExecStarBasicNever.Hide();
	}
	else if( bList )
	{
		aFiExecStarBasicAlways.Hide();
		aFiExecStarBasicList.Show();
		aFiExecStarBasicNever.Hide();
	}
	else if( bNever )
	{
		aFiExecStarBasicAlways.Hide();
		aFiExecStarBasicList.Hide();
		aFiExecStarBasicNever.Show();
	}

	aEdtScriptExec.Enable( bList );
	aLbScriptExec.Enable( bList );
	aBtnScriptExecInsert.Enable( bList );
	aBtnScriptExecDelete.Enable( bList );
	aBtnScriptExecDefault.Enable( bList );
	aGrpScriptExec.Enable( bList );

	if( bList )
	{
		// "oschen und Hinzuf"ugen wirklich enabled?
		LBHdl_Impl( NULL );
		EditHdl_Impl( NULL );
	}

	return 1;
}

/*--------------------------------------------------------------------*/

BOOL SvxScriptingTabPage::FillItemSet(SfxItemSet& rSet)
{
	// ggf. neuen Eintrag einf"ugen
	BtnHdl_Impl( &aBtnScriptExecInsert );

	BOOL bModified = FALSE;

	// Liste fuer Scripting (Execute)
	List aList;
	USHORT nCount = aLbScriptExec.GetEntryCount();
	for( USHORT i = 0; i < nCount; i++ )
		aList.Insert( new String( aLbScriptExec.GetEntry( i ) ), LIST_APPEND );

	// Vergleichen mit alter Liste
	const SfxItemSet&  rOldSet = GetItemSet();
	const SfxPoolItem* pItem;
	if( SFX_ITEM_SET == rOldSet.GetItemState( SID_SECURE_URL, FALSE, &pItem ) )
	{
		DBG_ASSERT( pItem->ISA(SfxStringListItem), "SfxStringListItem erwartet" );
		List* pList = ( (SfxStringListItem*)pItem )->GetList();

		if( pList )
		{
			ULONG nOldCount = pList->Count();
			if( nCount != nOldCount )
				bModified = TRUE;

			for ( ULONG i = 0; i < nOldCount && !bModified; i++ )
			{
				if ( *(String*)aList.GetObject(i) != *(String*)pList->GetObject(i) )
					bModified = TRUE;
			}
		}
	}

	if ( bModified )
	{
		rSet.Put( SfxStringListItem( SID_SECURE_URL, &aList ) );
	}

	// Liste (Inhalte) wieder loeschen
	for( String* pStr = (String*)aList.First(); pStr; pStr = (String*)aList.Next() )
		delete pStr;


	// Scripting
	if( aCbxScriptingJava.IsEnabled() &&
		aCbxScriptingJava.GetSavedValue() != aCbxScriptingJava.IsChecked() )
	{
		rSet.Put( SfxBoolItem( SID_INET_EXE_JAVASCRIPT, aCbxScriptingJava.IsChecked() ) );
		bModified = TRUE;
	}

	if( aRbtExecStarBasicNever.GetSavedValue() != aRbtExecStarBasicNever.IsChecked() ||
		aRbtExecStarBasicList.GetSavedValue() != aRbtExecStarBasicList.IsChecked() ||
		aRbtExecStarBasicAlways.GetSavedValue() != aRbtExecStarBasicAlways.IsChecked() )
	{
		USHORT nSB = 0;
		if( aRbtExecStarBasicNever.IsChecked() )
			nSB = 0;
		else if( aRbtExecStarBasicList.IsChecked() )
			nSB = 1;
		else if( aRbtExecStarBasicAlways.IsChecked() )
			nSB = 2;

		rSet.Put( SfxUInt16Item( SID_BASIC_ENABLED, nSB ) );
		bModified = TRUE;
	}

	return bModified;
}

/*--------------------------------------------------------------------*/

void SvxScriptingTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;

	// Execute
	aLbScriptExec.Clear();
	if ( SFX_ITEM_SET == rSet.GetItemState(SID_SECURE_URL, FALSE, &pItem) )
	{
		DBG_ASSERT( pItem->ISA(SfxStringListItem), "StringListItem erwartet" );
		List* pList = ( (SfxStringListItem*)pItem )->GetList();

		if ( pList )
		{
			ULONG nCount = pList->Count();

			for ( ULONG i = 0; i < nCount; i++ )
				aLbScriptExec.InsertEntry( *(String*)pList->GetObject(i) );
		}
	}

	// Scripting
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_EXE_JAVASCRIPT, FALSE, &pItem ) )
	{
		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
		aCbxScriptingJava.Check( ( (SfxBoolItem*)pItem )->GetValue() );
	}
#ifndef SOLAR_JAVA
	aCbxScriptingJava.Check( FALSE );
#endif
	aCbxScriptingJava.SaveValue();

	if ( SFX_ITEM_SET == rSet.GetItemState( SID_BASIC_ENABLED, FALSE, &pItem ) )
	{
		DBG_ASSERT( pItem->ISA(SfxUInt16Item), "SfxUInt16Item erwartet" );
		USHORT nSB = ( (const SfxUInt16Item*)pItem )->GetValue();
		if ( nSB == 0 )
			aRbtExecStarBasicNever.Check();
		else if ( nSB == 1 )
			aRbtExecStarBasicList.Check();
		else if ( nSB == 2 )
			aRbtExecStarBasicAlways.Check();
		else
			DBG_ERROR( "Kein gueltiger Wert fuer StarBasicScript (RadioButons)" );
	}
	aRbtExecStarBasicNever.SaveValue();
	aRbtExecStarBasicList.SaveValue();
	aRbtExecStarBasicAlways.SaveValue();

	EditHdl_Impl( NULL );
	RadioBtnHdl_Impl( NULL );
	LBHdl_Impl( NULL );
}

/********************************************************************/
/********************************************************************/
/*                                                                  */
/* 	SvxCookiesTabPage                                           	*/
/*                                                                  */
/********************************************************************/
/********************************************************************/
#define		COOK_WIDTH_TAB1		 50L		// Status
#define		COOK_WIDTH_TAB2      75L		// Domain
#define		COOK_WIDTH_TAB3		 75L		// Path
#define		COOK_WIDTH_TAB4		 75L		// Expires
#define		COOK_WIDTH_TAB5		 50L		// Name
#define		COOK_WIDTH_TAB6		125L		// Value
#define		COOK_WIDTH_TAB7		 25L		// Secure

struct CookiesPage_Impl
{
	String	aQueryBoxTitle;
	String	aAllButtonText;

	CookiesPage_Impl() {}
};

HeaderTabListBox::HeaderTabListBox( Window* pParent, WinBits nWinStyle ) :
	SvTabListBox( pParent, nWinStyle )
{
	bFirstPaint = TRUE;
}

void HeaderTabListBox::Paint(const Rectangle& rRect)
{
	if( bFirstPaint )
	{
		bFirstPaint = FALSE;
		RepaintScrollBars();
	}
	SvTabListBox::Paint(rRect);
}

void HeaderTabListBox::InitHeaderBar(HeaderBar* pNew)
{
	pHead = pNew;
	SetScrolledHdl(LINK(this,HeaderTabListBox, TabBoxScrollHdl_Impl));
}

IMPL_LINK( HeaderTabListBox, TabBoxScrollHdl_Impl, SvTabListBox*, pList )
{
	pHead->SetOffset(-GetXOffset());
	return 0;
}

SvxCookiesTabPage::SvxCookiesTabPage(Window* pParent, const SfxItemSet& rSet) :
	SfxTabPage(pParent, ResId( RID_SVXPAGE_INET_COOKIES, DIALOG_MGR() ), rSet),
	aGB_Handling		( this, ResId(GB_HANDLING) ),
	aRB_Send			( this, ResId(RB_SEND) ),
	aRB_Ignore			( this, ResId(RB_IGNORE) ),
	aRB_Interactive		( this, ResId(RB_INTERACTIV) ),
	aWin_ListBox 		( this, ResId(WIN_LB_WINDOW) ),
	aPB_Delete			( this, ResId(PB_DELETE_COOKIE) ),
	aPB_Dis_Enable		( this, ResId(PB_DIS_ENABLE) ),
	aSTR_Status			( ResId(STR_STATUS) ),
	aSTR_Domain			( ResId(STR_DOMAIN) ),
	aSTR_Path			( ResId(STR_PATH) ),
	aSTR_Name			( ResId(STR_NAME) ),
	aSTR_Expires		( ResId(STR_EXPIRES) ),
	aSTR_Content		( ResId(STR_CONTENT) ),
	aSTR_Secure			( ResId(STR_SECURE) ),
	aSTR_EnableBtn		( ResId(STR_ENABLE_BTN) ),
	aSTR_DisableBtn	    ( ResId(STR_DIS_BTN) ),
	aSTR_DeleteCookie	( ResId(STR_DELETE_COOKIE) )
{
	pImpl = new CookiesPage_Impl;
	pImpl->aQueryBoxTitle = String( ResId( STR_QUERYBOX_TITLE ) );
	pImpl->aAllButtonText = String( ResId( STR_ALLBTN_TEXT ) );

	FreeResource();

	Link aLink = LINK( this, SvxCookiesTabPage, CookieAction_Impl );
	aPB_Delete.SetClickHdl( aLink );
	aPB_Dis_Enable.SetClickHdl( aLink );
	aLink = LINK( this, SvxCookiesTabPage, HandlingHdl_Impl );
	aRB_Send.SetClickHdl( aLink );
	aRB_Ignore.SetClickHdl( aLink );
	aRB_Interactive.SetClickHdl( aLink );

	Size aWinSz = aWin_ListBox.GetOutputSizePixel();

	pHeaderBar = new HeaderBar( &aWin_ListBox, WB_BUTTONSTYLE | WB_BOTTOMBORDER );
	pHeaderBar->SetPosSizePixel( Point(0,0), Size(aWinSz.Width(), 16) );

	pHeaderBar->SetEndDragHdl(LINK(this,SvxCookiesTabPage, HeaderEndDrag_Impl));
	Size aSz; // ahhhhhrrrrrggggg, warum gibt es kein LogiToPixel fuer einen Long?

	aSz.Width() = COOK_WIDTH_TAB1;
	pHeaderBar->InsertItem( 1, aSTR_Status,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	aSz.Width() = COOK_WIDTH_TAB2;
	pHeaderBar->InsertItem( 2, aSTR_Domain,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	aSz.Width() = COOK_WIDTH_TAB3;
	pHeaderBar->InsertItem( 3, aSTR_Path,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	aSz.Width() = COOK_WIDTH_TAB4;
	pHeaderBar->InsertItem( 4, aSTR_Expires,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	aSz.Width() = COOK_WIDTH_TAB5;
	pHeaderBar->InsertItem( 5, aSTR_Name,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	aSz.Width() = COOK_WIDTH_TAB6;
	pHeaderBar->InsertItem( 6, aSTR_Content,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	aSz.Width() = COOK_WIDTH_TAB7;
	pHeaderBar->InsertItem( 7, aSTR_Secure,
				LogicToPixel(aSz, MapMode(MAP_APPFONT)).Width());

	// ... bitte nicht hinschauen, das kranke Interface der TabListBox zwingt mich dazu!
	static long nTabs[] = {8, 0,
				  COOK_WIDTH_TAB1,
				  COOK_WIDTH_TAB1+COOK_WIDTH_TAB2,
				  COOK_WIDTH_TAB1+COOK_WIDTH_TAB2+COOK_WIDTH_TAB3,
				  COOK_WIDTH_TAB1+COOK_WIDTH_TAB2+COOK_WIDTH_TAB3+COOK_WIDTH_TAB4,
				  COOK_WIDTH_TAB1+COOK_WIDTH_TAB2+COOK_WIDTH_TAB3+COOK_WIDTH_TAB4+COOK_WIDTH_TAB5,
				  COOK_WIDTH_TAB1+COOK_WIDTH_TAB2+COOK_WIDTH_TAB3+COOK_WIDTH_TAB4+COOK_WIDTH_TAB5+COOK_WIDTH_TAB6,
				  COOK_WIDTH_TAB1+COOK_WIDTH_TAB2+COOK_WIDTH_TAB3+COOK_WIDTH_TAB4+COOK_WIDTH_TAB5+COOK_WIDTH_TAB6+COOK_WIDTH_TAB7
	};

	Size aHeadSz = pHeaderBar->GetSizePixel();

	pLB_Cookies = new HeaderTabListBox( &aWin_ListBox, WB_HSCROLL | WB_CLIPCHILDREN );
	pLB_Cookies->SetPosSizePixel( Point(0, aHeadSz.Height()), Size(aWinSz.Width(),
		aWinSz.Height() - aHeadSz.Height()) );

	pLB_Cookies->SetTabs( &nTabs[0], MAP_APPFONT );
	pLB_Cookies->GetModel()->SetSortMode( SortNone );
	pLB_Cookies->InitHeaderBar( pHeaderBar );
	pLB_Cookies->SetSelectHdl( LINK(this,SvxCookiesTabPage, SelectHdl_Impl) );
	pLB_Cookies->SetSelectionMode( MULTIPLE_SELECTION );
	pLB_Cookies->SetHelpId( HID_OPTINET2_CTL_COOKIES );
	pHeaderBar->SetHelpId( HID_OPTCOOKIES_HEADERBAR );
	pLB_Cookies->Show();
	pHeaderBar->Show();

	aTextColor = pLB_Cookies->GetFont().GetColor();

#ifndef TF_UCB
	xAnchor = new CntAnchor( NULL, "private:httpcache" );
	xAnchor->Put( SfxVoidItem(WID_GETDATA) );

	const CntHTTPCookieManagerItem& rItem = (const CntHTTPCookieManagerItem&)xAnchor->
											Get(WID_HTTP_COOKIE_MANAGER);
	xCookMgr = rItem.GetValue();
	pCookLst = xCookMgr->getCookieList();

	FillListBox_Impl();
#endif
}

SvxCookiesTabPage::~SvxCookiesTabPage()
{
	pHeaderBar->Hide();

	delete pLB_Cookies;
	delete pHeaderBar;
	delete pImpl;
}

void SvxCookiesTabPage::FillListBox_Impl()
{
#ifndef TF_UCB
	pLB_Cookies->Clear();

	if( !pCookLst )
		return;

	for( USHORT i = 0; i < pCookLst->Count(); ++i )
	{
		CntHTTPCookie* pAct = pCookLst->GetObject(i);
		String aStr = GetEntryText_Impl( pAct );
		if( !aStr.Len() )
			continue;

		SvLBoxEntry* pEntry = pLB_Cookies->InsertEntry(aStr);
		pEntry->SetUserData( pAct );
	}
	UpdateButtons_Impl();
#endif
}

String SvxCookiesTabPage::GetEntryText_Impl( CntHTTPCookie* pAct )
{
	String aStr;

#ifndef TF_UCB

	if( pAct->m_nPolicy == CNTHTTP_COOKIE_POLICY_INTERACTIVE )
		return aStr;

	const International& rInter = Application::GetAppInternational();
	switch( pAct->m_nPolicy )
	{
		case CNTHTTP_COOKIE_POLICY_ACCEPTED:
			aStr = aRB_Send.GetText();
			break;
		case CNTHTTP_COOKIE_POLICY_BANNED:
			aStr = aRB_Ignore.GetText();
			break;
	}

	USHORT n = aStr.Search( '~' );
	if( n != STRING_NOTFOUND )
		aStr.Erase( n, 1 );
	aStr += "\t";

	aStr += pAct->m_aDomain;
	aStr += "\t";
	aStr += pAct->m_aPath;
	aStr += "\t";

	if( pAct->m_aExpires.GetDate() || pAct->m_aExpires.GetTime() ) {
		aStr += rInter.GetDate(pAct->m_aExpires);
		aStr += " ";
		aStr += rInter.GetTime(pAct->m_aExpires);
	}
	aStr += "\t";

	aStr += pAct->m_aName;
	aStr += "\t";
	aStr += pAct->m_aValue;
	aStr += "\t";

	//aStr += pAct->bSecure ? "Ja" : "Nein";
	//aStr += Button::GetButtonText( pAct->bSecure ? BUTTON_YES : BUTTON_NO );
	aStr += (pAct->m_nFlags & CNTHTTP_COOKIE_FLAG_SECURE)? "*" : "";

#endif

	return aStr;
}

void SvxCookiesTabPage::UpdateButtons_Impl()
{
#ifndef TF_UCB

	if ( !pLB_Cookies->GetModel()->GetEntryCount() ||
		 !pLB_Cookies->FirstSelected() || !aRB_Interactive.IsChecked() )
	{
		aPB_Delete.Enable( FALSE );
		aPB_Dis_Enable.SetText( aSTR_DisableBtn );
		aPB_Dis_Enable.Enable( FALSE );
	}
	else
	{
		SvLBoxEntry* pEntry = pLB_Cookies->FirstSelected();
		CntHTTPCookie* pSel = (CntHTTPCookie*)pEntry->GetUserData();

		if ( !pSel )
			return;

		if( pSel->m_nPolicy == CNTHTTP_COOKIE_POLICY_ACCEPTED )
			aPB_Dis_Enable.SetText( aSTR_DisableBtn );
		else if( pSel->m_nPolicy == CNTHTTP_COOKIE_POLICY_BANNED )
			aPB_Dis_Enable.SetText( aSTR_EnableBtn );

		aPB_Delete.Enable( TRUE );
		aPB_Dis_Enable.Enable( TRUE );
	}
#endif
}

IMPL_LINK( SvxCookiesTabPage, SelectHdl_Impl, void*, pPtr )
{
	UpdateButtons_Impl();
	return 1;
}

IMPL_LINK( SvxCookiesTabPage, CookieAction_Impl, PushButton*, pBtn )
{
#ifndef TF_UCB
	if( pBtn == &aPB_Delete )
	{
		FASTBOOL bMulti = FALSE;
		USHORT nSelCount = 0;
		SvLBoxEntry* pEntry = pLB_Cookies->FirstSelected();

		while ( nSelCount < 2 && pEntry )
		{
			nSelCount++;
			pEntry = pLB_Cookies->NextSelected( pEntry );
		}
		bMulti = nSelCount > 1;
		pEntry = pLB_Cookies->FirstSelected();
		FASTBOOL bAsk = TRUE;

		while ( pEntry )
		{
			CntHTTPCookie* pDel = (CntHTTPCookie*)pEntry->GetUserData();
			SvLBoxEntry* pRemoveEntry = pEntry;
			pEntry = pLB_Cookies->NextSelected( pEntry );
			String aMsg( aSTR_DeleteCookie );
			aMsg.SearchAndReplace( "%1", pDel->m_aDomain );
			MessBox* pQueryBox = NULL;

			if ( bMulti )
			{
				pQueryBox = new MessBox( this, 0, pImpl->aQueryBoxTitle, aMsg );
				pQueryBox->SetImage( QueryBox::GetStandardImage() );
				pQueryBox->AddButton( BUTTON_YES, RET_YES,
					BUTTONDIALOG_DEFBUTTON | BUTTONDIALOG_OKBUTTON | BUTTONDIALOG_FOCUSBUTTON );
				pQueryBox->AddButton( pImpl->aAllButtonText, RET_ALL, 0 );
				pQueryBox->AddButton( BUTTON_NO, RET_NO, 0 );
				pQueryBox->AddButton( BUTTON_CANCEL, RET_CANCEL, BUTTONDIALOG_CANCELBUTTON );
			}
			else
			{
				pQueryBox = new QueryBox( this, WB_YES_NO, aMsg );
				pQueryBox->SetText( pImpl->aQueryBoxTitle );
			}

			short nRet = bAsk ? pQueryBox->Execute() : RET_ALL;
			delete pQueryBox;
			bAsk = ( RET_ALL != nRet );

			if ( RET_CANCEL == nRet )
				break;

			if ( RET_YES == nRet || RET_ALL == nRet )
			{
				for( USHORT nI = 0; nI < pCookLst->Count(); nI++ )
				{
					if( pCookLst->GetObject(nI) == pDel )
					{
						pCookLst->Remove( (ULONG)nI );
						break;
					}
				}
				delete pDel;
				pLB_Cookies->GetModel()->Remove( pRemoveEntry );
			}
		}
	}
	else if( pBtn == &aPB_Dis_Enable )
	{
		USHORT nPolicy = CNTHTTP_COOKIE_POLICY_ACCEPTED;
		if ( aPB_Dis_Enable.GetText() == aSTR_DisableBtn )
			nPolicy = CNTHTTP_COOKIE_POLICY_BANNED;
		SvLBoxEntry* pEntry = pLB_Cookies->FirstSelected();

		while ( pEntry )
		{
			CntHTTPCookie* pChg = (CntHTTPCookie*)pEntry->GetUserData();
			pChg->m_nPolicy = nPolicy;
			String aStr( GetEntryText_Impl(pChg) );
			pLB_Cookies->SetEntryText( aStr, pEntry );
			pLB_Cookies->InvalidateEntry( pEntry );
			pEntry = pLB_Cookies->NextSelected( pEntry );
		}
	}
	UpdateButtons_Impl();
#endif
	return 1;
}

IMPL_LINK( SvxCookiesTabPage, HeaderEndDrag_Impl, HeaderBar*, pHeader )
{
#ifndef TF_UCB
	if( !pHeaderBar->GetCurItemId() )
		return 1;
	if( !pHeaderBar->IsItemMode() )
	{
		Size	aSz;
		USHORT	nTabs	= pHeaderBar->GetItemCount();
		long 	nTmpSz	= 0;
		for( USHORT i = 1; i <= nTabs; ++ i)
		{
			aSz.Width() = pHeaderBar->GetItemSize(i) + nTmpSz;
			nTmpSz 	   += pHeaderBar->GetItemSize(i);
			pLB_Cookies->SetTab( i, PixelToLogic(aSz, MapMode(MAP_APPFONT)).Width(), MAP_APPFONT );
		}
	}
#endif
	return 1;
}

IMPL_LINK( SvxCookiesTabPage, HandlingHdl_Impl, RadioButton*, EMPTYARG )
{
#ifndef TF_UCB
	BOOL bEnable = aRB_Interactive.IsChecked();
	pHeaderBar->Enable( bEnable );
//!	pLB_Cookies->EnableInput( bEnable );
	if ( !bEnable )
	{
		pLB_Cookies->SelectAll( FALSE );
		aPB_Delete.Disable();
		aPB_Dis_Enable.Disable();
	}
	else
		UpdateButtons_Impl();

	Color aNewColor = bEnable ? aTextColor :
		Application::GetSettings().GetStyleSettings().GetDeactiveTextColor();
	Font aFont = pLB_Cookies->GetFont();
	aFont.SetColor( aNewColor );
	pLB_Cookies->SetFont( aFont );
	pLB_Cookies->Invalidate();

#endif
	return 0;
}

SfxTabPage* SvxCookiesTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SvxCookiesTabPage(pParent, rAttrSet);
}

BOOL SvxCookiesTabPage::FillItemSet(SfxItemSet& rSet)
{
#ifndef TF_UCB
	if( aRB_Interactive.IsChecked() )
		xCookMgr->setGeneralPolicy( CNTHTTP_COOKIE_POLICY_INTERACTIVE );
	else if( aRB_Send.IsChecked() )
		xCookMgr->setGeneralPolicy( CNTHTTP_COOKIE_POLICY_ACCEPTED );
	else if( aRB_Ignore.IsChecked() )
		xCookMgr->setGeneralPolicy( CNTHTTP_COOKIE_POLICY_BANNED );

	xCookMgr->setCookieList( pCookLst );
	CntHTTPCookieManagerItem aItem( WID_HTTP_COOKIE_MANAGER, xCookMgr );

	SfxItemSet aSet( *(xAnchor->GetPool()), WID_HTTP_COOKIE_MANAGER, WID_HTTP_COOKIE_MANAGER );
	aSet.Put( aItem );
	xAnchor->Put( aSet );
#endif

	return FALSE;
}

void SvxCookiesTabPage::Reset( const SfxItemSet& rSet )
{
#ifndef TF_UCB
	if( !xCookMgr.Is() )
		return ;
	if( xCookMgr->getGeneralPolicy() == CNTHTTP_COOKIE_POLICY_INTERACTIVE )
		aRB_Interactive.Check( TRUE );
	else if( xCookMgr->getGeneralPolicy() == CNTHTTP_COOKIE_POLICY_ACCEPTED )
		aRB_Send.Check( TRUE );
	else if( xCookMgr->getGeneralPolicy() == CNTHTTP_COOKIE_POLICY_BANNED )
		aRB_Ignore.Check( TRUE );
	HandlingHdl_Impl( NULL );
#endif
}

