/*************************************************************************
 *
 *  $RCSfile: optmail.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _MAILENUM_HXX
#include <goodies/mailenum.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFX_INIMGR_HXX //autogen
#include <sfx2/inimgr.hxx>
#endif
#ifndef __RSC //autogen
#include <tools/errinf.hxx>
#endif
#ifndef _CTRLTOOL_HXX // FontList
#include <svtools/ctrltool.hxx>
#endif
#include <vcl/system.hxx>
#pragma hdrstop

#define _SVX_OPTMAIL_CXX

#include "optmail.hxx"
#include "dialmgr.hxx"

#include "dialogs.hrc"
#include "optmail.hrc"

// class SvxMailTabPage -------------------------------------------------

SvxMailTabPage::SvxMailTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_MAIL ), rSet ),

	aSendFT			( this, ResId( FT_SEND ) ),
	aSendED			( this, ResId( ED_SEND ) ),
	aReceiveFT		( this, ResId( FT_RECEIVE ) ),
	aReceiveED		( this, ResId( ED_RECEIVE ) ),
	aServerGB		( this, ResId( GB_SERVER ) ),
	aUserFT			( this, ResId( FT_USER ) ),
	aUserED			( this, ResId( ED_USER ) ),
	aPasswdFT		( this, ResId( FT_PASSWD ) ),
	aPasswdED		( this, ResId( ED_PASSWD ) ),
	aUserGB			( this, ResId( GB_USER ) ),
	aNewsServerFT	( this, ResId( FT_NEWSSERVER ) ),
	aNewsServerED	( this, ResId( ED_NEWSSEERVER ) ),
	aNewsGB       	( this, ResId( GB_NEWS ) ),
	aHtmlCB			( this, ResId( CB_HTML ) ),
	aRtfCB			( this, ResId( CB_RTF ) ),
	aOfficeCB		( this, ResId( CB_OFFICE ) ),
	aLine	    	( this, ResId( FL_FORMAT ) ),
	aFontSizeFT    	( this, ResId( FT_FONTSIZE ) ),
	aFontSizeBox   	( this, ResId( LB_FONTSIZE ) ),
	aFormatGB		( this, ResId( GB_FORMAT ) ),
	aReadTimerOnCB	( this, ResId( CB_READTIMER_ON ) ),
	aReadTimerOutFT	( this, ResId( FT_READTIMER_OUT ) ),
	aReadTimerOutED	( this, ResId( ED_READTIMER_OUT ) ),
	aReadTimerSecFT	( this, ResId( FT_READTIMER_SEC ) ),
	aReadTimerBox	( this, ResId( GB_READTIMER ) ),
	aAutoLoadCB		( this, ResId( CB_AUTOLOAD ) ),

	pFontList		( new FontList( this ) )

{
	FreeResource();

	aReadTimerOnCB.SetClickHdl( LINK( this, SvxMailTabPage, CheckHdl_Impl ) );

	// fill the FontSizeBox
	Font aFixedFont = System::GetStandardFont( STDFONT_FIXED );
	FontInfo aInfo = pFontList->Get( aFixedFont.GetName(), pFontList->GetNormalStr() );
	aFontSizeBox.Fill( aInfo, pFontList );

	// DeactivatePage() enablen
	SetExchangeSupport();

	// we need the OutboxServer only
	aReceiveFT.Hide();
	aReceiveED.Hide();
	aUserFT.Hide();
	aUserED.Hide();
	aPasswdFT.Hide();
	aPasswdED.Hide();
	aUserGB.Hide();
	aNewsServerFT.Hide();
	aNewsServerED.Hide();
	aNewsGB.Hide();
	aHtmlCB.Hide();
	aRtfCB.Hide();
	aOfficeCB.Hide();
	aLine.Hide();
	aFontSizeFT.Hide();
	aFontSizeBox.Hide();
	aFormatGB.Hide();
	aReadTimerOnCB.Hide();
	aReadTimerOutFT.Hide();
	aReadTimerOutED.Hide();
	aReadTimerSecFT.Hide();
	aReadTimerBox.Hide();
	aAutoLoadCB.Hide();
}

// -----------------------------------------------------------------------

SvxMailTabPage::~SvxMailTabPage()
{
	delete pFontList;
}

// -----------------------------------------------------------------------

BOOL SvxMailTabPage::CheckEditValue( Edit& rEdit, sal_uInt32 eType, USHORT nSlot )
{
	String aValue = rEdit.GetText();
	if ( !aValue.Len() )
		// allow empty username
		aValue = String::CreateFromAscii("pb");
	ErrCode nErr = 0;
#if (SUPD < 580) //! needs ucb changes
	nErr = CheckProtSpecValue( (CntMsgProtocolType)eType, GetWhich( nSlot ), aValue );
#endif

	if ( nErr )
	{
		ErrorHandler::HandleError( nErr );
		rEdit.GrabFocus();
		return FALSE;
	}
	else
		return TRUE;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxMailTabPage, CheckHdl_Impl, CheckBox *, pBtn )
{
	BOOL bEnable = pBtn->IsChecked();
	aReadTimerOutFT.Enable( bEnable );
	aReadTimerOutED.Enable( bEnable );
	aReadTimerSecFT.Enable( bEnable );
	return 0;
}

// -----------------------------------------------------------------------

int SvxMailTabPage::DeactivatePage( SfxItemSet* pSet )
{
	BOOL bOK = TRUE;
#if (SUPD < 580) //! needs ucb changes
	bOK = CheckEditValue( aSendED, CNT_MSG_PROTOCOL_SMTP, SID_SEND_SERVERNAME );
	bOK &= CheckEditValue( aReceiveED, CNT_MSG_PROTOCOL_POP3, SID_RECEIVE_SERVERNAME );
	bOK &= CheckEditValue( aUserED, CNT_MSG_PROTOCOL_POP3, SID_RECEIVE_USERNAME );
	bOK &= CheckEditValue( aPasswdED, CNT_MSG_PROTOCOL_POP3, SID_RECEIVE_PASSWORD );
	bOK &= CheckEditValue( aNewsServerED, CNT_MSG_PROTOCOL_NNTP, SID_RECEIVE_SERVERNAME );
#endif

	if ( !bOK )
	   return KEEP_PAGE;

	if ( pSet )
		FillItemSet( *pSet );
	return LEAVE_PAGE;
}

// -----------------------------------------------------------------------

SfxTabPage*	SvxMailTabPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SvxMailTabPage(pParent, rAttrSet);
}

// -----------------------------------------------------------------------

BOOL SvxMailTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;
	String aTemp = aSendED.GetText();

	if ( aSendED.GetSavedValue() != aTemp )
	{
		rSet.Put( SfxStringItem( SID_INET_SMTPSERVER, aTemp ) );
		bModified |= TRUE;
	}
	aTemp = aReceiveED.GetText();

	if ( aReceiveED.GetSavedValue() != aTemp )
	{
		rSet.Put( SfxStringItem( SID_INET_POPSERVER, aTemp ) );
		bModified |= TRUE;
	}
	aTemp = aUserED.GetText();

	if ( aUserED.GetSavedValue() != aTemp )
	{
		rSet.Put( SfxStringItem( SID_INET_MAILUSERNAME, aTemp ) );
		bModified |= TRUE;
	}
	aTemp = aPasswdED.GetText();

	if ( aPasswdED.GetSavedValue() != aTemp )
	{
		rSet.Put( SfxStringItem( SID_INET_MAILPASSWORD, aTemp ) );
		bModified |= TRUE;
	}
	aTemp = aNewsServerED.GetText();

	if ( aNewsServerED.GetSavedValue() != aTemp )
	{
		rSet.Put( SfxStringItem( SID_INET_NNTPSERVER, aTemp ) );
		bModified |= TRUE;
	}
	BYTE nFormat = TXTFORMAT_ASCII;

	if ( aHtmlCB.IsChecked() )
		nFormat |= TXTFORMAT_HTML;
	if ( aRtfCB.IsChecked() )
		nFormat |= TXTFORMAT_RTF;
	if ( aOfficeCB.IsChecked() )
		nFormat |= TXTFORMAT_OFFICE;
	const SfxByteItem* pOld =
		(SfxByteItem*)GetOldItem( rSet, SID_INET_MAILTEXTFORMAT );

	if ( !pOld || pOld->GetValue() != nFormat )
	{
		rSet.Put( SfxByteItem( SID_INET_MAILTEXTFORMAT, nFormat ) );
		bModified |= TRUE;
	}

	SfxIniManager* pIniMgr = SFX_INIMANAGER();

	if ( aFontSizeBox.GetValue() != (long)aFontSizeBox.GetSavedValue().ToInt32() )
		pIniMgr->Set( String::CreateFromInt32( aFontSizeBox.GetValue() ),
					  SFX_KEY_INET_MAILTEXT_FONTHEIGHT );

	if ( aReadTimerOnCB.IsChecked() != aReadTimerOnCB.GetSavedValue() )
	{
		pIniMgr->Set( (USHORT)aReadTimerOnCB.IsChecked(), SFX_KEY_INET_READTIMER_ON );
	}
	String aTmp = aReadTimerOutED.GetText();

	if ( aReadTimerOutED.GetSavedValue() != aTmp )
	{
		pIniMgr->Set( aReadTimerOutED.GetText(), SFX_KEY_INET_READTIMER_OUT );
	}

	if ( aAutoLoadCB.IsChecked() != aAutoLoadCB.GetSavedValue() )
	{
		pIniMgr->Set( (USHORT)aAutoLoadCB.IsChecked(), SFX_KEY_INET_AUTOLOAD );
	}
	return bModified;
}

// -----------------------------------------------------------------------

void SvxMailTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_SMTPSERVER, FALSE, &pItem ) )
		aSendED.SetText( ( (const SfxStringItem*)pItem )->GetValue() );
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_POPSERVER, FALSE, &pItem ) )
		aReceiveED.SetText( ( (const SfxStringItem*)pItem )->GetValue() );
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_MAILUSERNAME, FALSE, &pItem ) )
		aUserED.SetText( ( (const SfxStringItem*)pItem )->GetValue() );
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_MAILPASSWORD, FALSE, &pItem ) )
		aPasswdED.SetText( ( (const SfxStringItem*)pItem )->GetValue() );
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_NNTPSERVER, FALSE, &pItem ) )
		aNewsServerED.SetText( ( (const SfxStringItem*)pItem )->GetValue() );
	if ( SFX_ITEM_SET == rSet.GetItemState( SID_INET_MAILTEXTFORMAT, FALSE, &pItem ) )
	{
		BYTE nValue = ( (const SfxByteItem*)pItem )->GetValue();

		if ( ( nValue & TXTFORMAT_HTML ) == TXTFORMAT_HTML )
			aHtmlCB.Check();
		if ( ( nValue & TXTFORMAT_RTF ) == TXTFORMAT_RTF )
			aRtfCB.Check();
		if ( ( nValue & TXTFORMAT_OFFICE ) == TXTFORMAT_OFFICE )
			aOfficeCB.Check();
	}

	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	String aHeightStr = pIniMgr->Get( SFX_KEY_INET_MAILTEXT_FONTHEIGHT );
	long nH = ( aHeightStr.Len() && ByteString(U2S(aHeightStr)).IsNumericAscii() )
			  ? (long)aHeightStr.ToInt32() : 100;
	aFontSizeBox.SetValue( nH );

	String aTmp = pIniMgr->Get( SFX_KEY_INET_READTIMER_ON );
	aReadTimerOnCB.Check( (BOOL)(USHORT)aTmp.ToInt32() );
	aTmp = pIniMgr->Get( SFX_KEY_INET_READTIMER_OUT );
	aReadTimerOutED.SetValue( (USHORT)aTmp.ToInt32() );
	aTmp = pIniMgr->Get( SFX_KEY_INET_AUTOLOAD );
	aAutoLoadCB.Check( (BOOL)(USHORT)aTmp.ToInt32() );

	aSendED.SaveValue();
	aReceiveED.SaveValue();
	aUserED.SaveValue();
	aPasswdED.SaveValue();
	aNewsServerED.SaveValue();
	aHtmlCB.SaveValue();
	aRtfCB.SaveValue();
	aOfficeCB.SaveValue();
	aFontSizeBox.SaveValue();
	aReadTimerOnCB.SaveValue();
	aReadTimerOutED.SaveValue();
	aAutoLoadCB.SaveValue();

	CheckHdl_Impl( &aReadTimerOnCB );
}


