/*************************************************************************
 *
 *  $RCSfile: optpath.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#if defined (WIN) || defined (WNT)
#ifndef _SVWIN_H
#include <tools/svwin.h>
#endif
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _IODLG_HXX //autogen
#include <sfx2/iodlg.hxx>
#endif
#ifndef _LIBCALL_HXX //autogen
#include <svtools/libcall.hxx>
#endif
#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif
#ifndef _SFX_INIMGR_HXX
#include <sfx2/inimgr.hxx>
#endif
#ifndef _AEITEM_HXX //autogen
#include <svtools/aeitem.hxx>
#endif
#ifndef _SVT_FILEDLG_HXX //autogen
#include <svtools/filedlg.hxx>
#endif
#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif
#include <tools/urlobj.hxx>
#pragma hdrstop

#define _SVX_OPTPATH_CXX

#include "optpath.hxx"
#include "dialmgr.hxx"
#include "multipat.hxx"
#include "optinet2.hxx"		// HeaderTabListBox

#include "optpath.hrc"
#include "dialogs.hrc"
#include "helpid.hrc"

// define ----------------------------------------------------------------

#define TAB_WIDTH1		80
#define TAB_WIDTH2		1000
#define ITEMID_TYPE		1
#define ITEMID_PATH		2

#define IDX_SUB_INI		((USHORT)(SFX_KEY_SUB_INI		- SFX_KEY_SUB_INI))
#define IDX_CONFIG		((USHORT)(SFX_KEY_CONFIG_DIR	- SFX_KEY_SUB_INI))
#define IDX_TEMPLATE	((USHORT)(SFX_KEY_TEMPLATE_PATH	- SFX_KEY_SUB_INI))
#define IDX_AGENT		((USHORT)(SFX_KEY_AGENT_DIR		- SFX_KEY_SUB_INI))
#define IDX_STORAGE		((USHORT)(SFX_KEY_STORAGE_DIR	- SFX_KEY_SUB_INI))

// URL's f"ur den Invader
#if defined(WIN) || defined(OS2) || defined(WNT)
#define INVADER_PATH "file:///C|/those/who/dont/understand/unix/are/doomed/to/reinvent/it/poorly/"
#endif
#ifdef OS2
#define INVADER_PATH_OS2_FAT "file:///C|/those/who/dont/unders~1/unix/are/doomed/to/reinvent/it/poorly/"
#endif
#ifdef UNX
#define INVADER_PATH "file:///tmp/those/who/dont/understand/unix/are/doomed/to/reinvent/it/poorly/"
#endif
#ifdef MAC
#define INVADER_PATH "file:///System/those/who/dont/understand/unix/are/doomed/to/reinvent/it/poorly/"
#endif

// struct OptPath_Impl ---------------------------------------------------
// wird im Moment nicht ben"otigt

struct OptPath_Impl
{
};

// struct PathUserData_Impl ----------------------------------------------

struct PathUserData_Impl
{
	USHORT			nRealId;
	SfxItemState	eState;
	String			aPathStr;

	PathUserData_Impl( USHORT nId ) :
		nRealId( nId ), eState( SFX_ITEM_UNKNOWN ) {}
};

// class SvxPathControl_Impl ---------------------------------------------

long SvxPathControl_Impl::Notify( NotifyEvent& rNEvt )
{
	long nRet = Control::Notify( rNEvt );

	if ( m_pFocusCtrl && rNEvt.GetWindow() != m_pFocusCtrl && rNEvt.GetType() == EVENT_GETFOCUS )
		m_pFocusCtrl->GrabFocus();
	return nRet;
}

// class OptLBoxString_Impl ----------------------------------------------

class OptLBoxString_Impl : public SvLBoxString
{
public:
	OptLBoxString_Impl( SvLBoxEntry* pEntry, USHORT nFlags,	const String& rTxt ) :
		SvLBoxString( pEntry, nFlags, rTxt ) {}

	virtual void Paint( const Point& rPos, SvLBox& rDev, USHORT nFlags, SvLBoxEntry* pEntry );
};

// -----------------------------------------------------------------------

void OptLBoxString_Impl::Paint( const Point& rPos, SvLBox& rDev, USHORT, SvLBoxEntry* pEntry )
{
	Font aOldFont( rDev.GetFont() );
	Font aFont( aOldFont );
	DBG_ASSERT( pEntry && pEntry->GetUserData(), "Entry or UserData invalid" );
	if (  ( (PathUserData_Impl*)pEntry->GetUserData() )->nRealId == IDX_CONFIG )
		aFont.SetColor( Application::GetSettings().GetStyleSettings().GetDeactiveTextColor() );
	rDev.SetFont( aFont );
	rDev.DrawText( rPos, GetText() );
	rDev.SetFont( aOldFont );
}

// class OptHeaderTabListBox ---------------------------------------------

class OptHeaderTabListBox : public HeaderTabListBox
{
public:
	OptHeaderTabListBox( Window* pParent, WinBits nBits ) :
		HeaderTabListBox( pParent, nBits ) {}

	virtual void	InitEntry( SvLBoxEntry*, const XubString&, const Image&, const Image& );
};

// -----------------------------------------------------------------------

void OptHeaderTabListBox::InitEntry( SvLBoxEntry* pEntry, const XubString& rTxt,
									 const Image& rImg1, const Image& rImg2 )
{
	SvTabListBox::InitEntry( pEntry, rTxt, rImg1, rImg2 );
	USHORT nTabCount = TabCount();

	for ( USHORT nCol = 1; nCol < nTabCount; ++nCol )
	{
		// alle Spalten mit eigener Klasse initialisieren (Spalte 0 == Bitmap)
		SvLBoxString* pCol = (SvLBoxString*)pEntry->GetItem( nCol );
		OptLBoxString_Impl* pStr = new OptLBoxString_Impl( pEntry, 0, pCol->GetText() );
		pEntry->ReplaceItem( pStr, nCol );
	}
}

// functions -------------------------------------------------------------

BOOL IsMultiPath_Impl( const USHORT nIndex )
{
	USHORT nKey = nIndex + SFX_KEY_SUB_INI;
	return ( SFX_KEY_BASIC_PATH == nKey	|| SFX_KEY_MODULES_PATH == nKey ||
			 SFX_KEY_TEMPLATE_PATH == nKey || SFX_KEY_GLOSSARY_PATH == nKey ||
			 SFX_KEY_DESKTOP_DIR == nKey || SFX_KEY_GALLERY_DIR == nKey ||
			 SFX_KEY_PLUGINS_PATH == nKey || SFX_KEY_FILTER_PATH == nKey ||
			 SFX_KEY_ADDINS_PATH == nKey );
}

// ------------------------------------------------------------------------

String GetEntryURL_Impl( const USHORT nIndex, const OptHeaderTabListBox* pBox )
{
	String aURL;
	for ( USHORT i = 0; pBox && i < pBox->GetEntryCount(); ++i )
	{
		PathUserData_Impl* pUserData = (PathUserData_Impl*)pBox->GetEntry(i)->GetUserData();
		if ( nIndex == pUserData->nRealId )
		{
			INetURLObject aEntry( pUserData->aPathStr, INET_PROT_FILE );
			aEntry.setFinalSlash();
			aURL = aEntry.GetMainURL();
			break;
		}
	}
	return aURL;
}

// class SvxPathTabPage --------------------------------------------------

SvxPathTabPage::SvxPathTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SFXPAGE_PATH ), rSet ),

	aTypeText		( this, ResId( FT_TYPE ) ),
	aPathText		( this, ResId( FT_PATH ) ),
	aPathCtrl		( this, ResId( LB_PATH ) ),
	aStandardBtn	( this, ResId( BTN_STANDARD ) ),
	aPathBtn		( this, ResId( BTN_PATH ) ),
	aStdBox			( this, ResId( GB_STD ) ),

	pHeaderBar		( NULL ),
	pPathBox		( NULL ),
	pImpl			( NULL )

{
	aStandardBtn.SetClickHdl( LINK( this, SvxPathTabPage, StandardHdl_Impl ) );
	Link aLink = LINK( this, SvxPathTabPage, PathHdl_Impl );
	aPathBtn.SetClickHdl( aLink );
	Size aBoxSize = aPathCtrl.GetOutputSizePixel();
	pHeaderBar = new HeaderBar( &aPathCtrl, WB_BUTTONSTYLE | WB_BOTTOMBORDER );
	pHeaderBar->SetPosSizePixel( Point( 0, 0 ), Size( aBoxSize.Width(), 16 ) );
	pHeaderBar->SetSelectHdl( LINK( this, SvxPathTabPage, HeaderSelect_Impl ) );
	pHeaderBar->SetEndDragHdl( LINK( this, SvxPathTabPage, HeaderEndDrag_Impl ) );
	Size aSz;
	aSz.Width() = TAB_WIDTH1;
	pHeaderBar->InsertItem( ITEMID_TYPE, aTypeText.GetText(),
							LogicToPixel( aSz, MapMode( MAP_APPFONT ) ).Width(),
							HIB_LEFT | HIB_VCENTER | HIB_CLICKABLE | HIB_UPARROW );
	aSz.Width() = TAB_WIDTH2;
	pHeaderBar->InsertItem( ITEMID_PATH, aPathText.GetText(),
							LogicToPixel( aSz, MapMode( MAP_APPFONT ) ).Width(),
							HIB_LEFT | HIB_VCENTER );

	static long nTabs[] = {3, 0, TAB_WIDTH1, TAB_WIDTH1 + TAB_WIDTH2 };
	Size aHeadSize = pHeaderBar->GetSizePixel();

	WinBits nBits = WB_SORT | WB_HSCROLL | WB_CLIPCHILDREN | WB_TABSTOP;
	pPathBox = new OptHeaderTabListBox( &aPathCtrl, nBits );
	aPathCtrl.SetFocusControl( pPathBox );
	pPathBox->SetWindowBits( nBits );
	pPathBox->SetDoubleClickHdl( aLink );
	pPathBox->SetSelectHdl( LINK( this, SvxPathTabPage, PathSelect_Impl ) );
	pPathBox->SetSelectionMode( MULTIPLE_SELECTION );
	pPathBox->SetPosSizePixel( Point( 0, aHeadSize.Height() ),
							   Size( aBoxSize.Width(), aBoxSize.Height() - aHeadSize.Height() ) );
	pPathBox->SetTabs( &nTabs[0], MAP_APPFONT );
	pPathBox->InitHeaderBar( pHeaderBar );
	pPathBox->SetHighlightRange();
	pPathBox->SetHelpId( HID_OPTPATH_CTL_PATH );
	pHeaderBar->SetHelpId( HID_OPTPATH_HEADERBAR );
	pPathBox->Show();
	pHeaderBar->Show();

	// der StandardButton macht nur Sinn, wenn es eine Sub-Ini gibt.
//	if ( !SFX_INIMANAGER()->GetSubManager() )
//		aStandardBtn.Hide();

	FreeResource();
}

// -----------------------------------------------------------------------

SvxPathTabPage::~SvxPathTabPage()
{
	pHeaderBar->Hide();
	for ( USHORT i = 0; i < pPathBox->GetEntryCount(); ++i )
		delete (PathUserData_Impl*)pPathBox->GetEntry(i)->GetUserData();
	delete pPathBox;
	delete pHeaderBar;
	delete pImpl;
}

// -----------------------------------------------------------------------

SfxTabPage*	SvxPathTabPage::Create( Window* pParent,
									const SfxItemSet& rAttrSet )
{
	return ( new SvxPathTabPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------

BOOL SvxPathTabPage::FillItemSet( SfxItemSet& rCoreSet )
{
	SfxAllEnumItem aPathItem( GetWhich( SID_ATTR_PATHNAME ) );
	String aBlank( ' ' );

	for ( USHORT i = 0; i < pPathBox->GetEntryCount(); ++i )
	{
		PathUserData_Impl* pPathImpl = (PathUserData_Impl*)pPathBox->GetEntry(i)->GetUserData();
		SfxItemState eState = pPathImpl ? pPathImpl->eState : SFX_ITEM_UNKNOWN;
		USHORT nRealId = pPathImpl->nRealId;

		switch ( eState )
		{
			case SFX_ITEM_SET:
				// Eintrag in App-Ini machen
				aPathItem.InsertValue( nRealId, pPathImpl->aPathStr );
				break;

			case SFX_ITEM_DONTCARE:
				// Eintrag in App-Ini l"oschen
				aPathItem.InsertValue( nRealId, String() );
				break;

			case SFX_ITEM_UNKNOWN:
				// Eintrag in App-Ini unver"andert lassen
				aPathItem.InsertValue( nRealId, aBlank );
				break;
		}
	}
	aPathItem.InsertValue( IDX_AGENT, aBlank );
	rCoreSet.Put( aPathItem );
	return TRUE;
}

// -----------------------------------------------------------------------

void SvxPathTabPage::Reset( const SfxItemSet& rSet )
{
	SfxItemState eItemState = SFX_ITEM_UNKNOWN;
	const SfxAllEnumItem* pGrpItem = NULL;
	const SfxAllEnumItem* pNameItem = NULL;
	USHORT nWhich = GetWhich( SID_ATTR_PATHGROUP );

	// Item mit den Pfad-Gruppen holen
	eItemState = rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pGrpItem );

	if ( eItemState == SFX_ITEM_DEFAULT )
		pGrpItem = (const SfxAllEnumItem*)&( rSet.Get( nWhich ) );
	else if ( eItemState == SFX_ITEM_DONTCARE )
		pGrpItem = NULL;

	// Item mit den Pfad-Namen holen
	nWhich = GetWhich( SID_ATTR_PATHNAME );
	eItemState = rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pNameItem );

	if ( eItemState == SFX_ITEM_DEFAULT )
		pNameItem = (const SfxAllEnumItem*)&( rSet.Get( nWhich ) );
	else if ( eItemState == SFX_ITEM_DONTCARE )
		pNameItem = NULL;

	if ( !pGrpItem || !pNameItem )
	{
		DBG_ERRORFILE( "keine Pfade" );
		return;
	}

	if ( pGrpItem->GetValueCount() != pNameItem->GetValueCount() )
	{
		DBG_ERRORFILE( "die Counts der Items sind unterschiedlich" );
		return;
	}

	// TabListBox f"ullen
	pPathBox->Clear();

	for ( USHORT i = 0; i < pNameItem->GetValueCount(); ++i )
	{
		if ( IDX_AGENT == i )
			continue;

		String aStr( pGrpItem->GetValueTextByPos(i) );
		String aValue( pNameItem->GetValueTextByPos(i) );
		aStr += '\t';
		aStr += aValue;
		SvLBoxEntry* pEntry = pPathBox->InsertEntry( aStr );
		PathUserData_Impl* pPathImpl = new PathUserData_Impl( i );
		pPathImpl->aPathStr = aValue;
		pEntry->SetUserData( pPathImpl );
	}

	String aUserData = GetUserData();

	if ( aUserData.Len() )
	{
		// Spaltenbreite restaurieren
		pHeaderBar->SetItemSize( ITEMID_TYPE, aUserData.GetToken(0).ToInt32() );
		HeaderEndDrag_Impl( NULL );
		// Sortierrichtung restaurieren
		BOOL bUp = (BOOL)(USHORT)aUserData.GetToken(1).ToInt32();
		HeaderBarItemBits nBits	= pHeaderBar->GetItemBits(ITEMID_TYPE);

		if ( bUp )
		{
			nBits &= ~HIB_UPARROW;
			nBits |= HIB_DOWNARROW;
		}
		else
		{
			nBits &= ~HIB_DOWNARROW;
			nBits |= HIB_UPARROW;
		}
		pHeaderBar->SetItemBits( ITEMID_TYPE, nBits );
		HeaderSelect_Impl( NULL );
	}
	PathSelect_Impl( NULL );
}

// -----------------------------------------------------------------------

void SvxPathTabPage::FillUserData()
{
	String aUserData = String::CreateFromInt32( pHeaderBar->GetItemSize( ITEMID_TYPE ) );
	aUserData += ';';
	HeaderBarItemBits nBits	= pHeaderBar->GetItemBits( ITEMID_TYPE );
	BOOL bUp = ( ( nBits & HIB_UPARROW ) == HIB_UPARROW );
	aUserData += bUp ? '1' : '0';
	SetUserData( aUserData );
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxPathTabPage, PathSelect_Impl, OptHeaderTabListBox *, EMPTYARG )

/*	[Beschreibung]

*/

{
	BOOL bConfigPath = FALSE;
	USHORT nSelCount = 0;
	SvLBoxEntry* pEntry = pPathBox->FirstSelected();

	while ( pEntry && ( nSelCount < 2 || bConfigPath ) )
	{
		if (  ( (PathUserData_Impl*)pEntry->GetUserData() )->nRealId == IDX_CONFIG )
			bConfigPath = TRUE;
		nSelCount++;
		pEntry = pPathBox->NextSelected( pEntry );
	}

	aPathBtn.Enable( 1 == nSelCount && !bConfigPath );
	aStandardBtn.Enable( nSelCount > 0 && !bConfigPath );
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxPathTabPage, StandardHdl_Impl, PushButton *, EMPTYARG )

/*	[Beschreibung]

	Dieser Standard-Button-Handler holt sich aus dem Sub-Ini-Manager
	(soffice3.ini) alle Pfade, au\ser SubIni (0.) und Template (10.)
	und tr"agt diese in die ListBox ein. Die Ini-Group Directories
	selbst wird bis auf die beiden Eintr"age gel"oscht.
*/

{
	// den folgenden Ini-Manager (z.B. soffice3.ini) nehmen
	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	SfxIniManager* pSubMgr = NULL; //!!! pIniMgr->GetSubManager();

	if ( pSubMgr )
	{
		// die (Office-) Daten abholen
		SfxItemPool *pPool = GetItemSet().GetPool();
		SfxAllEnumItem aNames( pPool->GetWhich(SID_ATTR_PATHGROUP) );
		SfxAllEnumItem aValues( pPool->GetWhich(SID_ATTR_PATHNAME) );
		pSubMgr->Fill(SFX_GROUP_DIR, aNames, aValues);

		// Template und SubIni aus direktem IniManager dr"uberpl"atten
		aValues.RemoveValue( IDX_SUB_INI );
		aValues.InsertValue( IDX_SUB_INI,
							 pIniMgr->Get( SFX_KEY_SUB_INI ) );
		aValues.RemoveValue( IDX_TEMPLATE );
		aValues.InsertValue( IDX_TEMPLATE,
							 pIniMgr->Get( SFX_KEY_TEMPLATE_PATH ) );

		// die Daten in die TabPage f"ullen
		SfxItemSet aSet( *pPool,
						 SID_ATTR_PATHGROUP, SID_ATTR_PATHGROUP,
						 SID_ATTR_PATHNAME, SID_ATTR_PATHNAME, 0L );
		aSet.Put(aNames);
		aSet.Put(aValues);
		Reset( aSet );

		// alles au\ser SubIni/Template als 'zur"uckgesetzt' markieren
		for ( USHORT i = 1; i < pPathBox->GetEntryCount(); ++i )
		{
			// als ver"andert kennzeichnen
			PathUserData_Impl* pPathImpl =
				(PathUserData_Impl*)pPathBox->GetEntry(i)->GetUserData();
			USHORT nRealId = pPathImpl->nRealId;

			if ( IDX_SUB_INI == nRealId || IDX_TEMPLATE == nRealId )
				pPathImpl->eState = SFX_ITEM_UNKNOWN;
			else
				pPathImpl->eState = SFX_ITEM_DONTCARE;
		}
	}
	else
	{
		SvLBoxEntry* pEntry = pPathBox->FirstSelected();

		while ( pEntry )
		{
			PathUserData_Impl* pPathImpl = (PathUserData_Impl*)pEntry->GetUserData();
			USHORT nKey = pPathImpl->nRealId + SFX_KEY_SUB_INI;
			String aKey = pIniMgr->GetKeyName( nKey );
			String aOldPath;

			if ( aKey.Len() )
			{
				aOldPath = pIniMgr->ReadKey( String::CreateFromAscii(GROUPNAME_DIRBACKUP), aKey );
			}

			if ( !aOldPath.Len() )
			{
				// Item mit den Pfad-Namen holen
				const SfxAllEnumItem* pOldItem =
					(const SfxAllEnumItem*)GetOldItem( GetItemSet(), SID_ATTR_PATHNAME );

				if ( pOldItem )
					aOldPath = pOldItem->GetValueTextByPos( pPathImpl->nRealId );
			}

			if ( aOldPath.Len() )
			{
				aOldPath = pIniMgr->SubstPathVars( aOldPath );
				pPathBox->SetEntryText( aOldPath, pEntry, 1 );
				pPathImpl->eState = SFX_ITEM_SET;
				pPathImpl->aPathStr = aOldPath;
			}
			pEntry = pPathBox->NextSelected( pEntry );
		}
	}
	return 0;
}

void StartInvader( Window* );

// -----------------------------------------------------------------------

IMPL_LINK( SvxPathTabPage, PathHdl_Impl, PushButton *, EMPTYARG )
{
	SvLBoxEntry* pEntry = pPathBox->GetCurEntry();
	SfxFileDialog* pFileDlg = NULL;
	USHORT nPos = 0;

	if ( pEntry )
		nPos = ( (PathUserData_Impl*)pEntry->GetUserData() )->nRealId;

	if ( IDX_CONFIG == nPos )
		return 0;

	FASTBOOL bFile = ( IDX_SUB_INI == nPos );

	if ( bFile )
	{
		pFileDlg = new SfxFileDialog( this, WB_OPEN | WB_3DLOOK );

#if defined MAC
		pFileDlg->AddFilter( String::CreateFromAscii("Prefs"), String::CreateFromAscii("TEXT.Prefs") );
		pFileDlg->SetCurFilter( String::CreateFromAscii("Prefs") );
#elif defined UNX
		pFileDlg->AddFilter( String::CreateFromAscii(".*rc"), String::CreateFromAscii(".*rc") );
		pFileDlg->SetCurFilter( String::CreateFromAscii(".*rc") );
#else
		pFileDlg->AddFilter( String::CreateFromAscii("*.ini"), String::CreateFromAscii("*.ini") );
		pFileDlg->SetCurFilter( String::CreateFromAscii("*.ini") );
#endif

		if ( pEntry )
			pFileDlg->SetText( pPathBox->GetEntryText( pEntry, 0 ) );
	}
	else
		pFileDlg = new SfxFileDialog( this, WB_OPEN | SFXWB_PATHDIALOG | WB_3DLOOK );

	String aPathName;

	if ( pEntry )
	{
		PathUserData_Impl* pPathImpl =
			(PathUserData_Impl*)pEntry->GetUserData();
		aPathName = pPathImpl->aPathStr;
#ifdef MAC
		// ggf. ':' abschneiden
		if ( aPathName( aPathName.Len() - 1 ) == ':')
			aPathName.Erase( aPathName.Len() - 1 );
#endif
		if ( bFile )
		{
			BOOL bDir = FALSE;

			if ( !aPathName.Len() )
			{
				bDir = TRUE;
				aPathName =
					SFX_INIMANAGER()->Get( SFX_KEY_MODULES_PATH ).GetToken(0);
			}

			INetURLObject aObj( aPathName, INET_PROT_FILE );
			aObj.setFinalSlash();
			pFileDlg->SetPath( aObj.GetMainURL() );
		}
		else
			pFileDlg->SetPath( aPathName );
	}

	if ( IsMultiPath_Impl( nPos ) )
	{
		SvxMultiPathDialog aDlg( this );
		aDlg.SetPath( aPathName );

		if ( aDlg.Execute() == RET_OK && pEntry )
		{
			INetURLObject aObj( aDlg.GetPath() );
			String aNewPath = aObj.getFSysPath( INetURLObject::FSYS_DETECT );
			pPathBox->SetEntryText( aNewPath, pEntry, 1 );

			// merken, da\s er ver"andert wurde
			nPos = (USHORT)pPathBox->GetModel()->GetAbsPos( pEntry );
			PathUserData_Impl* pPathImpl = (PathUserData_Impl*)pPathBox->GetEntry(nPos)->GetUserData();
			pPathImpl->eState = SFX_ITEM_SET;
			pPathImpl->aPathStr = aNewPath;
		}
	}
	else if ( pEntry )
	{
		short nRet = pFileDlg->Execute();

		if ( RET_OK != nRet )
		{
			delete pFileDlg;
			return 0;
		}

		// neuen Pfad in ListBox setzen
		String aPathStr = pFileDlg->GetPath();
		INetURLObject aNewPathObj( aPathStr );
		String aCmpStr( String::CreateFromAscii(INVADER_PATH) );
		FASTBOOL bInvader = ( aPathStr.CompareIgnoreCaseToAscii( aCmpStr ) == COMPARE_EQUAL );

#ifdef OS2
		if ( !bInvader )
		{
			// auf FAT-Systemen wird ein Langname gek"urzt
			bInvader = ( aPathStr.CompareIgnoreCaseToAscii( String( INVADER_PATH_OS2_FAT ) ) == COMPARE_EQUAL );
		}
#endif

		if ( bInvader )
		{
			StartInvader( Application::GetDefDialogParent() );
			delete pFileDlg;
			return 0;
		}

		if ( IDX_CONFIG == nPos || IDX_STORAGE == nPos )
		{
			if ( aPathStr.GetChar( aPathStr.Len() - 1 ) != '/' )
				aPathStr += '/';
			String aCfgPath, aStorPath;
			aCfgPath = GetEntryURL_Impl( IDX_CONFIG, pPathBox );
			aStorPath = GetEntryURL_Impl( IDX_STORAGE, pPathBox );
			FASTBOOL bEqualPaths =
				( ( IDX_CONFIG == nPos && aStorPath.CompareIgnoreCaseToAscii( aPathStr ) == COMPARE_EQUAL ) ||
				  ( IDX_STORAGE == nPos && aCfgPath.CompareIgnoreCaseToAscii( aPathStr ) == COMPARE_EQUAL ) );

			while  ( bEqualPaths )
			{
				// solange die Verzeichnisse f"ur die Konfiguration und
				// die CHAOS-Storages gleich sind, wird eine Fehlermeldung
				// gezeigt und der Pfaddialog neu gestartet.
				ErrorBox aBox( this, SVX_RES( RID_SVXERR_OPT_DOUBLEPATHS ) );
				aBox.Execute();

				if ( pFileDlg->Execute() == RET_CANCEL )
				{
					delete pFileDlg;
					return 0;
				}
				else
				{
					aPathStr = pFileDlg->GetPath();
					aNewPathObj.SetURL( aPathStr );
					bEqualPaths =
						( ( IDX_CONFIG == nPos &&
							aStorPath.CompareIgnoreCaseToAscii( aPathStr ) == COMPARE_EQUAL ) ||
						  ( IDX_STORAGE == nPos &&
							aCfgPath.CompareIgnoreCaseToAscii( aPathStr ) == COMPARE_EQUAL ) );
				}
			}
		}

		String aNewPathStr = aNewPathObj.getFSysPath( INetURLObject::FSYS_DETECT );
		FASTBOOL bChanged =
#ifdef UNX
// Unix is case sensitive
							( aNewPathStr != aPathName );
#else
							( aNewPathStr.CompareIgnoreCaseToAscii( aPathName ) != COMPARE_EQUAL );
#endif

		if ( bChanged )
		{
			pPathBox->SetEntryText( aNewPathStr, pEntry, 1 );
			nPos = (USHORT)pPathBox->GetModel()->GetAbsPos( pEntry );
			PathUserData_Impl* pPathImpl = (PathUserData_Impl*)pPathBox->GetEntry(nPos)->GetUserData();
			pPathImpl->eState = SFX_ITEM_SET;
			pPathImpl->aPathStr = aNewPathStr;
		}
	}
	delete pFileDlg;
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxPathTabPage, HeaderSelect_Impl, HeaderBar*, pBar )
{
	if ( pBar && pBar->GetCurItemId() != ITEMID_TYPE )
		return 0;

	HeaderBarItemBits nBits	= pHeaderBar->GetItemBits(ITEMID_TYPE);
	BOOL bUp = ( ( nBits & HIB_UPARROW ) == HIB_UPARROW );
	SvSortMode eMode = SortAscending;

	if ( bUp )
	{
		nBits &= ~HIB_UPARROW;
		nBits |= HIB_DOWNARROW;
		eMode = SortDescending;
	}
	else
	{
		nBits &= ~HIB_DOWNARROW;
		nBits |= HIB_UPARROW;
	}
	pHeaderBar->SetItemBits( ITEMID_TYPE, nBits );
	SvTreeList* pModel = pPathBox->GetModel();
	pModel->SetSortMode( eMode );
	pModel->Resort();
	return 1;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvxPathTabPage, HeaderEndDrag_Impl, HeaderBar*, pBar )
{
	if ( pBar && !pBar->GetCurItemId() )
		return 0;

	if ( !pHeaderBar->IsItemMode() )
	{
		Size aSz;
		USHORT nTabs = pHeaderBar->GetItemCount();
		long nTmpSz = 0;
		long nWidth = pHeaderBar->GetItemSize(ITEMID_TYPE);
		long nBarWidth = pHeaderBar->GetSizePixel().Width();

		if ( ( nBarWidth - nWidth ) < 10 )
			pHeaderBar->SetItemSize( ITEMID_TYPE, nBarWidth - 10 );

		for ( USHORT i = 1; i <= nTabs; ++i )
		{
			long nWidth = pHeaderBar->GetItemSize(i);
			aSz.Width() =  nWidth + nTmpSz;
			nTmpSz += nWidth;
			pPathBox->SetTab( i, PixelToLogic( aSz, MapMode(MAP_APPFONT) ).Width(), MAP_APPFONT );
		}
	}
	return 1;
}

// Invader ---------------------------------------------------------------

#ifdef WNT
extern "C" { typedef void (__cdecl *InvaderFunc)( Window*, ResMgr* ); }
#else
extern "C" { typedef void (*InvaderFunc)( Window*, ResMgr* ); }
#endif

void StartInvader( Window* pParent )
{/*ASMUSS fuer Gimmick-Spiel SpaceInvader !!! :-)
	// tfu-DLL laden
	String aTfuDll( SVLIBRARY("tfu") );
	SvLibrary* pLibrary = new SvLibrary( aTfuDll );

	if ( pLibrary->ModulFound() )
	{
		// DLL gefunden -> Resource laden
		String aResName = "tfu";
		aResName += String( SOLARUPD );
		ResMgr* pInvaderRes = ResMgr::CreateResMgr(
			aResName, Application::GetAppInternational().GetLanguage() );
		InvaderFunc pFunc =
			(InvaderFunc)pLibrary->GetFunction ( "StartInvader" );

		if ( pFunc && pInvaderRes )
			// Invader starten
			(*pFunc)(pParent, pInvaderRes);
	}*/
}


