/*************************************************************************
 *
 *  $RCSfile: optsave.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#pragma hdrstop

#define _SVX_OPTSAVE_CXX

#include "optsave.hrc"
#include "dialogs.hrc"

#include "optsave.hxx"
#include "dialmgr.hxx"

// class SvxSaveTabPage --------------------------------------------------

SfxSaveTabPage::SfxSaveTabPage( Window* pParent, const SfxItemSet& rCoreSet ) :

	SfxTabPage( pParent, SVX_RES( RID_SFXPAGE_SAVE ), rCoreSet ),

	aSaveBox			( this,	ResId( GB_SAVE ) ),
	aDocInfoBtn			( this, ResId( BTN_DOCINFO ) ),
	aBackupBtn			( this,	ResId( BTN_BACKUP ) ),
	aAutoSaveBtn		( this,	ResId( BTN_AUTOSAVE ) ),
	aAutoSaveEdit		( this,	ResId( ED_AUTOSAVE ) ),
	aMinuteText			( this,	ResId( FT_MINUTE ) ),
	aAutoSavePromptBtn	( this,	ResId( BTN_AUTOSAVEPROMPT ) ),
	aSaveGraphicsBox	( this,	ResId( GB_SAVEGRAPHICS ) ),
	aSaveNormalRB		( this,	ResId( RB_SAVENORMAL ) ),
	aSaveCompressRB		( this,	ResId( RB_SAVECOMPRESS ) ),
	aSaveOriginalRB		( this,	ResId( RB_SAVEORIGINAL ) ),
	aWorkingSetBox		( this, ResId( GB_WORKINGSET ) ),
	aDocViewBtn			( this, ResId( BTN_DOCVIEW ) ),
	aOpenWinBtn			( this, ResId( BTN_OPENWIN ) ),
	aOpenDocBtn			( this, ResId( BTN_OPENDOC ) ),
	aRelBox				( this, ResId( GB_RELATIVE ) ),
	aRelFsysBtn			( this, ResId( BTN_RELATIVE_FSYS ) ),
	aRelInetBtn			( this, ResId( BTN_RELATIVE_INET ) ),
	aUndoBox			( this,	ResId( GB_UNDO ) ),
	aUndoText			( this,	ResId( FT_UNDO ) ),
	aUndoEdit			( this,	ResId( ED_UNDO ) )

{
	FreeResource();

	Link aLink = LINK( this, SfxSaveTabPage, AutoClickHdl_Impl );
	aDocInfoBtn.SetClickHdl( aLink );
	aBackupBtn.SetClickHdl( aLink );
	aAutoSaveBtn.SetClickHdl( aLink );
	aAutoSavePromptBtn.SetClickHdl( aLink );

	aAutoSaveEdit.SetMaxTextLen( 2 );
	aUndoEdit.SetMaxTextLen( 3 );
}

// -----------------------------------------------------------------------

SfxSaveTabPage::~SfxSaveTabPage()
{
}

// -----------------------------------------------------------------------

SfxTabPage*	SfxSaveTabPage::Create( Window* pParent,
									const SfxItemSet& rAttrSet )
{
	return ( new SfxSaveTabPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------

BOOL SfxSaveTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;

	if ( aDocInfoBtn.IsChecked() != aDocInfoBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_DOCINFO ),
							   aDocInfoBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aBackupBtn.IsChecked() != aBackupBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_BACKUP ),
							   aBackupBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aAutoSaveBtn.IsChecked() != aAutoSaveBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_AUTOSAVE ),
							   aAutoSaveBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aAutoSavePromptBtn.IsChecked() != aAutoSavePromptBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_AUTOSAVEPROMPT ),
							   aAutoSavePromptBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aSaveCompressRB.IsChecked() != aSaveCompressRB.GetSavedValue() ||
		 aSaveOriginalRB.IsChecked() != aSaveOriginalRB.GetSavedValue()	)
	{
		//              |   SaveNormalRB |  SaveCompressRB  |  SaveOriginalRB
		// SaveCompress |                |       x          |
		// SaveOriginal |                |       x          |       x

		BOOL bSaveCompressed = aSaveCompressRB.IsChecked();
		rSet.Put( SfxBoolItem( GetWhich( SID_OPT_SAVEGRAPHICSCOMPRESSED ), bSaveCompressed ) );

		if( bSaveCompressed )
			rSet.Put( SfxBoolItem( GetWhich( SID_OPT_SAVEORIGINALGRAPHICS ), TRUE ) );
		else
			rSet.Put( SfxBoolItem( GetWhich( SID_OPT_SAVEORIGINALGRAPHICS ),
							   aSaveOriginalRB.IsChecked() ) );

		bModified |= TRUE;
	}

	if ( aAutoSaveEdit.GetText() != aAutoSaveEdit.GetSavedValue() )
	{
		rSet.Put( SfxUInt16Item( GetWhich( SID_ATTR_AUTOSAVEMINUTE ),
								 (UINT16)aAutoSaveEdit.GetValue() ) );
		bModified |= TRUE;
	}
	// Workingset
	if ( aDocViewBtn.IsChecked() != aDocViewBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_SAVEDOCVIEW ),
							   aDocViewBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aOpenWinBtn.IsChecked() != aOpenWinBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_SAVEDOCWINS ),
							   aOpenWinBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aOpenDocBtn.IsChecked() != aOpenDocBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_WORKINGSET ),
							   aOpenDocBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	// relativ speichern
	if ( aRelFsysBtn.IsChecked() != aRelFsysBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_SAVEREL_FSYS ),
							   aRelFsysBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	if ( aRelInetBtn.IsChecked() != aRelInetBtn.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( GetWhich( SID_SAVEREL_INET ),
							   aRelInetBtn.IsChecked() ) );
		bModified |= TRUE;
	}

	// Undo-Schritte
	if ( aUndoEdit.GetText() != aUndoEdit.GetSavedValue() )
	{
		rSet.Put( SfxUInt16Item( GetWhich( SID_ATTR_UNDO_COUNT ),
								 (UINT16)aUndoEdit.GetValue() ) );
		bModified |= TRUE;
	}
	return bModified;
}

// -----------------------------------------------------------------------

void SfxSaveTabPage::Reset( const SfxItemSet& rSet )
{
	SfxItemState eItemState = SFX_ITEM_UNKNOWN;
//	const SfxItemSet& rSet = GetItemSet();
	const SfxBoolItem* pAttr = NULL;
	const SfxUInt16Item* pMinAttr = NULL;

	for ( USHORT i = SID_ATTR_DOCINFO; i < SID_ATTR_AUTOSAVEMINUTE; ++i  )
	{
		pAttr = (SfxBoolItem*)GetItem( rSet, i );
		CheckBox* pBox = NULL;

		switch ( i )
		{
			case SID_ATTR_DOCINFO:
				pBox = &aDocInfoBtn;
				break;

			case SID_ATTR_BACKUP:
				pBox = &aBackupBtn;
				break;

			case SID_ATTR_AUTOSAVE:
				pBox = &aAutoSaveBtn;
				break;

			case SID_ATTR_AUTOSAVEPROMPT:
				pBox = &aAutoSavePromptBtn;
				break;

			case SID_ATTR_INDEP_METAFILE:
				// neue ID
				break;
		}

		if ( pBox )
			pBox->Check( pAttr ? pAttr->GetValue() : FALSE );
	}

	pAttr = (SfxBoolItem*)GetItem( rSet, SID_OPT_SAVEGRAPHICSCOMPRESSED );
	aSaveCompressRB.Check( pAttr ? pAttr->GetValue() : FALSE );

	if( !aSaveCompressRB.IsChecked() )
	{
		pAttr = (SfxBoolItem*)GetItem( rSet, SID_OPT_SAVEORIGINALGRAPHICS );
		aSaveOriginalRB.Check( pAttr ? pAttr->GetValue() : FALSE );
	}
	else
		aSaveOriginalRB.Check( FALSE );

	aSaveNormalRB.Check(
		( !aSaveCompressRB.IsChecked() && !aSaveOriginalRB.IsChecked() ) );

	USHORT nWhich = GetWhich( SID_ATTR_AUTOSAVEMINUTE );
	eItemState =
		rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pMinAttr );

	// handelt es sich um ein Default-Item?
	if ( eItemState == SFX_ITEM_DEFAULT )
		pMinAttr = (const SfxUInt16Item*)&( rSet.Get( nWhich ) );
	else if ( eItemState == SFX_ITEM_DONTCARE )
		pMinAttr = NULL;

	aAutoSaveEdit.SetValue( pMinAttr ? (long)pMinAttr->GetValue() : 15 );

	const SfxPoolItem* pItem = 0;

	// WorkingSet
	nWhich = GetWhich( SID_ATTR_SAVEDOCVIEW );

	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
		aDocViewBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );

	nWhich = GetWhich( SID_ATTR_SAVEDOCWINS );

	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
		aOpenWinBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );

	nWhich = GetWhich( SID_ATTR_WORKINGSET );

	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
		aOpenDocBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );

	// relativ speichern
	nWhich = GetWhich( SID_SAVEREL_FSYS );

	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
		aRelFsysBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );

	nWhich = GetWhich( SID_SAVEREL_INET );

	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
		aRelInetBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );

	// Undo-Schritte
	nWhich = GetWhich( SID_ATTR_UNDO_COUNT );

	if ( rSet.GetItemState( nWhich, FALSE ) >= SFX_ITEM_AVAILABLE )
	{
		const SfxUInt16Item& rItem = (const SfxUInt16Item&)rSet.Get( nWhich );
		aUndoEdit.SetValue( rItem.GetValue() );
	}
	else
		aUndoEdit.SetValue( 100 );
	AutoClickHdl_Impl( &aAutoSaveBtn );

	aDocInfoBtn.SaveValue();
	aBackupBtn.SaveValue();
	aAutoSaveBtn.SaveValue();
	aAutoSaveEdit.SaveValue();
	aAutoSavePromptBtn.SaveValue();
	aSaveCompressRB.SaveValue();
	aSaveOriginalRB.SaveValue();
	aUndoEdit.SaveValue();

	aDocViewBtn.SaveValue();
	aOpenWinBtn.SaveValue();
	aOpenDocBtn.SaveValue();
	aRelFsysBtn.SaveValue();
	aRelInetBtn.SaveValue();
}

// -----------------------------------------------------------------------

IMPL_LINK( SfxSaveTabPage, AutoClickHdl_Impl, CheckBox *, pBox )
{
	if ( pBox == &aAutoSaveBtn )
	{
		if ( aAutoSaveBtn.IsChecked() )
		{
			aAutoSaveEdit.Enable();
			aMinuteText.Enable();
			aAutoSavePromptBtn.Enable();
			aAutoSaveEdit.GrabFocus();
		}
		else
		{
			aAutoSaveEdit.Disable();
			aMinuteText.Disable();
			aAutoSavePromptBtn.Disable();
		}
	}
	return 0;
}

// -----------------------------------------------------------------------

void SfxSaveTabPage::HideUndo()
{
	aUndoText.Hide();
	aUndoEdit.Hide();
	aUndoBox.Hide();
}


