/*************************************************************************
 *
 *  $RCSfile: rtfmap.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _RTFMAP_HXX
#define _RTFMAP_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class SfxItemPool;

// Hier sind die Ids fuer alle Charakter-Attribute, die vom SvxParser
// erkannt und in einem SfxItemSet gesetzt werden koennen.
// Die Ids werden ueber die SlotIds vom POOL richtig gesetzt.
struct RTFPlainAttrMapIds
{
	USHORT 	nCaseMap,
			nColor,
			nContour,
			nCrossedOut,
			nEscapement,
			nFont,
			nFontHeight,
			nKering,
			nLanguage,
			nPosture,
			nShadowed,
			nUnderline,
			nWeight,
			nWordlineMode,
			nAutoKerning
			;
	RTFPlainAttrMapIds( const SfxItemPool& rPool );
};

// Hier sind die Ids fuer alle Paragraph-Attribute, die vom SvxParser
// erkannt und in einem SfxItemSet gesetzt werden koennen.
// Die Ids werden ueber die SlotIds vom POOL richtig gesetzt.
struct RTFPardAttrMapIds
{
	USHORT	nLinespacing,
			nAdjust,
			nTabStop,
			nHyphenzone,
			nLRSpace,
			nULSpace,
			nBrush,
			nBox,
			nShadow,
			nOutlineLvl,
			nSplit,
			nKeep
			;
	RTFPardAttrMapIds( const SfxItemPool& rPool );
};

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/graphics/svx/source/svrtf/rtfmap.hxx,v 1.1.1.1 2000/09/18 17:01:26 hr Exp $

	  Source Code Control System - Update

	  $Log: rtfmap.hxx,v $
	  Revision 1.1.1.1  2000/09/18 17:01:26  hr
	  initial import
	
	  Revision 1.7  2000/09/18 12:43:03  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.6  2000/08/31 09:14:09  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.5  1997/11/20 21:54:30  JP
	  HeaderFile Umstellung
	

	  Rev 1.4   20 Nov 1997 22:54:30   JP
   HeaderFile Umstellung

	  Rev 1.3   01 Nov 1995 16:17:24   JP
   Keep-/Split-Item auswerten

	  Rev 1.2   16 Oct 1995 17:01:16   JP
   neue Tokens

	  Rev 1.1   29 Sep 1995 20:03:30   JP
   neues Token: kerning

	  Rev 1.0   23 Feb 1995 09:30:44   JP
   Initial revision.

*************************************************************************/


#endif
	//_RTFMAP_HXX


