/*************************************************************************
 *
 *  $RCSfile: fobjcach.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _FOBJCACH_HXX
#define _FOBJCACH_HXX


#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _PSEUDO_HXX //autogen
#include <so3/pseudo.hxx>
#endif
#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif

class SvFileObject;
class SvxLinkManager;
class Graphic;

class FileObjCacheEntry_Impl
{
	friend class FileObjCache_Impl;

	FileObjCacheEntry_Impl *pPrev, *pNext;
	SvPseudoObjectRef xObj;
	String sFileName;

public:
	FileObjCacheEntry_Impl( SvFileObject& rObj, const String& rName );
	~FileObjCacheEntry_Impl();

	SvPseudoObject* GetObject() const 			{ return &xObj; }
	const String& GetFileName() const 			{ return sFileName; }
};


class FileObjCache_Impl : public SfxListener
{
	FileObjCacheEntry_Impl *pFirst, *pLast;
	USHORT nSize, nMaxSize;

	virtual void SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
							const SfxHint& rHint, const TypeId& rHintType );

public:
	FileObjCache_Impl( USHORT nMaxCnt = 50 );
	virtual ~FileObjCache_Impl();


	// FileObject einfuegen. Wenn doppelt, dann returne das schon
	// vorhandene, ansonsten lege ein neues an.
	FileObjCacheEntry_Impl* Insert( SvFileObject& rObj, const String& );
	// enferne dieses Object
	void Remove( SvFileObject& rObj );
	void Remove( const String& rName );
	// suche nach einem Object mit dem Namen
	FileObjCacheEntry_Impl* Found( const String& rName );

	// PrepareReload - alle FileObjects des LinksManagers aus dem
	// Cache entfernen.
	void PrepareReload( const SvxLinkManager& );
};

class SvxGrfLinkData_Impl
{
public:
	FileObjCache_Impl* pCache;

	SvxGrfLinkData_Impl() : pCache( 0 ) 	{}
	~SvxGrfLinkData_Impl() 					{ delete pCache; }
};

inline FileObjCache_Impl* GetCache()
{
	SvxGrfLinkData_Impl* pData = *(SvxGrfLinkData_Impl**)GetAppData( SHL_LNKCCH );
	if( !pData->pCache )
		pData->pCache = new FileObjCache_Impl;
	return pData->pCache;
}


#endif

