/*************************************************************************
 *
 *  $RCSfile: svdraw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if defined(WIN) || defined(WNT)
#define MoreMenues
#endif
#ifdef MoreMenues
#include <sysdep.hxx>
#include <svwin.h>
#endif
#include <sv.hxx>
#define _ANIMATION
#include <svgraph.hxx>
#include <svtool.hxx>
#include "svdosmrt.hxx"
#include "svdosmbr.hxx"
#ifndef SVX_LIGHT
#include <sfxcore.hxx>
#include <sfxsh.hxx>
#endif

#include <sfxitems.hxx>
#include <tlcontnr.hxx>
#include <sfxiiter.hxx>
#include <outliner.hxx>

#include <sostor.hxx>
#include <svdfppt.hxx>

#ifndef SVX_LIGHT
//#include <drawdlgs.hxx>
#endif

#ifdef JOEDEBUG
// Weil ich SvDraw.Lib zur APP linke:
String aSdrEmptyStr;
class String& rImplEmptyStr=aSdrEmptyStr;
//String aBlaEmptyStr;
//String& rImplEmptyStr=aBlaEmptyStr;
//class String __far& __far rImplEmptyStr
#endif

//      textitem.hxx        editdata.hxx
#define ITEMID_COLOR        EE_CHAR_COLOR
#define ITEMID_FONT         EE_CHAR_FONTINFO
#define ITEMID_FONTHEIGHT   EE_CHAR_FONTHEIGHT
#define ITEMID_FONTWIDTH    EE_CHAR_FONTWIDTH
#define ITEMID_WEIGHT       EE_CHAR_WEIGHT
#define ITEMID_UNDERLINE    EE_CHAR_UNDERLINE
#define ITEMID_CROSSEDOUT   EE_CHAR_STRIKEOUT
#define ITEMID_POSTURE      EE_CHAR_ITALIC
#define ITEMID_CONTOUR      EE_CHAR_OUTLINE
#define ITEMID_SHADOWED     EE_CHAR_SHADOW
#define ITEMID_ESCAPEMENT   EE_CHAR_ESCAPEMENT
#define ITEMID_AUTOKERN     EE_CHAR_PAIRKERNING
#define ITEMID_WORDLINEMODE EE_CHAR_WLM
//      paraitem.hxx       editdata.hxx
#define ITEMID_ADJUST      EE_PARA_JUST
#define ITEMID_FIELD       EE_FEATURE_FIELD
#include <textitem.hxx>

#include <rscdll.hxx>
//#ifndef SVX_LIGHT
#include <editdll.hxx>
//#include <schdll.hxx>
//#include <simdll.hxx>
//#include <smdll.hxx>
//#endif

//#include "xout.hxx"
#include "svdfield.hxx"
#include "svdraw.hxx"
#include "svdraw.hrc"
#pragma hdrstop

#ifdef JOEDEBUG
#include "..\x\joedebug.hxx"
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////

// Mit der Maus draggen (Move)
#define MODKEY_NoSnap    bAlt    /* Fang temporaer aus */
#define MODKEY_Ortho     bShift  /* na eben ortho */
//#define MODKEY_BigOrtho  TRUE
//#define MODKEY_AngleSnap       /* Winkelfang */
#define MODKEY_CopyDrag  bCtrl   /* Draggen mit kopieren */
// irgendwo hinklicken (MouseDown)
#define MODKEY_PolyPoly  bAlt    /* Neues Poly bei InsPt und bei Create */
#define MODKEY_MultiMark bShift  /* MarkObj ohne vorher UnmarkAll */
#define MODKEY_Unmark    bAlt    /* Unmark durch Rahmenaufziehen */
#define MODKEY_ForceMark FALSE /*bCtrl*/   /* Rahmenaufziehen erzwingen, auch wenn Obj an MausPos */
#define MODKEY_DeepMark  bCtrl /*bAlt*/    /* MarkNextObj */
#define MODKEY_DeepBackw bShift  /* MarkNextObj rueckwaerts */

////////////////////////////////////////////////////////////////////////////////////////////////////

#define nMap       100                 /*57*/
#define eMap       MAP_100TH_MM        /*MAP_TWIP*/
#define eUIMap     FUNIT_KM            /* Masseinheit der UI */
#define aUIScale   Fraction(1,1000000) /* Masstab der Zeichnung */
#define nHitPix    2                   /* Hit-Toleranz in Pixel */
#define nDrgPix    3                   /* Drag MinMove in Pixel */
#define nRgtMrkPix 4                   /* MinRSelFrame in Pixel */
#define nMgnPix    4                   /* Magnetstaerke f. Hlpln, Border und ObjPnts in Pixel */

////////////////////////////////////////////////////////////////////////////////////////////////////

class MyApp: public /*Sfx*/Application {
public:
	void Main(int, char* []);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

DECLARE_STACK(UndoStackImp,SfxUndoAction*);
class UndoStack: public UndoStackImp {
public:
	void Clear();
	~UndoStack() { Clear(); }
};

void UndoStack::Clear()
{
	while (Count()>0) {
		delete Pop();
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////

String aEmptyStr;
#define MyScrParent Window
//class MyDrawView;
class MyScr: public MyScrParent {
friend class MyWin;
friend class MyDrawView;
	MyWin* pMyWin;
	Timer  aScroll;

	String     aFNam;
	SdrModel*  pDraw;
	//SdrView*   pView;
	MyDrawView* pView;
	UndoStack* pUndo;
	UndoStack* pRedo;

	Point   aLastPresPos;
	BOOL    bRgtMark;
	BOOL    bLftMerk;

	BOOL    bAddWin;
	Printer aPrn;
	MouseEvent aLastMEvt;

public:
	MyScr(MyWin* pParent, MyScr* p1stView, BOOL bNeuView, BOOL bNeuDoc, BOOL bLoad, const String& rFNam);
	~MyScr();
	void SetTotalSize(Size aSiz) {}
	virtual void RequestHelp(const HelpEvent& rHEvt);
	virtual void Paint(const Rectangle& rRect);
	virtual void KeyInput(const KeyEvent& rKEvt);
	virtual void MouseButtonDown(const MouseEvent& rMEvt);
	virtual void MouseButtonUp(const MouseEvent& rMEvt);
	virtual void MouseMove(const MouseEvent& rMEvt);
	virtual void Command(const CommandEvent& rCEvt);
	virtual BOOL QueryDrop(DropEvent& rDEvt);
	virtual BOOL Drop(const DropEvent& rDEvt);
	void DispatchModifiers(USHORT nModifiers);
	SdrModel* MakeModelEmptyPage() const;
	SdrModel* MakeModelOneRect() const;
	SdrModel* MakeModel() const;
	void DoScroll(long dx, long dy);
	void ForceScroll(const Point& aPixPos);
	DECL_LINK(ScrollHdl,Timer*);
	BOOL Load(const String& rFN);
	void Save(BOOL bCompressed, BOOL bNoBuf);
	BOOL Merge(const String& rFN, FASTBOOL bMergeMasters);
	void ZoomIn();
	void ZoomOut();
	void NextPage(BOOL bPrev=FALSE, BOOL bNoPrevNext=FALSE);
	void ForcePointer();
	void ForceCapture(FASTBOOL bLeft);
	void WriteStatus(const String& aStr=aEmptyStr);
	void WriteFlagStatus(const String& aStr, BOOL bFlag);
	XubString GetValStr(long a) const;
	Point GetLogPos() const { return PixelToLogic(ScreenToOutputPixel(Pointer::GetPosPixel())); }
	void ShowLayers();
	void DoUndo();
	void DoRedo();
	void DoRepeat();
	void DoCut();
	void DoYank();
	void DoPaste(ULONG nFormat=SDR_ANYFORMAT);
	void DoDragDrop();
	void DoPrint();
//    void DoMarkAll();
//    void DoDelete();
	void DoInsertPage();
	void DoDeletePage();
	void DoAttributes();
	void SetZoomDepValues();
	DECL_LINK(TestFactoryHdl,SdrObjFactory*);
	DECL_LINK(NotifyUndoActionHdl,SfxUndoAction*);
	//void PaintHdl(SdrObject* pObj, ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec);
	DECL_LINK(IOProgressHdl,USHORT*);
	DECL_LINK(MenuHdl,Menu*);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

class MyDrawView: public SdrView {
	MyScr& rMyScr;
public:
	SdrViewUserMarker* pTestMarker;
	SdrViewUserMarker* pObjMarker;
public:
	MyDrawView(SdrModel* pModel1, MyScr* pNewMyScr);
	~MyDrawView() { delete pTestMarker; delete pObjMarker; }
	virtual void   SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId&, const SfxHint& rHint, const TypeId&);
	virtual void   MarkListHasChanged();
	virtual void   ModelHasChanged();
};

////////////////////////////////////////////////////////////////////////////////////////////////////

class MyWin: public WorkWindow {
friend MyScr;
	MenuBar*   pMenu;
	ToolBox*   pBox;
	StatusBar* pBar;
	Size       aBoxSize;
	MyScr*     pWin;
	MyWin*     p1stW;

public:
	void InitVals();
	void InitBoxBar();
	MyWin(MyScr* p1stView, BOOL bNeuView, BOOL bNeuDoc, BOOL bLoad, const String& rFNam);
	virtual ~MyWin();
	virtual void RequestHelp(const HelpEvent& rHEvt);
	virtual void Resize();
	virtual void KeyInput(const KeyEvent& rKEvt);
	virtual BOOL QueryDrop(DropEvent& rDEvt);
	virtual BOOL Drop(const DropEvent& rDEvt);
	virtual void GetFocus();
	String Zero2(const String& rStr);
	void SetDateTime(const AutoTimer& rTim);
	void WriteStatus(const String& aStr=aEmptyStr);
	DECL_LINK(SetMenuStatusHdl,Menu*);
	DECL_LINK(EnableMenuHdl,Menu*);
	void DisplayRect(const Rectangle& rRect);
	DECL_LINK(ToolBoxClickHdl,ToolBox*);
	void AddNewWin();
	void AddNewView();
	void AddNewDoc(BOOL bLoad, const String& rFNam);
	Window* GetDrawWin() const { return pWin; }
	MenuBar* GetMenuBar() const { return pMenu; }
};

////////////////////////////////////////////////////////////////////////////////////////////////////

class MyToolBox: public ToolBox {
public:
	MyToolBox(Window* pParent, WinBits nBits): ToolBox(pParent,nBits) {}
	virtual void MouseButtonDown(const MouseEvent& rMEvt);
	virtual void MouseButtonUp(const MouseEvent& rMEvt);
};

void __EXPORT MyToolBox::MouseButtonDown(const MouseEvent& rMEvt)
{
	MouseEvent aEvt(rMEvt.GetPosPixel(),1,rMEvt.GetMode(),rMEvt.GetButtons(),rMEvt.GetModifier());
	ToolBox::MouseButtonDown(aEvt);
}

void __EXPORT MyToolBox::MouseButtonUp(const MouseEvent& rMEvt)
{
	MouseEvent aEvt(rMEvt.GetPosPixel(),1,rMEvt.GetMode(),rMEvt.GetButtons(),rMEvt.GetModifier());
	ToolBox::MouseButtonUp(aEvt);
}

////////////////////////////////////////////////////////////////////////////////////////////////////

/*class HelpWin: public ModelessDialog {
	USHORT  nLnFeed;
	USHORT  nKeyWdt;
	USHORT  nEquWdt;
	USHORT  nDscWdt;
	USHORT  nBoxHgt;
	Point   aTxtOrg;
	Point   aTxtPos;
public:
	HelpWin(Window* pParent);
	virtual void Paint(const Rectangle& rRect);
	virtual BOOL Close();
	void WriteHome(const Point& aOrg);
	void WriteKey(const String& rKey, const String& rDscr);
	void Write(const String& rStr);
	void Writeln(const String& rStr);
};*/

////////////////////////////////////////////////////////////////////////////////////////////////////
// MyApp
////////////////////////////////////////////////////////////////////////////////////////////////////

void __EXPORT MyApp::Main(int nParamCount, char* cParamStr[])
{
	srand(0);
//#ifndef SVX_LIGHT
	EditDLL      aEditDLL;
//#endif
	if(!SvFactory::Init()) return; // fuer Storages
	SvxGlobalItemData aItemData;
	SdrRegisterFieldClasses();
//    SvxDialogDll aSvxDialogDll;
	EnableSVLook();
	int i;
	String aFN;
	for (i=0; i<nParamCount; i++) {
		String aPara(cParamStr[i]);
		aPara.ToUpper();
		if (i!=0 && aPara[USHORT(0)]!='/' && aPara[USHORT(0)]!='-' && aFN.Len()==0) aFN=aPara;
	}

	SetAppFont(System::GetStandardFont(STDFONT_APP));

	//SdrEngineDefaults::SetMapUnit(MAP_POINT);
	//SdrEngineDefaults::SetFontHeight(48);
	//SdrEngineDefaults::SetFontHeight(1695); // 48Pt
	SdrEngineDefaults::SetFontHeight(2258); // 64Pt
	SdrEngineDefaults::SetFontColor(Color(COL_CYAN));

	MyWin aMainWin(NULL,TRUE,TRUE,aFN.Len()!=0,aFN);
#ifndef MoreMenues
	MenuBar aMenu(ResId(MENU_MAIN));
	Application::SetAppMenu(&aMenu);
	aMenu.PushSelectHdl(LINK(aMainWin.GetDrawWin(),MyScr,MenuHdl));
	aMenu.PushActivateHdl(LINK(&aMainWin,MyWin,SetMenuStatusHdl));
	aMenu.PushDeactivateHdl(LINK(&aMainWin,MyWin,EnableMenuHdl));
#endif
	String aWinName("SV-DrawingEngine (Joe M.)");
	aMainWin.SetText(aWinName);
	aMainWin.Show();

	// Fuer all die Resourcemanager
	//SchDLL       aSchDLL;
	//SimDLL       aSimDLL;
	//SmDLL        aSmDLL;
	//BasicIDEDLL  aBasicIDEDLL;
	//BasicDLL     aBasicDLL;
	//SiDLL        aSiDLL;
	//SdrItemPool* pP=new SdrItemPool;
	//delete pP;

	SdrModel* pM=new SdrModel;
	delete pM;

	Execute();
	aMainWin.Hide();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// MyDrawView
////////////////////////////////////////////////////////////////////////////////////////////////////

MyDrawView::MyDrawView(SdrModel* pModel1, MyScr* pNewMyScr):
	SdrView(pModel1,pNewMyScr), rMyScr(*pNewMyScr)
{
	//bPageTwice=TRUE;
	SetGridCoarse(Size(20*nMap,0));
	SetGridFine  (Size(4*nMap,0));
	//SetSnapGrid  (Size(10*nMap,10*nMap));
	SetGridCoarse(Size(10*nMap,10*nMap));
	//SetGridCoarse(Size( 4*nMap, 4*nMap));
	SetGridFine  (Size( 5*nMap, 5*nMap));
	SetSnapGrid  (Size(10*nMap,10*nMap));
	SetSnapAngle (1500);
	SetGridSnap(TRUE);
	SetVirtualObjectBundling(TRUE);
	bRestoreColors=TRUE;
	SetTextEditAfterCreate(TRUE);
	SetGridSnap(TRUE);
	SetMarkHdlWhenTextEdit(TRUE);
	SetSolidMarkHdl(TRUE);
	SetSolidDragging(TRUE);
//    SetWorkArea(Rectangle(-20L*nMap,-20L*nMap,820L*nMap,320L*nMap));
	pTestMarker=new SdrViewUserMarker(this);
	pTestMarker->SetRectangle(Rectangle(2500,8500,4000,11000));
	pTestMarker->Show();
	pObjMarker=new SdrViewUserMarker(this);
	pObjMarker->SetLineWidth(0);
	pObjMarker->SetPixelDistance(3);
	pObjMarker->SetAnimate(TRUE);
	pObjMarker->SetAnimateDelay(500);
	pObjMarker->SetAnimateCount(5);
	pObjMarker->SetAnimateToggle(TRUE);
	//SetGrafDraft(TRUE);
	SetDragStripes(FALSE);
	//SetUseIncompatiblePathCreateInterface(TRUE);
}

void __EXPORT MyDrawView::SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType)
{
	SdrView::SFX_NOTIFY(rBC,rBCType,rHint,rHintType);
#ifdef JOEDEBUG
//    SdrHint* pSdrHint=PTR_CAST(SdrHint,&rHint);
//    if (pSdrHint!=NULL && pSdrHint->eHint==HINT_MODELCHG) {
//        DebWrite("HINT_MODELCHG\n");
//    }
#endif
}

void __EXPORT MyDrawView::MarkListHasChanged()
{
	SdrView::MarkListHasChanged();
	if (IsInsObjPointMode()) {
		if (HasMarkedObj() && !HasMarkablePoints()) SetInsObjPointMode(FALSE);
	}
#ifdef NeinJOEDEBUG
	DebWriteln("MarkListHasChanged()");
#endif
}

void __EXPORT MyDrawView::ModelHasChanged()
{
	SdrView::ModelHasChanged();
//    rMyScr.WriteStatus(); // denn ggf. hat sich die Mark-Description geaendert
//    rMyScr.ForcePointer();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// MyScr
////////////////////////////////////////////////////////////////////////////////////////////////////

MyScr::MyScr(MyWin* pParent, MyScr* p1stView, BOOL bNeuView, BOOL bNeuDoc, BOOL bLoad, const String& rFNam):
	MyScrParent(pParent,WB_SVLOOK)
{
//    SetPalette(XOutputDevice::GetDitherPalette());
	pView=NULL;
	pDraw=NULL;
	if (p1stView==NULL) { bNeuView=TRUE; bNeuDoc=TRUE; }
	if (bNeuDoc) bNeuView=TRUE;
	pMyWin=pParent;
	bRgtMark=FALSE;
	bLftMerk=FALSE;
	bAddWin=p1stView!=NULL;

	SetMapMode(MapMode(eMap,Point(25,35),Fraction(1,4),Fraction(1,4)));
	aPrn.SetMapMode(MapMode(eMap));
//    SdrObjFactory::InsertMakeObjectHdl(LINK(this,MyScr,TestFactoryHdl));
	if (bNeuDoc) {
		pUndo=new UndoStack;
		pRedo=new UndoStack;
		if (bLoad) {
			pDraw=new SdrModel;
			pDraw->SetIOProgressHdl(LINK(this,MyScr,IOProgressHdl));
			pDraw->SetScaleUnit(eMap); // kann eigentlich weg
			pView=new MyDrawView(pDraw,this);
			pView->SetHiddenPageSaveMode(TRUE);
			if (!Load(rFNam)) {
				delete pDraw;
				pDraw=MakeModel();
			}
		} else {
			pDraw=MakeModel();
		}
		pDraw->SetUIUnit(eUIMap,aUIScale);
		pDraw->SetNotifyUndoActionHdl(LINK(this,MyScr,NotifyUndoActionHdl));
		pDraw->SetIOProgressHdl(LINK(this,MyScr,IOProgressHdl));
	} else {
		pDraw=p1stView->pDraw;
		pUndo=p1stView->pUndo;
		pRedo=p1stView->pRedo;
	}

	if (bNeuView) {
		if (pView==NULL) {
			pView=new MyDrawView(pDraw,this);
			pView->ShowPagePgNum(0,Point(0*220*nMap,0*20*nMap));
			pView->ShowPagePgNum(1,Point(1*220*nMap,1*20*nMap));
			pView->ShowPagePgNum(2,Point(2L*220L*nMap,2*20*nMap));
			pView->SetCurrentObj(OBJ_RECT);
			pView->SetCurrentObj(OBJ_MEASURE);
			pView->SetCreateMode();
			/*SdrPageView* pPV=pView->GetPageViewPvNum(0);
			if (pPV!=NULL) {
				pPV->InsertHelpLine(SdrHelpLine(SDRHELPLINE_VERTICAL,Point(93*nMap,0)));
				pPV->InsertHelpLine(SdrHelpLine(SDRHELPLINE_HORIZONTAL,Point(0,154*nMap)));
				pPV->InsertHelpLine(SdrHelpLine(SDRHELPLINE_POINT,Point(112*nMap,203*nMap)));
			}
			pPV=pView->GetPageViewPvNum(1);
			if (pPV!=NULL) {
				pPV->InsertHelpLine(SdrHelpLine(SDRHELPLINE_POINT,Point(2*nMap,3*nMap)));
				pPV->InsertHelpLine(SdrHelpLine(SDRHELPLINE_POINT,Point(22*nMap,33*nMap)));
			}*/
		}
		pView->SetHiddenPageSaveMode(TRUE);

		SetZoomDepValues();
	} else {
		pView=p1stView->pView;
		pView->AddWin(this);
	}
	//SetTotalSize(pPage->GetSize());
	EnableDrop();
	ForcePointer();
	Show();
	pView->ShowSmartObjBrowser();
}

MyScr::~MyScr()
{
//    SdrObjFactory::RemoveMakeObjectHdl(LINK(this,MyScr,TestFactoryHdl));
	if (!bAddWin) {
		delete pUndo;
		delete pRedo;
		delete pView;
		delete pDraw;
	}
}

#define KEY_CTRL KEY_MOD1
#define KEY_ALT  KEY_MOD2

void MyScr::DispatchModifiers(USHORT nModifiers)
{
	FASTBOOL bShift=(nModifiers & KEY_SHIFT) !=0;
	FASTBOOL bCtrl =(nModifiers & KEY_CTRL ) !=0;
	FASTBOOL bAlt  =(nModifiers & KEY_ALT  ) !=0;

#ifdef MODKEY_NoSnap
	pView->SetSnapEnabled(!MODKEY_NoSnap);
#endif
#ifdef MODKEY_Ortho
	pView->SetOrtho(MODKEY_Ortho!=pView->IsOrthoDesired());
#endif
#ifdef MODKEY_BigOrtho
	pView->SetBigOrtho(MODKEY_BigOrtho);
#endif
#ifdef MODKEY_AngleSnap
	pView->SetAngleSnapEnabled(MODKEY_AngleSnap);
#endif
#ifdef MODKEY_CopyDrag
	pView->SetDragWithCopy(MODKEY_CopyDrag);
#endif
}

void __EXPORT MyScr::MouseButtonDown(const MouseEvent& rMEvt)
{
	if (rMEvt.IsLeft()) bLftMerk=TRUE;
//    FASTBOOL bDoubleHdlSize0=pView->GetHdlList().IsDoubleSize();
//    pView->SetActualWin(this);
	aLastMEvt=rMEvt;
	if (pView->MouseButtonDown(rMEvt,this)) {
		WriteStatus();
		ForcePointer();
		return; // Event von der SdrView ausgewertet
	}
	SdrViewEvent aVEvt;
	pView->PickAnything(rMEvt,SDRMOUSEBUTTONDOWN,aVEvt);
	pView->DoMouseEvent(aVEvt);

/*    SdrViewEvent aVEvt;
	SdrHitKind eHit=pView->PickAnything(rMEvt,SDRMOUSEBUTTONDOWN,aVEvt);
	if (pView->IsTextEdit() && eHit!=SDRHIT_HANDLE &&
		eHit!=SDRHIT_HELPLINE && eHit!=SDRHIT_MACRO &&
		eHit!=SDRHIT_MARKEDOBJECT) pView->EndTextEdit(); // Danebengeklickt, Ende mit Edit
	FASTBOOL bShift=rMEvt.IsShift();
	FASTBOOL bCtrl=rMEvt.IsMod1();
	FASTBOOL bAlt=rMEvt.IsMod2();
	USHORT   nModifiers=rMEvt.GetModifier();
	DispatchModifiers(nModifiers);
	bRgtMark=FALSE;
	USHORT nDrgLog=USHORT(PixelToLogic(Size(nDrgPix,0)).Width());
	USHORT nHitLog=USHORT(PixelToLogic(Size(nHitPix,0)).Width());
	Point aPnt(PixelToLogic(rMEvt.GetPosPixel()));
	if (pView->IsAction()) {
		if (rMEvt.IsRight()) {
			pView->BckAction();
			if (!pView->IsAction()) {
				WriteStatus("Aktion abgebrochen");
				return;
			} else {
				WriteStatus("Letzten Punkt gelscht");
				return;
			}
		} else {
			return; // Action ist aktiv
		}
	}
	aLastPresPos=aPnt;
	if (rMEvt.IsLeft() || !rMEvt.IsRight()) {
		FASTBOOL bEditMode=pView->IsEditMode();
		FASTBOOL bPointMode=bEditMode && pView->HasMarkablePoints();
		FASTBOOL bGluePointMode=pView->IsGluePointEditMode();
		FASTBOOL bInsPolyPt=bPointMode && pView->IsInsObjPointMode() && pView->IsInsObjPointPossible();
		FASTBOOL bInsGluePt=bGluePointMode && pView->IsInsGluePointMode() && pView->IsInsGluePointPossible();
		FASTBOOL bDoubleHdlSize1=pView->GetHdlList().IsDoubleSize();
//        if (bDoubleHdlSize1!=bDoubleHdlSize0) (SdrHdlList&)(pView->SetHdlList()).SetDoubleSize(bDoubleHdlSize0);
		SdrHdl* pHdl=pView->HitHandle(aPnt,*this);
//        if (bDoubleHdlSize1!=bDoubleHdlSize0) (SdrHdlList&)(pView->SetHdlList()).SetDoubleSize(bDoubleHdlSize1);
		SdrPageView* pPV=NULL;
		SdrObject* pObj=NULL;
		USHORT nHlplIdx=0;
		USHORT nGlueId=0;
		FASTBOOL bHdlHit=FALSE;
		FASTBOOL bHplHit=FALSE;
		FASTBOOL bGluHit=FALSE;
		FASTBOOL bTxtHit=FALSE;
		FASTBOOL bMrkHit=FALSE;
		FASTBOOL bMakHit=FALSE;
		FASTBOOL bObjHit=FALSE;
		FASTBOOL bNonHit=FALSE;
		FASTBOOL bUnmark=FALSE;
		FASTBOOL bMultiMark=MODKEY_MultiMark || MODKEY_DeepMark;
		if (!MODKEY_ForceMark) {
			if (pHdl!=NULL) {
				bHdlHit=TRUE; // Handle getroffen hat hoechste Prioritaet
			} else if (bEditMode && pView->IsHlplFront() && pView->PickHelpLine(aPnt,nHitLog,*this,nHlplIdx,pPV)) {
				bHplHit=TRUE; // Hilfslinie im Vordergrund getroffen zum verschieben
			} else if (bGluePointMode && pView->PickGluePoint(aPnt,pObj,nGlueId,pPV)) {
				bGluHit=TRUE; // Klebepunkt getroffen (nicht markiert)
			} else if (pView->IsMarkedObjHit(aPnt,nHitLog)) {
				bMrkHit=TRUE; // Markiertes Objekt getroffen
				FASTBOOL bDouble=rMEvt.GetClicks()==2;
				if (!bMultiMark && (bDouble || pView->IsTextTool() || pView->IsQuickTextEditMode())) {
					bTxtHit=pView->PickTextEditObj(aPnt,pObj,pPV,bDouble ? 0 : SDRSEARCH_TESTTEXTAREA);
				}
			} else if (pView->IsMacroMode() && pView->PickMacroObj(aPnt,nHitLog,pObj,pPV)) {
				bMakHit=TRUE; // nichtmarkiertes Objekt mit Makro getroffen
			} else if ((bEditMode || bGluePointMode) && pView->PickMarkableObj(aPnt,nHitLog,pObj,pPV)) {
				bObjHit=TRUE; // sonstiges nichtmarkiertes Objekt getroffen
			} else if (bEditMode && pView->PickHelpLine(aPnt,nHitLog,*this,nHlplIdx,pPV)) {
				bHplHit=TRUE; // Hilfslinie im Hintergrund getroffen zum verschieben
			} else bNonHit=TRUE;
		} else bNonHit=TRUE;

		if (bHdlHit) { // Punkt evtl. markieren oder deselektieren ...
			if (pView->IsPointMarkable(*pHdl)) {
				FASTBOOL bPointMarked=pView->IsPointMarked(*pHdl);
				if (bMultiMark) {
					if (!bPointMarked) {
						pView->MarkPoint(*pHdl);
					} else {
						pView->UnmarkPoint(*pHdl);
						bUnmark=TRUE;
					}
				} else {
					if (!bPointMarked) {
						pView->UnmarkAllPoints();
						pView->MarkPoint(*pHdl);
					}
				}
			} else if (bMultiMark && pView->IsGluePoint(*pHdl)) {
			   pView->UnmarkGluePoint(*pHdl);
			   pHdl=NULL;
		   }
		} else if (bGluHit) {
			if (!bMultiMark) {
				pView->UnmarkAllGluePoints();
			}
			pView->MarkGluePoint(pObj,nGlueId,pPV);
			pHdl=pView->GetGluePointHdl(pObj,nGlueId); // Damit gleich losgedraggd werden kann
		} else if (bInsGluePt) {
			pView->BegInsGluePoint(aPnt);
		} else if (bInsPolyPt) {
			pView->BegInsObjPoint(aPnt,bShift);
		} else if (bHplHit) {
			pView->BegDragHelpLine(nHlplIdx,pPV);
		} else if (bTxtHit) {
			if (pView->BegTextEdit(pObj,pPV,this,(Outliner*)NULL)) {
				// Aus Doppelklick mach Einfachklick
				MouseEvent aMEvt(rMEvt.GetPosPixel(),1,rMEvt.GetMode(),
								 rMEvt.GetButtons(),rMEvt.GetModifier());
				OutlinerView* pOLV=pView->GetTextEditOutlinerView();
				pOLV->MouseButtonDown(aMEvt); // Event an den Outliner, aber ohne Doppelklick
			}
		} else if (bMakHit) {
			pView->BegMacroObj(aPnt,nHitLog,pObj,pPV,this);
		} else if (bMrkHit) {
			if (MODKEY_DeepMark) {
				pView->MarkNextObj(aPnt,nHitLog,MODKEY_DeepBackw);
			} else if (MODKEY_MultiMark) {
				pView->MarkObj(aPnt,nHitLog,TRUE); // Markierung toggeln
				bUnmark=TRUE;
			}
		} else if (bObjHit) { // Obj (ggf. hinzu-) markieren
			// Das getroffene Objekt wird nun gleich auf HdlHit und
			// GluePointHit untersucht
			if (!bMultiMark) {
				pView->UnmarkAllObj();
			}
			pView->MarkObj(pObj,pPV);
			bMrkHit=TRUE; // Damit Dragging (Move) gleich gestartet wird
			if (!bMultiMark && (pView->IsTextTool() || pView->IsQuickTextEditMode())) {
				bTxtHit=pView->PickTextEditObj(aPnt,pObj,pPV,SDRSEARCH_TESTTEXTAREA);
				if (bTxtHit && pView->BegTextEdit(pObj,pPV,this,(Outliner*)NULL)) {
					OutlinerView* pOLV=pView->GetTextEditOutlinerView();
					pOLV->MouseButtonDown(rMEvt);
				}
			}
		}
		if (!pView->IsAction()) {
			if ((bMrkHit && !MODKEY_ForceMark && !bTxtHit) || pHdl!=NULL) {
				pView->BegDragObj(aPnt,NULL,pHdl,nDrgLog);
			} else if (bNonHit) {
				if (bEditMode || bGluePointMode || MODKEY_ForceMark)
				{ // Selektionsrahmen aufziehen
					pView->BegMark(aPnt,bMultiMark,MODKEY_Unmark);
				} else { // Create
					if (pView->GetCurrentObjIdentifier()==UINT16(OBJ_CAPTION)) pView->BegCreateCaptionObj(aPnt,Size(40*nMap,20*nMap),NULL);
					else pView->BegCreateObj(aPnt,NULL);
				}
			}
		}
	} else if (rMEvt.IsRight() || !rMEvt.IsLeft()) {
		if (!MODKEY_MultiMark && !MODKEY_DeepMark) {
			pView->UnmarkAllObj();
			pView->SetDragMode(SDRDRAG_MOVE);
		}
		BOOL bHitOk=FALSE;
		if (MODKEY_DeepMark) {
			bHitOk=pView->MarkNextObj(aPnt,nHitLog,MODKEY_DeepBackw);
		} else {
			bHitOk=pView->MarkObj(aPnt,nHitLog,MODKEY_MultiMark);
		}
		bRgtMark=!MODKEY_DeepMark;
	}*/
	ForceCapture(rMEvt.IsLeft());
	ForcePointer();
	WriteStatus();
}

void __EXPORT MyScr::MouseButtonUp(const MouseEvent& rMEvt)
{
	if (rMEvt.IsLeft()) bLftMerk=FALSE;
//    pView->SetActualWin(this);
	aLastMEvt=rMEvt;
//    SdrTextObj* pCrText=(SdrTextObj*)pView->GetCreateObj();
	if (pView->MouseButtonUp(rMEvt,this)) {
//        if (pCrText!=NULL) pCrText->SetDisableAutoWidthOnDragging(TRUE);
		WriteStatus();
		ForcePointer();
		return; // Event von der SdrView ausgewertet
	}
	SdrViewEvent aVEvt;
	pView->PickAnything(rMEvt,SDRMOUSEBUTTONUP,aVEvt);
	pView->DoMouseEvent(aVEvt);

	/*FASTBOOL bShift=rMEvt.IsShift();
	FASTBOOL bCtrl=rMEvt.IsMod1();
	FASTBOOL bAlt=rMEvt.IsMod2();
	USHORT   nModifiers=rMEvt.GetModifier();
	DispatchModifiers(nModifiers);
	bRgtMark=FALSE;
	Point aPnt(PixelToLogic(rMEvt.GetPosPixel()));
	if (pView->IsDragObj()) { // Drag evtl. mit Copy
		pView->EndDragObj(pView->IsDragWithCopy());
		pView->ForceMarkedObjToAnotherPage();
	} else if (pView->IsCreateObj()) { // Create Action
		if (rMEvt.IsLeft()) {
			SdrCreateCmd eCmd=SDRCREATE_NEXTPOINT;
			if (MODKEY_PolyPoly) eCmd=SDRCREATE_NEXTOBJECT;
			if (rMEvt.GetClicks()>1) eCmd=SDRCREATE_FORCEEND;
			//eCmd=SDRCREATE_FORCEEND;
			if (!pView->EndCreateObj(eCmd)) { // Event fuer Create nicht ausgewerten? -> Markieren
				USHORT nHitLog=USHORT(PixelToLogic(Size(nHitPix,0)).Width());
				BOOL bHit=pView->MarkObj(aPnt,nHitLog,MODKEY_MultiMark);
				SdrObject* pObj=NULL;
				SdrPageView* pPV=NULL;
				if (bHit && !MODKEY_MultiMark && (pView->IsTextTool() || pView->IsQuickTextEditMode()) &&
					pView->PickTextEditObj(aPnt,pObj,pPV,SDRSEARCH_TESTTEXTAREA)) {
					if (pView->BegTextEdit(pObj,pPV,this,(Outliner*)NULL)) {
						OutlinerView* pOLV=pView->GetTextEditOutlinerView();
						pOLV->MouseButtonDown(rMEvt);
						pOLV->MouseButtonUp(rMEvt);
					}
				}
			}
		}
	} else if (pView->IsInsObjPoint()) { // InsObjPnt Action
		if (rMEvt.IsLeft()) {
			//pView->EndAction();
			SdrCreateCmd eCmd=SDRCREATE_NEXTPOINT;
			if (MODKEY_PolyPoly) eCmd=SDRCREATE_NEXTOBJECT;
			if (rMEvt.GetClicks()>1) eCmd=SDRCREATE_FORCEEND;
			pView->EndInsObjPoint(eCmd);
		}
	} else if (pView->IsAction()) { // sonstige Actions
		pView->EndAction();
	}*/
	ForceCapture(rMEvt.IsLeft());
	ForcePointer();
	WriteStatus();
}

void __EXPORT MyScr::MouseMove(const MouseEvent& rMEvt)
{
	if (pView->IsTextEditInSelectionMode()) {
		pView->GetTextEditOutlinerView()->MouseMove(rMEvt);
		return;
	}
	bLftMerk=rMEvt.IsLeft();
	aLastMEvt=rMEvt;
//    pView->SetActualWin(this);
	if (pView->MouseMove(rMEvt,this)); // { WriteStatus(); ForcePointer(); return; } // Event von der SdrView ausgewertet
	SdrViewEvent aVEvt;
	pView->PickAnything(rMEvt,SDRMOUSEMOVE,aVEvt);
	pView->DoMouseEvent(aVEvt);
	if (pView->IsAction() && rMEvt.IsLeft()) ForceScroll(rMEvt.GetPosPixel());
/*    FASTBOOL bShift=rMEvt.IsShift();
	FASTBOOL bCtrl=rMEvt.IsMod1();
	FASTBOOL bAlt=rMEvt.IsMod2();
	USHORT   nModifiers=rMEvt.GetModifier();
	DispatchModifiers(nModifiers);
	Point aPix(rMEvt.GetPosPixel());
	Point aPnt(PixelToLogic(aPix));
	USHORT nRgtMrkLog=USHORT(PixelToLogic(Size(nRgtMrkPix,0)).Width());
	if (pView->IsAction()) {
		if (rMEvt.IsLeft()) ForceScroll(aPix);
		pView->MovAction(aPnt);
		WriteStatus();
	} else {
		if (rMEvt.IsRight() && bRgtMark) {
			long dx=aLastPresPos.X()-aPnt.X(); if (dx<0) dx=-dx;
			long dy=aLastPresPos.Y()-aPnt.Y(); if (dy<0) dy=-dy;
			if (dx>long(nRgtMrkLog) || dy>long(nRgtMrkLog)) {
				if (!MODKEY_MultiMark && !MODKEY_DeepMark) {
					pView->UnmarkAllObj();
					pView->SetDragMode(SDRDRAG_MOVE);
				}
				if (pView->BegMarkObj(aLastPresPos,this)) {
					pView->MovAction(aPnt);
					//SetPointer(Pointer(POINTER_ARROW));
					WriteStatus();
				}
			}
		}
	}*/
	if (!pView->IsTextEditInSelectionMode()) {
		ForceCapture(rMEvt.IsLeft());
		ForcePointer();
		WriteStatus();
	}
	// MarkerTest:
	/*if (pView->IsEditMode()) {
		SdrObject* pObj=NULL;
		SdrPageView* pPV=NULL;
		FASTBOOL bHit=pView->PickObj(aPnt,pObj,pPV);
		if (bHit) {
			pView->pObjMarker->SetRectangle(pObj,pPV);
			pView->pObjMarker->Show();
		} else {
			pView->pObjMarker->SetPoint(pView->GetSnapPos(aPnt,NULL));
			pView->pObjMarker->Show();
		}
	} else {
		pView->pObjMarker->Hide();
	}*/
}

void __EXPORT MyScr::Command(const CommandEvent& rCEvt)
{
//    if (pView->Command(rCEvt,this)) { WriteStatus(); ForcePointer(); return; } // Event von der SdrView ausgewertet
}

SdrModel* MyScr::MakeModelEmptyPage() const
{
	SdrModel* pDraw=new SdrModel;
	pDraw->SetScaleUnit(eMap); // kann eigentlich weg

	/////////////////////////////////////////
	// Seite 1
	SdrPage* pPage=new SdrPage(*pDraw);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pDraw->InsertPage(pPage);
	// Seite 1
	/////////////////////////////////////////

	pDraw->SetChanged(FALSE);
	return pDraw;
}

SdrModel* MyScr::MakeModelOneRect() const
{
	SdrModel* pDraw=new SdrModel;
	pDraw->SetScaleUnit(eMap); // kann eigentlich weg

	SdrRectObj* pRect;
	SdrPage* pPage;

	SfxItemSet aSet(pDraw->GetItemPool());
	aSet.Put(XFillColorItem("JoeBraun",Color(COL_BROWN)));
	aSet.Put(XLineColorItem("JoeGelb",Color(COL_YELLOW)));
	/////////////////////////////////////////
	// Seite 1
	pPage=new SdrPage(*pDraw);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pDraw->InsertPage(pPage);

	pRect=new SdrRectObj(Rectangle(40*nMap,50*nMap,60*nMap,70*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);
	// Seite 1
	/////////////////////////////////////////

	pDraw->SetChanged(FALSE);
	return pDraw;
}

SdrPathObj* MakeSmartObj()
{
	SdrObjSmartData* pBla1=new SdrObjSmartData;
	SdrSmartGeometric* pBla2=new SdrSmartGeometric;
	SdrSmartGeometricLine* pBla3=new SdrSmartGeometricLine;
	pBla2->Insert(*pBla3);
	pBla1->aGeometrics.Insert(*pBla2);
	delete pBla3;
	delete pBla2;
	delete pBla1;

	SdrPathObj* pPath=new SdrPathObj(OBJ_PATHFILL);
	SdrObjSmartData* pSmart=pPath->ForceSmartData();
	pSmart->aPos.X().SetFormulaString("10",pPath);
	pSmart->aPos.Y().SetFormulaString("10",pPath);
	pSmart->aSize.X().SetFormulaString("20",pPath);
	pSmart->aSize.Y().SetFormulaString("20",pPath);

	SdrSmartGeometric aGeo;
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_START,"0","0",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Breite","0",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Breite","Hhe",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"0","Hhe",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"0","Hhe-2",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"5*Breite/10","Hhe-2",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"25*Breite/100","5*Hhe/10",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"5*Breite/10","2",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"0","2",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_CLOSE,pPath));/**/
	pSmart->aGeometrics.Insert(aGeo);
	pPath->SetXPolyDirty();
	return pPath;
}

SdrPathObj* MakeSmartClock()
{
	SdrPathObj* pPath=new SdrPathObj(OBJ_PATHFILL);
	SdrObjSmartData* pSmart=pPath->ForceSmartData();
	pSmart->aPos.X().SetFormulaString("40",pPath);
	pSmart->aPos.Y().SetFormulaString("10",pPath);
	pSmart->aSize.X().SetFormulaString("20",pPath);
	pSmart->aSize.Y().SetFormulaString("20",pPath);

	{
		SdrSmartDraftLine aVar;
//        aVar.A().SetFormulaString("1",pPath);
		pSmart->aVars.Insert(aVar);
	}
	{
		SdrSmartDraftLine aDraft;
		aDraft.Pos().X().SetFormulaString("Breite/2",pPath);
		aDraft.Pos().Y().SetFormulaString("Hhe/2",pPath);
		aDraft.B().SetFormulaString("1",pPath);
		pSmart->aDraft.Insert(aDraft);
	}
	{
		SdrSmartDraftLine aDraft;
		aDraft.Pos().X().SetFormulaString("Draft1-Draft1.B",pPath);
		aDraft.Pos().Y().SetFormulaString("Draft1-Draft1.B",pPath);
		pSmart->aDraft.Insert(aDraft);
	}
	{
		SdrSmartDraftLine aDraft;
		aDraft.A().SetFormulaString("Sekunde",pPath);
		aDraft.Pos().X().SetFormulaString("SinD(A*6)",pPath);
		aDraft.Pos().Y().SetFormulaString("-CosD(A*6)",pPath);
		pSmart->aDraft.Insert(aDraft);
	}

	SdrSmartGeometric aGeo;
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_START,"0","0",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Breite","0",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Breite","Hhe",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"0","Hhe",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_CLOSE,pPath));
	pSmart->aGeometrics.Insert(aGeo);
	aGeo.Clear();
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_START,"Draft1.B","Draft1.B",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Breite-Draft1.B","Draft1.B",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Breite-Draft1.B","Hhe-Draft1.B",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Draft1.B","Hhe-Draft1.B",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_CLOSE,pPath));
	pSmart->aGeometrics.Insert(aGeo);
	aGeo.Clear();
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_START,"Draft1-Draft3.Y*Draft1.B","Draft1+Draft3.X*Draft1.B",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Draft1+Draft3*Draft2","Draft1+Draft3*Draft2",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_LINETO,"Draft1+Draft3.Y*Draft1.B","Draft1-Draft3.X*Draft1.B",pPath));
	aGeo.Insert(SdrSmartGeometricLine(SDRSMARTGEO_CLOSE,pPath));
	pSmart->aGeometrics.Insert(aGeo);
	pPath->SetXPolyDirty();
	return pPath;
}

SdrModel* MyScr::MakeModel() const
{
//    return MakeModelEmptyPage();
//    return MakeModelOneRect();
	SdrModel* pDraw=new SdrModel;
	pDraw->SetScaleUnit(eMap); // kann eigentlich weg

	SdrRectObj* pRect;
	SdrCircObj* pCirc;
	SdrVirtObj* pVirt;
	SdrPathObj* pPath;
	SdrPageObj* pPageObj;
	SdrPage* pPage;

	SfxItemSet aSet(pDraw->GetItemPool());
	aSet.Put(XFillColorItem("Braun",Color(COL_BROWN)));
	aSet.Put(XLineColorItem("Gelb",Color(COL_YELLOW)));
	aSet.Put(XLineWidthItem(2*nMap));
	/////////////////////////////////////////
	// Stammseite 1
	pPage=new SdrPage(*pDraw,TRUE);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pDraw->InsertMasterPage(pPage);

	aSet.Put(XFillColorItem("Braun",Color(COL_BROWN)));
	aSet.Put(XLineColorItem("Gelb",Color(COL_YELLOW)));
	aSet.Put(XLineWidthItem(2*nMap));

	pRect=new SdrRectObj(Rectangle(10*nMap,5*nMap,200*nMap,15*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(10*nMap,285*nMap,200*nMap,295*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);
	/////////////////////////////////////////

	/////////////////////////////////////////
	// Stammseite 2
	pPage=new SdrPage(*pDraw,TRUE);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pDraw->InsertMasterPage(pPage);

	aSet.Put(XFillColorItem("Braun",Color(COL_CYAN)));
	aSet.Put(XLineColorItem("Gelb",Color(COL_LIGHTCYAN)));
	aSet.Put(XLineWidthItem(4*nMap));

	pRect=new SdrRectObj(Rectangle(10*nMap,25*nMap,200*nMap,35*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(10*nMap,265*nMap,200*nMap,275*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);
	/////////////////////////////////////////

	/////////////////////////////////////////
	// Seite 1
	pPage=new SdrPage(*pDraw);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pPage->InsertMasterPage(0);
	SetOfByte aSetOfByte;
	aSetOfByte.SetAll();
	aSetOfByte.Clear(2);
	pPage->SetMasterPageVisibleLayers(aSetOfByte,0);
	pDraw->InsertPage(pPage);

	aSet.Put(XFillColorItem("Rot",Color(COL_RED)));
	aSet.Put(XLineColorItem("Rot",Color(COL_LIGHTRED)));
	aSet.Put(XLineWidthItem(0*nMap));

	//SdrPolyObj* pPLin=new SdrPolyObj(OBJ_PLIN,Polygon(Rectangle(120*nMap,120*nMap,180*nMap,140*nMap)));
	//pPLin->SetAttributes(aSet,FALSE);
	//pPage->InsertObject(pPLin);

	//pRect=new SdrRectObj(Rectangle(20*nMap,20*nMap,80*nMap,40*nMap));
	//pRect->SetAttributes(aSet,FALSE);
	//pRect=new SdrRectObj(OBJ_TEXT,Rectangle(20*nMap,20*nMap,80*nMap,40*nMap),"Das ist ein Textrahmen");
	pRect=new SdrRectObj(Rectangle(20*nMap,20*nMap,80*nMap,40*nMap));
	//,"Das ist ein Textrahmen");
	pPage->InsertObject(pRect);
	SdrObject* pNode1=pRect;

	pRect=new SdrRectObj(Rectangle(40*nMap,40*nMap,60*nMap,120*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pRect->SetNotVisibleAsMaster(TRUE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(20*nMap,120*nMap,80*nMap,140*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pRect->SetResizeProtect(TRUE);
	pPage->InsertObject(pRect);
	SdrObject* pNode2=pRect;

	pRect=new SdrRectObj(Rectangle(0*nMap,0*nMap,20*nMap,20*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pVirt=new SdrVirtObj(*pRect,Point(100*nMap,100*nMap));
	pVirt->SetMoveProtect(TRUE);
	pPage->InsertObject(pVirt);
	pVirt=new SdrVirtObj(*pRect,Point(160*nMap,100*nMap));
	pPage->InsertObject(pVirt);
	pVirt=new SdrVirtObj(*pRect,Point(100*nMap,140*nMap));
	pPage->InsertObject(pVirt);
	pVirt=new SdrVirtObj(*pRect,Point(160*nMap,140*nMap));
	pPage->InsertObject(pVirt);

	SdrEdgeObj* pEdge=new SdrEdgeObj;
	aSet.Put(XLineColorItem("Schwarz",Color(COL_BLACK)));
	pEdge->SetAttributes(aSet,FALSE);
	pEdge->ConnectToNode(TRUE,pNode1);
	pEdge->ConnectToNode(FALSE,pNode2);
	pPage->InsertObject(pEdge);/**/

	pCirc=new SdrCircObj(OBJ_SECT,Rectangle(20*nMap,180*nMap,60*nMap,220*nMap),0,4500);
	pCirc->SetAttributes(aSet,FALSE);
	pCirc->Shear(Point(20*nMap,180*nMap),4500,1.0,FALSE);
	pPage->InsertObject(pCirc);

	pCirc=new SdrCircObj(OBJ_SECT,Rectangle(80*nMap,180*nMap,120*nMap,220*nMap),0,9000);
	pCirc->SetAttributes(aSet,FALSE);
	pCirc->Shear(Point(20*nMap,180*nMap),-4500,-1.0,FALSE);
	pPage->InsertObject(pCirc);

	pCirc=new SdrCircObj(OBJ_SECT,Rectangle(140*nMap,180*nMap,180*nMap,220*nMap),13500,27000);
	pCirc->SetAttributes(aSet,FALSE);
	pCirc->Shear(Point(20*nMap,180*nMap),4500,1.0,FALSE);
	pPage->InsertObject(pCirc);

	{ // nun ein SmartObject anlegen
		pPath=MakeSmartObj();
		pPath->SetAttributes(aSet,FALSE);
		pPage->InsertObject(pPath);/**/
		pPath=MakeSmartClock();
		pPath->SetAttributes(aSet,FALSE);
		pPage->InsertObject(pPath);/**/
	}
	/////////////////////////////////////////
/*
	/////////////////////////////////////////
	// Seite 2
	pPage=new SdrPage(*pDraw);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pPage->InsertMasterPage(0);
	pPage->InsertMasterPage(1);
	pDraw->InsertPage(pPage);

	aSet.Put(XFillColorItem("Zyan",Color(COL_CYAN)));
	aSet.Put(XLineColorItem("Zyan",Color(COL_LIGHTCYAN)));
	aSet.Put(XLineWidthItem(0*nMap));

	pRect=new SdrRectObj(Rectangle(20*nMap,20*nMap,120*nMap,40*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(40*nMap,40*nMap,60*nMap,120*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(80*nMap,40*nMap,100*nMap,120*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(20*nMap,120*nMap,120*nMap,140*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);
	/////////////////////////////////////////

	/////////////////////////////////////////
	// Seite 3
	pPage=new SdrPage(*pDraw);
	pPage->SetSize(Size(210*nMap,300*nMap));
	pPage->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	pPage->InsertMasterPage(1);
	pDraw->InsertPage(pPage);

	aSet.Put(XFillColorItem("Magenta",Color(COL_MAGENTA)));
	aSet.Put(XLineColorItem("Magenta",Color(COL_LIGHTMAGENTA)));
	aSet.Put(XLineWidthItem(0*nMap));

	pRect=new SdrRectObj(Rectangle(20*nMap,20*nMap,160*nMap,40*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(40*nMap,40*nMap,60*nMap,120*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(80*nMap,40*nMap,100*nMap,120*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(120*nMap,40*nMap,140*nMap,120*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pRect=new SdrRectObj(Rectangle(20*nMap,120*nMap,160*nMap,140*nMap));
	pRect->SetAttributes(aSet,FALSE);
	pPage->InsertObject(pRect);

	pPageObj=new SdrPageObj(Rectangle(20*nMap,180*nMap,100*nMap,280*nMap));
	pPageObj->NbcSetPageNum(0);
	pPage->InsertObject(pPageObj);

	pPageObj=new SdrPageObj(Rectangle(110*nMap,180*nMap,190*nMap,280*nMap));
	pPageObj->NbcSetPageNum(1);
	pPage->InsertObject(pPageObj);
*/
	/////////////////////////////////////////

	pDraw->GetLayerAdmin().NewStandardLayer();
	pDraw->GetLayerAdmin().NewLayer("Grundriss");
	pDraw->GetLayerAdmin().NewLayer("Keller");
	pDraw->GetLayerAdmin().NewLayer("Erdgeschoss");
	pDraw->GetLayerAdmin().NewLayer("1. Stock");
	pDraw->GetLayerAdmin().NewLayer("Dachgeschoss");
	pDraw->GetLayerAdmin().NewLayer("Bemassung");

	/////////////////////////////////////////

	SdrLayerSet* pSet;

	pSet=new SdrLayerSet("Alle");
	pSet->AddMember(0); pSet->AddMember(1); pSet->AddMember(2);
	pSet->AddMember(3); pSet->AddMember(4); pSet->AddMember(5);
	pDraw->GetLayerAdmin().InsertLayerSet(pSet);

	pSet=new SdrLayerSet("Set 1");
	pSet->AddMember(1); pSet->AddMember(2);
	pSet->AddExcluded(3); pSet->AddExcluded(4); pSet->AddExcluded(5);
	pDraw->GetLayerAdmin().InsertLayerSet(pSet);

	/////////////////////////////////////////

	pDraw->SetChanged(FALSE);

	return pDraw;
}

void MyScr::ForceScroll(const Point& aPixPos)
{
	aScroll.Stop();
	Point aPnt;
	//if (pMyWin->pBox!=NULL) aPnt.Y()-=pMyWin->pBox->GetSizePixel().Height();
	Rectangle aRect(aPnt,GetSizePixel());
	long dx=0,dy=0;
	if (aPixPos.X()<=aRect.Left()  ) { dx=(aRect.Left()  -aPixPos.X())/2; if (dx<+1) dx=+1; if (dx>+100) dx=+100; }
	if (aPixPos.X()>=aRect.Right() ) { dx=(aRect.Right() -aPixPos.X())/2; if (dx>-1) dx=-1; if (dx<-100) dx=-100; }
	if (aPixPos.Y()<=aRect.Top()   ) { dy=(aRect.Top()   -aPixPos.Y())/2; if (dy<+1) dy=+1; if (dy>+100) dy=+100; }
	if (aPixPos.Y()>=aRect.Bottom()) { dy=(aRect.Bottom()-aPixPos.Y())/2; if (dy>-1) dy=-1; if (dy<-100) dy=-100; }
	aPnt=OutputToScreenPixel(aPixPos);
	if (aPnt.X()<=1) if (dx<+16) dx=+16;
	if (aPnt.Y()<=1) if (dy<+16) dy=+16;
	Size aSiz(System::GetScreenSizePixel());
	if (aPnt.X()>=aSiz.Width()-2)  if (dx>-16) dx=-16;
	if (aPnt.Y()>=aSiz.Height()-2) if (dy>-16) dy=-16;
	if (dx!=0 || dy!=0) {
		DoScroll(dx,dy);
		aScroll.SetTimeoutHdl(LINK(this,MyScr,ScrollHdl));
		aScroll.SetTimeout(18);
		aScroll.Start();
	}
}

void MyScr::DoScroll(long dxPix, long dyPix)
{
	long dx=PixelToLogic(Size(dxPix,0)).Width();
	long dy=PixelToLogic(Size(0,dyPix)).Height();
	MapMode aMap(GetMapMode());
	Point aP0(aMap.GetOrigin());
	aP0+=Point(dx,dy);
	aMap.SetOrigin(aP0);
	BOOL bXor=pView->IsShownXorVisible(this);
	if (bXor) pView->HideShownXor(this);
	SetMapMode(aMap);
	Scroll(dx,dy);
	Point aPosPix(Pointer::GetPosPixel());
	aPosPix.X()+=dxPix;
	aPosPix.Y()+=dyPix;
	Pointer::SetPosPixel(aPosPix);
	Update();
	if (bXor) pView->ShowShownXor(this);
}

IMPL_LINK(MyScr,ScrollHdl,Timer*,pTim)
{
	Point aPnt(ScreenToOutputPixel(Pointer::GetPosPixel()));
	MouseEvent aMEvt(aPnt,0,aLastMEvt.GetMode(),aLastMEvt.GetButtons(),aLastMEvt.GetModifier());
	MouseMove(aMEvt);
	return 0;
}

BOOL MyScr::Load(const String& rFN)
{
	BOOL bDlg=rFN.Len()==0;
	BOOL bOk=!bDlg;
	if (bDlg) {
		FileDialog aGetFN(this,WB_OPEN|WB_SVLOOK);
		aGetFN.SetPath(aFNam);
		aGetFN.SetDefaultExt(".SVD");
		String aStr("SV-Draw Grafik laden");
		aGetFN.SetText(aStr);
		aGetFN.AddFilter("Grafiken","*.SVD; *.PPT");
		aGetFN.AddFilter("SV-Draw Grafik","*.SVD");
		aGetFN.AddFilter("PowerPoint Dokument","*.PPT");
		if (aGetFN.Execute()) {
			aFNam=aGetFN.GetPath();
			bOk=TRUE;
		}
	} else aFNam=rFN;
	if (bOk) {
		pUndo->Clear();
		pRedo->Clear();
		if (pView!=NULL) pView->ClearAll();   // Alle angezeigten Seiten ausblenden
		//while (pDraw->GetMasterPageCount()!=0) pDraw->DeleteMasterPage(0); // Workaround fuer Bug in Model::Clear()
		//pDraw->Clear();
		Update();
//#ifdef JOEDEBUG
//        pDraw->GetItemPool().Load(aIn,TRUE); // Pool mit RefCounts laden
//#else
		FASTBOOL bSVD=TRUE;
		if (SvStorage::IsStorageFile(aFNam)) {
//            SvStorageRef xStorage=new SvStorage(aFNam,STREAM_STD_READ);
			SvStorageRef xStorage=new SvStorage(aFNam,STREAM_READ | STREAM_SHARE_DENYNONE);
//            SvStorage* xStorage=new SvStorage(aFNam,STREAM_READ | STREAM_SHARE_DENYNONE);
			SdrPowerPointImport aFilter(*xStorage);
			if (aFilter.IsPowerPointDoc()) {
				aFilter.SetModel(pDraw);
				bSVD=FALSE;
				ULONG nPageAnz=aFilter.GetPageCount();
				ULONG nMPagAnz=aFilter.GetPageCount(TRUE);
				ULONG nNum;
				String aMsg("PPt-Import: ");
				aMsg+=nMPagAnz; aMsg+=" MasterPage(s), ";
				aMsg+=nPageAnz; aMsg+=" Page(s).\n";
				for (nNum=0; nNum<nMPagAnz; nNum++) {
					aFilter.SetPageNum(nNum,TRUE);
					aMsg+="Master "; aMsg+=nNum+1;
					aMsg+=": Name="; aMsg+=aFilter.GetPageName();
					aMsg+=", Objektanzahl="; aMsg+=aFilter.GetObjCount();
					aMsg+="\n";
				}
				for (nNum=0; nNum<nPageAnz; nNum++) {
					aFilter.SetPageNum(nNum);
					aMsg+="Seite "; aMsg+=nNum+1;
					aMsg+=": Name="; aMsg+=aFilter.GetPageName();
					aMsg+=", Objektanzahl="; aMsg+=aFilter.GetObjCount();
					aMsg+="\n";
				}
				InfoBox(NULL,aMsg).Execute();
				aFilter.ImportModel();
//                aFilter.ImportOutline();
				if (pView!=NULL) pView->ShowPagePgNum(0,Point(0,0));
			}
		}
		if (bSVD) {
			SvFileStream aIn(aFNam,STREAM_READ);
#ifdef neeJOEDEBUG
			DebWriteln("MyScr::Load(): Der Pool vor dem Aufruf von Load():");
			DebOut(pDraw->GetItemPool());
#endif
			pDraw->GetItemPool().Load(aIn); // Pool ohne RefCounts laden
#ifdef neeJOEDEBUG
			DebWriteln("MyScr::Load(): Der Pool nach dem Aufruf von Load():");
			DebOut(pDraw->GetItemPool());
#endif
//#endif
		//pDraw->GetStyleSheetPool()->Load(aIn);
			aIn>>*pDraw;  // Sdr-Zeichendaten laden
			if (pView!=NULL) {
				if (SdrIsView(aIn)) {
#ifdef JOEDEBUG
					DebWriteln("View wird geladen");
#endif
					aIn>>*pView;
				} else {
					if (pView!=NULL) pView->ShowPagePgNum(0,Point(0,0));
				}
			}
			if (!aIn) {
				String aStr("Fehler beim Laden: "); aStr+=aIn.GetError();
				InfoBox(NULL,aStr).Execute();
			}
		}
		pDraw->SetChanged(FALSE);
	}
	//if (pView!=NULL) WriteStatus();
	return bOk;
}

BOOL MyScr::Merge(const String& rFN, FASTBOOL bMergeMasters)
{
	BOOL bDlg=rFN.Len()==0;
	BOOL bOk=!bDlg;
	if (bDlg) {
		FileDialog aGetFN(this,WB_OPEN|WB_SVLOOK);
		aGetFN.SetPath(aFNam);
		aGetFN.SetDefaultExt(".SVD");
		String aStr("SV-Draw Grafik mergen");
		aGetFN.SetText(aStr);
		aGetFN.AddFilter("SV-Draw Grafik","*.SVD");
		if (aGetFN.Execute()) {
			aFNam=aGetFN.GetPath();
			bOk=TRUE;
		}
	} else aFNam=rFN;
	if (bOk) {
		WriteStatus("ModelMerging");
		SvFileStream aIn(aFNam,STREAM_READ);
		SdrModel* pNeuMod=new SdrModel;
		pNeuMod->GetItemPool().Load(aIn); // Pool ohne RefCounts laden
		aIn>>*pNeuMod;  // Sdr-Zeichendaten laden
		pDraw->Merge(*pNeuMod,0,0xFFFF,0xFFFF,bMergeMasters,FALSE,TRUE);
		delete pNeuMod;
		WriteStatus("ModelMerging beendet");
	}
	return bOk;
}

void MyScr::Save(BOOL bCompressed, BOOL bNoBuf)
{
	FileDialog aGetFN(this,0|WB_SVLOOK);
	aGetFN.SetPath(aFNam);
	aGetFN.SetDefaultExt(".SVD");
	String aStr("SV-Draw Grafik ");
	if (bCompressed) aStr+="komprimiert ";
	aStr+="speichern";
	aGetFN.SetText(aStr);
	aGetFN.AddFilter("SV-Draw Grafik","*.SVD");
	if (aGetFN.Execute()) {
		//pUndo->Clear();
		//pRedo->Clear();
		aFNam=aGetFN.GetPath();
		SvFileStream aOut(aFNam,STREAM_STD_READWRITE|STREAM_TRUNC);
		//aOut.nJoeDummy=bCompressed;
		if (bNoBuf) aOut.SetBufferSize(0);
		pDraw->GetItemPool().Store(aOut);
		//pDraw->GetStyleSheetPool()->Store(aOut,FALSE); // Inkl. unbenutzter Vorlagen
		aOut<<*pDraw; // Sdr-Zeichendaten sichern
		aOut<<*pView;
		pDraw->SetChanged(FALSE);
		if (!aOut) {
			String aStr("Fehler beim Speichern: "); aStr+=aOut.GetError();
			InfoBox(NULL,aStr).Execute();
		}
	}
	WriteStatus();
}

void MyScr::ZoomIn()
{
	MapMode aMap(GetMapMode());
	Fraction aFr(aMap.GetScaleX());
	long nSiz=(aFr.GetNumerator()*100)/aFr.GetDenominator();
	nSiz=(nSiz*5+2)/4;
	if (nSiz>1000) nSiz=1000;
	if (nSiz>200) aFr=Fraction((nSiz+50)/100,1);
	else if (nSiz>20) aFr=Fraction((nSiz+5)/10,10);
	else aFr=Fraction(nSiz,100);
	aMap.SetScaleX(aFr);
	aMap.SetScaleY(aFr);
//    pView->ToggleShownXor(this);
	SetMapMode(aMap);
	Invalidate();
	Update();
//    pView->ToggleShownXor(this);
	SetZoomDepValues();
	pView->MovAction(GetLogPos());
}

void MyScr::ZoomOut()
{
	MapMode aMap(GetMapMode());
	Fraction aFr(aMap.GetScaleX());
	long nSiz=(aFr.GetNumerator()*100)/aFr.GetDenominator();
	nSiz=(nSiz*4+2)/5;
	if (nSiz<1) nSiz=1;
	if (nSiz>200) aFr=Fraction((nSiz+50)/100,1);
	else if (nSiz>20) aFr=Fraction((nSiz+5)/10,10);
	else aFr=Fraction(nSiz,100);
	aMap.SetScaleX(aFr);
	aMap.SetScaleY(aFr);
//    pView->ToggleShownXor(this);
	SetMapMode(aMap);
	Invalidate();
	Update();
//    pView->ToggleShownXor(this);
	SetZoomDepValues();
	pView->MovAction(GetLogPos());
}

void MyScr::NextPage(BOOL bPrev, BOOL bNoPrevNext)
{
	long nPgNum=0;
	BOOL bDoIt=TRUE;
	USHORT nPvAnz=pView->GetPageViewCount();
	if (nPvAnz!=0) {                                     // Seitennummer der
		nPgNum=0xFFFF;                                   // 1. angezeigten Seite
		for (USHORT nPvNum=0; nPvNum<nPvAnz; nPvNum++) { // herausfinden
			SdrPageView* pPV=pView->GetPageViewPvNum(nPvNum);
			long nNum=pPV->GetPage()->GetPageNum();
			if (pPV->GetPage()->IsMasterPage()) nNum=-nNum-1; // -1==MasterPage0, ...
			if (nNum<nPgNum) nPgNum=nNum;
		}
		if (!bNoPrevNext) {
			if (bPrev) {
				if (nPgNum>-long(pDraw->GetMasterPageCount())) {
					nPgNum--;
				} else {
					bDoIt=FALSE; // weiter zurueck geht nicht
				}
			} else {
				if (nPgNum<long(pDraw->GetPageCount())-1) {
					nPgNum++; // Naechsten Seite
				} else {
					bDoIt=FALSE; // weiter geht nicht
				}
			}
		}
	} else nPgNum=0; // nix anezeigt, also erste Seite anzeigen
	if (bDoIt) {
		//pView->HideAllPages(); //Clear();   // Alle angezeigten Seiten ausblenden
		//Update();
		// Alle nun nicht mehr sichtbaren Seiten ausblenden
		// bzw. sichtbar bleibende Seiten zurechtruecken
		for (USHORT nPvNum=pView->GetPageViewCount(); nPvNum>0;) {
			nPvNum--;
			SdrPageView* pPV=pView->GetPageViewPvNum(nPvNum);
			long nPNum=pPV->GetPage()->GetPageNum();
			if (pPV->GetPage()->IsMasterPage()) nPNum=-nPNum-1;
			long i=nPNum-nPgNum;
			if (i>=0 && i<3) {
				Point aPos(i*220*nMap,i*20*nMap);
				pView->SetPagePosPvNum(nPvNum,aPos);
			} else {
				pView->HidePagePvNum(nPvNum);
			}
		}
		// Alle sichtbaren Seiten anzeigen bzw. verschieben
		for (ULONG i=0; i<3; i++) {
			FASTBOOL bMaster=nPgNum<0;
			USHORT nNum=bMaster ? USHORT(-nPgNum-1) : USHORT(nPgNum);
			SdrPage* pPage=bMaster ? pDraw->GetMasterPage(nNum) : pDraw->GetPage(nNum);
			if (pPage!=NULL && pView->GetPageView(pPage)==NULL) {
				Point aPos(i*220*nMap,i*20*nMap);
				pView->ShowPage(pPage,aPos);
			}
			nPgNum++;
		}
	}
}

void MyScr::DoUndo()
{
	if (pUndo->Count()>0) {
		SfxUndoAction* pDo=pUndo->Pop();
		pDo->Undo();
		pRedo->Push(pDo);
		XubString aStr("Undo: ");
		aStr+=pDo->GetComment();
		WriteStatus(aStr);
	} else InfoBox(NULL,"Undo-Stack ist leer!").Execute();
}

void MyScr::DoRedo()
{
	if (pRedo->Count()>0) {
		SfxUndoAction* pDo=pRedo->Pop();
		pDo->Redo();
		pUndo->Push(pDo);
		XubString aStr("Redo: ");
		aStr+=pDo->GetComment();
		WriteStatus(aStr);
	} else InfoBox(NULL,"Redo-Stack ist leer!").Execute();
}

void MyScr::DoRepeat()
{
	if (pUndo->Count()>0) {
		SfxUndoAction* pDo=pUndo->Top();
		XubString aStr("Repeat: ");
		BOOL bOk=TRUE;
		if (!pDo->CanRepeat(*pView)) {
			XubString aStr1(pDo->GetRepeatComment(*pView));
			if (aStr1.Len()!=0) {
				aStr+=" '";
				aStr+=aStr1;
				aStr+="'";
			}
			aStr+=" nicht mglich.";
			bOk=FALSE;
		}
		if (bOk) {
			pDo->Repeat(*pView);
			aStr+=pDo->GetRepeatComment(*pView);
		}
		WriteStatus(aStr);
	} else InfoBox(NULL,"Undo-Stack ist leer, Repeat nicht mglich!").Execute();
}

void MyScr::DoCut()
{
	pView->Cut();
}

void MyScr::DoYank()
{
	pView->Yank(/*FORMAT_GDIMETAFILE*/);
}

void MyScr::DoPaste(ULONG nFormat)
{
	FASTBOOL a=
//      pView->Paste(this,FORMAT_GDIMETAFILE) ||
	  pView->Paste(this,nFormat);
	WriteStatus();
}

void MyScr::DoDragDrop()
{
	ReleaseMouse();
	pView->DragDropMarked(*this/*,FORMAT_GDIMETAFILE*/);
	WriteStatus();
}

BOOL __EXPORT MyScr::QueryDrop(DropEvent& rDEvt)
{
//    pView->SetActualWin(this);
	BOOL bOk=pView->QueryDrop(rDEvt,this);
	return bOk;
}

BOOL __EXPORT MyScr::Drop(const DropEvent& rDEvt)
{
//    pView->SetActualWin(this);
	//Point aPos(PixelToLogic(rDEvt.GetPosPixel()));
	//BOOL bOk=pView->PasteDragDrop(aPos);
	BOOL bOk=
//      pView->Drop(rDEvt,this,FORMAT_GDIMETAFILE) ||
	  pView->Drop(rDEvt,this);
	WriteStatus();
	return bOk;
}

void MyScr::DoPrint()
{
	WriteStatus("Nun wird gedruckt ...");
	pView->AddWin(&aPrn);
	aPrn.StartJob("Joe druckt");
	aPrn.StartPage();
	//aPrn.SetFillInBrush(Brush(Color(COL_BLACK)));
	//aPrn.DrawRect(Rectangle(0,0,1000,1000));
	pView->InitRedraw(&aPrn,Region());
	aPrn.EndPage();
	aPrn.EndJob();
	pView->DelWin(&aPrn);
	WriteStatus("Drucken beendet.");
}

void MyScr::DoInsertPage()
{
	SdrPageView* pPV=pView->GetPageViewPvNum(0);
	USHORT nPgNum=pPV==NULL?0:pPV->GetPage()->GetPageNum();
	BOOL bMaster=pPV!=NULL && pPV->GetPage()->IsMasterPage();
	SdrPage* pPg=new SdrPage(*pDraw,bMaster);
	pPg->SetSize(Size(210*nMap,300*nMap));
	pPg->SetBorder(20*nMap,20*nMap,20*nMap,20*nMap);
	if (!bMaster) {
		pDraw->InsertPage(pPg,nPgNum);
		NextPage(TRUE);
		String aStr("Seite ");
		aStr+=nPgNum+1;
		aStr+=" eingefuegt";
		WriteStatus(aStr);
	} else {
		pDraw->InsertMasterPage(pPg,nPgNum);
		NextPage(FALSE);
		String aStr("Stammseite ");
		aStr+=nPgNum+1;
		aStr+=" eingefuegt";
		WriteStatus(aStr);
	}
	pView->AddUndo(new SdrUndoNewPage(*pPg));
}

void MyScr::DoDeletePage()
{
	SdrPageView* pPV=pView->GetPageViewPvNum(0);  // Seinennummer der
	if (pPV!=NULL) {                              // angezeigten Seite
		USHORT nPgNum=pPV->GetPage()->GetPageNum(); // herausfinden
		pView->AddUndo(new SdrUndoDelPage(*pPV->GetPage()));
		String aStr("Seite ");
		if (!pPV->GetPage()->IsMasterPage()) {
			pDraw->RemovePage(nPgNum);
		} else {
			pDraw->RemoveMasterPage(nPgNum);
			aStr="Masterpage ";
		}
		aStr+=nPgNum+1;
		aStr+=" gelscht";
		WriteStatus(aStr);
	} else {
		WriteStatus("Nix da zum lschen...");
	}
}

void MyScr::DoAttributes()
{
	  pView->ShowItemBrowser();
//    SfxItemSet aSet(pView->GetAttributes());
//    aItemBrowser.SetAttributes(&aSet);
//    if (!aItemBrowser.IsVisible()) aItemBrowser.Show();
	//else aItemBrowser.Hide();
//    aItemBrowser.GrabFocus();

	//SfxItemPool* pPool=aSet.GetPool();

	//ModalDialog aDlg1(this,WB_BORDER|WB_SVLOOK|WB_MOVEABLE|WB_MINABLE|WB_CLOSEABLE);
	//aDlg1.SetText("Attribute");
//    /*ListBox*/ ItemBrowserControl aLB(&aDlg1,WB_BORDER|WB_SVLOOK);
#ifdef asdfasdfasdf
	aLB.SetAttributes(&aSet);
	OKButton aOk(&aDlg1);
	CancelButton aNo(&aDlg1);
	aDlg1.SetOutputSizePixel(Size(300,540));
	aLB.SetSizePixel(Size(300,500));
	aOk.SetPosSizePixel(Point(0,510),Size(100,30));
	aNo.SetPosSizePixel(Point(200,510),Size(100,30));
	aOk.Show();
	aNo.Show();
	aLB.Show();
	if (aDlg1.Execute() /*&& aLB.GetSelectEntryCount()==1*/) {
		XubString aStr/*(aLB.GetEntry(aLB.GetSelectEntryPos()))*/;
		aStr.Erase(4);
		USHORT nWhich=USHORT(aStr);
		if (nWhich!=0) {
			SfxPoolItem* pNewItem=aSet.Get(nWhich).Clone();
			SfxByteItem*   pByte  =PTR_CAST(SfxByteItem  ,pNewItem);
			SfxInt16Item*  pInt16 =PTR_CAST(SfxInt16Item ,pNewItem);
			SfxUInt16Item* pUInt16=PTR_CAST(SfxUInt16Item,pNewItem);
			SfxInt32Item*  pInt32 =PTR_CAST(SfxInt32Item ,pNewItem);
			SfxUInt32Item* pUInt32=PTR_CAST(SfxUInt32Item,pNewItem);
			SfxEnumItem*   pEnum  =PTR_CAST(SfxEnumItem  ,pNewItem);
			SfxBoolItem*   pBool  =PTR_CAST(SfxBoolItem  ,pNewItem);
			SfxFlagItem*   pFlag  =PTR_CAST(SfxFlagItem  ,pNewItem);
			SfxStringItem* pString=PTR_CAST(SfxStringItem,pNewItem);
			long nVal=0,nMax=0x7FFFFFFF,nMin=-nMax;
			if (pByte  !=NULL) { nVal=pByte  ->GetValue(); nMin=0; nMax=255; }
			if (pInt16 !=NULL) { nVal=pInt16 ->GetValue(); nMin=-32767; nMax=32767; }
			if (pUInt16!=NULL) { nVal=pUInt16->GetValue(); nMin=0; nMax=65535; }
			if (pInt32 !=NULL) { nVal=pInt32 ->GetValue(); }
			if (pUInt32!=NULL) { nVal=pUInt32->GetValue(); nMin=0; nMax=0xFF; }
			if (pEnum  !=NULL) { nVal=pEnum  ->GetValue(); nMin=0; pEnum->GetValueCount(); }
			if (pBool  !=NULL) { nVal=pBool  ->GetValue(); nMin=0; nMax=1; }
			ModalDialog aDlg2(this,WB_BORDER|WB_SVLOOK|WB_MOVEABLE|WB_MINABLE|WB_CLOSEABLE);
			aDlg2.SetText("Attribut ndern (del=lschen)");
			FixedText aTx1(&aDlg2,WB_SVLOOK);
			FixedText aTx2(&aDlg2,WB_SVLOOK);
			Edit aEd(&aDlg2,WB_BORDER|WB_SVLOOK);
			OKButton aOk(&aDlg2);
			CancelButton aNo(&aDlg2);
			aEd.SetText(String(nVal));
			if (pString!=NULL) aEd.SetText(pString->GetValue());
			aTx1.SetText(/*aLB.GetEntry(aLB.GetSelectEntryPos())*/"Bla");
			aTx2.SetText(String(nMin)+String("...")+String(nMax));
			aTx1.SetPosSizePixel(Point(10,10),Size(280,20));
			aTx2.SetPosSizePixel(Point(10,30),Size(280,20));
			aEd.SetPosSizePixel(Point(10,60),Size(280,20));
			aOk.SetPosSizePixel(Point(10,100),Size(100,30));
			aNo.SetPosSizePixel(Point(190,100),Size(100,30));
			aTx1.Show();
			aTx2.Show();
			aEd.Show();
			aOk.Show();
			aNo.Show();
			aDlg2.SetOutputSizePixel(Size(300,140));
			if (aDlg2.Execute()) {
				nVal=long(aEd.GetText());
				if (nVal<nMin) nVal=nMin;
				if (nVal>nMax) nVal=nMax;
				if (pByte  !=NULL) pByte  ->SetValue((BYTE)nVal);
				if (pInt16 !=NULL) pInt16 ->SetValue((INT16)nVal);
				if (pUInt16!=NULL) pUInt16->SetValue((UINT16)nVal);
				if (pInt32 !=NULL) pInt32 ->SetValue((INT32)nVal);
				if (pUInt32!=NULL) pUInt32->SetValue((UINT32)nVal);
				if (pEnum  !=NULL) pEnum  ->SetValue((USHORT)nVal);
				if (pBool  !=NULL) pBool  ->SetValue((BOOL)nVal);
				if (pString!=NULL) pString->SetValue(aEd.GetText());
				SfxItemSet aNewSet(*pPool,nWhich,nWhich);
				FASTBOOL bDel=aEd.GetText()==XubString("del");
				if (!bDel) aNewSet.Put(*pNewItem);
				pView->SetAttributes(aNewSet,bDel);
			}
			delete pNewItem;
		}
	}
#endif
}

void MyScr::SetZoomDepValues()
{
//    USHORT nMgnLog=USHORT(PixelToLogic(Size(nMgnPix,0)).Width());
//    pView->SetSnapMagnetic(Size(nMgnLog,nMgnLog));
	pView->RecalcLogicSnapMagnetic(*this);
}

IMPL_LINK(MyScr,TestFactoryHdl,SdrObjFactory*,pFact)
{
#ifdef JOEDEBUG
	String aStr;
	aStr+="TestFactoryHdl() gerufen: ";
	aStr+=pMyWin->GetText();
	DebWriteln(aStr);
#endif
	return 0;
}

IMPL_LINK(MyScr,NotifyUndoActionHdl,SfxUndoAction*,pUndoAction)
{
	if (pUndoAction!=NULL) { // Sicherheitshalber
		XubString aStr("Neue UndoAction: ");
		aStr+=pUndoAction->GetComment();
		WriteStatus(aStr);
		pUndo->Push(pUndoAction);
		pRedo->Clear();
	} else InfoBox(NULL,"NotifyUndoActionHdl(): pUndoAction=NULL !").Execute();
	return 0;
}

IMPL_LINK(MyScr,IOProgressHdl,USHORT*,pPercent)
{
	Window* pOut=pMyWin->pBar;
	if (pOut!=NULL || !pOut->IsVisible() || (pOut->GetParent()!=NULL && !pOut->GetParent()->IsVisible())) {
		pOut=GetpApp()->GetAppWindow();
		if (pOut!=NULL) {
			if (pOut->GetChildCount()>=2) {
				pOut=pOut->GetChild(1);
			} else if (pOut->GetChildCount()>=1) {
				pOut=pOut->GetChild(0);
			}
		}
	}
	if (pOut!=NULL) {
		Brush aBrsMerk(pOut->GetFillInBrush());
		Size aSiz(pOut->GetOutputSizePixel());
		pOut->SetPen(PEN_NULL);
		if (*pPercent==0) {
			pOut->SetFillInBrush(Color(COL_YELLOW));
			pOut->DrawRect(Rectangle(Point(),aSiz));
		}
		aSiz.Width()*=*pPercent;
		aSiz.Width()+=50;
		aSiz.Width()/=100;
		pOut->SetFillInBrush(Color(COL_BLUE));
		pOut->DrawRect(Rectangle(Point(),aSiz));
		if (*pPercent==100) {
			pOut->Invalidate();
		}
		pOut->SetFillInBrush(aBrsMerk);
	}
	return 0;
}

/*
void __EXPORT MyScr::PaintHdl(SdrObject* pObj, ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec)
{
#ifdef JOEDEBUG
	DebWrite("PaintObj");
#endif
	pObj->Paint(rOut,rInfoRec);
}*/


IMPL_LINK(MyScr,MenuHdl,Menu*,pMenu)
{
	pView->SetActualWin(this);
#ifdef _JOEDEBUG
	DebWriteln("MyScr::MenuHdl():");
	DebWriteln(String("  pMenu =")+GetStr(pMenu));
	DebWriteln(String("  MyScr =")+GetStr(this));
	DebWriteln(String("  pMyWin=")+GetStr(pMyWin));
	DebWriteln(String("  pView =")+GetStr(pView));
#endif
	String aMsg;
	FASTBOOL bWriteStat=TRUE;
	switch (pMenu->GetCurItemId()) {
		case MENU_NEWDOC  : pMyWin->AddNewDoc(FALSE,String()); break;
		case MENU_OPEN    : pMyWin->AddNewDoc(TRUE,String());  break;
		case MENU_SAVE    : Save(FALSE,FALSE);  break;
		case MENU_PRINT   : DoPrint();  break;
		case MENU_EXIT    : Application::Quit(); break;
		case MENU_UNDO    : DoUndo();   bWriteStat=FALSE; break;
		case MENU_REDO    : DoRedo();   bWriteStat=FALSE; break;
		case MENU_REPEAT  : DoRepeat(); bWriteStat=FALSE; break;
		case MENU_CUT     : DoCut();    break;
		case MENU_YANK    : DoYank();   break;
		case MENU_PASTE   : DoPaste();  break;
		case MENU_PASTEAS : DoPaste();  break;
		case MENU_PASTEASMTF: DoPaste(FORMAT_GDIMETAFILE); break;
		case MENU_PASTEASBMP: DoPaste(FORMAT_BITMAP);      break;
		case MENU_PASTEASRTF: DoPaste(FORMAT_RTF);         break;
		case MENU_PASTEASSTR: DoPaste(FORMAT_STRING);      break;
		case MENU_PASTEASETC+ 0: case MENU_PASTEASETC+ 1: case MENU_PASTEASETC+ 2: case MENU_PASTEASETC+ 3: case MENU_PASTEASETC+ 4: case MENU_PASTEASETC+ 5:
		case MENU_PASTEASETC+ 6: case MENU_PASTEASETC+ 7: case MENU_PASTEASETC+ 8: case MENU_PASTEASETC+ 9: case MENU_PASTEASETC+10: case MENU_PASTEASETC+11:
		case MENU_PASTEASETC+12: case MENU_PASTEASETC+13: case MENU_PASTEASETC+14: case MENU_PASTEASETC+15: case MENU_PASTEASETC+16: case MENU_PASTEASETC+17:
							  DoPaste(Clipboard::GetFormat(pMenu->GetCurItemId()-MENU_PASTEASETC)); break;
		case MENU_DELETE  : pView->DeleteMarked();  break;
		case MENU_MARKALL : pView->MarkAll(); break;
		case MENU_MARKNEXT: pView->MarkNext(FALSE); break;
		case MENU_MARKPREV: pView->MarkNext(TRUE); break;

		case MENU_PAGEINS : DoInsertPage(); bWriteStat=FALSE; break;
		case MENU_PAGEDEL : DoDeletePage(); bWriteStat=FALSE; break;
		case MENU_MIRRVERT: pView->MirrorMarkedObjVertical(); break;
		case MENU_MIRRHORZ: pView->MirrorMarkedObjHorizontal(); break;
		case MENU_CONVBEZR: pView->ConvertMarkedToPathObj(FALSE); break;
		case MENU_CONVPOLY: pView->ConvertMarkedToPolyObj(FALSE); break;
		//case MENU_CONVPATH: pView->(); break;
//        case MENU_CONVTOSM: pView->(); break;
//        case MENU_CONVSMTO: pView->(); break;
		case MENU_INSPOINT: pView->SetInsObjPointMode(!pView->IsInsObjPointMode()); break;
		case MENU_PNTNORM : pView->SetMarkedPointsSmooth(SDRPATHSMOOTH_ANGULAR); break;
		case MENU_PNTSMOO : pView->SetMarkedPointsSmooth(SDRPATHSMOOTH_ASYMMETRIC); break;
		case MENU_PNTSYMM : pView->SetMarkedPointsSmooth(SDRPATHSMOOTH_SYMMETRIC); break;
		case MENU_SEGLINE : pView->SetMarkedSegmentsKind(SDRPATHSEGMENT_LINE);   break;
		case MENU_SEGCURV : pView->SetMarkedSegmentsKind(SDRPATHSEGMENT_CURVE);  break;
		case MENU_SEGTOGG : pView->SetMarkedSegmentsKind(SDRPATHSEGMENT_TOGGLE); break;
		//case MENU_SEGSPLN : pView->SetMarkedSegmentsKind(SDRPATHSEGMENT_SPLINE); break;
		case MENU_GLUEINSPOINT : pView->SetInsGluePointMode(!pView->IsInsGluePointMode()); break;
		case MENU_GLUEPERCENT  : pView->SetMarkedGluePointsPercent(pView->IsMarkedGluePointsPercent()!=TRUE); break;
		case MENU_GLUEHLEFT    : pView->SetMarkedGluePointsAlign(FALSE,SDRHORZALIGN_LEFT);  break;
		case MENU_GLUEHCENTER  : pView->SetMarkedGluePointsAlign(FALSE,SDRHORZALIGN_CENTER); break;
		case MENU_GLUEHRIGHT   : pView->SetMarkedGluePointsAlign(FALSE,SDRHORZALIGN_RIGHT); break;
		case MENU_GLUEVTOP     : pView->SetMarkedGluePointsAlign(TRUE,SDRVERTALIGN_TOP);    break;
		case MENU_GLUEVCENTER  : pView->SetMarkedGluePointsAlign(TRUE,SDRVERTALIGN_CENTER); break;
		case MENU_GLUEVBOTTOM  : pView->SetMarkedGluePointsAlign(TRUE,SDRVERTALIGN_BOTTOM); break;
		case MENU_GLUEESCLEFT  : pView->SetMarkedGluePointsEscDir(SDRESC_LEFT  ,pView->IsMarkedGluePointsEscDir(SDRESC_LEFT  )!=TRUE); break;
		case MENU_GLUEESCRIGHT : pView->SetMarkedGluePointsEscDir(SDRESC_RIGHT ,pView->IsMarkedGluePointsEscDir(SDRESC_RIGHT )!=TRUE); break;
		case MENU_GLUEESCTOP   : pView->SetMarkedGluePointsEscDir(SDRESC_TOP   ,pView->IsMarkedGluePointsEscDir(SDRESC_TOP   )!=TRUE); break;
		case MENU_GLUEESCBOTTOM: pView->SetMarkedGluePointsEscDir(SDRESC_BOTTOM,pView->IsMarkedGluePointsEscDir(SDRESC_BOTTOM)!=TRUE); break;
		case MENU_PUTTOTOP: pView->PutMarkedToTop();       break;
		case MENU_MOVTOTOP: pView->MovMarkedToTop();       break;
		case MENU_FRONTOBJ: pView->PutMarkedInFrontOfObj(pView->GetMarkList().GetMark(pView->GetMarkList().GetMarkCount()-1)->GetObj()); break;
		case MENU_BEHNDOBJ: pView->PutMarkedBehindObj(pView->GetMarkList().GetMark(0)->GetObj()); break;
		case MENU_MOVTOBTM: pView->MovMarkedToBtm();       break;
		case MENU_PUTTOBTM: pView->PutMarkedToBtm();       break;
		case MENU_REVORDER: pView->ReverseOrderOfMarked(); break;
		case MENU_ALGNHLFT: pView->AlignMarkedObjects(SDRHALIGN_LEFT  ,SDRVALIGN_NONE  ); break;
		case MENU_ALGNHCTR: pView->AlignMarkedObjects(SDRHALIGN_CENTER,SDRVALIGN_NONE  ); break;
		case MENU_ALGNHRGT: pView->AlignMarkedObjects(SDRHALIGN_RIGHT ,SDRVALIGN_NONE  ); break;
		case MENU_ALGNVTOP: pView->AlignMarkedObjects(SDRHALIGN_NONE  ,SDRVALIGN_TOP   ); break;
		case MENU_ALGNVCTR: pView->AlignMarkedObjects(SDRHALIGN_NONE  ,SDRVALIGN_CENTER); break;
		case MENU_ALGNVBTM: pView->AlignMarkedObjects(SDRHALIGN_NONE  ,SDRVALIGN_BOTTOM); break;
		case MENU_ALGNCNTR: pView->AlignMarkedObjects(SDRHALIGN_CENTER,SDRVALIGN_CENTER); break;
		case MENU_GROUP   : pView->GroupMarked();      break;
		case MENU_UNGROUP : pView->UnGroupMarked();    break;
		//case MENU_GRPNAME : break;
		case MENU_GRPENTER: pView->EnterMarkedGroup(); break;
		case MENU_GRPLEAVE: pView->LeaveOneGroup();    break;
		case MENU_COMBINE : pView->CombineMarkedObjects(FALSE);   break;
		case MENU_DISMANTL: pView->DismantleMarkedObjects(FALSE); break;
		case MENU_JOIN    : pView->CombineMarkedObjects(TRUE);    break;
		case MENU_UNJOIN  : pView->DismantleMarkedObjects(TRUE);  break;
		case MENU_MTFIMP  : pView->DoImportMarkedMtf();  break;

		case MENU_NEWWIN  : pMyWin->AddNewWin();  break;
		case MENU_NEWVIEW : pMyWin->AddNewView(); break;
	}
	if (bWriteStat) WriteStatus(aMsg);
	ForceCapture(bLftMerk);
	ForcePointer();
	return TRUE;
}

void __EXPORT MyScr::KeyInput(const KeyEvent& rKEvt)
{
//    pView->SetActualWin(this);
	USHORT nKeyCode=rKEvt.GetKeyCode().GetCode()+rKEvt.GetKeyCode().GetModifier();
	if (nKeyCode==KEY_ESCAPE) {
		if (pView->IsAction()) {
			pView->BrkAction();
			WriteStatus("Aktion abgebrochen");
		}
		pView->EndTextEdit();
	}
	if (pView->KeyInput(rKEvt,this)) { WriteStatus(); ForcePointer(); return; } // Event von der SdrView ausgewertet
	FASTBOOL bShift=rKEvt.GetKeyCode().IsShift();
	FASTBOOL bCtrl=rKEvt.GetKeyCode().IsMod1();
	FASTBOOL bAlt=rKEvt.GetKeyCode().IsMod2();
	USHORT   nModifiers=rKEvt.GetKeyCode().GetModifier();
	DispatchModifiers(nModifiers);
	Point aMPos(GetLogPos());
	BOOL bMyKey=FALSE;
	if (!bMyKey && pView->IsDragObj()) {
		bMyKey=TRUE;
		switch (nKeyCode) {
			case KEY_S: pView->SetDragStripes(!pView->IsDragStripes()); break;
			case KEY_H: pView->SetDragHdlHide(!pView->IsDragHdlHide()); break;
			case KEY_D: DoDragDrop(); break;
			default: bMyKey=FALSE;
		}
	}

	if (!bMyKey) {
		bMyKey=TRUE;
		switch (nKeyCode) {
			case KEY_F1: RequestHelp(HelpEvent(aMPos,HELPMODE_CONTEXT)); break;
			case KEY_F2: case KEY_F2+KEY_SHIFT: case KEY_F2+KEY_ALT:
			case KEY_F2+KEY_SHIFT+KEY_ALT: Save(bShift,bAlt); break;
			case KEY_PAGEDOWN: NextPage();     WriteStatus(); break;
			case KEY_PAGEUP  : NextPage(TRUE); WriteStatus(); break;
			case KEY_LEFT: case KEY_UP: case KEY_RIGHT: case KEY_DOWN: {
				long dx=0,dy=0;
				switch (rKEvt.GetKeyCode().GetCode()) {
					case KEY_LEFT : dx=-20; break;
					case KEY_UP   : dy=-20; break;
					case KEY_RIGHT: dx=+20; break;
					case KEY_DOWN : dy=+20; break;
				}
				SdrPageView* pPV=pView->HitPage(GetLogPos());
				if (pPV!=NULL) { // Page getroffen? -> verschieben
					Point aPos(pPV->GetOffset());
					aPos+=Point(dx*nMap,dy*nMap);
					pView->SetPagePos(pPV,aPos);
				} else {         // Sonst scrollen
					DoScroll(dx,dy);
				}
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_P: {
				pDraw->SetPickThroughTransparentTextFrames(!pDraw->IsPickThroughTransparentTextFrames());
				WriteFlagStatus("PickThroughTransparentTextFrames",pDraw->IsPickThroughTransparentTextFrames());
			} break;
			case KEY_ALT+KEY_P: {
#ifdef JOEDEBUG
				DEBOUT(pDraw->GetItemPool());
#else
				WriteStatus("Pool ansehen nur mit JOEDEBUG moeglich!");
#endif
			} break;
			case KEY_ALT+KEY_T: {
				DoAttributes();
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_T: {
				MapUnit eOldMU=pDraw->GetScaleUnit();
				MapUnit eNewMU=eOldMU!=MAP_100TH_MM ? MAP_100TH_MM : MAP_TWIP;
				pDraw->SetScaleUnit(eNewMU);
				String aMsg("Model-ScaleUnit umgestellt von [");
				aMsg+=SdrFormatter::GetUnitStr(eOldMU);
				aMsg+="] auf [";
				aMsg+=SdrFormatter::GetUnitStr(eNewMU);
				aMsg+="].";
				WriteStatus(aMsg);
			} break;
			case KEY_ALT+KEY_Z: {
				pView->SetCreate1stPointAsCenter(!pView->IsCreate1stPointAsCenter());
				WriteFlagStatus("Create1stPointAsCenter",pView->IsCreate1stPointAsCenter());
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_Z: {
				pView->SetResizeAtCenter(!pView->IsResizeAtCenter());
				WriteFlagStatus("ResizeAtCenter",pView->IsResizeAtCenter());
			} break;
			case KEY_CTRL+KEY_ALT+KEY_Z: {
				pView->SetCrookAtCenter(!pView->IsCrookAtCenter());
				WriteFlagStatus("CrookAtCenter",pView->IsCrookAtCenter());
			} break;
			case KEY_X: {
				pView->SetNoDragXorPolys(!pView->IsNoDragXorPolys());
				WriteFlagStatus("NoDragXorPolys",pView->IsNoDragXorPolys());
			} break;
			case KEY_CTRL+KEY_X: {
				pView->SetUseIncompatiblePathCreateInterface(!pView->IsUseIncompatiblePathCreateInterface());
				WriteFlagStatus("UseIncompatiblePathCreateInterface",pView->IsUseIncompatiblePathCreateInterface());
			} break;
			case KEY_ALT+KEY_D: {
				pView->SetSolidDragging(!pView->IsSolidDragging());
				WriteFlagStatus("SolidDragging",pView->IsSolidDragging());
			} break;
			case KEY_ALT+KEY_H: {
				pView->SetSolidMarkHdl(!pView->IsSolidMarkHdl());
				WriteFlagStatus("SolidMarkHandles",pView->IsSolidMarkHdl());
			} break;
			case KEY_CTRL+KEY_E: {
				SfxItemSet aSet(pDraw->GetItemPool());
				SvxEscapementItem aHochTief(SVX_ESCAPEMENT_SUPERSCRIPT);
				aSet.Put(aHochTief);
				pView->SetAttributes(aSet);
			} break;
			/*case KEY_ALT+KEY_S: {
				pView->SetSlantButShear(!pView->IsSlantButShear());
				WriteFlagStatus("SlantButShear",pView->IsSlantButShear());
			} break;*/
			case KEY_ALT+KEY_A: {
				pView->SetAngleSnapEnabled(!pView->IsAngleSnapEnabled());
				WriteFlagStatus("AngleSnap",pView->IsAngleSnapEnabled());
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_A: {
				SdrPageView* pPV=pView->GetPageView(aMPos);
				if (pPV!=NULL) {
					//Bitmap aBmp(pView->GetMarkedObjBitmap());
					Animation aAni;
					AnimationBitmap aAniBmp;
					aAniBmp.nWait=30;
					aAniBmp.eDisposal=DISPOSE_NOT;
					aAniBmp.bUserInput=FALSE;
					aAniBmp.nLoopCount=0;
					aAniBmp.aBmpEx=GetBitmap(Point(0*nMap,0*nMap),Size(20*nMap+1,20*nMap+1));
					aAniBmp.aSize=aAniBmp.aBmpEx.GetSizePixel();
					aAniBmp.aGlobalSize=aAniBmp.aBmpEx.GetSizePixel();
					aAni.InsertAnimationBitmap(aAniBmp);
					aAniBmp.aBmpEx=GetBitmap(Point(20*nMap,0*nMap),Size(20*nMap+1,20*nMap+1));
					aAni.InsertAnimationBitmap(aAniBmp);
					aAniBmp.aBmpEx=GetBitmap(Point(40*nMap,0*nMap),Size(20*nMap+1,20*nMap+1));
					aAni.InsertAnimationBitmap(aAniBmp);
					SdrGrafObj* pObj=new SdrGrafObj(Graphic(aAni),Rectangle(0,0,100*nMap,100*nMap));
					pView->InsertObject(pObj,*pPV);
					WriteStatus("Animation eingefuegt");
				}
			} break;
			case KEY_ALT+KEY_C: {
				pView->SetCrookNoContortion(!pView->IsCrookNoContortion());
				WriteFlagStatus("CrookNoContortion",pView->IsCrookNoContortion());
			} break;
			case KEY_CTRL+KEY_ALT+KEY_C: {
				String aStr("CrookMode auf ");
				SdrCrookMode eMode=pView->GetCrookMode();
				switch (eMode) {
					case SDRCROOK_ROTATE : eMode=SDRCROOK_SLANT  ; aStr+="'Slant'"  ; break;
					case SDRCROOK_SLANT  : eMode=SDRCROOK_STRETCH; aStr+="'Stretch'"; break;
					case SDRCROOK_STRETCH: eMode=SDRCROOK_ROTATE ; aStr+="'Rotate'" ; break;
				} // switch
				aStr+=" geschaltet";
				pView->SetCrookMode(eMode);
				WriteStatus(aStr);
			} break;
			case KEY_CTRL+KEY_SHIFT+KEY_C: {
				pView->SetRef1(pView->GetLastCrookCenter());
				WriteStatus("Ref1 auf LastCrookCenter gesetzt");
			}
			case KEY_ALT+KEY_M: {
				pView->SetMoveOnlyDragging(!pView->IsMoveOnlyDragging());
				WriteFlagStatus("MoveOnlyDragging",pView->IsMoveOnlyDragging());
			} break;
			case KEY_ALT+KEY_SHIFT+KEY_M: {
				Merge("",TRUE);
			} break;
			case KEY_ALT+KEY_SHIFT+KEY_CTRL+KEY_M: {
				Merge("",FALSE);
			} break;
			case KEY_CTRL+KEY_I: {
				WriteStatus("Importiere MetaFile(s)");
				pView->DoImportMarkedMtf();
			} break;
			case KEY_SHIFT+KEY_O: {
				BOOL bOn=!pView->IsOFrmSnap();
				pView->SetOFrmSnap(bOn);
				WriteFlagStatus("Objektfang (Frame) ",bOn);
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_O: {
				BOOL bOn=!pView->IsOPntSnap();
				pView->SetOPntSnap(bOn);
				WriteFlagStatus("Objektfang (Points) ",bOn);
			} break;
			case KEY_SHIFT+KEY_F: {
				if (pView->IsDragHelpLine()) {
					SdrHelpLineKind eKind=pView->GetDraggedHelpLineKind();
					// enums lassen sich nicht inkrementieren - grmpfl. (Cee nee, Joe)
					USHORT nKind=USHORT(eKind);
					nKind++;
					if (nKind>USHORT(SDRHELPLINE_MAX)) nKind=USHORT(SDRHELPLINE_MIN);
					eKind=SdrHelpLineKind(nKind);
					pView->SetDraggedHelpLineKind(eKind);
				} else {
					pView->BegDragHelpLine(aMPos,SDRHELPLINE_POINT);
				}
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_F: {
				BOOL bOn=!pView->IsHlplFront();
				pView->SetHlplFront(bOn);
				WriteFlagStatus("Helpline in Front ",bOn);
			} break;
			case KEY_CTRL+KEY_B: {
				pView->SetBigOrtho(!pView->IsBigOrtho());
				WriteFlagStatus("BigOrtho ",pView->IsBigOrtho());
			} break;
			case KEY_ALT+KEY_B: case KEY_SHIFT+KEY_ALT+KEY_B: {
				XPolygon aXP(4);
				aXP[0]=Point(41*nMap, 0*nMap);
				aXP[1]=Point( 0*nMap,60*nMap);
				aXP[2]=Point(82*nMap,60*nMap);
				aXP[3]=aXP[0];
				pView->BegCreateLibObj(aMPos,new SdrPathObj(OBJ_POLY,XPolyPolygon(aXP)),!bShift);
			} break;
			case KEY_ALT+KEY_CTRL+KEY_B: case KEY_SHIFT+KEY_ALT+KEY_CTRL+KEY_B: {
				XPolygon aXP(5);
				aXP[0]=Point( 0*nMap, 0*nMap);
				aXP[1]=Point( 0*nMap,60*nMap);
				aXP[2]=Point(80*nMap,40*nMap);
				aXP[3]=Point(80*nMap,20*nMap);
				aXP[4]=aXP[0];
				pView->SetCurrentLibObj(new SdrPathObj(OBJ_POLY,XPolyPolygon(aXP)),bShift);
				pView->SetDragMode(SDRDRAG_MOVE);
				pView->UnmarkAllObj();
				pView->SetCreateMode();
				WriteStatus();
			} break;
			case KEY_SHIFT+KEY_ALT+KEY_S: {
				pView->BegUndo("(50,100,150,250) setzen");
				pView->SetMarkedObjRect(Rectangle(50*nMap,100*nMap,150*nMap,250*nMap));
				pView->EndUndo();
				WriteStatus("Markierte Objekte auf (50,100,150,250) gesetzt");
			} break;
			case KEY_ALT+KEY_Q: {
				pView->SetQuickTextEditMode(!pView->IsQuickTextEditMode());
				WriteFlagStatus("QuickTextEdit",pView->IsQuickTextEditMode());
			} break;
			default: bMyKey=FALSE;
		}
	}

	if (!bMyKey) { // Layer
		bMyKey=TRUE;
		switch (rKEvt.GetKeyCode().GetCode()) {
			case KEY_0: case KEY_1: case KEY_2: case KEY_3: case KEY_4: case KEY_5: case KEY_6: case KEY_7: case KEY_8: case KEY_9: {
				BYTE nLay=BYTE(rKEvt.GetKeyCode().GetCode()-KEY_0);
				SdrLayer* pLay=pDraw->GetLayerAdmin().GetLayer(nLay);
				if (pLay!=NULL) {
					String aStr(pLay->GetName());
					String aActStr;
					if (bShift && bCtrl) {
						pView->DeleteLayer(aStr);
						aActStr="geloescht";
					} else if (bShift) {
						TRISTATE nPrn=pView->IsLayerPrintable(aStr);
						BOOL bOn=nPrn!=TRUE;
						pView->SetLayerPrintable(aStr,bOn);
						if (bOn) aActStr="druckbar";
						else aActStr="nicht druckbar";
					} else if (bCtrl) {
						TRISTATE nLock=pView->IsLayerLocked(aStr);
						BOOL bOn=nLock!=TRUE;
						pView->SetLayerLocked(aStr,bOn);
						if (bOn) aActStr="gesperrt";
						else aActStr="entsperrt";
					} else if (bAlt) {
						TRISTATE nVis=pView->IsLayerVisible(aStr);
						BOOL bOn=nVis!=TRUE;
						pView->SetLayerVisible(aStr,bOn);
						if (bOn) aActStr="eingeblendet";
						else aActStr="ausgeblendet";
					} else {
						pView->SetActiveLayer(aStr);
						WriteStatus();
					}
					if (aActStr.Len()!=0) {
						aActStr.Insert(' ',0);
						aActStr.Insert(aStr,0);
						aActStr.Insert("Layer ",0);
					}
					WriteStatus(aActStr);
				} else {
					String aStr("Ein Layer mit der ID ");
					aStr+=USHORT(nLay);
					aStr+=" ist nicht definiert";
					WriteStatus(aStr);
					InfoBox(NULL,aStr).Execute();
				}
			} break;
			default: bMyKey=FALSE;
		}
	}
	if (!bMyKey) {
		bMyKey=TRUE;
		switch (rKEvt.GetCharCode()) {
			case '+': {
				if (bAlt) {
					if (pMyWin->IsMinimized()) pMyWin->Restore();
					else pMyWin->Maximize();
				} else {
					ZoomIn();
				}
			} break;
			case '-': {
				if (bAlt) {
					if (pMyWin->IsMaximized()) pMyWin->Restore();
					else pMyWin->Minimize();
				} else {
					ZoomOut();
				}
			} break;
			case 'm': {
				pView->SetMacroMode(!pView->IsMacroMode());
				if (pView->IsMacroMode()) WriteStatus("Macromodus aktiviert");
				else WriteStatus("Macromodus deaktiviert");
			} break;
			case 'u': {
				pView->UnmarkAll();
				pView->SetDragMode(SDRDRAG_MOVE);
				WriteStatus();
			} break;
			case 'R': {
				if (pView->HasMarkedPoints()) {
					String aStr(pView->GetMarkDescription());
					aStr+=" aufgetrennt";
					pView->RipUpAtMarkedPoints();
					WriteStatus(aStr);
				}
			} break;
			case 'S': {
				if (pView->HasMarkedObj()) {
					String aStr(pView->GetMarkDescription());
					aStr+=" geschlossen";
					pView->ShutMarkedObjects();
					WriteStatus(aStr);
				}
			} break;
			//case 'l': ShowLayers(); break;
			/*case 'J': {
				VirtualDevice aOut;
				aOut.EnableOutput(FALSE);
				GDIMetaFile aMtf;
				aMtf.Record(&aOut);
				aOut.SetFillInBrush(Brush(Color(COL_YELLOW)));
				aOut.SetPen(Pen(Color(COL_RED),4*nMap));
				aOut.DrawRect(Rectangle(0*nMap,40*nMap,100*nMap,60*nMap));
				aOut.SetFillInBrush(Brush(Color(COL_BLUE)));
				aOut.SetPen(Pen(Color(COL_GREEN),4*nMap));
				aOut.DrawRect(Rectangle(40*nMap,0*nMap,60*nMap,100*nMap));
				aMtf.Stop();
				aMtf.SetPrefSize(Size(101*nMap,101*nMap));
				SdrGrafObj* pGO=new SdrGrafObj(Graphic(aMtf),Rectangle(0*nMap,0*nMap,100*nMap,100*nMap));
				pView->InsertObject(pGO,*pView->GetPageViewPvNum(0));
				//pView->Paste(aMtf);
#ifdef JOEDEBUG
				DEBOUT(aMtf);
#endif
			} break;*/
			/*case 'l': {
				SfxItemSet aSet(pView->GetAttributes());
				SvxLineTabDialog aDlg(this,&aSet,pView->GetModel());
				if (aDlg.Execute()) {
					pView->SetAttributes(*aDlg.GetOutputItemSet());
				}
			} break;
			case 'f': {
				SfxItemSet aSet(pView->GetAttributes());
				SvxAreaTabDialog aDlg(this,&aSet,pView->GetModel());
				if (aDlg.Execute()) {
					pView->SetAttributes(*aDlg.GetOutputItemSet());
				}
			} break;
			case 't': {
				SfxItemSet aSet(pView->GetGeoAttrFromMarked());
				//O:\SD\Source\UI\Func\FuTransf???
				Rectangle aRect(pView->GetMarkedObjRect());
				SvxTransformTabDialog aDlg(this,&aSet,pView);
				if (aDlg.Execute()) {
					pView->SetGeoAttrToMarked(*aDlg.GetOutputItemSet());
				}
			} break; /* */
			/*case 'n': case 'N': {
				if (pView->HasMarkedObj()) {
					Point aAP(20*nMap,20*nMap);
					if (rKEvt.GetCharCode()=='N') aAP=Point(60*nMap,80*nMap);
					pView->GetMarkList().GetMark(0)->GetObj()->SetAnchorPos(aAP);
					WriteStatus("Ankerposition gesetzt auf (20,20) bzw. (60,80)"); break;
				}
			} break;*/
			/*case 'b': {
				SdrPageView* pPV=pView->GetPageView(aMPos);
				if (pPV!=NULL) {
					//Bitmap aBmp(GetBitmap(Point(0,0),Size(160,100)));
					Bitmap aBmp(pView->GetMarkedObjBitmap());
					SdrGrafObj* pObj=new SdrGrafObj(Graphic(aBmp),Rectangle(0,0,100*nMap,100*nMap));
					pView->InsertObject(pObj,*pPV);
					WriteStatus("Bitmap eingefuegt");
				}
			} break;*/
			/*case 'S': {
				International aInter(pApp->GetAppInternational());
				LanguageType eLang=aInter.GetLanguage();
				if (eLang!=LANGUAGE_ENGLISH) eLang=LANGUAGE_ENGLISH;
				else eLang=LANGUAGE_GERMAN;
				pApp->SetAppInternational(aInter);
				SdrEngineDefaults::LanguageHasChanged();
				WriteStatus("Sprache umgestellt");
			} break;*/
			case 'y': {
				pView->SetMarkHdlHidden(!pView->IsMarkHdlHidden());
				String aStr("MarkHdlHidden-Mode ");
				if (pView->IsMarkHdlHidden()) aStr+="eingeschaltet";
				else aStr+="ausgeschaltet";
				WriteStatus(aStr);
			} break;
			case 'M': {
				pView->SetMarkedHitMovesAlways(!pView->IsMarkedHitMovesAlways());
				String aStr("MarkedHitMovesAlways ");
				if (pView->IsMarkedHitMovesAlways()) aStr+="eingeschaltet";
				else aStr+="ausgeschaltet";
				WriteStatus(aStr);
			} break;
			case 'o': {
				SdrPageView* pPV=pView->HitPage(aMPos);
				if (pPV!=NULL) {
					pPV->SetPageOrigin(aMPos-pPV->GetOffset());
				} else {
					pView->BegSetPageOrg(aMPos,NULL);
				}
			} break;
			//case 'g': pView->GroupMarked();      WriteStatus(); break;
			//case 'z': pView->UnGroupMarked();    WriteStatus(); break;
			//case 'c': pView->EnterMarkedGroup(); WriteStatus(); break;
			//case '.': pView->LeaveOneGroup();    WriteStatus(); break;
			case 'q': {
				USHORT nSiz=pView->GetMarkHdlSizePixel()-2;
				pView->SetMarkHdlSizePixel(nSiz);
				String aStr("MarkHandles auf ");
				aStr+=pView->GetMarkHdlSizePixel();
				aStr+=" Pixel gestellt";
				WriteStatus(aStr); break;
			} break;
			case 'Q': {
				USHORT nSiz=pView->GetMarkHdlSizePixel()+2;
				pView->SetMarkHdlSizePixel(nSiz);
				String aStr("MarkHandles auf ");
				aStr+=pView->GetMarkHdlSizePixel();
				aStr+=" Pixel gestellt";
				WriteStatus(aStr); break;
			} break;
			/*case 'K': {
				if (pView->IsConvertToPathObjPossible(FALSE)) {
					pView->ConvertMarkedToPathObj(FALSE);
					WriteStatus();
				} else InfoBox(NULL,"Konvertierung in Bezierkurve(n) nicht moeglich!").Execute();
			} break;*/
			case 'p': {
				pView->SetPlusHandlesAlwaysVisible(!pView->IsPlusHandlesAlwaysVisible());
			} break;
			/*case 'P': {
				if (pView->IsConvertToPolyObjPossible(FALSE)) {
					pView->ConvertMarkedToPolyObj(FALSE);
					WriteStatus();
				} else InfoBox(NULL,"Konvertierung in Polygon(e) nicht moeglich!").Execute();
			} break;*/
			case 'r': {
				Invalidate();
				WriteStatus("Redraw erzwungen");
				//pView->BegEncirclement(aMPos);
				//WriteStatus("Sinnloses Aufziehen eines animierten Rahmens");
			} break;
			default: bMyKey=FALSE;
		}
	}
	if (!bMyKey) MyScrParent::KeyInput(rKEvt);
	ForceCapture(bLftMerk);
	ForcePointer();
}

void __EXPORT MyScr::RequestHelp(const HelpEvent& rHEvt)
{
/*    HelpWin* pHelp=new HelpWin(this);
	pHelp->Show();*/
}

void __EXPORT MyScr::Paint(const Rectangle& rRect)
{
//#ifndef SD_PAINT
	pView->InitRedraw(this,rRect);
//#else
//    Link aLink(LINK(this,MyScr,PaintHdl));
//    USHORT nAnz=pView->GetPageViewCount();
//    for (USHORT i=0; i<nAnz; i++) {
//        SdrPageView* pPV=pView->GetPageViewPvNum(i);
//        pPV->DrawPaper(*this);
//        pPV->DrawBorder(*this);
//        pPV->DrawGrid(*this);
//        pPV->RedrawOneLayer(0,rRect,this,0,&aLink);
//    }
//#endif
}

void MyScr::ShowLayers()
{
/*    WriteHome(Point(2,2));
	USHORT nAnz,i;

	nAnz=pDraw->GetLayerAdmin().GetLayerCount();
	Writeln(String(nAnz)+String(" Layer:"));
	for (i=0; i<nAnz; i++) {
		String aStr;
		const SdrLayer* pL=pDraw->GetLayerAdmin().GetLayer(i);
		aStr+="    ID="; aStr+=USHORT(pL->GetID());
		aStr+=" Name="; aStr+=pL->GetName();
		Writeln(aStr);
	}

	nAnz=pDraw->GetLayerAdmin().GetLayerSetCount();
	Writeln(String(nAnz)+String(" Layersets:"));
	for (i=0; i<nAnz; i++) {
		String aStr;
		const SdrLayerSet* pS=pDraw->GetLayerAdmin().GetLayerSet(i);
		aStr+="    Name="; aStr+=pS->GetName();
		USHORT nMemb=pS->GetMemberCount();
		USHORT nExcl=pS->GetExcludedCount();
		aStr+=" (";
		aStr+=nMemb;
		if (nExcl!=0) {
			aStr+='/';
			aStr+=nExcl;
		}
		aStr+=')';
		Writeln(aStr);
		for (USHORT k=0; k<2; k++) {
			USHORT j;
			USHORT nMax;
			if (k==0) nMax=nMemb; else nMax=nExcl;
			for (j=0; j<nMax; j++) {
				BYTE nID;
				if (k==0) {
					nID=pS->GetMemberID(j);
					aStr="        + ";
				} else {
					nID=pS->GetExcludedID(j);
					aStr="        - ";
				}
				const SdrLayer* pL=pDraw->GetLayerAdmin().GetLayerPerID(nID);
				aStr+=USHORT(nID);
				aStr+='-';
				if (pL!=NULL) aStr+=pL->GetName();
				else aStr+="<nicht definiert>";
				Writeln(aStr);
			}
		}
	}
  */
}

void MyScr::ForcePointer()
{
	Point aPnt(PixelToLogic(ScreenToOutputPixel(Pointer::GetPosPixel())));
	USHORT nHitLog=USHORT(PixelToLogic(Size(nHitPix,0)).Width());
	SetPointer(pView->GetPreferedPointer(aPnt,this,aLastMEvt.GetModifier(),bLftMerk));
//    if (!pView->IsAction()) {
//        SetPointer(pView->GetPreferedPointer());
//    }
}

void MyScr::ForceCapture(FASTBOOL bLeft)
{
	bLftMerk=bLeft;
	if (bLeft && pView->IsAction()) CaptureMouse(); else ReleaseMouse();
}

void MyScr::WriteStatus(const String& aStr)
{
	pMyWin->WriteStatus(aStr);
}

void MyScr::WriteFlagStatus(const String& aStr, BOOL bFlag)
{
	String aStr2(aStr);
	if (bFlag) aStr2+=" eingeschaltet";
	else aStr2+=" ausgeschaltet";
	pMyWin->WriteStatus(aStr2);
}

XubString MyScr::GetValStr(long a) const
{
/*    BOOL bNeg=a<0;
	if (bNeg) a=-a;
	String aStr(a);
	if (nMap==100) {
		while (aStr.Len()<3) aStr.Insert('0',0);
		aStr.Insert('.',aStr.Len()-2);
	} else if (nMap==10) {
		while (aStr.Len()<2) aStr.Insert('0',0);
		aStr.Insert('.',aStr.Len()-1);
	} else if (nMap==1) {
		while (aStr.Len()<1) aStr.Insert('0',0);
		//aStr.Insert('.',aStr.Len()-0);
	} else {
		a*=100;
		a/=nMap;
		aStr=String(a);
		while (aStr.Len()<3) aStr.Insert('0',0);
		aStr.Insert('.',aStr.Len()-2);
		//aStr="???";
	}*/
	XubString aStr;
	pDraw->TakeMetricStr(a,aStr,TRUE);
	return aStr;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// MyWin
////////////////////////////////////////////////////////////////////////////////////////////////////
void MyWin::InitVals()
{
	pBar=NULL;
	pBox=NULL;
	pWin=NULL;
	p1stW=NULL;
	SetIcon(Icon(ResId(ICON_DrawDemo)));
	SetPen(Pen(Color(COL_RED)));
	SetFillInBrush(Brush(Color(COL_LIGHTCYAN)));
	SetBackgroundBrush(Brush(Color(COL_LIGHTGRAY)));
}

void MyWin::InitBoxBar()
{
	pBox=NULL;
	pBar=NULL;
#ifdef MoreMenues
	pMenu=new MenuBar(ResId(MENU_MAIN));
	//SetMenu(*pMenu);
	HMENU hMen=Sysdepen::GethMenu(*pMenu);
	HWND  hWin=Sysdepen::GethWnd(*this);
	SetMenu(hWin,hMen);

	//pMenu->PushSelectHdl(LINK(GetDrawWin(),MyScr,MenuHdl));
	pMenu->PushActivateHdl(LINK(this,MyWin,SetMenuStatusHdl));
	pMenu->PushDeactivateHdl(LINK(this,MyWin,EnableMenuHdl));
#endif
	pBox=new MyToolBox(this,WB_BORDER | WB_SVLOOK | WB_DOCKABLE | WB_MOVEABLE | WB_SIZEABLE | WB_SCROLL);
	pBar=new StatusBar(this,WB_BORDER | WB_SVLOOK);
	ImageList aIL(ResId(IMGL_Buttons));

	USHORT i=1;
	Color aGray(0xC000,0xC000,0xC000);
	pBox->InsertItem(FUNC_EditArrw,aIL.GetImage(FUNC_EditArrw));
	pBox->InsertItem(FUNC_EditFram,aIL.GetImage(FUNC_EditFram));
	pBox->InsertItem(FUNC_EditGlue,aIL.GetImage(FUNC_EditGlue));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_EditRota,aIL.GetImage(FUNC_EditRota));
	pBox->InsertItem(FUNC_EditMirr,aIL.GetImage(FUNC_EditMirr));
	pBox->InsertItem(FUNC_EditShea,aIL.GetImage(FUNC_EditShea));
	pBox->InsertItem(FUNC_EditCrok,aIL.GetImage(FUNC_EditCrok));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_EditFrnt,aIL.GetImage(FUNC_EditFrnt));
	pBox->InsertItem(FUNC_EditBack,aIL.GetImage(FUNC_EditBack));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_CreaRect,aIL.GetImage(FUNC_CreaRect));
	pBox->InsertItem(FUNC_CreaText,aIL.GetImage(FUNC_CreaText));
	pBox->InsertItem(FUNC_CreaPoly,aIL.GetImage(FUNC_CreaPoly));
	pBox->InsertItem(FUNC_CreaCirc,aIL.GetImage(FUNC_CreaCirc));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_Text2Crv,aIL.GetImage(FUNC_Text2Crv));
	pBox->InsertItem(FUNC_Shadow  ,aIL.GetImage(FUNC_Shadow  ));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_FillRt  ,aIL.GetImage(FUNC_FillRt  ));
	pBox->InsertItem(FUNC_FillGn  ,aIL.GetImage(FUNC_FillGn  ));
	pBox->InsertItem(FUNC_FillBl  ,aIL.GetImage(FUNC_FillBl  ));
	pBox->InsertItem(FUNC_FillGrad,aIL.GetImage(FUNC_FillGrad));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_LineRt  ,aIL.GetImage(FUNC_LineRt  ));
	pBox->InsertItem(FUNC_LineGn  ,aIL.GetImage(FUNC_LineGn  ));
	pBox->InsertItem(FUNC_LineBl  ,aIL.GetImage(FUNC_LineBl  ));
	pBox->InsertItem(FUNC_LineW1  ,aIL.GetImage(FUNC_LineW1  ));
	pBox->InsertItem(FUNC_LineW2  ,aIL.GetImage(FUNC_LineW2  ));
	pBox->InsertItem(FUNC_LineW3  ,aIL.GetImage(FUNC_LineW3  ));
	pBox->InsertItem(FUNC_LinePatt,aIL.GetImage(FUNC_LinePatt));
	pBox->InsertSeparator();
	pBox->InsertItem(FUNC_TextSw  ,aIL.GetImage(FUNC_TextSw  ));
	pBox->InsertItem(FUNC_TextRt  ,aIL.GetImage(FUNC_TextRt  ));
	pBox->InsertItem(FUNC_TextGn  ,aIL.GetImage(FUNC_TextGn  ));
	pBox->InsertItem(FUNC_TextBl  ,aIL.GetImage(FUNC_TextBl  ));
	pBox->InsertItem(FUNC_TextPl  ,aIL.GetImage(FUNC_TextPl  ));
	pBox->InsertItem(FUNC_TextMi  ,aIL.GetImage(FUNC_TextMi  ));

	pBox->SetSelectHdl(LINK(this,MyWin,ToolBoxClickHdl));
	pBox->SetDoubleClickHdl(LINK(this,MyWin,ToolBoxClickHdl));

	pBox->SetPosPixel(Point(0,0));
	aBoxSize=pBox->GetSizePixel();

	pBox->Show();

	pBar->SetText("...");
	pBar->InsertItem(1,2+GetTextSize("Rect").Width());
	pBar->InsertItem(2,2+GetTextSize('*').Width());
	pBar->InsertItem(3,2+GetTextSize("Standard").Width());
	pBar->InsertItem(4,2+GetTextSize("P 000.00 000.00").Width());
	pBar->InsertItem(5,2+GetTextSize("G 000.00 000.00").Width());
	//pBar->InsertItem(2,2+GetTextSize("24-08-1994").Width());
	//pBar->InsertItem(3,2+GetTextSize("22:30:00").Width());
	pBar->Show();

}

MyWin::MyWin(MyScr* p1stView, BOOL bNeuView, BOOL bNeuDoc, BOOL bLoad, const String& rFNam):
	WorkWindow(NULL,WinBits((p1stView==NULL?WB_APP:0) | WB_STDWORK /*| WB_CLIPCHILDREN*/))
{
	pWin=NULL;
	pMenu=NULL;
	SetText("SV-DrawingEngine (Joe M.)");
	SetPalette(OutputDevice::GetDitherPalette());
	if (p1stView==NULL) { bNeuView=TRUE; bNeuDoc=TRUE; }
	if (bNeuDoc) bNeuView=TRUE;
	InitVals();
	if (p1stView!=NULL && !bNeuView) p1stW=p1stView->pMyWin;
	if (p1stView==NULL || bNeuView) InitBoxBar(); // Buttons nur fuer das erste Win der View
	pWin=new MyScr(this,p1stView,bNeuView,bNeuDoc,bLoad,rFNam);
	WriteStatus();
#ifdef MoreMenues
	if (p1stView==NULL || bNeuView) pMenu->PushSelectHdl(LINK(GetDrawWin(),MyScr,MenuHdl));
#endif
	if (p1stView==NULL) SetPosPixel(Point(2,2));
	SetOutputSizePixel(Size(210+136,297+50));
	Resize();
#ifdef _JOEDEBUG
	DebWriteln("MyWin::MyWin()");
	DebWriteln(String("  pMenu =")+GetStr(pMenu));
	DebWriteln(String("  pMyScr=")+GetStr(pWin));
	DebWriteln(String("  MyWin= ")+GetStr(this));
	DebWriteln(String("  pView =")+GetStr(pWin->pView));
#endif
}

MyWin::~MyWin()
{
	if (pWin!=NULL)  { delete pWin;  pWin=NULL;  }
	if (pBox!=NULL)  { delete pBox;  pBox=NULL;  }
	if (pBar!=NULL)  { delete pBar;  pBar=NULL;  }
	if (pMenu!=NULL) { delete pMenu; pMenu=NULL; }
}

void MyWin::AddNewWin()
{
	MyWin* pNewWin=new MyWin(pWin,FALSE,FALSE,FALSE,String());
	pNewWin->SetText("Weiteres Win der DrawingEngine");
	pNewWin->Show();
}

void MyWin::AddNewView()
{
	MyWin* pNewWin=new MyWin(pWin,TRUE,FALSE,FALSE,String());
	pNewWin->SetText("Weitere View der DrawingEngine");
	pNewWin->Show();
}

void MyWin::AddNewDoc(BOOL bLoad, const String& rFNam)
{
	MyWin* pNewWin=new MyWin(pWin,TRUE,TRUE,bLoad,rFNam);
	pNewWin->SetText("Weiteres Doc der DrawingEngine");
	pNewWin->Show();
}

String MyWin::Zero2(const String& rStr)
{
	String aStr(rStr);
	if (aStr.Len()<2) aStr.Insert('0',0);
	return aStr;
}

void __EXPORT MyWin::RequestHelp(const HelpEvent& rHEvt)
{
	pWin->RequestHelp(rHEvt);
}

void __EXPORT MyWin::KeyInput(const KeyEvent& rKEvt)
{
	WorkWindow::KeyInput(rKEvt);
	pWin->KeyInput(rKEvt);
}

void MyWin::WriteStatus(const String& rStr)
{
	if (p1stW!=NULL) p1stW->WriteStatus(rStr);
	if (pBar==NULL) return;
	String aStr;
	SdrPageView* pPV=pWin->pView->GetPageViewPvNum(0);
	if (pPV!=NULL) {
		aStr=pPV->GetActualPathName();
		if (aStr.Len()>0) aStr+=" - ";
	}
	String aStr1(rStr);
	if (aStr1.Len()==0) {
		aStr1=pWin->pView->GetStatusText();
		if (pWin->pView->HasMarkedObj() && !pWin->pView->IsAction()) {
			/*long nWink=pWin->pView->GetMarkedObjRotate();
			aStr1+=" / ";
			long n=nWink;
			BOOL bNeg=n<0;
			if (bNeg) n=-n;
			String aValStr(n);
			while (aValStr.Len()<3) aValStr.Insert('0',0);
			aValStr.Insert('.',aValStr.Len()-2);
			if (bNeg) aValStr.Insert('-',0);
			aValStr+='';
			aStr1+=aValStr;*/
		}
		if (pWin->pView->GetMarkedObjCount()==1) {
			/*Point aAP=pWin->pView->GetMarkList().GetMark(0)->GetObj()->GetAnchorPos();
			aStr1+=" Anker (";
			aStr1+=pWin->GetValStr(aAP.X());
			aStr1+=',';
			aStr1+=pWin->GetValStr(aAP.Y());
			aStr1+=')';*/
		}
	}
	aStr+=aStr1;
	pBar->SetText(aStr);
	USHORT i;
	USHORT nSwt=0;
	if (pWin->pView->IsEditMode()) {
		pBar->SetItemText(1,"Edit");
	} else if (pWin->pView->IsGluePointEditMode()) {
		pBar->SetItemText(1,"Glue");
	} else if (pWin->pView->IsCreateMode()) {
		UINT16 nIdent;
		UINT32 nInvent;
		pWin->pView->TakeCurrentObj(nIdent,nInvent);
		String aStr("???");
		switch (nIdent) {
			case OBJ_NONE       : if (pWin->pView->GetCurrentLibObj()!=NULL) {
									  aStr="Lib";
								  } else {
									  aStr="Nix";
								  } break;
			case OBJ_RECT       : aStr="Rect";  nSwt=FUNC_CreaRect; break;
			case OBJ_CAPTION    : aStr="Capt";  nSwt=FUNC_CreaRect; break;
			case OBJ_EDGE       : aStr="Edge";  nSwt=FUNC_CreaPoly; break;
			case OBJ_POLY       : aStr="Poly";  nSwt=FUNC_CreaPoly; break;
			case OBJ_LINE       : aStr="Line";  nSwt=FUNC_CreaPoly; break;
			case OBJ_PLIN       : aStr="PLin";  nSwt=FUNC_CreaPoly; break;
			case OBJ_PATHLINE   : aStr="BezL";  nSwt=FUNC_CreaPoly; break;
			case OBJ_PATHFILL   : aStr="BezF";  nSwt=FUNC_CreaPoly; break;
			case OBJ_FREELINE   : aStr="FreL";  nSwt=FUNC_CreaPoly; break;
			case OBJ_FREEFILL   : aStr="FreF";  nSwt=FUNC_CreaPoly; break;
			case OBJ_SPLNLINE   : aStr="SplL";  nSwt=FUNC_CreaPoly; break;
			case OBJ_SPLNFILL   : aStr="SplF";  nSwt=FUNC_CreaPoly; break;
			case OBJ_CIRC       : aStr="Circ";  nSwt=FUNC_CreaCirc; break;
			case OBJ_CARC       : aStr="CArc";  nSwt=FUNC_CreaCirc; break;
			case OBJ_SECT       : aStr="Sect";  nSwt=FUNC_CreaCirc; break;
			case OBJ_CCUT       : aStr="CCut";  nSwt=FUNC_CreaCirc; break;
			case OBJ_TEXT       : aStr="Text";  nSwt=FUNC_CreaText; break;
			case OBJ_TEXTEXT    : aStr="XTxt";  nSwt=FUNC_CreaText; break;
			case OBJ_TITLETEXT  : aStr="Titl";  nSwt=FUNC_CreaText; break;
			case OBJ_OUTLINETEXT: aStr="Outl";  nSwt=FUNC_CreaText; break;
			case OBJ_MEASURE    : aStr="Mass";  nSwt=FUNC_CreaText; break;
		}
		pBar->SetItemText(1,aStr);
	}
	for (i=FUNC_CreaRect; i<FUNC_CreaRect+4; i++) {
		pBox->CheckItem(i,i==nSwt);
	}
	pBox->CheckItem(FUNC_EditArrw,pWin->pView->IsEditMode());
	pBox->CheckItem(FUNC_EditFram,pWin->pView->IsFrameHandles());
	pBox->CheckItem(FUNC_EditGlue,pWin->pView->IsGluePointEditMode());

	if (pWin->pDraw->IsChanged()) {
		pBar->SetItemText(2,'*');
	} else {
		pBar->SetItemText(2,' ');
	}

	{
		String s(pWin->pView->GetActiveLayer());
		pBar->SetItemText(3,s);
	}

	BOOL bEnab=pWin->pView->HasMarkedObj();
	pBox->EnableItem(FUNC_EditRota,pWin->pView->IsRotateAllowed(TRUE));
	pBox->EnableItem(FUNC_EditMirr,pWin->pView->IsMirrorAllowed(TRUE,TRUE));
	pBox->EnableItem(FUNC_EditShea,pWin->pView->IsShearAllowed() || pWin->pView->IsDistortAllowed(TRUE) || pWin->pView->IsDistortAllowed(FALSE));
	pBox->EnableItem(FUNC_EditCrok,pWin->pView->IsCrookAllowed(TRUE) || pWin->pView->IsCrookAllowed(FALSE));
	nSwt=0;
	if (bEnab) {
		switch (pWin->pView->GetDragMode()) {
			case SDRDRAG_ROTATE: nSwt=FUNC_EditRota; break;
			case SDRDRAG_MIRROR: nSwt=FUNC_EditMirr; break;
			case SDRDRAG_SHEAR : nSwt=FUNC_EditShea; break;
			case SDRDRAG_CROOK : nSwt=FUNC_EditCrok; break;
		}
	}
	for (i=FUNC_EditRota; i<FUNC_EditRota+4; i++) {
		pBox->CheckItem(i,i==nSwt);
	}
	pBox->CheckItem(FUNC_EditFrnt,pWin->pView->HasMarkedObj() && !pWin->pView->IsToTopPossible());
	pBox->EnableItem(FUNC_EditFrnt,pWin->pView->IsToTopPossible());
	pBox->CheckItem(FUNC_EditBack,pWin->pView->HasMarkedObj() && !pWin->pView->IsToBtmPossible());
	pBox->EnableItem(FUNC_EditBack,pWin->pView->IsToBtmPossible());

	USHORT nFillCol=0x1000,nFillPat=0x1000,nLineCol=0x1000,nLineWdt=0x1000,nTextCol=0x1000;
	/*if (pWin->pView->HasMarkedObj())*/ {
		FASTBOOL bMarked=pWin->pView->HasMarkedObj();
		SfxItemSet aSet(pWin->pView->GetAttributes());
//        if (pWin->aItemBrowser.IsVisible()) pWin->aItemBrowser.SetAttributes(&aSet);
		SfxItemState eState;
		eState=aSet.GetItemState(SDRATTR_SHADOW);
		//if (eState==SFX_ITEM_SET) {
			BOOL bShad=((SdrShadowItem&)(aSet.Get(SDRATTR_SHADOW))).GetValue();
			pBox->CheckItem(FUNC_Shadow,bShad);
		//} else pBox->CheckItem(FUNC_Shadow,FALSE);
		if (eState==SFX_ITEM_DONTCARE) pBox->SetItemState(FUNC_Shadow,STATE_DONTKNOW);
		pBox->EnableItem(FUNC_Shadow,!bMarked || eState!=SFX_ITEM_DEFAULT);

		eState=aSet.GetItemState(XATTR_LINESTYLE);
		//if (eState==SFX_ITEM_SET) {
			BOOL bPatt=((XLineStyleItem&)(aSet.Get(XATTR_LINESTYLE))).GetValue()==XLINE_DASH;
			pBox->CheckItem(FUNC_LinePatt,bPatt);
		//} else pBox->CheckItem(FUNC_LinePatt,FALSE);
		if (eState==SFX_ITEM_DONTCARE) pBox->SetItemState(FUNC_LinePatt,STATE_DONTKNOW);
		pBox->EnableItem(FUNC_LinePatt,!bMarked || eState!=SFX_ITEM_DEFAULT);

		eState=aSet.GetItemState(XATTR_FORMTXTSTYLE);
		//if (eState==SFX_ITEM_SET) {
			BOOL bT2C=((XFormTextStyleItem&)(aSet.Get(XATTR_FORMTXTSTYLE))).GetValue()!=XFT_NONE;
			pBox->CheckItem(FUNC_Text2Crv,bT2C);
		//} else pBox->CheckItem(FUNC_Text2Crv,FALSE);
		if (eState==SFX_ITEM_DONTCARE) pBox->SetItemState(FUNC_Text2Crv,STATE_DONTKNOW);
		pBox->EnableItem(FUNC_Text2Crv,!bMarked || eState!=SFX_ITEM_DEFAULT);

		eState=aSet.GetItemState(XATTR_FILLSTYLE);
		if (eState==SFX_ITEM_SET || eState==SFX_ITEM_DEFAULT) {
			XFillStyle eStyle=((XFillStyleItem&)(aSet.Get(XATTR_FILLSTYLE))).GetValue();
			if (eStyle==XFILL_SOLID) {
				if (aSet.GetItemState(XATTR_FILLCOLOR)==SFX_ITEM_SET) {
					Color aCol=((XFillColorItem&)(aSet.Get(XATTR_FILLCOLOR))).GetValue();
					if (aCol==Color(COL_LIGHTRED  )) nFillCol=0;
					if (aCol==Color(COL_LIGHTGREEN)) nFillCol=1;
					if (aCol==Color(COL_LIGHTBLUE )) nFillCol=2;
				}
			}
			if (eStyle==XFILL_GRADIENT || eStyle==XFILL_HATCH || eStyle==XFILL_BITMAP) {
				pBox->CheckItem(FUNC_FillGrad,TRUE);
			} else pBox->CheckItem(FUNC_FillGrad,FALSE);
			//XFILL_NONE,XFILL_HATCH,XFILL_BITMAP
		}
		pBox->EnableItem(FUNC_FillRt,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_FillGn,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_FillBl,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_FillGrad,!bMarked || eState!=SFX_ITEM_DEFAULT);

		eState=aSet.GetItemState(XATTR_LINECOLOR);
		if (eState==SFX_ITEM_SET || eState==SFX_ITEM_DEFAULT) {
			Color aCol=((XLineColorItem&)(aSet.Get(XATTR_LINECOLOR))).GetValue();
			if (aCol==Color(COL_RED  )) nLineCol=0;
			if (aCol==Color(COL_GREEN)) nLineCol=1;
			if (aCol==Color(COL_BLUE )) nLineCol=2;
		}
		pBox->EnableItem(FUNC_LineRt,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_LineGn,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_LineBl,!bMarked || eState!=SFX_ITEM_DEFAULT);

		eState=aSet.GetItemState(XATTR_LINEWIDTH);
		if (eState==SFX_ITEM_SET || eState==SFX_ITEM_DEFAULT) {
			INT32 nWdt=((XLineWidthItem&)(aSet.Get(XATTR_LINEWIDTH))).GetValue();
			if (nWdt==0*nMap) nLineWdt=0;
			if (nWdt==3*nMap) nLineWdt=1;
			if (nWdt==7*nMap) nLineWdt=2;
		}
		pBox->EnableItem(FUNC_LineW1,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_LineW2,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_LineW3,!bMarked || eState!=SFX_ITEM_DEFAULT);

		eState=aSet.GetItemState(EE_CHAR_COLOR);
		if (eState==SFX_ITEM_SET || eState==SFX_ITEM_DEFAULT) {
			Color aCol=((SvxColorItem&)(aSet.Get(EE_CHAR_COLOR))).GetValue();
			if (aCol==Color(COL_BLACK)) nTextCol=0;
			if (aCol==Color(COL_RED  )) nTextCol=1;
			if (aCol==Color(COL_GREEN)) nTextCol=2;
			if (aCol==Color(COL_BLUE )) nTextCol=3;
		}
		pBox->EnableItem(FUNC_TextSw,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_TextRt,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_TextGn,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_TextBl,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_TextPl,!bMarked || eState!=SFX_ITEM_DEFAULT);
		pBox->EnableItem(FUNC_TextMi,!bMarked || eState!=SFX_ITEM_DEFAULT);
	}
	if (nFillCol!=0x1000) nFillCol+=FUNC_FillRt;
	if (nFillPat!=0x1000) nFillPat+=FUNC_FillP1;
	if (nLineCol!=0x1000) nLineCol+=FUNC_LineRt;
	if (nLineWdt!=0x1000) nLineWdt+=FUNC_LineW1;
//    if (nLinePat!=0x1000) nLineWdt+=FUNC_LinePatt;
	if (nTextCol!=0x1000) nTextCol+=FUNC_TextSw;
	for (i=FUNC_FillRt; i<=FUNC_TextBl; i++) {
		if (i!=FUNC_FillGrad && i!=FUNC_LinePatt) {
			pBox->CheckItem(i,i==nFillCol || i==nFillPat ||
							  i==nLineCol || i==nLineWdt ||
							  i==nTextCol);
		}
	}

	if (pWin->pView->IsAction()) {
		Rectangle aR;
		String aStr;
		pWin->pView->TakeActionRect(aR);
		//TakeDragObjAnchorPos(Point& rPos)
		//aR.SetPos(pWin->pView->GetMoveDragPos());
		DisplayRect(aR);
	} else if (pWin->pView->HasMarked()) {
		DisplayRect(pWin->pView->GetMarkedRect());
	} else {
		Point aPt(pWin->pView->GetSnapPos(pWin->GetLogPos(),NULL));
		DisplayRect(Rectangle(aPt,aPt));
		//pBar->SetItemText(4,String());
		//pBar->SetItemText(5,String());
	}
}

IMPL_LINK(MyWin,SetMenuStatusHdl,Menu*,pMenu)
{
	pWin->pView->SetActualWin(pWin);
//    if (pMenu!=MyWin::pMenu) return FALSE; // sonst ist es nicht das Hauptmenu
	PopupMenu* pPop=pMenu->GetPopupMenu(MENU_EDIT);
	if (pPop==NULL) return FALSE; // sonst ist es nicht das Hauptmenu
	String aMsg,aStr;
	ULONG nMarkCnt=pWin->pView->GetMarkedObjCount();
	FASTBOOL bHasMark=nMarkCnt!=0;
	ULONG nObjCnt=0;
	USHORT nPvCnt=pWin->pView->GetPageViewCount();
	for (USHORT nPvNum=0; nPvNum<nPvCnt; nPvNum++) {
		nObjCnt+=pWin->pView->GetPageViewPvNum(nPvNum)->GetObjList()->GetObjCount();
	}
	FASTBOOL bHasObjs=nObjCnt!=0;


	pPop->EnableItem(MENU_UNDO,pWin->pUndo->Count()!=0);
	aMsg.Erase(); if (pWin->pUndo->Count()!=0) aMsg=pWin->pUndo->Top()->GetComment();
	aStr=pPop->GetItemText(MENU_UNDO);
	aStr.Erase(aStr.Search(':')+1); aStr+=' '; aStr+=aMsg;
	pPop->SetItemText(MENU_UNDO,aStr);

	pPop->EnableItem(MENU_REDO,pWin->pRedo->Count()!=0);
	aMsg.Erase(); if (pWin->pRedo->Count()!=0) aMsg=pWin->pRedo->Top()->GetComment();
	aStr=pPop->GetItemText(MENU_REDO);
	aStr.Erase(aStr.Search(':')+1); aStr+=' '; aStr+=aMsg;
	pPop->SetItemText(MENU_REDO,aStr);

	pPop->EnableItem(MENU_REPEAT,FALSE);
	if (pWin->pUndo->Count()!=0) {
		if (pWin->pUndo->Top()->CanRepeat(*pWin->pView)) pPop->EnableItem(MENU_REPEAT,TRUE);
	}
	aMsg.Erase(); if (pWin->pUndo->Count()!=0) aMsg=pWin->pUndo->Top()->GetRepeatComment(*pWin->pView);
	aStr=pPop->GetItemText(MENU_REPEAT);
	aStr.Erase(aStr.Search(':')+1); aStr+=' '; aStr+=aMsg;
	pPop->SetItemText(MENU_REPEAT,aStr);

	pPop->EnableItem(MENU_CUT,bHasMark);
	pPop->EnableItem(MENU_YANK,bHasMark);
	pPop->EnableItem(MENU_PASTE,pWin->pView->IsClipboardFormatSupported());
	pPop->EnableItem(MENU_PASTEAS,pWin->pView->IsClipboardFormatSupported());

	PopupMenu* pPaste=pPop->GetPopupMenu(MENU_PASTEAS);
	pPaste->EnableItem(MENU_PASTEASMTF,Clipboard::HasFormat(FORMAT_GDIMETAFILE) && pWin->pView->IsExchangeFormatSupported(FORMAT_GDIMETAFILE));
	pPaste->EnableItem(MENU_PASTEASBMP,Clipboard::HasFormat(FORMAT_BITMAP     ) && pWin->pView->IsExchangeFormatSupported(FORMAT_BITMAP     ));
	pPaste->EnableItem(MENU_PASTEASRTF,Clipboard::HasFormat(FORMAT_RTF        ) && pWin->pView->IsExchangeFormatSupported(FORMAT_RTF        ));
	pPaste->EnableItem(MENU_PASTEASSTR,Clipboard::HasFormat(FORMAT_STRING     ) && pWin->pView->IsExchangeFormatSupported(FORMAT_STRING     ));
	while (pPaste->GetItemCount()>4) pPaste->RemoveItem(4);
	pPaste->InsertSeparator();
	USHORT nAnz=Clipboard::GetFormatCount();
	for (USHORT nNum=0; nNum<nAnz; nNum++) {
		ULONG nForm=Clipboard::GetFormat(nNum);
		String aName(Clipboard::GetFormatName(nForm));
		aName+=" ("; aName+=nForm; aName+=')';
		pPaste->InsertItem(MENU_PASTEASETC+nNum,aName);
		pPaste->EnableItem(MENU_PASTEASETC+nNum,pWin->pView->IsExchangeFormatSupported(nForm));
	}
	FASTBOOL bCanDelete=pWin->pView->IsDeleteMarkedPossible();
	FASTBOOL bCanMark=pWin->pView->IsMarkPossible();
	FASTBOOL bIsMarkAll=pWin->pView->IsAllMarked();
	FASTBOOL bCanPrevNext=pWin->pView->IsAllMarkPrevNextPossible();

	pPop->EnableItem(MENU_DELETE,bCanDelete);
	pPop->EnableItem(MENU_MARKALL,bCanMark);
	pPop->CheckItem(MENU_MARKALL,bIsMarkAll);
	pPop->EnableItem(MENU_MARKPREV,bCanPrevNext);
	pPop->EnableItem(MENU_MARKNEXT,bCanPrevNext);

	PopupMenu* pChange=pMenu->GetPopupMenu(MENU_CHANGE);
	pPop=pChange->GetPopupMenu(MENU_PAGE);
	pPop->EnableItem(MENU_PAGEDEL,nPvCnt!=0);
//    pPop->EnableItem(MENU_PAGEMSTR
//MENU_LAYERINS
//MENU_LAYERDEL
//MENU_LAYERLCK
//MENU_LAYERVIS
//MENU_LAYERPRN
//MENU_LAYERLST
//MENU_POSSIZE

	pPop=pChange->GetPopupMenu(MENU_MIRROR);
	FASTBOOL bMirrOk=pWin->pView->IsMirrorAllowed(TRUE,TRUE);
	pChange->EnableItem(MENU_MIRROR,bMirrOk);
	pPop->EnableItem(MENU_MIRRVERT,bMirrOk);
	pPop->EnableItem(MENU_MIRRHORZ,bMirrOk);

	pPop=pChange->GetPopupMenu(MENU_POLY);
	FASTBOOL bPolyOk=pWin->pView->HasMarkablePoints();
	FASTBOOL bMrkPnts=pWin->pView->HasMarkedPoints();
	FASTBOOL bSetSmtOk=pWin->pView->IsSetMarkedPointsSmoothPossible();
	FASTBOOL bSetSegOk=pWin->pView->IsSetMarkedSegmentsKindPossible();
	pChange->EnableItem(MENU_POLY,bPolyOk);
	pPop->EnableItem(MENU_PNTNORM,bSetSmtOk);
	pPop->EnableItem(MENU_PNTSMOO,bSetSmtOk);
	pPop->EnableItem(MENU_PNTSYMM,bSetSmtOk);
	pPop->EnableItem(MENU_SEGLINE,bSetSegOk);
	pPop->EnableItem(MENU_SEGCURV,bSetSegOk);
	pPop->EnableItem(MENU_SEGTOGG,bSetSegOk);
	pPop->CheckItem(MENU_INSPOINT,pWin->pView->IsInsObjPointMode());
	SdrPathSmoothKind eSmooth=pWin->pView->GetMarkedPointsSmooth();
	pPop->CheckItem(MENU_PNTNORM,eSmooth==SDRPATHSMOOTH_ANGULAR);
	pPop->CheckItem(MENU_PNTSMOO,eSmooth==SDRPATHSMOOTH_ASYMMETRIC);
	pPop->CheckItem(MENU_PNTSYMM,eSmooth==SDRPATHSMOOTH_SYMMETRIC);
	SdrPathSegmentKind eKind=pWin->pView->GetMarkedSegmentsKind();
	pPop->CheckItem(MENU_SEGLINE,eKind==SDRPATHSEGMENT_LINE);
	pPop->CheckItem(MENU_SEGCURV,eKind==SDRPATHSEGMENT_CURVE);

	pPop=pChange->GetPopupMenu(MENU_GLUE);
	FASTBOOL bGlueOk=pWin->pView->IsGluePointEditMode();
	FASTBOOL bPercentOk=pWin->pView->IsSetMarkedGluePointsPercentPossible();
	FASTBOOL bEscDirOk =pWin->pView->IsSetMarkedGluePointsEscDirPossible();
	FASTBOOL bAlignOk  =pWin->pView->IsSetMarkedGluePointsAlignPossible();
	TRISTATE nIsPercent=pWin->pView->IsMarkedGluePointsPercent();
	pChange->EnableItem(MENU_GLUE,bGlueOk);
	pPop->CheckItem(MENU_GLUEINSPOINT,pWin->pView->IsInsGluePointMode());
	pPop->EnableItem(MENU_GLUEPERCENT,bPercentOk);
	pPop->EnableItem(MENU_GLUEHLEFT  ,bAlignOk && nIsPercent!=TRUE);
	pPop->EnableItem(MENU_GLUEHCENTER,bAlignOk && nIsPercent!=TRUE);
	pPop->EnableItem(MENU_GLUEHRIGHT ,bAlignOk && nIsPercent!=TRUE);
	pPop->EnableItem(MENU_GLUEVTOP   ,bAlignOk && nIsPercent!=TRUE);
	pPop->EnableItem(MENU_GLUEVCENTER,bAlignOk && nIsPercent!=TRUE);
	pPop->EnableItem(MENU_GLUEVBOTTOM,bAlignOk && nIsPercent!=TRUE);
	pPop->EnableItem(MENU_GLUEESCLEFT  ,bEscDirOk);
	pPop->EnableItem(MENU_GLUEESCRIGHT ,bEscDirOk);
	pPop->EnableItem(MENU_GLUEESCTOP   ,bEscDirOk);
	pPop->EnableItem(MENU_GLUEESCBOTTOM,bEscDirOk);

	pPop->CheckItem(MENU_GLUEPERCENT,bPercentOk && nIsPercent!=FALSE);
	USHORT nHAlign=pWin->pView->GetMarkedGluePointsAlign(FALSE);
	USHORT nVAlign=pWin->pView->GetMarkedGluePointsAlign(TRUE);
	pPop->CheckItem(MENU_GLUEHLEFT  ,bAlignOk && nHAlign==SDRHORZALIGN_LEFT  );
	pPop->CheckItem(MENU_GLUEHCENTER,bAlignOk && nHAlign==SDRHORZALIGN_CENTER);
	pPop->CheckItem(MENU_GLUEHRIGHT ,bAlignOk && nHAlign==SDRHORZALIGN_RIGHT );
	pPop->CheckItem(MENU_GLUEVTOP   ,bAlignOk && nVAlign==SDRVERTALIGN_TOP   );
	pPop->CheckItem(MENU_GLUEVCENTER,bAlignOk && nVAlign==SDRVERTALIGN_CENTER);
	pPop->CheckItem(MENU_GLUEVBOTTOM,bAlignOk && nVAlign==SDRVERTALIGN_BOTTOM);
	pPop->CheckItem(MENU_GLUEESCLEFT  ,bEscDirOk && pWin->pView->IsMarkedGluePointsEscDir(SDRESC_LEFT  )!=FALSE);
	pPop->CheckItem(MENU_GLUEESCRIGHT ,bEscDirOk && pWin->pView->IsMarkedGluePointsEscDir(SDRESC_RIGHT )!=FALSE);
	pPop->CheckItem(MENU_GLUEESCTOP   ,bEscDirOk && pWin->pView->IsMarkedGluePointsEscDir(SDRESC_TOP   )!=FALSE);
	pPop->CheckItem(MENU_GLUEESCBOTTOM,bEscDirOk && pWin->pView->IsMarkedGluePointsEscDir(SDRESC_BOTTOM)!=FALSE);

	pPop=pChange->GetPopupMenu(MENU_CONV);
	FASTBOOL bToPathOk=pWin->pView->IsConvertToPathObjPossible(FALSE);
	FASTBOOL bToPolyOk=pWin->pView->IsConvertToPolyObjPossible(FALSE);
	pChange->EnableItem(MENU_CONV,bToPathOk || bToPolyOk);
	pPop->EnableItem(MENU_CONVBEZR,bToPathOk);
	pPop->EnableItem(MENU_CONVPOLY,bToPolyOk);
//    pPop->EnableItem(MENU_CONVPATH

	pPop=pChange->GetPopupMenu(MENU_ORDER);
	FASTBOOL bToTopOk=pWin->pView->IsToTopPossible() || TRUE;
	FASTBOOL bToBtmOk=pWin->pView->IsToBtmPossible() || TRUE;
	FASTBOOL bReverOk=pWin->pView->IsReverseOrderPossible();
	pChange->EnableItem(MENU_ORDER,bToTopOk || bToBtmOk || bReverOk);
	pPop->EnableItem(MENU_PUTTOTOP,bToTopOk); pPop->CheckItem(MENU_PUTTOTOP,bHasMark && !bToTopOk);
	pPop->EnableItem(MENU_MOVTOTOP,bToTopOk);
	pPop->EnableItem(MENU_FRONTOBJ,bReverOk); // Abfrage ist hier nicht
	pPop->EnableItem(MENU_BEHNDOBJ,bReverOk); // so ganz fein. Geht aber.
	pPop->EnableItem(MENU_MOVTOBTM,bToBtmOk);
	pPop->EnableItem(MENU_PUTTOBTM,bToBtmOk); pPop->CheckItem(MENU_PUTTOBTM,bHasMark && !bToBtmOk);
	pPop->EnableItem(MENU_REVORDER,bReverOk);

	pPop=pChange->GetPopupMenu(MENU_ALIGN);
	bAlignOk=pWin->pView->IsAlignPossible();
	pChange->EnableItem(MENU_ALIGN,bAlignOk);
	pPop->EnableItem(MENU_ALGNHLFT,bAlignOk);
	pPop->EnableItem(MENU_ALGNHCTR,bAlignOk);
	pPop->EnableItem(MENU_ALGNHRGT,bAlignOk);
	pPop->EnableItem(MENU_ALGNVTOP,bAlignOk);
	pPop->EnableItem(MENU_ALGNVCTR,bAlignOk);
	pPop->EnableItem(MENU_ALGNVBTM,bAlignOk);
	pPop->EnableItem(MENU_ALGNCNTR,bAlignOk);

	pPop=pChange;
	pPop->EnableItem(MENU_GROUP,pWin->pView->IsGroupPossible());
	pPop->EnableItem(MENU_UNGROUP,pWin->pView->IsUnGroupPossible());
	//pPop->EnableItem(MENU_GRPNAME
	pPop->EnableItem(MENU_GRPENTER,pWin->pView->IsGroupEnterPossible());
	pPop->EnableItem(MENU_GRPLEAVE,pWin->pView->IsGroupEntered());
	pPop->EnableItem(MENU_COMBINE, pWin->pView->IsCombinePossible(FALSE));
	pPop->EnableItem(MENU_DISMANTL,pWin->pView->IsDismantlePossible(FALSE));
	pPop->EnableItem(MENU_JOIN,    pWin->pView->IsCombinePossible(TRUE));
	pPop->EnableItem(MENU_UNJOIN,  pWin->pView->IsDismantlePossible(TRUE));
	pPop->EnableItem(MENU_MTFIMP,  pWin->pView->IsImportMtfPossible());

	return TRUE;
}

void EnableMenu(Menu* pMenu)
{
	USHORT nAnz=pMenu->GetItemCount();
	while (nAnz>0) {
		nAnz--;
		USHORT nId=pMenu->GetItemId(nAnz);
		pMenu->EnableItem(nId);
		Menu* pSub=pMenu->GetPopupMenu(nId);
		if (pSub!=NULL) EnableMenu(pSub);
	}
}

IMPL_LINK(MyWin,EnableMenuHdl,Menu*,pMenu)
{
	// Bei Deactivate alle Menuepunkte enablen wg der Acceleratoren
	PopupMenu* pPop=pMenu->GetPopupMenu(MENU_EDIT);
	if (pPop==NULL) return FALSE; // sonst ist es nicht das Hauptmenu
	EnableMenu(pMenu);
	return TRUE;
}

void MyWin::DisplayRect(const Rectangle& rRect)
{
	XubString aStr;
	aStr="P "; aStr+=pWin->GetValStr(rRect.Left());
	aStr+=' '; aStr+=pWin->GetValStr(rRect.Top());
	pBar->SetItemText(4,aStr);
	aStr="G "; aStr+=pWin->GetValStr(rRect.Right()-rRect.Left());
	aStr+=' '; aStr+=pWin->GetValStr(rRect.Bottom()-rRect.Top());
	pBar->SetItemText(5,aStr);
}

IMPL_LINK(MyWin,ToolBoxClickHdl,ToolBox*,pBox)
{
	pWin->pView->SetActualWin(pWin);
	UINT16 nIdent;
	UINT32 nInvent;
	pWin->pView->TakeCurrentObj(nIdent,nInvent);
	SfxItemSet aAktAttr(pWin->pView->GetAttributes());
	XFillStyle eAktFillStyle=((XFillStyleItem&)aAktAttr.Get(XATTR_FILLSTYLE)).GetValue();
	USHORT nBtn=pBox->GetCurItemId();
	switch (nBtn) {
		case FUNC_EditArrw: pWin->pView->SetEditMode(); pWin->pView->SetDragMode(SDRDRAG_MOVE); break;
		case FUNC_EditFram: pWin->pView->SetFrameHandles(!pWin->pView->IsFrameHandles()); break;
		case FUNC_EditGlue: pWin->pView->SetGluePointEditMode(!pWin->pView->IsGluePointEditMode()); pWin->pView->SetInsGluePointMode(FALSE); break;
		case FUNC_EditRota: case FUNC_EditMirr: case FUNC_EditShea: case FUNC_EditCrok: {
			SdrDragMode eMode=SDRDRAG_MOVE;
			switch (nBtn) {
				case FUNC_EditRota: eMode=SDRDRAG_ROTATE; break;
				case FUNC_EditMirr: eMode=SDRDRAG_MIRROR; break;
				case FUNC_EditShea: eMode=SDRDRAG_SHEAR;  break;
				case FUNC_EditCrok: eMode=SDRDRAG_CROOK;  break;
			}
			if (eMode==pWin->pView->GetDragMode()) eMode=SDRDRAG_MOVE;
			pWin->pView->SetDragMode(eMode);
		} break;
		case FUNC_EditFrnt: pWin->pView->PutMarkedToTop(); break;
		case FUNC_EditBack: pWin->pView->PutMarkedToBtm(); break;
		case FUNC_CreaRect: case FUNC_CreaText: case FUNC_CreaPoly: case FUNC_CreaCirc: {
			pWin->pView->SetDragMode(SDRDRAG_MOVE);
			pWin->pView->UnmarkAllObj();
			FASTBOOL bCrea0=pWin->pView->IsCreateMode();
			switch (nBtn) {
				case FUNC_CreaRect: {
					USHORT nNew=OBJ_RECT;
					if (bCrea0) {
						if (nIdent==OBJ_RECT) nNew=OBJ_CAPTION;
						if (nIdent==OBJ_CAPTION) nNew=0x4711; // zum Testen von InsertFactory...
					}
					pWin->pView->SetCurrentObj(nNew);
				} break;
				case FUNC_CreaText: {
					USHORT nNew=OBJ_TEXT;
					if (bCrea0) {
						if (nIdent==OBJ_TEXT) nNew=OBJ_OUTLINETEXT;
						if (nIdent==OBJ_OUTLINETEXT) nNew=OBJ_MEASURE;
					}
					pWin->pView->SetCurrentObj(nNew);
				} break;
				case FUNC_CreaPoly: {
					USHORT nNew=OBJ_EDGE;
					if (bCrea0) {
						if (nIdent==OBJ_EDGE)     nNew=OBJ_LINE;
						if (nIdent==OBJ_LINE)     nNew=OBJ_PLIN;
						if (nIdent==OBJ_PLIN)     nNew=OBJ_POLY;
						if (nIdent==OBJ_POLY)     nNew=OBJ_PATHLINE;
						if (nIdent==OBJ_PATHLINE) nNew=OBJ_PATHFILL;
						if (nIdent==OBJ_PATHFILL) nNew=OBJ_FREELINE;
						if (nIdent==OBJ_FREELINE) nNew=OBJ_FREEFILL;
						if (nIdent==OBJ_FREEFILL) nNew=OBJ_SPLNLINE;
						if (nIdent==OBJ_SPLNLINE) nNew=OBJ_SPLNFILL;
					}
					pWin->pView->SetCurrentObj(nNew);
				} break;
				case FUNC_CreaCirc: {
					USHORT nNew=OBJ_CIRC;
					if (bCrea0) {
						if (nIdent==OBJ_CIRC) nNew=OBJ_SECT;
						if (nIdent==OBJ_SECT) nNew=OBJ_CARC;
						if (nIdent==OBJ_CARC) nNew=OBJ_CCUT;
					}
					pWin->pView->SetCurrentObj(nNew);
				} break;
			} // switch
			pWin->pView->SetCreateMode();
		} break;
		case FUNC_Shadow: {
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			if (pBox->IsItemChecked(FUNC_Shadow)) {
				aSet.Put(SdrShadowItem(FALSE));
			} else {
				aSet.Put(SdrShadowItem(TRUE));
				aSet.Put(SdrShadowColorItem("Magenta Schatten",Color(COL_MAGENTA)));
				//aSet.Put(SdrShadowXDistItem(300*nMap));
				//aSet.Put(SdrShadowYDistItem(300*nMap));
				aSet.Put(SdrShadowXDistItem(-6*nMap));
				aSet.Put(SdrShadowYDistItem(-4*nMap));
			}
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_LinePatt: {
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			if (pBox->IsItemChecked(FUNC_LinePatt)) {
				aSet.Put(XLineStyleItem(XLINE_SOLID));
			} else {
				SfxItemSet aAktSet(pWin->pView->GetAttributes());
				INT32 nWdt=((XLineWidthItem&)(aAktSet.Get(XATTR_LINEWIDTH))).GetValue();
				INT32 nLen=2*nWdt;
				if (nLen<2*nMap) nLen=2*nMap;
				aSet.Put(XLineStyleItem(XLINE_DASH));
				aSet.Put(XLineDashItem("Gepunktet",XDash(XDASH_ROUND,1,2*nLen,0,0,nLen)));
			}
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_FillGrad: {
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			if (eAktFillStyle==XFILL_NONE || eAktFillStyle==XFILL_SOLID) {
				aSet.Put(XFillStyleItem(XFILL_GRADIENT));
				aSet.Put(XFillGradientItem("Joe's Farbverlauf",
										   XGradient(Color(COL_WHITE),
													 Color(COL_BLACK),
													 XGRAD_SQUARE,450,50,50,0,100,100)));
			} else if (eAktFillStyle==XFILL_GRADIENT) {
				aSet.Put(XFillStyleItem(XFILL_HATCH));
				aSet.Put(XFillHatchItem("Joe's Schraffur",XHatch(Color(COL_BLACK),XHATCH_SINGLE,2*nMap,300)));
			} else if (eAktFillStyle==XFILL_HATCH) {
				aSet.Put(XFillStyleItem(XFILL_BITMAP));
				//MapMode aMapMerk(pWin->GetMapMode()); // Temporaer auf PixelMap umschalten
				//pWin->SetMapMode(MapMode()); // Temporaer auf PixelMap umschalten
				if (Clipboard::HasFormat(FORMAT_BITMAP)) {
					aSet.Put(XFillBitmapItem("Bitmap aus den Clipboard",Clipboard::PasteBitmap()));
				} else {
					aSet.Put(XFillBitmapItem("Obere linke Fensterecke (20x20)",pWin->GetBitmap(Point(0,0),Size(20*nMap+1,20*nMap+1))));
				}
				//pWin->SetMapMode(aMapMerk);
			} else {
				aSet.Put(XFillStyleItem(XFILL_NONE));
				//aSet.Put(XFillGradientItem("Farbverlauf 2",
				//                           XGradient(Color(COL_LIGHTCYAN),Color(COL_LIGHTGREEN),
				//                                     XGRAD_LINEAR,300)));
				//aSet.Put(XFillGradientItem("Farbverlauf 2",
				//                           XGradient(Color(COL_LIGHTBLUE),Color(COL_LIGHTGREEN),
				//                                     XGRAD_SQUARE,450)));
			}
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_Text2Crv: {
			//BOOL bToContour0=pBox->IsItemChecked(FUNC_Text2Crv);
			//BOOL bToContour1=TRUE;
			XFormTextStyle  eStyle=XFT_ROTATE;
			XFormTextAdjust eAdj=XFT_CENTER;
			/*if (bToContour0)*/ { // Ist schon TextToContour, dann anderen Stil
				SfxItemSet aSet(pWin->pView->GetAttributes());
				XFormTextStyle eStyle0=((XFormTextStyleItem&)(aSet.Get(XATTR_FORMTXTSTYLE))).GetValue();
				if (eStyle0==XFT_NONE) eStyle=XFT_ROTATE; //{ bToContour1=FALSE; } // alle Stile durch, also ausschalten
				else eStyle=XFormTextStyle(USHORT(eStyle0)+1);
			}
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			aSet.Put(XFormTextStyleItem(eStyle));
			aSet.Put(XFormTextAdjustItem(eAdj));
			pWin->pView->SetAttributes(aSet);
			//if (bToContour1!=bToContour0) {
			//    const SdrMarkList& rML=pWin->pView->GetMarkList();
			//    for (USHORT i=0; i<rML.GetMarkCount(); i++) {
			//        rML.GetMark(i)->GetObj()->SetTextToContour(bToContour1);
			//    }
			//}*/
		} break;
		case FUNC_FillRt: case FUNC_FillGn: case FUNC_FillBl: {
			Color aCol;
			XubString aNam;
			switch (nBtn) {
				case FUNC_FillRt: aCol=Color(COL_LIGHTRED);   aNam="Hellrot";  break;
				case FUNC_FillGn: aCol=Color(COL_LIGHTGREEN); aNam="Hellgrn"; break;
				case FUNC_FillBl: aCol=Color(COL_LIGHTBLUE);  aNam="Hellblau"; break;
			}
			XFillColorItem aFill(aNam,aCol);
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			aSet.Put(aFill);
			aSet.Put(XFillStyleItem(XFILL_SOLID));
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_LineRt: case FUNC_LineGn: case FUNC_LineBl: {
			Color aCol;
			XubString aNam;
			switch (nBtn) {
				case FUNC_LineRt: aCol=Color(COL_RED);   aNam="Rot";  break;
				case FUNC_LineGn: aCol=Color(COL_GREEN); aNam="Grn"; break;
				case FUNC_LineBl: aCol=Color(COL_BLUE);  aNam="Blau"; break;
			}
			XLineColorItem aLine(aNam,aCol);
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			aSet.Put(aLine);
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_LineW1: case FUNC_LineW2: case FUNC_LineW3: {
			INT32 nWdt=0;
			switch (nBtn) {
				case FUNC_LineW1: nWdt=0*nMap; break;
				case FUNC_LineW2: nWdt=3*nMap; break;
				case FUNC_LineW3: nWdt=7*nMap; break;
			}
			XLineWidthItem aLine(nWdt);
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			aSet.Put(aLine);
			INT32 nLen=2*nWdt;
			if (nLen<2*nMap) nLen=2*nMap;
			aSet.Put(XLineDashItem("Gepunktet",XDash(XDASH_ROUND,1,2*nLen,0,0,nLen)));
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_TextSw: case FUNC_TextRt: case FUNC_TextGn: case FUNC_TextBl: {
			Color aCol;
			XubString aNam;
			switch (nBtn) {
				case FUNC_TextSw: aCol=Color(COL_BLACK); aNam="Schwarz"; break;
				case FUNC_TextRt: aCol=Color(COL_RED);   aNam="Rot";     break;
				case FUNC_TextGn: aCol=Color(COL_GREEN); aNam="Grn";    break;
				case FUNC_TextBl: aCol=Color(COL_BLUE);  aNam="Blau";    break;
			}
			SvxColorItem aText(aCol,EE_CHAR_COLOR);
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			aSet.Put(aText);
			pWin->pView->SetAttributes(aSet);
		} break;
		case FUNC_TextPl: case FUNC_TextMi: {
			ULONG nHgt=((SvxFontHeightItem&)(pWin->pView->GetAttributes().Get(EE_CHAR_FONTHEIGHT))).GetHeight();
#ifdef JOEDEBUG
DEBOUT(nHgt);
#endif
			if (nBtn==FUNC_TextPl) nHgt+=nMap;
			if (nBtn==FUNC_TextMi) { if (nHgt<2*nMap) nHgt=nMap; else nHgt-=nMap; }
#ifdef JOEDEBUG
DEBOUT(nHgt);
#endif
			//if (nBtn==FUNC_TextPl) nHgt++;
			//if (nBtn==FUNC_TextMi) { if (nHgt<=1) nHgt=1; else nHgt--; }
			SvxFontHeightItem aHgt;
			aHgt.SetHeightValue(nHgt);
			SfxItemSet aSet(pWin->pDraw->GetItemPool());
			aSet.Put(aHgt);
			pWin->pView->SetAttributes(aSet);
		} break;
	}
	WriteStatus();
	return 0;
}

BOOL __EXPORT MyWin::QueryDrop(DropEvent& rDEvt)
{
	return pWin->QueryDrop(rDEvt);
}

BOOL __EXPORT MyWin::Drop(const DropEvent& rDEvt)
{
	return pWin->Drop(rDEvt);
}

void __EXPORT MyWin::GetFocus()
{
	if (pWin!=NULL) pWin->GrabFocus(); // fuer den Cursor beim TextEdit
/*#ifdef JOEDEBUG
	DebWriteln("MyWin::GetFocus()");
	DebWriteln(String("  pMenu =")+GetStr(pMenu));
	DebWriteln(String("  pMyScr=")+GetStr(pWin));
	DebWriteln(String("  MyWin= ")+GetStr(this));
	DebWriteln(String("  pView =")+GetStr(pWin->pView));
#endif*/
	if (pMenu!=NULL) Application::SetAppMenu(pMenu);
}

void __EXPORT MyWin::Resize()
{
	if (pWin!=NULL) {
		Size aWinSiz=GetOutputSizePixel();
		Size aBarSiz;
		Size aBoxSiz;
		if (pBox!=NULL && !pBox->IsFloatingMode()) {
			aBoxSiz=pBox->GetSizePixel();
			pBox->SetSizePixel(Size(aWinSiz.Width(),aBoxSiz.Height()));
		}
		if (pBar!=NULL) {
			aBarSiz=pBar->GetSizePixel();
			pBar->SetPosSizePixel(Point(0,aWinSiz.Height()-aBarSiz.Height()),
								  Size(aWinSiz.Width(),aBarSiz.Height()));
		}
		pWin->SetPosSizePixel(Point(0,aBoxSiz.Height()),
							  Size(aWinSiz.Width(),aWinSiz.Height()-aBoxSiz.Height()-aBarSiz.Height()));
		Invalidate();
	}
}

// -----------------------------------------------------------------------

#ifdef SvDrawHelpWin
HelpWin::HelpWin(Window* pParent):
	ModelessDialog(/*pParent*/NULL,WB_STDMODELESS|WB_SVLOOK|WB_SIZEABLE|WB_MINABLE|WB_MAXABLE)
{
	SetText("SVDrawDemo Hilfe");
	Font aFont(FAMILY_SWISS,Size(0,12));
	aFont.SetTransparent(TRUE);
	aFont.SetColor(Color(COL_BLUE));
	SetFont(aFont);
	nLnFeed=USHORT(GetTextSize(String('M')).Height());
	nBoxHgt=0;
	nKeyWdt=0;
	nEquWdt=USHORT(GetTextSize(String('=')).Width());
	nDscWdt=0;
	Paint(Rectangle(0,0,0,0));
	nKeyWdt+=2;
	nEquWdt+=2;
	SetOutputSizePixel(Size(nKeyWdt+nEquWdt+nDscWdt,nBoxHgt));
}

BOOL __EXPORT HelpWin::Close()
{
	delete this;
	return TRUE;
}

void HelpWin::WriteHome(const Point& aOrg)
{
	aTxtOrg=aOrg;
	aTxtPos=aTxtOrg;
}

void HelpWin::Write(const String& rStr)
{
	DrawText(aTxtPos,rStr);
	aTxtPos.X()+=GetTextSize(rStr).Width();
}

void HelpWin::Writeln(const String& rStr)
{
	DrawText(aTxtPos,rStr);
	aTxtPos.Y()+=nLnFeed;
	aTxtPos.X()=aTxtOrg.X();
}

void HelpWin::WriteKey(const String& rKey, const String& rDscr)
{
	DrawText(aTxtPos,rKey);
	if (rDscr.Len()>0) {
		DrawText(Point(aTxtPos.X()+nKeyWdt,aTxtPos.Y()),'=');
		DrawText(Point(aTxtPos.X()+nKeyWdt+nEquWdt,aTxtPos.Y()),rDscr);
		USHORT x;
		x=USHORT(GetTextSize(rDscr).Width());
		if (x>nDscWdt) nDscWdt=x;
		x=USHORT(GetTextSize(rKey).Width());
		if (x>nKeyWdt) nKeyWdt=x;
	}
	aTxtPos.Y()+=nLnFeed;
	if (USHORT(aTxtPos.Y())>nBoxHgt) nBoxHgt=USHORT(aTxtPos.Y());
}

void __EXPORT HelpWin::Paint(const Rectangle& rRect)
{
	WriteHome(Point(0,0));
	Writeln("Ansicht");
	WriteKey('k'             ,"Weiteres Dokument");
	WriteKey('v'             ,"Weitere View");
	WriteKey('w'             ,"Weiteres Fenster (keine neue View)");
	WriteKey('+'             ,"Zoom In");
	WriteKey('-'             ,"Zoom Out");
	WriteKey("PgUp"          ,"Zurueckblaettern");
	WriteKey("PgDn"          ,"Weiterblaettern");
	WriteKey("Cusrortasten"  ,"Seite verschieben bzw. Scrollen");
	WriteKey('o'             ,"Nullpunkt der Seite");
	WriteKey('F'             ,"Hilfslinie");
	WriteKey('m'             ,"Macromodus ein-/ausschalten");
	WriteKey('M'             ,"MarkedHitMovesAlways ein/ausschalten");
	WriteKey('p'             ,"Zusatzhandles dauerhaft ein-/ausblenden");
	WriteKey('r'             ,"Redraw erzingen");
	Writeln("Bearbeiten");
	WriteKey("0..9"          ,"Aktiven Layer setzen");
	WriteKey("Alt-0..9"      ,"Layer ein-/ausblenden");
	WriteKey("Strg-0..9"     ,"Layer sperren/entsperren");
	WriteKey("Umsch-0..9"    ,"Layer druckbar ja/nein");
	WriteKey('l'             ,"Liniendialog");
	WriteKey('f'             ,"Flchendialog");
	WriteKey('s'             ,"Markierte Objekte auf (50,100,150,250) setzten");
	WriteKey('t'             ,"Transformationsdialog");
	WriteKey('e'             ,"Umschaltung Edit/Create");
	WriteKey('a'             ,"Alles Objekte/Punkte markieren");
	WriteKey('u'             ,"Markierung aufheben");
	WriteKey("Shift+Maus"    ,"Mehrfachselektion");
	WriteKey("MausRechts"    ,"Objekt markieren (auch im Create-Mode)");
	WriteKey('g'             ,"Objekte zu Gruppe zusammenfassen");
	WriteKey('z'             ,"Gruppenobjekt(e) zerlegen");
	WriteKey('L'             ,"Objekte linksbndig ausrichten");
	WriteKey('R'             ,"Objekte rechtsbndig ausrichten");
	WriteKey('Z'             ,"Objekte hor+vert zentrieren");
	WriteKey('c'             ,"ChDir in markierte Gruppe");
	WriteKey('.'             ,"ChDir ..");
	WriteKey("Del"           ,"Markierte Punkte/Objekte lschen");
	WriteKey('S'             ,"Objekt(e) schliessen");
	WriteKey('T'             ,"Objekt an markierten Punkten auftrennen");
	WriteKey('i'             ,"Neuen Punkt in's Polygon einfuegen");
	WriteKey('I'             ,"Neues Polygon in's PolyPolygon einfuegen");
	//WriteKey("T"             ,"Text des markierten Objekts editieren");
	WriteKey('S'             ,"Sprache umschalten (Deutsch/Englisch)");
	WriteKey("Alt-Back"      ,"Undo");
	WriteKey("Shift-Alt-Back","Redo");
	WriteKey("Ctrl-MausMove" ,"Fang temporaer abschalten");
	WriteKey('K'             ,"Konvertierung in Bezierkurve(n)");
	WriteKey('P'             ,"Konvertierung in Polygon(e)");
	Writeln("I/O");
	WriteKey("F2"            ,"Speichern");
	WriteKey("Shift-F2"      ,"Komprimiert speichern");
	WriteKey("F3"            ,"Laden");
	Writeln("Waerend des Draggens:");
	WriteKey('h'             ,"Handles verstecken/anzeigen");
	WriteKey('s'             ,"DragStripes an/aus");
	WriteKey('d'             ,"Drag&Drop starten");
	WriteKey('q'             ,"Kleinere Markhandles");
	WriteKey('Q'             ,"Grssere Markhandles");
	//WriteKey("Del","Seite lschen");
	//WriteKey("Ins","Seite einfuegen");
	//WriteKey("Home","Alle Seiten ansehen");
}
#endif // SvDrawHelpWin

// -----------------------------------------------------------------------

MyApp aMyApp;

