/*************************************************************************
 *
 *  $RCSfile: swprtopt.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SWPRTOPT_HXX
#define _SWPRTOPT_HXX

#ifndef _SV_MULTISEL_HXX //autogen
#include <tools/multisel.hxx>
#endif

#define POSTITS_NONE	0
#define POSTITS_ONLY	1
#define POSTITS_ENDDOC	2
#define POSTITS_ENDPAGE 3

class SwPrtOptions
{
	USHORT nJobNo;
	String sJobName;

public:
	SwPrtOptions( const String& rJobName ) : aOffset( Point(0,0) ),
		nMergeCnt( 0 ), nMergeAct( 0 ), sJobName( rJobName ),
		nJobNo( 1 )
	{}

	const String& MakeNextJobName();		// steht in vprint.cxx
	const String& GetJobName() const 	{ return sJobName; }

#if defined(TCPP)
	// seit neuestem (SV 223) kann der keinen mehr generieren
	inline	SwPrtOptions(const SwPrtOptions& rNew) {*this = rNew;}
#endif

	MultiSelection	aMulti;
	Point  aOffset;
	ULONG  nMergeCnt;			// Anzahl der Serienbriefe
	ULONG  nMergeAct;			// Aktueller Serienbriefnr.
	USHORT nCopyCount;
	USHORT nPrintPostIts;
	BOOL   bPrintGraph,			//Grafiken/OLE Drucken
		   bPrintTable,			//Tabellen Drucken
		   bPrintDraw,			//Zeichenobjekte Drucken
		   bPrintControl,		//Controls Drucken
		   bPrintLeftPage,
		   bPrintRightPage,
		   bPrintReverse,
		   bPaperFromSetup,
		   bCollate,
		   bPrintSelection,     // Markierung drucken
		   bPrintPageBackground,
		   bPrintBlackFont,
		   bSinglePrtJobs,
		   bJobStartet;
};


#endif //_SWPRTOPT_HXX















