/*************************************************************************
 *
 *  $RCSfile: tempauto.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:08:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "core_pch.hxx"
#endif

#pragma hdrstop

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>		// fuers SV_IMPL_OP
#endif
#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif
#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _TEMPAUTO_HXX
#include <tempauto.hxx>
#endif

SwTempAuto *pTempAuto = NULL;

SV_IMPL_OP_PTRARR_SORT( SwTempList, SwCorrectionPtr )

StringCompare SwCorrection::_Compare( const SwCorrection& rCorr ) const
{
	return Application::GetAppInternational().Compare( aWrong,
									rCorr.aWrong, INTN_COMPARE_IGNORECASE );
}


const SwCorrection* SwTempAuto::Replaceable( const String& rCheck ) const
{
	const SwCorrection* pRet = 0;
	if( aList.Count() )
	{
		USHORT nPos;
		SwCorrection aTmp( rCheck );
		if( aList.Seek_Entry( &aTmp, &nPos ) )
			pRet = aList[ nPos ];
	}
	return pRet;
}



void SwTempAuto::Delete( const String& rCheck )
{
	if( aList.Count() )
	{
		USHORT nPos;
		SwCorrection aTmp( rCheck );
		if( aList.Seek_Entry( &aTmp, &nPos ) )
			aList.DeleteAndDestroy( nPos );
	}
}



void SwTempAuto::Insert( SwCorrection* pCorr )
{
	USHORT nPos;
	if( !aList.Insert( pCorr, nPos ) )
	{
		// ist schon vorhanden, also ggfs. das vorhandene ersetzen
		if( pCorr->Correct() != aList[ nPos ]->Correct() )
		{
			if( pCorr->Identical() )
				// den vorhanden loeschen
				aList.DeleteAndDestroy( nPos );
			else
				// den vorhanden ersetzen
				*aList[ nPos ] = *pCorr;
		}
		delete pCorr;
	}
	else if( pCorr->Identical() )
		// dann ist eine unnuetze Ersetzung, also entferne sie gleich wieder
		// kommt aber nicht so oft vor
		aList.DeleteAndDestroy( nPos );
}




