/*************************************************************************
 *
 *  $RCSfile: sw3frame.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:08:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifdef PRECOMPILED
#include "core_pch.hxx"
#endif

#pragma hdrstop


#ifndef _SVDPAGE_HXX //autogen
#include <svx/svdpage.hxx>
#endif

#ifndef _SVDMODEL_HXX //autogen
#include <svx/svdmodel.hxx>
#endif
#include "doc.hxx"
#include "cntfrm.hxx"
#include "rootfrm.hxx"
#include "pagefrm.hxx"
#include "flyfrm.hxx"
#include "section.hxx"
#include "sectfrm.hxx"
#include "ndtxt.hxx"
#include "dflyobj.hxx"
#include "dcontact.hxx"
#include "frmtool.hxx"
#include "fldbas.hxx"

#ifndef _SVX_LRSPITEM_HXX //autogen
#include <svx/lrspitem.hxx>
#endif
#ifndef _SVX_ULSPITEM_HXX //autogen
#include <svx/ulspitem.hxx>
#endif

#ifndef _FMTFLD_HXX //autogen
#include <fmtfld.hxx>
#endif
#ifndef _FMTCLDS_HXX //autogen
#include <fmtclds.hxx>
#endif
#ifndef _FMTANCHR_HXX //autogen
#include <fmtanchr.hxx>
#endif
#ifndef _TXTFTN_HXX //autogen
#include <txtftn.hxx>
#endif
#ifndef _FMTCNTNT_HXX //autogen
#include <fmtcntnt.hxx>
#endif
#ifndef _FMTFTNTX_HXX //autogen
#include <fmtftntx.hxx>
#endif
#ifndef _NDINDEX_HXX
#include <ndindex.hxx>
#endif

#include "sw3ids.hxx"
#include "sw3frmio.hxx"
#include "sw3imp.hxx"
#include "swtable.hxx"
#include "txatbase.hxx"
#include "notxtfrm.hxx"
#include "hffrm.hxx"
#include "colfrm.hxx"
#include "ftnfrm.hxx"
#include "tabfrm.hxx"
#include "txtfrm.hxx"
#include "bodyfrm.hxx"
#include "flyfrms.hxx"
#include "cellfrm.hxx"
#include "rowfrm.hxx"
#include "pagedesc.hxx"
#include "mdiexp.hxx"

static BYTE nRescCnt = 0;


class Sw3StartNodeSwitch
{
	Sw3FrameIo& rFrameIo;
	ULONG nStartNodeIdxSave;

public:

	Sw3StartNodeSwitch( Sw3FrameIo& rIo, ULONG nNewIdx );
	Sw3StartNodeSwitch( Sw3FrameIo& rIo, const SwLayoutFrm& rFrm );
	Sw3StartNodeSwitch( Sw3FrameIo& rIo, const SwNodeIndex *pNdIdx );

	~Sw3StartNodeSwitch() { rFrameIo.SetStartNodeIndex( nStartNodeIdxSave ); }
};


//////////////////////////////// Frame-Flags ///////////////////////////////

// Die globalen Flagbits werden in der I/O-Klasse gehalten. Sie halten all-
// gemeine Infos, wie z.B. ob ein PrintRect oder eine ID vorhanden ist.
// Klassenspezifische FrmFlags werden als Bytekette gehalten, wobei ein
// gesetztes Bit 7 anzeigt, dass noch ein Byte folgt. Nur SwFrm hat ein
// UINT16, wo Bit 15 diesen Vorgang anzeigt.

////////////////////////////// Frame-Rectangles ////////////////////////////

// Ein Rectangle startet mit einem Byte, dessen 8 Bits 4 Gruppen zu je 2 Bits
// enthalten. Die obersten 2 Bits geben das Format des ersten Wertes an. Werte:
// 0 - 0, 1 - 2 Bytes, 2 - 3 Bytes, 3 - 4 Bytes

// Rectangle einlesen:


void lcl_sw3io_InRectData( SvStream& rStrm, long* val )
{
	BYTE cInfo;
	rStrm >> cInfo;
	for( USHORT i = 0; i < 4; i++, cInfo <<= 2 )
	{
		switch( cInfo & 0xC0 )
		{
			case 0x00:
				*val++ = 0L;
				break;
			case 0x40:
			{
				INT16 n;
				rStrm >> n;
				*val++ = (long) n;
				break;
			}
			case 0x80:
			{
				UINT16 n1; INT8 n2;
				rStrm >> n1 >> n2;
				*val++ = ( (long) n2 << 16 ) + n1;
				break;
			}
			case 0xC0:
			{
				INT32 n;
				rStrm >> n;
				*val++ = n;
				break;
			}
		}
	}
}

// Ermitteln der benoetigten Speicherlaenge fuer ein long:


BYTE lcl_sw3io_NumLen( long n )
{
	if( !n ) return 0;
	if( n < 0 )
		n = -n;
	if( n <= 32767L ) return 1;
	if( n <= 8388607L ) return 2;
	return 3;

}

// Schreiben eines Rechtecks


void lcl_sw3io_OutRectData( SvStream& rStrm, long val[] )
{
	// Das Rechteck faengt mit einem Byte an, das die Laenge jedes
	// Wertes enthaelt.
	BYTE nLen = 0;
	BYTE len[ 4 ];
	long* p = val;
	for( USHORT i = 0; i < 4; i++ )
	{
		len[ i ] = lcl_sw3io_NumLen( *p++ );
		nLen = (nLen << 2) + len[ i ];
	}
	rStrm << (BYTE) nLen;
	p = val;
	for( i = 0; i < 4; i++, p++ )
	{
		switch( len[ i ] )
		{
			case 1:
			{
				INT16 n = (INT16) *p;
				rStrm << n; break;
			}
			case 2:
			{
				long n = *p;
				rStrm << (UINT16) n << (BYTE) ( n >> 16 );
				break;
			}
			case 3:
			{
				INT32 n = *p;
				rStrm << n; break;
			}
		}
	}
}

// Einlesen eines SwRect. Falls ein Upper Frame angegeben wurde, wird
// die Startposition entsprechend korrigiert.


BOOL lcl_sw3io_InRelRect( SvStream& rStrm, SwRect& rRect, const SwRect* pRel )
{
	BOOL bBadData = FALSE;
	long val[ 4 ];
	lcl_sw3io_InRectData( rStrm, val );
	if( pRel )
		val[ 0 ] += pRel->Pos().A(),
		val[ 1 ] += pRel->Pos().B();
	// Die Groesse muss immer positiv sein!
	if( val[ 2 ] <= 0 || val[ 3 ] <= 0 )
	  bBadData = TRUE;
	rRect.Pos( val[ 0 ], val[ 1 ] );
	rRect.SSize( val[ 3 ], val[ 2 ] );
	return bBadData;
}


BOOL lcl_sw3io_InRect( SvStream& rStrm, SwRect& rRect, const SwFrm* pUpper )
{
	return lcl_sw3io_InRelRect( rStrm, rRect, pUpper ? &pUpper->Frm() : NULL );
}

// Schreiben eines Rechtecks. Auch hier wird die Position relativiert,
// wenn ein Upper angegeben ist.


void lcl_sw3io_OutRelRect( SvStream& rStrm, const SwRect& r, const SwRect* pRel )
{
	long val[ 4 ];
	val[ 0 ] = r.Pos().A();
	val[ 1 ] = r.Pos().B();
	val[ 2 ] = r.SSize().A();
	val[ 3 ] = r.SSize().B();
	if( pRel )
		val[ 0 ] -= pRel->Pos().A(),
		val[ 1 ] -= pRel->Pos().B();
	lcl_sw3io_OutRectData( rStrm, val );
}


void lcl_sw3io_OutRect( SvStream& rStrm, const SwRect& r, const SwFrm* pUpper )
{
	lcl_sw3io_OutRelRect( rStrm, r, pUpper ? &pUpper->Frm() : NULL );
}

/////////////////////////// Basisklasse SwFrm //////////////////////////////


SwFrm::SwFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr ) : SwClient( NULL )
#ifndef PRODUCT
	, nFrmId( SwFrm::nLastFrmId++ )
#endif
{
	pUpper = pUpr;
	pNext  = pPrev = NULL;

	BYTE cGblFlags;
	UINT16 nFrmFlags;

	rIo.rStrm >> cGblFlags;
	rIo.nGblFlags = cGblFlags;
	if( rIo.IsFlag( FRMF_MOREFLAGS ) )
	{
		rIo.rStrm >> cGblFlags;
		rIo.nGblFlags |= (((USHORT)cGblFlags) << 8);
	}
	rIo.rStrm >> nFrmFlags;

	bValidPos		= BOOL( nFrmFlags );
	bValidPrtArea	= BOOL( nFrmFlags >> 1 );
	bValidSize		= BOOL( nFrmFlags >> 2 );
	bFixHeight		= BOOL( nFrmFlags >> 3 );
	bFixWidth		= BOOL( nFrmFlags >> 4 );
	bCompletePaint	= BOOL( nFrmFlags >> 5 );
	bRetouche		= BOOL( nFrmFlags >> 6 );
	bVarHeight		= BOOL( nFrmFlags >> 7 );
	bInfInvalid		= BOOL( nFrmFlags >> 8 );
	if( !bInfInvalid )
	{
		bInfBody	= BOOL( nFrmFlags >> 9 );
		bInfTab		= BOOL( nFrmFlags >> 10 );
		bInfFly		= BOOL( nFrmFlags >> 11 );
		bInfFtn		= BOOL( nFrmFlags >> 12 );
		bInfSct		= BOOL( nFrmFlags >> 13 );
	}
	bValidLineNum 	= BOOL( nFrmFlags >> 14 );
	// Aufwaertskompatibel: weitere Flagbytes toeten
	if( nFrmFlags & 0x8000 )
	{
		BYTE c;
		do rIo.rStrm >> c; while( c & 0x80 );
	}
	bColLocked = FALSE;
	// Frame-Rect einlesen (mit Addieren des Upper-Starts, falls vorhanden)
	BOOL bBadData = FALSE;
	// Bei ungueltigem Rectangle kein SwRect lesen
	// bValidPos || bValidSize
	if( rIo.IsFlag( FRMF_RECT ) )
		bBadData |= lcl_sw3io_InRect( rIo.rStrm, aFrm, pUpr );
	else
		bBadData = TRUE;	// zur Sicherheit
	// Printing Rect einlesen, falls vorhanden
	if( rIo.IsFlag( FRMF_PRINT ) )
		bBadData |= lcl_sw3io_InRect( rIo.rStrm, aPrt, NULL );
	else
		aPrt.SSize() = aFrm.SSize();
	// Quick Check: falls die Groesse <= 0 ist,
	// den Frame invalidieren
	if( bBadData )
	{
		bValidPos 	  =
		bValidPrtArea =
		bValidSize	  = FALSE;
	}

	pDrawObjs = rIo.IsFlag( FRMF_HASDRAW ) ? new SwDrawObjs : 0;
	// Frame-ID eintragen?
	if( rIo.IsFlag( FRMF_ISMASTER ) )
	{
		UINT16 nIdx;
		rIo.rStrm >> nIdx;
		rIo.RegisterFrm( this, nIdx );
	}
	// In Master eintragen?
	rIo.pMaster = NULL;
	if( rIo.IsFlag( FRMF_ISFOLLOW ) )
	{
		UINT16 nIdx;
		rIo.rStrm >> nIdx;
		rIo.pMaster = rIo.GetFrm( nIdx );
	}
	rIo.
	pFollow = NULL;
	if( rIo.IsFlag( FRMF_HASFOLLOW ) )
	{
		UINT16 nIdx;
		rIo.rStrm >> nIdx;
		rIo.pFollow = rIo.GetFrm( nIdx );
	}
	if( rIo.rStrm.GetError() != SVSTREAM_OK )
		rIo.SetError();
}


void SwFrm::Store( Sw3FrameIo& rIo ) const
{
	UINT16 nFrmFlags =
			bValidPos
		| ( bValidPrtArea 	<< 1 )
		| ( bValidSize 		<< 2 )
		| ( bFixHeight		<< 3 )
		| ( bFixWidth		<< 4 )
		| ( bCompletePaint	<< 5 )
		| ( bRetouche		<< 6 )
		| ( bVarHeight		<< 7 )
		| ( bInfInvalid		<< 8 )
		| ( bInfBody		<< 9 )
		| ( bInfTab			<< 10 )
		| ( bInfFly			<< 11 )
		| ( bInfFtn			<< 12 )
		| ( bInfSct			<< 13 )
		| ( bValidLineNum	<< 14 );
	// Gibt es Lower Frames?
	// TxtFrms erstmal NICHT!
	if( !IsTxtFrm() && GetLower() )
		rIo.SetFlag( FRMF_HASLOWER );
	if( pDrawObjs )
	{
		rIo.SetFlag( FRMF_HASDRAW );
		// Wir brauchen auch den ID
		rIo.SetFlag( FRMF_ISMASTER );

		// Den Frame mit dem entsprechenden Ref-Count regisrieren.
		// Das Store der abgeleiteten Frames darf dies nicht noch mal
		// tun.
		rIo.AddFrm( (SwFrm*) this, pDrawObjs->Count() );
	}
	// Ist der Frame gueltig?
	if( bValidPos || bValidSize )
		rIo.SetFlag( FRMF_RECT );
#ifdef DEBUG
	else
		int bla = 5;
#endif
	// Hat das Print-Rechteck eigene Werte?
	if( bValidPrtArea )
	  if( aPrt.Pos().A() || aPrt.Pos().B() || (aPrt.SSize() != aFrm.SSize() ) )
		rIo.SetFlag( FRMF_PRINT );

	if( rIo.IsFlag( 0xff00 ) )
		rIo.SetFlag( FRMF_MOREFLAGS );

	rIo.rStrm << (BYTE) rIo.nGblFlags;

	if( rIo.IsFlag( FRMF_MOREFLAGS ) )
	{
		rIo.rStrm << (BYTE)(rIo.nGblFlags >> 8);
	}

	rIo.rStrm << (UINT16) nFrmFlags;

	if( rIo.IsFlag( FRMF_RECT ) )
		lcl_sw3io_OutRect( rIo.rStrm, aFrm, pUpper );
	if( rIo.IsFlag( FRMF_PRINT ) )
		lcl_sw3io_OutRect( rIo.rStrm, aPrt, NULL );
	// Hat der Frame Follows? Dann den Frame mit eigenem ID
	// merken und eigenes ID schreiben
	if( rIo.IsFlag( FRMF_ISMASTER ) )
	{
		// Frame muss in der abgeleiteten Klasse registriert werden.
		// Der Ref-Count darf aber nicht dekrementiert werden, denn
		// denn dies ist der Index des eigenen Frames und nicht der
		// nicht mehr benoetigte eines anderes Frames.
		UINT16 nFrmId = rIo.GetIndex( (SwFrm*) this, FALSE );
		rIo.rStrm << nFrmId;
	}
	// Ist der Frame ein Folgeframe? Dann das ID des Master-Frames
	// schreiben. Die ID des Masters wird dann nicht mehr benoetigt und
	// kann geloescht werden.
	if( rIo.IsFlag( FRMF_ISFOLLOW ) )
		rIo.rStrm << (UINT16) rIo.GetMasterIndex( (SwFrm*) this, TRUE );
	if( rIo.IsFlag( FRMF_HASFOLLOW ) )
		rIo.rStrm << (UINT16) rIo.GetIndex( (SwFrm*)rIo.pFollow, TRUE );
	if( rIo.rStrm.GetError() != SVSTREAM_OK )
		rIo.SetError();
	// Und die Globalflags loeschen
	rIo.pFollow = NULL;
	rIo.nGblFlags = 0;
}

///////////////////////// Basisklasse SwLayoutFrm //////////////////////////

// BYTE			Format-Typ
// UINT16		Format-ID


SwLayoutFrm::SwLayoutFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		   : SwFrm( rIo, pUpr ), pLower( NULL )
{
	nType = FRM_LAYOUT;
	BYTE nFmtType; UINT16 nFmtIdx;
	rIo.rStrm >> nFmtType >> nFmtIdx;
	SwFrmFmt* pFmt = rIo.FindFmt( nFmtType, nFmtIdx );
	if( pFmt )
		pFmt->Add( this );
}


void SwLayoutFrm::Store( Sw3FrameIo& rIo ) const
{
	BYTE  nFmtType = FRMT_STANDARD;
	UINT16 nFmtIdx = IDX_NO_VALUE;
	// Root- und ColumnFrames haben dynamische Frame-Formate
	if( !IsRootFrm() && !IsColumnFrm() && !IsRowFrm() && !IsCellFrm() )
	{
		switch( nType )
		{
			case FRM_PAGE:		nFmtType = FRMT_PAGE;   break;
			case FRM_HEADER:	nFmtType = FRMT_HEADER; break;
			case FRM_FOOTER:	nFmtType = FRMT_FOOTER; break;
			case FRM_SECTION:	nFmtType = FRMT_SECTION; break;
		}
		rIo.FindFmtId( GetFmt(), nFmtType, nFmtIdx );
	}
	SwFrm::Store( rIo );
	rIo.rStrm << nFmtType << nFmtIdx;
}


void SwLayoutFrm::LoadLower( Sw3FrameIo& rIo )
{
	// Lower Frames einlesen?
	if( rIo.IsFlag( FRMF_HASLOWER ) )
	{
		SwFrm* pFirst = NULL;
		SwFrm* pLast = NULL;
		UINT32 nLower = Sw3IoImp::InULong( rIo.rStrm );
		while( nLower-- > 0 && !rIo.IsError() )
		{
			SwFrm* p = rIo.InFrame( this );
			if( p )
			{
				if( pLast )
					pLast->pNext = p,
					p->pPrev = pLast;
				else
					pFirst = p;
				pLast = p;
			}
		}
		pLower = pFirst;
	}
}


void SwLayoutFrm::StoreLower( Sw3FrameIo& rIo ) const
{
	// Lowers schreiben
	const SwFrm* p = GetLower();
	if( p )
	{
		const SwFrm* p1 = p;
		UINT32 nLower = 0;
		do {
			nLower++;
			p = p->GetNext();
		} while( p && p != p1 );
		p = p1;
		Sw3IoImp::OutULong(	rIo.rStrm, nLower );
		do
		{
			p->Store( rIo );
			p = p->GetNext();
		} while( p && ( p != p1 ) && !rIo.IsError() );
	}
}

//////////////////////////////// SwRootFrm //////////////////////////////////

// BYTE			Flags
// UINT16		Anzahl Seiten


SwRootFrm::SwRootFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		 : SwLayoutFrm( rIo, pUpr ), pDestroy( NULL )
{
	nType 	  = FRM_ROOT;
	pTurbo 	  = NULL;
	pCurrShell = NULL;
	pWaitingCurrShell = NULL;
	InitCurrShells( this );
	pLastPage = NULL;
	bIsNewLayout= FALSE;	//Hier stets FALSE (Layout wird ja geladen)
	BYTE nFrmFlags;
	rIo.rStrm >> nFrmFlags;
	bCheckSuperfluous	= BOOL( nFrmFlags );
	bIdleFormat			= TRUE;		//u.a. wg. OnlineSpelling.
	bTurboAllowed		= BOOL( nFrmFlags >> 2 );
	bAssertFlyPages		= BOOL( nFrmFlags >> 3 );
	bIsVirtPageNum		= BOOL( nFrmFlags >> 5 );
	bBrowseWidthValid   = BOOL( nFrmFlags >> 6 );

	while( nFrmFlags & 0x80 )
		rIo.rStrm >> nFrmFlags;

	UINT32 nPhyPageNums32 = Sw3IoImp::InULong( rIo.rStrm );
	ASSERT( nPhyPageNums32 <= USHRT_MAX, "Zu viele Seiten" );
	nPhyPageNums = (USHORT)nPhyPageNums32;

	SwFrmFmt* pFmt = rIo.MakeFmt( String::CreateFromAscii("Root") );
	pFmt->Add( this );

	// DrawPage anlegen bevor die Lowers eingelesen werden!
	// Die DrawPage fuer Flys merken
	// Die DrawPage in Frame eintragen, falls es jetzt schon ein
	// Drawing-Layer gibt.
	SdrModel *pMd = rIo.pDoc->GetDrawModel();
	if ( pMd )
	{
		rIo.pDrawPage = pDrawPage = pMd->GetPage( 0 );
		pDrawPage->SetSize( Frm().SSize() );
	}
	else
		rIo.pDrawPage = pDrawPage = 0;

	// Den Root-Frame ins Dok einfuegen, damit MakeDrawModel-Aufrufe in
	// LoadLower die DrawPage im Root-Frame eintragen koennen. Dies ist
	// neotig, weil der Organizer frueher mal den DrawingLayer-Stream
	// geloescht hat und wir dann an dieser Stelle noch kein
	// Drawing-Layer haben.
	rIo.pDoc->SetRootFrm( this );
	rIo.SetStartNodeIndex( rIo.pDoc->GetNodes().GetEndOfExtras().GetIndex()+1 );

	LoadLower( rIo );

	INT32 nBWidth;
	rIo.rStrm >> nBWidth;
	nBrowseWidth = nBWidth;

	// Und die letzte Seite eintragen
	pLastPage = rIo.pPage;
	RemoveMasterObjs( pDrawPage );
}

// Root-Frame: Basis + Layout + Flag-Byte


void SwRootFrm::Store( Sw3FrameIo& rIo ) const
{
	BYTE nFrmFlags =
			bCheckSuperfluous
		| ( bIdleFormat			<< 1 )
		| ( bTurboAllowed		<< 2 )
		| ( bAssertFlyPages		<< 3 )
		| ( bIsVirtPageNum		<< 5 )
		| ( bBrowseWidthValid   << 6 );
	rIo.pDrawPage = pDrawPage;
	rIo.OpenRec( SWG_FRM_ROOT );
	SwLayoutFrm::Store( rIo );
	rIo.rStrm << (BYTE) nFrmFlags;
	Sw3IoImp::OutULong( rIo.rStrm, nPhyPageNums );
	rIo.SetStartNodeIndex( rIo.pDoc->GetNodes().GetEndOfExtras().GetIndex()+1 );
	StoreLower( rIo );
	rIo.rStrm << (INT32)nBrowseWidth;

	rIo.CloseRec( SWG_FRM_ROOT );

	rIo.CheckRefCnts();
}

///////////////////////////////// SwPageFrm /////////////////////////////////

// Ein paar Worte zu FlyFrames.
// Diese sind in zwei Arrays vorzufinden:
// Seitengebundene Rahmen:
// 1. pSortedObjs der Seite
// 2. pDrawObjs der Seite
// Absatzgebundene Rahmen:
// 1. pSortedObjs der Seite
// 2. pDrawObjs der ContentFrames, in dem sie auftauchen
// Zeichengebundene Rahmen:
// 1. pDrawObjs der TxtFrames, in dem sie auftauchen
// Die Arrays halten Pointer auf SdrObject'e. Um an die Flys zu kommen,
// die evlt. dahinter stecken, muss der Point per PTR_CAST auf ein
// SwVirtFlyDrawObj gecastet werden. Wenn der Pointer dann != 0 ist kann
// von ihm mittels p->GetFlyFrm() der Fly besorgt werden.
//
// Seiten - und absatzgebundene FlyFrames werden innerhalb der
// Page-Frames durch Iteration ueber das pSortedObjs-Array
// gespeichert. Die Zuordnung zu den pDrawObjs erfolgt ueber zusaetzlich
// gespeicherte Ids.
// Zeichengebunde FlyFrames werden innerhalb des TxtFrames gespeichert.

// BYTE			Flags
// UINT16		String-ID des PageDesc
// UINT16		Seitennummer
// UINT16		Anzahl Flys (opt.)
// ...			Flys


SwPageFrm::SwPageFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		 : SwFtnBossFrm( rIo, pUpr )
{
	nType = FRM_PAGE;
	pSortedObjs = NULL;
	BYTE nFrmFlags;
	UINT16 nDesc;
	rIo.rStrm >> nFrmFlags;
	bInvalidCntnt		= BOOL( nFrmFlags );
	bInvalidLayout		= BOOL( nFrmFlags >> 1 );
	bInvalidFlyCntnt	= BOOL( nFrmFlags >> 2 );
	bInvalidFlyLayout	= BOOL( nFrmFlags >> 3 );
	bInvalidFlyInCnt	= BOOL( nFrmFlags >> 4 );
	bFtnPage			= BOOL( nFrmFlags >> 5 );
	bEmptyPage			= BOOL( nFrmFlags >> 6 );
	bInvalidSpelling	= TRUE;
	bEndNotePage		= FALSE;
	if( nFrmFlags & 0x80 )
	{
		rIo.rStrm >> nFrmFlags;
		bInvalidSpelling = BOOL( nFrmFlags );
		bEndNotePage = BOOL( nFrmFlags >> 1 );
	}

	//Drucker gewechselt, Inhalt invalidieren.
	if ( rIo.GetIoImp().bPrtChanged )
		bInvalidCntnt = bInvalidFlyCntnt = bInvalidFlyInCnt = TRUE;

	while( nFrmFlags & 0x80 )
		rIo.rStrm >> nFrmFlags;
	rIo.rStrm  >> nDesc;

	UINT32 nPhyPageNum32 = Sw3IoImp::InULong( rIo.rStrm );
	ASSERT( nPhyPageNum32 <= USHRT_MAX, "Seitenzahl zu gross" );
	nPhyPageNum = (USHORT)nPhyPageNum32;
	rIo.SetPercentBar( nPhyPageNum, FALSE );

	pDesc = rIo.FindPageDesc( nDesc );
	if( pDesc )
	{
		SetMaxFtnHeight( pDesc->GetFtnInfo().GetHeight() );
		if ( !GetMaxFtnHeight() )
			SetMaxFtnHeight( LONG_MAX );
	}
	// Seite und FlyFrm-Flag merken
	rIo.pPage = this;
	rIo.nPageCols = 0;
	BOOL bHasFlys = rIo.IsFlag( FRMF_HASFLYS );
	// Jetzt den Rest der Seite laden
	LoadLower( rIo );

	// JP 23.09.95: Bug 19614 - sollte die Anzahl der Spaten nicht mit denen
	// 				der Seitenbeschreibung uebereinstimmen, ist das Layout
	//				rottig!!!
	if( pDesc && !bEmptyPage )
	{
		const SwFrmFmt* pFmt = nPhyPageNum & 1 ? &pDesc->GetLeft()
											   : &pDesc->GetMaster();
		USHORT nFmtNumCols = pFmt->GetCol().GetNumCols();
		if( ( 1 == nFmtNumCols ? 0 : nFmtNumCols ) != rIo.nPageCols )
			rIo.SetError();
	}
	SetColMaxFtnHeight();

	// und erst danach die Flys an der Seite!
	if( bHasFlys && !rIo.IsError() )
	{
		// FlyFrames haben keinen Upper!
		UINT32 nFly = Sw3IoImp::InULong( rIo.rStrm );
		pSortedObjs = new SwSortDrawObjs;
		while( nFly-- && !rIo.IsError() )
		{
			SwFrm* pAtFrm = this;
			SdrObjectPtr pObj;
			// An welchem Frame haengt denn so ein Objekt?
			UINT16 nAtFrmId;
			BYTE cType, cSpare;
			rIo.rStrm >> nAtFrmId >> cType;
			rIo.rStrm.SeekRel( -1L );
			pAtFrm = rIo.GetFrm( nAtFrmId );
			UINT32 nObjRef;
			if( cType == SWG_FRM_DRAWOBJ )
			{
				rIo.OpenRec( cType );
				rIo.rStrm >> cSpare >> nObjRef;
				rIo.CloseRec( cType );
				ASSERT( rIo.pDrawPage,
						"SwPageFrm-Ctor without DrawPage (fehlt der DL-Stream?)" );
				if( !rIo.pDrawPage )
					rIo.pDrawPage = rIo.pDoc->MakeDrawModel()->GetPage( 0 );
				if( nObjRef >= rIo.pDrawPage->GetObjCount() )
				{
					ASSERT( !this, "Ungueltige SdrObject-Nummer" );
					rIo.SetError();
				}
				// cSpare ist fuer kuenftige Versionen gedacht
				else if( !cSpare )
				{
					// Seitenframe bekannt machen
					pObj = rIo.pDrawPage->GetObj( nObjRef );
					SwDrawContact *pContact = (SwDrawContact*)GetUserCall(pObj);
					pContact->ChgAnchor( pAtFrm );
					pContact->ChgPage( this );
				}
			}
			else
			{
				SwFlyFrm* p = (SwFlyFrm*) rIo.InFrame( this );
				if( !p ) break;
				ASSERT( p->IsFlyFrm(), "FlyFrm erwartet" );
				pObj = p->GetVirtDrawObj();
				// Ist der Fly bereits in der Seite drin?
				// Flys in Headers ab Seite 2 sind z.B. nicht drin
				if( !pObj->GetPage() )
				{
					ASSERT( rIo.pDrawPage,
							"SwPageFrm-Ctor without DrawPage (fehlt der DL-Stream?)" );
					if( !rIo.pDrawPage )
						rIo.pDrawPage = rIo.pDoc->MakeDrawModel()->GetPage( 0 );
					rIo.pDrawPage->InsertObject( pObj );
				}
				p->ChgAnchor( pAtFrm );
				p->NotifyDrawObj();
			}
			pSortedObjs->Insert( pObj );
			pAtFrm->GetDrawObjs()->Insert( pObj, pAtFrm->GetDrawObjs()->Count() );
		}
	}
}


void lcl_StoreFly( Sw3FrameIo &rIo, SwSortDrawObjs &rObjs, SwFlyFrm *pFly )
{
	//Wir sorgen dafuer, dass die "auesseren" Flys zuerst gespeichert werden
	//(damit der Anker schon geschrieben ist und so der Index gefunden werden
	//kann).
	//Die Rekursion kann an jeder Stelle auch zeichengeb. Rahmen haben, die
	//Kette wird dann weiterverfolgt, aber die Zeichengeb. nicht geschrieben -
	//das passiert bei den Absaetzen.

	if ( pFly->GetAnchor()->IsInFly() )
		lcl_StoreFly( rIo, rObjs, pFly->GetAnchor()->FindFlyFrm() );

	USHORT nPos = rObjs.GetPos( pFly->GetVirtDrawObj() );
	if ( nPos != USHRT_MAX )
	{
		rIo.rStrm << (UINT16) rIo.GetIndex( pFly->GetAnchor(), TRUE );
		pFly->Store( rIo );
		rObjs.Remove( nPos );
	}
}


void SwPageFrm::Store( Sw3FrameIo& rIo ) const
{
	// Seite merken
	rIo.pPage = (SwPageFrm*) this;
	BYTE nFrmFlags =
			bInvalidCntnt
		| ( bInvalidLayout		<< 1 )
		| ( bInvalidFlyCntnt	<< 2 )
		| ( bInvalidFlyLayout	<< 3 )
		| ( bInvalidFlyInCnt	<< 4 )
		| ( bFtnPage			<< 5 )
		| ( bEmptyPage			<< 6 )
		| ( 1                   << 7 );
	BYTE nFrmFlags2 =
			bInvalidSpelling
		| ( bEndNotePage		<< 1 );

	rIo.SetPercentBar( nPhyPageNum, TRUE );
	UINT16 nDesc = rIo.FindPageDescId( pDesc );
	const ULONG nFly = pSortedObjs ? pSortedObjs->Count() : 0;
	if( nFly )
	{
		// Der Frame brauch nicht registriert zu werden, denn wenn
		// wirklich ein Frame in ihm verankert ist, passiert das
		// schon im SwFrm::Store.
		rIo.SetFlag( FRMF_HASFLYS );
	}
	rIo.OpenRec( SWG_FRM_PAGE );
	SwLayoutFrm::Store( rIo );
	rIo.rStrm << (BYTE) nFrmFlags
			  << (BYTE) nFrmFlags2
			  << (UINT16) nDesc;
	Sw3IoImp::OutULong( rIo.rStrm, nPhyPageNum );
	StoreLower( rIo );

	if( nFly )
	{
		Sw3IoImp::OutULong( rIo.rStrm, nFly );
		const BYTE nCnt = BYTE( Max( USHORT(nFly), USHORT(255) ) );
		SwSortDrawObjs aTmpObjs( nCnt, nCnt );
		aTmpObjs.Insert( pSortedObjs );

		do
		{
			SdrObjectPtr pObj = aTmpObjs[0];
			SwVirtFlyDrawObj *p = pObj->IsWriterFlyFrame() ?
													(SwVirtFlyDrawObj*)pObj : 0;
			if( p )
				lcl_StoreFly( rIo, aTmpObjs, p->GetFlyFrm() );
			else
			{
				SwFrm* pFrm = ((SwDrawContact*)GetUserCall(pObj))->GetAnchor();
				if ( pFrm->IsInFly() )
					lcl_StoreFly( rIo, aTmpObjs, pFrm->FindFlyFrm() );

				// Nur die Z-Order und den FrmId raushusten
				rIo.rStrm << (UINT16) rIo.GetIndex( pFrm, TRUE );
				rIo.OpenRec( SWG_FRM_DRAWOBJ );
				rIo.rStrm << (BYTE) 0	// fuer Erweiterungen
						  << (UINT32) pObj->GetOrdNum();
				rIo.CloseRec( SWG_FRM_DRAWOBJ );
				aTmpObjs.Remove( (USHORT)0 );
			}
		} while ( aTmpObjs.Count() );
	}
	rIo.CloseRec( SWG_FRM_PAGE );
}

//////////////////////////////// SwHeaderFrm ///////////////////////////////


SwHeaderFrm::SwHeaderFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		   : SwLayoutFrm( rIo, pUpr )
{
	nType = FRM_HEADER;
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		LoadLower( rIo );
	}
}


void SwHeaderFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_HEADER );
	SwLayoutFrm::Store( rIo );
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		StoreLower( rIo );
	}
	rIo.CloseRec( SWG_FRM_HEADER );
}

//////////////////////////////// SwFooterFrm ///////////////////////////////


SwFooterFrm::SwFooterFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		   : SwLayoutFrm( rIo, pUpr )
{
	nType = FRM_FOOTER;
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		LoadLower( rIo );
	}
}


void SwFooterFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_FOOTER );
	SwLayoutFrm::Store( rIo );
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		StoreLower( rIo );
	}
	rIo.CloseRec( SWG_FRM_FOOTER );
}

//////////////////////////////// SwBodyFrm ////////////////////////////////


SwBodyFrm::SwBodyFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		 : SwLayoutFrm( rIo, pUpr )
{
	nType = FRM_BODY;
	LoadLower( rIo );
}


void SwBodyFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_BODY );
	SwLayoutFrm::Store( rIo );
	StoreLower( rIo );
	rIo.CloseRec( SWG_FRM_BODY );
}

/////////////////////////////// SwColumnFrm //////////////////////////////

// RECT			Masse des Rechtecks


SwColumnFrm::SwColumnFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		   : SwFtnBossFrm( rIo, pUpr )
{
	nType = FRM_COLUMN;
	SetMaxFtnHeight( LONG_MAX );
	if( pUpr->IsBodyFrm() ) //
		++rIo.nPageCols;
	else if( pUpr->IsFlyFrm() )
		++rIo.nFlyCols;

	// Format-Rechteck lesen
	long val[ 4 ];
	lcl_sw3io_InRectData( rIo.rStrm, val );
	SwFrmFmt* pFmt = rIo.MakeFmt( String::CreateFromAscii("Column") );
	SvxLRSpaceItem aLR( pFmt->GetLRSpace() );
	SvxULSpaceItem aUL( pFmt->GetULSpace() );
	aLR.SetLeft(  USHORT(val[ 0 ]) );
	aUL.SetUpper( USHORT(val[ 1 ]) );
	aLR.SetRight( USHORT(val[ 2 ]) );
	aUL.SetLower( USHORT(val[ 3 ]) );
	pFmt->SetAttr( aLR );
	pFmt->SetAttr( aUL );
	pFmt->Add( this );
	LoadLower( rIo );
}


void SwColumnFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_COLUMN );
	SwLayoutFrm::Store( rIo );
	// Das Attribut-Rechteck speichern
	long val[ 4 ];
	const SwFrmFmt *pFmt = GetFmt();
	const SvxLRSpaceItem& rLR = pFmt->GetLRSpace();
	const SvxULSpaceItem& rUL = pFmt->GetULSpace();
	val[ 0 ] = rLR.GetLeft();
	val[ 1 ] = rUL.GetUpper();
	val[ 2 ] = rLR.GetRight();
	val[ 3 ] = rUL.GetLower();
	lcl_sw3io_OutRectData( rIo.rStrm, val );
	StoreLower( rIo );
	rIo.CloseRec( SWG_FRM_COLUMN );
}

/////////////////////////////// SwFtnContFrm //////////////////////////////


SwFtnContFrm::SwFtnContFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
			: SwLayoutFrm( rIo, pUpr )
{
	nType = FRM_FTNCONT;
	LoadLower( rIo );
}


void SwFtnContFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_FTNCONT );
	SwLayoutFrm::Store( rIo );
	StoreLower( rIo );
	rIo.CloseRec( SWG_FRM_FTNCONT );
}

////////////////////////////// SwFtnFrm ///////////////////////////////////

// UINT16		ID des Cntnt-Frames
// UINT16		Offset des Ftn-Attributs im Text (opt).

SwFtnFrm::SwFtnFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
	: SwLayoutFrm( rIo, pUpr )
{
	nType = FRM_FTN;
	bBackMoveLocked = FALSE;
	pFollow = NULL;
	pMaster = NULL;
	pAttr	= NULL;
	UINT16 nIdx;
	xub_StrLen nOffset = 0;
	rIo.rStrm >> nIdx;
	if( rIo.IsFlag( FRMF_HASOFFSET ) )
	{
		UINT16 nOffset16;
		rIo.rStrm >> nOffset16;
		nOffset = nOffset16;
	}
	if( rIo.IsFlag( FRMF_ISFOLLOW ) )
	{
		ASSERT( rIo.pMaster->IsFtnFrm(), "Falscher Master-ID" );
		if( rIo.pMaster->IsFtnFrm() )
		{
			((SwFtnFrm*) this)->pMaster = (SwFtnFrm*) rIo.pMaster;
			((SwFtnFrm*) rIo.pMaster)->pFollow = (SwFtnFrm*) this;
		}
	}
	pRef = (SwCntntFrm*) rIo.GetFrm( nIdx );
	if( !pRef )
		return;
	ASSERT( pRef->IsCntntFrm(), "Ftn-Ref ist kein Cntnt-Frm" );
	if( pRef->IsCntntFrm() )
	{
		// Hint suchen:
		SwTxtNode* pNd = pRef->GetNode()->GetTxtNode();
		if( pNd )
			pAttr = (SwTxtFtn*) pNd->GetTxtAttr( nOffset, RES_TXTATR_FTN );
		ASSERT( pAttr, "SwFtnFrm: Hint nicht gefunden!" );
		if( !pAttr )
			rIo.SetError();
	}
	else
		rIo.SetError();

	{
		Sw3StartNodeSwitch aSwitch( rIo, pAttr->GetStartNode() );
		LoadLower( rIo );
	}
}


void SwFtnFrm::Store( Sw3FrameIo& rIo ) const
{
	BOOL bFound = FALSE;
	xub_StrLen nOffset = 0;
	SwTxtNode* pNd = pRef->GetNode()->GetTxtNode();
	if( pNd )
	{
		// Das Hint-Array abklappern:
		USHORT nCntAttr = pNd->HasHints() ? pNd->GetSwpHints().Count() : 0;
		for( USHORT n = 0; n < nCntAttr; n++ )
		{
			const SwTxtAttr* pHt = pNd->GetSwpHints()[ n ];
			if( (SwTxtFtn*) pHt == pAttr )
			{
				nOffset = *pHt->GetStart();
				bFound = TRUE; break;
			}
		}
	}
	ASSERT( bFound, "Node/Hint nicht gefunden" );
	if( bFound )
	{
		if( pFollow )
		{
			// Fussnoten gibt es nicht in Rahmen. Deshalb ist hier auch
			// keine doppelte Verkettung noetig.
			USHORT nIdx = rIo.AddFrm( (SwFrm*) this, 1 );
			rIo.SetFollow( nIdx, (SwFrm*) pFollow );
			rIo.SetFlag( FRMF_ISMASTER );
		}
		if( pMaster )
			rIo.SetFlag( FRMF_ISFOLLOW );
		if( nOffset )
			rIo.SetFlag( FRMF_HASOFFSET );
		rIo.OpenRec( SWG_FRM_FTN );
		SwLayoutFrm::Store( rIo );
		// Index des Ankers holen. Der Index darf jedoch nur frei gegeben
		// werden, wenn Frame keine Follows hat, denn sonst wird er
		// noch benoetigt.
		UINT16 nIdx = rIo.GetIndex( pRef, !pFollow );
		rIo.rStrm << nIdx;
		// Offset des Hints ablegen
		if( nOffset )
		{
			// If the offset is to large, stop here
			if( nOffset > STRING_MAXLEN52 )
				rIo.SetError();
			rIo.rStrm << (UINT16)nOffset;
		}
		{
			Sw3StartNodeSwitch aSwitch( rIo, pAttr->GetStartNode() );
			StoreLower( rIo );
		}
		rIo.CloseRec( SWG_FRM_FTN );
	}
	else
		rIo.SetError();
}

////////////////////////// Basisklasse SwFlowFrm //////////////////////////
//
// Das Lesen Schreiben und Schreiben der FlowFrm information ist etwas
// trickreich, denn die Frames koennen mal in der Reihenfolge Master-Follow
// und mal in der Reihenfolge Follow-Master geschrieben werden. Ausserdem
// muss auf darauf geachtet werden, das immer korrekt gecastet wird.

void lcl_sw3io_initFlowFrm( Sw3FrameIo& rIo, SwFrm *pThis )
{
	const USHORT nMask = FRM_SECTION | FRM_TAB | FRM_CNTNT;
	if( rIo.IsFlag( FRMF_ISFOLLOW ) )
	{
		BOOL bSameTypes =
			(rIo.pMaster->GetType() & pThis->GetType() & nMask) != 0;

		ASSERT( bSameTypes, "Master hat falschen Typ" );
		ASSERT( rIo.pMaster != pThis, "Master = Follow" );

		if( bSameTypes && rIo.pMaster != pThis )
		{
			SwFlowFrm *pThisFlow = SwFlowFrm::CastFlowFrm( pThis );
			SwFlowFrm::CastFlowFrm( rIo.pMaster )->SetFollow( pThisFlow );
			pThisFlow->_SetIsFollow( TRUE );
		}
		else
			rIo.SetError();
	}
	if( rIo.IsFlag( FRMF_HASFOLLOW ) )
	{
		BOOL bSameTypes =
			(rIo.pFollow->GetType() & pThis->GetType() && nMask) != 0;

		ASSERT( bSameTypes, "Master hat falschen Typ" );
		ASSERT( rIo.pFollow != pThis, "Follow = Master" );

		if( bSameTypes && rIo.pFollow != pThis )
		{
			SwFlowFrm *pFollowFlow = SwFlowFrm::CastFlowFrm( rIo.pFollow );
			SwFlowFrm::CastFlowFrm( pThis )->SetFollow( pFollowFlow );
			pFollowFlow->_SetIsFollow( TRUE );
		}
		else
			rIo.SetError();
	}
}

void lcl_sw3io_prepareStoreFlowFrm( Sw3FrameIo& rIo, const SwFrm *pThis )
{
	const SwFlowFrm *pThisFlow = SwFlowFrm::CastFlowFrm( pThis );

	if( pThisFlow->IsFollow() )
	{
		if( IDX_NO_VALUE != rIo.GetMasterIndexNoErr( (SwFrm*)pThis ) )
		{
			// Master schon geschrieben, dann ID des Masters schreiben
			rIo.SetFlag( FRMF_ISFOLLOW );
		}
		else
		{
			// Master noch nicht geschrieben, dann diesen Frame registrieren.
			// Der Master schreibt dann den Index des Follows.
			rIo.AddFrm( (SwFrm*)pThis , 1 );
			rIo.SetFlag( FRMF_ISMASTER );
		}
	}
	const SwFlowFrm *pFollowFlow = pThisFlow->GetFollow();
	if( pFollowFlow )
	{
		const SwFrm *pFollow;
		if ( pThis->IsCntntFrm() )
			pFollow = (const SwCntntFrm*)pFollowFlow;
		else if ( pThis->IsTabFrm() )
			pFollow = (const SwTabFrm*)pFollowFlow;
		else if ( pThis->IsSctFrm() )
			pFollow = (const SwSectionFrm*)pFollowFlow;

		if( IDX_NO_VALUE != rIo.GetIndexNoErr( (SwFrm*)pFollow ) )
		{
			// Follow schon geschrieben, dann ID des Follows schreiben
			rIo.SetFlag( FRMF_HASFOLLOW );
			rIo.pFollow = (SwFrm*)pFollow;
		}
		else
		{
			// Follow noch nicht geschrieben, dann diesen Frame registrieren
			// und den Follow dranhaengen. Der Follow schreibt dann die
			// ID des Masters.
			USHORT nIdx = rIo.AddFrm( (SwFrm*)pThis, 1 );
			rIo.SetFollow( nIdx, (SwFrm*)pFollow );
			rIo.SetFlag( FRMF_ISMASTER );
		}
	}
}


////////////////////////// Basisklasse SwCntntFrm //////////////////////////

// BYTE				Section
//				7: 	Section hat 2 Bytes
//				6: 	Offset hat 2 Bytes
//				5-0:Section
// BYTE				Section (opt.)
// BYTE/UINT16		Offset innerhalb der Section


SwCntntFrm::SwCntntFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
	: SwFrm( rIo, pUpr ), SwFlowFrm( (SwFrm&) *this )
{
	nType = FRM_CNTNT;
	ULONG nOff = Sw3IoImp::InULong( rIo.rStrm );
	SwCntntNode* pNd = rIo.FindNode( nOff );
	if( pNd )
		pNd->Add( this );
	lcl_sw3io_initFlowFrm( rIo, this );
}

void SwCntntFrm::Store( Sw3FrameIo& rIo ) const
{
	lcl_sw3io_prepareStoreFlowFrm( rIo, this );
	SwFrm::Store( rIo );
	ULONG nOff = rIo.GetNodeId( (SwCntntNode*) GetNode() );
	Sw3IoImp::OutULong( rIo.rStrm, nOff );
}

/////////////////////////////// SwTxtFrm //////////////////////////////////

// UINT16		Offset (opt.)


USHORT lcl_sw3io_GetFtnCnt( const SwTxtFrm *pTxtFrm )
{
	const SwTxtNode* pTxtNd = pTxtFrm->GetNode()->GetTxtNode();
	ASSERT( pTxtNd, "Wo ist der Node des TxtFrm?" );
	if( !pTxtNd )
		return 0;

	xub_StrLen nStart = pTxtFrm->GetOfst();
	xub_StrLen nEnd;
	const SwTxtFrm *pFollow = pTxtFrm->GetFollow();
	if( pFollow )
	{
		nEnd = pFollow->GetOfst();
	}
	else
	{
		nEnd = pTxtNd->Len();
	}

	// Das Hint-Array abklappern:
	USHORT nCntAttr = pTxtNd->HasHints() ? pTxtNd->GetSwpHints().Count() : 0;
	ASSERT( nCntAttr, "TxtFrm hat Fussnoten-Flag gesetzt aber keine Hints" );

	USHORT nFtnCnt = 0;
	for( USHORT n=0;  n<nCntAttr; n++ )
	{
		const SwTxtAttr* pHt = pTxtNd->GetSwpHints()[ n ];
		if( *pHt->GetStart() < nStart )
			continue;

		if( *pHt->GetStart() >= nEnd )
			break;

		if( RES_TXTATR_FTN == pHt->Which() )
			nFtnCnt++;
	}

	ASSERT( nFtnCnt, "TxtFrm hat Fussnoten-Flag gesetzt aber keine Fussnoten" );
	return nFtnCnt;
}

SwTxtFrm::SwTxtFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		 : SwCntntFrm( rIo, pUpr )
{
	InitCtor();
	BYTE nFrmFlags;

	if( ++nRescCnt==10 )
	{
		::RescheduleProgress( rIo.pDoc->GetDocShell() );
		nRescCnt = 0;
	}

	rIo.rStrm >> nFrmFlags;

/*  Die uebrigen Flags wurden in InitCtor initialisiert */
	bFormatted		= BOOL( nFrmFlags  );
	bWidow			= BOOL( nFrmFlags >> 1 );
	bInFtnConnect	= BOOL( nFrmFlags >> 5 );
	bFtn			= BOOL( nFrmFlags >> 6 );

	//Drucker gewechselt, Inhalt invalidieren.
	if ( rIo.GetIoImp().bPrtChanged )
		bValidSize = FALSE;

	while( nFrmFlags & 0x80 )
		rIo.rStrm >> nFrmFlags;

	if( !pDrawObjs && rIo.IsFlag( FRMF_HASFLYS ) )
		pDrawObjs = new SwDrawObjs;
	if( rIo.IsFlag( FRMF_HASOFFSET ) )
		rIo.rStrm >> nOfst;

	UINT32 nLines = Sw3IoImp::InULong( rIo.rStrm );
	nThisLines = nLines;	// ULONG:8 = ULONG, also kein Problem
	nAllLines = (nLines >> 8);

	if ( FRMVER_LINENUMBUG > rIo.nVersion )
		InvalidateLineNum();

	// Zeichengebundene Flys einlesen
	if( pDrawObjs )
	{
		UINT32 nFly = Sw3IoImp::InULong( rIo.rStrm );
		while( nFly-- && !rIo.IsError() )
		{
			SwFlyFrm* p = (SwFlyFrm*) rIo.InFrame( NULL );
			if( !p ) break;
			ASSERT( p->IsFlyInCntFrm(), "InCntFlyFrm erwartet" );
			SdrObjectPtr pObj = p->GetVirtDrawObj();
			// Ist der Fly bereits in der Seite drin?
			// Flys in Headers ab Seite 2 sind z.B. nicht drin
			if( !pObj->GetPage() )
			{
				ASSERT( rIo.pDrawPage,
						"SwPageFrm-Ctor without DrawPage (fehlt der DL-Stream?)" );
				if( !rIo.pDrawPage )
					rIo.pDrawPage = rIo.pDoc->MakeDrawModel()->GetPage( 0 );
				rIo.pDrawPage->InsertObject( pObj );
			}
			p->ChgAnchor( this );
			p->NotifyDrawObj();
			pDrawObjs->Insert( pObj, pDrawObjs->Count() );
		}
	}
}


void SwTxtFrm::Store( Sw3FrameIo& rIo ) const
{
	BYTE nFrmFlags =
		  ( bFormatted		<< 0 )
		| ( bWidow			<< 1 )
		| ( bUndersized		<< 2 )
//		| ( bJustWidow		<< 3 )
//		| ( bEmpty			<< 4 )
		| ( bInFtnConnect	<< 5 )
		| ( bFtn			<< 6 );
	// Falls wir Fussnoten haben, brauchen wir den ID
	if( bFtn )
	{
		rIo.SetFlag( FRMF_ISMASTER );
		rIo.AddFrm( (SwFrm*)this, lcl_sw3io_GetFtnCnt( this ) );
	}
	// Falls wir DrawObjs haben, den ID schreiben
	if( pDrawObjs )
		rIo.SetFlag( FRMF_HASFLYS );
	if( nOfst )
		rIo.SetFlag( FRMF_HASOFFSET );

	if( ++nRescCnt==10 )
	{
		::RescheduleProgress( rIo.pDoc->GetDocShell() );
		nRescCnt = 0;
	}


	rIo.OpenRec( SWG_FRM_TXT );
	SwCntntFrm::Store( rIo );
	rIo.rStrm << (BYTE) nFrmFlags;
	if( nOfst )
	{
		if( nOfst > STRING_MAXLEN52 )
			rIo.SetError();
		rIo.rStrm << (UINT16) nOfst;
	}

	UINT32 nLines = (nAllLines << 8) + nThisLines;
	Sw3IoImp::OutULong( rIo.rStrm, nLines );

	// Haben wir zeichengebundene Flys?
	UINT32 nFly = 0;
	if( pDrawObjs )
	{
		USHORT nSize = pDrawObjs->Count();
		for( USHORT i = 0; i < nSize; i++ )
		{
			SdrObjectPtr pObj = (*pDrawObjs)[i];
			SwVirtFlyDrawObj *p = pObj->IsWriterFlyFrame() ?
												(SwVirtFlyDrawObj*)pObj : 0;
			if( p )
			{
				if( p->GetFlyFrm()->IsFlyInCntFrm() )
				{
					nFly++;

					// Fuer den eigenen Frm existiert eine Ref fuer den
					// Fly, der noch geloescht werden muss, auch wenn der
					// Index gar nicht benoetigt wird.
					rIo.GetIndex( (SwFrm*)this, TRUE );
				}
			}
			else
			{
				// Fuer Zeichen-Objekte muss der Ref-Count auch erniedrigt
				// werden, wenn sie zeichengebunden sind.
				const SwDrawContact *pContact =
					(SwDrawContact*)GetUserCall(pObj);
				ASSERT( pContact, "Kein Draw-Contact fuer Zeichen-Objekt" );
				const SwFrmFmt *pFmt = pContact->GetFmt();
				ASSERT( pContact, "Kein Format am Draw-Contact" );
				if( FLY_IN_CNTNT == pFmt->GetAnchor().GetAnchorId() )
				{
					rIo.GetIndex( (SwFrm*)this, TRUE );
				}

			}
		}
		Sw3IoImp::OutULong( rIo.rStrm, nFly );
	}
	if( nFly )
	{
		USHORT nSize = pDrawObjs->Count();
		for( USHORT i = 0; i < nSize; i++ )
		{
			SdrObjectPtr pObj = (*pDrawObjs)[i];
			SwVirtFlyDrawObj *p = pObj->IsWriterFlyFrame() ?
													(SwVirtFlyDrawObj*)pObj : 0;
			if( p && p->GetFlyFrm()->IsFlyInCntFrm() )
				p->GetFlyFrm()->Store( rIo );
		}
	}
	rIo.CloseRec( SWG_FRM_TXT );
}

////////////////////////////// SwNoTxtFrm //////////////////////////////////


SwNoTxtFrm::SwNoTxtFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		  : SwCntntFrm( rIo, pUpr )
{
	nType = FRM_NOTXT;
	InitCtor();
}


void SwNoTxtFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_NOTXT );
	SwCntntFrm::Store( rIo );
	rIo.CloseRec( SWG_FRM_NOTXT );
}

////////////////////////// Basisklasse SwFlyFrm ////////////////////////////

// Die Uppers sind bei FlyFrames immer der PageFrm!

// BYTE			Flags
// INT32		Position X
// INT32		Position Y
// RECT			ClipRect
// RECT			StretchRect (opt.)


SwFlyFrm::SwFlyFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		: SwLayoutFrm( rIo, pUpr ), bInCnt( FALSE ),
		  bAtCnt( FALSE ), bLayout( FALSE )
{
	nType	 = FRM_FLY;
	pAnchor  = NULL;
	pPrevLink= pNextLink = 0;
	bLocked  = bFormatHeightOnly = FALSE;

	BYTE nFrmFlags;
	INT32 nX, nY;
	rIo.rStrm >> nFrmFlags;
	bMinHeight	= BOOL( nFrmFlags );
	bInvalid	= BOOL( nFrmFlags >> 1 );
	bNotifyBack	= BOOL( nFrmFlags >> 2 );
	bWidthClipped = BOOL( nFrmFlags >> 3 );
	bHeightClipped= BOOL( nFrmFlags >> 4 );
	bAutoPosition= BOOL( nFrmFlags >> 5 );

	// ACHTUNG: bHasPrev und bHasNext sind Bytes und keine Bits!!!
	// Deshalb funktioniert die shifterei dort alleine nicht, sondern
	// es muss amskiert werden!!!
	BOOL bHasPrev = BOOL( (nFrmFlags & 0x40) != 0 );

	BOOL bHasNext = FALSE, bHasChainMaster = FALSE;
	if( nFrmFlags & 0x80 )
	{
		rIo.rStrm >> nFrmFlags;
		bHasNext = BOOL( (nFrmFlags & 0x01) != 0 );
		bHasChainMaster = BOOL( (nFrmFlags & 0x02) != 0 );
	}
	while( nFrmFlags & 0x80 )
		rIo.rStrm >> nFrmFlags;
	rIo.rStrm >> nX >> nY;
	aRelPos = Point( nX, nY );

	if( bHasPrev )
	{
		UINT16 nIdx;
		rIo.rStrm >> nIdx;
		SwFrm *pFrm = rIo.GetFrm( nIdx );
		ASSERT( pFrm->IsFlyFrm(), "Prev-Link ist kein Fly-Frame" );
		ASSERT( pFrm != this, "Prev-Link auf eigenen Frame" );
		if( pFrm->IsFlyFrm() && pFrm != this )
		{
			pPrevLink = (SwFlyFrm *)pFrm;
			pPrevLink->pNextLink = this;
		}
		else
			rIo.SetError();
	}
	if( bHasNext )
	{
		UINT16 nIdx;
		rIo.rStrm >> nIdx;
		SwFrm *pFrm = rIo.GetFrm( nIdx );
		ASSERT( pFrm->IsFlyFrm(), "Next-Link ist kein Fly-Frame" );
		ASSERT( pFrm != this, "Next-Link auf eigenen Frame" );
		if( pFrm->IsFlyFrm() && pFrm != this )
		{
			pNextLink = (SwFlyFrm *)pFrm;
			pNextLink->pPrevLink = this;
		}
		else
			rIo.SetError();
	}
	ASSERT( !rIo.pChainMasterFmt, "Chain-Master-Fmt nicht abgerauemt" );
	rIo.pChainMasterFmt = 0;
	if( bHasChainMaster )
	{
		UINT16 nFmtIdx;
		rIo.rStrm >> nFmtIdx;
		rIo.pChainMasterFmt = rIo.FindFmt( FRMT_STANDARD, nFmtIdx );
	}

	//Bei ungueltigen Daten zum Zeitpunkt des Speicherns wurden keine Werte
	//fuer die Rechtecke geschrieben. Die Formatierung verlaeuft guenstiger
	//wenn dann ausgezeichnete Werte bereitstehen.
	if ( !bValidPos && !aFrm.Left() && !aFrm.Top() )
		aFrm.Pos().X() = aFrm.Pos().Y() = WEIT_WECH;

	InitDrawObj( FALSE );
}


void SwFlyFrm::Store( Sw3FrameIo& rIo ) const
{
	BYTE nFrmFlags =
			bMinHeight
		| ( bInvalid	<< 1 )
		| ( bNotifyBack	<< 2 )
		| ( bWidthClipped  << 3 )
		| ( bHeightClipped << 4 )
		| ( bAutoPosition << 5 );
	BYTE nFrmFlags2 = 0;

	// Die Chain-Verkettung wird wie folgt gespeichert:
	// Wenn ein Prev existiert, der Prev-Frame aber noch nicht gespeichert
	// wurde, wird kein Prev gespeichert, aber der Frame registriert. Wenn
	// dann spaeter der Prev-Frame gespeichert wird, wird dort nach dem
	// Next gesucht und dieser gefunden. Dessen Index wird gespeichert und
	// ist dann der des aktuellen Frames.
	// Beim Einlesen des Prev-Frames wird dann die Verbindung in beide
	// Richtungen hergestellt.
	// Das Speichern und Einlesen des Next passiert auf die gleiche Weise.
	USHORT nPrevIdx = IDX_NO_VALUE, nNextIdx = IDX_NO_VALUE;
	USHORT nIncRef = 0;
	if( pPrevLink )
	{
		nPrevIdx = rIo.GetIndexNoErr( pPrevLink );
		if( IDX_NO_VALUE != nPrevIdx )
			nFrmFlags |= 0x40;	//  (1 << 6)
		else
			nIncRef++;

		// Der FrmFmt-Index des ersten Formats muss in jedem Fall noch
		// gespeichert werden, denn die Indizes der Content-Frames beziehen
		// sich auf dessen Start-Node
		nFrmFlags |= 0x80;		// (1 << 7)
		nFrmFlags2 |= 0x02;	// (1 << 2)
	}
	if( pNextLink )
	{
		nNextIdx = rIo.GetIndexNoErr( pNextLink );
		if( IDX_NO_VALUE != nNextIdx )
		{
			nFrmFlags |= 0x80;	//  (1 << 7)
			nFrmFlags2 |= 0x01;
		}
		else
		{
			nIncRef++;
		}
	}

	if( nIncRef )
	{
		rIo.AddFrm( (SwFrm *)this, nIncRef );
		rIo.SetFlag( FRMF_ISMASTER );
	}

	SwLayoutFrm::Store( rIo );
	rIo.rStrm << (BYTE)  nFrmFlags;
	if( (nFrmFlags & 0x80) != 0 )
	{
		rIo.rStrm << (BYTE)  nFrmFlags2;
	}
	rIo.rStrm << (INT32) aRelPos.A()
			  << (INT32) aRelPos.B();

	if( (nFrmFlags & 0x40) != 0 )
	{
		rIo.rStrm << (UINT16)nPrevIdx;
		rIo.DecRef( nPrevIdx );
	}
	if( (nFrmFlags2 & 0x01) != 0 )
	{
		rIo.rStrm << (UINT16)nNextIdx;
		rIo.DecRef( nNextIdx );
	}
	ASSERT( !rIo.pChainMasterFmt, "Chain-Master-Fmt nicht abgerauemt" );
	rIo.pChainMasterFmt = 0;
	if( (nFrmFlags2 & 0x02) != 0 )
	{
		BYTE nFmtType = FRMT_STANDARD;
		UINT16 nFmtIdx = IDX_NO_VALUE;

		SwFlyFrm *pChainMaster = pPrevLink;
		while( pChainMaster->pPrevLink )
			pChainMaster = pChainMaster->pPrevLink;

		rIo.pChainMasterFmt = pChainMaster->GetFmt();
		rIo.FindFmtId( rIo.pChainMasterFmt, nFmtType, nFmtIdx );
		ASSERT( FRMT_STANDARD==nFmtType, "falscher Format-Type" );
		rIo.rStrm << nFmtIdx;
	}
}

//////////////////////// Basisklasse SwFlyFreeFrm //////////////////////////


SwFlyFreeFrm::SwFlyFreeFrm( Sw3FrameIo& rIo, SwLayoutFrm* pPg )
			: SwFlyFrm( rIo, NULL )
{
	pPage  = (SwPageFrm*) pPg;
	if( rIo.nVersion < FRMVER_PAGE_PRTAREA )
	{
		_InvalidatePos();
		pPage->InvalidateFlyLayout();
	}
}


void SwFlyFreeFrm::Store( Sw3FrameIo& rIo ) const
{
	SwFlyFrm::Store( rIo );
}

/////////////////////////////// SwFlyLayFrm ////////////////////////////////


SwFlyLayFrm::SwFlyLayFrm( Sw3FrameIo& rIo, SwLayoutFrm* pPg )
		   : SwFlyFreeFrm( rIo, pPg )
{
	bLayout = TRUE;
	USHORT nFlyColsSave = rIo.nFlyCols;
	rIo.nFlyCols = 0;
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		LoadLower( rIo );
	}

	// MIB: Anzahl der Spalten auch in Fly-Frames checken
	// (siehe auch bug 19614)
	USHORT nFmtNumCols = GetFmt()->GetCol().GetNumCols();
	if( ( 1 == nFmtNumCols ? 0 : nFmtNumCols ) != rIo.nFlyCols )
		rIo.SetError();

	rIo.nFlyCols = nFlyColsSave;
}


void SwFlyLayFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_FLYLAY );
	SwFlyFreeFrm::Store( rIo );
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		StoreLower( rIo );
	}
	rIo.CloseRec( SWG_FRM_FLYLAY );
}

///////////////////////////// SwFlyAtCntFrm ///////////////////////////////


SwFlyAtCntFrm::SwFlyAtCntFrm( Sw3FrameIo& rIo, SwLayoutFrm* pPg )
			 : SwFlyFreeFrm( rIo, pPg )
{
	USHORT nFlyColsSave = rIo.nFlyCols;
	bAtCnt = TRUE;
	rIo.nFlyCols = 0;
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		LoadLower( rIo );
	}

	// MIB: Anzahl der Spalten auch in Fly-Frames checken
	// (siehe auch bug 19614)
	USHORT nFmtNumCols = GetFmt()->GetCol().GetNumCols();
	if( ( 1 == nFmtNumCols ? 0 : nFmtNumCols ) != rIo.nFlyCols )
		rIo.SetError();

	rIo.nFlyCols = nFlyColsSave;
}


void SwFlyAtCntFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_FLYATCNT );
	SwFlyFreeFrm::Store( rIo );
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		StoreLower( rIo );
	}
	rIo.CloseRec( SWG_FRM_FLYATCNT );
}

/////////////////////////////// SwFlyInCntFrm //////////////////////////////

// BYTE			Flags
// INT32		Position X
// INT32		Position Y


SwFlyInCntFrm::SwFlyInCntFrm( Sw3FrameIo& rIo, SwLayoutFrm* p )
			 : SwFlyFrm( rIo, NULL )
{
	bInCnt = TRUE;
	BYTE nFrmFlags;
	INT32 nX, nY;
	rIo.rStrm >> nFrmFlags;
	bInvalidLayout = BOOL( nFrmFlags );
	bInvalidCntnt  = BOOL( nFrmFlags >> 1 );
	while( nFrmFlags & 0x80 )
		rIo.rStrm >> nFrmFlags;
	rIo.rStrm >> nX >> nY;
	aRef = Point( nX, nY );

	//Drucker gewechselt, Inhalt invalidieren.
	if ( rIo.GetIoImp().bPrtChanged )
		bInvalidCntnt = TRUE;

	USHORT nFlyColsSave = rIo.nFlyCols;
	rIo.nFlyCols = 0;
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		LoadLower( rIo );
	}

	rIo.rStrm >> nLine;

	// MIB: Anzahl der Spalten auch in Fly-Frames checken
	// (siehe auch bug 19614)
	USHORT nFmtNumCols = GetFmt()->GetCol().GetNumCols();
	if( ( 1 == nFmtNumCols ? 0 : nFmtNumCols ) != rIo.nFlyCols )
		rIo.SetError();

	rIo.nFlyCols = nFlyColsSave;
}


void SwFlyInCntFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_FLYINCNT );
	BYTE nFrmFlags = bInvalidLayout | ( bInvalidCntnt << 1 );
	SwFlyFrm::Store( rIo );
	rIo.rStrm << (BYTE) nFrmFlags
			  << (INT32) aRef.A()
			  << (INT32) aRef.B();
	{
		Sw3StartNodeSwitch aSwitch( rIo, *this );
		StoreLower( rIo );
	}
	rIo.rStrm << (INT32) nLine;
	rIo.CloseRec( SWG_FRM_FLYINCNT );
}

//////////////////////////////// SwSectionTabFrm /////////////////////////////

SwSectionFrm::SwSectionFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		: SwLayoutFrm( rIo, pUpr ), SwFlowFrm( (SwFrm&) *this )
{
	nType     = FRM_SECTION;
	bUndersized = TRUE;
	pSection = GetFmt() ? ((SwSectionFmt *)GetFmt())->GetSection() : 0;
	if( !pSection )
	{
		ASSERT( !this, "Section ist kein Bereich" );
		rIo.SetError();
		pSection = NULL;
	}
	else
		pSection->bHiddenFlag = FALSE;
	if( GetFmt() )
	{
		CalcFtnAtEndFlag();
		CalcEndAtEndFlag();
	}
	else
		bFtnAtEnd = bEndnAtEnd = FALSE;

	lcl_sw3io_initFlowFrm( rIo, this );
	LoadLower( rIo );
}

void SwSectionFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_SECTION );
	lcl_sw3io_prepareStoreFlowFrm( rIo, this );
	SwLayoutFrm::Store( rIo );
	StoreLower( rIo );
	rIo.CloseRec( SWG_FRM_SECTION );
}

//////////////////////////////// SwTabFrm /////////////////////////////////

// UINT16			Section-ID der Table
// UINT16			1. Zeilennr.


SwTabFrm::SwTabFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		: SwLayoutFrm( rIo, pUpr ), SwFlowFrm( (SwFrm&) *this )
{
	nType     = FRM_TAB;
	bLockJoin = bComplete = bCalcLowers = bONECalcLowers = bLowersFormatted =
	bLockBackMove = bResizeHTMLTable = FALSE;
	UINT16 nRow1;

	BYTE nFrmFlags;
	rIo.rStrm >> nFrmFlags;
	bIsFollow = BOOL( nFrmFlags );
	while( nFrmFlags & 0x80 )
		rIo.rStrm >> nFrmFlags;

	rIo.rStrm >> nRow1;

	ASSERT( GetFmt(), "Kein Tabellen-Format?" );
	SwClientIter aIter( *GetFmt() );
	pTable = (SwTable *)aIter.First( TYPE(SwTable) );

	if( pTable )
	{
		// Zeilen-Hilfsvariablen besetzen
		rIo.pLines = &pTable->GetTabLines();
		rIo.nLine  = nRow1;
		// bRow1 is TRUE, wenn in Follow-Frames die 1. Zeile gespiegelt ist
		rIo.bRow1 = BOOL( bIsFollow && pTable->IsHeadlineRepeat() );
	}
	else
	{
		ASSERT( !this, "Section ist keine Tabelle" );
		rIo.SetError();
		pTable = NULL;
	}
	lcl_sw3io_initFlowFrm( rIo, this );
	rIo.SetInTableLayout( TRUE );
	LoadLower( rIo );
	rIo.SetInTableLayout( FALSE );
}

// Tabellen: Layout + Index der Tabelle


void SwTabFrm::Store( Sw3FrameIo& rIo ) const
{
	// 1. angezeigte Reihe finden
	BOOL bHasHdr = pTable->IsHeadlineRepeat();
	const SwRowFrm* pRow1 = (const SwRowFrm*) pLower;
	// Falls die erste Zeile spiegelt, dann ist Row1 die Zeile
	// des nachfolgenden RowFrm
	if( bIsFollow && bHasHdr )
		pRow1 = (const SwRowFrm*) pLower->GetNext();
	const SwTableLine* pLine = pRow1->GetTabLine();
	const SwTableLines& rLines = pTable->GetTabLines();
	for( UINT16 nRow1 = 0; nRow1 < rLines.Count(); nRow1++ )
		if( rLines[ nRow1 ] == pLine )
			break;
	if( nRow1 == rLines.Count() )
	{
		ASSERT( !this, "SwTabFrm::Save: Zeile nicht gefunden!" );
		rIo.SetError();
		nRow1 = 0;
	}
	// Master/Follow-Relationship registrieren
	lcl_sw3io_prepareStoreFlowFrm( rIo, this );

	// Das IsFollow-Flag muss hier mit rausgeschrieben werden, weil
	// es beim Laden schon bebraucht wird, bevor die Verkettung des
	// Follows existiert.
	BYTE nFrmFlags = bIsFollow;

	rIo.OpenRec( SWG_FRM_TAB );
	SwLayoutFrm::Store( rIo );
	rIo.rStrm << (BYTE)nFrmFlags
			  << nRow1;
	StoreLower( rIo );
	rIo.CloseRec( SWG_FRM_TAB );
}

///////////////////////////////// SwRowFrm /////////////////////////////////


SwRowFrm::SwRowFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		 :SwLayoutFrm( rIo, pUpr ), pTabLine( NULL )
{
	nType = FRM_ROW;
	// Falls in einem Folge-Frame die 1. Zeile gespiegelt ist,
	// dann ist fuer den 1. RowFrm die 1. Tabellenzeile zu nehmen
	USHORT n = rIo.bRow1 ? 0 : rIo.nLine++;
	rIo.bRow1 = FALSE;
	// Konsistenztest:
	if( n < rIo.pLines->Count() )
	{
		pTabLine = (*rIo.pLines)[ n ];
		pTabLine->GetFrmFmt()->Add( this );

		// Aktuelle Positionen retten
		const SwTableBoxes* pBoxes = rIo.pBoxes;
		short nBox	= rIo.nBox;
		rIo.pBoxes	= &pTabLine->GetTabBoxes();
		rIo.nBox 	= 0;
		LoadLower( rIo );
		rIo.pBoxes 	= pBoxes;
		rIo.nBox   	= nBox;
	}
	else
	{
		ASSERT( !this, "Zu viele Tabellenzeilen" );
		rIo.SetError();
	}
}


void SwRowFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_ROW );
	SwLayoutFrm::Store( rIo );
	StoreLower( rIo );
	rIo.CloseRec( SWG_FRM_ROW );
}

//////////////////////////////// SwCellFrm ////////////////////////////////


SwCellFrm::SwCellFrm( Sw3FrameIo& rIo, SwLayoutFrm* pUpr )
		 : SwLayoutFrm( rIo, pUpr ), pTabBox( NULL )
{
	nType = FRM_CELL;
	// Konsistenztest:
	if( rIo.nBox < rIo.pBoxes->Count() )
	{
		pTabBox = (*rIo.pBoxes)[ rIo.nBox++ ];
		pTabBox->GetFrmFmt()->Add( this );

		const SwTableLines* pLines = rIo.pLines;
		short nLine = rIo.nLine;
		rIo.pLines	= &pTabBox->GetTabLines();
		rIo.nLine	= 0;
		BOOL bInTableLayout = rIo.GetInTableLayout();
		rIo.SetInTableLayout( FALSE );
		if( pTabBox->GetSttNd() )
		{
			Sw3StartNodeSwitch aSwitch( rIo, pTabBox->GetSttNd()->GetIndex() );
			LoadLower( rIo );
		}
		else
		{
			LoadLower( rIo );
		}

		rIo.SetInTableLayout( bInTableLayout );
		rIo.pLines = pLines;
		rIo.nLine  = nLine;
	}
	else
	{
		ASSERT( !this, "Zu viele Tabellenzellen" );
		rIo.SetError();
	}
}


void SwCellFrm::Store( Sw3FrameIo& rIo ) const
{
	rIo.OpenRec( SWG_FRM_CELL );
	SwLayoutFrm::Store( rIo );

	ASSERT( GetTabBox(), "CellFrm ohne Box?" );
	if( GetTabBox() && GetTabBox()->GetSttNd() )
	{
		Sw3StartNodeSwitch aSwitch( rIo, GetTabBox()->GetSttNd()->GetIndex() );
		StoreLower( rIo );
	}
	else
	{
		StoreLower( rIo );
	}
	rIo.CloseRec( SWG_FRM_CELL );
}

/*  */

Sw3StartNodeSwitch::Sw3StartNodeSwitch( Sw3FrameIo& rIo, ULONG nNewIdx ) :
	rFrameIo( rIo ), nStartNodeIdxSave( rIo.GetStartNodeIndex() )
{
	rIo.SetStartNodeIndex( nNewIdx );
}

Sw3StartNodeSwitch::Sw3StartNodeSwitch( Sw3FrameIo& rIo,
										const SwLayoutFrm& rFrm ) :
	rFrameIo( rIo ), nStartNodeIdxSave( rIo.GetStartNodeIndex() )
{
	ASSERT( rFrm.GetFmt(), "Format erwartet?" );
	const SwFrmFmt *pFmt = rIo.pChainMasterFmt ? rIo.pChainMasterFmt
											   : rFrm.GetFmt();
	if( pFmt )
	{
		const SwFmtCntnt& rCntnt = pFmt->GetCntnt();
		ASSERT( rCntnt.GetCntntIdx(), "StartNode erwartet" );
		if( rCntnt.GetCntntIdx() )
			rIo.SetStartNodeIndex( rCntnt.GetCntntIdx()->GetIndex() );
		else
			rIo.SetError();
	}
	else
		rIo.SetError();

	rIo.pChainMasterFmt = 0;
}

Sw3StartNodeSwitch::Sw3StartNodeSwitch( Sw3FrameIo& rIo,
										const SwNodeIndex *pNdIdx ) :
	rFrameIo( rIo ), nStartNodeIdxSave( rIo.GetStartNodeIndex() )
{
	ASSERT( pNdIdx, "Node-Index erwartet" );
	if( pNdIdx )
		rIo.SetStartNodeIndex( pNdIdx->GetIndex() );
	else
		rIo.SetError();
}

