/*************************************************************************
 *
 *  $RCSfile: sw3frmio.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:08:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SW3FRMIO_HXX
#define _SW3FRMIO_HXX

#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif

#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>

// Versionen der Layout-Info

class SwDoc;
class SvStream;
class SwFrm;
class SwLayoutFrm;
class SwStartNode;
class SwCntntNode;
class SwPageDesc;
class Sw3IoImp;
class SwTableLines;
class SwTableBoxes;
class SdrPage;
class SwPageFrm;
class SwFrmFmt;
class SwTable;
class SwNodeIdx;

typedef SwFrm *SwFrmPtr;
SV_DECL_PTRARR(Sw3Frms,SwFrmPtr,10,10)

typedef SwStartNode *SwStartNodePtr;
SV_DECL_PTRARR(Sw3Sections,SwStartNodePtr,10,50)

class Sw3FrameIo
{
	Sw3Frms		aNewFrms;
	Sw3Frms		aFollows;
	SvUShorts	aRefCounts;


	Sw3IoImp&   rIo;
	BOOL 		bErr;
	ULONG		nStartNodeIdx;		// Basis fuer Node-Indizes

	USHORT _GetIndex( Sw3Frms&, SwFrm*, BOOL bDecRef );
	USHORT _GetIndexNoErr( Sw3Frms&, SwFrm* );

	// An wenigen Stellen oft gerufen, deshalb dort inline
	inline void	_DecRef( USHORT nIdx );

public:
	SvStream& rStrm;				// I/O-Stream
	SwDoc*	  pDoc;					// aktuelles Doc
	SdrPage*  pDrawPage;			// aktuelle DrawPage
	SwPageFrm* pPage;				// aktuelle Seite
	USHORT	  nVersion;				// Versionsnummer
	USHORT	  nGblFlags;			// globale Flags eines Frames
	const 	  SwTableLines* pLines;	// aktuelles Zeilen-Array
	const	  SwTableBoxes* pBoxes;	// aktuelle Zellen-Array
	USHORT    nLine;			   	// Aktuelle Zeile
	USHORT    nBox;				   	// Aktuelle Zelle
	USHORT    nPageCols;			// Spalten einer Seite
	USHORT    nFlyCols;				// Spalten eines Rahmens
	BOOL 	  bRow1;			    // True bei 1. RowFrm in Tabelle
	SwFrm* 	  pMaster;				// Einlesen: Master-Frm
	SwFrm*	  pFollow;				// Schreiben: Follow-Frm
	const SwFrmFmt* pChainMasterFmt; // Lesen/Schreiben:

	void	  SetFlag( USHORT n )	{ nGblFlags |= n; }
	BOOL	  IsFlag( USHORT n )	{ return( ( nGblFlags & n ) != 0 ); }
	Sw3FrameIo( Sw3IoImp& );

	void   SetError()
#ifdef PRODUCT
		{ bErr = TRUE; }
#else
		// damit beim debuggen ein BreakPoint gesetzt werden kann
		;
#endif
	BOOL   IsError()  { return bErr; }

	const Sw3IoImp &GetIoImp() const { return rIo; }

	inline USHORT GetIndex( SwFrm*, BOOL bDecRef );
	inline USHORT GetMasterIndex( SwFrm*, BOOL bDecRef );
	inline USHORT GetIndexNoErr( SwFrm* );
	inline USHORT GetMasterIndexNoErr( SwFrm* );
	SwFrm* GetFrm( USHORT );
	USHORT AddFrm( SwFrm*, USHORT nIncRef );
	void DecRef( USHORT nPos );
	void   RegisterFrm( SwFrm*, USHORT );
	void   SetFollow( USHORT, SwFrm* );

	SwFrmFmt* MakeFmt( const String& rName );
	SwFrmFmt* FindFmt( BYTE, UINT16 );
	void  FindFmtId( const SwFrmFmt*, BYTE&, UINT16& );

	SwPageDesc* FindPageDesc( USHORT );
	USHORT FindPageDescId( const SwPageDesc* );

	void SetStartNodeIndex( ULONG n ) { nStartNodeIdx = n; }
	ULONG GetStartNodeIndex() const { return nStartNodeIdx; }

	ULONG GetNodeId( SwCntntNode* p );
	SwCntntNode* FindNode( ULONG nOff );

	SwFrm* InFrame( SwLayoutFrm* );
	void OutFrame( const SwFrm* );

	void SetPercentBar( USHORT, BOOL );
	void OpenRec( BYTE );
	void CloseRec( BYTE );

	void SetInTableLayout( BOOL bSet );
	BOOL GetInTableLayout() const;

	void CheckRefCnts();
};

inline USHORT Sw3FrameIo::GetIndex( SwFrm *pFrm, BOOL bDecRef )
{
	return _GetIndex( aNewFrms, pFrm, bDecRef );
}

inline USHORT Sw3FrameIo::GetMasterIndex( SwFrm *pFrm, BOOL bDecRef )
{
	return _GetIndex( aFollows, pFrm, bDecRef );
}

inline USHORT Sw3FrameIo::GetIndexNoErr( SwFrm *pFrm )
{
	return _GetIndexNoErr( aNewFrms, pFrm );
}

inline USHORT Sw3FrameIo::GetMasterIndexNoErr( SwFrm *pFrm )
{
	return _GetIndexNoErr( aFollows, pFrm );
}

inline void Sw3FrameIo::_DecRef( USHORT nIdx )
{
	aRefCounts[nIdx]--;
	if( !aRefCounts[nIdx] )
	{
		aNewFrms.Replace( (SwFrm *)0, nIdx );
		aFollows.Replace( (SwFrm *)0, nIdx );
	}
}

#endif
