/*************************************************************************
 *
 *  $RCSfile: txtatr0.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:08:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "core_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"
#include "swtypes.hxx"

#ifndef _SVX_FONTITEM_HXX //autogen
#include <svx/fontitem.hxx>
#endif
#ifndef _SVX_POSTITEM_HXX //autogen
#include <svx/postitem.hxx>
#endif
#ifndef _SVX_WGHTITEM_HXX //autogen
#include <svx/wghtitem.hxx>
#endif
#ifndef _SVX_UDLNITEM_HXX //autogen
#include <svx/udlnitem.hxx>
#endif
#ifndef _SVX_FHGTITEM_HXX //autogen
#include <svx/fhgtitem.hxx>
#endif
#ifndef _TXTATR_HXX //autogen
#include <txtatr.hxx>
#endif
#include "swfont.hxx"



/*************************************************************************
 *						class SwTxtFont
 *************************************************************************/

SwTxtFont::~SwTxtFont( )
{}

SwTxtFont::SwTxtFont( const SvxFontItem& rAttr, xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtFont::ChgFnt(SwFont *pFont)
{
	aPrevName = pFont->GetName( SW_LATIN );
	aPrevStyleName = pFont->GetStyleName( SW_LATIN );
	ePrevFamily = pFont->GetFamily( SW_LATIN );
	ePrevPitch = pFont->GetPitch( SW_LATIN );
	ePrevCharSet = pFont->GetCharSet( SW_LATIN );
	const SvxFontItem& rAttr = GetFont();
	pFont->SetName( rAttr.GetFamilyName(), SW_LATIN );
	pFont->SetStyleName( rAttr.GetStyleName(), SW_LATIN );
	pFont->SetFamily( rAttr.GetFamily(), SW_LATIN );
	pFont->SetPitch( rAttr.GetPitch(), SW_LATIN );
	pFont->SetCharSet( rAttr.GetCharSet(), SW_LATIN );
}

void SwTxtFont::RstFnt(SwFont *pFont)
{
	pFont->SetName( aPrevName, SW_LATIN );
	pFont->SetStyleName( aPrevStyleName, SW_LATIN );
	pFont->SetFamily( ePrevFamily, SW_LATIN );
	pFont->SetPitch( ePrevPitch, SW_LATIN );
	pFont->SetCharSet( ePrevCharSet, SW_LATIN );
}

void SwTxtFont::ChgTxtAttr( SwTxtAttr &rAttr )
{
	const SvxFontItem& rFont = rAttr.GetFont();
	aPrevName = rFont.GetFamilyName();
	aPrevStyleName = rFont.GetStyleName();
	ePrevFamily = rFont.GetFamily();
	ePrevPitch = rFont.GetPitch();
	ePrevCharSet = rFont.GetCharSet();
	const SvxFontItem& rFnt = GetFont();
	SwTxtFont& rOther = (SwTxtFont&)rAttr;
	rOther.aPrevName = rFnt.GetFamilyName();
	rOther.aPrevStyleName = rFnt.GetStyleName();
	rOther.ePrevFamily = rFnt.GetFamily();
	rOther.ePrevPitch = rFnt.GetPitch();
	rOther.ePrevCharSet = rFnt.GetCharSet();
}

void SwTxtFont::RstTxtAttr( SwTxtAttr &rAttr )
{
	SwTxtFont& rOther = (SwTxtFont&)rAttr;
	rOther.aPrevName = aPrevName;
	rOther.aPrevStyleName = aPrevStyleName;
	rOther.ePrevFamily = ePrevFamily;
	rOther.ePrevPitch = ePrevPitch;
	rOther.ePrevCharSet = ePrevCharSet;
}

/*************************************************************************
 *						class SwTxtPosture
 *************************************************************************/

SwTxtPosture::SwTxtPosture( const SvxPostureItem& rAttr,
							xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtPosture::ChgFnt(SwFont *pFont)
{
	ePrevPosture = pFont->GetItalic( SW_LATIN );
	pFont->SetItalic( GetPosture().GetPosture(), SW_LATIN );
}

void SwTxtPosture::RstFnt(SwFont *pFont)
{
	pFont->SetItalic( ePrevPosture, SW_LATIN );
}

void SwTxtPosture::ChgTxtAttr( SwTxtAttr &rAttr )
{
	ePrevPosture = ((SwTxtPosture&)rAttr).ePrevPosture;
	((SwTxtPosture&)rAttr).ePrevPosture = GetPosture().GetPosture();
}

void SwTxtPosture::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtPosture&)rAttr).ePrevPosture = ePrevPosture;
}


/*************************************************************************
 *						class SwTxtWeight
 *************************************************************************/

SwTxtWeight::SwTxtWeight( const SvxWeightItem& rAttr,
						xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtWeight::ChgFnt(SwFont *pFont)
{
	ePrevWeight = pFont->GetWeight( SW_LATIN );
	pFont->SetWeight( GetWeight().GetWeight(), SW_LATIN );
}

void SwTxtWeight::RstFnt(SwFont *pFont)
{
	pFont->SetWeight( ePrevWeight, SW_LATIN );
}

void SwTxtWeight::ChgTxtAttr( SwTxtAttr &rAttr )
{
	ePrevWeight = ((SwTxtWeight&)rAttr).ePrevWeight;
	((SwTxtWeight&)rAttr).ePrevWeight = GetWeight().GetWeight();
}

void SwTxtWeight::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtWeight&)rAttr).ePrevWeight = ePrevWeight;
}

/*************************************************************************
 *						class SwTxtUnderline
 *************************************************************************/

SwTxtUnderline::SwTxtUnderline( const SvxUnderlineItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtUnderline::ChgFnt(SwFont *pFont)
{
	ePrevUnderline = pFont->GetUnderline();
	pFont->SetUnderline( GetUnderline().GetUnderline() );
}

void SwTxtUnderline::RstFnt(SwFont *pFont)
{
	pFont->SetUnderline(ePrevUnderline);
}

void SwTxtUnderline::ChgTxtAttr( SwTxtAttr &rAttr )
{
	ePrevUnderline = ((SwTxtUnderline&)rAttr).ePrevUnderline;
	((SwTxtUnderline&)rAttr).ePrevUnderline = GetUnderline().GetUnderline();
}

void SwTxtUnderline::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtUnderline&)rAttr).ePrevUnderline = ePrevUnderline;
}

/*************************************************************************
 *						class SwTxtSize
 *************************************************************************/

SwTxtSize::SwTxtSize( const SvxFontHeightItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtSize::ChgFnt(SwFont *pFont)
{
	aPrevSize = pFont->GetSize( SW_LATIN );
	Size aTmpSize = aPrevSize;
	aTmpSize.Height() = GetFontSize().GetHeight();
	pFont->SetSize( aTmpSize, SW_LATIN );
}

void SwTxtSize::RstFnt(SwFont *pFont)
{
	pFont->SetSize( aPrevSize, SW_LATIN );
}

void SwTxtSize::ChgTxtAttr( SwTxtAttr &rAttr )
{
	aPrevSize = ((SwTxtSize&)rAttr).aPrevSize;
	Size aTmpSize = aPrevSize;
	aTmpSize.Height() = GetFontSize().GetHeight();
	((SwTxtSize&)rAttr).aPrevSize = aTmpSize;
}

void SwTxtSize::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtSize&)rAttr).aPrevSize = aPrevSize;
}



