/*************************************************************************
 *
 *  $RCSfile: txtatr1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:08:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "core_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"

#ifndef _SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif

#ifndef _SVX_CNTRITEM_HXX //autogen
#include <svx/cntritem.hxx>
#endif
#ifndef _SVX_CRSDITEM_HXX //autogen
#include <svx/crsditem.hxx>
#endif
#ifndef _SVX_CSCOITEM_HXX //autogen
#include <svx/cscoitem.hxx>
#endif
#ifndef _SVX_WRLMITEM_HXX //autogen
#include <svx/wrlmitem.hxx>
#endif
#ifndef _SVX_AKRNITEM_HXX //autogen
#include <svx/akrnitem.hxx>
#endif
#ifndef _SVX_SHDDITEM_HXX //autogen
#include <svx/shdditem.hxx>
#endif
#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif
#ifndef _TXTATR_HXX //autogen
#include <txtatr.hxx>
#endif
#ifndef _FMTHBSH_HXX //autogen
#include <fmthbsh.hxx>
#endif
#include "swfont.hxx"

/*************************************************************************
 *						class SwTxtCrossedOut
 *************************************************************************/

SwTxtCrossedOut::SwTxtCrossedOut( const SvxCrossedOutItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtCrossedOut::ChgFnt(SwFont *pFont)
{
	ePrevCrossedOut = pFont->GetStrikeout();
	pFont->SetStrikeout( GetCrossedOut().GetStrikeout() );
}

void SwTxtCrossedOut::RstFnt(SwFont *pFont)
{
	pFont->SetStrikeout(ePrevCrossedOut);
}

void SwTxtCrossedOut::ChgTxtAttr( SwTxtAttr &rAttr )
{
	ePrevCrossedOut = ((SwTxtCrossedOut&)rAttr).ePrevCrossedOut;
	((SwTxtCrossedOut&)rAttr).ePrevCrossedOut = GetCrossedOut().GetStrikeout();
}

void SwTxtCrossedOut::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtCrossedOut&)rAttr).ePrevCrossedOut = ePrevCrossedOut;
}

/*************************************************************************
 *						class SwTxtColor
 *************************************************************************/

SwTxtColor::SwTxtColor( const SvxColorItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtColor::ChgFnt(SwFont *pFont)
{
	const SvxColorItem& rAttr = GetColor();
	aPrevColor = pFont->GetColor();
	pFont->SetColor( rAttr.GetValue() );
}

void SwTxtColor::RstFnt(SwFont *pFont)
{
	pFont->SetColor( aPrevColor );
}

void SwTxtColor::ChgTxtAttr( SwTxtAttr &rAttr )
{
	aPrevColor = ((SwTxtColor&)rAttr).aPrevColor;
	((SwTxtColor&)rAttr).aPrevColor = GetColor().GetValue();
}

void SwTxtColor::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtColor&)rAttr).aPrevColor = aPrevColor;
}

/*************************************************************************
 *                      class SwTxtCharSetColor
 *************************************************************************/

SwTxtCharSetColor::SwTxtCharSetColor( const SvxCharSetColorItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtCharSetColor::ChgFnt(SwFont *pFont)
{
	ASSERT( FALSE, "CharSetColor???" );
}

void SwTxtCharSetColor::RstFnt(SwFont *pFont)
{
	ASSERT( FALSE, "CharSetColor???" );
}

void SwTxtCharSetColor::ChgTxtAttr( SwTxtAttr &rAttr )
{
	ASSERT( FALSE, "CharSetColor???" );
}

void SwTxtCharSetColor::RstTxtAttr( SwTxtAttr &rAttr )
{
	ASSERT( FALSE, "CharSetColor???" );
}

SwTxtCharSetColor::~SwTxtCharSetColor()
{
}

/*************************************************************************
 *						class SwTxtShadowed
 *************************************************************************/

SwTxtShadowed::SwTxtShadowed( const SvxShadowedItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtShadowed::ChgFnt(SwFont *pFont)
{
	bPrevShadow = pFont->IsShadow();
	pFont->SetShadow( GetShadowed().GetValue() );
}

void SwTxtShadowed::RstFnt(SwFont *pFont)
{
	pFont->SetShadow( bPrevShadow );
}

void SwTxtShadowed::ChgTxtAttr( SwTxtAttr &rAttr )
{
	bPrevShadow = ((SwTxtShadowed&)rAttr).bPrevShadow;
	((SwTxtShadowed&)rAttr).bPrevShadow = GetShadowed().GetValue();
}

void SwTxtShadowed::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtShadowed&)rAttr).bPrevShadow = bPrevShadow;
}

/*************************************************************************
 *						class SwTxtAutoKern
 *************************************************************************/

SwTxtAutoKern::SwTxtAutoKern( const SvxAutoKernItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtAutoKern::ChgFnt(SwFont *pFont)
{
	bPrevAutoKern = pFont->IsKerning();
	pFont->SetAutoKern( GetAutoKern().GetValue() );
}

void SwTxtAutoKern::RstFnt(SwFont *pFont)
{
	pFont->SetAutoKern( bPrevAutoKern );
}

/*************************************************************************
 *						class SwTxtWordLineMode
 *************************************************************************/

SwTxtWordLineMode::SwTxtWordLineMode( const SvxWordLineModeItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtWordLineMode::ChgFnt(SwFont *pFont)
{
	bPrevWordLineMode = pFont->IsWordLineMode();
	pFont->SetWordLineMode( GetWordLineMode().GetValue() );
}

void SwTxtWordLineMode::RstFnt(SwFont *pFont)
{
	pFont->SetWordLineMode( bPrevWordLineMode );
}

void SwTxtWordLineMode::ChgTxtAttr( SwTxtAttr &rAttr )
{
	bPrevWordLineMode = ((SwTxtWordLineMode&)rAttr).bPrevWordLineMode;
	((SwTxtWordLineMode&)rAttr).bPrevWordLineMode = GetWordLineMode().GetValue();
}

void SwTxtWordLineMode::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtWordLineMode&)rAttr).bPrevWordLineMode = bPrevWordLineMode;
}

/*************************************************************************
 *						class SwTxtContour
 *************************************************************************/

SwTxtContour::SwTxtContour( const SvxContourItem& rAttr,
					xub_StrLen nStart, xub_StrLen nEnd )
	: SwTxtAttrEnd( rAttr, nStart, nEnd )
{}

void SwTxtContour::ChgFnt(SwFont *pFont)
{
	bPrevContour = pFont->IsOutline();
	pFont->SetOutline( GetContour().GetValue() );
}

void SwTxtContour::RstFnt(SwFont *pFont)
{
	pFont->SetOutline(bPrevContour);
}

void SwTxtContour::ChgTxtAttr( SwTxtAttr &rAttr )
{
	bPrevContour = ((SwTxtContour&)rAttr).bPrevContour;
	((SwTxtContour&)rAttr).bPrevContour = GetContour().GetValue();
}

void SwTxtContour::RstTxtAttr( SwTxtAttr &rAttr )
{
	((SwTxtContour&)rAttr).bPrevContour = bPrevContour;
}

/*************************************************************************
 *						class SwTxtHardBlank
 *************************************************************************/

SwTxtHardBlank::SwTxtHardBlank( const SwFmtHardBlank& rAttr, xub_StrLen nStart )
	: SwTxtAttr( rAttr, nStart ),
	cChar( rAttr.GetChar() )
{
	ASSERT( ' ' != cChar && '-' != cChar,
			"Invalid character for the HardBlank attribute - "
			"must be a normal unicode character" );
}

