/*************************************************************************
 *
 *  $RCSfile: xmldrope.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:15:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XMLDROP_HXX
#define _XMLDROP_HXX

#ifdef XML_CORE_API

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef _XMLOFF_ATTRLIST_HXX
#include <xmloff/attrlist.hxx>
#endif

class SvXMLNamespaceMap;
class SvXMLUnitConverter;
class SwFmtDrop;

class SwXMLFmtDropExport
{
	const ::rtl::OUString								sCDATA;

	// the handlers
	::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XDocumentHandler >	xHandler;
	
	// a common attribute list
	SvXMLAttributeList									*pAttrList;

	// and an interface of it
	::com::sun::star::uno::Reference<
		::com::sun::star::xml::sax::XAttributeList > 	xAttrList;
	
	// the namepspace map
	const SvXMLNamespaceMap								*pNamespaceMap;
	const SvXMLUnitConverter&							rUnitConv;

protected:
	
	// Check if common attribute list is empty.
#ifdef PRODUCT
	void CheckAttrList() {}
#else
	void CheckAttrList();
#endif
	void ClearAttrList();
	void AddAttribute( sal_uInt16 nPrefixKey, const sal_Char *pName,
					   const ::rtl::OUString& rValue );
	::rtl::OUString GetQNameByKey( sal_uInt16 nKey,
								   const ::rtl::OUString& rLocalName ) const;
public:

	SwXMLFmtDropExport(
		const ::com::sun::star::uno::Reference<
				::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
		const SvXMLUnitConverter& rUnitConverter );
	~SwXMLFmtDropExport();
	
	// core API
	void exportXML( const SwFmtDrop& rItem,
					const SvXMLNamespaceMap& rNamespMap );
};

#endif


#endif
