/*************************************************************************
 *
 *  $RCSfile: xmlectxt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:15:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "filt_pch.hxx"
#endif

#pragma hdrstop

#ifdef XML_CORE_API

#ifndef _PAM_HXX //autogen wg. SwPosition
#include <pam.hxx>
#endif

#ifndef _XMLEXP_HXX
#include <xmlexp.hxx>
#endif
#ifndef _XMLECTXT_HXX
#include <xmlectxt.hxx>
#endif

SwXMLExpContext::SwXMLExpContext( SwXMLExport& rExp,
								  SwNode& rStartNd, SwNode& rEndNd,
								  xub_StrLen nStartCnt, xub_StrLen nEndCnt ) :
	rExport( rExp ),
	pCurPaM( rExp.pCurPaM )
{
	SwPosition aStartPos( rStartNd );
	if( rStartNd.IsCntntNode() )
		aStartPos.nContent.Assign( rStartNd.GetCntntNode(), nStartCnt );

	SwPosition aEndPos( rEndNd );
	if( rEndNd.IsCntntNode() )
	{
		if( STRING_LEN == nEndCnt )
			rEndNd.GetCntntNode()->MakeEndIndex( &aEndPos.nContent );
		else
			aEndPos.nContent.Assign( rEndNd.GetCntntNode(), nEndCnt );
	}

	rExport.pCurPaM = new SwPaM( aEndPos, aStartPos );
}

SwXMLExpContext::~SwXMLExpContext()
{
	delete rExport.pCurPaM;
	rExport.pCurPaM = pCurPaM;
}

#endif

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/filter/xml/xmlectxt.cxx,v 1.1.1.1 2000/09/18 17:15:00 hr Exp $

	  Source Code Control System - Update

	  $Log: xmlectxt.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:15:00  hr
	  initial import
	
	  Revision 1.6  2000/09/18 16:05:05  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.5  2000/07/31 09:42:35  mib
	  text export continued
	
	  Revision 1.4  2000/05/03 12:08:05  mib
	  unicode
	
	  Revision 1.3  2000/03/13 14:33:44  mib
	  UNO3
	
	  Revision 1.2  1999/11/26 11:08:59  mib
	  progress, export-flags
	
	  Revision 1.1  1999/08/13 14:17:50  MIB
	  Initial revision.
	

	  Rev 1.0   13 Aug 1999 16:17:50   MIB
   Initial revision.

*************************************************************************/

