/*************************************************************************
 *
 *  $RCSfile: swcomlib.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//Kein precompiled includen

#pragma hdrstop


#define _SWLIB_CXX

#ifndef _SFX_OBJFAC_HXX //autogen
#include <sfx2/docfac.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <sfx2/docfilt.hxx>
#endif
#ifndef _EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _LIBCALL_HXX
#include <svtools/libcall.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _PARHTML_HXX //autogen
#include <svtools/parhtml.hxx>
#endif
#ifndef _LIBCALL_HXX //autogen
#include <svtools/libcall.hxx>
#endif
#ifndef _SO_CLSIDS_HXX
#include <so3/clsids.hxx>
#endif

#ifndef _SWMODULE_HXX //autogen
#include <swmodule.hxx>
#endif
#ifndef _SWWDOCSH_HXX //autogen
#include <wdocsh.hxx>
#endif
#ifndef _SWGLOBDOCSH_HXX //autogen
#include <globdoc.hxx>
#endif
#ifndef _SHELLIO_HXX //autogen
#include <shellio.hxx>
#endif
#include <swdll.hxx>
#include "iodetect.hxx"

#include <app.hrc>
#include <web.hrc>
#include <globdoc.hrc>

#define C2S(cChar) String::CreateFromAscii(cChar)

extern char __FAR_DATA sHTML[];

SwDLL::SwDLL()
{
}

SwDLL::~SwDLL()
{
}
//-------------------------------------------------------------------------
void 	SwDLL::PreExit()
{
}

//-------------------------------------------------------------------------
void 	SwDLL::Init()
{
}
//-------------------------------------------------------------------------
void 	SwDLL::Exit()
{
}
//-------------------------------------------------------------------------

void	SwDLL::FillStatusBar(StatusBar &rBar)
{
}

//-------------------------------------------------------------------------

ULONG	SwDLL::DetectFilter( SfxMedium& rMedium, const SfxFilter** ppFilter,
							SfxFilterFlags nMust, SfxFilterFlags nDont )
{
	ULONG nRet = ERRCODE_NONE;
	const SfxFilter* pSavFilter = *ppFilter;

	do {
			// dann ueberpruefe mal ob der richtige ausgewaehlt wurde
		if( *ppFilter )
		{
			if( SwIoSystem::IsFileFilter( rMedium, (*ppFilter)->GetUserData()) )
				break;

			//JP 08.06.98: Bugfix 50498
			if( COMPARE_EQUAL == (*ppFilter)->GetUserData().CompareToAscii( "TEXT", 4 ))
			{
				//JP 09.11.98: der SWDOS - Filter hat dieselbe Extension und
				// wird vom SFX vorgeschlagen. Das es auch eine Textdatei ist,
				// muss die hier ausgefilter werden!
				if( SwIoSystem::IsFileFilter( rMedium, C2S("SW6"), ppFilter ))
					break;

				// eigentlich koennen wir alle Dateien als Text einlesen!
				// Aber zur Sicherheit pruefe mal 0 Bytes ab. Wenn welche vor-
				// handen sind, dann nicht als TEXT einlesen
				SvStream* pStrm = rMedium.GetInStream();
				BOOL bNullFound = TRUE;
				if( pStrm && !pStrm->GetError() )
				{
					bNullFound = FALSE;
					char aBuffer[ 4097 ];
					const char* p = aBuffer;
					ULONG nBytesRead = pStrm->Read( aBuffer, 4096 );
					while( nBytesRead-- )
						if( !*p++ )
						{
							bNullFound = TRUE;
							break;
						}
				}
				// DV: rMedium shouldn't be closed, IsStorage() needs the
				// InStream anyway
				// rMedium.CloseInStream();
				if( !bNullFound )
					break;
			}

		}

		if( SFX_FILTER_TEMPLATE & nMust )
		{
			// nur einen Vorlagen Filter
			BOOL bStorage = rMedium.IsStorage();
			if( bStorage && *ppFilter )
				break;
			else if( bStorage &&
				( SwIoSystem::IsFileFilter( rMedium, C2S(FILTER_SW5V), ppFilter ) ||
				  SwIoSystem::IsFileFilter( rMedium, C2S(FILTER_SW4V), ppFilter ) ||
				  SwIoSystem::IsFileFilter( rMedium, C2S(FILTER_SW3V), ppFilter ) ||
				  SwIoSystem::IsFileFilter( rMedium, C2S(FILTER_SWW5V), ppFilter ) ||
				  SwIoSystem::IsFileFilter( rMedium, C2S(FILTER_SWW4V), ppFilter ) ))
				break;
			else if( !bStorage &&
				SwIoSystem::IsFileFilter( rMedium, C2S(FILTER_SWGV), ppFilter ) )
				break;

			nRet = ERRCODE_ABORT;
			break;
		}


		String aPrefFlt;
		if( *ppFilter )
		{
			aPrefFlt = (*ppFilter)->GetUserData();
			if( SwIoSystem::IsFileFilter( rMedium, aPrefFlt ) )
			{
				nRet = ERRCODE_NONE;
				break;
			}

			// beim Browsen soll keine Filterbox kommen, wenn das Dokument nicht
			// in den ersten paar Bytes HTML-Tags hat (MA/ST/...). Solche Dok.
			// erzeugen z.B. SearchEngines
//JP 20.07.00: from now on we are not a browser
//			else if( aPrefFlt == C2S(sHTML) )
//			{
//				nRet = ERRCODE_NONE;
//				break;
//			}
		}

		const SfxFilter* pTmp = SwIoSystem::GetFileFilter( rMedium.GetPhysicalName(),
															aPrefFlt, &rMedium );
		if( !pTmp )
			nRet = ERRCODE_ABORT;

		// sollte der voreingestellte Filter ASCII sein und wir haben
		// ASCII erkannt, dann ist das ein gultiger Filter, ansonsten ist das
		// ein Fehler und wir wollen die Filterbox sehen
		else if( pTmp->GetUserData() == C2S(FILTER_ANSI) )
		{
			// Bug 28974: "Text" erkannt, aber "Text Dos" "Text ..." eingestellt
			// 	-> keine FilterBox, sondern den eingestellten Filter benutzen
			if( *ppFilter && COMPARE_EQUAL ==
				(*ppFilter)->GetUserData().CompareToAscii( FILTER_ANSI, 4 ))
				;
			else
//			if( !*ppFilter || COMPARE_EQUAL != pTmp->GetUserData().Compare(
//				(*ppFilter)->GetUserData(), 4 ))
			{
//				nRet = ERRCODE_ABORT;
				*ppFilter = pTmp;
			}
		}
		else
		{
			//Bug 41417: JP 09.07.97: HTML auf die WebDocShell defaulten
			if( pTmp->GetUserData() != C2S(sHTML) ||
				SwWebDocShell::Factory().GetFilterContainer() ==
				pTmp->GetFilterContainer() ||
				0 == ( (*ppFilter) = SwIoSystem::GetFilterOfFormat( C2S(sHTML),
					 SwWebDocShell::Factory().GetFilterContainer() ) ))

				*ppFilter = pTmp;
		}

	} while( FALSE );

	if( ERRCODE_NONE == nRet && (
		nMust != ( (*ppFilter)->GetFilterFlags() & nMust ) ||
		0 != ( (*ppFilter)->GetFilterFlags() & nDont )) )
	{
		nRet = ERRCODE_ABORT;
		*ppFilter = pSavFilter;
	}
	return nRet;
}

//-------------------------------------------------------------------------

ULONG SwDLL::GlobDetectFilter( SfxMedium& rMedium, const SfxFilter **ppFilter,
								ULONG nMust, ULONG nDont )
{
	ULONG nRet = ERRCODE_ABORT;
	const SfxFilter* pSavFilter = *ppFilter;
	do {
			// dann ueberpruefe mal ob der richtige ausgewaehlt wurde
		if( rMedium.IsStorage() )
		{
			SvStorageRef aStg = rMedium.GetStorage();

			if( *ppFilter &&
				aStg.Is() && SVSTREAM_OK == aStg->GetError() &&
				SwIoSystem::IsValidStgFilter( *aStg, **ppFilter ))
			{
				nRet = ERRCODE_NONE;
				break;
			}

			if( SFX_FILTER_TEMPLATE & nMust )
				break;

			const SfxFilter* pFltr;
			const SfxFactoryFilterContainer& rFltContainer =
							*SwGlobalDocShell::Factory().GetFilterContainer();
			USHORT nFltrCount = rFltContainer.GetFilterCount();
			for( USHORT nCnt = 0; nCnt < nFltrCount; ++nCnt )
				if( (sal_Unicode)'C' == ( pFltr = rFltContainer.GetFilter( nCnt ))->GetUserData().GetChar(0) &&
					aStg.Is() && SwIoSystem::IsValidStgFilter( *aStg, *pFltr ))
				{
					*ppFilter = pFltr;
					nRet = ERRCODE_NONE;
					break;
				}
		}

	} while( FALSE );

	if( ERRCODE_NONE == nRet && (
		nMust != ( (*ppFilter)->GetFilterFlags() & nMust ) ||
		0 != ( (*ppFilter)->GetFilterFlags() & nDont )) )
	{
		nRet = ERRCODE_ABORT;
		*ppFilter = pSavFilter;
	}

	return nRet;
}

//-------------------------------------------------------------------------

SvGlobalName SwModuleDummy::GetID(USHORT nFileFormat)
{
	SvGlobalName aName;
	switch ( nFileFormat )
	{
		case SOFFICE_FILEFORMAT_31:
			aName = SvGlobalName( SO3_SW_CLASSID_30 );
		break;
		case SOFFICE_FILEFORMAT_40:
			aName = SvGlobalName( SO3_SW_CLASSID_40 );
		break;
		case SOFFICE_FILEFORMAT_50:
			aName = SvGlobalName( SO3_SW_CLASSID_50 );
		break;
	}
	return aName;
}

USHORT       SwModuleDummy::HasID(const SvGlobalName& rName)
{
	if (GetID(SOFFICE_FILEFORMAT_31) == rName)
		return SOFFICE_FILEFORMAT_31;

	if (GetID(SOFFICE_FILEFORMAT_40) == rName)
		return SOFFICE_FILEFORMAT_40;

	if (GetID(SOFFICE_FILEFORMAT_50) == rName)
		return SOFFICE_FILEFORMAT_NOW;
	return 0;
}

/*-----------------18.03.98 08.09-------------------

--------------------------------------------------*/
SwModuleDummy::~SwModuleDummy()
{
}

/*------------------------------------------------------------------------
	$Log: swcomlib.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:31  hr
	initial import
	
	Revision 1.17  2000/09/18 16:05:12  willem.vandorp
	OpenOffice header added.
	
	Revision 1.16  2000/07/20 10:22:57  jp
	DetectFilter: remove old browser code
	
	Revision 1.15  2000/07/20 06:47:08  dv
	rMedium shouldn't be closed, IsStorage() needs the

	Revision 1.14  2000/04/11 08:01:31  os
	UNICODE

	Revision 1.13  2000/02/11 14:42:59  hr
	#70473# changes for unicode ( patched by automated patchtool )

	Revision 1.12  1998/11/17 09:33:30  JP
	Bug #59498#: bei ASCII kein ErrCode abort returnen


	  Rev 1.11   17 Nov 1998 10:33:30   JP
   Bug #59498#: bei ASCII kein ErrCode abort returnen

	  Rev 1.10   09 Nov 1998 15:03:56   JP
   Task #59114#: StarWriterDOS-Filter gesondert behandeln

	  Rev 1.9   05 Nov 1998 15:03:56   JP
   Bug #58936#: FilterSpec einhalten (Must und Dont Flags im DetectFilter beachten

	  Rev 1.8   30 Jun 1998 18:28:00   JP
   benutze die SwIoSystem-Methode IsValidStgFilter fuer Storage Dateien

	  Rev 1.7   08 Jun 1998 17:53:44   JP
   Bug #50498#: DetectFilter - wenn Text gewuenscht und es ein Textfile ist, so returne Ok

	  Rev 1.6   18 Mar 1998 15:47:12   OS
   virt. Dtor fuer SwModuleDummy

	  Rev 1.5   20 Feb 1998 18:49:14   MA
   nimmt nicht am pch teil

	  Rev 1.4   20 Feb 1998 16:11:06   MA
   headerfiles gewandert

	  Rev 1.3   07 Jan 1998 18:42:10   MIB
   5.0 Fileformat

	  Rev 1.2   24 Nov 1997 14:22:34   MA
   includes

	  Rev 1.1   20 Oct 1997 13:51:06   OS
   HasId/GetId vervollstaednigt/berichtigt

	  Rev 1.0   05 Sep 1997 13:33:40   OS
   Initial revision.


------------------------------------------------------------------------*/

