/*************************************************************************
 *
 *  $RCSfile: linbox.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop


#include "segmentc.hxx"
#include "swtypes.hxx"
#include "errhdl.hxx"

#define _LINBOX_CXX

#include "linbox.hxx"

#ifndef _DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _BITMAP_HXX //autogen
#include <vcl/bitmap.hxx>
#endif

#ifndef _IMAGE_HXX //autogen
#include <vcl/image.hxx>
#endif

SEG_EOFGLOBALS()

SV_IMPL_PTRARR(SwLineStyleLst, SwLineStyle*)

/*--------------------------------------------------------------------
	 Beschreibung: Ctor LineType
 --------------------------------------------------------------------*/


SwLineStyle::SwLineStyle(USHORT nWidth, USHORT nWidth2, USHORT nDst) :
	nIn(nWidth2), nOut(nWidth), nDist(nDst)
	{}


SwLineStyle::SwLineStyle(const SwLineStyle& rTyp) :
	nIn(rTyp.nIn), nOut(rTyp.nOut), nDist(rTyp.nDist)
	{}

/*--------------------------------------------------------------------
	 Beschreibung: Ctor LinetypeBox
 --------------------------------------------------------------------*/


SwLineBox::SwLineBox(Window* pPar, const ResId& rResId) :
	ListBox(pPar, rResId), aVirDev(*this)
{
// #ifndef PM2
	aVirDev.SetOutputSizePixel(Size(GetSizePixel().Width()-23, GetTextHeight()-2));
	aVirDev.SetMapMode(MapMode(MAP_TWIP));
	const Wallpaper aWall(GetBackground());
	aVirDev.SetBackground(aWall);
	aVirDev.SetFillColor(aWall.GetColor());
// #endif
}


void SwLineBox::InsertEntry(const SwLineStyle& rTyp, USHORT nPos)
{
	SwLineStyle* pType = new SwLineStyle(rTyp);
	// generieren, einfuegen

// #ifndef PM2
	const Size aOutSz( aVirDev.GetOutputSize() );
	const long nOff	 	= aVirDev.PixelToLogic(Point(10,0)).X();
	const long nHeight  = aOutSz.Height();
	const long nWidth   = aOutSz.Width() - 2 * nOff;
	const long nMin	 	= aVirDev.PixelToLogic(Point(1,2)).Y();

	// loeschen
	Color aWhiteColor(COL_WHITE);
	aVirDev.SetLineColor(aWhiteColor);
	aVirDev.DrawRect(Rectangle(Point(0,0), aVirDev.GetOutputSize()));
	aVirDev.SetClipRegion(Region(Rectangle(Point(nOff, 0),
											  Size(nWidth, nHeight))));

	const short nDist = (short)pType->nDist;
	const short nOut  = (short)pType->nOut ;
	const short nIn   = (short)pType->nIn  ;

	aVirDev.SetLineColor(Color(COL_BLACK));

	//	Offset berechnen
	long nY = (nHeight - nOut - nDist - nIn)/2;
	aVirDev.DrawLine(Point(0,   nY + nOut/2),
					 Point(aOutSz.Width(), nY + nOut/2));

	// evtl. Doppelte Linien
	if(nDist)
	{	// Abstand zur aeusseren Linie
		long nY2 = nY + nOut;
		nY2 += Max(long(nDist), nMin) + nIn /2 ;
		//TODO: DrawRect instead of DrawLine to show a double line
		aVirDev.DrawLine(Point(0, nY2), Point(aOutSz.Width(), nY2));
	}
	Bitmap aBmp = aVirDev.GetBitmap(Point(0, 0), aVirDev.GetOutputSize());
	ListBox::InsertEntry(aBmp, nPos);

// #endif
	if(nPos == LISTBOX_APPEND)
		nPos = aTypeList.Count();

	aTypeList.C40_INSERT(SwLineStyle, pType, nPos);
}

/*--------------------------------------------------------------------
	 Beschreibung:	Eintrag
 --------------------------------------------------------------------*/
/*

void SwLineBox::RemoveEntry(USHORT nPos)
{
	ListBox::RemoveEntry(nPos);
	aTypeList.DeleteAndDestroy(nPos, 1);
}
*/
/*--------------------------------------------------------------------
	 Beschreibung: Eintrag loeschen
 --------------------------------------------------------------------*/
/*

void SwLineBox::RemoveEntry(const SwLineStyle& rTyp)
{
	const USHORT nPos = FindEntry(rTyp);
	if(nPos != LISTBOX_ENTRY_NOTFOUND)
		RemoveEntry(nPos);
}
*/
/*--------------------------------------------------------------------
	 Beschreibung: Eintrag selektieren
 --------------------------------------------------------------------*/


void SwLineBox::SelectEntry(const SwLineStyle& rTyp)
{
	const USHORT nPos = FindEntry(rTyp);
	ListBox::SelectEntryPos(nPos);
}
/*

SwLineStyle SwLineBox::GetEntry(USHORT nPos)
{
	ASSERT(nPos < ListBox::GetEntryCount(), "Unzulaessiger Index");
	return *aTypeList[nPos];
}
*/

SwLineStyle SwLineBox::GetSelectEntry()
{
	SwLineStyle aDef;
	const USHORT nPos = ListBox::GetSelectEntryPos();
	if(nPos == LISTBOX_ENTRY_NOTFOUND)
		return aDef;

	return *aTypeList[nPos];
}


/*--------------------------------------------------------------------
	 Beschreibung: Eintrag finden
 --------------------------------------------------------------------*/


USHORT SwLineBox::FindEntry(const SwLineStyle& rTyp)
{
	for(USHORT i=0; i < aTypeList.Count();++i)
	{	const SwLineStyle* pType = aTypeList[i];
		if(*pType == rTyp)
			return i;
	}
	return LISTBOX_ENTRY_NOTFOUND;
}

/*-----------------26.02.94 00:40-------------------
 dtor ueberladen
--------------------------------------------------*/

SwLineBox::~SwLineBox() {}

/*-----------------26.02.94 00:41-------------------
   $Log: linbox.cxx,v $
   Revision 1.1.1.1  2000/09/18 17:14:32  hr
   initial import

   Revision 1.44  2000/09/18 16:05:12  willem.vandorp
   OpenOffice header added.

   Revision 1.43  2000/04/11 08:03:01  os
   UNICODE

   Revision 1.42  2000/03/03 15:16:58  os
   StarView remainders removed

   Revision 1.41  2000/02/11 14:43:16  hr
   #70473# changes for unicode ( patched by automated patchtool )

   Revision 1.40  1997/11/03 12:09:44  MA
   precomp entfernt


	  Rev 1.39   03 Nov 1997 13:09:44   MA
   precomp entfernt

	  Rev 1.38   08 Aug 1997 17:29:52   OM
   Headerfile-Umstellung

	  Rev 1.37   23 Apr 1997 11:03:38   OS
   ResId const

	  Rev 1.36   28 Aug 1996 08:23:40   OS
   includes

	  Rev 1.35   23 Apr 1996 10:49:26   TRI
   WTC Anpassung

	  Rev 1.34   24 Nov 1995 16:57:38   OM
   PCH->PRECOMPILED

	  Rev 1.33   17 Nov 1995 13:15:18   MA
   Segmentierung

	  Rev 1.32   08 Nov 1995 12:46:52   OM
   Change->Set

	  Rev 1.31   27 Jul 1995 10:41:38   mk
   an SCC4.0.1a angepasst (MDA)

	  Rev 1.30   20 Apr 1995 19:41:20   JP
   Bug11258: Linien rechts nicht mehr abgerundet

	  Rev 1.29   20 Mar 1995 19:03:34   OS
   unbenutzte Funktionen entfernt

	  Rev 1.28   09 Jan 1995 16:21:12   ER
	del: cctrl hrc

	  Rev 1.27   15 Dec 1994 20:21:02   SWG
   *ARR* Ersetzungen, svmem, __far_data etc.

	  Rev 1.26   18 Nov 1994 15:24:08   MA
   min -> Min, max -> Max

	  Rev 1.25   25 Oct 1994 14:55:18   ER
   add: PCH

	  Rev 1.24   19 Oct 1994 13:12:14   MA
   Syntax

	  Rev 1.23   19 Oct 1994 11:50:58   MA
   SV-ChangeXXX -> SetXXX.

	  Rev 1.22   22 Aug 1994 08:17:50   MS
   SPoints entfernt

	  Rev 1.21   18 Aug 1994 16:59:26   MS
   EMPTYBOX

	  Rev 1.20   04 Aug 1994 09:59:00   SWG
   swg32: SED Size to SSize, LSize to Size etc.

	  Rev 1.19   21 Jul 1994 15:13:34   MS
   Bug 8835

	  Rev 1.18   28 Apr 1994 19:12:36   MS
   Linien kleiner in der Hoehe

	  Rev 1.17   08 Apr 1994 12:40:54   MS
   Bitmaps fuer OS2

	  Rev 1.16   26 Feb 1994 02:07:16   ER
   virt. dtor mit export

	  Rev 1.15   26 Feb 1994 00:41:18   ER
   virtuellen dtor wegen export ueberladen
--------------------------------------------------*/


