/*************************************************************************
 *
 *  $RCSfile: autofopt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#include "cfgid.h"
#include "autofopt.hxx"
#include "cfgstr.hrc"


#define VERSION_30B		((USHORT)250)
#define VERSION_349     ((USHORT)349)
#define VERSION_355     ((USHORT)355)

#define AF_VERSION  	VERSION_355

/*--------------------------------------------------------------------
	Beschreibung:	Image einlesen
 --------------------------------------------------------------------*/



int SwAutoFmtOpt::Load(SvStream& rStream)
{
	unsigned char cIn;
	USHORT nIn;
	USHORT		nVersion;
	int			rc = SfxConfigItem::ERR_OK;

	rStream >> nVersion;

	if( nVersion >= VERSION_30B )
	{
		rStream >> cIn;  bAutoCorrect = cIn;
		rStream >> cIn;  bCptlSttWrd = cIn;
		rStream >> cIn;  bCptlSttSntnc = cIn;
		rStream >> cIn;  bReplaceQuote = cIn;
		rStream >> cIn;  bChgUserColl = cIn;
		rStream >> cIn;  bChgEnumNum = cIn;
		rStream >> cBullet;
		String aStr;
		rStream >> aStr;
		aBulletFont.SetName(aStr);
		rStream >> nIn; aBulletFont.SetFamily(FontFamily(nIn));
		rStream >> nIn; aBulletFont.SetCharSet(CharSet(nIn));
		rStream >> nIn; aBulletFont.SetPitch(FontPitch(nIn));
		rStream >> nIn; nRightMargin = (BYTE)nIn;
		if(nVersion >= VERSION_349)
		{
			rStream >> cIn;
			bDelEmptyNode 		= (BYTE)cIn;
			rStream >> cIn;
			bSetNumRule 		= (BYTE)cIn;
			rStream >> cIn;
			bChgFracionSymbol  	= (BYTE)cIn;
			rStream >> cIn;
			bChgOrdinalNumber   = (BYTE)cIn;
			rStream >> cIn;
			bChgToEnEmDash 	   	= (BYTE)cIn;
			rStream >> cIn;
			bChgWeightUnderl 	= (BYTE)cIn;
			rStream >> cIn;
			bSetINetAttr 		= (BYTE)cIn;
			rStream >> cIn;
			bSetBorder 			= (BYTE)cIn;
			rStream >> cIn;
			bCreateTable 		= (BYTE)cIn;

			if(nVersion >= VERSION_355)
			{
				rStream >> cIn;
				bReplaceStyles 		= (BYTE)cIn;
				rStream >> cIn;
				bDummy			 	= (BYTE)cIn;
			}
		}
	}
	else
	{
		rc = SfxConfigItem::WARNING_VERSION;
	}

	Apply();
	return rc;
}

/*--------------------------------------------------------------------
	Beschreibung:	Image schreiben
 --------------------------------------------------------------------*/



BOOL SwAutoFmtOpt::Store( SvStream& rStream)
{
	rStream << AF_VERSION;

	// typecast, weil SUN C++ manchmal zu doof....
	const unsigned char cOff = 0, cOn = 1;
	rStream << (unsigned char)(bAutoCorrect? cOn: cOff);
	rStream << (unsigned char)(bCptlSttWrd? cOn: cOff);
	rStream << (unsigned char)(bCptlSttSntnc? cOn: cOff);
	rStream << (unsigned char)(bReplaceQuote? cOn: cOff);
	rStream << (unsigned char)(bChgUserColl? cOn: cOff);
	rStream << (unsigned char)(bChgEnumNum? cOn: cOff);
	rStream << cBullet;
	rStream << aBulletFont.GetName() << (USHORT)aBulletFont.GetFamily() <<
			(USHORT)aBulletFont.GetCharSet() << (USHORT)aBulletFont.GetPitch();
	rStream << (USHORT)nRightMargin;

	rStream << (unsigned char)( bDelEmptyNode 		? cOn : cOff);
	rStream << (unsigned char)( bSetNumRule 		? cOn : cOff);
	rStream << (unsigned char)( bChgFracionSymbol 	? cOn : cOff);
	rStream << (unsigned char)( bChgOrdinalNumber 	? cOn : cOff);
	rStream << (unsigned char)( bChgToEnEmDash 		? cOn : cOff);
	rStream << (unsigned char)( bChgWeightUnderl 	? cOn : cOff);
	rStream << (unsigned char)( bSetINetAttr 		? cOn : cOff);
	rStream << (unsigned char)( bSetBorder 			? cOn : cOff);
	rStream << (unsigned char)( bCreateTable 		? cOn : cOff);

	rStream << (unsigned char)( bReplaceStyles 		? cOn : cOff);
	rStream << (unsigned char)( bDummy			 	? cOn : cOff);

	return SfxConfigItem::ERR_OK;
}

/*--------------------------------------------------------------------
	Beschreibung:	Ctor
 --------------------------------------------------------------------*/



SwAutoFmtOpt::SwAutoFmtOpt():
	SfxConfigItem(CFG_AUTOFMT_ITEM)
{
}



String SwAutoFmtOpt::GetName() const
{
	return SW_RESSTR( STR_CFG_AUTOFOPT );
}



void SwAutoFmtOpt::Apply()
{
	SwEditShell::SetAutoFmtFlags(this);
}



void SwAutoFmtOpt::UseDefault()
{
	bReplaceQuote =
	bAutoCorrect =
	bCptlSttSntnc =
	bCptlSttWrd =
	bChkFontAttr =
	bChgUserColl =
	bChgEnumNum = TRUE;

	bChgFracionSymbol =
	bChgOrdinalNumber =
	bChgToEnEmDash =
	bChgWeightUnderl =
	bSetINetAttr =
	bSetBorder =
	bCreateTable = TRUE;

	nRightMargin = 50;		// dflt. 50 %
	bDelEmptyNode = TRUE;

	bReplaceStyles =
	bDummy = FALSE;
}

/*------------------------------------------------------------------------

	$Log: autofopt.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:32  hr
	initial import
	
	Revision 1.24  2000/09/18 16:05:15  willem.vandorp
	OpenOffice header added.
	
	Revision 1.23  1997/11/24 16:58:48  MA
	include
	

	  Rev 1.22   24 Nov 1997 17:58:48   MA
   include

	  Rev 1.21   03 Nov 1997 13:11:00   MA
   precomp entfernt

	  Rev 1.20   10 Feb 1997 12:56:04   JP
   neue AutoFmtFlags

	  Rev 1.19   19 Dec 1996 15:58:54   OS
   UseDefault wieder drin, Store berichtigt

	  Rev 1.18   18 Dec 1996 15:01:26   OS
   AutoFormat-Optionen komplett speichern

	  Rev 1.17   18 Nov 1996 10:36:58   OS
   includes

	  Rev 1.16   11 Nov 1996 09:22:08   MA
   ResMgr

	  Rev 1.15   16 Jul 1996 20:19:50   MA
   includes

	  Rev 1.14   28 Jun 1996 10:11:54   OS
   - UseDefault

	  Rev 1.13   24 Nov 1995 16:58:52   OM
   PCH->PRECOMPILED

	  Rev 1.12   08 Nov 1995 12:48:12   OM
   Change->Set

	  Rev 1.11   15 Sep 1995 12:40:20   OS
   GetName() implementiert und ColorSetItem entfernt

	  Rev 1.10   19 Feb 1995 22:26:28   OS
   SEXPORT's fuer virt. Fkt.

	  Rev 1.9   05 Jan 1995 16:42:58   SWG
   Fix Update

	  Rev 1.8   25 Oct 1994 16:12:52   ER
   add: PCH

	  Rev 1.7   20 Oct 1994 12:53:44   JN
   Versionskontrolle bei Load/Store

	  Rev 1.6   05 Oct 1994 10:23:30   SWG
   Anpassung Sfx

	  Rev 1.5   04 Oct 1994 13:23:36   MS
   bis auf weiteres mit UTILS.HXX

	  Rev 1.4   28 Sep 1994 12:40:36   MS
   UMstellung SfxConfigItem

	  Rev 1.3   30 Mar 1994 14:49:26   MT
   explizite typecasts fuer SUN C++ 4.0

	  Rev 1.2   07 Mar 1994 17:15:20   ER
   bei geloeschten Funktionen auch das

	  Rev 1.1   07 Mar 1994 13:14:20   VB
   Speichern Optionen Autoformatierung

	  Rev 1.0   06 Mar 1994 20:46:40   VB
   Initial revision.

------------------------------------------------------------------------*/



