/*************************************************************************
 *
 *  $RCSfile: optins.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _INSDLG_HXX //autogen
#include <so3/insdlg.hxx>
#endif
#ifndef _OUTPLACE_HXX //autogen
#include <so3/outplace.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC //autogen
#include <svx/svxids.hrc>
#endif
#ifndef _SVX_HTMLMODE_HXX //autogen
#include <svx/htmlmode.hxx>
#endif

#ifndef _FLDMGR_HXX //autogen
#include <fldmgr.hxx>
#endif
#ifndef _FLDBAS_HXX //autogen
#include <fldbas.hxx>
#endif
#ifndef _EXPFLD_HXX //autogen
#include <expfld.hxx>
#endif
#ifndef _SWDOCSH_HXX //autogen
#include <docsh.hxx>
#endif
#ifndef _SWMODULE_HXX
#include <swmodule.hxx>
#endif
#ifndef _MODCFG_HXX
#include <modcfg.hxx>
#endif
#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
#ifndef _POOLFMT_HXX
#include <poolfmt.hxx>
#endif
#ifndef _SWTYPES_HXX
#include <swtypes.hxx>
#endif
#ifndef _ITABENUM_HXX
#include <itabenum.hxx>
#endif
#ifndef _NUMRULE_HXX
#include <numrule.hxx>
#endif
#ifndef _OPTINS_HXX
#include <optins.hxx>
#endif

#ifndef _HELPID_H
#include <helpid.h>
#endif
#ifndef _GLOBALS_HRC
#include <globals.hrc>
#endif
#ifndef _COMCORE_HRC
#include <comcore.hrc>
#endif
#ifndef _OPTINS_HRC
#include <optins.hrc>
#endif

extern String* pOldGrfCat;
extern String* pOldTabCat;
extern String* pOldFrmCat;

/* -----------------22.10.98 15:12-------------------
 *
 * --------------------------------------------------*/

SwInsertOptPage::SwInsertOptPage( Window* pParent, const SfxItemSet& rSet ) :
	SfxTabPage(pParent, SW_RES(TP_OPTINSERT_PAGE), rSet),
	aCaptionCB		(this, ResId(CB_GRF				)),
	aCaptionFT		(this, ResId(TXT_OPTIONS		)),
	aCaptionPB		(this, ResId(PB_OPTIONS			)),
	aCaptionGB		(this, ResId(GB_CAPTION			)),
	aHeaderCB		(this, ResId(CB_HEADER			)),
	aRepeatHeaderCB	(this, ResId(CB_REPEAT_HEADER	)),
	aDontSplitCB	(this, ResId(CB_DONT_SPLIT		)),
	aBorderCB		(this, ResId(CB_BORDER			)),
	aNumFormattingCB(this, ResId(CB_NUMFORMATTING	)),
	aNumFmtFormattingCB(this, ResId(CB_NUMFMT_FORMATTING	)),
	aNumAlignmentCB	(this, ResId(CB_NUMALIGNMENT	)),
	aTableGB		(this, ResId(GB_TABLE			)),
	aTableInsertGB	(this, ResId(GB_TABLE_INSERT	)),
	bHTMLMode(FALSE)
{
	FreeResource();

	aCaptionPB.SetClickHdl(LINK(this, SwInsertOptPage, CaptionHdl));

	Link aLnk(LINK(this, SwInsertOptPage, CheckBoxHdl));
	aNumFormattingCB.SetClickHdl(aLnk);
	aNumFmtFormattingCB.SetClickHdl(aLnk);
	aHeaderCB.SetClickHdl(aLnk);
}

/*-----------------18.01.97 12.43-------------------

--------------------------------------------------*/

SwInsertOptPage::~SwInsertOptPage()
{
}

/*-----------------18.01.97 12.43-------------------

--------------------------------------------------*/

SfxTabPage*	SwInsertOptPage::Create( Window* pParent,
								const SfxItemSet& rAttrSet )
{
	return new SwInsertOptPage(pParent, rAttrSet );
}

/*-----------------18.01.97 12.42-------------------

--------------------------------------------------*/

BOOL SwInsertOptPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bRet = FALSE;
	SwModuleOptions* pModOpt = SW_MOD()->GetModuleConfig();
	USHORT nInsTblFlags = 0;

	if (aCaptionCB.GetSavedValue() != aCaptionCB.GetState())
	{
		pModOpt->SetInsWithCaption(bHTMLMode, aCaptionCB.IsChecked());
		bRet = TRUE;
	}

	if (aHeaderCB.IsChecked())
		nInsTblFlags |= HEADLINE;

	if (aRepeatHeaderCB.IsEnabled() && aRepeatHeaderCB.IsChecked())
		nInsTblFlags |= HEADLINE_REPEAT;

	if (!aDontSplitCB.IsChecked())
		nInsTblFlags |= SPLIT_LAYOUT;

	if (aBorderCB.IsChecked())
		nInsTblFlags |= DEFAULT_BORDER;

	if (aHeaderCB.GetSavedValue() != aHeaderCB.GetState() ||
		aRepeatHeaderCB.GetSavedValue() != aRepeatHeaderCB.GetState() ||
		aDontSplitCB.GetSavedValue() != aDontSplitCB.GetState() ||
		aBorderCB.GetSavedValue() != aBorderCB.GetState())
	{
		pModOpt->SetInsTblFlags(bHTMLMode, nInsTblFlags);
	}

	if (aNumFormattingCB.GetSavedValue() != aNumFormattingCB.GetState())
	{
		pModOpt->SetInsTblFormatNum(bHTMLMode, aNumFormattingCB.IsChecked());
		bRet = TRUE;
	}

	if (aNumFmtFormattingCB.GetSavedValue() != aNumFmtFormattingCB.GetState())
	{
		pModOpt->SetInsTblChangeNumFormat(bHTMLMode, aNumFmtFormattingCB.IsChecked());
		bRet = TRUE;
	}

	if (aNumAlignmentCB.GetSavedValue() != aNumAlignmentCB.GetState())
	{
		pModOpt->SetInsTblAlignNum(bHTMLMode, aNumAlignmentCB.IsChecked());
		bRet = TRUE;
	}

	return bRet;
}
/*-----------------18.01.97 12.42-------------------

--------------------------------------------------*/

void SwInsertOptPage::Reset( const SfxItemSet& rSet)
{
	const SfxPoolItem* pItem;
	if(SFX_ITEM_SET == rSet.GetItemState(SID_HTML_MODE, FALSE, &pItem))
	{
		bHTMLMode = 0 != (((const SfxUInt16Item*)pItem)->GetValue() & HTMLMODE_ON);
	}

	//bestimmte Controls fuer HTML verstecken
	if(bHTMLMode)
	{
		Point aPos(aCaptionGB.GetPosPixel());
		long nYDiff = aTableGB.GetPosPixel().Y() - aPos.Y();
		aTableGB.SetPosPixel(aPos);

		aPos = aHeaderCB.GetPosPixel();
		aPos.Y() -= nYDiff;
		aHeaderCB.SetPosPixel(aPos);

		aPos = aRepeatHeaderCB.GetPosPixel();
		aPos.Y() -= nYDiff;
		aRepeatHeaderCB.SetPosPixel(aPos);

		aPos = aDontSplitCB.GetPosPixel(); // hier muss eine Luecke geschlossen werden
		aPos.Y() -= nYDiff;
		aBorderCB.SetPosPixel(aPos);

		aPos = aTableInsertGB.GetPosPixel();
		aPos.Y() -= nYDiff;
		aTableInsertGB.SetPosPixel(aPos);

		aPos = aNumFormattingCB.GetPosPixel();
		aPos.Y() -= nYDiff;
		aNumFormattingCB.SetPosPixel(aPos);

		aPos = aNumFmtFormattingCB.GetPosPixel();
		aPos.Y() -= nYDiff;
		aNumFmtFormattingCB.SetPosPixel(aPos);

		aPos = aNumAlignmentCB.GetPosPixel();
		aPos.Y() -= nYDiff;
		aNumAlignmentCB.SetPosPixel(aPos);

		aCaptionGB.Hide();
		aCaptionCB.Hide();
		aCaptionFT.Hide();
		aCaptionPB.Hide();

		aDontSplitCB.Hide();
	}

	const SwModuleOptions* pModOpt = SW_MOD()->GetModuleConfig();
	USHORT nInsTblFlags = pModOpt->GetInsTblFlags(bHTMLMode);

	aHeaderCB.Check(nInsTblFlags & HEADLINE);
	aRepeatHeaderCB.Check(nInsTblFlags & REPEAT);
	aDontSplitCB.Check(!(nInsTblFlags & SPLIT_LAYOUT));
	aBorderCB.Check(nInsTblFlags & DEFAULT_BORDER);

	aCaptionCB.Check(pModOpt->IsInsWithCaption(bHTMLMode));

	aNumFormattingCB.Check(pModOpt->IsInsTblFormatNum(bHTMLMode));
	aNumFmtFormattingCB.Check(pModOpt->IsInsTblChangeNumFormat(bHTMLMode));
	aNumAlignmentCB.Check(pModOpt->IsInsTblAlignNum(bHTMLMode));

	aCaptionCB.SaveValue();
	aHeaderCB.SaveValue();
	aRepeatHeaderCB.SaveValue();
	aDontSplitCB.SaveValue();
	aBorderCB.SaveValue();
	aNumFormattingCB.SaveValue();
	aNumFmtFormattingCB.SaveValue();
	aNumAlignmentCB.SaveValue();

	CheckBoxHdl();
}

/*********************************************************************/
/*                                                                   */
/*********************************************************************/

IMPL_LINK(SwInsertOptPage, CaptionHdl, PushButton*, EMPTYARG)
{
	SwCaptionOptDlg aDlg(this, GetItemSet());
	aDlg.Execute();

	return 0;
}

/*********************************************************************/
/*                                                                   */
/*********************************************************************/

IMPL_LINK(SwInsertOptPage, CheckBoxHdl, CheckBox*, EMPTYARG)
{
	aNumFmtFormattingCB.Enable(aNumFormattingCB.IsChecked());
	aNumAlignmentCB.Enable(aNumFormattingCB.IsChecked());
	aRepeatHeaderCB.Enable(aHeaderCB.IsChecked());

	return 0;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SwCaptionOptDlg::SwCaptionOptDlg(Window* pParent, const SfxItemSet& rSet) :
	SfxSingleTabDialog(pParent, rSet, 0)
{
	// TabPage erzeugen
	SwCaptionOptPage* pPage = (SwCaptionOptPage*) SwCaptionOptPage::Create(this, rSet);
	SetTabPage(pPage);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SwCaptionOptDlg::~SwCaptionOptDlg()
{
}

/* -----------------22.10.98 15:12-------------------
 *
 * --------------------------------------------------*/

SwCaptionOptPage::SwCaptionOptPage( Window* pParent, const SfxItemSet& rSet )
	: SfxTabPage(pParent, SW_RES(TP_OPTCAPTION_PAGE), rSet),
	aCheckLB		(this, SW_RES(CLB_OBJECTS	)),
	aSampleText		(this, SW_RES(TXT_SAMPLE	)),
	aCategoryText	(this, SW_RES(TXT_CATEGORY	)),
	aCategoryBox 	(this, SW_RES(BOX_CATEGORY	)),
	aFormatText		(this, SW_RES(TXT_FORMAT	)),
	aFormatBox		(this, SW_RES(BOX_FORMAT	)),
	aTextText		(this, SW_RES(TXT_TEXT		)),
	aTextEdit		(this, SW_RES(EDT_TEXT		)),
	aPosText		(this, SW_RES(TXT_POS		)),
	aPosBox			(this, SW_RES(BOX_POS		)),
	aFtLevel		(this, SW_RES(FT_LEVEL		)),
	aLbLevel		(this, SW_RES(LB_LEVEL		)),
	aFtDelim		(this, SW_RES(FT_SEPARATOR	)),
	aEdDelim		(this, SW_RES(ED_SEPARATOR	)),
	aSettingsGroup	(this, SW_RES(GRP_SETTINGS	)),

	sSWTable    	(SW_RES(STR_TABLE			)),
	sSWFrame    	(SW_RES(STR_FRAME			)),
	sSWGraphic   	(SW_RES(STR_GRAPHIC			)),
	sOLE    		(SW_RES(STR_OLE				)),

	sBegin			(SW_RESSTR(STR_BEGINNING			)),
	sEnd			(SW_RESSTR(STR_END					)),
	sAbove			(SW_RESSTR(STR_ABOVE				)),
	sBelow			(SW_RESSTR(STR_CP_BELOW				)),

	pMgr			(new SwFldMgr()),
	bHTMLMode(FALSE)
{
	GetDocPoolNm( RES_POOLCOLL_LABEL_ABB, sIllustration );
	GetDocPoolNm( RES_POOLCOLL_LABEL_TABLE, sTable );
	GetDocPoolNm( RES_POOLCOLL_LABEL_FRAME, sText );

	USHORT i, nCount;
	SwWrtShell *pSh = ::GetActiveWrtShell();

	// aFormatBox
	USHORT nSelFmt = SVX_NUM_ARABIC;
	if (pSh)
	{
		nCount = pMgr->GetFldTypeCount();
		SwFieldType* pFldType;
		for ( i = nCount; i; )
			if( ( pFldType = pMgr->GetFldType(USHRT_MAX, --i))->GetName() ==
				aCategoryBox.GetText() )
			{
				nSelFmt = (USHORT)((SwSetExpFieldType*)pFldType)->GetSeqFormat();
				break;
			}
	}


	nCount = pMgr->GetFormatCount(TYP_SEQFLD, FALSE);
	for ( i = 0; i < nCount; ++i )
	{
		aFormatBox.InsertEntry( pMgr->GetFormatStr(TYP_SEQFLD, i) );
		USHORT nFmtId = pMgr->GetFormatId(TYP_SEQFLD, i);
		aFormatBox.SetEntryData( i, (void*)nFmtId );
		if( nFmtId == nSelFmt )
			aFormatBox.SelectEntryPos( i );
	}

	for (i = 0; i < MAXLEVEL; i++)
		aLbLevel.InsertEntry(i + 1);

	BYTE cDelim = '.', nLvl = MAXLEVEL;

	if (pSh)
	{
		SwSetExpFieldType* pFldType = (SwSetExpFieldType*)pMgr->GetFldType(
											RES_SETEXPFLD, aCategoryBox.GetText() );
		if( pFldType )
		{
			cDelim = pFldType->GetDelimiter();
			nLvl = pFldType->GetOutlineLvl();
		}
	}

	aLbLevel.SelectEntryPos( nLvl < MAXLEVEL ? nLvl + 1 : 0 );
	aEdDelim.SetText( cDelim );

	aCheckLB.SetHelpId(HID_OPTCAPTION_CLB);

	FreeResource();

	Link aLk = LINK( this, SwCaptionOptPage, ModifyHdl );
	aCategoryBox.SetModifyHdl( aLk );
	aTextEdit	.SetModifyHdl( aLk );

	aLk = LINK(this, SwCaptionOptPage, SelectHdl);
	aCategoryBox.SetSelectHdl( aLk );
	aFormatBox	.SetSelectHdl( aLk );

	aCheckLB.SetSelectHdl( LINK(this, SwCaptionOptPage, ShowEntryHdl) );
	aCheckLB.SetDeselectHdl( LINK(this, SwCaptionOptPage, SaveEntryHdl) );
}

/*-----------------18.01.97 12.43-------------------

--------------------------------------------------*/

SwCaptionOptPage::~SwCaptionOptPage()
{
	DelUserData();
	delete pMgr;
}

/*-----------------18.01.97 12.43-------------------

--------------------------------------------------*/

SfxTabPage*	SwCaptionOptPage::Create( Window* pParent,
								const SfxItemSet& rAttrSet )
{
	return new SwCaptionOptPage(pParent, rAttrSet );
}

/*-----------------18.01.97 12.42-------------------

--------------------------------------------------*/

BOOL SwCaptionOptPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bRet = FALSE;
	SwModuleOptions* pModOpt = SW_MOD()->GetModuleConfig();

	SaveEntry(aCheckLB.FirstSelected());	// Aktuellen Eintrag uebernehmen

	SvLBoxEntry* pEntry = aCheckLB.First();

	while (pEntry)
	{
		InsCaptionOpt* pData = (InsCaptionOpt*)pEntry->GetUserData();
		bRet |= pModOpt->SetCapOption(bHTMLMode, pData);
		pEntry = aCheckLB.Next(pEntry);
	}

	return bRet;
}

/*-----------------18.01.97 12.42-------------------

--------------------------------------------------*/

void SwCaptionOptPage::Reset( const SfxItemSet& rSet)
{
	const SfxPoolItem* pItem;
	if(SFX_ITEM_SET == rSet.GetItemState(SID_HTML_MODE, FALSE, &pItem))
	{
		bHTMLMode = 0 != (((const SfxUInt16Item*)pItem)->GetValue() & HTMLMODE_ON);
	}

	USHORT nPos = 0;

	DelUserData();
	aCheckLB.GetModel()->Clear();	// Alle Eintraege entfernen

	aCheckLB.InsertEntry(sSWTable);		SetOptions(nPos++, TABLE_CAP);
	aCheckLB.InsertEntry(sSWFrame);		SetOptions(nPos++, FRAME_CAP);
	aCheckLB.InsertEntry(sSWGraphic);   SetOptions(nPos++, GRAPHIC_CAP);

	SvObjectServerList aObjS;
	aObjS.FillInsertObjects();
	aObjS.Remove(*SwDocShell::ClassFactory());	// Writer-Id wieder entfernen

	for (ULONG i = 0; i < aObjS.Count(); i++)
	{
		const SvGlobalName &rOleId = aObjS[i].GetClassName();
		const String *pClassName = &aObjS[i].GetHumanName();
		if (rOleId == *SvOutPlaceObject::ClassFactory())
			pClassName = &sOLE;
		aCheckLB.InsertEntry(*pClassName);
		SetOptions(nPos++, OLE_CAP, &rOleId);
	}

	ModifyHdl();
}

/*-----------------18.01.97 12.42-------------------

--------------------------------------------------*/

void SwCaptionOptPage::SetOptions(const USHORT nPos, const SwCapObjType eType, const SvGlobalName *pOleId)
{
	SwModuleOptions* pModOpt = SW_MOD()->GetModuleConfig();
	const InsCaptionOpt* pOpt = pModOpt->GetCapOption(bHTMLMode, eType, pOleId);

	if (pOpt)
	{
		aCheckLB.SetEntryData(nPos, new InsCaptionOpt(*pOpt));
		aCheckLB.CheckEntryPos(nPos, pOpt->UseCaption());
	}
	else
		aCheckLB.SetEntryData(nPos, new InsCaptionOpt(eType, pOleId));
}

/*-----------------18.01.97 12.42-------------------

--------------------------------------------------*/

void SwCaptionOptPage::DelUserData()
{
	SvLBoxEntry* pEntry = aCheckLB.First();

	while (pEntry)
	{
		delete (InsCaptionOpt*)pEntry->GetUserData();
		pEntry->SetUserData(0);
		pEntry = aCheckLB.Next(pEntry);
	}
}

/* -----------------26.10.98 11:06-------------------
 *
 * --------------------------------------------------*/

IMPL_LINK( SwCaptionOptPage, ShowEntryHdl, SvxCheckListBox *, EMPTYARG )
{
	SvLBoxEntry* pSelEntry = aCheckLB.FirstSelected();

	if (pSelEntry)
	{
		SwWrtShell *pSh = ::GetActiveWrtShell();

		InsCaptionOpt* pOpt = (InsCaptionOpt*)pSelEntry->GetUserData();

		aCategoryBox.Clear();
		if (pSh)
		{
			USHORT nCount = pMgr->GetFldTypeCount();

			for (USHORT i = 0; i < nCount; i++)
			{
				SwFieldType *pType = pMgr->GetFldType( USHRT_MAX, i );
				if( pType->Which() == RES_SETEXPFLD &&
					((SwSetExpFieldType *) pType)->GetType() & GSE_SEQ )
					aCategoryBox.InsertEntry(SwBoxEntry(pType->GetName(), i));
			}
		}
		else
		{
			aCategoryBox.InsertEntry(SwBoxEntry(sIllustration, 0));
			aCategoryBox.InsertEntry(SwBoxEntry(sTable, 1));
			aCategoryBox.InsertEntry(SwBoxEntry(sText, 2));
		}

		aCategoryBox.SetText(pOpt->GetCategory());
		if (pOpt->GetCategory().Len() &&
			aCategoryBox.GetEntryPos(pOpt->GetCategory()) == COMBOBOX_ENTRY_NOTFOUND)
			aCategoryBox.InsertEntry(pOpt->GetCategory());
		if (!aCategoryBox.GetText().Len())
		{
			USHORT nPos = 0;
			switch(pOpt->GetObjType())
			{
				case OLE_CAP:
				case GRAPHIC_CAP:		nPos = 0;	break;
				case TABLE_CAP:			nPos = 1;	break;
				case FRAME_CAP:			nPos = 2;	break;
			}
			aCategoryBox.SetText(aCategoryBox.GetEntry(nPos).aName);
		}

		for (USHORT i = 0; i < aFormatBox.GetEntryCount(); i++)
		{
			if (pOpt->GetNumType() == (USHORT)(ULONG)aFormatBox.GetEntryData(i))
			{
				aFormatBox.SelectEntryPos(i);
				break;
			}
		}
		aTextEdit.SetText(pOpt->GetCaption());

		aPosBox.Clear();
		switch (pOpt->GetObjType())
		{
			case GRAPHIC_CAP:
			case TABLE_CAP:
			case OLE_CAP:
				aPosBox.InsertEntry(sAbove);
				aPosBox.InsertEntry(sBelow);
				break;
			case FRAME_CAP:
				aPosBox.InsertEntry(sBegin);
				aPosBox.InsertEntry(sEnd);
				break;
		}
		aPosBox.SelectEntryPos(pOpt->GetPos());
		aPosBox.Enable(pOpt->GetObjType() != GRAPHIC_CAP);

		aPosBox.SelectEntryPos(pOpt->GetPos());
		aLbLevel.SelectEntryPos(pOpt->GetLevel());
		aEdDelim.SetText(pOpt->GetSeparator());
	}

	ModifyHdl();

	return 0;
}

/* -----------------26.10.98 11:06-------------------
 *
 * --------------------------------------------------*/

IMPL_LINK( SwCaptionOptPage, SaveEntryHdl, SvxCheckListBox *, EMPTYARG )
{
	SvLBoxEntry* pEntry = aCheckLB.GetHdlEntry();

	if (pEntry)		// Alles speichern
		SaveEntry(pEntry);

	return 0;
}

/* -----------------05.11.98 16:23-------------------
 *
 * --------------------------------------------------*/

void SwCaptionOptPage::SaveEntry(SvLBoxEntry* pEntry)
{
	if (pEntry)
	{
		InsCaptionOpt* pOpt = (InsCaptionOpt*)pEntry->GetUserData();

		pOpt->UseCaption() = aCheckLB.IsChecked(aCheckLB.GetModel()->GetAbsPos(pEntry));
		String aName( aCategoryBox.GetText() );
		aName.EraseLeadingChars (' ');
		aName.EraseTrailingChars(' ');
		pOpt->SetCategory(aName);
		pOpt->SetNumType((USHORT)(ULONG)aFormatBox.GetEntryData(aFormatBox.GetSelectEntryPos()));
		pOpt->SetCaption(aTextEdit.GetText());
		pOpt->SetPos(aPosBox.GetSelectEntryPos());
		pOpt->SetLevel(aLbLevel.GetSelectEntryPos());
		pOpt->SetSeparator(aEdDelim.GetText().GetChar(0));
	}
}

/* -----------------26.10.98 11:06-------------------
 *
 * --------------------------------------------------*/

IMPL_LINK( SwCaptionOptPage, ModifyHdl, Edit *, EMPTYARG )
{
	String sFldTypeName = aCategoryBox.GetText();
/*
	SwFieldType* pType = sFldTypeName.Len() ? pMgr->GetFldType(RES_SETEXPFLD, sFldTypeName) : 0;

	((SfxSingleTabDialog*)GetParent())->GetOKButton()->Enable( (!pType || ((SwSetExpFieldType*)pType)->GetType() == GSE_SEQ)
									&& sFldTypeName.Len() != 0 );
*/
	SfxSingleTabDialog *pDlg = (SfxSingleTabDialog *)GetParent();
	PushButton *pBtn = pDlg->GetOKButton();
	if (pBtn)
		pBtn->Enable(sFldTypeName.Len() != 0);

	DrawSample();
	return 0;
}

/* -----------------26.10.98 10:58-------------------
 *
 * --------------------------------------------------*/

IMPL_LINK_INLINE_START( SwCaptionOptPage, SelectHdl, ListBox *, pBox )
{
	DrawSample();
	return 0;
}
IMPL_LINK_INLINE_END( SwCaptionOptPage, SelectHdl, ListBox *, EMPTYARG )

/* -----------------26.10.98 10:58-------------------
 *
 * --------------------------------------------------*/

void SwCaptionOptPage::DrawSample()
{
	String aStr;

	// Nummer
	USHORT nNumFmt = (USHORT)(ULONG)aFormatBox.GetEntryData(
									aFormatBox.GetSelectEntryPos() );
	if( SVX_NUM_NUMBER_NONE != nNumFmt )
	{
		// Kategorie
		aStr += aCategoryBox.GetText();
		aStr += ' ';

		SwWrtShell *pSh = ::GetActiveWrtShell();
		String sFldTypeName( aCategoryBox.GetText() );
		if (pSh)
		{
			SwSetExpFieldType* pFldType = (SwSetExpFieldType*)pMgr->GetFldType(
											RES_SETEXPFLD, sFldTypeName );
			if( pFldType && pFldType->GetOutlineLvl() < MAXLEVEL )
			{
				BYTE nLvl = pFldType->GetOutlineLvl();
				SwNodeNum aNum( nLvl );
				for( BYTE i = 0; i <= nLvl; ++i )
					*(aNum.GetLevelVal() + i) = 1;

				String sNumber( pSh->GetOutlineNumRule()->MakeNumString(
														aNum, FALSE ));
				if( sNumber.Len() )
					(aStr += sNumber) += pFldType->GetDelimiter();
			}
		}

		switch( nNumFmt )
		{
			case SVX_NUM_CHARS_UPPER_LETTER:	aStr += 'A'; break;
			case SVX_NUM_CHARS_UPPER_LETTER_N:	aStr += 'A'; break;
			case SVX_NUM_CHARS_LOWER_LETTER:	aStr += 'a'; break;
			case SVX_NUM_CHARS_LOWER_LETTER_N:	aStr += 'a'; break;
			case SVX_NUM_ROMAN_UPPER: 			aStr += 'I'; break;
			case SVX_NUM_ROMAN_LOWER: 			aStr += 'i'; break;
			//case ARABIC:
			default:					aStr += '1'; break;
		}
	}

	aStr += aTextEdit.GetText();
	aSampleText.SetText(aStr);
}

/*------------------------------------------------------------------------
 Beschreibung:	ComboBox ohne Spaces
------------------------------------------------------------------------*/

void CaptionComboBox::KeyInput(const KeyEvent& rEvt)
{
	if( rEvt.GetKeyCode().GetCode() != KEY_SPACE )
		SwComboBox::KeyInput(rEvt);
}

/*--------------------------------------------------------------------

	$Log: optins.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:33  hr
	initial import
	
	Revision 1.16  2000/09/18 16:05:16  willem.vandorp
	OpenOffice header added.
	
	Revision 1.15  2000/07/27 21:15:25  jp
	opt: get template names direct from the doc and don't load it from the resource
	
	Revision 1.14  2000/04/11 08:02:23  os
	UNICODE

	Revision 1.13  2000/02/11 14:44:01  hr
	#70473# changes for unicode ( patched by automated patchtool )

	Revision 1.12  1999/04/20 16:58:38  JP
	Task #65061#: neu: ZahlenFormaterkennung abschaltbar


	  Rev 1.11   20 Apr 1999 18:58:38   JP
   Task #65061#: neu: ZahlenFormaterkennung abschaltbar

	  Rev 1.10   17 Feb 1999 08:38:12   OS
   #58158# Einfuegen TabPage auch in HTML-Docs

	  Rev 1.9   07 Dec 1998 17:30:34   OM
   #60132# Flags fuer Einfuegeoptionen korrekt initialisieren

	  Rev 1.8   02 Dec 1998 15:23:02   OM
   #59770# Tabellenueberschrift nur auf erster Seite

	  Rev 1.7   30 Nov 1998 17:30:12   OM
   #59770# Tabellenoptionen: Ueberschrift nur auf erster Seite

	  Rev 1.6   27 Nov 1998 10:12:52   OM
   #59770# Tabelle ohne Ueberschrift einfuegen

	  Rev 1.5   20 Nov 1998 14:02:14   OM
   #59720# Neue Tabellenoptionen beim Einfuegen

	  Rev 1.4   17 Nov 1998 10:50:14   OS
   #58263# NumType durch SvxExtNumType ersetzt

	  Rev 1.3   16 Nov 1998 16:23:40   OM
   #58158# Beschriftung fuer weiter OLE-Objekte

	  Rev 1.2   11 Nov 1998 16:48:30   OM
   #58158# Einfuegeoptionen fuer Tabellen

	  Rev 1.1   06 Nov 1998 17:02:32   OM
   #58158# Automatische Beschriftung

	  Rev 1.0   27 Oct 1998 13:31:44   OM
   Initial revision.

 --------------------------------------------------------------------*/


