/*************************************************************************
 *
 *  $RCSfile: srcvcfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop


#include "swtypes.hxx"
#ifndef _SV_RESID_HXX //autogen
#include <vcl/resid.hxx>
#endif
#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef _DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#include "srcvcfg.hxx"
#include "cfgstr.hrc"
#include "cfgid.h"


#define VERSION01			1
#define VERSION02			2 // Farbkonfiguration
#define SRCCONFIG_VERSION 	VERSION02

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SwSrcViewConfig::SwSrcViewConfig() :
	SfxConfigItem(CFG_SRCVIEW),
	nFontSize(10)
{
	UseDefault();
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

BOOL  SwSrcViewConfig::Store(SvStream& rOut)
{
	rOut << (UINT16) SRCCONFIG_VERSION;
	rOut << (UINT16) nFontSize;
	rOut.WriteByteString( sFontStyle, gsl_getSystemTextEncoding());
	for(USHORT i = 0; i < SYNTAX_COLOR_MAX; i++)
	{
		rOut << aSyntaxColors[i];
	}
	return SfxConfigItem::ERR_OK;
}


/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

int  SwSrcViewConfig::Load(SvStream& rIn)
{
	SetDefault(FALSE);
	USHORT 	nVersion;
	rIn >> nVersion;
	if(nVersion >= VERSION01)
	{
		UINT16 nValue;
		rIn >> nValue;
		nFontSize = nValue;
		rIn.ReadByteString( sFontStyle, gsl_getSystemTextEncoding());
		if(nVersion >= VERSION02)
		{
			for(USHORT i = 0; i < SYNTAX_COLOR_MAX; i++)
			{
				rIn >> aSyntaxColors[i];
			}
		}
		return SfxConfigItem::ERR_OK;
	}
	else
		return SfxConfigItem::WARNING_VERSION;
}
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void  SwSrcViewConfig::UseDefault()
{
	nFontSize = 200; // 10pt
#if defined(MAC)
	sFontStyle = String::CreateFromAscii("Monaco");
#elif defined(WNT)
	sFontStyle = String::CreateFromAscii("Courier New");
#else
	sFontStyle = String::CreateFromAscii("Courier");
#endif
	aSyntaxColors[SRC_SYN_SGML		] = Color( COL_BLUE );		// TT_SGML
	aSyntaxColors[SRC_SYN_COMMENT	] = Color( COL_GREEN );		// TT_COMMENT
	aSyntaxColors[SRC_SYN_KEYWRD	] = Color( COL_LIGHTRED );	// TT_KEYWORD
	aSyntaxColors[SRC_SYN_UNKNOWN	] = Color( COL_GRAY );		// TT_UNKNOWN
}

/*-----------------18.11.96 11.44-------------------

--------------------------------------------------*/

String  SwSrcViewConfig::GetName() const
{
	return SW_RESSTR(STR_CFG_SRCVIEW);
}

/*-----------------19.04.97 10:08-------------------

--------------------------------------------------*/
void	SwSrcViewConfig::SetSyntaxColor(USHORT nIdx, const Color& rColor)
{
	DBG_ASSERT(nIdx < SYNTAX_COLOR_MAX, "falscher Index")
	if(aSyntaxColors[nIdx] != rColor)
	{
		SetDefault(FALSE);
		aSyntaxColors[nIdx] = rColor;
	}
}

/*------------------------------------------------------------------------
	$Log: srcvcfg.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:33  hr
	initial import
	
	Revision 1.9  2000/09/18 16:05:18  willem.vandorp
	OpenOffice header added.
	
	Revision 1.8  2000/04/11 08:02:24  os
	UNICODE
	
	Revision 1.7  2000/02/11 14:44:15  hr
	#70473# changes for unicode ( patched by automated patchtool )

	Revision 1.6  1997/09/30 06:54:38  OS
	include


	  Rev 1.5   30 Sep 1997 08:54:38   OS
   include

	  Rev 1.4   21 Apr 1997 18:51:52   NF
   SEXPORT durch __EXPORT ersetzt ...

	  Rev 1.3   21 Apr 1997 11:02:16   OS
   SetSyntaxColor mit const Color&

	  Rev 1.2   19 Apr 1997 10:11:52   OS
   Farben in der Konfiguration

	  Rev 1.1   17 Dec 1996 08:38:22   OS
   unter WNT Courier New, MAC: Monaco

	  Rev 1.0   18 Nov 1996 13:58:26   OS
   Initial revision.

------------------------------------------------------------------------*/





