/*************************************************************************
 *
 *  $RCSfile: ltmpdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SFXNEW_HXX //autogen
#include <sfx2/new.hxx>
#endif

#include "swtypes.hxx"
#include "ltmpdlg.hxx"
#include "helpid.h"
#include "dialog.hrc"



/*--------------------------------------------------------------------
   Beschreibung:
 --------------------------------------------------------------------*/


SwLoadTemplateDlg::SwLoadTemplateDlg( Window* pParent ) :
	SfxSimpleFileDialog(pParent , WB_OPEN|WB_3DLOOK ),
	pNewDlg(0)
{
	SetText(SW_RESSTR(STR_LOAD_TEMPLATE));
	pTemplateBtn 	= new PushButton(this, SW_RES(PB_TPL_LOAD));
	pTextCB 		= new CheckBox(this, SW_RES(CB_TPL_TEXT));
	pFrameCB    	= new CheckBox(this, SW_RES(CB_TPL_FRAME));
	pPageCB    		= new CheckBox(this, SW_RES(CB_TPL_PAGE));
	pNumberingCB 	= new CheckBox(this, SW_RES(CB_TPL_NUMBERING));
	pOverwriteCB	= new CheckBox(this, SW_RES(CB_TPL_OVERWRITE));
	pTextCB 	 ->SetHelpId(	HID_LTEMPL_TEXT     );
	pFrameCB     ->SetHelpId(	HID_LTEMPL_FRAME    );
	pPageCB    	 ->SetHelpId(	HID_LTEMPL_PAGE     );
	pNumberingCB->SetHelpId(	HID_LTEMPL_NUMBERING);
	pOverwriteCB ->SetHelpId(	HID_LTEMPL_OVERRIDE );
	AddControl(pTemplateBtn , FALSE);
	AddControl(pTextCB , FALSE);
	AddControl(pFrameCB, FALSE);
	AddControl(pPageCB , FALSE);
	AddControl(pNumberingCB, FALSE);
	AddControl(pOverwriteCB, TRUE);
	Link aLk = LINK(this, SwLoadTemplateDlg, ClickHdl);
	pTextCB->Check( TRUE );
	pFrameCB->Check( TRUE );
	pPageCB->Check( TRUE );
	pNumberingCB->Check(TRUE);
	pTextCB->SetClickHdl( aLk );
	pFrameCB->SetClickHdl( aLk );
	pPageCB->SetClickHdl( aLk );
	pNumberingCB->SetClickHdl( aLk );
	pTemplateBtn->SetClickHdl(LINK(this, SwLoadTemplateDlg, TemplateHdl));
}
/*--------------------------------------------------------------------
   Beschreibung:
 --------------------------------------------------------------------*/


SwLoadTemplateDlg::~SwLoadTemplateDlg()
{
	ReleaseOwnerShip(pTemplateBtn);
	ReleaseOwnerShip(pTextCB );
	ReleaseOwnerShip(pFrameCB);
	ReleaseOwnerShip(pPageCB );
	ReleaseOwnerShip(pNumberingCB);
	ReleaseOwnerShip(pOverwriteCB);
	delete pTemplateBtn;
	delete pTextCB;
	delete pFrameCB;
	delete pPageCB;
	delete pNumberingCB;
	delete pNewDlg;
	delete pOverwriteCB;
}

/*--------------------------------------------------------------------
   Beschreibung:
 --------------------------------------------------------------------*/


IMPL_LINK_INLINE_START( SwLoadTemplateDlg, TemplateHdl, Button *, EMPTYARG )
{
	EndDialog( RET_TEMPLATE );
	return 0;
}
IMPL_LINK_INLINE_END( SwLoadTemplateDlg, TemplateHdl, Button *, EMPTYARG )

/*--------------------------------------------------------------------
   Beschreibung:
 --------------------------------------------------------------------*/


SfxNewFileDialog* SwLoadTemplateDlg::GetNewFileDlg()
{
	if(!pNewDlg)
	{
		pNewDlg = new SfxNewFileDialog(GetParent());
		pNewDlg->SetText(SW_RESSTR(STR_NEWDLG_NAME));
		pNewDlg->SetHelpId(HID_FILEDLG_LOADTEMPLATE);
	}

	return pNewDlg;
}
/*--------------------------------------------------------------------
   Beschreibung:
 --------------------------------------------------------------------*/


IMPL_LINK( SwLoadTemplateDlg, ClickHdl, CheckBox *, EMPTYARG )
{
	BOOL bEnable = FALSE;
	if( pTextCB->IsChecked() ||
		pFrameCB->IsChecked() ||
		pPageCB->IsChecked()  ||
		pNumberingCB->IsChecked() )
	{
		bEnable = TRUE;
	}
	pTemplateBtn->Enable(bEnable);
	return 0;
}

/*************************************************************************

	  Source Code Control System - Header

	  $Log: ltmpdlg.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:34  hr
	  initial import
	
	  Revision 1.19  2000/09/18 16:05:20  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.18  2000/03/03 15:16:59  os
	  StarView remainders removed
	
	  Revision 1.17  2000/01/28 10:55:46  os
	  #72421# start new control line at the 'Overwrite' CheckBox

	  Revision 1.16  1998/09/02 12:11:34  OM
	  #45378# HelpIDs fuer Dateidialoge


	  Rev 1.15   02 Sep 1998 14:11:34   OM
   #45378# HelpIDs fuer Dateidialoge

	  Rev 1.14   09 Dec 1997 08:17:00   OS
   Vorlagen laden: auch Numerierung

	  Rev 1.13   25 Nov 1997 10:43:20   MA
   includes

	  Rev 1.12   03 Nov 1997 13:12:26   MA
   precomp entfernt

	  Rev 1.11   18 Oct 1997 18:21:02   EL
   *Verwendung von SfxSimpleFileDialog

	  Rev 1.10   30 Apr 1997 07:39:08   OS
   HelpIds

	  Rev 1.9   14 Nov 1996 15:21:18   TRI
   includes

	  Rev 1.8   11 Nov 1996 09:31:16   MA
   ResMgr

	  Rev 1.7   02 Oct 1996 17:56:30   MA
   Umstellung Enable/Disable

	  Rev 1.6   28 Aug 1996 10:10:00   OS
   includes

*************************************************************************/



