/*************************************************************************
 *
 *  $RCSfile: labfmt.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _LABFMT_HXX
#define _LABFMT_HXX

#include "labimp.hxx"
#include "labimg.hxx"

class SwLabFmtPage;

// class SwLabPreview -------------------------------------------------------

class SwLabPreview : public Window
{
	long lOutWPix;
	long lOutHPix;
	long lOutWPix23;
	long lOutHPix23;

	Color aBlackColor;
	Color aGrayColor;
	Color aWhiteColor;

	String aHDistStr;
	String aVDistStr;
	String aWidthStr;
	String aHeightStr;
	String aLeftStr;
	String aUpperStr;
	String aColsStr;
	String aRowsStr;

	long lHDistWidth;
	long lVDistWidth;
	long lHeightWidth;
	long lLeftWidth;
	long lUpperWidth;
	long lColsWidth;

	long lXWidth;
	long lXHeight;

	SwLabItem aItem;

	void Paint(const Rectangle&);

	void DrawArrow(const Point& rP1, const Point& rP2, BOOL bArrow);
	SwLabFmtPage* GetParent() {return (SwLabFmtPage*) Window::GetParent();}

public:

	 SwLabPreview(const SwLabFmtPage* pParent, const ResId& rResID);
	~SwLabPreview();

	void Update(const SwLabItem& rItem);
};

// class SwLabFmtPage -------------------------------------------------------

class SwLabFmtPage : public SfxTabPage
{
	SwLabPreview aPreview;
	FixedText	 aHDistText;
	MetricField	 aHDistField;
	FixedText	 aVDistText;
	MetricField	 aVDistField;
	FixedText	 aWidthText;
	MetricField	 aWidthField;
	FixedText	 aHeightText;
	MetricField	 aHeightField;
	FixedText	 aLeftText;
	MetricField	 aLeftField;
	FixedText	 aUpperText;
	MetricField	 aUpperField;
	FixedText	 aColsText;
	NumericField aColsField;
	FixedText	 aRowsText;
	NumericField aRowsField;

	Timer aPreviewTimer;
	BOOL  bModified;

	SwLabItem	 aItem;

	 SwLabFmtPage(Window* pParent, const SfxItemSet& rSet);
	~SwLabFmtPage();

	DECL_LINK( ModifyHdl, Edit * );
	DECL_LINK( PreviewHdl, Timer * );
	DECL_LINK( LoseFocusHdl, Control * );

	void ChangeMinMax();

public:

	static SfxTabPage* Create(Window* pParent, const SfxItemSet& rSet);

	virtual void ActivatePage(const SfxItemSet& rSet);
	virtual int  DeactivatePage(SfxItemSet* pSet = 0);
			void FillItem(SwLabItem& rItem);
	virtual BOOL FillItemSet(SfxItemSet& rSet);
	virtual void Reset(const SfxItemSet& rSet);

	SwLabDlg* GetParent() {return (SwLabDlg*) SfxTabPage::GetParent()->GetParent();}
};

#endif

