/*************************************************************************
 *
 *  $RCSfile: cropex.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"
#include "uiparam.hxx"
#include "swtypes.hxx"
#include "cropex.hxx"
#include "frmui.hrc"


/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


SwCropExample::SwCropExample(Window* pPar, const ResId& rResId ) :
	Window(pPar, rResId),
	aFrameSize(MM50, MM50),
	nXZoom(100),
	nYZoom(100),
	aTopLeft(0,0),
	aBottomRight(0,0),
	aNormalColor(GetFillColor()),
	aGrf()
{
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


void SwCropExample::Paint( const Rectangle& rRect )
{
	Size aWinSize = PixelToLogic(GetOutputSizePixel());
	SetLineColor(Color(COL_GRAY));
	Rectangle aRect(Point((aWinSize.Width() - aFrameSize.Width())/2,
						  (aWinSize.Height() - aFrameSize.Height())/2),
						  aFrameSize );
	SetRasterOp( ROP_OVERPAINT );
	aGrf.Draw( this,  aRect.TopLeft(), aRect.GetSize() );

	Size aSz( 2, 0 );
	aSz = PixelToLogic( aSz );
	SetFillColor(Color(COL_TRANSPARENT));
	SetRasterOp( ROP_INVERT );
	aRect.Left() 	-= aTopLeft.Y();
	aRect.Top() 	-= aTopLeft.X();
	aRect.Right() 	+= aBottomRight.Y();
	aRect.Bottom() 	+= aBottomRight.X();
	DrawRect(aRect);
}


/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


void SwCropExample::SetFrameSize(Size aSz)
{
	aFrameSize = aSz;
	Size aWinSize = GetOutputSizePixel();
	Fraction aXScale(aWinSize.Width() * 4,
					 aFrameSize.Width() * 5 );
	Fraction aYScale(aWinSize.Height()*4,
					aFrameSize.Height() * 5);

	MapMode aMapMode(GetMapMode());

	if(aYScale < aXScale)
	{
		aMapMode.SetScaleX(aYScale);
		aMapMode.SetScaleY(aYScale);
	}
	else
	{
		aMapMode.SetScaleX(aXScale);
		aMapMode.SetScaleY(aXScale);
	}
	SetMapMode(aMapMode);
	Invalidate();
}
/*-----------------25.02.94 21:22-------------------
   $Log: cropex.cxx,v $
   Revision 1.1.1.1  2000/09/18 17:14:37  hr
   initial import

   Revision 1.12  2000/09/18 16:05:33  willem.vandorp
   OpenOffice header added.

   Revision 1.11  2000/03/03 15:17:01  os
   StarView remainders removed

   Revision 1.10  1997/11/24 16:40:10  MA
   include


	  Rev 1.9   24 Nov 1997 17:40:10   MA
   include

	  Rev 1.8   03 Nov 1997 13:19:46   MA
   precomp entfernt

	  Rev 1.7   23 Apr 1997 13:45:58   OS
   ResId const

	  Rev 1.6   28 Aug 1996 11:52:48   OS
   includes

	  Rev 1.5   21 Mar 1996 19:56:56   OS
   Grafik fuellt jeztzt 80

	  Rev 1.4   21 Mar 1996 12:58:08   OS
   - aBmpSize

	  Rev 1.3   20 Mar 1996 09:25:28   MA
   chg: Linie besser sichtbar

	  Rev 1.2   19 Mar 1996 16:36:40   OS
   Rand invertiert

	  Rev 1.1   18 Mar 1996 14:19:28   OS
   Graphic statt Bmp

	  Rev 1.0   15 Mar 1996 14:51:26   OS
   Initial revision.

--------------------------------------------------*/


