/*************************************************************************
 *
 *  $RCSfile: autofdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _AUTOFDLG_HXX
#define _AUTOFDLG_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif

#ifdef _AUTOFDLG_CXX

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
/*
#ifndef _SVX_CHECKLBX_HXX //autogen
#include <svx/checklbx.hxx>
#endif*/

#ifndef _SVX_SIMPTABL_HXX //autogen
#include <svx/simptabl.hxx>
#endif

#endif
class SwWrtShell;
class SvLBoxEntry;
class SvLBoxButtonData;

/*-----------------17.12.96 14.06-------------------

--------------------------------------------------*/
class SwAutoFmtTabDlg : public SfxTabDialog
{
	SwWrtShell*			pShell;

	protected:
		DECL_LINK(CloseHdl, PushButton*);
		virtual void  		PageCreated(USHORT nId, SfxTabPage& rPage);

	public:
		SwAutoFmtTabDlg(Window* pParent, const SfxItemSet& rSet, SwWrtShell* pSh);
		~SwAutoFmtTabDlg();

};

#ifdef _AUTOFDLG_CXX

class SvLBoxEntry;

/*-----------------17.12.96 15.18-------------------

--------------------------------------------------*/

class SwCheckListBox : public SvxSimpleTable
{
	protected:
		void			InitEntry(SvLBoxEntry*,const String&,const Image&,const Image&);
		virtual void	SetTabs();
		virtual void	HBarClick();

	public:
		SwCheckListBox(Window* pParent, const ResId& rResId ) :
			SvxSimpleTable( pParent, rResId ){}

		inline void *GetUserData(ULONG nPos) { return GetEntry(nPos)->GetUserData(); }
		inline void SetUserData(ULONG nPos, void *pData ) { GetEntry(nPos)->SetUserData(pData); }
		inline ULONG GetSelectEntryPos() { return GetModel()->GetAbsPos(FirstSelected()); }

		BOOL			IsChecked(ULONG nPos, USHORT nCol);
		void			CheckEntryPos(ULONG nPos, USHORT nCol, BOOL bChecked);
		SvButtonState	GetCheckButtonState( SvLBoxEntry*, USHORT nCol ) const;
		void			SetCheckButtonState( SvLBoxEntry*, USHORT nCol, SvButtonState );
};

/*-----------------17.12.96 14.06-------------------

--------------------------------------------------*/

#define CBCOL_FIRST		0
#define CBCOL_SECOND	1
#define CBCOL_BOTH		2

class SwAutoFmtApplyPage : public SfxTabPage
{
	SwCheckListBox	aCheckLB;
	PushButton		aEditPB;
	FixedText		aHeader1Expl;
	FixedText		aHeader2Expl;

	String			sHeader1;
	String			sHeader2;

	String			sDeleteEmptyPara;
	String			sUseReplaceTbl;
	String			sCptlSttWord;
	String			sCptlSttSent;
	String			sTypo;
	String			sUserStyle;
	String			sBullet;
	String			sBoldUnder;
	String			sFraction;
	String			sDetectURL;
	String          sDash;
	String			sOrdinal;
	String			sRightMargin;
	String			sNum;
	String			sBorder;
	String			sTable;
	String			sReplaceTemplates;

	String			sMargin;
	String			sBulletChar;
	Bitmap			aChkunBmp;
	Bitmap			aChkchBmp;
	Bitmap			aChkchhiBmp;
	Bitmap			aChkunhiBmp;
	Bitmap			aChktriBmp;
	Bitmap			aChktrihiBmp;

	Font			aBulletFont;
	USHORT			nPercent;

	SwWrtShell* 	pShell;
	SvLBoxButtonData*	pCheckButtonData;

		DECL_LINK(SelectHdl, SwCheckListBox*);
		DECL_LINK(EditHdl, PushButton*);
		SvLBoxEntry* CreateEntry(String& rTxt, USHORT nCol = CBCOL_BOTH);


		SwAutoFmtApplyPage( Window* pParent,
							const SfxItemSet& rSet );
		~SwAutoFmtApplyPage();

	public:
		static SfxTabPage*  Create( Window* pParent,
								const SfxItemSet& rAttrSet);
		virtual BOOL        FillItemSet( SfxItemSet& rSet );
		virtual void        Reset( const SfxItemSet& rSet );

		void				SetShell(SwWrtShell* pSh) {pShell = pSh;}
};

#endif
#endif
