/*************************************************************************
 *
 *  $RCSfile: cfgaddr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CFGADDR_HXX
#define _CFGADDR_HXX

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif


class SwCfgAddrDlg : public ModalDialog
{
	FixedText aCompanyLbl;
	Edit aCompanyEdit;
	FixedText aNameLbl;
	Edit aFirstName;
	Edit aName;
	Edit aShortName;
	FixedText aStreetLbl;
	Edit aStreetEdit;
	FixedText aCityLbl;
	Edit aCountryEdit;
	Edit aPLZEdit;
	Edit aCityEdit;
	FixedText aTitleLbl;
	Edit aTitleEdit;
	FixedText aPositionLbl;
	Edit aPositionEdit;
	FixedText aTelPrivLbl;
	Edit aTelPrivEdit;
	FixedText aTelCompanyLbl;
	Edit aTelCompanyEdit;
	FixedText aFaxLbl;
	Edit aFaxEdit;
	FixedText aEmailLbl;
	Edit aEmailEdit;
	GroupBox aAddrFrm;

	OKButton aOKBtn;
	CancelButton aCancelBtn;
	PushButton aLoadBtn;

	void LoadHdl(Button *);
public:
	String GetCompanyName() const;		// inline
	String GetFirstName() const;		// inline
	String GetName() const;		// inline
	String GetShortName() const;		// inline
	String GetStreetName() const;		// inline
	String GetCountryName() const;		// inline
	String GetPLZName() const;		// inline
	String GetCityName() const;		// inline
	String GetTitle() const;		// inline
	String GetPosition() const;		// inline
	String GetTelPriv() const;		// inline
	String GetTelCompany() const;		// inline
	String GetFaxName() const;		// inline
	String GetEmailName() const;		// inline

	void SetCompanyName(const String &);		// inline
	void SetFirstName(const String &);		// inline
	void SetName(const String &);		// inline
	void SetShortName(const String &);		// inline
	void SetStreetName(const String &);		// inline
	void SetCountryName(const String &);		// inline
	void SetPLZName(const String &);		// inline
	void SetCityName(const String &);		// inline
	void SetTitle(const String &);		// inline
	void SetPosition(const String &);		// inline
	void SetTelPriv(const String &);		// inline
	void SetTelCompany(const String &);		// inline
	void SetFaxName(const String &);		// inline
	void SetEmailName(const String &);		// inline

	SwCfgAddrDlg(Window *pParent, BOOL bShowLoadBtn);
	~SwCfgAddrDlg();
};
// INLINE METHODE --------------------------------------------------------
inline String SwCfgAddrDlg::GetCompanyName() const
{	return 	aCompanyEdit.GetText(); }
inline String SwCfgAddrDlg::GetFirstName() const
{	return 	aFirstName.GetText(); }
inline String SwCfgAddrDlg::GetName() const
{	return 	aName.GetText(); }
inline String SwCfgAddrDlg::GetShortName() const
{	return 	aShortName.GetText(); }
inline String SwCfgAddrDlg::GetStreetName() const
{	return 	aStreetEdit.GetText(); }
inline String SwCfgAddrDlg::GetCountryName() const
{	return 	aCountryEdit.GetText(); }
inline String SwCfgAddrDlg::GetPLZName() const
{	return 	aPLZEdit.GetText(); }
inline String SwCfgAddrDlg::GetCityName() const
{	return 	aCityEdit.GetText(); }
inline String SwCfgAddrDlg::GetTitle() const
{	return 	aTitleEdit.GetText(); }
inline String SwCfgAddrDlg::GetPosition() const
{	return 	aPositionEdit.GetText(); }
inline String SwCfgAddrDlg::GetTelPriv() const
{	return 	aTelPrivEdit.GetText(); }
inline String SwCfgAddrDlg::GetTelCompany() const
{	return 	aTelCompanyEdit.GetText(); }
inline String SwCfgAddrDlg::GetFaxName() const
{	return 	aFaxEdit.GetText(); }
inline String SwCfgAddrDlg::GetEmailName() const
{	return 	aEmailEdit.GetText(); }

inline void SwCfgAddrDlg::SetCompanyName(const String &rStr)
{		aCompanyEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetFirstName(const String &rStr)
{		aFirstName.SetText(rStr); }
inline void SwCfgAddrDlg::SetName(const String &rStr)
{		aName.SetText(rStr); }
inline void SwCfgAddrDlg::SetShortName(const String &rStr)
{		aShortName.SetText(rStr); }
inline void SwCfgAddrDlg::SetStreetName(const String &rStr)
{		aStreetEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetCountryName(const String &rStr)
{		aCountryEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetPLZName(const String &rStr)
{		aPLZEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetCityName(const String &rStr)
{		aCityEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetTitle(const String &rStr)
{		aTitleEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetPosition(const String &rStr)
{		aPositionEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetTelPriv(const String &rStr)
{		aTelPrivEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetTelCompany(const String &rStr)
{		aTelCompanyEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetFaxName(const String &rStr)
{		aFaxEdit.SetText(rStr); }
inline void SwCfgAddrDlg::SetEmailName(const String &rStr)
{		aEmailEdit.SetText(rStr); }

#endif
