/*************************************************************************
 *
 *  $RCSfile: dataex.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DATAEX_HXX
#define _DATAEX_HXX

#ifndef _EMBOBJ_HXX //autogen
#include <so3/embobj.hxx>
#endif
#ifndef _DTRANS_HXX //autogen
#include <so3/dtrans.hxx>
#endif

class Graphic;
class ImageMap;
class INetBookmark;
class INetImage;
class SwDoc;
class SwDocFac;
class SwNode;
class SwTextBlocks;
class SwWrtShell;

enum ClpBufferType
{
	CLP_NONE 			= 0x0000,
	CLP_DOCUMENT		= 0x0001,
	CLP_DOCUMENT_WORD	= 0x0002,
	CLP_GRAPHIC			= 0x0004,
	CLP_TABELLE			= 0x0008,
	CLP_DDELINK			= 0x0010,
	CLP_OLE				= 0x0020,
	CLP_INETFLD			= 0x0040,
	CLP_DRAWING			= 0x0081	//Drawing ist auch intern!
};

class SwDataExchange : public SvDataMemberObject
{
	SwWrtShell *pWrtShell;

	SvDataTypeList		aTypeList;
	SvEmbeddedObjectRef aDocShellRef;
	SvObjectDescriptor  aObjDesc;		//Damit wir fragen beantworten koennen
										//ohne das delayed rendering aufzugeben.

	ClpBufferType	eBufferType;
	SwDocFac		*pClpDocFac;
	Graphic			*pClpGraphic, *pClpBitmap, *pOrigGrf;
	SvAdviseSinkRef	refDdeLink;
	INetBookmark	*pBkmk;		// URL und Beschreibung!
	ImageMap		*pImageMap;
	INetImage		*pTargetURL;

	BOOL bIntern	:1;	//D&D innerhalb des SW
	BOOL bTblSel	:1;	//D&D Tabellen oder Rahmenselektion

	static int _Paste( SwWrtShell& rSh, SotDataObject& rObj,
						const DropEvent* pEvt = 0 );
	static int  ImpPaste( SwWrtShell&, SotDataObject&, ULONG nFormat,
						const DropEvent* pEvt = 0, BOOL bMsg = TRUE );
	static int ImpPasteDDE( SwWrtShell&, SotDataObject&,
							FASTBOOL bReReadGrf, BOOL bMsg );

	int PrivatePaste( SwWrtShell& );
	int PrivateDrop( SwWrtShell&, const Point& rPt, BOOL bMove );

	SvEmbeddedObject* FindOLEObj() const;


	static USHORT GetSotDestination( const SwWrtShell& rSh, const Point* = 0 );
	static void SetSelInShell( SwWrtShell& rSh, BOOL bSelectFrm,
								const Point* rPt );

	static int _PasteSdrFormat( SotDataObject& rObj, SwWrtShell& rSh,
								USHORT nAction, const Point* pPt,
								BYTE nActionFlags );
	static int _PasteGrf( SotDataObject& rObj, SwWrtShell& rSh,
							ULONG nFmt, USHORT nAction,
							const Point* pPt, BYTE nActionFlags, BOOL bMsg );
	static int _PasteImageMap( SotDataObject& rObj, SwWrtShell& rSh );
	static int _PasteTargetURL( SotDataObject& rObj, SwWrtShell& rSh,
								USHORT nAction, const Point* pPt,
								BOOL bInsertGRF );
	static int _PasteFileContent( SotDataObject& rObj, SwWrtShell& rSh,
									ULONG nFmt, BOOL bMsg );
	static int _PasteAsHyperlink( SotDataObject& rObj, SwWrtShell& rSh,
										ULONG nFmt );
	static int _PasteFileName( SotDataObject& rObj, SwWrtShell& rSh,
							ULONG nFmt, USHORT nAction,
							const Point* pPt, BYTE nActionFlags, BOOL bMsg );
	static int _PasteDBData( SotDataObject& rObj, SwWrtShell& rSh,
									ULONG nFmt, BOOL bLink,
									const Point* pDragPt, BOOL bMsg );
	static int _PasteOLE( SotDataObject& rObj, SwWrtShell& rSh,
							BYTE nActionFlags, BOOL bMsg );
	static int _PasteFileList( SotDataObject& rObj, SwWrtShell& rSh,
									const Point* pPt, BOOL bMsg );

public:
	SwDataExchange( SwWrtShell& );
	SwDataExchange( SwDoc& rDoc );
	virtual ~SwDataExchange();
	void Clear();

		  SwWrtShell *GetShell()	   { return pWrtShell; }
	const SwWrtShell *GetShell() const { return pWrtShell; }

	void SetIntern()	   { bIntern = TRUE;   }
	void SetTblSel()	   { bTblSel = TRUE;   }
	BOOL IsIntern()	const  { return bIntern;   }
	BOOL IsTblSel() const  { return bTblSel;   }

	ClpBufferType GetBufferType() const { return eBufferType; }

	//Copy-Methoden
	int	 Cut();						//Copy(), DeleteSelection()
	void DeleteSelection();
	int	 Copy( BOOL bDragDrop, BOOL bIsCut = FALSE );	//DragDrop, nur ankuendigen
	int  CalculateAndCopy();		//Spezialfall fuer Calculator
	int  CopyGlossary( SwTextBlocks& rGlossary, const String& rStr );

	//Paste-Methoden, es wird intern entschieden ob intern oder extern.
	static int Paste	   ( SwWrtShell&, SotDataObject& );
	static int PasteSpecial( SwWrtShell&, SotDataObject& );
	static int PasteFormat ( SwWrtShell&, SotDataObject&, ULONG nFormat ); // fuer API
	static int Drop		   ( SwWrtShell&, SotDataObject&, const DropEvent&);

	static int PasteData( SotDataObject& rObj, SwWrtShell& rSh,
							USHORT nAction, ULONG nFormat,
							USHORT nDestination,
							const DropEvent* pEvt = 0,
							BOOL bIsPasteFmt = FALSE );


	static BOOL	IsPaste( const SwWrtShell&, SotDataObject& );
	static BOOL IsPasteSpecial( const SwWrtShell&, SotDataObject& );

	virtual BOOL  GetData( SvData * );
	virtual BOOL  GetDataHere( SvData * );
	virtual const SvDataTypeList &GetTypeList() const;

	//Stellt das Document ein (Seitenraender, VisArea) und defaultet
	//die RealSize.
	static void InitOle( SvEmbeddedObjectRef rRef, SwDoc *pDoc );

	//Goessere Datenmenge (fuer Abfrage beim Beenden)?
	BOOL IsBig() const;

	const SvObjectDescriptor& GetObjectDescriptor() const
		{ return aObjDesc; }		//Damit wir fragen beantworten koennen

};
SV_DECL_IMPL_REF(SwDataExchange);


#endif
