/*************************************************************************
 *
 *  $RCSfile: docstdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DOCSTDLG_HXX
#define _DOCSTDLG_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#include "docstat.hxx"

/*--------------------------------------------------------------------
	Beschreibung:   DocInfo jetzt als Page
 --------------------------------------------------------------------*/

class SwDocStatPage: public SfxTabPage
{
public:
	SwDocStatPage(Window *pParent, const SfxItemSet &rSet);
	~SwDocStatPage();

	static SfxTabPage *Create(Window *pParent, const SfxItemSet &rSet);

protected:
	virtual BOOL    FillItemSet(      SfxItemSet &rSet);
	virtual void    Reset      (const SfxItemSet &rSet);

	DECL_LINK( UpdateHdl, PushButton*);

private:
	FixedText       aTableLbl;
	FixedText       aGrfLbl;
	FixedText       aOLELbl;
	FixedText       aPageLbl;
	FixedText       aParaLbl;
	FixedText       aWordLbl;
	FixedText		aWordDelimFT;
	Edit			aWordDelim;
	FixedText       aCharLbl;
	FixedText       aLineLbl;

	FixedInfo       aTableNo;
	FixedInfo       aGrfNo;
	FixedInfo       aOLENo;
	FixedInfo       aPageNo;
	FixedInfo       aParaNo;
	FixedInfo       aWordNo;
	FixedInfo       aCharNo;
	FixedInfo       aLineNo;

	PushButton		aUpdatePB;
	SwDocStat       aDocStat;

	void            Update();
	void            SetData(const SwDocStat &rStat);
};

#endif
