/*************************************************************************
 *
 *  $RCSfile: inputwin.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef SW_INPUTWIN_HXX
#define SW_INPUTWIN_HXX


#ifndef _MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX //autogen
#include <sfx2/childwin.hxx>
#endif
#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

class SwFldMgr;
class SwWrtShell;
class SwView;
class SfxDispatcher;

//========================================================================
class InputEdit : public Edit
{
public:
					InputEdit(Window* pParent, WinBits nStyle) :
						Edit(pParent , nStyle){}

	void			UpdateRange(const String& aSel,
								const String& aTblName );

protected:
	virtual void 	KeyInput( const KeyEvent&  );
};

//========================================================================

class SwInputWindow : public ToolBox
{
friend class InputEdit;

	Edit			aPos;
	InputEdit		aEdit;
	PopupMenu		aPopMenu;
	SwFldMgr*		pMgr;
	SwWrtShell*		pWrtShell;
	SwView*			pView;
	String 			aAktTableName, sOldFml;
	USHORT 			nActionCnt;

	BOOL			bFirst : 1;  //Initialisierungen beim ersten Aufruf
	BOOL 			bActive : 1; //fuer Hide/Show beim Dokumentwechsel
	BOOL 			bIsTable : 1;
	BOOL 			bDelSel : 1;
	BOOL 			bDoesUndo : 1;
	BOOL 			bResetUndo : 1;
	BOOL			bCallUndo : 1;


	void DelBoxCntnt();
	DECL_LINK( ModifyHdl, InputEdit* );

protected:
	virtual void 	Resize();
	virtual void 	Click();
	DECL_LINK( MenuHdl, Menu * );
	void 			ApplyFormula();
	void 			CancelFormula();
public:
					SwInputWindow( Window* pParent );
	virtual			~SwInputWindow();


	void			SelectHdl( ToolBox*);
	virtual void 	Show();
	BOOL			IsActive(){ return bActive; };
	DECL_LINK( SelTblCellsNotify, SwWrtShell * );

	void 			SetFormula( const String& rFormula, BOOL bDelSel = TRUE );
	const SwView*	GetView() const{return pView;}
};

class SwInputChild : public SfxChildWindow
{
	BOOL 			bObjVis;
	SfxDispatcher* 	pDispatch;
public:
	SwInputChild( Window* ,
						USHORT nId,
						SfxBindings*,
						SfxChildWinInfo*  );
	~SwInputChild();
	SFX_DECL_CHILDWINDOW( SwInputChild );
	void 			SetFormula( const String& rFormula, BOOL bDelSel = TRUE )
						{ ((SwInputWindow*)pWindow)->SetFormula(
									rFormula, bDelSel ); }
	const SwView*	GetView() const{return ((SwInputWindow*)pWindow)->GetView();}

};

//==================================================================

#endif

