/*************************************************************************
 *
 *  $RCSfile: modcfg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _MODOPT_HXX
#define _MODOPT_HXX


#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _SV_WINTYPES_HXX
#include <vcl/wintypes.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SFXCFGITEM_HXX //autogen
#include <sfx2/cfgitem.hxx>
#endif
#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif

#include "authratr.hxx"
#include "caption.hxx"
#include "tblenum.hxx"
#include "linkenum.hxx"

typedef InsCaptionOpt* InsCaptionOptPtr;
SV_DECL_PTRARR_SORT_DEL(InsCapOptArr, InsCaptionOptPtr, 0, 5)

class InsCaptionOptArr : public InsCapOptArr
{
	friend class SwModuleOptions;
protected:
	InsCaptionOpt* Find(const SwCapObjType eType, const SvGlobalName *pOleId = 0) const;
};

class SwModuleOptions : public SfxConfigItem
{
	InsCaptionOptArr aCapOptions;
	InsCaptionOptArr aHTMLCapOptions;
	USHORT		nDefTab;			//.....

	// Tabellenmodus (verschieben/einfuegen) und Standardwerte
	USHORT		nTblHMove;  		//int Table/Shift/Row
	USHORT 		nTblVMove;          //int Table/Shift/Column
	USHORT 		nTblHInsert;        //int Table/Insert/Row
	USHORT		nTblVInsert;        //int Table/Insert/Column
	TblChgMode	eTblChgMode;    	//int Table/Change/Effect

	AuthorCharAttr	aInsertAttr;	//Revision/TextDisplay/Insert/Attribute  // Redlining: Author-Zeichenattribute
									//Revision/TextDisplay/Insert/Color
	AuthorCharAttr	aDeletedAttr;	//Revision/TextDisplay/Delete/Attribute
									//Revision/TextDisplay/Delete/Color
	AuthorCharAttr	aFormatAttr;    //Revision/TextDisplay/ChangeAttribute/Attribute
									//Revision/TextDisplay/ChangeAttribute/Color
	USHORT			nMarkAlign;		//Revision/LinesChanged/Mark
	Color			aMarkColor;     //Revision/LinesChanged/Color

	FieldUnit	eUserMetric;
	FieldUnit	eWebUserMetric;

	BOOL		bGrfToGalleryAsLnk;
	BOOL		bNumAlignSize;		// Numerierung: Groessenabgleich
	BOOL		bSinglePrintJob;	// Serienbrief: einzelne Druckjobs erzeugen
	BYTE		nMailingFormats;	// Serienbrief: eMail-Formate
	BOOL		bNameFromColumn;	// Serienbrief: Dateiname aus DB-Spalte generieren
	String		sMailingPath;		// Serienbrief: Pfad
	String		sMailName;			// Serienbrief: Dateiname oder Spaltenname
	String		sWordDelimiter;		// Statistik-TP: Worttrenner

	BOOL		bInsWithCaption;	   //Insert/Caption/Automatic				// Objekte beschriftet einfuegen
	BOOL		bInsTblFormatNum;		// Table/Input/NumberRecognition 		// Automatische Zahlenerkennung
	BOOL		bInsTblChangeNumFormat; // Table/Input/NumberFormatRecognition 	// Automatische Zahlenformaterkennung
	BOOL		bInsTblAlignNum;		// Table/Input/Alignment				// Zahlen ausrichten
	USHORT		nInsTblFlags;			//Insert/Table/Header	 				// Flags fuer Tabellen einfuegen
										//Insert/Table/RepeatHeader
										//Insert/Table/Split
										//Insert/Table/Border

	BOOL		bHTMLInsWithCaption;   //Insert/Caption/Automatic		// Objekte beschriftet einfuegen
	BOOL		bHTMLInsTblFormatNum;		// Table/Input/NumberRecognition 		 // Automatische Zahlenerkennung
	BOOL		bHTMLInsTblChangeNumFormat;	// Table/Input/NumberFormatRecognition	// Automatische Zahlenformaterkennung
	BOOL		bHTMLInsTblAlignNum;		// Table/Input/Alignment				 // Zahlen ausrichten
	USHORT		nHTMLInsTblFlags;			//Insert/Table/Header	 				 // Flags fuer Tabellen einfuegen
											//Insert/Table/RepeatHeader
											//Insert/Table/Split
											//Insert/Table/Border


	USHORT		nLinkMode;			// Verknuepfungen autom./manuell/nie aktualisieren
	USHORT		nFldUpdateFlags;	// Aktualisierung von Feldern und Diagrammen

	BOOL		bDefaultFontsInCurrDocOnly; //apply default font to current document only

	// preview flags
	BOOL		bShowAutoTextPreview : 1;
	BOOL 		bShowIndexPreview : 1;

	virtual	int		Load(SvStream&);
	virtual	BOOL	Store(SvStream&);
	virtual	void 	UseDefault();

public:
	SwModuleOptions();

	virtual String	GetName() const;

	USHORT		GetDefTab() const { return nDefTab;}
	void		SetDefTab( USHORT nSet ) { 	nDefTab = nSet;
											SetDefault(FALSE);}

	TblChgMode	GetTblMode() const { return eTblChgMode;}
	void		SetTblMode( TblChgMode  eSet ) { eTblChgMode = eSet;
												SetDefault(FALSE);}

	USHORT		GetTblHMove() const { return nTblHMove;}
	void		SetTblHMove( USHORT nSet ) { 	nTblHMove = nSet;
												SetDefault(FALSE);}

	USHORT 		GetTblVMove() const { return nTblVMove;}
	void 		SetTblVMove( USHORT nSet ) { 	nTblVMove = nSet;
												SetDefault(FALSE);}

	USHORT 		GetTblHInsert() const {return nTblHInsert;}
	void 		SetTblHInsert( USHORT nSet ) {	nTblHInsert = nSet;
												SetDefault(FALSE);}

	USHORT		GetTblVInsert() const {return nTblVInsert;}
	void 		SetTblVInsert( USHORT nSet ) {	nTblVInsert = nSet;
												SetDefault(FALSE);}

	const AuthorCharAttr	&GetInsertAuthorAttr() const { return aInsertAttr; }
	void 		SetInsertAuthorAttr( AuthorCharAttr &rAttr ) {	aInsertAttr = rAttr;
																SetDefault(FALSE);}

	const AuthorCharAttr	&GetDeletedAuthorAttr() const { return aDeletedAttr; }
	void 		SetDeletedAuthorAttr( AuthorCharAttr &rAttr ) {	aDeletedAttr = rAttr;
																SetDefault(FALSE);}

	const AuthorCharAttr	&GetFormatAuthorAttr() const { return aFormatAttr; }
	void 		SetFormatAuthorAttr( AuthorCharAttr &rAttr ) {	aFormatAttr = rAttr;
																SetDefault(FALSE);}

	USHORT			GetMarkAlignMode()	const				{ return nMarkAlign; }
	void			SetMarkAlignMode(USHORT nMode)			{ nMarkAlign = nMode;
															  SetDefault(FALSE);}

	const Color&	GetMarkAlignColor()	const				{ return aMarkColor; }
	void 			SetMarkAlignColor(const Color &rColor)	{ aMarkColor = rColor;
															  SetDefault(FALSE);}

	FieldUnit	GetMetric(BOOL bWeb) const { return bWeb ? eWebUserMetric : eUserMetric;}
	void		SetMetric(FieldUnit eSet, BOOL bWeb) {
													if(bWeb)
														eWebUserMetric = eSet;
													else
														eUserMetric = eSet;
													SetDefault(FALSE);}

	BOOL		IsGrfToGalleryAsLnk() const 	{ return bGrfToGalleryAsLnk; }
	void		SetGrfToGalleryAsLnk( BOOL b )  { bGrfToGalleryAsLnk = b;
												  SetDefault(FALSE);}

	BYTE		GetMailingFormats() const 		{ return nMailingFormats;}
	void 		SetMailingFormats( BYTE nSet )	{ nMailingFormats = nSet;
												  SetDefault(FALSE);}

	BOOL		IsSinglePrintJob() const 		{ return bSinglePrintJob; }
	void		SetSinglePrintJob( BOOL b )  	{ bSinglePrintJob = b;
												  SetDefault(FALSE);}

	BOOL		IsNumAlignSize() const 			{ return bNumAlignSize; }
	void		SetNumAlignSize( BOOL b )  		{ bNumAlignSize = b;
												  SetDefault(FALSE);}

	BOOL		IsNameFromColumn() const		{ return bNameFromColumn; }
	void		SetNameFromColumn( BOOL b )  	{ bNameFromColumn = b;
												  SetDefault(FALSE);}

	String		GetMailingPath() const			{ return sMailingPath; }
	void		SetMailingPath(const String& sPath)	{ sMailingPath = sPath;
													  SetDefault(FALSE);}

	String		GetMailName() const				{ return sMailName; }
	void		SetMailName(const String& sName){ sMailName = sName;
												  SetDefault(FALSE);}

	const String	&GetWordDelimiter() const			{ return sWordDelimiter; }
	void		SetWordDelimiter(const String& sDelim)	{ sWordDelimiter = sDelim;
														  SetDefault(FALSE);}

	BOOL		IsInsWithCaption(BOOL bHTML) const
						{ return bHTML ? bHTMLInsWithCaption : bInsWithCaption; }
	void		SetInsWithCaption( BOOL bHTML, BOOL b )
					{ 	bHTML ? (bHTMLInsWithCaption = b) : (bInsWithCaption = b);
						SetDefault(FALSE);}

	BOOL		IsInsTblFormatNum(BOOL bHTML) const
					{ return bHTML ? bHTMLInsTblFormatNum : bInsTblFormatNum; }
	void		SetInsTblFormatNum( BOOL bHTML, BOOL b )
					{ bHTML ? (bHTMLInsTblFormatNum = b) : (bInsTblFormatNum = b);
					  SetDefault(FALSE);}

	BOOL		IsInsTblChangeNumFormat(BOOL bHTML) const
					{ return bHTML ? bHTMLInsTblChangeNumFormat : bInsTblChangeNumFormat; }
	void		SetInsTblChangeNumFormat( BOOL bHTML, BOOL b )
					{ bHTML ? (bHTMLInsTblChangeNumFormat = b) : (bInsTblChangeNumFormat = b);
					  SetDefault(FALSE);}



	BOOL		IsInsTblAlignNum(BOOL bHTML) const
					{ return bHTML ? bHTMLInsTblAlignNum : bInsTblAlignNum; }
	void		SetInsTblAlignNum( BOOL bHTML, BOOL b )
					{ bHTML ? (bHTMLInsTblAlignNum = b) : (bInsTblAlignNum = b);
						SetDefault(FALSE);}

	USHORT		GetInsTblFlags(BOOL bHTML) const
					{ return bHTML ? nHTMLInsTblFlags : nInsTblFlags;}
	void		SetInsTblFlags( BOOL bHTML, USHORT nSet )	{
					bHTML ? (nHTMLInsTblFlags = nSet) : (nInsTblFlags = nSet);
					SetDefault(FALSE);}

	const InsCaptionOpt* GetCapOption(BOOL bHTML, const SwCapObjType eType, const SvGlobalName *pOleId);
	BOOL		SetCapOption(BOOL bHTML, const InsCaptionOpt* pOpt);

	USHORT		GetLinkMode() const				{ return nLinkMode;}
	void		SetLinkMode( USHORT nSet )		{ 	nLinkMode = nSet;
													SetDefault(FALSE);}

	USHORT 		GetFldUpdateFlags() const {return nFldUpdateFlags;}
	void 		SetFldUpdateFlags( USHORT eFlags ) {nFldUpdateFlags = eFlags;
													SetDefault(FALSE);}

	BOOL		IsShowAutoTextPreview() const {return  bShowAutoTextPreview;}
	void		SetShowAutoTextPreview(BOOL bSet)
					{bShowAutoTextPreview = bSet;
					SetDefault(FALSE);}

	BOOL 		IsShowIndexPreview() const {return  bShowIndexPreview;}
	void		SetShowIndexPreview(BOOL bSet)
					{bShowIndexPreview = bSet;
					SetDefault(FALSE);}

	BOOL		IsDefaultFontInCurrDocOnly() const { return bDefaultFontsInCurrDocOnly;}
	void 		SetDefaultFontInCurrDocOnly(BOOL bSet)
					{
						bDefaultFontsInCurrDocOnly = bSet;
						SetDefault(FALSE);
					}
};
#endif

