/*************************************************************************
 *
 *  $RCSfile: sdrspell.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"


#ifndef _SVDITER_HXX //autogen
#include <svx/svditer.hxx>
#endif
#ifndef _SVDOTEXT_HXX //autogen
#include <svx/svdotext.hxx>
#endif
#ifndef _MyEDITDATA_HXX //autogen
#include <svx/editdata.hxx>
#endif
#ifndef _SVDPAGV_HXX //autogen
#include <svx/svdpagv.hxx>
#endif
#ifndef _SVDOGRP_HXX //autogen
#include <svx/svdogrp.hxx>
#endif
#ifndef _SFX_PRINTER_HXX //autogen
#include <sfx2/printer.hxx>
#endif
#ifndef _SVDMODEL_HXX //autogen
#include <svx/svdmodel.hxx>
#endif
#ifndef _SVX_LANGITEM_HXX
#include <svx/langitem.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif


#ifndef _LINGU_LNGPROPS_HHX_
#include <lingu/lngprops.hxx>
#endif
#ifndef _SFX_SFXUNO_HXX
#include <sfx2/sfxuno.hxx>
#endif

#ifndef _SVDVIEW_HXX //autogen
#include <svx/svdview.hxx>
#endif


#ifndef _FRMFMT_HXX //autogen
#include <frmfmt.hxx>
#endif
#include "sdrspell.hxx"
#include "docsh.hxx"        //     "     "     "
#include "wrtsh.hxx"        //  MakeVisible
#include "view.hxx"
#include "dcontact.hxx"		// Spelling von DrawObj
#include "doc.hxx"        //     "     "     "
#include "docary.hxx"
#include "edtwin.hxx"

class SfxStyleSheetPool;

using namespace ::com::sun::star;
using namespace ::rtl;

/*************************************************************************
|*
|* Ctor
|*
\************************************************************************/

SdrSpeller::SdrSpeller( SwView* pVw, uno::Reference< linguistic::XSpellChecker1 >  &xSpll ):
#if SUPD>601
	SdrOutliner(pView->GetDocShell()->GetDoc()->GetDrawModel()->
							 GetDrawOutliner().GetEmptyItemSet().GetPool(),
			OUTLINERMODE_TEXTOBJECT ),
#else
	SdrOutliner(OL_EDITENGINE, 10, (SfxStyleSheetPool*)pVw->GetDocShell()->GetStyleSheetPool() ),
#endif
	pView( pVw ),
	xSpell( xSpll ),
	pTextObj( NULL ),
	pOutlView( NULL ),
	pListIter( NULL ),
	nDocIndex( 0 )
{
	SetRefDevice( pView->GetDocShell()->GetDoc()->GetPrt() );

	MapMode aMapMode (MAP_TWIP);
	SetRefMapMode(aMapMode);

#if SUPD>601
#else
	ASSERT( pView->GetDocShell()->GetDoc()->GetDrawModel(),
			"SdrSpeller without DrawModel?" );
	const SfxItemSet& rSet = pView->GetDocShell()->GetDoc()->GetDrawModel()->
							 GetDrawOutliner().GetEmptyItemSet();
	SetPool(rSet.GetPool());
#endif
 	Size aSize( 1, 1 );
	SetPaperSize( aSize );

	SetSpeller( xSpell );

	pOutlView = new OutlinerView( this, &(pView->GetEditWin()) );
	pOutlView->GetOutliner()->SetRefDevice(pView->GetWrtShell().GetPrt());

	// Hack: Es sollten alle SdrTextObj-Attribute an die EditEngine
	//		 uebertragen werden.
	pOutlView->SetBackgroundColor( Color( COL_WHITE ) );


	InsertView( pOutlView );
	Point aPoint( 0, 0 );
 	Rectangle aRect( aPoint, aSize );
	pOutlView->SetOutputArea( aRect );
//	SetText( NULL );
	ClearModifyFlag();
}

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

SdrSpeller::~SdrSpeller()
{
	if (pTextObj)
	{
		SdrView *pSdrView = pView->GetWrtShell().GetDrawView();
		ASSERT( pSdrView, "SdrSpeller without DrawView?" );
		pSdrView->EndTextEdit( sal_True );
		SetUpdateMode(sal_False);
		pOutlView->SetOutputArea( Rectangle( Point(), Size(1, 1) ) );
//		SetPaperSize( Size(1, 1) );
//		SetText(NULL);
//		pTextObj = NULL;
	}
	RemoveView( pOutlView );
	delete pOutlView;
}


/*************************************************************************
|*
|* Pruefung starten
|*
\************************************************************************/

void SdrSpeller::StartSpelling()
{
	uno::Reference< beans::XPropertySet >  xProp( GetLinguPropertySet() );
	LanguageType nLang;
	if (xProp.is())
	{
		sal_Int16 nTemp;
		xProp->getPropertyValue( OUString::createFromAscii(UPN_DEFAULT_LANGUAGE) ) >>= nTemp;
		nLang = nTemp;
	}
	else
	{	// guess DefaultLanguage from other sources
		nLang = Application::GetAppInternational().GetLanguage();
		if( nLang == LANGUAGE_SYSTEM )
			nLang = ::GetSystemLanguage();
	}

	pOutlView->StartSpeller( nLang, sal_True );
}


/*************************************************************************
|*
|* Naechstes TextObjekt pruefen
|*
\************************************************************************/

sal_Bool __EXPORT SdrSpeller::SpellNextDocument()
{
	sal_Bool bNextDoc = sal_False;

	if ( pTextObj )
	{
		SdrView *pSdrView = pView->GetWrtShell().GetDrawView();
		ASSERT( pSdrView, "SdrSpeller without DrawView?" );
		pSdrView->EndTextEdit( sal_True );
		SetUpdateMode(sal_False);
		pOutlView->SetOutputArea( Rectangle( Point(), Size(1, 1) ) );
		SetPaperSize( Size(1, 1) );
		Clear();
		pTextObj = NULL;
	}

	sal_uInt16 n = nDocIndex;

	while( !bNextDoc && ( pListIter ||
		 n < pView->GetDocShell()->GetDoc()->GetSpzFrmFmts()->Count() ) )
	{
		while( !pTextObj && pListIter )
		{
			if( pListIter->IsMore() )
			{
				SdrObject* pSdrO = pListIter->Next();
				if( pSdrO && pSdrO->IsA( TYPE(SdrTextObj) ) &&
					( (SdrTextObj*) pSdrO )->HasText() )
					pTextObj = (SdrTextObj*) pSdrO;
			}
			else
			{
				delete pListIter;
				pListIter = NULL;
			}
		}

		if ( !pTextObj &&
			 n < pView->GetDocShell()->GetDoc()->GetSpzFrmFmts()->Count() )
		{
			SwFrmFmt* pFly = (*pView->GetDocShell()->GetDoc()->GetSpzFrmFmts())[ n ];
			if( pFly->IsA( TYPE(SwDrawFrmFmt) ) )
			{
				SwClientIter aIter( (SwFmt&) *pFly );
				if( aIter.First( TYPE(SwDrawContact) ) )
				{
					SdrObject* pSdrO = ((SwDrawContact*)aIter())->GetMaster();
					if ( pSdrO )
					{
						if ( pSdrO->IsA( TYPE(SdrObjGroup) ) )
							pListIter = new SdrObjListIter( *pSdrO, IM_DEEPNOGROUPS );
						else if( pSdrO->IsA( TYPE(SdrTextObj) ) &&
								( (SdrTextObj*) pSdrO )->HasText() )
							pTextObj = (SdrTextObj*) pSdrO;
					}
				}
			}
			++n;
		}
		if ( pTextObj )
		{
			OutlinerParaObject* pParaObj = pTextObj->GetOutlinerParaObject();

			if ( pParaObj )
			{
				SetPaperSize( pTextObj->GetLogicRect().GetSize() );
				SetText( *pParaObj );

				ClearModifyFlag();
				sal_Int16 nLang = ((SvxLanguageItem&)pView->GetWrtShell().
							GetDefault( RES_CHRATR_LANGUAGE )).GetValue();
				EESpellState eState = HasSpellErrors( nLang );

				if (eState != EE_SPELL_OK)
				{
					SdrView *pSdrView = pView->GetWrtShell().GetDrawView();
					ASSERT( pSdrView, "SdrSpeller without DrawView?" );
					SdrPageView* pPV = pSdrView->GetPageViewPvNum(0);
					nDocIndex = n;
					bNextDoc = sal_True;
					pOutlView->SetOutputArea( Rectangle( Point(), Size(1,1)));
					SetPaperSize( pTextObj->GetLogicRect().GetSize() );
					SetUpdateMode(sal_True);
					pView->GetWrtShell().MakeVisible(pTextObj->GetLogicRect());
					pSdrView->BegTextEdit( pTextObj, pPV, &pView->GetEditWin(),
										   sal_False, this, pOutlView, sal_True, sal_True);
				}
			}
			if ( !bNextDoc )
				pTextObj = NULL;
		}
	}

	ClearModifyFlag();

	return bNextDoc;
}

/*************************************************************************

	  Source Code Control chaos::System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/lingu/sdrspell.cxx,v 1.1.1.1 2000/09/18 17:14:44 hr Exp $

	  Source Code Control System - Update

	  $Log: sdrspell.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:44  hr
	  initial import
	
	  Revision 1.47  2000/09/18 16:05:54  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.46  2000/08/24 07:47:56  os
	  Outliner changes 2.
	
	  Revision 1.45  2000/08/23 07:59:41  os
	  Must: Ctor of SdrOutliner changed
	
	  Revision 1.44  2000/04/18 15:35:08  os
	  UNICODE

	  Revision 1.43  2000/03/23 07:48:03  os
	  UNO III

	  Revision 1.42  2000/03/03 15:17:02  os
	  StarView remainders removed

	  Revision 1.41  2000/02/24 12:58:56  tl
	  #71915# LANGUAGE_GERMAN replaced by document language

	  Revision 1.40  2000/02/16 20:59:11  tl
	  #72219# Locale Umstellung

	  Revision 1.39  1999/11/24 18:31:52  tl
	  check for Service availability

	  Revision 1.38  1999/11/19 16:40:23  os
	  modules renamed

	  Revision 1.37  1999/11/10 11:04:40  tl
	  Ongoing ONE_LINGU implementation

	  Revision 1.36  1999/08/31 08:37:18  TL
	  #if[n]def ONE_LINGU inserted (for transition of lingu to StarOne)


	  Rev 1.35   31 Aug 1999 10:37:18   TL
   #if[n]def ONE_LINGU inserted (for transition of lingu to StarOne)

	  Rev 1.34   04 Aug 1999 11:02:50   JP
   have to change: Outliner -> SdrOutlines

	  Rev 1.33   28 Nov 1997 17:51:56   MA
   includes

	  Rev 1.32   21 Nov 1997 13:00:26   MA
   includes

	  Rev 1.31   03 Nov 1997 13:21:46   MA
   precomp entfernt

	  Rev 1.30   04 Sep 1997 17:15:22   MA
   includes

	  Rev 1.29   03 Sep 1997 12:12:10   JP
   zusaetzliches include von docary

	  Rev 1.28   16 Aug 1997 12:53:48   OS
   include

	  Rev 1.27   09 Aug 1997 13:26:00   OS
   paraitem/frmitems/textitem aufgeteilt

	  Rev 1.26   20 Mar 1997 12:13:08   AMA
   Fix #37626#: Kein doppeltes Paint fuer DrawObjekte im Editmode.

	  Rev 1.25   06 Mar 1997 08:48:04   MA
   chg: wieder mit pch

	  Rev 1.24   24 Feb 1997 16:52:26   AMA
   Fix: Zeichenobjekte in der Default-Sprache spellen.

	  Rev 1.23   07 Nov 1996 15:28:08   OM
   RefDevice am Outliner setzen

	  Rev 1.22   01 Nov 1996 04:03:34   MH
   add: includes

	  Rev 1.21   29 Aug 1996 19:12:54   HJS
   define raus

	  Rev 1.20   28 Aug 1996 12:52:36   OS
   includes

	  Rev 1.19   22 Aug 1996 15:02:18   OS
   Header wg. PCH verschoben

	  Rev 1.18   08 Aug 1996 12:37:42   HJS
   aufteilung svdraw.hxx

	  Rev 1.17   04 Jul 1996 14:11:42   HJS
   define raus

	  Rev 1.16   24 May 1996 15:08:46   HJS
   gemeines define sfxobjfac

	  Rev 1.15   18 Mar 1996 15:03:16   HJS
   clooks

	  Rev 1.14   07 Mar 1996 20:43:40   HJS
   clooks

	  Rev 1.13   22 Feb 1996 23:07:06   MH
   CLOOKS

	  Rev 1.12   19 Feb 1996 18:29:44   MA
   chg: EndTextEdit mit sal_True

	  Rev 1.11   16 Jan 1996 09:44:58   OM
   Kampf den CLOOKs!

	  Rev 1.10   24 Nov 1995 16:57:40   OM
   PCH->PRECOMPILED

------------------------------------------------------------------------*/


