/*************************************************************************
 *
 *  $RCSfile: splwrp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _UIPARAM_HXX
#include <uiparam.hxx>		// fuer ITEMID_SPELLCHECK (muss _vor_ sfxdlg.hxx!)
#endif
#ifndef _HINTIDS_HXX
#include <hintids.hxx>
#endif
#ifndef _VIEW_HXX
#include <view.hxx>
#endif
#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
#ifndef _SWUNDO_HXX
#include <swundo.hxx>         // fuer Undo-Ids
#endif
#ifndef _GLOBALS_HRC
#include <globals.hrc>
#endif


#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SVX_SPLDLG_HXX //autogen
#include <svx/spldlg.hxx>
#endif
#ifndef _MySVXACORR_HXX //autogen
#include <svx/svxacorr.hxx>
#endif
#ifndef _OFF_APP_HXX //autogen
#include <offmgr/app.hxx>
#endif
#ifndef _SVX_LANGITEM_HXX //autogen
#include <svx/langitem.hxx>
#endif
#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif


#ifndef _UNO_LINGU_HXX
#include <svx/unolingu.hxx>
#endif
#ifndef _SFX_SFXUNO_HXX
#include <sfx2/sfxuno.hxx>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XSPELLALTERNATIVES_HPP_
#include <com/sun/star/linguistic/XSpellAlternatives.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XSPELLCHECKER1_HPP_
#include <com/sun/star/linguistic/XSpellChecker1.hpp>
#endif

#include "splwrp.hxx"
#include "sdrspell.hxx"
#include "shellio.hxx"      // fuer SwTextBlocks
#include "mdiexp.hxx"		// Progress
#include "tempauto.hxx"     // temporaere Autokorrektur
#include "edtwin.hxx"
#include "olmenu.hrc"

using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::linguistic;

#define PSH (&pView->GetWrtShell())

/*--------------------------------------------------------------------
	 Beschreibung: Ggf. Rahmen/Objektshell abschalten
 --------------------------------------------------------------------*/

void lcl_ActivateTextShell( SwWrtShell* pWrtSh )
{
	if( pWrtSh->IsSelFrmMode() || pWrtSh->IsObjSelected() )
		pWrtSh->EnterStdMode();
}

/*--------------------------------------------------------------------
	 Beschreibung: Ctor
 --------------------------------------------------------------------*/
SwSpellWrapper::SwSpellWrapper( SwView* pVw, Reference< XSpellChecker1 >  &xSpl,
								sal_Bool bStart, sal_Bool bIsAllRight,
								sal_Bool bOther, sal_Bool bSelect ) :
	SvxSpellWrapper( &pVw->GetEditWin(), xSpl, bStart,
					 bIsAllRight, bOther ), //#34752# EditWin als Parent
	pView( pVw ),
	nPageCount( 0 ),
	nPageStart( 0 ),
	pBlocks( 0 ),
	bInSelection(bSelect),
	bInfoBox( sal_False ),
	bLastRet( sal_True )
{
	bDrawObj = sal_False;
	EnableAutoCorrect();
}

// -----------------------------------------------------------------------

void SwSpellWrapper::SpellStart( SvxSpellArea eSpell )
{
	SetDrawObj( SVX_SPELL_OTHER == eSpell );
	pView->SpellStart( eSpell, IsStartDone(), IsEndDone() );
}

// -----------------------------------------------------------------------

sal_Bool SwSpellWrapper::SpellContinue()
{
	sal_Bool bProgress = !bDrawObj && !bInSelection;
	Reference< XInterface >  xSpellAlt = bProgress ?
		pView->GetWrtShell().SpellContinue( &nPageCount, &nPageStart ) :
		pView->GetWrtShell().SpellContinue( &nPageCount, NULL );
	SetLast( xSpellAlt );
	bLastRet = !xSpellAlt.is();
	return GetLast().is();
}

// -----------------------------------------------------------------------

void SwSpellWrapper::SpellEnd()
{
	pView->SpellEnd();
	SvxSpellWrapper::SpellEnd();
}

sal_Bool SwSpellWrapper::SpellMore()
{
	bInfoBox = sal_True;
	return sal_False;
}

// -----------------------------------------------------------------------

void SwSpellWrapper::ScrollArea()
{
	if ( IsDialog() && GetWin() )
		PSH->SetCareWin( GetWin() );

	pView->Scroll( PSH->GetCharRect().SVRect() );
}

// -----------------------------------------------------------------------

void SwSpellWrapper::ChangeWord( const String& rNewWord, const sal_uInt16 nLang )
{
	lcl_ActivateTextShell( PSH );
	// Das aktuelle Wort austauschen
	PSH->StartAllAction();
	PSH->StartUndo( UNDO_OVERWRITE );
	PSH->Delete();
	ChangeLanguage( nLang );

	String aTmp( rNewWord );

	// nur aufnehmen, wenn es NICHT schon in der Autokorrektur vorhanden ist
	Reference< XSpellAlternatives >  xAlt( GetLast(), UNO_QUERY );

	String 			aOrigWord;
	LanguageType	nOrigLang = LANGUAGE_NONE;
	if (xAlt.is())
	{
	 	aOrigWord = String(xAlt->getWord());
		nOrigLang = SvxLocaleToLanguage( xAlt->getLocale() );

		// if orginal word has a trailing . (likely the end of a sentence)
		// and the replacement text hasn't, then add it to the replacement
		if (aTmp.Len() && aOrigWord.Len() &&
			'.' == aOrigWord.GetChar( aOrigWord.Len() - 1) && /* !IsAlphaNumeric ??*/
			'.' != aTmp.GetChar( aTmp.Len() - 1))
		{
			aTmp += '.';
		}
	}
	SvxAutoCorrect* pACorr = OFF_APP()->GetAutoCorrect();
	SvxAutocorrWord aAWord( aOrigWord, aEmptyStr );
	if( aOrigWord.Len() > 0  &&
		!pACorr->GetAutocorrWordList( nOrigLang )->Seek_Entry( &aAWord ))
	{
		SwCorrection* pCorr = new SwCorrection( aAWord.GetShort() );
		pCorr->Correct() = rNewWord;
		if( !pTempAuto )
			pTempAuto = new SwTempAuto;
		pTempAuto->Insert( pCorr );
	}

	PSH->Insert( aTmp );
	PSH->EndUndo( UNDO_OVERWRITE );
	PSH->EndAllAction();
}

// -----------------------------------------------------------------------

String SwSpellWrapper::GetThesWord()
{
	if ( IsDialog() )
		return ((SvxSpellCheckDialog*)GetWin())->GetNewEditWord();
	return PSH->GetCurWord();
}

// -----------------------------------------------------------------------

void SwSpellWrapper::ChangeThesWord( const String& rNewWord )
{
	if ( IsDialog() )
		((SvxSpellCheckDialog*)GetWin())->SetNewEditWord( rNewWord );
	else
	{
		lcl_ActivateTextShell( PSH );
		PSH->StartAllAction();
		PSH->StartUndo(UNDO_DELETE);
		if( !PSH->IsInWrd() && !PSH->IsEndWrd()	&& !PSH->IsSttWrd() )
			PSH->PrvWrd();
		if( PSH->IsEndWrd() )
			PSH->Left();
		PSH->SelWrd();
		PSH->Insert( rNewWord );
		PSH->EndUndo(UNDO_DELETE);
		PSH->EndAllAction();
	}
}

// -----------------------------------------------------------------------

void SwSpellWrapper::ReplaceAll( const String &rNewText, sal_Int16 nLanguage )
{
	Reference< XSpellAlternatives >  xAlt( GetLast(), UNO_QUERY );
	if (!xAlt.is())
		return;

	lcl_ActivateTextShell( PSH );
	PSH->StartAllAction();
	PSH->StartUndo(UNDO_OVERWRITE);
	PSH->Delete();

	String 		 aRplcText( rNewText );
	LanguageType nRplcLang = nLanguage;
	LanguageType nActLang  = SvxLocaleToLanguage( xAlt->getLocale() );

	String aTmp( aRplcText );	// no pre-/poststripped available to attach...
	String aOrig( xAlt->getWord());

	// if orginal word has a trailing . (likely the end of a sentence)
	// and the replacement text hasn't, then add it to the replacement
	if (aTmp.Len() && aOrig.Len() &&
		'.' == aOrig.GetChar( aOrig.Len() - 1) && /* !IsAlphaNumeric ??*/
		'.' != aTmp.GetChar( aTmp.Len() - 1))
	{
		aTmp += '.';
	}

	PSH->Insert( aTmp );

	// evtl. auch Sprache anpassen
	if( nRplcLang != nActLang )
	{	// Sprache bei Aenderung setzen
		SvxLanguageItem aLang( nRplcLang );
		PSH->SetAttr( aLang );
	}

	PSH->EndUndo(UNDO_OVERWRITE);
	PSH->EndAllAction();
}

// -----------------------------------------------------------------------

void SwSpellWrapper::SetLanguage( const sal_uInt16 nLang )
{
	lcl_ActivateTextShell( PSH );
	PSH->StartAllAction();

	SfxItemSet aSet(pView->GetPool(), RES_CHRATR_LANGUAGE, RES_CHRATR_LANGUAGE);
	aSet.Put( SvxLanguageItem( (LanguageType)nLang ) );
	PSH->SetAttr(aSet);

	PSH->EndAllAction();
}

// -----------------------------------------------------------------------

sal_Bool SwSpellWrapper::HasOtherCnt()
{
	return bInSelection ? sal_False : PSH->HasOtherCnt();
}

// -----------------------------------------------------------------------

SwSpellWrapper::~SwSpellWrapper()
{
	if( pBlocks )
		delete pBlocks;

	PSH->SetCareWin( NULL );
	if ( IsDrawObj() && bLastRet && pView->GetWrtShell().HasDrawView() )
	{
		Cursor *pSave = pView->GetWindow()->GetCursor();
		{
			Reference< XSpellChecker1 >  xSpell( GetSpellChecker() );
			SdrSpeller aSdrSpell( pView, xSpell );
			aSdrSpell.StartSpelling();
		}
		pView->GetWindow()->SetCursor( pSave );
	}
	if( nPageCount )
		::EndProgress( pView->GetDocShell() );
	if( bInfoBox )
		InfoBox(&pView->GetEditWin(), String(SW_RES(STR_SPELL_OK)) ).Execute();
}
// -----------------------------------------------------------------------

void SwSpellWrapper::AutoCorrect( const String& rAktStr, const String& rNewStr )
{
	Reference< XSpellAlternatives >  xAlt( GetLast(), UNO_QUERY);
	if (!xAlt.is())
		return;

	SvxAutoCorrect* pACorr = OFF_APP()->GetAutoCorrect();
	pACorr->PutText( rAktStr, rNewStr,
			SvxLocaleToLanguage( xAlt->getLocale() ) );
	if( pTempAuto )
		pTempAuto->Delete( rAktStr );
}

/*------------------------------------------------------------------------

	$Log: splwrp.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:44  hr
	initial import
	
	Revision 1.63  2000/09/18 16:05:54  willem.vandorp
	OpenOffice header added.
	
	Revision 1.62  2000/05/11 12:37:55  tl
	include korigiert, namespace's verwendet
	
	Revision 1.61  2000/05/09 14:46:09  os
	UNICODE
	
	Revision 1.60  2000/04/18 15:35:08  os
	UNICODE

	Revision 1.59  2000/03/30 10:44:24  tl
	#74553# ASSERT removed

	Revision 1.58  2000/03/23 07:49:13  os
	UNO III

	Revision 1.57  2000/02/24 13:00:25  tl
	#71915# SvxSpellWrapper::SpellEnd called in SpellEnd now

	Revision 1.56  2000/02/16 20:59:36  tl
	#72219# Locale Umstellung

	Revision 1.55  2000/02/11 14:55:56  hr
	#70473# changes for unicode ( patched by automated patchtool )

	Revision 1.54  2000/02/07 13:26:37  tl
	#72445# add unknown words to dictionary now here implemented

	Revision 1.53  2000/02/01 11:53:36  tl
	#71634# insert '.' to replacement if original word has it

	Revision 1.52  2000/01/11 10:28:58  tl
	#70735# fixed ReplaceAll parameter list

	Revision 1.51  1999/11/24 18:33:58  tl
	check for Service availability

	Revision 1.50  1999/11/19 16:40:24  os
	modules renamed

	Revision 1.49  1999/11/10 11:07:44  tl
	uno::Reference< uno::XInterface >  SpellContinue() -> sal_Bool SpellContinue()
	Ongoing ONE_LINGU implementation

	Revision 1.48  1999/10/25 19:40:24  tl
	ongoing ONE_LINGU implementation

	Revision 1.47  1999/10/21 17:48:38  jp
	have to change - SearchFile with SfxIniManager, dont use SwFinder for this

	Revision 1.46  1999/08/31 08:37:00  TL
	#if[n]def ONE_LINGU inserted (for transition of lingu to StarOne)


	  Rev 1.45   31 Aug 1999 10:37:00   TL
   #if[n]def ONE_LINGU inserted (for transition of lingu to StarOne)

	  Rev 1.44   24 Nov 1998 10:05:10   OS
   #59590# mehrsprachige Autokorrektur

	  Rev 1.43   18 Nov 1998 15:21:06   AMA
   Fix #59559#: Der Punkt muss bleiben. Punkt.

	  Rev 1.42   26 Aug 1998 11:14:42   AMA
   Fix #55405#: InfoBox erst nach Pruefung der Textobjekte anzeigen.

	  Rev 1.41   13 Jul 1998 08:49:10   OS
   Dialog-Parent richtig setzen #51814#

	  Rev 1.40   10 Jun 1998 14:45:40   AMA
   Fix #51024#: GPF beim Aufnehmen einer Autokorrektur

	  Rev 1.39   28 Nov 1997 17:55:44   MA
   includes

	  Rev 1.38   04 Sep 1997 17:15:22   MA
   includes

	  Rev 1.37   02 Sep 1997 13:19:54   OS
   includes

	  Rev 1.36   01 Sep 1997 13:12:04   OS
   DLL-Umstellung

	  Rev 1.35   09 Aug 1997 13:25:58   OS
   paraitem/frmitems/textitem aufgeteilt

	  Rev 1.34   24 May 1997 14:15:44   MA
   precomp

	  Rev 1.33   13 May 1997 15:16:02   AMA
   New #39159#: InfoBox nach Abschluss der Rechtschreibpruefung.

	  Rev 1.32   19 Mar 1997 15:51:52   AMA
   Fix: Progress vor dem Spelldialog starten wg. des WarteCursors

	  Rev 1.31   19 Mar 1997 14:11:32   AMA
   Fix #37892: Rahmenselektion vor dem Ersetzen zuruecknehmen.

	  Rev 1.30   07 Mar 1997 17:29:38   AMA
   Chg: Progress nicht beenden, waehrend der Spelldlg. oben ist wg. Enter/LeaveWait

	  Rev 1.29   14 Jan 1997 15:59:32   MA
   #34752# EditWin als Parent

	  Rev 1.28   04 Dec 1996 23:08:34   MH
   chg: header

	  Rev 1.27   24 Oct 1996 13:36:30   JP
   String Umstellung: [] -> GetChar()

	  Rev 1.26   15 Oct 1996 14:14:46   JP
   AutoCorrCfg in die OfficeApplication verschoben

	  Rev 1.25   09 Oct 1996 18:00:30   MA
   Progress

	  Rev 1.24   30 Sep 1996 14:15:12   HJS
   segmentc.hxx verschoben - sonst wntmsci internal compiler error

	  Rev 1.23   02 Sep 1996 10:23:20   AMA
   Fix: Vorwaerts- und Rueckwaerts-Spellen

	  Rev 1.22   30 Aug 1996 14:49:08   AMA
   Chg: Umbau wg. rueckwaerts Spellen

	  Rev 1.21   28 Aug 1996 12:52:36   OS
   includes

	  Rev 1.20   21 Jun 1996 10:33:52   AMA
   New #28010#: Temporaere Autokorrektur

	  Rev 1.19   14 Mar 1996 11:38:06   AMA
   New: Progress-Anzeige bei Rechtschr. und Silbentrennung

	  Rev 1.18   08 Mar 1996 18:53:06   AMA
   Fix #20344#: Spelling/Trennung in Selektionen

	  Rev 1.17   01 Mar 1996 16:27:44   HJS
   l:175 LanguageType durch cast erzwungen

	  Rev 1.16   01 Mar 1996 13:24:52   mk
   GCC

	  Rev 1.15   20 Feb 1996 12:47:02   AMA
   Fix: GPF Beim Spelling von Zeichenobjekten.

	  Rev 1.14   14 Feb 1996 13:13:54   AMA
   Fix #25454#: Cursor wird vor dem Outliner gerettet.

	  Rev 1.13   08 Dec 1995 12:22:18   AMA
   Fix: Autocorrect muss natuerlich __EXPORTiert werden.

	  Rev 1.12   24 Nov 1995 16:57:40   OM
   PCH->PRECOMPILED

	  Rev 1.11   10 Nov 1995 15:20:46   OS
   Bug 22099: vom Spellcheck in Autokorrektur

------------------------------------------------------------------------*/
















