/*************************************************************************
 *
 *  $RCSfile: bibdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "swtypes.hxx"

#include "bibdlg.hxx"
#include "misc.hrc"
#include "bibdlg.hrc"



SwBibDlg::SwBibDlg(Window * pParent, BOOL bCaseSens, BOOL bDelLast) :

	SvxStandardDialog(pParent, SW_RES(DLG_BIB_BASE)),

	aBibBox		(this, SW_RES(CO_NAME), CBS_SW_FILENAME),
	aBibFrm		(this, SW_RES(GB_BIB)),
	aNewBtn		(this, SW_RES(PB_NEW)),
	aDelBtn		(this, SW_RES(PB_DELETE)),
	aOkBtn		(this, SW_RES(BT_OK)),
	aCancelBtn	(this, SW_RES(BT_CANCEL)),
	bDelLst(bDelLast),
	bCase(bCaseSens)
{
	aNewBtn.SetClickHdl(LINK(this, 	SwBibDlg, NewHdl));
	aDelBtn.SetClickHdl(LINK(this, 	SwBibDlg, DeleteHdl));
	aBibBox.SetModifyHdl(LINK(this,	SwBibDlg, ModifyHdl));
	aBibBox.SetSelectHdl(LINK(this,	SwBibDlg, SelectHdl));

	if(aBibBox.GetEntryCount())
		aBibBox.SetText(aBibBox.ComboBox::GetEntry(0));

	ModifyHdl();

	FreeResource();
}



SwBibDlg::~SwBibDlg()
{
}

/*--------------------------------------------------------------------
	 Beschreibung: Item erzeugen
 --------------------------------------------------------------------*/



IMPL_LINK( SwBibDlg, NewHdl, Button *, EMPTYARG )
{
	String aStr(aBibBox.GetText());

	if(!bCase)
		pApp->GetAppInternational().ToLower(aStr);

	if(aBibBox.GetEntryPos(aStr) == LISTBOX_ENTRY_NOTFOUND)
	{
		SwBoxEntry aTmpEntry(aStr);

		aBibBox.InsertNewEntry(aTmpEntry);

		aNewBtn.Enable(FALSE);
		aDelBtn.Enable();
	}
	return 0;
}

/*--------------------------------------------------------------------
	 Beschreibung: Item loeschen
 --------------------------------------------------------------------*/



IMPL_LINK( SwBibDlg, DeleteHdl, Button *, EMPTYARG )
{
	String aStr(aBibBox.GetText());
	USHORT nPos = aBibBox.GetEntryPos(aStr);

	if(nPos != LISTBOX_ENTRY_NOTFOUND)
	{
		aBibBox.RemoveEntry(nPos);
		aNewBtn.Enable(FALSE);
		USHORT nCount = aBibBox.GetEntryCount();
		if(nCount == 0 || !bDelLst && nCount == 1)
		{
			aDelBtn.Enable(FALSE);
			aBibBox.SetText(aEmptyStr);
		}
		else
		{
			if(nCount > 0)
				nPos = Min(nPos, USHORT(nCount - 1));
			aBibBox.SetText(aBibBox.ComboBox::GetEntry(nPos));
		}
	}
	return 0;
}

/*--------------------------------------------------------------------
	 Beschreibung: Edit modifizieren
 --------------------------------------------------------------------*/



IMPL_LINK( SwBibDlg, ModifyHdl, Edit *, EMPTYARG )
{
	String aName(aBibBox.GetText());
	if(aName.Len() == 0)
	{
		aDelBtn.Enable(FALSE);
		aNewBtn.Enable(FALSE);
		return 0;
	}

	BOOL bEnable = aBibBox.GetEntryPos(SwBoxEntry(aName)) == LISTBOX_ENTRY_NOTFOUND;
	aNewBtn.Enable(bEnable);
	aDelBtn.Enable(!bEnable && (bDelLst || aBibBox.GetEntryCount() != 1));
	return 0;
}



void SwBibDlg::Apply()
{
	String aName(aBibBox.GetText());
	if(aName.Len() > 0)
		NewHdl(0);
}



IMPL_LINK( SwBibDlg, SelectHdl, Edit*, EMPTYARG  )
{
	return 0;
}

/*--------------------------------------------------------------------

	  $Log: bibdlg.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:44  hr
	  initial import
	
	  Revision 1.45  2000/09/18 16:05:55  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.44  1997/11/24 15:47:42  MA
	  includes
	

	  Rev 1.43   24 Nov 1997 16:47:42   MA
   includes

	  Rev 1.42   03 Nov 1997 13:22:40   MA
   precomp entfernt

	  Rev 1.41   11 Nov 1996 11:05:44   MA
   ResMgr

	  Rev 1.40   02 Oct 1996 18:29:32   MA
   Umstellung Enable/Disable

	  Rev 1.39   28 Aug 1996 14:12:22   OS
   includes

	  Rev 1.38   12 Aug 1996 17:00:40   JP
   neu: SelectHdl - Auswahl aus der ComboBox propagieren

	  Rev 1.37   25 Jun 1996 18:39:40   HJS
   includes

	  Rev 1.36   06 Feb 1996 15:21:04   JP
   Link Umstellung 305

	  Rev 1.35   24 Nov 1995 16:58:44   OM
   PCH->PRECOMPILED

	  Rev 1.34   08 Nov 1995 13:31:42   JP
   Umstellung zur 301: Change -> Set

	  Rev 1.33   30 Aug 1995 14:00:40   MA
   fix: sexport'iert

	  Rev 1.32   21 Aug 1995 09:32:06   MA
   chg: swstddlg -> svxstandarddialog, Optimierungen

	  Rev 1.31	 15 Dec 1994 20:28:34	SWG
   *ARR* Ersetzungen, svmem, __far_data etc.

	  Rev 1.30	 22 Nov 1994 10:00:28	SWG
   Min/Max: unter NT muss bei Berechnungen gecastet werden

	  Rev 1.29	 18 Nov 1994 16:14:04	MA
   min -> Min, max -> Max

 --------------------------------------------------------------------*/



