/*************************************************************************
 *
 *  $RCSfile: hdftctrl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _HINTIDS_HXX
#include <hintids.hxx>
#endif

#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFX_OBJITEM_HXX //autogen
#include <sfx2/objitem.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SVX_ULSPITEM_HXX //autogen
#include <svx/ulspitem.hxx>
#endif
#ifndef _SVX_DIALMGR_HXX //autogen
#include <svx/dialmgr.hxx>
#endif
#ifndef _SVX_DIALOGS_HRC //autogen
#include <svx/dialogs.hrc>
#endif

#define _SVSTDARR_STRINGSSORT
#define _SVSTDARR_BOOLS
#include <svtools/svstdarr.hxx>

#ifndef _FMTHDFT_HXX //autogen
#include <fmthdft.hxx>
#endif
#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
#ifndef _SWMODULE_HXX
#include <swmodule.hxx>
#endif
#ifndef _HDFTCTRL_HXX
#include <hdftctrl.hxx>
#endif
#ifndef _WDOCSH_HXX
#include <wdocsh.hxx>
#endif
#ifndef _VIEW_HXX
#include <view.hxx>
#endif
#ifndef _PAGEDESC_HXX
#include <pagedesc.hxx>
#endif
#ifndef _SHELLRES_HXX
#include <shellres.hxx>
#endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _MISC_HRC
#include <misc.hrc>
#endif


SFX_IMPL_MENU_CONTROL( SwHeadFootMenuControl, SfxObjectItem );

SwHeadFootMenuControl::SwHeadFootMenuControl( USHORT nPos, Menu& rMenu,
											SfxBindings& rBindings )
	: SfxMenuControl( nPos, rBindings ), pParent( &rMenu ), nInsPos( nPos ),
	pDynMenu( 0 ), pShell( 0 )
{
}

SwHeadFootMenuControl::~SwHeadFootMenuControl()
{
	if( pDynMenu )
	{
		pParent->SetPopupMenu( nInsPos, 0 );
		delete pDynMenu;
	}
}

void SwHeadFootMenuControl::StateChanged( USHORT nSID, SfxItemState eState,
										  const SfxPoolItem* pState )
{
	if( pDynMenu )
		delete pDynMenu, pDynMenu = 0;

	SfxObjectItem* pItem = PTR_CAST( SfxObjectItem, pState );
	pShell = pItem ? PTR_CAST( SwDocShell, pItem->GetShell() ) : 0;
	if( pShell && pShell->GetWrtShell() )
	{
		SwWrtShell& rSh = *pShell->GetWrtShell();

		// Seitenvorlagen besorgen
		USHORT n, nCnt = rSh.GetPageDescCnt();
		SvStringsSort aArr( (BYTE)nCnt );
		SvBools aCheckArr( (BYTE)nCnt );
		BOOL bAllOneState = TRUE, bLastCheck;

		for( n = 0; n < nCnt; ++n )
		{
			const SwPageDesc& rDesc = rSh.GetPageDesc( n );
			StringPtr pNm = (StringPtr)&rDesc.GetName();
			USHORT nIPos;
			aArr.Insert( pNm, nIPos );

			BOOL bCheck = FN_INSERT_PAGEHEADER == nSID
							? rDesc.GetMaster().GetHeader().IsActive()
							: rDesc.GetMaster().GetFooter().IsActive();
			aCheckArr.Insert( bCheck, nIPos );
			if( bAllOneState && n && bCheck != bLastCheck )
				bAllOneState = FALSE;
			bLastCheck = bCheck;
		}

		// sollte keine "gueltige" Seitenvorlage existieren?
		// (sprich: haben schon alle Kopf/Fusszeilen?)
		nCnt = aArr.Count();
		if( nCnt )
		{
			pDynMenu = new PopupMenu;
			for( n = 0; n < nCnt; ++n )
			{
				pDynMenu->InsertItem( 100 + 1 + n, *aArr[ n ], MIB_CHECKABLE );
				pDynMenu->CheckItem( 100 + 1 + n, aCheckArr[ n ] );
			}

			// wenn mehrere Eintraege mit dem gleichen "CheckStatus"
			// existieren, dann auch den Menupunkt "Alle" anbieten
			if( 1 < nCnt && bAllOneState )
			{
				pDynMenu->InsertItem( 100,  ViewShell::GetShellRes()->
									aStrAllPageHeadFoot, 0, 0 );
				pDynMenu->InsertSeparator( 1 );
			}

			pDynMenu->SetSelectHdl( LINK( this, SwHeadFootMenuControl, DynMenuPageSelect ));
		}
	}
	else
		pShell = 0;

	pParent->SetPopupMenu( nInsPos, pDynMenu );

	SfxMenuControl::StateChanged( nSID, eState, pState );
}


PopupMenu* SwHeadFootMenuControl::GetPopup() const
{
	return pDynMenu;
}


BOOL SwHeadFootMenuControl::ChgHeaderOrFooter( BOOL bChecked, BOOL bCurState,
												int& rCallAsk ) const
{
	BOOL bRet = bChecked == bCurState;
	if( bChecked && bRet && rCallAsk )
	{
		// beim ausschalten soll der Dialog erscheinen
		if( 1 == rCallAsk )
		{
			// die Actionklammerung muss aber fuer den Dialog
			// abgeschaltet werden
			SwWrtShell& rSh = *pShell->GetWrtShell();
			rSh.EndAllAction();

			Window* pParent = &pShell->GetView()->GetViewFrame()->GetWindow();
			bRet = RET_YES == QueryBox( pParent, ResId( RID_SVXQBX_DELETE_HEADFOOT,
									DIALOG_MGR() ) ).Execute();
			rCallAsk = bRet ? 0 : 2;

			rSh.StartAllAction();
		}
		else
			bRet = FALSE;
	}
	return bRet;
}

IMPL_LINK( SwHeadFootMenuControl, DynMenuPageSelect, Menu*, pMenu )
{
	if( pShell && pShell->GetWrtShell() )
	{
		SwWrtShell& rSh = *pShell->GetWrtShell();

		USHORT nCurId = pMenu->GetCurItemId();
		String sSrchNm;
		BOOL bChecked;
		int bCallAsk = 1;

		if( 100 == nCurId )
			bChecked = pMenu->IsItemChecked( 101 );
		else
		{
			sSrchNm = pMenu->GetItemText( nCurId );
			//#64196# Shortcut-Symbol entfernen
			sSrchNm.EraseAllChars('~');
			bChecked = pMenu->IsItemChecked( nCurId );
		}

		FASTBOOL bCrsrSet = FALSE;

		rSh.StartAllAction();
		rSh.StartUndo( 0 );

		for( USHORT nFrom = 0, nTo = rSh.GetPageDescCnt();
				nFrom < nTo; ++nFrom )
		{
			int bChgd = FALSE;
			SwPageDesc aDesc( rSh.GetPageDesc( nFrom ));

			String sTmp(aDesc.GetName());
			//#64196#
			//auch im Vorlagennamen koennte eine Tilde enthalten sein
			//der Vergleich geht jetzt nur noch schief, wenn sich zwei
			//Vorlagennamen nur durch die Position oder Anzahl der Tilden unterscheiden
			//das ist dann Pech
			sTmp.EraseAllChars('~');
			if( 100 == nCurId || sSrchNm == sTmp )
			{
				if( FN_INSERT_PAGEHEADER == GetId() )
				{
					if( ChgHeaderOrFooter( bChecked, aDesc.GetMaster().
							GetHeader().IsActive(), bCallAsk ) )
					{
						bChgd = TRUE;
						aDesc.GetMaster().SetAttr( SwFmtHeader( !bChecked ));
						if( !bChecked )
						{
							SvxULSpaceItem aUL; aUL.SetLower( MM50 );
							SwFrmFmt* pFmt = (SwFrmFmt*)aDesc.GetMaster().GetHeader().GetHeaderFmt();
							pFmt->SetAttr( aUL );
						}
					}
				}
				else if( ChgHeaderOrFooter( bChecked, aDesc.GetMaster().
								GetFooter().IsActive(), bCallAsk ) )
				{
					bChgd = TRUE;
					aDesc.GetMaster().SetAttr( SwFmtFooter( !bChecked ));

					if( !bChecked )
					{
						SvxULSpaceItem aUL; aUL.SetUpper( MM50 );
						SwFrmFmt* pFmt = (SwFrmFmt*)aDesc.GetMaster().GetFooter().GetFooterFmt();
						pFmt->SetAttr( aUL );
					}
				}

				if( bChgd )
				{
					rSh.ChgPageDesc( nFrom, aDesc );

					if( !bCrsrSet && !bChecked )
						bCrsrSet = rSh.SetCrsrInHdFt(
								100 == nCurId ? USHRT_MAX : nFrom,
								FN_INSERT_PAGEHEADER == GetId() );
				}

				if( 100 != nCurId )
					break;
			}
		}
		rSh.EndUndo( 0 );
		rSh.EndAllAction();
	}
	return 0;
}

/*------------------------------------------------------------------------

	$Log: hdftctrl.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:45  hr
	initial import
	
	Revision 1.6  2000/09/18 16:05:57  willem.vandorp
	OpenOffice header added.
	
	Revision 1.5  2000/02/11 14:56:13  hr
	#70473# changes for unicode ( patched by automated patchtool )
	
	Revision 1.4  1999/03/31 10:41:16  OS
	#64196# Tilden in den Menueeintraegen ignorieren
	

	  Rev 1.3   31 Mar 1999 12:41:16   OS
   #64196# Tilden in den Menueeintraegen ignorieren

	  Rev 1.2   27 Jan 1999 11:34:16   JP
   Bug #61154#: setze nach Einfuegen von Kopf-/Fusszeilen den Cursor hinein

	  Rev 1.1   26 Jan 1999 12:02:08   JP
   Bug #61154#: nach Einfuegen der Kopf-/Fusszeilen den Cursor hineinsetzen

	  Rev 1.0   26 May 1998 15:29:30   JP
   neu: Kopf-/Fusszeilen per Menu ein-/ausschalten

------------------------------------------------------------------------*/


