/*************************************************************************
 *
 *  $RCSfile: tmpldlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SWTYPES_HXX //autogen
#include <swtypes.hxx>
#endif

#include "wrtsh.hxx"
#include "fmtcol.hxx"
#include "poolfmt.hxx"
#include "tmpldlg.hxx"
#include "misc.hrc"
#include "tmpldlg.hrc"


/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

SwSelTemplateDlg::SwSelTemplateDlg(Window* pParent, SwWrtShell* pWrtSh,
									String& rName )

	: SvxStandardDialog(pParent, SW_RES(DLG_SEL_TEMPLATE)),

	aTemplatesLB	(this, SW_RES(LB_TEMPLATES	)),
	aOkBtn			(this, SW_RES(BT_OK			)),
	aCancelBtn		(this, SW_RES(BT_CANCEL		)),
	aHelpBtn		(this, SW_RES(BT_HELP  		)),

	pSh				(pWrtSh),
	rTemplateName	(rName)
{
	FreeResource();

	const USHORT nCount = pSh->GetTxtFmtCollCount();
	for(USHORT i = 0; i < nCount; ++i)
	{
		SwTxtFmtColl &rTxtColl = pSh->GetTxtFmtColl(i);
		if( !rTxtColl.IsDefault() && rTxtColl.IsAtDocNodeSet() )
			aTemplatesLB.InsertEntry( rTxtColl.GetName() );
	}

	aTemplatesLB.SelectEntry(rTemplateName);

	if (!aTemplatesLB.GetSelectEntryCount())
	{
		aTemplatesLB.SelectEntry( SwSelTemplateDlg::GetStartTemplate( *pSh ) );

		if (!aTemplatesLB.GetSelectEntryCount())
			aTemplatesLB.SelectEntryPos(0);
	}
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SwSelTemplateDlg::~SwSelTemplateDlg()
{
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void SwSelTemplateDlg::Apply()
{
	rTemplateName = aTemplatesLB.GetSelectEntry();
}


const String& SwSelTemplateDlg::GetStartTemplate( SwWrtShell& rSh )
{
	// stelle fest, ob eine GliederungsVorlage existiert. Wenn ja, returne
	// diese, ansonsten irgendeine benutzte Vorlage
	SwTxtFmtColl *pFnd = 0, *pAny = 0;
	const USHORT nCount = rSh.GetTxtFmtCollCount();
	for( USHORT i = 0; i < nCount; ++i )
	{
		SwTxtFmtColl &rTxtColl = rSh.GetTxtFmtColl( i );
		if( !rTxtColl.IsDefault() && rTxtColl.IsAtDocNodeSet() )
		{
			if( MAXLEVEL >= rTxtColl.GetOutlineLevel() && ( !pFnd ||
				pFnd->GetOutlineLevel() > rTxtColl.GetOutlineLevel() ))
					pFnd = &rTxtColl;
			else if( !pAny )
				pAny = &rTxtColl;
		}
	}
	return pFnd ? pFnd->GetName() : pAny ? pAny->GetName() : aEmptyStr;
}

/*------------------------------------------------------------------------

	$Log: tmpldlg.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:46  hr
	initial import
	
	Revision 1.6  2000/09/18 16:06:00  willem.vandorp
	OpenOffice header added.
	
	Revision 1.5  2000/04/26 14:55:46  os
	GetName() returns const String&
	
	Revision 1.4  1999/04/16 15:21:32  JP
	Bug #64928#: erfrage an der Vorlage, ob sie an einem Node gesetzt ist


	  Rev 1.3   16 Apr 1999 17:21:32   JP
   Bug #64928#: erfrage an der Vorlage, ob sie an einem Node gesetzt ist

	  Rev 1.2   18 Jun 1998 18:18:16   OS
   Vorlage nur anzeigen, wenn nicht Default

	  Rev 1.1   20 Mar 1998 12:37:12   OM
   Globaldokument: Vorlage auswaehlen

	  Rev 1.0   19 Mar 1998 17:42:44   OM
   Initial revision.

------------------------------------------------------------------------*/



