/*************************************************************************
 *
 *  $RCSfile: split.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif


#include "cmdid.h"
#include "split.hxx"
#include "wrtsh.hxx"

#include "split.hrc"
#include "table.hrc"



void SwSplitTableDlg::Apply()
{
	USHORT nCount = aCountEdit.GetValue() - 1;
	rSh.SplitTab(!aHorzBox.IsChecked(),	nCount );
}

SwSplitTableDlg::SwSplitTableDlg( Window *pParent, SwWrtShell& rShell )
	: SvxStandardDialog(pParent, SW_RES(DLG_SPLIT)),
	aCountLbl(this, SW_RES(FT_COUNT)),
	aCountEdit(this, SW_RES(ED_COUNT)),
	aCountFrm(this, SW_RES(GB_COUNT)),
	aHorzBox(this, SW_RES(RB_HORZ)),
	aVertBox(this, SW_RES(RB_VERT)),
	aDirFrm(this, SW_RES(GB_DIR)),
	aOKBtn(this, SW_RES(BT_OK)),
	aCancelBtn(this, SW_RES(BT_CANCEL)),
	aHelpBtn( this, SW_RES( BT_HELP ) ),
	rSh( rShell )
{
	FreeResource();
	aHorzBox.SetClickHdl( STATIC_LINK( this, SwSplitTableDlg, ClickHdl ));
	aVertBox.SetClickHdl( STATIC_LINK( this, SwSplitTableDlg, ClickHdl ));

	long nMax = rSh.GetAnyCurRect( RECT_FRM ).Width();
	if( nMax < 2 * MINLAY )
		aVertBox.Enable(FALSE);
}



IMPL_STATIC_LINK( SwSplitTableDlg, ClickHdl, Button *, pButton )
{
	long nMax = 99;
	if( pButton == &pThis->aVertBox)
	{
		nMax = pThis->rSh.GetAnyCurRect( RECT_FRM ).Width();
		nMax /= MINLAY;
	}
	pThis->aCountEdit.SetMax( nMax );

	return 0;
}

/*------------------------------------------------------------------------

	$Log: split.cxx,v $
	Revision 1.1.1.1  2000/09/18 17:14:48  hr
	initial import
	
	Revision 1.35  2000/09/18 16:06:08  willem.vandorp
	OpenOffice header added.
	
	Revision 1.34  2000/05/26 07:21:33  os
	old SW Basic API Slots removed
	
	Revision 1.33  1998/05/13 14:00:44  OS
	HelpButton


	  Rev 1.32   13 May 1998 16:00:44   OS
   HelpButton

	  Rev 1.31   24 Nov 1997 15:52:22   MA
   includes

	  Rev 1.30   03 Nov 1997 13:56:52   MA
   precomp entfernt

	  Rev 1.29   11 Nov 1996 11:20:24   MA
   ResMgr

	  Rev 1.28   02 Oct 1996 19:06:06   MA
   Umstellung Enable/Disable

	  Rev 1.27   12 Sep 1996 17:10:36   OS
   GetAnyCurRect() ersetzt GetCur*Rect

	  Rev 1.26   06 Sep 1996 19:37:24   JP
   SetMax mit der errechneten Variablen

	  Rev 1.25   04 Sep 1996 11:16:52   JP
   TableManager wird nicht mehr benoetigt

	  Rev 1.24   28 Aug 1996 14:33:16   OS
   includes

	  Rev 1.23   26 Jun 1996 15:25:20   OS
   Aufruf von Dispatcher.Execute an 324 angepasst

	  Rev 1.22   19 Apr 1996 17:06:32   MA
   chg: Vorbereitung fuer kleine Rahmen

	  Rev 1.21   22 Mar 1996 14:16:32   HJS
   umstellung 311

	  Rev 1.20   22 Mar 1996 08:24:34   OS
   Item fuer Richtung muss BoolItem sein Bug #26296#

	  Rev 1.19   20 Feb 1996 16:58:24   OS
   Tabellenzellen teilen gibt jetzt das Teilungsziel an

	  Rev 1.18   06 Feb 1996 15:21:24   JP
   Link Umstellung 305

	  Rev 1.17   24 Nov 1995 16:58:58   OM
   PCH->PRECOMPILED

	  Rev 1.16   10 Nov 1995 15:26:44   OS
   Execute mit 0L abschliessen

	  Rev 1.15   08 Nov 1995 13:34:34   OS
   Change => Set

	  Rev 1.14   05 Nov 1995 16:49:06   OS
   Dtor ueberfluessig, -RecordFlag, Aktion ueber Dispatcher

------------------------------------------------------------------------*/



