/*************************************************************************
 *
 *  $RCSfile: wizagdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "swtypes.hxx"
#include "wizmulti.hxx"
#include "wizard.hrc"
#include "wizagdlg.hxx"


#ifndef _SV_SPINFLD_HXX //autogen
#include <vcl/spinfld.hxx>
#endif
#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif


WizardAgenDialog::~WizardAgenDialog()
{
	delete p1_Text_Stil  ;
	delete p1_RBtn_Stil1 ;
	delete p1_RBtn_Stil2 ;
	delete p1_RBtn_Stil3 ;
	delete p1_Text_Titel ;
	delete p1_Edit_TitTxt;
	delete p1_CBox_TitGrf;
	delete p1_PBtn_TitGrf;
	delete p1_Text_TitGrf;

	delete p2_Text_MetDim;
	delete p2_Text_MetDat;
	delete p2_DFld_MetDat;
	delete p2_Text_MetTim;
	delete p2_TFld_MetTim;
	delete p2_Text_MetOrt;
	delete p2_Edit_MetOrt;
	delete p2_Text_MetOpt;
	delete p2_CBox_Anlass;
	delete p2_CBox_Mitbrn;
	delete p2_CBox_Vorber;
	delete p2_CBox_Anmerk;

	delete p3_Text_AllNam;
	delete p3_CBox_Einber;
	delete p3_CBox_Leitng;
	delete p3_CBox_Protok;
	delete p3_CBox_Teilnm;
	delete p3_CBox_Gaeste;
	delete p3_CBox_Fachlt;
	delete p3_CBox_Nachbe;

	delete p4_Text_PktNum;
	delete p4_Text_Verant;
	delete p4_Text_Minutn;
	delete p4_Text_PktNm1;
	delete p4_Edit_PktNm1;
	delete p4_Edit_VerNm1;
	delete p4_NFld_TimNm1;
	delete p4_Text_PktNm2;
	delete p4_Edit_PktNm2;
	delete p4_Edit_VerNm2;
	delete p4_NFld_TimNm2;
	delete p4_Text_PktNm3;
	delete p4_Edit_PktNm3;
	delete p4_Edit_VerNm3;
	delete p4_NFld_TimNm3;
	delete p4_Text_PktNm4;
	delete p4_Edit_PktNm4;
	delete p4_Edit_VerNm4;
	delete p4_NFld_TimNm4;
	delete p4_Text_PktNm5;
	delete p4_Edit_PktNm5;
	delete p4_Edit_VerNm5;
	delete p4_NFld_TimNm5;
	delete p4_Text_PktNm6;
	delete p4_Edit_PktNm6;
	delete p4_Edit_VerNm6;
	delete p4_NFld_TimNm6;
	delete p4_Scrl_UpDown;
	delete p4_Text_TipNr1;
	delete p4_Text_TipNr2;
	delete p4_Text_TipNr3;
	delete p4_Text_TipNr4;

	//delete p5_Text_Versch;
	//delete p5_List_Punkte;
	//delete p5_SBtn_MoveUp;
	//delete p5_SBtn_MoveDn;

	delete p7_BMap_Fahne ;
	delete p7_Text_Final ;
	delete p7_Text_Protok;
	delete p7_RBtn_PrtJaa;
	delete p7_RBtn_PrnNee;
}



WizardAgenDialog::WizardAgenDialog(Window* pParent)
	: SwWizardDialog( pParent, SW_RES(DLG_WIZARD_AG), 6 )
{
	{
	p1_Text_Stil  =new FixedText   (this,SW_RES(DLG_AG1_Text_Stil  ));
	p1_RBtn_Stil1 =new RadioButton (this,SW_RES(DLG_AG1_RBtn_Stil1 ));
	p1_RBtn_Stil2 =new RadioButton (this,SW_RES(DLG_AG1_RBtn_Stil2 ));
	p1_RBtn_Stil3 =new RadioButton (this,SW_RES(DLG_AG1_RBtn_Stil3 ));
	p1_Text_Titel =new FixedText   (this,SW_RES(DLG_AG1_Text_Titel ));
	p1_Edit_TitTxt=new Edit        (this,SW_RES(DLG_AG1_Edit_TitTxt));
	p1_CBox_TitGrf=new CheckBox    (this,SW_RES(DLG_AG1_CBox_TitGrf));
	p1_PBtn_TitGrf=new PushButton  (this,SW_RES(DLG_AG1_PBtn_TitGrf));
	p1_Text_TitGrf=new FixedText   (this,SW_RES(DLG_AG1_Text_TitGrf));
	} {
	p2_Text_MetDim=new FixedText   (this,SW_RES(DLG_AG2_Text_MetDim));
	p2_Text_MetDat=new FixedText   (this,SW_RES(DLG_AG2_Text_MetDat));
	p2_DFld_MetDat=new DateField   (this,SW_RES(DLG_AG2_DFld_MetDat));
	p2_Text_MetTim=new FixedText   (this,SW_RES(DLG_AG2_Text_MetTim));
	p2_TFld_MetTim=new TimeField   (this,SW_RES(DLG_AG2_TFld_MetTim));
	p2_Text_MetOrt=new FixedText   (this,SW_RES(DLG_AG2_Text_MetOrt));
	p2_Edit_MetOrt=new Edit        (this,SW_RES(DLG_AG2_Edit_MetOrt));
	p2_Text_MetOpt=new FixedText   (this,SW_RES(DLG_AG2_Text_MetOpt));
	p2_CBox_Anlass=new CheckBox    (this,SW_RES(DLG_AG2_CBox_Anlass));
	p2_CBox_Mitbrn=new CheckBox    (this,SW_RES(DLG_AG2_CBox_Mitbrn));
	p2_CBox_Vorber=new CheckBox    (this,SW_RES(DLG_AG2_CBox_Vorber));
	p2_CBox_Anmerk=new CheckBox    (this,SW_RES(DLG_AG2_CBox_Anmerk));
	} {
	p3_Text_AllNam=new FixedText   (this,SW_RES(DLG_AG3_Text_AllNam));
	p3_CBox_Einber=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Einber));
	p3_CBox_Leitng=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Leitng));
	p3_CBox_Protok=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Protok));
	p3_CBox_Teilnm=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Teilnm));
	p3_CBox_Gaeste=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Gaeste));
	p3_CBox_Fachlt=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Fachlt));
	p3_CBox_Nachbe=new CheckBox    (this,SW_RES(DLG_AG3_CBox_Nachbe));
	} {
	p4_Text_PktNum=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNum));
	p4_Text_Verant=new FixedText   (this,SW_RES(DLG_AG4_Text_Verant));
	p4_Text_Minutn=new FixedText   (this,SW_RES(DLG_AG4_Text_Minutn));
	p4_Text_PktNm1=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNm1));
	p4_Edit_PktNm1=new SpinField   (this,SW_RES(DLG_AG4_Edit_PktNm1));
	p4_Edit_VerNm1=new SpinField   (this,SW_RES(DLG_AG4_Edit_VerNm1));
	p4_NFld_TimNm1=new NumericField(this,SW_RES(DLG_AG4_NFld_TimNm1));
	p4_Text_PktNm2=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNm2));
	p4_Edit_PktNm2=new SpinField   (this,SW_RES(DLG_AG4_Edit_PktNm2));
	p4_Edit_VerNm2=new SpinField   (this,SW_RES(DLG_AG4_Edit_VerNm2));
	p4_NFld_TimNm2=new NumericField(this,SW_RES(DLG_AG4_NFld_TimNm2));
	p4_Text_PktNm3=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNm3));
	p4_Edit_PktNm3=new SpinField   (this,SW_RES(DLG_AG4_Edit_PktNm3));
	p4_Edit_VerNm3=new SpinField   (this,SW_RES(DLG_AG4_Edit_VerNm3));
	p4_NFld_TimNm3=new NumericField(this,SW_RES(DLG_AG4_NFld_TimNm3));
	p4_Edit_PktNm4=new SpinField   (this,SW_RES(DLG_AG4_Edit_PktNm4));
	p4_Text_PktNm4=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNm4));
	p4_Edit_VerNm4=new SpinField   (this,SW_RES(DLG_AG4_Edit_VerNm4));
	p4_NFld_TimNm4=new NumericField(this,SW_RES(DLG_AG4_NFld_TimNm4));
	p4_Text_PktNm5=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNm5));
	p4_Edit_PktNm5=new SpinField   (this,SW_RES(DLG_AG4_Edit_PktNm5));
	p4_Edit_VerNm5=new SpinField   (this,SW_RES(DLG_AG4_Edit_VerNm5));
	p4_NFld_TimNm5=new NumericField(this,SW_RES(DLG_AG4_NFld_TimNm5));
	p4_Text_PktNm6=new FixedText   (this,SW_RES(DLG_AG4_Text_PktNm6));
	p4_Edit_PktNm6=new SpinField   (this,SW_RES(DLG_AG4_Edit_PktNm6));
	p4_Edit_VerNm6=new SpinField   (this,SW_RES(DLG_AG4_Edit_VerNm6));
	p4_NFld_TimNm6=new NumericField(this,SW_RES(DLG_AG4_NFld_TimNm6));
	p4_Scrl_UpDown=new ScrollBar   (this,SW_RES(DLG_AG4_Scrl_UpDown));
	p4_Text_TipNr1=new FixedText   (this,SW_RES(DLG_AG4_Text_TipNr1));
	p4_Text_TipNr2=new FixedText   (this,SW_RES(DLG_AG4_Text_TipNr2));
	p4_Text_TipNr3=new FixedText   (this,SW_RES(DLG_AG4_Text_TipNr3));
	p4_Text_TipNr4=new FixedText   (this,SW_RES(DLG_AG4_Text_TipNr4));

	// TipTexte ausrichten fuer anders spracheliche Versionen
	long nTextWidth = GetTextWidth( p4_Text_TipNr1->GetText() );
	Point aPos( p4_Text_TipNr1->GetPosPixel() );
	aPos.X() += nTextWidth + 3;

	aPos.Y() = p4_Text_TipNr2->GetPosPixel().Y();
	p4_Text_TipNr2->SetPosPixel( aPos );
	aPos.Y() = p4_Text_TipNr3->GetPosPixel().Y();
	p4_Text_TipNr3->SetPosPixel( aPos );
	aPos.Y() = p4_Text_TipNr4->GetPosPixel().Y();
	p4_Text_TipNr4->SetPosPixel( aPos );

	} {
	//p5_Text_Versch=new FixedText   (this,SW_RES(DLG_AG5_Text_Versch));
	//p5_List_Punkte=new ListBox     (this,SW_RES(DLG_AG5_List_Punkte));
	//p5_SBtn_MoveUp=new SymbolButton(this,SW_RES(DLG_AG5_SBtn_MoveUp));
	//p5_SBtn_MoveDn=new SymbolButton(this,SW_RES(DLG_AG5_SBtn_MoveDn));

	p7_BMap_Fahne =new FixedBitmap (this,SW_RES(DLG_AG7_BMap_Fahne ));
	p7_Text_Final =new FixedText   (this,SW_RES(DLG_AG7_Text_Final ));
	p7_Text_Protok=new FixedText   (this,SW_RES(DLG_AG7_Text_Protok));
	p7_RBtn_PrtJaa=new RadioButton (this,SW_RES(DLG_AG7_RBtn_PrtJaa));
	p7_RBtn_PrnNee=new RadioButton (this,SW_RES(DLG_AG7_RBtn_PrnNee));
	}
	FreeResource();
}



/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizagdlg.cxx,v 1.1.1.1 2000/09/18 17:14:51 hr Exp $

	  Source Code Control System - Update

	  $Log: wizagdlg.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:51  hr
	  initial import
	
	  Revision 1.26  2000/09/18 16:06:21  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.25  2000/04/19 11:18:58  os
	  UNICODE
	
	  Revision 1.24  2000/02/11 15:01:25  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.23  1999/07/07 13:40:22  MA
	  WizardDialog renamed to SwWizardDialog


	  Rev 1.22   07 Jul 1999 15:40:22   MA
   WizardDialog renamed to SwWizardDialog

	  Rev 1.21   17 Jul 1998 17:25:32   TJ
   include

	  Rev 1.20   03 Jun 1998 11:55:08   RG
   Aenderung Includereihenfolge wegen MS-Compiler

	  Rev 1.19   24 Nov 1997 10:58:40   MA
   includes

	  Rev 1.18   03 Nov 1997 14:01:44   MA
   precomp entfernt

	  Rev 1.17   21 Jan 1997 10:44:08   JP
   CTOR: Folgetexte der Tips dem Tip anpassen (andere Sprachen!)

	  Rev 1.16   14 Nov 1996 15:54:22   TRI
   includes

	  Rev 1.15   11 Nov 1996 10:38:08   MA
   ResMgr

	  Rev 1.14   29 Oct 1996 19:08:48   HJS
   includes

	  Rev 1.13   29 Aug 1996 09:05:00   OS
   includes

	  Rev 1.12   24 Nov 1995 16:59:20   OM
   PCH->PRECOMPILED

	  Rev 1.11   29 Jul 1995 23:35:46   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.10   25 Oct 1994 19:34:50   ER
   add: PCH

	  Rev 1.9   17 May 1994 14:49:10   JOE
   Sicherheits-CheckIn

	  Rev 1.7   26 Apr 1994 11:28:06   JOE
   Joe aus Bln4: Agenda UI Fertig, Core weitgehend. Multi: ClassArray ohne Ctor.

	  Rev 1.6   21 Apr 1994 19:12:20   JOE
   Konzeptumstellung Agenda Punkte verschieben

	  Rev 1.5   18 Apr 1994 23:52:30   JOE
   SEXPORT im Ctor/Dtor

	  Rev 1.4   18 Apr 1994 10:53:30   JOE
   Segmentierung

	  Rev 1.3   16 Apr 1994 10:16:16   JOE
   Das war zu kompliziert fuer den Mac

	  Rev 1.2   13 Apr 1994 05:15:52   JOE
   Resourcen ueberarbeitet. Agenda Res fertig. Fax-UI ausser Elem fertig.

	  Rev 1.1   12 Apr 1994 12:49:02   JOE
   PVCS-Header nach oben verschoben

	  Rev 1.0   11 Apr 1994 17:40:38   JOE
   Wieder in HH. Briefe fertig.

*************************************************************************/

