/*************************************************************************
 *
 *  $RCSfile: wizaggo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif


#include "wrtsh.hxx"     // Writershell
#include "shellio.hxx"		// SwDocFac
#include "wizgo.hxx"
#include "wizag.hxx"


#define C2S(cChar) UniString::CreateFromAscii(cChar)
////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef WINDOCHFILM
#define WIZNOFILM
#endif
#ifndef WINDOCHUNDO
#define WIZNOUNDO
#endif
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL AgenDialog::MakeDoc()
{
	aList.GetArray().Trim();
	BOOL bRet=FALSE;
	String aVorNam(C2S("wizagn1"));
	if (p1_RBtn_Stil2->IsChecked()) aVorNam=C2S("wizagn2");
	if (p1_RBtn_Stil3->IsChecked()) aVorNam=C2S("wizagn3");
	if (NewVorlage(aVorNam)) {
#ifdef WIZNOFILM
		pShell->StartAction();
#endif
#ifdef WIZNOUNDO
		pShell->DoUndo(FALSE); // hat leider noch Seiteneffekte
#endif
		// JP 14.02.97: Bug 36143 - Autoformatierung der Tabelle abschalten
		BOOL bOldUpdateCells = pShell->IsAutoUpdateCells();
		pShell->SetAutoUpdateCells( FALSE );
		//JP 19.02.99: Cursor in Readonly NIE zulassen
		BOOL bCrsrInReadOnly = pShell->IsReadOnlyAvailable();
		pShell->SetReadOnlyAvailable( FALSE );

		SetMarg(aPage1,NULL,NULL);
		DelText();
		InsLogoAgen();
		InsTitl('A');
		InsDatm('A');
		InsElem('A');
		InsAgen();
		InsBmrk('A');
		if (p7_RBtn_PrtJaa->IsChecked())
		{
			InsLogoProt();
			InsTitl('P');
			InsDatm('P');
			InsElem('P');
			InsProt();
			SetMarg(aPage1,NULL,NULL);
			InsBmrk('P');
			GotoBookmark(C2S("Umbr")); // damit der Marker verschwindet
		}
		else
			DeleteProtocoll();
// JP 19.02.99: den Text gibt es in der Agenda nicht!
//        MarkText();
		CreateMacro();
		SaveMacro();
		FillDocInfo(*pDoku);

		pShell->SetAutoUpdateCells( bOldUpdateCells );
		pShell->SetReadOnlyAvailable( bCrsrInReadOnly );

#ifdef WIZNOFILM
		pShell->EndAction();
#endif
		if (SaveVorNewDoc(*pDoku)) bRet=TRUE;
	}
	return bRet;
}

void AgenDialog::CreateMacro()
{
	SetCreateMacro( *pDoku );
}

void AgenDialog::SaveMacro()
{
	 SetSaveMacro( *pDoku );
}

void AgenDialog::InsLogoAgen()
{
	if (aPage1.aLogo.IsVisible()) {
		if (GotoBookmark(C2S("Grf"),'A')) {
			MovFrame(aPage1.aLogo);
			InsLogoObj(aPage1.aLogo);
		}
	} else {
		if (GotoBookmark(C2S("Grf"),'A')) {
			DelFrame();
		}
	}
}

void AgenDialog::InsLogoProt()
{
	BOOL bGotoBookmrk = TRUE;
	if (aPage1.aLogo.IsVisible())
	{
		if (GotoBookmark(C2S("Grf"),'P'))
		{
			MovFrame(aPage1.aLogo);
			if( aPage1.aLogo.HasGraphic() )
			{
				DelFrame();
				bGotoBookmrk = FALSE;
				if( GotoBookmark( C2S("PDum") ) )  // PDum, damit ich auf der richtigen Seite bin !
					InsLogoObj( aPage1.aLogo );
			}
		}
	}
	else if (GotoBookmark(C2S("Grf"),'P'))
		DelFrame();

	if( bGotoBookmrk )
		GotoBookmark(C2S("PDum"));	// Nicht loeschen! (Bug #47692)
}

void AgenDialog::InsTitl(char cAdd)
{
	if (aPage1.aTitl.IsVisible()) {
		if (GotoBookmark(C2S("Tit"),cAdd)) {
			MovFrame(aPage1.aTitl);
			InsLogoObj(aPage1.aTitl);
			if (cAdd=='A') InsDocInfBookmark(0);
		}
	} else {
		if (GotoBookmark(C2S("Tit"),cAdd)) {
			DelFrame();
		}
	}
}

void AgenDialog::InsDatm(char cAdd)
{
	if (aPage1.aDatm.IsVisible()) {
		if (GotoBookmark(C2S("Dat"),cAdd))
		{
			MovFrame(aPage1.aDatm);
			if( !pShell->IsEndPara() )
				pShell->MovePara( fnParaCurr, fnParaEnd );

/*
JP 15.03.99: warum so kompliziert ??? Bug 63381
			const International& rInter = p2_DFld_MetDat->GetInternational();
			Date aDate( p2_DFld_MetDat->GetDate() );

			if( p2_DFld_MetDat->IsLongFormat() )
				InsString(  rInter.GetLongDate( aDate ));
			else
				InsString( rInter.GetDate( aDate ));
*/
			InsString( p2_DFld_MetDat->GetField()->GetText() );

			if (cAdd=='A') InsDocInfBookmark(1);
		}
		if (GotoBookmark(C2S("Tim"),cAdd))
		{
			if( !pShell->IsEndPara() )
				pShell->MovePara( fnParaCurr, fnParaEnd );

			String aStr;
			GetTimeRange(aStr);
			InsString(aStr);
			if (cAdd=='A') InsDocInfBookmark(2);
		}
		if (GotoBookmark(C2S("Ort"),cAdd))
		{
			if( !pShell->IsEndPara() )
				pShell->MovePara( fnParaCurr, fnParaEnd );
			InsString(p2_Edit_MetOrt->GetText());
			if (cAdd=='A') InsDocInfBookmark(3);
		}
	} else {
		if (GotoBookmark(C2S("Dat"),cAdd)) {
			DelFrame();
		}
	}
}

void AgenDialog::InsElem(char cAdd)
{
	if (aPage1.aElem.IsVisible()) {
		if (GotoBookmark(C2S("Ein"),cAdd)) { if (!p3_CBox_Einber->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark( 8);
		if (GotoBookmark(C2S("Anl"),cAdd)) { if (!p2_CBox_Anlass->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark( 4);
		if (GotoBookmark(C2S("Lei"),cAdd)) { if (!p3_CBox_Leitng->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark( 9);
		if (GotoBookmark(C2S("Tei"),cAdd)) { if (!p3_CBox_Teilnm->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark(11);
		if (GotoBookmark(C2S("Vor"),cAdd)) { if (!p2_CBox_Vorber->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark( 6);
		if (GotoBookmark(C2S("Mit"),cAdd)) { if (!p2_CBox_Mitbrn->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark( 5);
		if (GotoBookmark(C2S("Pro"),cAdd)) { if (!p3_CBox_Protok->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark(10);
		if (GotoBookmark(C2S("Nac"),cAdd)) { if (!p3_CBox_Nachbe->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark(14);
		MovFrame(aPage1.aElem);
	} else {
		if (GotoBookmark(C2S("Ein"),cAdd)) {
			DelFrame();
		}
	}
}

void AgenDialog::InsBmrk(char cAdd)
{
	if (GotoBookmark(C2S("Gst"),cAdd)) { if (!p3_CBox_Gaeste->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark(12);
	if (GotoBookmark(C2S("Fch"),cAdd)) { if (!p3_CBox_Fachlt->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark(13);
	if (GotoBookmark(C2S("Rem"),cAdd)) { if (!p2_CBox_Anmerk->IsChecked()) pShell->DelFullPara(); } else if (cAdd=='A') InsDocInfBookmark( 7);
}

void AgenDialog::GetTimeRange(String& rStr, USHORT nNum)
{
	Time aTime;
	USHORT nBeg=0;
	USHORT nEnd=0;
	AgendaArray& rArr = aList.GetArray();
	USHORT nAnz=rArr.GetAnz();
	if (nNum>=nAnz) {
		AgendaRec aRec;
		for (USHORT i=0; i<nAnz; i++) {
			rArr.GetRec(i,aRec);
			nEnd+=aRec.nZeit;
		}
	} else {
		AgendaRec aRec;
		for (USHORT i=0; i<nNum; i++) {
			rArr.GetRec(i,aRec);
			nBeg+=aRec.nZeit;
		}
		rArr.GetRec(nNum,aRec);
		nEnd=nBeg+aRec.nZeit;
	}

	Time aTimeB(p2_TFld_MetTim->GetTime());
	Time aTimeE(aTimeB);

	aTimeB+=Time(0,nBeg);
	aTimeE+=Time(0,nEnd);

	if( aTimeB.GetHour() >= 24 ) aTimeB.SetHour( aTimeB.GetHour() % 24 );
	if( aTimeE.GetHour() >= 24 ) aTimeE.SetHour( aTimeE.GetHour() % 24 );

	const International& rInter = p2_TFld_MetTim->GetInternational();
	BOOL bSecond = FALSE;
	if( TIMEF_NONE != p2_TFld_MetTim->GetFormat()  )
		bSecond = TRUE;

	if( p2_TFld_MetTim->IsDuration() )
		rStr = rInter.GetDuration( aTimeB, bSecond, FALSE );
	else
		rStr = rInter.GetTime( aTimeB, bSecond, FALSE );

	rStr += C2S(" - ");

	if( p2_TFld_MetTim->IsDuration() )
		rStr += rInter.GetDuration( aTimeE, bSecond, FALSE );
	else
		rStr += rInter.GetTime( aTimeE, bSecond, FALSE );
}

void AgenDialog::InsAgen()
{
	AgendaArray& rArr = aList.GetArray();
	USHORT nAnz = rArr.GetAnz();
	if( nAnz && GotoBookmark( C2S("Pkt"), 'A' ) )
	{
		pShell->InsertRow( nAnz-1, TRUE );
		for( USHORT i = 0; i < nAnz; ++i )
		{
			AgendaRec aRec;
			rArr.GetRec( i, aRec );
			String aStr( i + 1 );
			aStr+=C2S(". ");
			InsString( aStr );
			pShell->GoNextCell();
			InsString( aRec.aThem );
			pShell->GoNextCell();
			InsString( aRec.aName );
			pShell->GoNextCell();
			GetTimeRange( aStr, i );
			InsString( aStr );
			if( i != nAnz-1 )
				pShell->GoNextCell();
		}
	}
}

void AgenDialog::InsProt()
{
	if( GotoBookmark( C2S("Thm"), 'P' ) )
	{
		AgendaArray& rArr = aList.GetArray();
		USHORT nAnz = rArr.GetAnz();
		String aStr;

		if( !pShell->IsSttPara() )
			pShell->MovePara( fnParaCurr, fnParaStart );
		pShell->Left( FALSE, 1, TRUE );

		if( !pShell->IsEndPara() )
			pShell->MovePara( fnParaCurr, fnParaEnd );
		pShell->Right( TRUE, 1, TRUE );

		SwDocFac aDocFac;
		SwDoc* pTmpDoc = aDocFac.GetDoc();
		pShell->Copy( pTmpDoc );
		pShell->DelRight();

		for( USHORT i = nAnz; i; )
		{
			AgendaRec aRec;
			rArr.GetRec( --i, aRec );
			pShell->Paste( pTmpDoc );		// Tabelle einfuegen

			// in die erste Zelle der gerade eingefuegten Tabelle
			pShell->MoveTable( fnTablePrev, fnTableStart );

			InsString( aRec.aThem );
			pShell->GoNextCell();
			InsString( aRec.aName );
			pShell->GoNextCell();
			GetTimeRange( aStr, i );
			InsString( aStr );
			pShell->MoveTable( fnTableCurr, fnTableStart );
			pShell->Left( FALSE, 1, TRUE );
		}
	}
}

void AgenDialog::DeleteProtocoll()
{
	if (GotoBookmark(C2S("Grf"),'P')) DelFrame();
	if (GotoBookmark(C2S("Tit"),'P')) DelFrame();
	if (GotoBookmark(C2S("Dat"),'P')) DelFrame();
	if (GotoBookmark(C2S("Ein"),'P')) DelFrame();
	if (GotoBookmark(C2S("Umbr"))) {
		pShell->SttSelect();
		pShell->EndDoc( TRUE );
		pShell->EndSelect();
		pShell->DelRight();
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void AgenDialog::InsDocInfBookmark(USHORT nElemNum)
{
	if (GetDocInfStrOk(nElemNum)) {   // als DocInf freigegeben ?
		USHORT nIdx=nElemNum;      // nIdx geht von 0..aDoku.GetTxFieldAnz()-1
		USHORT i;
		for (i=0; i<nElemNum; i++) // fuer jeden nicht freigeg. davor, Idx um 1 dec.
			if (!GetDocInfStrOk(i)) nIdx--;
		nIdx+=pDoku->GetTxFieldOfs();
		if (nIdx==pDoku->pD_List_InfTit->GetSelectEntryPos()) {
			if( !pShell->IsSttPara() )
				pShell->MovePara( fnParaCurr, fnParaStart );

			InsertBookmark( C2S("Titel") );
		}
		if (nIdx==pDoku->pD_List_InfTem->GetSelectEntryPos()) {
			if( !pShell->IsSttPara() )
				pShell->MovePara( fnParaCurr, fnParaStart );

			InsertBookmark( C2S("Thema") );
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////


/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizaggo.cxx,v 1.1.1.1 2000/09/18 17:14:51 hr Exp $

	  Source Code Control System - Update

	  $Log: wizaggo.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:51  hr
	  initial import
	
	  Revision 1.43  2000/09/18 16:06:21  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.42  2000/09/18 11:22:37  os
	  configuration of agenda wizard completed
	
	  Revision 1.41  2000/05/09 14:44:02  os
	  UNICODE

	  Revision 1.40  2000/04/19 11:18:58  os
	  UNICODE

	  Revision 1.39  2000/02/11 15:01:35  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.38  1999/04/15 10:20:28  JP
	  Bug #64785#: InsLogoProt - ASSERT entfernt


	  Rev 1.37   15 Apr 1999 12:20:28   JP
   Bug #64785#: InsLogoProt - ASSERT entfernt

	  Rev 1.36   13 Apr 1999 20:39:00   JP
   Bug #64435#: Cursor-Bewegungen als Basic-Calls ausgeben, damit sie in ReadOnly-Docs auch funktionieren

	  Rev 1.35   18 Mar 1999 20:27:18   JP
   Bug #57557#: InsProt - 2. Versuch fuer die Solaris-Server Version

	  Rev 1.34   15 Mar 1999 16:51:30   JP
   Bug #63381#: Datum ins Doc setzen, wie es vom Control formatiert ist

	  Rev 1.33   19 Feb 1999 14:03:52   JP
   Bug #57558#/#57557#: statt Left-/RightMargin MovePara( Start/End ) benutzen

	  Rev 1.32   25 Mar 1998 16:12:12   OM
   #48558# Agenda bei englischer Datumsdarstellung korrekt erzeugen

	  Rev 1.31   25 Mar 1998 13:26:54   OM
   #47692 PDum nach Fertigstellung entfernen

	  Rev 1.30   24 Nov 1997 10:58:42   MA
   includes

	  Rev 1.29   03 Nov 1997 14:01:36   MA
   precomp entfernt

	  Rev 1.28   22 May 1997 20:53:14   JP
   Datum/Zeit internationalisiert

	  Rev 1.27   22 Feb 1997 19:46:00   JP
   Bug #36774#: Tabelle komplett kopieren

	  Rev 1.26   14 Feb 1997 20:12:08   JP
   neu: Flag zum unterdruecken der Autoformatierung von Zellen

	  Rev 1.25   29 Oct 1996 19:09:06   HJS
   includes

	  Rev 1.24   29 Aug 1996 09:04:38   OS
   includes

	  Rev 1.23   08 May 1996 22:16:38   JP
   Bug #27657#: erst ans Ende des vorherigen Absatzes und dann die Tabelle selektieren

	  Rev 1.22   24 Nov 1995 16:59:16   OM
   PCH->PRECOMPILED

	  Rev 1.21   30 Aug 1995 13:01:32   MA
   Traveling mit/ohne Selektion vereint

	  Rev 1.20   05 Aug 1995 19:59:16   JP
   InsLogoProt: nur wenn Grafik erwuenscht ist, diese einfuegen

	  Rev 1.19   03 Aug 1995 21:15:04   JP
   alte Funktionalitaet wiederbeleben

	  Rev 1.18   02 Aug 1995 18:52:56   JP
   kein TableMgr mehr; Undo abgeschaltet; ActionKlammerung; optimiert

	  Rev 1.17   29 Jul 1995 23:35:52   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.16   05 Jul 1995 19:10:02   JP
   SwBookmarkFUNC gibts nicht mehr, rufe Methoden an die Shell-Methoden

	  Rev 1.15   05 Jul 1995 13:09:10   JP
   BookmarkFUNC gibts nicht mehr

	  Rev 1.14   09 Jan 1995 18:01:02   ER
	del: clphdl.hxx

*************************************************************************/

