/*************************************************************************
 *
 *  $RCSfile: wizcfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _WIZCFG_HXX
#include <wizcfg.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _WIZAG_HXX
#include <wizag.hxx>
#endif

using namespace rtl;
using namespace com::sun::star;
using namespace com::sun::star::uno;
using namespace com::sun::star::beans;

#define C2U(cChar) OUString::createFromAscii(cChar)
const char* cAgendaList = "AgendaList";
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
Sequence<OUString> SwAgendaWizardCfg::GetPropertyNames()
{
	static const char* aPropNames[] =
	{
		"Style/Style",			// 0
		"LogoGraphic/Name",  // 1
		"LogoGraphic/Filter",// 2
		"Occasion",         // 3
		"Number",			// 4
		"AutoPrefix",       // 5
		"AutoDocName",      // 6
		"AutoPath",         // 7
		"Notes",            // 8
		"Date",             // 9
		"Convened",         // 10
		"Experts",          // 11
		"Guests",           // 12
		"DocInfoSubject",   // 13
		"DocInfoTitle",     // 14
		"Presiding",        // 15
		"BringAlong",       // 16
		"Postprocessing",   // 17
		"Location",         // 18
		"Minutes",          // 19
		"UseMinutes",       // 20
		"Participants",     // 21
		"Title",            // 22
		"TitleGraphic",     // 23
		"Time",				// 24
		"Prepare",          // 25
		"TemplateInfo",     // 26
		"TemplateName"      // 27
	};
	const int nCount = 28;
	Sequence<OUString> aNames(nCount);
	OUString* pNames = aNames.getArray();
	for(int i = 0; i < nCount; i++)
	{
		pNames[i] = OUString::createFromAscii(aPropNames[i]);
	}
	return aNames;
}
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
SwAgendaWizardCfg::SwAgendaWizardCfg() :
	ConfigItem( C2U("Office.Writer/Wizard/Agenda")),
	pAgendaArr(0),
	nStyle(0),
	bOccasion(false),
	nNumber(0),
	bAutoDocName(false),
	bNotes(false),
	nDate(0),
	bConvened(false),
	bExperts(false),
	bGuests(false),
	bPresiding(false),
	bBringAlong(false),
	bPostprocessing(false),
	bMinutes(false),
	bUseMinutes(false),
	bParticipants(false),
	bTitleGraphic(false),
	nTime(0),
	bPrepare(false)
{
	Sequence<OUString> aNames = GetPropertyNames();
	Sequence<Any> aValues = GetProperties(aNames);
	const Any* pValues = aValues.getConstArray();
	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
	if(aValues.getLength() == aNames.getLength())
	{
		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
		{
			DBG_ASSERT(pValues[nProp].hasValue(), "property value missing")
			if(pValues[nProp].hasValue())
			{
				switch(nProp)
				{
					case 0: pValues[nProp] >>= nStyle; break;
					case 1: pValues[nProp] >>= sLogoGrapicName; break;
					case 2: pValues[nProp] >>= sLogoGrapicFilter; break;
					case 3: bOccasion = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 4: pValues[nProp] >>= nNumber; break;
					case 5: pValues[nProp] >>= sAutoPrefix; break;
					case 6: bAutoDocName = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 7: pValues[nProp] >>= sAutoPath; break;
					case 8: bNotes = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 9: pValues[nProp] >>= nDate; break;
					case 10:bConvened = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 11:bExperts = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 12:bGuests = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 13:pValues[nProp] >>= sDocInfoSubject; break;
					case 14:pValues[nProp] >>= sDocInfoTitle; break;
					case 15:bPresiding = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 16:bBringAlong = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 17:bPostprocessing = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 18:pValues[nProp] >>= sLocation; break;
					case 19:bMinutes = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 20:bUseMinutes = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 21:bParticipants = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 22:pValues[nProp] >>= sTitle; break;
					case 23:bTitleGraphic = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 24:pValues[nProp] >>= nTime; break;
					case 25:bPrepare = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 26:pValues[nProp] >>= sTemplateInfo; break;
					case 27:pValues[nProp] >>= sTemplateName; break;
				}
			}
		}
	}
}
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
SwAgendaWizardCfg::~SwAgendaWizardCfg()
{
	delete pAgendaArr;
}
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
void	SwAgendaWizardCfg::Commit()
{
	Sequence<OUString> aNames = GetPropertyNames();

	OUString* pNames = aNames.getArray();
	Sequence<Any> aValues(aNames.getLength());
	Any* pValues = aValues.getArray();

	const Type& rType = ::getBooleanCppuType();
	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
	{
		switch(nProp)
		{
			case 0: pValues[nProp] <<= nStyle; break;
			case 1: pValues[nProp] <<= sLogoGrapicName; break;
			case 2: pValues[nProp] <<= sLogoGrapicFilter; break;
			case 3: pValues[nProp].setValue(&bOccasion, rType); break;
			case 4: pValues[nProp] <<= nNumber; break;
			case 5: pValues[nProp] <<= sAutoPrefix; break;
			case 6: pValues[nProp].setValue(&bAutoDocName, rType); break;
			case 7: pValues[nProp] <<= sAutoPath; break;
			case 8: pValues[nProp].setValue(&bNotes, rType); break;
			case 9: pValues[nProp] <<= nDate; break;
			case 10:pValues[nProp].setValue(&bConvened, rType); break;
			case 11:pValues[nProp].setValue(&bExperts, rType); break;
			case 12:pValues[nProp].setValue(&bGuests, rType); break;
			case 13:pValues[nProp] <<= sDocInfoSubject; break;
			case 14:pValues[nProp] <<= sDocInfoTitle; break;
			case 15:pValues[nProp].setValue(&bPresiding, rType); break;
			case 16:pValues[nProp].setValue(&bBringAlong, rType); break;
			case 17:pValues[nProp].setValue(&bPostprocessing, rType); break;
			case 18:pValues[nProp] <<= sLocation; break;
			case 19:pValues[nProp].setValue(&bMinutes, rType); break;
			case 20:pValues[nProp].setValue(&bUseMinutes, rType); break;
			case 21:pValues[nProp].setValue(&bParticipants, rType); break;
			case 22:pValues[nProp] <<= sTitle; break;
			case 23:pValues[nProp].setValue(&bTitleGraphic, rType); break;
			case 24:pValues[nProp] <<= nTime;break;
			case 25:pValues[nProp].setValue(&bPrepare, rType); break;
			case 26:pValues[nProp] <<= sTemplateInfo; break;
			case 27:pValues[nProp] <<= sTemplateName; break;
		}
	}
	PutProperties(aNames, aValues);
	if(pAgendaArr)
	{
		OUString sAuthorSuffix(C2U("/Author"));
		OUString sDurationSuffix(C2U("/Duration"));
		OUString sTopicSuffix(C2U("/Topic"));
		Sequence< PropertyValue > aValues(pAgendaArr->GetAnz() * 3);
		PropertyValue* pValues = aValues.getArray();

		sal_Int32 nIndex = 0;
		for(sal_Int32 i = 0; i < pAgendaArr->GetAnz(); i++)
		{
			AgendaRec aRec;
			pAgendaArr->GetRec(i,aRec);

			OUString sPrefix(C2U(cAgendaList));
			sPrefix += C2U("/_");
			sPrefix += OUString::valueOf(i);
			pValues[nIndex].Name	= sPrefix;
			pValues[nIndex].Name	+= sAuthorSuffix;
			pValues[nIndex++].Value <<= OUString(aRec.aName);
			pValues[nIndex].Name    = sPrefix;
			pValues[nIndex].Name    += sDurationSuffix;
			pValues[nIndex++].Value <<= aRec.nZeit;
			pValues[nIndex].Name	= sPrefix;
			pValues[nIndex].Name    += sTopicSuffix;
			pValues[nIndex++].Value <<= OUString(aRec.aThem);
		}
		ReplaceSetProperties( C2U(cAgendaList), aValues);
	}
}
/* -----------------------------15.09.00 16:50--------------------------------

 ---------------------------------------------------------------------------*/
AgendaArray&	SwAgendaWizardCfg::GetAgendaArray()
{
	if(!pAgendaArr)
	{
		pAgendaArr = new AgendaArray;
		Sequence<OUString> aListNames = GetNodeNames(C2U(cAgendaList));
		if(aListNames.getLength())
		{
			const OUString* pListNames = aListNames.getConstArray();
			Sequence< rtl::OUString > aNames(aListNames.getLength() * 3);
			OUString* pNames = aNames.getArray();
			const OUString sSlash('/');
			sal_Int32 nIndex = 0;
			for(sal_Int32 i = 0; i < aListNames.getLength(); i++)
			{
				OUString sPrefix(C2U(cAgendaList));
				sPrefix += sSlash;
				sPrefix += pListNames[i];
				sPrefix += sSlash;
				pNames[nIndex] = sPrefix;
				pNames[nIndex++] += C2U("Author");
				pNames[nIndex] = sPrefix;
				pNames[nIndex++] += C2U("Duration");
				pNames[nIndex] = sPrefix;
				pNames[nIndex++] += C2U("Topic");
			}
			Sequence< Any> aProperties = GetProperties(aNames);
			const Any* pProperties = aProperties.getConstArray();
			if(aProperties.getLength() == aNames.getLength())
			{
				nIndex = 0;
				for(sal_Int32 i = 0; i < aListNames.getLength(); i++)
				{
					OUString sAuthor;
					sal_Int32 nDuration;
					OUString sTopic;
					pProperties[nIndex++] >>= sAuthor;
					pProperties[nIndex++] >>= nDuration;
					pProperties[nIndex++] >>= sTopic;
					pAgendaArr->SetThm(i, sTopic);
					pAgendaArr->SetNam(i, sAuthor);
					pAgendaArr->SetTim(i, nDuration);
				}
			}
		}
	}
	return *pAgendaArr;
}
/******************************************************************************

******************************************************************************/
Sequence<OUString> SwLetterWizardCfg::GetPropertyNames()
{
	return Sequence<OUString>();
}
/* -----------------------------14.09.00 13:23--------------------------------

 ---------------------------------------------------------------------------*/
SwLetterWizardCfg::SwLetterWizardCfg() :
	ConfigItem( C2U("Office/Writer/Wizard/Letter"))
{
}
/* -----------------------------14.09.00 13:23--------------------------------

 ---------------------------------------------------------------------------*/
SwLetterWizardCfg::~SwLetterWizardCfg()
{
}
/* -----------------------------14.09.00 13:23--------------------------------

 ---------------------------------------------------------------------------*/
void SwLetterWizardCfg::Commit()
{
}




























