/*************************************************************************
 *
 *  $RCSfile: wizcfg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _WIZCFG_HXX
#define _WIZCFG_HXX

#endif

#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
//-----------------------------------------------------------------------------
class AgendaArray;
class SwAgendaWizardCfg : public utl::ConfigItem
{
	AgendaArray*    pAgendaArr;
	sal_Int32 		nStyle;
	rtl::OUString	sLogoGrapicName;
	rtl::OUString	sLogoGrapicFilter;
	sal_Bool   		bOccasion;
	sal_Int32 		nNumber;
	rtl::OUString	sAutoPrefix;
	sal_Bool 		bAutoDocName;
	rtl::OUString	sAutoPath;
	sal_Bool		bNotes;
	sal_Int64		nDate;
	sal_Bool		bConvened;
	sal_Bool		bExperts;
	sal_Bool		bGuests;
	rtl::OUString	sDocInfoSubject;
	rtl::OUString	sDocInfoTitle;
	sal_Bool		bPresiding;
	sal_Bool		bBringAlong;
	sal_Bool		bPostprocessing;
	rtl::OUString	sLocation;
	sal_Bool		bMinutes;
	sal_Bool		bUseMinutes;
	sal_Bool		bParticipants;
	rtl::OUString	sTitle;
	sal_Bool		bTitleGraphic;
	sal_Int64		nTime;
	sal_Bool		bPrepare;
	rtl::OUString	sTemplateInfo;
	rtl::OUString	sTemplateName;

	com::sun::star::uno::Sequence<rtl::OUString> GetPropertyNames();

public:
	SwAgendaWizardCfg();
	~SwAgendaWizardCfg();

	virtual void	Commit();

	sal_Int32 		GetStyle() const {return nStyle;}
	void 			SetStyle(sal_Int32 nSet) {nStyle = nSet;}

	rtl::OUString	GetLogoGrapicName() const {return sLogoGrapicName;}
	void 			SetLogoGrapicName(const rtl::OUString& rSet ) {sLogoGrapicName = rSet;}

	rtl::OUString	GetLogoGraphicFilter() const {return sLogoGrapicFilter;}
	void 			SetLogoGraphicFilter(const rtl::OUString& rSet) {sLogoGrapicFilter = rSet;}

	sal_Bool   		IsOccasion() const {return bOccasion;}
	void 			SetOccasion(sal_Bool bSet) {bOccasion = bSet;}

	sal_Int32 		GetNumber() const {return nNumber;}
	void 			SetNumber(sal_Int32 nSet) {nNumber = nSet;}

	rtl::OUString	GetAutoPrefix() const {return sAutoPrefix;}
	void			SetAutoPrefix(const rtl::OUString& rSet) {sAutoPrefix = rSet;}

	sal_Bool 		IsAutoDocName() const {return bAutoDocName;}
	void 			SetAutoDocName(sal_Bool bSet) {bAutoDocName = bSet;}

	rtl::OUString	GetAutoPath() const {return sAutoPath;}
	void 			SetAutoPath(const rtl::OUString& rSet) {sAutoPath = rSet;}

	sal_Bool		IsNotes() const {return bNotes;}
	void 			SetNotes(sal_Bool bSet) {bNotes = bSet;}

	sal_Int64		GetDate() const {return nDate;}
	void 			SetDate(sal_Int64 nSet) {nDate = nSet;}

	sal_Bool		IsConvened() const {return bConvened;}
	void 			SetConvened(sal_Bool bSet) {bConvened = bSet;}

	sal_Bool		IsExperts() const {return bExperts;}
	void 			SetExperts(sal_Bool bSet) {bExperts = bSet;}

	sal_Bool		IsGuests() const {return bGuests;}
	void 			SetGuests(sal_Bool bSet) {bGuests = bSet;}

	rtl::OUString	GetDocInfoSubject() const {return sDocInfoSubject;}
	void 			SetDocInfoSubject(const rtl::OUString& rSet) {sDocInfoSubject = rSet;}

	rtl::OUString	GetDocInfoTitle() const {return sDocInfoTitle;}
	void 			SetDocInfoTitle(const rtl::OUString& rSet) {sDocInfoTitle = rSet;}

	sal_Bool		IsPresiding() const {return bPresiding;}
	void 			SetPresiding(sal_Bool bSet) {bPresiding = bSet;}

	sal_Bool		IsBringAlong() const {return bBringAlong;}
	void 			SetBringAlong(sal_Bool bSet) {bBringAlong = bSet;}

	sal_Bool		IsPostprocessing() const {return bPostprocessing;}
	void 			SetPostprocessing(sal_Bool bSet) {bPostprocessing = bSet;}

	rtl::OUString	GetLocation() const {return sLocation;}
	void 			SetLocation(const rtl::OUString& rSet) {sLocation = rSet;}

	sal_Bool		IsMinutes() const {return bMinutes;}
	void 			SetMinutes(sal_Bool bSet) {bMinutes = bSet;}

	sal_Bool		IsUseMinutes() const {return bUseMinutes;}
	void 			SetUseMinutes(sal_Bool bSet) {bUseMinutes = bSet;}

	sal_Bool		IsParticipants() const {return bParticipants;}
	void 			SetParticipants(sal_Bool bSet) {bParticipants = bSet;}

	rtl::OUString	GetTitle() const {return sTitle;}
	void 			SetTitle(const rtl::OUString& rSet) {sTitle = rSet;}

	sal_Bool		IsTitleGraphic() const {return bTitleGraphic;}
	void 			SetTitleGraphic(sal_Bool bSet) {bTitleGraphic = bSet;}

	sal_Int64 		GetTime() const {return nTime;}
	void			SetTime(sal_Int64 nSet) {nTime = nSet;}

	sal_Bool		IsPrepare() const {return bPrepare;}
	void 			SetPrepare(sal_Bool bSet) {bPrepare = bSet;}

	rtl::OUString	GetTemplateInfo() const {return sTemplateInfo;}
	void 			SetTemplateInfo(const rtl::OUString& rSet) {sTemplateInfo = rSet;}

	rtl::OUString	GetTemplateName() const {return sTemplateName;}
	void 			SetTemplateName(const rtl::OUString& rSet) {sTemplateName = rSet;}

	AgendaArray&	GetAgendaArray();
};
//-----------------------------------------------------------------------------
class SwLetterWizardCfg : public utl::ConfigItem
{
	com::sun::star::uno::Sequence<rtl::OUString> GetPropertyNames();
public:
	SwLetterWizardCfg();
	~SwLetterWizardCfg();

	virtual void		Commit();
};
//-----------------------------------------------------------------------------
class SwMemoWizardCfg : public utl::ConfigItem
{

	com::sun::star::uno::Sequence<rtl::OUString> GetPropertyNames();
public:
	SwMemoWizardCfg();
	~SwMemoWizardCfg();

	virtual void		Commit();
};
//-----------------------------------------------------------------------------
class SwFaxWizardCfg : public utl::ConfigItem
{
	com::sun::star::uno::Sequence<rtl::OUString> GetPropertyNames();
public:
	SwFaxWizardCfg();
	~SwFaxWizardCfg();

	virtual void		Commit();
};

