/*************************************************************************
 *
 *  $RCSfile: wizdoku.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFXDOCTEMPL_HXX //autogen
#include <sfx2/doctempl.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _IODLG_HXX
#include "sfx2/iodlg.hxx"
#endif
#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif

#include "helpid.h"
#include "swtypes.hxx"
#include "errhdl.hxx"
#include "wizmulti.hxx"
#include "wizard.hrc"
#include "wizdoku.hxx"

/* -----------------------------23.03.00 15:10--------------------------------

 ---------------------------------------------------------------------------*/
String lcl_CheckForItemIDPath(const String& rPath)
{
	String sRet(rPath);
	sal_Unicode cDelim = SFX_SEARCHPATH_DELIMITER;
	if(sRet.GetTokenCount(cDelim) > 1)
		sRet = sRet.GetToken(0, cDelim);
	return sRet;
}

// ---------------------------------------------------------------------------

WizardDokuDlg::WizardDokuDlg( SwWizardDialog* pDlgWin )
{
	pD_Text_SavOpt=new FixedText (pDlgWin,SW_RES(DLG_Dok_Text_SavOpt));
	pD_Text_InfTit=new FixedText (pDlgWin,SW_RES(DLG_Dok_Text_InfTit));
	pD_List_InfTit=new ListBox   (pDlgWin,SW_RES(DLG_Dok_List_InfTit));
	pD_Text_InfTem=new FixedText (pDlgWin,SW_RES(DLG_Dok_Text_InfTem));
	pD_List_InfTem=new ListBox   (pDlgWin,SW_RES(DLG_Dok_List_InfTem));
	pD_GBox_DokInf=new GroupBox  (pDlgWin,SW_RES(DLG_Dok_GBox_DokInf));
	pD_CBox_AutoFN=new CheckBox  (pDlgWin,SW_RES(DLG_Dok_CBox_AutoFN));
	pD_Text_AutoFN=new FixedText (pDlgWin,SW_RES(DLG_Dok_Text_AutoFN));
	pD_Edit_AutoFN=new Edit      (pDlgWin,SW_RES(DLG_Dok_Edit_AutoFN));
	pD_PBtn_Folder=new PushButton(pDlgWin,SW_RES(DLG_Dok_PBtn_Folder));
	pD_Text_Folder=new FixedText (pDlgWin,SW_RES(DLG_Dok_Text_Folder));
	pD_GBox_DokSav=new GroupBox (pDlgWin,SW_RES(DLG_Dok_GBox_DokSav));
	pD_Text_VorNam=new FixedText(pDlgWin,SW_RES(DLG_Dok_Text_VorNam));
	pD_Edit_VorNam=new Edit     (pDlgWin,SW_RES(DLG_Dok_Edit_VorNam));
	pD_Text_VorInf=new FixedText(pDlgWin,SW_RES(DLG_Dok_Text_VorInf));
	pD_Edit_VorInf=new Edit     (pDlgWin,SW_RES(DLG_Dok_Edit_VorInf));
	pD_GBox_VorSav=new GroupBox (pDlgWin,SW_RES(DLG_Dok_GBox_VorSav));
	pWizDlg = pDlgWin;
	nDBFieldAnz = 0;
	pOkayBtn = NULL;
	SetEventHandler();
	InitUI();
}

WizardDokuDlg::~WizardDokuDlg()
{
	delete pD_Text_SavOpt;
	delete pD_Text_InfTit;
	delete pD_List_InfTit;
	delete pD_Text_InfTem;
	delete pD_List_InfTem;
	delete pD_GBox_DokInf;
	delete pD_CBox_AutoFN;
	delete pD_Text_AutoFN;
	delete pD_Edit_AutoFN;
	delete pD_PBtn_Folder;
	delete pD_Text_Folder;
	delete pD_GBox_DokSav;
	delete pD_Text_VorNam;
	delete pD_Edit_VorNam;
	delete pD_Text_VorInf;
	delete pD_Edit_VorInf;
	delete pD_GBox_VorSav;
}

void WizardDokuDlg::Fill(MultiOne& WinArr)
{
	WinArr.AddWin(pD_Text_SavOpt);
	WinArr.AddWin(pD_Text_InfTit);
	WinArr.AddWin(pD_List_InfTit, TRUE);
	WinArr.AddWin(pD_Text_InfTem);
	WinArr.AddWin(pD_List_InfTem, TRUE);
	WinArr.AddWin(pD_GBox_DokInf,FALSE, TRUE);
	WinArr.AddWin(pD_CBox_AutoFN, TRUE);
	WinArr.AddWin(pD_Text_AutoFN);
	WinArr.AddWin(pD_Edit_AutoFN, TRUE);
	WinArr.AddWin(pD_PBtn_Folder, TRUE);
	WinArr.AddWin(pD_Text_Folder);
	WinArr.AddWin(pD_GBox_DokSav,FALSE,TRUE);
	WinArr.AddWin(pD_Text_VorNam);
	WinArr.AddWin(pD_Edit_VorNam, TRUE);
	WinArr.AddWin(pD_Text_VorInf);
	WinArr.AddWin(pD_Edit_VorInf, TRUE);
	WinArr.AddWin(pD_GBox_VorSav,FALSE,TRUE);
}

void WizardDokuDlg::SetPtr(PushButton* pBtn)
{
	pOkayBtn=pBtn;
	pOkayBtn->SetClickHdl(LINK(this,WizardDokuDlg,OkClckHdl));
	SetOkayDisable();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void WizardDokuDlg::SetDocInfListEntryOne(USHORT nNum, const String& aNam, ListBox& rLst)
{
	USHORT nAnz=rLst.GetEntryCount();
	if (nNum>=nAnz)
	{
		USHORT nFehl=nNum+1-nAnz;
		for (USHORT i=1; i<nFehl; ++i )
			rLst.InsertEntry(aEmptyStr);
	}
	rLst.RemoveEntry(nNum);
	rLst.InsertEntry(aNam,nNum);
}

void WizardDokuDlg::SetDocInfListEntry(USHORT nNum, const String& aNam)
{
	String sEntry(aNam);
	USHORT nCount = sEntry.GetTokenCount('.');
	if (nCount)	// Nur Spaltenname anzeigen. Da Punkte in DB-Namen moeglich
	{			// sind, letztes Token suchen
		sEntry = sEntry.GetToken(nCount - 1, '.');
	}

	SetDocInfListEntryOne(nNum, sEntry, *pD_List_InfTit);
	SetDocInfListEntryOne(nNum, sEntry, *pD_List_InfTem);
}

void WizardDokuDlg::SetDBFieldAnz(USHORT nAnz)
{
	USHORT nAnz0=GetTxFieldAnz();
	if (nAnz<nAnz0)
	{
		for (USHORT i=0; i<USHORT(nAnz0-nAnz); i++)
		{
			pD_List_InfTit->RemoveEntry(1+nAnz);
			pD_List_InfTem->RemoveEntry(1+nAnz);
		}
	}
	if (nAnz>nDBFieldAnz)
	{
		for (USHORT i=0; i<USHORT(nAnz-nAnz0); i++)
		{
			pD_List_InfTit->InsertEntry(aEmptyStr,1+nAnz0);
			pD_List_InfTem->InsertEntry(aEmptyStr,1+nAnz0);
		}
	}
	nDBFieldAnz=nAnz;
}

void WizardDokuDlg::SetTxFieldAnz(USHORT nAnz)
{
	USHORT nAnz0=GetTxFieldAnz();
	if (nAnz<nAnz0)
	{
		for (USHORT i=0; i<USHORT(nAnz0-nAnz); i++)
		{
			pD_List_InfTit->RemoveEntry(1+nDBFieldAnz+nAnz);
			pD_List_InfTem->RemoveEntry(1+nDBFieldAnz+nAnz);
		}
	}
}

void WizardDokuDlg::SetDBFieldNam(USHORT nNum, const String& aNam)
{
	SetDocInfListEntry(1+nNum,aNam);
}

void WizardDokuDlg::SetTxFieldNam(USHORT nNum, const String& aNam)
{
	SetDocInfListEntry(1+nDBFieldAnz+nNum,aNam);
}

void WizardDokuDlg::MerkDocInfListSel()
{
	aMerk1=pD_List_InfTit->GetSelectEntry();
	aMerk2=pD_List_InfTem->GetSelectEntry();
}

void WizardDokuDlg::RestDocInfListSel()
{
	pD_List_InfTit->SelectEntry(aMerk1);
	pD_List_InfTem->SelectEntry(aMerk2);
	SetDocInfDisable();
}

void WizardDokuDlg::SetDocInfDisable()
{
	if (pD_List_InfTit->GetSelectEntryCount()==0)
		pD_List_InfTit->SelectEntryPos(0);
	if (pD_List_InfTem->GetSelectEntryCount()==0)
		pD_List_InfTem->SelectEntryPos(0);

	const BOOL bEnable = pD_List_InfTit->GetEntryCount() > 1;
	pD_Text_InfTit->Enable(bEnable);
	pD_List_InfTit->Enable(bEnable);
	pD_Text_InfTem->Enable(bEnable);
	pD_List_InfTem->Enable(bEnable);
	pD_GBox_DokInf->Enable(bEnable);
}

BOOL WizardDokuDlg::IsDocInfoDBFeldSelected(USHORT nTyp) // 0=Titel 1=Thema
{
	BOOL bRet = FALSE;
	switch( nTyp )
	{
	case 0: bRet = IsDocInfoDBFeld(pD_List_InfTit->GetSelectEntryPos()); break;
	case 1: bRet = IsDocInfoDBFeld(pD_List_InfTem->GetSelectEntryPos()); break;
	}
	return bRet;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void WizardDokuDlg::InitUI()
{
	pD_List_InfTit->SelectEntryPos(0);
	pD_List_InfTem->SelectEntryPos(0);

	SfxIniManager* pIniManager = SFX_APP()->GetIniManager();
	ASSERT(pIniManager, "Kein Inimanager angelegt !!");
	String sWorkPath = pIniManager->Get(SFX_KEY_WORK_PATH);
	sWorkPath = lcl_CheckForItemIDPath(sWorkPath);
	pD_Text_Folder->SetText(sWorkPath);

	SetDisable();
}

void WizardDokuDlg::ToUI()
{
	SetDisable();
}

void WizardDokuDlg::SetDisable()
{
	SetDocInfDisable();
	SetAutoFNDisable();
}

void WizardDokuDlg::SetAutoFNDisable()
{
	const BOOL bEnable = pD_CBox_AutoFN->IsChecked();
	pD_Text_AutoFN->Enable(bEnable);
	pD_Edit_AutoFN->Enable(bEnable);
	pD_PBtn_Folder->Enable(bEnable);
	pD_Text_Folder->Enable(bEnable);
}

void WizardDokuDlg::SetEventHandler()
{
	pD_CBox_AutoFN->SetClickHdl (LINK(this,WizardDokuDlg,ClckHdl));
	pD_PBtn_Folder->SetClickHdl (LINK(this,WizardDokuDlg,FldClckHdl));
	pD_Edit_VorNam->SetModifyHdl(LINK(this,WizardDokuDlg,ModifyHdl));
}

IMPL_LINK_INLINE_START( WizardDokuDlg, ClckHdl, CheckBox *, pBtn )
{
	SetDisable();
	return 0;
}
IMPL_LINK_INLINE_END( WizardDokuDlg, ClckHdl, CheckBox *, pBtn )

IMPL_LINK( WizardDokuDlg, FldClckHdl, PushButton *, pBtn )
{
	SfxIniManager* pIniManager = SFX_APP()->GetIniManager();
	ASSERT(pIniManager, "Kein Inimanager angelegt !!");
	String sPath( pIniManager->Get(SFX_KEY_WORK_PATH) );

	sPath = lcl_CheckForItemIDPath(sPath);

	WinBits	nBits = WB_3DLOOK|WB_STDMODAL|WB_OPEN|SFXWB_PATHDIALOG;

	SfxFileDialog* pFileDlg = new SfxFileDialog( pWizDlg, nBits );
	pFileDlg->DisableSaveLastDirectory();
	pFileDlg->SetPath( sPath );
	pFileDlg->SetHelpId(HID_FILEDLG_WIZDOKU);

	if (pFileDlg->Execute())
	{
/*		DirEntry aDir(pFileDlg->GetPath());
		USHORT nMaxLen = (USHORT)(pD_Text_Folder->GetSizePixel().Width() / pD_Text_Folder->GetTextSize("X").Width());
		pD_Text_Folder->SetText(aDir.GetFull( FSYS_STYLE_HOST, FALSE, nMaxLen ));
*/
		pD_Text_Folder->SetText(pFileDlg->GetPath());
	}

	delete pFileDlg;

	return 0;
}

void WizardDokuDlg::SetOkayDisable()
{
	if (pOkayBtn!=NULL)
		pOkayBtn->Enable(pD_Edit_VorNam->GetText().Len()!=0);
}

IMPL_LINK_INLINE_START( WizardDokuDlg, ModifyHdl, Edit *, pEdt )
{
	SetOkayDisable();
	return 0;
}
IMPL_LINK_INLINE_END( WizardDokuDlg, ModifyHdl, Edit *, pEdt )

IMPL_LINK( WizardDokuDlg, OkClckHdl, PushButton *, pBtn )
{
	String aVorFN( pD_Edit_VorNam->GetText() );

	if( aVorFN.Len() )
	{
		SfxDocumentTemplates aFac;
		aFac.Construct();

		String aStr1( aVorFN );
		aStr1.ToUpperAscii();
		USHORT nRegion = 0;			// ist das der Standard - Bereich ??
		USHORT nAnz = aFac.GetCount( nRegion );
		USHORT i;
		for( i = 0; i < nAnz; ++i )
		{
			String aStr2( aFac.GetName( nRegion, i ) );
			aStr2.ToUpperAscii();
			if( aStr1 == aStr2 )
			{
				aStr1 = aVorFN;
				aStr1 += '\n';
				aStr1 += SW_RESSTR( STR_Dok_Overwrite1 );
				aStr1 += '\n';
				aStr1 += SW_RESSTR( STR_Dok_Overwrite2 );
				QueryBox aQuery( 0, WinBits( WB_YES_NO | WB_DEF_NO ), aStr1 );

				if( RET_YES == aQuery.Execute() )
					pWizDlg->EndDialog( TRUE );
				else
				{
					USHORT nStepNum;
					if( pWizDlg->FindWin( pD_Edit_VorNam, nStepNum ) )
					{
						pWizDlg->Switch( nStepNum );
						pD_Edit_VorNam->GrabFocus();
					}
				}
				break;
			}
		}
		if( i >= nAnz )			// nicht gefunden -> und schluss
			pWizDlg->EndDialog( TRUE );
	}
	else
	{
		Sound::Beep(SOUND_ERROR);
		InfoBox( NULL, SW_RESSTR( STR_Dok_NoVorNam ) ).Execute();
		USHORT nStepNum;
		if( pWizDlg->FindWin( pD_Edit_VorNam, nStepNum ) )
		{
			pWizDlg->Switch( nStepNum );
			pD_Edit_VorNam->GrabFocus();
		}
	}
	return 0;
}



/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizdoku.cxx,v 1.1.1.1 2000/09/18 17:14:51 hr Exp $

	  Source Code Control System - Update

	  $Log: wizdoku.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:51  hr
	  initial import
	
	  Revision 1.59  2000/09/18 16:06:21  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.58  2000/06/13 09:57:59  os
	  using UCB
	
	  Revision 1.57  2000/05/18 09:49:15  os
	  ItemIDPath removed

	  Revision 1.56  2000/04/19 12:56:36  os
	  include sfx2/filedlg.hxx removed

	  Revision 1.55  2000/04/19 11:18:58  os
	  UNICODE

	  Revision 1.54  2000/03/23 14:40:16  os
	  #74264# handling of file:///{documents}/

	  Revision 1.53  2000/03/03 15:17:05  os
	  StarView remainders removed

	  Revision 1.52  2000/02/11 15:01:40  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.51  2000/01/24 12:41:32  os
	  #72153# call SfxFileDialog::DisableSaveLastDirectory

	  Revision 1.50  1999/07/07 13:40:24  MA
	  WizardDialog renamed to SwWizardDialog


	  Rev 1.49   07 Jul 1999 15:40:24   MA
   WizardDialog renamed to SwWizardDialog

	  Rev 1.48   08 Apr 1999 10:51:46   JP
   Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)

	  Rev 1.47   02 Sep 1998 14:12:28   OM
   #45378# HelpIDs fuer Dateidialoge

	  Rev 1.46   28 Nov 1997 14:41:58   MA
   includes

	  Rev 1.45   24 Nov 1997 10:58:34   MA
   includes

	  Rev 1.44   12 Nov 1997 17:21:36   MBA
   SP3:include

	  Rev 1.43   03 Nov 1997 14:01:48   MA
   precomp entfernt

	  Rev 1.42   19 Oct 1997 15:07:02   MH
   add: header

	  Rev 1.41   03 Sep 1997 16:58:38   OM
   Automatischen Dokumentpfad defaulten

	  Rev 1.40   01 Sep 1997 13:22:26   OS
   DLL-Umstellung

	  Rev 1.39   09 Jun 1997 17:29:16   OM
   Pfad nicht kuerzen

	  Rev 1.38   07 Mar 1997 16:51:36   OM
   DocManPath entfernt

	  Rev 1.37   11 Nov 1996 10:38:08   MA
   ResMgr

	  Rev 1.36   07 Oct 1996 09:24:04   MA
   Umstellung Enable/Disable

	  Rev 1.35   02 Oct 1996 16:46:10   OM
   #31779#Datenbankfelder in Autopilot-Popups verkuerzt darstellen

	  Rev 1.34   29 Aug 1996 09:04:46   OS
   includes

	  Rev 1.33   17 Jul 1996 23:06:44   JP
   include svsystem

	  Rev 1.32   11 Apr 1996 19:12:50   MA
   opt: unbenutzes entfernt

	  Rev 1.31   06 Feb 1996 15:21:44   JP
   Link Umstellung 305

	  Rev 1.30   24 Nov 1995 16:59:16   OM
   PCH->PRECOMPILED

	  Rev 1.29   08 Nov 1995 12:03:26   OS
   Change => Set

	  Rev 1.28   21 Sep 1995 15:32:34   JP
   ASSERT entfernt

	  Rev 1.27   29 Jul 1995 23:35:48   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.26   25 Oct 1994 19:34:18   ER
   add: PCH

	  Rev 1.25   20 Oct 1994 11:28:14   PK
   ausgeboxtes wieder reingeboxt

	  Rev 1.24   22 Sep 1994 10:25:52   MS
   Umstellung SFX

*************************************************************************/



