/*************************************************************************
 *
 *  $RCSfile: wizempf.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SBA_SBAOBJ_HXX //autogen
#include <offmgr/sbaobj.hxx>
#endif


#include "swtypes.hxx"
#include "dbmgr.hxx"
#include "wizard.hrc"
#include "wizempf.hxx"
#include "initui.hxx"

#ifdef REPLACE_OFADBMGR
using namespace com::sun::star::uno;
using namespace rtl;
#else

#endif  //REPLACE_OFADBMGR

WizardEmpfDlg::WizardEmpfDlg(SwWizardDialog* pDlgWin, BOOL bTele, BOOL bAnrd)
{
	pWizDlg = pDlgWin;
	pEmpf = NULL;
	bAnrede = bAnrd;
	bTelfon = bTele;

	pE_Text_EmpTit = new FixedText (pDlgWin,SW_RES(DLG_Emp_Text_EmpTit ));
	pE_Text_DBase  = new FixedText (pDlgWin,SW_RES(DLG_Emp_Text_DBase  ));
	pE_List_DBase  = new ListBox   (pDlgWin,SW_RES(DLG_Emp_List_DBase  ));
	pE_List_DBTable= new ListBox   (pDlgWin,SW_RES(DLG_Emp_List_DBTable));

	if (bTelfon)
	{
	   pE_Text_Telfon = new FixedText(pDlgWin,SW_RES(DLG_Emp_Text_Telfon));
	   pE_List_Telfon = new ListBox  (pDlgWin,SW_RES(DLG_Emp_List_Telfon));
	   pE_Text_Telfax = new FixedText(pDlgWin,SW_RES(DLG_Emp_Text_Telfax));
	   pE_List_Telfax = new ListBox  (pDlgWin,SW_RES(DLG_Emp_List_Telfax));
	}
	else
	{
		pE_Text_Telfon = 0;
		pE_List_Telfon = 0;
		pE_Text_Telfax = 0;
		pE_List_Telfax = 0;
	}
	pE_Text_Adress = new FixedText    (pDlgWin,SW_RES(DLG_Emp_Text_Adress));
	pE_MEdt_Adress = new MultiLineEdit(pDlgWin,SW_RES(DLG_Emp_MEdt_Adress));
	pE_SBtn_Insert = new ImageButton (pDlgWin,SW_RES(DLG_Emp_SBtn_Insert));
	pE_BBtn_NewLin = new ImageButton (pDlgWin,SW_RES(DLG_Emp_BBtn_NewLin));
	pE_Text_Fields = new FixedText    (pDlgWin,SW_RES(DLG_Emp_Text_Fields));
	pE_List_Fields = new ListBox      (pDlgWin,SW_RES(DLG_Emp_List_Fields));

	if (bAnrede)
	{
	   pE_Text_AnrFix = new FixedText(pDlgWin,SW_RES(DLG_Emp_Text_AnrFix));
	   pE_Edit_AnrFix = new Edit     (pDlgWin,SW_RES(DLG_Emp_Edit_AnrFix));
	   pE_Text_AnrFld = new FixedText(pDlgWin,SW_RES(DLG_Emp_Text_AnrFld));
	   pE_List_AnrFld = new ListBox  (pDlgWin,SW_RES(DLG_Emp_List_AnrFld));
	}
	else
	{
		pE_Text_AnrFix = 0;
		pE_Edit_AnrFix = 0;
		pE_Text_AnrFld = 0;
		pE_List_AnrFld = 0;
	}

	SetEventHandler();
	pDBasMgr = new SwNewDBMgr;
	InitUI();
}

WizardEmpfDlg::~WizardEmpfDlg()
{
	delete pE_Text_EmpTit ;
	delete pE_Text_DBase  ;
	delete pE_List_DBase  ;
	delete pE_List_DBTable;
	if (pE_Text_Telfon ) delete pE_Text_Telfon ;
	if (pE_List_Telfon ) delete pE_List_Telfon ;
	if (pE_Text_Telfax ) delete pE_Text_Telfax ;
	if (pE_List_Telfax ) delete pE_List_Telfax ;
	delete pE_Text_Adress ;
	delete pE_MEdt_Adress ;
	delete pE_SBtn_Insert ;
	delete pE_BBtn_NewLin ;
	delete pE_Text_Fields ;
	delete pE_List_Fields ;
	if (pE_Text_AnrFix ) delete pE_Text_AnrFix ;
	if (pE_Edit_AnrFix ) delete pE_Edit_AnrFix ;
	if (pE_Text_AnrFld ) delete pE_Text_AnrFld ;
	if (pE_List_AnrFld ) delete pE_List_AnrFld ;
	delete pDBasMgr;
}

void WizardEmpfDlg::Fill(MultiOne& WinArr)
{
	WinArr.AddWin( pE_Text_EmpTit );
	WinArr.AddWin( pE_Text_DBase  );
	WinArr.AddWin( pE_List_DBase, TRUE );
	WinArr.AddWin( pE_List_DBTable, TRUE);
	WinArr.AddWin( pE_Text_Adress );
	WinArr.AddWin( pE_MEdt_Adress, TRUE );
	WinArr.AddWin( pE_SBtn_Insert, TRUE );
	WinArr.AddWin( pE_BBtn_NewLin, TRUE );
	WinArr.AddWin( pE_Text_Fields );
	WinArr.AddWin( pE_List_Fields, TRUE );
	if( pE_Text_AnrFix ) WinArr.AddWin( pE_Text_AnrFix );
	if( pE_Edit_AnrFix ) WinArr.AddWin( pE_Edit_AnrFix, TRUE );
	if( pE_Text_AnrFld ) WinArr.AddWin( pE_Text_AnrFld );
	if( pE_List_AnrFld ) WinArr.AddWin( pE_List_AnrFld, TRUE );
	if( pE_Text_Telfon ) WinArr.AddWin( pE_Text_Telfon );
	if( pE_List_Telfon ) WinArr.AddWin( pE_List_Telfon, TRUE );
	if( pE_Text_Telfax ) WinArr.AddWin( pE_Text_Telfax );
	if( pE_List_Telfax ) WinArr.AddWin( pE_List_Telfax, TRUE );
}

void WizardEmpfDlg::SetPtr(WizardText* pEmp)
{
	pEmpf=pEmp;
	ToUI();
}

void WizardEmpfDlg::FillFeldList(ListBox* pList, BOOL bUnselect, BOOL bInklKeins)
{
	if( pList )
	{
		String aMerk(pE_List_DBase->GetSelectEntry());
		pList->Clear();
		pList->SetNoSelection();
		if( bInklKeins )
			pList->InsertEntry( SW_RESSTR( STR_Emp_NoField ));

		String aDBName(pE_List_DBase->GetSelectEntry());
		aDBName += DB_DELIM;
		aDBName += pE_List_DBTable->GetSelectEntry();

		pDBasMgr->GetColumnNames(pList, aDBName, TRUE);
		pList->SelectEntry( aMerk );
		if( !pList->GetSelectEntryCount() && bInklKeins )
			pList->SelectEntryPos( 0 );
	}
}

String WizardEmpfDlg::GetDBFieldNam(USHORT nNum, BOOL bKlammern)
{
	String aStr(pE_List_DBase->GetSelectEntry());
	aStr += '.';
	aStr += pE_List_DBTable->GetSelectEntry();
	aStr += '.';
	aStr += pE_List_Fields->GetEntry( nNum );
	if (bKlammern)
	{
		aStr.Insert('<',0);
		aStr+='>';
	}
	return aStr;
}

void WizardEmpfDlg::SelectDBasList( USHORT nNum )
{
#ifdef REPLACE_OFADBMGR
	Sequence<OUString> aDataNames = SwNewDBMgr::GetExistingDatabaseNames();
	long nCount = aDataNames.getLength();
#else
	String sDBNames( pDBasMgr->GetSbaObject()->GetDatabaseNames() );
	sDBNames = SFX_APP()->LocalizeDBName(INI2NATIONAL, sDBNames);
	USHORT nCount = sDBNames.GetTokenCount();
#endif
	if( nNum < nCount )
	{
		String aNam( pE_List_DBase->GetEntry( nNum ) );
		String sDBName = aNam;
		aNam += DB_DELIM;
		aNam += pE_List_DBTable->GetSelectEntry();
		if( aNam != aAktDB )
		{
			pE_MEdt_Adress->SetText( aEmptyStr );
			if( pEmpf ) // Datenbank gewechselt? -> EmpfFeld raeumen
				pEmpf->SetStr( aEmptyStr, &pWizDlg->aPrevWin );
			pDBasMgr->GetTableNames(pE_List_DBTable, sDBName);

			aAktDB = aNam;
			pE_List_DBase->SelectEntry(sDBName);
		}

#ifdef REPLACE_OFADBMGR
		pDBasMgr->OpenDataSource( sDBName, pE_List_DBTable->GetSelectEntry());
#else
		sDBName += DB_DELIM;
		sDBName += pE_List_DBTable->GetSelectEntry();
		pDBasMgr->OpenDB(DBMGR_STD, sDBName);
#endif
	}

	FillFeldList(pE_List_Fields);
	FillFeldList(pE_List_Telfon,TRUE,TRUE);
	FillFeldList(pE_List_Telfax,TRUE,TRUE);
	FillFeldList(pE_List_AnrFld,TRUE,TRUE);
}

void WizardEmpfDlg::ReadDBasList()
{
	String aOldDBName( pE_List_DBase->GetSelectEntry() );
	String aOldTableName( pE_List_DBTable->GetSelectEntry() );
	USHORT nMerk = pE_List_DBase->GetSelectEntryPos();
	pE_List_DBase->Clear();

#ifdef REPLACE_OFADBMGR
	Sequence<OUString> aDataNames = SwNewDBMgr::GetExistingDatabaseNames();
	const OUString* pDataNames = aDataNames.getConstArray();
	long nPos = 0, nCount = aDataNames.getLength();
	for(long i = 0; i < nCount; i++)
		pE_List_DBase->InsertEntry( pDataNames[i] );
#else
	String sDBNames = pDBasMgr->GetSbaObject()->GetDatabaseNames();
	sDBNames = SFX_APP()->LocalizeDBName(INI2NATIONAL, sDBNames);
	USHORT nPos = 0, nCount = sDBNames.GetTokenCount();
	while( nCount-- )
		pE_List_DBase->InsertEntry( sDBNames.GetToken( 0, ';', nPos ));
#endif

	pE_List_DBase->SelectEntry( aOldDBName );
	if( !pE_List_DBase->GetSelectEntryCount() )
	{
		if (nMerk != LISTBOX_ENTRY_NOTFOUND)
			pE_List_DBase->SelectEntryPos( nMerk );
		if( !pE_List_DBase->GetSelectEntryCount() )
		{
			String sDBName(pDBasMgr->GetAddressDBName());
			aOldTableName = sDBName.GetToken(1, DB_DELIM);
			sDBName = SFX_APP()->LocalizeDBName(INI2NATIONAL, sDBName.GetToken(0, DB_DELIM));
			pE_List_DBase->SelectEntry(sDBName);
		}
	}
	pDBasMgr->GetTableNames(pE_List_DBTable, SFX_APP()->
		LocalizeDBName(NATIONAL2INI, pE_List_DBase->GetSelectEntry()));
	pE_List_DBTable->SelectEntry( aOldTableName );
	if (!pE_List_DBTable->GetSelectEntryCount())
		pE_List_DBTable->SelectEntryPos(0);

	SelectDBasList( pE_List_DBase->GetSelectEntryPos( 0 ) );
}

void WizardEmpfDlg::ToUI()
{
	if (pEmpf==NULL)
		return;
	String aStr(pEmpf->GetStr());
	if (aStr.Len()!=0)
		pE_MEdt_Adress->SetText(aStr);
	else
		pEmpf->SetStr(pE_MEdt_Adress->GetText());
	pE_List_DBase->SelectEntry(aAktDB.GetToken(0, DB_DELIM));
}

void WizardEmpfDlg::InitUI()
{
	ReadDBasList();
}

void WizardEmpfDlg::AddAktFeld()
{
	String aStr(pE_MEdt_Adress->GetText());
	String aFld(pE_List_DBase->GetSelectEntry());
	aFld += '.';
	aFld += pE_List_DBTable->GetSelectEntry();
	aFld += '.';
	aFld += pE_List_Fields->GetSelectEntry();

	short nPos=pE_MEdt_Adress->GetSelection().Min();
	char c;
	if (aFld.Len()>0)
	{
		aFld.Insert('<',0);
		aFld+='>';
		if (aStr.Len()>0)
		{
			if (nPos>0) { // ein Space davor
				c= aStr.GetChar( nPos-1 );
				if (c!='\n' && c!='\r') aFld.Insert(' ',0);
			}
			if (USHORT(nPos)<aStr.Len())
			{
				c=aStr.GetChar( nPos );
				if (c!='\n' && c!='\r') aFld+=' ';
			}
		}
		aStr.Insert(aFld,nPos);
		pE_MEdt_Adress->SetText(aStr);
		if (pEmpf!=NULL)
			pEmpf->SetStr(aStr,&pWizDlg->aPrevWin);
		nPos+=aFld.Len();
		pE_MEdt_Adress->SetSelection(Selection(nPos));
	}
}

void WizardEmpfDlg::AddCR()
{
	String aStr(pE_MEdt_Adress->GetText());
	short nPos=pE_MEdt_Adress->GetSelection().Min();
	aStr.InsertAscii(NEWLINE,nPos);
	nPos+=String(String::CreateFromAscii(NEWLINE)).Len();
	pE_MEdt_Adress->SetText(aStr);
	if (pEmpf!=NULL) pEmpf->SetStr(aStr,&pWizDlg->aPrevWin);
	pE_MEdt_Adress->SetSelection(Selection(nPos));
}

IMPL_LINK( WizardEmpfDlg, DBasListHdl, ListBox *, pLst )
{
	SelectDBasList(pE_List_DBase->GetSelectEntryPos());
	return 0;
}

IMPL_LINK( WizardEmpfDlg, EmpfModfHdl, MultiLineEdit *, pEdt )
{
	if( pEmpf )
		pEmpf->SetStr( pEdt->GetText(), &pWizDlg->aPrevWin );
	return 0;
}

IMPL_LINK( WizardEmpfDlg, InsrPBtnHdl, PushButton *, EMPTYARG )
{
	AddAktFeld();
	return 0;
}

IMPL_LINK( WizardEmpfDlg, NewLPBtnHdl, PushButton *, pBtn )
{
	AddCR();
	return 0;
}

IMPL_LINK( WizardEmpfDlg, FeldListHdl, ListBox*, pLst )
{
	AddAktFeld();
	return 0;
}

void WizardEmpfDlg::SetEventHandler()
{
	pE_List_DBase ->SetSelectHdl     (LINK(this,WizardEmpfDlg,DBasListHdl));
	pE_List_DBTable->SetSelectHdl    (LINK(this,WizardEmpfDlg,DBasListHdl));
	pE_MEdt_Adress->SetModifyHdl     (LINK(this,WizardEmpfDlg,EmpfModfHdl));
	pE_SBtn_Insert->SetClickHdl      (LINK(this,WizardEmpfDlg,InsrPBtnHdl));
	pE_BBtn_NewLin->SetClickHdl      (LINK(this,WizardEmpfDlg,NewLPBtnHdl));
	pE_List_Fields->SetDoubleClickHdl(LINK(this,WizardEmpfDlg,FeldListHdl));
}



/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizempf.cxx,v 1.1.1.1 2000/09/18 17:14:51 hr Exp $

	  Source Code Control System - Update

	  $Log: wizempf.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:51  hr
	  initial import
	
	  Revision 1.81  2000/09/18 16:06:21  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.80  2000/07/18 12:50:09  os
	  replace ofadbmgr
	
	  Revision 1.79  2000/04/19 11:18:59  os
	  UNICODE

	  Revision 1.78  1999/07/07 13:40:22  MA
	  WizardDialog renamed to SwWizardDialog


	  Rev 1.77   07 Jul 1999 15:40:22   MA
   WizardDialog renamed to SwWizardDialog

	  Rev 1.76   09 Jun 1999 19:33:16   JP
   have to change: no cast from GetpApp to SfxApp/OffApp, SfxShell only subclass of SfxApp

	  Rev 1.75   08 Apr 1999 10:51:14   JP
   Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)

	  Rev 1.74   27 Jul 1998 16:19:24   OM
   #50317# Tabelle analog zur gewaehlten Datenbank umschalten

	  Rev 1.73   06 Jul 1998 13:40:38   MH
   int.comp.error

	  Rev 1.72   24 Nov 1997 10:58:36   MA
   includes

	  Rev 1.71   03 Nov 1997 14:01:36   MA
   precomp entfernt

	  Rev 1.70   02 Sep 1997 09:57:48   OM
   SDB-Headeranpassung

	  Rev 1.69   06 Aug 1997 15:06:18   TRI
   VCL: GetpApp() statt pApp

	  Rev 1.68   19 Mar 1997 14:07:12   OM
   Richtigen DB-Trenner verwenden

	  Rev 1.67   18 Mar 1997 15:23:40   OM
   Spaltennamen mit DB-Namen holen

	  Rev 1.66   04 Dec 1996 13:54:24   OM
   Kein konstanter AdressDBName mehr

	  Rev 1.65   11 Nov 1996 10:38:10   MA
   ResMgr

	  Rev 1.64   24 Oct 1996 13:36:46   JP
   String Umstellung: [] -> GetChar()

	  Rev 1.63   25 Sep 1996 14:12:34   OM
   Neue Datenbanktrenner

	  Rev 1.62   29 Aug 1996 09:05:06   OS
   includes

	  Rev 1.61   28 Aug 1996 14:58:30   OM
   Datenbankumstellung

	  Rev 1.60   17 Jul 1996 13:47:54   OM
   Datenbankumstellung 327

	  Rev 1.59   29 May 1996 12:30:00   OM
   Umstellung auf 320

	  Rev 1.58   28 May 1996 10:11:50   OS
   richtigen Parent fuer den Datenbankdialog setzen - kein GrabFocus notwendig

	  Rev 1.57   20 May 1996 19:18:34   JP
   Bug #27832#: Datenbank-AuswahlDialog - den Button als DialogParent setzen

	  Rev 1.56   30 Apr 1996 09:25:06   OM
   Mehrere Datenbanken pro Dok

	  Rev 1.55   18 Apr 1996 16:31:24   OM
   Datenbankumstellung: Basic-Entkopplung

	  Rev 1.54   11 Apr 1996 12:27:28   OM
   #26838# Mehrfachoeffnung vom Datenbank-Dlg unterbunden

	  Rev 1.53   04 Apr 1996 12:03:20   OM
   patches legalisiert

	  Rev 1.52   19 Mar 1996 12:04:34   OM
   Umstellung Datenbankmanager->ODBC Tabellen

*************************************************************************/

