/*************************************************************************
 *
 *  $RCSfile: wizempf.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WIZEMPF_HXX
#define _WIZEMPF_HXX

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif
#include "wizmulti.hxx"

class SwNewDBMgr; // Neuer Datenbankmanager

class WizardEmpfDlg
{
	SwWizardDialog* pWizDlg;
	WizardText*   pEmpf;
	String aAktDB;
	BOOL bTelfon;
	BOOL bAnrede;
public:
	FixedText*     pE_Text_EmpTit;
	FixedText*     pE_Text_DBase;
	ListBox*       pE_List_DBase;
	ListBox*       pE_List_DBTable;
	PushButton*    pE_PBtn_DBase;
	FixedText*     pE_Text_Adress;
	MultiLineEdit* pE_MEdt_Adress;
	ImageButton*   pE_SBtn_Insert;
	ImageButton*   pE_BBtn_NewLin;
	FixedText*     pE_Text_Fields;
	ListBox*       pE_List_Fields;

	FixedText*     pE_Text_AnrFix;
	Edit*          pE_Edit_AnrFix;
	FixedText*     pE_Text_AnrFld;
	ListBox*       pE_List_AnrFld;

	FixedText*     pE_Text_Telfon;
	ListBox*       pE_List_Telfon;
	FixedText*     pE_Text_Telfax;
	ListBox*       pE_List_Telfax;

	SwNewDBMgr*    pDBasMgr;

public:
	WizardEmpfDlg(SwWizardDialog* pDlgWin, BOOL bTele=FALSE, BOOL bAnrd=FALSE);
	~WizardEmpfDlg();
	void Fill(MultiOne& WinArr);
	void SetPtr(WizardText* pEmp=NULL);
	void SetEventHandler();

	void ToUI();
	void InitUI();
	DECL_LINK( DBasListHdl, ListBox * );
	DECL_LINK( EmpfModfHdl, MultiLineEdit * );
	DECL_LINK( InsrPBtnHdl, PushButton * );
	DECL_LINK( NewLPBtnHdl, PushButton * );
	DECL_LINK( FeldListHdl, ListBox * );

	void AddAktFeld();
	void AddCR();
	void ReadDBasList();
	void FillFeldList( ListBox* pList, BOOL bUnselect = TRUE,
						BOOL bInklKeins = FALSE );
	void SelectDBasList( USHORT Num );

//    BOOL IsAdressenDBF();
//    void ForceDefault();

	USHORT GetDBFieldAnz() { return pE_List_Fields->GetEntryCount(); }
	String GetDBFieldNam(USHORT nNum, BOOL bKlammern=FALSE);
};


#endif  //_WIZEMPF_HXX
