/*************************************************************************
 *
 *  $RCSfile: wizfx.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SVX_ADRITEM_HXX //autogen
#include <svx/adritem.hxx>
#endif



#include "swtypes.hxx"
#include "finder.hxx"
#include "fldbas.hxx"  // TYP_FIXDATEFLD zum Fuellen der DateListbox
#include "wizfx.hxx"
#include "wizpage.hxx"
#include "wizdoku.hxx"
#include "wizini.hxx"
#include "wizard.hrc"
#include "helpid.h"


#define C2S(cChar) UniString::CreateFromAscii(cChar)

#define FRAME_SPACE (5*EINHEIT)  /* vertikaler Abstand zwischen den Rahmen */

////////////////////////////////////////////////////////////////////////////////
//
// @@@@@ @@ @@ @@@@@ @@  @@ @@@@ @@  @@  @@@@  @@  @@ @@@@@  @@   @@@@@ @@@@@
// @@    @@ @@ @@    @@@ @@  @@  @@  @@ @@  @@ @@@ @@ @@  @@ @@   @@    @@  @@
// @@    @@ @@ @@    @@@@@@  @@  @@  @@ @@  @@ @@@@@@ @@  @@ @@   @@    @@  @@
// @@@@  @@@@@ @@@@  @@@@@@  @@  @@@@@@ @@@@@@ @@@@@@ @@  @@ @@   @@@@  @@@@@
// @@     @@@  @@    @@ @@@  @@  @@  @@ @@  @@ @@ @@@ @@  @@ @@   @@    @@  @@
// @@     @@@  @@    @@  @@  @@  @@  @@ @@  @@ @@  @@ @@  @@ @@   @@    @@  @@
// @@@@@   @   @@@@@ @@  @@  @@  @@  @@ @@  @@ @@  @@ @@@@@  @@@@ @@@@@ @@  @@
//
////////////////////////////////////////////////////////////////////////////////

IMPL_LINK( FaxDialog, TitelModifyHdl, Edit *, pEdt )
{
	aPage1.aTitl.SetStr(pEdt->GetText(),&aPrevWin);
	if (aPage1.aTitl.GetStr().Len()!=0) {
		aPage1.aTitl.Show(&aPrevWin);
	} else {
		aPage1.aTitl.Hide(&aPrevWin);
	}
	ArrangeObjects();
	return 0;
}

IMPL_LINK( FaxDialog, FormatSelectHdl, ListBox *, pLst )
{
	switch (pLst->GetSelectEntryPos()) {
		case 0: aPage1.SetDinA4(&aPrevWin); break;
		case 1: aPage1.SetDinA5Q(&aPrevWin); break;
	}
	aPage1.aFusz.KorregPgRand();
	ArrangeObjects();
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
// Absn
////////////////////////////////////////////////////////////////////////////////

IMPL_LINK_INLINE_START( FaxDialog, AbsnBBtnHdl, Button *, pBtn )
{
	if (pBtn==&a3_BBtn_AbsnOL) aPage1.aAbsn.SetAlign(ALIGN_LiOb,&aPrevWin);
	if (pBtn==&a3_BBtn_AbsnOR) aPage1.aAbsn.SetAlign(ALIGN_ReOb,&aPrevWin);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, AbsnBBtnHdl, Button *, pBtn )

IMPL_LINK_INLINE_START( FaxDialog, AbsnMFldHdl, MetricField *, pEdt )
{
	USHORT nVal=USHORT(pEdt->GetValue(FUNIT_CM));
	if (pEdt==&a3_MFld_AbsnWd) aPage1.aAbsn.SetWdt(nVal,&aPrevWin);
	if (pEdt==&a3_MFld_AbsnHg) aPage1.aAbsn.SetHgt(nVal,&aPrevWin);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, AbsnMFldHdl, MetricField *, pEdt )

IMPL_LINK_INLINE_START( FaxDialog, ATeleModifyHdl, Edit *, pEdt )
{
	SetAbsnLineAnz();
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, ATeleModifyHdl, Edit *, pEdt )

IMPL_LINK_INLINE_START( FaxDialog, EditModifyHdl, Edit *, pEdt )
{
	String aStr(pEdt->GetText());
	if (pEdt==&a3_MEdt_AbsInp) aPage1.aAbsn.SetStr(aStr,&aPrevWin);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, EditModifyHdl, Edit *, pEdt )

////////////////////////////////////////////////////////////////////////////////
// Elem
////////////////////////////////////////////////////////////////////////////////

IMPL_LINK_INLINE_START( FaxDialog, ElemDatmCheckHdl, Button *, pBtn )
{
	SetDatmLineAnz();
	FillDocInfoList();
	SetElemDisable();
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, ElemDatmCheckHdl, Button *, pBtn )

IMPL_LINK_INLINE_START( FaxDialog, ElemBetrCheckHdl, Button *, pBtn )
{
	SetBetrLineAnz();
	FillDocInfoList();
	SetElemDisable();
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, ElemBetrCheckHdl, Button *, pBtn )

IMPL_LINK( FaxDialog, ElemMiscCheckHdl, Button *, pBtn )
{
	if (pBtn==&a5_CBox_Elem1) aPage1.aElem.Show(0,&aPrevWin,a5_CBox_Elem1.IsChecked());
	if (pBtn==&a5_CBox_Elem2) aPage1.aElem.Show(1,&aPrevWin,a5_CBox_Elem2.IsChecked());
	if (pBtn==&a5_CBox_Elem3) aPage1.aElem.Show(2,&aPrevWin,a5_CBox_Elem3.IsChecked());
	if (pBtn==&a5_CBox_Elem4) aPage1.aElem.Show(3,&aPrevWin,a5_CBox_Elem4.IsChecked());
	FillDocInfoList();
	SetElemDisable();
	ArrangeObjects();
	return 0;
}

IMPL_LINK( FaxDialog, ElemModifyHdl, Edit *, pEdt )
{
	String aStr(pEdt->GetText());
	if (pEdt==&a5_Edit_Elem1)  aPage1.aElem.aBezeich[0].SetStr(aStr,&aPrevWin);
	if (pEdt==&a5_Edit_Elem2)  aPage1.aElem.aBezeich[1].SetStr(aStr,&aPrevWin);
	if (pEdt==&a5_Edit_Elem3)  aPage1.aElem.aBezeich[2].SetStr(aStr,&aPrevWin);
	if (pEdt==&a5_Edit_Elem4)  aPage1.aElem.aBezeich[3].SetStr(aStr,&aPrevWin);
	if (pEdt==&a5_Edit_Betref) aPage1.aBetr.SetStr(aStr,&aPrevWin);
	FillDocInfoList();
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
// Logo - Abgefangene Handler von WizLogoDlg
////////////////////////////////////////////////////////////////////////////////

IMPL_LINK_INLINE_START( FaxDialog, LogoMFldHdl, MetricField *, pEdt )
{
	aLogo.MFldHdl(pEdt);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, LogoMFldHdl, MetricField *, pEdt )

IMPL_LINK_INLINE_START( FaxDialog, LogoRBtnHdl, RadioButton *, pBtn )
{
	aLogo.RBtnHdl(pBtn);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, LogoRBtnHdl, RadioButton *, pBtn )

////////////////////////////////////////////////////////////////////////////////
// Marg - Abgefangene Handler von WizFuszDlg
////////////////////////////////////////////////////////////////////////////////

IMPL_LINK_INLINE_START( FaxDialog, RandMetrcModifyHdl, MetricField *, pEdt )
{
	aMarg.MFldHdl(pEdt); // erstmal das Orginal rufen
	aPage1.aFusz.KorregWdt(&aPrevWin);
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, RandMetrcModifyHdl, MetricField *, pEdt )


////////////////////////////////////////////////////////////////////////////////
// Empf - Abgefangene Handler von WizEmpfDlg
////////////////////////////////////////////////////////////////////////////////

IMPL_LINK_INLINE_START( FaxDialog, EmpfDBasListHdl, ListBox *, pLst )
{
	aEmpf.DBasListHdl(pLst);
	FillDocInfoList();
	SetEmpfLineAnz();
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, EmpfDBasListHdl, ListBox *, pLst )

IMPL_LINK_INLINE_START( FaxDialog, EmpfModifyHdl, MultiLineEdit *, pEdt )
{
	aEmpf.EmpfModfHdl(pEdt);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, EmpfModifyHdl, MultiLineEdit *, pEdt )
IMPL_LINK( FaxDialog, UpdateAdressHdl, PushButton *, pButton)
{
	GetFromUsr();
	a3_MEdt_AbsInp.SetText(aPage1.aAbsn.GetStr());
	return 0;
}


IMPL_LINK_INLINE_START( FaxDialog, EmpfInsrPBtnHdl, PushButton *, pBtn )
{
	aEmpf.InsrPBtnHdl(pBtn);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, EmpfInsrPBtnHdl, PushButton *, pBtn )

IMPL_LINK_INLINE_START( FaxDialog, EmpfNewLPBtnHdl, PushButton *, pBtn )
{
	aEmpf.NewLPBtnHdl(pBtn);
	SetEmpfLineAnz();
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, EmpfNewLPBtnHdl, PushButton *, pBtn )

IMPL_LINK_INLINE_START( FaxDialog, EmpfFeldListHdl, ListBox *, pLst )
{
	aEmpf.FeldListHdl(pLst);
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, EmpfFeldListHdl, ListBox *, pLst )

IMPL_LINK_INLINE_START( FaxDialog, ETeleSelectHdl, ListBox *, pLst )
{
	SetEmpfLineAnz();
	ArrangeObjects();
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, ETeleSelectHdl, ListBox *, pLst )

IMPL_LINK_INLINE_START( FaxDialog, StyleClickHdl, RadioButton *, pBtn )
{
	BYTE nStyle=0;
	if (a1_RBtn_Stil1.IsChecked()) nStyle=0;
	else if (a1_RBtn_Stil2.IsChecked()) nStyle=1;
	else if (a1_RBtn_Stil3.IsChecked()) nStyle=2;
	SetStyle(nStyle);
	return 0;
}
IMPL_LINK_INLINE_END( FaxDialog, StyleClickHdl, RadioButton *, pBtn )
////////////////////////////////////////////////////////////////////////////////
// FaxDialog
////////////////////////////////////////////////////////////////////////////////

FaxDialog::FaxDialog(Window* pParent)
	: WizardFaxDialog(pParent)
{
	Init();
	aPrevWin.SetPage(&aPage1);
	aLogo.SetPtr(&aPage1.aLogo);
	aEmpf.SetPtr(&aPage1.aEmpf);
	aMarg.SetPtr(&aPage1);
	aFusz.SetPtr(&aPage1.aFusz);
	pDoku->SetPtr(pOkayBtn);

	InitElemUI();

	GetFromDef();  // Harte Defaults setzen
	GetFromUsr();  // Defaults von Benutzereinstellungen holen
	GetFromIni();  // Defaults vom Inifile holen

	SetEventHandler();

	aLogo.ToUI();
	aEmpf.ToUI();
	aMarg.ToUI();
	aFusz.ToUI();
	pDoku->ToUI();
	FormToUI();
	AbsnToUI();
	TitlToUI();
	ElemToUI();
	SetElemDisable();
	FillDocInfoList();

	SetAbsnLineAnz();
	SetEmpfLineAnz();
	SetDatmLineAnz();
	SetBetrLineAnz();
	ArrangeObjects();

	Inc();
}

////////////////////////////////////////////////////////////////////////////////
//
//  @@@@  @@@@@ @@@@   @@@@@ @@@@   @@@@  @@   @@
// @@  @@ @@     @@    @@    @@ @@ @@  @@ @@@ @@@
// @@     @@     @@    @@    @@ @@ @@  @@ @@@@@@@
// @@ @@@ @@@@   @@    @@@@  @@@@  @@  @@ @@ @ @@
// @@  @@ @@     @@    @@    @@ @@ @@  @@ @@   @@
// @@  @@ @@     @@    @@    @@ @@ @@  @@ @@   @@  @@ @@ @@
//  @@@@@ @@@@@  @@    @@    @@ @@  @@@@  @@   @@  @@ @@ @@
//
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::GetFromDef()
{
	//a1_List_Format.SelectEntryPos(0);
	aPage1.aTitl.SetStr(a1_CLst_FaxTit.GetText());
	a1_RBtn_Stil1.Check();
	// a5_List_Datum.SelectEntryPos(0);  // Datum Standard kurz
	// a5_List_Uhrzt.SelectEntryPos(0);  // Uhrzeit
}

void FaxDialog::GetFromUsr()
{
	String aLF(C2S(NEWLINE));
	String sStr, sRow, sTmp, sToken, sPrevToken;
	String sAddrDef(SW_RES(STR_Fax_Usr_Address));

	SvxAddressItem aAddress( pPathFinder->GetAddress() );
	String sEmail(aAddress.GetToken(ADDRESS_EMAIL));

	USHORT nCnt = sAddrDef.GetTokenCount();

	for (USHORT i = 0; i < nCnt; i++)
	{
		sPrevToken = sToken;
		sToken = sAddrDef.GetToken(i);
		int nPos = -1;

		if (sToken.EqualsAscii( "COMPANY"))
			nPos = ADDRESS_COMPANY;
		else if (sToken.EqualsAscii( "PREFIX"))
			nPos = ADDRESS_TITLE;
		else if (sToken.EqualsAscii( "FIRSTNAME"))
		{
			sRow += aAddress.GetFirstName();
			continue;
		}
		else if (sToken.EqualsAscii( "LASTNAME"))
		{
			sRow += aAddress.GetName();
			continue;
		}
		else if (sToken.EqualsAscii( "TITLE"))
			nPos = ADDRESS_POSITION;
		else if (sToken.EqualsAscii( "ADDRESS"))
			nPos = ADDRESS_STREET;
		else if (sToken.EqualsAscii( "COUNTRY"))
			nPos = ADDRESS_COUNTRY;
		else if (sToken.EqualsAscii( "POSTALCODE"))
			nPos = ADDRESS_PLZ;
		else if (sToken.EqualsAscii( "CITY"))
			nPos = ADDRESS_CITY;
		else if (sToken.EqualsAscii( "EMAILPREFIX"))
		{
			if(sEmail.Len())
				sRow += SW_RESSTR(STR_Usr_ElektrMail);
			continue;
		}
		else if (sToken.EqualsAscii( "EMAIL"))
		{
			sRow += sEmail;
			continue;
		}
		else if (sToken.EqualsAscii( "STATEPROV"))
			nPos = ADDRESS_STATE;
		else if (sToken.EqualsAscii( "FAX"))
			nPos = ADDRESS_FAX;
		else if (sToken.EqualsAscii( "PHONEHOME"))
			nPos = ADDRESS_TEL_PRIVATE;
		else if (sToken.EqualsAscii( "PHONEWORK"))
			nPos = ADDRESS_TEL_COMPANY;
		else if (sToken.EqualsAscii( "CR"))
		{
			if (sRow.Len())
			{
				(sStr += sRow) += aLF;
				sRow.Erase();
			}
			sToken = aEmptyStr;
			continue;
		}

		if (nPos >= 0)
		{
			sToken = aAddress.GetToken(nPos);
			sRow += sToken;
			continue;
		}

		if (sPrevToken.Len())	// Trennzeichen nur einfuegen, wenn vorheriges Token existierte
			sRow += sToken;
	}
	if (sRow.Len())
		sStr += sRow;

	aPage1.aAbsn.SetStr( sStr );

	// Keine Privatnummer, wenn Dienst vorhanden
	if( !( sTmp = aAddress.GetToken( ADDRESS_TEL_COMPANY ) ).Len() )
		sTmp = aAddress.GetToken( ADDRESS_TEL_PRIVATE );
	a3_Edit_Telfon.SetText( sTmp );

	// FAX-Nummer setzen
	a3_Edit_Telfax.SetText( aAddress.GetToken( ADDRESS_FAX ) );

#if 0
	String aLF(NEWLINE);
	String aStr, sTmp;

	SvxAddressItem aAddress( pPathFinder->GetAddress() );

	// Baue den Namen zusammen
	String aName( aAddress.GetToken( ADDRESS_TITLE ) );
	if( (sTmp = aAddress.GetFirstName()).Len() )
	{
		if( aName.Len() )
			aName += ' ';
		aName += sTmp;
	}
	if( (sTmp = aAddress.GetName()).Len() )
	{
		if( aName.Len() )
			aName += ' ';
		aName += sTmp;
	}

	if( ( sTmp = aAddress.GetToken( ADDRESS_COMPANY ) ).Len() )
		( aStr += sTmp ) += aLF;

	if( aName.Len() )
		( aStr += aName ) += aLF;

	// Position vorhanden ?
	if( ( sTmp = aAddress.GetToken( ADDRESS_POSITION ) ).Len() )
		( aStr += sTmp ) += aLF;

	// Strasse vorhanden ?
	if( ( sTmp = aAddress.GetToken( ADDRESS_STREET ) ).Len() )
		( aStr += sTmp ) += aLF;

	// Ortsbezeichnung vorhanden ?
	if( ( sTmp = aAddress.GetToken( ADDRESS_COUNTRY ) ).Len() )
		sTmp += ' ';
	if( ( sTmp += aAddress.GetToken( ADDRESS_PLZ ) ).Len() )
		sTmp += ' ';
	if( ( sTmp += aAddress.GetToken( ADDRESS_CITY ) ).Len() )
		( aStr += sTmp ) += aLF;

	// Email-Nummer vorhanden ?
	if( ( sTmp = aAddress.GetToken( ADDRESS_EMAIL ) ).Len() )
		(( aStr += SW_RESSTR( STR_Usr_ElektrMail ) ) += sTmp ) += aLF;

	if( aStr.Len() )
		aStr.Erase( aStr.Len() - aLF.Len() ); // das letzte LF weg
	aPage1.aAbsn.SetStr( aStr );

	// Keine Privatnummer, wenn Dienst vorhanden
	if( !( sTmp = aAddress.GetToken( ADDRESS_TEL_COMPANY ) ).Len() )
		sTmp = aAddress.GetToken( ADDRESS_TEL_PRIVATE );
	a3_Edit_Telfon.SetText( sTmp );

	// FAX-Nummer setzen
	a3_Edit_Telfax.SetText( aAddress.GetToken( ADDRESS_FAX ) );
#endif
#if 0
	// JP 31.08.95: alter Code, nur zum Fehler finden/beheben

//  BOOL bTitl=(pPathFinder->GetTitle()     .Len()>0);
	BOOL bVNam=(pPathFinder->GetFirstName() .Len()>0);
	BOOL bFNam=(pPathFinder->GetFamilyName().Len()>0);
	BOOL bComp=(pPathFinder->GetCompany()   .Len()>0);
	BOOL bPosi=(pPathFinder->GetPosition()  .Len()>0);
	BOOL bStra=(pPathFinder->GetStreet()    .Len()>0);
	BOOL bCity=(pPathFinder->GetCity()      .Len()>0);
//  BOOL bTelP=(pPathFinder->GetTelPrivate().Len()>0);
	BOOL bTelD=(pPathFinder->GetTelCompany().Len()>0);
//  BOOL bFaxn=(pPathFinder->GetFax()       .Len()>0);
	BOOL bEMai=(pPathFinder->GetEmail()     .Len()>0);

	String aName(pPathFinder->GetTitle());
	if (bVNam) { if (aName.Len()>0) aName+=' '; aName+=pPathFinder->GetFirstName();  }
	if (bFNam) { if (aName.Len()>0) aName+=' '; aName+=pPathFinder->GetFamilyName(); }
	BOOL bName=(aName.Len()>0);
	String aComp(pPathFinder->GetCompany());
	String aPosi(pPathFinder->GetPosition());
	String aStra(pPathFinder->GetStreet());
	String aCity(pPathFinder->GetCity());
	for (USHORT i=0; i<aCity.Len(); i++) if (aCity[i]=='|') aCity[i]=' ';
	String aTelP(SW_RES(STR_Usr_TelePrivat)); aTelP+=pPathFinder->GetTelPrivate();
	String aTelD(SW_RES(STR_Usr_TeleDienst)); aTelD+=pPathFinder->GetTelCompany();
	String aFaxn(SW_RES(STR_Usr_Faxnummer )); aFaxn+=pPathFinder->GetFax();
	String aEMai(SW_RES(STR_Usr_ElektrMail)); aEMai+=pPathFinder->GetEmail();

	if (bComp) { aStr+=aComp; aStr+=aLF; }
	if (bName) { aStr+=aName; aStr+=aLF; }
	if (bPosi) { aStr+=aPosi; aStr+=aLF; }
	if (bStra) { aStr+=aStra; aStr+=aLF; }
	if (bCity) { aStr+=aCity; aStr+=aLF; }
	//if (bTelP) { aStr+=aTelP; aStr+=aLF; }
	//if (bTelD) { aStr+=aTelD; aStr+=aLF; }
	//if (bFaxn) { aStr+=aFaxn; aStr+=aLF; }
	if (bEMai) { aStr+=aEMai; aStr+=aLF; }
	if (aStr.Len()!=0) aStr.Erase(aStr.Len()-aLF.Len()); // das letzte LF weg
	aPage1.aAbsn.SetStr(aStr);
	if (bTelD) a3_Edit_Telfon.SetText(pPathFinder->GetTelCompany());
	else a3_Edit_Telfon.SetText(pPathFinder->GetTelPrivate());
	a3_Edit_Telfax.SetText(pPathFinder->GetFax());
#endif
}

void FaxDialog::GetFromIni()
{
	long   nMetr,nMetr1,nMetr2;
	String aStr;
	BOOL   bFlag;
	BOOL   bOk1,bOk2;
	WizardIni aIni(C2S("FaxWizard"));
	aIni.ReadStil(a1_RBtn_Stil1,a1_RBtn_Stil2,a1_RBtn_Stil3);
	StyleClickHdl(NULL);
	if (aIni.ReadText(C2S("Titl"),aStr)) aPage1.aTitl.SetStr(aStr);
	bOk1=aIni.ReadMetr(C2S("PagWdt"),nMetr1);
	bOk2=aIni.ReadMetr(C2S("PagHgt"),nMetr2);
	if (bOk1 && bOk2) { aPage1.SetWdt(USHORT(nMetr1)); aPage1.SetHgt(USHORT(nMetr2)); }

	aIni.ReadLogo(C2S("Logo"),aPage1.aLogo);

	aIni.ReadFram(C2S("Absn"),aPage1.aAbsn);
	aIni.ReadText(C2S("AbsnFax"),a3_Edit_Telfax);
	aIni.ReadText(C2S("AbsnTel"),a3_Edit_Telfon);

	if (aIni.ReadText(C2S("EmpfDBas"),aStr)) aEmpf.SelectDBasList(aEmpf.pE_List_DBase->GetEntryPos(aStr));
	aIni.ReadList(C2S("EmpfFax"),*(aEmpf.pE_List_Telfax));
	aIni.ReadList(C2S("EmpfTel"),*(aEmpf.pE_List_Telfon));
	aIni.ReadFram(C2S("Empf"),aPage1.aEmpf);

	aIni.ReadList(C2S("Datm"),a5_CBox_Datum,a5_List_Datum,TRUE);
	aIni.ReadList(C2S("Uhrz"),a5_CBox_Uhrzt,a5_List_Uhrzt,TRUE);
	aIni.ReadText(C2S("Betr"),a5_CBox_Betref,a5_Edit_Betref);  // Im BetreffFrame ist auch Kopie an mit drin
	aIni.ReadFlag(C2S("Kopi"),a5_CBox_KopiAn);
	if (aIni.ReadText(C2S("Ele1"),bFlag,a5_Edit_Elem1)) aPage1.aElem.Show(0,NULL,bFlag);
	if (aIni.ReadText(C2S("Ele2"),bFlag,a5_Edit_Elem2)) aPage1.aElem.Show(1,NULL,bFlag);
	if (aIni.ReadText(C2S("Ele3"),bFlag,a5_Edit_Elem3)) aPage1.aElem.Show(2,NULL,bFlag);
	if (aIni.ReadText(C2S("Ele4"),bFlag,a5_Edit_Elem4)) aPage1.aElem.Show(3,NULL,bFlag);

	if (aIni.ReadFlag(C2S("Fus1Vis"),bFlag)) aPage1.aFusz.Show(NULL,bFlag);
	if (aIni.ReadFlag(C2S("Fus1Trl"),bFlag)) aPage1.aFusz.SetTrennlinie(bFlag);
	if (aIni.ReadText(C2S("Fus1Txt"),aStr )) aPage1.aFusz.SetStr(aStr);

	if (aIni.ReadMetr(C2S("RandL"),nMetr)) aPage1.SetRandL(USHORT(nMetr));
	if (aIni.ReadMetr(C2S("RandR"),nMetr)) aPage1.SetRandR(USHORT(nMetr));

	FillDocInfoList();
	aIni.ReadDoku(*pDoku);
}

void FaxDialog::WriteToIni()
{
	WizardIni aIni(C2S("FaxWizard"));
	aIni.WritStil(a1_RBtn_Stil1,a1_RBtn_Stil2,a1_RBtn_Stil3);
	aIni.WritText(C2S("Titl"),aPage1.aTitl.GetStr());
	aIni.WritMetr(C2S("PagWdt"),aPage1.GetWdt());
	aIni.WritMetr(C2S("PagHgt"),aPage1.GetHgt());
	aIni.WritLogo(C2S("Logo"),aPage1.aLogo);

	aIni.WritFram(C2S("Absn"),aPage1.aAbsn);
	aIni.WritText(C2S("AbsnFax"),a3_Edit_Telfax);
	aIni.WritText(C2S("AbsnTel"),a3_Edit_Telfon);

	aIni.WritText(C2S("EmpfDBas"),aEmpf.pE_List_DBase->GetSelectEntry());
	aIni.WritList(C2S("EmpfFax"),*(aEmpf.pE_List_Telfax));
	aIni.WritList(C2S("EmpfTel"),*(aEmpf.pE_List_Telfon));
	aIni.WritFram(C2S("Empf"),aPage1.aEmpf);

	aIni.WritList(C2S("Datm"),a5_CBox_Datum,a5_List_Datum,TRUE);
	aIni.WritList(C2S("Uhrz"),a5_CBox_Uhrzt,a5_List_Uhrzt,TRUE);
	aIni.WritText(C2S("Betr"),a5_CBox_Betref,a5_Edit_Betref);   // Im BetreffFrame ist auch Kopie an mit drin
	aIni.WritFlag(C2S("Kopi"),a5_CBox_KopiAn);
	aIni.WritText(C2S("Ele1"),aPage1.aElem.IsVisible(0),a5_Edit_Elem1);
	aIni.WritText(C2S("Ele2"),aPage1.aElem.IsVisible(1),a5_Edit_Elem2);
	aIni.WritText(C2S("Ele3"),aPage1.aElem.IsVisible(2),a5_Edit_Elem3);
	aIni.WritText(C2S("Ele4"),aPage1.aElem.IsVisible(3),a5_Edit_Elem4);

	aIni.WritFlag(C2S("Fus1Vis"),aPage1.aFusz.IsVisible());
	aIni.WritFlag(C2S("Fus1Trl"),aPage1.aFusz.IsTrennlinie());
	aIni.WritText(C2S("Fus1Txt"),aPage1.aFusz.GetStr());

	aIni.WritMetr(C2S("RandL"),aPage1.RandL);
	aIni.WritMetr(C2S("RandR"),aPage1.RandR);

	aIni.WritDoku(*pDoku);
}

////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::ArrangeObjects()
{
	USHORT yPos=10*EINHEIT; // Defaultrand oben = 10mm
	USHORT nHgt;
	if (aPage1.aLogo.IsVisible()) {
		yPos=USHORT(aPage1.aLogo.GetPosY())+aPage1.aLogo.GetHgt();
		yPos+=FRAME_SPACE;  // Abstand zwischen Logo und Titel
	}

	nHgt=0;
	if (aPage1.aTitl.IsVisible()) {
		aPage1.aTitl.SetVer(yPos,&aPrevWin);
		nHgt=Max(nHgt,aPage1.aTitl.GetHgt());
	}
	if (aPage1.aDatm.IsVisible()) {
		aPage1.aDatm.SetVer(yPos,&aPrevWin);
		nHgt=Max(nHgt,aPage1.aDatm.GetHgt());
	}
	if (nHgt>0) yPos+=nHgt+FRAME_SPACE; // Abstand Titel und Empfaenger

	BOOL bUntern=aPage1.aAbsn.IsLks(); // Absender Links? -> Anordnung untereinander
	nHgt=0;
	if (aPage1.aAbsn.IsVisible()) {
		aPage1.aAbsn.SetVer(yPos,&aPrevWin);
		nHgt=Max(nHgt,aPage1.aAbsn.GetHgt());
		if (bUntern) {
			yPos+=nHgt+FRAME_SPACE; // Abstand Absender und Empfaenger
			nHgt=0;
		}
	}
	if (aPage1.aEmpf.IsVisible()) {
		aPage1.aEmpf.SetVer(yPos,&aPrevWin);
		nHgt=Max(nHgt,aPage1.aEmpf.GetHgt());
	}
	if (nHgt>0) yPos+=nHgt+FRAME_SPACE; // Abstand Empfaenger und Betreff

	if (aPage1.aBetr.IsVisible()) {
		aPage1.aBetr.SetPosY(yPos,&aPrevWin);
		nHgt=aPage1.aBetr.GetHgt();
		if (nHgt>0) yPos+=nHgt+FRAME_SPACE; // Abstand Betreff und Elemente
	}

	if (aPage1.aElem.IsAnyVisible()) {
		aPage1.aElem.SetPosY(yPos,&aPrevWin);
		nHgt=aPage1.aElem.GetHgt();
		if (nHgt>0) yPos+=nHgt+FRAME_SPACE; // Abstand Elemente und Bodytext
	}
	aPage1.SetRandO(yPos,&aPrevWin);
}

void FaxDialog::SetAbsnLineAnz()
{
	USHORT nDazu=0;
	if (a3_Edit_Telfon.GetText().Len()!=0) nDazu++;
	if (a3_Edit_Telfax.GetText().Len()!=0) nDazu++;
	aPage1.aAbsn.SetLnDazu(nDazu,&aPrevWin);
}

void FaxDialog::SetEmpfLineAnz()
{
	USHORT nDazu=0;
	if (aEmpf.pE_List_Telfon->GetSelectEntryPos()!=0) nDazu++;
	if (aEmpf.pE_List_Telfax->GetSelectEntryPos()!=0) nDazu++;
	aPage1.aEmpf.SetLnDazu(nDazu,&aPrevWin);
}

void FaxDialog::SetDatmLineAnz()
{
	USHORT LnAnz=1;  // Seitenanzahl ist immer da
	if (a5_CBox_Uhrzt.IsChecked()) LnAnz++;
	if (a5_CBox_Datum.IsChecked()) LnAnz++;
	aPage1.aDatm.SetLnDazu(USHORT(LnAnz-1),&aPrevWin); // Eine Zeile ist immer mind. da
}

void FaxDialog::SetBetrLineAnz()
{
	USHORT LnAnz=0;
	if (a5_CBox_Betref.IsChecked()) LnAnz++;
	if (a5_CBox_KopiAn.IsChecked()) LnAnz++;
	if (LnAnz!=0) {
		aPage1.aBetr.SetLnDazu(USHORT(LnAnz-1),&aPrevWin);
		aPage1.aBetr.Show(&aPrevWin);
	} else {
		aPage1.aBetr.Hide(&aPrevWin);
	}
}

////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::FillDocInfoList()
{
	pDoku->MerkDocInfListSel();
	USHORT nAnz=aEmpf.GetDBFieldAnz();
	pDoku->SetDBFieldAnz(nAnz);
	USHORT i,j;
	String aStr;
	for (i=0; i<nAnz; i++) {
		aStr=aEmpf.GetDBFieldNam(i);
		pDoku->SetDBFieldNam(i,aStr);
	}
	nAnz=0;
	for (i=0; i<5; i++)
		if (GetDocInfStrOk(i)) nAnz++;
	pDoku->SetTxFieldAnz(nAnz);
	j=0;
	for (i=0; i<5; i++) {
		if (GetDocInfStrOk(i))  {
			aStr=GetDocInfStr(i);
			pDoku->SetTxFieldNam(j,aStr);
			j++;
		}
	}
	pDoku->RestDocInfListSel();
}

String FaxDialog::GetDocInfStr(USHORT nNum)
{
	Edit* pEd = 0;
	USHORT nRId;
	switch( nNum )
	{
	case 0: pEd = &a5_Edit_Elem1;	nRId = STR_Brf_DocInEl1; break;
	case 1: pEd = &a5_Edit_Elem2;	nRId = STR_Brf_DocInEl2; break;
	case 2: pEd = &a5_Edit_Elem3;	nRId = STR_Brf_DocInEl3; break;
	case 3: pEd = &a5_Edit_Elem4;	nRId = STR_Brf_DocInEl4; break;
	case 4: pEd = &a5_Edit_Betref;	nRId = STR_Brf_DocInBtr; break;
	}

	String aStr;
	if( pEd )
	{
		aStr = pEd->GetText();
		if( !aStr.Len() || !aStr.EraseTrailingChars().Len() )
			aStr = SW_RESSTR( nRId );
	}
	return aStr;
}

BOOL FaxDialog::GetDocInfStrOk(USHORT nNum)
{
	BOOL bVisi=FALSE;
//  BOOL bEmpt;
	if (nNum<4) bVisi=aPage1.aElem.IsVisible(nNum);
	if (nNum==4) bVisi=a5_CBox_Betref.IsChecked(); // aPage1.aBetr.IsVisible();
//  bEmpt=(GetDocInfStr(nNum).Len()==0);
	return bVisi /*&& !bEmpt*/;
}

BOOL FaxDialog::GetDocInfoGoDown(USHORT nNum)
{   // Achtung: nNum ist Index auf Doku.List_Info...
	BOOL bRet=FALSE;
	if (pDoku->IsDocInfoTxFeld(nNum)) {
		bRet=TRUE;
		if (GetDocInfStrOk(4)) {
			if (nNum==pDoku->GetTxFieldOfs()+pDoku->GetTxFieldAnz()-1) { // Betreff ist das letzte der Elemente
				bRet=FALSE; // nur bei Betreff kein GoDown
			}
		}
	}
	return bRet;
}

////////////////////////////////////////////////////////////////////////////////
//
// @@  @@ @@     @@@@@ @@  @@ @@@@@ @@    @@    @@  @@ @@  @@  @@@@
// @@  @@ @@     @@    @@  @@ @@    @@    @@    @@  @@ @@@ @@ @@  @@
// @@  @@ @@     @@    @@  @@ @@    @@    @@    @@  @@ @@@@@@ @@
// @@  @@ @@ @@@ @@@@  @@  @@ @@@@  @@    @@    @@  @@ @@@@@@ @@ @@@
// @@  @@ @@     @@    @@  @@ @@    @@    @@    @@  @@ @@ @@@ @@  @@
// @@  @@ @@     @@    @@  @@ @@    @@    @@    @@  @@ @@  @@ @@  @@
//  @@@@  @@     @@     @@@@  @@@@@ @@@@@ @@@@@  @@@@  @@  @@  @@@@@
//
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::InitElemUI()
{
	// Datumslistbox fuellen
	FillFldListBox( a5_List_Datum, TYP_FIXDATEFLD );
	// Uhrzeitlistbox fuellen
	FillFldListBox( a5_List_Uhrzt, TYP_FIXTIMEFLD );
}

void FaxDialog::FormToUI()
{
	if (aPage1.IsDinA4()) a1_List_Format.SelectEntryPos(0);
	else if (aPage1.IsDinA5Q()) a1_List_Format.SelectEntryPos(1);
	else a1_List_Format.SetNoSelection();
}

void FaxDialog::AbsnToUI()
{
	a3_MFld_AbsnWd.SetValue(aPage1.aAbsn.GetWdt(), FUNIT_CM);
	a3_MFld_AbsnHg.SetValue(aPage1.aAbsn.GetHgt(), FUNIT_CM);
	a3_MEdt_AbsInp.SetText(aPage1.aAbsn.GetStr());
}

void FaxDialog::TitlToUI()
{
	a1_CLst_FaxTit.SetText(aPage1.aTitl.GetStr());
}

void FaxDialog::ElemToUI()
{
	a5_CBox_Elem1.Check(aPage1.aElem.IsVisible(0));
	a5_CBox_Elem2.Check(aPage1.aElem.IsVisible(1));
	a5_CBox_Elem3.Check(aPage1.aElem.IsVisible(2));
	a5_CBox_Elem4.Check(aPage1.aElem.IsVisible(3));
}

////////////////////////////////////////////////////////////////////////////////
// Disable
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::SetElemDisable()
{
	a5_Edit_Elem1 .Enable(a5_CBox_Elem1 .IsChecked());
	a5_Edit_Elem2 .Enable(a5_CBox_Elem2 .IsChecked());
	a5_Edit_Elem3 .Enable(a5_CBox_Elem3 .IsChecked());
	a5_Edit_Elem4 .Enable(a5_CBox_Elem4 .IsChecked());
	a5_List_Datum .Enable(a5_CBox_Datum .IsChecked());
	a5_List_Uhrzt .Enable(a5_CBox_Uhrzt .IsChecked());
	a5_Edit_Betref.Enable(a5_CBox_Betref.IsChecked());
}


////////////////////////////////////////////////////////////////////////////////
//  Set Style                                                                 //
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::SetStyle(BYTE nStyle)
{
	aPage1.aLogo.SetFontStyle(nStyle,&aPrevWin);
	aPage1.aTitl.SetFontStyle(nStyle,&aPrevWin);
}

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

void FaxDialog::SetEventHandler()
{
	Link aLk = LINK(this,FaxDialog,StyleClickHdl);
	{
		a1_RBtn_Stil1.SetClickHdl( aLk );
		a1_RBtn_Stil2.SetClickHdl( aLk );
		a1_RBtn_Stil3.SetClickHdl( aLk );

		aLk = LINK(this,FaxDialog,LogoMFldHdl);
		aLogo.pL_MFld_LogoWd->SetModifyHdl( aLk );
		aLogo.pL_MFld_LogoHg->SetModifyHdl( aLk );
		aLogo.pL_MFld_LogoHo->SetModifyHdl( aLk );
		aLogo.pL_MFld_LogoVe->SetModifyHdl( aLk );

		aLk = LINK(this,FaxDialog,LogoRBtnHdl);
		aLogo.pL_RBtn_NoLogo->SetClickHdl( aLk );
		aLogo.pL_RBtn_GrLogo->SetClickHdl( aLk );
		aLogo.pL_RBtn_TxLogo->SetClickHdl( aLk );

		aLk = LINK(this,FaxDialog,AbsnBBtnHdl);
		a3_BBtn_AbsnOL.SetClickHdl( aLk );
		a3_BBtn_AbsnOR.SetClickHdl( aLk );

		aLk = LINK(this,FaxDialog,AbsnMFldHdl);
		a3_MFld_AbsnWd.SetModifyHdl( aLk );
		a3_MFld_AbsnHg.SetModifyHdl( aLk );
	}
	{
		a3_PBtn_LoadAdr.SetClickHdl(LINK(this,FaxDialog,UpdateAdressHdl));
		a3_MEdt_AbsInp.SetModifyHdl(LINK(this,FaxDialog,EditModifyHdl));
		a3_Edit_Telfon.SetModifyHdl(LINK(this,FaxDialog,ATeleModifyHdl));
		a3_Edit_Telfax.SetModifyHdl(LINK(this,FaxDialog,ATeleModifyHdl));
		a1_CLst_FaxTit.SetModifyHdl(LINK(this,FaxDialog,TitelModifyHdl));
		a1_List_Format.SetSelectHdl(LINK(this,FaxDialog,FormatSelectHdl));
		aMarg.pM_MFld_VonLks->SetModifyHdl(LINK(this,FaxDialog,RandMetrcModifyHdl));
		aMarg.pM_MFld_VonRts->SetModifyHdl(LINK(this,FaxDialog,RandMetrcModifyHdl));
	}
	{
		aEmpf.pE_List_DBase ->SetSelectHdl(LINK(this,FaxDialog,EmpfDBasListHdl)); // Meine eigenen Handler
		aEmpf.pE_MEdt_Adress->SetModifyHdl(LINK(this,FaxDialog,EmpfModifyHdl));  // Mein Handler vor WizEmpf
		aEmpf.pE_SBtn_Insert->SetClickHdl (LINK(this,FaxDialog,EmpfInsrPBtnHdl));
		aEmpf.pE_BBtn_NewLin->SetClickHdl (LINK(this,FaxDialog,EmpfNewLPBtnHdl));
		aEmpf.pE_List_Fields->SetDoubleClickHdl(LINK(this,FaxDialog,EmpfFeldListHdl));
		aEmpf.pE_List_Telfon->SetSelectHdl(LINK(this,FaxDialog,ETeleSelectHdl));
		aEmpf.pE_List_Telfax->SetSelectHdl(LINK(this,FaxDialog,ETeleSelectHdl));
	}
	{
		a5_CBox_Datum .SetClickHdl(LINK(this,FaxDialog,ElemDatmCheckHdl));
		a5_CBox_Uhrzt .SetClickHdl(LINK(this,FaxDialog,ElemDatmCheckHdl));

		a5_CBox_Betref.SetClickHdl(LINK(this,FaxDialog,ElemBetrCheckHdl));
		a5_CBox_KopiAn.SetClickHdl(LINK(this,FaxDialog,ElemBetrCheckHdl));
	}
	{
		aLk = LINK(this,FaxDialog,ElemMiscCheckHdl);
		a5_CBox_Elem1 .SetClickHdl( aLk );
		a5_CBox_Elem2 .SetClickHdl( aLk );
		a5_CBox_Elem3 .SetClickHdl( aLk );
		a5_CBox_Elem4 .SetClickHdl( aLk );

		aLk = LINK(this,FaxDialog,ElemModifyHdl);
		a5_Edit_Elem1 .SetModifyHdl( aLk );
		a5_Edit_Elem2 .SetModifyHdl( aLk );
		a5_Edit_Elem3 .SetModifyHdl( aLk );
		a5_Edit_Elem4 .SetModifyHdl( aLk );
		a5_Edit_Betref.SetModifyHdl( aLk );
	}
}

////////////////////////////////////////////////////////////////////////////////
//
// @@  @@ @@ @@@@@  @@@@@@ @@  @@ @@@@@ @@   @@
// @@  @@ @@ @@  @@   @@   @@  @@ @@    @@   @@
// @@  @@ @@ @@  @@   @@   @@  @@ @@    @@   @@
// @@@@@@ @@ @@@@@    @@   @@  @@ @@@@  @@   @@
//  @@@@  @@ @@  @@   @@   @@  @@ @@    @@   @@
//  @@@@  @@ @@  @@   @@   @@  @@ @@    @@   @@
//   @@   @@ @@  @@   @@    @@@@  @@@@@ @@@@ @@@@
//
////////////////////////////////////////////////////////////////////////////////

BOOL FaxDialog::Possible(USHORT StepNum)
{
	return(TRUE);
}

void FaxDialog::Enter(USHORT StepNum)
{
	if (StepNum==7) aPrevWin.Hide(); // Fuer die Fahne
}

void FaxDialog::Leave(USHORT StepNum)
{
	if (StepNum==7) aPrevWin.Show(); // Fuer die Fahne
}

void FaxDialog::Fill(USHORT StepNum, MultiOne& WinArr)
{
	switch (StepNum) {
		case 0: {
			WinArr.AddWin(&a1_Text_Stil  );
			WinArr.AddWin(&a1_RBtn_Stil1, TRUE );
			WinArr.AddWin(&a1_RBtn_Stil2, TRUE );
			WinArr.AddWin(&a1_RBtn_Stil3, TRUE );
			WinArr.AddWin(&a1_Text_FaxTit);
			WinArr.AddWin(&a1_CLst_FaxTit, TRUE);
			WinArr.AddWin(&a1_Text_Format);
			WinArr.AddWin(&a1_List_Format, TRUE);
			WinArr.SetHelpId( HID_FAX_PAGE1 );
		} break;
		case 1: {
			aLogo.Fill(WinArr);
			WinArr.SetHelpId( HID_FAX_PAGE2 );
		} break;
		case 2: {
			WinArr.AddWin(&a3_PBtn_LoadAdr);
			WinArr.AddWin(&a3_MEdt_AbsInp, TRUE);
			WinArr.AddWin(&a3_Text_Telfon);
			WinArr.AddWin(&a3_Edit_Telfon, TRUE);
			WinArr.AddWin(&a3_Text_Telfax);
			WinArr.AddWin(&a3_Edit_Telfax, TRUE);
			WinArr.AddWin(&a3_GBox_AbsInp,FALSE,TRUE);
			WinArr.AddWin(&a3_BBtn_AbsnOL, TRUE);
			WinArr.AddWin(&a3_BBtn_AbsnOR, TRUE);
			WinArr.AddWin(&a3_Text_AbsnWd);
			WinArr.AddWin(&a3_MFld_AbsnWd, TRUE);
			WinArr.AddWin(&a3_Text_AbsnHg);
			WinArr.AddWin(&a3_MFld_AbsnHg, TRUE);
			WinArr.AddWin(&a3_GBox_AbsPos,FALSE,TRUE);
			WinArr.SetHelpId( HID_FAX_PAGE3 );
		} break;
		case 3: {
			aEmpf.Fill(WinArr);
			WinArr.SetHelpId( HID_FAX_PAGE4 );
		} break;
		case 4: {
			WinArr.AddWin(&a5_Text_Welche);
			WinArr.AddWin(&a5_CBox_Datum, TRUE );
			WinArr.AddWin(&a5_List_Datum, TRUE );
			WinArr.AddWin(&a5_CBox_Uhrzt, TRUE );
			WinArr.AddWin(&a5_List_Uhrzt, TRUE );
			WinArr.AddWin(&a5_CBox_Betref, TRUE);
			WinArr.AddWin(&a5_Edit_Betref, TRUE);
			WinArr.AddWin(&a5_CBox_KopiAn, TRUE);
			WinArr.AddWin(&a5_CBox_Elem1, TRUE );
			WinArr.AddWin(&a5_Edit_Elem1, TRUE );
			WinArr.AddWin(&a5_CBox_Elem2, TRUE );
			WinArr.AddWin(&a5_Edit_Elem2, TRUE );
			WinArr.AddWin(&a5_CBox_Elem3, TRUE );
			WinArr.AddWin(&a5_Edit_Elem3, TRUE );
			WinArr.AddWin(&a5_CBox_Elem4, TRUE );
			WinArr.AddWin(&a5_Edit_Elem4, TRUE );
			WinArr.SetHelpId( HID_FAX_PAGE5 );
		} break;
		case 5: {
			aFusz.Fill(WinArr);
			aMarg.Fill(WinArr);
			WinArr.SetHelpId( HID_FAX_PAGE6 );
		} break;
		case 6: {
			pDoku->Fill(WinArr);
			WinArr.SetHelpId( HID_FAX_PAGE7 );
		} break;
		case 7: {
			WinArr.AddWin(&a8_BMap_Fahne, TRUE );
			WinArr.AddWin(&a8_Text_Final );
			WinArr.SetHelpId( HID_FAX_PAGE8 );
		} break;
		case 0xFFFF: {
			FillDefElems(WinArr); // Defaultelemente (Buttons, PrevWin)
		} break;
	}
}




/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizfx.cxx,v 1.1.1.1 2000/09/18 17:14:51 hr Exp $

	  Source Code Control System - Update

	  $Log: wizfx.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:51  hr
	  initial import
	
	  Revision 1.63  2000/09/18 16:06:22  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.62  2000/06/26 16:32:52  jp
	  have to change: enums of AddressToken
	
	  Revision 1.61  2000/04/19 11:18:59  os
	  UNICODE

	  Revision 1.60  2000/02/25 10:12:05  hr
	  #73447#: removed temporary

	  Revision 1.59  2000/01/28 14:25:21  os
	  #71324# Reload button to update return address

	  Revision 1.58  1999/04/08 08:50:26  JP
	  Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)


	  Rev 1.57   08 Apr 1999 10:50:26   JP
   Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)

	  Rev 1.56   27 Apr 1998 16:01:30   OM
   #49831# Andere Masseinheiten erlauben

	  Rev 1.55   08 Jan 1998 17:47:14   OM
   Neue Datumsfelder einfuegen

	  Rev 1.54   24 Nov 1997 10:58:42   MA
   includes

	  Rev 1.53   03 Nov 1997 14:01:46   MA
   precomp entfernt

	  Rev 1.52   20 Oct 1997 15:14:00   OM
   Absender wieder in INI speichern

	  Rev 1.51   11 Sep 1997 10:44:52   OM
   #43604# Unnoetige Leerzeichen entfernt

	  Rev 1.50   26 May 1997 16:02:06   OM
   Internationalisierte Absender

	  Rev 1.49   04 Apr 1997 14:52:12   OM
   HelpIDs fuer letzte Seite

	  Rev 1.48   05 Mar 1997 17:56:52   OM
   Autopiloten: Groessenanpassung

	  Rev 1.47   11 Nov 1996 10:38:06   MA
   ResMgr

	  Rev 1.46   29 Oct 1996 19:09:50   HJS
   includes

	  Rev 1.45   07 Oct 1996 09:24:04   MA
   Umstellung Enable/Disable

	  Rev 1.44   29 Aug 1996 09:04:50   OS
   includes

	  Rev 1.43   28 Aug 1996 14:58:32   OM
   Datenbankumstellung

	  Rev 1.42   19 Mar 1996 16:29:10   MA
   chg: Umstellungen, Finder und AdrItem

	  Rev 1.41   07 Feb 1996 08:33:14   OS
   Handler an den Anfang verschoben

	  Rev 1.40   06 Feb 1996 15:21:52   JP
   Link Umstellung 305

	  Rev 1.39   30 Nov 1995 19:08:08   JP
   HilfeIds fuer die einzelnen Wizard-Pages

	  Rev 1.38   24 Nov 1995 16:59:22   OM
   PCH->PRECOMPILED

	  Rev 1.37   08 Nov 1995 12:03:32   OS
   Change => Set

	  Rev 1.36   31 Aug 1995 12:48:48   JP
   Adresse richtig zusammenbauen

	  Rev 1.35   04 Aug 1995 08:38:16   JP
   Feldzugriff in die Basisklasse verschoben

	  Rev 1.34   02 Aug 1995 18:49:26   JP
   Optimierung

*************************************************************************/

