/*************************************************************************
 *
 *  $RCSfile: wizgo1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"
#include "uiparam.hxx"

#ifndef _TXTCMP_HXX //autogen
#include <svtools/txtcmp.hxx>
#endif
#ifndef _KEYCOD_HXX //autogen
#include <vcl/keycod.hxx>
#endif
#ifndef _SVX_PAPERINF_HXX //autogen
#include <svx/paperinf.hxx>
#endif
#ifndef _SVX_LRSPITEM_HXX //autogen
#include <svx/lrspitem.hxx>
#endif
#ifndef _SVX_BOXITEM_HXX //autogen
#include <svx/boxitem.hxx>
#endif
#ifndef _SVX_PBINITEM_HXX //autogen
#include <svx/pbinitem.hxx>
#endif
#ifndef _SVX_ULSPITEM_HXX //autogen
#include <svx/ulspitem.hxx>
#endif
#ifndef _SVX_PRNTITEM_HXX //autogen
#include <svx/prntitem.hxx>
#endif
#ifndef _SVX_FHGTITEM_HXX //autogen
#include <svx/fhgtitem.hxx>
#endif
#ifndef _FMTANCHR_HXX //autogen
#include <fmtanchr.hxx>
#endif
#ifndef _FMTSRND_HXX //autogen
#include <fmtsrnd.hxx>
#endif
#ifndef _FMTFSIZE_HXX //autogen
#include <fmtfsize.hxx>
#endif
#ifndef _FMTHDFT_HXX //autogen
#include <fmthdft.hxx>
#endif
#ifndef _FMTORNT_HXX //autogen
#include <fmtornt.hxx>
#endif


#include "wrtsh.hxx"	 // Writershell
#include "expfld.hxx"	 // Seitenraender,
#include "pagedesc.hxx"	 // Seitenraender,
#include "frmatr.hxx"	 // Fussz,Kopfz,FlyHoriOrient
#include "docufld.hxx"	 // DS_PAGE
#include "flddat.hxx"	 // DATE_FIX
#include "fldmgr.hxx"	 // Datenbankfeld einfuegen
#include "tabcol.hxx"  	// SwTabCols
#include "wizgo.hxx"
#include "wizpage.hxx"

#define C2S(cChar) UniString::CreateFromAscii(cChar)


////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

// Einfuegen eines String
void WizardGo::InsString( const String& rStr )
{
	USHORT n = CountLines( rStr );
	USHORT i;
	for (i=0; i<n; i++)
	{
		pShell->Insert(GetLine(rStr,i));
		if (i<n-1)
			pShell->SplitNode();
	}
}

// Einfuegen eines String bestehend aus Text und DB-Feldern
void WizardGo::InsDBasFldStr(const String& rStr)
{
	USHORT n = CountLines( rStr );
	USHORT i;
	String aStr1,aStr2;
	BOOL   bIsFld;
	USHORT j;
	char c;
	for( i = 0; i < n; ++i )
	{
		aStr1 = GetLine( rStr, i );
		bIsFld = FALSE;
		aStr2 = aEmptyStr;
		for( j = 0; j < aStr1.Len(); ++j )
		{
			c = aStr1.GetChar(j);
			if( c == '<' && !bIsFld )
			{
				bIsFld = TRUE;
				if( aStr2.Len() )
				{
					pShell->Insert( aStr2 );
					aStr2 = aEmptyStr;
				}
			}
			else if (c == '>' && bIsFld)
			{
				bIsFld = FALSE;
				if( aStr2.Len() )
				{
					::ReplacePoint(aStr2);
					InsDBasFld( aStr2 );
					aStr2 = aEmptyStr;
				}
			}
			else
			   aStr2 += c;

		}
		if( aStr2.Len() )
			pShell->Insert( aStr2 );
		if( i < n - 1 )
			pShell->SplitNode();
	}
}

void WizardGo::InsLogoObj(WizardLogo& rLogo, BOOL bKopz, BOOL bPrintGraf)
{
	if( rLogo.IsTextLogo() )
	{
		// Schriftgroesse aendern
		long tHgt = Twip( rLogo.GetLogoTextHgt() );
		tHgt = tHgt * 9 / 10;  // Sicherheitshalber 10% weg
		if( tHgt < 40 )	// mind. 2 Point
			tHgt = 40;
		pShell->SetAttr( SvxFontHeightItem( (ULONG) tHgt ) );
		InsString( rLogo.GetStr() );
	}
	else
	{
		String aFNam;
		String aFilt;
		if( rLogo.GetGraphic( aFNam, aFilt ) )
		{
			DelFrame();

			SfxItemSet aSet( pShell->GetAttrPool(), aGrfFmtCollSetRange );
			aSet.Put( SwFmtSurround( SURROUND_PARALLEL ));
			aSet.Put( SwFmtFrmSize( ATT_FIX_SIZE, Twip( rLogo.GetWdt() ),
												Twip( rLogo.GetHgt() ) ) );
			if (bKopz)
			{
				aSet.Put( SwFmtAnchor( FLY_AT_CNTNT ));
				SwHoriOrient eOrient = HORI_NONE;
				switch( rLogo.GetAlign() )
				{
					case ALIGN_LiOb:
					case ALIGN_LiUn: eOrient=HORI_LEFT;   break;
					case ALIGN_MiOb: eOrient=HORI_CENTER; break;
					case ALIGN_ReOb:
					case ALIGN_ReUn: eOrient=HORI_RIGHT;  break;
				}
				aSet.Put( SwFmtHoriOrient( 0, eOrient, FRAME ) );
			}
			else
			{
				aSet.Put( SwFmtFrmSize( ATT_FIX_SIZE, Twip( rLogo.GetWdt() ),
												Twip( rLogo.GetHgt() ) ) );

				USHORT nPhyPageNum, nVirtPageNum;
				pShell->GetPageNum( nPhyPageNum, nVirtPageNum );
				aSet.Put( SwFmtAnchor( FLY_PAGE, nPhyPageNum ));

				aSet.Put( SwFmtHoriOrient( Twip( rLogo.GetPosX() ), HORI_NONE, FRAME ) );
				aSet.Put( SwFmtVertOrient( Twip( rLogo.GetPosY() ), VERT_NONE, FRAME ) );
			}

			if( !bPrintGraf )
				aSet.Put( SvxPrintItem( RES_PRINT, bPrintGraf ));

			pShell->SwFEShell::Insert( aFNam, aFilt, 0, &aSet );
			pShell->UnSelectFrm();
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void WizardGo::SetFusz(WizardFusz& rFusz, const String& rFusMark, const String& rNumMark)
{
	BOOL bFusz=rFusz.IsVisible();
	if (rNumMark.Len()!=0 && GotoBookmark(rNumMark))
	{
		if (rFusz.IsPgNum())
		{
			USHORT nFmt=rFusz.GetPgNumFmt();
			SwFldMgr aFldMgr;
			String aStr(rFusz.GetPgNumStr());
			if( aStr.Len() )
			{
				aStr+=' ';
				InsString(aStr);
			}
			aFldMgr.InsertFld( TYP_PAGENUMBERFLD, 0, aEmptyStr, aEmptyStr,
								nFmt, pShell );
			if( rFusz.IsPgNumGes() )
			{
				aStr = rFusz.GetPgNumGesStr();
				if( aStr.Len() )
				{
					aStr.Insert( ' ', 0 );
					aStr += ' ';
					InsString( aStr );
				}
				aFldMgr.InsertFld( TYP_DOCSTATFLD, DS_PAGE, aEmptyStr,
									aEmptyStr, nFmt, pShell );
			}
		}
		else
			pShell->DelFullPara();
	}
	if( GotoBookmark( rFusMark) )
	{
		USHORT nPgDescIdx=pShell->GetCurPageDesc();
		SwPageDesc aPageDesc(pShell->GetPageDesc(nPgDescIdx));
		SwFrmFmt*  pFmt=&aPageDesc.GetMaster();	 //CopyCtor geht hier nicht, da Pointer
		if (rFusz.IsVisible())
		{
			InsString(rFusz.GetStr());
			SwFmtFooter aFooterFmt(pFmt->GetFooter());
			SwFrmFmt* pFooterFmt=aFooterFmt.GetFooterFmt();
			SvxULSpaceItem aULSpace(pFooterFmt->GetULSpace()); // Upper/Lower-Space holen
			aULSpace.SetUpper(USHORT(rFusz.GetTextDst()));	 // Abstand zum Text
			pFooterFmt->SetAttr(aULSpace);

			if (!rFusz.IsTrennlinie())
				// Trennlinie aus
				pFooterFmt->SetAttr( SvxBoxItem() );
			pFmt->SetAttr(aFooterFmt);
		}
		if( !bFusz )
		{
			// Fuzeile entfernen !
			pFmt->SetAttr(SwFmtFooter(BOOL(FALSE)));
			aPageDesc.ChgFooterShare(FALSE);
		}
		pShell->ChgPageDesc(nPgDescIdx,aPageDesc);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL WizardGo::GotoBookmark( const String& rStr, char cAdd )
{ // Zur Textmarke Springen und den dahinterstehenden Text in eckigen Klammern lschen
	String aStr( rStr );
	if( cAdd )
		aStr += cAdd;
	if( pShell->GotoBookmark( aStr ) )
	{
		if( '[' == pShell->GetChar() )
		{
			String sTxt( pShell->GetText() );
			USHORT nPos = sTxt.Search( ']' );
			if( nPos != STRING_NOTFOUND )
			{
				pShell->SttSelect();
				pShell->ExtendSelection( TRUE, nPos+1 );
			}
			else
			{
				pShell->SearchPattern(
					SearchParam( ']', SearchParam::SRCH_NORMAL, TRUE ),
					DOCPOS_CURR, DOCPOS_END );
				pShell->ExtendSelection( TRUE, 1 );
				pShell->SttSelect();
				pShell->GotoBookmark( aStr );
			}
			pShell->EndSelect();
			pShell->DelRight();
		}
		/*if (bLeaveMarker) {
			InsertBookmark( aStr );
		}*/
		return TRUE;
	}
	ASSERT( !this, "Bookmark nicht gefunden" );
	return FALSE;
}

void WizardGo::InsertBookmark( const String& rName )
{
	pShell->SetBookmark( KeyCode(), rName, aEmptyStr );
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////


void WizardGo::DelFrame()
{
	pShell->WizzardDelFly();
}

void WizardGo::MovFrame(WizardFrame& rFrm, BOOL bPreventHgt, BOOL bPutBack)
{
	MovFrame(rFrm.GetPosX(),rFrm.GetPosY(),rFrm.GetWdt(),rFrm.GetHgt(),bPreventHgt,bPutBack);
}

void WizardGo::MovFrame( long X, long Y, long W, long H, BOOL bPreventHgt,
						BOOL bPutBack )
{
	X=Twip(X);
	Y=Twip(Y);
	W=Twip(W);
	H=Twip(H);

	SwFrmFmt* pFmt = pShell->WizzardGetFly();
	if( pFmt )
	{
		SwFmtFrmSize aSize( pFmt->GetFrmSize() );
		if( !bPreventHgt )
			aSize.SetHeight( Max( H, long( MINFLY ) ) );
		aSize.SetWidth( Max( W, long( MINFLY ) ) );

		pFmt->SetAttr( aSize );
		pFmt->SetAttr( SwFmtVertOrient( Y, VERT_NONE, FRAME ) );
		pFmt->SetAttr( SwFmtHoriOrient( X, HORI_NONE, FRAME ) );

// Hallo MA: wie das ohne Layout ??
//		if( bPutBack )
//			pShell->SelectionToBottom();
	}
}

void WizardGo::SizFrame(long W, long H, BOOL bPreventHgt, BOOL bPutBack )
{
	W=Twip(W);
	H=Twip(H);

	SwFrmFmt* pFmt = pShell->WizzardGetFly();
	if( pFmt )
	{
		SwFmtFrmSize aSize( pFmt->GetFrmSize() );
		if( !bPreventHgt )
			aSize.SetHeight( Max( H, long( MINFLY ) ) );
		aSize.SetWidth( Max( W, long( MINFLY ) ) );

		pFmt->SetAttr( aSize );

// Hallo MA: wie das ohne Layout ??
//		if( bPutBack )
//			pShell->SelectionToBottom();
	}
}

void WizardGo::JstFrame(PageAlign eJst, BOOL bPutBack)
{
	SwHoriOrient eOrient;
	switch( eJst )
	{
		case ALIGN_LiOb:
		case ALIGN_LiUn: eOrient = HORI_LEFT;	 break;
		case ALIGN_MiOb: eOrient = HORI_CENTER; break;
		case ALIGN_ReOb:
		case ALIGN_ReUn: eOrient = HORI_RIGHT;	 break;
		default: return;
	}

	SwFrmFmt* pFmt = pShell->WizzardGetFly();
	if( pFmt )
	{
		SwFmtHoriOrient aHoriOrient( pFmt->GetHoriOrient() );
		if( eOrient != aHoriOrient.GetHoriOrient() )
		{
			aHoriOrient.SetHoriOrient( eOrient );
			pFmt->SetAttr( aHoriOrient );
		}

// Hallo MA: wie das ohne Layout ??
//		if( bPutBack )
//			pShell->SelectionToBottom();
	}

}

void WizardGo::PrnFrame( BOOL bPrn )
{
	SwFrmFmt* pFmt = pShell->WizzardGetFly();
	if( pFmt && pFmt->GetPrint().GetValue() != bPrn )
		pFmt->SetAttr( SvxPrintItem( RES_PRINT, bPrn ) );
}

void WizardGo::SetMarg( const WizardPage& rPage, WizardKopz* pKopz,
						WizardFusz* pFusz )
{
	SvxLRSpaceItem aLR;
	aLR.SetLeft( (USHORT) Twip( rPage.RandL ) );	// 1/EINHEIT mm nach Twip
	aLR.SetRight( (USHORT) Twip( rPage.RandR ) );

	SvxULSpaceItem aOU;
	long nTmp;

	if( pKopz && pKopz->IsVisible() )
		nTmp = pKopz->GetVer();
	else
		nTmp = rPage.RandO;
	aOU.SetUpper( (USHORT)Twip( nTmp ) );

	if( pFusz && pFusz->IsVisible() )
		nTmp = pFusz->GetVer();
	else
		nTmp = rPage.RandU;
	aOU.SetLower( (USHORT)Twip( nTmp ) );

	USHORT nPgDescIdx = pShell->GetCurPageDesc();
	SwPageDesc aPageDesc( pShell->GetPageDesc( nPgDescIdx ) );
	SwFrmFmt* pFmt = &aPageDesc.GetMaster();
	pFmt->SetAttr( aLR );
	pFmt->SetAttr( aOU );

	if( rPage.IsDinA5Q() )
	{
		Size aPSize( SvxPaperInfo::GetPaperSize( SVX_PAPER_A5 ) );
		LandscapeSwap( aPSize );
		pFmt->SetAttr( SwFmtFrmSize( ATT_FIX_SIZE, aPSize.Width(), aPSize.Height() ));
	}
//??	else if( rPage.IsDinA4() )

	pShell->ChgPageDesc( nPgDescIdx, aPageDesc );
}

void WizardGo::SetTray( USHORT nTray )
{
	pShell->SetAttr( SvxPaperBinItem( RES_PAPER_BIN, (BYTE) nTray ) );
}

void WizardGo::MarkText()
{
	// Die Zeile "[Bitte geben Sie hier Ihren Text ein]" wird markiert
	if (GotoBookmark(C2S("Text")))
	{
		InsertBookmark(C2S("Text"));
		pShell->SttSelect();
		if( !pShell->IsEndPara() )
			pShell->MovePara( fnParaCurr, fnParaEnd );
		pShell->EndSelect();
	}
}

void WizardGo::DelText()
{
	// der Text zwischen DelA und DelE wird gelscht
	if (pShell->GotoBookmark(C2S("DelA")))
	{
		pShell->Left( FALSE, 1, TRUE );
		pShell->SttSelect();
		if (pShell->GotoBookmark(C2S("DelE")))
		{
			if( !pShell->IsEndPara() )
				pShell->MovePara( fnParaCurr, fnParaEnd );
			pShell->EndSelect();
			pShell->DelRight();
			pShell->DelBookmark(C2S("DelE"));
		}
		else
			pShell->EndSelect();
	}
}

void WizardGo::SetTabColWidth( SwTabCols& rCols, USHORT nNum, long nNewWidth )
{
	// aktuelle Breite setzen
	// alle folgenden Verschieben
	SwTwips nWidth = 0;

	if( rCols.Count() > 0 )
	{
		nWidth = (nNum == rCols.Count()) ?
				rCols.GetRight() - rCols[nNum-1] :
				nNum == 0 ? rCols[nNum] - rCols.GetLeft() :
							rCols[nNum] - rCols[nNum-1];

		if(nNum < rCols.Count())
			rCols[nNum] += USHORT(nNewWidth - nWidth);
		else
			rCols[rCols.Count()-1] -= USHORT(nNewWidth - nWidth);
	}
	else
		rCols.SetRight( Min( nNewWidth, rCols.GetRightMax() ) );
}


/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizgo1.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizgo1.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.66  2000/09/18 16:06:23  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.65  2000/08/29 13:56:57  ama
	  New: Negative margins
	
	  Revision 1.64  2000/06/30 08:52:05  os
	  #76541# string assertions removed

	  Revision 1.63  2000/04/19 11:18:59  os
	  UNICODE

	  Revision 1.62  2000/02/11 15:02:06  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.61  1999/04/13 18:39:46  JP
	  Bug #64435#: Cursor-Bewegungen als Basic-Calls ausgeben, damit sie in ReadOnly-Docs auch funktionieren


	  Rev 1.60   13 Apr 1999 20:39:46   JP
   Bug #64435#: Cursor-Bewegungen als Basic-Calls ausgeben, damit sie in ReadOnly-Docs auch funktionieren

	  Rev 1.59   19 Feb 1999 14:03:54   JP
   Bug #57558#/#57557#: statt Left-/RightMargin MovePara( Start/End ) benutzen

	  Rev 1.58   28 May 1998 15:09:28   OM
   #50572 Eingefuegte Grafik deselektieren

	  Rev 1.57   12 May 1998 15:45:12   JP
   InsertGraphic: Schnittstelle hat sich geaendert

	  Rev 1.56   20 Mar 1998 15:44:06   OM
   Korrekte Rahmenausrichtungen fuer VertOrient

	  Rev 1.55   24 Feb 1998 15:28:36   JP
   Search..: SWPOSDOC entfernt, auf enums umgestellt

	  Rev 1.54   09 Jan 1998 10:31:24   OM
   Rahmenpositionen korrigiert

	  Rev 1.53   24 Nov 1997 10:58:38   MA
   includes

	  Rev 1.52   12 Sep 1997 10:40:38   OS
   ITEMID_* definiert

	  Rev 1.51   15 Aug 1997 12:15:52   OS
   chartar/frmatr/txtatr aufgeteilt

	  Rev 1.50   11 Aug 1997 10:51:12   OS
   paraitem/frmitems/textitem aufgeteilt

	  Rev 1.49   23 Jun 1997 15:40:02   OM
   Druckereinstellung fuer Autopilot Brief

	  Rev 1.48   13 Mar 1997 16:29:22   OM
   DB-Feldbefehle korrekt erkennen

	  Rev 1.47   11 Feb 1997 16:52:38   OM
   Eingabefeld ueber Basic ohne Dialog einfuegen

	  Rev 1.46   24 Oct 1996 13:36:48   JP
   String Umstellung: [] -> GetChar()

	  Rev 1.45   25 Sep 1996 15:11:48   OM
   Neue Datenbanktrenner

	  Rev 1.44   11 Sep 1996 16:51:54   MA
   new: Umlauf nur Anker

	  Rev 1.43   19 Apr 1996 17:10:38   MA
   chg: Vorbereitung fuer kleine Rahmen

	  Rev 1.42   11 Apr 1996 19:13:06   MA
   opt: unbenutzes entfernt

	  Rev 1.41   28 Mar 1996 21:34:36   JP
   FaxVorlage: DinA5-Quer einstellen

	  Rev 1.40   24 Nov 1995 16:59:16   OM
   PCH->PRECOMPILED

	  Rev 1.39   19 Oct 1995 18:38:40   JP
   Grafiken mit Seitenumfluss

	  Rev 1.38   18 Oct 1995 18:38:58   JP
   FldMgr: immer die WrtShell uebergeben (auf richtigen Document arbeiten!)

	  Rev 1.37   30 Aug 1995 13:01:36   MA
   Traveling mit/ohne Selektion vereint

	  Rev 1.36   05 Aug 1995 19:58:02   JP
   InsertGraphic: keinen FlyFrame anlegen lassen

	  Rev 1.35   03 Aug 1995 21:15:04   JP
   alte Funktionalitaet wiederbeleben

	  Rev 1.34   02 Aug 1995 18:52:56   JP
   kein TableMgr mehr; Undo abgeschaltet; ActionKlammerung; optimiert

	  Rev 1.33   01 Aug 1995 12:27:50   JP
   Get-/Del-FlyFrames ueber neue SS an der FeShell

	  Rev 1.32	 29 Jul 1995 23:35:40	JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.31	 05 Jul 1995 19:10:06	JP
   SwBookmarkFUNC gibts nicht mehr, rufe Methoden an die Shell-Methoden

	  Rev 1.30	 05 Jul 1995 13:09:26	JP
   BookmarkFUNC gibts nicht mehr

	  Rev 1.29	 22 Jun 1995 20:08:46	MA
   fix/opt: FrmMgr mit Shell erzeugen.

	  Rev 1.28	 08 Feb 1995 18:18:58	JP
   Unsinn entfernt

	  Rev 1.27	 23 Dec 1994 13:26:14	JP
   umgestellt auf SearchKlasse aus svtools

	  Rev 1.26	 20 Dec 1994 11:54:16	MA
   SS Drawing.

	  Rev 1.25	 22 Nov 1994 13:07:46	PK
   swborderattrmgr rausgeschmissen

	  Rev 1.24	 03 Nov 1994 16:41:40	AMA
   include frmitems.hxx statt svxitems.hxx

*************************************************************************/


