/*************************************************************************
 *
 *  $RCSfile: wizgo2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#if STLPORT_VERSION>=321
#include <cstdarg>
#endif

#ifndef _SFXREQUEST_HXX
#include <sfx2/request.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFX_INIMGR_HXX
#include <sfx2/inimgr.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <sfx2/docfilt.hxx>
#endif
#ifndef _SFXDOCTEMPL_HXX //autogen
#include <sfx2/doctempl.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SFXDOCINF_HXX //autogen
#include <sfx2/docinf.hxx>
#endif


#ifndef _WRTSH_HXX
#include <wrtsh.hxx>     // Writershell
#endif
#ifndef _VIEW_HXX
#include <view.hxx>
#endif
#ifndef _DOCSH_HXX
#include <docsh.hxx>
#endif
#ifndef _DOC_HXX
#include <doc.hxx>
#endif
#ifndef _WIZGO_HXX
#include <wizgo.hxx>
#endif
#ifndef _WIZDOKU_HXX
#include <wizdoku.hxx>
#endif
#ifndef _SHELLIO_HXX
#include <shellio.hxx>
#endif
#ifndef _DBMGR_HXX
#include <dbmgr.hxx>     // SwDBMgr, der Datanbankmanager (nur fuer's delete!)
#endif

extern BOOL bNotLoadLayout;

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

WizardGo::WizardGo()
{
	pShell = 0;
	pDBas = 0;
}

WizardGo::~WizardGo()
{
	if( pDBas )
		delete pDBas;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL WizardGo::NewVorlage( const String& rVorlage )
{
	SfxApplication *pSApp = SFX_APP();
	BOOL bRet = FALSE;

	String sTemplate( String::CreateFromAscii("wizard") );
	sTemplate += INET_PATH_TOKEN;
	sTemplate += rVorlage;
#ifndef MAC_WITHOUT_EXT
	sTemplate.AppendAscii(".vor");
#endif

	const SfxFilter* pFilter;
	if( SFX_INIMANAGER()->SearchFile( sTemplate, SFX_KEY_TEMPLATE_PATH ) &&
		0 != (pFilter = SwIoSystem::GetFileFilter(sTemplate, aEmptyStr)) )
	{
		SfxRequest aReq( SID_OPENDOC, SFX_CALLMODE_SYNCHRON, pSApp->GetPool() );
		aReq.AppendItem( SfxStringItem( SID_FILE_NAME, sTemplate ));
		aReq.AppendItem( SfxStringItem( SID_FILTER_NAME, pFilter->GetName() ));
		aReq.AppendItem( SfxBoolItem( SID_HIDDEN, TRUE ) );
		aReq.AppendItem( SfxStringItem( SID_REFERER, String::CreateFromAscii(URL_PREFIX_PRIV_SOFFICE) ));

		pSApp->ExecuteSlot( aReq, pSApp->SfxApplication::GetInterface());
		SfxViewFrameItem* pVItem = (SfxViewFrameItem*)aReq.GetReturnValue();
		if( pVItem )
		{
			// DocShell besorgen
			SwDocShell* pDocSh = (SwDocShell*)pVItem->GetFrame()
													->GetObjectShell();
			pShell = pDocSh->GetWrtShell();
			pShell->CalcLayout();
			return TRUE;
		}
	}
	return FALSE;
}

BOOL WizardGo::SaveVorNewDoc( const WizardDokuDlg& rDoku )
{
	BOOL bRet = FALSE;
	String aVorFN( rDoku.pD_Edit_VorNam->GetText() );
	if( aVorFN.Len() )
	{
// evt. die Vorgabe holen, aber woher??
USHORT nRegion = 0; 		// ist das der Standard - Bereich ??

		{
			BOOL bSaveOld = bNotLoadLayout;
			bNotLoadLayout = TRUE;

			SfxRequest aReq( SID_DOCTEMPLATE, 0, SFX_APP()->GetPool() );
			aReq.AppendItem( SfxStringItem( SID_TEMPLATE_NAME, aVorFN ) );
			aReq.AppendItem( SfxUInt16Item( SID_TEMPLATE_REGION, nRegion ));
			SfxObjectShell *pDSh = pShell->GetView().GetDocShell();
			pDSh->ExecuteSlot( aReq, pDSh->SfxObjectShell::GetInterface() );
			bRet = aReq.IsDone();

			bNotLoadLayout = bSaveOld;
		}

		pShell->ResetModified();
		// nach eier SFX Aenderung muss eine Hidden ObjShell ueber den
		// OwnerLock geschlossen werden.
		pShell->GetView().GetDocShell()->OwnerLock( FALSE );

		if( bRet )
		{
			// fuers besorgen vom RegionNamen !!
			SfxDocumentTemplates aFac;
			aFac.Construct();
			SfxApplication *pSApp = SFX_APP();

			SfxRequest aReq( SID_NEWDOC, 0, pSApp->GetPool() );
			aReq.AppendItem( SfxStringItem( SID_TEMPLATE_NAME, aVorFN ) );
			aReq.AppendItem( SfxStringItem( SID_TEMPLATE_REGIONNAME,
										aFac.GetRegionName( nRegion ) ) );
			pSApp->ExecuteSlot( aReq, pSApp->SfxApplication::GetInterface() );
			bRet = aReq.IsDone();
		}
	}

	return bRet;
}

void WizardGo::FillDocInfo(const WizardDokuDlg& rDoku)
{
	String aStr( rDoku.pD_Edit_VorInf->GetText() );

	// DocInfo holen
	SfxDocumentInfo aInfo( *pShell->GetInfo() );
	aInfo.SetComment( aStr );

	// Ueber Dispatcher updaten
	pShell->GetView().GetDocShell()->SetDocumentInfo( aInfo );
}

void WizardGo::SetPrinter( Printer *pPrt )
{
	if (pPrt)
	{
		SwDocShell *pDocSh = pShell->GetView().GetDocShell();
		pDocSh->GetDoc()->SetJobsetup(pPrt->GetJobSetup());
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////


/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizgo2.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizgo2.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.70  2000/09/18 16:06:23  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.69  2000/09/06 08:09:37  os
	  #78444# Check dispatcher return value instead of SfxRequest::IsDone()
	
	  Revision 1.68  2000/07/18 12:50:09  os
	  replace ofadbmgr

	  Revision 1.67  2000/06/07 14:46:29  os
	  using UCB

	  Revision 1.66  2000/04/19 11:18:59  os
	  UNICODE

	  Revision 1.65  1999/11/11 15:20:05  hr
	  #65293# STLPORT 3.2.1

	  Revision 1.64  1999/10/21 17:44:38  jp
	  have to change - SearchFile with SfxIniManager, dont use SwFinder for this

	  Revision 1.63  1999/09/24 13:53:22  os
	  chg: ODbRow/ODbVariant - includes moved

	  Revision 1.62  1999/06/09 17:32:54  JP
	  have to change: no cast from GetpApp to SfxApp/OffApp, SfxShell only subclass of SfxApp


	  Rev 1.61   09 Jun 1999 19:32:54   JP
   have to change: no cast from GetpApp to SfxApp/OffApp, SfxShell only subclass of SfxApp

	  Rev 1.60   25 Feb 1999 15:03:40   JP
   Task #61263#: es gibt kein private URL-Scheme mehr

	  Rev 1.59   03 Jul 1998 16:20:30   TJ
   include

	  Rev 1.58   02 Jul 1998 16:18:10   JP
   ueber den PathFinder multi pathes behandeln

	  Rev 1.57   02 Mar 1998 15:24:54   OM
   #47692# UpdateLayout

	  Rev 1.56   02 Mar 1998 12:56:34   JP
   GetFileFilter kann auch 0 returnen

	  Rev 1.55   16 Dec 1997 18:13:58   JP
   GetSearchDelim gegen SFX_SEARCH_DELIMITER ausgetauscht

	  Rev 1.54   03 Dec 1997 12:42:24   JP
   Extensions auf dem MAC zulassen

	  Rev 1.53   24 Nov 1997 10:58:32   MA
   includes

	  Rev 1.52   03 Nov 1997 14:01:48   MA
   precomp entfernt

	  Rev 1.51   08 Aug 1997 14:33:40   MH
   chg: header, war CLOOKS

	  Rev 1.50   21 Jul 1997 17:18:06   AMA
   Fix #38434#: Das FontListen-Update wird jetzt von SetPrt angestossen

	  Rev 1.49   23 Jun 1997 15:39:42   OM
   Druckereinstellung fuer Autopilot Brief

	  Rev 1.48   09 Jun 1997 20:09:22   JP
   SwFilterNms/SwFilterNm entfernt

	  Rev 1.47   05 Jun 1997 19:51:04   JP
   statt DoClose muss ein OwnerLink gerufen werden

	  Rev 1.46   04 Apr 1997 14:15:26   MH
   chg: header

	  Rev 1.45   20 Mar 1997 15:51:48   OM
   Referrer bei Sid_OpenDoc angegeben

	  Rev 1.44   07 Mar 1997 16:51:36   OM
   DocManPath entfernt

	  Rev 1.43   05 Mar 1997 20:51:46   HJS
   muss 357

	  Rev 1.42   18 Feb 1997 23:20:04   NF
   SID_FILE_CONVERT wech...

	  Rev 1.41   05 Dec 1996 11:40:04   MA
   nur getoucht

	  Rev 1.40   03 Dec 1997 18:49:24   TLX
   REGIONNAME statt REGION

	  Rev 1.39   22 Nov 1996 20:58:46   MI
   SID_STYLE_DESIGNER war irrtuemlich anstatt SID_TEMPLATE_NAME verwendet worden

	  Rev 1.38   14 Nov 1996 19:18:52   OS
   Umstellung SlotIds

	  Rev 1.37   01 Oct 1996 22:32:04   JP
   Bug #31937#: Fuer SDT - Filter ueber FilterContainer besorgem

	  Rev 1.36   29 Aug 1996 09:05:08   OS
   includes

	  Rev 1.35   18 Apr 1996 11:23:54   MA
   Umstellung 313

	  Rev 1.34   24 Nov 1995 16:59:16   OM
   PCH->PRECOMPILED

	  Rev 1.33   16 Nov 1995 21:55:22   JP
   Umstellung SwIoSystem

	  Rev 1.32   18 Oct 1995 18:44:46   JP
   Wizard temp Doc kann nun doch gehiddet werden

	  Rev 1.31   14 Oct 1995 17:57:46   JP
   HACK: View erstmal nicht verstecken - unter W95 gibts Fehler

	  Rev 1.30	 13 Oct 1995 16:09:24	JP
   NewVorlage: Wizard-Vorlage nicht anzeigen

	  Rev 1.29	 11 Oct 1995 15:41:10	JP
   NewVorlage: keine SfxDocTemplate benutzen, Pfad selbst zusammen bauen

	  Rev 1.28	 05 Oct 1995 19:27:06	JP
   SfxDocShellItem -> SfxViewFrameItem

	  Rev 1.27	 21 Sep 1995 15:28:44	JP
   Bug 19624: Filter beim OpenDoc mit geben

	  Rev 1.26	 23 Aug 1995 09:50:52	SWG
   die erlaubten Methoden rufen

*************************************************************************/

