/*************************************************************************
 *
 *  $RCSfile: wizgo3.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop


#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _IPOBJ_HXX //autogen
#include <so3/ipobj.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _BASMGR_HXX //autogen
#include <basic/basmgr.hxx>
#endif
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif
#ifndef _SFX_EVENTCONF_HXX //autogen
#include <sfx2/evntconf.hxx>
#endif
#ifndef _SB_SBSTAR_HXX //autogen
#include <basic/sbstar.hxx>
#endif

#include "wrtsh.hxx"
#include "view.hxx"
#include "docsh.hxx"
#include "flddat.hxx"
#include "wizgo.hxx"
#include "wizdoku.hxx"

#ifdef DEBUG
#define WRITESOURCE
#endif

//#define WRITESOURCE
#define C2S(cChar) UniString::CreateFromAscii(cChar)



/////////////////////////////////////////////////
//  Basicanbindung

static void IndentStr(String& rStr, USHORT n)
{
	String aIns;
	aIns.Fill(n);
	USHORT nLen = rStr.Len();
	USHORT i = nLen;
	char c1 = '\n', c = 0;
	while( i > 0 )
	{
		c = rStr.GetChar( --i );
		if( c == '\n' && c1 != '\n' )
			rStr.Insert( aIns, i+1 );
		c1 = c;
	}
	c = rStr.GetChar( 0 );   // und nun noch die erste Zeile
	if( c != 0 && c != '\n' )
		rStr.Insert( aIns, 0 );
}

static void ValidateMacroName( String& rName )
{
	rName.ToUpperAscii();
	sal_Unicode* pStr = rName.GetBufferAccess();

	if( *pStr >= '0' && *pStr <= '9' )
		*pStr = '_';

	for( USHORT i = rName.Len(); i; --i, ++pStr )
		if( !(( *pStr >= 'A' && *pStr <= 'Z' ) ||
			  ( *pStr >= '0' && *pStr <= '9' ) || *pStr == '_' ) )
			*pStr = '_';
}


// Macros einfuegen
BOOL WizardGo::AssignMacro( String& rMacStr, String& rMacNam,
							const String& rLibNam, const String& rModulNam,
							USHORT nEvent, String *pCode )
{
	if( !rMacStr.Len() )
		return FALSE;

	String aLibNam('~');
	aLibNam += rLibNam;

	rMacNam.ToUpperAscii();

	String aStr(C2S("FUNCTION "));
	aStr += rMacNam;
	aStr.AppendAscii("()\n");
	aStr.AppendAscii("    REM Vom StarWriter-Autopiloten automatisch generiertes Macro\n");
	aStr.AppendAscii("    REM (c) Sun Microsystems, Inc. -  Autor Joe Merten.\n");
	//aStr+="    Fehler%=0\n";
	aStr += rMacStr;
	aStr.AppendAscii("END FUNCTION");
	//aStr.SearchAndReplace( "GetErrorCode()", "Fehler%" );
	rMacStr = aStr;

#ifdef WRITESOURCE
	{
		String aSrcFN( rMacNam );
		aSrcFN.AppendAscii(".bas");
		SvFileStream aOut( aSrcFN, STREAM_STD_WRITE );
		aOut.WriteByteString(rMacStr, aOut.GetStreamCharSet());
	}
#endif

	BOOL bRet = FALSE;

	SFX_APP()->EnterBasicCall();

	SwDocShell* pDocSh = pShell->GetView().GetDocShell();

	StarBASIC* pBasic = pDocSh->GetBasicManager()->GetLib( aLibNam );
	if( pBasic ||
		0 != ( pBasic = pDocSh->GetBasicManager()->CreateLib( aLibNam ) ) )
	{
		SbModule* pModul = pBasic->MakeModule( rModulNam, rMacStr );
		bRet = pBasic->Compile( pModul );
		if( bRet )
		{
			// so, dann mal an die DocShell fuer den Event binden
			String aCode( aLibNam );
			(((aCode += '.') += rModulNam) += '.') += rMacNam;
			SfxEventConfiguration* pECfg = SFX_APP()->GetEventConfig();
			pECfg->ConfigureEvent( nEvent,
								   SvxMacro( aCode, aEmptyStr, STARBASIC ),
								   pDocSh );
			if ( pCode )
				*pCode = aCode;
		}
	}
	SFX_APP()->LeaveBasicCall();

	return bRet;
}

BOOL WizardGo::SetCreateMacro( WizardDokuDlg& rDoku,
								ULONG nDateFmt, ULONG nTimeFmt,
								USHORT nDateAnz, BOOL bDelUmbr )
{
	BOOL bRet = TRUE;
	String sPath( rDoku.pD_Text_Folder->GetText() );
	String sDelim(INET_PATH_TOKEN);
	if (sPath.Len() >= sDelim.Len() &&
		sPath.Copy(sPath.Len()-sDelim.Len()).CompareTo(sDelim) != COMPARE_EQUAL)
		sPath += sDelim;
	String aPrefix( rDoku.pD_Edit_AutoFN->GetText() );
	String aLibNam( rDoku.pD_Edit_VorNam->GetText() );
	String aMacNam( aLibNam );
	aMacNam.AppendAscii("_Create");
	ValidateMacroName( aMacNam );

	String aMacStr;
	if( rDoku.pD_CBox_AutoFN->IsChecked() && aPrefix.Len() )
	{
		String aCntFN( C2S("cnt_" ));
		aCntFN += aPrefix;
		aCntFN.AppendAscii(".wiz");

		{
static char __READONLY_DATA cAutoFNamMacro1[] =
	"REM Automatische Vergabe eines Dateinamen\n"
	"CntFN$=Application.GetDocManPath(\"~~~GetMacroPath\")+\"_$CNTFN$_\"\n"
	"a$=\"0000\"\n"
	"ON ERROR GOTO NoFile\n"
	"OPEN CntFN$ for input as #1\n"
	"LINE INPUT #1,a$\n"
	"CLOSE #1\n"
	"NoFile:\n";                                    /* _$CNTFN$_ (6 Zeilen hoeher (bloeder Mac)) */
static char __READONLY_DATA cAutoFNamMacro2[] =
	"ON ERROR GOTO 0\n"
	"IF LEN(a$)<>4 THEN a$=\"0000\"\n"
	"n1$=MID$(a$,4,1)\n"
	"n2$=MID$(a$,3,1)\n"
	"n3$=MID$(a$,2,1)\n"
	"n4$=MID$(a$,1,1)\n";
static char __READONLY_DATA cAutoFNamMacro3[] =
	"IF n1$=\"9\" THEN\n"
	"    n1$=\"0\"\n"
	"    IF n2$=\"9\" THEN\n"
	"        n2$=\"0\"\n"
	"        IF n3$=\"9\" THEN\n"
	"            n3$=\"0\"\n"
	"            IF n4$=\"9\" THEN\n"
	"                n4$=\"0\"\n"
	"                GOTO Overflow\n";
static char __READONLY_DATA cAutoFNamMacro4[] =
	"            ELSE n4$=CHR$(ASC(n4$)+1)\n"
	"            END IF\n"
	"        ELSE n3$=CHR$(ASC(n3$)+1)\n"
	"        END IF\n"
	"    ELSE n2$=CHR$(ASC(n2$)+1)\n"
	"    END IF\n"
	"ELSE n1$=CHR$(ASC(n1$)+1)\n"
	"END IF\n";
static char __READONLY_DATA cAutoFNamMacro5[] =
	"a$=n4$+n3$+n2$+n1$\n"
	"b$=\"_$GRUPPE$_\"\n"
	"b$=b$+\"_$PREFIX$_\"+a$+Application.GetDocmanPath(\"~~~GetDefDocExt\")\n"
	"ReturnValue=ThisDocument.SaveAs(b$)\n"
	"OPEN CntFN$ for output as #1\n"
	"PRINT #1,a$\n"
	"CLOSE #1\n"
	"Overflow:\n";                                  /* _$DOCNAM$_, {_$SDWEXT$_} (5 Zeilen hoeher (bloeder Mac)) */

			String aTmp;
			aTmp.AppendAscii(cAutoFNamMacro1);
			aTmp.AppendAscii(cAutoFNamMacro2);
			aTmp.AppendAscii(cAutoFNamMacro3);
			aTmp.AppendAscii(cAutoFNamMacro4);
			aTmp.AppendAscii(cAutoFNamMacro5);
			aTmp.SearchAndReplaceAscii("_$CNTFN$_",aCntFN);
			aTmp.SearchAndReplaceAscii("_$PREFIX$_",aPrefix);
			aTmp.SearchAndReplaceAscii("_$GRUPPE$_",sPath);
			IndentStr(aTmp,4); // damit der Basic-Source auch vernuenftig aussieht
			aMacStr+=aTmp;
		}
	}
	if (nDateFmt >= 0 && nDateAnz > 0)
	{
		// Macro zum setzen des aktuellen Datums
		aMacStr.AppendAscii("    REM Setzen des aktuellen Datums\n");
		for( USHORT i = 0; i < nDateAnz; ++i )
		{
			String aMark( C2S("Datum" ));
			if( i > 0)
				aMark += String::CreateFromInt32( i );
			aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
							"    IF ThisWindow.Selection.JumpToBookmark(\""));
			aMacStr+= aMark;
			aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					   "\") THEN\n"
					   "        ThisWindow.Selection.DeleteBookmark(\""));
			aMacStr+= aMark;
			aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					   "\")\n"
					   "        ThisWindow.Selection.InsertField(TYP_DATEFLD,DATE_FIX,\"\",\"\","));
			aMacStr += String::CreateFromInt32( nDateFmt );
			aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					   ")\n"
					   "    END IF\n"));
		}
	}
	if (nTimeFmt >= 0)
	{
		// Macro zum setzen der aktuellen Uhrzeit
		aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					"    REM Setzen der aktuellen Uhrzeit\n"
					"    IF ThisWindow.Selection.JumpToBookmark(\"Uhrzeit\") THEN\n"
					"        ThisWindow.Selection.DeleteBookmark(\"Uhrzeit\")\n"
					"        ThisWindow.Selection.InsertField(TYP_TIMEFLD,TIME_FIX,\"\",\"\","));
		aMacStr += String::CreateFromInt32( nTimeFmt );
		aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					")\n"
					"    END IF\n"));
	}
	if (bDelUmbr)
	{
		aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					"    REM Loeschen des harten Seitenumbruchs\n"
					"    IF ThisWindow.Selection.JumpToBookmark(\"Umbruch\") THEN\n"
					"        ThisWindow.Selection.DeleteBookmark(\"Umbruch\")\n"
					"        ThisWindow.Selection.Delete()\n"
					"    END IF\n"));
	}
	// Loeschen der aus der Vorlage geerbten Description
	aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
				"    REM Loeschen der aus der Vorlage geerbten Doc-Beschreibung\n"
				"    ThisDocument.DocumentInfo.Description = \"\"\n"
	// Macro zum springen zum Textanfang
				"    REM Zum Textbeginn springen und die Zeile dort markieren\n"
				"    IF ThisWindow.Selection.JumpToBookmark(\"Text\") THEN\n"
				"        ThisWindow.Selection.DeleteBookmark(\"Text\")\n"
				"        ThisWindow.Selection.GotoEndOfLine(TRUE)\n"
				"    END IF\n"));
	bRet = AssignMacro( aMacStr, aMacNam, aLibNam, C2S("Create"),
						SFX_EVENT_CREATEDOC );
	return bRet;
}

String WizardGo::GetDocInfoMacroStr( const String& rStr, BOOL bFeld,
									BOOL bGoDown )
{
	String aStr;
	if (bFeld)
	{
		aStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
			"    a$=ThisWindow.Selection.GetDatabaseFieldValue(\"\", \"\", \""));
		aStr += rStr;
		aStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM("\")\n"));
	}
	else
	{
		aStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
				"    a$=\"\"\n"
				"    ThisWindow.Selection.GoLeft()\n"		// evtl Selektion entfernen
				"    IF ThisWindow.Selection.JumpToBookmark(\""));
		aStr += rStr;
		aStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM("\") THEN\n"));

		if (bGoDown)
			aStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
				"        ThisWindow.Selection.GoDown(1)\n"));

		aStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
				"        IF ThisWindow.Selection.IsStartOfPara()=0 THEN\n"
				"            ThisWindow.Selection.GotoStartOfPara()\n"
				"        END IF\n"
				"        IF ThisWindow.Selection.IsEndOfPara()=0 THEN\n"
				"            ThisWindow.Selection.GotoEndOfPara(TRUE)\n"
				"            a$=ThisWindow.Selection.Value\n"
				"            ThisWindow.Selection.GoLeft()\n"
				"        END IF\n"
				"    END IF\n"));
	}
	return aStr;
}

BOOL WizardGo::SetSaveMacro( WizardDokuDlg& rDoku,
							BOOL bMarker1Down, BOOL bMarker2Down )
{
	BOOL bRet=TRUE;
	if( rDoku.pD_List_InfTit->GetSelectEntryPos() ||
		rDoku.pD_List_InfTem->GetSelectEntryPos() )
	{
		String aCode;
		String aLibNam( rDoku.pD_Edit_VorNam->GetText() );
		String aMacNam( aLibNam );
		aMacNam.AppendAscii("_Save");
		ValidateMacroName( aMacNam );

		String aMacStr( C2S("    ThisWindow.Selection.InsertBookmark(\"JoeSaveLabel\")\n" ));

		if( rDoku.pD_List_InfTit->GetSelectEntryPos() )
		{
			String aStr(rDoku.pD_List_InfTit->GetSelectEntry());
			BOOL bIsDBFeld = rDoku.IsDocInfoDBFeldSelected( 0 );
			if (!bIsDBFeld)
				aStr.AssignAscii( RTL_CONSTASCII_STRINGPARAM("Titel"));
			aMacStr += GetDocInfoMacroStr( aStr, bIsDBFeld, bMarker1Down );
			aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
				"    ThisDocument.DocumentInfo.Title = a$\n"));
		}

		if( rDoku.pD_List_InfTem->GetSelectEntryPos() )
		{
			String aStr(rDoku.pD_List_InfTem->GetSelectEntry());
			BOOL bIsDBFeld = rDoku.IsDocInfoDBFeldSelected(1);
			if (!bIsDBFeld)
				aStr.AssignAscii( RTL_CONSTASCII_STRINGPARAM("Thema"));
			aMacStr += GetDocInfoMacroStr( aStr, bIsDBFeld, bMarker2Down );
			aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					"    ThisDocument.DocumentInfo.Subject = a$\n"));
		}
		aMacStr.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					"    IF ThisWindow.Selection.JumpToBookmark(\"JoeSaveLabel\") THEN\n"
					"        ThisWindow.Selection.DeleteBookmark(\"JoeSaveLabel\")\n"
					"    END IF\n"));
		bRet = AssignMacro( aMacStr, aMacNam, aLibNam, C2S("Save"), SFX_EVENT_SAVEDOC, &aCode );
		if ( bRet )
		{
			SfxEventConfiguration* pECfg = SFX_APP()->GetEventConfig();
			pECfg->ConfigureEvent( SFX_EVENT_SAVEASDOC,
									SvxMacro( aCode, aEmptyStr, STARBASIC ),
									pShell->GetView().GetDocShell() );
		}
	}
	return bRet;
}


/*************************************************************************

	  $Log: wizgo3.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.75  2000/09/18 16:06:23  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.74  2000/09/14 08:24:09  os
	  GetSbxObject - DBG_ERROR removed
	
	  Revision 1.73  2000/09/06 08:10:51  os
	  debug code corrected
	
	  Revision 1.72  2000/06/07 14:46:29  os
	  using UCB

	  Revision 1.71  2000/05/23 20:07:33  jp
	  Bugfixes for Unicode

	  Revision 1.70  2000/05/10 11:54:02  os
	  Basic API removed

	  Revision 1.69  2000/04/19 11:18:59  os
	  UNICODE

	  Revision 1.68  2000/02/11 15:02:11  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.67  1999/08/05 11:50:08  JP
	  Bug #68039#: StarDiv -> Sun


	  Rev 1.66   05 Aug 1999 13:50:08   JP
   Bug #68039#: StarDiv -> Sun

	  Rev 1.65   09 Jul 1998 17:14:12   MA
   muss: kein docman mehr

	  Rev 1.64   26 May 1998 10:44:54   OM
   #49590 Dokinfo auch bei SaveAs fuellen

	  Rev 1.63   08 Jan 1998 17:47:52   OM
   Neue Datumsfelder einfuegen

	  Rev 1.62   24 Nov 1997 10:58:34   MA
   includes

	  Rev 1.61   03 Nov 1997 14:01:44   MA
   precomp entfernt

	  Rev 1.60   05 Sep 1997 15:58:42   OM
   #43480# Alle Datumsformate zulassen

	  Rev 1.59   23 Jul 1997 21:56:02   HJS
   includes

	  Rev 1.58   05 May 1997 15:25:06   OM
   #39588# Basic-Laufzeitfehler behoben

	  Rev 1.57   07 Mar 1997 16:51:12   OM
   DocManPath entfernt

	  Rev 1.56   31 Jan 1997 16:27:38   JP
   Bug #35358#: JumpToBookmark returnt jetzt einen BOOL

	  Rev 1.55   18 Dec 1996 14:42:18   MIB
   Macro-Unstellung am SFX

	  Rev 1.54   24 Oct 1996 13:36:50   JP
   String Umstellung: [] -> GetChar()

	  Rev 1.53   19 Sep 1996 14:33:24   OM
   Datenbank Basicanbindung

	  Rev 1.52   29 Aug 1996 09:04:48   OS
   includes

	  Rev 1.51   08 Aug 1996 14:00:28   JP
   AssignMacro: Bug im SFX umgangen

	  Rev 1.50   13 Apr 1996 15:19:54   JP
   BasicMakros: Delete -> thisDoc.Text.Delete

	  Rev 1.49   30 Jan 1996 14:13:48   OS
   Selection. gegen ThisWindow.Selection ausgetauscht

	  Rev 1.48   22 Dec 1995 21:04:38   JP
   BugFix im CreateMakro

	  Rev 1.47   22 Dec 1995 19:48:28   JP
   SaveAs auf ThisDocument, DocInfo steht endlich zur Verfuegung

	  Rev 1.46   16 Dec 1995 20:26:22   JP
   Makros auf den akt. Stand gebracht

	  Rev 1.45   01 Dec 1995 19:18:28   JP
   Bug 22645: beim CLOSE muss die Kanalnummer mit einem Hash anfangen

	  Rev 1.44   24 Nov 1995 16:59:22   OM
   PCH->PRECOMPILED

	  Rev 1.43   21 Nov 1995 19:54:52   JP
   BasicMakro: INPUT file -> LINEINPUT file - komplette Zeile aus dem File lesen

	  Rev 1.42   21 Nov 1995 08:13:20   OS
   Basic: GotoBookmark heisst jetzt JumpTo...

*************************************************************************/


