/*************************************************************************
 *
 *  $RCSfile: wizgo4.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif


#include "wrtsh.hxx"     // Writershell
#include "fldmgr.hxx"    // Datenbankfeld einfuegen
#include "dbmgr.hxx"     // SwDBMgr, der Datanbankmanager
#include "fldbas.hxx"    // Irrtum, TYP_DBFLD hier..
#include "dbfld.hxx"     // SwDBFieldType
#include "wizgo.hxx"

void WizardGo::AssignDBas(const String& rDBName, const String& rDBTable)
{
#ifdef REPLACE_OFADBMGR
	if(pDBas->OpenDataSource( rDBName, rDBTable))
	{
		String sDBName(rDBName);
		sDBName += DB_DELIM;
		sDBName += rDBTable;
		pShell->ChgDBName(sDBName);
	}
#else
	String sDBName(rDBName);
	sDBName += DB_DELIM;
	sDBName += rDBTable;

	pDBas = new SwNewDBMgr;
	if( pDBas->OpenDB(DBMGR_STD, sDBName))
		pShell->ChgDBName(sDBName);
#endif
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

// Einfuegen eines String als DB-Feld
void WizardGo::InsDBasFld(const String& rStr)
{
	SwFldMgr aFldMgr;
	USHORT nPos = 0;
	String sFld = SFX_APP()->LocalizeDBName(NATIONAL2INI,
										rStr.GetToken(0, DB_DELIM, nPos));
	sFld += rStr.Copy(nPos > 0 ? nPos - 1 : 0);

	aFldMgr.InsertFld( TYP_DBFLD, 0, rStr, aEmptyStr, 0, pShell );
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////


/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizgo4.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizgo4.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.29  2000/09/18 16:06:23  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.28  2000/07/18 12:50:09  os
	  replace ofadbmgr
	
	  Revision 1.27  2000/06/30 08:52:05  os
	  #76541# string assertions removed

	  Revision 1.26  1999/06/09 17:33:14  JP
	  have to change: no cast from GetpApp to SfxApp/OffApp, SfxShell only subclass of SfxApp


	  Rev 1.25   09 Jun 1999 19:33:14   JP
   have to change: no cast from GetpApp to SfxApp/OffApp, SfxShell only subclass of SfxApp

	  Rev 1.24   24 Nov 1997 10:58:42   MA
   includes

	  Rev 1.23   07 Nov 1997 09:38:18   JP
   fstream include entfernt

	  Rev 1.22   03 Nov 1997 14:01:38   MA
   precomp entfernt

	  Rev 1.21   06 Aug 1997 15:28:30   TRI
   VCL: GetpApp() statt pApp

	  Rev 1.20   13 Mar 1997 16:29:22   OM
   DB-Feldbefehle korrekt erkennen

	  Rev 1.19   11 Feb 1997 16:52:38   OM
   Eingabefeld ueber Basic ohne Dialog einfuegen

	  Rev 1.18   25 Sep 1996 14:12:36   OM
   Neue Datenbanktrenner

	  Rev 1.17   29 Aug 1996 09:04:50   OS
   includes

	  Rev 1.16   28 Aug 1996 14:59:26   OM
   Datenbankumstellung

	  Rev 1.15   18 Apr 1996 16:31:22   OM
   Datenbankumstellung: Basic-Entkopplung

	  Rev 1.14   04 Apr 1996 12:03:20   OM
   patches legalisiert

	  Rev 1.13   20 Dec 1995 15:37:04   OM
   Wandlung Address<->Adressen

	  Rev 1.12   24 Nov 1995 16:59:18   OM
   PCH->PRECOMPILED

	  Rev 1.11   18 Oct 1995 18:38:58   JP
   FldMgr: immer die WrtShell uebergeben (auf richtigen Document arbeiten!)

	  Rev 1.10   18 Sep 1995 14:12:42   OS
   geht wieder mit PCH

	  Rev 1.9   04 Aug 1995 18:40:12   JP
   Datenbank wieder angebunden

	  Rev 1.8   29 Jul 1995 23:35:36   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.7   09 Jun 1995 14:26:40   OM
   Alten DB-Manager entfernt

*************************************************************************/

