/*************************************************************************
 *
 *  $RCSfile: wizini.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SFX_INIMGR_HXX
#include <sfx2/inimgr.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SWTYPES_HXX
#include <swtypes.hxx>
#endif
#ifndef _WIZINI_HXX
#include <wizini.hxx>
#endif
#ifndef _WIZDOKU_HXX
#include <wizdoku.hxx>
#endif

#define ALIGNTAB_SZ 9


//collectn.cxx
BOOL lcl_IsNumeric(const String& rStr);
#define C2S(cChar) UniString::CreateFromAscii(cChar)

char __READONLY_DATA
	sAlign_Null[] = "Null",
	sAlign_LiOb[] = "LiOb",
	sAlign_MiOb[] = "MiOb",
	sAlign_ReOb[] = "ReOb",
	sAlign_LiUn[] = "LiUn",
	sAlign_ReUn[] = "ReUn",
	sAlign_Mitt[] = "Mitt",
	sAlign_ReMg[] = "ReMg",
	sAlign_LiMg[] = "LiMg";


struct
#ifdef GCC
AlignTab_t
#endif
{
	PageAlign eAlignType;
	const char* pAlignNm;
}
#ifdef GCC
;
	__READONLY_DATA AlignTab_t aAlignTab[ ALIGNTAB_SZ ] =
#else
	__READONLY_DATA aAlignTab[ ALIGNTAB_SZ ] =
#endif
{
		ALIGN_Null,   sAlign_Null,
		ALIGN_LiOb,   sAlign_LiOb,
		ALIGN_MiOb,   sAlign_MiOb,
		ALIGN_ReOb,   sAlign_ReOb,
		ALIGN_LiUn,   sAlign_LiUn,
		ALIGN_ReUn,   sAlign_ReUn,
		ALIGN_Mitt,   sAlign_Mitt,
		ALIGN_ReMg,   sAlign_ReMg,
		ALIGN_LiMg,   sAlign_LiMg
	};

char __READONLY_DATA
	sStil[] = "Stil",
	sDenGibsNich[] = "Den~gibs~nich",
	sVis[] = "Vis",
	sPos[] = "Pos",
	sAln[] = "Aln",
	sStr[] = "Str",
	sGrf[] = "Grf",
	sNam[] = "Nam",
	sFlt[] = "Flt",
	sInfoTitl[] = "InfoTitl",
	sInfoThem[] = "InfoThem",
	sVorlgNam[] = "VorlgNam",
	sVorlgInf[] = "VorlgInf",
	sAutoFNam[] = "AutoFNam",
	sAutoPath[] = "AutoPath";


////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

inline sal_Unicode Bool2Str( BOOL bFlg )
{
	return bFlg ? 'J' : 'N';
}

BOOL Str2Bool(const String& rStr, BOOL& bFlg)
{
	BOOL bRet = TRUE;
	switch( rStr.GetChar(0))
	{
		case 'Y':	bFlg = TRUE;  break;
		case 'J':	bFlg = TRUE;  break;
		case 'N':	bFlg = FALSE; break;
		default: 	bRet = FALSE;
	}
	return bRet;
}

#if (EINHEIT!=10)
!!! neu anpassen !!!
#endif
String Metr2Str(long nVal)
{
	String aStr( nVal );
	if ( aStr.Len() < 1 )
		aStr.Insert( '0', 0 );
	aStr.Insert( '.', USHORT( aStr.Len() - 1 ) );
	return aStr;
}

#if (EINHEIT!=10)
!!! neu anpassen !!!
#endif
BOOL Str2Metr( const String& rStr, long& rVal )
{
	BOOL bRet = FALSE;
	if( rStr.Len() >= 3 && '.' == rStr.GetChar( rStr.Len()-2 ) )
	{
		// mind. "0.0"
		String aStr( rStr );
		aStr.Erase( USHORT(aStr.Len()-2),1);
		if( lcl_IsNumeric(aStr) )
		{ // Negative darf's dann eben nicht geben
			rVal = aStr.ToInt32();
			bRet = TRUE;
		}
	}
	return bRet;
}

inline const char* Algn2Str( PageAlign eAlgn )
{
	return aAlignTab[ eAlgn ].pAlignNm;
}

BOOL Str2Algn( const String& rStr, PageAlign& rAlgn )
{
	for( int i = 0; i < ALIGNTAB_SZ; ++i )
		if( rStr.EqualsAscii(aAlignTab[ i ].pAlignNm) )
		{
			rAlgn = (PageAlign)i;
			return TRUE;
		}
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

String lcl_GetPathToWizzardDir()
{
static char __READONLY_DATA cWizIni[] = "wizard.ini";
	String sRet( C2S(cWizIni) );
	SfxIniManager* pIniManager = SFX_INIMANAGER();
	if( !pIniManager->SearchFile( sRet, SFX_KEY_USERCONFIG_PATH ))
	{
		sRet.Insert( INET_PATH_TOKEN, 0 );
		sRet.Insert( pIniManager->Get( SFX_KEY_USERCONFIG_PATH ), 0 );
	}
	return sRet;
}

WizardIni::WizardIni( const String& rSection )
	: Config( ::lcl_GetPathToWizzardDir() )
{
	SetGroup( ByteString(rSection, gsl_getSystemTextEncoding()) );
}

void WizardIni::WritStil(const RadioButton& rBtn1, const RadioButton& rBtn2, const RadioButton& rBtn3)
{
	char c = rBtn2.IsChecked() ? '2'
				: rBtn3.IsChecked() ? '3' : '1';
	WriteKey( sStil, c );
}

BOOL WizardIni::ReadStil(RadioButton& rBtn1, RadioButton& rBtn2, RadioButton& rBtn3)
{
	BOOL bRet = TRUE;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	ByteString aBytString(sStil, eEnc );
	ByteString aReadKey = ReadKey( aBytString );
	UniString  aUniString(aReadKey, eEnc);
	String aStr( aUniString );
//	String aStr( UniString(ReadKey( ByteString(sStil, eEnc ) ), eEnc));
	switch( aStr.GetChar( 0 ) )
	{
		case '1': rBtn1.Check(); break;
		case '2': rBtn2.Check(); break;
		case '3': rBtn3.Check(); break;
		default: bRet = FALSE;
	}
	return bRet;
}

void WizardIni::WritText( const String& rKey, BOOL bSwt, const String& rStr )
{
	String aStr( Bool2Str( bSwt ) );
	aStr += ',';
	aStr += rStr;
	WriteKey( ByteString(rKey, gsl_getSystemTextEncoding()), ByteString(aStr, gsl_getSystemTextEncoding()) );
}

BOOL WizardIni::ReadText(const String& rKey, BOOL& rSwt, String& rStr)
{
	BOOL bRet = FALSE;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	ByteString aBytString(rKey, eEnc );
	ByteString aReadKey = ReadKey( aBytString );
	UniString  aUniString(aReadKey, eEnc);
	String aStr( aUniString );
//	String aStr( UniString(ReadKey( ByteString(rKey, eEnc) ), eEnc ));
	if( 1 == aStr.Search(',') )
	{
		String aFlg( aStr );
		BOOL bFlg;
		aFlg.Erase( 1 );		// nu sollte noch ein "J" oder "N" ber sein
		aStr.Erase( 0 , 2 );    // Flag und Komma weg
		if( 1 == aFlg.Len() && Str2Bool( aFlg, bFlg ) )
		{
			rSwt = bFlg;  // Scheinbar alles ok
			rStr = aStr;  // -> Datenuebernahme
			bRet = TRUE;
		}
	}
	return bRet;
}

BOOL WizardIni::ReadText(const String& rKey, CheckBox& rChk, Edit& rEdt)
{
	BOOL bFlg;
	String aStr;
	BOOL bRet = ReadText( rKey, bFlg, aStr );
	if (bRet)
	{
		rChk.Check( bFlg );
		rEdt.SetText( aStr );
	}
	return bRet;
}

BOOL WizardIni::ReadText(const String& rKey, BOOL& rSwt, Edit& rEdt)
{
	String aStr;
	BOOL bRet = ReadText( rKey, rSwt, aStr );
	if( bRet )
		rEdt.SetText( aStr );
	return bRet;
}

BOOL WizardIni::ReadText(const String& rKey, Edit& rEdt)
{
	String aStr;
	BOOL bRet = ReadText(rKey,aStr);
	if (bRet)
		rEdt.SetText(aStr);
	return bRet;
}

void WizardIni::WritText(const String& rKey, const String& rStr)
{
	USHORT nAnz = CountLines( rStr );
	String aStr;
	for( USHORT i = 0; i < nAnz; ++i )
	{
		if( i )
			aStr += '|';
		aStr += GetLine( rStr, i );
	}
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), ByteString(aStr, eEnc));
}

BOOL WizardIni::ReadText(const String& rKey, String& rStr)
{
	BOOL bRet = FALSE;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	ByteString aBytString(rKey, eEnc );
	const ByteString a2ndByteString(sDenGibsNich);
	ByteString aReadKey = ReadKey( aBytString, a2ndByteString );
	UniString  aUniString(aReadKey, eEnc);
	String aStr( aUniString );
	if( aStr != C2S(sDenGibsNich) )
	{
		rStr = aEmptyStr;
		USHORT i = 0, nPos;
		while( STRING_NOTFOUND != ( nPos = aStr.Search( '|' ) ) )
		{
			if( i++ )
				rStr.AppendAscii(NEWLINE);
			rStr += aStr.Copy( 0, nPos );
			aStr.Erase( 0, nPos );
			aStr.Erase( 0, 1 );
		}
		if( i )
			rStr.AppendAscii(NEWLINE);
		rStr += aStr;
		bRet = TRUE;
	}
	return bRet;
}

void WizardIni::WritText(const String& rKey, WizardText& rFrame)
{
	WritText( rKey, rFrame.GetStr() );
}

BOOL WizardIni::ReadText(const String& rKey, WizardText& rFrame)
{
	String aStr;
	BOOL bRet = FALSE;
	if( ReadText( rKey, aStr ) )
	{
		rFrame.SetStr( aStr );
		bRet = TRUE;
	}
	return bRet;
}

////////////////////////////////////////////////////////////////////////////////

void WizardIni::WritFNam(const String& rKey, const String& rStr)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), ByteString(rStr, eEnc) );
}

BOOL WizardIni::ReadFNam(const String& rKey, String& rStr)
{
	BOOL bRet = FALSE;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	ByteString aBytString(rKey, eEnc );
	ByteString aReadKey = ReadKey( aBytString, sDenGibsNich );
	UniString  aUniString(aReadKey, eEnc);
	String aStr( aUniString );
//	String aStr( UniString(ReadKey( ByteString(rKey, eEnc), sDenGibsNich ), eEnc) );
	if( !aStr.EqualsAscii(sDenGibsNich) )
	{
		rStr = aStr;
		bRet = TRUE;
	}
	return bRet;
}

////////////////////////////////////////////////////////////////////////////////

void WizardIni::WritFlag(const String& rKey, BOOL bOn)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), Bool2Str( bOn ) );
}

BOOL WizardIni::ReadFlag(const String& rKey, BOOL& rOn)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	return Str2Bool( UniString(ReadKey( ByteString(rKey, eEnc) ), eEnc), rOn );
}

BOOL WizardIni::ReadFlag(const String& rKey, CheckBox& rChk)
{
	BOOL bFlg;
	BOOL bRet = ReadFlag( rKey, bFlg );
	if( bRet )
		rChk.Check( bFlg );
	return bRet;
}

BOOL WizardIni::ReadFlag( const String& rKey, RadioButton& rBtn )
{
	BOOL bFlg;
	BOOL bRet = ReadFlag( rKey, bFlg );
	if (bRet)
		rBtn.Check( bFlg );
	return bRet;
}

void WizardIni::WritMetr( const String& rKey, long nVal )
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), ByteString(Metr2Str( nVal ), eEnc ));
}

BOOL WizardIni::ReadMetr( const String& rKey, long& rVal )
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	return Str2Metr( UniString(ReadKey( ByteString(rKey, eEnc) ), eEnc), rVal );
}

void WizardIni::WritZahl( const String& rKey, USHORT nVal )
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, gsl_getSystemTextEncoding()), ByteString::CreateFromInt32( nVal ) );
}

BOOL WizardIni::ReadZahl(const String& rKey, USHORT& rVal)
{
	BOOL bRet = FALSE;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	ByteString aBytString(rKey, eEnc );
	ByteString aReadKey = ReadKey( aBytString );
	UniString  aUniString(aReadKey, eEnc);
	String aStr( aUniString );
//	String aStr( UniString(ReadKey(ByteString(rKey, eEnc) ), eEnc ));
	if( aStr.Len() && lcl_IsNumeric(aStr) )
	{
		rVal = aStr.ToInt32();
		bRet = TRUE;
	}
	return bRet;
}

////////////////////////////////////////////////////////////////////////////////

void WizardIni::WritList(const String& rKey, ListBox& rList, BOOL bNum)
{
	String aStr;
	if( bNum )
		aStr = String::CreateFromInt32(rList.GetSelectEntryPos());
	else
		aStr = rList.GetSelectEntry();
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), ByteString(aStr, eEnc) );
}

BOOL WizardIni::ReadList(const String& rKey, ListBox& rList, BOOL bNum)
{
	BOOL bRet;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	String aStr( ReadKey( ByteString(rKey, eEnc ) ), eEnc);
	if( !aStr.Len() )
		bRet = FALSE;
	else
	{
		bRet = TRUE;
		if( !bNum )
			rList.SelectEntry( aStr );
		else if( lcl_IsNumeric(aStr) )
			rList.SelectEntryPos( aStr.ToInt32() );
		else
			bRet = FALSE;
	}
	return bRet;
}

BOOL WizardIni::ReadList(const String& rKey, CheckBox& rChk, ListBox& rList, BOOL bNum)
{
	BOOL bFlg, bRet = ReadList( rKey, bFlg, rList, bNum );
	if( bRet )
		rChk.Check( bFlg );
	return bRet;
}

void WizardIni::WritList( const String& rKey, BOOL bSwt,
							ListBox& rList, BOOL bNum )
{
	String aStr( Bool2Str( bSwt ) );
	aStr += ',';
	if( bNum )
		aStr += String::CreateFromInt32(rList.GetSelectEntryPos());
	else
		aStr += rList.GetSelectEntry();
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), ByteString(aStr, eEnc) );
}

BOOL WizardIni::ReadList(const String& rKey, BOOL& rSwt, ListBox& rList, BOOL bNum)
{
	BOOL bRet, bFlg;
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	String aStr( ReadKey( ByteString(rKey, eEnc) ), eEnc );

	if( 2 != aStr.GetTokenCount(',') )
		bRet = FALSE;
	else if( !Str2Bool( aStr.GetToken( 0, ',' ), bFlg ) )
		bRet = FALSE;
	else if( (aStr = aStr.GetToken( 1, ',' ) ).Len() )
	{
		bRet = TRUE;
		if( !bNum )
			rList.SelectEntry( aStr );
		else if( lcl_IsNumeric(aStr) )
			rList.SelectEntryPos( aStr.ToInt32() );
		else
			bRet = FALSE;

		if( bRet )
			rSwt = bFlg;
	}
	else
		bRet = FALSE;

	return bRet;
}

////////////////////////////////////////////////////////////////////////////////

void WizardIni::WritAlgn(const String& rKey, PageAlign eAlgn)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(rKey, eEnc), ByteString(Algn2Str( eAlgn ), eEnc) );
}

BOOL WizardIni::ReadAlgn(const String& rKey, PageAlign& rAlgn)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	return Str2Algn( String(ReadKey( ByteString(rKey, eEnc) ), eEnc), rAlgn );
}

void WizardIni::WritFram(const String& rKeyPre, WizardText& rFrame, BOOL bString)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	String aStr;
	String aKey( rKeyPre );             ////
	aKey.AppendAscii(sVis);                        // Visible
	aStr = Bool2Str( rFrame.IsVisible() );  //
	WriteKey( ByteString(aKey, eEnc), ByteString(aStr, eEnc) );              ////

	aKey = rKeyPre;                ////
	aKey.AppendAscii(sPos);                   // Position

	aStr = Metr2Str(rFrame.PosX);    // und
	aStr += ',';                     // Groesse
	aStr += Metr2Str(rFrame.PosY);   //
	aStr += ',';                     //
	aStr += Metr2Str(rFrame.SizX);   //
	aStr += ',';                     //
	aStr += Metr2Str(rFrame.SizY);   //
	WriteKey( ByteString(aKey, eEnc), ByteString(aStr, eEnc) );         ////

	aKey = rKeyPre;                      ////
	aKey.AppendAscii(sAln);                         // Alignment
	aStr = C2S(Algn2Str(rFrame.GetAlign()));   // und
	aStr += ',';                           // dazugehoerige
	aStr += Metr2Str(rFrame.RandL);        // Abstaende
	aStr += ',';                           //
	aStr += Metr2Str(rFrame.RandO);        //
	aStr += ',';                           //
	aStr += Metr2Str(rFrame.RandR);        //
	aStr += ',';                           //
	aStr += Metr2Str(rFrame.RandU);        //
	WriteKey( ByteString(aKey, eEnc), ByteString(aStr, eEnc) );               ////

	if( bString )               ////
	{
		aKey = rKeyPre;              // Text
		aKey.AppendAscii(sStr);               //
		aStr = rFrame.GetStr();      //
		WritText( aKey, aStr );       //
	}                            ////
}

BOOL WizardIni::ReadFram(const String& rKeyPre, WizardText& rFrame, BOOL bString)
{
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	BOOL bRet = FALSE;
	long xo,yo,xs,ys,li,ob,re,un;
	PageAlign eAlgn;
	BOOL bVisi;
	String aString, aStr;
	String aKey( rKeyPre );

	do {		// middle check loop

		aKey.AppendAscii(sVis);
		if( !Str2Bool( String(ReadKey( ByteString(aKey, eEnc) ), eEnc), bVisi ) )
			break;

		aKey = rKeyPre;
		aKey.AppendAscii(sPos);
		aStr = String(ReadKey( ByteString(aKey, eEnc) ), eEnc);
		if( 4 != aStr.GetTokenCount(',') )
			break;
		if( !Str2Metr( aStr.GetToken( 0,','), xo ) )
			break;
		if( !Str2Metr( aStr.GetToken( 1,','), yo ) )
			break;
		if( !Str2Metr( aStr.GetToken( 2,','), xs ) )
			break;
		if( !Str2Metr( aStr.GetToken( 3,','), ys ) )
			break;

		aKey = rKeyPre;
		aKey.AppendAscii(sAln);
		aStr = String(ReadKey( ByteString(aKey, eEnc) ), eEnc);
		if( 5 != aStr.GetTokenCount( ',' ) )
			break;
		if( !Str2Algn( aStr.GetToken( 0, ',' ), eAlgn ) )
			break;
		if( !Str2Metr( aStr.GetToken( 1, ',' ), li ) )
			break;
		if( !Str2Metr( aStr.GetToken( 2, ',' ), ob ) )
			break;
		if( !Str2Metr( aStr.GetToken( 3, ',' ), re ) )
			break;
		if( !Str2Metr( aStr.GetToken( 4, ',' ), un ) )
			break;

		if( bString )
		{
			aKey = rKeyPre;
			aKey.AppendAscii(sStr);
			if( !ReadText( aKey, aString ))
				break;
		}

		// Datenuebernahme
		rFrame.PosX = xo;
		rFrame.PosY = yo;
		rFrame.SizX = xs;
		rFrame.SizY = ys;
		rFrame.RandL = li;
		rFrame.RandO = ob;
		rFrame.RandR = re;
		rFrame.RandU = un;
		rFrame.SetAlign( eAlgn );
		if( bString )
			rFrame.SetStr( aString );

		bRet = TRUE;
	} while( FALSE );
	return bRet;
}

void WizardIni::WritLogo(const String& rKeyPre, WizardLogo& rLogo)
{
	WritFram( rKeyPre, rLogo );
	String aKey( rKeyPre );
	aKey.AppendAscii(sGrf);
	String aStr( Bool2Str( rLogo.IsGrafLogo() ) );
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	WriteKey( ByteString(aKey, eEnc), ByteString(aStr, eEnc) );

	String aFlt;
	if( rLogo.GetGraphic( aStr, aFlt ) )
	{
		aKey = rKeyPre;
		aKey.AppendAscii(sNam);
		WritFNam( aKey, aStr );
		aKey = rKeyPre;
		aKey.AppendAscii(sFlt);
		WriteKey( ByteString(aKey, eEnc), ByteString(aFlt, eEnc) );
	}
}

BOOL WizardIni::ReadLogo(const String& rKeyPre, WizardLogo& rLogo)
{
	if( !ReadFram( rKeyPre, rLogo ) )
		return FALSE;

	BOOL bRet = FALSE;
	String aFNam;
	String aFilt;
	BOOL   bGraf;
	String aKey( rKeyPre );
	aKey.AppendAscii(sGrf);
	rtl_TextEncoding eEnc = gsl_getSystemTextEncoding();
	String aStr( ReadKey( ByteString(aKey, eEnc) ), eEnc );

	if( Str2Bool( aStr, bGraf ) )
		do { 		// middle check loop
			bRet = TRUE;
			rLogo.SetModeGraf( 0, bGraf );

			aKey = rKeyPre;
			aKey.AppendAscii(sNam);
			if( !ReadFNam( aKey, aFNam ) )
				break;

			aKey = rKeyPre;
			aKey.AppendAscii(sFlt);
			if( !ReadText( aKey, aFilt ) )
				break;

			rLogo.SetGraphic( aFNam, aFilt );
		} while( FALSE );

	return bRet;
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void WizardIni::WritDoku( WizardDokuDlg& rDoku )
{
	WritList( C2S(sInfoTitl), *rDoku.pD_List_InfTit );
	WritList( C2S(sInfoThem), *rDoku.pD_List_InfTem );
	WritText( C2S(sVorlgNam), *rDoku.pD_Edit_VorNam );
	WritText( C2S(sVorlgInf), *rDoku.pD_Edit_VorInf );
	WritText( C2S(sAutoFNam), *rDoku.pD_CBox_AutoFN, *rDoku.pD_Edit_AutoFN );
	WritText( C2S(sAutoPath), rDoku.pD_Text_Folder->GetText() );
}

BOOL WizardIni::ReadDoku( WizardDokuDlg& rDoku )
{
	BOOL bRet = FALSE;
	do {		// middle check loop
		if( !ReadList( C2S(sInfoTitl), *rDoku.pD_List_InfTit ) )
			break;
		if( !ReadList( C2S(sInfoThem), *rDoku.pD_List_InfTem ) )
			break;
		if( !ReadText( C2S(sVorlgNam), *rDoku.pD_Edit_VorNam ) )
			break;
		if( !ReadText( C2S(sVorlgInf), *rDoku.pD_Edit_VorInf ) )
			break;
		if( !ReadText( C2S(sAutoPath), *rDoku.pD_CBox_AutoFN, *rDoku.pD_Edit_AutoFN ) )
			break;
		String sTxt;
		if( !ReadText( C2S(sAutoPath), sTxt ) )
			break;
		rDoku.pD_Text_Folder->SetText(sTxt);

		 bRet = TRUE;
	} while( FALSE );
	return bRet;
}

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/Attic/wizini.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizini.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.35  2000/09/18 16:06:23  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.34  2000/09/04 13:39:11  os
	  #78436# create ByteString from char*
	
	  Revision 1.33  2000/06/27 07:55:47  obo
	  #65293#
	
	  Revision 1.32  2000/06/07 14:46:29  os
	  using UCB
	
	  Revision 1.31  2000/04/19 11:18:59  os
	  UNICODE

	  Revision 1.30  1999/10/21 17:44:42  jp
	  have to change - SearchFile with SfxIniManager, dont use SwFinder for this

	  Revision 1.29  1999/04/08 08:51:46  JP
	  Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)


	  Rev 1.28   08 Apr 1999 10:51:46   JP
   Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)

	  Rev 1.27   09 Jul 1998 17:14:12   MA
   muss: kein docman mehr

	  Rev 1.26   27 Jan 1998 18:49:18   HR
   Alten HP9000 Krams entfernt

	  Rev 1.25   24 Nov 1997 10:58:36   MA
   includes

	  Rev 1.24   03 Nov 1997 14:01:40   MA
   precomp entfernt

	  Rev 1.23   07 Mar 1997 16:51:12   OM
   DocManPath entfernt

	  Rev 1.22   24 Oct 1996 13:36:54   JP
   String Umstellung: [] -> GetChar()

	  Rev 1.21   29 Aug 1996 09:04:40   OS
   includes

	  Rev 1.20   11 Apr 1996 19:12:34   MA
   opt: unbenutzes entfernt

	  Rev 1.19   03 Apr 1996 11:28:14   sdo
   HPUX

	  Rev 1.18   20 Mar 1996 13:55:34   HJS
   { aus ifdef raus

	  Rev 1.17   29 Feb 1996 09:31:16   mk
   GCC

	  Rev 1.16   24 Nov 1995 16:59:22   OM
   PCH->PRECOMPILED

	  Rev 1.15   07 Nov 1995 18:14:50   MA
   opt/fix/chg: statics und segs

	  Rev 1.14   23 Aug 1995 10:02:28   SWG
   Nacharbeit UNX-Port

	  Rev 1.13   21 Aug 1995 05:49:38   mk
   HP9000 (MDA)

	  Rev 1.12   29 Jul 1995 23:35:20   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.11   21 Mar 1995 15:43:36   ER
   getpathtowizzarddir() statt getinifilewizzard()

*************************************************************************/


