/*************************************************************************
 *
 *  $RCSfile: wizini.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _WIZINI_HXX
#define _WIZINI_HXX

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#include "wizenum.hxx"

class WizardDokuDlg;
class WizardLogo;
class WizardText;

class WizardIni: public Config
{
public:
	WizardIni(const String& rSection);

	void WritText(const String& rKey, const String& rStr );
	BOOL ReadText(const String& rKey, String& rStr );

	void WritText(const String& rKey, const Edit& rEdt)
		{ WritText( rKey, rEdt.GetText() ); }
	BOOL ReadText(const String& rKey, Edit& rEdt);

	void WritText(const String& rKey, BOOL bSwt, const String& rStr );
	BOOL ReadText(const String& rKey, BOOL& rSwt, String& rStr );

	void WritText(const String& rKey, BOOL bSwt, const Edit& rEdt)
		{ WritText( rKey, bSwt, rEdt.GetText() ); }
	BOOL ReadText(const String& rKey, BOOL& rSwt, Edit& rEdt);

	void WritText(const String& rKey, CheckBox& rChk, const Edit& rEdt)
		{ WritText( rKey, rChk.IsChecked(), rEdt.GetText() ); }
	BOOL ReadText(const String& rKey, CheckBox& rChk, Edit& rEdt);

	void WritFlag(const String& rKey, BOOL bOn);
	BOOL ReadFlag(const String& rKey, BOOL& rOn);

	void WritFlag(const String& rKey, CheckBox& rChk)
		{	WritFlag( rKey, rChk.IsChecked() ); 	}
	BOOL ReadFlag(const String& rKey, CheckBox& rChk);

	void WritFlag(const String& rKey, RadioButton& rBtn )
		{	WritFlag( rKey, rBtn.IsChecked() ); 	}
	BOOL ReadFlag(const String& rKey, RadioButton& rBtn);

	void WritMetr(const String& rKey, long nVal);
	BOOL ReadMetr(const String& rKey, long& rVal);

	void WritZahl(const String& rKey, USHORT nVal);
	BOOL ReadZahl(const String& rKey, USHORT& rVal);

	void WritFNam(const String& rKey, const String& rStr);
	BOOL ReadFNam(const String& rKey, String& rStr);

	void WritList(const String& rKey, ListBox& rList, BOOL bNum=FALSE);
	BOOL ReadList(const String& rKey, ListBox& rList, BOOL bNum=FALSE);

	void WritList(const String& rKey, BOOL bSwt,      ListBox& rList, BOOL bNum=FALSE);
	BOOL ReadList(const String& rKey, BOOL& rSwt,     ListBox& rList, BOOL bNum=FALSE);

	void WritList(const String& rKey, CheckBox& rChk, ListBox& rList, BOOL bNum=FALSE)
		{ WritList( rKey, rChk.IsChecked(), rList, bNum ); }
	BOOL ReadList(const String& rKey, CheckBox& rChk, ListBox& rList, BOOL bNum=FALSE);

	void WritStil(const RadioButton& rBtn1, const RadioButton& rBtn2, const RadioButton& rBtn3);
	BOOL ReadStil(RadioButton& rBtn1, RadioButton& rBtn2, RadioButton& rBtn3);

	void WritText(const String& rKey, WizardText& rFrame);
	BOOL ReadText(const String& rKey, WizardText& rFrame);

	void WritAlgn(const String& rKey, PageAlign eAlgn);
	BOOL ReadAlgn(const String& rKey, PageAlign& rAlgn);

	void WritFram(const String& rKeySfx, WizardText& rFrame, BOOL bString=TRUE);
	BOOL ReadFram(const String& rKeySfx, WizardText& rFrame, BOOL bString=TRUE);

	void WritLogo(const String& rKeySfx, WizardLogo& rLogo);
	BOOL ReadLogo(const String& rKeySfx, WizardLogo& rLogo);

	void WritDoku(WizardDokuDlg& rDoku);
	BOOL ReadDoku(WizardDokuDlg& rDoku);
};


#endif  //_WIZINI_HXX

