/*************************************************************************
 *
 *  $RCSfile: wizlogo.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WIZLOGO_HXX
#define _WIZLOGO_HXX

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif


#include "wizmulti.hxx"

class MetricField;

class WizardLogoDlg
{
	SwWizardDialog* pWizDlg;
	WizardLogo*   pLogo1;
	WizardLogo*   pLogoF;
	PageAlign    eBeware;
public:
	FixedText*     pL_Text_LgoArt;
	RadioButton*   pL_RBtn_NoLogo;
	RadioButton*   pL_RBtn_GrLogo;
	RadioButton*   pL_RBtn_TxLogo;
	FixedText*     pL_Text_LogoTx;
	MultiLineEdit* pL_MEdt_LogoTx;
	FixedText*     pL_Edit_LogoFN;
	PushButton*    pL_PBtn_LogoFN;
	GroupBox*      pL_GBox_LogoFN;
	JBitmapButton* pL_BBtn_LogoLi;
	JBitmapButton* pL_BBtn_LogoMi;
	JBitmapButton* pL_BBtn_LogoRe;
	FixedText*     pL_Text_LogoHo;
	MetricField*   pL_MFld_LogoHo;
	FixedText*     pL_Text_LogoVe;
	MetricField*   pL_MFld_LogoVe;
	GroupBox*      pL_GBox_LgoPos;
	FixedText*     pL_Text_LogoWd;
	MetricField*   pL_MFld_LogoWd;
	FixedText*     pL_Text_LogoHg;
	MetricField*   pL_MFld_LogoHg;
	GroupBox*      pL_GBox_LgoSiz;
public:
	WizardLogoDlg(SwWizardDialog* pDlgWin);
	~WizardLogoDlg();
	void Fill(MultiOne& WinArr);
	void SetPtr(WizardLogo* pL1=NULL,WizardLogo* pL2=NULL);
	void SetEventHandler();

	DECL_LINK( PBtnHdl, PushButton * );
	DECL_LINK( BBtnHdl, Button * );
	DECL_LINK( MFldHdl, MetricField * );
	DECL_LINK( RBtnHdl, RadioButton * );
	DECL_LINK( MEdtHdl, MultiLineEdit * );
	void SetDisable();
	void SetMetric();
	void ToUI();
	void SetBeware(PageAlign eBwr);
	void SetBBtnDisable();
};


#endif  //_WIZLOGO_HXX
