/*************************************************************************
 *
 *  $RCSfile: wizltdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WIZLTDLG_HXX
#define _WIZLTDLG_HXX

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#include "wizmulti.hxx"
#include "wizdoku.hxx"
#include "wizlogo.hxx"
#include "wizmarg.hxx"
#include "wizempf.hxx"
#include "wizfusz.hxx"
#include "numfmtlb.hxx"

#if defined( PM2 )
// Bug 18086 - unter OS/2 kann man keine Druckerschaechte erfragen
#define NO_PAPERBIN
#endif

class WizardLettDialog: public SwWizardDialog
{
protected:
	FixedText     a1_Text_BrfArt;
	RadioButton   a1_RBtn_GesBrf;
	RadioButton   a1_RBtn_PrvBrf;
	FixedText     a1_Text_Stil;
	RadioButton   a1_RBtn_Stil1;
	RadioButton   a1_RBtn_Stil2;
	RadioButton   a1_RBtn_Stil3;

	WizardLogoDlg aLogo;

	ImageButton	  a3_Btn_LoadAdr;
	FixedText     a3_Text_AbsInp;
	MultiLineEdit a3_MEdt_AbsInp;
	FixedText     a3_Text_AbsWdh;
	RadioButton   a3_RBtn_WdhJaa;
	RadioButton   a3_RBtn_WdhNee;
	FixedText     a3_Text_AbsAnz;
	RadioButton   a3_RBtn_AnzJaa;
	RadioButton   a3_RBtn_AnzNee;
	JBitmapButton a3_BBtn_AbsnOL;
	JBitmapButton a3_BBtn_AbsnOR;
	JBitmapButton a3_BBtn_AbsnUL;
	JBitmapButton a3_BBtn_AbsnUR;
	JBitmapButton a3_BBtn_AbsnMi;
	FixedText     a3_Text_AbsnHo;
	MetricField   a3_MFld_AbsnHo;
	FixedText     a3_Text_AbsnVe;
	MetricField   a3_MFld_AbsnVe;
	FixedText     a3_Text_AbsnWd;
	MetricField   a3_MFld_AbsnWd;
	FixedText     a3_Text_AbsnHg;
	MetricField   a3_MFld_AbsnHg;
	GroupBox      a3_GBox_AbsPos;

	WizardEmpfDlg aEmpf;

	FixedText     a5_Text_Welche;
	CheckBox      a5_CBox_Elem1;
	Edit          a5_Edit_Elem1;
	CheckBox      a5_CBox_Elem2;
	Edit          a5_Edit_Elem2;
	CheckBox      a5_CBox_Elem3;
	Edit          a5_Edit_Elem3;
	CheckBox      a5_CBox_Elem4;
	Edit          a5_Edit_Elem4;
	CheckBox      a5_CBox_Datum;
	NumFormatListBox	a5_List_Datum;
	CheckBox      a5_CBox_Betref;
	Edit          a5_Edit_Betref;
	CheckBox      a5_CBox_KopiAn;
	CheckBox      a5_CBox_Anlagn;
	CheckBox      a5_CBox_PagNum;
	Edit          a5_Edit_PagNum;
	ListBox       a5_List_PagNum;
	CheckBox      a5_CBox_PagGes;
	Edit          a5_Edit_PagGes;

	WizardFuszDlg* pFusz;
	WizardMargDlg* pMarg;

	FixedText*     p7_Text_FolgPg;
	FixedText*     p7_Text_KLinOb;
	MetricField*   p7_MFld_KLinOb;
	FixedText*     p7_Text_KLinTx;
	MetricField*   p7_MFld_KLinTx;
	FixedText*     p7_Text_LogoWo;
	ListBox*       p7_List_LogoWo;
	FixedText*     p7_Text_LogoWd;
	MetricField*   p7_MFld_LogoWd;
	FixedText*     p7_Text_LogoHg;
	MetricField*   p7_MFld_LogoHg;
	FixedText*     p7_Text_AbsnWo;
	ListBox*       p7_List_AbsnWo;
	FixedText*     p7_Text_AbsnWd;
	MetricField*   p7_MFld_AbsnWd;
	FixedText*     p7_Text_AbsnHg;
	MetricField*   p7_MFld_AbsnHg;
	GroupBox*      p7_GBox_KopLin;
	CheckBox*      p7_CBox_FusAnz;
	FixedText*     p7_Text_FLinOb;
	MetricField*   p7_MFld_FLinOb;
	FixedText*     p7_Text_FLinTx;
	MetricField*   p7_MFld_FLinTx;
	GroupBox*      p7_GBox_FusLin;

	FixedBitmap*   p9_BMap_Fahne;
	FixedText*     p9_Text_WanPrn;
	FixedText*     p9_Text_LgoPrn;
	ListBox*       p9_List_LgoPrn;
	FixedText*     p9_Text_AbsPrn;
	ListBox*       p9_List_AbsPrn;
	FixedText*     p9_Text_Tip;
	FixedText*     p9_Text_TipPrn;

#ifndef NO_PAPERBIN
	FixedText*     p9_Text_PrTray;
	FixedText*     p9_Text_TrayS1;
	ListBox*       p9_List_TrayS1;
	FixedText*     p9_Text_TrayFF;
	ListBox*       p9_List_TrayFF;
#endif

	GroupBox*	   p9_Group_Prn;
	PushButton*	   p9_Btn_PrSetup;
	FixedText*	   p9_Text_PrName;

	Printer*		pPrinter;				//Fuer die Schachteinstellung

public:
	WizardLettDialog(Window* pParent);
	~WizardLettDialog();
};

#endif  //_WIZLTDLG_HXX


