/*************************************************************************
 *
 *  $RCSfile: wizltgo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"

#ifndef _SVX_ULSPITEM_HXX //autogen
#include <svx/ulspitem.hxx>
#endif


#ifndef _FMTHDFT_HXX //autogen
#include <fmthdft.hxx>
#endif
#include "wrtsh.hxx"     // Writershell
#include "frmmgr.hxx"    // Framemanager
#include "pagedesc.hxx"  // Seitenraender,
#include "frmatr.hxx"    // Fussz,Kopfz
#include "tabcol.hxx"  	// SwTabCols
#include "wizpage.hxx"
#include "wizgo.hxx"
#include "wizlt.hxx"

#define C2S(cChar) UniString::CreateFromAscii(cChar)

////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef WINDOCHFILM
#define WIZNOFILM
#endif
#ifndef WINDOCHUNDO
#define WIZNOUNDO
#endif
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL LetterDialog::MakeDoc()
{
	BOOL bRet=FALSE;
	BOOL bPrivat=(a1_RBtn_PrvBrf.IsChecked());
	String aVorNam(C2S("wizbrf1"));
	if (a1_RBtn_Stil2.IsChecked()) aVorNam=C2S("wizbrf2");
	if (a1_RBtn_Stil3.IsChecked()) aVorNam=C2S("wizbrf3");
	if (NewVorlage(aVorNam))
	{
#ifdef WIZNOFILM
		pShell->StartAction();
#endif
#ifdef WIZNOUNDO
		pShell->DoUndo(FALSE); // hat leider noch Seiteneffekte
#endif
		if (!bPrivat) // keine Datenbank am Privatbrief
			AssignDBas(aEmpf.pE_List_DBase->GetSelectEntry(), aEmpf.pE_List_DBTable->GetSelectEntry());
		SetMarg(aPage1,NULL,&aPage1.aFusz);
		SetPrinter(pPrinter);
#ifndef NO_PAPERBIN
		SetTray(p9_List_TrayS1->GetSelectEntryPos());
#endif
		InsLogo();
		InsEmpf();
		InsAbsn();
		InsAbs2();
		InsElem();
		InsBetr();
		InsAnrd();
		SetFusz(aPage1.aFusz,C2S("Fus1"),C2S("Num1"));
		InsAnlg(); // ab hier befindet sich der Cursor auf der 2. Seite !
		InsKopi();
		InsKopF();
		SetFusz(aPageF.aFusz,C2S("FusF"),C2S("NumF"));
		SetMarg(aPageF,&aPageF.aKopz,&aPageF.aFusz);
#ifndef NO_PAPERBIN
		SetTray(p9_List_TrayFF->GetSelectEntryPos());
#endif
		DelText();
		MarkText();
		CreateMacro();
		if (!bPrivat) SaveMacro();
		FillDocInfo(*pDoku);
#ifdef WIZNOFILM
		pShell->EndAction();
#endif
		if (SaveVorNewDoc(*pDoku)) bRet=TRUE;
	}
	return bRet;
}

void LetterDialog::CreateMacro()
{
	ULONG nDateFmt = NODATE;

	if (aPage1.aElem.IsVisible(4))
		nDateFmt = a5_List_Datum.GetFormat();
	 SetCreateMacro(*pDoku,nDateFmt);
}

void LetterDialog::SaveMacro()
{
	 BOOL bDown1=GetDocInfoGoDown(pDoku->pD_List_InfTit->GetSelectEntryPos());
	 BOOL bDown2=GetDocInfoGoDown(pDoku->pD_List_InfTem->GetSelectEntryPos());
	 SetSaveMacro(*pDoku,bDown1,bDown2);
}

void LetterDialog::InsAbsnStr()
{
	String aStr;
	USHORT n=CountLines(a3_MEdt_AbsInp.GetText());
	USHORT i;
	for (i=0; i<n; i++) {
		aStr=GetLine(a3_MEdt_AbsInp.GetText(),i);
		if (aStr.Len()>0) {
			USHORT nBla=0;
			char c=aStr.GetChar(nBla);
			if (c=='>') aStr.Erase(0,1);
		}
		InsString(aStr);
		if (i<n-1) pShell->SplitNode(); // kein CR and die letzte Zeile
	}
}

void LetterDialog::InsAbsn()
{
	if (GotoBookmark(C2S("Absn"))) {
		if (aPage1.aAbsn.IsVisible()) {
			InsAbsnStr();
			MovFrame(aPage1.aAbsn);
			USHORT a=p9_List_AbsPrn->GetSelectEntryPos(); // 0=Immer, 1=Erste, 2=Folge, 3=Nie
			PrnFrame(a==0 || a==1);
		} else { // ansonsten wird er geloescht
			DelFrame();
		}
	}
}

void LetterDialog::InsAbs2()
{
	if (aPage1.aEmpf.IsVisible()) { // nur wenn Empfngerfeld vorhanden!
		if (GotoBookmark(C2S("Abs2"))) {
			if (aPage1.aEmpf.IsAbsnShown()) {
				String aStr;
				String aStr2;
				USHORT n=CountLines(a3_MEdt_AbsInp.GetText());
				USHORT i;
				for (i=0; i<n; i++) {
					aStr2=GetLine(a3_MEdt_AbsInp.GetText(),i);
					if (aStr2.Len()>0) {
						USHORT nBla=0;
						char c=aStr2.GetChar( nBla );
						if (c=='>') {
							aStr2.Erase(0,1);
							if (aStr.Len()!=0) aStr+=C2S(" - ");
							aStr+=aStr2;
						}
					}
				}
				InsString(aStr);
			} else {
				if( !pShell->IsEndPara() )
					pShell->MovePara( fnParaCurr, fnParaEnd );

				pShell->Right( FALSE, 1, TRUE );       // der nchsten Zeile,
				pShell->SplitNode();   // dort einen Umbruch,
				pShell->Up( FALSE, 1, TRUE );
				pShell->Up( FALSE, 1, TRUE );
				pShell->DelFullPara();
				//pShell->UpSel();       // Und dann den unterstrichenen
				//pShell->DelRight();    // Absatz lschen
			}                          // (Dabei bleibt oben eine Leerzeile stehen!)
		}
	}
}

void LetterDialog::InsLogo()
{
	if (GotoBookmark(C2S("Logo"))) {
		if (aPage1.aLogo.IsVisible()) {
			MovFrame(aPage1.aLogo);
			USHORT a=p9_List_LgoPrn->GetSelectEntryPos(); // 0=Immer, 1=Erste, 2=Folge, 3=Nie
			BOOL bPrn=(a==0 || a==1);
			PrnFrame(bPrn);
			InsLogoObj(aPage1.aLogo,FALSE,bPrn);
		} else {
			DelFrame();
		}
	}
}

void LetterDialog::InsEmpf()
{
	if (GotoBookmark(C2S("Empf")))
	{
		if (aPage1.aEmpf.IsVisible())
		{
			InsDBasFldStr(aPage1.aEmpf.GetStr());
			MovFrame(aPage1.aEmpf);
		}
		else
			DelFrame();
	}
}

void LetterDialog::InsKopF()
{
	if (GotoBookmark(C2S("AbsK"))) {
		USHORT nPgDescIdx=pShell->GetCurPageDesc();
		SwPageDesc aPageDesc(pShell->GetPageDesc(nPgDescIdx));
		SwFrmFmt*  pFmt=&aPageDesc.GetMaster();  //CopyCtor geht hier nicht, da Pointer
		if (aPageF.aKopz.IsVisible()) {
			SwFmtHeader aHeaderFmt(pFmt->GetHeader());
			SwFrmFmt* pHeaderFmt=aHeaderFmt.GetHeaderFmt();
			SvxULSpaceItem aULSpace(pHeaderFmt->GetULSpace());    // Upper/Lower-Space holen
			aULSpace.SetLower(USHORT(Twip(aPageF.aKopz.GetTextDst()))); // Abstand zum Text
			pHeaderFmt->SetAttr(aULSpace);
			SwFmtFrmSize aFrmSize(ATT_FIX_SIZE);
			aFrmSize.SetHeight(Twip(aPageF.aKopz.GetHgt()+aPageF.aKopz.GetTextDst()));
			pHeaderFmt->SetAttr(aFrmSize);
			pFmt->SetAttr(aHeaderFmt);
		} else { // Kopfeile entfernen !
			pFmt->SetAttr(SwFmtHeader(BOOL(FALSE)));
			aPageDesc.ChgHeaderShare(FALSE);
		}
		pShell->ChgPageDesc(nPgDescIdx,aPageDesc);
		if (aPageF.aKopz.IsVisible()) {
			if (aPageF.aKopz.AbsnIsVisible()) { // Absender einfuegen
				InsAbsnStr();
				JstFrame(aPageF.aKopz.GetAbsnAlign());
				SizFrame(aPageF.aKopz.GetAbsnWdt(),aPageF.aKopz.GetAbsnHgt(),FALSE,TRUE);
				USHORT a=p9_List_AbsPrn->GetSelectEntryPos(); // 0=Immer, 1=Erste, 2=Folge, 3=Nie
				PrnFrame(a==0 || a==2);
			} else {
				DelFrame();
			}
			if (GotoBookmark(C2S("LgoK"))) {
				if (aPageF.aKopz.LogoIsVisible()) { // Logo einfuegen
					JstFrame(aPageF.aKopz.GetLogoAlign());
					SizFrame(aPageF.aKopz.GetLogoWdt(),aPageF.aKopz.GetLogoHgt());
					USHORT a=p9_List_LgoPrn->GetSelectEntryPos(); // 0=Immer, 1=Erste, 2=Folge, 3=Nie
					BOOL bPrn=(a==0 || a==2);
					PrnFrame(bPrn);
					InsLogoObj(aPageF.aKopz.aLogo,TRUE,bPrn);
				} else {
					DelFrame();
				}
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

void LetterDialog::InsDocInfBookmark(USHORT nElemNum)
{
	if (GetDocInfStrOk(nElemNum)) {   // als DocInf freigegeben ?
		USHORT nIdx=nElemNum;      // nIdx geht von 0..pDoku->GetTxFieldAnz()-1
		USHORT i;
		for (i=0; i<nElemNum; i++) // fuer jeden nicht freigeg. davor, Idx um 1 dec.
			if (!GetDocInfStrOk(i)) nIdx--;
		nIdx+=pDoku->GetTxFieldOfs();
		if (nIdx==pDoku->pD_List_InfTit->GetSelectEntryPos())
			InsertBookmark(C2S("Titel"));
		if (nIdx==pDoku->pD_List_InfTem->GetSelectEntryPos())
			InsertBookmark(C2S("Thema"));
	}
}


void LetterDialog::InsElem()
{
	USHORT i;
	USHORT nAnz = 0;

	WizardElem& rPg1Elem = aPage1.aElem;
	for( i = 0; i < 5; ++i )
		if( rPg1Elem.IsVisible(i) )
			++nAnz;

	BOOL bDatm = rPg1Elem.NurDatum(); // || a1_RBtn_PrvBrf.IsChecked();
	BOOL bElem = !bDatm && nAnz;

	String aFuerDenMac(C2S("Elem"));
	if( bElem && GotoBookmark( aFuerDenMac ) )
	{
		USHORT nColAnz = nAnz; // Anzahl der bentigten Tabellenspalten
		BOOL bDatAbs = FALSE;  // Abstandsspalte zum Datum ?

		if( rPg1Elem.IsVisible(4) )
		{
			// Position des Datums
			long nDatPos = rPg1Elem.aBezeich[4].GetPosX();
			i = 0;
			for( USHORT j = 0; j < 4; ++j )
				if( rPg1Elem.IsVisible( j ) )
					i = j; // das Feld neben Datum suchen

			// Eine Abstandsspalte vor dem Datum (Toleranz 10 wg. Rundungsfehler)
			if( rPg1Elem.aBezeich[i].GetPosX() +
				rPg1Elem.aBezeich[i].GetWdt() + 10 < nDatPos )
			{
				bDatAbs=TRUE;
				nColAnz++;
			}
		}

		if( 5 > nColAnz )
		{
			InsertBookmark( aFuerDenMac );
			pShell->GoNextCell();
			pShell->SetMark();

			for( i = ++nColAnz; i < 5; ++i )
				pShell->GoNextCell();

			pShell->DeleteCol(); 	// Ueberfluessige Spalten loeschen
			pShell->ClearMark();

			// und wieder in die Tabelle zurueck
			if( USHRT_MAX != ( i = pShell->FindBookmark( aFuerDenMac ) ) )
			{
				pShell->GotoBookmark( i );
				pShell->DelBookmark( i );
			}
			else
				ASSERT( !this, "Wer hat meine Bookmark zerstoert" )
		}

		MovFrame( rPg1Elem.GetPosX(), rPg1Elem.GetPosY(),
					rPg1Elem.GetWdt(), rPg1Elem.GetHgt(), TRUE );

		SwTabCols aCols;
		pShell->GetTabCols( aCols );

		nColAnz = 0; // Nummer der Tabellenspalte
		USHORT nElemCnt = 0; // Nummer des Elementes [0..nAnz-1]
		for( i = 0; i < 5; ++i )
		{
			if( rPg1Elem.IsVisible( i ) )
			{
				// Breite der letzten Spalte nur setzen, wenn Datum
				if( nElemCnt < nAnz - 1 || i == 4 )
					SetTabColWidth( aCols, nColAnz,
						Twip( rPg1Elem.aBezeich[i].GetWdt() ));

				String aStr;
				switch (i)
				{
					case 0: aStr=a5_Edit_Elem1.GetText(); break;
					case 1: aStr=a5_Edit_Elem2.GetText(); break;
					case 2: aStr=a5_Edit_Elem3.GetText(); break;
					case 3: aStr=a5_Edit_Elem4.GetText(); break;
					case 4: aStr=a5_CBox_Datum.GetText();
							aStr.EraseAllChars('~');		break;
				}
				InsString( aStr );
				if( i <= 3 )
				{
					// DocInfBookmarker fuer alle Elemente ausser Datum
					if( !pShell->IsSttPara() )
						pShell->MovePara( fnParaCurr, fnParaStart );

					InsDocInfBookmark( i );
				}
				else if( i == 4 )
				{
					// Datumsfeld in die 2. Zeile
					pShell->Down( FALSE, 1, TRUE );
					InsertBookmark(C2S("Datum"));
					if( !pShell->IsSttPara() )
						pShell->MovePara( fnParaCurr, fnParaStart );

					pShell->Up( FALSE, 1, TRUE );
				}

				if( nElemCnt < nAnz - 1 )
				{	 // kommt noch mehr ?
					pShell->GoNextCell();
					++nColAnz;

					if( nElemCnt == nAnz - 2 && bDatAbs )
					{
						pShell->GoNextCell();
						++nColAnz;
					}
				}
				++nElemCnt;
			}
		}
		pShell->SetTabCols( aCols, FALSE );
	}

	aFuerDenMac=C2S("Datm");
	if (bDatm && GotoBookmark(aFuerDenMac))
	{
		InsertBookmark(C2S("Datum"));
		MovFrame(rPg1Elem.GetPosX(),rPg1Elem.GetPosY(),rPg1Elem.GetWdt(),rPg1Elem.GetHgt(),TRUE);
	}

	aFuerDenMac=C2S("Elem");
	if( !bElem && GotoBookmark(aFuerDenMac))
	{
		if( pShell->DeleteRow() && pShell->DeleteRow() && pShell->HasSelection() )
			pShell->EnterStdMode();
		DelFrame();
	}

	aFuerDenMac=C2S("Datm");
	if (!bDatm && GotoBookmark(aFuerDenMac))
	{
		if( pShell->DeleteRow() && pShell->HasSelection() )
			pShell->EnterStdMode();
		DelFrame();
	}
}

void LetterDialog::InsBetr()
{
	if (GotoBookmark(C2S("Betr")))
	{
		if (aPage1.aBetr.IsVisible())
		{
			InsString(a5_Edit_Betref.GetText());
			if( !pShell->IsSttPara() )
				pShell->MovePara( fnParaCurr, fnParaStart );

			InsDocInfBookmark(4);
			MovFrame(aPage1.aBetr,TRUE);
		}
		else
		{
			if ( pShell->DeleteRow() && pShell->HasSelection() )
				pShell->EnterStdMode();

			DelFrame();
		}
	}
}

void LetterDialog::InsAnrd()
{
	if (GotoBookmark(C2S("Anrd")))
	{
		if (a1_RBtn_GesBrf.IsChecked())
		{
			String aStr1(aEmpf.pE_Edit_AnrFix->GetText());
			if( aEmpf.pE_List_AnrFld->GetSelectEntryPos() )
			{
				String aStr2(aEmpf.pE_List_AnrFld->GetSelectEntry());
				if( aStr2.Len() )
				{
					if (aStr1.Len() && aStr1.GetChar( aStr1.Len()-1 ) != ' ')
						aStr1 += ' ';	// Leerzeichen vor Feldbefehl einfuegen: Bug #50316
					aStr1 += '<';
					aStr1 += aStr2;
					aStr1 += '>';
				}
			}

			if( aStr1.Len() )
			{
				pShell->SttSelect();
				pShell->RightMargin( TRUE );
				pShell->EndSelect();
				pShell->DelRight();
				InsDBasFldStr(aStr1);
				//InsString(String(C2S(",")));
			}
		}
		else
		{
			// SwFmtPageDesc beibehalten !!
			SfxItemSet aSet( pShell->GetAttrPool(), RES_PAGEDESC, RES_PAGEDESC );
			pShell->GetAttr( aSet );
			pShell->DelFullPara();
			pShell->SetAttr( aSet );
		}
	}
}

void LetterDialog::InsAnlg()
{
	if( GotoBookmark(C2S("Anlg")) &&
		(!a5_CBox_Anlagn.IsChecked() || !a1_RBtn_GesBrf.IsChecked() ) )
			pShell->DelFullPara();
}

void LetterDialog::InsKopi()
{
	if( GotoBookmark(C2S("Kopi")) &&
		( !a5_CBox_KopiAn.IsChecked() || !a1_RBtn_GesBrf.IsChecked() ) )
			pShell->DelFullPara();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////



/****************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizltgo.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizltgo.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.58  2000/09/18 16:06:24  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.57  2000/04/19 11:18:59  os
	  UNICODE
	
	  Revision 1.56  1999/04/13 18:39:20  JP
	  Bug #64435#: Cursor-Bewegungen als Basic-Calls ausgeben, damit sie in ReadOnly-Docs auch funktionieren


	  Rev 1.55   13 Apr 1999 20:39:20   JP
   Bug #64435#: Cursor-Bewegungen als Basic-Calls ausgeben, damit sie in ReadOnly-Docs auch funktionieren

	  Rev 1.54   19 Feb 1999 14:03:56   JP
   Bug #57558#/#57557#: statt Left-/RightMargin MovePara( Start/End ) benutzen

	  Rev 1.53   18 May 1998 13:12:34   OM
   #50316 Leerzeichen nach Anrede

	  Rev 1.52   27 Apr 1998 13:38:26   OM
   #49801# Datum nicht mehr festverdratet

	  Rev 1.51   08 Jan 1998 17:48:26   OM
   Neue Datumsfelder einfuegen

	  Rev 1.50   24 Nov 1997 10:58:34   MA
   includes

	  Rev 1.49   03 Nov 1997 14:01:46   MA
   precomp entfernt

	  Rev 1.48   15 Aug 1997 12:15:52   OS
   chartar/frmatr/txtatr aufgeteilt

	  Rev 1.47   12 Aug 1997 16:00:12   OS
   frmitems/textitem/paraitem aufgeteilt

	  Rev 1.46   07 Aug 1997 15:00:28   OM
   Headerfile-Umstellung

	  Rev 1.45   23 Jun 1997 15:39:44   OM
   Druckereinstellung fuer Autopilot Brief

	  Rev 1.44   13 Mar 1997 16:29:22   OM
   DB-Feldbefehle korrekt erkennen

	  Rev 1.43   24 Oct 1996 13:36:56   JP
   String Umstellung: [] -> GetChar()

	  Rev 1.42   29 Aug 1996 09:05:02   OS
   includes

	  Rev 1.41   02 May 1996 16:34:14   JP
   Bug #27504#: Kopie an einfuegen

	  Rev 1.40   24 Nov 1995 16:59:10   OM
   PCH->PRECOMPILED

	  Rev 1.39   18 Oct 1995 18:36:56   JP
   Bug 21115: PrivatBrief - PageDesc-Attr nicht loeschen

	  Rev 1.38   13 Sep 1995 14:09:40   JP
   Bug 18086: unter OS/2 sind keine Druckerschaechte verfuegbar

	  Rev 1.37   30 Aug 1995 13:01:34   MA
   Traveling mit/ohne Selektion vereint

	  Rev 1.36   04 Aug 1995 08:38:16   JP
   Feldzugriff in die Basisklasse verschoben

	  Rev 1.35   02 Aug 1995 18:52:56   JP
   kein TableMgr mehr; Undo abgeschaltet; ActionKlammerung; optimiert

	  Rev 1.34   29 Jul 1995 23:35:48   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.33   05 Jul 1995 19:10:12   JP
   SwBookmarkFUNC gibts nicht mehr, rufe Methoden an die Shell-Methoden

	  Rev 1.32   05 Jul 1995 13:09:24   JP
   BookmarkFUNC gibts nicht mehr

*************************************************************************/

