/*************************************************************************
 *
 *  $RCSfile: wizmarg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "swtypes.hxx"
#include "uitool.hxx"
#include "wizard.hrc"
#include "wizmarg.hxx"



WizardMargDlg::WizardMargDlg(SwWizardDialog* pDlgWin)
{
	pM_Text_VonLks=new FixedText  (pDlgWin,SW_RES(DLG_Mrg_Text_VonLks));
	pM_MFld_VonLks=new MetricField(pDlgWin,SW_RES(DLG_Mrg_MFld_VonLks));
	pM_Text_VonRts=new FixedText  (pDlgWin,SW_RES(DLG_Mrg_Text_VonRts));
	pM_MFld_VonRts=new MetricField(pDlgWin,SW_RES(DLG_Mrg_MFld_VonRts));
	pM_GBox_PgMarg=new GroupBox   (pDlgWin,SW_RES(DLG_Mrg_GBox_PgMarg));
	pWizDlg=pDlgWin;
	pPage1=NULL;
	pPage2=NULL;

	FieldUnit eMetric = ::GetDfltMetric(FALSE);
	pM_MFld_VonLks->SetUnit(eMetric);
	pM_MFld_VonRts->SetUnit(eMetric);

	SetEventHandler();
}

WizardMargDlg::~WizardMargDlg()
{
	delete pM_Text_VonLks;
	delete pM_MFld_VonLks;
	delete pM_Text_VonRts;
	delete pM_MFld_VonRts;
	delete pM_GBox_PgMarg;
}

void WizardMargDlg::Fill(MultiOne& WinArr)
{
	WinArr.AddWin(pM_Text_VonLks);
	WinArr.AddWin(pM_MFld_VonLks);
	WinArr.AddWin(pM_Text_VonRts);
	WinArr.AddWin(pM_MFld_VonRts);
	WinArr.AddWin(pM_GBox_PgMarg,FALSE,TRUE);
}

void WizardMargDlg::SetPtr(WizardPage* pPg1, WizardPage* pPg2)
{
	pPage1=pPg1;
	pPage2=pPg2;
	ToUI();
}

void WizardMargDlg::ToUI()
{
	if (pPage1==NULL) return;
	pM_MFld_VonLks->SetValue(pPage1->RandL, FUNIT_CM);
	pM_MFld_VonRts->SetValue(pPage1->RandR, FUNIT_CM);
}

IMPL_LINK( WizardMargDlg, MFldHdl, MetricField *, pEdt )
{
	USHORT nVal=USHORT(pEdt->GetValue(FUNIT_CM));
	if (pEdt==pM_MFld_VonLks) {
		if (pPage1!=NULL) pPage1->SetRandL(nVal,&pWizDlg->aPrevWin);
		if (pPage2!=NULL) pPage2->SetRandL(nVal,&pWizDlg->aPrevWin);
	}
	if (pEdt==pM_MFld_VonRts) {
		if (pPage1!=NULL) pPage1->SetRandR(nVal,&pWizDlg->aPrevWin);
		if (pPage2!=NULL) pPage2->SetRandR(nVal,&pWizDlg->aPrevWin);
	}
	return 0;
}

void WizardMargDlg::SetEventHandler()
{
	pM_MFld_VonLks->SetModifyHdl(LINK(this,WizardMargDlg,MFldHdl));
	pM_MFld_VonRts->SetModifyHdl(LINK(this,WizardMargDlg,MFldHdl));
}



/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizmarg.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizmarg.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.31  2000/09/18 16:06:24  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.30  1999/07/07 13:40:24  MA
	  WizardDialog renamed to SwWizardDialog
	

	  Rev 1.29   07 Jul 1999 15:40:24   MA
   WizardDialog renamed to SwWizardDialog

	  Rev 1.28   08 Apr 1999 10:51:14   JP
   Task #64466#: Focus auf die 1.Controls der Seiten setzen (fuer die Hilfe)

	  Rev 1.27   08 Sep 1998 17:06:48   OS
   #56134# Metric fuer Text und HTML getrennt

	  Rev 1.26   27 Apr 1998 16:02:06   OM
   #49831# Andere Masseinheiten erlauben

	  Rev 1.25   24 Nov 1997 10:58:40   MA
   includes

	  Rev 1.24   03 Nov 1997 14:01:46   MA
   precomp entfernt

	  Rev 1.23   11 Nov 1996 10:38:04   MA
   ResMgr

	  Rev 1.22   29 Oct 1996 19:11:36   HJS
   includes

	  Rev 1.21   29 Aug 1996 09:04:52   OS
   includes

	  Rev 1.20   27 Feb 1996 12:21:22   OS
   GetDfltMetric jetzt aus uitool.hxx

	  Rev 1.19   06 Feb 1996 15:22:00   JP
   Link Umstellung 305

	  Rev 1.18   28 Nov 1995 21:12:26   JP
   UiSystem-Klasse aufgehoben, in initui/swtype aufgeteilt

	  Rev 1.17   24 Nov 1995 16:59:14   OM
   PCH->PRECOMPILED

	  Rev 1.16   08 Nov 1995 12:03:24   OS
   Change => Set

	  Rev 1.15   29 Jul 1995 23:35:42   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.14   25 Oct 1994 19:34:02   ER
   add: PCH

	  Rev 1.13   06 Jul 1994 09:28:00   MS
   AppMetric

	  Rev 1.12   10 Jun 1994 10:27:22   JOE
   Joe aus Bln: Unused Vars. GrpFlag in AddWin. PM2 ohne Clipping.

*************************************************************************/

