/*************************************************************************
 *
 *  $RCSfile: wizmmdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop


#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif


#include "swtypes.hxx"
#include "wizmulti.hxx"
#include "wizard.hrc"
#include "wizmmdlg.hxx"
#include "numfmtlb.hxx"


WizardMemoDialog::WizardMemoDialog(Window* pParent)
	: SwWizardDialog(pParent,SW_RES(DLG_WIZARD_MM),5)
{
	p1_Text_Stil  =new FixedText   (this,SW_RES(DLG_MM1_Text_Stil  ));
	p1_RBtn_Stil1 =new RadioButton (this,SW_RES(DLG_MM1_RBtn_Stil1 ));
	p1_RBtn_Stil2 =new RadioButton (this,SW_RES(DLG_MM1_RBtn_Stil2 ));
	p1_RBtn_Stil3 =new RadioButton (this,SW_RES(DLG_MM1_RBtn_Stil3 ));
	p1_Text_Titel =new FixedText   (this,SW_RES(DLG_MM1_Text_Titel ));
	p1_RBtn_TitTxt=new RadioButton (this,SW_RES(DLG_MM1_RBtn_TitTxt));
	p1_RBtn_TitGrf=new RadioButton (this,SW_RES(DLG_MM1_RBtn_TitGrf));
	p1_CBox_TitTxt=new ComboBox    (this,SW_RES(DLG_MM1_CBox_TitTxt));
	p1_PBtn_TitGrf=new PushButton  (this,SW_RES(DLG_MM1_PBtn_TitGrf));
	p1_Text_TitGrf=new FixedText   (this,SW_RES(DLG_MM1_Text_TitGrf));

	p2_Text_Welche=new FixedText   (this,SW_RES(DLG_MM2_Text_Welche));
	p2_CBox_Datum =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Datum ));
	p2_List_Datum =new NumFormatListBox (this,SW_RES(DLG_MM2_List_Datum ), NUMBERFORMAT_DATE, 0, FALSE);
	p2_CBox_Betref=new CheckBox    (this,SW_RES(DLG_MM2_CBox_Betref));
	p2_Edit_Betref=new Edit        (this,SW_RES(DLG_MM2_Edit_Betref));
	p2_CBox_MemoAn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_MemoAn));
	p2_CBox_KopiAn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_KopiAn));
	p2_CBox_MemoVn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_MemoVn));
	p2_CBox_Elem1 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem1 ));
	p2_Edit_Elem1 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem1 ));
	p2_CBox_Elem2 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem2 ));
	p2_Edit_Elem2 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem2 ));
	p2_CBox_Elem3 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem3 ));
	p2_Edit_Elem3 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem3 ));
	p2_CBox_Elem4 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem4 ));
	p2_Edit_Elem4 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem4 ));
	//p2_CBox_TrenLn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_TrenLn));
	//p2_CBox_Anlagn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_Anlagn));

	p3_Text_KWelch=new FixedText   (this,SW_RES(DLG_MM3_Text_KWelch));
	p3_CBox_KDatum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KDatum));
	p3_CBox_KThema=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KThema));
	p3_CBox_KPgNum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KPgNum));
	p3_CBox_KTrnLn=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KTrnLn));
	p3_Text_FWelch=new FixedText   (this,SW_RES(DLG_MM3_Text_FWelch));
	p3_CBox_FDatum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FDatum));
	p3_CBox_FVertr=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FVertr));
	p3_Edit_FVertr=new Edit        (this,SW_RES(DLG_MM3_Edit_FVertr));
	p3_CBox_FPgNum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FPgNum));
	p3_CBox_FTrnLn=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FTrnLn));

	p5_BMap_Fahne =new FixedBitmap (this,SW_RES(DLG_MM5_BMap_Fahne ));
	p5_Text_Final =new FixedText   (this,SW_RES(DLG_MM5_Text_Final ));

	FreeResource();
}

WizardMemoDialog::~WizardMemoDialog()
{
	delete p1_Text_Stil  ;
	delete p1_RBtn_Stil1 ;
	delete p1_RBtn_Stil2 ;
	delete p1_RBtn_Stil3 ;
	delete p1_Text_Titel ;
	delete p1_RBtn_TitTxt;
	delete p1_RBtn_TitGrf;
	delete p1_CBox_TitTxt;
	delete p1_PBtn_TitGrf;
	delete p1_Text_TitGrf;

	delete p2_Text_Welche;
	delete p2_CBox_Datum ;
	delete p2_List_Datum ;
	delete p2_CBox_Betref;
	delete p2_Edit_Betref;
	delete p2_CBox_MemoAn;
	delete p2_CBox_KopiAn;
	delete p2_CBox_MemoVn;
	delete p2_CBox_Elem1 ;
	delete p2_Edit_Elem1 ;
	delete p2_CBox_Elem2 ;
	delete p2_Edit_Elem2 ;
	delete p2_CBox_Elem3 ;
	delete p2_Edit_Elem3 ;
	delete p2_CBox_Elem4 ;
	delete p2_Edit_Elem4 ;
	//delete p2_CBox_TrenLn;
	//delete p2_CBox_Anlagn;

	delete p3_Text_KWelch;
	delete p3_CBox_KDatum;
	delete p3_CBox_KThema;
	delete p3_CBox_KPgNum;
	delete p3_CBox_KTrnLn;
	delete p3_Text_FWelch;
	delete p3_CBox_FDatum;
	delete p3_CBox_FVertr;
	delete p3_Edit_FVertr;
	delete p3_CBox_FPgNum;
	delete p3_CBox_FTrnLn;

	delete p5_BMap_Fahne ;
	delete p5_Text_Final ;
}


/**********************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizmmdlg.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizmmdlg.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.18  2000/09/18 16:06:25  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.17  2000/02/11 15:03:05  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.16  1999/07/07 13:40:16  MA
	  WizardDialog renamed to SwWizardDialog
	

	  Rev 1.15   07 Jul 1999 15:40:16   MA
   WizardDialog renamed to SwWizardDialog

	  Rev 1.14   09 Jan 1998 11:34:24   OM
   Datumsformate fuer Memos

	  Rev 1.13   24 Nov 1997 10:58:46   MA
   includes

	  Rev 1.12   03 Nov 1997 14:01:52   MA
   precomp entfernt

	  Rev 1.11   14 Nov 1996 15:55:36   TRI
   includes

	  Rev 1.10   11 Nov 1996 10:38:10   MA
   ResMgr

	  Rev 1.9   29 Aug 1996 09:04:54   OS
   includes

	  Rev 1.8   24 Nov 1995 16:59:10   OM
   PCH->PRECOMPILED

	  Rev 1.7   29 Jul 1995 23:35:48   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.6   25 Oct 1994 19:34:02   ER
   add: PCH

	  Rev 1.5   17 May 1994 14:49:30   JOE
   Sicherheits-CheckIn

	  Rev 1.4   20 Apr 1994 09:23:26   JOE
   HXX nun im WizardDir. Memo Fertig. Neue Methode von JP: DelFullPara()

	  Rev 1.3   18 Apr 1994 23:52:26   JOE
   SEXPORT im Ctor/Dtor

	  Rev 1.2   18 Apr 1994 10:53:24   JOE
   Segmentierung

	  Rev 1.1   12 Apr 1994 12:49:14   JOE
   PVCS-Header nach oben verschoben

	  Rev 1.0   11 Apr 1994 17:41:40   JOE
   Wieder in HH. Briefe fertig.

*************************************************************************/

