/*************************************************************************
 *
 *  $RCSfile: wizmmgo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "hintids.hxx"

#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _SVX_BOXITEM_HXX //autogen
#include <svx/boxitem.hxx>
#endif


#ifndef _FMTHDFT_HXX //autogen
#include <fmthdft.hxx>
#endif
#include "uiparam.hxx"
#include "wrtsh.hxx"     // Writershell
#include "frmatr.hxx"    // Fussz,Kopfz,FlyHoriOrient
#include "pagedesc.hxx"  // Seitenraender,
#include "wizpage.hxx"
#include "wizgo.hxx"
#include "wizmm.hxx"
#include "numfmtlb.hxx"

#define C2S(cChar) UniString::CreateFromAscii(cChar)


////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef WINDOCHFILM
#define WIZNOFILM
#endif
#ifndef WINDOCHUNDO
#define WIZNOUNDO
#endif
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL MemoDialog::MakeDoc()
{
	BOOL bRet=FALSE;
	String aVorNam(C2S("wizmem1"));
	if (p1_RBtn_Stil2->IsChecked()) aVorNam=C2S("wizmem2");
	if (p1_RBtn_Stil3->IsChecked()) aVorNam=C2S("wizmem3");
	if (NewVorlage(aVorNam)) {
#ifdef WIZNOFILM
		pShell->StartAction();
#endif
#ifdef WIZNOUNDO
		pShell->DoUndo(FALSE); // hat leider noch Seiteneffekte
#endif
		SetMarg(aPage1,NULL,&aPage1.aFusz);
		InsTitl();
		InsElem();
		InsFusz();
		InsKopz();
		DelText();
		MarkText();
		CreateMacro();
		SaveMacro();
		FillDocInfo(*pDoku);
#ifdef WIZNOFILM
		pShell->EndAction();
#endif
		if (SaveVorNewDoc(*pDoku)) bRet=TRUE;
	}
	return bRet;
}

void MemoDialog::CreateMacro()
{
	ULONG nDateFmt = NODATE;
	if (p2_CBox_Datum->IsChecked())
		nDateFmt = p2_List_Datum->GetFormat();
	SetCreateMacro(*pDoku,nDateFmt,NOTIME,4,TRUE);
}

void MemoDialog::SaveMacro()
{
	 SetSaveMacro(*pDoku,FALSE,FALSE);
}

void MemoDialog::InsTitl()
{
	if (GotoBookmark(C2S("Titl"))) {
		if (aPage1.aTitl.IsVisible()) {
			MovFrame(aPage1.aTitl);
			InsLogoObj(aPage1.aTitl);
		} else {
			DelFrame();
		}
	}
}

void MemoDialog::InsElem()
{
	if (aPage1.aEleZ.IsVisible())
	{
		if (GotoBookmark(C2S("Datm")))
		{
			if (p2_CBox_Datum->IsChecked())
			{
				if( !pShell->IsEndPara() )
					pShell->MovePara( fnParaCurr, fnParaEnd );
				InsertBookmark(C2S("Datum"));
			}
			else
				pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("Absn")))
		{
			if (p2_CBox_MemoVn->IsChecked())
				InsDocInfBookmark(3);
			else
				pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("Empf")))
		{
			if (p2_CBox_MemoAn->IsChecked())
				InsDocInfBookmark(1);
			else
				pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("Kopi")))
		{
			if (p2_CBox_KopiAn->IsChecked())
				InsDocInfBookmark(2);
			else
				pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("Betr")))
		{
			if (p2_CBox_Betref->IsChecked())
			{
				InsString(p2_Edit_Betref->GetText());
				if( !pShell->IsSttPara() )
					pShell->MovePara( fnParaCurr, fnParaStart );
				InsDocInfBookmark(0);
			}
			else
				pShell->DelFullPara();
		}


		static CheckBox* aCBArr[ 4 ] =
			{ p2_CBox_Elem1, p2_CBox_Elem2, p2_CBox_Elem3, p2_CBox_Elem4 };
		static Edit* aEDArr[ 4 ] =
			{ p2_Edit_Elem1, p2_Edit_Elem2, p2_Edit_Elem3, p2_Edit_Elem4 };

		String sBook( C2S("Ele0") );
		for( USHORT n = 1; n <= 4; ++n )
		{
			sBook.SetChar( 3, '0' + n );
			if( GotoBookmark( sBook ))
			{
				if( aCBArr[ n-1 ]->IsChecked())
				{
					InsString( aEDArr[ n-1 ]->GetText() );
					if( !pShell->IsSttPara() )
						pShell->MovePara( fnParaCurr, fnParaStart );
					InsDocInfBookmark( 3 + n );
				}
				else
					pShell->DelFullPara();
			}
		}
		MovFrame(aPage1.aEleZ);
	} else {
		if (GotoBookmark(C2S("Datm"))) {
			DelFrame();
		}
	}
}

void MemoDialog::DelFusz()
{
	USHORT nPgDescIdx=pShell->GetCurPageDesc();
	SwPageDesc aPageDesc(pShell->GetPageDesc(nPgDescIdx));
	SwFrmFmt*  pFmt=&aPageDesc.GetMaster();
	pFmt->SetAttr(SwFmtFooter(BOOL(FALSE)));
	aPageDesc.ChgFooterShare(FALSE);
	pShell->ChgPageDesc(nPgDescIdx,aPageDesc);
}

void MemoDialog::DelFuszTr()
{
	USHORT nPgDescIdx=pShell->GetCurPageDesc();
	SwPageDesc aPageDesc(pShell->GetPageDesc(nPgDescIdx));
	SwFrmFmt*  pFmt=&aPageDesc.GetMaster();
	SwFmtFooter aFooterFmt(pFmt->GetFooter());
	SwFrmFmt* pFooterFmt=aFooterFmt.GetFooterFmt();

	pFooterFmt->SetAttr( SvxBoxItem() );

	pFmt->SetAttr(aFooterFmt);
	pShell->ChgPageDesc(nPgDescIdx,aPageDesc);
}

void MemoDialog::DelKopz()
{
	USHORT nPgDescIdx=pShell->GetCurPageDesc();
	SwPageDesc aPageDesc(pShell->GetPageDesc(nPgDescIdx));
	SwFrmFmt*  pFmt=&aPageDesc.GetMaster();
	pFmt->SetAttr(SwFmtHeader(BOOL(FALSE)));
	aPageDesc.ChgHeaderShare(FALSE);
	pShell->ChgPageDesc(nPgDescIdx,aPageDesc);
}

void MemoDialog::DelKopzTr()
{
	USHORT nPgDescIdx=pShell->GetCurPageDesc();
	SwPageDesc aPageDesc(pShell->GetPageDesc(nPgDescIdx));
	SwFrmFmt*  pFmt=&aPageDesc.GetMaster();
	SwFmtHeader aHeaderFmt(pFmt->GetHeader());
	SwFrmFmt* pHeaderFmt=aHeaderFmt.GetHeaderFmt();

	pHeaderFmt->SetAttr( SvxBoxItem() );

	pFmt->SetAttr(aHeaderFmt);
	pShell->ChgPageDesc(nPgDescIdx,aPageDesc);
}

void MemoDialog::InsFusz()
{
	if (aPage1.aFusz.IsVisible()) {
		// Seite 1
		if (GotoBookmark(C2S("Dat1"))) {
			if (p2_CBox_Datum->IsChecked() && p3_CBox_FDatum->IsChecked()) {
				InsertBookmark(C2S("Datum1"));
			} else pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("Vtr1"))) {
			if (p3_CBox_FVertr->IsChecked()) {
				InsString(p3_Edit_FVertr->GetText());
			} else pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("Num1"))) {
			if (p3_CBox_FPgNum->IsChecked()) {
			} else pShell->DelFullPara();
		}
		if (!aPage1.aFusz.IsTrennlinie()) {
			DelFuszTr();
		}
		// Folgeseiten
		if (GotoBookmark(C2S("DtFF"))) {
			if (p2_CBox_Datum->IsChecked() && p3_CBox_FDatum->IsChecked()) {
				InsertBookmark(C2S("Datum2"));
			} else pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("VtrF"))) {
			if (p3_CBox_FVertr->IsChecked()) {
				InsString(p3_Edit_FVertr->GetText());
			} else pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("NmFF"))) {
			if (p3_CBox_FPgNum->IsChecked()) {
			} else pShell->DelFullPara();
		}
		if (!aPage1.aFusz.IsTrennlinie()) {
			DelFuszTr();
		}
	} else { // Fusszeilen entfernen
		if (GotoBookmark(C2S("Dat1"))) {
			DelFusz();
		}
		if (GotoBookmark(C2S("DtFF"))) {
			DelFusz();
		}
	}
}

void MemoDialog::InsKopz()
{
	if (p3_CBox_KDatum->IsChecked() ||
		(p3_CBox_KThema->IsChecked() && p1_RBtn_TitTxt->IsChecked())||
		p3_CBox_KPgNum->IsChecked()) {
		if (GotoBookmark(C2S("DtKF"))) {
			if (p2_CBox_Datum->IsChecked() && p3_CBox_KDatum->IsChecked()) {
				InsertBookmark(C2S("Datum3"));
			} else pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("NmKF"))) {
			if (p3_CBox_KPgNum->IsChecked()) {
			} else pShell->DelFullPara();
		}
		if (GotoBookmark(C2S("ThmF"))) {
			if (p3_CBox_KThema->IsChecked() && p1_RBtn_TitTxt->IsChecked()) {
				InsString(p1_CBox_TitTxt->GetText());
			} else pShell->DelFullPara();
		}
		if (!p3_CBox_KTrnLn->IsChecked()) {
			DelKopzTr();
		}
	} else {
		if (GotoBookmark(C2S("DtKF"))) {
			DelKopz();
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void MemoDialog::InsDocInfBookmark(USHORT nElemNum)
{
	if (GetDocInfStrOk(nElemNum)) {   // als DocInf freigegeben ?
		USHORT nIdx=nElemNum;      // nIdx geht von 0..aDoku.GetTxFieldAnz()-1
		USHORT i;
		for (i=0; i<nElemNum; i++) // fuer jeden nicht freigeg. davor, Idx um 1 dec.
			if (!GetDocInfStrOk(i)) nIdx--;
		nIdx+=pDoku->GetTxFieldOfs();
		if (nIdx==pDoku->pD_List_InfTit->GetSelectEntryPos())
			InsertBookmark(C2S("Titel"));
		if (nIdx==pDoku->pD_List_InfTem->GetSelectEntryPos())
			InsertBookmark(C2S("Thema"));
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////




/*************************************************************************


	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizmmgo.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizmmgo.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.32  2000/09/18 16:06:25  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.31  2000/04/19 11:19:00  os
	  UNICODE
	
	  Revision 1.30  2000/02/11 15:03:08  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.29  1999/02/19 13:03:58  JP
	  Bug #57558#/#57557#: statt Left-/RightMargin MovePara( Start/End ) benutzen


	  Rev 1.28   19 Feb 1999 14:03:58   JP
   Bug #57558#/#57557#: statt Left-/RightMargin MovePara( Start/End ) benutzen

	  Rev 1.27   09 Jan 1998 11:34:24   OM
   Datumsformate fuer Memos

	  Rev 1.26   24 Nov 1997 10:58:46   MA
   includes

	  Rev 1.25   12 Sep 1997 10:40:38   OS
   ITEMID_* definiert

	  Rev 1.24   15 Aug 1997 12:15:52   OS
   chartar/frmatr/txtatr aufgeteilt

	  Rev 1.23   12 Aug 1997 16:00:10   OS
   frmitems/textitem/paraitem aufgeteilt

	  Rev 1.22   07 Aug 1997 15:00:34   OM
   Headerfile-Umstellung

	  Rev 1.21   29 Aug 1996 09:04:56   OS
   includes

	  Rev 1.20   13 Dec 1995 18:30:18   MA
   unnuetzes entfernt

	  Rev 1.19   24 Nov 1995 16:59:10   OM
   PCH->PRECOMPILED

	  Rev 1.18   02 Aug 1995 18:52:54   JP
   kein TableMgr mehr; Undo abgeschaltet; ActionKlammerung; optimiert

	  Rev 1.17   29 Jul 1995 23:35:30   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.16   05 Jul 1995 19:10:54   JP
   SwBookmarkFUNC gibts nicht mehr, rufe Methoden an die Shell-Methoden

	  Rev 1.15   05 Jul 1995 13:09:26   JP
   BookmarkFUNC gibts nicht mehr

	  Rev 1.14   08 Feb 1995 18:19:00   JP
   Unsinn entfernt

	  Rev 1.13   22 Nov 1994 13:07:50   PK
   swborderattrmgr rausgeschmissen

	  Rev 1.12   28 Oct 1994 19:14:08   MA
   Reimport frmatr.

*************************************************************************/

