/*************************************************************************
 *
 *  $RCSfile: wizzard.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#include "wizzard.hxx"
#include "wizlt.hxx"
#include "wizfx.hxx"
#include "wizmm.hxx"
#include "wizag.hxx"
#include <vcl/msgbox.hxx>



Wizzard::Wizzard( USHORT nSlotId )
{
	SwWizardDialog* pDlg = 0;
	switch( nSlotId )
	{
	case SID_SW_LETTER_WIZZARD:	pDlg = new LetterDialog( 0 );	break;
	case SID_SW_FAX_WIZZARD:	pDlg = new FaxDialog( 0 );	break;
	case SID_SW_MEMO_WIZZARD:	pDlg = new MemoDialog( 0 );	break;
	case SID_SW_AGENDA_WIZZARD:	pDlg = new AgenDialog( 0 );	break;
	}

	if( pDlg )
	{
		if( RET_OK == pDlg->Execute() )
		{
			pDlg->WriteToIni();
			pDlg->MakeDoc();
		}
		delete pDlg;
	}
}


/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/sw/sw/source/ui/wizard/wizzard.cxx,v 1.1.1.1 2000/09/18 17:14:52 hr Exp $

	  Source Code Control System - Update

	  $Log: wizzard.cxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:52  hr
	  initial import
	
	  Revision 1.33  2000/09/18 16:06:26  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.32  2000/03/16 16:36:11  kz
	  add. include msgbox
	
	  Revision 1.31  2000/03/08 17:22:41  os
	  wizard control via SlotId
	
	  Revision 1.30  2000/02/11 15:03:25  hr
	  #70473# changes for unicode ( patched by automated patchtool )

	  Revision 1.29  1999/07/07 13:40:20  MA
	  WizardDialog renamed to SwWizardDialog


	  Rev 1.28   07 Jul 1999 15:40:20   MA
   WizardDialog renamed to SwWizardDialog

	  Rev 1.27   24 Nov 1997 10:58:46   MA
   includes

	  Rev 1.26   03 Nov 1997 14:01:46   MA
   precomp entfernt

	  Rev 1.25   01 Sep 1997 13:22:26   OS
   DLL-Umstellung

	  Rev 1.24   09 Jun 1997 14:28:46   MA
   chg: Browse-Flag nur noch am Doc

	  Rev 1.23   30 Jan 1997 11:08:44   OS
   UsrPrefs verdoppelt

	  Rev 1.22   29 Aug 1996 09:05:08   OS
   includes

	  Rev 1.21   24 Apr 1996 15:04:54   OS
   Umstellung UsrPref/ViewOption

	  Rev 1.20   08 Mar 1996 12:25:48   JP
   Wizzard nie im BrowserModus oeffnen

	  Rev 1.19   24 Nov 1995 16:59:18   OM
   PCH->PRECOMPILED

	  Rev 1.18   29 Jul 1995 23:35:44   JP
   alte Funktionalitaet wiederbeleben - Teil1

	  Rev 1.17   25 Oct 1994 19:34:32   ER
   add: PCH

	  Rev 1.16   17 May 1994 14:49:34   JOE
   Sicherheits-CheckIn

	  Rev 1.15   26 Apr 1994 19:34:10   JOE
   Wieder in HH: DelRight() gegen DelFullPara. GetErrorCode()

	  Rev 1.14   18 Apr 1994 10:53:30   JOE
   Segmentierung


*************************************************************************/


