/*************************************************************************
 *
 *  $RCSfile: ldump.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <../hashtbl.hxx>
#include <iostream.h>
#include <ctype.h>
#include <string.h>
#include <direct.h>

#include "../getopt.h"

#include <stdio.h>
#include <stdlib.h>

#include "ldump.hxx"

#define MAXSYM     32768
#define MAXBASE    49152
#ifdef WNT
#define MAX_MAN		1023
#else
#define MAX_MAN		1023
#endif

#define MH_TEST

int	bFilter = 0;

LibDump::LibDump( ByteString sFileName )
{
#ifndef ICC
    cerr << "LIB-NT File Dumper v2.02 (C) 2000 Sun Microsystems, Inc.\n\n";
#else
    cerr << "LIB-ICC File Dumper v2.03 (C) 1991-1997 STAR DIVISION\n\n";
#endif
	cerr << sFileName.GetBuffer() << endl;

	//int nSlots =  HashTabBase::GetNearPrime( (HASHTYPE) 32000 );
	int nSlots =  63997;
	pBaseTab = new ExportSet( nSlots );
	pIndexTab = new ExportSet( nSlots );
	pFilterLines = new char * [MAXFILT];
	CheckLibrary(sFileName);
	bBase = 0;
	bAll = FALSE;
	nDefStart = 0;
	nBaseLines = 0;
	nFilterLines = 0;
	bDef = TRUE;
	sAPrefix = ByteString();
	CheckDataBase();
}

BOOL LibDump::Dump()
{
	FILE *pList;
    char  aBuf[MAX_MAN];
    int   nLen;
    char  aName[MAX_MAN];

#ifndef ICC
    pList = fopen( sLibName.GetBuffer(), "rb");
	if (!pList)
		DumpError(10);

	// berechnug des offsets fuer anfang der gemangelten namen
	unsigned char TmpBuffer[4];
	fread( TmpBuffer, 1, 4, pList);
	// anzahl bigendian mal laenge + ueberspringen der naechsten laengenangabe
	ULONG nOffSet = ( TmpBuffer[2] * 256 + TmpBuffer[3] ) * 4 + 4;
	fseek( pList, nOffSet, 0);

    char c;
	char aTmpBuf[4096];
	// Einlesen der .exp-Datei
    while( !feof( pList ) )
    {
		int i = 0;
		// symbol komplett einlesen
        while ( (c = fgetc( pList )) != '\0' )
        {
            if ( ((c >= 33) && (c <= 126)) && ( c!=40 && c!=41) )
            	aBuf[i] = c;
            else
            {
                aBuf[0] = '\0';
                break;
            }
        	i++;
        }
		// Namen gefunden
        aBuf[i] = '\0';

		int n_is_ct;
	    if ((aBuf[0] =='?') || ( n_is_ct = !strncmp(aBuf, "__CT",4)))
		{
			nLen = strlen(aBuf);
            memset( aName, 0, sizeof( aName ) );
            int nName = 0;
            for( i = 0; i < nLen; i++ )
            {
                if ( (aBuf[i] != '\n') && (aBuf[i] != '\r') )
                {
                    aName[nName] = aBuf[i];
                    nName++;
                }
            }
			// und raus damit
            PrintSym( aName );
		}
		else if ( bAll == TRUE )
		{
			int nPreLen = sAPrefix.Len();

            nLen = strlen(aBuf);
            memset( aName, 0, sizeof( aName ) );
            int nName = 0;

            for( i = 0; i < nLen; i++ )
            {
              if ( (aBuf[i] != '\n') && (aBuf[i] != '\r') )
              {
                  aName[nName] = aBuf[i];
                  nName++;
			  }
			}
			//fprintf( stderr, "Gefundenen Prefix : %s %d \n", aTmpBuf, nPreLen );
			// den ersten _ raus
            nLen = strlen(aName);
            if (aName[0] == '_')
				strcpy( aBuf , &aName[1] );
			strncpy ( aTmpBuf, aBuf, nPreLen );
			aTmpBuf[nPreLen] = '\0';
			if ( !strcmp( aTmpBuf, sAPrefix.GetBuffer() ))
			{
#ifdef LDUMP3
				int nChar = '@';
				char *pNeu = strchr( aBuf, nChar );
				int nPos = pNeu - aBuf + 1;
				if ( nPos > 0 )
				{
					char aOldBuf[MAX_MAN];
					strcpy( aOldBuf, aBuf );
					char pChar[MAX_MAN];
					strncpy( pChar, aBuf, nPos -1 );
					pChar[nPos-1] = '\0';
					strcpy( aBuf, pChar );
					strcat( aBuf, "=" );
					strcat( aBuf, aOldBuf );
					strcpy( pChar, "" );
				}
#endif
			// und raus damit
            	PrintSym( aBuf, FALSE );
			}
		}
    }
#else
    pList = fopen( sLibName.GetBuffer(), "rb");
	if (!pList)
		DumpError(10);

	char c = fgetc( pList );

    while( !feof( pList ) )
    {
		int bBreakOut = 0;

		int i=0;
		BOOL bStop = FALSE;

        while ( c != '\0' )
        {
			if(c == 0x0d || c == 0x20)
			{
				c = fgetc( pList );
				continue;
			}

			if(c == '@')
			{
				bStop = TRUE;
				c = fgetc( pList );
				continue;
			}

			if(c != 0x0a)
			{
				if(!bStop)
					aBuf[i++] = c;
			}
            else
            {
                aBuf[i] = '\0';
				c = fgetc( pList );
                break;
            }

			c = fgetc( pList );
        }


		//wenn erstes Zeichen kein Semikolon ist, wird die Zeile bernommen
		if(aBuf[0] != ';' && aBuf[0] != 0)
		{
			//cdecl Methoden werden ohne NONAME expotiert
			if(aBuf[0] == '_' && aBuf[1] != '_' && sAPrefix.Len())
		      	PrintSym( aBuf, FALSE );
			else if(ByteString(aBuf).Search(sAPrefix) == 0)
		      	PrintSym( aBuf, FALSE );
			else
				PrintSym( aBuf );
		}
	}
#endif
	fclose(pList);
	return TRUE;
}

BOOL LibDump::ReadFilter( ByteString sFilterName )
{
	FILE* pfFilter = 0;
    char  aBuf[MAX_MAN];
    char* pStr;
    int   nLen;

    pfFilter = fopen( sFilterName.GetBuffer(), "r" );

    if ( !pfFilter )
    {
        ::bFilter = 0;
        DumpError( 500 );
        return TRUE;
    }

    while( fgets( aBuf, MAX_MAN, pfFilter ) != 0 )
    {
        nLen = strlen(aBuf);
        pStr = new char[nLen];
        if ( !pStr )
            DumpError( 98 );
        memcpy( pStr, aBuf, nLen );
        if ( *(pStr+nLen-1) == '\n' )
            *(pStr+nLen-1) = '\0';
		pFilterLines[nFilterLines] = pStr;
		nFilterLines++;
		if ( nFilterLines >= MAXFILT )
				DumpError( 510 );
    }

	fclose( pfFilter );
	return TRUE;
}

BOOL LibDump::PrintSym(char *pName, BOOL bName )
{
    int nTreffer = 0;
    int bTreffer = FALSE;
	LibExport *pData;
	ByteString *pString;


    // Filter auswerten
    if ( Filter( pName ) )
    {
        if ( strlen( pName ) > 3 )
        {
            if ( bDef )
		    {
		        if (!bBase)
				{
                        cout << "\t" << pName << "\t\t@" << nDefStart << "\n";
				}
				else
				{
					 pString = new ByteString( pName );
					 pData = pBaseTab->Find( *pString );
					 if ( pData )
					 {
						pData->bExport = TRUE;
						if ( bName )
							pData->bByName = TRUE;
						else
							pData->bByName = FALSE;
						fprintf(stderr,".");
					 }
					 else
					 {
					 	// neuen Export eintragen
					 	pData = new LibExport;
						pData->sExportName = *(ByteString *) new ByteString( pName );
						pData->nOrdinal = nBaseLines++;
						pData->bExport = TRUE;
						if ( bName )
							pData->bByName = TRUE;
						else
							pData->bByName = FALSE;
						pBaseTab->Insert( pData->sExportName, pData );
						pIndexTab->Insert( pData->nOrdinal, pData );
						fprintf(stderr,"n");
					 }
					 delete pString;
				}
		    }
            else
                printf( "%s\n", pName );
            nDefStart++;
        }
    }
	return TRUE;
}

BOOL LibDump::Filter(char *pExportName)
{
	ULONG i;
	char pTest[256];

    // Kein Filter gesetzt
    if ( ::bFilter == 0 )
        return TRUE;

	// die Imports bleiben drin !
	if ( strstr ( pExportName, "mport"))
		return TRUE;

	if( strstr ( pExportName, "getImpl"))
		i= 5;

	for ( i=0; i<nFilterLines; i++ )
	{
		//Zum vergleichen mu das Plus abgeschnitteb werden
		if(pFilterLines[i][0] != '+')
		{
			if ( strstr( pExportName, pFilterLines[i]))
				return FALSE;
		}
		else
		{
			strcpy(pTest,&pFilterLines[i][1]);
			if ( strstr( pExportName, pTest))
				return TRUE;
		}
	}
    return TRUE;
}

BOOL LibDump::SetFilter(ByteString sFilterName)
{
	ReadFilter( sFilterName );
	return TRUE;
}

BOOL LibDump::CheckLibrary(ByteString &sName)
{
	sLibName = sName;
	return TRUE;
}

BOOL LibDump::ReadDataBase()
{
	FILE* pfBase = 0;
    char  aBuf[MAX_MAN];
    char* pStr;
    int   nLen;
	LibExport *pData;

    pfBase = fopen( sBName.GetBuffer(), "r" );

    if ( !pfBase )
    {
        bBase = 0;
        DumpError( 600 );
        return FALSE;
    }

	BOOL bRet = TRUE;
	while( fgets( aBuf, MAX_MAN, pfBase ) != 0 )
    {
        nLen = strlen(aBuf);
        pStr = new char[nLen];
        if ( !pStr )
            DumpError( 98 );
        memcpy( pStr, aBuf, nLen );
        if ( *(pStr+nLen-1) == '\n' )
            *(pStr+nLen-1) = '\0';
		pData = new LibExport;
		pData->sExportName = *(ByteString *) new ByteString(pStr);
		pData->nOrdinal = nBaseLines;
		pData->bExport=FALSE;

		if (pBaseTab->Insert(pData->sExportName, pData ) == NULL)
			bRet = FALSE;
		if (pIndexTab->Insert(pData->nOrdinal, pData ) == NULL)
			bRet = FALSE;
        nBaseLines++;
        if ( nBaseLines >= MAXBASE )
            DumpError( 610 );
    }
    //nNumber = nBaseLines-1;
    fclose( pfBase );
	return bRet;
}

DECLARE_HASHTABLE_ITERATOR( ExportSetIter, LibExport* )

BOOL LibDump::PrintDataBase()
{
	FILE *pFp;
	pFp = fopen (sBName.GetBuffer(),"w+");
	if (!pFp)
		cerr << "Error opening DataBase File\n";

	LibExport *pData;
	for ( ULONG i=0; i < nBaseLines+10; i++ )
	{
		pData = pIndexTab->Find( ByteString::CreateFromInt64( i ));
		if ( pData )
			fprintf(pFp,"%s\n",pData->sExportName.GetBuffer());
	}
	fclose(pFp);
	return TRUE;
}

BOOL LibDump::PrintDefFile()
{
#ifdef FAST
	ExportSetIter aIterator( *pBaseTab );
	for ( LibExport *pData = aIterator.GetFirst(); pData != NULL;
										pData = aIterator.GetNext() )
	{
		if ( pData->bExport )
		{
			if ( pData->bByName )
			{
				fprintf(stdout,"\t%s\t\t@%d NONAME\n",
					pData->sExportName.GetBuffer(), pData->nOrdinal+nBegin);
			}
			else
			{
				fprintf(stdout,"\t%s\t\t@%d\n",
					pData->sExportName.GetBuffer(), pData->nOrdinal+nBegin);
			}
		}
	}
#else
	// sortiert nach Ordinals;
	LibExport *pData;
	for ( ULONG i=0; i<nBaseLines+1; i++)
	{
		pData = pIndexTab->Find( ByteString::CreateFromInt64( i ));
		if ( pData )
			if ( pData->bExport )
			{
				if ( pData->bByName )
				{
					if ( pData->sExportName != "" )
						fprintf(stdout,"\t%s\t\t@%d NONAME\n",
							pData->sExportName.GetBuffer(), pData->nOrdinal+nBegin);
				}
				else
				{
					if ( pData->sExportName != "" )
						fprintf(stdout,"\t%s\t\t@%d\n",
							pData->sExportName.GetBuffer(), pData->nOrdinal+nBegin);
				}
			}
	}
#endif
	return TRUE;
}

BOOL LibDump::CheckDataBase()
{
    // existiert eine Datenbasis ?
    if (!bBase)
    {
    	FILE *fp;
		mkdir ("defs");
		sBName = "defs\\";
    	sBName +=  (char *) getenv ("COMP_ENV");

		fp = fopen (sBName.GetBuffer(),"r");
		if (fp)
		{
			bBase = TRUE;
		}
		else
		{
			fp = fopen (sBName.GetBuffer(),"w+");
			bBase = TRUE;
		}
		fclose (fp);
    }
    // lese Datenbasis !
    if (bBase)
	{
    	ReadDataBase();
	}
	return TRUE;
}

LibDump::~LibDump()
{
}


//******************************************************************
//* Error() - Gibt Fehlermeldumg aus
//******************************************************************

BOOL LibDump::DumpError( ULONG n )
{
    char *p;

    switch (n)
    {
        case 1:  p = "Lesefehler in LIB-Datei"; break;
        case 2:  p = "Positionierfehler in LIB-Datei (kein THEADR-Satz)"; break;
        case 3:  p = "Ueberlauf der Symboltabelle"; break;
#ifdef WNT
        case 10: p = "EXP-Datei nicht gefunden"; break;
        case 11: p = "Datei ist keine EXP-Datei"; break;
#else
        case 10: p = "LIB-Datei nicht gefunden"; break;
        case 11: p = "Datei ist keine LIB-Datei"; break;
#endif
        case 98: p = "Speichermangel"; break;
#ifndef ICC
        case 99: p = "LDUMP [-A] [-Enn] [-Fname] [-BName] [-Gy] Dateiname[.LIB]\n"
#else
        case 99: p = "LDUMP [-A] [-Enn] [-Fname] [-BName] [-Gy] Dateiname[.cpf]\n"
#endif
                     "-A     : alle Symbole (Default: nur C++)\n"
                     "-Enn   : Exportlisten generieren ab nn\n"
                     "-Fname : Filterdatei\n"
                     "-Bname : BasisDatendatei\n"
                     "-Gy    : fuer Win3.x falls Compiler mit -Gy \n"; break;
        case 500: p = "Filterdatei konnte nicht geffnet werden\n"; break;
        case 510: p = "Ueberlauf der Filtertabelle\n"; break;
        case 600: p = "Basisdatendatei konnte nicht geffnet werden\n"; break;
        case 610: p = "Ueberlauf der Basisdatentabelle\n"; break;
        default: p = "Allgemeiner Fehler";
    }
    cout << p << "\n";
    exit (1);
	return FALSE;
}

/*********************************************************************
		Test Funktionen
*********************************************************************/

#ifdef MH_TEST

usage()
{
	LibDump::DumpError(99);
	exit(0);
	return 0;
}

#ifdef WNT
int __cdecl
#endif
main( int argc, char **argv )
{
	char *pLibName, *pFilterName, *pCExport= NULL;
	char pBegin[16];
	int c, nBegin=1;

	while (1)
	{
		int this_option_optind = optind ? optind :1;
		int option_index = 0;
		static struct option long_options[] =
		{
			{"prj",1,0,0 },
			{"file",1,0,0},
			{0,0,0,0 }
		};
		c = getopt_long ( argc, argv, "?ha:A:e:E:f:F:",
				long_options, &option_index );
		if ( c == EOF)
			break;

		switch (c)
		{
			case 'h' :
					usage();
				break;
			case '?' :
					usage();
				break;
			case 'e' :
			case 'E' :
					(void) strcpy( pBegin, optarg );
					nBegin = atoi( pBegin );
#ifdef DEBUG
					fprintf( stderr, "-E %s ", pBegin );
#endif
				break;
			case 'f' :
			case 'F' :
					pFilterName = new char[ strlen(optarg) + 1];
					(void) strcpy( pFilterName, optarg );
					bFilter = 1;
#ifdef DEBUG
					fprintf( stderr, "-F %s ", pFilterName );
#endif
				break;
			case 'a' :
			case 'A' :
					pCExport = new char[ strlen(optarg) + 1];
					(void) strcpy( pCExport, optarg );
//#ifdef DEBUG
	 				fprintf( stderr, "-A %s ", pCExport );
//#endif
				break;
		}
	}
#ifdef DEBUG
	fprintf( stderr, "\n" );
#endif
	if ( optind < argc )
	{
		while (optind < argc)
		{
			int nLength = strlen( argv[optind] ) +1;
			pLibName = (char *)new char [nLength];
			(void) strcpy ( pLibName, argv[optind] );
			optind++;
		}
	}
	else
	{
			usage();
			fprintf ( stderr, "fehlendes Argument !\n" );
			exit(0);
	}
	LibDump *pDump = new LibDump( ByteString(pLibName) );
	pDump->SetBeginExport(nBegin);
	if ( bFilter != 0 )
		pDump->SetFilter( pFilterName );
	if ( pCExport )
		pDump->SetCExport( pCExport );
	else
		pDump->SetCExport( "" );
	pDump->Dump();
	pDump->PrintDefFile();
	pDump->PrintDataBase();
	delete pDump;
	return 0;
}

#endif
