/*************************************************************************
 *
 *  $RCSfile: names.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stddef.h>

typedef void* (*ptrtofunction) ();
typedef int (*ptrtofunctioniiv) (int, void*);

class classforward1{};
class classforward2{};
struct structforward3{};

typedef structforward3 (*ptrtofunctionu) (classforward2&, classforward1*);

#ifdef WNT
#define CDECL __cdecl
#define STDCALL __stdcall
#else
#define CDECL
#define STDCALL
#endif

typedef int ( STDCALL *ptrtofunctioniiiv) (int, int, void*);

int functionA( int, short, long, char )
{
	return 0;
}

int CDECL functionB()
{
	return 0;
}

int STDCALL functionC()
{
	return 0;
}

long STDCALL functionD()
{
	return 1;
}

void functionE()
{
}


struct structA
{
	int n;
	short s;
	long l;
};

class classA
{
public:
		classA();
		classA( classA& );
		~classA();

	void	m1(void);
	static void	m11(void);
	void	m1(void) const;
	virtual ptrtofunction m1(int, int);
	virtual ptrtofunctionu m1(float, double);
	virtual ptrtofunctioniiv m1(long, long);
	void	m1(ptrtofunction);
	void	m1(ptrtofunctioniiv);
	void	m1(ptrtofunctioniiiv);
	void	m1(ptrtofunctionu);
	void	m1(void*);
	void	m1(void**);
	void	m1(int);
	void	m1(unsigned int);
	void	m1(int *);
	void	m1(int const *);
	void	m1(int&);
	void	m1(int const &);
	void	m1(short);
	void	m1(unsigned short);
	void	m1(short*);
	void	m1(short&);
	void	m1(long);
	void	m1(unsigned long);
	void	m1(long*);
	void	m1(long&);
	void	m1(char);
	void	m1(unsigned char);
	void	m1(char*);
	void	m1(char&);
	void	m1(double);
	void	m1(float);
	virtual void m1( int, char );

	void	m1(classforward1);
	void	m1(classforward1, classforward1);
	void	m1(classforward1, classforward2);
	void	m1(classforward1, classforward2, classforward1, classforward2);
	void	m1(classforward1, classforward2, classforward1, classforward2, classforward2, classforward1);
	void	m1(classforward1, classforward2, classforward1, classforward2, int, classforward2, classforward1);
	void	m1(classforward1, classforward2, classforward1, classforward2, int, classforward2, classforward1, structforward3, structforward3);
	void	m1(classforward1, classforward2, classforward1, classforward2, int, classforward2, classforward1, structforward3, structforward3, int, structforward3);
	void	m1(classforward1*);
	void	m1(classforward1&);
	void    m1(structforward3);
	void    m1(structforward3*);
	void    m1(structforward3&);

private:
	void	m2(void);
	void	m2(void) const;
	void	m2(void*);
	virtual void m2( int );
protected:
	void	m3(void);
	void	m3(void) const;
	void	m3(void*);
	virtual void	m3(int);

public:
	int 	m4(void);
	long    m5(void);
	short	m6(void);
	char	m7(void);

	classA* operator&();
	classA	operator&(classA);
	void	operator=(const classA& );
	void 	operator,(const classA& );
	void	operator+(classA&);
	void	operator-(classA&);
	void	operator*(classA&);
	void	operator/(classA&);
	void	operator%(classA&);
	void	operator^(classA&);
	void	operator|(classA&);
	void	operator~();
	void	operator!();
	void	operator<(classA&);
	void	operator>(classA&);
	void	operator+=(classA&);
	void	operator-=(classA&);
	void	operator*=(classA&);
	void	operator/=(classA&);
	void	operator%=(classA&);
	void	operator^=(classA&);
	void	operator&=(classA&);
	void	operator|=(classA&);
	void	operator<<(classA&);
	void	operator>>(classA&);
	void	operator>>=(classA&);
	void	operator<<=(classA&);
	void	operator==(classA&);
	void	operator!=(classA&);
	void	operator<=(classA&);
	void	operator>=(classA&);
	void	operator&&(classA&);
	void	operator||(classA&);
	classA	operator++(int);
	void	operator--(int);
	void	operator->*(classA&);
//#ifdef WNT
	void   operator->();
//#endif
	void	operator[](classA&);
	void	operator()(classA&);
	void*	operator new(unsigned int);
	void	operator delete(void*);
	//size_t	operator sizeof()();
		
};

classA::classA()
{
}

classA::classA( classA& rRef )
{
}

classA::~classA()
{
}

void classA::m1(void)
{
}

void classA::m11(void)
{
}

void classA::m1(void) const
{
}

void classA::m1(void* p)
{
}

void classA::m1(void** p)
{
}

void classA::m1( int n )
{
}

void classA::m1( unsigned int n )
{
}

void classA::m1( int* p )
{
}

void classA::m1( int const * p )
{
}

void classA::m1( int& r )
{
}

void classA::m1( int const & r )
{
}

void classA::m1( short n )
{
}

void classA::m1( unsigned short n )
{
}

void classA::m1( short* p )
{
}

void classA::m1( short& r )
{
}

void classA::m1( long n )
{
}

void classA::m1( unsigned long n )
{
}

void classA::m1( long* p )
{
}

void classA::m1( long& r )
{
}

void classA::m1( char n )
{
}

void classA::m1( unsigned char n )
{
}

void classA::m1( char* p )
{
}

void classA::m1( char& r )
{
}

void classA::m1( float n )
{
}

void classA::m1( double n )
{
}

ptrtofunction classA::m1( int, int ){return (ptrtofunction)0;}
ptrtofunctioniiv classA::m1( long, long ){return (ptrtofunctioniiv)0;}
ptrtofunctionu classA::m1( float, double ){return (ptrtofunctionu)0;}
void	classA::m1(ptrtofunction){}
void	classA::m1(ptrtofunctioniiv){}
void	classA::m1(ptrtofunctioniiiv){}
void	classA::m1(ptrtofunctionu){}
void classA::m1( int, char ){}

void classA::m2(void) {}
void classA::m2(void) const {}
void classA::m2(void*) {}
void classA::m2(int) {}

void classA::m3(void) {}
void classA::m3(void) const {}
void classA::m3(void*) {}
void classA::m3(int) {}

int classA::m4(void) { int i=0;return i;}
long  classA::m5(void) { long i=0; return i;}
short classA::m6(void) { short i=0; return i;}
char classA::m7(void) { char c='c'; return c;}

void classA::m1(classforward1) {}
void classA::m1(classforward1, classforward1) {}
void classA::m1(classforward1, classforward2) {}
void classA::m1(classforward1, classforward2, classforward1, classforward2){}
void classA::m1(classforward1, classforward2, classforward1, classforward2, classforward2, classforward1){}
void classA::m1(classforward1, classforward2, classforward1, classforward2, int, classforward2, classforward1){}
void classA::m1(classforward1, classforward2, classforward1, classforward2, int, classforward2, classforward1, structforward3, structforward3){}
void classA::m1(classforward1, classforward2, classforward1, classforward2, int, classforward2, classforward1, structforward3, structforward3, int, structforward3){}
void classA::m1(classforward1*) {}
void classA::m1(classforward1&) {}
void classA::m1(structforward3) {}
void classA::m1(structforward3*) {}
void classA::m1(structforward3&) {}

classA* classA::operator&()
{
	return (classA*) 0;
}

classA	classA::operator&(classA)
{
	classA abla;
	return abla ;
}

void	classA::operator=(const classA& ){}
void 	classA::operator,(const classA& ){}
void	classA::operator+(classA&){}
void	classA::operator-(classA&){}
void	classA::operator*(classA&){}
void	classA::operator/(classA&){}
void	classA::operator%(classA&){}
void	classA::operator^(classA&){}
void	classA::operator|(classA&){}
void	classA::operator~(){}
void	classA::operator!(){}
void	classA::operator<(classA&){}
void	classA::operator>(classA&){}
void	classA::operator+=(classA&){}
void	classA::operator-=(classA&){}
void	classA::operator*=(classA&){}
void	classA::operator/=(classA&){}
void	classA::operator%=(classA&){}
void	classA::operator^=(classA&){}
void	classA::operator&=(classA&){}
void	classA::operator|=(classA&){}
void	classA::operator<<(classA&){}
void	classA::operator>>(classA&){}
void	classA::operator>>=(classA&){}
void	classA::operator<<=(classA&){}
void	classA::operator==(classA&){}
void	classA::operator!=(classA&){}
void	classA::operator<=(classA&){}
void	classA::operator>=(classA&){}
void	classA::operator&&(classA&){}
void	classA::operator||(classA&){}
classA	classA::operator++(int){classA abla; return abla;}
void	classA::operator--(int){}
void	classA::operator->*(classA&){}
//#ifdef WNT
void	classA::operator->(){}
//#endif
void*	operator new(unsigned int){ return 0;}
void	operator delete(void*){ }
//size_t	operator sizeof(void){ }

int bla();

namespace namespaceA
{

void functionA()
{
}

class classB
{
public:
		classB();
		~classB();

	int	m1();
};

classB::classB()
{
}

classB::~classB()
{
}

int classB::m1()
{
	return 0;
}

namespace namespaceB
{
void functionA()
{
}

}	// end of namespace B
}	// end of namespace A

template<class T>
class classC
{
public:
			classC(int );
	void	m1( T* );
	//T		m2();
};

int main()
{
	classC<classA> aBlubb(1);

	return 0;
}

classC<class T>::classC(int bla)
{
}

void classC<class T>::m1( T* a )
{
}

