/*************************************************************************
 *
 *  $RCSfile: deliver.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:02:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#include "string.hxx"
#include "deliver.hxx"
#include "errhdl.hxx"
#include "bsecode.hxx"


class MyDeliver : public UPDDeliver
{
					MyDeliver();
public:
					MyDeliver(ByteString sInitP, ByteString sInitF = theDList );
					~MyDeliver();
	virtual char 	GetInput( ByteString aSrcFileName, ByteString aDestFileName );
	virtual void	GetDiff( ByteString aSrcFileName, ByteString aDestFileName );
	virtual void	Alarm( ByteString aSrcFileName, ByteString aDestFileName );
	virtual void	Print( ByteString sMessage );
};

MyDeliver::MyDeliver(ByteString sInitP, ByteString sInitF) :
	UPDDeliver( sInitP, sInitF )
{
	fprintf( stdout, "Deliver 2.0 ($Revision: 1.1.1.1 $)\n" );
}

MyDeliver::~MyDeliver()
{
	fprintf( stdout, "%d Files copied\n", pDeliverStat->nCopy );
	fprintf( stdout, "%d Files unchanged\n", pDeliverStat->nNotCopy );
	fprintf( stdout, "%d Files replaced\n", pDeliverStat->nReplace );
	fprintf( stdout, "%d Errors\n", pDeliverStat->nError );
}

/*
 * GetInput ist in diesem Beispiel so implemtentiert, so dass immer replaced
 * wird. Sinnvolle Ruekgabeparameter sind 'r' fuer Replace, 'c' fuer compare,
 * 'n' oder sonsige fuer nocopy
 *
 */

char MyDeliver::GetInput( ByteString aSrcFileName, ByteString aDestFileName )
{
	//fprintf( stderr, "MyDeliver :\n" );
	char aChar = 'r';
	return aChar;
}

/*
 * noch zu implementieren :
 * Methode, die Filepointer zurueckgibt, in dem das Diff nach einem Compare
 * enthalten ist.
 *
 */

void MyDeliver::GetDiff( ByteString aSrc, ByteString aDest )
{
	UPDDeliver::GetDiff( aSrc, aDest );
}

void MyDeliver::Alarm( ByteString aSrc, ByteString aDest )
{
	fprintf( stderr, "Allert: %s and %s are different!\n",
					aSrc.GetBuffer(), aDest.GetBuffer());
}


/*
 *
 * Print sorgt fuer die Ausgaben des Deliver
 *
 */

void MyDeliver::Print( ByteString sString )
{
	fprintf( stderr, "%s\n", sString.GetBuffer() );
}

/*
void UPDDeliver::Print( String sString )
{
	fprintf( stderr, "%s\n", sString.GetStr() );
}
*/
/*
 * main()
 *
 */

int
#ifdef WNT
__cdecl
#endif
main( int argc, char **argv )
{
	ByteString aDeliverName;
	char aFileName[255];

	strcpy( aFileName, theDList.GetBuffer());

/*	new BS_ErrorHandler;

	BS_ErrorContext aEC( ERRCTX_BS_DELIVER, "Deliver" ); */

	BOOL bDeliverAll = FALSE, bMinor = FALSE;
	BOOL bForce = FALSE;
	BOOL bRel = FALSE;
	ByteString aPath;

#ifdef OS2
	if ( signal( SIGINT, (_SigFunc)UPDDeliver::Signal) == SIG_ERR )
#else
	if ( signal( SIGINT, UPDDeliver::Signal) == SIG_ERR )
#endif
		fprintf( stderr, "Can't Catch SigInt !\n");

	if ( argc > 1 )
	{
		ByteString aOption;
		for ( USHORT i=1; i< argc; i++ )
		{
			aOption = argv[i];
			if ( aOption == "-all" )
				bDeliverAll = TRUE;
			else
			if ( aOption == "-minor" )
				bMinor = TRUE;
			else
			if ( aOption == "-abs" )
				bRel = TRUE;
			else
			if ( aOption == "-force" )
			{
				bForce = TRUE;
				#ifdef DEBUG
				fprintf(stderr, "Using -force" );
				#endif
			}
			else
			if ( aOption == "-f" )
			{
				i++;
				strcpy( aFileName, argv[i] );
				#ifdef DEBUG
				fprintf(stderr, "Using %s\n", aFileName );
				#endif
			}
			else
				aPath = aOption;
		}
	}
#ifndef UNX
#ifndef MAC
	MyDeliver *pDeliv = new MyDeliver( "..\\prj\\", aFileName );
#else
	MyDeliver *pDeliv = new MyDeliver( "::prj" , aFileName);
#endif
#else
	MyDeliver *pDeliv = new MyDeliver( "../prj/" , aFileName);
#endif
	// alle Header aus $PRJ\inc delivern !!
	//pDeliv->SetAll( TRUE );
	if ( aPath != "" )
		pDeliv->SetDestPath( aPath );
	pDeliv->SetUseMinor( bMinor );
	pDeliv->SetRel( bRel );
#if defined( WNT ) || defined ( MSC )
	// wir sind hier unter uns
	pDeliv->SetProtectedPublicHack( TRUE );
#endif
	if (pDeliv->Deliver( bDeliverAll ))
	{
		fprintf( stderr, "Fehler aufgetreten !\n Bitte nochmal delivern!\n");
		return 1;
	}
	delete pDeliv;

	return 0;
}
