/*************************************************************************
 *
 *  $RCSfile: dlvclass.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:02:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef SCO
#define _IOSTREAM_H
#endif

#include "debug.hxx"
#include <signal.h>
#include <stdio.h>

#if defined(OS2) || defined(WNT) || defined(WIN) || defined( DOS )
#include <conio.h>				// fuer _getch()
#endif
#if defined( OS2 ) || defined( WTC )
#define _getch getch
#endif

#ifdef UNX
#include <unistd.h>
#define PFADTRENNER '/'
#else
#ifdef MAC
#include <unistd.h>
#define PFADTRENNER ':'
#else
#define PFADTRENNER '\\'
#endif
#endif

#ifdef DEBUG
#include <stdio.h>
#endif
#include <stdlib.h>

#define protected public

#include "fsys.hxx"
#include "stream.hxx"
#include "appdef.hxx"
#include "deliver.hxx"
#include "fattr.hxx"
#include "command.hxx"
#include "prj.hxx"
#include "hedabu.hxx"
#include "inimgr.hxx"

#ifdef MAC
#define S_IREAD 0
#define S_IWRITE 0
#endif

#ifdef DEBUG
#define DEBUG_VERBOSE
#endif

extern ByteString GetPrj(
	DirEntry aEntry = DirEntry(UniString(".", gsl_getSystemTextEncoding())));

#if !defined ( OS2 ) && !defined ( GCC )
ByteString aBootstrapEmptyByteString;
#endif

static UniString aAccessDelimiter = DirEntry::GetAccessDelimiter();
#ifdef UNX
static const char pNullString[] = "/dev/null";
#else
static const char pNullString[] = "nul";
#endif

/*****************************************************************************/
ByteString GetPrj( DirEntry aEntry )
/*****************************************************************************/
{
	int i=0;
	int bOSbreak = 0;
	UniString aRetString;
	UniString aSrchFile = aAccessDelimiter;
	aSrchFile += UniString("prj", gsl_getSystemTextEncoding());
	aSrchFile += aAccessDelimiter;
	aSrchFile += UniString("d.lst", gsl_getSystemTextEncoding());

	UniString aSRCHFILE = aAccessDelimiter;
	aSRCHFILE += UniString("prj", gsl_getSystemTextEncoding());
	aSRCHFILE += aAccessDelimiter;
	aSRCHFILE += UniString("D.LST", gsl_getSystemTextEncoding());

	DirEntry *pPath = new DirEntry(UniString(".", gsl_getSystemTextEncoding()));
	if ( pPath ) while ( TRUE )
	{
		i++;
			UniString aPath = pPath->GetFull();
			UniString aPATH = pPath->GetFull();
			aPath += aSrchFile;
			aPATH += aSRCHFILE;
			DirEntry aTmpEntry( aPath );
			DirEntry aTMPENTRY( aPATH );
			if ( aTmpEntry.Exists() || aTMPENTRY.Exists() )
			{
				pPath->ToAbs();
				aRetString = pPath->GetFull();
				break;
			}
			else
			{
				pPath->SetCWD();
				DirEntry *pParent = new DirEntry( FSYS_FLAG_PARENT);
#ifdef OS2
				String aTmpPath = pParent->GetFull();
				if ( bOSbreak )
				{
					aRetString = UniString( pNullString, gsl_getSystemTextEncoding());
					break;
				}
				if ( aTmpPath.Len() < 5 )
					bOSbreak = 1;
#else
				if ( pParent->First() )
				{
					aRetString = UniString( pNullString, gsl_getSystemTextEncoding());
					break;
				}
				else
#endif
					pPath = pParent;
				if ( !pPath )
				{
					aRetString = UniString( pNullString, gsl_getSystemTextEncoding());
					break;
				}
			}
		// verhindern, dass wir allzuweit ueber die root hinausschiessen
		// und so endlos loopen
		if ( i > 20 )
		{
			aRetString = UniString( pNullString, gsl_getSystemTextEncoding());
			break;
		}
#ifndef OS2
		if ( pPath->First() )
			break;
#endif
		if ( pPath->GetName() == UniString( "/", gsl_getSystemTextEncoding()))
			break;
	}
	return ByteString( aRetString, gsl_getSystemTextEncoding());
}

/*****************************************************************************/
BOOL IsProduct()
/*****************************************************************************/
{
	ByteString aInpath( GetEnv( "INPATH" ));
	USHORT nPos = aInpath.Search( "." );
	if ( aInpath.Erase( nPos+1, nPos+4 ).ToLowerAscii() == "pro" )
		return TRUE;
	return FALSE;
}


/*****************************************************************************/
UPDDeliver::UPDDeliver( ByteString sInitPath, ByteString sInitFile )
/*****************************************************************************/
{

	bHack = FALSE;
	bUseMinor = FALSE;
	bRel = FALSE;
	sDeliverPath = GetPrj();
	sDeliverPath += ByteString( PFADTRENNER );
	sDeliverPath += ByteString( "prj" );
	sDeliverPath += ByteString( PFADTRENNER );
	sDeliverFile = sInitFile;

	pRplLst = new HedabuReplaceList;
	pDeliverStat = new DeliverStat;
}

/*****************************************************************************/
UPDDeliver::~UPDDeliver()
/*****************************************************************************/
{
	delete pDeliverStat;
	delete pRplLst;
}

/*****************************************************************************/
void UPDDeliver::Alarm( ByteString aSrcFileName, ByteString aDestFileName )
/*****************************************************************************/
{
}

/*****************************************************************************/
void UPDDeliver::Signal( int nSignal )
/*****************************************************************************/
{
	if ( !bControlC && ( nSignal == SIGINT ))
	{
		bControlC = TRUE;
		fprintf( stderr, "Got SIG INT \n" );
#ifdef OS2
		signal( SIGINT, (_SigFunc)UPDDeliver::Signal );
#else
		signal( SIGINT, UPDDeliver::Signal );
#endif
	}
	return;
}

/*****************************************************************************/
void UPDDeliver::InitList( Star *pStar )
/*****************************************************************************/
{

	ByteString sLstName;
	pCpyLst = new FileCopyList;

	Impl_Init();

	UniString sUniPath( sDeliverPath, gsl_getSystemTextEncoding());
	DirEntry aPathEntry( sUniPath );

	if ( !aPathEntry.Exists() )
			eStatus = INVALID_PATH;

	sLstName = sDeliverPath;
	sLstName += ByteString( PFADTRENNER );
	sLstName += sDeliverFile;

	UniString sUniLst( sLstName, gsl_getSystemTextEncoding());
	DirEntry aFileEntry( sUniLst );

	if ( !aFileEntry.Exists() )
	{
		eStatus = NO_FILE;
		ByteString sOutput( "No d.lst found in " );
		sOutput += ByteString( aFileEntry.GetFull().GetBuffer(), gsl_getSystemTextEncoding());
		sOutput += ByteString( "\n" );
		Print( sOutput );
	}
	Impl_Read( sLstName, pStar );
}

/*****************************************************************************/
void UPDDeliver::PutError( FSysError nError )
/*****************************************************************************/
{
	if ( nError == ERRCODE_IO_MISPLACEDCHAR	)
		Print( "Misplaced char \n" );

	if ( nError == FSYS_ERR_INVALIDCHAR	)
		Print( "Invalid char \n" );

	if ( nError == ERRCODE_IO_NOTEXISTS	)
		Print( "Does not exist \n" );

	if ( nError == ERRCODE_IO_ALREADYEXISTS	)
		Print( "Already exists \n" );

	if ( nError == ERRCODE_IO_NOTADIRECTORY	)
		Print( "Not a Driectory \n" );

	if ( nError == ERRCODE_IO_NOTAFILE )
		Print( "Not a File \n" );

	if ( nError == ERRCODE_IO_INVALIDDEVICE	)
		Print( "Invalid Drive \n" );

	if ( nError == ERRCODE_IO_ACCESSDENIED )
		Print( "Access Denied \n" );

	if ( nError == ERRCODE_IO_LOCKVIOLATION	)
		Print( "Sharing violation \n" );

	if ( nError == ERRCODE_IO_OUTOFSPACE )
		Print( "Volume is full \n" );

	if ( nError == ERRCODE_IO_ISWILDCARD )
		Print( "Wildcard Error \n" );

	if ( nError == ERRCODE_IO_NOTSUPPORTED )
		Print( "Not Supported \n" );

	if ( nError == ERRCODE_IO_UNKNOWN )
		Print( "Unknown Error \n" );
}

/*****************************************************************************/
DeliverResult UPDDeliver::Deliver(BOOL bAll, ByteString aProjectName )
/*****************************************************************************/
{
	ULONG nSize;
	BOOL bHelpCopy = FALSE;
	BOOL bSkip = FALSE;

	IniManager aIniManager;
	aIniManager.Update();
	ByteString aFileName( _SOLARLIST );
	aFileName = aIniManager.ToLocal( aFileName );
	UniString aUniFileName( aFileName, gsl_getSystemTextEncoding());
	Star *pStar = new Star( aUniFileName );
	InitList( pStar );
	// ForceDeliver !?!

	bForce = bAll;
	FSysError nRet = 0;
	ULONG nCount = pCpyLst->Count();

	// keine sinnvolle Solarlist gefunden !!
	if ( pStar->Count() < 1 )
		ErrorHandler::HandleError( FSYS_ERR_NOTEXISTS );

	for ( ULONG i=0; i<nCount; i++ )
	{
		// Source und Destination feststellen

		FileCopyData *pData = pCpyLst->GetObject(i);

		if ( pData->eAction == Deliver_Copy ||
				pData->eAction == Deliver_Touch ||
				pData->eAction == Deliver_Hedabu )

		{
			UniString aUniSource( *pData->pSource, gsl_getSystemTextEncoding());
			UniString aUniPath( sDeliverPath, gsl_getSystemTextEncoding());

			DirEntry aSrcRelEntry( aUniSource );
			DirEntry aSrcAbsEntry( aUniPath );

			DirEntry aSrcEntry = aSrcAbsEntry + aSrcRelEntry;

			UniString aUniDest( *pData->pDestination, gsl_getSystemTextEncoding());
			DirEntry aDestEntry( aUniDest );
			DateTime aSrcDateTime;
			DateTime aDestDateTime;
			if ( !aSrcEntry.Exists() )
				aSrcDateTime = DateTime( Date( 0,0,0 ), Time( 0, 0, 0 ));
			else
			{
				// FileDaten holen
				FileStat aSrcStat( aSrcEntry );
				nSize = aSrcStat.GetSize();
				Date aSrcDate = aSrcStat.DateModified();
				Time aSrcTime = aSrcStat.TimeModified();
				// auf 2 Sekunden adjustieren
				ULONG nSeconds = aSrcTime.GetSec();
				if ( nSeconds % 2 == 1 )
					aSrcTime.SetSec( --nSeconds );
				aSrcDateTime = DateTime( aSrcDate, aSrcTime );
			}

			if ( !aDestEntry.Exists() )
			{
				aDestDateTime = DateTime( Date( 0,0,0 ), Time( 0, 0, 0 ));
				bHelpCopy = TRUE;

			}
			else
			{
				FileStat aDestStat( aDestEntry );
				Date aDestDate = aDestStat.DateModified();
				Time aDestTime = aDestStat.TimeModified();
				aDestDateTime = DateTime( aDestDate, aDestTime );
			}

			// muss kopiert werden ?
			if ( (aSrcDateTime > aDestDateTime) )
			{
				FileAttribute aFileAttr( aDestEntry );
				// die urspruenglich FileAttribute Speichern
				FileAttribute aTmpAttr( aSrcEntry );

				// Destination einfach loeschen
				if ( aDestEntry.Exists() )
				{
					aFileAttr.Attrib( FA_WRITE );
					ByteString aFull( aDestEntry.GetFull(), gsl_getSystemTextEncoding());
					unlink( aFull.GetBuffer() );
				}
				// und Kopieren ....
#ifndef MAC
				FileCloner aCopy( aSrcEntry, aDestEntry );
#else
				FileCopier aCopy( aSrcEntry, aDestEntry );
#endif
				aCopy.SetErrorHdl( LINK( this, UPDDeliver, DeliverErrorHandler ));

				if ( !aDestEntry.Exists() )
				{
					if ( pData->eAction != Deliver_Hedabu )
					{
						Time aStartTime;
						ByteString aOutput( "Copy: " );
						aOutput += *pData->pSource;
						aOutput += " to ";
						aOutput += *pData->pDestination;
						Print( aOutput );

						nRet = aCopy.Execute();
						Time aEndTime;
						Time aExecTime = aEndTime - aStartTime;
						long nSec = aExecTime.GetMSFromTime() / 1000;
						long nBS; long nKB = 0 ;
						if ( nSec != 0 )
							nBS = nSize / nSec;
						else
							nBS = nSize;

						aOutput = " mit ";
						aOutput += ByteString::CreateFromInt64( nBS );
						aOutput += " Byte/s\n";
						Print( aOutput );
					}
					else
					{
						ByteString aOutput( "Hedabu: " );
						aOutput += *pData->pSource;
						aOutput += " to ";
						aOutput += *pData->pDestination;
						aOutput += "\n";
						Print( aOutput );

						// if hedabu() is unsuccesful then assign our
						// return value to non zero.
						if(!hedabu( *pData->pSource, *pData->pDestination,
							pRplLst, aProjectName, bHack, pStar ))
						{
							nRet = 1;
						}
					}
					pDeliverStat->nCopy++;
				}
				else
				if ( !bForce && !bSkip )
				{
					char aInput;
					ByteString aByteSrc;
					ByteString aByteDest;
input_label:
					aByteSrc = ByteString( aSrcEntry.GetFull(), gsl_getSystemTextEncoding());
					aByteDest = ByteString( aDestEntry.GetFull(), gsl_getSystemTextEncoding());
					aInput = GetInput( aByteSrc, aByteDest );
					if ( aInput == 'r' || aInput == 'R' )
					{
						ByteString aOutput( "Replacing: " );
						aOutput += *pData->pSource;
						aOutput += " to ";
						aOutput += *pData->pDestination;
						aOutput += "\n";
						Print( aOutput );
						if ( pData->eAction != Deliver_Hedabu )
							nRet = aCopy.Execute();
						else
						{
							// if hedabu() is unsuccesful then assign our
							// return value to non zero.
							if(!hedabu( *pData->pSource,
							*pData->pDestination, pRplLst, aProjectName,
							bHack, pStar ))
							{
								nRet = 1;
							}
						}
						pDeliverStat->nReplace++;
					}
					else
					if (aInput == 'c' || aInput == 'C' )
					{
						GetDiff( aByteSrc, aByteDest );
						goto input_label;

					}
					else
					{
							//if (aInput == 'n' || aInput == 'N' )
							Print( " ... No Action ... \n" );
					}
				}
				else
				{
					if ( !bSkip )
					{
						ByteString aOutput( "Copying: " );
						aOutput += *pData->pSource;
						aOutput += " to ";
						aOutput += *pData->pDestination;
						aOutput += "\n";
						Print( aOutput );

						if ( pData->eAction != Deliver_Hedabu )
							nRet = aCopy.Execute();
						else
						{
							// if hedabu() is unsuccesful then assign our
							// return value to non zero.
							if(!hedabu( *pData->pSource, *pData->pDestination,
										pRplLst, aProjectName, bHack, pStar ))
							{
								nRet = 1;
							}
						}
						pDeliverStat->nCopy++;
					}
					else
					{
						pDeliverStat->nError++;
					}
				}
				if ( pData->eAction == Deliver_Touch )
					aFileAttr.Touch();

			// die urspruenglich FileAttribute Sichern

			aFileAttr = aTmpAttr;
			// alle Rechte diese Welt setzen
			if ( !aFileAttr.Attrib( aFileAttr.GetFlags() ) && !bSkip )
			{
				Print( "Can't chmod after Copy\n" );
			}
			// Error Flag zuruecksetzen !
			bSkip = FALSE;
			/*bHelpCopy = FALSE;
			if ( !aCopy.Compare() ) Alarm( aSrcEntry.GetFull(), aDestEntry.GetFull()); */
			}
			else
			if ( aSrcDateTime < aDestDateTime )
			{
				pDeliverStat->nNotCopy++;
			}
			else
			if ( aSrcDateTime == aDestDateTime )
			{
				pDeliverStat->nNotCopy++;
			}
		}
		else
		if ( pData->eAction == Deliver_DosCommand )
		{
			CCommand aCommand( *pData->pCommand );
			int status = aCommand;
			delete pData->pCommand;
		}
		else
		if ( pData->eAction == Deliver_Pro )
		{
		}
		else
		if ( pData->eAction == Deliver_Ln )
		{
#ifdef UNX
			UniString aUniSource( *pData->pSource, gsl_getSystemTextEncoding());
			UniString aUniDestination( *pData->pDestination, gsl_getSystemTextEncoding());
			DirEntry aTmpEntry( aUniSource );
			DirEntry a2TmpEntry( aUniDestination );
			ByteString aPath = ( aTmpEntry.GetPath().GetFull(), gsl_getSystemTextEncoding());
			ByteString a1P = ( aTmpEntry.GetName(), gsl_getSystemTextEncoding());
			ByteString a2P = ( a2TmpEntry.GetName(), gsl_getSystemTextEncoding());

			ByteString aOutput( "Ln Path: " );
			aOutput += aPath;
			aOutput += " 1. ";
			aOutput += a1P;
			aOutput += " 2. ";
			aOutput += a2P;
			aOutput += "\n";
			Print( aOutput );

			ByteString aCommand("( cd ");
			aCommand += aPath; aCommand += "; ln -s ";
			aCommand += a1P; aCommand += " ";
			aCommand += a2P; aCommand += ")";

			if ( !a2TmpEntry.Exists())
			{
				CCommand aCmd( aCommand );
				int status = aCmd;
			}
#endif
		}
		else
		if ( pData->eAction == Deliver_Mkdir )
		{
			UniString aUniSource( *pData->pSource, gsl_getSystemTextEncoding());
		   	DirEntry aTouch( aUniSource );
		   	if(!aTouch.Exists())
			{
				aTouch.MakeDir();
			}
		}
		// an dieser Stelle ist mal wieder ein file abgearbeitet worden
		// da koennen wir bei einem inzwichen aufgelaufendem Contro-C
		// sauber abbrechen
		if ( bControlC )
		{
			bControlC = FALSE;
			return UNKNOWN_ERROR;
		}
	}

	delete pStar;
	if ( nRet )
		return UNKNOWN_ERROR;
	else
		return NO_ERROR;
}

/*****************************************************************************/
BOOL UPDDeliver::Impl_Read( ByteString sFile, Star *pStar )
/*****************************************************************************/
{
	int j=0;
	ByteString aBuffer;
	SvFileStream aFile;
	UniString aUniFile( sFile, gsl_getSystemTextEncoding());
	aFile.Open( aUniFile, STREAM_READ );

#ifdef WNT
	// map Files in jedem Fall kopieren
	ByteString aStr ( "..\\%__SRC%\\misc\\*.map %_DEST%\\bin%_EXT%\\*.map");
	ReadData_Impl( aStr, Deliver_Copy );
#endif
	while ( aFile.ReadLine( aBuffer ) )
	{
		if ( aBuffer != "" )
		{
			// so einige Sonderbehandlungen !
			// dos Befahle absetzen
			if ( aBuffer.GetToken( 0, ' ') == "dos:" )
			{
				// Rest der Zeile holen und ausfuehren
				//
				// den Rest der Zeile holen

				ByteString aCommandString = aBuffer.GetToken( 1, ':' );
#ifdef UNX
				while (aCommandString.SearchAndReplace( "\\", "/" ) != (USHORT)-1);
#endif
#ifdef MAC
				while (aCommandString.SearchAndReplace( "..\\..\\", ":::" ) != (USHORT)-1);

				while (aCommandString.SearchAndReplace( "..\\", "::" ) != (USHORT)-1);

				while (aCommandString.SearchAndReplace( "\\", ":" ) != (USHORT)-1);

#endif
				FileCopyData *pData = new FileCopyData;
				pData->eAction = Deliver_DosCommand;
				pData->pCommand = Impl_Transform(aCommandString);
#ifdef MAC
				String sOutput( "Attention! DOS: \n" );
				sOutput += aCommandString;
				sOutput += "\n";
				Print( sOutput );
#endif
				// In die Liste stopfen
				pCpyLst->Insert( pData, LIST_APPEND );
			}
			else
			if ( aBuffer.GetToken( 0, ' ') == "pro:" )
			{
				// nur fuer Produkt !!
				if ( /*Environment::*/IsProduct() )
				{
					ByteString aTmpStr( aBuffer.Copy(5, aBuffer.Len()));
					ByteString sCommonIn( aTmpStr );
					ReadData_Impl( aTmpStr , Deliver_Copy );

					if (( sCommonIn.Search( "%__src%" ) != STRING_NOTFOUND ) ||
						( sCommonIn.Search( "%__SRC%" ) != STRING_NOTFOUND ))
					{
						sCommonIn.SearchAndReplace( "%__src%", "%common_outdir%" );
						sCommonIn.SearchAndReplace( "%__SRC%", "%COMMON_OUTDIR%" );

						ReadData_Impl( sCommonIn , Deliver_Copy );
					}
				}
			}
			else
			if ( aBuffer.GetToken( 0, ' ') == "nopro:" )
			{
				// nur fuer NonProdukt !!
				if ( !/*Environment::*/IsProduct() )
				{
					ByteString aTmpStr( aBuffer.Copy(7, aBuffer.Len()));
					ByteString sCommonIn( aTmpStr );
					ReadData_Impl( aTmpStr , Deliver_Copy );

					if (( sCommonIn.Search( "%__src%" ) != STRING_NOTFOUND ) ||
						( sCommonIn.Search( "%__SRC%" ) != STRING_NOTFOUND ))
					{
						sCommonIn.SearchAndReplace( "%__src%", "%common_outdir%" );
						sCommonIn.SearchAndReplace( "%__SRC%", "%COMMON_OUTDIR%" );

						ReadData_Impl( sCommonIn , Deliver_Copy );
					}
				}
			}
			else
			if ( aBuffer.GetToken( 0, ' ') == "touch:" )
			{
				// den Rest der Zeile holen
				ByteString aTmpStr( aBuffer.Copy(7, aBuffer.Len()));
				ReadData_Impl( aTmpStr , Deliver_Touch );
			}
			else
			if ( aBuffer.GetToken( 0, ' ') == "mkdir:" )
			{
				// den Rest der Zeile holen
				ByteString aTmpStr( aBuffer.Copy(7, aBuffer.Len()));
				ReadData_Impl( aTmpStr , Deliver_Mkdir );
			}
			else
			if ( aBuffer.GetToken( 0, ' ') == "ln:" )
			{
				// den Rest der Zeile holen
				ByteString aTmpStr( aBuffer.Copy(4, aBuffer.Len()));
				ReadData_Impl( aTmpStr , Deliver_Ln );
			}
			else
			if ( aBuffer.GetToken( 0, ' ') == "hedabu:" )
			{
				// den Rest der Zeile holen

				ByteString aTmpStr = aBuffer.Copy( 8, aBuffer.Len());
				// Den Namen des zu deliverenden Files in die Hedabu Replace
				// List mit aufnehmen.
				ByteString aHeaderName = aTmpStr.GetToken( 0, ' ' );
#ifdef UNX
			        while (aHeaderName.SearchAndReplace( "\\", "/" ) != (USHORT)-1);
#endif

#ifdef MAC
			        while (aHeaderName.SearchAndReplace( "..\\..\\", ":::" ) != (USHORT)-1);

					while (aHeaderName.SearchAndReplace( "..\\", "::" ) != (USHORT)-1);

				    while (aHeaderName.SearchAndReplace( "\\", ":" ) != (USHORT)-1);

#endif
				UniString aUniHeader( aHeaderName, gsl_getSystemTextEncoding());
				DirEntry aHeaderFile( aUniHeader );
				ByteString *pHeaderFileName = new ByteString( aHeaderFile.GetName(), gsl_getSystemTextEncoding());
				pRplLst->Insert( pHeaderFileName, LIST_APPEND );
				ByteString sCommonIn( aTmpStr );
				ReadData_Impl( aTmpStr, Deliver_Hedabu );

				if (( sCommonIn.Search( "%__src%" ) != STRING_NOTFOUND ) ||
					( sCommonIn.Search( "%__SRC%" ) != STRING_NOTFOUND ))
				{
					sCommonIn.SearchAndReplace( "%__src%", "%common_outdir%" );
					sCommonIn.SearchAndReplace( "%__SRC%", "%COMMON_OUTDIR%" );

					ReadData_Impl( sCommonIn , Deliver_Hedabu );
				}

			}
			else {
				ByteString sCommonIn( aBuffer );
				ReadData_Impl( aBuffer, Deliver_Copy );

				if (( sCommonIn.Search( "%__src%" ) != STRING_NOTFOUND ) ||
					( sCommonIn.Search( "%__SRC%" ) != STRING_NOTFOUND ))
				{
					sCommonIn.SearchAndReplace( "%__src%", "%common_outdir%" );
					sCommonIn.SearchAndReplace( "%__SRC%", "%COMMON_OUTDIR%" );

					ReadData_Impl( sCommonIn , Deliver_Copy );
				}
			}
		}
	}
	// Zusaetzlich sollen alle Headerfiles aus dem globalen include
	// delivert werden

	if ( bNew ) {
#ifndef UNX

#ifndef MAC
		UniString aUniDir( "..\\inc\\*.h*", gsl_getSystemTextEncoding());
#else
		UniString aUniDir( "::inc:*.h*", gsl_getSystemTextEncoding());
#endif
#else
		UniString aUniDir( "../inc/*.h*", gsl_getSystemTextEncoding());
#endif
		Dir aDir( aUniDir );

		ULONG nCount = aDir.Count();
		for ( USHORT k=0; k<nCount; k++)
		{
			ByteString aRelFilename( aDir[k].GetFull(), gsl_getSystemTextEncoding());
			aDir[k].ToAbs();
			ByteString aFilename( aDir[k].GetFull(), gsl_getSystemTextEncoding());
			ByteString aFile( aDir[k].GetName(), gsl_getSystemTextEncoding());
			DirEntry aTmpDEntry( aDir[k].GetFull());
			// Dieses geht bei /home/usr/mh schief !
			//String aPrjname = pStar->GetPrj( aTmpDEntry );
			ByteString aPrjname = ::GetPrj();
			ByteString aSFileName( sSolarversion );
			aSFileName += PFADTRENNER;
			aSFileName += sInpath;
			aSFileName += PFADTRENNER;
			aSFileName += "inc";
			aSFileName += PFADTRENNER;
			aSFileName += aPrjname;

			UniString aUniSFileName( aSFileName, gsl_getSystemTextEncoding());
			DirEntry aDir( aUniSFileName );

			if ( !aDir.Exists())
				aDir.MakeDir();

			aSFileName += PFADTRENNER;
			aSFileName += aFile;

			FileCopyData *pData = new FileCopyData;
			pData->eAction = Deliver_Hedabu;
			pData->pSource = new ByteString(aRelFilename);
			pData->pDestination = new ByteString(aSFileName);
			// In die Liste stopfen
			pCpyLst->Insert( pData, LIST_APPEND );
		}

	} // if bNew

	aFile.Close();

	return FALSE;
}

/*****************************************************************************/
BOOL UPDDeliver::ReadData_Impl( ByteString &rBuffer, DeliverAction eAction )
/*****************************************************************************/
{
	ByteString aSrc, aDest;
	BOOL bWild = FALSE;
	FileCopyData *pData;
	pData = new FileCopyData;

	aSrc = rBuffer.GetToken(0,' ');
	aDest = rBuffer.GetToken(1,' ');

#ifdef UNX
	while (aSrc.SearchAndReplace( "\\", "/" ) != (USHORT)-1);
	while (aDest.SearchAndReplace( "\\", "/" ) != (USHORT)-1 );
#endif
#ifdef MAC
	while (aSrc.SearchAndReplace( "..\\..\\", ":::" ) != (USHORT)-1);
	while (aSrc.SearchAndReplace( "..\\", "::" ) != (USHORT)-1);
	while (aSrc.SearchAndReplace( "\\", ":" ) != (USHORT)-1);
	while (aDest.SearchAndReplace( "..\\..\\", ":::" ) != (USHORT)-1);
	while (aDest.SearchAndReplace( "..\\", "::" ) != (USHORT)-1);
	while (aDest.SearchAndReplace( "\\", ":" ) != (USHORT)-1 );
#endif
	UniString aUniSrc( aSrc, gsl_getSystemTextEncoding());
	DirEntry aSrcRelEntry( aUniSrc );
	UniString aUniDeliver( sDeliverPath, gsl_getSystemTextEncoding());
	DirEntry aSrcAbsEntry( aUniDeliver );
	DirEntry aSrcEntry;

	if(eAction == Deliver_Mkdir || eAction == Deliver_Ln || bRel )
		aSrcEntry = aSrcRelEntry;
	else
		aSrcEntry = aSrcAbsEntry + aSrcRelEntry;

	ByteString aFullName( aSrcEntry.GetFull(), gsl_getSystemTextEncoding());

	UniString aTmpString( *Impl_Transform( aFullName ), gsl_getSystemTextEncoding());
	// ob wir uns hier wohl Wildcards eingefangen haben ??

	DirEntry aTmpDirEntry (aTmpString);
	Dir aDir( aTmpDirEntry, FSYS_KIND_FILE | FSYS_KIND_WILD );
	USHORT y = aDir.Count();
	for ( USHORT i=0; i<y; i++ )
	{
		if (i)
			pData = new FileCopyData;

		pData->eAction = eAction;
		UniString aTmpPath( *Impl_Transform( aDest ), gsl_getSystemTextEncoding());
		DirEntry aDest( aTmpPath );

		ByteString aDestPath( aDest.GetPath().GetFull(), gsl_getSystemTextEncoding());
		pData->pSource = new ByteString( aDir[i].GetPath().GetFull(), gsl_getSystemTextEncoding());

		ByteString sFName( aDir[i].GetName(), gsl_getSystemTextEncoding());
#ifndef WTC
		*pData->pSource += PFADTRENNER;
		*pData->pSource += sFName;
#endif
		pData->pDestination = new ByteString( aDestPath );
		*pData->pDestination += PFADTRENNER;
		*pData->pDestination += sFName;

		if ( eAction == Deliver_Touch )
			pData->eAction = Deliver_Touch;
		// In die Liste stopfen
		pCpyLst->Insert( pData, LIST_APPEND );
		bWild = TRUE;
	}

	if ( !bWild )
	{
		pData->eAction = eAction;
		ByteString aTransform( aTmpString, gsl_getSystemTextEncoding());
		pData->pSource = Impl_Transform(aTransform);
		pData->pDestination = Impl_Transform(aDest);

		// In die Liste stopfen
		pCpyLst->Insert( pData, LIST_APPEND );

	}
	return FALSE;
}

/*****************************************************************************/
ByteString UPDDeliver::Impl_TransformNative( ByteString &rString )
/*****************************************************************************/
{
	ByteString sVariable;
	ByteString sConverted;

	BOOL bText = TRUE;

	for ( USHORT i = 0; i < rString.Len(); i++ ) {
		char cChar( rString.GetChar( i ));
		if ( bText ) {
			switch ( cChar ) {
				case '%':
					sVariable += cChar;
					bText = FALSE;
				break;
				default:
					sConverted += cChar;
				break;
			}
		}
		else {
			switch ( cChar ) {
				case ' '  :
				case '\\' :
				case '.'  :
				case '%'  : {
					sVariable += cChar;
					ByteString sVar( sVariable );
					sVar.EraseAllChars( '%' );
					ByteString sVal( GetEnv( sVar.GetBuffer()));
					if ( sVal.Len())
						sVariable = sVal;
					sConverted += sVariable;
					sVariable = "";
					bText = TRUE;
				}
				break;
				default:
					sVariable += cChar;
				break;
			}
		}
	}
	if ( sVariable.Len()) {
		ByteString sVar( sVariable );
		sVar.EraseAllChars( '%' );
		ByteString sVal( GetEnv( sVar.GetBuffer()));
		if ( sVal.Len())
			sVariable = sVal;
		sConverted += sVariable;
	}
	return sConverted;
}

/*****************************************************************************/
ByteString* UPDDeliver::Impl_Transform( ByteString &rString )
/*****************************************************************************/
{
	ByteString aSRC = "%__SRC%";
	ByteString asrc = "%__src%";
	ByteString aCMN = "%COMMON_OUTDIR%";
	ByteString acmn = "%common_outdir%";
	ByteString aWORKSTAMP = "%__WORK_STAMP%";
	ByteString aWorkStamp = "%__work_stamp%";
	ByteString aDEST = "%_DEST%";
	ByteString aEXT = "%_EXT%";
	ByteString aUPD = "%UPD%";
	ByteString aupd = "%upd%";
	ByteString aSDK = "%SDK%";
	ByteString asdk = "%sdk%";
	ByteString aDLLSUFFIX = "%DLLSUFFIX%";
	ByteString adllsuffix = "%dllsuffix%";
	ByteString aOffenv = "%__OFFENV%";
	ByteString aGUI = "%GUI%";
	ByteString agui = "%gui%";
	ByteString aOUTPATH = "%OUTPATH%";
	ByteString aoutpath = "%outpath%";
	ByteString sSdk = GetEnv( "SDK" );
	ByteString sDllSuffix = GetEnv( "DLLSUFFIX" );
	ByteString *pStr = new ByteString();

	rString.SearchAndReplaceAll( ByteString("%__PRJROOT%"), GetPrj() );
	rString.SearchAndReplaceAll( aUPD, sUpd );
	rString.SearchAndReplaceAll( aupd, sUpd );

	rString.SearchAndReplaceAll( aSDK, sSdk );
	rString.SearchAndReplaceAll( asdk, sSdk );

	rString.SearchAndReplaceAll( aWORKSTAMP, sWorkStamp );
	rString.SearchAndReplaceAll( aWorkStamp, sWorkStamp );

	rString.SearchAndReplaceAll( aDLLSUFFIX, sDllSuffix );
	rString.SearchAndReplaceAll( adllsuffix, sDllSuffix );

	rString.SearchAndReplaceAll( aOffenv, sOffenv );

	rString.SearchAndReplaceAll( aOUTPATH, sOutpath );
    rString.SearchAndReplaceAll( aoutpath, sOutpath );

    rString.SearchAndReplaceAll( aGUI, sGui );
    rString.SearchAndReplaceAll( agui, sGui );

	ByteString _sInpath = sInpath;
	ByteString _sCommon = sCommon;
#ifndef MAC
	_sInpath += PFADTRENNER;
	_sCommon += PFADTRENNER;
#endif

	rString.SearchAndReplace( aSRC, _sInpath);
	rString.SearchAndReplace( asrc, _sInpath);
	rString.SearchAndReplace( aCMN, _sCommon);
	rString.SearchAndReplace( acmn, _sCommon);

	ByteString _sDest;

	if ( sDestPath != "" )
		_sDest = sDestPath;
	else {
		_sDest = sSolarversion;
		_sDest += PFADTRENNER;
		_sDest += sInpath;
#ifndef MAC
		_sDest += PFADTRENNER;
#endif
	}

	while (rString.SearchAndReplace( aDEST, _sDest) != (USHORT)-1);
	ByteString _sExt;
	if ( bUseMinor )
	{
		_sExt = ".";
		_sExt += sMinor;
	}

	while (rString.SearchAndReplace( aEXT, _sExt) != (USHORT)-1);
	// Hack !!!
#ifdef UNX
	ByteString aSolverPath = "/develop4/update/";
	aSolverPath += sWorkStamp;
	aSolverPath += "/dev/solver/";
	while (rString.SearchAndReplace( "%SOLARVER%",  aSolverPath )!=(USHORT)-1);
#else
	while (rString.SearchAndReplace( "%SOLARVER%", "s:\\solver" )!=(USHORT)-1);
#endif

	rString = Impl_TransformNative( rString );

	*pStr = rString;
	return pStr;
}

/*****************************************************************************/
BOOL UPDDeliver::bControlC = FALSE;
/*****************************************************************************/

/*****************************************************************************/
void UPDDeliver::Impl_Init()
/*****************************************************************************/
{
	bNew = FALSE; bControlC = FALSE;

	sInpath = ByteString( GetEnv("INPATH"));
	sCommon = ByteString( GetEnv("COMMON_OUTDIR"));
	sPro = ByteString( GetEnv("PROEXT"));
	sCommon += sPro;
	sUpd = ByteString( GetEnv("UPD"));
	sSolarver = ByteString( GetEnv("SOLARVER" ));
	sSolarversion = ByteString( GetEnv("SOLARVERSION" ));
	// if SOLARVERSION not set the we use the old mechanism
	if ( sSolarversion == "" )
	{
		sSolarversion = sSolarver;
		sSolarversion += PFADTRENNER;
		sSolarversion += sUpd;
	}
	sMinor = ByteString( GetEnv("UPDMINOR"));
	if ( sMinor == "" )
		sMinor = ByteString( GetEnv("DMAKE_MINOR"));
	sOffenv = ByteString( GetEnv("OFFENV_PATH"));
	sWorkStamp = ByteString( GetEnv("WORK_STAMP"));
	sGui = ByteString( GetEnv("GUI"));
	sGui.SearchAndReplaceAll( "UNX", "unx" );
	sGui.SearchAndReplaceAll( "WNT", "wnt" );

	sOutpath = ByteString( GetEnv("OUTPATH"));

	pDeliverStat->nCopy = pDeliverStat->nNotCopy = 0;
	pDeliverStat->nReplace = 0;
	pDeliverStat->nError = 0;

	MkDestDirs();
}

/*****************************************************************************/
ByteString UPDDeliver::MKSubDir(
	const ByteString &rDir, const ByteString &rSub, BOOL bMinor )
/*****************************************************************************/
{
	ByteString sSub( rSub );
#if defined( UNX ) || defined( MAC )
	if (sMinor.Len())
#endif
	if ( bUseMinor && bMinor ) {
		sSub += ".";
		sSub += sMinor;
	}

	String sUniDir( rDir, gsl_getSystemTextEncoding());
	String sUniSub( sSub, gsl_getSystemTextEncoding());

	DirEntry aFull( sUniDir );
	aFull += DirEntry( sUniSub );

	if ( !aFull.Exists())
		aFull.MakeDir();

	return ByteString( aFull.GetFull(), gsl_getSystemTextEncoding());
}

/*****************************************************************************/
void UPDDeliver::MkDestDirs()
/*****************************************************************************/
{
	UniString aDir;
	ByteString aPath;
	if ( sDestPath == "" ) {
		aDir = UniString( sSolarversion, gsl_getSystemTextEncoding());
		aPath = sSolarversion;
	}
	else {
		aDir = UniString( sDestPath, gsl_getSystemTextEncoding());
		aPath = sDestPath;
	}

	if ( sDestPath == "" )
	{
		// %SOLARVER anlegen
		DirEntry aSolarVer( aDir );
		if ( !aSolarVer.Exists() )
		{
			aSolarVer.MakeDir();
		}

		UniString aUniUpd( sUpd, gsl_getSystemTextEncoding());
		DirEntry aSolarVerUpd( sSolarversion );
		if ( !aSolarVerUpd.Exists() )
		{
			aSolarVerUpd.MakeDir();
		}

		UniString aUniInpath( sInpath, gsl_getSystemTextEncoding());
		DirEntry aSolarVerUpdInpath( aSolarVerUpd );
		aSolarVerUpdInpath += DirEntry( aUniInpath );

		if ( !aSolarVerUpdInpath.Exists() )
		{
			aSolarVerUpdInpath.MakeDir();
		}

		aDir = aSolarVerUpdInpath.GetFull();
	}

	aPath = ByteString( aDir, gsl_getSystemTextEncoding());

	MKSubDir( aPath, "inc" );
	MKSubDir( aPath, "lib" );
	MKSubDir( aPath, "res" );
	MKSubDir( aPath, "idl" );
	MKSubDir( aPath, "xml" );
	MKSubDir( aPath, "rdb" );
	ByteString sBin( MKSubDir( aPath, "bin" ));
	MKSubDir( sBin, "app", FALSE );
}

/*****************************************************************************/
char UPDDeliver::GetInput( ByteString aSrcFileName, ByteString aDestFileName )
/*****************************************************************************/
{

	char aInput;

	ByteString sOutput( aSrcFileName );
	sOutput += " to ";
	sOutput += aDestFileName;
	sOutput += "\n";
	Print( sOutput );
	Print( "(R)eplace, (C)ompare, (N)ocopy ?\n" );

#if defined( UNX ) || defined ( MAC)
	aInput = fgetc(stdin);
#else
	aInput = _getch();
#endif

	return aInput;
}

/*****************************************************************************/
void UPDDeliver::GetDiff( ByteString aSrc, ByteString aDest )
/*****************************************************************************/
{
		ByteString aCompareCommand = CCommand::Search("Path", "vdiff.exe " );
		aCompareCommand += aSrc;
		aCompareCommand += " ";
		aCompareCommand += aDest;
		CCommand aCommand( aCompareCommand );
		int status = aCommand;
}

/*****************************************************************************/
IMPL_LINK( UPDDeliver, DeliverErrorHandler, void*, EMPTYARG )
/*****************************************************************************/
{
	return 0;
}



