/*************************************************************************
 *
 *  $RCSfile: hedabu.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:02:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "string.hxx"
#include "fsys.hxx"
#include "deliver.hxx"
#include "errhdl.hxx"
#include "bsecode.hxx"
#include "appdef.hxx"
#include "prj.hxx"

// deklaration auf dlvclass.cxx
ByteString GetPrj(
	DirEntry aEntry = DirEntry(UniString(".", gsl_getSystemTextEncoding())));

static HedabuReplaceList *pIncludeReplace;
static ByteString aPrjName;
static BOOL bHxx;
static BOOL bprotectedpublichack;

#ifdef MAC
#include <cursorctl.h>
#endif

#ifdef OLD_HEDABU
#include "cmdlin.hxx"
#endif

#define LINE_MAXLEN 10240

BOOL hedabu( FILE *fpint, FILE *fpout );
BOOL hedabu( FILE *fpint, FILE *fpout, HedabuReplaceList * );

#ifdef UNX
#define SEPSIGN ":"
#else
#define SEPSIGN ";"
#endif

#ifdef MAC
/*************************************************************************
|*
|*	  char * strdup( const char *pChar )
|*
|*	  Beschreibung		FSYS.DOC
|*	  Ersterstellung	MA 18.09.91
|*	  Letzte Aenderung	MA 18.09.91
|*
*************************************************************************/
//strdup kennt der MAC leider nicht
char * strdup( const char *pChar )
{
	char *pReturn = new char[ strlen( pChar ) + 1 ];
	strcpy( pReturn, pChar );
	return pReturn;
};
#endif

extern "C" {    //den prep binden wir heute als LIB dazu.
int start_cpp( int argc, char *argv[] );
};

enum Zustand
{
	NORMAL,
	STRING,
	EXPECTCOMMENT,
	LINECOMMENT,
	COMMENT,
	INCOMMENT,
	COMMENTEND
};

ByteString aInclude;
WildCard aExcludeWild( UniString( "", gsl_getSystemTextEncoding()), ';' );
WildCard aForceIncludeWild( UniString( "", gsl_getSystemTextEncoding()) , ';' );
BOOL WithComments=FALSE;

const char* pHelpPage1[] =
{
	"------------------------------------------------------------------",
	"Header Datei Builder V1.01 -- copyright (c) 1991/94 by StarDivision",
	"by Matthias Breuer. Special thanks to Thomas Hosemann.",
	"",
	"Builds a new Headerfile by merging Headerfiles.",
	"Commends and surplus empty Lines are removed.",
	"Beware: No Line should be longer than 2048 bytes.",
	"",
	"Syntax: hedabu [Options] [@<resposefile>] -O:Outputfile Inputfile",
	"",
	"Valid Options are:",
	"",
	"-D:<Define>    Define   for evaluation of the Inputfile",
	"-U:<Undefine>  UnDefine for evaluation of the Inputfile",
	"-I:<Path>      Include Path for searching for the Inputfile",
	"               and the Headerfiles",
	"-E:WildCard    Every line in the Headerfile matching the WildCard",
	"               will be ignored. '*' and '?' are the Wild-Card characters,",
	"               they will be used as usually.",
	"-K:WildCard    Every line in the Headerfile matching the WildCard",
	"               will be kept even if it matches a Wildcard specified",
	"               by the -E option.",
	"-C:            Enable comments in outputfile",
	"-H             Displays this Help-Page",
	"-HX            Explains Inputfile-Syntax",
	"------------------------------------------------------------------",
	"",
	NULL,
};
const char* pHelpPage2[] =
{
	"------------------------------------------------------------------",
	"Header Datei Builder V1.01 -- copyright (c) 1991/94 by StarDivision",
	"by Matthias Breuer. Special thanks to Thomas Hosemann.",
	"",
	"Allowed Statements for the Inputfile:",
	"",
	"Statement   Meaning",
	"",
	"echo  \"TXT\" TXT would be echoed to stdout.",
	"            If there's no \"TXT\", an empty Line would be echoed.",
	"write \"TXT\" TXT would be written to the Outputfile.",
	"            If there's no \"TXT\", an empty Line would be written.",
	"file        All stuff behind the first Blank is assumed as an",
	"            Input-Headerfile-Name.",
	"",
	"- Only one Statement should occur in every Line.",
	"- Empty Lines are allowed.",
	"- C and C++ Commends are allowed.",
	"- Usual Preprocessor Directives like '#if, #else, #endif, #include'",
	"  are allowed.",
	"- The define __DATE__ will be replaced as usual.",
	"------------------------------------------------------------------",
	NULL,
};

void Help( char **pHelpPage )
{
	USHORT i = 0;
	while ( pHelpPage[i] != NULL )
		puts( pHelpPage[ i++ ] );
	exit( 0 );
};

ByteString& ReplaceHeader( ByteString &aOut )
{
	BOOL bFound = FALSE;
	ByteString aHeaderName = aOut.Copy( 10 );
	aHeaderName.SearchAndReplace( '>','\0' );
	aHeaderName.SearchAndReplace( '"','\0' );
	for ( ULONG i=0; i<pIncludeReplace->Count(); i++ )
	{
		ByteString aStr = *pIncludeReplace->GetObject(i);
		if ( aHeaderName.CompareTo( aStr ) == COMPARE_EQUAL )
		{
			bFound = TRUE;
			break;
		}
	}
	if ( bFound == TRUE)
	{
		aOut = aOut.Insert( "/", 10 );
		aOut = aOut.Insert( aPrjName, 10 );
	}
	return aOut;
}

BOOL ConvertHeader( FILE *pOut, char *pInFileName )
{
#define STEP_EMPTY( Next )	\
	{						\
	eState = Next;			\
	pIn++;					\
	break;					\
	}

	//Zeilenendezeichen im Namen sind unerwuenscht.
	if ( *(pInFileName + ( strlen( pInFileName ) - 1 ) ) == '\n' )
		*(pInFileName + ( strlen( pInFileName ) - 1 ) ) = '\0';

	ByteString		aOut;					//Ausgabe Zeile
	ByteString		aLast;					//letzte Zeile wenn "#if"
	FILE	   *pInFile;				//Pointer auf Eingabefile
	char	   *pIn,
				sInBuf[ LINE_MAXLEN ];	//Buffer fuer Eingabezeile
	int 		nCommentCount = 0;		//Merker fuer Kommentarverschachtelung
	BOOL		bEmptyLine	  = FALSE;	//Zur Vermeidung ueberfl. leerzeilen
	Zustand 	eState		  = NORMAL;

	DirEntry	aInFile( UniString( pInFileName, gsl_getSystemTextEncoding())); //Eingabe Headerfile
	//Input Headerfile suchen und oeffnen
	aInFile.ToAbs();

	if ( !aInFile.Find( UniString( aInclude, gsl_getSystemTextEncoding())))
	{
		printf( "Error: couldn't find Headerfile: %s", aInFile.GetFull().GetBuffer() );
		return FALSE;
	}
	char pInName[255];
	strcpy( pInName, ByteString( aInFile.GetFull(), gsl_getSystemTextEncoding()).GetBuffer());
	pInFile = fopen( pInName, "r" );
	if ( !pInFile )
	{
		printf( "Error: couldn't open Headerfile: %s", aInFile.GetFull().GetBuffer() );
		return FALSE;
	}
	// Falls wir im SV Projekt delivern, muss noch ein undef protected
	if ( aPrjName == "sv" )
	{
#ifdef DEBUG
		printf("Sv Project" );
#endif
		if ( bHxx )
		{
			fprintf( pOut, "#ifndef _SVGEN_HXX\n" );
			fprintf( pOut, "#include <sv/convert.hxx> \n" );
			fprintf( pOut, "#endif\n" );
		}
	}

	while( fgets( sInBuf, LINE_MAXLEN, pInFile ) )
	{
//DOS-FILES fuer Mac!
#ifdef MAC
		if (sInBuf[0] < char(20))
			pIn = &sInBuf[1];
		else
			pIn = &sInBuf[0];
		if (!*pIn)
			continue;
#else
		pIn = &sInBuf[0];
#endif

#ifdef MAC
			SpinCursor( 1 );
#endif

		while( (*pIn != '\0') && ( eState != LINECOMMENT ) )
		{
			switch ( eState )
			{
			case NORMAL:
				while ( *pIn != '\0' ) {
					if ( *pIn == '"' ){
						aOut += '"';
						STEP_EMPTY( STRING );
					}
					if (( *pIn == '/' ) && ( !WithComments ))
						STEP_EMPTY( EXPECTCOMMENT );
					aOut += *pIn;
					pIn++;
				}
				break;
			case STRING:
				while ( *pIn != '\0' ) {
					aOut += *pIn;
					if ( ( *pIn == '"' ) && ( *(pIn - 1) != '\\' ) )
						STEP_EMPTY( NORMAL );
					pIn++;
				}
				break;
			case EXPECTCOMMENT:
				if ( *pIn == '*' ) {
					nCommentCount++;
					STEP_EMPTY( COMMENT );
				}
				else
					if ( *pIn == '/' )
					{
							STEP_EMPTY( LINECOMMENT );
					}
				aOut += *( pIn - 1 );
				aOut += *pIn;
				STEP_EMPTY( NORMAL );
			case COMMENT:
				while ( *pIn != '\0' ) {
					if ( *pIn == '*' ) STEP_EMPTY( COMMENTEND );
					if ( *pIn == '/' ) STEP_EMPTY( INCOMMENT );
					pIn++;
				}
				break;
			case COMMENTEND:
				if ( *pIn == '/' ) {
					nCommentCount--;
					if ( !nCommentCount )
						STEP_EMPTY( NORMAL )
				}
				if ( *pIn == '*' )
					STEP_EMPTY( COMMENTEND );
				STEP_EMPTY( COMMENT );
			case INCOMMENT:
				if ( *pIn == '*' ) {
					nCommentCount++;
					STEP_EMPTY( COMMENT );
				}
				eState = COMMENT;
			default:	/* kann nicht sein */;
			}
		}

		if ( eState == LINECOMMENT ) {
			eState = NORMAL;
			aOut += "\n";
		}

		if ( aOut == "" )
			aOut = "\n";

		//Nur Blanks wollen wir ja nun auch nicht ausgeben.
		ByteString aTmp( aOut );
		while( aTmp.GetChar( 0 ) == ' ' || aTmp.GetChar( 0 ) == '\t' )
			aTmp.Erase( 0, 1 );

		//Vermeidung doppelter Leerzeilen
		if ( aTmp == "\n" )
		{
			if ( !bEmptyLine )
			{
				bEmptyLine = TRUE;
				fputs( "\n", pOut );
			}
		}
		else if ( !aExcludeWild.Matches( UniString( aOut, gsl_getSystemTextEncoding()))
				 || aForceIncludeWild.Matches( UniString( aOut, gsl_getSystemTextEncoding())))
		{
			if( !aLast.Len() || aOut.CompareTo("#endif",6) != COMPARE_EQUAL ) {
				if( aLast.Len() ) { // Zeile davor war "#if"
					fputs( aLast.GetBuffer(), pOut );
					aLast.Erase();
				}
				bEmptyLine = FALSE;
				ByteString aFirstWord = aOut.GetToken( 0, ' ' );
				if ( aFirstWord == "#include" )
					aOut = ReplaceHeader( aOut );
				if( aPrjName == "sv" && bprotectedpublichack && aFirstWord.CompareTo("protected:\n") == COMPARE_EQUAL )
					fputs( "public: //war protected !!\n", pOut );
				else
				if( aOut.CompareTo("#if", 3) != COMPARE_EQUAL )
					fputs( aOut.GetBuffer(), pOut );
				else if( aOut.Search("#if __PRIVATE") != STRING_NOTFOUND )
					fputs( "#if 0 // __PRIVATE\n", pOut );
				else
					aLast = aOut;
			}
			else
				aLast.Erase(); // #if + #endif Paar
		}
		aOut.Erase();
	}
	// Falls wir im SV Projekt delivern, muss noch ein undef protected
	if ( aPrjName == "sv" )
	{
#ifdef DEBUG
		printf("Sv Project" );
#endif
		if ( bHxx )
		{
			fprintf( pOut, "#if (defined(_MSC_VER) || defined(__SC__)) || (defined(ALPHA) && defined(WNT))\n" );
			fprintf( pOut, "#undef protected\n" );
			fprintf( pOut, "#endif\n" );
		}
	}

	fclose( pInFile );
	return TRUE;
}

//-------------------------------------------------------------

#ifdef OLD_HEADBU
int main( int argc, char** argv )
{
	// Globale Variablen initialisieren
	aInclude = "";

	CmdLine 	aCmdLine( argc, (const char**)argv );
	ByteString		aExclude;
	ByteString      aForceInclude;
	char	   *pPrep[ 64 ];			//cpp Komandozeile
	int 		nPrepCount = 1; 		//Anzahl Param. fuer cpp

#ifdef MAC
		InitCursorCtl( 0 );
#endif

	//Hilfe angefordert?   --> Help() beendet das Programm
	ByteString aH ( 'H'  ), //Temporaere ByteString sind vom Sun-Compiler
		   ah ( 'h'  ), //in if's nicht gefragt.
		   aHX( "HX" ),
		   ahx( "hx" );
	if ( aCmdLine.GetSwitch( aH ) ||
		 aCmdLine.GetSwitch( ah ) ||
		(aCmdLine.GetParamCnt() == 1) )
		Help( (char**)pHelpPage1 );
	if ( aCmdLine.GetSwitch( aHX ) ||
		 aCmdLine.GetSwitch( ahx ) )
		Help( (char**)pHelpPage2 );

	//eigenen Namen aus der CmdLine entfernen
	aCmdLine.CutParam();

	//Output-File aus der CmdLine lesen und merken
	ByteString aOutFile( aCmdLine.CutOption( ByteString( 'O' ) ) );
	if ( aOutFile == "" )
		aOutFile = aCmdLine.CutOption( ByteString( 'o' ) );
	if ( aOutFile == "" )
	{
		puts( "Error: No Output-Filename specified" );
		return 0;
	}
	//Exclude-Liste aus der CmdLine lesen und merken
	aExclude = aCmdLine.CutOption( ByteString( 'E' ) );
	while ( aCmdLine.ChkOption( ByteString( 'E' ) ) )
		aExclude += ByteString( ";" ) + aCmdLine.CutOption( ByteString( 'E' ) );
	if ( aExclude == "" )
		aExclude = aCmdLine.CutOption( ByteString( 'e' ) );
	while ( aCmdLine.ChkOption( ByteString( 'e' ) ) )
		aExclude += ByteString( ";" ) + aCmdLine.CutOption( ByteString( 'e' ) );

	aExcludeWild = aExclude;

	aForceInclude = aCmdLine.CutOption( ByteString( 'K' ) );
	while ( aCmdLine.ChkOption( ByteString( 'K' ) ) )
		aForceInclude += ByteString( ";" ) + aCmdLine.CutOption( ByteString( 'K' ) );
	if ( aForceInclude == "" )
		aForceInclude = aCmdLine.CutOption( ByteString( 'k' ) );
	while ( aCmdLine.ChkOption( ByteString( 'k' ) ) )
		aForceInclude += ByteString( ";" ) + aCmdLine.CutOption( ByteString( 'k' ) );

	aForceIncludeWild = aForceInclude;



	//Includes aus der CmdLine Lesen und merken
	while( aCmdLine.ChkOption( ByteString( "I" ) ) )
		aInclude += aCmdLine.CutOption( ByteString( "I" ) ) + ByteString( SEPSIGN );

	aInclude += getenv( "INCLUDE" );

	//Kommentare erlauben
	while( aCmdLine.ChkOption( ByteString( "C" ) ) )
	{
		aCmdLine.CutOption( ByteString( "C" ) );
		WithComments=TRUE;
	}

	while( aCmdLine.ChkOption( ByteString( "c" ) ) )
	{
		aCmdLine.CutOption( ByteString( "c" ) );
		WithComments=TRUE;
	}

	//erstmal den Namen des cpp in seine Kommadozeile bringen
	pPrep[0] = "cpp";

	//Defines u. Undefines an den cpp weiterreichen,
	//die Reihenfolge ist signifikant!
	int i = 1;
	while ( i <= aCmdLine.GetParamCnt() ) {
		if ( aCmdLine.ChkOption( i ) ) {
			if ( aCmdLine.GetName( i ) == "D" ) {
				pPrep[nPrepCount] = strdup( ( ByteString( "-D" ) +
						aCmdLine.CutOption( i ) ).GetBuffer() );
				nPrepCount++;
				i--;
			}
			else if ( aCmdLine.GetName( i ) == "U" )    {
				pPrep[nPrepCount] = strdup( ( ByteString( "-U" ) +
						aCmdLine.CutOption( i ) ).GetBuffer() );
				nPrepCount++;
				i--;
			}
		}
		i++;
	}

	//Namen des Inputfiles feststellen...
	if ( !aCmdLine.ChkParam() )
	{
		puts( "Error: No Input-File specified!" );
		return 1;
	}
	DirEntry aInputFile( aCmdLine.CutParam() );
	aInputFile.Find( aInclude );
	aInputFile.ToAbs();
	//... und an den cpp weitergeben
	pPrep[nPrepCount] = strdup( aInputFile.GetFull() );
	nPrepCount++;

	if ( aCmdLine.ChkParam() )
	{
		puts( "Error: More than one Input-File specified!" );
		return 1;
	}

	//Der cpp moechte als letztes auch noch ein Outfile haben
	//falls moeglich landet dies im temporaeren Verzeichnis
	ByteString aIntermediate( getenv( "TMP" ) );
	if ( aIntermediate == "" )
		aIntermediate = getenv( "TEMP" );
	if ( aIntermediate == "" )
	{
		puts( "Error: Environment, missing temp-path" );
		return 1;
	}

	DirEntry aInter;
	if ( aIntermediate.Len() )
		aInter = DirEntry( aIntermediate );

	aInter += aInputFile.GetBase() + ByteString( ".i" );
	pPrep[nPrepCount] = strdup( aInter.GetFull().GetBuffer() );
	nPrepCount++;

	//und den Preprozessor aufrufen
	if ( start_cpp( nPrepCount, pPrep ) )
	{
		puts( "Error: cpp faild!" );
		return 1;
	}

		//! der cpp leert den Speicher von pPrep scheinbar selbst

	//Oeffnen des Intermediate-Files
	FILE	*pIn = fopen( aInter.GetFull(), "rt" );
	if ( !pIn )
	{
		printf( "Error: Can't open Intermediate-File: %s", aInter.GetFull().GetBuffer() );
		return 1;
	}

	//Outfile oeffnen
	//?O das sollte auf das Tempverzeichnis laufen, sobald FSYS
	//	 das Move() auf allen Systemen beherscht.
	DirEntry  aOut( aOutFile );
	FILE	 *pOut = fopen( aOut.GetFull(), "w+" );
	if ( !pOut )
	{
		printf( "Error: can't open Outfile: %s", aOut.GetFull().GetBuffer() );
		aInputFile.Kill();
		fclose( pIn );
		return 0;
	}

	//Input-File verarbeiten
	char   sBuf[ LINE_MAXLEN ];
	ByteString aStuff;
	USHORT nPos;

	while ( fgets( sBuf, LINE_MAXLEN, pIn ) )
	{
		switch ( sBuf[0] )
		{
			case 'E': //Ausgabe der Zeile auf den Bildschirm
			case 'e':
				if ( strchr( sBuf, ' ' ) )
					printf( "%s", (strchr( sBuf, ' ' )) + 1 );
				else
					puts( "" );
				break;

			case 'W': //Ausgabe der Zeile in das Out-File
			case 'w':
				if ( strchr( sBuf, '"' ) ) {
					aStuff = (strchr( sBuf, '"' ) + 1);
					aStuff.Erase( aStuff.Len() - 2, 1 );
					//Entfernen von '\"' im AusgabeByteString
					ByteString aStr( '\\' );
					aStr += ByteString( '"' );
					while ( (nPos = aStuff.Search( aStr ))
							!= ByteString_NOTFOUND )
						aStuff.Erase( nPos, 1 );
					//Ersetzen von __DATE__
					while ( (nPos = aStuff.Search( ByteString( "__DATE__" ) ))
							!= ByteString_NOTFOUND )
					{
						time_t *pTime = new time_t;
						time( pTime );
						aStuff.Erase( nPos, 8 );
						aStuff.Insert( ctime( pTime ), nPos );
						//ctime liefert ein "\n", das muss wieder 'raus
						nPos = aStuff.Search( "\n" );
						aStuff.Erase( nPos, ByteString( "\n" ).Len() );
						delete pTime;
					}
					fprintf( pOut, "%s", aStuff.GetBuffer() );
				}
				else
					fprintf( pOut, "\n" );
				break;

			case 'F': //Konvertierung und Ausgabe eines Headerfiles
			case 'f':
				if( strchr( sBuf, ' ' ) )
				{
					if ( !ConvertHeader( pOut, (strchr( sBuf, ' ' )) + 1 ) )
					{
						fclose( pIn );
						fclose( pOut);
						aInter.Kill();
						return 1;
					}
				}
				else
				{
					printf( "Error: Problems with Headerfile: %s",
							(strchr( sBuf, ' ')) + 1 );
					fclose( pIn );
					fclose( pOut );
					aInter.Kill();
					return 1;
				}
			case '#':
				//looks like an #line directive, generatet by cpp
				break;

			case '\n':
				//empty lines are allowed
				break;

			default:
				puts(  "Error: Syntax error in Inputfile," );
				printf("\tthe Line looks like: %s", sBuf );
				fclose( pIn );
				fclose( pOut );
				aInter.Kill();
				return 1;
		}
	}
	fclose( pIn );
	fclose( pOut );
	aInter.Kill();

	return 0;
}
#else		// OLD_HEDABU
BOOL hedabu( ByteString aFileName, ByteString aTargetFileName )
{
	BOOL bRet = FALSE;

	bHxx = TRUE;
	//bHxx = FALSE;
	// sv.h nicht patchen am Ende
	DirEntry aTarget( UniString( aTargetFileName, gsl_getSystemTextEncoding()));
	ByteString aSearchFileName( aTarget.GetName(), gsl_getSystemTextEncoding());
	if ( aSearchFileName.ToLowerAscii() != "convert.hxx" )
		bHxx = TRUE;

	char *pHFileName = new char[ aFileName.Len() + 2];
#ifdef DEBUG
	fprintf( stderr, "hedabu : aFileName %s, aTargetFileName %s\n", aFileName.GetBuffer(),
					aTargetFileName.GetBuffer() );
#endif

	// vielleicht sollte hier noch ein eindeutiges define gebaut werden
	// z.B. _TOOLS_NEW_HXX		??

	strcpy( pHFileName, aFileName.GetBuffer() );

//	BS_ErrorContext( ERRCTX_BS_DELIVER, aTargetFileName );
	FILE *outFp = fopen( aTargetFileName.GetBuffer(), "w");
	if ( outFp )
	{
		bRet = ConvertHeader( outFp, pHFileName );
		fclose( outFp );
	}
	else
	{
		ErrorHandler::HandleError( FSYS_ERR_NOTEXISTS );
		bRet = FALSE;
	}
	delete pHFileName;

	return bRet;
}

BOOL hedabu( ByteString aFileName, ByteString aTargetFileName,
		HedabuReplaceList *pLst, ByteString aProjectName, BOOL bProtectedPublicHack,
		Star *pStar )
{
	bprotectedpublichack = bProtectedPublicHack;
	if ( aProjectName == "" )
	{
		//BS_ErrorContext( ERRCTX_BS_DELIVER, ByteString(_SOLARLIST) );
		DirEntry aDirEntry( UniString( aFileName, gsl_getSystemTextEncoding()));
		aDirEntry.ToAbs();
		UniString aFile = aDirEntry.GetFull();
		DirEntry aTmpDE( aFile );

		aPrjName = ::GetPrj().ToLowerAscii();
		DirEntry aTmp( UniString( aPrjName, gsl_getSystemTextEncoding()));
		aPrjName = ByteString( aTmp.GetName(), gsl_getSystemTextEncoding());
#ifdef DEBUGxxxx
		printf( "Path : %s\n", aTmpDE.GetFull().GetBuffer() );
		printf( "Prj : %s\n", aPrjName.GetBuffer() );

#endif
	}
	else
	{
		aPrjName = aProjectName;
#ifdef DEBUGxxxx
		printf( "Prj : %s\n", aPrjName.GetBuffer() );
#endif
	}

	pIncludeReplace = pLst;

	return hedabu( aFileName, aTargetFileName );

}
#endif
