/*************************************************************************
 *
 *  $RCSfile: mkout.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: armin.theissen $ $Date: 2000/09/22 16:40:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifdef WNT
#define __STDC__ 1
#ifdef BOOTSTRAPPER
#include <glibc/posix/getopt.h>
#else
#include <glibc/getopt.h>
#endif
#endif
#ifdef UNX
#ifdef BOOTSTRAPPER
#include <glibc/posix/config.h>
#ifdef MACOSX
#include <glibc/posix/getopt.h>
#endif
#else
#include <glibc/config.h>
#ifndef SOLARIS
#include <glibc/getopt.h>
#endif
#endif
#endif
#if defined(SOLARIS)
extern "C" {
struct option
{
	char* name;
	int has_arg;
	int* flagl;
	int val;
};
extern int getopt_long( int, char* const*, const char *, const struct option*, int *);
}
#endif

#include <stdio.h>
#include <stdlib.h>

#include "string.hxx"
#include "fsys.hxx"
#include "prj.hxx"
#include "errhdl.hxx"
#include "bsecode.hxx"

static ByteString aAccessDelimiter( DirEntry::GetAccessDelimiter(), gsl_getSystemTextEncoding());
static DirEntry aSrcPath;

ByteString GetPrj(DirEntry aEntry);

class Mkout
{
	ByteString	 	aEnvironmentname;
	DirEntry		aDestPath;
	DirEntry		aAllDestPath;
public:
	BOOL			bError;
	BOOL			bSmall;
	BOOL			bRemote;
	BOOL			bNewstor;
	BOOL			bMoney;
private:
	void			GetPrj();
	BOOL			ImplExecute( DirEntry &rEntry );
	BOOL			ImplMkdir( DirEntry &rEntry );
	BOOL			ImplMkLangdir( DirEntry &rEntry );
	BOOL			ImplMkRemotedir( DirEntry &rEntry, const ByteString& rName = ByteString("remote"));

public:
					Mkout();
//					Mkout( Environment &rEnv );
					Mkout( ByteString &rStr );
	virtual			~Mkout();

	BOOL			Execute();
	virtual void	Print( const ByteString &rStr );
};


class ConMkout : public Mkout
{
public:
					ConMkout() : Mkout(){};
//					ConMkout( Environment &rEnv );
					ConMkout( ByteString &rStr );
					~ConMkout();

	void			Print( const ByteString &rStr );
};

Mkout::Mkout()
{
	//StandVerwaltung *pStand = GetStandVer();
	// In welchem Projekt sind wir ueberhaupt ??
	bSmall = FALSE;
	bRemote = FALSE;
	bNewstor = FALSE;
	bMoney = FALSE;
	bError = FALSE;
	GetPrj();
}

/*Mkout::Mkout( Environment &rEnv )
{
	bSmall = FALSE;
	bRemote = FALSE;
	bNewstor = FALSE;
	bError = FALSE;
	bMoney = FALSE;
}*/


Mkout::Mkout( ByteString &rStr )
{
	aEnvironmentname = rStr;

	bSmall = FALSE;
	bRemote = FALSE;
	bNewstor = FALSE;
	bError = FALSE;
	bMoney = FALSE;
	//StandVerwaltung *pStand = GetStandVer();

	// In welchem Projekt sind wir ueberhaupt ??
	GetPrj();
}

Mkout::~Mkout()
{
}

BOOL Mkout::Execute()
{
	ByteString aEnvName;
	if ( aEnvironmentname == "" )
		aEnvName = getenv( "INPATH" );
	else
	{
		aEnvName = aEnvironmentname;
		aDestPath = aSrcPath;
		aSrcPath.SetCWD();
	}
	//fprintf( stderr, "DestPath : %s\n", aDestPath.GetFull().GetStr());
	if ( bError )
	{
		Print( ByteString("Konnte Projekt nicht ermitteln !\n"));
		return FALSE;
	}

	ByteString sOutput( " Got Environment : " );
	sOutput += aEnvName;
	sOutput += ByteString( "\n" );
	Print( sOutput );
	sOutput = ByteString( " Make Directory " );
	sOutput += aEnvName;
	sOutput += ByteString( " in " );
	sOutput += ByteString( aDestPath.GetFull(), gsl_getSystemTextEncoding());
	Print( sOutput );

	DirEntry aDestPathEntry( aDestPath );
	aDestPathEntry += DirEntry( String( aEnvName, gsl_getSystemTextEncoding()));
	ImplExecute( aDestPathEntry );

	return TRUE;
}

BOOL Mkout::ImplExecute( DirEntry &rEntry )
{
	const ByteString aMoney("money");
	const ByteString aNewstor("newstor");

	ByteString rPathSep = aAccessDelimiter.GetBuffer();

	BOOL nRet = FALSE;
	ByteString aPath( rEntry.GetFull(), gsl_getSystemTextEncoding());
	DirEntry aTmpDir;

	ByteString aTmpRoot( aPath );
	aTmpRoot += rPathSep;
	ByteString aTmpPath( aTmpRoot );
	aTmpPath += ByteString( "bin" );

	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);

	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "inc" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "class" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "obj" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "srs" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "res" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);
	ImplMkLangdir( aTmpDir);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "slo" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "idl" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "misc" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);
	ImplMkLangdir( aTmpDir);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "slb" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "lib" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);
	if (bRemote) ImplMkRemotedir( aTmpDir );
	if (bMoney) ImplMkRemotedir(aTmpDir, aMoney);
	if (bNewstor) ImplMkRemotedir(aTmpDir, aNewstor);

	aTmpPath = aTmpRoot;
	aTmpPath += ByteString( "doc" );
	aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
	ImplMkdir( aTmpDir);

	if (!bSmall)
	{
		aTmpPath = aTmpRoot;
		aTmpPath += ByteString( "dbo" );
		aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
		ImplMkdir( aTmpDir);

		aTmpPath = aTmpRoot;
		aTmpPath += ByteString( "dlb" );
		aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
		ImplMkdir( aTmpDir);

		aTmpPath = aTmpRoot;
		aTmpPath += ByteString( "dso" );
		aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
		ImplMkdir( aTmpDir);

		aTmpPath = aTmpRoot;
		aTmpPath += ByteString( "dib" );
		aTmpDir = DirEntry( String( aTmpPath, gsl_getSystemTextEncoding()));
		ImplMkdir( aTmpDir);
	}

	return nRet;
}

BOOL Mkout::ImplMkdir( DirEntry &rDir )
{
	if ( !rDir.Exists() )
	{
		BOOL bRet = FALSE;
		bRet = rDir.MakeDir();
		if ( bRemote )
		{
			ByteString aPath( rDir.GetFull(), gsl_getSystemTextEncoding());
			aPath += aAccessDelimiter;
			aPath += "remote";
			DirEntry rrDir( String( aPath, gsl_getSystemTextEncoding()));
			bRet = rrDir.MakeDir();
		}
		return bRet;
	}
	else
		return FALSE;
}

BOOL Mkout::ImplMkLangdir( DirEntry &rDir )
{
/*	DirEntry 	aTempDir;
	ByteString rPathSep( aAccessDelimiter );
	const ByteString aMoney("money");
	const ByteString aNewstor("newstor");

	if ( !rDir.Exists() ) if (!rDir.MakeDir()) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("enus"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("dtch"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("ital"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("fren"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("span"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("swed"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("port"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("chinsim"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;

	aTempDir = DirEntry( rDir.GetFull() + rPathSep + String("japn"));
	if ( !aTempDir.Exists() ) if (!aTempDir.MakeDir()) return FALSE;
	if (bRemote) if (!ImplMkRemotedir(aTempDir)) return FALSE;
	if (bMoney) if (!ImplMkRemotedir(aTempDir, aMoney)) return FALSE;
	if (bNewstor) if (!ImplMkRemotedir(aTempDir, aNewstor)) return FALSE;
	*/

	return TRUE;
}

BOOL Mkout::ImplMkRemotedir( DirEntry &rDir, const ByteString& rName )
{
	DirEntry 	aTempDir;
	ByteString rPathSep( aAccessDelimiter );

	if ( !rDir.Exists() && !rDir.MakeDir())
		return FALSE;

	ByteString sTmp( rDir.GetFull(), gsl_getSystemTextEncoding());
	sTmp += rPathSep;
	sTmp += rName;

	aTempDir = DirEntry( String( sTmp, gsl_getSystemTextEncoding()));

	if ( !aTempDir.Exists() && !aTempDir.MakeDir())
		return FALSE;

	return TRUE;
}

void Mkout::Print( const ByteString &rStr )
{
}

/************************************************************************
*
* In welchem Project sind wir wohl ??
*
************************************************************************/
void Mkout::GetPrj()
{
	ByteString aPath = ::GetPrj( DirEntry("."));
	if ( aPath == "nul" || aPath == "/dev/null" )
		bError = TRUE;
	aDestPath = DirEntry(aPath);
}

ConMkout::~ConMkout()
{
}

ConMkout::ConMkout( ByteString &rStr ) :
	Mkout( rStr )
{
}

void ConMkout::Print( const ByteString &rStr )
{
	fprintf( stderr, "Mkout : %s \n", rStr.GetBuffer() );
}

int usage()
{
	fprintf( stderr, "mkout $Revision: 1.3 $:\n" );
	fprintf( stderr, "Usage :\n" );
	fprintf( stderr, "mkout [-r] [-s] [-n] [-m] [-h] [Environmentname]\n");
	fprintf( stderr, "-r : Remote;\n -m : Money;\n -s : Small;\n -n : Newstor;\n -h : Help \n");

	exit(0);
	return 0;
}

int mkout( int argc, char **argv )
{
	int c;
	BOOL	bSmall=FALSE, bRemote=FALSE, bNewstor=FALSE, bMoney=FALSE;
	ByteString aLongOption;
	ByteString aLongOptionArg1;
	ByteString aProduct;
	char aEnvName[255];

	(void) strcpy( aEnvName, "" );

	fprintf( stderr, "%s $Revision: 1.3 $ (MH) :\n", argv[0] );
	while(1)
	{
		int this_option_optind = optind ? optind :1;
        int option_index = 0;
        static struct option long_options[] =
		{
                           {"pro",0,0,0},
		           {0,0,0,0 }
		};

		c = getopt_long ( (int)argc, argv, "?srnmh",
			long_options, &option_index );
		if ( c == EOF	)
	        break;
		switch( c )
		{
			case 0 :
				aLongOption = long_options[option_index].name;
				aLongOptionArg1;
				if ( optarg )
					aLongOptionArg1 = optarg;
				if ( aLongOption  == "pro" )
					aProduct = aLongOption;
				break;
			case 'm' :
			case 'M' :
				bMoney = TRUE;
				break;
			case 'n' :
			case 'N' :
				bNewstor = TRUE;
				break;
			case 'r' :
			case 'R' :
				bRemote = TRUE;
				break;
			case 's' :
			case 'S' :
				bSmall = TRUE;
				break;
			case 'h' :
				usage();
				break;
			default:
				break;
		}
	}
	if ( optind < argc )
	{
		strcpy( aEnvName, argv[optind] );
	}

	// StandVerwaltung anlegen
	//(void) new StandVerwaltung;
	ByteString aTemp( aEnvName );
	ConMkout *pM = new ConMkout( aTemp );
	if (bRemote)
		pM->bRemote = TRUE;
	if (bMoney)
		pM->bMoney = TRUE;
	if (bNewstor)
		pM->bNewstor = TRUE;
	if (bSmall)
		pM->bSmall = TRUE;

	pM->Execute();

	delete pM;

	return 0;
}
int
#ifdef WNT
__cdecl
#endif
main( int argc, char **argv )
{
/*	new BS_ErrorHandler;

	BS_ErrorContext aEC( ERRCTX_BS_DELIVER, "Mkout" ); */

	aSrcPath = DirEntry(".");
	aSrcPath.ToAbs();
	BOOL bDeliverAll = FALSE, bMinor = FALSE;
	BOOL bForce = FALSE;
	BOOL bRel = FALSE;
	/*String aPath = GetPrj(DirEntry("."));
	if ( aPath == "nul" || aPath == "/dev/null" )
	{
		fprintf( stderr, "Projekt konnte nicht ermittelt werden\n" );
		return 1;
	}
	fprintf( stderr, "Projekt: %s\n", aPath.GetStr() );*/

#if 0
	if ( argc > 1 )
	{
		ByteString aOption;
		for ( USHORT i=1; i< argc; i++ )
		{
			aOption = argv[i];
			if ( aOption == "-all" )
				bDeliverAll = TRUE;
			else
			if ( aOption == "-minor" )
				bMinor = TRUE;
			else
			if ( aOption == "-abs" )
				bRel = TRUE;
			else
			if ( aOption == "-force" )
			{
				bForce = TRUE;
				#ifdef DEBUG
				fprintf(stderr, "Using -force" );
				#endif
			}
			else
				aPath = aOption;
		}
	}
#else
	return mkout( argc, argv );
#endif
}
