#*************************************************************************
#
#   $RCSfile: static.mk,v $
#
#   $Revision: 1.2 $
#
#   last change: $Author: nf $ $Date: 2000/09/20 12:22:40 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
.IF "$(GUI)"=="WNT"
# -----------------------------------------------------------
# --------------------- Windows32 ---------------------------
# -----------------------------------------------------------
BOOTSTRP		=	bootstrp.lib
VERMAP			= 	bsvermap.lib
STATIC_LIBS		=	advapi32.lib						\
					user32.lib							\
					shell32.lib 						\
					mpr.lib 							\
					ole32.lib							\
					uuid.lib 							\
					wsock32.lib							\
					$(L)$/avos.lib
.IF "$(PRJNAME)" == "tools"
STATIC_LIBS		+= 	$(LB)$/atools.lib
.ELSE
STATIC_LIBS		+= 	atools.lib
.ENDIF
.IF "$(UPD)" >= "590"
STATIC_LIBS		+=  kernel9x.lib 						\
					advapi9x.lib 						\
					shell9x.lib
.IF "$(UPD)" >= "604"
STATIC_LIBS		+=  tools32.lib
.ENDIF
.ENDIF
.IF "$(UPD)" >= "546"
STATIC_LIBS		+= 	asal.lib
.ELSE
STATIC_LIBS		+= 	aosl.lib							\
					artl.lib
.ENDIF
.IF "$(UPD)" >= "597"
STATIC_LIBS		+= 	gnu_getopt.lib
.ENDIF
# -----------------------------------------------------------

.ELSE
.IF "$(GUI)"=="UNX"
# -----------------------------------------------------------
# ------------------------ UNIX -----------------------------
# -----------------------------------------------------------
BOOTSTRP		=	-lbtstrp
VERMAP			=	-lbsvermap
.IF "$(OS)"=="MACOSX"
STATIC_LIBS		=	-latools
.ELSE
.IF "$(OS)"=="LINUX"
STATIC_LIBS		=	-Wl,-Bstatic
.ELSE
STATIC_LIBS		=	-Bstatic
.ENDIF
.ENDIF
STATIC_LIBS		+= \
					-latools 							\
					-lvos$(VOS_MAJOR)$(DLLPOSTFIX)
.IF "$(UPD)" >= "546"
.IF "$(UPD)" >= "604"
STATIC_LIBS		+= 	-lsal$(SAL_MAJOR)$(DLLPOSTFIX)
.ELSE
STATIC_LIBS     +=  -lsal$(UPD)$(DLLPOSTFIX)
.ENDIF
.ELSE
STATIC_LIBS		+= 	-losl$(UPD)$(DLLPOSTFIX)			\
					-lrtl$(UPD)$(DLLPOSTFIX)
.ENDIF
.IF "$(UPD)" >= "597"
STATIC_LIBS		+= 	-lgnu_getopt
.ENDIF
.IF "$(OS)"=="SOLARIS"
STATIC_LIBS		+=	-Bdynamic -lnsl -lsocket -lposix4
.ENDIF
.IF "$(OS)"=="LINUX"
STATIC_LIBS		+=	-lX11 -lXext -lstdc++
.ENDIF
# -----------------------------------------------------------

.ELSE
.IF "$(GUI)"=="OS2"
# -----------------------------------------------------------
# ------------------------- OS2 -----------------------------
# -----------------------------------------------------------
BOOTSTRP		=	bootstrp.lib
VERMAP			= 	bsvermap.lib
STATIC_LIBS		=	$(L)$/atools.lib					\
					$(L)$/avos.lib
.IF "$(UPD)" >= "546"
STATIC_LIBS		+= 	$(L)$/asal.lib
.ELSE
STATIC_LIBS		+= 	$(L)$/aosl.lib						\
					$(L)$/artl.lib
.ENDIF
# -----------------------------------------------------------

.ENDIF
.ENDIF
.ENDIF
