/*************************************************************************
 *
 *  $RCSfile: cntmenu.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <svpm.h>

#include "folder.hxx"

IfcContextMenuImpl::IfcContextMenuImpl(String& rObject)
{
    if(!WinFolderImpl::queryHandle((PSZ) rObject.GetStr(), &m_hObject))
        m_hObject = NULL;
}

BOOL IfcContextMenuImpl::GetMenuItem(UINT32 nIndex, MenuItem& rItem)
{
    switch(nIndex)
    {
    case 0:
        rItem.aItemKind    = MENU_ITEM_KIND_COMMAND;
        rItem.aItemFlags   = MENU_ITEM_FLAG_DEFAULT;
//        rItem.aDisplayText = "open";
        rItem.aVerb        = "open";
        rItem.aCommand     = "open";
        break;
    case 1:
        rItem.aItemKind    = MENU_ITEM_KIND_COMMAND;
//        rItem.aDisplayText = "properties";
        rItem.aVerb        = "properties";
        rItem.aCommand     = "properties";
        break;
    default:
        return FALSE;
    }

    return TRUE;
}

BOOL IfcContextMenuImpl::ExecuteCommand(String aCommand)
{
    ULONG ulView = -1;

    if(m_hObject)
    {
        if(aCommand == "open")
        {
            // OPEN_DEFAULT in wpobject.h
            ulView = 0;
        }
        else if(aCommand == "properties")
        {
            // OPEN_SETTINGS in wpobject.h
            ulView = 2;
        }
    }

    if(ulView != -1)
    {
        WinOpenObject(m_hObject, ulView, TRUE);
        return TRUE;
    }

    return FALSE;
}

