/*************************************************************************
 *
 *  $RCSfile: itempath.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _ITEMPATH_HXX
#define _ITEMPATH_HXX

#ifndef _FASTFSYS_HXX
#include <fastfsys.hxx>
#endif

#ifndef _WPDESKTOP_H
#include <wpdesktp.h>
#endif

#ifdef ItemIDPathData
#undef ItemIDPathData
#endif

typedef struct
{

    // since the path stored in sPath will be in host notation without leading \ or /, we
    // need a flag to determine if path is relative or absolute.

    USHORT nRefCount;  // reference counter
    USHORT nImplFlags; // item status flags
    String sPath;      // file path in host notation
    String sLocation;  // file system location for special objects

    union
    {
        FILEFINDBUF3   ffBuf;
        wps_objectInfo wpInfo;
        CHAR           szBuf[CCHMAXPATHCOMP];
    } Cache;

} ItemIDPathData, *PItemIDPathData;

#define ITEM_IMPL_FLAG_IS_ABSOLUTE 0x0001
#define ITEM_IMPL_FLAG_OBJ_INFO    0x0002
#define ITEM_IMPL_FLAG_FIND_INFO   0x0004
#define ITEM_IMPL_FLAG_VOL_INFO    0x0008

#define ITEM_IMPL_FLAG_IS_VALID    0x000E
#define ITEM_IMPL_FLAG_IS_CACHED   0x000E


#endif /* _ITEMPATH_HXX */





