/*************************************************************************
 *
 *  $RCSfile: intnunx.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdlib.h>  // fuer getenv
#include <stdio.h>

#ifndef _STRING_HXX
#include <string.hxx>
#endif
#ifndef _INTNTAB_HXX
#include <intntab.hxx>
#endif

// =======================================================================

static LanguageType eImplSystemLanguage = LANGUAGE_DONTKNOW;
static LanguageType eImplSystemFormat = LANGUAGE_DONTKNOW;

// =======================================================================

static char const aImplSVCharLowerArray[] =
{
	0,	 1,   2,   3,	4,	 5,   6,   7,	8,	 9,  10,  11,  12,	13,  14,  15,
   16,	17,  18,  19,  20,	21,  22,  23,  24,	25,  26,  27,  28,	29,  30,  31,
   32,	33,  34,  35,  36,	37,  38,  39,  40,	41,  42,  43,  44,	45,  46,  47,
   48,	49,  50,  51,  52,	53,  54,  55,  56,	57,  58,  59,  60,	61,  62,  63,
   64,	97,  98,  99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
  112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122,  91,  92,	93,  94,  95,
   96,	97,  98,  99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
  112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127,
  128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143,
  144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159,
  160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175,
  176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191,
  192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207,
  208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223,
  224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239,
  240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255
};

inline int svstrpicmp( const char* pStr1, const char* pStr2)
{
	int nCharDiff;
	do
	{
		nCharDiff = (int)*pStr1 - (int)aImplSVCharLowerArray[*pStr2];
		if ( nCharDiff )
			return *pStr1 ? nCharDiff : 0;
	}
	while ( *pStr1++ && *pStr2++ );

	return 0;
}

// =======================================================================

USHORT ImplGetSystemLanguageCount()
{
	// !!! Noch nicht implementiert
	return 0;
}

// -----------------------------------------------------------------------

LanguageType GetSystemLanguage( USHORT nIndex )
{
	char		*sLang;
	static char *sDefaultLang = "C";

	// Soll die im System eingestellte Sprache ermittelt werden
	if ( nIndex == INTERNATIONAL_SYSTEM_DEFAULT )
	{
		if ( eImplSystemLanguage == LANGUAGE_DONTKNOW )
		{
			sLang = getenv( "LANG" );
			if (! sLang)
				sLang = getenv ( "LC_CTYPE" );
			if (! sLang)
				sLang = sDefaultLang;
		}
		else
			return eImplSystemLanguage;
	}
	else
	{
		return LANGUAGE_DONTKNOW;
	}

	static struct aStruct { char *sLang; LanguageType eLanguage; } aArray[] =
	{
// Diese Liste muss alphabetisch sortiert sein, dabei kurze Strings
// _vor_ langen Strings und _nur_ Kleinbuchstaben verwenden.
#		if 0
		// language definitions with no corresponding locale
		{ "?_es" , LANGUAGE_BASQUE },
		{ "zh_cn.?" , LANGUAGE_CHINESE_SIMPLIFIED },
		{ "zh_cn.?" , LANGUAGE_CHINESE_TRADITIONAL },
		{ "en_?" , LANGUAGE_ENGLISH },      /* en means en_US */
		{ "en_?" , LANGUAGE_ENGLISH_CARRIBEAN },
		{ "?_KP" , LANGUAGE_KOREAN_JOHAB }  /* or "?_KR" */
		{ "no_?" , LANGUAGE_NORWEGIAN },    /* no means norwegian bokmal */
		{ "?" , LANGUAGE_NORWEGIAN_NYNORSK },
		{ "?" , LANGUAGE_SORBIAN },
		{ "es_?" , LANGUAGE_SPANISH_MODERN },
#		endif 0
		{ "" , LANGUAGE_DONTKNOW },
		{ "af_za" , LANGUAGE_AFRIKAANS },
		{ "al" , LANGUAGE_ALBANIAN },
		{ "ar_ae" , LANGUAGE_ARABIC_UAE },
		{ "ar_bh" , LANGUAGE_ARABIC_BAHRAIN },
		{ "ar_dz" , LANGUAGE_ARABIC_ALGERIA },
		{ "ar_eg" , LANGUAGE_ARABIC_EGYPT },
		{ "ar_iq" , LANGUAGE_ARABIC_IRAQ },
		{ "ar_jo" , LANGUAGE_ARABIC_JORDAN },
		{ "ar_kw" , LANGUAGE_ARABIC_KUWAIT },
		{ "ar_lb" , LANGUAGE_ARABIC_LEBANON },
		{ "ar_ly" , LANGUAGE_ARABIC_LIBYA },
		{ "ar_ma" , LANGUAGE_ARABIC_MOROCCO },
		{ "ar_om" , LANGUAGE_ARABIC_OMAN },
		{ "ar_qa" , LANGUAGE_ARABIC_QATAR },
		{ "ar_sa" , LANGUAGE_ARABIC },
		{ "ar_sy" , LANGUAGE_ARABIC_SYRIA },
		{ "ar_tn" , LANGUAGE_ARABIC_TUNISIA },
		{ "ar_ye" , LANGUAGE_ARABIC_YEMEN },
		{ "at" , LANGUAGE_GERMAN_AUSTRIAN },
		{ "be" , LANGUAGE_DUTCH_BELGIAN },
		{ "bg" , LANGUAGE_BULGARIAN },
#if SUPD >= 345
		{ "by" , LANGUAGE_BELARUSIAN },
#else
		{ "by" , LANGUAGE_BYELORUSSIAN },
#endif
		{ "c" , LANGUAGE_ENGLISH_US },
		{ "ca" , LANGUAGE_ENGLISH_CAN },
		{ "ca_ad" , LANGUAGE_CATALAN },
		{ "ch" , LANGUAGE_GERMAN_SWISS },
		{ "cz" , LANGUAGE_CZECH },
		{ "da" , LANGUAGE_DANISH },
		{ "de" , LANGUAGE_GERMAN },
		{ "de_at" , LANGUAGE_GERMAN_AUSTRIAN },
		{ "de_ch" , LANGUAGE_GERMAN_SWISS },
		{ "de_li" , LANGUAGE_GERMAN_LIECHTENSTEIN },
		{ "de_lu" , LANGUAGE_GERMAN_LUXEMBOURG },
		{ "dk" , LANGUAGE_DANISH },
		{ "el_gr" , LANGUAGE_GREEK },
		{ "en" , LANGUAGE_ENGLISH_US },
		{ "en_au" , LANGUAGE_ENGLISH_AUS },
		{ "en_bz" , LANGUAGE_ENGLISH_BELIZE },
		{ "en_ca" , LANGUAGE_ENGLISH_CAN },
		{ "en_gb" , LANGUAGE_ENGLISH_UK },
		{ "en_ie" , LANGUAGE_ENGLISH_EIRE },
		{ "en_jm" , LANGUAGE_ENGLISH_JAMAICA },
		{ "en_nz" , LANGUAGE_ENGLISH_NZ },
		{ "en_ph" , LANGUAGE_ENGLISH_PHILIPPINES },
		{ "en_tt" , LANGUAGE_ENGLISH_TRINIDAD },
		{ "en_us" , LANGUAGE_ENGLISH_US },
		{ "en_za" , LANGUAGE_ENGLISH_SAFRICA },
		{ "en_zw" , LANGUAGE_ENGLISH_ZIMBABWE },
		{ "es" , LANGUAGE_SPANISH },
		{ "es_ar" , LANGUAGE_SPANISH_ARGENTINA },
		{ "es_bo" , LANGUAGE_SPANISH_BOLIVIA },
		{ "es_cl" , LANGUAGE_SPANISH_CHILE },
		{ "es_co" , LANGUAGE_SPANISH_COLOMBIA },
		{ "es_cr" , LANGUAGE_SPANISH_COSTARICA },
		{ "es_do" , LANGUAGE_SPANISH_DOMINICAN_REPUBLIC },
		{ "es_ec" , LANGUAGE_SPANISH_ECUADOR },
		{ "es_gt" , LANGUAGE_SPANISH_GUATEMALA },
		{ "es_hn" , LANGUAGE_SPANISH_HONDURAS },
		{ "es_mx" , LANGUAGE_SPANISH_MEXICAN },
		{ "es_ni" , LANGUAGE_SPANISH_NICARAGUA },
		{ "es_pa" , LANGUAGE_SPANISH_PANAMA },
		{ "es_pe" , LANGUAGE_SPANISH_PERU },
		{ "es_pr" , LANGUAGE_SPANISH_PUERTO_RICO },
		{ "es_py" , LANGUAGE_SPANISH_PARAGUAY },
		{ "es_sv" , LANGUAGE_SPANISH_EL_SALVADOR },
		{ "es_uy" , LANGUAGE_SPANISH_URUGUAY },
		{ "es_ve" , LANGUAGE_SPANISH_VENEZUELA },
		{ "et_ee" , LANGUAGE_ESTONIAN },
		{ "fa_ir" , LANGUAGE_FARSI },
		{ "fi" , LANGUAGE_FINNISH },
		{ "fo" , LANGUAGE_FAEROESE },
		{ "fr" , LANGUAGE_FRENCH },
		{ "fr_be" , LANGUAGE_FRENCH_BELGIAN },
		{ "fr_ca" , LANGUAGE_FRENCH_CANADIAN },
		{ "fr_ch" , LANGUAGE_FRENCH_SWISS },
		{ "fr_lu" , LANGUAGE_FRENCH_LUXEMBOURG },
		{ "fr_mc" , LANGUAGE_FRENCH_MONACO },
		{ "german" , LANGUAGE_GERMAN },
		{ "gr" , LANGUAGE_GREEK },
		{ "hr" , LANGUAGE_CROATIAN },
		{ "hu" , LANGUAGE_HUNGARIAN },
		{ "hu" , LANGUAGE_HUNGARIAN },
		{ "ie" , LANGUAGE_ENGLISH_EIRE },
		{ "in_id" , LANGUAGE_INDONESIAN },
		{ "is" , LANGUAGE_ICELANDIC },
		{ "it" , LANGUAGE_ITALIAN },
		{ "it_ch" , LANGUAGE_ITALIAN_SWISS },
		{ "iw_il" , LANGUAGE_HEBREW },
		{ "ja" , LANGUAGE_JAPANESE },
		{ "ja_jp" , LANGUAGE_JAPANESE },
		{ "japanese" , LANGUAGE_JAPANESE },
		{ "ko_kp" , LANGUAGE_KOREAN },
		{ "ko_kr" , LANGUAGE_KOREAN },
		{ "li" , LANGUAGE_GERMAN_LIECHTENSTEIN },
		{ "lt" , LANGUAGE_LITHUANIAN },
		{ "lu" , LANGUAGE_FRENCH_LUXEMBOURG },
		{ "lv" , LANGUAGE_LATVIAN },
		{ "mk" , LANGUAGE_MACEDONIAN },
		{ "ms_my" , LANGUAGE_MALAY },
		{ "nl" , LANGUAGE_DUTCH },
		{ "nl_be" , LANGUAGE_DUTCH_BELGIAN },
		{ "no" , LANGUAGE_NORWEGIAN_BOKMAL },
		{ "nz" , LANGUAGE_ENGLISH_NZ },
		{ "pl" , LANGUAGE_POLISH },
		{ "pt" , LANGUAGE_PORTUGUESE },
		{ "pt_br" , LANGUAGE_PORTUGUESE_BRAZILIAN },
		{ "rm_ch" , LANGUAGE_RHAETO_ROMAN },
		{ "ro" , LANGUAGE_ROMANIAN },
		{ "ru" , LANGUAGE_RUSSIAN },
		{ "se" , LANGUAGE_SWEDISH },
		{ "si" , LANGUAGE_SLOVENIAN },
		{ "sk" , LANGUAGE_SLOVAK },
		{ "sq_al" , LANGUAGE_ALBANIAN },
		{ "sv" , LANGUAGE_SWEDISH },
		{ "sv_fi" , LANGUAGE_SWEDISH_FINLAND },
		{ "th" , LANGUAGE_THAI },
		{ "tr" , LANGUAGE_TURKISH },
		{ "ua" , LANGUAGE_UKRAINIAN },
		{ "ur" , LANGUAGE_URDU },
		{ "ur_PK" , LANGUAGE_URDU },
		{ "us" , LANGUAGE_ENGLISH_US },
		{ "vi_vn" , LANGUAGE_VIETNAMESE },
		{ "za" , LANGUAGE_AFRIKAANS },
		{ "zh_cn" , LANGUAGE_CHINESE },
		{ "zh_hk" , LANGUAGE_CHINESE_HONGKONG },
		{ "zh_sg" , LANGUAGE_CHINESE_SINGAPORE }
	};
	for (int i = sizeof( aArray ) / sizeof( struct aStruct);;)
		if (! svstrpicmp (aArray[--i].sLang, sLang))
			return eImplSystemLanguage = aArray[i].eLanguage;
	return eImplSystemLanguage = LANGUAGE_DONTKNOW;
}

// =======================================================================

void ImplUpdateSystemLanguage( LanguageType eLanguage, LanguageTable* pTable )
{
	// Wenn keine Table gesetzt ist, dann Cache-Sprache zuruecksetzen
	if ( !pTable )
		eImplSystemLanguage = LANGUAGE_DONTKNOW;

	// Wenigstens Standard einfuellen
	eImplSystemLanguage = GetSystemLanguage( INTERNATIONAL_SYSTEM_DEFAULT ) ;
	ImplUpdateStandardLanguage( eImplSystemLanguage, pTable );
}

// =======================================================================

USHORT ImplGetSystemFormatCount()
{
	// !!! Noch nicht implementiert
	return 0;
}

// -----------------------------------------------------------------------

LanguageType GetSystemFormatLanguage( USHORT nIndex )
{
	return GetSystemLanguage( nIndex );
}

// -----------------------------------------------------------------------

void ImplUpdateSystemFormat( LanguageType eLanguage, FormatTable* pTable )
{
	if ( !pTable )
	{
		eImplSystemLanguage = LANGUAGE_DONTKNOW;
		return;
	}

	// Wenigstens Standardformat einfuellen ?
	eImplSystemLanguage = GetSystemLanguage( INTERNATIONAL_SYSTEM_DEFAULT );
	ImplUpdateStandardFormat( eImplSystemLanguage, pTable );
}
