/*************************************************************************
 *
 *  $RCSfile: stdstrm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <vos/macros.hxx>

#include <stream.hxx>
#include <stdstrm.hxx>


// -----------------------------------------------------------------------

#ifdef WIN

// #include <svwin.h>

#define WRITEDATA(pData,nWrite,nRetVal)  \
nRetVal = nWrite;\
char __huge *p = (char __huge *)pData;\
while ( nWrite >= 8192 )\
{\
    rStream.write( p, 8192 );\
    p += 8192;\
    nWrite -= 8192;\
}\
if ( nWrite )\
    rStream.write( p, nWrite );\
if ( !rStream.good() )\
{\
    nRetVal = 0;\
    SetError( SVSTREAM_WRITE_ERROR );\
}

#define READDATA(pData,nRead,nRetVal) \
char __huge * p = pData;\
nRetVal = 0;\
while ( nRead >= 8192 )\
{\
    rStream.read( p, 8192 );\
    p += 8192;\
    nRead -= 8192;\
    nRetVal += rStream.gcount();\
}\
if ( nRead )\
{\
    rStream.read( p, (short)nRead );\
    nRetVal += rStream.gcount();\
}\
if ( !rStream.good() )\
{\
    if ( rStream.eof() )\
        rStream.clear();\
    else\
        SetError( SVSTREAM_READ_ERROR );\
}


#else

#define WRITEDATA(pData,nWrite,nRetVal)  \
nRetVal = nWrite;\
rStream.write(pData, nWrite );\
if ( !rStream.good() )\
{\
    nRetVal = 0;\
    SetError( SVSTREAM_WRITE_ERROR );\
}

#define READDATA(pData,nRead,nRetVal) \
rStream.read( pData, nRead );\
nRetVal = rStream.gcount();\
if ( !rStream.good() )\
{\
    if ( rStream.eof() )\
        rStream.clear();\
    else\
        SetError( SVSTREAM_READ_ERROR );\
}

#endif

// -----------------------------------------------------------------------

/*************************************************************************
|*
|*    StdIStream::StdIStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

StdIStream::StdIStream( istream& rIoStream ) :
                rStream( rIoStream )
{
    bClosed = FALSE;
    // nHandle = rStream.rdbuf()->fd();
    SyncSvStream();
    SetBufferSize( 0 );
}

/*************************************************************************
|*
|*    StdIStream::~StdIStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

 StdIStream::~StdIStream()
{
    SyncStdStream();
}

/*************************************************************************
|*
|*    StdIStream::Close()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void StdIStream::Close()
{
    SyncStdStream();
    bClosed = TRUE;
}

/*************************************************************************
|*
|*    StdIStream::SyncSvStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

// Der SvStream wird auf den Zustand des Standard-Streams gesetzt.
// Der Puffer des SvStreams wird weggeworfen.

void StdIStream::SyncSvStream()
{
    if( bClosed )
        return;
    SvStream::SyncSvStream( (ULONG)rStream.tellg() );
}

/*************************************************************************
|*
|*    StdIStream::SyncStdStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

// Der Standard-Stream wird auf den Zustand des SvStreams gesetzt.

void StdIStream::SyncStdStream()
{
    if( bClosed )
        return;
    SyncSysStream();
}

/*************************************************************************
|*
|*    StdIStream::operator istream&()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

StdIStream::operator istream&()
{
    SyncStdStream();
    return rStream;
}

/*************************************************************************
|*
|*    StdIStream::GetData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdIStream::GetData( char* pData, ULONG nSize )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    ULONG nRetVal;
    // ULONG nRead=nSize;
    READDATA(pData,nSize,nRetVal)
    return nRetVal;
}

/*************************************************************************
|*
|*    StdIStream::PutData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdIStream::PutData( const char* /* pData */, ULONG /* nSize */ )
{
    return 0;   // in einen istream kann nicht geschrieben werden
}

/*************************************************************************
|*
|*    StdIStream::SeekPos()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdIStream::SeekPos( ULONG nPos )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    if ( nPos != STREAM_SEEK_TO_END )
#if STLPORT_VERSION < 321 || defined( _MSC_VER) || defined(MACOSX)
        rStream.seekg( (streampos)nPos );
#else
        rStream.seekg( (NAMESPACE_STD(streampos))nPos );
#endif
    else
        rStream.seekg( 0, ios::end );

    nPos = rStream.tellg();
    return nPos;
}

/*************************************************************************
|*
|*    StdIStream::FlushData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdIStream::FlushData()
{
}

/*************************************************************************
|*
|*    StdIStream::SetSize()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdIStream::SetSize( ULONG )
{
    SetError( SVSTREAM_ACCESS_DENIED );
}

/*************************************************************************
|*
|*    StdIStream::ResetError()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void StdIStream::ResetError()
{
    if ( bClosed )
        return;
    SvStream::ClearError();
    rStream.clear();
}

/*************************************************************************
|*
|*    StdOStream::StdOStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

StdOStream::StdOStream( ostream& rIoStream ) :
                rStream( rIoStream )
{
    bClosed = FALSE;
    bIsWritable = TRUE;
    rStream.flush();
    SyncSvStream();
    SetBufferSize( 0 );
}

/*************************************************************************
|*
|*    StdOStream::~StdOStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

 StdOStream::~StdOStream()
{
    SyncStdStream();
}

/*************************************************************************
|*
|*    StdOStream::Close()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void StdOStream::Close()
{
    SyncStdStream();
    bClosed = TRUE;
}

/*************************************************************************
|*
|*    StdOStream::SyncSvStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

// Der SvStream wird auf den Zustand des Standard-Streams gesetzt.
// Der Puffer des SvStreams wird weggeworfen.

void StdOStream::SyncSvStream()
{
    if( bClosed )
        return;
    SvStream::SyncSvStream( (ULONG)rStream.tellp() );
}

/*************************************************************************
|*
|*    StdOStream::SyncStdStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

// Der Standard-Stream wird auf den Zustand des SvStreams gesetzt.

void StdOStream::SyncStdStream()
{
    if (bClosed )
        return;
    SyncSysStream();
}

/*************************************************************************
|*
|*    StdOStream::operator ostream&()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

StdOStream::operator ostream&()
{
    SyncStdStream();
    return rStream;
}

/*************************************************************************
|*
|*    StdOStream::GetData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdOStream::GetData( char* /* pData */, ULONG /* nSize */ )
{
    return 0; // aus einem ostream kann nicht gelesen werden
}

/*************************************************************************
|*
|*    StdOStream::PutData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdOStream::PutData( const char* pData, ULONG nSize )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    ULONG nRetVal;
    WRITEDATA(pData,nSize,nRetVal)
    return nRetVal;
}

/*************************************************************************
|*
|*    StdOStream::SeekPos()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdOStream::SeekPos( ULONG nPos )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    if ( nPos != STREAM_SEEK_TO_END )
#if STLPORT_VERSION<321 || defined(_MSC_VER) || defined(MACOSX)
        rStream.seekp( (streampos)nPos );
#else
        rStream.seekp( (NAMESPACE_STD(streampos))nPos );
#endif
    else
        rStream.seekp( 0, ios::end );
    return rStream.tellp();
}

/*************************************************************************
|*
|*    StdOStream::FlushData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdOStream::FlushData()
{
    if ( bClosed )
        return;
    rStream.flush();
}

/*************************************************************************
|*
|*    StdOStream::ResetError()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdOStream::ResetError()
{
    if ( bClosed )
        return;
    SvStream::ClearError();
    rStream.clear();
}

/*************************************************************************
|*
|*    StdOStream::SetSize()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdOStream::SetSize( ULONG)
{
    SetError( SVSTREAM_ACCESS_DENIED );
}

/*************************************************************************
|*
|*    StdIOStream::StdIOStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

StdIOStream::StdIOStream( iostream& rIoStream ) :
                rStream( rIoStream )
{
    // nHandle = rStream.rdbuf()->fd();
    bClosed = FALSE;
    bIsWritable = TRUE;
    SyncSvStream();
    SetBufferSize( 0 );
}

/*************************************************************************
|*
|*    StdIOStream::~StdIOStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

 StdIOStream::~StdIOStream()
{
    SyncStdStream();
}

/*************************************************************************
|*
|*    StdIOStream::Close()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void StdIOStream::Close()
{
    SyncStdStream();
    bClosed = TRUE;
}

/*************************************************************************
|*
|*    StdIOStream::SyncSvStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

// Der SvStream wird auf den Zustand des Standard-Streams gesetzt.
// Der Puffer des SvStreams wird weggeworfen.

void StdIOStream::SyncSvStream()
{
    if( bClosed )
        return;
    SvStream::SyncSvStream( (ULONG)rStream.tellg() );

}

/*************************************************************************
|*
|*    StdIOStream::SyncStdStream()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

// Der Standard-Stream wird auf den Zustand des SvStreams gesetzt.

void StdIOStream::SyncStdStream()
{
    if( bClosed )
        return;
    SyncSysStream();
}

/*************************************************************************
|*
|*    StdIOStream::operator iostream&()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

StdIOStream::operator iostream&()
{
    SyncStdStream();
    return rStream;
}

/*************************************************************************
|*
|*    StdIOStream::GetData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdIOStream::GetData( char* pData, ULONG nSize )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    ULONG nRetVal;
    READDATA(pData,nSize,nRetVal)
    return nRetVal;
}

/*************************************************************************
|*
|*    StdIOStream::PutData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdIOStream::PutData( const char* pData, ULONG nSize )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    ULONG nRetVal;
    WRITEDATA(pData,nSize,nRetVal)
    return nRetVal;
}

/*************************************************************************
|*
|*    StdIOStream::SeekPos()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

ULONG  StdIOStream::SeekPos( ULONG nPos )
{
    if (bClosed )
    {
        SetError( SVSTREAM_GENERALERROR );
        return 0;
    }
    if ( nPos != STREAM_SEEK_TO_END )
#if STLPORT_VERSION<321 || defined(_MSC_VER) || defined(MACOSX)
        rStream.seekg( (streampos)nPos );
#else
        rStream.seekg( (NAMESPACE_STD(streampos))nPos );
#endif
    else
        rStream.seekg( 0, ios::end );
    return rStream.tellg();
}

/*************************************************************************
|*
|*    StdIOStream::FlushData()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdIOStream::FlushData()
{
    if ( bClosed )
        return;
    rStream.flush();
}

/*************************************************************************
|*
|*    StdIOStream::ResetError()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdIOStream::ResetError()
{
    if ( bClosed )
        return;
    SvStream::ClearError();
    rStream.clear();
}

/*************************************************************************
|*
|*    StdIOStream::SetSize()
|*
|*    Beschreibung      STREAM.SDW
|*    Ersterstellung    OV 07.07.94
|*    Letzte Aenderung  OV 07.07.94
|*
*************************************************************************/

void  StdIOStream::SetSize( ULONG )
{
    SetError( SVSTREAM_ACCESS_DENIED );
}
