/*************************************************************************
 *
 *  $RCSfile: header.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//#define COMPLETE	// alle 4 Passes, sonst nur class.lst anlegen

//#define DEBUG 1
//#define DEBUGxxx

#include "header.hxx"

//globle Variablen

AllClasses* pClassesList;
USHORT	vLevel;					// VerboseLevel

char* strmakro ( char *pChar )
{
	char* pDefine;char* cPos;int nPos;
	if (( cPos = strchr ( pChar, '(')) > 0 )
	{
		nPos = cPos - pChar + 1;
		// Makro gefunden
		pDefine = new char[nPos+1];
		strncpy ( pDefine, pChar, nPos );
		pDefine[nPos-1] = '\0';
		//bInMacro = TRUE;
		if (( cPos = strchr ( pDefine, '(')) > 0 )
		{
			char* pNewDef;
			nPos = cPos - pDefine + 1;
			pNewDef = new char[nPos+1];
			strncpy ( pNewDef, pDefine, nPos );
			pDefine[nPos-1] = '\0';
			strcpy ( pDefine, pNewDef );
			delete pNewDef;
		}
		return pDefine;
	}
	return pChar;
}

int strtolower ( char *pChar )
{
	for ( unsigned int i=0;i<strlen(pChar);i++ )
		pChar[i] = tolower ( pChar[i] );
	return i;
}

char* strabstobase ( char *pChar )
{
	char *pResult, pTmpChar[255]; 
	pResult = strtok ( pChar, "\\" );
	do
	{
		if ( pResult ) strcpy ( pTmpChar, pResult );
	} while ( (pResult = strtok ( NULL, "\\")) != NULL );
	(void) strcpy ( pChar, pTmpChar );
	strtolower( pChar);
	return pChar;
}

int str_c_simple ( char *pChar )
{
	if (pChar )
	{
		int nLen = strlen ( pChar );
		char c = pChar[nLen-1];
		if ( c=='*' || c=='/' || c == '&' || c==';' || c == '+' || c == '-'
					|| c=='%' || c == '|' || c=='(' || c == ')' )
			pChar[nLen-1] = '\0';
		return 1;
	}
	else
		return 0;
}
//***************************************************************************
//
//	AllClasses
//
//***************************************************************************

AllClasses::AllClasses()
{
	// Liste der Klassen einlesen
	FILE *fp;
	// neue Hashtable fuer ClassInfos anlegen
	pClassSet = new ClassInfoSet( 63997 );
	char aLineBuffer[LINE_LENGTH];
	if (( fp = fopen ( "class.lst","r" )) == NULL )
	{
		fprintf ( stderr, "Can't open File class.lst" );
		exit (1);
	}
	while ( fgets ( aLineBuffer, LINE_LENGTH, fp ) != NULL )
	{
		ClassInfo* pClassInfo = new ClassInfo ( aLineBuffer );
		pClassSet->Insert( pClassInfo->GetClassName(), pClassInfo );

	}
#ifdef DEBUGhahah
	FILE* p = fopen ( "ttt.lst","a");
	for ( ULONG z=0; z<pItemsList->Count();z++)
		fprintf (p, "%s\n", pItemsList->GetObject(z)->GetStr() );
	fclose ( p );
#endif
	fclose ( fp );
}

DECLARE_HASHTABLE_ITERATOR( ClassInfoIt, ClassInfo* );

BOOL AllClasses::UpdateDefs()
{
	ULONG j,l,m;
	ClassInfoIt aClassIter ( *pClassSet );
	fprintf( stderr, "\nEntering Update Defs!\n" );
	for ( ClassInfo *pClassInfo = aClassIter.GetFirst(); pClassInfo != NULL;
			pClassInfo = aClassIter.GetNext())
	{
		fprintf( stderr, "d" );
		ULONG nDepCount = pClassInfo->pClassDepList->Count();
		for ( j=0; j<nDepCount; j++ )
		{
			String* pDepClassName = pClassInfo->pClassDepList->GetObject(j);
			ClassInfo* pCurClassInfo = pClassSet->Find(*pDepClassName);
			if ( pCurClassInfo )
			{
				ULONG nClassFoundDefs=pCurClassInfo->pClassDefineList->Count();
				for ( l=0; l<nClassFoundDefs; l++)
				{
					// Nur einfuegen, wenn nicht schon vorhanden !
					ULONG nDefs = pClassInfo->pClassDefineList->Count();
					BOOL bFound = FALSE;
					for ( m=0;m<nDefs;m++)
					{
						String* pNewDefine = pCurClassInfo->
											pClassDefineList->GetObject(l);
						String* pDefineName = pClassInfo->
											pClassDefineList->GetObject(m);
						if (!strcmp(pNewDefine->GetStr(),pDefineName->GetStr()))
							bFound = TRUE;
					}
					if ( !bFound )
				  	pClassInfo->pClassDefineList->
						PutString( pCurClassInfo->pClassDefineList->GetObject(l));
				}
			}
		}
	}
	fprintf( stderr, "\nLeaving Update Defs!\n" );
	return TRUE;
}

BOOL AllClasses::Update()
{
	fprintf ( stderr, "\ngut schuetteln ...\t" );
	// wir gehen hier ueber alle Klassen
	ClassInfoIt aClassIter ( *pClassSet );
	for ( ClassInfo *pClassInfo = aClassIter.GetFirst(); pClassInfo != NULL;
			pClassInfo = aClassIter.GetNext())
	{
		fprintf ( stderr, "." );
		// abhaengige Klassen erfassen
		ULONG nDeps = pClassInfo->pClassDepList->Count();
		for ( ULONG j=0; j<nDeps; j++ )
		{
			// Name einer abhaengigen Klasse
			String* pDepClassName = pClassInfo->pClassDepList->GetObject(j);
			if ( pDepClassName )
			{
				ClassInfo* pInfo = pClassSet->Find( *pDepClassName );
				if ( pInfo )
				{
					String aCurClassName = pInfo->GetClassName();
					ULONG l=pInfo->pClassDepList->Count();
			   		for ( ULONG m=0; m<l; m++)
					{
						String* pDepClassName = pInfo->pClassDepList->
															GetObject(m);
						pClassInfo->pClassDepList->PutString( 
										pInfo->pClassDepList->GetObject(m) );
					}
				}
			}
		}
	}
	//UpdateDefs();
	fprintf ( stderr, "... fertig !\n");
	return TRUE;
}


//**********************************************************************
//
//	ClassInfo
//
//**********************************************************************
ClassInfo::ClassInfo()
{
	Init();
}

// pLine ist eine Zeile aus class.lst	headerfile typ items _defines
ClassInfo::ClassInfo( char* pLine )
{
	BOOL bGotClassName = FALSE;
	BOOL bCancel = FALSE;
	char* pChar;
	Init();
	
	pChar = strtok ( pLine, " \t" );
	aFileName = pChar;

	pChar = strtok ( NULL, " \t" );
	aType = pChar;

	while (( (pChar = strtok ( NULL, " \t" )) != NULL) && !bCancel )
	{
		if ( !strcmp (pChar, "Typ:")) 
			bCancel = TRUE;
		else
		if ( !bGotClassName )
		{
			aClassName = pChar;
			bGotClassName = TRUE;
		}
		else
		{
		  if ( strcmp ( pChar, "\n"))
		  {
			String* pStr = new String ( pChar );
			pClassDefineList->PutString ( pStr );
		  }
		}
	}
}

ClassInfo::~ClassInfo()
{
	delete pClassDefineList;
	delete pClassDepList;
	delete pOccList;
}

BOOL ClassInfo::Init()
{
	pClassDepList = new SStringList;
	pClassDefineList = new SStringList;
	pOccList = new OccList;
	return TRUE;
}

BOOL ClassInfo::AddDeps(ClassInfo *pInfo)
{
	BOOL bFound=FALSE;
	ULONG nPos = 0;

	for (ULONG z=0; z<pInfo->pClassDepList->Count(); z++)
	{
	  if (z)
		if ( !strcmp ( aClassName.GetStr(), 
					pInfo->pClassDepList->GetObject(z)->GetStr() ))
			bFound = TRUE;
	}
	if (!bFound)
	{
		String *pStr = new String( aClassName );
		nPos = pInfo->pClassDepList->PutString( pStr );
	}
	return TRUE;
}

//**********************************************************************
//
//	SourceCppParser
//
//**********************************************************************
SourceCppParser::SourceCppParser( String aFile )	:
	SimpleCppParser ( aFile )
{
	pResultList = new StringList;
	pAllDefineList = new StringList;
	
	InitDef();
	Init();
}

SourceCppParser::~SourceCppParser()
{
	WriteResult();
	//delete pResultList;
	//delete pAllDefineList;
}

BOOL SourceCppParser::InitDef()
{
	ClassInfoIt aIter( *pClassesList->GetSet());
	ULONG j,k;
	// Liste alle bekannten Defines aufbauen
	for ( ClassInfo *pClassInfo = aIter.GetFirst(); pClassInfo != NULL; 
										pClassInfo = aIter.GetNext())
	{
		ULONG nDefCount = pClassInfo->pClassDefineList->Count();
		for ( j=0; j<nDefCount; j++ )
		{
			// wenn nicht schon vorhanden, einfuegen
			BOOL bFound = FALSE;
			String* pStr = pClassInfo->pClassDefineList->GetObject(j);
			ULONG nDefs = pAllDefineList->Count();
			for ( k=0; k<nDefs; k++ )
			{
				String* pSecStr = pAllDefineList->GetObject(k);
				if ( !strcmp ( pStr->GetStr(), pSecStr->GetStr()))
					bFound = TRUE;
			}
			if ( !bFound )
				pAllDefineList->Insert( pStr );
		}
	}
	return TRUE;
}

BOOL SourceCppParser::ProcessLine ()
{
	char* pChar;
	ULONG j,k;
	fprintf ( stderr, "ProcessLine !!!!\n" );

	pChar = strtok ( aLineBuffer, WHITE_CHAR );
	if ( pChar == NULL ) return FALSE;

	while ( pChar != NULL )
	{
		str_c_simple ( pChar );
		ClassInfo *pClassInfo = pClassesList->GetSet()->Find( String( pChar ));
		if ( pClassInfo )
		{
		ULONG nDefCount = pClassInfo->pClassDefineList->Count();
		for ( j=0; j<nDefCount; j++ )
		{
			String* pDefStr=pClassInfo->pClassDefineList->GetObject(j);
			// diese Defines, wenn noch nicht vohanden, eintragen
			BOOL bFound = FALSE;
			ULONG nResCount = pResultList->Count();
			for ( k=0; k<nResCount; k++ )
			{
				if ( !strcmp ( pDefStr->GetStr(), 
							pResultList->GetObject(k)->GetStr() ) )
						bFound = TRUE;
			}
			if ( !bFound ) 
			{	// hier die defines fuer die Klasse eintragen
				pResultList->Insert ( pDefStr );
			}	
		}
		}
		pChar = strtok ( NULL, WHITE_CHAR );
	}
	return TRUE;
}

BOOL SourceCppParser::Parse()
{
	fprintf ( stderr, "Pass 3\n" );
	while ( fgets ( aLineBuffer, LINE_LENGTH, fp ) != NULL )
	{
		nLines++;
		ProcessLine();
	}
	return TRUE;
}

BOOL SourceCppParser::WriteResult()
{
	FILE* fp;
	ULONG i,j;
	if (( fp = fopen ( "defs.lst","w" )) == NULL )
	{
		fprintf ( stderr, "Cannot open File defs.lst\n");
		exit(1);
	}
	ULONG nDef = pAllDefineList->Count();
	for ( i=0; i<nDef; i++ )
	{
		BOOL bFound = FALSE;
		String* pStr = pAllDefineList->GetObject(i);
		ULONG nResDef = pResultList->Count();
		for ( j=0; j<nResDef; j++ )
		{
			String* pSecStr = pResultList->GetObject(j);
			if ( !strcmp ( pStr->GetStr(), pSecStr->GetStr()) )
				bFound = TRUE;
		}
		if ( !bFound )
		{
			if ( strcmp ( pStr->GetStr(), "_SV_H" ) )
										// wg. define protected public
				fprintf ( fp, "#define %s\n", pStr->GetStr() );
		}

	}
	fclose ( fp );
	return TRUE;
}

//**********************************************************************
//
//	SecondCppParser
//
//**********************************************************************
SecondCppParser::SecondCppParser( String aFile )	:
	SimpleCppParser ( aFile )
{
	pStringList = new StringList;
	bDeriviationExpected = FALSE;
	bClassBodyExpected = FALSE;
	bReferenceFound = TRUE;
	bInMacro = FALSE;
	bInClassBody = FALSE;
	nScope=0;
	pScopeStack = new ScopeStack;
	Init();
}

BOOL SecondCppParser::Parse()
{
	fprintf ( stderr, "Pass 2\n" );
	if ( fp != NULL)
	{
		while ( fgets ( aLineBuffer, LINE_LENGTH, fp ) != NULL )
		{
			nLines++;
			strcpy ( aBuf, aLineBuffer );
			ProcessLine();
		}
		return TRUE;
	}
	else
	{
		fprintf ( stderr, "Error : Cant open File %s\n", aFileName.GetStr());
		return FALSE;
	}
}

BOOL SecondCppParser::ProcessLine()
{
	BOOL bClassFound = FALSE;
	BOOL bDefineFound = FALSE;
	BOOL bFriendFound = FALSE;
	char* pChar;

	pChar = strtok ( aLineBuffer, WHITE_CHAR );
	if ( pChar == NULL ) return FALSE;

	pChar = strmakro ( pChar );
	while ( pChar != NULL )
	{
		int nLength = strlen ( pChar );
		if ( pChar[nLength-1] == '&' )		// Referenz gefunden
		{
			/*pChar[nLength-1] = '\0';*/
			bReferenceFound = TRUE;
		}
		if ( bInClassBody )
		{

			if ( bFriendFound == TRUE )
			{
				if ( pChar[nLength-1] == ';' )
					pChar[nLength-1] = '\0';
				bFriendFound = FALSE;
			}
			if ( !IsForward ( pChar ))
				Put ( pChar );
		}
		if ( bInMacro )
		{
			int nLineLen = strlen ( aBuf );
			if ( aBuf[nLineLen-2] == '\\' )
				bInMacro = TRUE;
			else
				bInMacro = FALSE;
			bDefineFound = FALSE;
			char* pToken;
			int nP = strcspn( pChar, "(" );
			pToken = new char[nP+1];
			strncpy ( pToken, pChar, nP ); pToken[nP] = '\0';
			strcpy ( pChar, pToken );

			//ClassInfo* pClassInfo=pClassesList->GetSet()->Find(String(pChar));
			ClassInfo* pInfoY=pClassesList->GetSet()->Find(pCurrentClassName);
			if ( pInfoY )
			{
				String* pStr = new String ( pChar );
				pInfoY->pClassDepList->PutString( pStr );
			}
		}
		if ( bDefineFound )
		{
			// sind wir in einem Makro ???
			char* pDefine;char* cPos;int nPos;
			int nLength = strlen ( pChar );
			if (( cPos = strchr ( pChar, '(')) > 0 )
			{
				nPos = cPos - pChar + 1;
				// Makro gefunden
				pDefine = new char[nPos+1];
				strncpy ( pDefine, pChar, nPos );
				pDefine[nPos-1] = '\0';
				bInMacro = TRUE;
				if (( cPos = strchr ( pDefine, '(')) > 0 )
				{
					char* pNewDef;
					nPos = cPos - pDefine + 1;
					pNewDef = new char[nPos+1];
					strncpy ( pNewDef, pDefine, nPos );
					pDefine[nPos-1] = '\0';
					strcpy ( pDefine, pNewDef );
				}
			}
			else
			{
				pDefine = new char[nLength];
				strcpy ( pDefine, pChar );
			}
			aCurrentMacroName = pDefine;
			int nLineLen = strlen ( aBuf );
			if ( aBuf[nLineLen-3] == '\\' || aBuf[nLineLen-2] == '\\' || aBuf[nLineLen-1] == '\\' )
				bInMacro = TRUE;
			else
				bInMacro = FALSE;
			char* pToken;
			int nP = strcspn( pChar, "(" );
			pToken = new char[nP+1];
			strncpy ( pToken, pChar, nP ); pToken[nP] = '\0';
			strcpy ( pChar, pToken );

				(void) strcpy ( pCurrentClassName, pChar );
			bDefineFound = FALSE;
		}
		if ( (bClassFound == TRUE) && (bDefineFound == FALSE) )
		{
			nLength = strlen ( pChar );
			if ( pChar[nLength-1] == ';' )			// Forward Deklaration gefunden
			{
				nForward++;
				// reichte hier nicht ein bForwarFound ???
				pChar[nLength-1] = '\0';
			}
			else 
			{
				if ( pChar[nLength-1] == ':' )
				{
					pChar[nLength-1] = '\0';
				}

				bClassBodyExpected = TRUE;
				(void) strcpy (pCurrentClassName, pChar);
				bDeriviationExpected = TRUE;
			}
			bClassFound = FALSE;
		}
		if ( !(strcmp ( pChar,"class" ) && strcmp ( pChar,"struct" ) && strcmp ( pChar,"enum") ))
		{
#ifdef ALL_DEBUG
			fprintf ( stdout, "Class or struct found\n" );
#endif
			bClassFound = TRUE;
		}
		if ( !strcmp ( pChar, "{" ) )
		{
			bDeriviationExpected = FALSE;
			nScope++;
			ClassScope* pClassScope = new ClassScope;
			pClassScope->nLevel = nScope;
			if ( bClassBodyExpected )
			{
				pClassScope->pClassName = new String;// ( pChar );
				bInClassBody = TRUE;
				//fprintf ( stderr, "Line %u : Class body found!\n", nLines);
				pScopeStack->Push(pClassScope);
			}
			else
			{
				pClassScope->pClassName = new String;
			}
			bClassBodyExpected = FALSE;
		}
		if ( !(strcmp ( pChar, "};" ) && strcmp ( pChar, "}")) )
		{
			ClassScope* pClassScope = pScopeStack->Top();
			if ( pClassScope )
			{
				if ( pClassScope->nLevel == nScope )
				{
					bInClassBody = FALSE;
#ifdef ALL_DEBUG
					fprintf ( stderr, " Line %u : out of class body !\n", 
																	nLines);
#endif

					pClassScope = pScopeStack->Pop();
					delete pClassScope->pClassName;
					delete pClassScope;
				}
			}
			nScope--;
			bDeriviationExpected = FALSE;
			bClassBodyExpected = FALSE;
		}
		if ( !strcmp ( pChar, "#define" ))
			bDefineFound = TRUE;
		if ( !strcmp ( pChar, "friend" ))
			bFriendFound = TRUE;

		if (bClassBodyExpected && !bInClassBody && !strcmp ( pChar, ":" ))
		{
			bDeriviationExpected = TRUE;
		}
		// Ableitung erkennen !!
		if ( bDeriviationExpected == TRUE )
		{
			//was ist mit mehrfachableitungen ???
			if ( strcmp ( pChar,":" ))
			{
//#ifdef DEBUG
				if ( !strcmp ( pChar, "public" ))
				{
					fprintf ( stderr, " public Ableitung\n");
				}
				else if ( !strcmp ( pChar, "private" ))
				{
					fprintf ( stderr, " private Ableitung\n");
				}
				else if ( !strcmp ( pChar, "virtual" ))
				{
					fprintf ( stderr, " virtual Ableitung\n");
				}
				else
//#endif
				{
					// Ableitung gefunden
					ClassInfo *pInfoY = pClassesList->GetSet()->
											Find( pCurrentClassName );
					if ( pInfoY )
					{
						String* pStr = new String ( pChar );
						pInfoY->pClassDepList->PutString( pStr );
#ifdef DEBUG
					fprintf ( stderr, "Current Class Name : %s\t\t", 
										pCurrentClassName);
					fprintf ( stderr, "<Second> Gotcha : %s\n", pStr->GetStr() );
#endif
						ClassOccurence* pFound = new ClassOccurence;
						pFound->pStr = pStr;
						pFound->aFileName = aFileName;
						pFound->nLine = nLines;
						pInfoY->pOccList->Insert ( pFound );

						bDeriviationExpected = FALSE;
					}
				}
			}
		}
		pChar = strtok ( NULL, WHITE_CHAR );
	} 
	return TRUE;
}

BOOL SecondCppParser::Put( char* pChar )
{
	ClassInfo *pInfo;
	ClassInfo *pInfoY = pClassesList->GetSet()->Find( pCurrentClassName );
	if ( pInfoY )
	{
		if ( pInfo = pClassesList->GetSet()->Find( pChar ) )
		{
			String* pStr = new String ( pChar );
			pInfoY->pClassDepList->PutString( pStr );
       
#ifdef DEBUG
			fprintf ( stderr, "Current Class Name : %s\t\t", 
								pCurrentClassName);
			fprintf ( stderr, "<Second > Gotcha : %s\n", pStr->GetStr() );
#endif
			// genaue Fundstelle vermerken
			ClassOccurence* pFound = new ClassOccurence;
			pFound->pStr = pStr;
			pFound->aFileName = aFileName;
			pFound->nLine = nLines;
			pInfoY->pOccList->Insert ( pFound );
			return TRUE;
		}
		else return FALSE;
	}
	else
		return FALSE;
}

BOOL SecondCppParser::IsForward( char* pChar )
{
	BOOL bIsForward = FALSE;
	int nLen = strlen ( pChar );
	if ( pChar[nLen-1] == '*' ) return TRUE;
	long nPos = ftell( fp );
	int nCurPos = nPos;
	BOOL bAsciiFound = FALSE;
	while ( !bAsciiFound )
	{
		fseek ( fp, nCurPos, SEEK_SET );
		char ch = fgetc ( fp );
		if ( isascii ( ch ))
		{
			bIsForward = FALSE;
			bAsciiFound = TRUE;
		}  else
		if ( ch == ' ' )
		{
			bAsciiFound = FALSE;
		}
		else if ( ch == '*' )
		{
			bAsciiFound = TRUE;
			bIsForward = TRUE;
		}
		else if ( ch == '\n' )
		{
			bAsciiFound = TRUE;
			bIsForward = FALSE;
		}
		else
			bAsciiFound = TRUE;
	}
	fseek  ( fp, nPos, SEEK_SET );
	return bIsForward;
}

//**********************************************************************
//
//	ThirdCppParser
//
//	Im dritten Pass werden die Abhaengigkeiten der Identifier im Headerfile
//	untereinander beruecksichtigt. Es werden jedoch nur die Ident. aus den
//	kleinsten #ifndef/#endif-Einheiten beruecksichtigt.
//	Dazu wird mit Beginn jeden #ifndefs ein List der gefundenen Identifier
//	angelegt, die, sofern die kleinste #ifndef/#endif-Einheit gefunden
//	ist, in die allgemeinen Abhaengigkeiten ergaenzt wird.
//
//**********************************************************************
ThirdCppParser::ThirdCppParser( String aFile, FILE* fpLogFile ) :
	SimpleCppParser ( aFile, fpLogFile )
{
	//pScopeClasses = new ClassesList;
	//pIntList = new IntList;
	pScopeClassSet = new ClassInfoSet(1001);
	pScopeStack = new StringStack;
	Init();
}

ThirdCppParser::ThirdCppParser( String aFile ) :
	SimpleCppParser ( aFile )
{
	nIfLevel = 0;
	pScopeStack = new StringStack;
	Init();
}

// Ein Identifier wurde gefunden !!
BOOL ThirdCppParser::PutItem( char *pChar )
{
	DBG_ASSERT( FALSE, "!" );
	//ULONG nPos;
	//int *pInt;
	if ( pScopeStack->Count() )
	{
		//IntList *pIntList = pScopeStack->Top()->pIntList;
		ClassInfoSet *pClassSet = pScopeStack->Top()->pScopeClassSet;
		String *pString = new String ( pChar );
		//Position aus der allgemeinen List holen
		//nPos = pClassesList->pItemsList->IsString ( pString );
		// und in die temp. List einfuegen.
		//pInt = new int(nPos);
		//pIntList->Insert ( pInt );
		ClassInfo *pInfo = pClassesList->GetSet()->Find( *pString );
		pClassSet->Insert( *pString, pInfo );
		return TRUE;
	}
	else
		return FALSE;
}

// Neue Dependencies hinzufuegen
BOOL ThirdCppParser::AddDeps (void)
{
	//ULONG i,j, nCount;
	//IntList *pIntList = pScopeStack->Top()->pIntList;
	ClassInfoSet *pClassSet = pScopeStack->Top()->pScopeClassSet;

	// Jetzt muss aus der ClassList die interessierende Klasse geholt werden
	// und alle anderen Klassen hinzugefuegt werden.

	ClassInfoIt aIter1( *pClassSet);
	ClassInfoIt aIter2( *pClassSet);
	for ( ClassInfo *pInfoI=aIter1.GetFirst(); pInfoI!=NULL; pInfoI =
				aIter1.GetNext())
	{
		for ( ClassInfo *pInfoJ=aIter2.GetFirst(); pInfoJ!=NULL;pInfoJ = 
							aIter2.GetNext())
			pInfoI->AddDeps( pInfoJ );
	}
	return TRUE;
}

// Die temp. Liste wieder loeschen
BOOL ThirdCppParser::Reset()
{
	//ULONG i, nCount;
	if ( pScopeStack->Top())
	{
		//IntList *pIntList = pScopeStack->Top()->pIntList;
		ClassInfoSet *pClassSet = pScopeStack->Top()->pScopeClassSet;
		ClassInfoIt aIter( *pClassSet);
		for ( ClassInfo *pInfo=aIter.GetFirst(); pInfo!=NULL; pInfo =
					aIter.GetNext())
		{
			pClassSet->Delete(*pInfo->GetClassName());
		}
		return TRUE;
	}
	else
		return FALSE;
}

BOOL ThirdCppParser::Parse()
{
	fprintf ( stderr, "Pass 3\n" );
	while ( fgets ( aLineBuffer, LINE_LENGTH, fp ) != NULL )
	{
		nLines++;
		ProcessLine();
	}
	return TRUE;
}

BOOL ThirdCppParser::ProcessLine()
{
	BOOL bClassFound = FALSE, bDefineFound = FALSE, bIfdefFound = FALSE;
	BOOL bIfndefFound = FALSE, bEnumFound = FALSE, bTypedefFound = FALSE;
	BOOL bGotClass = FALSE, bGotDerivedClass = FALSE;
	char* pChar;

	pChar = strtok ( aLineBuffer, WHITE_CHAR );
	while ( pChar != NULL )
	{
		if ( !(strcmp ( pChar, "unsigned" ) && 
				strcmp ( pChar, "const") &&
				strcmp ( pChar, "const*") &&
				strcmp ( pChar, "const**") 
				))
			pChar = strtok ( NULL, WHITE_CHAR );
		if ( !pChar )
			return TRUE;
		// c++ Kommentare ueberlesen
		if ( !strcmp ( pChar, "//" ))
			return TRUE;
		if ( !strcmp ( pChar, "/*" ))
			bInCComment = TRUE;
		if ( pChar[0] == '/' && pChar[1] == '*' )
			bInCComment = TRUE;
		if ( !strcmp ( pChar, "*/" ))
			bInCComment = FALSE;
		int nTmp = strlen ( pChar );
		if ( pChar[nTmp-2] == '*' && pChar[nTmp-1] == '/' )
			bInCComment = FALSE;

		if ( !bInCComment )
		{
			if ( (bClassFound == TRUE) && (bDefineFound == FALSE) )
			{
				int nLength = strlen ( pChar );
				if ( pChar[nLength-1] == ';' )			// Forward Deklaration gefunden
				{
					nForward++;
				}
				else 
				{
				 if ( strcmp ( "{", pChar ) )
				 {
					if ( pChar[nLength-1] == ':' )
					{
						// abgelittene Klasse gefunden
						bGotClass = TRUE;
						pChar[nLength-1] = '\0';
					}
					// auf jeden Fall eine Klasse gefunden, ist diese abgeleitet ???
					bGotClass = TRUE;
					// SonderFaelle nicht mit aufnehmen !!
					if ( strcmp ( pChar, "ClassName" ) &&
						 strcmp ( pChar, "ClassName##Wrap") &&
						 strcmp ( pChar, "ClassName##Ref") &&
						 strcmp ( pChar, "ClassName##Lock") &&
						 strcmp ( pChar, "ClassName##MemberList") && 
						 strcmp ( pChar, "CN##MemberList") && 
						 strcmp ( pChar, "name") &&
						 strcmp ( pChar, "name\\") &&
						 strcmp ( pChar, "\\") &&
						 strcmp ( pChar, ")") &&
						 strcmp ( pChar, "),") &&
						 strcmp ( pChar, ")x") &&
						 strcmp ( pChar, "Timer(") 
						 )
					{
						nClass++;
						for ( ULONG i=0; i<pStringStack->Count(); i++ )
							fprintf ( fpClassFile, "%s\t", 
								pStringStack->GetObject(i)->pStr->GetStr());
						fprintf ( fpClassFile, "\n" );
						//fprintf ( fpClassFile, "Typ: Class\n");
						PutItem( pChar );
					}
					bClassFound = FALSE;
				  }
				}
			}
			if ( bEnumFound )
			{
				// kein enum { xxx=0x1, yyy=0x2 }; mitnehmen
				if ( strcmp ( pChar, "{" ))
				{
					nClass++;
					for ( ULONG i=0; i<pStringStack->Count(); i++ )
						fprintf ( fpClassFile, "%s\t", 
							pStringStack->GetObject(i)->pStr->GetStr());
					fprintf ( fpClassFile, "\n" );
					PutItem( pChar );
					//fprintf ( fpClassFile, "Typ: Enum\n");
				}
				bEnumFound = FALSE;
			}
			if ( bDefineFound )
			{

				char* pDefine;char* cPos;int nPos;
				int nLength = strlen ( pChar );
				BOOL bTypedefFunc = ( pChar[0] == '(');
				if (( cPos = strchr ( pChar, '(')) > 0 )
				{
					nPos = cPos - pChar + 1;
					// Makro gefunden
					pDefine = new char[nPos+1];
					strncpy ( pDefine, pChar, nPos );
					pDefine[nPos-1] = '\0';
					//bMakroFound = TRUE;

					if (( cPos = strchr ( pDefine, '(')) > 0 )
					{
						char* pNewDef;
						nPos = cPos - pDefine + 1;
						pNewDef = new char[nPos+1];
						strncpy ( pNewDef, pDefine, nPos );
						pDefine[nPos-1] = '\0';
						strcpy ( pDefine, pNewDef );
					}
				}
				else
				{
					pDefine = new char[nLength+1];
					strcpy ( pDefine, pChar );
					pChar = strtok ( NULL, WHITE_CHAR );
					if ( !pChar )
					{
						//ein einfaches define -> uninteressant
						pDefine = ( char* ) NULL;
						return TRUE;
					}
					else
						// hoffentlich sinnvolles define gefunden
						;

				}				
				if ( pDefine )
				{
					if ( ( strcmp ( pDefine, "protected" ) &&
							strcmp ( pDefine, "extern_c") &&
							strcmp ( pDefine, "_CDECLARE_") &&
							strcmp ( pDefine, "CDECLARE") &&
							strcmp ( pDefine, "_CDECLARE") &&
							strcmp ( pDefine, "_CDECL") &&
							strcmp ( pDefine, "CDECL") &&
							strcmp ( pDefine, "INETCDECL") &&
							strcmp ( pDefine, "C") &&
							strcmp ( pDefine, "TRUE") &&
							strcmp ( pDefine, "FALSE") &&
							strcmp ( pDefine, "CVERSION") &&
							strcmp ( pDefine, "TCPP") &&
							strcmp ( pDefine, "FAR" ) &&
							strcmp ( pDefine, "HUGE" ) &&
							strcmp ( pDefine, "_FAR" ) &&
							strcmp ( pDefine, "_FARC" ) &&
							strcmp ( pDefine, "_FARCC" )))
					{
						nClass++;
						for ( ULONG i=0; i<pStringStack->Count(); i++ )
							fprintf ( fpClassFile, "%s\t", 
								pStringStack->GetObject(i)->pStr->GetStr());
						fprintf ( fpClassFile, "\n" );
						PutItem( pDefine );
						//fprintf ( fpClassFile, "Typ: Define\n");
					}
				}
				bDefineFound = FALSE;

			}
			if ( bTypedefFound )
			{
				char* pTypedef;char* pNewTypedef; int nPos;
				// das erste Token nach einem typedef koennen wir immer ueberlesen
				// es sollte ein uns bekannter typ sein ( unsigned oben schon rausgeworfen )
				pChar = strtok ( NULL, WHITE_CHAR );
				if ( strcmp (pChar, "{") )
				{
					int nPos; char* cPos;
					int nLength = strlen ( pChar );
					pTypedef = new char[nLength+1];
					if ( pChar[0] == '(' )
					{
						pChar += 2;
						// typedef auf Function 


						if (( cPos = strchr ( pChar, '(')) > 0 )
						{
							nPos = cPos - pChar + 1;
							pNewTypedef = new char[nPos+1];
							strncpy ( pNewTypedef, pChar, nPos );
							pNewTypedef[nPos-1] = '\0';
				

							strcpy (pTypedef,pNewTypedef);
						}
						else
							strcpy ( pTypedef, pChar );
						int nLen = strlen ( pTypedef );
						if ( pTypedef[nLen-1] == ')')
							pTypedef[nLen-1] = '\0';
					}
					else
					strcpy ( pTypedef, pChar );	   
				}
				if ( pTypedef )
				if ( !strcmp ( pTypedef, "*" )) // mm-spezial
					pTypedef = '\0';
				if ( pTypedef )
				{
					int nLen = strlen ( pTypedef );
					if ( pTypedef[nLen-1] == ';')
						pTypedef[nLen-1] = '\0';

					nClass++;
					for ( ULONG i=0; i<pStringStack->Count(); i++ )
						fprintf ( fpClassFile, "%s\t", 
							pStringStack->GetObject(i)->pStr->GetStr());
					fprintf ( fpClassFile, "\n" );	
					PutItem( pTypedef );
					//fprintf ( fpClassFile, "Typ: Typedef\n");
				}
				bTypedefFound =  FALSE;
			}
			if ( !(strcmp ( pChar, "class" ) && strcmp ( pChar, "struct" )))
				bClassFound = TRUE;
			if ( !(strcmp ( pChar, "enum" )))
				bEnumFound = TRUE;
			if ( bIfndefFound == TRUE )
			{
				DefineString* pTmpDefStr;
				DefineString* pDefStr = new DefineString;
				if ( !( strcmp ( pChar, "TCPP" ) &&
					    strcmp ( pChar, "protected") &&
					    strcmp ( pChar, "_FAR") &&
						strcmp ( pChar, "SUN" ) &&
						strcmp ( pChar, "ENABLEUNICODE" ) &&
						strcmp ( pChar, "_FARC" ) &&
						strcmp ( pChar, "_FARCC" ) ))
				pDefStr->pStr = new String;
				else 					
				pDefStr->pStr = new String ( pChar );
				pDefStr->pScopeClassSet = new ClassInfoSet(1001);
				pDefStr->nLevel = nIfLevel;
				pDefStr->bSubDefine = FALSE;
				pTmpDefStr = pScopeStack->Top();
				if ( pTmpDefStr )
					pTmpDefStr->bSubDefine = TRUE;
				pScopeStack->Push( pDefStr );
				bIfndefFound = FALSE;
				fprintf ( stderr, "Level %d : %s\n", nIfLevel, pChar );
			}
			if ( bGotClass == TRUE )
			{
				if ( !(strcmp ( pChar, "public" ) && strcmp ( pChar, "private" )))
					bGotDerivedClass = TRUE;
				bGotClass = FALSE;
			}
			if ( bGotDerivedClass == TRUE )
			{
				; // abgelittene Klasse gefunden
			}
			if ( !strcmp ( pChar, "#define" ))
			{
				nDefine++;
				bDefineFound = TRUE;
			}
			if ( !strcmp ( pChar, "typedef" ))
			{
				bTypedefFound = TRUE;
			}
			if ( !(strcmp ( pChar, "#if")  && strcmp ( pChar, "#ifdef" )))
			{
				nIfdef++;
				bIfdefFound = TRUE;
				nIfLevel++;
			}
			if ( !strcmp ( pChar, "#ifndef" ))
			{
				nIfndef++;
				bIfndefFound = TRUE;
				nIfLevel++;
			}
			if ( !strcmp ( pChar, "#endif" ))
			{
				DefineString* pDefStr = pScopeStack->Top();
				if ( pDefStr )
				if ( pDefStr->nLevel == nIfLevel )
				{
					if ( pDefStr->bSubDefine == TRUE )
					{
						fprintf ( stderr, "SubDefine Found in %s\n", pDefStr->pStr->GetStr());
						AddDeps();
						Reset();
					}
					else
					{
						// untereste Ebene gefunden !!
						fprintf ( stderr, "SubDefine not Found in %s\n", pDefStr->pStr->GetStr());
						AddDeps();
						Reset();
					}
					pDefStr = pScopeStack->Pop();
					//Reset();
					delete pDefStr->pScopeClassSet;
					delete pDefStr->pStr;
					delete pDefStr;
				}
				nIfLevel--;
			}
		}
		pChar = strtok ( NULL, WHITE_CHAR );
	}
	return TRUE;
}

//**********************************************************************
//
//	SimpleCppParser
//
//**********************************************************************
SimpleCppParser::SimpleCppParser( String aFile, FILE* fpLogFile )
{
	fpClassFile = fpLogFile;
	aFileName = aFile;
	Init();
}

SimpleCppParser::SimpleCppParser( String aFile )
{
	aFileName = aFile;
	fpClassFile = stdout;
	Init();
}

BOOL SimpleCppParser::Init()
{
	bClass = FALSE;
	bInCComment = FALSE;
	nLines = 0;
	nClass = 0;
	nForward = 0;
	nDefine = 0;
	nIfndef = 0;
	nIfdef = 0;

	pStringStack = new StringStack;

	if (( fp = fopen ( aFileName.GetStr(), "r" )) == NULL )
	{
		fprintf ( stderr, "Cannot open file %s\n", aFileName.GetStr() );
		return FALSE;
	}
	if ( vLevel > 0 )
	  fprintf ( stderr, "\nPass 1 : Processing File  %s", aFileName.GetStr() );
	return TRUE;
}

BOOL SimpleCppParser::Parse()
{
	//fprintf ( stderr, "Pass 1\n" );
	while ( fgets ( aLineBuffer, LINE_LENGTH, fp ) != NULL )
	{
		nLines++;
		ProcessLine();
	}
	return TRUE;
}

SimpleCppParser::~SimpleCppParser()
{
	delete pStringStack;

	if ( vLevel > 3 )
	{
		fprintf ( stderr, "%u Lines processed\n", nLines );
		fprintf ( stderr, "%u Classes Found\n", nClass );
		fprintf ( stderr, "%u Class forwards Found\n", nForward );
		fprintf ( stderr, "%u defines Found\n", nDefine );
		fprintf ( stderr, "%u ifdefines Found\n", nIfdef );
		fprintf ( stderr, "%u ifnotdefines Found\n", nIfndef );
	}
	fclose ( fp );
}

BOOL SimpleCppParser::ProcessLine()
{
	BOOL bClassFound = FALSE, bDefineFound = FALSE, bIfdefFound = FALSE;
	BOOL bIfndefFound = FALSE, bEnumFound = FALSE, bTypedefFound = FALSE;
	BOOL bGotClass = FALSE, bGotDerivedClass = FALSE;
	char* pChar;

	pChar = strtok ( aLineBuffer, WHITE_CHAR );
	while ( pChar != NULL )
	{
		if ( !(strcmp ( pChar, "unsigned" ) && 
				strcmp ( pChar, "const") &&
				strcmp ( pChar, "const*") &&
				strcmp ( pChar, "const**") 
				))
			pChar = strtok ( NULL, WHITE_CHAR );
		if ( !pChar )
			return TRUE;
		// c++ Kommentare ueberlesen
		if ( !strcmp ( pChar, "//" ))
			return TRUE;
		if ( !strcmp ( pChar, "/*" ))
			bInCComment = TRUE;
		if ( pChar[0] == '/' && pChar[1] == '*' )
			bInCComment = TRUE;
		if ( !strcmp ( pChar, "*/" ))
			bInCComment = FALSE;
		int nTmp = strlen ( pChar );
		if ( pChar[nTmp-2] == '*' && pChar[nTmp-1] == '/' )
			bInCComment = FALSE;

		if ( !bInCComment )
		{
			if ( (bClassFound == TRUE) && (bDefineFound == FALSE) )
			{
				int nLength = strlen ( pChar );
				if ( pChar[nLength-1] == ';' )			// Forward Deklaration gefunden
				{
					nForward++;
				}
				else 
				{
				 if ( strcmp ( "{", pChar ) )
				 {
					if ( pChar[nLength-1] == ':' )
					{
						// abgelittene Klasse gefunden
						bGotClass = TRUE;
						pChar[nLength-1] = '\0';
					}
					// auf jeden Fall eine Klasse gefunden, ist diese abgeleitet ???
					bGotClass = TRUE;
					// SonderFaelle nicht mit aufnehmen !!
					if ( strcmp ( pChar, "ClassName" ) &&
						 strcmp ( pChar, "ClassName##Wrap") &&
						 strcmp ( pChar, "ClassName##Ref") &&
						 strcmp ( pChar, "ClassName##Lock") &&
						 strcmp ( pChar, "ClassName##MemberList") && 
						 strcmp ( pChar, "CN##MemberList") && 
						 strcmp ( pChar, "name") &&
						 strcmp ( pChar, "name\\") &&
						 strcmp ( pChar, "\\") &&
						 strcmp ( pChar, ")") &&
						 strcmp ( pChar, "),") &&
						 strcmp ( pChar, ")x") &&
						 strcmp ( pChar, "Timer(") 
						 )
					{
						char* pFile = new char[strlen(aFileName.GetStr())+1];
						(void) strcpy ( pFile, aFileName.GetStr() );
						fprintf ( fpClassFile, "%s\t", strabstobase ( pFile) );
						fprintf ( fpClassFile, "class\t" );
						fprintf ( fpClassFile, "%s\t", pChar );
						nClass++;
						for ( ULONG i=0; i<pStringStack->Count(); i++ )
							fprintf ( fpClassFile, "%s\t", 
								pStringStack->GetObject(i)->pStr->GetStr());
						fprintf ( fpClassFile, "\n" );
					}
					bClassFound = FALSE;
				  }
				}
			}
			if ( bEnumFound )
			{
				// kein enum { xxx=0x1, yyy=0x2 }; mitnehmen
				if ( strcmp ( pChar, "{" ))
				{
					char* pFile = new char[strlen(aFileName.GetStr())+1];
					(void) strcpy ( pFile, aFileName.GetStr() );
					fprintf ( fpClassFile, "%s\t", strabstobase ( pFile ) );
					fprintf ( fpClassFile, "enum\t" );
					fprintf ( fpClassFile, "%s\t", pChar );
					//if ( vLevel > 1 )
					//	fprintf( stderr, "%s\t", pChar );
					nClass++;
					for ( ULONG i=0; i<pStringStack->Count(); i++ )
					{
						fprintf ( fpClassFile, "%s\t", 
							pStringStack->GetObject(i)->pStr->GetStr());
					}
					fprintf ( fpClassFile, "\n" );
				}
				bEnumFound = FALSE;
			}
			if ( bDefineFound )
			{

				char* pDefine;char* cPos;int nPos;
				int nLength = strlen ( pChar );
				BOOL bTypedefFunc = ( pChar[0] == '(');
				if (( cPos = strchr ( pChar, '(')) > 0 )
				{
					nPos = cPos - pChar + 1;
					// Makro gefunden
					pDefine = new char[nPos+1];
					strncpy ( pDefine, pChar, nPos );
					pDefine[nPos-1] = '\0';
					//bMakroFound = TRUE;

					if (( cPos = strchr ( pDefine, '(')) > 0 )
					{
						char* pNewDef;
						nPos = cPos - pDefine + 1;
						pNewDef = new char[nPos+1];
						strncpy ( pNewDef, pDefine, nPos );
						pDefine[nPos-1] = '\0';
						strcpy ( pDefine, pNewDef );
					}
				}
				else
				{
					pDefine = new char[nLength+1];
					strcpy ( pDefine, pChar );
					pChar = strtok ( NULL, WHITE_CHAR );
					if ( !pChar )
					{
						//ein einfaches define -> uninteressant
						pDefine = ( char* ) NULL;
						return TRUE;
					}
					else
						// hoffentlich sinnvolles define gefunden
						;

				}				
				if ( pDefine )
				{
					if ( ( strcmp ( pDefine, "protected" ) &&
							strcmp ( pDefine, "extern_c") &&
							strcmp ( pDefine, "_CDECLARE_") &&
							strcmp ( pDefine, "CDECLARE") &&
							strcmp ( pDefine, "_CDECLARE") &&
							strcmp ( pDefine, "_CDECL") &&
							strcmp ( pDefine, "CDECL") &&
							strcmp ( pDefine, "INETCDECL") &&
							strcmp ( pDefine, "C") &&
							strcmp ( pDefine, "TRUE") &&
							strcmp ( pDefine, "FALSE") &&
							strcmp ( pDefine, "CVERSION") &&
							strcmp ( pDefine, "TCPP") &&
							strcmp ( pDefine, "FAR" ) &&
							strcmp ( pDefine, "HUGE" ) &&
							strcmp ( pDefine, "_FAR" ) &&
							strcmp ( pDefine, "_FARC" ) &&
							strcmp ( pDefine, "_FARCC" )))
					{
						char* pFile = new char[strlen(aFileName.GetStr())+1];
						(void) strcpy ( pFile, aFileName.GetStr() );
						fprintf ( fpClassFile, "%s\t", strabstobase ( pFile) );
						fprintf ( fpClassFile, "define\t" );
						fprintf ( fpClassFile, "%s\t", pDefine );
						nClass++;
						for ( ULONG i=0; i<pStringStack->Count(); i++ )
							fprintf ( fpClassFile, "%s\t", 
								pStringStack->GetObject(i)->pStr->GetStr());
						fprintf ( fpClassFile, "\n" );
					}
				}
				bDefineFound = FALSE;

			}
			if ( bTypedefFound )
			{
				char* pTypedef;char* pNewTypedef; int nPos;
				// das erste Token nach einem typedef koennen wir immer ueberlesen
				// es sollte ein uns bekannter typ sein ( unsigned oben schon rausgeworfen )
				pChar = strtok ( NULL, WHITE_CHAR );
				if ( strcmp (pChar, "{") )
				{
					int nPos; char* cPos;
					int nLength = strlen ( pChar );
					pTypedef = new char[nLength+1];
					if ( pChar[0] == '(' )
					{
						pChar += 2;
						// typedef auf Function 


						if (( cPos = strchr ( pChar, '(')) > 0 )
						{
							nPos = cPos - pChar + 1;
							pNewTypedef = new char[nPos+1];
							strncpy ( pNewTypedef, pChar, nPos );
							pNewTypedef[nPos-1] = '\0';
				

							strcpy (pTypedef,pNewTypedef);
						}
						else
							strcpy ( pTypedef, pChar );
						int nLen = strlen ( pTypedef );
						if ( pTypedef[nLen-1] == ')')
							pTypedef[nLen-1] = '\0';
					}
					else
					strcpy ( pTypedef, pChar );	   
				}
				if ( pTypedef )
				if ( !strcmp ( pTypedef, "*" )) // mm-spezial
					pTypedef = '\0';
				if ( pTypedef )
				{
					int nLen = strlen ( pTypedef );
					if ( pTypedef[nLen-1] == ';')
						pTypedef[nLen-1] = '\0';

					char* pFile = new char[strlen(aFileName.GetStr())+1];
					(void) strcpy ( pFile, aFileName.GetStr() );
					fprintf ( fpClassFile, "%s\t", strabstobase ( pFile ));
					fprintf ( fpClassFile, "typedef\t" );
					fprintf ( fpClassFile, "%s\t", pTypedef );
					nClass++;
					for ( ULONG i=0; i<pStringStack->Count(); i++ )
						fprintf ( fpClassFile, "%s\t", 
							pStringStack->GetObject(i)->pStr->GetStr());
					fprintf ( fpClassFile, "\n" );	
				}
				bTypedefFound =  FALSE;
			}
			if ( !(strcmp ( pChar, "class" ) && strcmp ( pChar, "struct" )))
				bClassFound = TRUE;
			if ( !(strcmp ( pChar, "enum" )))
				bEnumFound = TRUE;
			if ( bIfndefFound == TRUE )
			{
				DefineString* pDefStr = new DefineString;
				if ( !( strcmp ( pChar, "TCPP" ) &&
					    strcmp ( pChar, "protected") &&
					    strcmp ( pChar, "_FAR") &&
						strcmp ( pChar, "SUN" ) &&
						strcmp ( pChar, "ENABLEUNICODE" ) &&
						strcmp ( pChar, "_FARC" ) &&
						strcmp ( pChar, "_FARCC" ) ))
				pDefStr->pStr = new String;
				else 					
				pDefStr->pStr = new String ( pChar );
				pDefStr->nLevel = nIfLevel;
				pStringStack->Push( pDefStr );
				bIfndefFound = FALSE;
			}
			if ( bGotClass == TRUE )
			{
				if ( !(strcmp ( pChar, "public" ) && strcmp ( pChar, "private" )))
					bGotDerivedClass = TRUE;
				bGotClass = FALSE;
			}
			if ( bGotDerivedClass == TRUE )
			{
				; // abgelittene Klasse gefunden
			}
			if ( !strcmp ( pChar, "#define" ))
			{
				nDefine++;
				bDefineFound = TRUE;
			}
			if ( !strcmp ( pChar, "typedef" ))
			{
				bTypedefFound = TRUE;
			}
			//if ( !strcmp ( pChar, "struct" ))
			//{
				//bStructFound = TRUE;
			//}
			if ( !(strcmp ( pChar, "#if")  && strcmp ( pChar, "#ifdef" )))
			{
				nIfdef++;
				bIfdefFound = TRUE;
				nIfLevel++;
			}
			if ( !strcmp ( pChar, "#ifndef" ))
			{
				nIfndef++;
				bIfndefFound = TRUE;
				nIfLevel++;
			}
			if ( !strcmp ( pChar, "#endif" ))
			{
				DefineString* pDefStr = pStringStack->Top();
				if ( pDefStr )
				if ( pDefStr->nLevel == nIfLevel )
				{
					pDefStr = pStringStack->Pop();
					delete pDefStr->pStr;
					delete pDefStr;
				}
				nIfLevel--;
			}
		}
		pChar = strtok ( NULL, WHITE_CHAR );
	}  
	return TRUE;
}

// *************** ProcessPath ****************************************

int ProcessPath ( char* pPath, char* aSourceFileName )
{
	// pPath enthaelte einen oder mehrere Pfade, mit ; getrennt
	FILE* fp;
	USHORT i;
	String aFileName;
	char *pCurPath = new char[255];
	char *pRestPath = new char[255];
	char *pTmpChar;
	char *pRemPath = new char[255];
	int nRestLen;
	
	// den Original-Pfad retten
	(void) strcpy ( pRemPath, pPath );
	if (( fp = fopen ( "class.lst","w" )) == NULL )
	{
		fprintf ( stderr, "Can't open File class.lst" );
		return 0;
	}
	// den ersten Pass anwerfen, um alle Klassen zu ermitteln
	// und in class.lst ablegen

	pTmpChar = strchr ( pPath, ';' );
	if ( pTmpChar )
	{
		nRestLen = strlen ( pTmpChar );
	 	strncpy ( pCurPath, pPath, pTmpChar-pPath );
		pCurPath[pTmpChar-pPath] = '\0';
		strncpy ( pRestPath, pTmpChar+1, nRestLen );
		pRestPath[nRestLen] = '\0';
	}
	else
	{
		(void) strcpy (pRestPath, "");
		(void) strcpy ( pCurPath, pPath );
	}
	
	do
	{
		String aDirName ( pCurPath );
		String aSearchMask = aDirName;
		aSearchMask += "/*.hxx";
		Dir aSearchDir ( aSearchMask );
		aSearchDir.SetSort( FSYS_SORT_NAME );
		for ( i=0; i<aSearchDir.Count(); i++ )
		{
			aFileName = aSearchDir[i].GetFull();
			SimpleCppParser* pParser = new SimpleCppParser ( aFileName, fp );
			pParser->Parse();
			delete pParser;
		}

		pTmpChar = strchr ( pRestPath, ';' );
		if ( pTmpChar )
			nRestLen = strlen ( pTmpChar );
		else
			break;
		strncpy ( pCurPath, pRestPath, pTmpChar-pRestPath );
		pCurPath[pTmpChar-pRestPath] = '\0';
		strncpy ( pRestPath, pTmpChar+1, nRestLen );
		pRestPath[nRestLen-1] = '\0';
	
	}
	while ( pRestPath != NULL );
	fclose(fp);


	// KlassenListe anlegen aus class.lst
#ifdef COMPLETE
	pClassesList = new AllClasses;

	// den zweiten Pass mit den nun bekannten Klassen anwerfen

	(void) strcpy ( pPath, pRemPath );
	if ( pTmpChar)
	{
		pTmpChar = strchr ( pPath, ';' );
		nRestLen = strlen ( pTmpChar );
		strncpy ( pCurPath, pPath, pTmpChar-pPath );
		pCurPath[pTmpChar-pPath] = '\0';
		strncpy ( pRestPath, pTmpChar+1, nRestLen );
		pRestPath[nRestLen] = '\0';
	}
	else
	{
		(void) strcpy (pRestPath, "");
		(void) strcpy ( pCurPath, pPath );
	}
	
	do
	{
		String aDirName ( pCurPath );
		String aSearchMask = aDirName;
		aSearchMask += "/*.hxx";
		Dir aSearchDir ( aSearchMask );
		for ( i=0; i<aSearchDir.Count(); i++ )
		{
			aFileName = aSearchDir[i].GetFull();

			SecondCppParser* pParser = new SecondCppParser ( aFileName );
			pParser->Parse();
			delete pParser;
		}

		pTmpChar = strchr ( pRestPath, ';' );
		if ( pTmpChar )
			nRestLen = strlen ( pTmpChar );
		else
			break;
		strncpy ( pCurPath, pRestPath, pTmpChar-pRestPath );
		pCurPath[pTmpChar-pRestPath] = '\0';
		strncpy ( pRestPath, pTmpChar+1, nRestLen );
		pRestPath[nRestLen-1] = '\0';
	
	}
	while ( pRestPath != NULL );
	
	// Klassenlist gut durchschuetteln damit alle Abhaengigkeiten erkannt werden
	pClassesList->Update();

	(void) strcpy ( pPath, pRemPath );
	pTmpChar = strchr ( pPath, ';' );
	if ( pTmpChar )
	{
		nRestLen = strlen ( pTmpChar );
		strncpy ( pCurPath, pPath, pTmpChar-pPath );
		pCurPath[pTmpChar-pPath] = '\0';
		strncpy ( pRestPath, pTmpChar+1, nRestLen );
		pRestPath[nRestLen] = '\0';
	}
	else
	{
		(void) strcpy ( pCurPath, pPath );
			(void) strcpy (pRestPath, "");
	}
	do
	{
		String aDirName ( pCurPath );
		String aSearchMask = aDirName;
		aSearchMask += "/*.hxx";
		Dir aSearchDir ( aSearchMask );
		for ( i=0; i<aSearchDir.Count(); i++ )
		{
			aFileName = aSearchDir[i].GetFull();
			ThirdCppParser* pParser = new ThirdCppParser ( aFileName );
			pParser->Parse();
			delete pParser;
		}

		pTmpChar = strchr ( pRestPath, ';' );
		if ( pTmpChar )
			nRestLen = strlen ( pTmpChar );
		else
			break;
		strncpy ( pCurPath, pRestPath, pTmpChar-pRestPath );
		pCurPath[pTmpChar-pRestPath] = '\0';
		strncpy ( pRestPath, pTmpChar+1, nRestLen );
		pRestPath[nRestLen-1] = '\0';
	
	}
	while ( pRestPath != NULL );
	
	// Klassenliste gut durchschuetteln damit alle Abhaengigkeiten erkannt werden
	pClassesList->Update();

	// ASCII-File fuer die Abhaengigkeiten rausschreiben 
	FILE* fpClassesList;
	if (( fpClassesList = fopen ( "classes.all", "w" )) == NULL )
	{
		fprintf ( stderr, "Can't open File classes.all\n");
		return 1;
	}
	ClassInfo *pClassInfo;
	ClassInfoIt aIter( *pClassesList->GetSet());
	for ( pClassInfo = aIter.GetFirst(); pClassInfo != NULL; 
													pClassInfo=aIter.GetNext())
	{
		fprintf ( fpClassesList,"\nKlasse :\t");
		fprintf ( fpClassesList,"%s\t\n", pClassInfo->GetClassName().GetStr() );
		fprintf ( fpClassesList,"Type :\t");
		fprintf ( fpClassesList,"%s\t\n", pClassInfo->GetClassType().GetStr() );
		fprintf ( fpClassesList,"nDefines :\t");
		ULONG nDefCount = pClassInfo->pClassDefineList->Count();
		if (nDefCount < 10000 )
		for ( ULONG m=0; m<nDefCount; m++ )
		{
			String* pStr = pClassInfo->pClassDefineList->GetObject(m);
			if ( pStr )
				fprintf ( fpClassesList, "%s\t", pStr->GetStr() );
		}
		fprintf ( fpClassesList, "\nAbhaengigkeiten :\t");
		ULONG nDepCount =  pClassInfo->pClassDepList->Count();
		if ( nDepCount < 10000 )
		for ( ULONG p=0; p<nDepCount; p++ )
		{
			String* pStr = pClassInfo->pClassDepList->GetObject(p);
			if ( pStr )
				fprintf ( fpClassesList, "%s\t", pStr->GetStr() );
		}
		fprintf ( fpClassesList, "\n");
	}
	fclose ( fpClassesList );

	pClassesList->Update();
	// ASCII-File fuer die Abhaengigkeiten rausschreiben nochmal !!
	if (( fpClassesList = fopen ( "classes.txt", "w" )) == NULL )
	{
		fprintf ( stderr, "Can't open File classes.txt\n");
		return 1;
	}

	//ClassInfoIt aIter( *pClassesList->GetSet());
	for ( pClassInfo = aIter.GetFirst(); pClassInfo != NULL; 
											pClassInfo = aIter.GetNext())
	{
		fprintf ( fpClassesList,"\nKlasse :\t");
		fprintf ( fpClassesList,"%s\t\n", pClassInfo->GetClassName().GetStr() );
		fprintf ( fpClassesList,"Type :\t");
		fprintf ( fpClassesList,"%s\t\n", pClassInfo->GetClassType().GetStr() );
		fprintf ( fpClassesList, "nDefines :\t");
		ULONG nDefCount = pClassInfo->pClassDefineList->Count();
		if (nDefCount < 10000 )
		for ( ULONG m=0; m<nDefCount; m++ )
		{
			String* pStr = pClassInfo->pClassDefineList->GetObject(m);
			if ( pStr )
				fprintf ( fpClassesList, "%s\t", pStr->GetStr() );
		}
		fprintf ( fpClassesList, "\nAbhaengigkeiten :\t");
		ULONG nDepCount =  pClassInfo->pClassDepList->Count();
		if ( nDepCount < 10000 )
		for ( ULONG n=0; n<nDepCount; n++ )
		{
			String* pStr = pClassInfo->pClassDepList->GetObject(n);
			if ( pStr )
				fprintf ( fpClassesList, "%s\t", pStr->GetStr() );

		}
		ULONG nOccCount = pClassInfo->pOccList->Count();
		fprintf ( fpClassesList,"\nOccurences :\n" );
		for ( ULONG o=0;o<nOccCount;o++)
		{
			ClassOccurence* pFound = pClassInfo->pOccList->GetObject(o);
			fprintf ( fpClassesList,"File : %s :\t",pFound->aFileName.GetStr() );
			fprintf ( fpClassesList,"Line : %d :\t",pFound->nLine );
			fprintf ( fpClassesList,"\t%s\n", pFound->pStr->GetStr());
		}
		fprintf ( fpClassesList, "\n");
	}
	fclose ( fpClassesList );

	// SourceFile auf bekannte Klassen parsen

	SourceCppParser* pParser =  new SourceCppParser ( aSourceFileName );
	pParser->Parse();
	delete pParser;
#endif //COMPLETE
	return 0;
}

int usage()
{
	fprintf ( stderr, "Usage : clook.exe file.cxx\n");
	exit(1);
	return 1;
}

int __cdecl main ( int argc, char** argv )
{
	// verbose Level setzen
	vLevel = 2;
	ProcessPath( "..\\..\\wntmsci\\inc",  "..\\..\\workben\\header.cxx"  );
	return 0;
}

/*
 * Methoden der SStringList
 *
 */

SStringList::SStringList()
{
#ifdef DEBUGxxx
	nInternalCounter=0;
#endif
}

SStringList::~SStringList()
{
	Print();
}

ULONG SStringList::IsString( String* pStr )
{
	ULONG nRet = NOT_THERE;
	String* pString;
	ULONG nCount = Count();
	for ( ULONG i=0; i<nCount; i++ )
	{
		pString = GetObject(i);
		if ( !strcmp ( pString->GetStr(), pStr->GetStr() ) )
			return (i);
	}
	return nRet;
}

ULONG SStringList::GetPrevString( String* pStr )
{
	ULONG nRet = 0;
	BOOL bFound = FALSE;
	ULONG nCount = Count();
	ULONG nUpper = nCount;
	ULONG nLower = 0;
	ULONG nCurrent = nUpper / 2;
	ULONG nRem = 0;
	String* pString;

	do {
#ifdef DEBUGxxx
		nInternalCounter++;
#endif
		if ( (nCurrent == nLower) || (nCurrent == nUpper)) return nLower;
		pString = GetObject(nCurrent);
		ULONG nResult =  pString->Compare( pStr->GetStr() );
		if ( nResult == COMPARE_LESS )
		{
			nUpper = nCurrent;
			nCurrent = (nCurrent + nLower) /2;
		}
		else if ( nResult == COMPARE_GREATER )
		{
			nLower = nCurrent;
			nCurrent = (nUpper + nCurrent) /2;
		}
		else if ( nResult == COMPARE_EQUAL )
			return nCurrent;
		if ( nRem == nCurrent ) return (nCurrent);
		nRem = nCurrent;
	} while ( !bFound );
	return nRet;
}

/**************************************************************************
*
*	Sortiert einen String in die Liste ein und gibt die Position,
*	an der einsortiert wurde, zurueck
*
**************************************************************************/

ULONG SStringList::PutString( String* pStr )
{
	ULONG nPos = GetPrevString ( pStr );
#ifdef DEBUGxxx
	fprintf ( stderr, "Vergleiche : %d\n",nInternalCounter );
	nInternalCounter =0 ;
#endif
	if ( Count() )
	{
		{
			String* pString = GetObject(0);
			if ( pStr->Compare(pString->GetStr()) == COMPARE_GREATER )
			{
				Insert( pStr, (ULONG)0);
				return (ULONG)0;
			}
		}
		String* pString = GetObject(nPos);
		if ( pStr->Compare( pString->GetStr() ) != COMPARE_EQUAL )
		{
				Insert( pStr, nPos+1 );
				return ( nPos +1 );
		}
	}
	else
	{
		Insert( pStr );
		return (ULONG)0;
	}
	return NOT_THERE;
}

/*
 *
 */
 
BOOL SStringList::Print()
{
	ULONG nCount = Count();
	for ( ULONG i=0; i<nCount; i++)
		fprintf ( stderr, "%d : %s\n",i, GetObject(i)->GetStr());
	return TRUE;
}
