/*************************************************************************
 *
 *  $RCSfile: burdargs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <idl.hxx>

#include <iostream.h>
#include <fstream.h>
#include <sys/types.h>

#include <idlext.hxx>
#include "beurd.hxx"

static void BE_prep_help() 
{
	fprintf(stderr, "Supported -Wb arguments:\n\n"
		   "\t-Wb,c\t: generate only corereflection data in the registry.\n"
		   "           No output for documentation and services will be generated.\n\n"
		   "\t-Wb,h\t: Print this help message\n\n"
		   "\t-Wb,V\t: Print version info about backend\n\n");

	BE_version();
	exit(1);
}

void UNOIDL_CALLTYPE BE_prep_arg(char *a, sal_Bool) 
{
	if(strlen(a) != 1) 
	    BE_prep_help();
    
	switch(*a) 
	{
		case 'c':
			coreOnly = sal_True;
			break;
		case '?':
		case 'h':
			BE_prep_help();
			break;
		case 'V':
			BE_version();
			exit(1);
			break;
		default:
			BE_prep_help();
			break;
	}
}
