/*************************************************************************
 *
 *  $RCSfile: burdclas.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _BE_CLASSES_H
#define _BE_CLASSES_H

// bsmtclas.hxx
//
// Defines all classes for BE

// convenience functions:
//

#include <burddecl.hxx>

class RegistryTypeWriter;

// disable warning: inherits ... via dominance
#pragma warning( disable : 4250 )

char *direction_to_string(AST_Argument::Direction);
char *exprtype_to_string(AST_Expression::ExprType);
void exprvalue_to_string(AST_Expression::AST_ExprValue *ev, char* value);
AST_Type *td2t(AST_Type *td);
AST_Type *sq2t(AST_Type *td);
sal_Bool isMarshalType(AST_Type* &t);
void dump_expr_val(ostream &, AST_Expression::AST_ExprValue *);
void dump_binary_expr(ostream &, char *, AST_Expression *, AST_Expression *);
void dump_unary_expr(ostream &, char *, AST_Expression *);


// predefined type:
//
class BE_PredefinedType 
	:	public virtual AST_PredefinedType, public virtual BE_Decl
{
public:
	// Operations
	BE_PredefinedType();
	BE_PredefinedType(AST_PredefinedType::PredefinedType t, UTL_ScopedName *n,
		     UTL_StrList *p);
	virtual ~BE_PredefinedType() {}

	virtual void dumpReflection(RegistryKey& rKey);
	  
	virtual const char* getRelName();
  
	// Narrowing
	DEF_NARROW_METHODS2(BE_PredefinedType, AST_PredefinedType, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_PredefinedType);
};

// object:
//
class BE_Object 
	:	public virtual AST_Object, public virtual BE_Decl
{
public:
	// Operations
	BE_Object();
	BE_Object(UTL_ScopedName *n, UTL_StrList *p, char *name);
	virtual ~BE_Object() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Object, AST_Object, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Object);
	DEF_NARROW_FROM_SCOPE(BE_Object);
};

// service:
//
class BE_Service 
	:	public virtual AST_Service, public virtual BE_Decl
{
public:
	// Operations
	BE_Service();
	BE_Service(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Service() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Service, AST_Service, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Service);
	DEF_NARROW_FROM_SCOPE(BE_Service);
};

// interface_member:
//
class BE_InterfaceMember 
	:	public virtual AST_InterfaceMember, public virtual BE_Decl
{
public:
	// Operations
	BE_InterfaceMember();
	BE_InterfaceMember(const sal_uInt16 fOptional, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_InterfaceMember() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);
//	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_InterfaceMember, AST_InterfaceMember, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_InterfaceMember);
};

// service_member:
//
class BE_ServiceMember 
	:	public virtual AST_ServiceMember, public virtual BE_Decl
{
public:
	// Operations
	BE_ServiceMember();
	BE_ServiceMember(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_ServiceMember() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);
//	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_ServiceMember, AST_ServiceMember, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_ServiceMember);
};

// observes:
//
class BE_Observes 
	:	public virtual AST_Observes, public virtual BE_Decl
{
public:
	// Operations
	BE_Observes();
	BE_Observes(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Observes() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);
//	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Observes, AST_Observes, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Observes);
};

// needs:
//
class BE_Needs 
	:	public virtual AST_Needs, public virtual BE_Decl
{
public:
	// Operations
	BE_Needs();
	BE_Needs(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Needs() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);
//	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Needs, AST_Needs, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Needs);
};

// module:
//
class BE_Module 
	:	public virtual AST_Module, public virtual BE_Decl
{
public:
	// Operations
	BE_Module();
	BE_Module(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Module() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Module, AST_Module, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Module);
	DEF_NARROW_FROM_SCOPE(BE_Module);
};

// constants:
//
class BE_Constants 
	:	public virtual AST_Constants, public virtual BE_Decl
{
public:
	// Operations
	BE_Constants();
	BE_Constants(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Constants() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Constants, AST_Constants, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Constants);
	DEF_NARROW_FROM_SCOPE(BE_Constants);
};

// mapping:
//
class BE_Mapping 
	:	public virtual AST_Mapping, public virtual BE_Decl
{
public:
	// Operations
	BE_Mapping();
	BE_Mapping(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Mapping() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Mapping, AST_Mapping, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Mapping);
	DEF_NARROW_FROM_SCOPE(BE_Mapping);
};

class BE_Operation;
class BE_Attribute;

// interface:
//
class BE_Interface 
	:	public virtual AST_Interface, public virtual BE_Decl
{
	friend class BE_InterfaceFwd;
public:
	// Operations
	BE_Interface();
	BE_Interface(UTL_ScopedName *n, AST_Interface **ih, long nih,
	       UTL_StrList *p, char* uik, double version, sal_Bool vrt, char* ident);
	virtual ~BE_Interface(); // {}

	// Narrowing
	DEF_NARROW_METHODS2(BE_Interface, AST_Interface, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Interface);
	DEF_NARROW_FROM_SCOPE(BE_Interface);

	virtual void dumpReflection(RegistryKey& rKey);

protected:
	//void dumpCheckException(ostream&, BE_Operation *);
	void setProxyDefined(sal_Bool);
	sal_Bool isProxyDefined();

private:
	sal_Bool m_forwardDeclExists;
	sal_Bool m_unicast;                            // pragma multicast
	sal_Bool m_upcalls;                            // pragma upcalls
	sal_Bool m_proxy_defined;
	char    *m_pSmartProxy;
};

// interface forward decl.:
//
class BE_InterfaceFwd 
	:	public virtual AST_InterfaceFwd, public virtual BE_Decl
{
public:
	// Operations
	BE_InterfaceFwd();
	BE_InterfaceFwd(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_InterfaceFwd() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_InterfaceFwd, AST_InterfaceFwd, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_InterfaceFwd);
};

// exception:
//
class BE_Exception 
	:	public virtual AST_Exception, public virtual BE_Decl {
public:
	// Operations
	BE_Exception();
	BE_Exception(UTL_ScopedName *n, AST_Exception **ih, 
				 long nih, UTL_StrList *p);
	virtual ~BE_Exception() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Exception, AST_Exception, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Exception);
	DEF_NARROW_FROM_SCOPE(BE_Exception);
};

// structure:
//
class BE_Structure 
	:	public virtual AST_Structure, public virtual BE_Decl 
{
public:
	// Operations
	BE_Structure();
	BE_Structure(UTL_ScopedName *n, AST_Structure **ih, 
				 long nih, UTL_StrList *p);
	virtual ~BE_Structure() {}

	virtual void dumpReflection(RegistryKey& rKey);

	void setChecked(sal_Bool ch);
	sal_Bool getChecked();

	// Narrowing
	DEF_NARROW_METHODS2(BE_Structure, AST_Structure, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Structure);
	DEF_NARROW_FROM_SCOPE(BE_Structure);

protected:
	sal_Bool	m_checked;
};

// enumeration:
//
class BE_Enum 
	:	public virtual AST_Enum, public virtual BE_Decl
{
public:
	// Operations
	BE_Enum();
	BE_Enum(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Enum() {}

	virtual void dumpReflection(RegistryKey& rKey);

	void setChecked(sal_Bool ch);
	sal_Bool getChecked();
	
	// Narrowing
	DEF_NARROW_METHODS2(BE_Enum, AST_Enum, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Enum);
	DEF_NARROW_FROM_SCOPE(BE_Enum);

protected:
	sal_Bool 	m_checked;
};

// operation:
//
class BE_Operation 
	:	public virtual AST_Operation, public virtual BE_Decl 
{
public:
	// Operations
	BE_Operation();
	BE_Operation(AST_Type *rt, AST_Operation::Flags fl, IFlag ifl, 
				char* local, sal_Bool cons, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Operation() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);

	virtual AST_Argument *add_argument(AST_Argument *);

	sal_Bool hasReturnVal();
	sal_Bool hasArgs();
	sal_Bool hasInInoutArgs();
	sal_Bool hasOutInoutArgs();
	sal_Bool hasInoutArgs();
	sal_Bool isGetAttribute();
	sal_Bool isSetAttribute();
	void    isGetAttribute(sal_Bool);
	void    isSetAttribute(sal_Bool);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Operation, AST_Operation, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Operation);
	DEF_NARROW_FROM_SCOPE(BE_Operation);
  
private:
	sal_Bool m_returnVal;                          // return type != void ?
	sal_Bool m_hasArgs;                            // > arguments ?
	sal_Bool m_hasInInoutArgs;                     // > 0 IN, INOUT arguments ?
	sal_Bool m_hasOutInoutArgs;                    // > 0 OUT, INOUT arguments ?
	sal_Bool m_hasInoutArgs;                       // > 0 INOUT arguments ?
	sal_Bool m_isGetAttribute;                     // get attribute operation?
	sal_Bool m_isSetAttribute;                     // set attribute operation?
};

// BE_Field:
//
class BE_Field 
	:	public virtual AST_Field, public virtual BE_Decl
{
public:
	// Operations
	BE_Field();
	BE_Field(AST_Type *ft, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Field() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Field, AST_Field, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Field);
};

// argument:
//
class BE_Argument 
	:	public virtual AST_Argument, public virtual BE_Decl 
{
public:
	// Operations
	BE_Argument();
	BE_Argument(AST_Argument::Direction d, AST_Type *ft, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Argument() {}

	// Narrowing
	DEF_NARROW_METHODS2(BE_Argument, AST_Argument, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Argument);

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index, sal_uInt16& argIndex);
};

// attribute:
//
class BE_Attribute 
	:	public virtual AST_Attribute, public virtual BE_Decl
{
	friend class BE_Interface;
public:
	// Operations
	BE_Attribute();
	BE_Attribute(sal_uInt16 attrFlags, IFlag ifl,
			   AST_Type *ft, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Attribute();

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Attribute, AST_Attribute, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Attribute);
  
private:
	BE_Operation *m_get, *m_set;
};

// union:
//
class BE_Union 
	:	public virtual AST_Union, public virtual BE_Decl
{
public:
	// Operations
	BE_Union();
	BE_Union(AST_ConcreteType *dt, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Union() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Union, AST_Union, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Union);
	DEF_NARROW_FROM_SCOPE(BE_Union);
};

// union branch:
//
class BE_UnionBranch 
	:	public virtual AST_UnionBranch, public virtual BE_Decl
{
public:
	// Operations
	BE_UnionBranch();
	BE_UnionBranch(AST_UnionLabel *lab, AST_Type *ft, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_UnionBranch() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_UnionBranch, AST_UnionBranch, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_UnionBranch);
};

// union label:
//
class BE_UnionLabel 
	:	public virtual AST_UnionLabel 
{
public:
	// Operations
	BE_UnionLabel();
	BE_UnionLabel(AST_UnionLabel::UnionLabel ul, AST_Expression *v);
	virtual ~BE_UnionLabel() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	/*
	DEF_NARROW_METHODS2(BE_union_label, AST_UnionLabel, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_union_label);
	*/
};

// constant:
//
class BE_Constant 
	:	public virtual AST_Constant, public virtual BE_Decl 
{
public:
	// Operations
	BE_Constant();
	BE_Constant(AST_Expression::ExprType et,
	      AST_Expression *v,
	      UTL_ScopedName *n,
	      UTL_StrList *p);
	virtual ~BE_Constant() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);

	virtual const char* getRelName();

	// Narrowing
	DEF_NARROW_METHODS2(BE_Constant, AST_Constant, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Constant);

private:
	sal_Bool 	m_hasTypeMapping;
	UTL_Map		*m_typeMapping;
};

// expression:
//
class BE_ExprVal 
	:	public virtual AST_Expression 
{
public:
	// Operations
	BE_ExprVal(UTL_ScopedName *n);
	BE_ExprVal(AST_Expression *b, AST_Expression::ExprType t);
	BE_ExprVal(AST_Expression::ExprComb c,
	      AST_Expression *v1,
	      AST_Expression *v2);
	BE_ExprVal(long l);
	BE_ExprVal(long l, AST_Expression::ExprType t);
	BE_ExprVal(unsigned long l);
	BE_ExprVal(String *s);
	BE_ExprVal(char c);
	BE_ExprVal(double d);
	virtual ~BE_ExprVal() {}

	// Narrowing
	/*
	DEF_NARROW_METHODS2(BE_ExprVal, AST_Expression, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_ExprVal);
	*/
};

// enum value:
//
class BE_EnumVal 
	:	public virtual AST_EnumVal, public virtual BE_Decl 
{
public:
	// Operations
	BE_EnumVal();
	BE_EnumVal(unsigned long v, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_EnumVal() {}

	void dumpBlop(RegistryTypeWriter& aBlop, sal_uInt16& index);

	void setChecked(sal_Bool ch);
	sal_Bool getChecked();
  
	// Narrowing
	DEF_NARROW_METHODS2(BE_EnumVal, AST_EnumVal, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_EnumVal);

protected:
	sal_Bool	m_checked;
};

// array:
//
class BE_Array 
	:	public virtual AST_Array, public virtual BE_Decl
{
public:
	// Operations
	BE_Array();
	BE_Array(UTL_ScopedName *n, unsigned long ndims, UTL_ExprList *dims);
	virtual ~BE_Array() {}

	virtual void dumpReflection(RegistryKey& rKey);

	int  num_elems();

	// Narrowing
	DEF_NARROW_METHODS2(BE_Array, AST_Array, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Array);
};

// sequence:
//
class BE_Sequence 
	:	public virtual AST_Sequence, public virtual BE_Decl 
{
public:
	// Operations
	BE_Sequence();
	BE_Sequence(AST_Expression *v, AST_Type *bt);
	virtual ~BE_Sequence() {}

	virtual void dumpReflection(RegistryKey& rKey);

	String getFullName(String name);

	virtual const char* getRelName();
	
	virtual String getTypeName();
	// Narrowing
	DEF_NARROW_METHODS2(BE_Sequence, AST_Sequence, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Sequence);

protected:
	String setRelName(String name);

	String m_relName;
};

// string:
//
class BE_String 
	:	public virtual AST_String, public virtual BE_Decl
{
public:
	// Operations
	BE_String();
	BE_String(AST_Expression *v);
	virtual ~BE_String() {}

	virtual void dumpReflection(RegistryKey& rKey);

	virtual const char* getRelName();

	// Narrowing
	DEF_NARROW_METHODS2(BE_String, AST_String, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_String);
};

// typedef:
//
class BE_Typedef 
	:	public virtual AST_Typedef, public virtual BE_Decl 
{
public:
	// Operations
	BE_Typedef();
	BE_Typedef(AST_Type *bt, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~BE_Typedef() {}

	virtual void dumpReflection(RegistryKey& rKey);

	// Narrowing
	DEF_NARROW_METHODS2(BE_Typedef, AST_Typedef, BE_Decl);
	DEF_NARROW_FROM_DECL(BE_Typedef);
};

#endif	// _BE_CLASSES_BE_CLASSES_H
