/*************************************************************************
 *
 *  $RCSfile: burddecl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _BE_DECL_HXX
#define _BE_DECL_HXX


//#include <ucr/itemset.hxx>

#ifndef	_REGISTRY_REGISTRY_HXX_
#include <registry/registry.hxx>
#endif
#ifndef	_RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

class Registry;


class be_operation;

class BE_Decl 
	:	public virtual AST_Decl, public virtual UTL_Scope 
{
public:
	typedef enum { eIn, eOut, eInOut, eReturn } tKind;

	BE_Decl();
	BE_Decl(AST_Decl::NodeType nt, UTL_ScopedName *n, UTL_StrList *p);
	~BE_Decl();

	// return scoped name:
	virtual char *scope(BE_Decl *access =0);
  
	// generate reflection data:
	virtual void dumpReflection(RegistryKey& rKey);

	void dumpConstantPool(RegistryKey& rKey);

	unsigned short getNodeCount(AST_Decl::NodeType nt);

	const char* getFullName() const;
	virtual const char* getRelName();

	virtual String getTypeName();

	// utilities:
	BE_Decl *dd(AST_Decl *a);                    // AST_decl -> BE_Decl
	BE_Decl *ds(UTL_Scope *s);                   // UTL_Scope -> BE_Decl
	virtual char *getNamePref();                 // get scoped name
	tKind dir2dir(AST_Argument::Direction);      // Direction -> tKind
	tKind dir2dir(AST_Decl *);                   // AST_Decl -> tKind
	sal_Bool isAny(AST_Type *t);                  // is t a UNO Any?
	sal_Bool isPseudo(AST_Type *t);               // is t a UNO Pseudo object?
	const ::rtl::OUString& getDoku() { return m_doku; }

	// Narrowing
	DEF_NARROW_METHODS2(BE_Decl, AST_Decl, UTL_Scope);
	DEF_NARROW_FROM_DECL(BE_Decl);
	DEF_NARROW_FROM_SCOPE(BE_Decl);
  
protected:
	void setFullName();
	// set scoped name
	virtual void setNamePref();                  
  
	// global scope?:
	virtual sal_Bool global(); 
  
	// handling access types (in, out, inout):
	virtual sal_Bool isAccessType(AST_Argument::Direction, AST_Decl*);
	virtual sal_Bool isPredefinedType(AST_Decl*);
	virtual sal_Bool lastAccess(AST_Argument::Direction, 
			     UTL_ScopeActiveIterator*);
  
	// create path of stub files:
	char *buildPath(const char *, char *, sal_Bool path);
  
	// formatting output:
	static void inc();
	static void dec();
	static UTL_Indenter *indent();
	static void indent(ostream& o);
  
private:
	void	checkDoku();

	char 		*namePref_;		// name prefix. :: notation.

	String			m_scope;
	::rtl::OUString	m_doku;
	const sal_Char* m_fullName;
};

#endif // _BE_DECL_BE_DECL_HXX
