/*************************************************************************
 *
 *  $RCSfile: burdgen.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <idl.hxx>

#include <iostream.h>
#include <fstream.h>
#include <sys/types.h>

#include <idlext.hxx>
#include "beurd.hxx"
#include "burdroot.hxx"

/*
 * Create a BE_PredefinedType node
 */
AST_PredefinedType *
BE_Generator::create_predefined_type(AST_PredefinedType::PredefinedType t,
										UTL_ScopedName *n,
										UTL_StrList *p)
{
	return (AST_PredefinedType *) new BE_PredefinedType(t, n, p);
}

/*
 * Create a BE_Object node
 */
AST_Object *
BE_Generator::create_object(UTL_ScopedName *n, UTL_StrList *p, char *name)
{
	return (AST_Object *) new BE_Object(n, p, name);
}

/*
 * Create a BE_Service node
 */
AST_Service *
BE_Generator::create_service(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Service *) new BE_Service(n, p);
}

/*
 * Create a BE_InterfaceMember node
 */
AST_InterfaceMember *
BE_Generator::create_interface_member(const sal_uInt16 fOptional, UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_InterfaceMember *) new BE_InterfaceMember(fOptional, n, p);
}

/*
 * Create a BE_ServiceMember node
 */
AST_ServiceMember *
BE_Generator::create_service_member(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_ServiceMember *) new BE_ServiceMember(n, p);
}

/*
 * Create a BE_Observes node
 */
AST_Observes *
BE_Generator::create_observes(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Observes *) new BE_Observes(n, p);
}

/*
 * Create a BE_Needs node
 */
AST_Needs *
BE_Generator::create_needs(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Needs *) new BE_Needs(n, p);
}

/*
 * Create a BE_Module node
 */
AST_Module *
BE_Generator::create_module(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Module *) new BE_Module(n, p);
}

/*
 * Create a BE_Constants node
 */
AST_Constants *
BE_Generator::create_constants(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Constants *) new BE_Constants(n, p);
}

/*
 * Create a BE_Mapping node
 */
AST_Mapping *
BE_Generator::create_mapping(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Mapping *) new BE_Mapping(n, p);
}

/*
 * Construct an AST_Root node (a node representing the root of an AST)
 */
AST_Root *
BE_Generator::create_root(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Root *) new BE_Root(n, p);
}

/*
 * Create a BE_Interface node
 */
AST_Interface *
BE_Generator::create_interface(UTL_ScopedName *n, AST_Interface **ih,
								long nih, UTL_StrList *p,
								char* uik, double ver, sal_Bool vrt, char* ident)
{
	return (AST_Interface *) new BE_Interface(n, ih, nih, p, uik, ver, vrt, ident);
}

/*
 * Create a BE_InterfaceFwd node
 */
AST_InterfaceFwd *
BE_Generator::create_interface_fwd(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_InterfaceFwd *) new BE_InterfaceFwd(n, p);
}

/*
 * Create a BE_Exception node
 */
AST_Exception *
BE_Generator::create_exception(UTL_ScopedName *n, AST_Exception **ih, 
								long nih, UTL_StrList *p)
{
	return (AST_Exception *) new BE_Exception(n, ih, nih, p);
}

/*
 * Create a BE_Structure node
 */
AST_Structure *
BE_Generator::create_structure(UTL_ScopedName *n, AST_Structure **ih, 
								long nih, UTL_StrList *p)
{
	return (AST_Structure*) new BE_Structure(n, ih, nih, p);
}

/*
 * Create a BE_Enum node
 */
AST_Enum *
BE_Generator::create_enum(UTL_ScopedName *n, UTL_StrList *p)
{
	return (AST_Enum *) new BE_Enum(n, p);
}

/*
 * Create a BE_Operation node
 */
AST_Operation *
BE_Generator::create_operation(AST_Type *rt,
								AST_Operation::Flags fl,
								IFlag ifl,	
								char* local,
								sal_Bool cons,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return (AST_Operation *) new BE_Operation(rt, fl, ifl, local, cons, n, p);
}

/*
 * Create a BE_Field node
 */
AST_Field *
BE_Generator::create_field(AST_Type *ft,
						   UTL_ScopedName *n, 
						   UTL_StrList *p)
{
	return (AST_Field *) new BE_Field(ft, n, p);
}

/*
 * Create a BE_Argument node
 */
AST_Argument *
BE_Generator::create_argument(AST_Argument::Direction d,
								AST_Type *ft,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return new BE_Argument(d, ft, n, p);
}

/*
 * Create a BE_Attribute node
 */
AST_Attribute *
BE_Generator::create_attribute(sal_uInt16 attrFlags,
								IFlag ifl,	
								AST_Type *ft,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return (AST_Attribute *) new BE_Attribute(attrFlags, ifl, ft, n, p);
}

/*
 * Create a BE_Union node
 */
AST_Union *
BE_Generator::create_union(AST_ConcreteType *dt,
							UTL_ScopedName *n,
							UTL_StrList *p)
{
//	notImpl();
	return (AST_Union *) new BE_Union(dt, n, p);
}

/*
 * Create a BE_UnionBranch node
 */
AST_UnionBranch *
BE_Generator::create_union_branch(AST_UnionLabel *lab,
									AST_Type *ft,
									UTL_ScopedName *n,
									UTL_StrList *p)
{
//	notImpl();
	return (AST_UnionBranch *) new BE_UnionBranch(lab, ft, n, p);
}

/*
 * Create a BE_UnionLabel node
 */
AST_UnionLabel *
BE_Generator::create_union_label(AST_UnionLabel::UnionLabel ul,
									AST_Expression *lv)
{
//	notImpl();
	return (AST_UnionLabel *) new BE_UnionLabel(ul, lv);
}

/*
 * Create a BE_Constant node
 */
AST_Constant *
BE_Generator::create_constant(AST_Expression::ExprType et,
								AST_Expression *ev,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return (AST_Constant *) new BE_Constant(et, ev, n, p);
}

/*
 * Create a symbolic BE_Expression node
 */
AST_Expression *
BE_Generator::create_expr(UTL_ScopedName *n)
{
	return (AST_Expression *) new BE_ExprVal(n);
}

/*
 * Create a BE_Expression node denoting a coercion
 */
AST_Expression *
BE_Generator::create_expr(AST_Expression *b, AST_Expression::ExprType t)
{
	return (AST_Expression *) new BE_ExprVal(b, t);
}

/*
 * Create a BE_Expression node combining two other AST_Expression nodes
 */
AST_Expression *
BE_Generator::create_expr(AST_Expression::ExprComb c,
							AST_Expression *v1,
							AST_Expression *v2)
{
	return (AST_Expression *) new BE_ExprVal(c, v1, v2);
}

/*
 * Create a BE_Expression node denoting a long integer
 */
AST_Expression *
BE_Generator::create_expr(long l)
{
	return (AST_Expression *) new BE_ExprVal(l);
}

/*
 * Create a BE_Expression node denoting a long integer being used as a boolean
 */
AST_Expression *
BE_Generator::create_expr(long l, AST_Expression::ExprType t)
{
	return (AST_Expression *) new BE_ExprVal(l, t);
}

/*
 * Create a BE_Expression node denoting an unsigned long integer
 */
AST_Expression *
BE_Generator::create_expr(unsigned long l)
{
	return (AST_Expression *) new BE_ExprVal(l);
}

/*
 * Create a BE_Expression node denoting a char * (encapsulated as a String)
 */
AST_Expression *
BE_Generator::create_expr(String *s)
{
	return (AST_Expression *) new BE_ExprVal(s);
}

/*
 * Create a BE_Expression node denoting a character
 */
AST_Expression *
BE_Generator::create_expr(char c)
{
	return (AST_Expression *) new BE_ExprVal(c);
}

/*
 * Create a BE_Expression node denoting a 64-bit floating point number
 */
AST_Expression *
BE_Generator::create_expr(double d)
{
	return (AST_Expression *) new BE_ExprVal(d);
}

/*
 * Create a BE_EnumVal node
 */
AST_EnumVal *
BE_Generator::create_enum_val(unsigned long v,
			      UTL_ScopedName *n,
			      UTL_StrList *p)
{
	return (AST_EnumVal *) new BE_EnumVal(v, n, p);
}

/*
 * Create a BE_Array node
 */
AST_Array *
BE_Generator::create_array(UTL_ScopedName *n,
			   unsigned long ndims,
			   UTL_ExprList *dims)
{
	return (AST_Array *) new BE_Array(n, ndims, dims);
}

/*
 * Create a BE_Sequence node
 */
AST_Sequence *
BE_Generator::create_sequence(AST_Expression *v, AST_Type *bt)
{
	return (AST_Sequence *) new BE_Sequence(v, bt);
}

/*
 * Create a BE_String node
 */
AST_String *
BE_Generator::create_string(AST_Expression *v)
{
	return (AST_String *) new BE_String(v);
}

/*
 * Create a BE_Typedef node
 */
AST_Typedef *
BE_Generator::create_typedef(AST_Type *bt, UTL_ScopedName *n, UTL_StrList *p)
{
	return new BE_Typedef(bt, n, p);
}
