/*************************************************************************
 *
 *  $RCSfile: burdgen.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _BE_GENERATOR_HXX
#define _BE_GENERATOR_HXX



class BE_Generator 
	:	public AST_Generator 
{
public:
	// Constructor
	BE_Generator() {}
	~BE_Generator() {}

	// Operations
	virtual AST_PredefinedType
	*create_predefined_type(AST_PredefinedType::PredefinedType t,
			  UTL_ScopedName *n,
			  UTL_StrList *p);

	virtual AST_Object	*create_object(UTL_ScopedName *n, UTL_StrList *p, char *name);

	virtual AST_Service	*create_service(UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_InterfaceMember	*create_interface_member(const sal_uInt16 fOptional, UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_ServiceMember	*create_service_member(UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_Observes	*create_observes(UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_Needs	*create_needs(UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_Module	*create_module(UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_Constants	*create_constants(UTL_ScopedName *n, UTL_StrList *p);

	virtual AST_Mapping	*create_mapping(UTL_ScopedName *n, UTL_StrList *p);
  
	virtual AST_Root	*create_root(UTL_ScopedName *n, UTL_StrList *p);  
  
	virtual AST_Interface	*create_interface(UTL_ScopedName *n, AST_Interface **ih,
					long nih, UTL_StrList *p,
					char* uik, double version, sal_Bool vrt, char* ident);
	virtual AST_InterfaceFwd *create_interface_fwd(UTL_ScopedName *n,
					UTL_StrList *p);
	virtual AST_Exception	*create_exception(UTL_ScopedName *n, 
					AST_Exception **ih, long nih, UTL_StrList *p);
	virtual AST_Structure	*create_structure(UTL_ScopedName *n, 
					AST_Structure **ih, long nih, UTL_StrList *p);
	virtual AST_Enum	*create_enum(UTL_ScopedName *n, UTL_StrList *p);
	virtual AST_Operation	*create_operation(AST_Type *rt,
					AST_Operation::Flags fl,
					IFlag ifl,
					char* local,
					sal_Bool cons, 
					UTL_ScopedName *n,
					UTL_StrList *p);
	virtual AST_Field	*create_field(AST_Type *ft, 
					UTL_ScopedName *n,
				    UTL_StrList *p);
	virtual AST_Argument	*create_argument(AST_Argument::Direction d,
					AST_Type *ft,
					UTL_ScopedName *n,
					UTL_StrList *p);
	virtual AST_Attribute	*create_attribute(sal_uInt16 attrFlags,
					IFlag ifl,
					AST_Type *ft,
					UTL_ScopedName *n,
					UTL_StrList *p);
	virtual AST_Union	*create_union(AST_ConcreteType *dt,
				    UTL_ScopedName *n,
				    UTL_StrList *p);
	virtual AST_UnionBranch *create_union_branch(AST_UnionLabel *lab,
					AST_Type *ft,
					UTL_ScopedName *n,
					UTL_StrList *p);
	virtual AST_UnionLabel *create_union_label(AST_UnionLabel::UnionLabel ul,
				    AST_Expression *lv);
	virtual AST_Constant	*create_constant(AST_Expression::ExprType et,
					AST_Expression *ev,
					UTL_ScopedName *n,
					UTL_StrList *p);
  
	virtual AST_Expression	*create_expr(UTL_ScopedName *n);
	virtual AST_Expression	*create_expr(AST_Expression *v,
					AST_Expression::ExprType t);
	virtual AST_Expression	*create_expr(AST_Expression::ExprComb c,
					AST_Expression *v1,
					AST_Expression *v2);
	virtual AST_Expression	*create_expr(long v);
	virtual AST_Expression	*create_expr(long v,
					AST_Expression::ExprType t);
	virtual AST_Expression	*create_expr(unsigned long v);
	virtual AST_Expression	*create_expr(String *s);
	virtual AST_Expression	*create_expr(char c);
	virtual AST_Expression	*create_expr(double d);
  
	virtual AST_EnumVal	*create_enum_val(unsigned long v,
					UTL_ScopedName *n,
					UTL_StrList *p);
	virtual AST_Array	*create_array(UTL_ScopedName *n,
					unsigned long ndims,
					UTL_ExprList *dims);
	virtual AST_Sequence	*create_sequence(AST_Expression *v, AST_Type *bt);
	virtual AST_String	*create_string(AST_Expression *v);
	virtual AST_Typedef	*create_typedef(AST_Type *bt,
					UTL_ScopedName *n,
					UTL_StrList *p);
};

#endif	// _BE_GENERATOR_HXX
