/*************************************************************************
 *
 *  $RCSfile: burdinit.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <idl.hxx>

#include <iostream.h>
#include <fstream.h>
#include <sys/types.h>

#include <idlext.hxx>
#include "beurd.hxx"

/*
 * Initialize the BE. The protocol requires only that this routine
 * return an instance of AST_Generator (or a subclass thereof).
 *
 * Remember that none of the FE initialization has been done, when you
 * add stuff here.
 */

//IDL_Global* IDL_Global::idl_global() = NULL;

AST_Generator* UNOIDL_CALLTYPE BE_init() 
{
	AST_Generator	*g = new BE_Generator();

	if (g == NULL) 
	{
		fprintf(stderr, "%s: Reflection Data Backend init failed to create generator, exiting\n\n"
			   "\nStarDivision (R) UNO-IDL Compiler Version 1.0"
			   "\nCopyright (C) StarDivision GmbH 1997. All rights reserved\n\n",
			   IDL_Global::idl_global()->prog_name());
		exit(99);
	}

	return g;
}

/*
 * Print out a version string for the BE
 */
void UNOIDL_CALLTYPE BE_version() 
{
	fprintf(stderr, "%s\nStarDivision (R) UNO-IDL Compiler Version 1.0"
		   "\nCopyright (C) StarDivision GmbH 1997. All rights reserved\n"
		   "IDL Reflection Data Backend Generator, version 1.0\n",
		   IDL_Global::idl_global()->prog_name());
}
