/*************************************************************************
 *
 *  $RCSfile: burdutil.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <idl.hxx>
#include <idlext.hxx>
#include "beurd.hxx"

#if STLPORT_VERSION>=321
#include <cstdarg>
#endif

#include <stdio.h>

sal_Bool coreOnly = sal_False;

UTL_NList   gAddIncludes;

// Not implemented feature:
//
void notImpl(char *msg ...)
{
	va_list args;
	va_start(args, msg);

	fprintf(stderr, "Not implemented: ");
	vfprintf(stderr, msg, args);
	fprintf(stderr, ".\n");
	va_end(args);
	abort();
	exit(1);
}

void notImpl()
{
	fprintf(stderr, "UNO union type not yet implemented. Sorry!\n");
	exit(1);
}

// fatal internal error:
//
void internal(char *msg ...)
{
	va_list args;
	va_start(args, msg);

	fprintf(stderr, "Unoidl INTERNAL ERROR: ");
	vfprintf(stderr, msg, args);
	fprintf(stderr, ".\n");
	va_end(args);
	abort();
}

// fatal programmer error:
//
void programmer(char *msg ...)
{
	va_list args;
	va_start(args, msg);	

	fprintf(stderr, "Unoidl ERROR: ");
	vfprintf(stderr, msg, args);
	fprintf(stderr, ".\n");
	va_end(args);
	exit(1);
}

// recoverable internal or external error:
//
void warning(char *msg ...)
{
	va_list args;
	va_start(args, msg);

	fprintf(stderr, "Unoidl WARNING: ");
	vfprintf(stderr, msg, args);
	fprintf(stderr, ".\n");
	va_end(args);
}


String getScopeName(String* file)
{
    char       *n = NULL;
    char 	   sn[1024];	
	long       l;
	String	   ret("");	

	if (file != NULL)
	{
		 n = (char*)file->getStr();
	} else
		return(ret);
	
    if (n == NULL)
    	return(ret);
		
    l = strlen(n);
    for (n += l; l > 0 && !((*n == '\\') || (*n == '/')); l--, n--)
	{
	}

    if ((*n == '\\') || (*n == '/')) n++;

	strncpy(sn, n, strlen(n) - 4);
	sn[strlen(n)-4]='\0';
    return(ret = ret + sn);
}

	 
