/*************************************************************************
 *
 *  $RCSfile: burdutil.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _BE_UTIL_HXX
#define _BE_UTIL_HXX


// --------------------- General -----------------------------------------------
#define UCR_SUFFIX		".ucr"				// suffix for UCR files	
#define URD_SUFFIX		".urd"				// suffix for URD files	
// -----------------------------------------------------------------------------

extern sal_Bool coreOnly; // generate corereflection data only


void notImpl(char *msg ...);				// "not implemented yet" error.
void notImpl();
void internal(char *msg ...);				// internal error.
void programmer(char *msg ...);				// programmer mistake.
void warning(char *msg ...);				// warning.

String getScopeName(String* file);

// --------------------- Generic Lists -----------------------------------------

class AddInclElem
	:	public UTL_NListElem 
{
public:
	AddInclElem(char *i): incl_(i){};
	int compare(const class UTL_NListElem *){ abort(); return 0;};
	class UTL_NListElem *clone(){ return (UTL_NListElem*)new AddInclElem(*this); };
	char *incl_;
};

class ObjectIncludeElem
	:	public UTL_NListElem 
{
public:
	ObjectIncludeElem(char *str): str_(str){};
	int compare(const class UTL_NListElem *){ abort(); return 0;};
	class UTL_NListElem *clone(){ return (UTL_NListElem*)new ObjectIncludeElem(*this); };
	char *str_;
};

#endif //_BE_UTIL_HXX
