#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..

PRJNAME=unoidl
TARGET=beurd

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

#.IF "$(GUI)"=="UNX"
#CFLAGS += -instances=extern -template=wholeclass -ptr$(OBJ)
#LINKFLAGS += -temp=/tmp -PIC -instances=extern -ptr$(OBJ)
#.ENDIF

# --- Files --------------------------------------------------------
CDEFS += -DDLL_VERSION=\"$(UPD)$(DLLPOSTFIX)\"

CXXFILES=	\
            burdargs.cxx   \
			burdclas.cxx	\
			burddecl.cxx	\
			burdgen.cxx	\
			burdhead.cxx	\
			burdinit.cxx	\
			burdprod.cxx	\
			burdroot.cxx	\
			burdutil.cxx

SLOFILES=   \
			$(SLO)$/burdargs.obj	\
			$(SLO)$/burdclas.obj	\
			$(SLO)$/burddecl.obj	\
			$(SLO)$/burdgen.obj	\
			$(SLO)$/burdhead.obj	\
			$(SLO)$/burdinit.obj	\
			$(SLO)$/burdprod.obj	\
			$(SLO)$/burdroot.obj	\
			$(SLO)$/burdutil.obj

.IF "$(OS)$(CPU)" == "SOLARISS"
NOOPTFILES=   \
			$(SLO)$/burdargs.obj	\
			$(SLO)$/burdclas.obj	\
			$(SLO)$/burddecl.obj	\
			$(SLO)$/burdgen.obj	\
			$(SLO)$/burdhead.obj	\
			$(SLO)$/burdinit.obj	\
			$(SLO)$/burdprod.obj	\
			$(SLO)$/burdroot.obj	\
			$(SLO)$/burdutil.obj
.ENDIF

SHL1TARGET     =urd
SHL1IMPLIB     =urd
SHL1STDLIBS    =\
	$(UASLIB) \
	$(SALLIB) \
	$(VOSLIB) \
	$(STDLIBCPP)
	

.IF "$(GUI)" == "WNT"
SHL1STDLIBS    +=\
	$(LIBCMT) \
	$(LIBCIMT)
.ENDIF

#.IF "$(OS)" == "SOLARIS"
#SHL1STDLIBS    +=\
#	-lgen
#.ENDIF

SHL1DEPN       =$(LB)$/uas.lib
SHL1LIBS       =$(SLB)$/beurd.lib
SHL1DEF        =$(MISC)$/$(SHL1TARGET).def
.IF "$(GUI)" != "UNX"
SHL1OBJS       =$(SLO)$/burdargs.obj
.ENDIF

DEF1NAME		=$(SHL1TARGET)
DEF1DEPN		=$(MISC)$/$(SHL1TARGET).flt 
DEFLIB1NAME		=beurd
DEF1DES			=Uno BE Reflection data
.IF "$(COM)"!="ICC" || "$(GUI)"=="OS2"
DEF1EXPORT1		=BE_init @1000
DEF1EXPORT2		=BE_prep_arg @1001
DEF1EXPORT3		=BE_produce @1002
DEF1EXPORT4		=BE_abort @1003
DEF1EXPORT5		=BE_version @1004
.ELSE
DEF1EXPORT1		=_BE_init @1000
DEF1EXPORT2		=_BE_prep_arg @1001
DEF1EXPORT3		=_BE_produce @1002
DEF1EXPORT4		=_BE_abort @1003
DEF1EXPORT5		=_BE_version @1004
.ENDIF

# NETBSD: somewhere we have to instantiate the static data members.
# NETBSD-1.2.1 doesn't know about weak symbols so the default mechanism for GCC won't work.
# SCO and MACOSX: the linker does know about weak symbols, but we can't ignore multiple defined symbols
.IF "$(OS)"=="NETBSD" || "$(OS)"=="SCO" || "$(OS)$(COM)"=="OS2GCC" || "$(OS)"=="MACOSX"
SLOFILES+=$(SLO)$/staticmb.obj
OBJFILES+=$(OBJ)$/staticmb.obj
.ENDIF

.IF "$(depend)" == ""

# --- Targets ------------------------------------------------------
ALL:	\
		$(SLB)$/beurd.lib	\
		ALLTAR

.ENDIF


.INCLUDE :  target.mk


$(MISC)$/$(SHL1TARGET).flt: $(MISC)$/$(TARGET).dpc
		@echo Making $@
		@echo Impl > $@
		@echo BE >> $@
		@echo AST >> $@	
		@echo UTL >> $@
		@echo Server >> $@			
		@echo Client >> $@	
		@echo ase >> $@
		@echo Inc >> $@
		@echo Ident >> $@
		@echo int >> $@	
		@echo prog >> $@
		@echo warn >> $@
		@echo __alloc >> $@
		@echo __malloc >> $@
		@echo __stl >> $@
		@echo __lower_bound >> $@
		@echo _alloc >> $@
        @echo exception::exception>>$@		
		@echo Registry >> $@





