/*************************************************************************
 *
 *  $RCSfile: ast.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _AST_HXX_
#define _AST_HXX_



#ifndef _UTLSCPNA_HXX_
#include	<utlscpna.hxx>		// Define UTL_ScopedName
#endif
#ifndef _ASTDECL_HXX_
#include	<astdecl.hxx>		// class AST_Decl
#endif
#ifndef _ASTEXPR_HXX_
#include	<astexpr.hxx>		// class AST_Expression
#endif
#ifndef _UTLSCOPE_HXX_
#include	<utlscope.hxx>		// class UTL_Scope
#endif
#ifndef _ASTTYPE_HXX_
#include	<asttype.hxx>		// class AST_Type
#endif
#ifndef _ASTOBJ_HXX_
#include	<astobj.hxx>		// class AST_Object
#endif
#ifndef _ASTOBJMB_HXX_
#include	<astobjmb.hxx>		// class AST_ObjectMember
#endif
#ifndef _ASTCTYPE_HXX_
#include	<astctype.hxx>		// class AST_ConcreteType
#endif
#ifndef _ASTPTYPE_HXX_
#include	<astptype.hxx>		// class AST_PredefinedType
#endif
#ifndef _ASTMODUL_HXX_
#include	<astmodul.hxx>		// class AST_Module
#endif
#ifndef _ASTMAP_HXX_
#include	<astmap.hxx>		// class AST_Mapping
#endif
#ifndef _ASTROOT_HXX_
#include	<astroot.hxx>		// class AST_Root
#endif
#ifndef _ASTINTER_HXX_
#include	<astinter.hxx>		// class AST_Interface
#endif
#ifndef _ASTINTFW_HXX_
#include	<astintfw.hxx>		// class AST_InterfaceFwd
#endif
#ifndef _ASTSTRUC_HXX_
#include	<aststruc.hxx>		// class AST_Structure
#endif
#ifndef _ASTEXCEP_HXX_
#include	<astexcep.hxx>		// class AST_Exception
#endif
#ifndef _ASTENUM_HXX_
#include	<astenum.hxx>		// class AST_Enum
#endif
#ifndef _ASTOPER_HXX_
#include	<astoper.hxx>		// class AST_Operation
#endif
#ifndef _ASTFIELD_HXX_
#include	<astfield.hxx>		// class AST_Field
#endif
#ifndef _ASTARG_HXX_
#include	<astarg.hxx>		// class AST_Argument
#endif
#ifndef _ASTATTR_HXX_
#include	<astattr.hxx>		// class AST_Attribute
#endif
#ifndef _ASTUNION_HXX_
#include	<astunion.hxx>		// class AST_Union
#endif
#ifndef _ASTUBRAN_HXX_
#include	<astubran.hxx>		// class AST_UnionBranch
#endif
#ifndef _ASTULAB_HXX_
#include	<astulab.hxx>		// class AST_UnionLabel
#endif
#ifndef _ASTCONST_HXX_
#include	<astconst.hxx>		// class AST_Constant
#endif
#ifndef _ASTENVAL_HXX_
#include	<astenval.hxx>		// class AST_EnumVal
#endif
#ifndef _ASTARRAY_HXX_
#include	<astarray.hxx>		// class AST_Array
#endif
#ifndef _ASTSEQ_HXX_
#include	<astseq.hxx>		// class AST_Sequence
#endif
#ifndef _ASTSERV_HXX_
#include	<astserv.hxx>		// class AST_Service
#endif
#ifndef _ASTSTR_HXX_
#include	<aststr.hxx>		// class AST_String
#endif
#ifndef _ASTTDEF_HXX_
#include	<asttdef.hxx>		// class AST_Typedef 
#endif
#ifndef _UTLLIST_HXX_
#include	<utllist.hxx>		// class UTL_List
#endif
#ifndef _UTLSTRL_HXX_
#include	<utlstrl.hxx>		// class UTL_StrList
#endif
#ifndef _UTLEXPRL_HXX_
#include	<utlexprl.hxx>		// class UTL_ExprList
#endif
#ifndef _ASTGEN_HXX_
#include	<astgen.hxx>		// class AST_Generator
#endif

#endif	// _AST_HXX_

