/*************************************************************************
 *
 *  $RCSfile: astattr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTATTR_HXX_
#define _ASTATTR_HXX_

#ifndef _FEHEADS_HXX_
#include <feheads.hxx>
#endif

// Representation of attribute declaration:
//
// An attribute is a field with a readonly property

class AST_Attribute 
	:	public virtual AST_Field
{
public:
	// Define enum with flags for attributes

	// Operations

	// Constructor(s)
	AST_Attribute();
	AST_Attribute(sal_uInt32 attrFlags,
				  IFlag iflag,
				  AST_Type *ft,
				  UTL_ScopedName *n,
				  UTL_StrList *p);
	virtual ~AST_Attribute() {}

	// Data Accessors
	const sal_Bool isReadonly()
		{ return ((m_flags & AF_READONLY) == AF_READONLY); }
	const sal_Bool isOptional()
		{ return ((m_flags & AF_OPTIONAL) == AF_OPTIONAL); }
	const sal_Bool isAttribute()
		{ return ((m_flags & AF_ATTRIBUTE) == AF_ATTRIBUTE); }
	const sal_Bool isProperty()
		{ return ((m_flags & AF_PROPERTY) == AF_PROPERTY); }
	const sal_Bool isBound()
		{ return ((m_flags & AF_BOUND) == AF_BOUND); }
	const sal_Bool isMayBeVoid()
		{ return ((m_flags & AF_MAYBEVOID) == AF_MAYBEVOID); }
	const sal_Bool isConstrained()
		{ return ((m_flags & AF_CONSTRAINED) == AF_CONSTRAINED); }
	const sal_Bool isTransient()
		{ return ((m_flags & AF_TRANSIENT) == AF_TRANSIENT); }
	const sal_Bool isMayBeAmbiguous()
		{ return ((m_flags & AF_MAYBEAMBIGUOUS) == AF_MAYBEAMBIGUOUS); }
	const sal_Bool isMayBeDefault()
		{ return ((m_flags & AF_MAYBEDEFAULT) == AF_MAYBEDEFAULT); }
	const sal_Bool isRemoveable()
		{ return ((m_flags & AF_REMOVEABLE) == AF_REMOVEABLE); }

	const sal_Bool isLocal();
	String& local();
	IFlag iflag();

	// Narrowing
	DEF_NARROW_METHODS1(AST_Attribute, AST_Field);
	DEF_NARROW_FROM_DECL(AST_Attribute);

	// AST Dumping
	virtual void	dump(ostream &o);

private:
	// Data
	const sal_uInt32 	m_flags;
	const sal_Bool		m_isLocal;
	const String		m_local;
	IFlag				m_iflag;
};

#endif	// _ASTATTR_HXX_

