/*************************************************************************
 *
 *  $RCSfile: astenum.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTENUM_HXX_
#define _ASTENUM_HXX_



class AST_Enum 
	:	public virtual AST_ConcreteType, 
		public virtual UTL_Scope
{
public:
	// Operations

	// Constructor(s)
	AST_Enum();
	AST_Enum(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_Enum() {}

	// Narrowing
	DEF_NARROW_METHODS2(AST_Enum, AST_ConcreteType, UTL_Scope);
	DEF_NARROW_FROM_DECL(AST_Enum);
	DEF_NARROW_FROM_SCOPE(AST_Enum);

	// AST Dumping
	virtual void	dump(ostream &);

	// Other operations

	// Look up an AST_EnumVal by value
	virtual AST_EnumVal		*lookup_by_value(const AST_Expression *v);

	// Check up an AST_EnumVal by value
	virtual AST_EnumVal		*check_value(AST_Expression *v);

	// Get value to be assigned to next enumerator
	void				setEnumVal(unsigned long count) { pd_enum_counter = count; }
	unsigned long		next_enum_val() { return(pd_enum_counter++); }

private:
	// Data
	unsigned long			pd_enum_counter;	// Value for next
							// enumerator
	// Scope management
	friend int yyparse();
	virtual AST_EnumVal		*fe_add_enum_val(AST_EnumVal	*v);
};

#endif	// _ASTENUM_HXX_

