/*************************************************************************
 *
 *  $RCSfile: astexcep.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTEXCEP_HXX_
#define _ASTEXCEP_HXX_



class AST_Exception 
	:	public virtual AST_Structure
{
public:
	// Operations

	// Constructor(s)
	AST_Exception();
	AST_Exception(UTL_ScopedName *n, AST_Exception **ih,
							 long nih, UTL_StrList *p);
	virtual ~AST_Exception() {}

	// Data Accessors
	AST_Exception	**inherits() { return(m_inherits); }
	void set_inherits(AST_Exception **i) { m_inherits = i; }
	long n_inherits() { return(m_n_inherits); }
	void set_n_inherits(long i) { m_n_inherits = i; }

	// Narrowing
	DEF_NARROW_METHODS1(AST_Exception, AST_Structure);
	DEF_NARROW_FROM_DECL(AST_Exception);
	DEF_NARROW_FROM_SCOPE(AST_Exception);

	// AST Dumping
	virtual void	dump(ostream &o);

private:
	// Data
	AST_Exception	**m_inherits;	// Inherited exceptions
									// This is an array of pointers
									// to the inherited exceptions
	long			m_n_inherits;	// How many of them?

	friend int yyparse();
	// Scope Management Protocol

	virtual AST_Field		*fe_add_field(AST_Field		*f);
	virtual AST_Union		*fe_add_union(AST_Union		*u);
	virtual AST_Structure	*fe_add_structure(AST_Structure	*s);
	virtual AST_Enum		*fe_add_enum(AST_Enum		*e);
	virtual AST_EnumVal		*fe_add_enum_val(AST_EnumVal	*v);
};

#endif	// _ASTEXCEP_HXX_

