/*************************************************************************
 *
 *  $RCSfile: astmap.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTMAP_HXX_
#define _ASTMAP_HXX_



class AST_Mapping 
	:	public virtual AST_Decl, 
		public virtual UTL_Scope
{
public:
	// Operations

	// Constructor(s)
	AST_Mapping();
	AST_Mapping(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_Mapping() {}

	// Narrowing
	DEF_NARROW_METHODS2(AST_Mapping, AST_Decl, UTL_Scope);
	DEF_NARROW_FROM_DECL(AST_Mapping);
	DEF_NARROW_FROM_SCOPE(AST_Mapping);

	// AST Dumping
	virtual void			dump(ostream &o);

private:

	// Scope Management Protocol

	virtual AST_PredefinedType	*fe_add_predefined_type(AST_PredefinedType *t);
	virtual AST_Object			*fe_add_object(AST_Object *cl);
	virtual AST_Service			*fe_add_service(AST_Service *sm);
	virtual AST_Observes		*fe_add_observes(AST_Observes *obm);
	virtual AST_Needs			*fe_add_needs(AST_Needs *nm);
	virtual AST_Module			*fe_add_module(AST_Module *m);
	virtual AST_Constants		*fe_add_constants(AST_Constants *c);
	virtual AST_Interface		*fe_add_interface(AST_Interface	*i);
	virtual AST_InterfaceFwd	*fe_add_interface_fwd(AST_InterfaceFwd *i);
	virtual AST_Constant		*fe_add_constant(AST_Constant *c);
	virtual AST_Exception		*fe_add_exception(AST_Exception *e);
	virtual AST_Union			*fe_add_union(AST_Union	*u);
	virtual AST_Structure		*fe_add_structure(AST_Structure	*s);
	virtual AST_Enum			*fe_add_enum(AST_Enum *e);
	virtual AST_EnumVal			*fe_add_enum_val(AST_EnumVal *v);
	virtual AST_Typedef			*fe_add_typedef(AST_Typedef *t);
};



class AST_Language 
	:	public virtual AST_Decl, 
		public virtual UTL_Scope
{
public:
	// Operations

	// Constructor(s)
	AST_Language();
	AST_Language(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_Language() {}

	// Narrowing
	DEF_NARROW_METHODS2(AST_Language, AST_Decl, UTL_Scope);
	DEF_NARROW_FROM_DECL(AST_Language);
	DEF_NARROW_FROM_SCOPE(AST_Language);
};

#endif	// _ASTMAP_HXX_

