/*************************************************************************
 *
 *  $RCSfile: astobj.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTOBJ_HXX_
#define _ASTOBJ_HXX_



class AST_Object 
	:	public virtual AST_Decl, 
		public virtual UTL_Scope
{
public:
	// Operations

	// Constructor(s)
	AST_Object();
	AST_Object(UTL_ScopedName *n, UTL_StrList *p, char *name);
	virtual ~AST_Object(); // {}

	// Narrowing
	DEF_NARROW_METHODS2(AST_Object, AST_Decl, UTL_Scope);
	DEF_NARROW_FROM_DECL(AST_Object);
	DEF_NARROW_FROM_SCOPE(AST_Object);

	// AST Dumping
	virtual void	dump(ostream &o);

	char* get_name();
	void set_name(char* name);

	// help function
	AST_Decl* check_for_add(AST_Decl *m);
	sal_Bool checkExport();

private:

	// Scope Management Protocol
	virtual AST_InterfaceMember	*fe_add_interface_member(AST_InterfaceMember *olm);
	virtual AST_ServiceMember	*fe_add_service_member(AST_ServiceMember *sm);
	virtual AST_Observes		*fe_add_observes(AST_Observes *obm);
	virtual AST_Needs			*fe_add_needs(AST_Needs *nm);
	virtual AST_Attribute		*fe_add_attribute(AST_Attribute	*a);

	// Data
	char*	pd_object_name;
};

#endif	// _ASTOBJ_HXX_

