/*************************************************************************
 *
 *  $RCSfile: astobjmb.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTOBJMB_HXX_
#define _ASTOBJMB_HXX_


#ifndef _IDLFWD_HXX_
#include	<idlfwd.hxx>
#endif
#ifndef _IDLNRW_HXX_
#include	<idlnrw.hxx>
#endif
#ifndef _ASTDECL_HXX_
#include	<astdecl.hxx>
#endif

#ifndef _FEHEADS_HXX_
#include	<feheads.hxx>
#endif

/*
 * AST_InterfaceMember
 */
class AST_InterfaceMember 
	:	public virtual AST_Decl
{
public:
	// Operations

	// Constructor(s)
	AST_InterfaceMember();
	AST_InterfaceMember(const sal_uInt16 fOptional, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_InterfaceMember() {}

	// Data Accessors
	void setInterface(AST_Interface *inter);
	AST_Interface* getInterface();

	const sal_uInt16 getOptional() 
		{ return (m_optionalFlag & AF_OPTIONAL); }

	// Narrowing
	DEF_NARROW_METHODS1(AST_InterfaceMember, AST_Decl);
	DEF_NARROW_FROM_DECL(AST_InterfaceMember);

	// AST Dumping
	virtual void	dump(ostream &o);

protected:
	const sal_uInt16	 m_optionalFlag;
	AST_Interface		*m_realInterface;
};


/*
 * AST_ServiceMember
 */
class AST_ServiceMember 
	:	public virtual AST_Decl
{
public:
	// Operations

	// Constructor(s)
	AST_ServiceMember();
	AST_ServiceMember(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_ServiceMember() {}

	// Data Accessors
	void setService(AST_Service *serv);
	AST_Service* getService();

	// Narrowing
	DEF_NARROW_METHODS1(AST_ServiceMember, AST_Decl);
	DEF_NARROW_FROM_DECL(AST_ServiceMember);

	// AST Dumping
	virtual void	dump(ostream &o);
protected:
	AST_Service 	*m_realService;
};


/*
 * AST_Observes
 */
class AST_Observes 
	:	public virtual AST_Decl
{
public:
	// Operations

	// Constructor(s)
	AST_Observes();
	AST_Observes(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_Observes() {}

	// Data Accessors
	void setInterface(AST_Interface *serv);
	AST_Interface* getInterface();

	// Narrowing
	DEF_NARROW_METHODS1(AST_Observes, AST_Decl);
	DEF_NARROW_FROM_DECL(AST_Observes);

	// AST Dumping
	virtual void	dump(ostream &o);
protected:
	AST_Interface		*m_realInterface;
};


/*
 * AST_Needs
 */
class AST_Needs 
	:	public virtual AST_Decl
{
public:
	// Operations

	// Constructor(s)
	AST_Needs();
	AST_Needs(UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_Needs() {}

	// Data Accessors
	void setService(AST_Service *contr);
	AST_Service* getService();

	// Narrowing
	DEF_NARROW_METHODS1(AST_Needs, AST_Decl);
	DEF_NARROW_FROM_DECL(AST_Needs);

	// AST Dumping
	virtual void	dump(ostream &o);
protected:
	AST_Service	*m_realService;
};

#endif	// _ASTOBJMB_HXX_

