/*************************************************************************
 *
 *  $RCSfile: astoper.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTOPER_HXX_
#define _ASTOPER_HXX_


#ifndef _IDLFWD_HXX_
#include	<idlfwd.hxx>
#endif
#ifndef _IDLNRW_HXX_
#include	<idlnrw.hxx>
#endif
#ifndef _UTLLIST_HXX_
#include	<utllist.hxx>
#endif
#ifndef _ASTDECL_HXX_
#include	<astdecl.hxx>
#endif
#ifndef _UTLSCOPE_HXX_
#include	<utlscope.hxx>
#endif
#ifndef _UTLSCPNA_HXX_
#include	<utlscpna.hxx>
#endif

class AST_Operation 
	:	public virtual AST_Decl, 
		public virtual UTL_Scope
{
public:
	// Define enum with flags for operation attributes
	enum Flags 
	{
		OP_noflags,		// No flags present
		OP_oneway,		// Operation is oneway
		OP_idempotent		// Operation is idempotent
	};

	// Operations

	// Constructor(s)
	AST_Operation();
	AST_Operation(AST_Type *return_type,
				Flags flags,
				IFlag iflag,
				char* local,
				sal_Bool cons,
				UTL_ScopedName *n,
				UTL_StrList *p);
	virtual ~AST_Operation(); // {}

	// Data Accessors
	AST_Type *return_type();
	Flags flags();
	IFlag iflag();
	char* local();
	sal_Bool isConst();
	UTL_StrList *context();
	UTL_ExceptList *exceptions();
  
	// Narrowing
	DEF_NARROW_METHODS2(AST_Operation, AST_Decl, UTL_Scope);
	DEF_NARROW_FROM_DECL(AST_Operation);
	DEF_NARROW_FROM_SCOPE(AST_Operation);

	// AST Dumping
	virtual void	dump(ostream &o);

private:

	// Data
	AST_Type		*pd_return_type;	// Return type
	Flags			pd_flags;			// Operation flags
	IFlag			pd_iflag;
	char			*pd_local;
	sal_Bool		pd_const;
	UTL_StrList		*pd_context;		// Context
	UTL_ExceptList	*pd_exceptions;		// Exceptions raised

	// Scope Management Protocol
	friend int yyparse();

	virtual AST_Argument	*fe_add_argument(AST_Argument	*a);
	virtual UTL_StrList		*fe_add_context(UTL_StrList 	*c);	
							// Add context
	virtual UTL_NameList	*fe_add_exceptions(UTL_NameList *e);
							// exceptions
};

#endif	// _ASTOPER_HXX_

