/*************************************************************************
 *
 *  $RCSfile: astptype.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTPTYPE_HXX_
#define _ASTPTYPE_HXX_



class AST_PredefinedType 
	:	public virtual AST_ConcreteType
{
public:
	// Enum for all the different predefined types
	enum PredefinedType 
	{
		PT_long,		// Predefined type "long"
		PT_ulong,		// Predefined type "unsigned long"
		PT_hyper,		// Predefined Type "hyper"
		PT_uhyper,		// Predefined Type "unsigned hyper" 
		PT_longlong,	// Predefined type "long long"
		PT_ulonglong,	// Predefined type "unsigned long long"
		PT_short,		// Predefined type "short"
		PT_ushort,		// Predefined type "unsigned short"
		PT_float,		// Predefined type "float"
		PT_double,		// Predefined type "double"
		PT_longdouble,	// Predefined type "long double"
		PT_char,		// Predefined type "char"
		PT_wchar,		// Predefined type "wchar_t"
		PT_boolean,		// Predefined type "boolean"
		PT_octet,		// Predefined type "octet"
		PT_byte,		// Predefined type "byte"
		PT_any,			// Predefined type "any"
		PT_void,		// Predefined type "void"
		PT_type,		// Predefined type "type"
		PT_implementation, // Predefined type "implementation"
		PT_pseudo		// Predefined type for pseudo objects
	};

	// Operations

	// Constructor(s)
	AST_PredefinedType();
	AST_PredefinedType(PredefinedType t, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_PredefinedType() {}

	// Data Accessors
	const PredefinedType	pt();

	// Narrowing
	DEF_NARROW_METHODS1(AST_PredefinedType, AST_ConcreteType);
	DEF_NARROW_FROM_DECL(AST_PredefinedType);

	// AST Dumping
	virtual void	dump(ostream &o);

private:
	// Data
	const PredefinedType	pd_pt;		// The specific predefined type
};  

#endif	// _ASTPTYPE_HXX_

