/*************************************************************************
 *
 *  $RCSfile: astunion.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ASTUNION_HXX_
#define _ASTUNION_HXX_



class AST_Union 
	:	public virtual AST_Structure
{
public:
	// Operations

	// Constructor(s)
	AST_Union();
	AST_Union(AST_ConcreteType *disc_type, UTL_ScopedName *n, UTL_StrList *p);
	virtual ~AST_Union() {}

	// Data Accessors
	AST_ConcreteType *disc_type();
	AST_Expression::ExprType udisc_type();

	// Narrowing
	DEF_NARROW_METHODS1(AST_Union, AST_Structure);
	DEF_NARROW_FROM_DECL(AST_Union);
	DEF_NARROW_FROM_SCOPE(AST_Union);

	// AST Dumping
	virtual void	dump(ostream &);

private:
	// Data
	AST_ConcreteType		*pd_disc_type;	// Discriminator type
	AST_Expression::ExprType	pd_udisc_type;	// Its expression type
	/* Convention: udisc_type == EV_any denotes an enum value */

	// Operations

	// Look up a branch by node pointer
	AST_UnionBranch		*lookup_branch(AST_UnionBranch *branch);

	// Look up the branch with the "default" label
	AST_UnionBranch		*lookup_default();

	// Look up a branch given a branch with a label. This is used to
	// check for duplicate labels
	AST_UnionBranch		*lookup_label(AST_UnionBranch *b);

	// Look up a union branch given an enumerator. This is used to
	// check for duplicate enum labels
	AST_UnionBranch		*lookup_enum(AST_UnionBranch *b);

private:
	friend int yyparse();
	// Scope Management Protocol

	virtual AST_Union			*fe_add_union(AST_Union	*u);
	virtual AST_UnionBranch		*fe_add_union_branch(AST_UnionBranch *b);
	virtual AST_Structure		*fe_add_structure(AST_Structure	*s);
	virtual AST_Enum			*fe_add_enum(AST_Enum *e);
	virtual AST_EnumVal			*fe_add_enum_val(AST_EnumVal *v);
};

#endif	// _ASTUNION_HXX_

