/*************************************************************************
 *
 *  $RCSfile: drvlink.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DRVLINK_HXX_
#define _DRVLINK_HXX_


#ifndef _IDLDEFS_HXX_
#include <idldefs.hxx>
#endif

/*
 * Front end interface
 */
#if defined(WIN32) || defined(__OS2__) || defined(WNT)

#else
class File;
#endif

typedef void (* DRV_PF_FE_init_stage1)();
typedef void (* DRV_PF_FE_init_stage2)();
typedef int  (* DRV_PF_FE_yyparse)();
//typedef void (* DRV_PF_FE_set_yyin)(File *);
typedef void (* DRV_PF_FE_set_yyin)(File *, char *);

class UTL_Error;
class UTL_Indenter;
class UTL_String;
typedef UTL_Error * (* DRV_PF_FE_new_UTL_Error)();
typedef UTL_Indenter * (* DRV_PF_FE_new_UTL_Indenter)();
typedef UTL_String * (* DRV_PF_FE_new_UTL_String)(char *);

extern DRV_PF_FE_init_stage1             DRV_FE_init_stage1;
extern DRV_PF_FE_init_stage2             DRV_FE_init_stage2;
extern DRV_PF_FE_yyparse                 DRV_FE_yyparse;
extern DRV_PF_FE_set_yyin                DRV_FE_set_yyin;

extern DRV_PF_FE_new_UTL_Error           DRV_FE_new_UTL_Error;
extern DRV_PF_FE_new_UTL_Indenter        DRV_FE_new_UTL_Indenter;
extern DRV_PF_FE_new_UTL_String          DRV_FE_new_UTL_String;

/*
 * Back end interface
 */

class AST_Generator;
typedef AST_Generator * (UNOIDL_CALLTYPE *DRV_PF_BE_init)();
typedef void (UNOIDL_CALLTYPE *DRV_PF_BE_produce)();
typedef void (UNOIDL_CALLTYPE *DRV_PF_BE_abort)();
typedef void (UNOIDL_CALLTYPE *DRV_PF_BE_prep_arg)(char *, sal_Bool);
typedef void (UNOIDL_CALLTYPE *DRV_PF_BE_version)();

extern DRV_PF_BE_init                    DRV_BE_init;
extern DRV_PF_BE_produce                 DRV_BE_produce;
extern DRV_PF_BE_abort                   DRV_BE_abort;
extern DRV_PF_BE_prep_arg                DRV_BE_prep_arg;
extern DRV_PF_BE_version                 DRV_BE_version;

// Functions

extern void DRV_FE_open();
extern void DRV_FE_close();

extern void DRV_BE_open();
extern void DRV_BE_close();


#endif	// _DRVLINK_HXX_

