/*************************************************************************
 *
 *  $RCSfile: fedecl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _FEDECL_HXX_
#define _FEDECL_HXX_



class FE_Declarator
{
public:
	// Enum to denote types of declarators
	enum DeclaratorType 
	{
		FD_simple,		// Simple declarator
		FD_complex		// Complex declarator (complex_part field used)
	};

	// Operations

	// Constructor(s)
	FE_Declarator(UTL_ScopedName *n, DeclaratorType dt, AST_Decl *cp);
	virtual ~FE_Declarator(); // {}

	// Data Accessors
	AST_Decl *complex_part();
	UTL_ScopedName *name();
	DeclaratorType decl_type();
	// Other Operations

	sal_Bool checkType(AST_Decl *type);

	// Compose an FE_Declarator into an AST_Type once all the needed information
	// is available
	AST_Type		*compose(AST_Decl* tc);

private:
	// Data
	AST_Decl		*pd_complex_part;	// If a complex declarator
	UTL_ScopedName	*pd_name;			// The name if complex
	DeclaratorType	pd_decl_type;		// Whether complex or simple
};

class FE_FieldInfo
{
public:
	// Operations

	// Constructor(s)
	FE_FieldInfo(sal_Bool type, char *index);
	virtual ~FE_FieldInfo(); 

	// Data Accessors
	const sal_Bool index_type();
	char* index_name();

private:
	// Data
	const sal_Bool	pd_index_type;		// Whether length=FALSE or size=TRUE
	char			*pd_index_name;
};

#endif	// _FEDECL_HXX_

