/*************************************************************************
 *
 *  $RCSfile: feextern.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _FE_EXTERN_FE_EXTERN_HXX
#define _FE_EXTERN_FE_EXTERN_HXX



// Functions:

// Initialization:
//
// FE initialization is done in two stages, with the BE initialization
// occurring in between. The first stage is responsible for creating
// the sope stack. The BE initialization creates the generator object
// which is then used in the second stage to create the global scope
// and to populate it with nodes for the predefined types

extern "C" void			FE_init_stage1();	// Initialize stage 1
extern "C" void			FE_init_stage2();	// Initialize stage 2

// Interface to Yacc parser

#if defined(WIN32) || defined(__OS2__) || defined(WNT)
#include <stdio.h>
typedef FILE File;
#else
class File;
#endif

extern "C" int		FE_yyparse();		// Invode yyparse
//extern "C" void		FE_set_yyin(FILE *);	// Set yyin
extern "C" void		FE_set_yyin(FILE *, char* tmp_file);	// Set yyin

// Interface to constructors for objects need by the driver

class UTL_Error;
class UTL_Indenter;

extern "C" UTL_Error *		FE_new_UTL_Error();
extern "C" UTL_Indenter *	FE_new_UTL_Indenter();
extern "C" String *  		FE_new_UTL_String(char *);

#endif	// _FE_EXTERN_FE_EXTERN_HXX

