/*************************************************************************
 *
 *  $RCSfile: idldefs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _IDL_DEFS_HXX_
#define _IDL_DEFS_HXX_


// use VOS types
#ifndef _VOS_TYPES_HXX_
#include <vos/types.hxx>
#endif
#ifndef _VOS_MACROS_HXX_
#include <vos/macros.hxx>
#endif

// use RTL strings
#ifdef String
#undef String
#endif

#ifndef _RTL_STRING_HXX_
#include <rtl/string.hxx>
#endif

#define String NAMESPACE_RTL(OString)
#define Identifier NAMESPACE_RTL(OString)


#include	<iostream.h>	// Standard IO library

SAL_DLLEXPORT ostream &operator<<(ostream& o, String*);
//ostream &operator<<(ostream& o, String);
SAL_DLLEXPORT ostream &operator<<(ostream& o, const String&);

#define UNOIDL_CALLTYPE	SAL_CALL


#define	GTDEVEL(s)		s

// needed in AST_attribute and AST_Operation
// for the optional implemtation flag
enum IFlag
{
	IFLAG_noflag,
	IFLAG_local
};

// This cannot be an enum since more than one value may be active at
// a given time, hence bitflags are #define'd instead
     
#define	IDL_CF_VERSION		(1 << 0)
#define	IDL_CF_DUMP_AST		(1 << 1)
#define	IDL_CF_ONLY_PREPROC	(1 << 2)
#define	IDL_CF_ONLY_USAGE	(1 << 3)
#define	IDL_CF_INFORMATIVE	(1 << 4)
#define	IDL_CF_NOWARNINGS	(1 << 5)

#endif	// _IDL_DEFS_HXX_

