/*************************************************************************
 *
 *  $RCSfile: idlfwd.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _IDLFWD_HXX_
#define _IDLFWD_HXX_


// Class for global data representation:

class	IDL_Global;			// Global data is stored in an
								// instance of this

// Classes for utility of the IDL compiler:
class	UTL_ScopeStack;				// Stack of scopes
class	UTL_Scope;					// A definition scope (mixin)

class	UTL_LongList;				// List of longs
class	UTL_StrList;				// List of strings
class	UTL_StrlistActiveIterator;	// Active iterator for list of strings
class	UTL_IdList;					// List of identifiers
class	UTL_IdListActiveIterator;	// Active iterator for list of id's
class	UTL_ExceptList;				// List of exceptions
class	UTL_NameList;				// List of scoped names
class	UTL_ExprList;				// List of expressions
class	UTL_InterfList;				// List of interfaces
class	UTL_LabelList;				// List of union branch labels
class	UTL_DeclList;				// List of declarators

class	UTL_PkgItem;
class	UTL_PkgList;

class	UTL_Map;
class	UTL_MapTable;

class	UTL_Error;					// Error class
class	UTL_Indenter;				// Indenter class

// Classes for utility of the FE. These classes are used only
// by the FE but their forward declaration is needed because lists
// of them are constructed by classes in UTL

class	FE_InterfaceHeader;		// Interface header
class	FE_Declarator;			// Declarator

// Generator class for the AST

class	AST_Generator;			// Generate nodes of various types

// Classes for AST:

class	AST_Decl;				// The rock bottom base class

class	AST_PredefinedType;		// A predefined type
class	AST_Type;				// An IDL type
class	AST_ConcreteType;		// An IDL concrete type
class	AST_Object;				// A object
class	AST_Service;			// A service
class	AST_InterfaceMember;	// An interface which is exported by object
class	AST_ServiceMember;		// An service which is exported by object
class	AST_Observes;			// An interface which must observed
class	AST_Needs;				// An service which is needed
class	AST_Module;				// A module
class	AST_Constants;		  	// A const group
class	AST_Mapping;  			// A mapping
class	AST_Root;				// The root of an AST (a module)
class	AST_Interface;			// An interface
class	AST_InterfaceFwd;		// A forward interface decl
class	AST_Constant;			// A constant declaration
class	AST_Expression;			// Value of an expression
class	AST_Exception;			// An exception declaration
class	AST_Attribute;			// An attribute declaration
class	AST_Operation;			// An operation declaration
class	AST_Argument;			// An argument to an operation
class	AST_Union;				// A union declaration
class	AST_UnionBranch;		// A branch in a union
class	AST_UnionLabel;			// A union branch label
class	AST_Structure;			// A structure declaration
class	AST_Field;				// A field in a structure or union
class	AST_Enum;				// An enum declaration
class	AST_EnumVal;			// An enumerator in an enum
class	AST_Sequence;			// A sequence declaration
class	AST_String;				// A string declaration
class	AST_Array;				// An array declaration
class	AST_Typedef;			// A typedef declaration

#endif	// _IDLFWD_HXX_

