/*************************************************************************
 *
 *  $RCSfile: utllist.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _UTLLIST_HXX_
#define _UTLLIST_HXX_



// NOTE: This list class only works correctly because we use single public
//       inheritance, as opposed to multiple inheritance or public virtual.
//	 It relies on a type-unsafe cast from UTL_List to subclasses, which
//	 will cease to operate correctly if you use either multiple or
//	 public virtual inheritance.
//
//	 For portability reasons we have decided to provide both this and
//	 an implementation of the list classes in terms of templates. If
//	 your compiler supports templates, please use the files in the
//	 include/utl_tmpl and util/utl_tmpl directories instead of the
//	 files by the same names in the include and util directories.

// Forward declare active iterator for UTL_List
class	UTL_ListActiveIterator;


class UTL_List
{
public:
	// Operations

	// Constructor(s)
	UTL_List(UTL_List *c);
	virtual ~UTL_List();

	// Smash last cdr pointer in "this" with l
	void	nconc(UTL_List *l);

	// Copy the list starting at "this"
	virtual UTL_List	*copy();

	// Get next list
	UTL_List	*tail();

	// Set next list
	void		set_tail(UTL_List *l);

	// How long is this list?
	long		length();

private:
	// Data
	UTL_List	*pd_cdr_data;	// The next list

	// Operations
	long		list_length(long n); // How long is it?

	// Friend class
	friend class		UTL_ListActiveIterator; // Friend class

};

// Active iterator for lists
class UTL_ListActiveIterator
{
public:
	// Operations

	// Constructor(s)
	UTL_ListActiveIterator(UTL_List *s);	
	virtual ~UTL_ListActiveIterator() {}

	// Get next list
	virtual void	next();

	// Are we at the end of this list?
	virtual long	is_done();

protected:
	// Data
	UTL_List	*source;		// On what to iterate?
};

#endif	// _UTLLIST_HXX_

