/*************************************************************************
 *
 *  $RCSfile: drvlink.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif
#ifndef _CRVPRIV_HXX_
#include <drvpriv.hxx>
#endif
#ifndef _DRVLINK_HXX_
#include <drvlink.hxx>
#endif

#ifndef _VOS_MODULE_HXX_
#include <vos/module.hxx>
#endif
#ifndef _VOS_DYNLOAD_HXX_
#include <vos/dynload.hxx>
#endif

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

using namespace rtl;
using namespace vos;


/**
 * Handle for the backend module which support the appropriate
 * api functions
 */
OModule hBEModule;

//#define UCO_PREFIX 		"uco"		// Core Backend
//#define UBC_PREFIX 		"ubc"		// C++ Backend
//#define S2U_PREFIX 		"s2u"		// SmartToUno Backend
//#define UBJ_PREFIX 		"ubj"		// Java Backend 
//#define UDC_PREFIX 		"udc"		// Doc Backend
//#define USM_PREFIX 		"usm"		// Smart Backend
#define URD_PREFIX 		"urd"		// Reflection Backend
//#define UXL_PREFIX 		"uxl"		// XML Backend

DRV_PF_FE_init_stage1			DRV_FE_init_stage1;
DRV_PF_FE_init_stage2			DRV_FE_init_stage2;
DRV_PF_FE_yyparse				DRV_FE_yyparse;
DRV_PF_FE_set_yyin				DRV_FE_set_yyin;
DRV_PF_FE_new_UTL_Error			DRV_FE_new_UTL_Error;
DRV_PF_FE_new_UTL_Indenter		DRV_FE_new_UTL_Indenter;
DRV_PF_FE_new_UTL_String		DRV_FE_new_UTL_String;

DRV_PF_BE_init					DRV_BE_init;
DRV_PF_BE_produce				DRV_BE_produce;
DRV_PF_BE_abort					DRV_BE_abort;
DRV_PF_BE_prep_arg				DRV_BE_prep_arg;
DRV_PF_BE_version				DRV_BE_version;


void DRV_FE_open()
{
	DRV_FE_init_stage1 = (DRV_PF_FE_init_stage1)&FE_init_stage1;
	DRV_FE_init_stage2 = (DRV_PF_FE_init_stage2)&FE_init_stage2;
	DRV_FE_yyparse = (DRV_PF_FE_yyparse)&FE_yyparse;
	DRV_FE_set_yyin = (DRV_PF_FE_set_yyin)&FE_set_yyin;
	DRV_FE_new_UTL_Error = (DRV_PF_FE_new_UTL_Error)&FE_new_UTL_Error;
	DRV_FE_new_UTL_Indenter = (DRV_PF_FE_new_UTL_Indenter)&FE_new_UTL_Indenter;
	DRV_FE_new_UTL_String = (DRV_PF_FE_new_UTL_String)&FE_new_UTL_String;
}

void DRV_FE_close()
{
	DRV_FE_init_stage1 = 0;
	DRV_FE_init_stage2 = 0;
	DRV_FE_yyparse = 0;
	DRV_FE_set_yyin = 0;
	DRV_FE_new_UTL_Error = 0;
	DRV_FE_new_UTL_Indenter = 0;
	DRV_FE_new_UTL_String = 0;
}

void DRV_BE_open()
{
	OUString dllname;
	String backend = IDL_Global::idl_global()->be();
/*
	if (backend == "core")
	{
		NAMESPACE_VOS(ORealDynamicLoader)::computeModuleName(OUString( RTL_CONSTASCII_USTRINGPARAM(UCO_PREFIX) ), 
															 dllname);
	} else
	if (backend == "cpp")
	{
		NAMESPACE_VOS(ORealDynamicLoader)::computeModuleName(OUString( RTL_CONSTASCII_USTRINGPARAM(UBC_PREFIX) ),
															 dllname);
	} else
	if (backend == "s2u")
	{
		IDL_Global::idl_global()->setMappingLanguage("cpp");
		NAMESPACE_VOS(ORealDynamicLoader)::computeModuleName(OUString( RTL_CONSTASCII_USTRINGPARAM(S2U_PREFIX) ), 
															 dllname);
	} else
	if (backend == "smart")
	{
		IDL_Global::idl_global()->setMappingLanguage("cpp");
		NAMESPACE_VOS(ORealDynamicLoader)::computeModuleName(OUString( RTL_CONSTASCII_USTRINGPARAM(USM_PREFIX) ), 
															 dllname);
	} else
*/
	if (backend == "urd")
	{
		NAMESPACE_VOS(ORealDynamicLoader)::computeLibraryName(OUString( RTL_CONSTASCII_USTRINGPARAM(URD_PREFIX) ), 
															  dllname);
	} else
/*
	if (backend == "java")
	{
		NAMESPACE_VOS(ORealDynamicLoader)::computeModuleName(OUString( RTL_CONSTASCII_USTRINGPARAM(UBJ_PREFIX) ),
															 dllname);
	} else
	if (backend == "doc")
	{
		NAMESPACE_VOS(ORealDynamicLoader)::computeLibraryName(OUString( RTL_CONSTASCII_USTRINGPARAM(UDC_PREFIX) ),
															  dllname);
	} else
	if (backend == "xml")
	{
		NAMESPACE_VOS(ORealDynamicLoader)::computeModuleName(OUString( RTL_CONSTASCII_USTRINGPARAM(UXL_PREFIX) ), 
															 dllname);
	} else
*/
	{
		IDL_Global::idl_global()->set_be("urd");
		NAMESPACE_VOS(ORealDynamicLoader)::computeLibraryName(OUString( RTL_CONSTASCII_USTRINGPARAM(URD_PREFIX) ), 
															 dllname);
	}	


	if (!hBEModule.load(dllname))
	{
		fprintf(stderr, "%s: %s Backend DLL could not be loaded\n\n",
			   IDL_Global::idl_global()->prog_name(), backend.getStr());
	} 

	if ((DRV_BE_init = (DRV_PF_BE_init)hBEModule.getSymbol(OUString( RTL_CONSTASCII_USTRINGPARAM("BE_init") ))) == NULL
		||(DRV_BE_produce = (DRV_PF_BE_produce)hBEModule.getSymbol(OUString( RTL_CONSTASCII_USTRINGPARAM("BE_produce") ))) == NULL
		||(DRV_BE_abort = (DRV_PF_BE_abort)hBEModule.getSymbol(OUString( RTL_CONSTASCII_USTRINGPARAM("BE_abort") ))) == NULL
		||(DRV_BE_prep_arg = (DRV_PF_BE_prep_arg)hBEModule.getSymbol(OUString( RTL_CONSTASCII_USTRINGPARAM("BE_prep_arg") ))) == NULL
		||(DRV_BE_version = (DRV_PF_BE_version)hBEModule.getSymbol(OUString( RTL_CONSTASCII_USTRINGPARAM("BE_version") ))) == NULL)
	{
		fprintf(stderr, "%s: %s Error in the DLL: check the exported API functions\n\n",
			   IDL_Global::idl_global()->prog_name(), backend.getStr());

		exit(99);
	}
}

void DRV_BE_close()
{
	DRV_BE_init = 0;
	DRV_BE_produce = 0;
	DRV_BE_abort = 0;
	DRV_BE_prep_arg = 0;
	DRV_BE_version = 0;

	if (IDL_Global::idl_global() != NULL) 
		delete(IDL_Global::idl_global());
		
	hBEModule.unload();	
}
