/*************************************************************************
 *
 *  $RCSfile: feextern.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include   <stdio.h>

#ifndef _IDL_HXX_
#include   <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include   <idlext.hxx>
#endif
#ifndef _UTLERROR_HXX_
#include   <utlerror.hxx>
#endif
#ifndef _UTLIND_HXX_
#include   <utlind.hxx>
#endif

#ifdef SAL_UNX
#include	<unistd.h>	
#endif


/*
 * yacc parser interface
 */

extern int yyparse();
extern FILE* yyin;
extern int yydebug;
char* parser_tmp_file;

int FE_yyparse()
{
	//yydebug = 0 no trace information
	//yydebug = 1 parser produce trace information
	yydebug = 0;

	int result = yyparse();
	if (IDL_Global::idl_global()->err_count() == 0)
	{
		IDL_Global::idl_global()->root()->call_add();
	}

	fclose(yyin);
	if (unlink(parser_tmp_file) != 0)
	{
		fprintf(stderr, "%s: Could not remove parser input file %s\n",
			   IDL_Global::idl_global()->prog_name(), parser_tmp_file);
		exit(99);
	}

	return result;
}

void FE_set_yyin(FILE* f, char* tmp_file)
{
	yyin = f;
	parser_tmp_file = tmp_file;
}

/*
 * constructor interfaces
 */

UTL_Error *FE_new_UTL_Error()
{
	return new UTL_Error();
}

UTL_Indenter *FE_new_UTL_Indenter()
{
	return new UTL_Indenter();
}

String *FE_new_UTL_String(char * str)
{
	return new String(str);
}
