/*************************************************************************
 *
 *  $RCSfile: feinit.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include	<idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include	<idlext.hxx>
#endif

/*
 * Create a scoped name
 */
static UTL_ScopedName *create_scoped_name(char *s)
{
	return new UTL_ScopedName(s, NULL);
}

/*
 * Populate the global scope with all predefined entities
 */
void fe_populate(AST_Module *m)
{
	AST_PredefinedType *pdt;

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_long,
									create_scoped_name("long"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_ulong,
									create_scoped_name("unsigned long"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_hyper,
									create_scoped_name("hyper"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_uhyper,
									create_scoped_name("unsigned hyper"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_longlong,
									create_scoped_name("long long"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_ulonglong,
									create_scoped_name("unsigned long long"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_short,
									create_scoped_name("short"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_ushort,
									create_scoped_name("unsigned short"),
									NULL);
	m->fe_add_predefined_type(pdt);
 
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_float,
									create_scoped_name("float"),
					       			NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_double,
									create_scoped_name("double"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_longdouble,
									create_scoped_name("long double"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_char,
									create_scoped_name("char"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_wchar,
									create_scoped_name("wchar_t"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_octet,
									create_scoped_name("octet"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_byte,
									create_scoped_name("byte"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_any,
									create_scoped_name("any"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_type,
									create_scoped_name("type"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_boolean,
									create_scoped_name("boolean"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_implementation,
									create_scoped_name("implementation"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_void,
									create_scoped_name("void"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("TypeCode"),
									NULL);
	m->fe_add_predefined_type(pdt);
 
  /*
   * Add these to make all keywords protected even in different spellings
   */
 
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("attribute"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("case"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("const"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("context"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("default"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("enum"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("exception"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("in"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("out"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("inout"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("interface"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("module"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("object"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("service"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("oneway"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("uoid"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("version"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("requests"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("raises"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("readonly"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("optional"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("sequence"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("string"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("wstring_t"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("struct"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("switch"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("typedef"),
									NULL);
	m->fe_add_predefined_type(pdt);

	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("union"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("unsigned"),
									NULL);
	m->fe_add_predefined_type(pdt);
  
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("TRUE"),
									NULL);
	m->fe_add_predefined_type(pdt);
	
	pdt = IDL_Global::idl_global()->gen()->
			create_predefined_type(AST_PredefinedType::PT_pseudo,
									create_scoped_name("FALSE"),
									NULL);
	m->fe_add_predefined_type(pdt);

}

/*
 * Initialization stage 1: create global scopes stack
 */
void FE_init_stage1()
{
	IDL_Global::idl_global()->set_scopes(new UTL_ScopeStack());
	if (IDL_Global::idl_global()->scopes() == NULL) 
	{
		fprintf(stderr, "IDL: FE init failed to create scope stack, exiting\n");
		exit(99);
	}
}

/*
 * Initialization stage 2: create global scope and populate it
 */
void FE_init_stage2()
{
	AST_Root	*r;

	/*
	 * Check that the BE init created a generator object
	 */
	if (IDL_Global::idl_global()->gen() == NULL) 
	{
		fprintf(stderr, "IDL: BE did not initialize IDL_Global::idl_global()->gen(), exiting\n");
		exit(99);
	}
	/*
	 * Create a global root for the AST. Note that the AST root has no
	 * name
	 */
	r = IDL_Global::idl_global()->gen()->create_root(create_scoped_name(""), NULL);
	IDL_Global::idl_global()->set_root(r);
	if (r == NULL) 
	{
		fprintf(stderr, "IDL: FE init failed to create AST root, exiting\n");
		exit(99);
	}
	/*
	 * Push it on the stack
	 */
	IDL_Global::idl_global()->scopes()->push(IDL_Global::idl_global()->root());
	/*
	 * Populate it with nodes for predefined types
	 */
	fe_populate(IDL_Global::idl_global()->root());
	/*
	 * Set flag to indicate we are processing the main file now
	 */
	IDL_Global::idl_global()->set_in_main_file(sal_True);
}
