/*************************************************************************
 *
 *  $RCSfile: astgen.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif

/*
 * Constructors
 */

/*
 * Private operations
 */

/*
 * Public operations
 */

/*
 * Construct an AST_PredefinedType node (a predefined type)
 */
AST_PredefinedType *
AST_Generator::create_predefined_type(AST_PredefinedType::PredefinedType t,
										UTL_ScopedName *n,
										UTL_StrList *p)
{
	return new AST_PredefinedType(t, n, p);
}

/*
 * Construct an AST_Object node (an object)
 */
AST_Object *
AST_Generator::create_object(UTL_ScopedName *n, UTL_StrList *p, char* name)
{
	return new AST_Object(n, p, name);
}

/*
 * Construct an AST_Service node (an service)
 */
AST_Service *
AST_Generator::create_service(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Service(n, p);
}

/*
 * Construct an AST_InterfaceMember node
 */
AST_InterfaceMember *
AST_Generator::create_interface_member(const sal_uInt16 fOptional, UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_InterfaceMember(fOptional, n, p);
}

/*
 * Construct an AST_ServiceMember node
 */
AST_ServiceMember *
AST_Generator::create_service_member(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_ServiceMember(n, p);
}

/*
 * Construct an AST_Observes node
 */
AST_Observes *
AST_Generator::create_observes(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Observes(n, p);
}

/*
 * Construct an AST_Needs node
 */
AST_Needs *
AST_Generator::create_needs(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Needs(n, p);
}

/*
 * Construct an AST_Module node (a module)
 */
AST_Module *
AST_Generator::create_module(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Module(n, p);
}

/*
 * Construct an AST_Constants node (a const group)
 */
AST_Constants *
AST_Generator::create_constants(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Constants(n, p);
}

/*
 * Construct an AST_Mapping node 
 */
AST_Mapping *
AST_Generator::create_mapping(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Mapping(n, p);
}

/*
 * Construct an AST_Root node (a node representing the root of an AST)
 */
AST_Root *
AST_Generator::create_root(UTL_ScopedName *n,
							UTL_StrList *p)
{
    return new AST_Root(n, p);
}

/*
 * Construct an AST_Interface node (an interface)
 */
AST_Interface *
AST_Generator::create_interface(UTL_ScopedName *n, AST_Interface **ih,
								long nih, UTL_StrList *p,
								char* uik, double version, sal_Bool vrt, char* ident)
{
	return new AST_Interface(n, ih, nih, p, uik, version, vrt, ident);
}

/*
 * Construct an AST_InterfaceFwd node (a node representing the forward
 * declaration of an interface)
 */
AST_InterfaceFwd *
AST_Generator::create_interface_fwd(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_InterfaceFwd(n, p);
}

/*
 * Construct an AST_Exception node (an exception)
 */
AST_Exception *
AST_Generator::create_exception(UTL_ScopedName *n, AST_Exception **ih,
								long nih, UTL_StrList *p)
{
	return new AST_Exception(n, ih, nih, p);
}

/*
 * Construct an AST_Structure node (a struct)
 */
AST_Structure *
AST_Generator::create_structure(UTL_ScopedName *n, AST_Structure **ih,
								long nih, UTL_StrList *p)
{
	return new AST_Structure(n, ih, nih, p);
}

/*
 * Construct an AST_Enum node (an enum)
 */
AST_Enum *
AST_Generator::create_enum(UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Enum(n, p);
}

/*
 * Construct an AST_Operation node (an operation on an interface)
 */
AST_Operation *
AST_Generator::create_operation(AST_Type *rt,
								AST_Operation::Flags fl,
								IFlag ifl,
								char* local,
								sal_Bool cons,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return new AST_Operation(rt, fl, ifl, local, cons, n, p);
}

/*
 * Construct an AST_Field node (a field in a struct, union or exception)
 */
AST_Field *
AST_Generator::create_field(AST_Type *ft, UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Field(ft, n, p);
}

/*
 * Construct an AST_Argument node (an argument to an operation)
 */
AST_Argument *
AST_Generator::create_argument(AST_Argument::Direction d,
								AST_Type *ft,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return new AST_Argument(d, ft, n, p);
}

/*
 * Construct an AST_Attribute node (an attribute)
 */
AST_Attribute *
AST_Generator::create_attribute(sal_uInt16 attrFlags,
								IFlag ifl,
								AST_Type *ft,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return new AST_Attribute(attrFlags, ifl, ft, n, p);
}

/*
 * Construct an AST_Union node (a union)
 */
AST_Union *
AST_Generator::create_union(AST_ConcreteType *dt,
							UTL_ScopedName *n,
							UTL_StrList *p)
{
	return new AST_Union(dt, n, p);
}

/*
 * Construct an AST_UnionBranch node (a branch in a union)
 */
AST_UnionBranch *
AST_Generator::create_union_branch(AST_UnionLabel *lab,
									AST_Type *ft,
									UTL_ScopedName *n,
									UTL_StrList *p)
{
	return new AST_UnionBranch(lab, ft, n, p);
}

/*
 * Construct an AST_UnionLabel node (a label in a union)
 */
AST_UnionLabel *
AST_Generator::create_union_label(AST_UnionLabel::UnionLabel ul,
									AST_Expression *v)
{
	return new AST_UnionLabel(ul, v);
}

/*
 * Construct an AST_Constant node (a constant)
 */
AST_Constant *
AST_Generator::create_constant(AST_Expression::ExprType et,
								AST_Expression *ev,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return new AST_Constant(et, ev, n, p);
}

/*
 * Construct an AST_Expression node denoting a symbolic name
 */
AST_Expression *
AST_Generator::create_expr(UTL_ScopedName *n)
{
	return new AST_Expression(n);
}

/*
 * Construct an AST_Expression denoting a coercion
 */
AST_Expression *
AST_Generator::create_expr(AST_Expression *v, AST_Expression::ExprType t)
{
	return new AST_Expression(v, t);
}

/*
 * Construct an AST_Expression node denoting a binary combinator
 * of two other AST_Expression nodes
 */
AST_Expression *
AST_Generator::create_expr(AST_Expression::ExprComb c,
							AST_Expression *v1,
							AST_Expression *v2)
{
	return new AST_Expression(c, v1, v2);
}

/*
 * Construct an AST_Expression node denoting a long integer
 */
AST_Expression *
AST_Generator::create_expr(long v)
{
	return new AST_Expression(v);
}

/*
 * Construct an AST_Expression node denoting a long integer being used
 * as a boolean
 */
AST_Expression *
AST_Generator::create_expr(long v, AST_Expression::ExprType t)
{
	return new AST_Expression(v, t);
}

/*
 * Construct an AST_Expression node denoting an unsigned long integer
 */
AST_Expression *
AST_Generator::create_expr(unsigned long v)
{
	return new AST_Expression(v);
}

/*
 * Construct an AST_Expression node denoting a string (a char *
 * encapsulated as String)
 */
AST_Expression *
AST_Generator::create_expr(String *s)
{
	return new AST_Expression(s);
}

/*
 * Construct an AST_Expression node denoting a character
 */
AST_Expression *
AST_Generator::create_expr(char c)
{
	return new AST_Expression(c);
}

/*
 * Construct an AST_Expression node denoting a 64-bit floating point number
 */
AST_Expression *
AST_Generator::create_expr(double d)
{
	return new AST_Expression(d);
}

/*
 * Construct an AST_EnumVal node (an enumerator)
 */
AST_EnumVal *
AST_Generator::create_enum_val(unsigned long v,
								UTL_ScopedName *n,
								UTL_StrList *p)
{
	return new AST_EnumVal(v, n, p);
}

/*
 * Construct an AST_Array node (an array type or field modifier)
 */
AST_Array *
AST_Generator::create_array(UTL_ScopedName *n,
							unsigned long ndims,
							UTL_ExprList *dims)
{
	return new AST_Array(n, ndims, dims);
}

/*
 * Construct an AST_Sequence node (a sequence type definition)
 */
AST_Sequence *
AST_Generator::create_sequence(AST_Expression *ms, AST_Type *bt)
{
	return new AST_Sequence(ms, bt);
}

/*
 * Construct an AST_String node (a string type definition)
 */
AST_String *
AST_Generator::create_string(AST_Expression *ms)
{
	return new AST_String(ms);
}

/*
 * Construct an AST_String node denoting a wide string type definition
 */
AST_String *
AST_Generator::create_wstring(AST_Expression *ms)
{
	return new AST_String(ms, sizeof(wchar_t));
}

/*
 * Construct an AST_Typedef node (a typedef)
 */
AST_Typedef *
AST_Generator::create_typedef(AST_Type *bt, UTL_ScopedName *n, UTL_StrList *p)
{
	return new AST_Typedef(bt, n, p);
}
