/*************************************************************************
 *
 *  $RCSfile: astintfw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif

/*
 * Constructor(s) and destructor
 */
AST_InterfaceFwd::AST_InterfaceFwd()
	:	pd_full_definition(NULL)
{
}

AST_InterfaceFwd::AST_InterfaceFwd(UTL_ScopedName *n, UTL_StrList *p)
	:	AST_Decl(AST_Decl::NT_interface_fwd, n, p)
{
	/*
	 * Create a dummy placeholder for the forward declared interface. This
	 * interface node is not yet defined (n_inherits < 0), so some operations
	 * will fail
	 */
	pd_full_definition = IDL_Global::idl_global()->gen()->create_interface(n, NULL, -1, p,
														   NULL, 0, sal_False, NULL);

	pd_full_definition->set_forwarded(sal_True);													
	/*
	 * Record the node in a list to be checked after the entire AST has been
	 * parsed. All nodes in the list must have n_inherits >= 0, else this
	 * indicates that a full definition was not seen for this forward
	 * delcared interface
	 */
	AST_record_fwd_interface(this);
}

AST_InterfaceFwd::~AST_InterfaceFwd()
{
	//if (pd_full_definition != NULL) delete(pd_full_definition);
}


/*
 * Private operations
 */

/*
 * Public operations
 */

/*
 * Redefinition of inherited virtual operations
 */

/*
 * Dump this AST_InterfaceFwd node to the ostream o
 */
void AST_InterfaceFwd::dump(ostream &o)
{
	o << "interface " << local_name();
}

/*
 * Data accessors
 */

AST_Interface *AST_InterfaceFwd::full_definition()
{
	return pd_full_definition;
}

void AST_InterfaceFwd::set_full_definition(AST_Interface *nfd)
{
	pd_full_definition = nfd;
}    

/*
 * Narrowing methods 
 */
IMPL_NARROW_METHODS1(AST_InterfaceFwd, AST_Type)
IMPL_NARROW_FROM_DECL(AST_InterfaceFwd)
