/*************************************************************************
 *
 *  $RCSfile: astobjmb.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif

/*
 * Constructor(s) and destructor
 */

AST_InterfaceMember::AST_InterfaceMember()
	:	m_optionalFlag(AF_INVALID)	
	,	m_realInterface(NULL)
{
}

AST_InterfaceMember::AST_InterfaceMember(const sal_uInt16 fOptional, UTL_ScopedName *n, UTL_StrList *p)
	:	AST_Decl(AST_Decl::NT_interface_member, n, p)
	,	m_optionalFlag( fOptional )
	,	m_realInterface(NULL)
{
}

/*
 * Dump this AST_InterfaceMember node to the ostream o
 */
void AST_InterfaceMember::dump(ostream &o)
{
	AST_Decl::dump(o);
}

/*
 * Data Accessors
 */
void AST_InterfaceMember::setInterface(AST_Interface *inter)
{
	m_realInterface = inter;	
}	

AST_Interface* AST_InterfaceMember::getInterface()
{
	return(m_realInterface);
}	

/*
 * Narrowing operations
 */
IMPL_NARROW_METHODS1(AST_InterfaceMember, AST_Decl)
IMPL_NARROW_FROM_DECL(AST_InterfaceMember)


/*
 * Constructor(s) and destructor
 */

AST_ServiceMember::AST_ServiceMember()
	:	m_realService(NULL)
{
}

AST_ServiceMember::AST_ServiceMember(UTL_ScopedName *n, UTL_StrList *p)
	:	AST_Decl(AST_Decl::NT_service_member, n, p),
		m_realService(NULL)
{
}

/*
 * Dump this AST_ServiceMember node to the ostream o
 */
void AST_ServiceMember::dump(ostream &o)
{
	AST_Decl::dump(o);
}

/*
 * Data Accessors
 */
void AST_ServiceMember::setService(AST_Service *serv)
{
	m_realService = serv;	
}	

AST_Service* AST_ServiceMember::getService()
{
	return(m_realService);
}	

/*
 * Narrowing operations
 */
IMPL_NARROW_METHODS1(AST_ServiceMember, AST_Decl)
IMPL_NARROW_FROM_DECL(AST_ServiceMember)


/*
 * Constructor(s) and destructor
 */

AST_Observes::AST_Observes()
	: 	m_realInterface(NULL)
{
}

AST_Observes::AST_Observes(UTL_ScopedName *n, UTL_StrList *p)
	:	AST_Decl(AST_Decl::NT_observes, n, p),
		m_realInterface(NULL)
{
}

/*
 * Dump this AST_Observes node to the ostream o
 */
void AST_Observes::dump(ostream &o)
{
	AST_Decl::dump(o);
}

/*
 * Data Accessors
 */
void AST_Observes::setInterface(AST_Interface *inter)
{
	m_realInterface = inter;	
}	

AST_Interface* AST_Observes::getInterface()
{
	return(m_realInterface);
}	

/*
 * Narrowing operations
 */
IMPL_NARROW_METHODS1(AST_Observes, AST_Decl)
IMPL_NARROW_FROM_DECL(AST_Observes)


/*
 * Constructor(s) and destructor
 */

AST_Needs::AST_Needs()
	:	m_realService(NULL)
{
}

AST_Needs::AST_Needs(UTL_ScopedName *n, UTL_StrList *p)
	:	AST_Decl(AST_Decl::NT_needs, n, p),
		m_realService(NULL)
{
}

/*
 * Dump this AST_Needs node to the ostream o
 */
void AST_Needs::dump(ostream &o)
{
	AST_Decl::dump(o);
}

/*
 * Data Accessors
 */
void AST_Needs::setService(AST_Service *serv)
{
	m_realService = serv;	
}	

AST_Service* AST_Needs::getService()
{
	return(m_realService);
}	

/*
 * Narrowing operations
 */
IMPL_NARROW_METHODS1(AST_Needs, AST_Decl)
IMPL_NARROW_FROM_DECL(AST_Needs)
