/*************************************************************************
 *
 *  $RCSfile: fedecl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif
#ifndef _FEDECL_HXX_					 
#include	<fedecl.hxx>
#endif

/*
 * Constructor(s) and destructor
 */

FE_Declarator::FE_Declarator(UTL_ScopedName *n, DeclaratorType dt,
			     AST_Decl *cp)
	:	pd_name(n),
		pd_complex_part(cp),
		pd_decl_type(dt)
{
}

FE_Declarator::~FE_Declarator()
{
}

/*
 * Private operations
 */

/*
 * Public operations
 */
sal_Bool FE_Declarator::checkType(AST_Decl *type)
{
	if (pd_name->last_component() == *(type->local_name()))
		return(sal_False);
	else
		return(sal_True);
}	

// Compose the type of the complex declarator (if any) with the base
// type supplied in ct
AST_Type *FE_Declarator::compose(AST_Decl *d)
{
	AST_Array	*arr;
	AST_Type	*ct;

	ct = AST_Type::narrow_from_decl(d);
	if (ct == NULL) 
	{
		IDL_Global::idl_global()->err()->not_a_type(d);
		return NULL;
	}
	if (ct->node_type() == AST_Decl::NT_except) 
	{
		IDL_Global::idl_global()->err()->not_a_type(d);
		return NULL;
	}
	if (pd_decl_type == FD_simple || pd_complex_part == NULL) 
	{
		return ct;
	}
	//
	if (pd_complex_part->node_type() == AST_Decl::NT_array) 
	{
		arr = AST_Array::narrow_from_decl(pd_complex_part);
		arr->set_base_type(ct);

		/*
		 * Add the new array to the types defined in the global scope
		 */
		//IDL_Global::idl_global()->root()->fe_add_array(arr);

		return arr;
	}
	//
	return NULL; // return through this statement should not happen
}

/*
 * Redefinition of inherited virtual operations
 */

/*
 * Data accessors
 */

AST_Decl *FE_Declarator::complex_part()
{
	return pd_complex_part;
}

UTL_ScopedName *FE_Declarator::name()
{
	return pd_name;
}

FE_Declarator::DeclaratorType FE_Declarator::decl_type()
{
	return pd_decl_type;
}


/*
 * FE_FieldInfo
 */

/*
 * Constructor(s) and destructor
 */
FE_FieldInfo::FE_FieldInfo(sal_Bool type, char *index)
	:	pd_index_type(type),
		pd_index_name(index)
{
}

FE_FieldInfo::~FE_FieldInfo()
{
}

const sal_Bool FE_FieldInfo::index_type()
{
	return pd_index_type;
}

char* FE_FieldInfo::index_name()
{
	return pd_index_name;
}

