#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 15:19:15 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..

PRJNAME=unoidl
TARGET=unoast

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

#.IF "$(GUI)"=="UNX"
#CFLAGS += -instances=extern -template=wholeclass -ptr$(SLO)
#LINKFLAGS += -temp=/tmp -PIC -instances=extern -ptr$(SLO)
#.ENDIF

USE_LDUMP2=TRUE
LDUMP2 = LDUMP3

#--- Files --------------------------------------------------------

CXXFILES=	\
			astarg.cxx	\
			astarray.cxx	\
			astattr.cxx	\
			astcheck.cxx	\
			astconst.cxx	\
			astctype.cxx	\
			astdecl.cxx	\
			astenum.cxx	\
			astenval.cxx	\
			astexcep.cxx	\
			astexpr.cxx	\
			astfield.cxx	\
			astgen.cxx	\
			astinter.cxx	\
			astintfw.cxx	\
			astmap.cxx	\
			astmodul.cxx	\
			astobj.cxx	\
			astobjmb.cxx	\
			astoper.cxx	\
			astptype.cxx	\
			astrecur.cxx	\
			astredef.cxx	\
			astroot.cxx	\
			astseq.cxx	\
			astserv.cxx	\
			aststr.cxx	\
			aststruc.cxx	\
			asttdef.cxx	\
			asttype.cxx	\
			astubran.cxx	\
			astulab.cxx	\
			astunion.cxx	\
			fedecl.cxx	\
			feheads.cxx	\
			idlnew.cxx	\
			narrow.cxx	\
			utldecll.cxx	\
			utlecptl.cxx	\
			utlerror.cxx	\
			utlexprl.cxx	\
			utlglob.cxx	\
			utlidl.cxx	\
			utlind.cxx	\
			utllabl.cxx	\
			utllist.cxx	\
			utlnamel.cxx	\
			utlnlist.cxx	\
			utlscope.cxx	\
			utlstack.cxx	\
			utlstrl.cxx	\
			utlpkgl.cxx	\
			utlmap.cxx

SLOFILES=	\
			$(SLO)$/astarg.obj	\
			$(SLO)$/astarray.obj	\
			$(SLO)$/astattr.obj	\
			$(SLO)$/astcheck.obj	\
			$(SLO)$/astconst.obj	\
			$(SLO)$/astctype.obj	\
			$(SLO)$/astdecl.obj	\
			$(SLO)$/astenum.obj	\
			$(SLO)$/astenval.obj	\
			$(SLO)$/astexcep.obj	\
			$(SLO)$/astexpr.obj	\
			$(SLO)$/astfield.obj	\
			$(SLO)$/astgen.obj	\
			$(SLO)$/astinter.obj	\
			$(SLO)$/astintfw.obj	\
			$(SLO)$/astmap.obj	\
			$(SLO)$/astmodul.obj	\
			$(SLO)$/astobj.obj	\
			$(SLO)$/astobjmb.obj	\
			$(SLO)$/astoper.obj	\
			$(SLO)$/astptype.obj	\
			$(SLO)$/astrecur.obj	\
			$(SLO)$/astredef.obj	\
			$(SLO)$/astroot.obj	\
			$(SLO)$/astseq.obj	\
			$(SLO)$/astserv.obj	\
			$(SLO)$/aststr.obj	\
			$(SLO)$/aststruc.obj	\
			$(SLO)$/asttdef.obj	\
			$(SLO)$/asttype.obj	\
			$(SLO)$/astubran.obj	\
			$(SLO)$/astulab.obj	\
			$(SLO)$/astunion.obj	\
			$(SLO)$/fedecl.obj	\
			$(SLO)$/feheads.obj	\
			$(SLO)$/idlnew.obj	\
			$(SLO)$/narrow.obj	\
			$(SLO)$/utldecll.obj	\
			$(SLO)$/utlecptl.obj	\
			$(SLO)$/utlerror.obj	\
			$(SLO)$/utlexprl.obj	\
			$(SLO)$/utlglob.obj	\
			$(SLO)$/utlidl.obj	\
			$(SLO)$/utlind.obj	\
			$(SLO)$/utllabl.obj	\
			$(SLO)$/utllist.obj	\
			$(SLO)$/utlnamel.obj	\
			$(SLO)$/utlnlist.obj	\
			$(SLO)$/utlscope.obj	\
			$(SLO)$/utlstack.obj	\
			$(SLO)$/utlstrl.obj	\
			$(SLO)$/utlpkgl.obj	\
			$(SLO)$/utlmap.obj

.IF "$(OS)$(CPU)" == "SOLARISS"
NOOPTFILES=	\
			$(SLO)$/astarg.obj	\
			$(SLO)$/astarray.obj	\
			$(SLO)$/astattr.obj	\
			$(SLO)$/astcheck.obj	\
			$(SLO)$/astconst.obj	\
			$(SLO)$/astctype.obj	\
			$(SLO)$/astdecl.obj	\
			$(SLO)$/astenum.obj	\
			$(SLO)$/astenval.obj	\
			$(SLO)$/astexcep.obj	\
			$(SLO)$/astexpr.obj	\
			$(SLO)$/astfield.obj	\
			$(SLO)$/astgen.obj	\
			$(SLO)$/astinter.obj	\
			$(SLO)$/astintfw.obj	\
			$(SLO)$/astmap.obj	\
			$(SLO)$/astmodul.obj	\
			$(SLO)$/astobj.obj	\
			$(SLO)$/astobjmb.obj	\
			$(SLO)$/astoper.obj	\
			$(SLO)$/astptype.obj	\
			$(SLO)$/astrecur.obj	\
			$(SLO)$/astredef.obj	\
			$(SLO)$/astroot.obj	\
			$(SLO)$/astseq.obj	\
			$(SLO)$/astserv.obj	\
			$(SLO)$/aststr.obj	\
			$(SLO)$/aststruc.obj	\
			$(SLO)$/asttdef.obj	\
			$(SLO)$/asttype.obj	\
			$(SLO)$/astubran.obj	\
			$(SLO)$/astulab.obj	\
			$(SLO)$/astunion.obj	\
			$(SLO)$/fedecl.obj	\
			$(SLO)$/feheads.obj	\
			$(SLO)$/idlnew.obj	\
			$(SLO)$/narrow.obj	\
			$(SLO)$/utldecll.obj	\
			$(SLO)$/utlecptl.obj	\
			$(SLO)$/utlerror.obj	\
			$(SLO)$/utlexprl.obj	\
			$(SLO)$/utlglob.obj	\
			$(SLO)$/utlidl.obj	\
			$(SLO)$/utlind.obj	\
			$(SLO)$/utllabl.obj	\
			$(SLO)$/utllist.obj	\
			$(SLO)$/utlnamel.obj	\
			$(SLO)$/utlnlist.obj	\
			$(SLO)$/utlscope.obj	\
			$(SLO)$/utlstack.obj	\
			$(SLO)$/utlstrl.obj	\
			$(SLO)$/utlpkgl.obj	\
			$(SLO)$/utlmap.obj
.ENDIF

SHL1TARGET     =uas$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB     =uas
SHL1STDLIBS    =\
			    $(SALLIB) \
				$(VOSLIB) \
				$(STDLIBCPP)


.IF "$(GUI)" == "WNT"
SHL1STDLIBS    +=\
				$(LIBCIMT) \
				$(LIBCMT)
.ENDIF

SHL1DEPN       =
SHL1LIBS       =$(SLB)$/unoast.lib
SHL1DEF        =$(MISC)$/$(SHL1TARGET).def
.IF "$(GUI)" != "UNX"
SHL1OBJS       =$(SLO)$/astdecl.obj
.ENDIF

DEF1NAME       =$(SHL1TARGET)
DEF1DEPN       =$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME    =unoast
DEF1DES        =Uno AST


.IF "$(depend)" == ""

# --- Targets ------------------------------------------------------
ALL:	\
		$(SLB)$/unoast.lib	\
		ALLTAR

.ENDIF


.INCLUDE :  target.mk

$(MISC)$/$(SHL1TARGET).flt: $(MISC)$/$(TARGET).dpc 
		@echo Making $@
		@echo Impl		> $@
		@echo __alloc	>> $@
		@echo __malloc	>> $@
		@echo _alloc	>> $@
        @echo _CT>>$@
        @echo _TI2>>$@
        @echo _M_new_node>>$@
        @echo exception::exception>>$@
.IF "$(GUI)"=="OS2"
        @echo __lower_bound__FPCUlT1RCUlPi26random_access_iterator_tag	>>$@
        @echo list___11__stl_primeXSP0_	>>$@
.ENDIF

