/*************************************************************************
 *
 *  $RCSfile: utlglob.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif

// Define an increment for the size of the array used to store names of
// included files
#undef		INCREMENT
#define		INCREMENT	64

NAMESPACE_STD(hash)<const char*> IDL_Global::HashString::h;


IDL_Global *IDL_Global::m_global = NULL;

IDL_Global::IDL_Global()
	:	m_scopes(NULL),
		m_root(NULL),
		m_generator(NULL),
		m_error(NULL),
		m_err_count(0),
		m_lineno(0),
		m_filename(NULL),
		m_main_filename(NULL),
		m_real_filename(NULL),
		m_stripped_filename(NULL),
		m_in_main_file(sal_False),
		m_prog_name(NULL),
		m_cpp_location(NULL),
		m_compile_flags(0),
		m_backend(""),
		m_headerdestination(NULL),
		m_impldestination(NULL),
		m_be_args(NULL),
		m_local_escapes(NULL),
		
		m_options(NULL),
		m_indent(NULL),
		m_pragmas(NULL),
		
		m_read_from_stdin(sal_False),
/*
		m_include_file_names(NULL),
		m_n_include_file_names(0),
		m_n_alloced_file_names(0),
*/
		m_parse_state(PS_NoState),
		m_idldoc_text(NULL),
		m_idldoc_valid(0),
		m_file_packages(NULL),
		m_includePrefix(""),
		m_projectName(""),
		m_filePrefix(""),
		m_appendCore(sal_False),
		m_makeDepend(sal_False)
{
	m_mapTable = new UTL_MapTable();
	m_include_files = new IncludeSet();
	m_importmap = new ImportMap();
 	(*m_importmap)[""] = 0;

	m_depIncFiles = new IncludeSet();

	m_global = this;
}

IDL_Global::~IDL_Global()
{
/*
	if(m_include_file_names != NULL) 
	{
		for(m_n_include_file_names; m_n_include_file_names >= 1; 
			m_n_include_file_names--) 
		{
			if (m_include_file_names[m_n_include_file_names-1] != NULL) 
				delete(m_include_file_names[m_n_include_file_names-1]);
		}

		delete[] m_include_file_names;
	}
*/  
	if (m_pragmas != NULL) delete(m_pragmas);
	if (m_indent != NULL) delete(m_indent);
	if (m_local_escapes != NULL) delete(m_local_escapes);
	if (m_options != NULL) delete(m_options);

	if (m_headerdestination != NULL) delete(m_headerdestination);
	if (m_impldestination != NULL) delete(m_impldestination);

	if (m_be_args != NULL) delete(m_be_args);
	if (m_cpp_location != NULL) delete(m_cpp_location);	
	if (m_prog_name != NULL) delete(m_prog_name);
	if (m_stripped_filename != NULL) delete(m_stripped_filename);
	if (m_real_filename != NULL) delete(m_real_filename);
	if (m_main_filename != NULL) delete(m_main_filename);
	if (m_filename != NULL) delete(m_filename);
	
	if (m_error != NULL) delete(m_error);
	if (m_generator != NULL) delete(m_generator);
	
	if (m_idldoc_text != NULL) delete(m_idldoc_text);
	if (m_file_packages != NULL) delete(m_file_packages);
	
	if (m_mapTable != NULL) delete(m_mapTable);
	if (m_include_files != NULL) delete(m_include_files);
	if (m_importmap != NULL) delete(m_importmap);

	if (m_depIncFiles != NULL) delete(m_depIncFiles);
	
	// pop root from stack before delete
	m_scopes->pop();
	if (m_root != NULL) delete(m_root);
	
	if (m_scopes != NULL) delete(m_scopes);

	m_global = NULL;
}

IDL_Global *IDL_Global::idl_global()
{
	return (m_global);
}

// Get or set scopes stack
UTL_ScopeStack *IDL_Global::scopes()
{
	return m_scopes;
}

void IDL_Global::set_scopes(UTL_ScopeStack *s)
{
    if (m_scopes != NULL)
    {
        if (m_scopes->depth() == 1)
        {
            // root entfernen;
            m_scopes->pop();
        }
            
        delete(m_scopes);
    }

	m_scopes = s;
}

// Get or set root of AST
AST_Root *IDL_Global::root()
{
	return m_root;
}

void IDL_Global::set_root(AST_Root *r)
{
	if (m_root != NULL)
	{
		m_scopes->pop();
		delete(m_root);
	} 
	m_root = r;
}

// Get or set generator object
AST_Generator *IDL_Global::gen()
{
	return m_generator;
}

void IDL_Global::set_gen(AST_Generator *g)
{
	if (m_generator != NULL) delete(m_generator);
	m_generator = g;
}

// Get or set error object
UTL_Error *IDL_Global::err()
{
	return m_error;
}

void IDL_Global::set_err(UTL_Error *e)
{
	if (m_error != NULL) delete(m_error);
	m_error = e;
}

// Get or set error count
long IDL_Global::err_count()
{
	return m_err_count;
}

void IDL_Global::set_err_count(long c)
{
	m_err_count = c;
}

// Get or set line number
long IDL_Global::lineno()
{
	return m_lineno;
}

void IDL_Global::set_lineno(long n)
{
	m_lineno = n;
}

// Get or set file name being read now
String *IDL_Global::filename()
{
	return m_filename;
}

void IDL_Global::set_filename(String* f)
{
	if (m_filename != NULL) delete(m_filename);
	m_filename = f;
}

// Get or set main file name
String *IDL_Global::main_filename()
{
	return m_main_filename;
}

void IDL_Global::set_main_filename(String *n)
{
	if (m_main_filename != NULL) delete(m_main_filename);
	m_main_filename = n;
}

// Get or set real file name
String *IDL_Global::real_filename()
{
	return m_real_filename;
}

void IDL_Global::set_real_filename(String *n)
{
	if (m_real_filename != NULL) delete(m_real_filename);
	m_real_filename = n;
}

// Get or set indicator whether import is on
sal_Bool IDL_Global::imported()
{
	return m_in_main_file ? sal_False : m_import;
}

sal_Bool IDL_Global::import()
{
	return m_import;
}

void IDL_Global::set_import(sal_Bool is_in)
{
	m_import = is_in;
}

// Get or set indicator whether we're reading the main file now
sal_Bool IDL_Global::in_main_file()
{
	return m_in_main_file;
}

void IDL_Global::set_in_main_file(sal_Bool is_in)
{
	m_in_main_file = is_in;
}

// Get or set stripped file name
String *IDL_Global::stripped_filename()
{
	return m_stripped_filename;
}

void IDL_Global::set_stripped_filename(String *nm)
{
	if (m_stripped_filename != NULL) delete(m_stripped_filename);
	m_stripped_filename = nm;
}

// Get or set cache value for argv[0]
char *IDL_Global::prog_name()
{
	return m_prog_name;
}

void IDL_Global::set_prog_name(const char *pn)
{
	if (m_prog_name != NULL) delete(m_prog_name);

	if (pn != NULL) 
	{
		m_prog_name = new char[strlen(pn)+1];
		strcpy(m_prog_name, pn);
	} else
		m_prog_name = NULL;
}

// Get or set location to find C preprocessor
char *IDL_Global::cpp_location()
{
	return m_cpp_location;
}

void IDL_Global::set_cpp_location(char *l)
{
	if (m_cpp_location != NULL) delete(m_cpp_location);

	if (l != NULL) 
	{
		m_cpp_location = new char[strlen(l)+1];
		strcpy(m_cpp_location, l);
	} else
		m_cpp_location = NULL;
}

// Get or set IDL compiler flags
long IDL_Global::compile_flags()
{
	return m_compile_flags;
}

void IDL_Global::set_compile_flags(long cf)
{
	m_compile_flags = cf;
}

// Get or set BE to be used
String& IDL_Global::be()
{
	return m_backend;
}

void IDL_Global::set_be(String nbe)
{
	m_backend = nbe;
}

// Get or set destination to be used
char *IDL_Global::getHeaderDestination()
{
	return m_headerdestination;
}

void IDL_Global::setHeaderDestination(char *dest)
{
	if (m_headerdestination != NULL) delete(m_headerdestination);

	if (dest != NULL) 
	{
#ifdef UNX
		if(dest[strlen(dest)-1] == '/')
#else
		if(dest[strlen(dest)-1] == '\\')
#endif
		{
			m_headerdestination = new char[strlen(dest)];
			strncpy(m_headerdestination, dest, strlen(dest)-1);
			m_headerdestination[strlen(dest)-1]='\0';
		} else
		{
			m_headerdestination = new char[strlen(dest)+1];
			strcpy(m_headerdestination, dest);
		}
	} else
		m_headerdestination = NULL;
}

char *IDL_Global::getImplDestination()
{
	return m_impldestination;
}

void IDL_Global::setImplDestination(char *dest)
{
	if (m_impldestination != NULL) delete(m_impldestination);

	if (dest != NULL) 
	{
#ifdef UNX
		if(dest[strlen(dest)-1] == '/')
#else
		if(dest[strlen(dest)-1] == '\\')
#endif
		{
			m_impldestination = new char[strlen(dest)];
			strncpy(m_impldestination, dest, strlen(dest)-1);
			m_impldestination[strlen(dest)-1]='\0';
		} else
		{
			m_impldestination = new char[strlen(dest)+1];
			strcpy(m_impldestination, dest);
		}
	} else
		m_impldestination = NULL;
}

// Get or set BE args to be used when be is loaded
char* IDL_Global::be_args()
{
	return m_be_args;
}

void IDL_Global::set_be_args(char *args)
{
	if (m_be_args != NULL) delete(m_be_args);

	if (args != NULL) {
		m_be_args = new char[strlen(args)+1];
		strcpy(m_be_args, args);
	} else
		m_be_args = NULL;
}

// Get or set local escapes string. This provides additional mechanism
// to pass information to a BE.
char *IDL_Global::local_escapes()
{
	return m_local_escapes;
}

void IDL_Global::set_local_escapes(char *e)
{
	if (m_local_escapes != NULL) delete(m_local_escapes);

	if (e != NULL) 
	{
		m_local_escapes = new char[strlen(e)+1];
		strcpy(m_local_escapes, e);
	} else 
		m_local_escapes != NULL;
}

// Get or set command line options. This are needed for fork on some systems
char *IDL_Global::options()
{
	return m_options;
}

void IDL_Global::set_options(char *o)
{
	if (m_options != NULL) delete(m_options);

	if (o != NULL) 
	{
		m_options = new char[strlen(o)+1];
		strcpy(m_options, o);
	} else
		m_options = NULL;
}

// Get or set indent object
UTL_Indenter *IDL_Global::indent()
{
	return m_indent;
}

void IDL_Global::set_indent(UTL_Indenter *i)
{
	m_indent = i;
}

// Get or set list of pragmas being parsed
UTL_StrList *IDL_Global::pragmas()
{
	UTL_StrList *p = m_pragmas;

	m_pragmas = NULL;
	return p;
}

void IDL_Global::set_pragmas(UTL_StrList *p)
{
	m_pragmas = p;
}

// Get or set indicator whether we're reading from stdin
sal_Bool IDL_Global::read_from_stdin()
{
	return m_read_from_stdin;
}

void IDL_Global::set_read_from_stdin(sal_Bool r)
{
	m_read_from_stdin = r;
}

void IDL_Global::set_parse_state(ParseState ps)
{
	m_parse_state = ps;
}

IDL_Global::ParseState IDL_Global::parse_state()
{
	return m_parse_state;
}

void IDL_Global::set_idldoc_text(char* doc)
{
	if (m_idldoc_text != NULL) delete(m_idldoc_text);

	if (doc != NULL) 
	{
		m_idldoc_text = new char[strlen(doc)+1];
		strcpy(m_idldoc_text, doc);
	} else
		m_idldoc_text = NULL;

}

char* IDL_Global::idldoc_text()
{
	return m_idldoc_text;
}

void IDL_Global::set_idldoc_valid(int valid)
{
	m_idldoc_valid = valid;
}

int IDL_Global::idldoc_valid()
{
	return m_idldoc_valid;
}

void IDL_Global::setFilePackages(UTL_PkgList *packages)
{
	if (m_file_packages != NULL) delete(m_file_packages);
	m_file_packages = packages;
}

String* IDL_Global::getFilePackagePrefix(String *file)
{
	UTL_PkgListActiveIterator	*iter;
	String						*package = NULL;

	if (m_file_packages != NULL)
	{
		iter = new UTL_PkgListActiveIterator(m_file_packages);
		while (!iter->is_done())
		{
			if (*(iter->item()->getFile()) == *(file))
			{
				package = iter->item()->getPackage();
				break;
			}

			iter->next();
		}
	
		delete iter;
		return package;
	} else
		return package;
}

void IDL_Global::addFilePackagePrefix(String* file, String* package)
{
	if (m_file_packages == NULL)
		m_file_packages = new UTL_PkgList(new UTL_PkgItem(file, package));
	else
		m_file_packages->insert(new UTL_PkgItem(file, package));
}

void IDL_Global::resetSettings()
{
	if (m_file_packages) 
	{
		delete(m_file_packages);
		m_file_packages = NULL;
	}

	if (m_mapTable != NULL)
	{
		delete(m_mapTable);
		m_mapTable = new UTL_MapTable();
	}

	if (m_include_files != NULL)
	{
		delete(m_include_files);
		m_include_files = new IncludeSet();
	}

	if (m_importmap != NULL)
	{
		delete(m_importmap);
		m_importmap = new ImportMap();
		(*m_importmap)[""] = 0;
	}
}

void IDL_Global::setMapping(const String language, const String name, UTL_Map* mapping)
{
	m_mapTable->setMappingOf(language, name, mapping);	
}	

UTL_Map	*IDL_Global::getMapping(const String& language, const String& name)
{
	return(m_mapTable->getMappingOf(language, name));	
}	

void IDL_Global::setIncludeFile(String include)
{
	m_include_files->insert(include);
}	

IncludeSet*	IDL_Global::getIncludeFiles()
{
	return(m_include_files);	
}	

void IDL_Global::setImportOfFile(const String filename, short import)
{
	(*m_importmap)[filename] = import;
}	

short IDL_Global::getImportOfFile(const String& filename)
{
	if (m_importmap->count(filename) > 0)
	{
		return((*m_importmap)[filename]);
	} else
	{
		return(0);	
	}
}	

void IDL_Global::setIncludePrefix(String include)
{
	m_includePrefix = include;
}	

String&	IDL_Global::getIncludePrefix()
{
	return(m_includePrefix);	
}	

void IDL_Global::setProjectName(String name)
{
	m_projectName = name;
}	

String&	IDL_Global::getProjectName()
{
	return(m_projectName);	
}	

/*
 * Convert a PredefinedType to an ExprType
 */
AST_Expression::ExprType 
IDL_Global::PredefinedTypeToExprType(AST_PredefinedType::PredefinedType pt)
{
	switch (pt) 
	{
		case AST_PredefinedType::PT_long:
			return AST_Expression::EV_long;
		case AST_PredefinedType::PT_ulong:
			return AST_Expression::EV_ulong;
		case AST_PredefinedType::PT_short:
			return AST_Expression::EV_short;
		case AST_PredefinedType::PT_ushort:
			return AST_Expression::EV_ushort;
		case AST_PredefinedType::PT_float:
			return AST_Expression::EV_float;
		case AST_PredefinedType::PT_double:
			return AST_Expression::EV_double;
		case AST_PredefinedType::PT_char:
			return AST_Expression::EV_char;
		case AST_PredefinedType::PT_octet:
			return AST_Expression::EV_octet;
		case AST_PredefinedType::PT_boolean:
			return AST_Expression::EV_bool;
		default:
			return AST_Expression::EV_any;
	}
}

/*
 *  help functions
 */
SAL_DLLEXPORT ostream &operator <<(ostream& o, String* i)
{
	o << i->getStr();

	return o;
}
/*
ostream &operator <<(ostream& o, String i)
{
	o << i.nullTermStr();

	return o;
}
*/
SAL_DLLEXPORT ostream &operator <<(ostream& o, const String& i)
{
	o << i.getStr();

	return o;
}
