/*************************************************************************
 *
 *  $RCSfile: utlpkgl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _IDL_HXX_
#include <idl.hxx>
#endif
#ifndef _IDLEXT_HXX_
#include <idlext.hxx>
#endif


UTL_PkgItem::UTL_PkgItem(String* file, String* package)
	:	m_file(file),
		m_package(package)
{
}

UTL_PkgItem::~UTL_PkgItem()
{
	if (m_file != NULL) delete(m_file);
	if (m_package != NULL) delete(m_package);
}

void UTL_PkgItem::setFile(String *file)
{
	if (m_file != NULL) delete(m_file);
	m_file = new String(*file);
}

String* UTL_PkgItem::getFile()
{
	return m_file;
}

void UTL_PkgItem::setPackage(String *package)
{
	if (m_package != NULL) delete(m_package);
	m_package = new String(*package);
}

String* UTL_PkgItem::getPackage()
{
	return m_package;
}


/*
 * Constructor(s)
 */
UTL_PkgList::UTL_PkgList(UTL_PkgItem *s)	
	:	pd_car_data(s),
		UTL_List(NULL)
{
}

UTL_PkgList::UTL_PkgList(UTL_PkgItem *s, UTL_PkgList *cdr)
	:	pd_car_data(s),
		UTL_List(cdr)
{
}

UTL_PkgList::~UTL_PkgList()
{
	//if(pd_car_data != NULL) delete(pd_car_data);
}

/*
 * Private operations
 */

/*
 * Public operations
 */

// Get list item
UTL_PkgItem *UTL_PkgList::head()
{
	return pd_car_data;
}

void UTL_PkgList::insert(UTL_PkgItem *pkgItem)
{
	UTL_PkgListActiveIterator *iter = new UTL_PkgListActiveIterator(this);

	String file;
	while (!iter->is_done())
	{
		file = *(iter->item()->getFile());
		if (*(iter->item()->getFile()) == *(pkgItem->getFile()))
		{
			delete iter;
			return;
		}

		iter->next();
	}

	this->nconc(new UTL_PkgList(pkgItem));
	
	delete iter;
}

/*
 * Redefinition of inherited virtual operations
 */

// UTL_DeclList active iterator

/*
 * Constructor
 */

UTL_PkgListActiveIterator::UTL_PkgListActiveIterator(UTL_PkgList *s)
	:	UTL_ListActiveIterator(s)
{
}

/*
 * Private operations
 */

/*
 * Public operations
 */

// Get current item
UTL_PkgItem *UTL_PkgListActiveIterator::item()
{
	if (source == NULL)
		return NULL;

	return ((UTL_PkgList *) source)->head();
}


