/*************************************************************************
 *
 *  $RCSfile: dbconversion.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UTL_DB_CONVERSION_HXX_
#define _UTL_DB_CONVERSION_HXX_

#ifndef _DATE_HXX
#include <tools/date.hxx>
#endif
#ifndef _TOOLS_TIME_HXX
#include <tools/time.hxx>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

#include <com/sun/star/sdb/XColumnUpdate.hpp>
#include <com/sun/star/sdb/XColumn.hpp>
#include <com/sun/star/util/XNumberFormatter.hpp>

namespace com { namespace sun { namespace star {
 
namespace beans {
	class XPropertySet;
} 

} } }

//.........................................................................
namespace utl
{
//.........................................................................

	namespace staruno	= ::com::sun::star::uno;
	namespace starsdbc	= ::com::sun::star::sdbc;
	namespace starsdb	= ::com::sun::star::sdb;
	namespace starutil	= ::com::sun::star::util;
	namespace starlang	= ::com::sun::star::lang;
	namespace starbeans	= ::com::sun::star::beans;

class DBTypeConversion
{
public:
	static void setValue(const staruno::Reference<starsdb::XColumnUpdate>& xVariant,
								const staruno::Reference<starutil::XNumberFormatter>& xFormatter,
								const Date& rNullDate,
								const ::rtl::OUString& rString,
								sal_Int32 nKey,
								sal_Int16 nFieldType,
								sal_Int16 nKeyType) throw(starlang::IllegalArgumentException);

	static void setValue(const staruno::Reference<starsdb::XColumnUpdate>& xVariant,
					     const Date& rNullDate,
						 const double& rValue,
						 sal_Int16 nKeyType) throw(starlang::IllegalArgumentException);

	static double getValue(const staruno::Reference<starsdb::XColumn>& xVariant, const Date& rNullDate,
							    sal_Int16 nKeyType);

	// get the columnvalue as string with a default format given by the column or a default format
	// for the type
	static ::rtl::OUString getValue(const staruno::Reference<starbeans::XPropertySet>& _xColumn,
								    const staruno::Reference<starutil::XNumberFormatter>& xFormatter,
									const starlang::Locale& _rLocale,
								    const Date& rNullDate);								   
	
	static ::rtl::OUString getValue(const staruno::Reference<starsdb::XColumn>& _xColumn,
								    const staruno::Reference<starutil::XNumberFormatter>& xFormatter,
								    const Date& rNullDate,
								    sal_Int32 nKey,
								    sal_Int16 nKeyType);

	static Date		toDate(double dVal);
	static Time		toTime(double dVal);
	static DateTime	toDateTime(double dVal);

	static double	toDouble(const Date& rVal);
	static double	toDouble(const Time& rVal);
	static double	toDouble(const DateTime& rVal);

	static double	toDouble(const starutil::Date& rVal);
	static double	toDouble(const starutil::Time& rVal);
	static double	toDouble(const starutil::DateTime& rVal);

	static sal_Int32	toINT32(const Date& rVal);
	static sal_Int32	toINT32(const Time& rVal);

	static sal_Int32	toINT32(const starutil::Date& rVal);
	static sal_Int32	toINT32(const starutil::Time& rVal);
};

//.........................................................................
}	// namespace utl
//.........................................................................

#endif // _UTL_DB_CONVERSION_HXX_

