/*************************************************************************
 *
 *  $RCSfile: certctrl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:04:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CERTCTRL_HXX
#define _CERTCTRL_HXX

#ifndef _SV_WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

// class CertDetailWindow ------------------------------------------------

class CertDetailWindow : public Window
{
	FixedText		m_aIssuedFTI;
	FixedText		m_aIssuedFT;
	FixedLine		m_aFL1;
	FixedText		m_aOwnerFTI;
	FixedText		m_aOwnerFT;
	FixedLine		m_aFL2;
	FixedText		m_aFingerPrintFTI;
	FixedText		m_aFingerPrintFT;
	FixedLine		m_aFL3;
	FixedText		m_aValidFTI;
	FixedText		m_aValidFT;

public:
	CertDetailWindow( Window* pParent, ResMgr* pResMgr );

	void SetIssuedBy( const String& rStr )	{ m_aIssuedFT.SetText( rStr ); }
	void SetOwner( const String& rStr )		{ m_aOwnerFT.SetText( rStr ); }
	void SetFinger( const String& rStr )	{ m_aFingerPrintFT.SetText( rStr ); }
	void SetValid( const String& rStr )		{ m_aValidFT.SetText( rStr ); }
};

// class CertDetailEdit --------------------------------------------------

class CertDetailEdit : public Window
{
private:
	FixedText		m_aQueryFT;
	RadioButton		m_aYesRB;
	RadioButton		m_aNoRB;

public:
	CertDetailEdit( Window* pParent, ResMgr* pResMgr );
};


#endif /* _CERTCTRL_HXX */

