/*************************************************************************
 *
 *  $RCSfile: salaqua.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_WINCOMP_HXX
#define _SV_WINCOMP_HXX

#ifndef _STRING_H
#include <string.h>
#endif

#ifndef _SV_SV_H
#include <sv.h>
#endif

// ----------
// - Strict -
// ----------

// Anpassungen fuer TypeChecking

inline HPEN SelectPen( HDC hDC, HPEN hPen )
{
#ifdef WIN
	return (HPEN)SelectObject( hDC, (HGDIOBJ)hPen );
#else
	return NULL;
#endif
}

inline void DeletePen( HPEN hPen )
{
#ifdef WIN
	DeleteObject( (HGDIOBJ)hPen );
#endif
}

inline HPEN GetStockPen( int nObject )
{
#ifdef WIN
	return (HPEN)GetStockObject( nObject );
#else
	return NULL;
#endif
}

inline HBRUSH SelectBrush( HDC hDC, HBRUSH hBrush )
{
#ifdef WIN
	return (HBRUSH)SelectObject( hDC, (HGDIOBJ)hBrush );
#else
	return NULL;
#endif
}

inline void DeleteBrush( HBRUSH hBrush )
{
#ifdef WIN
	DeleteObject( (HGDIOBJ)hBrush );
#endif
}

inline HBRUSH GetStockBrush( int nObject )
{
#ifdef WIN
	return (HBRUSH)GetStockObject( nObject );
#else
	return NULL;
#endif
}

inline HFONT SelectFont( HDC hDC, HFONT hFont )
{
#ifdef WIN
	return (HFONT)SelectObject( hDC, (HGDIOBJ)hFont );
#else
	return NULL;
#endif
}

inline void DeleteFont( HFONT hFont )
{
#ifdef WIN
	DeleteObject( (HGDIOBJ)hFont );
#endif
}

inline HFONT GetStockFont( int nObject )
{
#ifdef WIN
	return (HFONT)GetStockObject( nObject );
#else
	return NULL;
#endif
}

inline HBITMAP SelectBitmap( HDC hDC, HBITMAP hBitmap )
{
#ifdef WIN
	return (HBITMAP)SelectObject( hDC, (HGDIOBJ)hBitmap );
#else
	return NULL;
#endif
}

inline void DeleteBitmap( HBITMAP hBitmap )
{
#ifdef WIN
	DeleteObject( (HGDIOBJ)hBitmap );
#endif
}

inline void DeleteRegion( HRGN hRegion )
{
#ifdef WIN
	DeleteObject( (HGDIOBJ)hRegion );
#endif
}

inline HPALETTE GetStockPalette( int nObject )
{
#ifdef WIN
	return (HPALETTE)GetStockObject( nObject );
#else
	return NULL;
#endif
}

inline void DeletePalette( HPALETTE hPalette )
{
#ifdef WIN
	DeleteObject( (HGDIOBJ)hPalette );
#endif
}

inline void SetWindowStyle( HWND hWnd, DWORD nStyle )
{
#ifdef WIN
	SetWindowLong( hWnd, GWL_STYLE, nStyle );
#endif
}

inline DWORD GetWindowStyle( HWND hWnd )
{
#ifdef WIN
	return GetWindowLong( hWnd, GWL_STYLE );
#else
	return 0;
#endif
}

inline void SetWindowExStyle( HWND hWnd, DWORD nStyle )
{
#ifdef WIN
	SetWindowLong( hWnd, GWL_EXSTYLE, nStyle );
#endif
}

inline DWORD GetWindowExStyle( HWND hWnd )
{
#ifdef WIN
	return GetWindowLong( hWnd, GWL_EXSTYLE );
#else
	return 0;
#endif
}

inline WIN_BOOL IsMinimized( HWND hWnd )
{
#ifdef WIN
	return IsIconic( hWnd );
#else
	return 0;
#endif
}

inline WIN_BOOL IsMaximized( HWND hWnd )
{
#ifdef WIN
	return IsZoomed( hWnd );
#else
	return 0;
#endif
}

inline void SetWindowFont( HWND hWnd, HFONT hFont, WIN_BOOL bRedraw )
{
#ifdef WIN
	SendMessage( hWnd, WM_SETFONT, (WPARAM)hFont, MAKELPARAM((UINT)bRedraw,0) );
#endif
}

inline HFONT GetWindowFont( HWND hWnd )
{
#ifdef WIN
	return (HFONT)(UINT)SendMessage( hWnd, WM_GETFONT, 0, 0 );
#else
	return 0;
#endif
}

inline void SetClassCursor( HWND hWnd, HCURSOR hCursor )
{
#ifdef WIN
	SetClassWord( hWnd, GCL_HCURSOR, (WORD)hCursor );
#endif
}

inline HCURSOR GetClassCursor( HWND hWnd )
{
#ifdef WIN
	return (HCURSOR)GetClassWORD( hWnd, GCL_HCURSOR );
#else
	return 0;
#endif
}

inline void SetClassIcon( HWND hWnd, HICON hIcon )
{
#ifdef WIN
	SetClassWord( hWnd, GCL_HICON, (WORD)hIcon );
#endif
}

inline HICON GetClassIcon( HWND hWnd )
{
#ifdef WIN
	return (HICON)GetClassWord( hWnd, GCL_HICON );
#else
	return 0;
#endif
}

inline HBRUSH SetClassBrush( HWND hWnd, HBRUSH hBrush )
{
#ifdef WIN
	return (HBRUSH)SetClassWord( hWnd, GCW_HBRBACKGROUND, (WORD)hBrush );
#else
	return 0;
#endif
}

inline HBRUSH GetClassBrush( HWND hWnd )
{
#ifdef WIN
	return (HBRUSH)GetClassWord( hWnd, GCW_HBRBACKGROUND );
#else
	return 0;
#endif
}

inline HINSTANCE GetWindowInstance( HWND hWnd )
{
#ifdef WIN
	return (HINSTANCE)GetWindowWord( hWnd, GWW_HINSTANCE );
#else
	return 0;
#endif
}

#ifdef WIN
inline UINT CharLowerBuff( LPSTR lpStr, UINT nLen )
{
	return AnsiLowerBuff( lpStr, nLen );
}
#endif

#ifdef WIN
inline UINT CharUpperBuff( LPSTR lpStr, UINT nLen )
{
	return AnsiUpperBuff( lpStr, nLen );
}
#endif

#ifdef WIN
inline void OemToChar( LPCSTR lpStr1, LPSTR lpStr2 )
{
	OemToAnsi( lpStr1, lpStr2 );
}
#endif

inline void lmemcpy( void* pDst, const void* pSrc, ULONG nSize )
{
	memcpy( pDst, pSrc, nSize );
}

typedef int 	WinWeight;
typedef int	 	(* SysAgt_Enable_PROC)( int );


#ifndef COLOR_HOTLIGHT
#define COLOR_HOTLIGHT					26
#endif
#ifndef COLOR_GRADIENTACTIVECAPTION
#define COLOR_GRADIENTACTIVECAPTION 	27
#endif
#ifndef COLOR_GRADIENTINACTIVECAPTION
#define COLOR_GRADIENTINACTIVECAPTION	28
#endif

#endif // _SV_WINCOMP_HXX
