/*************************************************************************
 *
 *  $RCSfile: clip.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_CLIP_HXX
#define _SV_CLIP_HXX

#ifndef _SOT_EXCHANGE_HXX
#include <sot/exchange.hxx>
#endif
#ifndef _SOT_DTRANS_HXX
#include <sot/dtrans.hxx>
#endif

#ifndef _SV_SV_H
#include <sv.h>
#endif
#ifndef _SV_EXCHANGE_HXX
#include <exchange.hxx>
#endif

class Bitmap;
class GDIMetaFile;

// Neues Clipboard
class VclClipboard : public Exchange
{
private:
	Link					aClearedHdl;

	// SYSTEM_EXCHANGE: Hilfs-Methode fuer System-Schnittstelle
	static void ImplCopyToSystemClipboard( SotDataObject* pData );

	// Hilfs-Methode fuer alte Schnittstelle
	static SotDataMemberObject* ImplGetMemberObject( void );

public:
							VclClipboard();
							~VclClipboard();

	virtual void			Cleared();

	static void 			Clear();

	static void 			Copy( SotDataObject* pData_ );
	static SotDataObject*	Paste( void );

	static void 			ReleaseClipboard( BOOL bFlushToSystem );
	static BOOL 			ExistsSystemClipboard( void );

	// Alte Schnittstellen zunaechst beibehalten und auf SotData mappen
	static BOOL 			CopyString( const UniString& rStr );
	static BOOL 			CopyBitmap( const Bitmap& rBitmap );
	static BOOL 			CopyGDIMetaFile( const GDIMetaFile& rGDIMetaFile );

	// Schein niemand zu benutzen, nur eine (unwichtige) Anwendung im Calc fuer OS/2-Bug:
	static BOOL 			CopyPrivateData( void* pData );

	static BOOL 			CopyData( const void* pData, ULONG nLen,
									  ULONG nFormat, USHORT nTypeLen = 8 );
	static BOOL 			CopyRequest( ULONG nFormat );

	static UniString		PasteString();
	static Bitmap			PasteBitmap();
	static BOOL 			PasteGDIMetaFile( GDIMetaFile& rGDIMetaFile );

	static void*			PastePrivateData(); 	// Schein niemand zu benutzen
	static BOOL 			PasteData( void* pBuf, ULONG nLen, ULONG nFormat );
	static ULONG			GetDataLen( ULONG nFormat );

	static USHORT			GetFormatCount();
	static ULONG			GetFormat( USHORT nPos );
	static BOOL 			HasFormat( ULONG nFormat );

	static ULONG			GetRequestFormat();

	void					SetClearedHdl( const Link& rLink ) { aClearedHdl = rLink; }
	const Link& 			GetClearedHdl() const { return aClearedHdl; }
};

// Altes Clipboard beibehalten:


#define Clipboard VclClipboard

#endif // _SV_CLIP_HXX
