/*************************************************************************
 *
 *  $RCSfile: ooffice.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OOFFICE_HXX
#define _OOFFICE_HXX

#include "rvp.hxx"

// ------------------
// - CORmStarOffice -
// ------------------

class CORmStarOffice : public ::cppu::WeakImplHelper1< NMSP_CLIENT::XRmStarOffice >
{
protected:

	static BOOL						m_isStarOneServer;
	static BOOL						m_isBeanServer;
	static BOOL						m_isStarted;
	static ::vos::OModule*			m_pS2uLib;

public:
	static void eraseRemoteCaches();

	virtual NMSP_CLIENT::StartUpError SAL_CALL Start( 
			const REF( NMSP_LANG::XMultiServiceFactory )& rxFactory,
			const OUSTRING& rConnectionName,
			const OUSTRING& rUserName,
			const OUSTRING& rPassword,
			const OUSTRING& rFileServer,
			const OUSTRING& rClientSystemName,
			const OUSTRING& rAppName,
			const OUSTRING& rAppParams,
			sal_uInt32 nAppLanguage,
			sal_uInt32 nRemoteVersion,
			sal_Int32 nServerType
			);

	virtual void SAL_CALL SetUserInfoForPrinting( const OUSTRING& rUserName, const OUSTRING& rPassword );
									
	virtual void SAL_CALL AddRemotePrinter( const OUSTRING& rPrinterName, const OUSTRING& rPrintServerName,
											sal_Bool bSetDefault, sal_Bool bIsLocal );

    virtual REF( NMSP_UNO::XInterface ) SAL_CALL CreateBeanWindow( const REF( NMSP_CLIENT::XRmFrameWindow )& xFrameWin, 
																   const REF( NMSP_LANG::XMultiServiceFactory )& xClientFactory,
																   const NMSP_UNO::Any& aSystemWindowToken );

public:

				CORmStarOffice( /*ORefCounter& rRef !!!UNO3*/ );
	virtual 	~CORmStarOffice();
									
	static 		void resetState();
};

#endif	// _OOFFICE_HXX
