/*************************************************************************
 *
 *  $RCSfile: salprn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SALPRN_HXX
#define _SV_SALPRN_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _SV_SV_H
#include <sv.h>
#endif
#ifndef _SV_SALPRN_H
#include <salprn.h>
#endif

class SalGraphics;
class SalFrame;
struct ImplJobSetup;

// -----------------------
// - SalPrinterQueueInfo -
// -----------------------

struct SalPrinterQueueInfo
{
	XubString				maPrinterName;
	XubString				maDriver;
	XubString				maLocation;
	XubString				maComment;
	ULONG					mnStatus;
	ULONG					mnJobs;
	void*					mpSysData;

							SalPrinterQueueInfo();
							~SalPrinterQueueInfo();
};


// ------------------
// - SalInfoPrinter -
// ------------------

class SalInfoPrinter
{
	friend class SalInstance;

private:
							SalInfoPrinter();
							~SalInfoPrinter();

public: 					// public for Sal Implementation
	SalInfoPrinterData		maPrinterData;

#ifdef _INCL_SAL_SALIPRN_IMP
#include <saliprn.imp>
#endif

public:
	// SalGraphics or NULL, but two Graphics for all SalFrames
	// must be returned
	SalGraphics*			GetGraphics();
	void					ReleaseGraphics( SalGraphics* pGraphics );

	BOOL					Setup( SalFrame* pFrame, ImplJobSetup* pSetupData );
							// This function set the driver data and
							// set the new indepen data in pSetupData
	BOOL					SetPrinterData( ImplJobSetup* pSetupData );
							// This function merged the indepen driver data
							// and set the new indepen data in pSetupData
							// Only the data must changed, where the bit
							// in nFlags is set
	BOOL					SetData( ULONG nFlags, ImplJobSetup* pSetupData );

	void					GetPageInfo( const ImplJobSetup* pSetupData,
										 long& rOutWidth, long& rOutHeight,
										 long& rPageOffX, long& rPageOffY,
										 long& rPageWidth, long& rPageHeight );
	ULONG					GetCapabilities( const ImplJobSetup* pSetupData, USHORT nType );
	ULONG					GetPaperBinCount( const ImplJobSetup* pSetupData );
	XubString				GetPaperBinName( const ImplJobSetup* pSetupData, ULONG nPaperBin );
};


// --------------
// - SalPrinter -
// --------------

class SalPrinter
{
	friend class SalInstance;

private:
							SalPrinter();
							~SalPrinter();

public: 					// public for Sal Implementation
	SalPrinterData			maPrinterData;

#ifdef _INCL_SAL_SALPRN_IMP
#include <salprn.imp>
#endif

public:
	BOOL					StartJob( const XubString* pFileName,
									  const XubString& rJobName,
									  const XubString& rAppName,
									  ULONG nCopies, BOOL bCollate,
									  ImplJobSetup* pSetupData );
	BOOL					EndJob();
	BOOL					AbortJob();
	SalGraphics*			StartPage( ImplJobSetup* pSetupData, BOOL bNewJobData );
	BOOL					EndPage();
	ULONG					GetErrorCode();
};

#endif // _SV_SALPRN_HXX
