/*************************************************************************
 *
 *  $RCSfile: salwtype.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SALWTYPE_HXX
#define _SV_SALWTYPE_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif

#ifndef _SV_SV_H
#include <sv.h>
#endif

class SalGraphics;
class SalFrame;
class SalObject;
struct ImplFontSelectData;

// -----------------
// - SalExtCharPos -
// -----------------

struct SalExtCharPos
{
	long			mnX;
	long			mnY;
	long			mnWidth;
	long			mnHeight;
};

// ---------------
// - SalExtInput -
// ---------------

// Muessen mit den Defines in cmdevt.hxx uebereinstimmen, da diese
// nicht konvertiert werden
#define SAL_EXTTEXTINPUT_ATTR_INPUT 				((USHORT)0x0001)
#define SAL_EXTTEXTINPUT_ATTR_CONVERTED 			((USHORT)0x0002)
#define SAL_EXTTEXTINPUT_ATTR_TARGETCONVERTED		((USHORT)0x0004)
#define SAL_EXTTEXTINPUT_ATTR_TARGETNOTCONVERTED	((USHORT)0x0008)
#define SAL_EXTTEXTINPUT_ATTR_INPUTERROR			((USHORT)0x0010)

#define SAL_EXTTEXTINPUT_ATTR_GRAYWAVELINE			((USHORT)0x0100)
#define SAL_EXTTEXTINPUT_ATTR_UNDERLINE 			((USHORT)0x0200)
#define SAL_EXTTEXTINPUT_ATTR_BOLDUNDERLINE 		((USHORT)0x0400)
#define SAL_EXTTEXTINPUT_ATTR_DOTTEDUNDERLINE		((USHORT)0x0800)
#define SAL_EXTTEXTINPUT_ATTR_DASHDOTUNDERLINE		((USHORT)0x1000)
#define SAL_EXTTEXTINPUT_ATTR_HIGHLIGHT 			((USHORT)0x2000)
#define SAL_EXTTEXTINPUT_ATTR_REDTEXT				((USHORT)0x4000)

// ------------
// - SalEvent -
// ------------

#define SALEVENT_MOUSEMOVE				((USHORT)1)
#define SALEVENT_MOUSELEAVE 			((USHORT)2)
#define SALEVENT_MOUSEBUTTONDOWN		((USHORT)3)
#define SALEVENT_MOUSEBUTTONUP			((USHORT)4)
#define SALEVENT_KEYINPUT				((USHORT)5)
#define SALEVENT_KEYUP					((USHORT)6)
#define SALEVENT_KEYMODCHANGE			((USHORT)7)
#define SALEVENT_PAINT					((USHORT)8)
#define SALEVENT_RESIZE 				((USHORT)9)
#define SALEVENT_GETFOCUS				((USHORT)10)
#define SALEVENT_LOSEFOCUS				((USHORT)11)
#define SALEVENT_CLOSE					((USHORT)12)
#define SALEVENT_SHUTDOWN				((USHORT)13)
#define SALEVENT_SETTINGSCHANGED		((USHORT)14)
#define SALEVENT_VOLUMECHANGED			((USHORT)15)
#define SALEVENT_PRINTERCHANGED 		((USHORT)16)
#define SALEVENT_DISPLAYCHANGED 		((USHORT)17)
#define SALEVENT_FONTCHANGED			((USHORT)18)
#define SALEVENT_DATETIMECHANGED		((USHORT)19)
#define SALEVENT_KEYBOARDCHANGED		((USHORT)20)
#define SALEVENT_WHEELMOUSE 			((USHORT)21)
#define SALEVENT_USEREVENT				((USHORT)22)
#define SALEVENT_MOUSEACTIVATE			((USHORT)23)
#define SALEVENT_STARTEXTTEXTINPUT		((USHORT)24)
#define SALEVENT_EXTTEXTINPUT			((USHORT)25)
#define SALEVENT_ENDEXTTEXTINPUT		((USHORT)26)
#define SALEVENT_EXTTEXTINPUTPOS		((USHORT)27)
#define SALEVENT_INPUTCONTEXTCHANGE 	((USHORT)28)
#define SALEVENT_CURSORPOS				((USHORT)29)
#define SALEVENT_COUNT					((USHORT)29)

// MOUSELEAVE must send, when the pointer leave the client area and
// the mouse is not captured
// MOUSEMOVE, MOUSELEAVE, MOUSEBUTTONDOWN and MOUSEBUTTONUP
// MAC: Ctrl+Button is MOUSE_RIGHT
struct SalMouseEvent
{
	ULONG			mnTime; 		// Time in ms, when event is created
	long			mnX;			// X-Position (Pixel, TopLeft-Output)
	long			mnY;			// Y-Position (Pixel, TopLeft-Output)
	USHORT			mnButton;		// 0-MouseMove/MouseLeave, MOUSE_LEFT, MOUSE_RIGHT, MOUSE_MIDDLE
	USHORT			mnCode; 		// SV-ModifierCode (KEY_SHIFT | KEY_MOD1 | KEY_MOD2 | MOUSE_LEFT | MOUSE_MIDDLE | MOUSE_RIGHT)
};

// KEYINPUT and KEYUP
struct SalKeyEvent
{
	ULONG			mnTime; 		// Time in ms, when event is created
	USHORT			mnCode; 		// SV-KeyCode (KEY_xxx | KEY_SHIFT | KEY_MOD1 | KEY_MOD2)
	USHORT			mnCharCode; 	// SV-CharCode
	USHORT			mnRepeat;		// Repeat-Count (KeyInputs-1)
};

// KEYMODCHANGE
struct SalKeyModEvent
{
	ULONG			mnTime; 		// Time in ms, when event is created
	USHORT			mnCode; 		// SV-ModifierCode (KEY_SHIFT | KEY_MOD1 | KEY_MOD2)
};

// PAINT
struct SalPaintEvent
{
	long			mnBoundX;		// BoundRect - X
	long			mnBoundY;		// BoundRect - Y
	long			mnBoundWidth;	// BoundRect - Width
	long			mnBoundHeight;	// BoundRect - Height
};

// USEREVENT
// pEvent == pData

// WHEELMOUSE
#define SAL_WHEELMOUSE_EVENT_PAGESCROLL 	((ULONG)0xFFFFFFFF)
struct SalWheelMouseEvent
{
	ULONG			mnTime; 		// Time in ms, when event is created
	long			mnX;			// X-Position (Pixel, TopLeft-Output)
	long			mnY;			// Y-Position (Pixel, TopLeft-Output)
	long			mnDelta;		// Anzahl Drehungen
	long			mnNotchDelta;	// Anzahl feste Drehungen
	ULONG			mnScrollLines;	// Aktuelle Anzahl zu scrollende Zeilen
	USHORT			mnCode; 		// SV-ModifierCode (KEY_SHIFT | KEY_MOD1 | KEY_MOD2 | MOUSE_LEFT | MOUSE_MIDDLE | MOUSE_RIGHT)
	BOOL			mbHorz; 		// Horizontal
};

// MOUSEACTIVATE
struct SalMouseActivateEvent
{
	long			mnX;			// X-Position (Pixel, TopLeft-Output)
	long			mnY;			// Y-Position (Pixel, TopLeft-Output)
};

// EXTTEXTINPUT
struct SalExtTextInputEvent
{
	ULONG			mnTime; 		// Time in ms, when event is created
#ifdef ENABLEDBCS
	UniString		maText; 		// Text
#else
	XubString		maText; 		// Text
#endif
	const USHORT*	mpTextAttr; 	// Text-Attribute
	ULONG			mnCursorPos;	// Cursor-Position
	ULONG			mnDeltaStart;	// Start-Position der letzten Aenderung
	BOOL			mbCursorVisible;// TRUE: Cursor soll angezeigt werden
	BOOL			mbOnlyCursor;	// TRUE: Nur Cursor-Position wurde geaendert
};

// EXTTEXTINPUTPOS
struct SalExtTextInputPosEvent
{
	ULONG			mnTime; 		// Time in ms, when event is created
	SalExtCharPos*	mpPosAry;		// Array mit allen Zeichen-Positionen
	ULONG			mnFirstPos; 	// Erste Position
	ULONG			mnChars;		// Anzahl Zeichen
};

// INPUTCONTEXTCHANGE
struct SalInputContextChangeEvent
{
	CharSet 		meCharSet;		// Neuer CharSet
	LanguageType	meLanguage; 	// Neue Sprache
};

// CURSORPOS
struct SalCursorPosEvent
{
	long			mnX;			// Cursor-X-Position to upper left corner of frame
	long			mnY;			// Cursor-Y-Position to upper left corner of frame
	long			mnWidth;		// Cursor-Width in Pixel
	long			mnHeight;		// Cursor-Height in Pixel
};

// ------------------
// - SalFrame-Types -
// ------------------

typedef long (*SALFRAMEPROC)( void* pInst, SalFrame* pFrame,
							  USHORT nEvent, const void* pEvent );


// --------------------
// - SalObject-Events -
// --------------------

#define SALOBJ_EVENT_GETFOCUS			((USHORT)1)
#define SALOBJ_EVENT_LOSEFOCUS			((USHORT)2)
#define SALOBJ_EVENT_TOTOP				((USHORT)3)
#define SALOBJ_EVENT_COUNT				((USHORT)4)

// ------------------
// - SalObject-Types -
// ------------------

typedef long (*SALOBJECTPROC)( void* pInst, SalObject* pObject,
							   USHORT nEvent, const void* pEvent );


// -----------------
// - SalFrameState -
// -----------------

#define SAL_FRAMESTATE_MINIMIZED		((ULONG)0x00000001)
#define SAL_FRAMESTATE_MAXIMIZED		((ULONG)0x00000002)

struct SalFrameState
{
	long			mnX;
	long			mnY;
	long			mnWidth;
	long			mnHeight;
	ULONG			mnState;
};


// -------------------
// - SalInputContext -
// -------------------

// Muessen mit den Defines in inputctx.hxx uebereinstimmen, da diese
// nicht konvertiert werden
#define SAL_INPUTCONTEXT_TEXT				((ULONG)0x00000001)
#define SAL_INPUTCONTEXT_EXTTEXTINPUT		((ULONG)0x00000002)
#define SAL_INPUTCONTEXT_EXTTEXTINPUT_ON	((ULONG)0x00000004)
#define SAL_INPUTCONTEXT_EXTTEXTINPUT_OFF	((ULONG)0x00000008)

struct SalInputContext
{
	ImplFontSelectData* 	mpFont;
	CharSet 				meCharSet;
	LanguageType			meLanguage;
	ULONG					mnOptions;
};


// ------------------
// - SalTimer-Types -
// ------------------

typedef void (*SALTIMERPROC)();


#endif // _SV_SALWTYPE_HXX
