/*************************************************************************
 *
 *  $RCSfile: svdata.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SVDATA_HXX
#define _SV_SVDATA_HXX

#ifndef _VOS_THREAD_HXX
#include <vos/thread.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

#ifndef _SV_SV_H
#include <sv.h>
#endif

struct ImplTimerData;
struct ImplFileImageCacheData;
struct ImplConfigData;
struct ImplFontSubstEntry;
struct ImplHotKey;
struct ImplEventHook;
class Point;
class Rectangle;
class ImpResMgr;
class ResMgr;
class UniqueIndex;
class ImplAccelManager;
class ImplDevFontList;
class ImplFontCache;
class HelpTextWindow;
class ImplTBDragMgr;
class ImplButtonList;
class ImplIdleMgr;
class DbgWindow;
class FloatingWindow;
class AllSettings;
class KeyCode;
class NotifyEvent;
class Timer;
class AutoTimer;
class Help;
class ImageList;
class PopupMenu;
class Application;
class OutputDevice;
class Window;
class SystemWindow;
class WorkWindow;
class Dialog;
class VirtualDevice;
class Printer;
class SalFrame;
class SalInstance;
class SalSystem;
class SalProcessWindowList;
class SalTrayList;
class UniqueIdContainer;
class ImplClipTab;
class ImplDragTab;
class DragManager;
class ClipManager;
class List;
class ImplPrnQueueList;
class ImplVDevCache;
class UnoWrapperBase;
class GraphicConverter;
class ImplWheelWindow;

#ifdef _VOS_NO_NAMESPACE
class OMutex;
class OCondition;
#else
namespace vos { class OMutex; }
namespace vos { class OCondition; }
#endif

// ----------
// - Remote -
// ----------

#ifdef REMOTE_APPSERVER
class VclOTimer;
class RmEventQueue;
class UNODispatchThread;
class XRmStatus;
class XFactory;
class XMultiInstanceFactory;
class RemotePrinterList;

// see atom.hxx
namespace vcl {
	class AtomClient;
}

#include <tools/table.hxx>
#include <vos/mutex.hxx>
#include <vos/thread.hxx>
#include <vos/semaphor.hxx>
#include "rvp.hxx"

DECLARE_TABLE( KeyNames, String* );

class ImplRemoteYieldMutex : public NAMESPACE_VOS(OMutex)
{
	ULONG										mnCount;
	NAMESPACE_VOS(OThread)::TThreadIdentifier	mnThreadId;
	NAMESPACE_VOS(OThread)::TThreadIdentifier	mnMainThreadId;

public:
												ImplRemoteYieldMutex();

	virtual void SAL_CALL						acquire();
	virtual void SAL_CALL						release();
	virtual sal_Bool SAL_CALL					tryToAcquire();

	ULONG										GetAcquireCount() const { return mnCount; }
	NAMESPACE_VOS(OThread)::TThreadIdentifier	GetThreadId() const { return mnThreadId; }
	NAMESPACE_VOS(OThread)::TThreadIdentifier	GetMainThreadId() const { return mnMainThreadId; }
};

struct UserOnPrintServer
{
	String	sName;
	String	sPassword;
};

#endif

// -----------------
// - ImplSVAppData -
// -----------------

struct ImplSVAppData
{
#ifdef REMOTE_APPSERVER
	ImplRemoteYieldMutex*	mpSolarMutex;		// Solar-Mutex
#endif
	AllSettings*			mpSettings; 		// Application settings
	ImplAccelManager*		mpAccelMgr; 		// Accelerator Manager
	XubString*				mpAppName;			// Application name
	XubString*				mpAppFileName;		// Abs. Application FileName
	XubString*				mpDisplayName;		// Application Display Name
	XubString*				mpResPath;			// Resource-Path
	Help*					mpHelp; 			// Application help
	PopupMenu*				mpActivePopupMenu;	// Actives Popup-Menu (in Execute)
	UniqueIdContainer*		mpUniqueIdCont; 	// Fuer Eindeutige Id's
	ImplIdleMgr*			mpIdleMgr;			// Idle-Manager
	ImplWheelWindow*		mpWheelWindow;		// WheelWindow
	ImplHotKey* 			mpFirstHotKey;		// HotKey-Verwaltung
	ImplEventHook*			mpFirstEventHook;	// Event-Hooks
	List*					mpAccessList;		// Accessibilty
	ULONG					mnLastInputTime;	// GetLastInputTime()
	USHORT					mnDispatchLevel;	// DispatchLevel
	USHORT					mnModalMode;		// ModalMode Count
	USHORT					mnModalDialog;		// ModalDialog Count
	USHORT					mnAccessCount;		// AccessHdl Count
	USHORT					mnSysWinMode;		// Modus, wann SystemWindows erzeugt werden sollen
	USHORT					mnLayout;			// --- RTL-Flags --- currently not used, only for testing
	short					mnDialogScaleX; 	// Scale X-Positions and sizes in Dialogs
	BOOL					mbInAppMain;		// is Application::Main() on stack
	BOOL					mbInAppExecute; 	// is Application::Execute() on stack
	BOOL					mbAppQuit;			// is Application::Quit() called
	BOOL					mbSettingsInit; 	// TRUE: Settings are init
	BOOL					mbIntnChanged;		// TRUE: International-Settings Changed
	BOOL					mbAutoMnemonics;	// TRUE: Create Mnemonics for Menus/Dialogs
	BOOL					mbDialogCancel; 	// TRUE: Alle Dialog::Execute()-Aufrufe werden mit return FALSE sofort beendet

							DECL_STATIC_LINK( ImplSVAppData, ImplQuitMsg, void* );
};


// -----------------
// - ImplSVGDIData -
// -----------------

struct ImplSVGDIData
{
	OutputDevice*			mpFirstWinGraphics; // First OutputDevice with a Frame Graphics
	OutputDevice*			mpLastWinGraphics;	// Last OutputDevice with a Frame Graphics
	OutputDevice*			mpFirstVirGraphics; // First OutputDevice with a VirtualDevice Graphics
	OutputDevice*			mpLastVirGraphics;	// Last OutputDevice with a VirtualDevice Graphics
	OutputDevice*			mpFirstPrnGraphics; // First OutputDevice with a InfoPrinter Graphics
	OutputDevice*			mpLastPrnGraphics;	// Last OutputDevice with a InfoPrinter Graphics
	VirtualDevice*			mpFirstVirDev;		// First VirtualDevice
	VirtualDevice*			mpLastVirDev;		// Last VirtualDevice
	Printer*				mpFirstPrinter; 	// First Printer
	Printer*				mpLastPrinter;		// Last Printer
	ImplPrnQueueList*		mpPrinterQueueList; // List of all printer queue
	ImplDevFontList*		mpScreenFontList;	// Screen-Font-List
	ImplFontCache*			mpScreenFontCache;	// Screen-Font-Cache
	ImplFontSubstEntry* 	mpFirstFontSubst;	// First Entry in Font-Substitute-List
	GraphicConverter*		mpGrfConverter; 	// Converter for graphics
	long					mnRealAppFontX; 	// AppFont X-Numenator for 40/tel Width
	long					mnAppFontX; 		// AppFont X-Numenator for 40/tel Width + DialogScaleX
	long					mnAppFontY; 		// AppFont Y-Numenator for 80/tel Height
	BOOL					mbFontSubChanged;	// TRUE: FontSubstitution wurde zwischen Begin/End geaendert
};


// -----------------
// - ImplSVWinData -
// -----------------

struct ImplSVWinData
{
	Window* 				mpFirstFrame;		// First FrameWindow
	Window* 				mpDefDialogParent;	// Default Dialog Parent
	WorkWindow* 			mpAppWin;			// Application-Window
	Window* 				mpFocusWin; 		// window, that has the focus
	Window* 				mpCaptureWin;		// window, that has the mouse capture
	Window* 				mpLastDeacWin;		// Window, that need a deactivate (FloatingWindow-Handling)
	DbgWindow*				mpDbgWin;			// debug window
	FloatingWindow* 		mpFirstFloat;		// First FloatingWindow in PopupMode
	Dialog* 				mpLastExecuteDlg;	// Erster Dialog, der sich in Execute befindet
	Window* 				mpTrackWin; 		// window, that is in tracking mode
	AutoTimer*				mpTrackTimer;		// tracking timer
	ImageList*				mpMsgBoxImgList;	// ImageList for MessageBoxen
	Window* 				mpAutoScrollWin;	// window, that is in AutoScrollMode mode
	USHORT					mnTrackFlags;		// tracking flags
	USHORT					mnAutoScrollFlags;	// auto scroll flags
	BOOL					mbNoDeactivate; 	// TRUE: keine Deactivate durchfuehren
	BOOL					mbDummy1;
};


// ------------------
// - ImplSVCtrlData -
// ------------------

struct ImplSVCtrlData
{
	ImageList*				mpCheckImgList; 	// ImageList for CheckBoxes
	ImageList*				mpRadioImgList; 	// ImageList for RadioButtons
	ImageList*				mpPinImgList;		// ImageList for PIN
	ImageList*				mpSplitHPinImgList; // ImageList for Horizontale SplitWindows
	ImageList*				mpSplitVPinImgList; // ImageList for Vertikale SplitWindows (PIN's)
	ImageList*				mpSplitHArwImgList; // ImageList for Horizontale SplitWindows (Arrows)
	ImageList*				mpSplitVArwImgList; // ImageList for Vertikale SplitWindows (Arrows)
	ImplTBDragMgr*			mpTBDragMgr;		// DragMgr for ToolBox
	ImplButtonList* 		mpButtonList;		// ButtonList for ToolBox
	USHORT					mnCheckStyle;		// CheckBox-Style for ImageList-Update
	USHORT					mnRadioStyle;		// Radio-Style for ImageList-Update
	ULONG					mnLastCheckFColor;	// Letzte FaceColor fuer CheckImage
	ULONG					mnLastCheckWColor;	// Letzte WindowColor fuer CheckImage
	ULONG					mnLastCheckLColor;	// Letzte LightColor fuer CheckImage
	ULONG					mnLastRadioFColor;	// Letzte FaceColor fuer RadioImage
	ULONG					mnLastRadioWColor;	// Letzte WindowColor fuer RadioImage
	ULONG					mnLastRadioLColor;	// Letzte LightColor fuer RadioImage
};


// ------------------
// - ImplSVHelpData -
// ------------------

struct ImplSVHelpData
{
	BOOL					mbContextHelp;		// is ContextHelp enabled
	BOOL					mbExtHelp;			// is ExtendedHelp enabled
	BOOL					mbExtHelpMode;		// is in ExtendedHelp Mode
	BOOL					mbOldBalloonMode;	// BallonMode, befor ExtHelpMode started
	BOOL					mbBalloonHelp;		// is BalloonHelp enabled
	BOOL					mbQuickHelp;		// is QuickHelp enabled
	BOOL					mbAutoHelpId;		// generate HelpIds
	BOOL					mbRequestingHelp;	// In Window::RequestHelp
	HelpTextWindow* 		mpHelpWin;			// HelpWindow
};


// --------------------
// - ImplSVSystemData -
// --------------------

struct ImplSVSystemData
{
#ifndef REMOTE_APPSERVER
	SalSystem*				mpDefSystem;		// Default-System-Instance
#endif
};

// ----------------
// - ImplClipData -
// ----------------

struct ImplExchangeData
{
	DragManager*			mpActiveDragManager;// != NULL during Drag&Drop
	DragManager*			mpDragManager;		// instance of DragManager
	ClipManager*			mpClipManager;		// instance of ClipManager
	// Unterstuetzung der alten Schnittstelle
	ULONG					mnClipReqFormat;	// Format to render for Clipboard
	ULONG					mnDragReqFormat;	// Format to render for DragServer
	ImplClipTab*			mpClipTab;			// list of all Clipboard instances
	ImplDragTab*			mpDragTab;			// list of all DragServer instances
	USHORT					mnDragItem; 		// Active Item in xDragServerData
};


// --------------
// - ImplSVData -
// --------------

struct ImplSVData
{
	void*					mpSalData;			// SalData
	SalInstance*			mpDefInst;			// Default SalInstance
	Application*			mpApp;				// pApp
	WorkWindow* 			mpDefaultWin;		// Default-Window
	BOOL					mbInit; 			// Is VCL initialized
	ULONG					mnThreadCount;		// is VCL MultiThread enabled
	ImplConfigData* 		mpFirstConfigData;	// Zeiger auf ersten Config-Block
	ImplTimerData*			mpFirstTimerData;	// list of all running timers
	ResMgr* 				mpResMgr;			// SV-Resource-Manager
	ULONG					mnTimerPeriod;		// current timer period
	ULONG					mnTimerUpdate;		// TimerCallbackProcs on stack
	BOOL					mbNotAllTimerCalled;// TRUE: Es muessen noch Timer abgearbeitet werden
	BOOL					mbNoCallTimer;		// TRUE: No Timeout calls
	ImplSVAppData			maAppData;			// indepen data for class Application
	ImplSVGDIData			maGDIData;			// indepen data for Output classes
	ImplSVWinData			maWinData;			// indepen data for Windows classes
	ImplSVCtrlData			maCtrlData; 		// indepen data for Control classes
	ImplSVHelpData			maHelpData; 		// indepen data for Help classes
	ImplSVSystemData		maSystemData;		// indepen data for class System
	ImplExchangeData		maExchangeData; 	// indepen data for Clipboard / Drag&Drop

	UnoWrapperBase* 		mpUnoWrapper;

#ifdef _VOS_NO_NAMESPACE
	OThread::TThreadIdentifier			mnMainThreadId;
#else
	vos::OThread::TThreadIdentifier 	mnMainThreadId;
#endif

#ifdef REMOTE_APPSERVER
	VclOTimer*							mpOTimer;			// VOS-Timer
	RmEventQueue*						mpRmEventQueue; 	// Remote-EventQueue
	REF( NMSP_CLIENT::XRmStatus )				mxStatus;			// Remote-Status
	REF( NMSP_LANG::XMultiServiceFactory )		mxClientFactory;	// XFactory zum erzeugen der UNO-Objekte statt ueber UNO_createObject
	REF( NMSP_CLIENT::XMultiInstanceFactory )	mxMultiFactory; 	// XFactory zum erzeugen der UNO-Objekte statt ueber UNO_createObject
	::vcl::AtomClient*					mpAtoms;			// Atoms for client connection
	::vos::OMutex*						mpWindowObjectMutex;
	::vos::OCondition*					mpStartUpCond;
	void*								mhRemoteEnv;		// not needed anymore
	String* 							mpConnectionName;
	KeyNames*							mpKeyNames;
	UserOnPrintServer*					mpUserInfo; 		// Will be used for Login to Print Server
	RemotePrinterList*					mpRemotePrinterList;
//	UNO_Server							mhRemotePrinter;	// UNO-PrinterServer
//	XRmPrinterEnvironment*				mpRmPrinterEnv; 	// UNO-Printer-Environment
#endif
};

void		ImplInitSVData();
void		ImplDeInitSVData();
void		ImplDestroySVData();
void		ImplDeInitTimer();
Window* 	ImplGetDefaultWindow();
ResMgr* 	ImplGetResMgr();
void		ImplWindowAutoMnemonic( Window* pWindow );
void		ImplTimerCallbackProc();

#ifndef REMOTE_APPSERVER
void		ImplUpdateSystemProcessWindow();
Window* 	ImplFindWindow( const SalFrame* pFrame, Point& rSalFramePos );
#endif

// SVAPP.CXX
BOOL		ImplCallHotKey( const KeyCode& rKeyCode );
void		ImplFreeHotKeyData();
void		ImplFreeEventHookData();

// WINPROC.CXX
long		ImplCallPreNotify( NotifyEvent& rEvt );
long		ImplCallEvent( NotifyEvent& rEvt );

#ifdef WIN
ImplSVData* ImplGetSVData();
inline ImplSVData* ImplGetSVData() { return *((ImplSVData**)GetAppData( SHL_SV )); }
#else
extern ImplSVData* pImplSVData;
inline ImplSVData* ImplGetSVData() { return pImplSVData; }
#endif
inline ImplSVData* ImplGetAppSVData() { return *((ImplSVData**)GetAppData( SHL_SV )); }

// -----------------
// - ImplSVShlData -
// -----------------

struct ImplSVShlData
{
};

extern ImplSVShlData aImplSVShlData;

// -----------------------------------------------------------------------

// -----------------
// - ImplSVEmpyStr -
// -----------------

// Empty-SV-String
extern XubString& rImplSVEmptyStr;
inline const XubString& ImplGetSVEmptyStr() { return rImplSVEmptyStr; }
#ifdef ENABLEUNICODE
extern ByteString& rImplSVEmptyByteStr;
inline const ByteString& ImplGetSVEmptyByteStr() { return rImplSVEmptyByteStr; }
#else
#define ImplGetSVEmptyByteStr ImplGetSVEmptyByteStr
#endif

// -----------------------------------------------------------------------

// ----------------------
// - struct ImplDelData -
// ----------------------

struct ImplDelData
{
	BOOL			mbDel;
	ImplDelData*	mpNext;

					ImplDelData() { mbDel = FALSE; }

	BOOL			IsDelete() const { return mbDel; }
};

// ---------------
// - ImplSVEvent -
// ---------------

struct ImplSVEvent
{
	ULONG				mnEvent;
	void*				mpData;
	Link*				mpLink;
	Window* 			mpWindow;
	ImplDelData 		maDelData;
	BOOL				mbCall;
};

#endif	// _SV_SVDATA_HXX
