/*************************************************************************
 *
 *  $RCSfile: SALBMP.HXX,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRUNTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRUNTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SALBMP_HXX
#define _SV_SALBMP_HXX

#ifndef _SV_SVMAC_H
#include <svmac.h>
#endif

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _SV_SV_H
#include <sv.h>
#endif

// --------------
// - SalBitmap	-
// --------------

struct	BitmapBuffer;
class	BitmapColor;
class	BitmapPalette;
class	SalGraphics;

class SalBitmap
{
private:

	PixMapHandle		mhPixMap;
	Size				maSize;
	USHORT				mnBitCount;

public:

	BOOL				ImplCreate( PixMapHandle hPixMap, BOOL bCopyHandle );
	PixMapHandle 		ImplGethPixMap() const { return mhPixMap; }

	static PixMapHandle	ImplCreatePixMap( const Size& rSize, USHORT nBitCount, const BitmapPalette& rPal );

public:

						SalBitmap();
						~SalBitmap();
public:

	BOOL				Create( const Size& rSize, USHORT nBitCount, const BitmapPalette& rPal );
	BOOL				Create( const SalBitmap& rSalBmpImpl );
	BOOL				Create( const SalBitmap& rSalBmpImpl, SalGraphics* pGraphics );
	BOOL				Create( const SalBitmap& rSalBmpImpl, USHORT nNewBitCount );

	void				Destroy();

	Size				GetSize() const { return maSize; }
	USHORT				GetBitCount() const { return mnBitCount; }

	BitmapBuffer*		AcquireBuffer( BOOL bReadOnly );
	void				ReleaseBuffer( BitmapBuffer* pBuffer, BOOL bReadOnly );
};

#endif // _SV_SALBMP_HXX
