/*************************************************************************
 *
 *  $RCSfile: salogl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/



#define _SV_SALOGL_CXX



#ifndef _SV_SALOGL_HXX

#include <salogl.hxx>

#endif

#ifndef _SV_SALGDI_HXX

#include <salgdi.hxx>

#endif



// ------------

// - Lib-Name -

// ------------



/*

#ifdef WIN

#define OGL_LIBNAME "OPENGL.DLL"

#else

#define OGL_LIBNAME "OPENGL32.DLL"

#endif

*/



// ----------

// - Macros -

// ----------



/*

#define GET_OGLFNC_WGL( FncName )				\

pFnc##FncName = (OGLFnc##FncName##) 			\

	GetProcAddress( mhOGLLib, "wgl" #FncName );	\

if( !pFnc##FncName## )							\

	bRet = FALSE;

*/



// -----------------

// - Statics init. -

// -----------------



// Members

/*

HINSTANCE	SalOpenGL::mhOGLLib = 0;

HGLRC		SalOpenGL::mhOGLContext = 0;

HDC			SalOpenGL::mhOGLLastDC = 0;

*/

ULONG		SalOpenGL::mnOGLState = OGL_STATE_UNLOADED;



/*

INIT_OGLFNC( SalOpenGL, CreateContext );

INIT_OGLFNC( SalOpenGL, DeleteContext );

INIT_OGLFNC( SalOpenGL, GetCurrentContext );

INIT_OGLFNC( SalOpenGL, MakeCurrent );

*/



// -------------

// - SalOpenGL -

// -------------



SalOpenGL::SalOpenGL( SalGraphics* pGraphics )

{

/*

	mhOGLLastDC = pGraphics->maGraphicsData.mhDC;

*/

}



// ------------------------------------------------------------------------



SalOpenGL::~SalOpenGL()

{

}



// ------------------------------------------------------------------------



BOOL SalOpenGL::Create()

{

	BOOL bRet = FALSE;



	if( OGL_STATE_UNLOADED == mnOGLState )

	{

		if( ImplInitLib() )

		{

/*

			PIXELFORMATDESCRIPTOR pfd = 

			{

				sizeof( PIXELFORMATDESCRIPTOR ),

				1,

				PFD_DRAW_TO_WINDOW | PFD_SUPPORT_GDI | PFD_SUPPORT_OPENGL,

				PFD_TYPE_RGBA,

				GetDeviceCaps( mhOGLLastDC, BITSPIXEL ),

				0, 0, 0, 0, 0, 0,

				0,

				0,

				0,

				0, 0, 0, 0,

				16,                 

				0,                  

				0,                  

				PFD_MAIN_PLANE,		

				0,	

				0, 0, 0

			};

			

			const int nIndex = ChoosePixelFormat( mhOGLLastDC, &pfd );



			if( nIndex && SetPixelFormat( mhOGLLastDC, nIndex, &pfd ) ) 

			{

				if( ImplInit() && ( mhOGLContext = pFncCreateContext( mhOGLLastDC ) ) != 0 )

				{

					SaveDC( mhOGLLastDC );

					SelectClipRgn( mhOGLLastDC, NULL );

					pFncMakeCurrent( mhOGLLastDC, mhOGLContext );

					RestoreDC( mhOGLLastDC, -1 );

					mnOGLState = OGL_STATE_VALID;

					bRet = TRUE;

				}

				else

				{

					ImplFreeLib();

					mnOGLState = OGL_STATE_INVALID;

				}

			}

			else

				mnOGLState = OGL_STATE_INVALID;

*/

		}			

		else

			mnOGLState = OGL_STATE_INVALID;

	}

	else if( OGL_STATE_VALID == mnOGLState )

		bRet = TRUE;



	return bRet;

}



// ------------------------------------------------------------------------



void SalOpenGL::Release()

{

	ImplFreeLib();

}



// ------------------------------------------------------------------------



void* SalOpenGL::GetOGLFnc( const String& rFncName )

{

	return NULL;

/*

	if( mhOGLLib )

		return( (void*) GetProcAddress( mhOGLLib, rFncName ) );

	else

		return NULL;

*/

}



// ------------------------------------------------------------------------



void SalOpenGL::OGLEntry( SalGraphics* pGraphics )

{

/*	

	if( pGraphics->maGraphicsData.mhDC != mhOGLLastDC )

	{												

		mhOGLLastDC = pGraphics->maGraphicsData.mhDC;

		SaveDC( mhOGLLastDC );

		pFncMakeCurrent( mhOGLLastDC, mhOGLContext );

		RestoreDC( mhOGLLastDC, -1 );

	}

*/

}



// ------------------------------------------------------------------------



void SalOpenGL::OGLExit( SalGraphics* pGraphics )

{

}



// ------------------------------------------------------------------------



BOOL SalOpenGL::ImplInitLib()

{

	return FALSE;

/*

	return( ( mhOGLLib = LoadLibrary( OGL_LIBNAME ) ) != NULL );

*/

}



// ------------------------------------------------------------------------



void SalOpenGL::ImplFreeLib()

{

/*

	if( mhOGLLib )

	{

		FreeLibrary( mhOGLLib );

		mhOGLLib = NULL;

		mnOGLState = OGL_STATE_UNLOADED;

	}

*/

}



// ------------------------------------------------------------------------



BOOL SalOpenGL::ImplInit()

{

	return FALSE;

/*

	BOOL bRet = TRUE;



	// Internal use

	GET_OGLFNC_WGL( CreateContext );

	GET_OGLFNC_WGL( DeleteContext );

	GET_OGLFNC_WGL( GetCurrentContext );

	GET_OGLFNC_WGL( MakeCurrent );



	return bRet;

*/

}

