/*************************************************************************
 *
 *  $RCSfile: macex.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define __MACEX_CXX
#include <stdlib.h>
#include <stdio.h>

#include <mac_start.h>
#include <Types.h>
#include <Memory.h>
#include <Scrap.h>
#include <Events.h>
#include <Drag.h>
#include <Files.h>
#include <Finder.h>
#include <mac_end.h>

#include <window.hxx>
#include <svdata.hxx>
#include <svapp.hxx>
#include <drag.hxx>
#include <exchange.hxx>
#include <tools/stream.hxx>

#ifndef _SV_SALDATA_HXX
#include <saldata.hxx>
#endif

#ifndef _SV_SALFRAME_HXX
#include <salframe.hxx>
#endif

#ifndef _NEW_HXX
#include <tools/new.hxx>
#endif

#include <salinst.hxx>
#include <salctype.hxx>
#include <saldata.hxx>
#include <sysexchg.hxx>
#include <getsys.hxx>
#include <vcl/sysex.h>
#include <ptrstyle.hxx>

#include "macex.hxx"

// Die Mac-Resource-Typen

#define MAC_FORMAT_TEXT			'TEXT'
#define MAC_FORMAT_PICT			'PICT'
#define MAC_FORMAT_FILE			'hfs '
#define MAC_FORMAT_RTF				'RTF '
#define MAC_FORMAT_PRIVATE			'SOF4'
#define MAC_FORMAT_HTML			'HTML'
#define MAC_FORMAT_NONE			'\0\0\0\0'

// Standard-Formate fuer die es auch Copy/Paste-Methoden gibt
#define	FORMAT_NONE				0
#define FORMAT_STRING           1		// -> MAC_FORMAT_TEXT
#define FORMAT_BITMAP           2		// -> MAC_FORMAT_PICT
#define FORMAT_GDIMETAFILE      3		// -> MAC_FORMAT_PICT
#define FORMAT_PRIVATE          4		// -> MAC_FORMAT_PRIV
#define FORMAT_FILE             5		// -> MAC_FORMAT_FILE
#define FORMAT_FILE_LIST        6		// -> MAC_FORMAT_FILE

// Weitere Standardformate (diese gehen nur ueber CopyData/PasteData)
#define FORMAT_RTF              10		// -> MAC_FORMAT_RTF
#define FORMAT_HTML			0x32

// Format-Suche

BOOL HasFormat(IDataTrans *pInterface, UINT32 nFormat);

// Konvertierungen von Datenformaten

BYTE *ConvertResType2Format(ResType theResType, UINT32 nFormat, const BYTE *pData, UINT32 nSize, UINT32 &rSize);
BYTE *ConvertFormat2ResType(UINT32 nFormat, ResType theResType, const BYTE *pData, UINT32 nSize, UINT32 &rSize);

ResType FormatResType(UINT32 n)
{
	char	szResName[5];
	sprintf(szResName, "sF%02x", n);
	return *(ResType *)szResName;			
}

ResType DataResType(UINT32 n)
{
	char	szResName[5];
	sprintf(szResName, "sD%02x", n);
	return *(ResType *)szResName;			
}

//**************************************************************************************************
//    CMacClipData::aquire
//**************************************************************************************************

void CMacClipData::aquire()
{
	mnRefCount++;
}


//**************************************************************************************************
//    CMacClipData::release
//**************************************************************************************************

void CMacClipData::release()
{
	if (--mnRefCount <= 0)
		delete this;
}


//**************************************************************************************************
//    CMacClipData::getTypeList
//**************************************************************************************************

UINT32	*__getTypeList(UINT32 &rSize)
{
	long offset;
	UINT32	uTypeList[100];			// temporre Liste fr die maximal 100 Typen
	UINT32	*pTypeList = NULL;
	
	rSize = 0;

	// Zuerst die Native-Typen ermitteln

/*
	for (int n = 0; n < 100; n++)
	{
		Handle hData = NewHandle(0);
		
		result = GetScrap(hData, FormatResType(n), &offset);
		if (result > 0)
		{
			HLock(hData);
			String	aStr((const char *)*hData);
			HUnlock(hData);
			
			const FormatItem	*pItem = CMacExchange::theExchange.findItem(aStr);
			
			if (pItem)
				uTypeList[rSize++] = pItem->mnFormatID;
		}
		else
			break;
		
		DisposeHandle(hData);
	}
*/

	// Wie wre es mit HTML

	if (GetScrap(nil, MAC_FORMAT_HTML, &offset) >= 0)
		uTypeList[rSize++] = FORMAT_HTML;
	
	// Haben wir vielleicht auch RTF ?
	
	if (GetScrap(nil, MAC_FORMAT_RTF, &offset) >= 0)
		uTypeList[rSize++] = FORMAT_RTF;
	
	// Liegt reiner Text im Clipboard ?
	
	if (GetScrap(nil, MAC_FORMAT_TEXT, &offset) >= 0)
		uTypeList[rSize++] = FORMAT_STRING;
	
	// Wenn PICT im Clipboard liegt, bieten wird Bitmap und GDIMetafile an
	
	if (GetScrap(nil, MAC_FORMAT_PICT, &offset) >= 0)
	{
		uTypeList[rSize++] = FORMAT_GDIMETAFILE;
		uTypeList[rSize++] = FORMAT_BITMAP;
	}

	// Jetzt eine Typeliste allokieren und die temporren Daten kopieren
	
	if (rSize > 0)
	{
		pTypeList = new UINT32[rSize];
		if (pTypeList)
			memcpy(pTypeList, uTypeList, rSize * sizeof(UINT32));
		else
			rSize = 0;
	}
	
	return pTypeList;
}

UINT32	*CMacClipData::getTypeList(UINT32 &rSize) const
{
	return ::__getTypeList(rSize);
}



//**************************************************************************************************
//    CMacClipData::getData
//**************************************************************************************************

BYTE *CMacClipData::getData(UINT32 nFormat, UINT32 &rSize)
{
	ResType	theResType;
	BYTE	*pData = NULL;
	
	rSize = 0;

	// Welcher Typ wird gewnscht ?
	
	switch (nFormat)
	{
		case FORMAT_STRING:
			theResType = MAC_FORMAT_TEXT;
			break;
		case FORMAT_GDIMETAFILE:
		case FORMAT_BITMAP:
			theResType = MAC_FORMAT_PICT;
			break;
		case FORMAT_RTF:
+			theResType = MAC_FORMAT_RTF;
			break;
		default:
			if (nFormat == FORMAT_HTML)
				theResType = MAC_FORMAT_HTML;
			else
				theResType = MAC_FORMAT_NONE;
			break;
	}
	
	// Wenn es einen korrespondirenden Typ gibt, dann holen wird die Daten aus dem
	// System clipboard und konvertieren sie.
	
	if (theResType != MAC_FORMAT_NONE)
	{
		Handle hData = NewHandle(0);
		long offset, result = GetScrap(hData, theResType, &offset);
		
		if (result > 0)
		{
			HLock(hData);
			pData = ConvertResType2Format(theResType, nFormat, (const BYTE *)*hData, result, rSize);
			HUnlock(hData);
		}
		
		DisposeHandle(hData);
	}
	
	// Andernfalls handelt es sich um ein Native-format des Office
	
	else
	{

		for (int n = 0; n < 100 && !pData; n++)
		{
			Handle hNameData = NewHandle(0);
			
			long offset, result = GetScrap(hNameData, FormatResType(n), &offset);
			if (result > 0)
			{
				HLock(hNameData);
				String	aStr((const char *)*hNameData);
				HUnlock(hNameData);
				
				const FormatItem	*pItem = CMacExchange::theExchange.findItem("", nFormat);
				
				if (pItem && pItem->maFormatName == aStr)
				{
					Handle	hData = NewHandle(0);
					result = GetScrap(hData, DataResType(n), &offset);
					if (result > 0)
					{
						pData = new BYTE[result];
						if (pData)
						{
							memcpy(pData, *hData, result);
							rSize = result;
						}
					}
					DisposeHandle(hData);
				}
			}
			
			DisposeHandle(hNameData);
		}
		
	}


	return pData;
}

//**************************************************************************************************
//    CMacClipboard::theClipboard
//**************************************************************************************************

CMacClipboard CMacClipboard::theClipboard; // Die Instanz des Systemclipboard-Interfaces

//**************************************************************************************************
//    CMacClipboard::CTOR
//**************************************************************************************************

CMacClipboard::CMacClipboard() :
	mpListener(NULL),
	mpLastXDTrans(NULL)
{
}

//**************************************************************************************************
//    CMacClipboard::DTOR
//**************************************************************************************************

CMacClipboard::~CMacClipboard()
{
	// Wenn wir noch ein Interface haben, sollten wir das jezt freigeben

	if (mpLastXDTrans)
	{
		mpLastXDTrans->release;
		mpLastXDTrans = NULL;
	}
}

//**************************************************************************************************
//    CMacClipboard::registerListener
//**************************************************************************************************

void CMacClipboard::registerListener(IClipboardListener &xListener)
{
	mpListener = &xListener;
	changed();	// Sicherheitshalber benachrichtigen wir ihn gleich
}



//**************************************************************************************************
//    CMacClipboard::changed
//**************************************************************************************************

void CMacClipboard::changed()
{
	// Der Inhalt des Systemclipboarda hat sich gendert, also ist des zuletzt uebergebene Interface
	// hinfaellig und wir koenne es freigeben.
	
	if (mpLastXDTrans)
	{
		mpLastXDTrans->release();
		mpLastXDTrans = NULL;
	}
		
	// Jetzt noch den Listener benachrichtigen, da sich der Inhalt geaendert hat.

	if (mpListener)
		mpListener->changed();
}


//**************************************************************************************************
//    CMacClipboard::cleared
//**************************************************************************************************

void CMacClipboard::cleared()
{
	// Das Systemclipboard wurde gelscht, also mu das interne Clipboard auch gelscht werden,
	// um keine Inkonsistenzen zu haben. Das zuletzt bergebene Interface knnen wir daher
	// freigeben.
	
	if (mpLastXDTrans)
	{
		mpLastXDTrans->release();
		mpLastXDTrans = NULL;
	}
	
	// Jetzt noch den Listener benachrichtigen, da das clipboard gelscht wurde
	
	if (mpListener)
		mpListener->cleared();
}

//**************************************************************************************************
//    CMacClipboard::copy
//**************************************************************************************************

void CMacClipboard::copy(IDataTrans *pDataTrans)
{
	
	// Falls schon ein Interface bergeben wurde, vergessen wird das jetzt
	if (mpLastXDTrans)
	{
		mpLastXDTrans->release();
		mpLastXDTrans = NULL;
	}
		
	// Neues Interface merken
	
	mpLastXDTrans = pDataTrans;
	mpLastXDTrans->aquire();
}

//**************************************************************************************************
//    CMacClipboard::writeFormat
//**************************************************************************************************

void CMacClipboard::writeFormat(UINT32 nFormatID, ResType theResType)
{
	UINT32	nSize;
	BYTE *pData = mpLastXDTrans->getData(nFormatID, nSize);
	
	if (pData)
	{
		BYTE *pConvData = ConvertFormat2ResType(nFormatID, theResType, pData, nSize, nSize);
		delete pData;
		if (pConvData)
		{
			PutScrap(nSize, theResType, pConvData);
			delete pConvData;
		}
	}
}

//**************************************************************************************************
//    CMacClipboard::writeBack
//**************************************************************************************************

void CMacClipboard::writeBack(BOOL bWriteNative)
{
	if (mpLastXDTrans)
	{
		// Zuerst einmal lschen wir das MAC-System-Clipboard
		ZeroScrap();
		
		// Jetzt alle Standard-Typen des Interfaces sichern

		if (HasFormat(mpLastXDTrans, FORMAT_HTML))
			writeFormat(FORMAT_HTML, MAC_FORMAT_HTML);

		if (HasFormat(mpLastXDTrans, FORMAT_STRING))
			writeFormat(FORMAT_STRING, MAC_FORMAT_TEXT);
		
		if (HasFormat(mpLastXDTrans, FORMAT_RTF))
			writeFormat(FORMAT_RTF, MAC_FORMAT_RTF);

		// Wenn Bitmap oder GDIMetafile vorliegt, duerfen wir nur ein Format schreiben
		
		if (HasFormat(mpLastXDTrans, FORMAT_GDIMETAFILE))
			writeFormat(FORMAT_GDIMETAFILE, MAC_FORMAT_PICT);
		else if (HasFormat(mpLastXDTrans, FORMAT_BITMAP))
			writeFormat(FORMAT_BITMAP, MAC_FORMAT_PICT);
		
		// Auch die Office-Formate wegschreiben
		
		if (bWriteNative)
		{
			UINT32 nTypeList;
			UINT32 *pTypeList = mpLastXDTrans->getTypeList(nTypeList);
			
			for (UINT32 n = 0; n < nTypeList && pTypeList; n++)
			{
				UINT32	nFormatID = pTypeList[n];
				
				const FormatItem *pItem = CMacExchange::theExchange.findItem("", nFormatID);
				
				if (pItem)
				{
					PutScrap(pItem->maFormatName.Len() + 1, FormatResType(n), (BYTE *)(const char *)(pItem->maFormatName));
					
					UINT32	nDataSize;
					BYTE 	*pDataBuf = mpLastXDTrans->getData(nFormatID, nDataSize);
					
					if (pDataBuf)
					{
						PutScrap(nDataSize, DataResType(n), pDataBuf);
						delete pDataBuf;
					}
				}

			}
			
			if (pTypeList)
				delete pTypeList;
		}
		
	}

	if (mpLastXDTrans)
	{
		mpLastXDTrans->release();
		mpLastXDTrans = NULL;
	}
}

//**************************************************************************************************
//    CMacClipboard::paste
//**************************************************************************************************

IDataTrans *CMacClipboard::paste()
{
	// Paste liefert nur ein Interface, also erzeugen wir jetzt eines, es werden aber noch 
	// keine Daten kopiert.

	return new CMacClipData;
}


//**************************************************************************************************
//    CMacClipboard::clear
//**************************************************************************************************

void CMacClipboard::clear()
{
	// Clear wird im Augenblick flschlicherweise beim Runterfahren des Office aufgerufen.
	// Entgegen der Semantik wird daher nicht das Systemclipboard gelscht, sondern. Der Inhalt
	// des internen Clipboards ins Systemclipboard geschrieben.
	
	// ZeroScrap();
	// cleared();

	writeBack(TRUE);
}


//**************************************************************************************************
//    UpdateMacClipboard
//**************************************************************************************************

// Wrapper der das Clipboard dazu bringt alle oder nur die Standardformate wegzuschreiben.

void UpdateMacClipboard(BOOL bAllFormats)
{
	CMacClipboard::theClipboard.writeBack(bAllFormats);
}

//**************************************************************************************************
//    MacClipboardHasChanged
//**************************************************************************************************

// Benachrichtigt das Systemclipboard-Interface, dass sich das Clipboard geaendert hat

void MacClipboardHasChanged()
{
	CMacClipboard::theClipboard.changed();
}

//**************************************************************************************************
//    GetMacClipboard
//**************************************************************************************************

// Liefert die Instanz des Clipboard-Interfaces

ISystemClipboard* GetMacClipboard()
{
	return &CMacClipboard::theClipboard;
}


//==================================================================================================
// FormatItem
//==================================================================================================

FormatItem::FormatItem(const String &rName, UINT32 nFormatID) :
	mnFormatID(nFormatID),
	maFormatName(rName)
{
}

//==================================================================================================
// CMacExchange
//==================================================================================================

// Eigentlich sollte diese Klasse die Formate rewgistrieren und am System anmelden
// (letzteres duerfte auf dem Mac etwas schwierig werden), aber da die Format-ID
// angeblich dynamisch vergeben werden, und z.Z. vor einem Paste nicht registriert
// werden, macht das wenig sinn, selbst dann nicht, wenn die Format-Informationen
// persistent gespeichert wrden.
// Wie kann z.B. der Writer ein Format mit der ID 42 anfordern, wenn diese ID zur
// Laufzeit des Office vergeben wird, und "Star Writer 4.0 Dokument" noch nicht 
// registriert wurde???
// Offensichtlich scheint es da doch eine feste Verdrahtung der Typen zu geben!
// Lassen wir uns ueberraschen...

//**************************************************************************************************
//    CMacExchange::theExchange
//**************************************************************************************************

// Die Instance des Interfaces

CMacExchange CMacExchange::theExchange;

//**************************************************************************************************
//    CMacExchange::CTOR
//**************************************************************************************************

CMacExchange::CMacExchange() :
	FormatList()
{
}

//**************************************************************************************************
//    CMacExchange::DTOR
//**************************************************************************************************

CMacExchange::~CMacExchange()
{
    FormatItem* pItem = First();
    while( pItem )
    {
        delete pItem;
        pItem = Next();
    }
}

//**************************************************************************************************
//    CMacExchange::registerFormatName
//**************************************************************************************************

void CMacExchange::registerFormatName(const String &rFormatName, UINT32 nFormatID)
{
	FormatItem *pItem = new FormatItem(rFormatName, nFormatID);
	Insert(pItem, LIST_APPEND);
}

//**************************************************************************************************
//    CMacExchange::findItem
//**************************************************************************************************

const FormatItem *CMacExchange::findItem(const String &rFormatName, UINT32 nFormatID)
{
	BOOL	bFindName = (BOOL)(rFormatName != "");
	BOOL	bFindFormatID = (BOOL)(nFormatID != FORMAT_NONE);

	if (!bFindName && !bFindFormatID)
		return NULL;
		
    FormatItem* pItem = First();
	FormatItem* pFound = NULL;
	
    while( pItem && !pFound)
    {
		BOOL	bFoundName = (BOOL)(!bFindName || rFormatName == pItem->maFormatName);
		BOOL	bFoundFormatID = (BOOL)(!bFindFormatID || nFormatID == pItem->mnFormatID);

		if (bFoundName && bFoundFormatID)
			pFound = pItem;
			
        pItem = Next();
    }
	
	return pFound;
}

//**************************************************************************************************
//    GetSystemExchange   (SYSEXCHG.HXX in VCL/INC)
//**************************************************************************************************

ISystemExchange* GetMacExchange()
{
	// Die Instanz des Exchange-Interfaces liefern
	return &CMacExchange::theExchange;
}


// Die folgenden Funktionen sind Tools, die sowohl vom Drag & Drop als auch vom
// Clipboard benoetigt werden.

//**************************************************************************************************
//    HasFormat
//**************************************************************************************************

// Prft an einen IDataTrans-Interface, ob ein bestimmtes Format vorhanden ist

BOOL HasFormat(IDataTrans *pInterface, UINT32 nFormat)
{
	BOOL	bHasFormat = FALSE;
	UINT32	nTypeList, *pTypeList = pInterface->getTypeList(nTypeList);
	
	if (pTypeList)
	{
		for (UINT32 n = 0; n < nTypeList && !bHasFormat; n++)
			bHasFormat = (BOOL)(pTypeList[n] == nFormat);
		delete pTypeList;
	}
		
	return bHasFormat;
}


//**************************************************************************************************
//    GetPathFromDirID
//**************************************************************************************************

// Liefert aus einer dirID einen completten Pfad

#ifndef _MAX_PATH
#define _MAX_PATH			512
#endif

OSErr GetPathFromDirID( long DirID, short VRefNum, char *pPath )
{
	CInfoPBRec	paramBlock;
	Str255		dirName; 	// Pascal string
	int			len;
	OSErr		err;
	
	*pPath = '\0';
	len = 0;
	
	paramBlock.dirInfo.ioNamePtr = dirName;
	paramBlock.dirInfo.ioDrParID = DirID;
	
	do { 
		paramBlock.dirInfo.ioVRefNum = VRefNum;
		paramBlock.dirInfo.ioFDirIndex = -1;
		paramBlock.dirInfo.ioDrDirID = paramBlock.dirInfo.ioDrParID;
		
		err = PBGetCatInfoSync( &paramBlock );
		
		if (err == noErr)
		{
			if ( len + 1 + dirName[0] + 1 > _MAX_PATH )
				err = -1;
			else
			{
				memmove( pPath + dirName[0] + 1, pPath, len + 1 );
				memcpy( pPath, &dirName[1], dirName[0] );
				pPath[ dirName[0] ] = ':';
				len += dirName[0] + 1;
			}		
		}
	} while ( ( err == noErr ) && ( paramBlock.dirInfo.ioDrDirID != fsRtDirID ) );
	
	return err;
}


//**************************************************************************************************
//    MakeHFSFlavor
//**************************************************************************************************

// Erzeugt aus einem Pfadnamen einen HFS-Typ fr den Finder

HFSFlavor *MakeHFSFlavor(const char *pszPathName)
{
	HFSFlavor	*pHFSData = new HFSFlavor;
	Str255		spPathName;

	if (pHFSData)
	{
		pHFSData->fileType = 0;
		pHFSData->fileCreator = 0;
		pHFSData->fdFlags = 0;
		spPathName[0] = strlen(pszPathName);
		memcpy(&spPathName[1], pszPathName, spPathName[0]);
		
		
		FSMakeFSSpec(0, 0, spPathName, &pHFSData->fileSpec);
	}
	
	return pHFSData;
}

//**************************************************************************************************
//    ConvertResType2Format
//**************************************************************************************************

// Konvertiert (fall moeglich) eine Mac-Resource in ein Office-format

BYTE *ConvertResType2Format(ResType theResType, UINT32 nFormat, const BYTE *pData, UINT32 nSize, UINT32 &rSize)
{
	BYTE	*pNewData = NULL;
	
	rSize = 0;
	
	// Text in NULL-terminierten C-String umwandeln
	
	if (theResType == MAC_FORMAT_TEXT && nFormat == FORMAT_STRING)
	{
		pNewData = new BYTE[nSize + 1];
		if (pNewData)
		{
			memcpy(pNewData, pData, nSize);
			pNewData[nSize] = 0;
			rSize = nSize + 1;
		}
	}
	
	// HTML wird native uebernommen
	
	else if (theResType == MAC_FORMAT_HTML && nFormat == FORMAT_HTML)
	{
		pNewData = new BYTE[nSize];
		if (pNewData)
		{
			rSize = nSize;
			memcpy(pNewData, pData, rSize);
		}
	}
	
	// RTF wird native uebernommen
	
	else if (theResType == MAC_FORMAT_RTF && nFormat == FORMAT_RTF)
	{
		pNewData = new BYTE[nSize];
		if (pNewData)
		{
			rSize = nSize;
			memcpy(pNewData, pData, rSize);
		}
	}
	
	// PICT in GDIMetafile oder Bitmap umwandeln
	
	else if (theResType == MAC_FORMAT_PICT)
	{
		ULONG			cvtFormat;
		
		switch (nFormat)
		{
			case FORMAT_BITMAP:
				cvtFormat = CVT_BMP;
				break;
			case FORMAT_GDIMETAFILE:
				cvtFormat = CVT_SVM;
				break;
			default:
				return NULL;
		}
		
		SALGRFCVTPROC	pFnc = (SALGRFCVTPROC) GetSalData()->mpFirstInstance->maInstData.mpFilterCallback;
		
		if (pFnc == NULL)
			return NULL;

		void*	pFilterInst = GetSalData()->mpFirstInstance->maInstData.mpFilterInst;

		if (pFilterInst == NULL)
			return NULL;

		// Das PICT mu vor der Konvertierung noch einen 512 Byte grossen Header bekommen,
		// was da drin steht ist aber egal.
		
		UINT32	nPictBufSize = nSize + 512;
		BYTE*	pPictBuf = new BYTE[nPictBufSize];
		BYTE*	pOutBuf = NULL;
		
		if (pPictBuf == NULL)
			return NULL; 
			
		memcpy(&pPictBuf[512], pData, nSize);
		
		ULONG nOutSize = pFnc(pFilterInst, CVT_PCT, pPictBuf, nPictBufSize, cvtFormat, (void**)&pOutBuf);
		
		delete pPictBuf;
		
		if (pOutBuf)
		{
			pNewData = new BYTE[nOutSize];
			
			if (pNewData)
			{
				rSize = nOutSize;
				memcpy(pNewData, pOutBuf, rSize);
			}
			
			SvMemFree( pOutBuf );
		}
	}
	
	// HFS in C-String umwandeln
	
	else if (theResType == MAC_FORMAT_FILE && nFormat == FORMAT_FILE)
	{
		const HFSFlavor	*pHFSData = (const HFSFlavor *)pData;
		char			szDirName[_MAX_PATH];
		int				len;
		
		GetPathFromDirID( pHFSData->fileSpec.parID, pHFSData->fileSpec.vRefNum, szDirName );

		len = strlen(szDirName);		
		pNewData = new BYTE[len + pHFSData->fileSpec.name[0] + 1];
		if (pNewData)
		{
			strcpy((char *)pNewData, szDirName);
			memcpy(&pNewData[len], &pHFSData->fileSpec.name[1], pHFSData->fileSpec.name[0]);
			rSize = len + pHFSData->fileSpec.name[0];
			pNewData[rSize++] = 0;
		}
	}
	
	return pNewData;
}


//**************************************************************************************************
//    ConvertFormat2ResType
//**************************************************************************************************

// Konvertiert (fall moeglich) ein Office-format in eine Mac-Resource

BYTE *ConvertFormat2ResType(UINT32 nFormat, ResType theResType, const BYTE *pData, UINT32 nSize, UINT32 &rSize)
{
	BYTE	*pNewData = NULL;
	
	rSize = 0;
	
	// C-String nach Text
	
	if (theResType == MAC_FORMAT_TEXT && nFormat == FORMAT_STRING)
	{
		String	aString((const char *)pData);
		
		aString.ConvertLineEnd();
		pNewData = new BYTE[aString.Len()];
		if (pNewData)
		{
			rSize = aString.Len();
			memcpy(pNewData, (const char *)aString, rSize);
		}
	}
	
	// HTML wird native uebernommen
	
	else if (theResType == MAC_FORMAT_HTML && nFormat == FORMAT_HTML)
	{
		pNewData = new BYTE[nSize];
		if (pNewData)
		{
			rSize = nSize;
			memcpy(pNewData, pData, rSize);
		}
	}
	
	// RTF wird native uebernommen
	
	else if (theResType == MAC_FORMAT_RTF && nFormat == FORMAT_RTF)
	{
		pNewData = new BYTE[nSize];
		if (pNewData)
		{
			rSize = nSize;
			memcpy(pNewData, pData, rSize);
		}
	}
	
	// Bitmap oder GDIMetafile nach PICT
	
	else if (theResType == MAC_FORMAT_PICT)
	{
		ULONG			cvtFormat;
		
		switch (nFormat)
		{
			case FORMAT_BITMAP:
				cvtFormat = CVT_BMP;
				break;
			case FORMAT_GDIMETAFILE:
				cvtFormat = CVT_SVM;
				break;
			default:
				return NULL;
		}
		
		SALGRFCVTPROC	pFnc = (SALGRFCVTPROC) GetSalData()->mpFirstInstance->maInstData.mpFilterCallback;
		
		if (pFnc == NULL)
			return NULL;

		void*	pFilterInst = GetSalData()->mpFirstInstance->maInstData.mpFilterInst;

		if (pFilterInst == NULL)
			return NULL;

		BYTE*	pOutBuf = NULL;
		
		ULONG nOutSize = pFnc(pFilterInst, cvtFormat, (BYTE *)pData, nSize, CVT_PCT, (void**)&pOutBuf);
		
		if (pOutBuf)
		{
			// Den 512 Byte Header des PICT brauchen wir nicht
			
			pNewData = new BYTE[nOutSize-512];
			
			if (pNewData)
			{
				rSize = nOutSize - 512;
				memcpy(pNewData, &pOutBuf[512], rSize);
			}
			
			SvMemFree( pOutBuf );
		}
		
	}
	
	// C-String nach HFS
	
	else if (theResType == MAC_FORMAT_FILE && nFormat == FORMAT_FILE)
	{
		pNewData = (BYTE *)MakeHFSFlavor((const char *)pData);
		if (pNewData)
			rSize = sizeof(HFSFlavor);
	}
	return pNewData;
}



//====================================================================================
// CMacDragTrans
//====================================================================================

class CMacDragData : public IDataTrans
{
public:
	CMacDragData(DragReference theDragRef);
	virtual ~CMacDragData() {}
	
	virtual void aquire();
	virtual void release();
	
	virtual UINT32 *getTypeList(UINT32 &rSize) const;
	virtual BYTE *getData(UINT32 nFormat, UINT32 &rSize);

protected:	
	BOOL hasFormat(UINT32 nFormat) const;
	BYTE *getItemData(long nItem, UINT32 nFormat, UINT32 &rSize);

protected:
	int mnRefCount;
	DragReference	maDragRef;
};

//------------------------------------------------------------------------------------

CMacDragData::CMacDragData(DragReference theDragRef) :
	mnRefCount( 0 ),
	maDragRef( theDragRef)
{
}

//------------------------------------------------------------------------------------

void CMacDragData::aquire()
{
	mnRefCount++;
}

//------------------------------------------------------------------------------------

void CMacDragData::release()
{
	if (--mnRefCount <= 0)
		delete this;
}

//------------------------------------------------------------------------------------

BOOL CMacDragData::hasFormat(UINT32 nFormat) const
{
	BOOL	bHasType = FALSE;
	OSErr	error;
	unsigned short	numItems;
	
	if ((error = CountDragItems(maDragRef, &numItems)) == noErr)
	{
		for (unsigned short nItem = 1; nItem <= numItems; nItem++)
		{
			ItemReference	theItemRef;
			unsigned short	numFlavors;
			
			error = GetDragItemReferenceNumber(maDragRef, nItem, &theItemRef);
			if (error == noErr)
				error = CountDragItemFlavors(maDragRef, theItemRef, &numFlavors);
			
			for (unsigned short nFlavor = 1; error == noErr && nFlavor <= numFlavors; nFlavor++)
			{
				FlavorType	theFlavorType;
				
				error = GetFlavorType (maDragRef, theItemRef, nFlavor, &theFlavorType);
				if (error == noErr)
				{
					switch (theFlavorType)
					{
						case MAC_FORMAT_TEXT:
							bHasType = (BOOL)(nFormat == FORMAT_STRING);
							break;
						case MAC_FORMAT_PICT:
							bHasType = (BOOL)(nFormat == FORMAT_BITMAP || nFormat == FORMAT_GDIMETAFILE);
							break;
						case MAC_FORMAT_FILE:
							bHasType = (BOOL)(nFormat == FORMAT_FILE || nFormat == FORMAT_FILE_LIST);
							break;
						default:
							break;
					}
				}
			}
			
		}
	}
	
	return bHasType;
}

UINT32 *CMacDragData::getTypeList(UINT32 &rSize) const
{
	UINT32	tempList[10];
	UINT32	*pTypeList = NULL;
	
	rSize = 0;
	
	if (hasFormat(FORMAT_STRING))
		tempList[rSize++] = FORMAT_STRING;
	if (hasFormat(FORMAT_BITMAP))
		tempList[rSize++] = FORMAT_BITMAP;
	if (hasFormat(FORMAT_GDIMETAFILE))
		tempList[rSize++] = FORMAT_GDIMETAFILE;
	if (hasFormat(FORMAT_FILE))
		tempList[rSize++] = FORMAT_FILE;
	if (hasFormat(FORMAT_FILE_LIST))
		tempList[rSize++] = FORMAT_FILE_LIST;
		
	if (rSize > 0)
	{
		pTypeList = new UINT32[rSize];
		
		if (pTypeList)
			memcpy(pTypeList, tempList, sizeof(UINT32) * rSize);
		else
			rSize = 0;
	}
	
	return pTypeList;
}


//------------------------------------------------------------------------------------

BYTE *CMacDragData::getItemData(long nItem, UINT32 nFormat, UINT32 &rSize)
{
	ItemReference	theItemRef;
	unsigned short	numFlavors;
	OSErr			error;
	BYTE			*pData = NULL;

	rSize = 0;
	
	error = GetDragItemReferenceNumber(maDragRef, nItem, &theItemRef);
	
	if (error == noErr)
		error = CountDragItemFlavors(maDragRef, theItemRef, &numFlavors);
	
	for (unsigned short nFlavor = 1; nFlavor <= numFlavors && error == noErr && pData == NULL; nFlavor++)
	{
		FlavorType	theFlavorType;
		long	theSize;
		
		error = GetFlavorType (maDragRef, theItemRef, nFlavor, &theFlavorType);
		if (error == noErr)
			error = GetFlavorDataSize(maDragRef, theItemRef, theFlavorType, &theSize);
		if (error == noErr)
		{
			BYTE *pTempData = new BYTE[theSize];
			if (pTempData)
			{
				error = GetFlavorData(maDragRef, theItemRef, theFlavorType, pTempData, &theSize, nil);
				if (error == noErr)
					pData = ConvertResType2Format(theFlavorType, nFormat, pTempData, theSize, rSize);
				delete pTempData;
			}
		}
	}
	
	return pData;
}

BYTE *CMacDragData::getData(UINT32 nFormat, UINT32 &rSize)
{
	unsigned short	numItems;
	OSErr			error;
	BYTE			*pData = NULL;
	
	rSize = 0;
	
	if ((error = CountDragItems(maDragRef, &numItems)) == noErr && numItems >= 1)
	{
		if (nFormat == FORMAT_FILE_LIST)
		{
			char 	*pFileData[512];
			UINT32	nFileSize[512];
			UINT32	sumSize = 0;
			SysexchgFileList header;
			
			for (unsigned short nItem = 1; nItem <= numItems; nItem++)
			{
				((BYTE *)pFileData[nItem-1]) = getItemData(nItem, FORMAT_FILE, nFileSize[nItem-1]);
				rSize += nFileSize[nItem-1];
			}
			rSize += 1 + 20;
			pData = new BYTE[rSize];
			memcpy(pData, &header, 20);

			int index = 20;
			for (nItem = 1; nItem <= numItems; nItem++)
			{
				memcpy(&pData[index], pFileData[nItem-1], nFileSize[nItem-1]);
				index += nFileSize[nItem-1];
			}
			
			pData[index] = 0;
		}
		else
			pData = getItemData(1, nFormat, rSize);
	}
	
	return pData;
}


//====================================================================================

class CMacDragManager : public ISystemDragManager
{
protected:
	IDragDropListener	*pListener;
	SalFrame			*pSalFrame;
	WindowPtr			pMacWindow;
	RgnHandle			hMacWindowRgn;
	IDataTrans				*pMyOwnDrag;
	
public:
	CMacDragManager();
	virtual ~CMacDragManager();
	
	virtual SysDropAction executeDrag( IDataTrans* pData, USHORT nOptions );

	virtual void registerListener( IDragDropListener& xListener );

	virtual void enableDrop( SalFrame* pFrame, BOOL bEnable );

protected:	
	OSErr DragInput(MAC_Point *mouse,
           			short *modifiers,
           			DragReference theDragRef);
							  
	static pascal OSErr DragInputWrapper(MAC_Point *mouse,
                      			short *modifiers,
								void  *dragInputRefCon,
                      			DragReference theDragRef);
								
	OSErr DragReceive(WindowPtr theWindow, DragReference theDragRef);					
								
	static pascal OSErr DragReceiveWrapper(WindowPtr theWindow,
    	                             void *handlerRefCon,
        	                         DragReference theDragRef);					

	OSErr DragTrack(DragTrackingMessage message, WindowPtr theWindow, DragReference theDragRef);

	static pascal OSErr DragTrackingWrapper(DragTrackingMessage message,
                                  WindowPtr theWindow,
                                  void *handlerRefCon,
                                  DragReference theDragRef);
								  
	static CMacDragManager theDragManager;

	friend ISystemDragManager* GetMacDragManager();
};


//------------------------------------------------------------------------------------

CMacDragManager CMacDragManager::theDragManager;

//------------------------------------------------------------------------------------

pascal OSErr CMacDragManager::DragInputWrapper(MAC_Point *mouse,
                      			short *modifiers,
								void  *dragInputRefCon,
                      			DragReference theDragRef)
{
	return ((CMacDragManager *)dragInputRefCon)->DragInput(mouse, modifiers, theDragRef);
}

//------------------------------------------------------------------------------------

pascal OSErr CMacDragManager::DragReceiveWrapper(WindowPtr theWindow,
    	                             void *handlerRefCon,
        	                         DragReference theDragRef)
{
	return ((CMacDragManager *)handlerRefCon)->DragReceive(theWindow, theDragRef);
}

//------------------------------------------------------------------------------------

pascal OSErr CMacDragManager::DragTrackingWrapper(DragTrackingMessage message,
                                  WindowPtr theWindow,
                                  void *handlerRefCon,
                                  DragReference theDragRef)
{
	return ((CMacDragManager *)handlerRefCon)->DragTrack(message, theWindow, theDragRef);
}

//------------------------------------------------------------------------------------

CMacDragManager::CMacDragManager() :
	pListener(NULL),
	pMacWindow(NULL),
	pSalFrame(NULL),
	pMyOwnDrag(NULL),
	hMacWindowRgn(0)
{
}

//------------------------------------------------------------------------------------

CMacDragManager::~CMacDragManager()
{
}

//------------------------------------------------------------------------------------

void CMacDragManager::registerListener( IDragDropListener& xListener )
{
	pListener = &xListener;
}

//------------------------------------------------------------------------------------

SysDropAction CMacDragManager::executeDrag( IDataTrans *pDataInterface, USHORT nOptions)
{
	OSErr			error;
	DragReference	theDragRef;
	RgnHandle		theDragRgn;
	EventRecord		*pEvent = &GetSalData()->maLastMouseDown;
	
	if (pDataInterface == NULL)
		return DROP_NONE;
		
	error = NewDrag(&theDragRef);
	
	if (error != noErr)
		return DROP_NONE;
		
	pDataInterface->aquire();
	pMyOwnDrag = pDataInterface;
	
	SetDragInputProc(theDragRef, NewDragSendDataProc(DragInputWrapper), (void*)this);

	{
		UINT32	nSize;
		BYTE *pData;
	
		pData = pDataInterface->getData(FORMAT_STRING, nSize);
	
		if (pData)
		{
			nSize--;
			AddDragItemFlavor(theDragRef, 1, MAC_FORMAT_TEXT, pData, nSize, 0);
			delete pData;
		}


		pData = pDataInterface->getData(FORMAT_FILE, nSize);
	
		if (pData)
		{
			HFSFlavor	*pHFSData = MakeHFSFlavor((const char *)pData);
			delete pData;
			if (pHFSData)
			{
				AddDragItemFlavor(theDragRef, 1, MAC_FORMAT_FILE, pHFSData, sizeof(HFSFlavor), 0);
				delete pHFSData;
			}
		}

	}

	pEvent->modifiers |= activeFlag;


	theDragRgn = NewRgn();
	SetRectRgn( theDragRgn, pEvent->where.h + 4, pEvent->where.v + 4, pEvent->where.h + 16, pEvent->where.v + 16 );
	TrackDrag(theDragRef, pEvent, theDragRgn);
	DisposeDrag(theDragRef);
	DisposeRgn( theDragRgn );
	
	pDataInterface->release();
	pMyOwnDrag = NULL;
	return DROP_MOVE;
}

//------------------------------------------------------------------------------------

void CMacDragManager::enableDrop( SalFrame *pFrame, BOOL bEnable )
{
	if (bEnable)
	{
		// Das hier ist ein Hack. Es wird davon ausgegangen, das das zuletzt angemeldete Fenster
		// der MainFrame ist !!!

		if (pFrame == NULL)
			pFrame = GetSalData()->mpFirstFrame;

		pMacWindow = &pFrame->maFrameData.mpMacWin->port;
		hMacWindowRgn = pFrame->maFrameData.mpMacWin->contRgn;
		pSalFrame = pFrame;

		InstallReceiveHandler(NewDragReceiveHandlerProc(DragReceiveWrapper), pMacWindow, (void *)this);
		InstallTrackingHandler(NewDragTrackingHandlerProc(DragTrackingWrapper), pMacWindow, (void *)this);
	}
	else
	{
//		RemoveTrackingHandler(DragTracking, pMacWindow);
//		RemoveReceiveHandler(DragReceive, pMacWindow);
	}
}

//------------------------------------------------------------------------------------

OSErr CMacDragManager::DragReceive(WindowPtr theWindow, DragReference theDragRef)
{
	MAC_Point	macMouse;
	short		nFind;
	
	if (pListener == NULL)
		return noErr;
	
	GetDragMouse(theDragRef, &macMouse, nil);
	nFind = FindWindow(macMouse, &theWindow);
	
	GlobalToLocal(&macMouse);
	
	Point	salMouse(macMouse.h, macMouse.v);

	if (nFind == inContent)	
		pListener->drop(salMouse, pSalFrame, DROP_COPY);
	return noErr;
}

//------------------------------------------------------------------------------------

OSErr CMacDragManager::DragTrack(DragTrackingMessage message, WindowPtr theWindow, DragReference theDragRef)
{
	MAC_Point		macMouse;
	short			nFind;
	SysDropAction	eAction = DROP_NONE;
	
	if (pListener == NULL)
		return noErr;
	
	GetDragMouse(theDragRef, &macMouse, nil);
	nFind = FindWindow(macMouse, &theWindow);
	
	GlobalToLocal(&macMouse);
	
	Point	salMouse(macMouse.h, macMouse.v);
	
	switch (message)
	{
		case dragTrackingEnterHandler:
			if (pMyOwnDrag)
				pListener->beginDragDrop(pMyOwnDrag, SYSEX_DROP_COPY);
			else
				pListener->beginDragDrop(new CMacDragData(theDragRef), SYSEX_DROP_COPY);
			break;
		case dragTrackingEnterWindow:
		case dragTrackingInWindow:
			if (nFind == inContent)
				eAction = pListener->queryDrop(salMouse, pSalFrame, 0);
			break;
		case dragTrackingLeaveWindow:
			if (nFind == inContent)
				eAction = pListener->queryDrop(salMouse, NULL, 0);
			break;
		case dragTrackingLeaveHandler:
			if (nFind != inContent)
				pListener->endDragDrop();
			if (pSalFrame)
				pSalFrame->SetPointer(POINTER_ARROW);
			break;
		default:
			break;
	}

	PointerStyle	nStyle = POINTER_ARROW;
	
	switch (eAction)
	{
		case DROP_MOVE:
			nStyle = POINTER_MOVEDATA;
			break;
		case DROP_COPY:
			nStyle = POINTER_COPYDATA;
			break;
		case DROP_LINK:
			nStyle = POINTER_LINKFILE;
			break;
		case DROP_PRINT:
			nStyle = POINTER_MOVEDATA;
			break;
		case DROP_DISCARD:
		case DROP_CANCEL:
		default:
			nStyle = POINTER_NOTALLOWED;
			break;
	}
	
	if (pSalFrame)
		pSalFrame->SetPointer(nStyle);

	return noErr;
}

//------------------------------------------------------------------------------------

OSErr CMacDragManager::DragInput(MAC_Point *mouse,
           			short *modifiers,
           			DragReference theDragRef)
{
	return noErr;
}

//------------------------------------------------------------------------------------

ISystemDragManager* GetMacDragManager()
{
	return &CMacDragManager::theDragManager;
}
