/*************************************************************************
 *
 *  $RCSfile: os2ex.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define INCL_WINCLIPBOARD
#include <OS2.H>

#include <stdlib.h>
#include <string.h>

#include <uno/uno.h>
#include <uno/object.hxx>
#include <vos/diagnose.hxx>
#include <sysex.hxx>
#include <os2ex.hxx>

#ifndef _UNO_NO_NAMESPACE
using namespace uno;
#endif


// -------------------------------------------------------------------------------------------

#define FORMAT_TXT	"Text"
#define FORMAT_MTF	"GDIMetaFile"
#define FORMAT_DIB	"Bitmap"
#define FORMAT_DDB	"Bitmap"

// -------------------------------------------------------------------------------------------

static	HAB hAB;

// -------------------------------------------------------------------------------------------

class OSystemExchange : public OUnoObject
{
// Construction and destruction
public:
	OSystemExchange( ORefCounter &rRefCounter );
	virtual ~OSystemExchange();

// Attributes
protected:
	XSystemEnvironment	m_Environment;
	XClipboardListener  m_ClipboardListener;
	XDragDropListener   m_DragDropListener;
	OUnoAny				m_DragDropFrame;
	XDataTransfer		m_DataTransfer;

// Implementaion
protected:
    UNO_BEGIN_INTERFACE_PART(TSystemExchange, XSystemExchange)
	    void setSystemEnvironment(XSystemEnvironment& Environment);
    UNO_END_INTERFACE_PART(TSystemExchange)

    UNO_BEGIN_INTERFACE_PART(TSystemClipboard, XSystemClipboard)
	    void copy(XDataTransfer& Data);
	    XDataTransfer paste(void);
	    void clear(void);
	    void registerListener(XClipboardListener& xListener);
    UNO_END_INTERFACE_PART(TSystemClipboard)

    UNO_BEGIN_INTERFACE_PART(TSystemDragManager, XSystemDragManager)
    	Short executeDrag(XDataTransfer& Data, Short nOptions);
        void registerListener(XDragDropListener& Listener);
        void enableDrop(const OUnoAny& Frame, Boolean Enable);
    UNO_END_INTERFACE_PART(TSystemDragManager)

	UNO_DECLARE_INTERFACE_TABLE()
};

UNO_BEGIN_INTERFACE_TABLE(OSystemExchange, OUnoObject)
	UNO_INTERFACE_PART(OSystemExchange, TSystemExchange, XSystemExchange)	
	UNO_INTERFACE_PART(OSystemExchange, TSystemClipboard, XSystemClipboard)	
	UNO_INTERFACE_PART(OSystemExchange, TSystemDragManager, XSystemDragManager)	
UNO_END_INTERFACE_TABLE()


// Implementation of XInterface interface
UNO_IMPLEMENT_XINTERFACE(OSystemExchange, TSystemExchange)
UNO_IMPLEMENT_XINTERFACE(OSystemExchange, TSystemClipboard)
UNO_IMPLEMENT_XINTERFACE(OSystemExchange, TSystemDragManager)

OSystemExchange::OSystemExchange( ORefCounter &rRefCounter )
	: OUnoObject( rRefCounter )
{
}

OSystemExchange::~OSystemExchange()
{
}

/*****************************************************************************/

void OSystemExchange::TSystemExchange::setSystemEnvironment(XSystemEnvironment& Environment)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemExchange);

	This->m_Environment = Environment;
}

/*****************************************************************************/

SequenceOfString UnoDataTransferAdaptor::getTypeList(void)
{
	SequenceOfString	Strings;

	if( WinQueryClipbrdData(hAB,CF_TEXT) )
	{
		Strings.setLength( 1 );
		Strings[ 0 ] = FORMAT_TXT;
	}

	return Strings;
}

/*****************************************************************************/

SequenceOfByte UnoDataTransferAdaptor::getData(const OUnoString& Format)
{
	SequenceOfByte	Bytes;
	
	const char *pszFormatName = Format;

	if (stricmp(pszFormatName, FORMAT_TXT) == 0)
	{
		if( WinOpenClipbrd( hAB ) )
		{
			PSZ pszText = (PSZ) WinQueryClipbrdData( hAB, CF_TEXT );

			if( pszText )
				Bytes.setSeq( (Byte*) pszText, strlen( pszText ) + 1 );

			WinCloseClipbrd( hAB );
		}
	}
/*
	if (stricmp(pszFormatName, FORMAT_MTF) == 0)
	{
		if( WinOpenClipbrd( hAB ) )
		{
			HMF hmf = (HMF) WinQueryClipbrdData( hAB, CF_METAFILE );

			// ...

			WinCloseClipbrd( hAB );
		}
	}

	if (stricmp(pszFormatName, FORMAT_DDB) == 0)
	{
		if( WinOpenClipbrd( hAB ) )
		{
			HBITMAP hBitmap = (HBITMAP) WinQueryClipbrdData( hAB, CF_BITMAP );

			// ...

			WinCloseClipbrd( hAB );
		}
	}
*/
	return Bytes;

}

/*****************************************************************************/

void OSystemExchange::TSystemClipboard::copy(XDataTransfer& xData)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemClipboard);

	This->m_DataTransfer = xData;
	SequenceOfString Strings = This->m_DataTransfer.getTypeList();
	
	for (int i = 0; i < Strings.getLength(); i++)
	{
		const char *str = Strings[i];
		if( stricmp(str, FORMAT_TXT) == 0 )
		{
			SequenceOfByte	Bytes = This->m_DataTransfer.getData(str);
			PSZ pText = (PSZ) Bytes.getPointer();

			if( WinOpenClipbrd( hAB ) )
			{
				PSZ pSharedText;

				DosAllocSharedMem( 	(PPVOID) &pSharedText, NULL, strlen( pText ) + 1,
									PAG_WRITE | PAG_COMMIT | OBJ_GIVEABLE );

				memcpy( pSharedText, pText, strlen( pText ) + 1 );

				WinEmptyClipbrd( hAB );

				// give pointer to clipboard (it will become owner of pSharedText!)
				WinSetClipbrdData( hAB, (ULONG) pSharedText, CF_TEXT, CFI_POINTER );

				WinCloseClipbrd( hAB );
			}
		}
/*
		if( stricmp(str, FORMAT_MTF) == 0 )
		{
			SequenceOfByte	Bytes = This->m_DataTransfer.getData(str);
			PSZ pText = (PSZ) Bytes.getPointer();
			
			if( WinOpenClipbrd( hAB ) )
			{
				PSZ pSharedText;

				DosAllocSharedMem( 	(PPVOID) &pSharedText, NULL, strlen( pText ) + 1,
									PAG_WRITE | PAG_COMMIT | OBJ_GIVEABLE );

				memcpy( pSharedText, pText, strlen( pText ) + 1 );

				WinEmptyClipbrd( hAB );

				// give pointer to clipboard (it will become owner of pSharedText!)
				WinSetClipbrdData( hAB, (ULONG) pSharedText, CF_METAFILE, CFI_POINTER );

				WinCloseClipbrd( hAB );
			}
		}
		
		if( stricmp(str, FORMAT_DDB) == 0 )
		{
			SequenceOfByte	Bytes = This->m_DataTransfer.getData(str);
			PSZ pText = (PSZ) Bytes.getPointer();

			if( WinOpenClipbrd( hAB ) )
			{
				PSZ pSharedText;

				DosAllocSharedMem( 	(PPVOID) &pSharedText, NULL, strlen( pText ) + 1,
									PAG_WRITE | PAG_COMMIT | OBJ_GIVEABLE );

				memcpy( pSharedText, pText, strlen( pText ) + 1 );

				WinEmptyClipbrd( hAB );

				// give pointer to clipboard (it will become owner of pSharedText!)
				WinSetClipbrdData( hAB, (ULONG) pSharedText, CF_BITMAP, CFI_POINTER );

				WinCloseClipbrd( hAB );
			}
		}
*/
	}
}

/*****************************************************************************/

XDataTransfer OSystemExchange::TSystemClipboard::paste(void)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemClipboard);

	XDataTransfer DataTransfer;

//	if (SUCCEEDED(OleGetClipboard(&pDataObj)))
//	{
		UnoDataTransferAdaptor *pAdaptor = new UnoDataTransferAdaptor();
		
		pAdaptor->queryInterface(UNO_UIK(XDataTransfer), DataTransfer);
//	}

	return DataTransfer;
}

/*****************************************************************************/

void OSystemExchange::TSystemClipboard::clear(void)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemClipboard);

	if( WinOpenClipbrd( hAB ) )
	{
		WinEmptyClipbrd( hAB );
		WinCloseClipbrd( hAB );
	}

	This->m_ClipboardListener.cleared();
}

/*****************************************************************************/

void OSystemExchange::TSystemClipboard::registerListener(XClipboardListener& xListener)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemClipboard);

	This->m_ClipboardListener = xListener;
}

/*****************************************************************************/

Short OSystemExchange::TSystemDragManager::executeDrag(XDataTransfer& Data, Short nOptions)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemDragManager);

	return SYSEX_DROP_NONE;
}

/*****************************************************************************/

void OSystemExchange::TSystemDragManager::registerListener(XDragDropListener& Listener)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemDragManager);

	This->m_DragDropListener = Listener;
}

/*****************************************************************************/

void OSystemExchange::TSystemDragManager::enableDrop(const OUnoAny& Frame, Boolean Enable)
{
	UNO_METHOD_PROLOGUE(OSystemExchange, TSystemDragManager);

	This->m_DragDropFrame = Frame;
/*
	OUnoAny OS2Data = This->m_Environment.getSystemRepresentation(Frame);

	ULONG nHAB;

	OS2Data >>= nHAB;

	hAB = (HAB) nHAB;
*/

	hAB = WinQueryAnchorBlock( HWND_DESKTOP );
}

/*****************************************************************************/

////////////////////////////////////////////////////////////////////////////

UNO_DEFINE_FACTORY( OSystemExchange, SystemExchange.stardiv.de )

UNO_BEGIN_INIT_MODULE
UNO_REGISTER_FACTORY( OSystemExchange, SystemExchange.stardiv.de )
UNO_END_INIT_MODULE


