/*************************************************************************
 *
 *  $RCSfile: unoex.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: pl $ $Date: 2000/10/04 14:28:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef W31
#include <tools/svwin.h>
#endif
#ifndef _SV_GETSYS_HXX
#include <getsys.hxx>
#endif
#ifndef _SV_EXCHANGE_H
#include <exchange.h>
#endif
#ifndef _SV_CLIP_HXX
#include <clip.hxx>
#endif
#ifndef _SV_BITMAP_HXX
#include <bitmap.hxx>
#endif
#ifndef _SV_SVDATA_HXX
#include <svdata.hxx>
#endif
#ifndef _SV_SVSYS_HXX
#include <svsys.h>
#endif
#ifndef _SV_SALFRAME_HXX
#include <salframe.hxx>
#endif
#ifndef _SV_CVTGRF_HXX
#include <cvtgrf.hxx>
#endif
#include <tools/stream.hxx>
#include <sysdata.hxx>

#ifdef REMOTE_APPSERVER
#include "unoex.hxx"

// ------------------------
// - UnoSystemEnvironment -
// ------------------------

class UnoSystemEnvironment : public ::cppu::WeakImplHelper1< NMSP_SYSTEM::XSystemEnvironment >
{
public:

							UnoSystemEnvironment();
							~UnoSystemEnvironment();

    virtual ANY SAL_CALL	getSystemRepresentation( const ANY& Handle ) throw( NMSP_UNO::RuntimeException );
};

// -----------------------------------------------------------------------------

UnoSystemEnvironment::UnoSystemEnvironment()
{
}

// -----------------------------------------------------------------------------

UnoSystemEnvironment::~UnoSystemEnvironment()
{
}

// -----------------------------------------------------------------------------

ANY SAL_CALL UnoSystemEnvironment::getSystemRepresentation( const ANY& Handle ) throw( NMSP_UNO::RuntimeException )
{
    ANY aRetVal;

#if !defined( REMOTE_APPSERVER ) && !defined(MAC)
    sal_uInt32 pFrame;
    Handle >>= pFrame;

    if( pFrame != 0 )
#ifndef UNX
        aRetVal <<= (sal_uInt32)( ((SalFrame *)pFrame)->GetSystemData()->hWnd );
#else
	    aRetVal <<= (sal_uInt32)( ((SalFrame *)pFrame)->GetSystemData() );
#endif

#endif // !defined( REMOTE_APPSERVER )
    
	return aRetVal;
}

// ---------------------
// - UnoSystemExchange -
// ---------------------

static UnoSystemExchange *pSystemExchange = NULL;

UnoSystemExchange* UnoSystemExchange::getSystemExchange()
{
	if( pSystemExchange == NULL ) 
	{
        pSystemExchange = new UnoSystemExchange();
		// Die Instanz wurde zwar erzeugt, ist sie aber auch gueltig ???
        // Wenn nicht, dann wieder loeschen !!!
//      if (pSystemExchange && (NULL == pSystemExchange->m_hUnoEnviron || NULL == pSystemExchange->m_hUnoServer)) {
//          delete pSystemExchange;
//          pSystemExchange = NULL;
//      }
    }

    return pSystemExchange;
}

// -----------------------------------------------------------------------------

UnoSystemExchange::UnoSystemExchange() : 
    m_SystemEnvironment(0)
{
#if defined( REMOTE_APPSERVER )

	REF( NMSP_UNO::XInterface ) xIf( ImplGetSVData()->mxClientFactory->createInstance( 
									 OUSTRING::createFromAscii( "SystemExchange.stardiv.de" ) ),
									 NMSP_UNO::UNO_QUERY );

	if( xIf.is() )
		mxSystemExchange = REF( NMSP_SYSTEM::XSystemExchange )( xIf, NMSP_UNO::UNO_QUERY );

#else // !defined( REMOTE_APPSERVER )

#ifdef MAC
	String aDll( "dll://sex000MP.dll" );
#else
	String aDll = rtl::OUString::createFromAscii( _WEX_DLLNAME );
#endif

/* !!!UNO3 ==> JBU
    if (m_hUnoEnviron = UNO_initialize(0) )
    {
        if( m_hUnoServer = UNO_registerServer(m_hUnoEnviron, (const char*) aDll ) )
        {
            m_SystemExchange = new XSystemExchange();

            if (UNO_createObject(m_hUnoEnviron, m_hUnoServer,
                                "SystemExchange.stardiv.de", UNO_RUIK(XSystemExchange),
                                *m_SystemExchange))
            {
                m_SystemEnvironment = new UnoSystemEnvironment;

                XSystemEnvironment xEnvironment;

                if (m_SystemEnvironment->queryInterface(UNO_UIK(XSystemEnvironment), xEnvironment))
                    m_SystemExchange->setSystemEnvironment(xEnvironment);

                return;
            }
            else
            {
                UNO_deregisterServer(m_hUnoEnviron, m_hUnoServer);
                m_hUnoServer = NULL;
            }
        }
        else
        {
            UNO_destroy(m_hUnoEnviron);
            m_hUnoEnviron = NULL;
        }
    }
*/
#endif // REMOTE_APPSERVER
}

// -----------------------------------------------------------------------------

UnoSystemExchange::~UnoSystemExchange()
{
#if !defined ( REMOTE_APPSERVER )

/* !!!UNO3 ==> JBU
    if (m_hUnoEnviron)
    {
        if (m_hUnoServer)
            UNO_deregisterServer(m_hUnoEnviron, m_hUnoServer);

        UNO_destroy(m_hUnoEnviron);
    }
*/
#endif
}

// ----------------
// - UnoDataTrans -
// ----------------

UINT32* UnoDataTrans::getTypeList( UINT32& rSize ) const
{
    NMSP_SYSTEM::SequenceOfString aStrings( mxDataTransfer->getTypeList() );

    if( ( rSize = aStrings.getLength() ) > 0 )
    {
        UINT32 *pData = new UINT32[ rSize ];

        for( UINT32 i = 0; i < rSize; i++ )
            pData[ i ] = SotExchange::RegisterFormatName( UniString( aStrings[ (int) i ] ) );

        return pData;
    }

    return 0;
}

// -----------------------------------------------------------------------------

BYTE* UnoDataTrans::getData( UINT32 nFormat, UINT32 &rSize )
{
    NMSP_SYSTEM::SequenceOfByte Bytes( mxDataTransfer->getData( SotExchange::GetFormatName( nFormat ) ) );

    if( ( rSize = Bytes.getLength() ) > 0 )
    {
        BYTE* pData = new BYTE[ rSize ];

        memcpy( pData, Bytes.getConstArray(), rSize );

        return pData;
    }

    return 0;
}

// -----------------------
// - UnoDataTransAdaptor -
// -----------------------

UnoDataTransAdaptor::UnoDataTransAdaptor( IDataTrans* pData ) : 
	mpData( pData )
{
	mpData->aquire(); 
}

// -----------------------------------------------------------------------------

UnoDataTransAdaptor::~UnoDataTransAdaptor()
{
	mpData->release(); 
}

// -----------------------------------------------------------------------------

NMSP_SYSTEM::SequenceOfString SAL_CALL UnoDataTransAdaptor::getTypeList() throw( NMSP_UNO::RuntimeException )
{
    UINT32							nFormats, *pFormatId = mpData->getTypeList( nFormats );
    NMSP_SYSTEM::SequenceOfString	aStrings( nFormats );

    for( UINT32 i = 0; i < nFormats; i++ )
        aStrings[ (int) i ] = SotExchange::GetFormatName( pFormatId[ i ] );

    return aStrings;
}

// -----------------------------------------------------------------------------

NMSP_SYSTEM::SequenceOfByte SAL_CALL UnoDataTransAdaptor::getData( const OUSTRING& rFormat ) throw( NMSP_UNO::RuntimeException )
{
	NMSP_SYSTEM::SequenceOfByte	aRet;
	const OUSTRING				aUpperFormat( rFormat.toUpperCase() );
    UINT32						nFormat = SotExchange::RegisterFormatName( UniString( OUSTRING( rFormat ) ) );
    UINT32						nBytes = 0;
    sal_Int8*					pData = (sal_Int8*) mpData->getData( nFormat, nBytes );

#if defined WIN || defined WNT || defined OS2

    if( aUpperFormat == OUSTRING::createFromAscii( "BITMAP" ) && pData && nBytes > 14 )
    {
        aRet = NMSP_SYSTEM::SequenceOfByte( pData + 14, nBytes - 14 );
        delete[] pData;
    }
    else if( aUpperFormat == OUSTRING::createFromAscii( "GDIMETAFILE" ) )
    {
        SvMemoryStream  aIStm;
        Graphic         aGraphic;

        aIStm.SetBuffer( (char*) pData, nBytes, FALSE, nBytes );
        aIStm >> aGraphic;
        delete[] pData;

        if( !aIStm.GetError() )
        {
            SvMemoryStream aOStm( 65535, 65535 );

#ifdef OS2
            if( GraphicConverter::Export( aOStm, aGraphic, CVT_MET ) == ERRCODE_NONE )
#else // OS2
            if( GraphicConverter::Export( aOStm, aGraphic, CVT_WMF ) == ERRCODE_NONE )
#endif // OSD2
			{
				aRet = NMSP_SYSTEM::SequenceOfByte( (sal_Int8*) aOStm.GetData(), aOStm.Seek( STREAM_SEEK_TO_END ) );
			}
        }
    }

#endif // WIN || WNT || OS2

	if( !aRet.getLength() && pData && nBytes )
	{
		aRet = NMSP_SYSTEM::SequenceOfByte( pData, nBytes );
		delete[] pData;
	}
	
	return aRet;
}

#endif

//*******************************************************************************************

void CreateSystemExchange()
{
#ifdef REMOTE_APPSERVER
	UnoSystemExchange::getSystemExchange();
#endif
}
