/*************************************************************************
 *
 *  $RCSfile: unoex.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "rvp.hxx"


class UnoSystemEnvironment;

class UnoSystemExchange
{
protected:

	void*										m_hUnoEnviron;	// !!!UNO3 ==> UNO_Environment
	void*										m_hUnoServer;	// !!!UNO3 ==> UNO_Server
	REF( NMSP_SYSTEM::XSystemExchange )			mxSystemExchange;
	UnoSystemEnvironment*						m_SystemEnvironment;
												
public:											
												
	static UnoSystemExchange*					getSystemExchange();
												
public:											
												
												UnoSystemExchange();
	virtual										~UnoSystemExchange();
	
	BOOL										isAvailable() const { return mxSystemExchange.is(); }
	const REF( NMSP_SYSTEM::XSystemExchange )&	getInterface() const { return mxSystemExchange; }
};

// ----------------
// - UnoDataTrans -
// ----------------

class UnoDataTrans : public IDataTrans
{
protected:

	ULONG								m_RefCount;
	REF( NMSP_SYSTEM::XDataTransfer )	mxDataTransfer;	

	virtual								~UnoDataTrans() {}

public:

										 UnoDataTrans( const REF( NMSP_SYSTEM::XDataTransfer )& rxDataTransfer ) :
											mxDataTransfer( rxDataTransfer ), m_RefCount(0) {}

	virtual void aquire()				{ m_RefCount++; }
	virtual void release()				{ if (--m_RefCount == 0) delete this; }
	
	virtual UINT32*						getTypeList(UINT32 &rSize) const;
	virtual BYTE*						getData(UINT32 nFormat, UINT32 &rSize);
};

// -----------------------
// - UnoDataTransAdaptor -
// -----------------------

class UnoDataTransAdaptor : public ::cppu::WeakImplHelper1< NMSP_SYSTEM::XDataTransfer >
{
protected:
	
	IDataTrans*										mpData;


public:

													UnoDataTransAdaptor( IDataTrans* pData );
													~UnoDataTransAdaptor();

    virtual NMSP_SYSTEM::SequenceOfString SAL_CALL	getTypeList() throw( NMSP_UNO::RuntimeException );
    virtual NMSP_SYSTEM::SequenceOfByte SAL_CALL	getData( const OUSTRING& rFormat ) throw( NMSP_UNO::RuntimeException );
};
