/*************************************************************************
 *
 *  $RCSfile: ole.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef __SV_OLE_HXX
#define __SV_OLE_HXX

#include <ole2.h>

#ifndef __SV_SYSEX_HXX
#include <vcl/sysex.hxx>
#endif

class ISVEnumFormatEtc : public IEnumFORMATETC
{
private:
    ULONG           nRef;       //Object reference count
    ULONG           nCur;       //Current element
    ULONG           nCount;     //Number of FORMATETCs in us
    LPFORMATETC     pFormats;   //Source of FORMATETCs

public:
	ISVEnumFormatEtc(const ISVEnumFormatEtc& rFormat);
    ISVEnumFormatEtc(XDataTransfer& rxData);
    ~ISVEnumFormatEtc();

    //IUnknown members that delegate to m_pUnkOuter.
    STDMETHODIMP         QueryInterface( REFIID, LPVOID FAR * );
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    //IEnumFORMATETC members
    STDMETHODIMP Next( ULONG, LPFORMATETC, ULONG FAR * );
    STDMETHODIMP Skip( ULONG );
    STDMETHODIMP Reset( void );
    STDMETHODIMP Clone( IEnumFORMATETC FAR * FAR * );
};



class ISVDataObject : public IDataObject
{
private:
    ULONG			nRef;
	XDataTransfer	xData;
public:
    ISVDataObject(XDataTransfer& rxData);

    // IUnknown
    STDMETHOD( QueryInterface ) ( REFIID, LPVOID FAR * ppvObj );
    STDMETHOD_( ULONG, AddRef ) ();
    STDMETHOD_( ULONG, Release ) ();

    // IDataObject
    STDMETHOD(GetData) ( LPFORMATETC pFormat, LPSTGMEDIUM pMedium );
    STDMETHOD(GetDataHere) ( LPFORMATETC pFormat, LPSTGMEDIUM pMedium );
    STDMETHOD(QueryGetData) ( LPFORMATETC pFormat );
    STDMETHOD(GetCanonicalFormatEtc) ( LPFORMATETC pInFormat,
                                       LPFORMATETC pOutFormat );
    STDMETHOD(SetData) ( LPFORMATETC pFormat, LPSTGMEDIUM pMedium,
                         BOOL fRelease );
    STDMETHOD(EnumFormatEtc) ( DWORD dwDirection, LPENUMFORMATETC FAR *ppForm );
    STDMETHOD(DAdvise) ( LPFORMATETC pFormat, DWORD advf,
                         LPADVISESINK pAdvSink, DWORD FAR *pConnect );
    STDMETHOD(DUnadvise) ( DWORD dwConnect );
    STDMETHOD(EnumDAdvise) ( LPENUMSTATDATA FAR *pAdvise );
};


class ISVDropTarget : public IDropTarget
{
private:
	const OUnoAny		&m_Frame;
	XDragDropListener	m_Listener;
	XDataTransfer		m_Data;
public:
	ISVDropTarget(const OUnoAny& Frame, XDataTransfer& xData, XDragDropListener& xListener);
	~ISVDropTarget();

	STDMETHOD( DragEnter )(IDataObject *pDataObject, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
	STDMETHOD( DragOver )(DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
	STDMETHOD( DragLeave )();
	STDMETHOD( Drop )(IDataObject *pDataObject, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
};


#endif	// __SV_OLE_HXX
