/*************************************************************************
 *
 *  $RCSfile: sunowrap.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <svapp.hxx>
#include <unowrap.hxx>

#include <cppuhelper/factory.hxx>
#include <uno/dispatcher.h>
#ifndef _CPPUHELPER_SERVICEFACTORY_HXX_
#include <cppuhelper/servicefactory.hxx>
#endif

#include <osl/process.h>

#include <com/sun/star/awt/XWindowPeer.hpp>

using namespace com::sun::star::uno;
using namespace com::sun::star::lang;
using namespace rtl;
using namespace cppu;

class SimpleUnoWrapper : public UnoWrapperBase
{
public:
	virtual void 				Destroy() {}
	
	// Toolkit
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XToolkit > GetVCLToolkit() { return NULL; }
	virtual void 				RegisterUnoServices() {}

	// Graphics
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XGraphics >			CreateGraphics( OutputDevice* pOutDev ) { return NULL; }
	virtual void				ReleaseAllGraphics( OutputDevice* pOutDev ) {}
	
	// Component
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer >		GetWindowInterface( Window* pWindow, BOOL bCreate ) { return NULL; }
	virtual void				SetWindowInterface( Window* pWindow, ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer > xIFace ) {}

	virtual void				WindowDestroyed( Window* pWindow ) {}

	virtual void 				WindowEvent_Move( Window* pWindow ) {}
	virtual void 				WindowEvent_Resize( Window* pWindow ) {}
	virtual void 				WindowEvent_Show( Window* pWindow, BOOL bShow ) {}
	virtual void 				WindowEvent_Activate( Window* pWindow, BOOL bActivated ) {}
	virtual void 				WindowEvent_MouseButtonUp( Window* pWindow, const MouseEvent& rEvt ) {}
	virtual void 				WindowEvent_MouseButtonDown( Window* pWindow, const MouseEvent& rEvt ) {}
	virtual void 				WindowEvent_MouseMove( Window* pWindow, const MouseEvent& rEvt ) {}
	virtual void 				WindowEvent_Command( Window* pWindow, const CommandEvent& rCEvt ) {}
	virtual void 				WindowEvent_KeyInput( Window* pWindow, const KeyEvent& rEvt ) {}
	virtual void 				WindowEvent_GetFocus( Window* pWindow ) {}
	virtual void 				WindowEvent_LoseFocus( Window* pWindow ) {}
	virtual void 				WindowEvent_Paint( Window* pWindow, const Rectangle& rRect ) {}
	virtual void 				WindowEvent_KeyUp( Window* pWindow, const KeyEvent& rEvt ) {}
	virtual void 				WindowEvent_Minimize( Window* pWindow ) {}
	virtual void 				WindowEvent_Normalize( Window* pWindow ) {}
	virtual void 				WindowEvent_Close( Window* pWindow ) {}

	virtual Reference< XMultiServiceFactory >	getNewUnoServiceManager();
};

#ifdef UNX
#define PATH_DELIM '/'
#else
#define PATH_DELIM '\\'
#endif

Reference< XMultiServiceFactory > SimpleUnoWrapper::getNewUnoServiceManager()
{
	static Reference< XMultiServiceFactory > xMgr;
	if( ! xMgr.is() )
	{
		::rtl::OUString aExec;
		if( ! osl_getExecutableFile( &aExec.pData ) )
		{
			int nPos = aExec.lastIndexOf( PATH_DELIM );
			if( nPos >= 0 )
			{
				aExec = aExec.copy( 0, nPos+1 );
				aExec += ::rtl::OUString::createFromAscii( "applicat.rdb" );
			}
			else
				aExec = ::rtl::OUString::createFromAscii( "applicat.rdb" );
			
			xMgr = ::cppu::createRegistryServiceFactory( aExec );
		}
	}

	return xMgr;
}

void SetSimpleVclUnoWrapper()
{
	static SimpleUnoWrapper aWrapper;
	Application::SetUnoWrapper( &aWrapper );
}
