/*************************************************************************
 *
 *  $RCSfile: unobrok.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>


#ifdef REMOTE_APPSERVER

#include <ooffice.hxx>
#include <unotools/processfactory.hxx>

#endif /* REMOTE_APPSERVER */


#include <vcl/svapp.hxx>
#include <osl/diagnose.h>
#include <osl/signal.h>

#include <vos/security.hxx>
#include <vos/channel.hxx>
#include <vos/timer.hxx>
#include <vos/conditn.hxx>

#include <unobrok.hxx>

#include <com/sun/star/connection/XConnector.hpp>
#include <com/sun/star/connection/XConnectionBroadcaster.hpp>
#include <com/sun/star/bridge/XBridgeFactory.hpp>

#include <cppuhelper/implbase1.hxx>

#include <cppuhelper/servicefactory.hxx>
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#include <unotools/regpathhelper.hxx>
#include <com/sun/star/lang/XInitialization.hpp>

#include <com/sun/star/connection/XAcceptor.hpp>
#include <com/sun/star/io/XStreamListener.hpp>

using namespace ::cppu;
using namespace ::rtl;
using namespace ::vos;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::io;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::connection;
using namespace ::com::sun::star::bridge;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::registry;
using namespace ::utl;


namespace vcl
{
	OUString getRemoteProtocol()
	{
		OUString sProtocol = OUString( RTL_CONSTASCII_USTRINGPARAM( "urp" ) );
		sal_Char *pEnv = getenv( "UNO_PROTOCOL" );
		if( pEnv )
		{
			sProtocol = OStringToOUString( pEnv , RTL_TEXTENCODING_ASCII_US );
		}
		return sProtocol;
	}

	class OInstanceProvider :
		public OWeakObject,
		public XInstanceProvider
	{
	public:	
		// XInterface
		Any	        SAL_CALL queryInterface( const Type & aType);
		void 		SAL_CALL acquire() 						 { OWeakObject::acquire(); }
		void 		SAL_CALL release() 						 { OWeakObject::release(); }
		
	public:
		// XConnectCallback
		virtual Reference<XInterface> SAL_CALL getInstance(const OUString & sObjectName) throw(NoSuchElementException, RuntimeException);
		
		Reference <XInterface> m_rInitialObject;
	};

	Any OInstanceProvider::queryInterface(const Type & aType)
	{
		Any a = ::cppu::queryInterface(aType, SAL_STATIC_CAST(XInstanceProvider * , this));
		if(a.hasValue())
		{
			return a;
		}

		return OWeakObject::queryInterface(aType);
	}
	
	Reference<XInterface> OInstanceProvider::getInstance(const OUString & sObjectName) throw(NoSuchElementException, RuntimeException)
	{
		Reference < XInterface > r;
		if(sObjectName == OUString(RTL_CONSTASCII_USTRINGPARAM("StarOffice.Startup")))
		{
			r = Reference<XInterface>(SAL_STATIC_CAST(OWeakObject *, new CORmStarOffice()));
		}
		else if(sObjectName == OUString(RTL_CONSTASCII_USTRINGPARAM("StarOffice.ServiceManager")))
		{
		  
		  // wait for the office to start ....
		  while( !Application::IsInExecute() )
		    {
		      TimeValue aTimeValue = { 0, 500000 };
		      osl_waitThread( &aTimeValue );
		    }
		  r = Reference<XInterface>(getProcessServiceFactory(), UNO_QUERY);
		}
#ifdef DEBUG
		else 
		{
			OString o = "unknown object name : ";
			o += OUStringToOString(sObjectName, RTL_TEXTENCODING_ASCII_US);
			OSL_ENSHURE(0, o.pData->buffer);
		}

		OString tmp = OUStringToOString(sObjectName, RTL_TEXTENCODING_ASCII_US);
		OSL_TRACE("getInstance %s %i\n", tmp.getStr(), (int)r.is());
#endif

		return r;
	}

	class RVPConnectionListener : public WeakAggImplHelper1< ::com::sun::star::io::XStreamListener >
	{
		Reference< ::com::sun::star::connection::XConnectionBroadcaster >	m_xBroadcaster;
	public:
		RVPConnectionListener( const Reference< ::com::sun::star::connection::XConnectionBroadcaster >& xBroadcaster ) : m_xBroadcaster( xBroadcaster ) {}

		// XEventListener
		virtual void SAL_CALL disposing( const EventObject& );

		// XStreamListener
		virtual void SAL_CALL started();
		virtual void SAL_CALL closed();
		virtual void SAL_CALL terminated();
		virtual void SAL_CALL error( const Any& rException );
	};
	
	void RVPConnectionListener::disposing( const EventObject& rObject )
	{
		m_xBroadcaster.clear();
	}

	void RVPConnectionListener::started()
	{
#ifdef DEBUG
		fprintf( stderr, "RVPConnectionListener::started\n" );
#endif
	}
	void RVPConnectionListener::closed()
	{
#ifdef DEBUG
		fprintf( stderr, "RVPConnectionListener::closed\n" );
#endif
	}
	void RVPConnectionListener::terminated()
	{
#ifdef DEBUG
		fprintf( stderr, "RVPConnectionListener::terminated\n" );
#endif
	}
	void RVPConnectionListener::error( const Any& rException )
	{
#ifdef DEBUG
		fprintf( stderr, "connection to client lost ... terminating\n" );
#endif
		osl_raiseSignal( OSL_SIGNAL_USER_RVPCONNECTIONERROR, NULL );
	}
}


using namespace vcl;

//  UnoBrokerThread::UnoBrokerThread( const Reference< XMultiServiceFactory > & r,
//  								  const Reference< XInterface > & rInitialObject ) :
//  	m_rSMgr( r ),
//  	m_rInitialObject( rInitialObject )
//  {
//  }	


//  UnoBrokerThread::~UnoBrokerThread()
//  {
//  }	

//  void UnoBrokerThread::run()
//  {
//  	Reference < XInterface > rX = m_rSMgr->createInstance(
//  		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.connection.Connector" ) ) );
//  	Reference < XConnector > rConnector( rX , UNO_QUERY );
	
//  	rX = m_rSMgr->createInstance(
//  		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.bridge.BridgeFactory" ) ) );
//  	Reference < XBridgeFactory > rBridgeFacrory( rX , UNO_QUERY );

//  	OSL_ASSERT( rConnector.is() && rBridgeFacrory.is() );
//  	if ( rConnector.is() && rBridgeFacrory.is() )
//  	{			
//  		OSecurity userSecurity;
//  		OUString sUserIdent;
//  	    userSecurity.getUserIdent(sUserIdent);
		
//  		OUSTRING resourceName( OUSTRING::createFromAscii( "soffice_" ) );
//  		resourceName += sUserIdent;

//  		ORef<OChannelBroker> rBroker = OChannelBroker::getGlobalChannelBroker();
//  		ORef<OChannel> rChannel;
//  		TTimeValue timeout(5,0);

//  		sal_Bool bFirstConnectionAccepted = sal_False;
//  		while ( schedule() )
//  		{
//  			OChannelBroker::TError error = rBroker->accept(rChannel, resourceName, NULL, &timeout);
			
//  			if (error == OChannelBroker::NoError)
//  			{
//  				bFirstConnectionAccepted = sal_True;
//  				OUString sParameter( OUSTRING::createFromAscii( "channel,Resource=" ) );
//  				sParameter += OUString::valueOf( ( sal_Int64 ) &rChannel , 10 );

//  				try
//  				{
//  					Reference < XConnection > rConnection =
//  						rConnector->connect( sParameter  );

//  					if( rConnection.is() )
//  					{
//  						// Bridge object exists until first object is mapped !
//  						Reference< XBridge > rBridge = rBridgeFacrory->createBridge(
//  							OUString(),
//  							getRemoteProtocol(),
//  							rConnection,
//  							(XInstanceProvider *) new OInstanceProvider( m_rInitialObject ) );
//  					}
//  				}
//  				catch ( IllegalArgumentException & e)
//  				{
//  					OString sError = "IllegalArgumentException : ";
//  					sError += OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US );
//  					sError += OUStringToOString( sParameter , RTL_TEXTENCODING_ASCII_US );
//  					sError += "\nAccepting cancelled";
//  					OSL_ENSHURE( 0 , sError.getStr() );
//  					break;
//  				}
//  			}
//  			if( OChannelBroker::Timeout == error && !bFirstConnectionAccepted )
//  			{
//  				terminate();
//  			}
//  		}
//  	}
//  }

//  void UnoBrokerThread::onTerminated()
//  {
//  	ImplSVData* pSVData = ImplGetSVData();

//  	if (pSVData->mpStartUpCond)
//  		pSVData->mpStartUpCond->set();	
//  }




//  vcl_AcceptorThread::vcl_AcceptorThread(
//  	const Reference< XMultiServiceFactory > & r,
//  	const Reference< XInterface > & rInitialObject,
//  	const ::rtl::OUString &sAcceptorDescription ) :
//  	m_rSMgr( r ),
//  	m_rInitialObject( rInitialObject ),
//  	m_sAcceptorDescription( sAcceptorDescription )
//  {
	
//  }

//  void vcl_AcceptorThread::run()
//  {
//  	Reference < XInterface > rX = m_rSMgr->createInstance(
//  		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.connection.Acceptor" ) ) );
//  	m_rAcceptor = Reference < XAcceptor > ( rX , UNO_QUERY );
	
//  	rX = m_rSMgr->createInstance(
//  		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.bridge.BridgeFactory" ) ) );
//  	Reference < XBridgeFactory > rBridgeFacrory( rX , UNO_QUERY );

//  	OSL_ASSERT( m_rAcceptor.is() && rBridgeFacrory.is() );
//  	if ( m_rAcceptor.is() && rBridgeFacrory.is() )
//  	{			
//  		sal_Int32 nIndex = m_sAcceptorDescription.indexOf( (sal_Unicode) ';' );
//  		if( -1 == nIndex )
//  		{
//  				// wrong format
//  			return;
//  		}
//  		OUString sConnection = m_sAcceptorDescription.copy( 0 , nIndex ).trim();
//  		nIndex++;
		
//  		sal_Int32 nIndex2 = m_sAcceptorDescription.indexOf( (sal_Unicode) ';' , nIndex );
//  		if( -1 == nIndex2 )
//  		{
//  			nIndex2 = m_sAcceptorDescription.getLength();
//  		}
//  		OUString sProtocol   = m_sAcceptorDescription.copy( nIndex, nIndex2 - nIndex );		
		
//  		while ( schedule() )
//  		{
//  			try
//  			{
//  				Reference < XConnection > rConnection = m_rAcceptor->accept( sConnection );
//  				if( rConnection.is() )
//  				{
//  					// Bridge object exists until first object is mapped !
//  					Reference< XBridge > rBridge = rBridgeFacrory->createBridge(
//  						OUString(),
//  //  						getRemoteProtocol(),
//  						sProtocol,
//  						rConnection,
//  						(XInstanceProvider *) new OInstanceProvider( m_rInitialObject ) );
//  				}
//  			}
//  			catch( ConnectionSetupException & e )
//  			{
//  				OString sError = "ConnectionSetupException : ";
//  				sError += OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US );
//  				sError += "\nAccepting cancelled";
				
//  				OSL_ENSHURE( 0 , sError.getStr() );
//  				break;
//  			}
//  			catch( IllegalArgumentException & e )
//  			{
//  				OString sError = "vcl_AcceptorThread: IllegalArgumentException : ";
//  				sError += OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US );
//  				sError += "\n";
//  				sError += OUStringToOString( m_sAcceptorDescription, RTL_TEXTENCODING_ASCII_US );
					
//  				sError += "\nAccepting cancelled";

//  				OSL_ENSHURE( 0 , sError.getStr() );
//  				break;
//  			}
			
//  		}
//  	}
//  }

//  void vcl_AcceptorThread::terminate()
//  {
//  	OThread::terminate();
//  	if( m_rAcceptor.is() )
//  	{
//  		m_rAcceptor->stopAccepting();
//  #ifndef LINUX
//  		// The accepting thread does not return on linux
//  		join();
//  #endif
//  	}
//  }
	
//  void vcl_AcceptorThread::onTerminated()
//  {
//  	ImplSVData* pSVData = ImplGetSVData();

//  	if (pSVData->mpStartUpCond)
//  		pSVData->mpStartUpCond->set();	
//  }


namespace vcl_accept 
{

	sal_Bool accept(const OUString & accDcp, const Reference<XMultiServiceFactory> & rSMgr)
    {
		sal_Bool result = sal_False;

		Reference<XInterface> rX = rSMgr->createInstance(OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.connection.Acceptor")));
		Reference<XAcceptor> xAcceptor(rX, UNO_QUERY);
	
		rX = rSMgr->createInstance(OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.bridge.BridgeFactory")));
		Reference <XBridgeFactory> xBridgeFactory(rX , UNO_QUERY);

		OSL_ASSERT(xAcceptor.is() && xBridgeFactory.is());
		if (xAcceptor.is() && xBridgeFactory.is())
		{			
			sal_Int32 nIndex = accDcp.indexOf((sal_Unicode)';');
			if(-1 != nIndex)
			{
				OUString sConnection = accDcp.copy(0 , nIndex).trim();
				++ nIndex;
				
				sal_Int32 nIndex2 = accDcp.indexOf((sal_Unicode)';', nIndex);
				if( -1 == nIndex2)
					nIndex2 = accDcp.getLength();

				OUString sProtocol = accDcp.copy(nIndex, nIndex2 - nIndex);		
		
				try
				{
					Reference <XConnection> xConnection = xAcceptor->accept(sConnection);
					if(xConnection.is())
					{
						Reference< XConnectionBroadcaster > xBroadcaster( xConnection, UNO_QUERY );
						if( xBroadcaster.is() )
						{
							xBroadcaster->addStreamListener( new RVPConnectionListener( xBroadcaster ) );
#ifdef DEBUG
							fprintf( stderr, "registered listener to connection\n" );
#endif
						}
#ifdef DEBUG
						else
							fprintf( stderr, "Connection is not a XConnectionBroadcaster\n" );
#endif
							
						// Bridge object exists until first object is mapped !
						Reference<XBridge> xBridge = xBridgeFactory->createBridge(
							OUString(),
							sProtocol,
							xConnection,
							(XInstanceProvider *) new OInstanceProvider());

						result = sal_True;
					}
				}
				catch(ConnectionSetupException & e)
				{
					OString sError = "ConnectionSetupException : ";
					sError += OUStringToOString(e.Message, RTL_TEXTENCODING_ASCII_US);
					sError += "\nAccepting cancelled";
					
					OSL_ENSHURE(0 , sError.getStr());
				}
				catch(IllegalArgumentException & e)
				{
					OString sError = "vcl_AcceptorThread: IllegalArgumentException : ";
					sError += OUStringToOString(e.Message, RTL_TEXTENCODING_ASCII_US);
					sError += "\n";
					sError += OUStringToOString( accDcp, RTL_TEXTENCODING_ASCII_US);
					
					sError += "\nAccepting cancelled";
					
					OSL_ENSHURE(0 , sError.getStr());
				}
			}
			
		}

		return result;
	}
}
