/*************************************************************************
 *
 *  $RCSfile: kdeint.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SV_KDEINT_HXX
#define _SV_KDEINT_HXX

#ifndef _SV_DTINT_HXX
#include <dtint.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

struct KDEMimeType
{
	String		maName;
	String		maExtensions;	// contains the extensions of this mimetype
								// separated by ':'
	String		maIcon;			// the appropriate xpm
	String		maMiniIcon;		// and the small one
	String		maApplication;	// Application for this file type
};

DECLARE_LIST( KDEMimeTypeList, KDEMimeType* );


class KDEIntegrator : public DtIntegrator
{
	friend DtIntegrator* DtIntegrator::CreateDtIntegrator( SalFrame* );
private:
	static int		nInstances;

	KDEMimeTypeList	maMimeTypes;
	Atom			mnDndSelectionAtom;
	Atom			mnDndProtocolAtom;

	Atom			mnCurrentDesktopAtom;
	ULONG			mnCurrentDesktop;

	String			maGlobalKDEDir;
	String			maLocalKDEDir;
	ByteString		maKDELanguage;

	KDEIntegrator( SalFrame* );

	String CreateKDEPath( char* );
	
	void InitMimeTypes();
	void IntegrateMimePath( const String& );
	KDEMimeType*	FindTypeForFile( const String& );

protected:
	virtual void ImplHandleXEvent( XEvent* );

public:
	virtual ~KDEIntegrator();

	virtual BOOL StartProcess( String&, String&, const String& rDir = String() );
	virtual BOOL GetSystemLook( SystemLookInfo& rInfo );
};

#endif
