/*************************************************************************
 *
 *  $RCSfile: salpdecl.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:05:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef __salpdecl_h
#define __salpdecl_h

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <X11/Xmu/Atoms.h>
#include <X11/Xmu/SysUtil.h>

#ifdef __cplusplus
extern "C" {
#endif

#if defined S390 || defined AIX
#define NO_SHM_FUNCTIONS
#endif

#ifndef NO_SHM_FUNCTIONS
#include <X11/extensions/XShm.h>
#else
typedef struct XShmSegmentInfo XShmSegmentInfo;
#endif

/* error handling */

typedef int (*XSalPeekEventPredicate)( Display*, XEvent*, XPointer );
typedef int (*XSalAfterFunction)( );

/* funtions for drawing rotated strings */
extern int	XSalCanDrawRotString( Display*, GC );
extern int	XSalDrawRotString( Display*, Drawable, GC,
							   int x, int y,
							   const char* string, int length,
							   int angle );
extern int	XSalDrawRotImageString( Display*, Drawable, GC,
									int x, int y,
									const char* string, int length,
									int angle );
extern int	XSalDrawRotString16( Display*, Drawable, GC,
								 int x, int y,
								 const unsigned short* string, int length,
								 int angle );
extern int	XSalDrawRotImageString16( Display*, Drawable, GC,
									  int x, int y,
									  const unsigned short* string, int length,
									  int angle );



#include <salpdec1.h>



/* printer interface */
extern int XSalIsDisplay( const Display * );
extern int XSalIsPrinter( const Display * );

#ifdef __cplusplus
} // extern "C"
#endif

#endif
