/*************************************************************************
 *
 *  $RCSfile: ctrl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:18:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>

#ifndef _OSL_DEMONMGR_H_
#       include <osl/demonmgr.h>
#endif
#ifndef _CTRL_HXX_
#		include "ctrl.hxx"
#endif


char *charDaemonStatus[] =
{	
	"osl_Daemon_StatusStartPending",
	"osl_Daemon_StatusStopPending",
	"osl_Daemon_StatusPausePending",
	"osl_Daemon_StatusRunning",
	"osl_Daemon_StatusStopped",
	"osl_Daemon_StatusPaused",
	"osl_Daemon_StatusUnknown",
};

char *charDaemonCommand[] =
{	
	"osl_Daemon_CommandStart",
	"osl_Daemon_CommandStop",
	"osl_Daemon_CommandPause",
	"osl_Daemon_CommandContinue",
	"osl_Daemon_CommandShutdown",
	"osl_Daemon_CommandUnknown"
};


/*--------------------------------------------------------------------------*
 * be a better daemon: run as controller									*
 *--------------------------------------------------------------------------*/


void 
run_as_master ( char *name, FILE *outfile, oslDaemonInfo *info, 
				oslDaemonCommand mode)
{
	osl_DaemonMgrHandle mgr_handle;
    osl_DaemonEntityHandle entity_handle;
	oslDaemonCommand 	eCommand;

	mgr_handle = osl_openDaemonManager ( osl_DaemonMgr_Read );

	if ( !mgr_handle ) 
	{
		fprintf (outfile, "%s: can't open daemon-mgr (read/write)\n", name);
		return;
	}

	entity_handle = osl_openDaemonEntity ( mgr_handle, info->service_name );

    if ( !entity_handle )
   	{
        fprintf (outfile, "%s: can't open entity \"%s\"\n", name, info->service_name);
        osl_closeDaemonManager ( mgr_handle );
        return;
   	} 
    
	if ( mode == osl_Daemon_CommandUnknown )
	{
		oslDaemonStatus Status;
		if ( osl_queryDaemon ( entity_handle, &Status ) )
			fprintf (outfile, "%s: status for \"%s\" is \"%s\"\n", 
					 name, info->service_name, charDaemonStatus [ Status ] );
		else
			fprintf (outfile, "%s: status for \"%s\" could not be retrieved\n", 
					 name, info->service_name );
	}
	else	
	{
		if ( osl_controlDaemon ( entity_handle, mode, 0 /* TimeOut */ ) )
			fprintf (outfile, "%s: instructed \"%s\" to \"%s\"\n",
					 name, info->service_name,  charDaemonCommand [ mode ] );
		else
			fprintf (outfile, "%s: could not instruct \"%s\" to \"%s\"\n",
					 name, info->service_name,  charDaemonCommand [ mode ] );
	}

	osl_closeDaemonEntity  ( entity_handle );
	osl_closeDaemonManager ( mgr_handle );
}


