/*************************************************************************
 *
 *  $RCSfile: run.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:18:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>

#ifndef _OSL_DEMONMGR_H_
#       include <osl/demonmgr.h>
#endif
#ifndef _RUN_HXX_
#		include "run.hxx"
#endif


/*--------------------------------------------------------------------------*
 * be a good daemon: run as a slave											*
 *--------------------------------------------------------------------------*/


void paresseux (char *name, FILE *outfile, char *string)
{
	fprintf (outfile, "%s: going into state %s ", name, string); 
	usleep ( random() % (1000 * 1000) );
	fprintf (outfile, " (done)\n");
}


void 
run_as_slave ( char *name, FILE *outfile, oslDaemonInfo *info)
{
	osl_DaemonMgrHandle mgr_handle;
	oslDaemonCommand 	eCommand;
	Boolean 		 	bContinue = True;

	mgr_handle = osl_openSlaveManager ( osl_DaemonMgr_Read );

	if ( !mgr_handle ) 
	{
		fprintf (outfile, "%s: can't open slave-mgr (read)\n", name);
		return;
	}
	
	srandom ( time(NULL) );
	osl_reportSlave ( mgr_handle, osl_Daemon_StatusStartPending );
	paresseux( name, outfile, "Running" );	
	osl_reportSlave ( mgr_handle, osl_Daemon_StatusRunning );
	
	while ( bContinue )
	{
		fprintf ( outfile, "%s: obeing ..." );
		eCommand = osl_obeySlave( mgr_handle );
		fprintf ( outfile, "\n");

		switch ( eCommand )
		{
		case osl_Daemon_CommandPause:
			paresseux( name, outfile, "PausePending" );
			osl_reportSlave ( mgr_handle, osl_Daemon_StatusPausePending );
			paresseux( name, outfile, "Paused" );
			osl_reportSlave ( mgr_handle, osl_Daemon_StatusPaused );
			break;

		case osl_Daemon_CommandStart:
		case osl_Daemon_CommandContinue:
			paresseux( name, outfile, "Running" );
			osl_reportSlave ( mgr_handle, osl_Daemon_StatusRunning ); 
			break;

		case osl_Daemon_CommandStop:
		case osl_Daemon_CommandShutdown:
		case osl_Daemon_CommandUnknown:
			paresseux( name, outfile, "StopPending" );
			osl_reportSlave ( mgr_handle, osl_Daemon_StatusStopPending );
			paresseux( name, outfile, "Stopped" );
			osl_reportSlave ( mgr_handle, osl_Daemon_StatusStopped );
			bContinue = False;
			break;
		}
	}

	osl_closeDaemonManager ( mgr_handle );
}


