/*************************************************************************
 *
 *  $RCSfile: dispatch.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:18:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DISPATCH_HXX_
#define _DISPATCH_HXX_

#ifndef _VOS_MUTEX_HXX_
#   include <vos/mutex.hxx>
#endif
#ifndef _ERROR_HXX_
#	include "error.hxx"
#endif

class DmgrEntity;
class MTProfile;


class Entity  {

public:

					 Entity() { 
						entry  = NULL; 
						name   = "(null)"; 
						owner  = 0; 
						daemon = 0;
					};

	DmgrEntity		*entry;	// the service itself
	char 	  		*name;	// name of service
	int				 owner;	// a clients pid, who has locked this entry
	int				 daemon;// the daemons pid, if has been started
};


/*
 * Repository of daemon information
 */

class DmgrDispatcher
{
public:
					  DmgrDispatcher  ( MTProfile *mpRepository, 
										Boolean bAutomatic  );
					  ~DmgrDispatcher ( );

	int				  OpenEntity   ( char* name, int caller );
	int				  NewEntity    ( char* name, int caller );
	DmgrEntity*		  GetEntity    ( int   id,   int caller );
	void			  DeleteEntity ( int   id,   int caller );
	void			  CloseEntity  ( int   id,   int caller );

	Boolean			  EnumDaemonInfo ( int ordinal, oslDaemonInfo* Info );
	Boolean			  StartDaemon  ( int   id,   int caller, int timeout );
	int				  ReconnectDaemon  ( int pid, OStreamPipe &aConnection );
	int				  DisconnectDaemon ( int nid );

	Boolean           SetProperty  ( char* Name, char *Value );
    Boolean           GetProperty  ( char* Name, char *Value, size_t Length );

	Boolean			  Cleanup	   ( int caller );

private:

	Boolean			  AccessAllowed	( int id, int caller, Boolean do_lock );
	int				  EntityExists  ( char *name );
	int				  EmptyEntity   ( );

	Entity			 *mpEntity;		  	// List of services
	int				  mnEntityCount;	// Number of entities
	int				  mnAllocCount;		// Number of preallocated entities

	OMutex 			  maMutex;
	MTProfile 		 *mpRepository;
};


#endif // _DISPATCH_HXX_

