/*************************************************************************
 *
 *  $RCSfile: ports.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:18:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include <vos/diagnose.hxx>
#include <vos/ports.hxx>


#ifdef _USE_NAMESPACE
namespace vos
{
#endif

#ifndef WNT 
	/*	in win32 muss die initialisierung im header erfolgen.		
	*/
	const OPort::TPortType	OPort::Rs232		=	OSL_PORT_TYPE_RS232;
	const OPort::TPortType	OPort::Parallel		=	OSL_PORT_TYPE_PARALLELPORT; 
	const OPort::TPortType	OPort::Unknown		=	OSL_PORT_TYPE_UNKNOWN;


	const OSerialPort::TDatabit	OSerialPort::Databits_5		=	OSL_PORT_DATABITS_5;
	const OSerialPort::TDatabit	OSerialPort::Databits_6		=	OSL_PORT_DATABITS_6;
	const OSerialPort::TDatabit	OSerialPort::Databits_7		=	OSL_PORT_DATABITS_7;
	const OSerialPort::TDatabit	OSerialPort::Databits_8		=	OSL_PORT_DATABITS_8;
	const OSerialPort::TDatabit	OSerialPort::Databits_16	=	OSL_PORT_DATABITS_16;
	const OSerialPort::TDatabit	OSerialPort::Databits_16x	=	OSL_PORT_DATABITS_16X;


	const OSerialPort::TStopbit	OSerialPort::Stopbits_10	=	OSL_PORT_STOPBITS_10;
	const OSerialPort::TStopbit	OSerialPort::Stopbits_15	=	OSL_PORT_STOPBITS_15;
	const OSerialPort::TStopbit	OSerialPort::Stopbits_20	=	OSL_PORT_STOPBITS_20;

	const OSerialPort::TParityMode	OSerialPort::Parity_None	=	OSL_PORT_PARITY_NONE;
	const OSerialPort::TParityMode	OSerialPort::Parity_Odd		=	OSL_PORT_PARITY_ODD;
	const OSerialPort::TParityMode	OSerialPort::Parity_Even	=	OSL_PORT_PARITY_EVEN;
	const OSerialPort::TParityMode	OSerialPort::Parity_Mark	=	OSL_PORT_PARITY_MARK;
	const OSerialPort::TParityMode	OSerialPort::Parity_Space	=	OSL_PORT_PARITY_SPACE;


	const OSerialPort::TBaudRate	OSerialPort::Baud_075		=	OSL_PORT_BAUD_075;
	const OSerialPort::TBaudRate	OSerialPort::Baud_110		=	OSL_PORT_BAUD_110;
	const OSerialPort::TBaudRate	OSerialPort::Baud_134_5		=	OSL_PORT_BAUD_134_5;
	const OSerialPort::TBaudRate	OSerialPort::Baud_150		=	OSL_PORT_BAUD_150;
	const OSerialPort::TBaudRate	OSerialPort::Baud_300		=	OSL_PORT_BAUD_300;
	const OSerialPort::TBaudRate	OSerialPort::Baud_600		=	OSL_PORT_BAUD_600;
	const OSerialPort::TBaudRate	OSerialPort::Baud_1200		=	OSL_PORT_BAUD_1200;
	const OSerialPort::TBaudRate	OSerialPort::Baud_1800		=	OSL_PORT_BAUD_1800;
	const OSerialPort::TBaudRate	OSerialPort::Baud_2400		=	OSL_PORT_BAUD_2400;
	const OSerialPort::TBaudRate	OSerialPort::Baud_4800		=	OSL_PORT_BAUD_4800;
	const OSerialPort::TBaudRate	OSerialPort::Baud_7200		=	OSL_PORT_BAUD_7200;
	const OSerialPort::TBaudRate	OSerialPort::Baud_9600		=	OSL_PORT_BAUD_9600;
	const OSerialPort::TBaudRate	OSerialPort::Baud_14400		=	OSL_PORT_BAUD_14400;
	const OSerialPort::TBaudRate	OSerialPort::Baud_19200		=	OSL_PORT_BAUD_19200;
	const OSerialPort::TBaudRate	OSerialPort::Baud_38400		=	OSL_PORT_BAUD_38400;
	const OSerialPort::TBaudRate	OSerialPort::Baud_56k		=	OSL_PORT_BAUD_56000;
	const OSerialPort::TBaudRate	OSerialPort::Baud_128k		=	OSL_PORT_BAUD_128000;
	const OSerialPort::TBaudRate	OSerialPort::Baud_115200	=	OSL_PORT_BAUD_115200;
	const OSerialPort::TBaudRate	OSerialPort::Baud_57600		=	OSL_PORT_BAUD_57600;
	const OSerialPort::TBaudRate	OSerialPort::Baud_User		=	OSL_PORT_BAUD_USER;


	const OSerialPort::TPurgeOption	OSerialPort::Purge_TxAbort	=	OSL_PORT_PURGE_TXABORT;
	const OSerialPort::TPurgeOption	OSerialPort::Purge_RxAbort	=	OSL_PORT_PURGE_RXABORT;
	const OSerialPort::TPurgeOption	OSerialPort::Purge_TxClear	=	OSL_PORT_PURGE_TXCLEAR;
	const OSerialPort::TPurgeOption	OSerialPort::Purge_RxClear	=	OSL_PORT_PURGE_TXCLEAR;

	const OSerialPort::TEvent	OSerialPort::Event_RxChar	=	OSL_PORT_EV_RXCHAR;
	const OSerialPort::TEvent	OSerialPort::Event_RxFlag	=	OSL_PORT_EV_RXFLAG;
	const OSerialPort::TEvent	OSerialPort::Event_TxEmpty	=	OSL_PORT_EV_TXEMPTY;
	const OSerialPort::TEvent	OSerialPort::Event_Cts		=	OSL_PORT_EV_CTS;
	const OSerialPort::TEvent	OSerialPort::Event_Dsr		=	OSL_PORT_EV_DSR;
	const OSerialPort::TEvent	OSerialPort::Event_Rlsd		=	OSL_PORT_EV_RLSD;
	const OSerialPort::TEvent	OSerialPort::Event_Break	=	OSL_PORT_EV_BREAK;
	const OSerialPort::TEvent	OSerialPort::Event_Error	=	OSL_PORT_EV_ERR;
	const OSerialPort::TEvent	OSerialPort::Event_Ring		=	OSL_PORT_EV_RING;
	const OSerialPort::TEvent	OSerialPort::Event_RX80Percent	=	OSL_PORT_EV_RX80FULL;


	const OSerialPort::TError	OSerialPort::Error_None			=	OSL_PORT_E_NONE;
	const OSerialPort::TError	OSerialPort::Error_RxOverflow	=	OSL_PORT_E_RXOVER;
	const OSerialPort::TError	OSerialPort::Error_Overrun		=	OSL_PORT_E_OVERRUN;
	const OSerialPort::TError	OSerialPort::Error_RxParity		=	OSL_PORT_E_RXPARITY;
	const OSerialPort::TError	OSerialPort::Error_Frame		=	OSL_PORT_E_FRAME;
	const OSerialPort::TError	OSerialPort::Error_TxFull		=	OSL_PORT_E_TXFULL;
	const OSerialPort::TError	OSerialPort::Error_Io			=	OSL_PORT_E_IOE;
	const OSerialPort::TError	OSerialPort::Error_Unknown		=	OSL_PORT_E_UNKNOWN;

	const OSerialPort::TDtrControl	OSerialPort::DtrControl_Disable	=	OSL_PORT_DTR_CONTROL_DISABLE;
	const OSerialPort::TDtrControl	OSerialPort::DtrControl_Enable	=	OSL_PORT_DTR_CONTROL_ENABLE;
	const OSerialPort::TDtrControl	OSerialPort::DtrControl_Handshake=	OSL_PORT_DTR_CONTROL_HANDSHAKE;


	const OSerialPort::TRtsControl	OSerialPort::RtsControl_Disable	=	OSL_PORT_RTS_CONTROL_DISABLE;
	const OSerialPort::TRtsControl	OSerialPort::RtsControl_Enable	=	OSL_PORT_RTS_CONTROL_ENABLE;
	const OSerialPort::TRtsControl	OSerialPort::RtsControl_Handshake=	OSL_PORT_RTS_CONTROL_HANDSHAKE;
	const OSerialPort::TRtsControl	OSerialPort::RtsControl_Toggle	=	OSL_PORT_RTS_CONTROL_TOGGLE;

#endif //WNT 


static void SAL_CALL _osl_Port_Callback( sal_uInt32 nEventMask, oslPort hPort, sal_uInt32 nUserData )
{
	if( nUserData ) ( (NAMESPACE_VOS( OSerialPort )*) nUserData)->notifyListener( nEventMask );
}

/*****************************************************
Globals
*****************************************************/

inline sal_Bool isError_Impl ( oslPortError val )
{
	return ( val != osl_Port_E_None );
}



/*****************************************************
PortImpl class
*****************************************************/

class OPortImpl
{


public:
	oslPort					m_hPort;
	oslPortProperties		m_aPortProp;
	sal_Bool					m_isProp;
	sal_Bool					m_isOpen;

public:
				OPortImpl();
	virtual		~OPortImpl();

	void		reset () { m_hPort = NULL; m_isOpen = sal_False; m_isProp = sal_False; };

};

OPortImpl::OPortImpl() :
	m_hPort		( NULL ),
	m_isOpen	( sal_False ),
	m_isProp	( sal_False )
{
	m_aPortProp.Size = sizeof( m_aPortProp );
}

OPortImpl::~OPortImpl()
{
}


class IPortEnum_impl: public IPortEnum, public OReference
{
private:
	oslPortEnum portEnum;
public:
	IPortEnum_impl();
	~IPortEnum_impl();
	
	virtual sal_Bool SAL_CALL getNextPortName( rtl::OUString& strPortName );
	virtual void SAL_CALL reset();
	
	virtual RefCount SAL_CALL acquire() { return OReference::acquire(); }
	virtual RefCount SAL_CALL release() { return OReference::release(); }
	virtual RefCount SAL_CALL referenced() const { return OReference::referenced(); }
	
};


IPortEnum_impl::IPortEnum_impl()
{
	portEnum = osl_openPortEnum(); 
}
	
IPortEnum_impl::~IPortEnum_impl()
{
	osl_closePortEnum( portEnum );
}

sal_Bool IPortEnum_impl::getNextPortName( rtl::OUString& strPortName )
{
	return osl_getNextPortName( portEnum, &strPortName.pData );
}

void IPortEnum_impl::reset()
{
	osl_resetPortEnum( portEnum );
}


/*****************************************************
OPort implementation
*****************************************************/

VOS_IMPLEMENT_CLASSINFO(VOS_CLASSNAME(OPort, vos), 
						VOS_NAMESPACE(OPort, vos), 
						VOS_NAMESPACE(OObject, vos), 0);



/*****************************************************
OPort constructor / destructor
*****************************************************/

OPort::OPort() :
	m_pPortData ( NULL ) 
{
	m_pPortData = new OPortImpl;

}

OPort::~OPort()
{ 
	if( m_pPortData->m_isOpen )
	{
		osl_closePort( m_pPortData->m_hPort );
	}

	delete m_pPortData;
}

/*****************************************************
OPort static memberfunction
*****************************************************/

OPort::TPortType	OPort::getPortTypeByName( const rtl::OUString& pName )
{
	return (TPortType) osl_getPortTypeByName( pName.pData );
}


OPortEnumRef OPort::enumPortNames()
{
	IPortEnum_impl *data = new IPortEnum_impl();
	return *new OPortEnumRef( data );
}


/*
OPort::TPortError	OPort::getPortNames(	sal_Char* pNameList, 
											sal_uInt32 tSize, 
											sal_uInt32 *pNumberOfEntries )
{
	sal_uInt32 numOfEntries = *pNumberOfEntries;
	TPortError ret = (TPortError) osl_getPortNames( pNameList, tSize, &numOfEntries );	
	*pNumberOfEntries = numOfEntries;
	return ret;
}*/


OPort::TPortError OPort::getPortNames( NAMESPACE_STD(vector) < NAMESPACE_RTL(OUString) >& rPortNameVec )
{
	IPortEnum_impl PortNumberIter;
	rtl::OUString actualPortName;
	sal_Bool ListNotExhausted;
	
	do {
		ListNotExhausted = PortNumberIter.getNextPortName( actualPortName );
		rPortNameVec.push_back( actualPortName );
	} while( ! ListNotExhausted );
	return E_None; 
}



/*****************************************************
OPort memberfunction
*****************************************************/

/*****************************************************
OPort open()
*****************************************************/
OPort::TPortError	OPort::open( const rtl::OUString& pPortName )
{
	oslPortError	ret;

	if( m_pPortData->m_isOpen )
	{
		return E_None;
	}
	else
	{
		m_pPortData->m_hPort = (void*) 1;
		ret = osl_openPort( pPortName.pData, 
							OSL_PORT_AC_READ | OSL_PORT_AC_WRITE,
							& (m_pPortData->m_hPort)
							);
		if( ! isError_Impl(ret) )
		{
			m_pPortData->m_isOpen = sal_True;

			ret = osl_getPortProperties( m_pPortData->m_hPort, & m_pPortData->m_aPortProp );
			if( ! isError_Impl( ret) )
			{
				m_pPortData->m_isProp = sal_True;
			}
		}
	}
	return (TPortError) ret;
}
/*****************************************************
OPort close()
*****************************************************/

OPort::TPortError	OPort::close()
{
	if( ! m_pPortData->m_isOpen )
	{
		 return E_None;
	}
	else
	{
		osl_closePort( m_pPortData->m_hPort );
		m_pPortData->reset();
	}
	return E_None;
}

sal_Bool		OPort::isOpen() const
{
	return m_pPortData->m_isOpen;		
}

/*****************************************************
OPort isIntervalTimeoutSupported()
*****************************************************/

sal_Bool	OPort::isIntervalTimeoutSupported() const
{
	if( m_pPortData->m_isOpen  && m_pPortData->m_isProp )
	{
	 	if ( (m_pPortData->m_aPortProp.PortCapabilities & OSL_PORT_PCF_INTTIMEOUTS) )
			return 	sal_True;
	}
	return sal_False;
}
/*****************************************************
OPort isTotalTimeoutSupported()
*****************************************************/

sal_Bool		OPort::isTotalTimeoutSupported() const
{
	if( m_pPortData->m_isOpen  && m_pPortData->m_isProp )
	{
	 	if ( (m_pPortData->m_aPortProp.PortCapabilities & OSL_PORT_PCF_TOTALTIMEOUTS) )
			return 	sal_True;
	}
	return sal_False;
}
/*****************************************************
OPort getType()
*****************************************************/

OPort::TPortType	OPort::getType()
{
	if( m_pPortData->m_isOpen  && m_pPortData->m_isProp )
	{
	 	return 	(TPortType) m_pPortData->m_aPortProp.PortType;
	}
	return Unknown;
}

/*****************************************************
OPort getTimeout()	/ setTimeout()
*****************************************************/

OPort::TPortError	OPort::getTimeout( 
		sal_uInt32 &ReadIntervalTimeout,
		sal_uInt32 &ReadTotalTimeoutMultiplier,
		sal_uInt32 &ReadTotalTimeoutConstant,
		sal_uInt32 &WriteTotalTimeoutMultiplier,
		sal_uInt32 &WriteTotalTimeoutConstant )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			ReadIntervalTimeout			=	aTimeout.ReadIntervalTimeout;
			ReadTotalTimeoutMultiplier	=	aTimeout.ReadTotalTimeoutMultiplier;
			ReadTotalTimeoutConstant	=	aTimeout.ReadTotalTimeoutConstant;
			WriteTotalTimeoutMultiplier	=	aTimeout.WriteTotalTimeoutMultiplier;
			WriteTotalTimeoutConstant	=	aTimeout.WriteTotalTimeoutConstant;

			return E_None;
		}
	}
	return E_NotAvailable;
}
								
OPort::TPortError	OPort::setTimeout(
		sal_uInt32 ReadIntervalTimeout,
		sal_uInt32 ReadTotalTimeoutMultiplier,
		sal_uInt32 ReadTotalTimeoutConstant,
		sal_uInt32 WriteTotalTimeoutMultiplier,
		sal_uInt32 WriteTotalTimeoutConstant )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
																	  
		aTimeout.ReadIntervalTimeout		=	ReadIntervalTimeout;
		aTimeout.ReadTotalTimeoutMultiplier	=	ReadTotalTimeoutMultiplier;
		aTimeout.ReadTotalTimeoutConstant	=   ReadTotalTimeoutConstant;
		aTimeout.WriteTotalTimeoutMultiplier=	WriteTotalTimeoutMultiplier;
		aTimeout.WriteTotalTimeoutConstant	=	WriteTotalTimeoutConstant;
		
		ret = osl_setPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl ( ret ) )
			return E_None;
	}
	return E_NotAvailable;

}

/*****************************************************
OPort getTimeoutXXX()	/ setTimeoutXXX()
*****************************************************/

OPort::TPortError	OPort::getReadIntervalTimeout( sal_uInt32 &ReadIntervalTimeout )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			ReadIntervalTimeout			=	aTimeout.ReadIntervalTimeout;
			return E_None;
		}
	}
	return E_NotAvailable;
}

OPort::TPortError	OPort::getReadTotalTimeoutMultiplier(	sal_uInt32 &ReadTotalTimeoutMultiplier )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			ReadTotalTimeoutMultiplier	=	aTimeout.ReadTotalTimeoutMultiplier;

			return E_None;
		}
	}
	return E_NotAvailable;
}

OPort::TPortError	OPort::getReadTotalTimeoutConstant(		sal_uInt32 &ReadTotalTimeoutConstant )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			ReadTotalTimeoutConstant	=	aTimeout.ReadTotalTimeoutConstant;
			return E_None;
		}
	}
	return E_NotAvailable;
}
OPort::TPortError	OPort::getWriteTotalTimeoutMultiplier(	sal_uInt32 &WriteTotalTimeoutMultiplier )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			WriteTotalTimeoutMultiplier	=	aTimeout.WriteTotalTimeoutMultiplier;
			return E_None;
		}
	}
	return E_NotAvailable;
}
OPort::TPortError	OPort::getWriteTotalTimeoutConstant( sal_uInt32 &WriteTotalTimeoutConstant )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			WriteTotalTimeoutConstant	=	aTimeout.WriteTotalTimeoutConstant;
			return E_None;
		}
	}
	return E_NotAvailable;
}

OPort::TPortError	OPort::setReadIntervalTimeout( sal_uInt32 ReadIntervalTimeout )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			aTimeout.ReadIntervalTimeout		=	ReadIntervalTimeout;
			ret = osl_setPortTimeout( m_pPortData->m_hPort, & aTimeout );
			if ( ! isError_Impl ( ret ) )
				return E_None;
		}
	}
	return E_NotAvailable;
}

OPort::TPortError	OPort::setReadTotalTimeoutMultiplier(	sal_uInt32 ReadTotalTimeoutMultiplier )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			aTimeout.ReadTotalTimeoutMultiplier		=	ReadTotalTimeoutMultiplier;
			ret = osl_setPortTimeout( m_pPortData->m_hPort, & aTimeout );
			if ( ! isError_Impl ( ret ) )
				return E_None;
		}
	}
	return E_NotAvailable;
}

OPort::TPortError	OPort::setReadTotalTimeoutConstant(		sal_uInt32 ReadTotalTimeoutConstant )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
																	  
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			aTimeout.ReadTotalTimeoutConstant		=	ReadTotalTimeoutConstant;
			ret = osl_setPortTimeout( m_pPortData->m_hPort, & aTimeout );
			if ( ! isError_Impl ( ret ) )
				return E_None;
		}
	}
	return E_NotAvailable;
}

OPort::TPortError	OPort::setWriteTotalTimeoutMultiplier(	sal_uInt32 WriteTotalTimeoutMultiplier )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
		
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			aTimeout.WriteTotalTimeoutMultiplier		=	WriteTotalTimeoutMultiplier;
			ret = osl_setPortTimeout( m_pPortData->m_hPort, & aTimeout );
			if ( ! isError_Impl ( ret ) )
				return E_None;
		}
	}
	return E_NotAvailable;

}
OPort::TPortError	OPort::setWriteTotalTimeoutConstant(	sal_uInt32 WriteTotalTimeoutConstant )
{
	if( m_pPortData->m_isOpen )
	{
		oslPortError		ret;
		oslPortTimeouts		aTimeout;
		aTimeout.Size = sizeof( aTimeout );
																	  
		ret = osl_getPortTimeout( m_pPortData->m_hPort, & aTimeout );
		if ( ! isError_Impl( ret ) )
		{
			aTimeout.WriteTotalTimeoutConstant		=	WriteTotalTimeoutConstant;
			ret = osl_setPortTimeout( m_pPortData->m_hPort, & aTimeout );
			if ( ! isError_Impl ( ret ) )
				return E_None;
		}
	}
	return E_NotAvailable;
}

/*****************************************************
OPort read()
*****************************************************/

sal_Int32		OPort::read( void* pBuffer, sal_uInt32 nNumberOfBytesToRead ) const
{
	if( m_pPortData->m_isOpen )
	{
		osl_receiveFromPort(	m_pPortData->m_hPort,
								pBuffer, 
								nNumberOfBytesToRead );
	}

	return 0;
}

/*****************************************************
OPort write()
*****************************************************/
					
sal_Int32		OPort::write( const void* pBuffer, sal_uInt32 nNumberOfBytesToWrite )
{
	if( m_pPortData->m_isOpen )
	{
		return osl_sendToPort(	m_pPortData->m_hPort,
								(void*)pBuffer,
								nNumberOfBytesToWrite );
	}

	return 0;
}

/*****************************************************
OPort isEof()
*****************************************************/

sal_Bool		OPort::isEof() const
{
	if( m_pPortData->m_isOpen )
		return sal_False;

	return sal_True;
}
/*****************************************************
OPort transmitChar()
*****************************************************/
							
OPort::TPortError	OPort::transmitChar( sal_Char cChar )
{
	if( m_pPortData->m_isOpen )
	{
		return (TPortError) osl_transmitPortChar(m_pPortData->m_hPort, cChar );
	}
	
	return E_NotAvailable;
}
						

/*****************************************************
SerialPortImpl class
*****************************************************/

class OSerialPortImpl
{

public:
	oslSerialPortControlBlock	m_aSpcb;
	oslPortControlBlock*		m_pPcb;
	sal_Bool						m_isSpcb;
	ISerialPortListener*		m_pListener;

public:
				OSerialPortImpl();

	void		reset () { m_isSpcb = sal_False; };


};

OSerialPortImpl::OSerialPortImpl() :
	m_isSpcb	( sal_False ),
	m_pListener	( NULL )
{
	m_aSpcb.PortControlBlock.Size = sizeof( m_aSpcb );
	m_aSpcb.PortControlBlock.PortType = OSL_PORT_TYPE_RS232;

	m_pPcb = (oslPortControlBlock*) & m_aSpcb;
}




/*****************************************************
OSerialPort Implentation
*****************************************************/

VOS_IMPLEMENT_CLASSINFO(VOS_CLASSNAME(OSerialPort, vos), 
						VOS_NAMESPACE(OSerialPort, vos),
						VOS_NAMESPACE(OPort, vos),
						0);




/*****************************************************
OSerialPort constructors / destructors
*****************************************************/
				   
OSerialPort::OSerialPort() :
	m_pSerialData	( NULL )
{
	m_pSerialData	= new OSerialPortImpl;
}

OSerialPort::~OSerialPort()
{
	if ( m_pSerialData ) 
		delete m_pSerialData;
}

/*****************************************************
OSerialPort open()
*****************************************************/

OPort::TPortError	OSerialPort::open( const rtl::OUString& pPortName )
{
	oslPortError ret;
	TPortError err;
	
	
	if( osl_getPortTypeByName( pPortName.pData ) != OSL_PORT_TYPE_RS232 )
		return E_InvalidType;

	err = OPort::open( pPortName );

	if ( err == E_None )
	{
		ret = osl_getPortControlBlock( m_pPortData->m_hPort, m_pSerialData->m_pPcb );

		if( ! isError_Impl( ret ) )
		{
			m_pSerialData->m_isSpcb = sal_True;
		}
		else
		{
			m_pSerialData->m_isSpcb = sal_False;
		}
	}

	return err;
}

/*****************************************************
OSerialPort	setListener()
*****************************************************/

sal_Bool	OSerialPort::setListener( ISerialPortListener* pListener )
{
	if ( m_pPortData->m_isOpen )
	{
		oslPortError ret;

		m_pSerialData->m_pListener = pListener;

		ret = osl_setEventHandler(	m_pPortData->m_hPort,
									(osl_Port_Callback) _osl_Port_Callback,
									(sal_uInt32) this );
		if( ! isError_Impl ( ret ) )
		{
			return sal_True;
		}

		m_pSerialData->m_pListener = NULL;
	}
	return sal_False;
}

/*****************************************************
OSerialPort	removeListener()
*****************************************************/

void OSerialPort::removeListener()
{
	if ( m_pPortData->m_isOpen )
	{
		if( m_pSerialData->m_pListener )
			osl_removeEventHandler(	m_pPortData->m_hPort );
	}
	
	m_pSerialData->m_pListener = NULL;
}

/*****************************************************
OSerialPort	filterEvents()
*****************************************************/

OPort::TPortError	OSerialPort::filterEvents( TEvent nEventMask )
{
 	if ( m_pPortData->m_isOpen )
	{
		oslPortError ret;
		ret = osl_setPortEventMask( m_pPortData->m_hPort, (sal_uInt32) nEventMask );

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	notifyListener() - only for Callback use
*****************************************************/

void	OSerialPort::notifyListener( sal_uInt32 nEventMask )
{
	if( m_pSerialData->m_pListener )
			m_pSerialData->m_pListener->event( (TEvent) nEventMask );
}

/*****************************************************
OSerialPort	setBreak()
*****************************************************/

OPort::TPortError	OSerialPort::setBreak()
{
	if ( m_pPortData->m_isOpen )
	{
		oslPortError ret;

		ret = osl_setPortBreak( m_pPortData->m_hPort );

		return (TPortError) ret;
	}
	
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	notifyListener()
*****************************************************/

OPort::TPortError	OSerialPort::clearBreak()
{
	if ( m_pPortData->m_isOpen )
	{
		oslPortError ret;

		ret = osl_clearPortBreak( m_pPortData->m_hPort );

		return (TPortError) ret;
	}
	
	return E_NotAvailable;

}
/*****************************************************
OSerialPort	getAndClearError()
*****************************************************/

OPort::TPortError	OSerialPort::getAndClearError( TError &nErrorMask, SPortState *pPortState )
{
	if ( m_pPortData->m_isOpen )
	{
		if ( pPortState )
			if ( pPortState->Size != sizeof (SPortState) ) 
				return E_DifferentStructSize;

		oslPortError ret;
		oslPortState aState;
		aState.Size = sizeof( aState );

		ret = osl_getAndClearPortError( m_pPortData->m_hPort, (sal_uInt32*) &nErrorMask, & aState );
		if( ! isError_Impl( ret ) )
		{
			if( pPortState )
			{
				pPortState->CTSHold			=	aState.CTSHold;
				pPortState->DSRHold			=	aState.DSRHold;
				pPortState->RLSDHold		=	aState.RLSDHold;
				pPortState->XOFFHold		=	aState.XOFFHold;
				pPortState->XOFFSent		=	aState.XOFFSent;
				pPortState->Txim			=	aState.Txim;
				pPortState->Eof				=	aState.Eof;
				pPortState->BytesInQueue	=	aState.BytesInQueue;
				pPortState->BytesOutQueue	=	aState.BytesOutQueue;
			}
			return E_None;
		}
		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	purge()
*****************************************************/

OPort::TPortError	OSerialPort::purge( TPurgeOption aPurgeMask )
{
	if ( m_pPortData->m_isOpen )
	{
		oslPortError ret;

		ret = osl_purgePort( m_pPortData->m_hPort, (sal_uInt32) aPurgeMask );

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	isParityCheckSupported()
*****************************************************/

sal_Bool		OSerialPort::isParityCheckSupported() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.PortCapabilities & OSL_PORT_PCF_PARITY_CHECK )
			return sal_True;
	}

	return sal_False;
}

/*****************************************************
OSerialPort	isBinaryModeSetable()
*****************************************************/

sal_Bool		OSerialPort::isBinaryModeSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_BINARY )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	isStopbitsSetable()
*****************************************************/

sal_Bool		OSerialPort::isStopbitsSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_STOPBITS )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	isParityCheckSetable()
*****************************************************/

sal_Bool		OSerialPort::isParityCheckSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_PARITY )
			return sal_True;
	}

	return sal_False;

}
/*****************************************************
OSerialPort	isParityModeSetable()
*****************************************************/

sal_Bool		OSerialPort::isParityModeSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_PARITY_CHECK )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	isDatabitsSetable()
*****************************************************/

sal_Bool		OSerialPort::isDatabitsSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_DATABITS )
			return sal_True;
	}

	return sal_False;


}
/*****************************************************
OSerialPort	isBaudRateSetable()
*****************************************************/

sal_Bool		OSerialPort::isBaudRateSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_BAUD )
			return sal_True;
	}

	return sal_False;
}

/*****************************************************
OSerialPort	isHandshakingSetable()
*****************************************************/

sal_Bool		OSerialPort::isHandshakingSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_SP_HANDSHAKING )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	getMaxBaudRate()
*****************************************************/

OSerialPort::TBaudRate	OSerialPort::getMaxBaudRate() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		return (TBaudRate) m_pPortData->m_aPortProp.MaxBaud;
	}
	
	return 0;
}
/*****************************************************
OSerialPort	getSetableBaudRate()
*****************************************************/

OSerialPort::TBaudRate	OSerialPort::getSetableBaudRate() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp  )
	{
		return (TBaudRate) m_pPortData->m_aPortProp.SettableBaud;
	}
	
	return 0;
}
/*****************************************************
OSerialPort	getSetableDatabits()
*****************************************************/

OSerialPort::TDatabit	OSerialPort::getSetableDatabits() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp  )
	{
		return (TDatabit) m_pPortData->m_aPortProp.SettableData;
	}
	
	return 0;
}
/*****************************************************
OSerialPort	getSetableStopbits()
*****************************************************/

OSerialPort::TStopbit	OSerialPort::getSetableStopbits() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp  )
	{
		// the last byte is for the Paritymode
		return (TStopbit) m_pPortData->m_aPortProp.SettableStopParity;
	}
	
	return 0;
}
/*****************************************************
OSerialPort	getSetableParityMode()
*****************************************************/

OSerialPort::TParityMode	OSerialPort::getSetableParityMode() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp  )
	{
		// the last byte is for the Paritymode
		return (TParityMode) m_pPortData->m_aPortProp.SettableStopParity;
	}
	
	return 0;
}

/*****************************************************
OSerialPort	getBaudRate()
*****************************************************/

sal_uInt32	OSerialPort::getBaudRate() const
{

	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.BaudRate;
	}

	return 0;
}
/*****************************************************
OSerialPort	setBaudRate()
*****************************************************/

OPort::TPortError	OSerialPort::setBaudRate( sal_uInt32 nBaudrate )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		oslPortError ret;
		sal_uInt32 temp = m_pSerialData->m_aSpcb.BaudRate;
		
		m_pSerialData->m_aSpcb.BaudRate = nBaudrate;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.BaudRate = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isBinaryModeEnabled()
*****************************************************/

sal_Bool	OSerialPort::isBinaryModeEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if( m_pSerialData->m_aSpcb.Binary )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableBinaryMode()
*****************************************************/

OPort::TPortError	OSerialPort::enableBinaryMode( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.Binary;
		
		m_pSerialData->m_aSpcb.Binary = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.Binary = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isParityCheckingEnabled()
*****************************************************/

sal_Bool		OSerialPort::isParityCheckingEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if( m_pSerialData->m_aSpcb.Parity )
			return sal_True;
	}
	return sal_False;

}
/*****************************************************
OSerialPort	enableParityChecking()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableParityChecking( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.Parity;
		
		m_pSerialData->m_aSpcb.Parity = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.Parity = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getStopbits()
*****************************************************/

OSerialPort::TStopbit	OSerialPort::getStopbits() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return (TStopbit) m_pSerialData->m_aSpcb.StopBits;
			
	}
	return 0;
}
/*****************************************************
OSerialPort	setStopbits()
*****************************************************/

OPort::TPortError	OSerialPort::setStopbits( TStopbit aStopbit )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		oslPortError ret;
		sal_uInt16 temp = m_pSerialData->m_aSpcb.StopBits;
		
		m_pSerialData->m_aSpcb.StopBits = aStopbit;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.StopBits = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getParityMode()
*****************************************************/

OSerialPort::TParityMode	OSerialPort::getParityMode() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return (TStopbit) m_pSerialData->m_aSpcb.ParityMode;
			
	}
	return 0;
}
/*****************************************************
OSerialPort	setParityMode()
*****************************************************/

OPort::TPortError	OSerialPort::setParityMode( TParityMode aParityMode )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_uInt16 temp = m_pSerialData->m_aSpcb.ParityMode;
		
		m_pSerialData->m_aSpcb.ParityMode = aParityMode;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.ParityMode = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getDatabits()
*****************************************************/

sal_uInt8	OSerialPort::getDatabits() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.ByteSize;
	}
	return 0;
}
/*****************************************************
OSerialPort	setDatabits()
*****************************************************/

OPort::TPortError	OSerialPort::setDatabits( sal_uInt8 nDatabitSize )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_uInt8 temp = m_pSerialData->m_aSpcb.ByteSize;
		
		m_pSerialData->m_aSpcb.ByteSize = nDatabitSize;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.ByteSize = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	isDtrDsrSupported()
*****************************************************/

sal_Bool		OSerialPort::isDtrDsrSupported() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_PCF_DTRDSR )
			return sal_True;
	}

	return sal_False;
}

/*****************************************************
OSerialPort	isRtsCtsSupported()
*****************************************************/

sal_Bool		OSerialPort::isRtsCtsSupported() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_PCF_RTSCTS )
			return sal_True;
	}

	return sal_False;

}
/*****************************************************
OSerialPort	isRlsdSupported()
*****************************************************/

sal_Bool		OSerialPort::isRlsdSupported() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_PCF_RLSD )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	isXonXoffSupported()
*****************************************************/

sal_Bool		OSerialPort::isXonXoffSupported() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_PCF_XONXOFF )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	isXCharSetable()
*****************************************************/

sal_Bool		OSerialPort::isXCharSetable() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		if( m_pPortData->m_aPortProp.SettableParams & OSL_PORT_PCF_SETXCHAR )
			return sal_True;
	}

	return sal_False;
}
/*****************************************************
OSerialPort	getTxQueueMaxSize()
*****************************************************/

sal_uInt32		OSerialPort::getTxQueueMaxSize() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		return (sal_uInt32) m_pPortData->m_aPortProp.MaxTxQueue ;
	}

	return 0;
}
/*****************************************************
OSerialPort	getRxQueueMaxSize()
*****************************************************/

sal_uInt32		OSerialPort::getRxQueueMaxSize() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		return (sal_uInt32) m_pPortData->m_aPortProp.MaxRxQueue;
	}

	return 0;
}
/*****************************************************
OSerialPort	getTxQueueCurrentSize()
*****************************************************/

sal_uInt32		OSerialPort::getTxQueueCurrentSize() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		return (sal_uInt32) m_pPortData->m_aPortProp.CurrentTxQueue;
	}

	return 0;
}
/*****************************************************
OSerialPort	getRxQueueCurrentSize()
*****************************************************/

sal_uInt32		OSerialPort::getRxQueueCurrentSize() const
{
	if( m_pPortData->m_isOpen && m_pPortData->m_isProp )
	{
		return (sal_uInt32) m_pPortData->m_aPortProp.CurrentRxQueue;
	}

	return 0;
}
/*****************************************************
OSerialPort	isOutCtsFlowControlEnabled()
*****************************************************/

sal_Bool		OSerialPort::isOutCtsFlowControlEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.OutxCTSFlow )
			return sal_True;
	}
	return sal_False;
}

/*****************************************************
OSerialPort	enableOutCtsFlowControl()
*****************************************************/

OSerialPort::TPortError	OSerialPort::enableOutCtsFlowControl( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.OutxCTSFlow;
		
		m_pSerialData->m_aSpcb.OutxCTSFlow = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.OutxCTSFlow = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	isOutDtrFlowControlEnabled()
*****************************************************/

sal_Bool		OSerialPort::isOutDsrFlowControlEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.OutxDSRFlow )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableOutDtrFlowControl()
*****************************************************/

OSerialPort::TPortError	OSerialPort::enableOutDsrFlowControl( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.OutxDSRFlow;
		
		m_pSerialData->m_aSpcb.OutxDSRFlow = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.OutxDSRFlow = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getDtrControlMode()
*****************************************************/

OSerialPort::TDtrControl		OSerialPort::getDtrControlMode() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return (TDtrControl) m_pSerialData->m_aSpcb.DTRControl;
	}
	return 0;
}
/*****************************************************
OSerialPort	setDtrControlMode()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setDtrControlMode( TDtrControl aDtrControlMode )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_uInt32 temp = m_pSerialData->m_aSpcb.DTRControl;
		
		m_pSerialData->m_aSpcb.DTRControl = aDtrControlMode;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.DTRControl = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	getRtsControlMode()
*****************************************************/

OSerialPort::TRtsControl		OSerialPort::getRtsControlMode() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return (TRtsControl) m_pSerialData->m_aSpcb.RTSControl;
	}
	return 0;
}
/*****************************************************
OSerialPort	setRtsControlMode()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setRtsControlMode( TRtsControl aRtsControlMode )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_uInt32 temp = m_pSerialData->m_aSpcb.RTSControl;
		
		m_pSerialData->m_aSpcb.RTSControl = aRtsControlMode;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.RTSControl = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	isDtrSensitivityEnabled()
*****************************************************/

sal_Bool			OSerialPort::isDtrSensitivityEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.DSRSensitivity )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableDtrSensitivity()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableDtrSensitivity( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.DSRSensitivity;
		
		m_pSerialData->m_aSpcb.DSRSensitivity = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.DSRSensitivity = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isTxContinueOnXoffEnabled()
*****************************************************/

sal_Bool			OSerialPort::isTxContinueOnXoffEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.TXContinueOnXoff )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableTxContinueOnXoff()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableTxContinueOnXoff( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.TXContinueOnXoff;
		
		m_pSerialData->m_aSpcb.TXContinueOnXoff = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.TXContinueOnXoff = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isOutXonXoffEnabled()
*****************************************************/

sal_Bool			OSerialPort::isOutXonXoffEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.OutX )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableOutXonXoff()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableOutXonXoff( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.OutX;
		
		m_pSerialData->m_aSpcb.OutX = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.OutX = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isInXonXoffEnabled()
*****************************************************/

sal_Bool		OSerialPort::isInXonXoffEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.InX )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableInXonXoff()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableInXonXoff( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.InX;
		
		m_pSerialData->m_aSpcb.InX = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.InX = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getErrorChar()
*****************************************************/

sal_Char	OSerialPort::getErrorChar() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.ErrorChar;
	}
	return 0;
}
/*****************************************************
OSerialPort	setErrorChar()
*****************************************************/

OSerialPort::TPortError	OSerialPort::setErrorChar( sal_Char cChar )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Char temp = m_pSerialData->m_aSpcb.ErrorChar;
		
		m_pSerialData->m_aSpcb.ErrorChar = cChar;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.ErrorChar = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isErrorCharReplacementEnabled()
*****************************************************/

sal_Bool		OSerialPort::isErrorCharReplacementEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.UseErrorChar )
			return sal_True;
	}
	return sal_False;
}

/*****************************************************
OSerialPort	enableErrorCharReplacement()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableErrorCharReplacement( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.UseErrorChar;
		
		m_pSerialData->m_aSpcb.UseErrorChar = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.UseErrorChar = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	enableErrorCharReplacement()
*****************************************************/

sal_Bool		OSerialPort::isNullByteDiscardEnabled() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.Null )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableErrorCharReplacement()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableNullByteDiscard( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.Null;
		
		m_pSerialData->m_aSpcb.Null = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.Null = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	isHoldOnErrorEnabled()
*****************************************************/

sal_Bool		OSerialPort::isHoldOnErrorEnabled()  const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		if (m_pSerialData->m_aSpcb.AbortOnError )
			return sal_True;
	}
	return sal_False;
}
/*****************************************************
OSerialPort	enableHoldOnError()
*****************************************************/

OSerialPort::TPortError		OSerialPort::enableHoldOnError( sal_Bool bEnable )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Bool temp = m_pSerialData->m_aSpcb.AbortOnError;
		
		m_pSerialData->m_aSpcb.AbortOnError = bEnable;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.AbortOnError = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	setXonLimit()
*****************************************************/

sal_uInt32		OSerialPort::getXonLimit() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return (sal_uInt32) m_pSerialData->m_aSpcb.XonLim;
	}
	return 0;
}
/*****************************************************
OSerialPort	setXonLimit()
*****************************************************/
OSerialPort::TPortError		OSerialPort::setXonLimit( sal_uInt32 aNumberOfBytes )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_uInt16 temp = m_pSerialData->m_aSpcb.XonLim;
		
		m_pSerialData->m_aSpcb.XonLim = (sal_uInt16) aNumberOfBytes;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.XonLim = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getXoffLimit()
*****************************************************/

sal_uInt32		OSerialPort::getXoffLimit() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return (sal_uInt32) m_pSerialData->m_aSpcb.XoffLim;
	}
	return 0;
}
/*****************************************************
OSerialPort	setXoffLimit()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setXoffLimit( sal_uInt32 aNumberOfBytes )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_uInt16 temp = m_pSerialData->m_aSpcb.XoffLim;
		
		m_pSerialData->m_aSpcb.XoffLim = (sal_uInt16) aNumberOfBytes;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.XoffLim = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getXonChar()
*****************************************************/

sal_Char	OSerialPort::getXonChar() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.XonChar;
	}
	return 0;
}

/*****************************************************
OSerialPort	setXonChar()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setXonChar( sal_Char cChar )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Char temp = m_pSerialData->m_aSpcb.XonChar;
		
		m_pSerialData->m_aSpcb.XonChar = cChar;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.XonChar = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getXoffChar()
*****************************************************/

sal_Char	OSerialPort::getXoffChar() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.XoffChar;
	}
	return 0;
}

/*****************************************************
OSerialPort	setXoffChar()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setXoffChar( sal_Char cChar )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Char temp = m_pSerialData->m_aSpcb.XoffChar;
		
		m_pSerialData->m_aSpcb.XoffChar = cChar;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.XoffChar = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

/*****************************************************
OSerialPort	getEOFChar()
*****************************************************/

sal_Char	OSerialPort::getEOFChar() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.EofChar;
	}
	return 0;
}
/*****************************************************
OSerialPort	setEOFChar()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setEOFChar( sal_Char cChar )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Char temp = m_pSerialData->m_aSpcb.EofChar;
		
		m_pSerialData->m_aSpcb.EofChar = cChar;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.EofChar = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}
/*****************************************************
OSerialPort	getEventChar()
*****************************************************/

sal_Char	OSerialPort::getEventChar() const
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb  )
	{
		return m_pSerialData->m_aSpcb.EvtChar;
	}
	return 0;
}
/*****************************************************
OSerialPort	setEventChar()
*****************************************************/

OSerialPort::TPortError		OSerialPort::setEventChar( sal_Char cChar )
{
	if( m_pPortData->m_isOpen && m_pSerialData->m_isSpcb )
	{
		oslPortError ret;
		sal_Char temp = m_pSerialData->m_aSpcb.EvtChar;
		
		m_pSerialData->m_aSpcb.EvtChar = cChar;
		
		ret =  osl_setPortControlBlock ( m_pPortData->m_hPort, m_pSerialData->m_pPcb);

		if( ! isError_Impl( ret ) )
			return E_None;
		
		m_pSerialData->m_aSpcb.EvtChar = temp;

		return (TPortError) ret;
	}
	return E_NotAvailable;
}

#ifdef _USE_NAMESPACE
}     
#endif


