BEGIN {
	if ( ARGC < 3)
	{
		printf("Syntax: awk ... LogFileIn ErrorLogOut [MscCLOOKsOut]\n")
		exit 1
	}
	fout = ARGV[2]
	if ( ARGC == 4 )
	{
		CLOOKsOut = ARGV[3]
		doClooks = 1
		ARGC -= 2
		printf("") >CLOOKsOut
	}
	else
	{
		ARGC -= 1
		doClooks = 0
	}
	err = 0
	clook = 0
	hzeile = ""
	zeile1 = ""
	zeile2 = ""
	errhzeile = 0
	clookhzeile = 0
	isError = 0
	isProduct = 0
	printf("") >fout
}

{
	if ( "[error log]" == $1" "$2 )
	{
		if ( $0 ~ /product=/ )
		{
			isProduct = 1
		}
		if ( err == 1 )
		{
			printf("\n\n") >>fout
			err = 0
		}
		if ( clook == 1 )
		{
			printf("\n\n") >>CLOOKsOut
			clook = 0
		}
		hzeile = $0
		errhzeile = 0
		clookhzeile = 0
	}
	else
	{
		if ( $0 ~ /error/ || $0 ~ /Error/ || $0 ~ /ERROR/ )
		{
			isError = 1
		}
		else if ( $2 == "warning," && ($1 == "vcs:" || $1 == "get:"))
		{
			# // pvcs error
			isError = 1
		}
		if ( isError == 1 )
		{
			if ( doClooks && ( \
					$0 ~ /error C1055: compiler limit : out of keys/ || \
					$0 ~ /error C1852: '/ ))
			{
				if ( clookhzeile == 0 )
				{
					print hzeile >>CLOOKsOut
					clookhzeile = 1
					printf("\n") >>CLOOKsOut
				}
				print >>CLOOKsOut
				clook = 1
				isError = 0
			}
			else
			{
				# // die ganz speziellen, die keine sind..
				if ( ( FILENAME ~ /APP.LOG/ || FILENAME ~ /app.log/ || \
						FILENAME ~ /APP.log/ || FILENAME ~ /app.LOG/ ) && \
						(( $0 ~ /error.src/ && $0 ~ /app.srs/ ) || \
							( $0 ~ /error.src/ && $0 ~ /commandline/ )))
				{
					isError = 0
				}
				else if ( ( FILENAME ~ /_UI.LOG/ || FILENAME ~ /_ui.log/ || \
						FILENAME ~ /_UI.log/ || FILENAME ~ /_ui.LOG/ ) && \
						(( $0 ~ /error.src/ && $0 ~ /app.srs/ ) || \
							( $0 ~ /error.src/ && $0 ~ /commandline/ )))
				{
					isError = 0
				}
				# // MASM Endmeldung
				else if ( $0 ~ / 0 Warning Errors/ || \
							$0 ~ / 0 Severe  Errors/  )
				{
					isError = 0
				}
				# // TASM Endausgabe
				if ( $0 ~ /Error messages:    None/ )
				{
					isError = 0
				}
				# // MkDepend doppeltes Include, leading tab
				else if ( $0 == "\t../../../INC/error.h" || $0 == "\t../../../inc/error.h" )
				{
					isError = 0
				}
				# // PM2B300: Warning filename.ext line: Parameter '*error*' is never used
				else if ( $1 == "Warning" && $4 == "Parameter" )
				{
					isError = 0
				}
				# // PVCS StampGet
				else if ( $0 == "Modified logfile \"T:/sw6/source/ui/app/error.srv\"." || \
					 		$0 == "error.src <- t:/sw6/source/ui/app/error.srv" || \
					 		$0 == "Modified logfile \"T:/sw6/inc/error.h_v\"." || \
					 		$0 == "error.h <- t:/sw6/inc/error.h_v" )
				{
					isError = 0
				}
			}
		}
		if ( isError == 1 )
		{
			if ( errhzeile == 0 )
			{
				print hzeile >>fout
				errhzeile = 1
				printf("\n") >>fout
			}
			print >>fout
			err = 1
			isError = 0
		}
	}
}

