'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=MainWithDefault0
'SBLLINK:MethodInfo=IsComboBox0
'SBLLINK:MethodInfo=CreateForm0
'SBLLINK:MethodInfo=FormNewDatabaseSelected0
'SBLLINK:MethodInfo=FormGetTables0
'SBLLINK:MethodInfo=FormGetFields0
'SBLLINK:MethodInfo=FormGetFieldsFromCombo10
'SBLLINK:MethodInfo=FormGetFieldsFromCombo20
'SBLLINK:MethodInfo=FormSetFieldConnection10
'SBLLINK:MethodInfo=FormSetFieldConnection20
'SBLLINK:MethodInfo=FormChangeDBField0
'SBLLINK:MethodInfo=FormcmdCancel0
'SBLLINK:MethodInfo=FormPrevClicked0
'SBLLINK:MethodInfo=FormNextOrReadyClicked0
'SBLLINK:MethodInfo=FormSetTitle0
'SBLLINK:MethodInfo=FormSetMoveRights0
'SBLLINK:MethodInfo=FormMoveSelected0
'SBLLINK:MethodInfo=FormMoveAll0
'SBLLINK:MethodInfo=FormRemoveSelected0
'SBLLINK:MethodInfo=FormRemoveAll0
'SBLLINK:MethodInfo=FormPreview1Repaint0
'SBLLINK:MethodInfo=FormNameGetFocus0
'SBLLINK:MethodInfo=FormNameLostFocus0
'SBLLINK:MethodInfo=GetTableOfQuery0
'SBLLINK:MethodInfo=CloseConnections0
'SBLLINK:MethodInfo=CreateListBoxClicked0
'SBLLINK:MethodInfo=CreateComboBoxClicked0

Option Explicit

Global FormActiveTableName$, FormPath$, FormDBName$, FormReturnValue$
Global FormTableName1$, FormTableName2$
Global TemplatePath$

Global FormAvailTables As New Strings
Global FormOriginalFieldList As New Strings
Global FormInstalledQueries As New Strings
Global FormControl As Object
Global IsControl As Boolean
Global bIsComboBox as Boolean

Global nActLanguage%

Sub Main()
	MainWithDefault ( Application, False )
End Sub

Sub MainWithDefault( ByVal aControl as Object, ByVal bActive as Boolean )

on error Goto GlobalError

	If (Not InitResources()) Then
		Exit Sub
	End If

	Dim sResult$, sTitle$, sFileName$, sShow$, sTmp$
	Dim nPos%

	FormControl = aControl
	IsControl = bActive
		
	TemplatePath$ = Application.PathSettings.Template
	If InStr (TemplatePath$, ";")<>0 Then
		TemplatePath$ = Left$(TemplatePath$, InStr(TemplatePath$, ";")-1)       ' Non-Unix
	End If
	
	FormPath$ = TemplatePath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	Application.EnterWait()
	Wait( 0 )

	bIsComboBox = IsComboBox (FormControl)

	'   load language
	nActLanguage% = nLoadLanguage% ( Application.LanguageID )

	'       Load dialog and string tools
	Application.LoadLibrary( "Tools" )
	Wait( 0 )

	'       creating a form with the help of the dialog
	sResult$ = CreateForm$ ( aControl, bActive )
	Call CloseConnections()
	
EndOfSub:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend
	Exit Sub

GlobalError:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	MsgBox(Form_gErrMsg$ ( nActLanguage% ), 16, Form_gWizardName$ ( nActLanguage% ))

End Sub

Function IsComboBox (aControl as Object) as Boolean
	IsComboBox = True
	if IsControl then
		IsComboBox = not aControl.PropertySetInfo.HasPropertyByName ("BoundColumn")
	end If
end Function

Function CreateForm$(ByVal aControl as Object, ByVal bActive as Boolean)

on error Goto GlobalError

	Dim nCount%

	'       Initialize Global Variables
	FormActiveTableName$ = ""
	FormTableName1$ = ""
	FormTableName2$ = ""	
	FormReturnValue$ = ""
	FormDBName$ = ""
	if bActive Then
		FormDBName$ = aControl.Parent.DataSourceName
		FormTableName1$ = aControl.Parent.Command
	endIf	
	FormActiveTableName$ = ""

	DlgComboDB.Load()

	DlgComboDB.cmdPrev.Enabled = False
	DlgComboDB.opNoDBField.Value = True
	DlgComboDB.CurrentStep = 1
	
	if (FormDBName$ = "") OR (FormTableName1$ = "") Then
		DlgComboDB.lbTables.Visible = False
		DlgComboDB.frameTables.Visible = False
		DlgComboDB.cmdNextOrReady.SetFocus
	else
		DlgComboDB.frameDatabase.Visible = False
		DlgComboDB.cmbAvailDatabase.Visible = False
		DlgComboDB.frameTable1.Visible = False
		DlgComboDB.cmbAvailTable1.Visible = False
		DlgComboDB.frameTable2.Visible = False
		DlgComboDB.cmbAvailTable2.Visible = False
		
		DlgComboDB.lbTables.Top = 480
		DlgComboDB.lbTables.Left = 3300
		DlgComboDB.frameTables.Top = 180
		DlgComboDB.frameTables.Left = 3120
		DlgComboDB.lbTables.SetFocus
	endif

	If (FormDBName$ = "") OR (FormTableName1$ = "") Then
		DlgComboDB.cmbAvailDatabase.Clear()
		Dim nPreselectPos As Integer
		nPreselectPos = -1
		Dim sCurrent as String
		For nCount% = 1 To Application.DataDefinedDatabaseNumber()
			sCurrent = Application.DataDefinedDatabase(nCount%)
			DlgComboDB.cmbAvailDatabase.AddItem(sCurrent)
			if (sCurrent = FormDBName$) Then
				nPreselectPos = DlgComboDB.cmbAvailDatabase.ListCount() - 1
			End If
		Next

		' for validating the selected database selected initially
		Dim bValidConnection as boolean
		bValidConnection = false
		while (Not bValidConnection) And (DlgComboDB.cmbAvailDatabase.ListCount() > 0)
			if (nPreselectPos = -1) Then
				DlgComboDB.cmbAvailDatabase.ListIndex = 0
			Else
				DlgComboDB.cmbAvailDatabase.ListIndex = nPreselectPos
				nPreselectPos = -1
				' if this round fails we start with the first list entry in the next round
			End If
			FormDBName$ = DlgComboDB.cmbAvailDatabase.List(DlgComboDB.cmbAvailDatabase.ListIndex())
			Application.OpenDatabaseConnection(FormDBName$)
			bValidConnection = Not IsNull(GetDBObject(FormDBName$))
			If (Not bValidConnection) Then
				' remove the (invalid) current entry and try again
				DlgComboDB.cmbAvailDatabase.RemoveItem(DlgComboDB.cmbAvailDatabase.ListIndex)
				FormDBName$ = ""
			End If
		Wend
		if (0 = DlgComboDB.cmbAvailDatabase.ListCount()) Then
			MsgBox(Form_gErrNoDatabase$ ( nActLanguage% ), 64, Form_gWizardName$ ( nActLanguage% ))
			while( Application.IsWait() )
				Application.LeaveWait()
			wend
			Exit Function
		End If

	End If

	Call FormSetTitle()
	Call GetAllInstalledNamesInDatabase(FormDBName$, FormAvailTables)
	Call FormGetTables()
	
	If (bActive AND (FormDBName$ <> "") AND (FormTableName1$ <> "")) then
		DlgComboDB.cmbAvailDatabase.Clear()
		DlgComboDB.cmbAvailDatabase.AddItem (FormDBName$)
		DlgComboDB.cmbAvailDatabase.ListIndex = 0
	End If
		
	If (FormTableName1$ <> "") then	
		DlgComboDB.cmbAvailTable1.Clear()
		DlgComboDB.cmbAvailTable1.AddItem (FormTableName1$)
		DlgComboDB.cmbAvailTable1.ListIndex = 0
	End If	
	
	Call FormGetFieldsFromCombo1()
	Call FormGetFieldsFromCombo2()

	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	
	DlgComboDB.Show()
	CreateForm$ = FormReturnValue$
	Exit Function

GlobalError:
	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	MsgBox(Form_gErrMsg$ ( nActLanguage% ), 16, Form_gWizardName$ ( nActLanguage% ))
	CreateForm$ = ""
	DlgComboDB.UnLoad()
	Reset
	Stop
End Function

Sub FormNewDatabaseSelected()
	DlgComboDB.lbSelected.Clear()
	
	FormDBName$ = DlgComboDB.cmbAvailDatabase.List(DlgComboDB.cmbAvailDatabase.ListIndex())

	Call GetAllInstalledNamesInDatabase(FormDBName$, FormAvailTables)
	Call FormGetTables()
	Call FormGetFieldsFromCombo1()
	Call FormGetFieldsFromCombo2()
End Sub

Sub FormGetTables()
	Dim tablename$,i%
	Dim aDBEngine, aDBWorkspace, aDBDatabase as Object
	Dim DBNames as Variant
	
	aDBEngine = CreateUnoService("com.sun.star.data.DatabaseEngine")
	aDBWorkspace = aDBEngine.Workspaces.getByIndex(0)
	aDBDatabase  = aDBWorkspace.open(aDBEngine.getLocation(FormDBName$))	
	
	Application.OpenDatabaseConnection(FormDBName$)

	DlgComboDB.lbTables.Clear()
	DlgComboDB.cmbAvailTable1.Clear()
	DlgComboDB.cmbAvailTable2.Clear()

	'keine Queries anzeigen
	'Queries
	'DBNames = aDBDatabase.Queries.ElementNames
	'if UBound (DBNames)>=0 then 'obere Grenze min. 0
	'	For i% = 0 To UBound (DBNames)
	'		FormInstalledQueries.Add ( DBNames(i%) )
	'		DlgComboDB.lbTables.AddItem ( DBNames(i%) )
	'		DlgComboDB.cmbAvailTable1.AddItem ( DBNames(i%) )
	'		DlgComboDB.cmbAvailTable2.AddItem ( DBNames(i%) )
	'	Next
	'End if
	
	'Tables
	DBNames = aDBDatabase.Tables.ElementNames
	if UBound (DBNames)>=0 then 'obere Grenze min. 0
		For i% = 0 To UBound (DBNames)
			tablename$ = DBNames(i%)
			DlgComboDB.lbTables.AddItem(tableName$)
			DlgComboDB.cmbAvailTable1.AddItem (tableName$)
			DlgComboDB.cmbAvailTable2.AddItem (tableName$)
		Next
	End if

	If (DlgComboDB.lbTables.ListCount>=1) Then
		DlgComboDB.lbTables.Selected(0)=True
		DlgComboDB.cmbAvailTable1.ListIndex = 0
		DlgComboDB.cmbAvailTable2.ListIndex = 0
		if (DlgComboDB.CurrentStep=1) then 
			DlgComboDB.cmdNextOrReady.Enabled = True
		End If		
	Else
		MsgBox(Form_gErrNoTableInDatabase$ ( nActLanguage% ), 16, Form_gWizardName$ ( nActLanguage% ) )
		DlgComboDB.cmdNextOrReady.Enabled = False
	End If
End Sub

Sub FormGetFields()
	Dim n%, i%, maxFields%
	Dim sActFieldName$
	Dim DocTest$
	Dim FieldsInQueries As New Strings

	DlgComboDB.lbFields.Clear()
	DlgComboDB.lbSelected.Clear()
	DlgComboDB.lbConnection2.Clear()
	DlgComboDB.fdConnection2.Text = ""
	FormOriginalFieldList.Clear()
	
	Application.EnterWait()
	Wait( 0 )

	'       which table was selected
	n% = DlgComboDB.lbTables.ListIndex()
	If ( -1 = n% ) Then Goto EndOfSub
	FormActiveTableName$ = DlgComboDB.lbTables.List(DlgComboDB.lbTables.ListIndex())
	FormTableName2$ = FormActiveTableName$

	If ( -1 < StrInStrings%( FormInstalledQueries, FormActiveTableName$ ) ) Then
		FieldsInQueries = Application.GetQueryColumns ( FormActiveTableName$ )
		maxFields% = FieldsInQueries.Count()
		For n% = 1 To maxFields%
			sActFieldName$ = FieldsInQueries.Item ( n% )
			sActFieldName$ = Left ( sActFieldName$, InStr ( 1, sActFieldName$, "," ) - 1 )
			DlgComboDB.lbFields.AddItem ( sActFieldName$ )
			DlgComboDB.lbConnection2.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	Else
		'       fill out the list lbFields
		Application.OpenTableConnection( FormActiveTableName$ )
		Application.DataSelect( "select * from " + Application.QuoteTablename( FormActiveTableName$ ) )
		Call FixODBCBug()
		maxFields% = Application.DataColumnNumber()
		For n%=1 To maxFields%
			sActFieldName$ = Application.DataColumnname( n% )
			DlgComboDB.lbFields.AddItem ( sActFieldName$ )
			DlgComboDB.lbConnection2.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	End If

	If (DlgComboDB.lbFields.ListCount()>=1) Then
		DlgComboDB.cmdMoveSelected.Enabled = True
		DlgComboDB.cmdRemoveSelected.Enabled = False
		DlgComboDB.lbFields.Selected(0) = True
	Else
		DlgComboDB.cmdMoveSelected.Enabled = False
		DlgComboDB.cmdRemoveSelected.Enabled = False
	End If

	Erase FieldsInQueries

EndOfSub:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

Sub FormGetFieldsFromCombo1()
	Dim n%, i%, maxFields%
	Dim sActFieldName$
	Dim DocTest$
	Dim FieldsInQueries As New Strings

	DlgComboDB.lbConnection1.Clear()
	DlgComboDB.cbDBField.Clear()
	DlgComboDB.fdConnection1.Text = ""
	
	Application.EnterWait()
	Wait( 0 )

	'       which table was selected
	n% = DlgComboDB.cmbAvailTable1.ListIndex()
	If ( -1 = n% ) Then Goto EndOfSub
	FormActiveTableName$ = DlgComboDB.cmbAvailTable1.List(DlgComboDB.cmbAvailTable1.ListIndex())
	FormTableName1$ = FormActiveTableName$

	If ( -1 < StrInStrings%( FormInstalledQueries, FormActiveTableName$ ) ) Then
		FieldsInQueries = Application.GetQueryColumns ( FormActiveTableName$ )
		maxFields% = FieldsInQueries.Count()
		For n% = 1 To maxFields%
			sActFieldName$ = FieldsInQueries.Item ( n% )
			sActFieldName$ = Left ( sActFieldName$, InStr ( 1, sActFieldName$, "," ) - 1 )
			DlgComboDB.lbConnection1.AddItem ( sActFieldName$ )
			DlgComboDB.cbDBField.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	Else
		'       fill out the list lbFields
		Application.OpenTableConnection( FormActiveTableName$ )
		Application.DataSelect( "select * from " + Application.QuoteTablename( FormActiveTableName$ ) )
		Call FixODBCBug()
		maxFields% = Application.DataColumnNumber()
		For n%=1 To maxFields%
			sActFieldName$ = Application.DataColumnname( n% )
			DlgComboDB.lbConnection1.AddItem ( sActFieldName$ )
			DlgComboDB.cbDBField.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	End If

	Erase FieldsInQueries
	if DlgComboDB.cbDBField.ListCount()>0 then
		DlgComboDB.cbDBField.ListIndex()=0
	End If	
	
	DlgComboDB.opNoDBField.Value = True
	DlgComboDB.cbDBField.Enabled = False

EndOfSub:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

Sub FormGetFieldsFromCombo2()
	Dim n%, i%, maxFields%
	Dim sActFieldName$
	Dim DocTest$
	Dim FieldsInQueries As New Strings
	
	DlgComboDB.lbSelected.Clear()
	DlgComboDB.lbFields.Clear()
	DlgComboDB.lbConnection2.Clear()
	DlgComboDB.fdConnection2.Text = ""
	FormOriginalFieldList.Clear()

	Application.EnterWait()
	Wait( 0 )
		
	'       which table was selected
	n% = DlgComboDB.cmbAvailTable2.ListIndex()
	If ( -1 = n% ) Then Goto EndOfSub
	FormActiveTableName$ = DlgComboDB.cmbAvailTable2.List(DlgComboDB.cmbAvailTable2.ListIndex())
	FormTableName2$ = FormActiveTableName$

	If ( -1 < StrInStrings%( FormInstalledQueries, FormActiveTableName$ ) ) Then
		FieldsInQueries = Application.GetQueryColumns ( FormActiveTableName$ )
		maxFields% = FieldsInQueries.Count()
		For n% = 1 To maxFields%
			sActFieldName$ = FieldsInQueries.Item ( n% )
			sActFieldName$ = Left ( sActFieldName$, InStr ( 1, sActFieldName$, "," ) - 1 )
			DlgComboDB.lbConnection2.AddItem ( sActFieldName$ )
			DlgComboDB.lbFields.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	Else
		'       fill out the list lbFields
		Application.OpenTableConnection( FormActiveTableName$ )
		Application.DataSelect( "select * from " + Application.QuoteTablename( FormActiveTableName$ ) )
		Call FixODBCBug()
		maxFields% = Application.DataColumnNumber()
		For n%=1 To maxFields%
			sActFieldName$ = Application.DataColumnname( n% )
			DlgComboDB.lbConnection2.AddItem ( sActFieldName$ )
			DlgComboDB.lbFields.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	End If
	
	If (DlgComboDB.lbFields.ListCount()>=1) Then
		DlgComboDB.cmdMoveSelected.Enabled = True
		DlgComboDB.cmdRemoveSelected.Enabled = False
		DlgComboDB.lbFields.Selected(0) = True
	Else
		DlgComboDB.cmdMoveSelected.Enabled = False
		DlgComboDB.cmdRemoveSelected.Enabled = False
	End If
	
	Erase FieldsInQueries

EndOfSub:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

Sub FormSetFieldConnection1
	fdConnection1.Text = lbConnection1.List(lbConnection1.ListIndex())
	cmdFinish.Enabled = ((lbConnection1.ListIndex()<>-1) AND (lbConnection2.ListIndex()<>-1))
	'cmdNextOrReady.Enabled = ((lbConnection1.ListIndex()<>-1) AND (lbConnection2.ListIndex()<>-1))
End Sub

Sub FormSetFieldConnection2
	fdConnection2.Text = lbConnection2.List(lbConnection2.ListIndex())
	cmdFinish.Enabled = ((lbConnection1.ListIndex()<>-1) AND (lbConnection2.ListIndex()<>-1))
	'cmdNextOrReady.Enabled = ((lbConnection1.ListIndex()<>-1) AND (lbConnection2.ListIndex()<>-1))
End Sub

Sub FormChangeDBField
	if (opDBField.Value = True) then
		cbDBField.Enabled = True
	else	
		cbDBField.Enabled = False
	End If	
End Sub

Sub FormcmdCancel()
	DlgComboDB.Hide()
	DlgComboDB.Unload()
	Call CloseConnections()
	FormReturnValue$ = ""
End Sub

Sub FormPrevClicked()
	cmdNextOrReady.Visible = True
	cmdNextOrReady.Enabled = True
	
	if DlgComboDB.CurrentStep = 4 then
		DlgComboDB.CurrentStep = 2
	else	
		DlgComboDB.CurrentStep = DlgComboDB.CurrentStep - 1
	end If

	If (DlgComboDB.CurrentStep=1) Then
		cmdPrev.Enabled = False
		cmdNextOrReady.Enabled = (DlgComboDB.lbTables.ListIndex()>=0)
		if cmdNextOrReady.Enabled then
			cmdNextOrReady.SetFocus
		End If
	End If
	
	Call FormSetTitle()
End Sub

Sub FormNextOrReadyClicked()
	cmdNextOrReady.Visible = ( DlgComboDB.CurrentStep < 2 )
	cmdNextOrReady.Enabled = ( DlgComboDB.CurrentStep < 2 )
	
	if bIsComboBox and (DlgComboDB.CurrentStep = 2) then
		DlgComboDB.CurrentStep = 4
	else	
		DlgComboDB.CurrentStep = DlgComboDB.CurrentStep + 1
	end If
		
	If (DlgComboDB.CurrentStep>=2) Then
		cmdPrev.Enabled = True
	End If
	If (DlgComboDB.CurrentStep=2) Then
		cmdNextOrReady.Enabled = (lbSelected.ListCount()>=1)
		lbFields.SetFocus
	End If
	If (DlgComboDB.CurrentStep=3) Then
		'cmdNextOrReady.Enabled = ((lbConnection1.ListIndex()<>-1) AND (lbConnection2.ListIndex()<>-1))
		'if cmdNextOrReady.Enabled then
		'	cmdNextOrReady.SetFocus
		cmdFinish.Enabled = ((lbConnection1.ListIndex()<>-1) AND (lbConnection2.ListIndex()<>-1))
		if cmdFinish.Enabled then
			cmdFinish.SetFocus
		else
			lbConnection1.SetFocus
		End If		
	End If
	If (DlgComboDB.CurrentStep=4) Then
		cmdFinishCombo.SetFocus
	End If
	Call FormSetTitle()
End Sub

Sub FormSetTitle()
	Select Case (DlgComboDB.CurrentStep)
		Case 1
			DlgComboDB.Caption = Form_Dlg_1Caption$ ( nActLanguage% )
		Case 2
			DlgComboDB.Caption = Form_Dlg_2Caption$ ( nActLanguage% )
		Case 3
			DlgComboDB.Caption = Form_Dlg_3Caption$ ( nActLanguage% )
		Case 4
			DlgComboDB.Caption = Form_Dlg_4Caption$ ( nActLanguage% )
		Case 5
			DlgComboDB.Caption = Form_Dlg_5Caption$ ( nActLanguage% )
	End Select
End Sub

Sub FormSetMoveRights()
	'       Enable or disable the buttons used for moving the available
	'       fields between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	FieldSelected% = (-1<>lbFields.ListIndex())
	FieldCount% = lbFields.ListCount()

	SelectSelected% = (-1<>lbSelected.ListIndex())
	SelectCount% = lbSelected.ListCount()
	cmdRemoveSelected.Enabled = (SelectCount%>=1)
	cmdMoveSelected.Enabled = (SelectCount%<1  And FieldSelected%)
	cmdNextOrReady.Enabled = (SelectCount%>=1)
End Sub

Sub FormMoveSelected()
	if ( DlgComboDB.lbSelected.ListCount()<1 ) Then
		Call MoveSelectedListBox(lbFields, lbSelected)
		cmdNextOrReady.SetFocus
	end If	
	Call FormSetMoveRights()
End Sub

Sub FormMoveAll()
	Call CopyItemsListBox(lbFields, lbSelected)
	Call FormSetMoveRights()
End Sub

Sub FormRemoveSelected()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, FormOriginalFieldList, False )
	Call FormSetMoveRights()
End Sub

Sub FormRemoveAll()
	DIM ListIndex%
	ListIndex% = DlgComboDB.lbFields.ListIndex()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, FormOriginalFieldList, True )
	DlgComboDB.lbFields.SetFocus
	DlgComboDB.lbFields.Selected(ListIndex%) = True
	Call FormSetMoveRights()
End Sub

'       Picture Repaint-Events
Sub FormPreview1Repaint()
	Call PaintPicOnPreview(DlgComboDB.Preview1, FormPath$+"cjcombo0.bmp", 152, 172, True)
End Sub

Sub FormNameGetFocus()
	txtDocTitle.Tag = txtDocTitle.Text
End Sub

Sub FormNameLostFocus()

	Dim sError$, sWizardName$

	sError$ = Form_gErrTitleSyntaxError$( nActLanguage% )
	sWizardName$ = Form_gWizardName$( nActLanguage% )

	Call CheckDatabaseIdentifier(txtDocTitle, sError$, sWizardName$ )
	Call CheckTitleUnique(FormAvailTables, txtDocTitle, sError$, sWizardName$ )
End Sub

Function GetTableOfQuery$ ( Byval sSql$ )

	Dim nCnt1%, nCnt2%, nEnd%, n%

	sSql$ = UCase$( sSql$ )

	nCnt1% = 0
	nCnt2% = 0
	nEnd% = len( sSql$ )
	for n% = 1 to nEnd%
		select case asc( mid( sSql$, n%, 1 ))
		case 34:
			if( 0 = nCnt2% ) then
				if( 0 = 		nCnt1% ) then
					nCnt1% = nCnt1% + 1
				else
					nCnt1% = nCnt1% - 1
				endif
			endif

		case 39:
			if( 0 = nCnt1% ) then
				if( 0 = 		nCnt2% ) then
					nCnt2% = nCnt2% + 1
				else
					nCnt2% = nCnt2% - 1
				endif
			endif
		case 70:
			if( 0 = nCnt1% + nCnt2% AND "FROM " = mid( sSql$, n%, 5 ) ) then
				' oder gefunden, ist es auch ein oder by?
				n% = n% + 5
				while( " " = mid$( sSql$, n%, 1 ))
					n% = n% + 1
				wend
				if( """" = mid$( sSql$, n%, 1 )) then n% = n% + 1
				nCnt1% = n%
				while( n% <= nEnd% AND 0 = InStr( " """, mid$( sSql$, n%, 1 )))
					n% = n% + 1
				wend
				GetTableOfQuery$ = Mid ( sSql$, nCnt1%, n% - nCnt1% )
				Exit Function
			endif
		end select
	next n%
End Function

Sub CloseConnections()
	If ( "" <> Application.GetActiveTableConnection() ) Then
		Application.CloseTableConnection( Application.GetActiveTableConnection() )
	End If
	If ( "" <> Application.GetActiveDatabaseConnection() ) Then
		Application.CloseDatabaseConnection( Application.GetActiveDatabaseConnection() )
	End If
End Sub

Const MaxFieldIndex% = 200
Const cColumnarLeft% = 1, cColumnarTop% = 2, cJustified% = 3, cTabled% = 4
Const cText = 1, cFloat = 2, cInteger = 3, cLong = 4, cBoolean = 5, cMemo = 6, cCounter = 7, cDateTime = 8,cDateField = 9, cTime = 10, cCurrency = 11
Const cNone = 1, cHorizontal = 2, cVertical = 3

Dim FieldName$(0 To MaxFieldIndex%)
Dim FieldType%(0 To MaxFieldIndex%)
Dim FieldLabelWidth(0 To MaxFieldIndex%) As Single
Dim FieldDataWidth%(0 To MaxFieldIndex%)
Dim StructFieldSize%, Style%, Alignment%
Dim TemplateFile$

Sub CreateListBoxClicked()
	'       prepare the calling parameters for Juergen Pingel's routine
	DlgComboDB.Hide()
	Dim activeColumnName$, actType$, subType$, ShowAfterCreate$,DocumentName$, sSQLExpr$, sQueryName$
	Dim n%, m%, Found%, nArrCount%
	Dim Source$
	Dim Sql (1) as String 

	Application.EnterWait()
	Wait( 0 )
	If IsControl then
		FormControl.ListSourceType = 3
		Source$ = "Select "+chr$(34)
		Source$ = Source$+lbSelected.List(0)
		Source$ = Source$+chr$(34)+", "+chr$(34)
		Source$ = Source$+fdConnection2.Text
		Source$ = Source$+chr$(34)+" from "
		Source$ = Source$+FormTableName2$
		Sql(0) = Source$
		FormControl.ListSource = Sql()
		FormControl.BoundColumn = 1
		FormControl.Dropdown = True ' als Dropdown-List
		FormControl.DataField = fdConnection1.Text
		if (DlgComboDB.lbTables.Visible = False) Then
			FormControl.Parent.DataSourceName = FormDBName$
			FormControl.Parent.Command = FormTableName1$
		End IF
	End If
End Sub

Sub CreateComboBoxClicked()
	'       prepare the calling parameters for Juergen Pingel's routine
	DlgComboDB.Hide()
	Dim activeColumnName$, actType$, subType$, ShowAfterCreate$,DocumentName$, sSQLExpr$, sQueryName$
	Dim n%, m%, Found%, nArrCount%
	Dim Source$
	Dim Sql (1) as String 

	Application.EnterWait()
	Wait( 0 )
	If IsControl then
		FormControl.ListSourceType = 3
		Source$ = "Select Distinct "+chr$(34)
		Source$ = Source$+lbSelected.List(0)
		Source$ = Source$+chr$(34)+" from "
		Source$ = Source$+FormTableName2$
		Sql(0) = Source$
		FormControl.ListSource = Source$
		'FormControl.BoundColumn = 1
		FormControl.Dropdown = True ' als Dropdown-List
		if (opDBField.Value = True) then
			FormControl.DataField = cbDBField.Text
		end If	
		if (DlgComboDB.lbTables.Visible = False) Then
			FormControl.Parent.DataSourceName = FormDBName$
			FormControl.Parent.Command = FormTableName1$
		End IF
	End If
End Sub
