'SBLLINK:MethodInfo=main0
'SBLLINK:MethodInfo=Report_Create0
'SBLLINK:MethodInfo=Report_CreateGroup0
'SBLLINK:MethodInfo=Report_FillGroup0
'SBLLINK:MethodInfo=Report_FillBody0
'SBLLINK:MethodInfo=Report_Create_Column0
'SBLLINK:MethodInfo=Report_Create_Table0
'SBLLINK:MethodInfo=Report_IsValidQuery0
'SBLLINK:MethodInfo=ReplaceTokenInString0
Option Explicit

' Strings
const sDBGroupCount = "DBGroupCount", sDBGroupField = "DBGroupField_"
const sDBFieldCount = "DBFieldCount", sDBFieldName = "DBFieldName_", sDBFieldWidth = "DBFieldWidth_"
const sDBName = "DB_Name", sDBTable = "DB_Table", sSQLStatement = "DB_SQLStatement"
const sDBReport = "ReportStyle", sDBReportDefinied = "DB_ReportDefined"
const sDBQuery = "DB_Query_Name"

const sSWGroupTableName = "group", sSWBodyTableName = "body"
const sParaBehindTable = "ParaBehindTable", sParaBeforeTable = "ParaBeforeTable"
const sFrameStyleName = "Image_"
const sAutoTextGroupName = "$$crrep$", sAutoTextName = "Report"
const sAutoTextGrpShort = "RepGrpTbl", sAutoTextBdyShort = "RepBdyTbl"

'Numbers
const cMaxGroups = 4
const cMaxFieldIndex% = 200

const cStyleTable = 1, cStyleColumn = 2
const cStyleStepped = 3, cStyleBlock = 4
const cStyleLeft1 = 7, cStyleLeft2 = 8
const cStyleOutline1 = 5, cStyleOutline2 = 6

' Arrays
DIM sGroupFields$( 0 to cMaxGroups )
DIM sGroupFieldContents$( 0 to cMaxGroups )
DIM sBodyFields$( 0 to cMaxFieldIndex% )
DIM sBodyStyleNames$( 0 to cMaxFieldIndex% )
DIM aRowHeight$( 0 to cMaxGroups + 1 )
DIM nFieldCount, nGroupCount as integer
Dim nActiveLanguage%

sub main
Report_Create
end sub

sub Report_Create

	ON Error Goto Report_Create_Error

	DIM n%, bIsEqual%, bFirst%, bNewRow%, nLastEqualGroup%, bEditMode%, bUndo%
	DIM filename$, sStr$, sWindowName$, sDataBaseName$, sSQLStr$, sQueryName$, sError$
	DIM nReportStyle as integer
	DIM nDataMax&, nDataCount&
	DIM aProgress AS NEW PROGRESS
	DIM aWin AS OBJECT

	aWin = ThisWindow

	'       load language
	nActiveLanguage% = nLoadLanguage% ( Application.LanguageID )

	if( aWin.Selection.GetUserFieldValue( sDBReportDefinied ) <> "Defined" ) then exit sub

	nReportStyle =  aWin.Selection.GetUserFieldValue( sDBReport )

	Application.EnterWait()

	aWin.LockPaint( TRUE )
	aWin.ShowCursor = FALSE

	sWindowName$ = aWin.Name

	bEditMode% = NOT ActiveDocument.ReadOnly
	bUndo% = aWin.Selection.UndoMode
	aWin.Selection.UndoMode = FALSE

	' Turn off Layout Beeps
	Application.GetDocManPath( "~~~SetNoFrameBeep" )

	nGroupCount = VAL( aWin.Selection.GetUserFieldValue( sDBGroupCount ))
	for n% = 0 to nGroupCount - 1
		sGroupFields$( n% ) = aWin.Selection.GetUserFieldValue( sDBGroupField + trim(str(n% )) )
	next n%

	nFieldCount = VAL( aWin.Selection.GetUserFieldValue( sDBFieldCount ))
	for n% = 0 to nFieldCount - 1
		sStr$ = trim(str( n% ))
		sBodyFields$( n% ) = aWin.Selection.GetUserFieldValue( sDBFieldName + sStr$ )
		sBodyStyleNames$( n% ) = sFrameStyleName + sStr$
	next n%

	sSQLStr$ = aWin.Selection.GetUserFieldValue( sSQLStatement )
	sQueryName$ = aWin.Selection.GetUserFieldValue( sDBQuery )
	sDataBaseName$ = aWin.Selection.GetUserFieldValue( sDBName )
	Application.OpenDatabaseConnection( sDataBaseName$ )

	' If the report was created from a query, have to check the
	' validity here
	if( "" <> sQueryName$ ) then

		select case Report_IsValidQuery( sQueryName$, sSQLStr$ )
		case 1
			sError$ = CreateRep_gErrCannotOpenQuery ( nActiveLanguage% )
			ReplaceTokenInString ( "$1", sQueryName$, sError$ )
			sError$ = sError$ + " " + CreateRep_gErrReportInComplete ( nActiveLanguage% )
			'cg sError$ = "Die Abfrage " + sQueryName$ + " konnte nicht geffnet werden."
		case 2
			sError$ = CreateRep_gErrFieldsDeleted ( nActiveLanguage% )
			ReplaceTokenInString ( "$1", sQueryName$, sError$ )
			sError$ = sError$ + " " + CreateRep_gErrReportInComplete ( nActiveLanguage% )
			'cg sError$ = "Aus der Abfrage " + sQueryName$ + " wurden Felder gelscht."
		case else
			sError$ = ""
		end select

		if( "" <> sError$ ) then
			'cg MsgBox( sError$ + " Der Bericht ist unvollstndig.", 16, "Bericht erzeugen" )
			MsgBox( sError$, 16, CreateRep_gMyName$ ( nActiveLanguage% ) )
			aWin.LockPaint( FALSE )
			aWin.ShowCursor = TRUE
			goto Report_Create_Ende
		endif

	else
		Application.OpenTableConnection( aWin.Selection.GetUserFieldValue( sDBTable ) )
	endif

	Application.DataSelect( sSQLStr$ )

	Application.DataUpdate()
	Application.DataFirstRecord()

	if( 0 = bEditMode% ) then
		' ProgressBar
		nDataMax& = Application.GetDataRecordCount()
		aProgress.Start( CreateRep_gMyName$ ( nActiveLanguage% ), nDataMax& )
	endif

	' create the temp. glossary entry for the body-table
	if( cStyleStepped <> nReportStyle AND cStyleBlock <> nReportStyle AND _
		cStyleTable <> nReportStyle AND cStyleColumn <> nReportStyle ) then

		with aWin.Selection
			.CreateGlossaryGroup( sAutoTextGroupName )
			.gototable( sSWBodyTableName )
			.Select()
			.NewGlossary( sAutoTextGroupName, sAutoTextName, sAutoTextBdyShort )
		end with
	end if

	' then iterate over all data records
	bFirst% = 1
	nDataCount& = 0
	do

		if( cStyleTable = nReportStyle ) then

			if( NOT bEditMode% ) then
				call Report_Create_Table( aWin, bFirst%, nDataMax& )
			endif
			bFirst% = 0

		else
			if( cStyleColumn = nReportStyle ) then

				call Report_Create_Column( aWin, bFirst%, bEditMode%, nDataMax& )
				bFirst% = 0

			else

				bNewRow% = 1

				if( 1 = bFirst% ) then
					for n% = 0 to nGroupCount - 1

						sGroupFieldContents$( n% ) = Application.DataColumn( sGroupFields$( n% ))

					next n%

					Report_CreateGroup( aWin, nReportStyle, 0, 1, bEditMode%, nDataMax& )

					bFirst% = 0
					bNewRow% = 0
					nLastEqualGroup% = 0
				else

					bIsEqual% = 1
					for n% = 0 to nGroupCount - 1
						sStr$ = Application.DataColumn( sGroupFields$( n% ))
						if( 0 = bIsEqual% OR (sGroupFieldContents$( n% ) <> sStr$ ) ) then

							if( 0 <> bIsEqual ) then
								Report_CreateGroup( aWin, nReportStyle, n%, 0, bEditMode%, 0 )
								nLastEqualGroup% = n%
							end if

							sGroupFieldContents$( n% ) = sStr$
							bIsEqual% = 0
						end if

					next n%

					if( 0 = bIsEqual% ) then
						bNewRow% = 0
					end if

				endif

				if( 0 = bNewRow ) then
					Report_FillGroup( aWin, nReportStyle, nLastEqualGroup%, nGroupCount, nGroupCount + nFieldCount, bEditMode% )
				end if

				call Report_FillBody( aWin, nReportStyle, bNewRow%, nGroupCount, bEditMode% )

			endif
		endif

		nDataCount& = nDataCount& + 1
		' ProgressBar
		if( 0 = bEditMode% ) then aProgress.Value = nDataCount&

	loop while( TRUE = Application.DataNextRecord() AND NOT bEditMode% )

	if( cStyleColumn = nReportStyle ) then

		with aWin.Selection
			.JumpToStartOfDoc()
			.GoDown( nFieldCount, TRUE )
			.Delete()
		end with

	else
		if( NOT bEditMode% ) then

			if( cStyleStepped = nReportStyle ) then
				with aWin.Selection
					.JumpToStartOfDoc()
					.JumpToNextTable()
					.GoToEnd()              ' in die letzte Zelle der Tabelle
					.DeleteRows()
				end with
			else
				if( cStyleTable <> nReportStyle AND cStyleBlock <> nReportStyle ) then
					with aWin.Selection
						.GotoTable( sSWGroupTableName )
						.select()
						.DeleteRows()
						.GotoTable( sSWBodyTableName )
						.select()
						.DeleteRows()
					end with
				end if
			end if
		end if
	end if

	aWin.Selection.JumpToStartOfDoc()
	if( NOT bEditMode% ) then
		aWin.Selection.SetUserFieldValue( sDBReportDefinied, "Createt" )
	endif

    ' Actualize Time/Date Fields of header and footer
	aWin.Selection.SetFixDateTimeFields()

	aWin.LockPaint( FALSE )
	aWin.ShowCursor = TRUE

		' ProgressBar
	if( 0 = bEditMode% ) then aProgress.Stop

	Goto Report_Create_Ende

Report_Create_Error:
	aWin.LockPaint( FALSE )
	aWin.ShowCursor = TRUE

	if( sWindowName$ = aWin.Name ) then     aWin.Selection.ActionEnd()
	MsgBox(CreateRep_gErrMsg ( nActiveLanguage% ) + " " + CreateRep_gErrReportInComplete ( nActiveLanguage% ), 16, CreateRep_gMyName$ ( nActiveLanguage% ) )

Report_Create_Ende:
	on error resume next

	aWin.Selection.DeleteGlossaryGroup( sAutoTextGroupName )

	Application.CloseDatabaseConnection( sDataBaseName$ )
	Application.LeaveWait()

	aWin.Selection.UndoMode = bUndo%

End sub



sub Report_CreateGroup( aWin AS Object, BYVAL nStyle as integer, _
						BYVAL nPos as integer, BYVAL bFirst as integer, _
						BYVAL bEditMode as integer, BYVAL nDataMax& )

	DIM bCopyTbl, n as integer
	DIM sCell$

	bCopyTbl = 1
	select case nStyle
	case cStyleStepped

		bCopyTbl = 0
		with aWin.Selection
			if 0 <> bFirst then
				.JumpToStartOfDoc()
				.JumpToNextTable()
			endif

			for n = nPos to nGroupCount
				with aWin.Selection
					.GoToEnd()              ' in die letzte Zelle der Tabelle
					.JumpToNextCell()
					if( n = nPos ) then
						' die Anfangsposition merken!
						sCell$ = aWin.Selection.CellName()
						.GotoCell( "A" + trim( str( val( right$( sCell$, len(sCell$) - 1 )) - 1 )))
						.InsertBookmark( "_SavePos" )
						.GotoCell( sCell$ )
					endif
				end with
			next n
			.JumpToBookmark( "_SavePos" )
			.DeleteBookmark( "_SavePos" )
		end with

	case cStyleBlock
		bCopyTbl = 0
		if( 0 <> bFirst ) then
			with aWin.Selection
				.JumpToStartOfDoc()
				.JumpToNextTable()
				.GotoCell("A2")
				if( nDataMax& > 1 ) then
					.InsertRows( nDataMax&-1, TRUE )
					.GotoCell("A2")
				end if
			end with
		else
			aWin.Selection.JumpToNextCell
		endif

	end select

	if( 1 = bCopyTbl ) then
		with aWin.Selection


			if( 0 <> bFirst ) then

				.CreateGlossaryGroup( sAutoTextGroupName )
				.gototable( sSWGroupTableName )

				for n = 0 to nGroupCount-1
					with aWin.Selection

						' Outline Style -> jump over an empty box at the beginning
						' starting at the second row
						if( 0 <> n AND ( nStyle = cStyleOutline1 OR nStyle = cStyleOutline2 )) THEN
							.JumpToNextCell()
						end if

						if( 0 = aWin.Selection.GetCharCount(1,FALSE) ) then
							.Insert( sGroupFields$( n ))
						endif
						.JumpToNextCell()

						if( n <> nGroupCount - 1 ) THEN
							.JumpToNextCell()
						endif

					end with
				next n

				.Select()
				.NewGlossary( sAutoTextGroupName, sAutoTextName, sAutoTextGrpShort )

				.GotoCell( "A1" )
			endif

			if( NOT bEditMode ) then
				.GotoEndOfDoc()
				.GotoEndOfDoc()
				.GotoEndOfDoc()
				.ExpandGlossary( sAutoTextGrpShort )
				.GotoEndOfDoc()		' out of the Table
				.jumptoprevtable()
			endif
		end with

		for n = 0 to nPos - 1
			aWin.Selection.DeleteRows()
		next n

	end if

end sub


sub Report_FillGroup( aWin AS Object, BYVAL nReportStyle as integer, _
					BYVAL nStt as integer, BYVAL nEnd as integer, _
					BYVAL nCellCount as integer, BYVAL bEditMode as integer )

	DIM n as integer
	DIM sCell$

	' Jump over the start of all groups up to the current group
	if(( cStyleStepped = nReportStyle OR cStyleBlock = nReportStyle) AND 0 <> nStt ) then
		for n = 0 to nStt - 1
			aWin.Selection.JumpToNextCell()
		next n
	endif

	for n = nStt to nEnd - 1
		with aWin.Selection
			' Outline Style -> jump over an empty box at the beginning
			' starting at the second row
			if( 0 <> n AND ( nReportStyle = cStyleOutline1 OR nReportStyle = cStyleOutline2 )) THEN
				.JumpToNextCell()
			end if

			if( cStyleStepped <> nReportStyle AND cStyleBlock <> nReportStyle ) then
				.JumpToNextCell()
			end if

			if( NOT bEditMode ) then
				.InsertDBColumnContent( sGroupFields$( n ) )
'				.Insert( Application.DataColumn( sGroupFields$(  n )) )
			endif

			if( cStyleStepped = nReportStyle ) then

				' Note starting position!
				sCell$ = aWin.Selection.CellName()

				' Combine the current boxes left and right
				if( 1 < n ) then
					.Repaginate
					.InsertBookmark( "_SavePos" )
					.JumpToPrevCell()
					.GoLeft( n - 1, TRUE )
					.MergeCells()
					.JumpToBookmark( "_SavePos" )
					.DeleteBookmark( "_SavePos" )
				endif

				if( n + 1 < nCellCount ) then
					.Repaginate
					.JumpToNextCell()
					.GoRight( nCellCount - n - 2, TRUE )
					.MergeCells()
				endif
				.Repaginate
				.EntireRow()
				.StyleApply( "group_" + trim( str( n )), 2 )

				' That is the next cell
				sCell$ = left$(sCell$,1) + trim( str( val( right$( sCell$, len(sCell$) - 1 )) + 1 ))
				.GotoCell( sCell$ )
			endif

			if( n <> nEnd - 1 ) THEN
				.JumpToNextCell()
			endif

		end with
	next n

end sub


sub Report_FillBody( aWin AS Object, BYVAL nReportStyle as integer, _
					 BYVAL bNewRow as integer, BYVAL nPos as integer, _
					 BYVAL bEditMode as integer )

	DIM bCopyTbl, n as integer
	DIM sTmplNm$

	if( 0 = bNewRow ) then

		select case nReportStyle
		case cStyleStepped
			bCopyTbl = 0
		case cStyleBlock
			bCopyTbl = 0
		case else
			bCopyTbl = 1
		end select

		if( 0 <> bCopyTbl ) then
			if( NOT bEditMode ) then
				with aWin.Selection
					.GotoEndOfDoc()
					.GotoEndOfDoc()
					.GotoEndOfDoc()
					.ExpandGlossary( sAutoTextBdyShort )
					.GotoEndOfDoc()

					.jumptoprevtable()

					for n = 0 to nFieldCount-2
						.JumpToNextCell()
					next n
					.JumpToNextCell()

				end with
			end if
		else
			aWin.Selection.JumpToNextCell()
		end if

	else
	' Jump over all equal groups up to Body Start
		if( cStyleBlock = nReportStyle ) then
			for n = 0 to nGroupCount
				aWin.Selection.JumpToNextCell()
			next n
		else
			if( cStyleStepped = nReportStyle ) then
				aWin.Selection.GoToEnd()             ' in die letzte Zelle der Tabelle
				aWin.Selection.JumpToNextCell()

				for n = 0 to nFieldCount - 1
					aWin.Selection.JumpToPrevCell()
				next n

			else
				aWin.Selection.JumpToNextCell()

			endif
		endif
	end if

	if( cStyleStepped = nReportStyle ) then
		with aWin.Selection
			.Repaginate
			sTmplNm$ = aWin.Selection.StyleApplyState()
			.InsertBookmark( "_SavePos" )

			.JumpToPrevCell()
			.GoLeft( nGroupCount - 1, TRUE )
			.MergeCells()

			.EntireRow()
			.StyleApply( sTmplNm$, 2 )

			.JumpToBookmark( "_SavePos" )
			.DeleteBookmark( "_SavePos" )
		end with
	endif

	if( NOT bEditMode ) then
		for n = 0 to nFieldCount-1
			with aWin.Selection
				.InsertDBColumnContent( sBodyFields$( n ), sBodyStyleNames$(n))
'				.Insert( Application.DataColumn( sBodyFields$( n )) )
				if( n <> nFieldCount-1 ) then
					aWin.Selection.JumpToNextCell()
				end if
			end with
		next n
	endif

end sub


sub Report_Create_Column( aWin AS Object, BYVAL bFirst%, BYVAL bEditMode%, BYVAL nDataMax& )
	DIM n as integer

	if( bFirst% ) then
		with aWin.Selection
			' this is the area that always gets copied
			.CreateGlossaryGroup( sAutoTextGroupName )
			.JumpToStartOfDoc()
			.GoDown( nFieldCount, TRUE )

			.NewGlossary( sAutoTextGroupName, sAutoTextName, sAutoTextGrpShort )
		end with
	end if

	with aWin.Selection
		.GotoEndOfDoc()
		.GotoEndOfDoc()
		.GotoEndOfDoc()
		.ExpandGlossary( sAutoTextGrpShort )
		.GotoEndOfDoc()
		.GoLeft( nFieldCount, true )
		.Escape()
	end with

	if( NOT bEditMode% ) then
		aWin.Selection.ActionStart
		for n = 0 to nFieldCount-1
			with aWin.Selection

				.JumpToNextTable()
				.JumpToNextCell()
				.InsertDBColumnContent( sBodyFields$( n ), sBodyStyleNames$(n) )
'				.Insert( Application.DataColumn( sBodyFields$( n )) )

			end with
		next n
		aWin.Selection.ActionEnd
	endif

	aWin.Selection.GotoEndOfDoc()

end sub

sub Report_Create_Table( aWin AS Object, BYVAL bFirst%, BYVAL nDataMax& )

	DIM n as integer

	if( 0 <> bFirst% ) then
		with aWin.Selection
			.JumpToStartOfDoc()
			.JumpToNextTable()
			.GotoCell("A2")
			if( nDataMax& > 1 ) then
				.InsertRows( nDataMax& - 1, TRUE )
				.GotoCell("A2")
			end if
			.GoLeft()
		end with
	endif

	aWin.Selection.ActionStart
	for n = 0 to nFieldCount-1
		with aWin.Selection
			.JumpToNextCell()
			.InsertDBColumnContent( sBodyFields$( n ), sBodyStyleNames$(n) )
'			.Insert( Application.DataColumn( sBodyFields$( n )) )
		end with
	next n
	aWin.Selection.ActionEnd

end sub


' ---------------------------------------------------------------------
' utilities

function Report_IsValidQuery( BYVAL sQueryName$, sReportSQL$ ) as integer
	DIM nError%, bFound%, nStt%, nEnd%, n%, nCnt1%, nCnt2%, nFoundPos%
	DIM sSql$, sCmp$
	DIM aColumns as NEW Strings

	nError% = 0
	if( TRUE = Application.OpenQueryConnection( sQueryName$ )) then

		' first step - have the columns changed?
		' Ignore any new ones; deleted ones trigger an error

		aColumns = Application.GetQueryColumns( sQueryName$ )
		if( aColumns.Count() < nGroupCount + nFieldCount ) OR 0 = aColumns.Count() then
			nError% = 2
		else

			DIM sTmpColNms( 0 TO cMaxFieldIndex% )
			nCnt2% = 0
			for n% = 1 to aColumns.Count()
				sCmp$ = aColumns.Item( n% )
				sCmp$ = left$( sCmp$, InStr( sCmp$, "," )-1 )
				sTmpColNms( n% - 1 ) = UCASE$( sCmp$ )
			next n%
			nCnt2% = n% - 1

			bFound% = 1
			nCnt1% = 0
			if( 0 < nGroupCount ) then
				do
					bFound% = 0
					sCmp$ = UCASE$( sGroupFields$( nCnt1% ))

					for n% = 0 to nCnt2%-1
						if( sTmpColNms( n% ) = sCmp$ ) then
							bFound% = 1
							n% = nCnt2%
						endif
					next n%
					nCnt1% = nCnt1% + 1
				loop while( nCnt1% < nGroupCount AND 0 <> bFound% )
			endif

			if( 0 <> bFound% ) then
				nCnt1% = 0
				do
					bFound% = 0
					sCmp$ = UCASE$( sBodyFields$( nCnt1% ))

					for n% = 0 to nCnt2%-1
						if( sTmpColNms( n% ) = sCmp$ ) then
							bFound% = 1
							n% = nCnt2%
						endif
					next n%
					nCnt1% = nCnt1% + 1
				loop while( nCnt1% < nFieldCount AND 0 <> bFound% )
			endif

			if( 0 = bFound% ) then nError% = 2
		endif
	else
		nError% = 1
	endif

	if( 0 = nError% ) and ( "" <> sReportSql$ ) then
		sSql$ = Application.GetSql_Statement( sQueryName$ )

		sSql$ = UCase$( sSql$ )

		nCnt1% = 0
		nCnt2% = 0
		nEnd% = len( sSql$ )
		nFoundPos% = 0
		for n% = 1 to nEnd%
			select case asc( mid( sSql$, n%, 1 ))
			case 34:
				if( 0 = nCnt2% ) then
					if( 0 =         nCnt1% ) then
						nCnt1% = nCnt1% + 1
					else
						nCnt1% = nCnt1% - 1
					endif
				endif

			case 39:
				if( 0 = nCnt1% ) then
					if( 0 =         nCnt2% ) then
						nCnt2% = nCnt2% + 1
					else
						nCnt2% = nCnt2% - 1
					endif
				endif
			case 79:
				if( 0 = nCnt1% + nCnt2% AND "ORDER " = mid( sSql$, n%, 6 ) ) then
					' or found; is it also a blank or BY?
					n% = n% + 6
					while( " " = mid$( sSql$, n%, 1 ))
						n% = n% + 1
					wend
					if( "BY " = mid$( sSql$, n%, 3 )) then
						' then we've found the one we're looking for
						nFoundPos% = n% + 3
						n% = nEnd%
					endif
				endif
			end select
		next n%

		sSql$ = Application.GetSql_Statement( sQueryName$ )
		if( 0 = nFoundPos% ) then
	    ' append
			sSql$ = sSql$ + " ORDER BY " + sReportSQL$
		else
	    ' insert
			sSql$ = left$( sSql$, nFoundPos% - 1 ) + sReportSQL$ + "," + mid$( sSql$, nFoundPos%, nEnd% )
		endif
		sReportSQL$ = sSql$
	endif

	Report_IsValidQuery = nError%
end function



Sub ReplaceTokenInString ( ByVal TokenToReplace$, ByVal TokenToInsert$, sReplaceIn$ )

	Dim sLeft$, sRight$
	Dim nActSearchPos%

	nActSearchPos% = 1

	While ( 0 <> InStr ( nActSearchPos%, sReplaceIn$, TokenToReplace$ ) )

		sLeft$ = Left ( sReplaceIn$, InStr ( nActSearchPos%, sReplaceIn$, TokenToReplace$ ) - 1 )
		nActSearchPos% = Len ( sLeft$ ) + Len ( TokenToReplace$ ) + 1
		sRight = Mid ( sReplaceIn$, nActSearchPos% )

		sReplaceIn$ = sLeft$ + TokenToInsert$ + sRight$

	Wend

End Sub


