'SBLLINK:MethodInfo=CreateRangeEnumeration0
'SBLLINK:MethodInfo=AddSheetRanges0
'SBLLINK:MethodInfo=SelectRange0
'SBLLINK:MethodInfo=ConvertThehardWay0
'SBLLINK:MethodInfo=ConvertCellCurrencies0
'SBLLINK:MethodInfo=CheckIfRangeisCurrency0
'SBLLINK:MethodInfo=CountColumnsForRow0
'SBLLINK:MethodInfo=CountRangeCells0
REM  *****  BASIC  *****
Option Explicit


Sub CreateRangeEnumeration()
Dim i, MaxIndex as integer
Dim sStatustext as String
	MaxIndex = 0
	If NOT AutoPilot Then
		EnableStep1DialogControls(False)
		EmptySelection
		DialogConvert.Label1.Caption = GetResText(STEP_CONVERTER_CURRRANGES)  	'"Whrungsbereiche:"
		DialogConvert.Listbox1.Clear
		oDocument.CurrentController.Select(oSelRanges)
	End If

	If (DialogConvert.OptionButton2.Value) AND (NOT DialogConvert.CheckBox1.Value) Then
		' Ist das Sheet Grundlage fr die Bearbeitung?
		oStatusLine.SetText(GetResText(STATUSLINE_RELSHEETRANGES)        		'"Erfassung der relevanten Bereiche..."
		osheet = oDocument.CurrentController.GetActiveSheet
		oRanges = osheet.CellFormatRanges.createEnumeration
		MaxIndex = AddSheetRanges(oRanges, MaxIndex, oSheet)
	Else
		' oder das Dokument - dann msssen alle Sheets abgearbeitet werden	
		If NOT RangeListDefined Then
			' Die Ranges sind noch nicht definiert
			oSheets = oDocument.Sheets
			For i = 0 To oSheets.Count-1
				oSheet = oSheets.GetbyIndex(i)
				If AutoPilot Then
					StatusValue = StatusValue + SBRELGET/osheets.Count
					oStatusline.SetValue(Int(StatusValue))
				Else																	 
					sStatustext = ReplaceString(GetResText(STATUSLINE_RELRANGES),Str(i+1),"%1Number%1")
					sStatustext = ReplaceString(sStatusText,oSheets.Count,"%2TotPageCount%2")
					oStatusLine.SetText(sStatusText)
				End If
				oRanges = osheet.CellFormatRanges.createEnumeration
				MaxIndex = AddSheetRanges(oRanges, MaxIndex, oSheet)
			Next i
			RangeListDefined = True
		Else
			oStatusLine.SetText(GetResText(STATUSLINE_RELSHEETRANGES))  	'"Erfassung der relevanten Bereiche..."
			' Die Ranges sind schon definiert
			For I = 0 To CInt(RangeList(0)) 
				If RangeList(i) <> "" AND RangeBools(i) = True  Then
					DialogConvert.Listbox1.AddItem(RangeList(i))
				End If
			Next
		End If
	End If

	If Not AutoPilot Then
		EnableStep1DialogControls(True)
		oStatusLine.SetText("")	
	End If
	Rangeindex = MaxIndex
End Sub
	
	
			
Function AddSheetRanges(oRanges as Object, iBasis as Integer, oSheet as Object)			
Dim r as Integer	
Dim RangeName as String
Dim AddtoList as Boolean

	r = iBasis
	While oRanges.hasMoreElements
		oRange = oRanges.NextElement
		AddToList = CheckFormatType(oRange)
		If AddToList Then
			' Den Namen der Range ermitteln und in ein Array packen
			RangeName = RetrieveRangeNamefromAddress(oRange.RangeAddress, oSheet.Name)
			If NOT AutoPilot Then
				DialogConvert.Listbox1.AddItem(RangeName)
			End If
			TotCellCount = TotCellCount + CountRangeCells(oRange)
			If Not ((RangeListDefined) AND (DialogConvert.OptionButton2.Value)) OR (AutoPilot) Then
				' The Ranges are only passed to an Array when the whole Document is the basis
				r = r + 1
				RangeList(r) = RangeName
				RangeBools(r) = True
			End If
		End If
	Wend
	RangeList(0) = Cstr(r)
	AddSheetRanges = r
End Function



' Fgt einen Bereich zur selektierten Kollektion hinzu
Sub SelectRange()
Dim i, a, s as Integer
Dim Listbox as Object
Dim RangeName as String
Dim SelItem as String
Dim LocRangeList(100) as String
Dim CurRange as String
Dim ListCount as Integer
Dim SheetRangeName as String
Dim DescriptionList(1) as String
Dim MaxRangeIndex, StatusValue as Integer

	StatusValue = 0
	MaxRangeIndex = Val(SelRangeList(0))
	Listbox = DialogConvert.Listbox1
	ListCount = Listbox.ListCount
	a = 0
	
	CurSheetName = oSheet.Name

	For i = 1 To MaxRangeIndex
	
		SelItem = SelRangeList(i)
		' Is the Range already included in the collection?

		oRange = RetrieveRangeoutOfRangename(SelItem)

		' Find out how many Cells are in the range
		TotCellCount = TotCellCount + CountRangeCells(oRange)

		LocRangeList(a) = SelItem
		a = a + 1
			
		' Der Listboxeintrag ist frisch selektiert worden und mu der Range - Kollektion 
		' hinzugefgt werden
		DescriptionList() = ArrayOutofString(SelItem,".",1)
		SheetRangeName = DeleteStr(DescriptionList(0),"'")
		If SheetRangeName = CurSheetName Then
			oSelRanges.InsertbyName("",oRange)
		End If
		StatusValue= StatusValue + (SBRELGET/MaxRangeIndex)
		oStatusLine.SetValue(Int(StatusValue))
	Next i
	
	' Das Array mit den selektierten Listboxeintrgen aktualisieren
	ClearArray(ListboxItems())
	For s = 0 To a - 1
		CurRange = LocRangeList(s)
		ListboxItems(s) = CurRange
	Next s
End Sub


Sub ConvertThehardWay(ListboxList() as String, LastIndex as Integer, ThisSel() as Boolean, SwitchFormat as Boolean)
Dim i, a, r as Integer
Dim AddCells as Long
Dim OldStatusValue as Single
Dim RangeName as String
	If TotCellCount > 0 Then
		' Index fr die Removelist
		a = 0
		OldStatusValue = StatusValue
		' Harte Formatierung
		For i = 0 To LastIndex
			If ThisSel(i) = True Then
				RangeName = ListboxList(i)
				oRange = RetrieveRangeoutofRangeName(RangeName)
				ConvertCellCurrencies(oRange, Currfactor, False, SwitchFormat)
				If NOT AutoPilot Then
' The following line has been put beside due to Bug #73157 (Two ranges lying side by side)
'				If oSelRanges.HasbyName(RangeName) Then
					oSelRanges.RemovebyName(RangeName)
					oDocument.CurrentController.Select(oSelRanges)
'				End If
				End If

				If SwitchFormat Then
					If oRange.getPropertyState("NumberFormat") <> 1 Then
						' Range Ist hart formatiert
						SwitchNumberFormat( oRange, oFormats, sEuroSign)
					End If
				Else
					SwitchNumberFormat( oRange, oFormats,sEuroSign )
				End If
				AddCells = CountRangeCells(oRange)
				CurCellCount = AddCells

				StatusValue = StatusValue + (CurCellCount/TotCellCount)*(100-OldStatusValue)
				oStatusline.SetValue(Int(StatusValue))

				' Die selektierte Stilvorlage mu zum Schlu aus der Listbox entfernt werden
				If PreSelect Then
					RemoveList(0) = ListboxList(i)
				Else
					r = IndexinArray(ListboxList(i), RangeList())
					If r <> -1 Then
						RangeBools(r) = False
						RemoveList(a) = RangeList(r)
						a = a + 1
					End If
				End If
			End If
		Next
	End If
End Sub



Sub ConvertCellCurrencies(oRange as Object, fFaktor as Double, CurrRoundMode, SwitchFormat as Boolean)
Dim oValues as Object
Dim IntValue as Long
Dim i as Integer
Dim CellValue as double
Dim oCells as Object
Dim oCell as Object
Dim DecFactor as integer
Dim nFormatDecimals as integer
Dim IsHardFormatted as Boolean

	' Wenn der Bereich hart formatiert ist, dann bei selektierter
	' weichen Formatierung keine Umrechnung

	' konstante Werte im Bereich anpassen
  	oValues = oRange.queryContentCells( com.sun.star.sheet.CellFlags.VALUE )

	If (oValues.Count > 0) Then
		oCells = oValues.Cells.createEnumeration
		While oCells.hasMoreElements
			oCell = oCells.nextElement
			DecFactor = 0
			CellValue = oCell.Value
			oCell.Value = CellValue/fFaktor
		Wend
	End If
End Sub


Function CheckIfRangeisCurrency(FormatObject as Object)
Dim oFormatofObject() as Object
	' Retrieve the Format of the Object
	On Local Error GoTo NOKEY
	oFormatofObject() = oFormats.getByKey(FormatObject.NumberFormat)
	On Local Error GoTo 0			

	' Typ und Whrungssymbol des Numberformats heraussuchen
  	If INT(oFormatofObject.Type) AND com.sun.star.util.NumberFormat.CURRENCY Then
		CheckIfRangeisCurrency = True
	Else
		CheckIfRangeisCurrency = False
	End If
	NOKEY:
	If Err <> 0 Then
		CheckIfRangeisCurrency = False
		Resume CLERROR
	End If
	CLERROR:
End Function


Function CountColumnsForRow(IndexArray() as String, Row as Integer)
Dim i as Integer
Dim NoNulls as Boolean
	For i = 1 To Ubound(IndexArray,2)
		If IndexArray(Row,i)= "" Then
			NoNulls = False
			Exit For
		End If
	Next
	CountColumnsForRow = i
End Function


Function CountRangeCells(oRange as Object) As Long
Dim oRangeAddress as Object
Dim LocCellCount as Long
	oRangeAddress = oRange.RangeAddress
	LocCellCount = (oRangeAddress.EndColumn - oRangeAddress.StartColumn + 1) * (oRangeAddress.EndRow - oRangeAddress.StartRow + 1)
	CountRangeCells = LocCellCount
End Function
