'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=MainWithDefault0
'SBLLINK:MethodInfo=calcCurrencyProperties0
'SBLLINK:MethodInfo=CreateForm0
'SBLLINK:MethodInfo=FormTableSelect0
'SBLLINK:MethodInfo=FormNewDatabaseSelected0
'SBLLINK:MethodInfo=FormGetTemplateFilename0
'SBLLINK:MethodInfo=FormReadTemplates0
'SBLLINK:MethodInfo=FormGetTables0
'SBLLINK:MethodInfo=FormGetFields0
'SBLLINK:MethodInfo=FormcmdCancel0
'SBLLINK:MethodInfo=FormPrevClicked0
'SBLLINK:MethodInfo=FormNextOrReadyClicked0
'SBLLINK:MethodInfo=FormSetTitle0
'SBLLINK:MethodInfo=FormSetMoveRights0
'SBLLINK:MethodInfo=FormMoveSelected0
'SBLLINK:MethodInfo=FormMoveAll0
'SBLLINK:MethodInfo=FormRemoveSelected0
'SBLLINK:MethodInfo=FormRemoveAll0
'SBLLINK:MethodInfo=FormPreview1Repaint0
'SBLLINK:MethodInfo=FormPreview2Repaint0
'SBLLINK:MethodInfo=FormPreview3Repaint0
'SBLLINK:MethodInfo=FormPreview4Repaint0
'SBLLINK:MethodInfo=GetFileNameWithDescription0
'SBLLINK:MethodInfo=FormNameGetFocus0
'SBLLINK:MethodInfo=CheckFormTitle0
'SBLLINK:MethodInfo=GetTableOfQuery0
'SBLLINK:MethodInfo=CloseConnections0
'SBLLINK:MethodInfo=CreateClicked0
Option Explicit

Private Const  DatabaseFieldType_BOOL			= -7
Private Const  DatabaseFieldType_TINYINT		= -6
Private Const  DatabaseFieldType_SMALLINT		= 5
Private Const  DatabaseFieldType_INTEGER		= 4
Private Const  DatabaseFieldType_BIGINT			= -5
Private Const  DatabaseFieldType_REAL			= 7
Private Const  DatabaseFieldType_DOUBLE			= 8
Private Const  DatabaseFieldType_NUMERIC		= 2
Private Const  DatabaseFieldType_DECIMAL		= 3
Private Const  DatabaseFieldType_CURRENCY		= 2222
Private Const  DatabaseFieldType_CHAR			= 1
Private Const  DatabaseFieldType_VARCHAR		= 12
Private Const  DatabaseFieldType_LONGVARCHAR	= -1
Private Const  DatabaseFieldType_DATE			= 91
Private Const  DatabaseFieldType_TIME			= 92
Private Const  DatabaseFieldType_DATETIME		= 93
Private Const  DatabaseFieldType_BINARY			= -2
Private Const  DatabaseFieldType_VARBINARY		= -3
Private Const  DatabaseFieldType_LONGVARBINARY	= -4
Private Const  DatabaseFieldType_OTHER			= 1111

Global FormActiveTableName$, FormPath$, FormDBName$, FormReturnValue$
Global TemplatePath$

Global FormAvailForms As New Strings
Global FormOriginalFieldList As New Strings
Global FormInstalledQueries As New Strings

Global s_aCurrencySymbol As String
Global s_aPrependCurrencySymbol As Boolean

Dim bNeedFieldRefresh as Boolean

' -----------------------------------------------------------------------------
Sub Main()
	MainWithDefault ( "" )
End Sub

' -----------------------------------------------------------------------------
Sub MainWithDefault( ByVal DBName$ )

On Error Goto GlobalError

	if not (InitResources()) then
		exit sub
	end if


	Dim sResult$, sTitle$, sFileName$, sShow$, sTmp$
	Dim nPos%
	
	TemplatePath$ = Application.PathSettings.Template
	If InStr (TemplatePath$, ";")<>0 Then
		TemplatePath$ = Left$(TemplatePath$, InStr(TemplatePath$, ";")-1)       ' Non-Unix
	End If

	FormPath$ = TemplatePath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	Application.EnterWait()
	Wait( 0 )

	'   load language
	LoadLanguage( )

	'       Load dialog and string tools
	Application.LoadLibrary( "Tools" )
	Wait( 0 )

	' calc some special currency control properties (they depend from the system language)
	calcCurrencyProperties()

	bNeedFieldRefresh = True
	'       creating a form with the help of the dialog
	sResult$ = CreateForm$ ( DBName$ )
	Call CloseConnections()

	If ( "" = sResult$ ) Then Goto EndOfSub

	'       Everything up to the first semicolon = title
	nPos% = InStr ( 1, sResult$, ";" )
	sTitle$ = Left ( sResult$, nPos% - 1)
	sResult$ = Mid ( sResult$, nPos% + 1 )

	'   Everything up to the second semicolon = filename
	nPos% = InStr ( 1, sResult$, ";" )
	sFileName$ = Left ( sResult$, nPos% - 1 )

	Application.OpenDatabaseConnection ( FormDBName$ )

	If (Not Application.CreateForm( sTitle$, sFileName$ ) ) Then Goto GlobalError
	Wait ( 1 )

 	Application.OpenDatabaseConnection ( FormDBName$ )
	'       the last letter tells whether the form should be displayed
	If ( "1" = Right( sResult$, 1 ) ) Then
		Application.OpenForm( sTitle$ , TRUE )
		Wait ( 1 )
		On Error Resume Next
		ActiveWindow.TopWindow.Maximized = True
	Else
		MsgBox Form_gCreatedForm$ 
	End If

	'       Close all database connections
	Call CloseConnections()

EndOfSub:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend
	Exit Sub

GlobalError:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	MsgBox(Form_gErrMsg$ , 16, Form_gWizardName$ )

End Sub

' -----------------------------------------------------------------------------
Sub calcCurrencyProperties()
On Local Error goto _outta_here_
	Dim aInternational as Object
	aInternational = createUNOService("com.sun.star.deprecated.International")
		' WARNING : as the name suggests, this service is more a hack than a free usable service
		' so don't use it in your own macros as later versions of StarOffice may (and surely will)
		' not support it
		' ! UNO still has no real international service !

	' by definition the object (which is an com::sun::star::lang::XLocalizable) is working with the
	' system language initially , which is exactly the one we need, so just ask for the properties
	' we're interested in

	select case aInternational.CurrencyPositiveFormat
		case 0:	' $1
			s_aCurrencySymbol = aInternational.CurrencySymbol
			s_aPrependCurrencySymbol = TRUE
		case 1:	' 1$
			s_aCurrencySymbol = aInternational.CurrencySymbol
			s_aPrependCurrencySymbol = FALSE
		case 2:	' $ 1
			s_aCurrencySymbol = aInternational.CurrencySymbol & " "
			s_aPrependCurrencySymbol = TRUE
		case 3: ' 1 $
			s_aCurrencySymbol = " " & aInternational.CurrencySymbol
			s_aPrependCurrencySymbol = FALSE
	end select
_outta_here_:
	Exit Sub
End Sub

' -----------------------------------------------------------------------------
Function CreateForm$(databasename$)

On Error Goto GlobalError

	Dim nCount%

	'       Initialize Global Variables
	FormActiveTableName$ = ""
	FormReturnValue$ = ""
	FormDBName$ = databasename$
	FormActiveTableName$ = ""

	DlgFormDB.Load()

	DlgFormDB.optStyleCol.Value = True
	DlgFormDB.optHorizontal.Value = True
	DlgFormDB.optRunEdit.Value = True
	DlgFormDB.cmdPrev.Enabled = False
	DlgFormDB.CurrentStep = 1

	DlgFormDB.optRunNow.Value = True
	DlgFormDB.optRunEdit.Value = False

	If (FormDBName$ = "") Then
		DlgFormDB.cmbAvailDatabase.Visible = True
		DlgFormDB.frameDatabase.Visible = True
		DlgFormDB.cmbAvailDatabase.Top = 480
		DlgFormDB.frameDatabase.Top = 180
		DlgFormDB.frameTables.Top = DlgFormDB.frameTables.Top + DlgFormDB.frameDatabase.Height + 90
		DlgFormDB.frameTables.Height = DlgFormDB.frameTables.Height - DlgFormDB.frameDatabase.Height - 90
		DlgFormDB.lbTables.Top = DlgFormDB.lbTables.Top + DlgFormDB.frameDatabase.Height + 90
		DlgFormDB.lbTables.Height = DlgFormDB.lbTables.Height - DlgFormDB.frameDatabase.Height - 90

		DlgFormDB.cmbAvailDatabase.Clear()
		For nCount% = 1 To Application.DataDefinedDatabaseNumber()
			DlgFormDB.cmbAvailDatabase.AddItem(Application.DataDefinedDatabase(nCount%))
		Next

		If (0 = DlgFormDB.cmbAvailDatabase.ListCount()) Then
			MsgBox(Form_gErrNoDatabase$ , 64, Form_gWizardName$ )
			while( Application.IsWait() )
				Application.LeaveWait()
			wend
			Exit Function
		Else
			DlgFormDB.cmbAvailDatabase.ListIndex = 0
			FormDBName$ = DlgFormDB.cmbAvailDatabase.List(DlgFormDB.cmbAvailDatabase.ListIndex())
			Application.OpenDatabaseConnection(FormDBName$)
		End If
	Else
		DlgFormDB.cmbAvailDatabase.Visible = False
		DlgFormDB.frameDatabase.Visible = False
	End If

	'Call GetAllInstalledNamesInDatabase(FormDBName$, FormAvailTables)
	Call GetInstalledFormNamesInDatabase (FormDBName$, FormAvailForms )
	
	Call FormSetTitle()
	Call FormReadTemplates()
	Call FormGetTables()

	while( Application.IsWait() )
		Application.LeaveWait()
	wend

	DlgFormDB.Show()
	CreateForm$ = FormReturnValue$
	Exit Function

GlobalError:
	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	MsgBox(Form_gErrMsg$ , 16, Form_gWizardName$ )
	CreateForm$ = ""
	DlgFormDB.UnLoad()
	Reset
	Stop
End Function

' -----------------------------------------------------------------------------
Sub FormTableSelect
	bNeedFieldRefresh = True
End Sub

' -----------------------------------------------------------------------------
Sub FormNewDatabaseSelected()
	bNeedFieldRefresh = True
	FormDBName$ = DlgFormDB.cmbAvailDatabase.List(DlgFormDB.cmbAvailDatabase.ListIndex())

	Call GetInstalledFormNamesInDatabase(FormDBName$, FormAvailForms)
	Call FormGetTables()
End Sub

' -----------------------------------------------------------------------------
Function FormGetTemplateFilename$()
	Dim FindTitle$, sSep$
	Dim actFile$
	Dim ActFileInfo as new DocumentInfo

	FindTitle$ = DlgFormDB.lbPageStyles.List(DlgFormDB.lbPageStyles.ListIndex())

	sSep$ =  GetPathSeparator()

	actFile$ = Dir(TemplatePath$ + sSep$ + "wizard" + sSep$ + "db*.vor")
	While (actFile$<>"")
		ActFileInfo.Load(TemplatePath$ + sSep$ + "wizard" + sSep$ + ActFile$)
		If (ActFileInfo.Title=FindTitle$) Then
			FormGetTemplateFilename$ = TemplatePath$ + sSep$ + "wizard" + sSep$ + actFile$
			Exit Function
		End If
		actFile$=Dir
	Wend
	FormGetTemplateFilename$ = ""
End Function

' -----------------------------------------------------------------------------
Sub FormReadTemplates()
	Dim actFile$, sActTitle$, sSep$
	Dim ActFileInfo as new DocumentInfo

	sSep$ =  GetPathSeparator()

	DlgFormDB.lbPageStyles.Clear()
	actFile$ = Dir(TemplatePath$ + sSep$ + "wizard" + sSep$ + "db*.vor")
	While (actFile$<>"")
		ActFileInfo.Load(TemplatePath$ + sSep$ + "wizard" + sSep$ + ActFile$)
		sActTitle$ = ActFileInfo.Title
		If ( sActTitle$ <> "" ) Then
			DlgFormDB.lbPageStyles.AddItem( sActTitle$ )
		End If
		actFile$=Dir
	Wend
	If (DlgFormDB.lbPageStyles.ListCount()>=1) Then
		DlgFormDB.lbPageStyles.Selected(0) = True
	End If
End Sub

' -----------------------------------------------------------------------------
Sub FormGetTables()
	Dim i%
	Dim aNameSequence()

	Application.OpenDatabaseConnection(FormDBName$)
	FormInstalledQueries = Application.GetQueryNames()
		' this is a global not needed in this routine, but in some others

	DlgFormDB.lbTables.Clear()

	Dim aDBEngine, aDBWorkspace, aDatabase as Object
	Dim aEnumeration, aCurrentObject as Object
	' get the db we're searching in
	aDBEngine = createUnoService("com.sun.star.data.DatabaseEngine")
	aDBWorkspace = aDBEngine.Workspaces(0)	' this is the default workspace
	aDatabase = aDBWorkspace.open(aDBEngine.getLocation(FormDBName$))

	' get the query names
	aNameSequence = aDatabase.Queries.getElementNames()
	For i%=lbound(aNameSequence) To ubound(aNameSequence)
		DlgFormDB.lbTables.AddItem ( aNameSequence(i%) )
	Next i%

	' same for all tables
	aNameSequence = aDatabase.Tables.getElementNames()
	For i%=lbound(aNameSequence) To ubound(aNameSequence)
		DlgFormDB.lbTables.AddItem ( aNameSequence(i%) )
	Next i%

	' modify the UI accordingly ...
	If (DlgFormDB.lbTables.ListCount>=1) Then
		DlgFormDB.lbTables.Selected(0)=True
		DlgFormDB.cmdNextOrReady.Enabled = True
	Else
		MsgBox(Form_gErrNoTableInDatabase$ , 16, Form_gWizardName$  )
		DlgFormDB.cmdNextOrReady.Enabled = False
	End If
End Sub

' -----------------------------------------------------------------------------
Sub FormGetFields()
	If (Not bNeedFieldRefresh) Then Exit Sub

	Dim n%, i%, maxFields%
	Dim sActFieldName$
	Dim DocTest$
	Dim FieldsInQueries As New Strings

	Application.EnterWait()
On Local Error Goto no_fields
	' disable ui while loading
	DlgFormDB.cmdCancel.Enabled = False
	DlgFormDB.cmdPrev.Enabled = False
	DlgFormDB.cmdNextOrReady.Enabled = False
	DlgFormDB.cmdMoveSelected.Enabled = False
	DlgFormDB.cmdMoveAll.Enabled = False
	DlgFormDB.cmdRemoveSelected.Enabled = False
	DlgFormDB.cmdRemoveAll.Enabled = False

	DlgFormDB.lbFields.Clear()
	DlgFormDB.lbSelected.Clear()

	'       which table was selected
	n% = DlgFormDB.lbTables.ListIndex()
	If ( -1 = n% ) Then Goto outta_here
	FormActiveTableName$ = DlgFormDB.lbTables.List(DlgFormDB.lbTables.ListIndex())

	DocTest$ = SuggestTitleStr$(FormAvailForms, Form_ilFormTitleSuggestPrefix$  + FormActiveTableName$)

	i%= instr( 1, DocTest$,  ":" ,1 )
	if i% > 0 then	mid(DocTest$,i%,1,"_")

	DlgFormDB.txtDocTitle.Text = DocTest$

	FormOriginalFieldList.Clear()

	Dim bIsQuery as Boolean
	bIsQuery = (-1 < StrInStrings%(FormInstalledQueries, FormActiveTableName$))

	' We don't have controls for binary or fixed binary fields, so we don't want them to appear in the field list.
	' To ensure this, we check the field type of every column as got from the Fields-member of the table (or query, respectivly).
	' (This is one of he rare places where we use the new UNO-approach, because the Application.DataColumnType method - which
	' you normally would use to determine a column's type - doesn't make a difference between image and binary fields.
	' Propably the entire AutoPilot should use this other approach via StarOne, but hey, never touch a running system ...)
	Dim aDBEngine, aDBWorkspace, aDatabase as Object
	Dim aTable, aFields as Object
	Dim aField as Object
	Dim nType as integer
	aDBEngine = createUnoService("com.sun.star.data.DatabaseEngine")
	aDBWorkspace = aDBEngine.Workspaces(0)	' this is the default workspace
	aDatabase = aDBWorkspace.open(aDBEngine.getLocation(FormDBName$))
	If (bIsQuery) Then
		aTable = aDatabase.Queries.getByName(FormActiveTableName$)
	Else
		aTable = aDatabase.Tables.getByName(FormActiveTableName$)
	End If
	aFields = aTable.Fields

	If (bIsQuery) Then
		FieldsInQueries = Application.GetQueryColumns ( FormActiveTableName$ )
		maxFields% = FieldsInQueries.Count()
		For n% = 1 To maxFields%
			aField = aFields(n%-1)	' the UNO-interface is zero based !
			nType = aField.Type
			if (nType <> DatabaseFieldType_BINARY) And (nType <> DatabaseFieldType_VARBINARY) Then
				sActFieldName$ = FieldsInQueries.Item ( n% )	' should be the same as aField.Name
				sActFieldName$ = Left ( sActFieldName$, InStr ( 1, sActFieldName$, "," ) - 1 )
				DlgFormDB.lbFields.AddItem ( sActFieldName$ )
				FormOriginalFieldList.Add ( sActFieldName$ )
			End If
		Next
	Else
		'       fill out the list lbFields
		Application.OpenTableConnection( FormActiveTableName$ )
		Application.DataSelect( "select * from " + Application.QuoteTablename( FormActiveTableName$ ) )
		Call FixODBCBug()
		maxFields% = Application.DataColumnNumber()
		For n%=1 To maxFields%
			aField = aFields(n%-1)
			nType = aField.Type
			if (nType <> DatabaseFieldType_BINARY) And (nType <> DatabaseFieldType_VARBINARY) Then
				sActFieldName$ = Application.DataColumnname( n% )	' should be the same as aField.Name
				DlgFormDB.lbFields.AddItem ( sActFieldName$ )
				FormOriginalFieldList.Add ( sActFieldName$ )
			End If
		Next
	End If

	goto outta_here

no_fields:
	MsgBox Form_gErrCouldNotOpenObject$, 16, Form_gWizardName$

outta_here:
	're-enable the ui
	DlgFormDB.cmdCancel.Enabled = True
	DlgFormDB.cmdPrev.Enabled = True

	If (DlgFormDB.lbFields.ListCount()>=1) Then
		DlgFormDB.lbFields.Selected(0) = True
	End If
	FormSetMoveRights()

	Erase FieldsInQueries
	Application.LeaveWait()

	bNeedFieldRefresh = False
End Sub

' -----------------------------------------------------------------------------
Sub FormcmdCancel()
	DlgFormDB.Hide()
	DlgFormDB.Unload()
	Call CloseConnections()
	FormReturnValue$ = ""
End Sub

' -----------------------------------------------------------------------------
Sub FormPrevClicked()
	If (DlgFormDB.CurrentStep = 5) And (Not CheckFormTitle()) Then Exit Sub

	cmdNextOrReady.Visible = True
	DlgFormDB.CurrentStep = DlgFormDB.CurrentStep - 1
	If (DlgFormDB.CurrentStep=1) Then
		cmdPrev.Enabled = False
		cmdNextOrReady.Enabled = (DlgFormDB.lbTables.ListIndex()>=0)
	End If
	Call FormSetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub FormNextOrReadyClicked()
	cmdNextOrReady.Visible = ( DlgFormDB.CurrentStep < 4 )
	DlgFormDB.CurrentStep = DlgFormDB.CurrentStep + 1

	If (DlgFormDB.CurrentStep=2) Then
		FormGetFields()
	End If

	If (DlgFormDB.CurrentStep>=2) Then
		cmdPrev.Enabled = True
	End If

	If (DlgFormDB.CurrentStep=2) Then
		cmdNextOrReady.Enabled = (lbSelected.ListCount()>=1)
		if cmdMoveAll.Enabled then
			cmdMoveAll.SetFocus
		else
			cmdNextOrReady.SetFocus
		end If	
	End If

	If (DlgFormDB.CurrentStep>2)and (DlgFormDB.CurrentStep<5) Then
		cmdNextOrReady.SetFocus
	end IF

	If (DlgFormDB.CurrentStep=5) Then
		cmdReady.SetFocus
	End If

	Call FormSetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub FormSetTitle()
	Select Case (DlgFormDB.CurrentStep)
		Case 1
			DlgFormDB.Caption = Form_Dlg_1Caption$ 
		Case 2
			DlgFormDB.Caption = Form_Dlg_2Caption$ 
		Case 3
			DlgFormDB.Caption = Form_Dlg_3Caption$ 
		Case 4
			DlgFormDB.Caption = Form_Dlg_4Caption$ 
		Case 5
			DlgFormDB.Caption = Form_Dlg_5Caption$ 
	End Select
End Sub

' -----------------------------------------------------------------------------
Sub FormSetMoveRights()
	'       Enable or disable the buttons used for moving the available
	'       fields between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	FieldSelected% = (-1<>lbFields.ListIndex())
	FieldCount% = lbFields.ListCount()

	SelectSelected% = (-1<>lbSelected.ListIndex())
	SelectCount% = lbSelected.ListCount()

	cmdRemoveAll.Enabled = (SelectCount%>=1)
	cmdRemoveSelected.Enabled = (SelectCount%>=1 And SelectSelected%)
	cmdMoveAll.Enabled = (FieldCount%>=1)
	cmdMoveSelected.Enabled = (FieldCount%>=1 And FieldSelected%)
	cmdNextOrReady.Enabled = (SelectCount%>=1)
End Sub

' -----------------------------------------------------------------------------
Sub FormMoveSelected()
	Call MoveSelectedListBox(lbFields, lbSelected)
	Call FormSetMoveRights()
End Sub

' -----------------------------------------------------------------------------
Sub FormMoveAll()
	Call CopyItemsListBox(lbFields, lbSelected)
	Call FormSetMoveRights()
	cmdNextOrReady.SetFocus
End Sub

' -----------------------------------------------------------------------------
Sub FormRemoveSelected()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, FormOriginalFieldList, False )
	Call FormSetMoveRights()
End Sub

' -----------------------------------------------------------------------------
Sub FormRemoveAll()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, FormOriginalFieldList, True )
	Call FormSetMoveRights()
End Sub

' -----------------------------------------------------------------------------
'       Picture Repaint-Events
Sub FormPreview1Repaint()
	Call PaintPicOnPreview(DlgFormDB.Preview1, FormPath$+"cjform01.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub FormPreview2Repaint()

	Dim FileName$

	If (optStyleCol.Value=False And optStyleJustified.Value=False And optStyleTabled.Value=False) Then optStyleCol.Value = True

	If ( optStyleCol.Value ) Then
		frameOrientation.Enabled = True
		optHorizontal.Enabled = True
		optVertical.Enabled = True
		If ( optVertical.Enabled And optVertical.Value ) Then
			FileName$ = "cjform2c.bmp"
		Else
			FileName$ = "cjform2b.bmp"
		End If
	Else
		frameOrientation.Enabled = False
		optHorizontal.Enabled = False
		optVertical.Enabled = False
		If ( optStyleJustified.Value ) Then
			FileName$ = "cjform02.bmp"
		ELSE	
			FileName$ = "cjform05.bmp"
		End If	
	End If
	Call PaintPicOnPreview(DlgFormDB.Preview2, FormPath$+FileName$, 222, 156, True)
End Sub

' -----------------------------------------------------------------------------
Sub FormPreview3Repaint()

	Dim sBitmapFile$
	
	If (optStyleTabled.Value=False) Then
		sBitmapFile$ = LCase ( Trim ( Right ( FormGetTemplateFilename$(), 8 ) ) )
		sBitmapFile$ = Left ( sBitmapFile$, (Len (sBitmapFile$) - 4) ) + ".bmp"
		If ( not FileExists (FormPath$+sBitmapFile$) ) Then
	    	sBitmapFile$ = "db00.bmp"
	    endif	
	else
		sBitmapFile$ = LCase ( Trim ( Right ( FormGetTemplateFilename$(), 8 ) ) )
		sBitmapFile$ = Left ( sBitmapFile$, 2 )+ "t" +Mid ( sBitmapFile$,  3, 2 ) + ".bmp"
		If ( not FileExists (FormPath$+sBitmapFile$) ) Then
			sBitmapFile$ = "db00.bmp"
		endif
	endif

	Call PaintPicOnPreview(DlgFormDB.Preview3, FormPath$+sBitmapFile$, 166, 128, True) 

End Sub

' -----------------------------------------------------------------------------
Sub FormPreview4Repaint()
	Call PaintPicOnPreview(DlgFormDB.Preview4, FormPath$+"end.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Function GetFileNameWithDescription$(ByVal TableName$, ByVal actPath$)
	Dim actFileName$, aLine$
	Dim fileChannel%
	On Error Resume Next
	actFileName$ = Dir(actPath$ + "db*.def")
	fileChannel% = FreeFile%
	Open actPath$ + actFileName$ For INPUT As fileChannel%
	Line Input #fileChannel%, aLine$
	Close #fileChannel%
	While (aLine$<>TableName$)
		fileChannel% = FreeFile%
		Open actPath$ + actFileName$ For INPUT As fileChannel%
	Line Input #fileChannel%, aLine$
		Close #fileChannel%
		If (aLine$<>TableName$) Then actFileName$ = Dir
	Wend
	GetFileNameWithDescription$ = actFileName$
End Function

' -----------------------------------------------------------------------------
Sub FormNameGetFocus()
	txtDocTitle.Tag = txtDocTitle.Text
End Sub

' -----------------------------------------------------------------------------
Function CheckFormTitle as Boolean
	Dim sError$, sWizardName$

	sError$ = Form_gErrTitleSyntaxError$
	sWizardName$ = Form_gWizardName$

	CheckFormTitle = False
	If ( Len(txtDocTitle.Text) > 32 ) Then
		txtDocTitle.Text = Trim ( Left ( txtDocTitle.Text, 31 ) )
		MsgBox Form_gErrNameToLong$, 64, sWizardName$
		txtDocTitle.SetFocus()
		txtDocTitle.Tag = "ERROR"
		Exit Function
	End If

	If (Not CheckDatabaseIdentifier2(txtDocTitle, sError$, sWizardName$)) Then
		txtDocTitle.Tag = txtDocTitle.Text
		Exit Function
	End If	

	sError$ = Form_gErrTitleAsTableExist$
	If (Not CheckTitleUnique(FormAvailForms, txtDocTitle, sError$, sWizardName$)) Then
		txtDocTitle.Tag = txtDocTitle.Text
		Exit Function
	End If	

	CheckFormTitle = True
End Function

' -----------------------------------------------------------------------------
Function GetTableOfQuery$ ( Byval sSql$ )

	Dim nCnt1%, nCnt2%, nEnd%, n%

	sSql$ = UCase$( sSql$ )

	nCnt1% = 0
	nCnt2% = 0
	nEnd% = len( sSql$ )
	for n% = 1 to nEnd%
		select case asc( mid( sSql$, n%, 1 ))
		case 34:
			if( 0 = nCnt2% ) then
				if( 0 = 		nCnt1% ) then
					nCnt1% = nCnt1% + 1
				else
					nCnt1% = nCnt1% - 1
				endif
			endif

		case 39:
			if( 0 = nCnt1% ) then
				if( 0 = 		nCnt2% ) then
					nCnt2% = nCnt2% + 1
				else
					nCnt2% = nCnt2% - 1
				endif
			endif
		case 70:
			if( 0 = nCnt1% + nCnt2% AND "FROM " = mid( sSql$, n%, 5 ) ) then
				' oder gefunden, ist es auch ein oder by?
				n% = n% + 5
				while( " " = mid$( sSql$, n%, 1 ))
					n% = n% + 1
				wend
				if( """" = mid$( sSql$, n%, 1 )) then n% = n% + 1
				nCnt1% = n%
				while( n% <= nEnd% AND 0 = InStr( " """, mid$( sSql$, n%, 1 )))
					n% = n% + 1
				wend
				GetTableOfQuery$ = Mid ( sSql$, nCnt1%, n% - nCnt1% )
				Exit Function
			endif
		end select
	next n%
End Function

' -----------------------------------------------------------------------------
Sub CloseConnections()
	If ( "" <> Application.GetActiveTableConnection() ) Then
		Application.CloseTableConnection( Application.GetActiveTableConnection() )
	End If
	If ( "" <> Application.GetActiveDatabaseConnection() ) Then
		Application.CloseDatabaseConnection( Application.GetActiveDatabaseConnection() )
	End If
End Sub

' -----------------------------------------------------------------------------
Const MaxFieldIndex% = 256
Const cColumnarLeft% = 1, cColumnarTop% = 2, cJustified% = 3, cTabled% = 4
Const cNone = 1, cHorizontal = 2, cVertical = 3

Dim FieldName$(0 To MaxFieldIndex%)
Dim FieldPostfix$(0 To MaxFieldIndex%)
Dim FieldType%(0 To MaxFieldIndex%)
'Dim FieldLabelWidth(0 To MaxFieldIndex%) As Single
Dim FieldDataWidth%(0 To MaxFieldIndex%)
Dim FieldDecimalAccuracy%(0 To MaxFieldIndex%)
Dim ColumnMap(0 To MaxFieldIndex%)
Dim StructFieldSize%, Style%, Alignment%
Dim TemplateFile$

' -----------------------------------------------------------------------------
Sub CreateClicked()
	If (Not CheckFormTitle()) Then Exit Sub

	'       prepare the calling parameters for Juergen Pingel's routine
	DlgFormDB.Hide()
	Dim activeColumnName$, actType$, subType$, ShowAfterCreate$,DocumentName$, sSQLExpr$, sQueryName$
	Dim n%, m%, Found%, nArrCount%

	Application.EnterWait()
	Wait( 0 )

	TemplateFile$ = FormGetTemplateFilename$()
	If (optRunNow.Value = True) Then
		ShowAfterCreate$ = "1"
	Else
		ShowAfterCreate$ = "0"
	End If

	Call FixODBCBug()

	' what is the form based on ? a query or a table ?
	Dim bIsQuery as boolean
	bIsQuery = (-1 < StrInStrings%(FormInstalledQueries, FormActiveTableName$))
	If (bIsQuery) Then
		sQueryName$ = FormActiveTableName$
		sSQLExpr$ = Application.GetSQL_Statement ( sQueryName$ )
		Application.OpenQueryConnection( sQueryName$ )
	Else
		sQueryName$ = ""
	End If

	' Build a structure which maps the position of a selected field (within the selection) to the the column position within
	' the table. So we ensure that the controls are placed in the same order the according fields are selected.
	For StructFieldSize% = 1 To Application.DataColumnNumber()
		activeColumnName$ = Application.DataColumnName(StructFieldSize%)
		n% = 0
		Found% = False
		While (n%<lbSelected.ListCount() And (Not Found%))
			If (lbSelected.List(n%)=activeColumnName$) Then
				Found% = True
				ColumnMap(n%) = StructFieldSize%
			End If
			n% = n% + 1
		Wend
	Next StructFieldSize%

	' now collect the control descriptions for the fields
	nArrCount% = 0
	for n% = 0 to lbSelected.ListCount()-1
		m% = m% + 1
		activeColumnName$ = Application.DataColumnName(ColumnMap(n%))
		FieldName$(nArrCount%) = activeColumnName$
		FieldPostfix$(nArrCount%) = ""
		actType$ = Application.DataColumnType(activeColumnName$)
		' default subtype
		subType$ = ""
		Select Case (actType$)
			Case "TEXT" :
				FieldType%(nArrCount%) = cText
				subType$=Application.DataColumnSubType(activeColumnName$)
				FieldDataWidth(nArrCount%) = Val(subType$)
			Case "NUMERIC" :
				subType$=Application.DataColumnSubType(activeColumnName$)
				FieldType%(nArrCount%) = cFloat
				If (subType$="DOUBLE" Or subType$="SINGLE") Then
					FieldType%(nArrCount%) = cFloat
					FieldDataWidth(nArrCount%) = 21
				End If
				If (subType$="INTEGER") Then
					FieldType%(nArrCount%) = cInteger
					FieldDataWidth(nArrCount%) = 6
				End If
				If (subType$="LONG") Then
					FieldType%(nArrCount%) = cLong
					FieldDataWidth(nArrCount%) = 11
				End If
				If (subType$="BYTE") Then
					FieldType%(nArrCount%) = cShortInt
					FieldDataWidth(nArrCount%) = 4
				End If
				subType$ = ""
			Case "MEMO" :
				FieldType%(nArrCount%) = cMEMO
				FieldDataWidth(nArrCount%) = 100
			Case "BOOL" :
				FieldType%(nArrCount%) = cBoolean
				FieldDataWidth(nArrCount%) = 5
			Case "COUNTER" :
				FieldType%(nArrCount%) = cCounter
				FieldDataWidth(nArrCount%) = 11
			Case "DOUBLE" : ' Dezimalfeld
				FieldType%(nArrCount%) = cDecimal
				Dim aDBDatabase, aDBFields, aDBField as Object
				aDBDatabase  = GetDBObject(FormDBName$)
				if sQueryName$ = "" then
					aDBFields = aDBDatabase.Tables.GetByName(FormActiveTableName$).Fields
				else
					aDBFields = aDBDatabase.Queries.GetByName(FormActiveTableName$).Fields	
				End IF
				aDBField = aDBFields.getByName(activeColumnName$)
				FieldDataWidth(nArrCount%) = aDBField.Size+aDBField.Scale ' Gre und Nachkommastellen
				if FieldDataWidth(nArrCount%)>50 then
					FieldDataWidth(nArrCount%) = 50
				End If
				FieldDecimalAccuracy%(nArrCount%) = aDBField.Scale
			Case "DATE/TIME" :
				' a date/time field needs two separated controls :
				' one for the date part
				FieldType%(nArrCount%) = cDateField
				FieldPostfix$(nArrCount%) = Form_gDatetime_DateComponent$
				FieldDataWidth(nArrCount%) = 12
'				FieldLabelWidth(nArrCount%) = len(FieldName$(nArrCount%) + FieldPostfix$(nArrCount%))*0.2

				' and one for the time part
				nArrCount% = nArrCount% + 1
				FieldName$(nArrCount%) = activeColumnName$
				FieldType%(nArrCount%) = cTime
				FieldPostfix$(nArrCount%) = Form_gDatetime_TimeComponent$
				FieldDataWidth(nArrCount%) = 11
			Case "DATE" :
				FieldType%(nArrCount%) = cDateField
				FieldDataWidth(nArrCount%) = 12
			Case "TIME" :
				FieldType%(nArrCount%) = cTime
				FieldDataWidth(nArrCount%) = 11
			Case "CURRENCY" :
				FieldType%(nArrCount%) = cCurrency
				FieldDataWidth(nArrCount%) = 15
			Case "IMAGE" :
				FieldType%(nArrCount%) = cImage
				FieldDataWidth(nArrCount%) = 100	' max Breite
			Case Else :
				FieldType%(nArrCount%) = cText
				subType$ = "50"
		End Select
		'       average width "x" in cm 0.184
'		FieldLabelWidth(nArrCount%) = len(FieldName$(nArrCount%) + FieldPostfix$(nArrCount%))*0.2
		nArrCount% = nArrCount% + 1
	Next

	'   Formating
	If (optStyleCol.Value=True) Then
		If (optVertical.Value = True) Then
			Style% = cColumnarTop%
		Else
			Style% = cColumnarLeft%
		End If
	Else
	If (optStyleJustified.Value=True) Then
		Style% = cJustified%
	Else
		Style% = cTabled%
	End If
	End If

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

	'       Parameter expansion with nDataSource% -> meaning depends on FormActiveTableName$
	DocumentName$ = CreateLayout$(Style%, nArrCount%,FieldName$(),FieldPostfix$(),FieldType%(),FieldDataWidth(), TemplateFile$, FormDBName$, FormActiveTableName$, sQueryName$)

	FormReturnValue$ = txtDocTitle.Text + ";" + DocumentName$ + ";" + ShowAfterCreate$
End Sub
