'SBLLINK:MethodInfo=CloneObject0
'SBLLINK:MethodInfo=CloneControl0
'SBLLINK:MethodInfo=InsertControl0
'SBLLINK:MethodInfo=CreateLayout0
'SBLLINK:MethodInfo=createTempFilename0
'SBLLINK:MethodInfo=SaveDataInUserField0
'SBLLINK:MethodInfo=CalcForColumns20
'SBLLINK:MethodInfo=CalcForJustified20
'SBLLINK:MethodInfo=CalcForTable0
'SBLLINK:MethodInfo=CalcFontSizes0
'SBLLINK:MethodInfo=InsertFrmCaptLeft20
'SBLLINK:MethodInfo=InsertFrmCaptTop20
'SBLLINK:MethodInfo=GetRasterWidth0
'SBLLINK:MethodInfo=GetRasterHeight0
'SBLLINK:MethodInfo=CalcFieldWidth0
'SBLLINK:MethodInfo=CalcCaptionWidth0
'SBLLINK:MethodInfo=GetContentCount0
'SBLLINK:MethodInfo=GetControlHeight0
'SBLLINK:MethodInfo=TwipToCM0
'SBLLINK:MethodInfo=TwipTo100telMM0
'SBLLINK:MethodInfo=TwipToPixel0
'SBLLINK:MethodInfo=SetLayoutEventHandles0
Option Explicit

' ActionStart/-End can be turned on or off for debug purposes
const bCallActionSttEnd = 1

Const MaxFieldIndex% = 200
Const cColumnarLeft% = 1, cColumnarTop% = 2, cJustified% = 3, cTabled% = 4
Global Const cText = 1, cFloat = 2, cInteger = 3, cLong = 4, cBoolean = 5, cMemo = 6, cCounter = 7, cDateTime = 8,_
			cDateField = 9, cTime = 10, cCurrency = 11, cImage = 12, cDecimal = 13, cShortInt = 14
const sDBDataNumber = "DB_DataNumber", sDBFieldPos = "DB_FieldPos", sDBFieldCount = "DB_FieldCount"
const sDBFieldName = "DB_FieldName_", sDBFieldType = "DB_FieldType_", sDBFieldLen = "DB_FieldLen_"
const sDBRecordFrame = "DataRecordID", sDBName = "DB_Name", sDBTable = "DB_Table", sDBQuery = "DB_Query_Name"
const sDBFormType = "DB_FormType"

' VersionNumber of Form
const sDBFormVersion = "Form_Version", cDBFormVersion = 1

' values are always in Twips
' Offsets
const cXOffset% = 283, cYOffset% = 283

' Values for Columnar
const cColPageWidth% = 10 * 567, cColPageHeight% = 10 * 567
const cColCaptionMaxWidth% = 2.9 * 567, cColContentMaxWidth% = 4.0 * 567, cColColumnWidth% = cColContentMaxWidth% + cColCaptionMaxWidth%

' Values for Justified
const cJustPageWidth% = 20 * 567, cJustPageHeight% = 10 * 567

' Type of Columnars
const cCaptionLeft = 0, cCaptionTop = 1

' Type of ControlCollection
const cControlCollectionCount = 9
const cLabel 		= 1
const cTextBox 		= 2
const cCheckBox 	= 3
const cDateBox 		= 4
const cTimeBox 		= 5
const cNumericBox 	= 6
const cCurrencyBox 	= 7
const cGridControl	= 8
const cImageControl	= 9

' data source
DIM nFieldControlSources (0 to MaxFieldIndex% ) as string

' field label postfix (the label ist the data source followed by a postfix)
DIM nFieldPostfixes (0 to MaxFieldIndex% ) as string

' Field Type
DIM nFieldContentTypes (0 to MaxFieldIndex% ) as string

' number of characters in the field
DIM nFieldContentChars (0 to MaxFieldIndex% ) as integer

' width of the description and the field in Twips
DIM nFieldContentWidth (0 to MaxFieldIndex% ) as long
DIM nFieldContentHeight (0 to MaxFieldIndex% ) as long
DIM nFieldCaptionWidth (0 to MaxFieldIndex% ) as long
DIM nFieldCaptionHeight (0 to MaxFieldIndex% ) as long

' Field font sizes
DIM nCaptionFontWidth as long
DIM nCaptionFontHeight as long
DIM nFieldFontWidth as long
DIM nFieldFontHeight as long

' inner Border of the template frame
DIM nCaptionFrameBorder, nContentFrameBorder as long

'#########################################

Function CloneObject (aControlObject as object) as Object
	' The usual way for creating a clone would be to instantiate an input stream, a pipe, an
	' output stream, chain them, write the object into the output and read it from the input
	' stream. Difficult enough ;).
	' Unfortunally the form controls need markable streams for persistence so we have to
	' add two more elements to our stream chain.
	dim aOutStream as Object
	dim aOutMarkable as Object
	dim aPipe as Object
	dim aInMarkable as Object
	dim aInStream as object

	' first create the objects
	aInStream = createUnoService("com.sun.star.io.ObjectInputStream")
  aInMarkable = createUnoService("com.sun.star.io.MarkableInputStream")
	aPipe = createUnoService("com.sun.star.io.Pipe")
  aOutMarkable = createUnoService("com.sun.star.io.MarkableOutputStream")
	aOutStream = createUnoService("com.sun.star.io.ObjectOutputStream")
	' chain them
	aInMarkable.setInputStream(aPipe)
	aOutMarkable.setOutputStream(aPipe)
	aInStream.setInputStream(aInMarkable)
	aOutStream.setOutputStream(aOutMarkable)
	' do the cloning
	aOutStream.WriteObject(aControlObject)
	aOutStream.closeOutput
	CloneObject = aInStream.ReadObject()
	aInStream.closeInput
End Function

Function CloneControl (sControlName$, aDoc as Object) as Object
	dim formcomp1 as object
	dim dbforms as object

	dbforms = aDoc.DrawPage.Forms.GetByName("Standard")
	formcomp1 = dbforms.GetByName (sControlName$)
	CloneControl = CloneObject (formcomp1)
End Function

Function InsertControl (aControlObject as object, aDoc as Object, aPoint as Object, aSize as Object)
	dim aDPage, aShape as object
	aShape = aDoc.CreateInstance ("com.sun.star.drawing.ControlShape")
	aShape.Size = aSize
	aShape.Position = aPoint
	aShape.AnchorType = 0
	aShape.control = aControlObject
	aDPage = aDoc.drawpage
	aDPage.Add (aShape)
	InsertControl = aShape
End Function

'#################################

Function CreateLayout$( BYVAL nStyle%, BYVAL nCount%, nFldCaptionNames$(), _
						nFldLabelPostfixes$(), nFldContentTypes(), nFldContentChars(), _
						BYVAL sFileStr$, BYVAL sDBName$, BYVAL sTableName$, _
						BYVAL sQueryName$ )

	Dim filename$, sTmpFileName$, bWinMaxiMized%
	DIM bUndo%, bSolidHdl%, nOldMetric%
	DIM aProgress AS NEW PROGRESS
	DIM aDoc, aForm, aUnoDoc as Object
	DIM aControlCollection(cControlCollectionCount) as Object

	nFieldControlSources() = nFldCaptionNames$()
	nFieldPostfixes() = nFldLabelPostfixes$()
	nFieldContentTypes() = nFldContentTypes()
	nFieldContentChars() = nFldContentChars()

	Application.EnterWait()
	Wait( 0 )

	aDoc = documents.open( sFileStr$, "", "H"  ) ' verdeckt Laden

	ON local Error goto ErrorAndCloseTMP

	aUnoDoc = aDoc.Uno
	aControlCollection(cLabel) = CloneControl ("LabelStandard", aUnoDoc )
	aControlCollection(cTextBox) = CloneControl ("TextBoxStandard", aUnoDoc )
	aControlCollection(cCheckBox) = CloneControl ("CheckBoxStandard", aUnoDoc )
	aControlCollection(cDateBox) = CloneControl ("DateBoxStandard", aUnoDoc  )
	aControlCollection(cTimeBox) = CloneControl ("TimeBoxStandard", aUnoDoc )
	aControlCollection(cNumericBox) = CloneControl ("NumericBoxStandard", aUnoDoc )
	aControlCollection(cCurrencyBox) = CloneControl ("CurrencyBoxStandard", aUnoDoc )
	aControlCollection(cGridControl) = CloneControl ("GridControlStandard", aUnoDoc )
	aControlCollection(cImageControl) = CloneControl ("ImageControlStandard", aUnoDoc )
	aDoc.Close(false)

	ON local Error goto 0

	aDoc = documents.open( TemplatePath$ + GetPathSeparator() + "wizard" + GetPathSeparator() + "dbform.vor" )

	ON local Error goto ErrorAndCloseForm

	aDoc = aDoc.uno

  aForm = aDoc.CreateInstance ("com.sun.star.form.component.Form")
	aDoc.Drawpage.Forms.InsertByIndex (0, aForm)
	aForm.Name="Standard"
	aForm.DataSourceName = sDBName$
	aForm.Command = sTableName$
	if (sQueryName$="") then
		aForm.CommandType=0 ' Tabelle
	else
		aForm.CommandType=1 ' Abfrage
	End If


	If ActiveDocument.ReadOnly=FALSE Then
		Application.DesignerDialog = FALSE
	End If
	Application.Navigator = FALSE

	nOldMetric% = StarWriter.MetricUnit
	StarWriter.MetricUnit = 2               ' Unit to Centimeters

	bUndo% = Selection.UndoMode
	Selection.UndoMode = FALSE

	bSolidHdl% = StarWriter.ViewSettings().SolidHandles
	StarWriter.ViewSettings().SolidHandles = FALSE

	ActiveDocument.LoadStyles( sFileStr$, 15 )

	ActiveWindow.LockPaint( TRUE )
	ActiveWindow.ShowCursor = FALSE

	LoadLanguage ( Application.LanguageID )
	aProgress.Start( Form_gProgressText$, nCount% )

	' clear EventTable
	SetLayoutEventHandles( 0 )

	Select Case (Style%)
		Case cColumnarLeft%
			CalcForColumns2( nCount%, cCaptionLeft, aProgress, aControlCollection(), aDoc, aForm)

		Case cColumnarTop%
			CalcForColumns2( nCount%, cCaptionTop, aProgress, aControlCollection(), aDoc, aForm)

		Case cJustified%
			CalcForJustified2( nCount%, aProgress, aControlCollection(), aDoc, aForm )

		Case cTabled%
			CalcForTable( nCount%, aProgress, aControlCollection(), aDoc, aForm )
			aForm.NavigationBarMode = 0
	End Select

    ' create User Fields
	SaveDataInUserField( nCount%, sDBName$, sTableName$, sQueryName$, Style% )

	Selection.UndoMode = bUndo%
	StarWriter.ViewSettings().SolidHandles = bSolidHdl%

	StarWriter.MetricUnit = nOldMetric%

	sTmpFileName$ = createTempFilename$

	'SetLayoutEventHandles( 1 )

	' ProgressBar
	aProgress.Stop

	filename$ = application.pathsettings.database + GetPathSeparator() + sTmpFileName$ +".sdw"

	activedocument.close(True,filename$)
	wait( 1 )

	'       Readonly
	ON local Error goto ErrHdl_Form_Create
	'SetAttr( filename$, 1 )
	'SetAttr( TemplatePath$ + GetPathSeparator() + "wizard" + GetPathSeparator() + "travel.sdw", 1 )

	Application.LeaveWait()

	CreateLayout$ = filename$
	exit function

ErrHdl_Form_Create:
	if( 53 = err ) then
	' Setting to ReadOnly not succesfull, file still in use
	' wait until it works
		resume 0
	endif
		' ProgressBar
	aProgress.Stop
	exit function

ErrorAndCloseTMP:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	MsgBox(Form_gErrMsg$, 16, Form_gWizardName$)
	aDoc.Close (false)
	Stop
	exit function

ErrorAndCloseForm:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	MsgBox(Form_gErrMsg$, 16, Form_gWizardName$)
	aDoc.dispose
	Stop
	exit function

end function

function createTempFilename$()
	DIM sStr$, n%, cChar%
	DIM nDateVal, nTimeVal as long

	randomize()

	sStr$ = Date
	nDateVal = 0
	for n% = 1 to len( sStr$ )
		cChar% = asc(mid$( sStr$, n%, 1 ))
		if( 48 <= cChar and cChar <= 57  ) then
			nDateVal = nDateVal * 10 + ( cChar - 48 )
		endif
	next n%

	sStr$ = Time
	nTimeVal = 0
	for n% = 1 to len( sStr$ )
		cChar% = asc(mid$( sStr$, n%, 1 ))
		if( 48 <= cChar and cChar <= 57  ) then
			nTimeVal = nTimeVal * 10 + ( cChar - 48 )
		endif
	next n%
	if( 0 = nTimeVal ) then nTimeVal = 1

	createTempFilename$ = Left(Trim(Str(Int(10000 * Rnd * nDateVal / nTimeVal ))),7)
end function


sub SaveDataInUserField( BYVAL nCount%, BYVAL sDBNm$, BYVAL sDBTableNm$, BYVAL sQueryName$, BYVAL nFormType% )
	dim n%, sNo$, sFldNm$

	for n% = 0 to nCount%-1
		with selection
			sNo$ = trim( str$( n% ))

			sFldNm$ = sDBFieldName + sNo$
			.SetUserFieldValue( sFldNm$, nFieldControlSources( n% ) )

			sFldNm$ = sDBFieldType + sNo$
			.SetUserFieldValue( sFldNm$, nFieldContentTypes( n% ) )

			sFldNm$ = sDBFieldLen + sNo$
			.SetUserFieldValue( sFldNm$, nFieldContentChars( n% ) )
		end with
	next n%

	with selection
		.SetUserFieldValue( sDBFormVersion, cDBFormVersion )
		.SetUserFieldValue( sDBFormType, nFormType% )

		.SetUserFieldValue( sDBDataNumber, 1 )
		.SetUserFieldValue( sDBFieldPos, 0 )
		.SetUserFieldValue( sDBFieldCount, nCount% )

		.SetUserFieldValue( sDBName, sDBNm$ )
		.SetUserFieldValue( sDBTable, sDBTableNm$ )
		.SetUserFieldValue( sDBQuery, sQueryName$ )

	end with

end sub

function CalcForColumns2( BYVAL nCount%, BYVAL nType%, aProgress AS PROGRESS, aControlCollection() as Object, aDoc as Object, aForm as Object )

	' Assertion: the Columns are max 20 cm high and grow in width
	'       Captions can never be wider than 3 cm, Fields no more than 7 cm
	'       The captions always appear at the beginning to start with. (They can
    '   optionally also appear above the fields)

	DIM nXPos, nCaptMax, nContentMax as long
	DIM nCapCount%, nStt%, nEnd%, nFldCount%
	DIM aPoint, aSize, aDPage, aDesc, aShape as Object

	' 1. Determine font sizes for captions and Fields
	CalcFontSizes(aDoc)

	'if 0 <> bCallActionSttEnd then Selection.ActionStart

	' 2. Calculate how many captions of that height fit within the page height
	if  nCaptionFontHeight > nFieldFontHeight  then
		nCapCount% = CINT( cColPageHeight% / nCaptionFontHeight )
	else
		nCapCount% = CINT( cColPageHeight% / nFieldFontHeight )
	end if

	nXPos = cXOffset%        ' vom Rand um 0,5 verschoben

	nStt% = 0
	while nStt% < nCount%

		nEnd% = nStt% + nCapCount%
		if( nEnd% > nCount% ) then nEnd% = nCount%

	if( cCaptionLeft = nType% ) THEN        ' Caption left

			nCaptMax = CalcCaptionWidth( nStt%, nEnd%, 0 )
			if( nCaptMax > cColCaptionMaxWidth% ) then nCaptMax = cColCaptionMaxWidth%

			nContentMax = CalcFieldWidth( nStt%, nEnd%, 1, int( cColColumnWidth% / nFieldFontWidth ))
			if( nCaptMax + nContentMax > cColColumnWidth% ) then

				' The fields take up more than the available space; they have to be compressed
				nContentMax = cColColumnWidth% - nCaptMax
				' then calculate how many fields now fit in the column
			end if

			nFldCount% = GetContentCount( nStt%, nEnd%, nType%, nContentMax, cColPageHeight% )
			call InsertFrmCaptLeft2( nXPos, nStt%, nStt% + nFldCount%, nCaptMax, nContentMax, aProgress, aControlCollection, aDoc , aForm)

	else                        ' Caption above

			nContentMax = CalcFieldWidth( nStt%, nEnd%, 1, int( cColContentMaxWidth% / nFieldFontWidth ) )
			if( nContentMax > cColContentMaxWidth% ) then nContentMax = cColContentMaxWidth%

			nFldCount% = GetContentCount( nStt%, nEnd%, nType%, nContentMax, cColPageHeight% )
			call InsertFrmCaptTop2( nXPos, cYOffset%, nStt%, nStt% + nFldCount%, nContentMax, aProgress, aControlCollection, aDoc , aForm )

		end if

		nStt% = nStt% + nFldCount%
		nXPos = nXPos + nContentMax + nCaptMax + cXOffset% ' zwischen den Spalten 0.5 cm Abstand

	wend

		'if 0 <> bCallActionSttEnd then selection.ActionEnd

end function

function CalcForJustified2( BYVAL nCount%, aProgress AS PROGRESS, aControlCollection() as Object, aDoc as Object, aForm as Object )

	' Assertion: the Columns are max 20 cm high and grow in width
	'       Captions can never be wider than 3 cm, Fields no more than 7 cm
	'       The captions always appear at the beginning to start with. (They can
    '   optionally also appear above the fields)


	DIM nCaptionWidth, nContentWidth, nCalc as long
	DIM nYPos, nXPos, nWidth, nTmpYPos as long
	DIM nStt%, nTmpEnd%,     nHeight%, bBreak%, nFldHeight%, n%

	' 1. Determine font sizes for captions and fields
	call CalcFontSizes(aDoc)

	'if 0 <> bCallActionSttEnd then selection.ActionStart

	' 2. Calculate widths of the fields
	call CalcFieldWidth( 0, nCount%, 1, 0 )
	call CalcCaptionWidth( 0, nCount%, 0 )

    nYPos = cYOffset%    ' offset 0.5 from edge

	nStt% = 0
	while nStt% < nCount%

		nXPos = cXOffset%
		nTmpEnd% = nStt%
		nHeight% = 0
		bBreak% = 0
		while( nTmpEnd% < nCount% AND bBreak% = 0 )

			nFldHeight% = GetControlHeight (nTmpEnd% )
			nFieldContentHeight( nTmpEnd% ) = nFldHeight%

			nFldHeight% = nFldHeight% + nContentFrameBorder

			' calculate the width of the captions and fields
			nCaptionWidth =  nFieldCaptionWidth( nTmpEnd% )
			nContentWidth =  nFieldContentWidth( nTmpEnd% )

			if( nContentWidth < nCaptionWidth ) then nContentWidth = nCaptionWidth

			if( nXPos + nContentWidth > cJustPageWidth% ) then
				' Ende erreicht
				bBreak% = 1
				if( nStt% = nTmpEnd% ) then ' Sonderfall - 1. Feld wird groesser als eine Seite

					' then it has to be compressed
					nXPos = cJustPageWidth%
					nFieldContentWidth( nTmpEnd% ) = cJustPageWidth% - nXPos
					nHeight% = nFldHeight%
					nTmpEnd% = nTmpEnd% + 1
				end if
			else
				' now it comes into the row
				nXPos = nXPos +         nContentWidth
				nFieldContentWidth( nTmpEnd% ) = nContentWidth

				if( nHeight% < nFldHeight% ) then nHeight% = nFldHeight%
				nTmpEnd% = nTmpEnd% + 1
			end if
		wend


		' divide the rest proportionally over all columns
		for n% = nStt% to nTmpEnd

			nCalc =         nFieldContentWidth( n% )
			nCalc = nCalc * ( cJustPageWidth% - cXOffset )
			nCalc = nCalc / ( nXPos - cXOffset )

			nFieldContentWidth( n% ) = nCalc

		next n%

		' then create the frames
		nXPos = cXOffset%
		while nStt% < nTmpEnd%
			nTmpYPos = nYPos
			nContentWidth = nFieldContentWidth( nStt% )
			call InsertFrmCaptTop2( nXPos, nTmpYPos, nStt%, nStt%+1, nContentWidth, aProgress, aControlCollection, aDoc, aForm )
			nXPos = nXPos + nContentWidth
			nStt% = nStt% + 1
		wend

		nYPos = nYPos + nHeight% + nCaptionFontHeight + nCaptionFrameBorder + 112

	wend

	'if 0 <> bCallActionSttEnd then selection.ActionEnd

end function

function CalcForTable( BYVAL nCount%, aProgress AS PROGRESS, aControlCollection() as Object, aDoc as Object, aForm as Object )

	DIM n%, nType%, nWidth%
	Dim aControl as Object
	Dim aColumn as Object
	DIM aPoint as Object
	DIM aSize as Object

  aPoint = createUnoStruct("com.sun.star.awt.Point")
  aSize = createUnoStruct("com.sun.star.awt.Size")

	' 1. Determine font sizes for captions and fields
	call CalcFontSizes(aDoc)
	call CalcFieldWidth( 0, nCount%, 1, 0 )
	call CalcCaptionWidth( 0, nCount%, 0 )

	'if 0 <> bCallActionSttEnd then selection.ActionStart

	aControl = CloneObject(aControlCollection(cGridControl))

	nWidth% = 0
	for n% = 0 to nCount%-1

		nType% = nFieldContentTypes( n% )

		if( cBoolean = nType% ) then
			aColumn = aControl.CreateColumn("CheckBox")
			aColumn.Name = CalcUniqueContentName(aControl, "CheckBox")
		elseif( cFloat = nType% or cInteger = nType% or cLong = nType% or _
			cCounter = nType% or cDecimal = nType% or cShortInt = nType%) then
			aColumn = aControl.CreateColumn("NumericField")
			aColumn.Name = CalcUniqueContentName(aControl, "NumericField")
			if( cInteger = nType% or cLong = nType% or cCounter = nType% or cShortInt = nType% ) then
				aColumn.DecimalAccuracy = 0 ' keine Nachkommastellen
				aColumn.ValueMin = 0 ' Minwerte sind 0
			End If
			select Case (nType)
				case cLong
					aColumn.ValueMax = 2147483647 ' Maxwert
				case cInteger
					aColumn.ValueMax = 32767 ' Maxwert
				case cShortInt
					aColumn.ValueMax = 255 ' Maxwert
				case cDecimal
					aColumn.DecimalAccuracy = FieldDecimalAccuracy%( n%) ' Nachkommastellen
			end Select
		elseif( cCurrency = nType% ) then
			aColumn = aControl.CreateColumn("CurrencyField")
			aColumn.CurrencySymbol = s_aCurrencySymbol
			aColumn.PrependCurrencySymbol = s_aPrependCurrencySymbol
			aColumn.Name = CalcUniqueContentName(aControl, "CurrencyField")
		elseif( cDateField = nType% ) then
			aColumn = aControl.CreateColumn("DateField")
			aColumn.Name = CalcUniqueContentName(aControl, "DateField")
		elseif( cTime = nType% ) then
			aColumn = aControl.CreateColumn("TimeField")
			aColumn.Name = CalcUniqueContentName(aControl, "TimeField")
		else
			aColumn = aControl.CreateColumn("TextField")
			aColumn.Name = CalcUniqueContentName(aControl, "TextField")
		endif

		aColumn.DataField = nFieldControlSources (n%)
		aColumn.Label = nFieldControlSources (n%) + nFieldPostfixes (n%)
		aColumn.Width = 0 	'Spaltenbreite richtet sich nach dem Feldnamen
		aControl.insertByName(aColumn.Name, aColumn)

		aProgress.Value = n%
		nWidth% = nWidth% + aColumn.Width

	next n%
	aPoint.X = TwipTo100telMM(cXOffset%)
	aPoint.Y = TwipTo100telMM(cYOffset%)

	aSize.Width = TwipTo100telMM(cJustPageWidth%-2*cXOffset%)
	aSize.Height = TwipTo100telMM(cJustPageHeight%-2*cYOffset%)

	aForm.InsertByName (aControl.Name, aControl)
	InsertControl (aControl, aDoc, aPoint, aSize)
end function

sub CalcFontSizes(aDoc as object)

	Dim aPoint, aSize as object
	Dim aModel, aShape, aControl, aPeer as Object
	Dim aControlFont as object
	Dim nWidth as Integer

	' temporary insert a sample label
  aPoint = createUnoStruct("com.sun.star.awt.Point")
  aSize = createUnoStruct("com.sun.star.awt.Size")
	aPoint.X = 0
	aPoint.Y = 0
	aSize.Width = 10000
	aSize.Height = 1000

  aModel = createUnoService("com.sun.star.form.component.FixedText")
	aShape = InsertControl(aModel, aDoc, aPoint, aSize)

	' get the font of the label control
	aControl = aDoc.CurrentController.getControl(aModel)
	aPeer = aControl.getPeer()
	aControlFont = aPeer.getFont(aModel.FontDescriptor)

	' calculate the average width of a single character
	nWidth = aControlFont.getStringWidth("SaMpLe tExT")
	nWidth = nWidth / 11

	' now calculate the sizes in twips. unfortunally the factor between twips and pixel is device-dependent, but
	' UNO gives no access to any converting functions. So we have to estimate : We assume 1 pixel equals 15 twips.
	' In addition, we slightly enlarge the result. A control which is to large isn't as bad as a control which's text
	' doesn't fit.

	' borders : assume 3 pixel at each edge
	nCaptionFrameBorder = (3 + 3) * 15
	nCaptionFontWidth = (nWidth + 1) * 15 * 1.1		' +1 & *1.1 are our heuristic enlargement
	nCaptionFontHeight = aControlFont.getFontDescriptor().Height * 15 * 1.4	' + 60%
		' here the inaccuracy is event worse : the height isn't necessarily given in pixels ....

	' assume the same for non-label controls
	nContentFrameBorder = nCaptionFrameBorder
	nFieldFontWidth = nCaptionFontWidth
	nFieldFontHeight = nCaptionFontHeight

	' and remove the temporary shape
	aDoc.DrawPage.Remove(aShape)

end sub

sub InsertFrmCaptLeft2( BYVAL nXPos as long, BYVAL nStt%, nEnd%, _
						BYVAL nCapWidth as long, BYVAL nContentMax as long, _
						aProgress AS PROGRESS, aControlCollection() as Object, _
						aDoc as Object, aForm as Object  )

	DIM nYPos, nHeight, nFldWidth, nWidth, nFrmBorder as long
	DIM n%, nType%, sNo$
	DIM aShape as Object, aShapes as Object
	DIM aPoint as Object
	DIM aSize as Object
	DIM aControl as Object, aTextControl as Object

  aPoint = createUnoStruct("com.sun.star.awt.Point")
  aSize = createUnoStruct("com.sun.star.awt.Size")

	if( nCaptionFrameBorder < nContentFrameBorder ) then
		nFrmBorder = nContentFrameBorder
	else
		nFrmBorder = nCaptionFrameBorder
	endif

	nYPos = cYOffset%
	for n% = nStt% to nEnd% - 1

      aShapes = createUnoService("com.sun.star.drawing.ShapeCollection")
			sNo$ = trim$(str$( n% ))
			nHeight = nFieldContentHeight( n% ) + nFrmBorder

			nFldWidth = nFieldContentWidth( n% )
			if( nFldWidth > nContentMax ) then
				nFldWidth = nContentMax
			endif
			nWidth = nCapWidth + nFldWidth

			nType% = nFieldContentTypes( n% )

			if( cBoolean = nType% ) then
				aControl = CloneObject(aControlCollection(cCheckBox))
				aControl.Name ="CheckBox"+(n%+1)
			elseif (cFloat = nType or cInteger = nType or cLong = nType or _
					cCounter = nType or cDecimal = nType or cShortInt = nType) then
				aControl = CloneObject(aControlCollection(cNumericBox))
				aControl.Name ="NumericField"+(n%+1)
				if( cInteger = nType or cLong = nType or cCounter = nType or cShortInt = nType ) then
					aControl.DecimalAccuracy = 0 ' keine Nachkommastellen
					aControl.ValueMin = 0 ' Minwerte sind 0
					select Case (nType)
						case cLong
							aControl.ValueMax = 2147483647 ' Maxwert
						case cInteger
							aControl.ValueMax = 32767 ' Maxwert
						case cShortInt
							aControl.ValueMax = 255 ' Maxwert
					end Select
				End If
				if( cDecimal = nType% ) then
					aControl.DecimalAccuracy = FieldDecimalAccuracy%( n%) ' Nachkommastellen
				End If
			elseif( cCurrency = nType% ) then
				aControl = CloneObject(aControlCollection(cCurrencyBox))
				aControl.CurrencySymbol = s_aCurrencySymbol
				aControl.PrependCurrencySymbol = s_aPrependCurrencySymbol
				aControl.Name ="CurrencyField"+(n%+1)
			elseif( cDateField = nType% ) then
				aControl = CloneObject(aControlCollection(cDateBox))
				aControl.Name ="DateField"+(n%+1)
			elseif( cTime = nType% ) then
				aControl = CloneObject(aControlCollection(cTimeBox))
				aControl.Name ="TimeField"+(n%+1)
			elseif( cImage = nType% ) then
				aControl = CloneObject(aControlCollection(cImageControl))
				aControl.Name ="ImageControl"+(n%+1)
			elseif( cMemo = nType% ) then
				aControl = CloneObject(aControlCollection(cTextBox))
				aControl.Name ="TextField"+(n%+1)
				aControl.MultiLine = True
			else
				aControl = CloneObject(aControlCollection(cTextBox))
				aControl.Name ="TextField"+(n%+1)
				if GetRasterHeight( nFieldContentChars( n%) ) >1 then
					aControl.MultiLine = True
				endif
			endif

			aPoint.X = TwipTo100telMM(nXPos+nCapWidth)
			aPoint.Y = TwipTo100telMM(nYPos)

			aSize.Width = TwipTo100telMM(nFldWidth)
			aSize.Height = TwipTo100telMM(nHeight)

			aControl.DataField = nFieldControlSources (n%)
			aForm.InsertByName (aControl.Name, aControl)
			aShape = InsertControl (aControl, aDoc, aPoint, aSize)
			aShapes.Add(aShape)

			aPoint.X = TwipTo100telMM(nXPos)
			aPoint.Y = TwipTo100telMM(nYPos)

			aSize.Width = TwipTo100telMM(nCapWidth)
			aSize.Height = TwipTo100telMM(nHeight)

			aTextControl = CloneObject(aControlCollection(cLabel))
			aTextControl.Name ="Label"+(n%+1)
			aTextControl.Label = nFieldControlSources (n%) + nFieldPostfixes (n%)
			aForm.InsertByName (aTextControl.Name, aTextControl)
			aShape = InsertControl (aTextControl, aDoc, aPoint, aSize)
			aShapes.Add(aShape)

			aDoc.DrawPage.Group (aShapes)

			' announce the label to the data control
			aControl.LabelControl = aTextControl

			aProgress.Value = n%

			nYPos = nYPos + nHeight + 112

	next n%

end sub

sub InsertFrmCaptTop2( BYVAL nXPos as long, BYVAL nYPos as long, _
					BYVAL nStt%, BYVAL nEnd%, BYVAL nContentMax as long, _
					aProgress AS PROGRESS, aControlCollection() as Object, _
					aDoc as Object, aForm as Object )

	DIM nTmpYPos, nHeight, nFldWidth, nWidth as long
	DIM n%, nType%, sNo$
	DIM aShapes as Object, aShape as Object
	DIM aTextControl as Object
	DIM aControl as Object
	DIM aPoint as Object
	DIM aSize as Object

  aPoint = createUnoStruct("com.sun.star.awt.Point")
  aSize = createUnoStruct("com.sun.star.awt.Size")

	nTmpYPos = nYPos

	for n% = nStt% to nEnd% - 1

      aShapes = createUnoService("com.sun.star.drawing.ShapeCollection")
			sNo$ = trim$(str$( n% ))

			nHeight = nCaptionFontHeight + nCaptionFrameBorder + nFieldContentHeight( n% ) + nContentFrameBorder
			nWidth = nFieldContentWidth( n% )
			if( nWidth > nContentMax ) then
				nWidth = nContentMax
			endif

			nType% = nFieldContentTypes( n% )

			if( cBoolean = nType% ) then
				aControl = CloneObject(aControlCollection(cCheckBox))
				aControl.Name ="CheckBox"+(n%+1)
			elseif( cFloat = nType or cInteger = nType or cLong = nType or _
						cCounter = nType or cDecimal = nType or cShortInt = nType) then
				aControl = CloneObject(aControlCollection(cNumericBox))
				aControl.Name ="NumericField"+(n%+1)
				if( cInteger = nType or cLong = nType or cCounter = nType or cShortInt = nType ) then
					aControl.DecimalAccuracy = 0 ' keine Nachkommastellen
					aControl.ValueMin = 0 ' Minwerte sind 0
					select Case (nType)
						case cLong
							aControl.ValueMax = 2147483647 ' Maxwert
						case cInteger
							aControl.ValueMax = 32767 ' Maxwert
						case cShortInt
							aControl.ValueMax = 255 ' Maxwert
					end Select
				End If
				if( cDecimal = nType% ) then
					aControl.DecimalAccuracy = FieldDecimalAccuracy%( n%) ' Nachkommastellen
				End If
			elseif( cCurrency = nType% ) then
				aControl = CloneObject(aControlCollection(cCurrencyBox))
				aControl.CurrencySymbol = s_aCurrencySymbol
				aControl.PrependCurrencySymbol = s_aPrependCurrencySymbol
				aControl.Name ="CurrencyField"+(n%+1)
			elseif( cDateField = nType% ) then
				aControl = CloneObject(aControlCollection(cDateBox))
				aControl.Name ="DateField"+(n%+1)
			elseif( cTime = nType% ) then
				aControl = CloneObject(aControlCollection(cTimeBox))
				aControl.Name ="TimeField"+(n%+1)
			elseif( cImage = nType% ) then
				aControl = CloneObject(aControlCollection(cImageControl))
				aControl.Name ="ImageControl"+(n%+1)
			elseif( cMemo = nType% ) then
				aControl = CloneObject(aControlCollection(cTextBox))
				aControl.Name ="TextField"+(n%+1)
				aControl.MultiLine = True
			else
				aControl = CloneObject(aControlCollection(cTextBox))
				aControl.Name ="TextField"+(n%+1)
				if GetRasterHeight( nFieldContentChars( n%) ) >1 then
					aControl.MultiLine = True
				endif
			endif

			aPoint.X = TwipTo100telMM(nXPos)
			aPoint.Y = TwipTo100telMM(nTmpYPos+nCaptionFontHeight + nCaptionFrameBorder)

			aSize.Width = TwipTo100telMM(nWidth)
			aSize.Height = TwipTo100telMM(nFieldContentHeight( n% ) + nContentFrameBorder)

			aControl.DataField = nFieldControlSources (n%)
			aForm.InsertByName (aControl.Name, aControl)
			aShape = InsertControl (aControl, aDoc, aPoint, aSize)
			aShapes.Add(aShape)

			aPoint.X = TwipTo100telMM(nXPos)
			aPoint.Y = TwipTo100telMM(nTmpYPos)

			aSize.Width = TwipTo100telMM(nWidth)
			aSize.Height = TwipTo100telMM(nCaptionFontHeight + nCaptionFrameBorder)

			aTextControl = CloneObject(aControlCollection(cLabel))
			aTextControl.Name ="Label"+(n%+1)
			aTextControl.Label = nFieldControlSources (n%) + nFieldPostfixes (n%)
			aForm.InsertByName (aTextControl.Name, aTextControl)
			aShape = InsertControl (aTextControl, aDoc, aPoint, aSize)
			aShapes.Add(aShape)

			aDoc.DrawPage.Group (aShapes)

			' announce the label to the data control
			aControl.LabelControl = aTextControl

			aProgress.Value = n%

			nTmpYPos = nTmpYPos + nHeight + 112

	next n%

end sub

function GetRasterWidth( BYVAL nChars% ) as integer
	select case nChars%
	case is <= 5
		GetRasterWidth = 5
	case is <= 15
		GetRasterWidth = 10
	case is <= 25
		GetRasterWidth = 15
	case else
		GetRasterWidth = 20
	end select
end function

function GetRasterHeight( BYVAL nChars% ) as integer
	GetRasterHeight = 1 ' auf 1 begrenzt
	exit function

	select case nChars%
	case is <= 60
		GetRasterHeight = 1
	case else
		GetRasterHeight = 2
	end select
end function

function CalcFieldWidth( BYVAL nStt%, BYVAL nEnd%, BYVAL bRaster%, BYVAL nMaxChars% ) as long
	DIM nMaxWidth, nCalc as long
	DIM n%, nChar%

	nMaxWidth = 0
	for n% = nStt% to nEnd% - 1
		nChar% = nFieldContentChars( n% )

		' pass Raster for the field widths
		if( 0 <> bRaster% ) THEN

'                       if( 0 = nMaxChars% OR nChar% > nMaxChars% ) then
				if( cText = nFieldContentTypes (n%) OR cMemo = nFieldContentTypes (n%)_
				 	OR cImage = nFieldContentTypes (n%)) then
					nChar% = GetRasterWidth( nChar% )
				else
				if( cFloat = nFieldContentTypes (n%) ) then
					nChar% = 14
				endif
				endif
'                       end if
		end if

		nCalc = nChar% * nFieldFontWidth

		nFieldContentWidth( n% ) = nCalc
		if( nCalc > nMaxWidth ) then nMaxWidth = nCalc
	next n%
	CalcFieldWidth = nMaxWidth
end function


function CalcCaptionWidth( BYVAL nStt%, BYVAL nEnd%, BYVAL bRaster% ) as long
	DIM nMaxWidth, nCalc as long
	DIM n%, nChar%

	nMaxWidth = 0
	for n% = nStt% to nEnd% - 1

		nChar% = LEN( nFieldControlSources( n% ) + nFieldPostfixes (n%))

		' pass Raster for the field widths
		if( 0 <> bRaster% ) then
			nChar% = GetRasterWidth( nChar% )
		end if

		nCalc = nChar% * nCaptionFontWidth

		nFieldCaptionWidth( n% ) = nCalc
		if( nCalc > nMaxWidth ) then nMaxWidth = nCalc
	next n%
	CalcCaptionWidth = nMaxWidth
end function


function GetContentCount( BYVAL nStt%, BYVAL nCapCount%, BYVAL nType%, BYVAL nContentMax as long, BYVAL nPageHeight as long )

	DIM nCurrHeight as long
	DIM n%, nCount%, nHeight%

	nCount% = nCapCount%
	nCurrHeight = cYOffset%

	for n% = nStt% to nCapCount% -1
		nHeight% = GetControlHeight (n%)

		nFieldContentHeight ( n% ) = nHeight%

		nHeight% = nHeight% + nContentFrameBorder
		if( cCaptionTop = nType% ) then
			nHeight% = nHeight% + nCaptionFontHeight + nCaptionFrameBorder
		end if

		nCurrHeight = nCurrHeight + nHeight% + 112
		if( nCurrHeight > nPageHeight ) then
			nCount% = n%
			n% = nCapCount%
		end if
	next n%
	GetContentCount = nCount% - nStt%
end function

Function GetControlHeight ( BYVAL nTmpCount% ) as long
	if  (cMemo = nFieldContentTypes( nTmpCount% )) then
		GetControlHeight = nFieldFontHeight * 2
	else
	if  (cImage = nFieldContentTypes( nTmpCount% )) then
		GetControlHeight = nFieldFontHeight * 8
	else
		GetControlHeight = nFieldFontHeight * GetRasterHeight( nFieldContentChars( nTmpCount% ))
	end if
	end if
end function

Function TwipToCM( BYVAL nValue as long ) as String
	TwipToCM = trim(str( nValue / 567 )) + "cm"
end function

Function TwipTo100telMM( BYVAL nValue as long ) as long
	 TwipTo100telMM = nValue / 0.567
end function

Function TwipToPixel( BYVAL nValue as long ) as long ' nur ungefaehre Berechnung
	TwipToPixel = nValue / 15
end function

Sub SetLayoutEventHandles( BYVAL bOn% )
	const sLib = "StarOffice"
	DIM sStyle$, sHdl$

	if( bOn% ) then

		sHdl$ = "dbhandler.dbFormEdit.Form_DeSelectFrameSel"
		ActiveDocument.SetFramestyleMacro( "FieldContent", 4, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldCaption", 4, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldInputRequired", 4, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldReadOnly", 4, sHdl$, sLib )

		sHdl$ = "dbhandler.dbFormEdit.Form_ResizeHdl"
		ActiveDocument.SetFramestyleMacro( "FieldContent", 7, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldCaption", 7, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldInputRequired", 7, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldReadOnly", 7, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldFrame", 7, sHdl$, sLib )

		sHdl$ = "dbhandler.dbFormEdit.Form_MoveHdl"
		ActiveDocument.SetFramestyleMacro( "FieldContent", 8, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldCaption", 8, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldInputRequired", 8, sHdl$, sLib )
		ActiveDocument.SetFramestyleMacro( "FieldReadOnly", 8, sHdl$, sLib )

		sHdl$ = "dbhandler.dbhandler.Form_KeyInput_NoA"
		ActiveDocument.SetFramestyleMacro( "FieldFrame", 6, sHdl$, sLib )

	else
		ActiveDocument.SetFramestyleMacro( "FieldContent", 4, "" )
		ActiveDocument.SetFramestyleMacro( "FieldCaption", 4, "" )
	endif
End Sub


