'SBLLINK:MethodInfo=ChangeAllChars0
'SBLLINK:MethodInfo=ReplaceStrings0
'SBLLINK:MethodInfo=SetLanguage0
'SBLLINK:MethodInfo=ReplaceAllStrings0
' This macro replaces all characters in a writer-documet through "x" or "X" signs.
' It works on the currently activated document.
Private const UPPERREPLACECHAR = "X"
Private const LOWERREPLACECHAR = "x"

Private MSGBOXTITLE
Private NOTSAVEDTEXT
Private WARNING

Sub ChangeAllChars   ' Change all chars in the active document
Dim oSheets, oPages as Object
Dim i as Integer
Const MBYES = 6
Const MBABORT = 2
Const MBNO = 7
'	Application.LoadLibrary("tools")
	Call SetLanguage

	On Local Error GoTo NODOCUMENT
	oDocument = StarDesktop.ActiveFrame.Controller.Model
	NODOCUMENT:
	If Err <> 0 Then
		Msgbox("This Macro extracts all Data of a displayed Writer-Document." & chr(13) & "Activate a Writer-Document!" , 16, "StarOffice 5.2")
		Exit Sub
	End If
	On Local Error Goto 0
	
	sDocType = GetDocumentType(oDocument)

	If oDocument.IsModified And oDocument.Url <> "" Then
		Status = MsgBox(NOTSAVEDTEXT, 3+32, MSGBOXTITLE)
		Select Case Status
			Case MBYES  
				oDocument.Store
			Case MBABORT, MBNO
				End
		End Select
	Else
		Status = MsgBox(WARNING, 3+32, MSGBOXTITLE)
		If Status = MBNO Or Status = MBABORT Then  ' No, Abort
			End
		End If
	End If

	Select Case sDocType
		Case "sWriter"
			ReplaceAllStrings(oDocument)	

		Case Else
			Msgbox("This Macro only works with Writer-Documents!", 16, "StarOffice 5.2") 
	End Select
End Sub


Sub ReplaceAllStrings(oContainer as Object)	
	ReplaceStrings(oContainer, "[a-z]", LOWERREPLACECHAR)
	ReplaceStrings(oContainer, "[-]", LOWERREPLACECHAR)
	ReplaceStrings(oContainer, "[A-Z]", UPPERREPLACECHAR)
	ReplaceStrings(oContainer, "[-]", UPPERREPLACECHAR)
	ReplaceStrings(oContainer, "[0-9]", UPPERREPLACECHAR)
End Sub


Sub ReplaceStrings(oContainer as Object, sSearchString, sReplaceString  as String)
	oReplaceDesc = oContainer.createReplaceDescriptor()
	oReplaceDesc.SearchCaseSensitive = True
	oReplaceDesc.SearchRegularExpression = True
	oReplaceDesc.Searchstring = sSearchString
	oReplaceDesc.ReplaceString = sReplaceString
	oReplCount = oContainer.ReplaceAll(oReplaceDesc)	
End Sub


Sub SetLanguage
Dim ISOLanguage as String
	ISOLanguage = StarDesktop.ISOLocale.Language

	Select Case ISOLanguage

		Case "en"
			MSGBOXTITLE = "Change all characters to a '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "This Document is modified: All characters are changed to an " & UPPERREPLACECHAR & "'. Shall the document be saved now?"
			WARNING = "This macro changes all characters and numbers to an '" & UPPERREPLACECHAR & "' in this document."

		Case "fr"
			MSGBOXTITLE = "Remplacer tous les caractres par '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Le document a t modif, la macro remplacera tous les caractres par '" & UPPERREPLACECHAR & "'. Enregistrer avant de procder?"
			WARNING = "La macro remplacera tous les caractres et nombres par '" & UPPERREPLACECHAR & "' dans le document." 

		Case "it"
			MSGBOXTITLE = "Sostituire tutti i caratteri '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Il documento  stato modificato, la macro sostituer tutti i caratteri con '" & UPPERREPLACECHAR & "'. Salvare il documento prima di procedere?"
			WARNING = "La macro sostituir tutti i caratteri e numeri con  '" & UPPERREPLACECHAR & "' nel documento attivo." 	

		Case "es"
			MSGBOXTITLE = "Sustituir todos los caracteres por '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Este documento fue cambiado: todos los caracteres fueron sustituidos por " & UPPERREPLACECHAR & "'. Desea guardar el documento?"
			WARNING = "Esta macro sustitue todos los caracteres y nmeros en este documento por '" & UPPERREPLACECHAR & "'."

		Case "pt"
			MSGBOXTITLE = "Substituir todos os caracteres por '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Este documento foi modificado: todos os caracteres foram substitudos por " & UPPERREPLACECHAR & "'. Deseja guardar o documento?"
			WARNING = "Esta macro substitui todos os caracteres e nmeros neste documento por '" & UPPERREPLACECHAR & "'."

		Case "nl"
			MSGBOXTITLE = "Verander alle tekens in een'" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Dit document is veranderd. Alle tekens zijn veranderd in een " & UPPERREPLACECHAR & "'. Wilt u het document nu opslaan?"
			WARNING = "Dit macro verandert alle tekens en cijfers in een '" & UPPERREPLACECHAR & "' in dit document."

		Case "sv"
			MSGBOXTITLE = "Byt ut alla bokstver mot en '" & UPPERREPLACECHAR & "' "
			NOTSAVEDTEXT = "Dokumentet har ndrats, med detta makro kommer alla bokstver att bytas ut mot en '" & UPPERREPLACECHAR & "' . Ska dokumentet skras/sparas innan?"
			WARNING = "Makrot erstter alla bokstver och tal i detta dokument med en '" & UPPERREPLACECHAR & "'."

'		Case "da"

'		Case "pl"

'		Case "ru"

		' English & fallback/default
		Case Else
			MSGBOXTITLE = "Change all characters to a '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "This Document is modified: All characters are changed to an " & UPPERREPLACECHAR & "'. Shall the document be saved now?"
			WARNING = "This macro changes all characters and numbers to an '" & UPPERREPLACECHAR & "' in this document."
	End Select
End Sub
