'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=MainWithDefault0
'SBLLINK:MethodInfo=InitDbEngine0
'SBLLINK:MethodInfo=FillDatabases0
'SBLLINK:MethodInfo=OpenDBConnection0
'SBLLINK:MethodInfo=CloseDbConnection0
'SBLLINK:MethodInfo=CreateGrid0
'SBLLINK:MethodInfo=GridNewTableSelected0
'SBLLINK:MethodInfo=GridNewDatabaseSelected0
'SBLLINK:MethodInfo=GridGetTables0
'SBLLINK:MethodInfo=GridCheckButtons0
'SBLLINK:MethodInfo=GridGetFields0
'SBLLINK:MethodInfo=FormcmdCancel0
'SBLLINK:MethodInfo=FormPrevClicked0
'SBLLINK:MethodInfo=FormNextOrReadyClicked0
'SBLLINK:MethodInfo=GridSetTitle0
'SBLLINK:MethodInfo=FormSetMoveRights0
'SBLLINK:MethodInfo=FormMoveSelected0
'SBLLINK:MethodInfo=FormMoveAll0
'SBLLINK:MethodInfo=FormRemoveSelected0
'SBLLINK:MethodInfo=FormRemoveAll0
'SBLLINK:MethodInfo=FormPreview1Repaint0
'SBLLINK:MethodInfo=CreateClicked0
'SBLLINK:MethodInfo=CalcForTable0

Option Explicit

Global GridActiveTableName$, GridPath, GridDBName$, GridReturnValue$
Global TemplatePath$

Global GridAvailTables As New Strings
Global GridOriginalFieldList As New Strings
Global GridInstalledQueries As New Strings
Global GridControl As Object
Global IsControl As Boolean
Global aParentForm as Object

Dim aDbEngine, aDbWorkspace as Object
Dim aCurrentDb as Object
Dim aCurrentFields as Object
Dim aSourceType as integer
Dim bNeedFieldRefresh as Boolean

const ST_TABLE		= 0
const ST_QUERY		= 1
const ST_STATEMENT	= 2

Global Const  DatabaseFieldType_BOOL			= -7
Global Const  DatabaseFieldType_TINYINT			= -6
Global Const  DatabaseFieldType_SMALLINT		= 5
Global Const  DatabaseFieldType_INTEGER			= 4
Global Const  DatabaseFieldType_BIGINT			= -5
Global Const  DatabaseFieldType_REAL			= 7
Global Const  DatabaseFieldType_DOUBLE			= 8
Global Const  DatabaseFieldType_NUMERIC			= 2
Global Const  DatabaseFieldType_DECIMAL			= 3
Global Const  DatabaseFieldType_CURRENCY		= 2222
Global Const  DatabaseFieldType_CHAR			= 1
Global Const  DatabaseFieldType_VARCHAR			= 12
Global Const  DatabaseFieldType_LONGVARCHAR		= -1
Global Const  DatabaseFieldType_DATE			= 91
Global Const  DatabaseFieldType_TIME			= 92
Global Const  DatabaseFieldType_DATETIME		= 93
Global Const  DatabaseFieldType_BINARY			= -2
Global Const  DatabaseFieldType_VARBINARY		= -3
Global Const  DatabaseFieldType_LONGVARBINARY	= -4
Global Const  DatabaseFieldType_OTHER			= 1111

' -----------------------------------------------------------------------------
Sub Main()
	MainWithDefault ( Application, False )
End Sub

' -----------------------------------------------------------------------------
Sub MainWithDefault( ByVal aControl as Object, ByVal bActive as Boolean )

on error goto GloablError

	If (Not InitResources()) Then
		Exit Sub
	End If

	Dim sResult$, sTitle$, sFileName$, sShow$, sTmp$
	Dim nPos%
	
	GridControl = aControl
	IsControl = bActive

	TemplatePath$ = Application.PathSettings.Template
	If InStr (TemplatePath$, ";")<>0 Then
		TemplatePath$ = Left$(TemplatePath$, InStr(TemplatePath$, ";")-1)       ' Non-Unix
	End If
	
	GridPath = TemplatePath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	Application.EnterWait()

	' init language
	LoadLanguage( Application.LanguageID )

	' Load dialog and string tools
	Application.LoadLibrary( "Tools" )
	InitDlgTools()

	' init Db engine
	If Not InitDbEngine() Then
		Application.LeaveWait()
		Exit Sub
	End If

	' do fill the grid ...
	sResult$ = CreateGrid ( aControl, bActive )
	CloseDBConnection()

EndOfSub:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend
	Exit Sub

GloablError:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend
	MsgBox(Grid_gErrMsg$, 16, Grid_gWizardName$)
End Sub

' -----------------------------------------------------------------------------
Function InitDbEngine as Boolean
On Local Error Goto CouldNotInit
	aDbEngine = CreateUnoService("com.sun.star.data.DatabaseEngine")
	aDbWorkspace = aDbEngine.Workspaces( 0 )

	InitDbEngine = TRUE
	Exit Function

CouldNotInit:
	MsgBox Grid_gErrNoEngine$
	InitDbEngine = FALSE
End Function

' -----------------------------------------------------------------------------
Sub FillDatabases
	DlgGridDB.cmbAvailDatabase.Clear()

	Dim i%
	Dim aFavorites
	aFavorites = aDbEngine.getFavorites
	For i% = lbound(aFavorites) to ubound(aFavorites)
		DlgGridDB.cmbAvailDatabase.AddItem(aFavorites(i%).Name)
	Next i%
End Sub

' -----------------------------------------------------------------------------
Function OpenDBConnection(sName as String) as Boolean
	Application.EnterWait()

	' reset the table based stuff
	Dim aEmptyObject as Object
	aCurrentFields = aEmptyObject

On Local Error goto could_not_open
	CloseDbConnection()	' just in case

	aCurrentDb = aDBWorkspace.open(sName)
	UNO_GetAllInstalledNamesInDatabase(aCurrentDb, GridAvailTables, INC_TABLES)

	OpenDBConnection = TRUE
	goto exit_function

could_not_open:
	CloseDbConnection()
	GridAvailTables.Clear()
	OpenDBConnection = FALSE

exit_function:
	Application.LeaveWait()
End Function

' -----------------------------------------------------------------------------
Sub CloseDbConnection()
	Dim aEmptyObject as Object
	aCurrentFields = aEmptyObject
	aCurrentDb = aEmptyObject
End Sub

' -----------------------------------------------------------------------------
Function getFormDatasourceName(aForm as Object) as String
	Dim sReturn as String
On Local Error Goto _outta_here_
	sReturn = aForm.DataSourceName

	If (sReturn = "") Then
		Dim aConnection as Object
		aConnection = aForm.ActiveConnection
		If (IsNull(aConnection)) Then
			Dim aSearch as Object
			aSearch = aForm
			While (Not IsNull(aSearch)) And (Not hasUnoInterfaces(aSearch, "com.sun.star.sdbc.XConnection"))
				aSearch = aSearch.Parent
			Wend
		End If
		If (Not IsNull(aSearch)) Then
			sReturn = aSearch.Parent.URL
		End If
	End If
_outta_here_:
	getFormDatasourceName = sReturn
End Function

' -----------------------------------------------------------------------------
Function CreateGrid(ByVal aControl as Object, ByVal bActive as Boolean)
on error goto ErrorOccured

	Dim nCount%
	DIM bIsTable as boolean

	'       Initialize Global Variables
	bIsTable = False
	GridActiveTableName$ = ""
	GridReturnValue$ = ""
	GridDBName$ = ""
	GridActiveTableName$ = ""
	bNeedFieldRefresh = True

	DlgGridDB.Load()

	DlgGridDB.cmdPrev.Enabled = False
	DlgGridDB.CurrentStep = 1

	If (bActive = True) Then
		aParentForm = aControl.Parent
		GridDBName$ = getFormDatasourceName(aParentForm)
		If (not (aParentForm.Command = "")) Then
			GridActiveTableName$ = aParentForm.Command
			aSourceType = aParentForm.CommandType
			bIsTable = True
		End If
	End If	

	If (bIsTable = False) Then
		DlgGridDB.CurrentStep = 1
		If (GridDBName$ = "") Then
			DlgGridDB.cmbAvailDatabase.Visible = True
			DlgGridDB.frameDatabase.Visible = True
			DlgGridDB.cmbAvailDatabase.Top = 480
			DlgGridDB.frameDatabase.Top = 180
			DlgGridDB.frameTables.Top = DlgGridDB.frameTables.Top + DlgGridDB.frameDatabase.Height + 90
			DlgGridDB.frameTables.Height = DlgGridDB.frameTables.Height - DlgGridDB.frameDatabase.Height - 90
			DlgGridDB.lbTables.Top = DlgGridDB.lbTables.Top + DlgGridDB.frameDatabase.Height + 90
			DlgGridDB.lbTables.Height = DlgGridDB.lbTables.Height - DlgGridDB.frameDatabase.Height - 90
	
			FillDatabases()

			while IsNull(aCurrentDb) And (DlgGridDB.cmbAvailDatabase.ListCount() > 0)
				DlgGridDB.cmbAvailDatabase.ListIndex = 0
				GridDBName$ = DlgGridDB.cmbAvailDatabase.List(DlgGridDB.cmbAvailDatabase.ListIndex())
				OpenDBConnection(GridDBName$)
				If IsNull(aCurrentDb) Then
					' remove the (invalid) first entry and try again
					DlgGridDB.cmbAvailDatabase.RemoveItem(0)
					GridDBName$ = ""
				End If
			Wend
			If (0 = DlgGridDB.cmbAvailDatabase.ListCount()) Then
				MsgBox(Grid_gErrNoDatabase$, 64, Grid_gWizardName$)
				while( Application.IsWait() )
					Application.LeaveWait()
				wend
				Exit Function
			Else
			End If
		Else
			DlgGridDB.cmbAvailDatabase.Visible = False
			DlgGridDB.frameDatabase.Visible = False
		End If

		GridSetTitle()

		OpenDBConnection(GridDBName$)
		GridGetTables()
	else
		' the grid's data source is already set - move to the next step
		DlgGridDB.CurrentStep = 2	
		DlgGridDB.cmdNextOrReady.Visible = False
		DlgGridDB.cmdReady.Enabled = (DlgGridDB.lbSelected.ListCount()>=1)
		DlgGridDB.cmdCancel.Top = DlgGridDB.cmdPrev.Top
		DlgGridDB.cmdCancel.Left = DlgGridDB.cmdNextOrReady.Left
		DlgGridDB.cmdPrev.Visible = False

		GridSetTitle()

		OpenDBConnection(GridDBName$)
		GridGetFields(GridActiveTableName$)
	End If

	GridCheckButtons()

	while( Application.IsWait() )
		Application.LeaveWait()
	wend

	DlgGridDB.Show()
	CreateGrid = GridReturnValue$
	Exit Function

ErrorOccured:
	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	MsgBox(Grid_gErrMsg$, 16, Grid_gWizardName$)
	CreateGrid = ""
	DlgGridDB.UnLoad()
	Reset
	Stop
End Function

' -----------------------------------------------------------------------------
Sub GridNewTableSelected
	bNeedFieldRefresh = True
	DlgGridDB.cmdReady.Enabled = False
End Sub

' -----------------------------------------------------------------------------
Sub GridNewDatabaseSelected()
	Application.EnterWait()
	On Local Error Goto leave_wait

	GridDBName$ = DlgGridDB.cmbAvailDatabase.List(DlgGridDB.cmbAvailDatabase.ListIndex())

	DlgGridDB.lbTables.Enabled = False
	DlgGridDB.cmbAvailDatabase.Enabled = False
	DlgGridDB.cmdNextOrReady.Enabled = False
	DlgGridDB.cmdCancel.Enabled = False

	' open the newly selected db
	CloseDbConnection()
	OpenDBConnection(GridDBName$)

	' fill in it's tables (and queries)
	GridGetTables()

	DlgGridDB.lbTables.Enabled = True
	DlgGridDB.cmbAvailDatabase.Enabled = True
	DlgGridDB.cmdNextOrReady.Enabled = True
	DlgGridDB.cmdCancel.Enabled = True

leave_wait:
	DlgGridDB.cmdReady.Enabled = False
	bNeedFieldRefresh = True
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub GridGetTables()
	Dim tablename$,i%
	Dim DBNames as Variant
	
	DlgGridDB.lbTables.Clear()
	
	' first the queries
	DBNames = aCurrentDb.Queries.ElementNames
	if UBound (DBNames)>=0 then
		For i% = 0 To UBound (DBNames)
			DlgGridDB.lbTables.AddItem ( DBNames(i%) )
			GridInstalledQueries.Add ( DBNames(i%) )
		Next
	End if
	
	' next the tables
	DBNames = aCurrentDb.Tables.ElementNames
	if UBound (DBNames)>=0 then
		For i%=0 To UBound (DBNames)
			DlgGridDB.lbTables.AddItem(DBNames(i%))
		Next
	End If
	
	If (DlgGridDB.lbTables.ListCount>=1) Then
		DlgGridDB.lbTables.Selected(0)=True
		DlgGridDB.cmdNextOrReady.Enabled = True
	Else
		MsgBox(Grid_gErrNoTableInDatabase$, 16, Grid_gWizardName$ )
		DlgGridDB.cmdNextOrReady.Enabled = False
	End If	
End Sub

' -----------------------------------------------------------------------------
Sub GridCheckButtons()
	DlgGridDB.cmdNextOrReady.Enabled = (DlgGridDB.CurrentStep < 2) And ((DlgGridDB.CurrentStep<>1) Or (DlgGridDB.lbTables.ListIndex()>=0))

	DlgGridDB.cmdPrev.Enabled = (DlgGridDB.CurrentStep > 1)
	DlgGridDB.cmdCancel.Enabled = True
	DlgGridDB.cmdReady.Enabled = (DlgGridDB.lbSelected.ListCount()>=1)
End Sub

' -----------------------------------------------------------------------------
Sub GridGetFields(sObjectName as String)
	If (not bNeedFieldRefresh) Then Exit Sub

On Local Error Goto could_not_open_fields
	Dim i%
	Dim sCurrentFieldName$

	Dim aFieldNames as Variant
	Dim aFieldsIterator, aCurrentField as Object

	' disable some ui elements
	DlgGridDB.cmdNextOrReady.Enabled = False
	DlgGridDB.cmdCancel.Enabled = False
	DlgGridDB.cmdPrev.Enabled = False
	DlgGridDB.cmdReady.Enabled = False
	DlgGridDB.cmdMoveSelected.Enabled = False
	DlgGridDB.cmdMoveAll.Enabled = False
	DlgGridDB.cmdRemoveSelected.Enabled = False
	DlgGridDB.cmdRemoveAll.Enabled = False
	
	Application.EnterWait()
	GridActiveTableName$ = sObjectName

	DlgGridDB.lbSelected.Clear()
	DlgGridDB.lbFields.Clear()
	GridOriginalFieldList.Clear()

	' What ist the grid based on ?
	Dim aSourceObject as Object
	Select Case (aSourceType)
		Case ST_TABLE :
			aSourceObject = aCurrentDb.getTables().getByName(GridActiveTableName$)
			aCurrentFields = aSourceObject.getFields()
		Case ST_QUERY :
			aSourceObject = aCurrentDb.getQueries().getByName(GridActiveTableName$)
			aCurrentFields = aSourceObject.getFields()
		Case ST_STATEMENT :
			' a statement source means the form initially had a datasource, so we can ask itself
			aCurrentFields = aParentForm.getRecord()
	End Select

	aFieldNames = aCurrentFields.ElementNames

	' go through it ...
	if UBound (aFieldNames)>=0 then
		For i%=0 To UBound (aFieldNames)
			sCurrentFieldName$ = aFieldNames(i%)
			If (Not isVersionColumn(aCurrentFields, sCurrentFieldName$)) Then
				DlgGridDB.lbFields.AddItem (sCurrentFieldName$)
				GridOriginalFieldList.Add (sCurrentFieldName$)
			End If
		Next
	End If

	If (DlgGridDB.lbFields.ListCount()>=1) Then
		DlgGridDB.cmdMoveSelected.Enabled = True
		DlgGridDB.cmdMoveAll.Enabled = True
		DlgGridDB.lbFields.Selected(0) = True
	Else
		DlgGridDB.cmdMoveSelected.Enabled = False
		DlgGridDB.cmdMoveAll.Enabled = False
	End If
	DlgGridDB.cmdRemoveSelected.Enabled = False
	DlgGridDB.cmdRemoveAll.Enabled = False

	bNeedFieldRefresh = False
	GridCheckButtons()
	Application.LeaveWait()
	Exit Sub

could_not_open_fields:
	MsgBox Grid_gErrCouldNotOpenObject$

	bNeedFieldRefresh = False
	GridCheckButtons()
	DlgGridDB.cmdMoveSelected.Enabled = False
	DlgGridDB.cmdMoveAll.Enabled = False
	DlgGridDB.cmdRemoveSelected.Enabled = False
	DlgGridDB.cmdRemoveAll.Enabled = False

	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub FormcmdCancel()
	DlgGridDB.Hide()
	DlgGridDB.Unload()
	CloseDBConnection()
	GridReturnValue$ = ""
End Sub

' -----------------------------------------------------------------------------
Sub FormPrevClicked()
	DlgGridDB.CurrentStep = DlgGridDB.CurrentStep - 1
	GridCheckButtons(DlgGridDB.CurrentStep)
	GridSetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub FormNextOrReadyClicked()
	Dim sClickedOn as String

	If ((DlgGridDB.CurrentStep = 1) And bNeedFieldRefresh) Then
		DlgGridDB.lbFields.Clear()
		DlgGridDB.lbSelected.Clear()
	End If

	DlgGridDB.CurrentStep = DlgGridDB.CurrentStep + 1
	GridCheckButtons()

	If (DlgGridDB.CurrentStep = 2) Then
		' fill the fields list
		sClickedOn = DlgGridDB.lbTables.List(DlgGridDB.lbTables.ListIndex())
		' is the selected entry a query or a table ?
		If ( -1 < StrInStrings%( GridInstalledQueries, sClickedOn ) ) Then
			aSourceType = ST_QUERY
		Else
			aSourceType = ST_TABLE
		End If
		GridGetFields(sClickedOn)
		cmdMoveAll.SetFocus
	End If

	GridSetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub GridSetTitle()
	Select Case (DlgGridDB.CurrentStep)
		Case 1
			DlgGridDB.Caption = Grid_Dlg_1Caption$
		Case 2
			DlgGridDB.Caption = Grid_Dlg_2Caption$
		Case 3
			DlgGridDB.Caption = Grid_Dlg_3Caption$
	End Select
End Sub

' -----------------------------------------------------------------------------
Sub FormSetMoveRights()
	'       Enable or disable the buttons used for moving the available
	'       fields between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	FieldSelected% = (-1<>lbFields.ListIndex())
	FieldCount% = lbFields.ListCount()

	SelectSelected% = (-1<>lbSelected.ListIndex())
	SelectCount% = lbSelected.ListCount()

	cmdRemoveAll.Enabled = (SelectCount%>=1)
	cmdRemoveSelected.Enabled = (SelectCount%>=1 And SelectSelected%)
	cmdMoveAll.Enabled = (FieldCount%>=1)
	cmdMoveSelected.Enabled = (FieldCount%>=1 And FieldSelected%)
	cmdReady.Enabled = (SelectCount%>=1)
End Sub

' -----------------------------------------------------------------------------
Sub FormMoveSelected()
	MoveSelectedListBox(lbFields, lbSelected)
	FormSetMoveRights()
End Sub

' -----------------------------------------------------------------------------
Sub FormMoveAll()
	CopyItemsListBox(lbFields, lbSelected)
	FormSetMoveRights()
	cmdReady.SetFocus
End Sub

' -----------------------------------------------------------------------------
Sub FormRemoveSelected()
	MoveOrderedSelectedListbox( lbFields, lbSelected, GridOriginalFieldList, False )
	FormSetMoveRights()
End Sub

' -----------------------------------------------------------------------------
Sub FormRemoveAll()
	MoveOrderedSelectedListbox( lbFields, lbSelected, GridOriginalFieldList, True )
	FormSetMoveRights()
End Sub

'       Picture Repaint-Events
' -----------------------------------------------------------------------------
Sub FormPreview1Repaint()
	PaintPicOnPreview(DlgGridDB.Preview1, GridPath+"cjtable0.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Const MaxFieldIndex% = 256
Const cColumnarLeft% = 1, cColumnarTop% = 2, cJustified% = 3, cTabled% = 4
Const cText = 1, cFloat = 2, cInteger = 3, cLong = 4, cBoolean = 5, cMemo = 6, cCounter = 7, cDateTime = 8,cDateField = 9, cTime = 10, cCurrency = 11, cImage = 12
Const cNone = 1, cHorizontal = 2, cVertical = 3

Sub CreateClicked()
	Dim ColumnMap(0 To MaxFieldIndex%)
	Dim FieldName$(0 To MaxFieldIndex%)
	Dim FieldPostfix$(0 To MaxFieldIndex%)
	Dim FieldType%(0 To MaxFieldIndex%)
	Dim StructFieldSize%, Style%, Alignment%
	Dim nColType%

	DlgGridDB.Hide()
	Dim activeColumnName$
	Dim n%, Found%, nArrCount%

	Application.EnterWait()
	Wait( 0 )

	nArrCount% = 0
	FixODBCBug()
	
	' now collect the column descriptions
	nArrCount% = 0
	For n% = 0 to lbSelected.ListCount()-1
		activeColumnName$ = lbSelected.List(n%)

		FieldName$(nArrCount%) = activeColumnName$
		FieldPostfix$(nArrCount%) = ""		' default no title postfix

		nColType% = aCurrentFields.getByName(activeColumnName$).Type
		Select Case (nColType%)
			Case DatabaseFieldType_BOOL :
				FieldType%(nArrCount%) = cBoolean
			Case DatabaseFieldType_TINYINT :
			Case DatabaseFieldType_SMALLINT :
				FieldType%(nArrCount%) = cInteger
			Case DatabaseFieldType_INTEGER :
				FieldType%(nArrCount%) = cLong
			Case DatabaseFieldType_REAL :		goto NumericField
			Case DatabaseFieldType_DOUBLE :		goto NumericField
			Case DatabaseFieldType_NUMERIC :	goto NumericField
			Case DatabaseFieldType_DECIMAL :
				NumericField:
				FieldType%(nArrCount%) = cFloat
			Case DatabaseFieldType_CURRENCY :
				FieldType%(nArrCount%) = cCurrency
			Case DatabaseFieldType_CHAR :		goto TextField
			Case DatabaseFieldType_VARCHAR :
				TextField:
				FieldType%(nArrCount%) = cText
			Case DatabaseFieldType_LONGVARCHAR :
				FieldType%(nArrCount%) = cMEMO
			Case DatabaseFieldType_DATE :
				FieldType%(nArrCount%) = cDateField
			Case DatabaseFieldType_TIME :
				FieldType%(nArrCount%) = cTime
			Case DatabaseFieldType_DATETIME :
				' a date/time field needs two separated columns :
				' one for the date part
				FieldType%(nArrCount%) = cDateField
				FieldName$(nArrCount%) = activeColumnName$
				FieldPostfix$(nArrCount%) = Grid_gDatetime_DateComponent$

				' and one for the time part
				nArrCount% = nArrCount% + 1
				FieldName$(nArrCount%) = activeColumnName$
				FieldPostfix$(nArrCount%) = Grid_gDatetime_TimeComponent$
				FieldType%(nArrCount%) = cTime
			Case DatabaseFieldType_LONGVARBINARY :
				FieldType%(nArrCount%) = cImage
			Case Else :
				FieldType%(nArrCount%) = cText
		End Select
		nArrCount% = nArrCount% + 1
	Next

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

	if IsControl then
		CalcForTable (GridControl, nArrCount%, FieldName$(), FieldPostfix$(), FieldType%(), GridDBName$, GridActiveTableName$)
	End If
End Sub

' -----------------------------------------------------------------------------
function CalcForTable( BYVAL aControl as Object, nCount%, sFieldNames$(), sFieldPostfix$(), nFieldType%(), sDBName$, sTableName$)

	DIM n%, nType%
	Dim aColumn as Object
	DIM aProgress AS NEW PROGRESS
	DIM sOldTableName$

	On local Error goto TableError
	aProgress.Start( Grid_gProgressText$, nCount% )
	
	if (aControl.Count > 0 ) then
		for n% = 0 to aControl.Count-1
			aControl.RemoveByIndex (0)
		Next n%
	End If	
	
	for n% = 0 to nCount%-1
		
		nType% = nFieldType%( n% )
				
		if( cBoolean = nType% ) then
			aColumn = aControl.CreateColumn("CheckBox")
			aColumn.Name = CalcUniqueContentName(aControl, "CheckBox")
		elseif ( cFloat = nType% ) then
			aColumn = aControl.CreateColumn("FormattedField")
			aColumn.Name = CalcUniqueContentName(aControl, "FormattedField")
		elseif ( cInteger = nType% or cLong = nType% or  cCounter = nType% ) then
			aColumn = aControl.CreateColumn("NumericField")
			aColumn.Name = CalcUniqueContentName(aControl, "NumericField")
			aColumn.DecimalAccuracy = 0		' no scale for integer types
		elseif (cCurrency = nType% ) then
			aColumn = aControl.CreateColumn("CurrencyField")
			aColumn.Name = CalcUniqueContentName(aControl, "CurrencyField")
		elseif ( cDateField = nType% ) then
			aColumn = aControl.CreateColumn("DateField")
			aColumn.Name = CalcUniqueContentName(aControl, "DateField")
		elseif ( cTime = nType% ) then
			aColumn = aControl.CreateColumn("TimeField")
			aColumn.Name = CalcUniqueContentName(aControl, "TimeField")
		else
			aColumn = aControl.CreateColumn("TextField")
			aColumn.Name = CalcUniqueContentName(aControl, "TextField")
		endif

		aColumn.DataField = sFieldNames$ (n%)
		aColumn.Label = sFieldNames$ (n%) + sFieldPostfix$(n%)
		aColumn.Width = 0 	' column should be auto-sized
		aControl.insertByName (aColumn.Name, aColumn)

		aProgress.Value = n%
		
	next n%

TableError:
	On Local Error Resume Next
	if (aParentForm.DataSourceName = "") Then
		aParentForm.DataSourceName = sDBName$
	End If
	' If the DataSource is already set, we didn't allow the user to select another one so we don't have to
	' set this property again. With this we avoid the case where the setProperty is vetoed (which happens in
	' documents belonging to a database)
	aParentForm.Command = sTableName$
	aParentForm.CommandType = aSourceType

	aProgress.Stop
	Erase aProgress
end function

