'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=MainWithDefault0
'SBLLINK:MethodInfo=CreateForm0
'SBLLINK:MethodInfo=FormNewDatabaseSelected0
'SBLLINK:MethodInfo=FormGetTables0
'SBLLINK:MethodInfo=FormGetFields0
'SBLLINK:MethodInfo=FormGetFieldsFromTable0
'SBLLINK:MethodInfo=FormcmdCancel0
'SBLLINK:MethodInfo=FormPrevClicked0
'SBLLINK:MethodInfo=FormNextOrReadyClicked0
'SBLLINK:MethodInfo=FormSetTitle0
'SBLLINK:MethodInfo=FormSetMoveRights0
'SBLLINK:MethodInfo=FormMoveSelected0
'SBLLINK:MethodInfo=FormMoveAll0
'SBLLINK:MethodInfo=FormRemoveSelected0
'SBLLINK:MethodInfo=FormRemoveAll0
'SBLLINK:MethodInfo=FormEditChanged0
'SBLLINK:MethodInfo=FormChangeDBField0
'SBLLINK:MethodInfo=FormChangeField0
'SBLLINK:MethodInfo=FormRadioCaptionSelect0
'SBLLINK:MethodInfo=FormRadioValueSelect0
'SBLLINK:MethodInfo=FormEditValueFocusLost0
'SBLLINK:MethodInfo=FormPreview1Repaint0
'SBLLINK:MethodInfo=FormPreview4Repaint0
'SBLLINK:MethodInfo=GetTableOfQuery0
'SBLLINK:MethodInfo=CloseConnections0
'SBLLINK:MethodInfo=CreateClicked0

Option Explicit

Global FormActiveTableName$, FormPath$, FormDBName$, FormReturnValue$
Global TemplatePath$
Global EditListIndex%
Global MinPrevStep%

Global FormAvailTables As New Strings
Global FormOriginalFieldList As New Strings
Global FormInstalledQueries As New Strings
Global FormControl As Object
Global IsControl As Boolean
Global bIsTable as boolean

Global nActLanguage%

Sub Main()
	MainWithDefault ( Application, False )
End Sub

Sub MainWithDefault( ByVal aControl as Object, ByVal bActive as Boolean )

On Error Goto GloablError

	If (Not InitResources()) Then
		Exit Sub
	End If

	Dim sResult$, sTitle$, sFileName$, sShow$, sTmp$
	Dim nPos%
	
	FormControl = aControl
	IsControl = bActive

	EditListIndex% = -1
	
	TemplatePath$ = Application.PathSettings.Template
	If InStr (TemplatePath$, ";")<>0 Then
		TemplatePath$ = Left$(TemplatePath$, InStr(TemplatePath$, ";")-1)       ' Non-Unix
	End If
	
	FormPath$ = TemplatePath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	Application.EnterWait()
	Wait( 0 )

	'   load language
	nActLanguage% = nLoadLanguage% ( Application.LanguageID )

	'       Load dialog and string tools
	Application.LoadLibrary( "Tools" )
	Wait( 0 )

	'       creating a form with the help of the dialog
	sResult$ = CreateForm$ ( aControl, bActive )
	Call CloseConnections()
	
EndOfSub:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend
	Exit Sub

GloablError:
	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	MsgBox(Form_gErrMsg$ ( nActLanguage% ), 16, Form_gWizardName$ ( nActLanguage% ))

End Sub

Function CreateForm$(ByVal aControl as Object, ByVal bActive as Boolean)

On Error Goto GloablError

	Dim nCount%
	DIM aForm as Object

	'       Initialize Global Variables
	bIsTable = False
	FormActiveTableName$ = ""
	FormReturnValue$ = ""
	FormDBName$ = ""
	FormActiveTableName$ = ""

	DlgGroupDB.Load()

	DlgGroupDB.cmdPrev.Enabled = False
	DlgGroupDB.CurrentStep = 1
	MinPrevStep% = 1
	
	If (bActive = True) Then
		DlgGroupDB.edGroupTitle.Text = aControl.Label
		aForm = aControl.Parent
		FormDBName$=aForm.DataSourceName
		If (not (aForm.Command = "")) Then
			FormActiveTableName$ = aForm.Command
			bIsTable = True
		End If
	End If	

	DlgGroupDB.CurrentStep = 2	
	MinPrevStep% = 2
	DlgGroupDB.cmdNextOrReady.Visible = True
	DlgGroupDB.cmdNextOrReady.Enabled = False
	DlgGroupDB.cmdReady.Visible = False
	DlgGroupDB.cmdPrev.Visible = True
	DlgGroupDB.cmdPrev.Enabled = False
	DlgGroupDB.cmbAvailDatabase.Visible = False
	DlgGroupDB.frameDatabase.Visible = False
	DlgGroupDB.edEdit.SetFocus

	Call FormSetTitle()
	'If bIsTable = True then
	'	Call GetAllInstalledNamesInDatabase(FormDBName$, FormAvailTables)
	'	Call FormGetTables()
	'	Call FormGetFields()
	'else
	If bIsTable = True then
		' wenn keine Tabelle geholt wird, mu wenigsten die DB geffnet werden
		Application.OpenDatabaseConnection(FormDBName$) 
		' und die Namen der Abfragen holen
		FormInstalledQueries = Application.GetQueryNames()
		Call FormGetFieldsFromTable(FormActiveTableName$)
	End If	

	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	DlgGroupDB.opField.Value = True
	DlgGroupDB.lbSelected.Clear()
	DlgGroupDB.lbRadioCaptions.Clear()
	DlgGroupDB.cbField.Clear()
	DlgGroupDB.Show()
	CreateForm$ = FormReturnValue$
	Exit Function

GloablError:
	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	MsgBox(Form_gErrMsg$ ( nActLanguage% ), 16, Form_gWizardName$ ( nActLanguage% ))
	CreateForm$ = ""
	DlgGroupDB.UnLoad()
	Reset
	Stop
End Function

Sub FormNewDatabaseSelected()
	FormDBName$ = DlgGroupDB.cmbAvailDatabase.List(DlgGroupDB.cmbAvailDatabase.ListIndex())
	
	DlgGroupDB.lbTables.Clear()
	Call GetAllInstalledNamesInDatabase(FormDBName$, FormAvailTables)
	Call FormGetTables()
	Call FormGetFields()
End Sub

Sub FormGetTables()
	Dim tablename$,i%
	Dim aDBEngine, aDBWorkspace, aDBDatabase as Object
	Dim DBNames as Variant
	
	aDBEngine = CreateUnoService("com.sun.star.data.DatabaseEngine")
	aDBWorkspace = aDBEngine.Workspaces.getByIndex(0)
	aDBDatabase  = aDBWorkspace.open(aDBEngine.getLocation(FormDBName$))	
	
	DlgGroupDB.lbTables.Clear()
	
	'erst die Abfragen
	DBNames = aDBDatabase.Queries.ElementNames
	if UBound (DBNames)>=0 then 'obere Grenze min. 0
		For i% = 0 To UBound (DBNames)
			DlgGroupDB.lbTables.AddItem ( DBNames(i%) )
			FormInstalledQueries.Add ( DBNames(i%) )
		Next
	End if
	
	'dann die Tabellen
	DBNames = aDBDatabase.Tables.ElementNames
	if UBound (DBNames)>=0 then 'obere Grenze min. 0
		For i%=0 To UBound (DBNames)
			DlgGroupDB.lbTables.AddItem(DBNames(i%))
		Next
	End If
	
	If (DlgGroupDB.lbTables.ListCount>=1) Then
		DlgGroupDB.lbTables.Selected(0)=True
		DlgGroupDB.cmdNextOrReady.Enabled = True
	Else
		MsgBox(Form_gErrNoTableInDatabase$ ( nActLanguage% ), 16, Form_gWizardName$ ( nActLanguage% ) )
		DlgGroupDB.cmdNextOrReady.Enabled = False
	End If	
End Sub

Sub FormGetFields()
	Dim n%, i%, maxFields%
	Dim sActFieldName$
	Dim DocTest$
	Dim FieldsInQueries As New Strings

	Application.EnterWait()
	Wait( 0 )
	
	'       which table was selected
	n% = DlgGroupDB.lbTables.ListIndex()
	If ( -1 = n% ) Then Goto EndOfSub
	FormActiveTableName$ = DlgGroupDB.lbTables.List(DlgGroupDB.lbTables.ListIndex())

	DlgGroupDB.cbDBField.Clear()
	FormOriginalFieldList.Clear()

	If ( -1 < StrInStrings%( FormInstalledQueries, FormActiveTableName$ ) ) Then
		FieldsInQueries = Application.GetQueryColumns ( FormActiveTableName$ )
		maxFields% = FieldsInQueries.Count()
		For n% = 1 To maxFields%
			sActFieldName$ = FieldsInQueries.Item ( n% )
			sActFieldName$ = Left ( sActFieldName$, InStr ( 1, sActFieldName$, "," ) - 1 )
			DlgGroupDB.cbDBField.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	Else
		'       fill out the list lbFields
		Application.OpenTableConnection( FormActiveTableName$ )
		Application.DataSelect( "select * from " + Application.QuoteTablename( FormActiveTableName$ ) )
		Call FixODBCBug()
		maxFields% = Application.DataColumnNumber()
		For n%=1 To maxFields%
			sActFieldName$ = Application.DataColumnname( n% )
			DlgGroupDB.cbDBField.AddItem ( sActFieldName$ )
			FormOriginalFieldList.Add ( sActFieldName$ )
		Next
	End If
	
	Erase FieldsInQueries
	if DlgGroupDB.cbDBField.ListCount()>0 then
		DlgGroupDB.cbDBField.ListIndex()=0
		DlgGroupDB.opDBField.Value = True
	else
		DlgGroupDB.opNoDBField.Value = True
	End If	
	
	Exit Sub
	If (DlgGroupDB.lbFields.ListCount()>=1) Then
		DlgGroupDB.cmdMoveSelected.Enabled = True
		'DlgGroupDB.cmdMoveAll.Enabled = True
		DlgGroupDB.lbFields.Selected(0) = True
	Else
		DlgGroupDB.cmdMoveSelected.Enabled = False
		'DlgGroupDB.cmdMoveAll.Enabled = False
	End If
	DlgGroupDB.lbSelected.Clear()

	Erase FieldsInQueries

EndOfSub:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

Sub FormGetFieldsFromTable(FormActiveTableName$)
	If (not (FormActiveTableName$ = "")) then
		DlgGroupDB.lbTables.Clear()	
		DlgGroupDB.lbTables.AddItem(FormActiveTableName$)
		DlgGroupDB.lbTables.ListIndex() = 0
	End If	
	call FormGetFields()
End Sub

Sub FormcmdCancel()
	DlgGroupDB.Hide()
	DlgGroupDB.Unload()
	Call CloseConnections()
	FormReturnValue$ = ""
End Sub

Sub FormPrevClicked()
	cmdNextOrReady.Visible = True
	cmdNextOrReady.Enabled = True
	DlgGroupDB.CurrentStep = DlgGroupDB.CurrentStep - 1
	If (DlgGroupDB.CurrentStep=MinPrevStep%) Then
		cmdPrev.Enabled = False
		cmdNextOrReady.Enabled = (DlgGroupDB.lbTables.ListIndex()>=0)
	End If
	If (DlgGroupDB.CurrentStep=2) Then
		cmdNextOrReady.Enabled = (lbSelected.ListCount()>=1)
		edEdit.SetFocus
	End If
		If (DlgGroupDB.CurrentStep=3) Then
		if (opField.Value = True) then
			opField.SetFocus
		else
			opNoField.SetFocus
		EndIf	
	End If
	If (DlgGroupDB.CurrentStep=4) Then
		edValue.SetFocus
	End If
	If (DlgGroupDB.CurrentStep=5) Then
		if (bIsTable = False) then
			DlgGroupDB.CurrentStep = DlgGroupDB.CurrentStep - 1
			call FormPrevClicked()
		else	
			if (opDBField.Value = True) then
				opDBField.SetFocus
			else
				opNoDBField.SetFocus
			EndIf	
		End If	
	End If
	If (DlgGroupDB.CurrentStep=6) Then
		edGroupTitle.SetFocus
	End If
	Call FormSetTitle()
End Sub

Sub FormNextOrReadyClicked()
	Dim i%
	'cmdNextOrReady.Visible = ( DlgGroupDB.CurrentStep < 5 )
	'cmdReady.Visible = not cmdNextOrReady.Visible
	DlgGroupDB.CurrentStep = DlgGroupDB.CurrentStep + 1
	If (DlgGroupDB.CurrentStep>=2) Then
		cmdPrev.Enabled = True
	End If
	If (DlgGroupDB.CurrentStep=2) Then
		cmdNextOrReady.Enabled = (lbSelected.ListCount()>=1)
		edEdit.SetFocus
	End If
	If (DlgGroupDB.CurrentStep=3) Then
		if (opField.Value = True) then
			opField.SetFocus
		else
			opNoField.SetFocus
		EndIf
		if (lbSelected.Tag = "Change") and (lbRadioCaptions.ListCount()>0) then
			lbRadioValues.Clear()
			lbSelected.Tag = ""
			for i% = 0 to lbRadioCaptions.ListCount()-1
				lbRadioValues.AddItem(Trim(Str(i%+1)))
			Next
			call FormRadioCaptionSelect
		end If
	End If
	If (DlgGroupDB.CurrentStep=4) Then
		edValue.SetFocus
	End If
	If (DlgGroupDB.CurrentStep=5) Then
		if (bIsTable = False) then
			DlgGroupDB.CurrentStep = DlgGroupDB.CurrentStep + 1
			call FormNextOrReadyClicked()
		else	
			if (opDBField.Value = True) then
				opDBField.SetFocus
			else
				opNoDBField.SetFocus
			EndIf	
		end If	
	End If
	If (DlgGroupDB.CurrentStep=6) Then
		cmdNextOrReady.Enabled = False
		cmdNextOrReady.Visible = False
		cmdReady.Visible = True
		edGroupTitle.SetFocus
	End If
	Call FormSetTitle()
End Sub

Sub FormSetTitle()
	Select Case (DlgGroupDB.CurrentStep)
		Case 1
			DlgGroupDB.Caption = Form_Dlg_1Caption$ ( nActLanguage% )
		Case 2
			DlgGroupDB.Caption = Form_Dlg_2Caption$ ( nActLanguage% )
		Case 3
			DlgGroupDB.Caption = Form_Dlg_3Caption$ ( nActLanguage% )
		Case 4
			DlgGroupDB.Caption = Form_Dlg_4Caption$ ( nActLanguage% )
		Case 5
			DlgGroupDB.Caption = Form_Dlg_5Caption$ ( nActLanguage% )
		Case 6
			DlgGroupDB.Caption = Form_Dlg_6Caption$ ( nActLanguage% )
	End Select
End Sub

Sub FormSetMoveRights()
	'       Enable or disable the buttons used for moving the available
	'       fields between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	'FieldSelected% = (-1<>lbFields.ListIndex())
	'FieldCount% = lbFields.ListCount()

	SelectSelected% = (-1<>lbSelected.ListIndex())
	SelectCount% = lbSelected.ListCount()

	'cmdRemoveAll.Enabled = (SelectCount%>=1)
	cmdRemoveSelected.Enabled = (SelectCount%>=1 And SelectSelected%)
	'cmdMoveAll.Enabled = (FieldCount%>=1)
	'cmdMoveSelected.Enabled = (FieldCount%>=1 And FieldSelected%)
	'cmdReady.Enabled = (SelectCount%>=1)
	cmdNextOrReady.Enabled = (SelectCount%>=1)
End Sub

Sub FormMoveSelected()
	lbSelected.AddItem (edEdit.Text)
	lbRadioCaptions.AddItem (edEdit.Text)
	cbField.AddItem (edEdit.Text)
	if cbField.ListCount()=1 then
		cbField.ListIndex = 0
		lbRadioCaptions.ListIndex = 0
	End If	
	edEdit.Text = ""
	'Call MoveSelectedListBox(lbFields, lbSelected)
	Call FormSetMoveRights()
	edEdit.SetFocus
	cmdMoveSelected.Visible = True
	lbSelected.Tag = "Change"
End Sub

Sub FormMoveAll()
	Call CopyItemsListBox(lbFields, lbSelected)
	Call FormSetMoveRights()
End Sub

Sub FormRemoveSelected()
	Dim nListIndex%, nFieldListIndex%, nCaptionListIndex%
	nListIndex% = lbSelected.ListIndex()
	nFieldListIndex% = cbField.ListIndex()
	nCaptionListIndex% = lbRadioCaptions.ListIndex()
	lbSelected.RemoveItem(nListIndex%)
	lbRadioCaptions.RemoveItem(nListIndex%)
	cbField.RemoveItem(nListIndex%)
	if nListIndex% > lbSelected.ListCount()-1 then
		lbSelected.ListIndex = lbSelected.ListCount()-1
	else
		'lbSelected.ListIndex = lbSelected.ListIndex
		lbSelected.Selected (nListIndex%) = True
	End If
	if (nListIndex%=nFieldListIndex%) and (cbField.ListCount()>0)  then
		cbField.ListIndex() = 0
	End If	
	'Call MoveOrderedSelectedListbox( lbFields, lbSelected, FormOriginalFieldList, False )
	Call FormSetMoveRights()
	if lbSelected.ListCount() = 0 then
		edEdit.SetFocus
		edValue.Text = ""
	End If
	
	if nCaptionListIndex% > lbRadioCaptions.ListCount()-1 then
		lbRadioCaptions.ListIndex = lbRadioCaptions.ListCount()-1
	else
		lbRadioCaptions.Selected (nCaptionListIndex%) = True
	End If	
	
	lbSelected.Tag = "Change"
End Sub

Sub FormRemoveAll()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, FormOriginalFieldList, True )
	Call FormSetMoveRights()
End Sub

Sub FormEditChanged()
	If len (edEdit.Text)>0 then
		cmdMoveSelected.Enabled = True
	else
		cmdMoveSelected.Enabled = False
	End IF
End Sub

Sub FormChangeDBField
	if (opDBField.Value = True) then
		cbDBField.Enabled = True
	else	
		cbDBField.Enabled = False
	End If	
End Sub

Sub FormChangeField
	if (opField.Value = True) then
		cbField.Enabled = True
	else	
		cbField.Enabled = False
	End If	
End Sub

Sub FormRadioCaptionSelect
	lbRadioValues.ListIndex = lbRadioCaptions.ListIndex
	EditListIndex% = lbRadioValues.ListIndex
	edValue.Text = Trim(lbRadioValues.List(lbRadioValues.ListIndex))
End Sub

Sub FormRadioValueSelect
	lbRadioCaptions.ListIndex = lbRadioValues.ListIndex
	EditListIndex% = lbRadioValues.ListIndex
	edValue.Text = Trim(lbRadioValues.List(lbRadioValues.ListIndex))
End Sub

Sub FormEditValueFocusLost
	if not (EditListIndex%=-1) then
		lbRadioValues.List(EditListIndex%) = (Trim(edValue.Text))
		call FormRadioCaptionSelect
	end If	
End Sub

'       Picture Repaint-Events
Sub FormPreview1Repaint()
	Call PaintPicOnPreview(DlgGroupDB.Preview1, FormPath$+"cjtable0.bmp", 152, 172, True)
End Sub

Sub FormPreview4Repaint()
	Call PaintPicOnPreview(DlgGroupDB.Preview4, FormPath$+"end.bmp", 152, 172, True)
End Sub

Function GetTableOfQuery$ ( Byval sSql$ )

	Dim nCnt1%, nCnt2%, nEnd%, n%

	sSql$ = UCase$( sSql$ )

	nCnt1% = 0
	nCnt2% = 0
	nEnd% = len( sSql$ )
	for n% = 1 to nEnd%
		select case asc( mid( sSql$, n%, 1 ))
		case 34:
			if( 0 = nCnt2% ) then
				if( 0 = 		nCnt1% ) then
					nCnt1% = nCnt1% + 1
				else
					nCnt1% = nCnt1% - 1
				endif
			endif

		case 39:
			if( 0 = nCnt1% ) then
				if( 0 = 		nCnt2% ) then
					nCnt2% = nCnt2% + 1
				else
					nCnt2% = nCnt2% - 1
				endif
			endif
		case 70:
			if( 0 = nCnt1% + nCnt2% AND "FROM " = mid( sSql$, n%, 5 ) ) then
				' oder gefunden, ist es auch ein oder by?
				n% = n% + 5
				while( " " = mid$( sSql$, n%, 1 ))
					n% = n% + 1
				wend
				if( """" = mid$( sSql$, n%, 1 )) then n% = n% + 1
				nCnt1% = n%
				while( n% <= nEnd% AND 0 = InStr( " """, mid$( sSql$, n%, 1 )))
					n% = n% + 1
				wend
				GetTableOfQuery$ = Mid ( sSql$, nCnt1%, n% - nCnt1% )
				Exit Function
			endif
		end select
	next n%
End Function

Sub CloseConnections()
	If ( "" <> Application.GetActiveTableConnection() ) Then
		Application.CloseTableConnection( Application.GetActiveTableConnection() )
	End If
	If ( "" <> Application.GetActiveDatabaseConnection() ) Then
		Application.CloseDatabaseConnection( Application.GetActiveDatabaseConnection() )
	End If
End Sub

Sub CreateClicked()
	'       prepare the calling parameters for Juergen Pingel's routine
	DlgGroupDB.Hide()
	DlgGroupDB.UnLoad()

	Application.EnterWait()
	Wait( 0 )

	Call FixODBCBug()
	
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend
	
	if IsControl then
		CalcForGroup (FormControl, DlgGroupDB.lbSelected.ListCount)
	End If	
End Sub
