'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=NextStep0
'SBLLINK:MethodInfo=PrevStep0
'SBLLINK:MethodInfo=CancelButton0
'SBLLINK:MethodInfo=FillCurrentStep0
'SBLLINK:MethodInfo=OnWinWordClick0
'SBLLINK:MethodInfo=OnExcelClick0
'SBLLINK:MethodInfo=OnPowerPClick0
'SBLLINK:MethodInfo=WinWordRepaint0
'SBLLINK:MethodInfo=ExcelRepaint0
'SBLLINK:MethodInfo=PowerPRepaint0
'SBLLINK:MethodInfo=RepaintMsOfficeButton0
'SBLLINK:MethodInfo=RepaintWelcomePreview0
'SBLLINK:MethodInfo=RepaintChoosePreview0
'SBLLINK:MethodInfo=RepaintProgressPreview0
'SBLLINK:MethodInfo=FillStep_InputPaths0
'SBLLINK:MethodInfo=SaveStep_InputPath0
'SBLLINK:MethodInfo=SetDefault_InputPath0
'SBLLINK:MethodInfo=SetEnabledTemplate_InputPath0
'SBLLINK:MethodInfo=SetEnabledDocument_InputPath0
'SBLLINK:MethodInfo=FillStep_Welcome0
'SBLLINK:MethodInfo=FillStep_Progress0
'SBLLINK:MethodInfo=CheckAllPaths0
'SBLLINK:MethodInfo=CheckToNoData0
'SBLLINK:MethodInfo=CheckPath0
'SBLLINK:MethodInfo=CancelTask0
'SBLLINK:MethodInfo=CancelButtonPressed0
'SBLLINK:MethodInfo=TemplateDirSearchDialog0
'SBLLINK:MethodInfo=DocumentDirSearchDialog0
'SBLLINK:MethodInfo=StarDocumentDirSearchDialog0
'SBLLINK:MethodInfo=HelperDialog0
'SBLLINK:MethodInfo=RepaintSummaryPreview0
'SBLLINK:MethodInfo=MakeSummaryString0
'SBLLINK:MethodInfo=FillStep_Summary0
Public Const bDebugWizard=0

Public Const cWinWordChecked=1
Public Const cExcelChecked=2
Public Const cPowerPointChecked=3

Public Const Twip = 425

Public iOffice As Integer
Public sQueryPath As String
Public bCancelTask As Boolean

Public bCheckTemplates( 3 ) As Boolean
Public sTemplateSourceDir( 3 ) As String
Public bTemplateRecursive( 3 ) As Boolean

Public bCheckDocuments( 3 ) As Boolean
Public sDocumentSourceDir( 3 ) As String
Public bDocumentRecursive( 3 ) As Boolean
Public sStarDocumentTextboxValue( 3 ) As String

Public CHAOS As Variant
Public sTemplatePath As String
Public iSectionNameExists As Integer

Public AsyncCreateFlag As Boolean
Public AsyncCheckFlag As Boolean

Public Const cWordInGrph = "wordin.bmp"
Public Const cWordOutGrph = "wordout.bmp"
Public Const cExcelInGrph = "excelin.bmp"
Public Const cExcelOutGrph = "excelout.bmp"
Public Const cPowerPInGrph = "powerin.bmp"
Public Const cPowerPOutGrph = "powerout.bmp"

Public Const cWelcomeGrph = "welcome.bmp"
Public Const cChooseGrph = "choose.bmp"
Public Const cSummaryGrph = "summary.bmp"
Public Const cProgressGrph = "progress.bmp"

Sub Main

	Application.LoadLibrary("tools")
	If Not bDebugWizard Then
		On Error Goto RTError
	End If
	sQueryPath = GetBitmapDir()

  	bCancelTask = False
	bHideErrorMsg = False
	ImportDialog.CurrentStep = 1
	iOffice = 1

    LoadLanguage()

	ImportDialog.Load
    Call SetDefault_InputPath()
	Call FillStep_Welcome()

	ImportDialog.show

	Exit Sub
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader
End Sub


Sub NextStep

	If bDebugWizard = False Then
		On Error Goto RTError
	End If

	If ImportDialog.CurrentStep < 4 Then
		If FillCurrentStep( ImportDialog.CurrentStep + 1 ) Then

			ImportDialog.CurrentStep = ImportDialog.CurrentStep + 1
			If ImportDialog.CurrentStep = 4 Then
				Call ConvertAllDocuments()
			End If
		End If
	End If

	Exit Sub
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader
End Sub


Sub PrevStep

	If bDebugWizard = False Then
		On Error Goto RTError
	End If

	If ImportDialog.CurrentStep > 1 Then
		If FillCurrentStep( ImportDialog.CurrentStep - 1 ) Then
			ImportDialog.CurrentStep = ImportDialog.CurrentStep - 1
		End If
	End If
	
	If ImportDialog.CurrentStep = 1 Then ImportDialog.NextButton.Enabled = True

	Exit Sub
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader

End Sub


Sub CancelButton

	If ImportDialog.CurrentStep = 4 Then
		Call CancelButtonPressed()
	Else
		ImportDialog.Hide
		End
	End If

End Sub


Function FillCurrentStep( iStep As Integer )

	If bDebugWizard = False Then
		On Error Goto RTError
	End If

	FillCurrentStep = True

	Select Case iStep
	Case 1
		If CheckAllPaths() = False Then
			FillCurrentStep = False
			Exit Function
		End If
		Call SaveStep_InputPath()
		Call FillStep_Welcome()
	Case 2
		Call FillStep_InputPaths()
	Case 3
		If CheckAllPaths() = False Then
			FillCurrentStep = False
			Exit Function
		End If
		Call SaveStep_InputPath()
		Call FillStep_Summary()
	Case 4
		Call FillStep_Progress()

	End Select

	Exit Function
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader

End Function


Sub OnWinWordClick()

	If bDebugWizard = False Then
		On Error Goto RTError
	End If
	
	If CheckAllPaths() Then
		Call SaveStep_InputPath()
			
		iOffice = cWinWordChecked
		RepaintMsOfficeButton( ImportDialog.WinWordPreview, sQueryPath & cWordInGrph )
		RepaintMsOfficeButton( ImportDialog.ExcelPreview, sQueryPath & cExcelOutGrph )
		RepaintMsOfficeButton( ImportDialog.PowerPPreview, sQueryPath & cPowerPOutGrph )
		
		Call FillStep_InputPaths()
	End If

	Exit Sub
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader
		
End Sub


Sub OnExcelClick()

	If bDebugWizard = False Then
		On Error Goto RTError
	End If
	
	If CheckAllPaths() Then
		Call SaveStep_InputPath()
			
		iOffice = cExcelChecked
		RepaintMsOfficeButton( ImportDialog.WinWordPreview, sQueryPath & cWordOutGrph )
		RepaintMsOfficeButton( ImportDialog.ExcelPreview, sQueryPath & cExcelInGrph )
		RepaintMsOfficeButton( ImportDialog.PowerPPreview, sQueryPath & cPowerPOutGrph )
		
		Call FillStep_InputPaths( )	
	End If

	Exit Sub
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader
		
End Sub


Sub OnPowerPClick()

	If bDebugWizard = False Then
		On Error Goto RTError
	End If
	
	If CheckAllPaths() Then	
		Call SaveStep_InputPath()	
			
		iOffice = cPowerPointChecked
		RepaintMsOfficeButton( ImportDialog.WinWordPreview, sQueryPath & cWordOutGrph )
		RepaintMsOfficeButton( ImportDialog.ExcelPreview, sQueryPath & cExcelOutGrph )
		RepaintMsOfficeButton( ImportDialog.PowerPPreview, sQueryPath & cPowerPInGrph )
		
		Call FillStep_InputPaths( )	
	End If

	Exit Sub
RTError:
	Msgbox sRTErrorDesc, 16, sRTErrorHeader
	
End Sub


Sub WinWordRepaint
	If iOffice = cWinWordChecked Then
		RepaintMsOfficeButton( ImportDialog.WinWordPreview, sQueryPath & cWordInGrph )
	Else
		RepaintMsOfficeButton( ImportDialog.WinWordPreview, sQueryPath & cWordOutGrph )
	End If
	
End Sub


Sub ExcelRepaint
		
	If iOffice = cExcelChecked Then
		RepaintMsOfficeButton( ImportDialog.ExcelPreview, sQueryPath & cExcelInGrph )
	Else
		RepaintMsOfficeButton( ImportDialog.ExcelPreview, sQueryPath & cExcelOutGrph )
	End If
	
End Sub


Sub PowerPRepaint
	
	If iOffice = cPowerPointChecked Then
		RepaintMsOfficeButton( ImportDialog.PowerPPreview, sQueryPath & cPowerPInGrph )
	Else
		RepaintMsOfficeButton( ImportDialog.PowerPPreview, sQueryPath & cPowerPOutGrph )
	End If
	
End Sub


Sub RepaintMsOfficeButton( oPreviewControl As Object, sPictFullname As String )

	Dim Bitmap As Object

	Set Bitmap = LoadPicture ( sPictFullname )

	oPreviewControl.DrawPicture ( Bitmap, 0, 0, (Twip * 1.41), (Twip * 1.41) )
	
End Sub


Sub RepaintSummaryPreview()
	Dim Bitmap As Object

	Set Bitmap = LoadPicture ( sQueryPath & cSummaryGrph )

	ImportDialog.SummaryPreview.DrawPicture ( Bitmap, 3, 3, (Twip * 16.02), (Twip * 1.66) )
	
End Sub


Sub RepaintWelcomePreview()

	Dim Bitmap As Object

	Set Bitmap = LoadPicture ( sQueryPath & cWelcomeGrph )

	ImportDialog.WelcomePreview.DrawPicture ( Bitmap, 3, 3, (Twip * 16.02), (Twip * 1.66) )

End Sub


Sub RepaintChoosePreview()

	Dim Bitmap As Object

	Set Bitmap = LoadPicture ( sQueryPath & cChooseGrph )

	ImportDialog.ChoosePreview.DrawPicture ( Bitmap, 3, 3, (Twip * 16.02), (Twip * 1.66) )
	
End Sub


Sub RepaintProgressPreview()

	Dim Bitmap As Object

	Set Bitmap = LoadPicture ( sQueryPath & cProgressGrph )

	ImportDialog.ProgressPreview.DrawPicture ( Bitmap, 3, 3, (Twip * 16.02), (Twip * 1.66) )
	
End Sub


Sub FillStep_InputPaths( )

	ImportDialog.TemplateCheckbox.Caption = sTemplateCheckbox( iOffice )
	ImportDialog.TemplatePathLabel.Caption = sTemplateLabel( iOffice )
	ImportDialog.TemplateSearchSubDir.Caption = sSearchInSubDir
	
	ImportDialog.DocumentPathCheckbox.Caption = sDocumentCheckbox( iOffice )
	ImportDialog.DocumentPathLabel.Caption = sDocumentLabel( iOffice )	
	ImportDialog.StarDocumentLabel.Caption = sStarDocLabel( iOffice )
	ImportDialog.DocumentSearchSubDir.Caption = sSearchInSubDir
	ImportDialog.DocumentFrame.Caption = sProgressMoreDocs

	ImportDialog.TemplateCheckbox.Value = bCheckTemplates( iOffice )
	
	If Len( sTemplateSourceDir( iOffice ) ) > 0 Then
		ImportDialog.TemplatePath.Text = sTemplateSourceDir( iOffice )
	Else
		ImportDialog.TemplatePath.Text = GetTemplateDefaultPath()
	End If
	
	ImportDialog.TemplateSearchSubDir.Value = bTemplateRecursive( iOffice )

	ImportDialog.DocumentPathCheckbox.Value = bCheckDocuments( iOffice )

	If Len( sDocumentSourceDir( iOffice ) ) > 0 Then
		ImportDialog.MsDocumentPath.Text = sDocumentSourceDir( iOffice )
	Else
		Select Case iOffice
		Case 1
			ImportDialog.MsDocumentPath.Text = GetWinWordDefaultPath()
		Case 2
			ImportDialog.MsDocumentPath.Text = GetExcelDefaultPath()
		Case 3
			ImportDialog.MsDocumentPath.Text = GetPowerPointDefaultPath()
		End Select
	End if
	If ImportDialog.MsDocumentPath.Text = "" Then
		ImportDialog.MsDocumentPath.Text = ResolvePath("file:///{documents}")		
	End If
	
	ImportDialog.DocumentSearchSubDir.Value = bDocumentRecursive( iOffice )
	
	If Len( sStarDocumentTextboxValue( iOffice ) ) > 0 Then
		ImportDialog.StarDocumentPath.Text = sStarDocumentTextboxValue( iOffice ) 
	Else
		ImportDialog.StarDocumentPath.Text = GetPathSettings("Work", False)
	End If
	
	Call SetEnabledTemplate_InputPath()
	Call SetEnabledDocument_InputPath()

	ImportDialog.NextButton.Enabled = True
	ImportDialog.NextButton.Caption = sNextButton
	ImportDialog.PrevButton.Enabled = True
	
End Sub


Sub SaveStep_InputPath()

	bCheckTemplates( iOffice ) = ImportDialog.TemplateCheckbox.Value
	sTemplateSourceDir( iOffice ) = ConvertToURL(ImportDialog.TemplatePath.Text)
	bTemplateRecursive( iOffice ) = ImportDialog.TemplateSearchSubDir.Value

	bCheckDocuments( iOffice ) = ImportDialog.DocumentPathCheckbox.Value
	sDocumentSourceDir( iOffice ) = ConvertToURL(ImportDialog.MsDocumentPath.Text)
	bDocumentRecursive( iOffice ) = ImportDialog.DocumentSearchSubDir.Value

	sStarDocumentTextboxValue( iOffice ) = ImportDialog.StarDocumentPath.Text

End Sub


Sub SetDefault_InputPath()

	For iCount = 1 To 3
		bCheckTemplates( iCount ) = True
		sTemplateSourceDir( iCount ) = ""
		bTemplateRecursive( iCount ) = True
	
		bCheckDocuments( iCount ) = True
		sDocumentSourceDir( iCount ) = ""
	
		bDocumentRecursive( iCount ) = True
		sStarDocumentTextboxValue( iCount ) = ""
	Next iCount	
	
End Sub


Sub SetEnabledTemplate_InputPath()

	ImportDialog.TemplatePathLabel.Enabled = ImportDialog.TemplateCheckbox.Value
	ImportDialog.TemplateSearchSubDir.Enabled = ImportDialog.TemplateCheckbox.Value
	ImportDialog.TemplatePath.Enabled = ImportDialog.TemplateCheckbox.Value
	ImportDialog.TemplateSearchDir.Enabled = ImportDialog.TemplateCheckbox.Value

	Call CheckToNoData()

End Sub


Sub SetEnabledDocument_InputPath()

	ImportDialog.DocumentPathLabel.Enabled = ImportDialog.DocumentPathCheckbox.Value
	ImportDialog.StarDocumentLabel.Enabled = ImportDialog.DocumentPathCheckbox.Value
	ImportDialog.DocumentSearchSubDir.Enabled = ImportDialog.DocumentPathCheckbox.Value
	ImportDialog.MsDocumentPath.Enabled = ImportDialog.DocumentPathCheckbox.Value
	ImportDialog.StarDocumentPath.Enabled = ImportDialog.DocumentPathCheckbox.Value
	ImportDialog.DocumentSearchDir.Enabled = ImportDialog.DocumentPathCheckbox.Value
	ImportDialog.StarDocumentSearchDir.Enabled = ImportDialog.DocumentPathCheckbox.Value

	Call CheckToNoData()

End Sub


Function MakeSummaryString()

	Dim sCRLF As String, sTmpText As String
	
	sCRLF = CHR(10) & CHR(13)
	
	For iCount = 1 To 3 

		If 	bCheckTemplates( iCount ) = True And Len( Trim( sTemplateSourceDir( iCount ) ) ) > 0 Then

			sTmpText = sTmpText & sSumTemplate( iCount ) & sCRLF
			sTmpText = sTmpText & sTemplateSourceDir( iCount ) & sCRLF
			If bTemplateRecursive( iCount ) Then
				sTmpText = sTmpText & sSumInclusiveSubDir & sCRLF
			End If
			sTmpText = sTmpText & sCRLF
		End If

		If 	bCheckDocuments( iCount ) = True And Len( Trim( sDocumentSourceDir( iCount ) ) ) > 0 And Len( Trim( sStarDocumentTextboxValue( iCount ) ) ) > 0 Then
			sTmpText = sTmpText & sSumDokumente( iCount ) & sCRLF
			sTmpText = sTmpText & sDocumentSourceDir( iCount ) & sCRLF
			
			If bDocumentRecursive( iCount ) Then
				sTmpText = sTmpText & sSumInclusiveSubDir & sCRLF
			End If
			
			sTmpText = sTmpText & sSumSaveDokumente & sCRLF

			sTmpText = sTmpText & sStarDocumentTextboxValue( iCount ) & sCRLF
			
			sTmpText = sTmpText & sCRLF
		End If
		
	Next iCount

	MakeSummaryString = sTmpText

End Function


Sub FillStep_Welcome()

	ImportDialog.HelpButton.Caption = sHelpButton
	ImportDialog.CancelButton.Caption = sCancelButton
	ImportDialog.PrevButton.Caption = sBackButton
	ImportDialog.NextButton.Caption = sNextButton
	
	ImportDialog.WelcomeTextLabel.Caption = sWelcomeTextLabel1 + chr(13) + chr(13) + sWelcomeTextLabel2
	
	ImportDialog.PrevButton.Enabled = False

End Sub


Sub FillStep_Summary()

	ImportDialog.SummaryTextbox.Text = MakeSummaryString()
	
	If Len( Trim( ImportDialog.SummaryTextbox.Text ) ) = 0 Then
		ImportDialog.NextButton.Enabled = False
	End If

	ImportDialog.NextButton.Caption = sBeginButton
	ImportDialog.SummaryHeaderLabel.Caption = sSummaryHeader
	ImportDialog.TemplateGroupFrame.Caption = sSummaryFrame
	
	ImportDialog.TexttemplateLabel.Caption = sTextTemplateLabel
	ImportDialog.SpreadsheetTemplateLabel.Caption = sSpreadsheetTemplateLabel
	ImportDialog.PreTemplateLabel.Caption = sPreTemplateLabel			

	ImportDialog.TextTemplateTextbox.Text = sTextGroupnameDefault
	ImportDialog.SpreadsheetTemplateTextbox.Text = sSpeadGroupnameDefault
	ImportDialog.PresTemplateTextbox.Text = sPresGroupnameDefault
	
End Sub


Sub FillStep_Progress()
	ImportDialog.PrevButton.Enabled = False
	ImportDialog.NextButton.Enabled = False
'	ImportDialog.ProgressLabel.Caption = sProgressDesc1 & sProgressDesc2 & sProgressDesc3
'	ImportDialog.ProgressFullname.Caption = "."
'	ImportDialog.SummaryTextBox.Step = 4
	ImportDialog.FrameProgress.Caption = sProgressPage_1
	ImportDialog.LabelRetrieval.FontBold = True
	ImportDialog.LabelRetrieval.Caption = sProgressPage_2
	ImportDialog.LabelCurProgress.Caption = sProgressPage_3
End Sub


Function CheckAllPaths() As Boolean

	Dim iErrorCounter As Integer
	Dim sErrorPathName As String
	Dim oCtrl As Object
	
	sCRLF = CHR(10) & CHR(13)
	CheckAllPaths = True
	
	If CheckPath( ImportDialog.TemplatePath.Text ) = False And ImportDialog.TemplateCheckbox.Value Then
		iErrorCounter = iErrorCounter + 1 
		oCtrl = ImportDialog.TemplatePath
		sErrorPathName = sErrorPathName & sPathErrorTemplates( iOffice )
	End If
	
	If CheckPath( ImportDialog.MsDocumentPath.Text ) = False And ImportDialog.DocumentPathCheckbox.Value Then
		If iErrorCounter = 1 Then
			sErrorPathName = sCRLF & sErrorPathName & sCRLF
		End If
		iErrorCounter = iErrorCounter + 1 
		oCtrl = ImportDialog.MsDocumentPath
		sErrorPathName = sErrorPathName & sPathErrorDocument( iOffice )
	End If
	
	If CheckPath( ImportDialog.StarDocumentPath.Text ) = False And ImportDialog.DocumentPathCheckbox.Value Then
		If iErrorCounter = 1 Then
			sErrorPathName = sCRLF & sErrorPathName & sCRLF
		End If

		If iErrorCounter = 2 Then
			sErrorPathName = sErrorPathName & sCRLF
		End If
		iErrorCounter = iErrorCounter + 1 
		oCtrl = ImportDialog.StarDocumentPath		
		sErrorPathName = sErrorPathName & sPathErrorStarDoc( iOffice )	
	End If
	
	If iErrorCounter > 0 Then
		If iErrorCounter > 1 Then
			sErrorPathName = sErrorPathName & sCRLF
			Msgbox sMorePathsError1 & sErrorPathName, 16, sMorePathsError2
			CheckAllPaths = False
		Else
			Msgbox sOnePathError1 & sErrorPathName, 16, sOnePathError2
			CheckAllPaths = False
		End If
		oCtrl.SetFocus
	End If

End Function


Sub CheckToNoData

	bNextStepEnabled = False
	
	For iStep = 1 To 3
		If iOffice <> iStep Then
			If bCheckTemplates( iStep ) And Len( sTemplateSourceDir( iStep ) ) > 0  Then
				bNextStepEnabled = True
			End If
			
			If bCheckDocuments( iStep ) And Len( sDocumentSourceDir( iStep ) ) > 0 And Len( sStarDocumentTextboxValue( iStep ) ) > 0 Then
				bNextStepEnabled = True
			End If
		Else
			If ImportDialog.TemplateCheckbox.Value And Len( ImportDialog.TemplatePath.Text ) > 0  Then
				bNextStepEnabled = True
			End If
			
			If ImportDialog.DocumentPathCheckbox.Value And Len( ImportDialog.MsDocumentPath.Text ) > 0 And Len( ImportDialog.StarDocumentPath.Text ) > 0 Then
				bNextStepEnabled = True
			End If			
		End If
	Next iStep

	ImportDialog.NextButton.Enabled = bNextStepEnabled
	
End Sub


Function CheckPath( sPathStr As String ) As Boolean

	CheckPath = True
	
	If Len( sPathStr ) > 0 Then
		If Len( Dir( sPathStr, 16 ) ) = 0 Then
			CheckPath = False
		End If
	End If
	
End Function


Sub CancelTask()

	If Msgbox( sConvertError1, 36, sConvertError2 ) = 6 Then
		ImportDialog.Hide
		End
	Else
		bCancelTask = False
		ImportDialog.CancelButton.Enabled = True
	End If
	
End Sub


Sub CancelButtonPressed

	ImportDialog.CancelButton.Enabled = False
	bCancelTask = True
	
End Sub


Sub TemplateDirSearchDialog

	sDirName = Application.FileDialog( "P", sPathDialogMessage, ImportDialog.TemplatePath.Text )

	If Len( sDirName ) > 0 Then
		ImportDialog.TemplatePath.Text = sDirName
	End If
	
End Sub


Sub DocumentDirSearchDialog

	sDirName = Application.FileDialog( "P", sPathDialogMessage, ImportDialog.MsDocumentPath.Text )

	If Len( sDirName ) > 0 Then
		ImportDialog.MsDocumentPath.Text = sDirName
	End If
	
End Sub


Sub StarDocumentDirSearchDialog

	sDirName = Application.FileDialog( "P", sPathDialogMessage, ImportDialog.StarDocumentPath.Text )

	If Len( sDirName ) > 0 Then
		ImportDialog.StarDocumentPath.Text = sDirName
	End If
	
End Sub


Sub HelperDialog
	Application.HelperDialog = Not Application.HelperDialog	
End Sub
