'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=InitChaos0
'SBLLINK:MethodInfo=MakeExplorerObject0
'SBLLINK:MethodInfo=MakeExplorerFolderObject0
'SBLLINK:MethodInfo=MakeGroupObject0
'SBLLINK:MethodInfo=MakeGroupFolderObject0
'SBLLINK:MethodInfo=MakeViewURL0
'SBLLINK:MethodInfo=GetView0
'SBLLINK:MethodInfo=DirToURL0
'This script initalizes the explorer and sets some additional properties
'It is called whenever StarOffice starts for the first time in a specific language

Public Const DoIt = False

sub Main

	' Initialize system and Chaos
	GroupWorkplaceURL = InitChaos()

    '---------------------------------------------------------------------
    ' Now we are ready to create objects for existing groups and to modify
    ' their properties...
    '---------------------------------------------------------------------

    ConfigDirURL = DirToURL( Application.Pathsettings.Config )
    GroupDirURL  = DirToURL( Application.Pathsettings.Group )

  '---------------------------------------------------------------------
	' Setup properties of the group ( property "GroupViewConfig" ):
	' These Properties have to be set on the GroupObject
	' (use MakeGroupObject or MakeExplorerObject)
	'
	' Possible Values:
	'   1  : READONLY
	'   2  : DISABLE_VIEWSTYLE_TREE
	'   4  : DISABLE_VIEWSTYLE_SMALLICON
	'   8  : DISABLE_VIEWSTYLE_ICON
	'  16  : VIEWSTYLE_ICON
	'  32  : VIEWSTYLE_SMALLICON
	'  64  : VIEWSTYLE_TREE
	' 128  : CURRENT_GROUP
	' 1024 : TREE_WITH_DOCS
	'---------------------------------------------------------------------


	'---------------------------------------------------------------------
	' Setup background of the group ( property "BackGround" ):
	' These Properties have to be set on the GroupFolderObject
	' (use MakeGroupFolderObject or MakeExplorerFolderObject)
	'
	' This property has type WallPaper:
	'
	' Structure WallPaper members and values:
	' 	string ImageURL
	'		- The URL to an existing image file to be set as background
	'
	'   long Color
	'       - The color to be used as background. This is an 32 bit value
	'	      in the form TRGB (transparency, red, green, blue)
	'
	'	long Style
	'       - The display style of the background image.
	'		- Possible values:
	'  			 0 : NONE
	'  			 1 : TILE
	'  			 2 : CENTER
	'  			 3 : SCALE
	'  			 4 : TOP_LEFT
	'  			 5 : TOP
	'  			 6 : TOP_RIGHT
	'  			 7 : LEFT
	'  			 8 : RIGHT
	'  			 9 : BOTTOM_LEFT
	' 			10 : BOTTOM
	' 			11 : BOTTOM_RIGHT
	'---------------------------------------------------------------------

	' Get the current property value and change the parts of the structure
	' you are interseted in...


'------------------------------------language independent part

	GroupURL = GroupDirURL + "explorer.url"		'Explorer
	If FileExists(GroupURL) Then
		Group = MakeGroupObject( GroupURL )
		If Group.UserSortCriterium = "" OR DoIt Then			'only if macro is run first time or overruled
			Group.GroupViewConfig = 128 + 64					'Set active + Treeview
			Group.UserSortCriterium = "ZZZZ"

			Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
			BackGround = Group.FolderBackground
			'BackGround.Color = 16777215						'White not set-default color will be used
			Group.FolderBackground = BackGround

		'	The following part has been commented out because the settings are beeing done in the Internet Setup Wizard
		'	GroupURL = GroupDirURL + "E-mail & News"			'Work Folder
		'	If FileExists(GroupURL) Then
		'		Group = MakeGroupObject( GroupURL )
		'		Group.GroupViewConfig = 64 						'Treeview
		'		Group.UserSortCriterium = "KKK"

		'		Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
		'		BackGround = Group.FolderBackground
		'		BackGround.Color = 16777215						'White
		'		Group.FolderBackground = BackGround
		'	End If


			GroupURL = GroupDirURL + "work.url"					'Work Folder
			If FileExists(GroupURL) Then
				Group = MakeGroupObject( GroupURL )
				Group.GroupViewConfig = 1024 + 32				'show documents if set to hierarchical + Small Iconview
				Group.UserSortCriterium = "FF"

				Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
				BackGround = Group.FolderBackground
				'BackGround.ImageURL = ConfigDirURL + "mydocs.gif"
				'BackGround.Style = 1							'Tile
				BackGround.Color = RGB(255,255,204)				'Light yellow
				Group.FolderBackground = BackGround
			End If


			GroupURL = GroupDirURL + "tasks.url"				'Tasks
			If FileExists(GroupURL) Then
				Group = MakeGroupObject( GroupURL )
				Group.GroupViewConfig = 1024 + 16				'show documents if set to hierarchical + Large Iconview
				Group.UserSortCriterium = "A"

				Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
				BackGround = Group.FolderBackground
				BackGround.Color = RGB(102,102,102)				'Grey 60%
				Group.FolderBackground = BackGround

				' Positioning of the Icons
        		Dim IconPos(13) as new com.sun.star.chaos.IconPosInfo
				' Writer on top
				IconPos( 0 ).ObjectURL = ConfigDirUrl + "tasks/writer.url"
				IconPos( 0 ).PredecessorURL = ""
        		IconPos( 0 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 1 ).ObjectURL = ConfigDirUrl + "tasks/calc.url"
				IconPos( 1 ).PredecessorURL = ConfigDirUrl + "tasks/writer.url"
        		IconPos( 1 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 2 ).ObjectURL = ConfigDirUrl + "tasks/impress.url"
				IconPos( 2 ).PredecessorURL = ConfigDirUrl + "tasks/calc.url"
        		IconPos( 2 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 3 ).ObjectURL = ConfigDirUrl + "tasks/draw.url"
				IconPos( 3 ).PredecessorURL = ConfigDirUrl + "tasks/impress.url"
        		IconPos( 3 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 4 ).ObjectURL = ConfigDirUrl + "tasks/html.url"
				IconPos( 4 ).PredecessorURL = ConfigDirUrl + "tasks/draw.url"
        		IconPos( 4 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 5 ).ObjectURL = ConfigDirUrl + "tasks/mail.url"
				IconPos( 5 ).PredecessorURL = ConfigDirUrl + "tasks/html.url"
        		IconPos( 5 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 6 ).ObjectURL = ConfigDirUrl + "tasks/frameset.url"
				IconPos( 6 ).PredecessorURL = ConfigDirUrl + "tasks/mail.url"
        		IconPos( 6 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 7 ).ObjectURL = ConfigDirUrl + "tasks/global.url"
				IconPos( 7 ).PredecessorURL = ConfigDirUrl + "tasks/frameset.url"
        		IconPos( 7 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 8 ).ObjectURL = ConfigDirUrl + "tasks/dbase.url"
				IconPos( 8 ).PredecessorURL = ConfigDirUrl + "tasks/global.url"
        		IconPos( 8 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 9 ).ObjectURL = ConfigDirUrl + "tasks/chart.url"
				IconPos( 9 ).PredecessorURL = ConfigDirUrl + "tasks/dbase.url"
        		IconPos( 9 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 10 ).ObjectURL = ConfigDirUrl + "tasks/image.url"
				IconPos( 10 ).PredecessorURL = ConfigDirUrl + "tasks/chart.url"
        		IconPos( 10 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 11 ).ObjectURL = ConfigDirUrl + "tasks/formula.url"
				IconPos( 11 ).PredecessorURL = ConfigDirUrl + "tasks/image.url"
        		IconPos( 11 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 12 ).ObjectURL = ConfigDirUrl + "tasks/tasks.url"
				IconPos( 12 ).PredecessorURL = ConfigDirUrl + "tasks/formula.url"
        		IconPos( 12 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				IconPos( 13 ).ObjectURL = ConfigDirUrl + "tasks/events.url"
				IconPos( 13 ).PredecessorURL = ConfigDirUrl + "tasks/tasks.url"
        		IconPos( 13 ).Mode = com.sun.star.chaos.IconPosMode.HAS_PREDECESSOR
				Group.GroupViewIconPos = IconPos()
			End If


			'set background image for the desktop
			GroupURL = SubstPathVars("$(userurl)") + "/desktop/"
			If FileExists(GroupURL) Then
				Application.LoadLibrary("tools")
				' Read the configuration data of the grid pattern out of the ini-file.
				oSpecConMan = CreateUnoService( "com.sun.star.config.SpecialConfigManager" ).RootKey
				sGridString = oSpecConMan.openKey( "soffice-View/IconView-GridSize" ).StringValue
				CoordList = ArrayoutofString(sGridString,";",2)
				xCoord = Val(CoordList(0))
				yCoord = Val(CoordList(1))
				zCoord = Val(CoordList(2))

				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "desk_bck.gif"
				'BackGround.Color = 16777215						'White not set-default color will be used
				BackGround.Style = 11								'bottom right
				Folder.FolderBackground = BackGround
				'positioning desktop icons:
				Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )

				Dim DesktopIconPos(11) as new com.sun.star.chaos.IconPosInfo
				DesktopIconPos( 0 ).ObjectURL = GroupURL + "writer.url"
        		DesktopIconPos( 0 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 0 ).X = 0
				DesktopIconPos( 0 ).Y = 10

				DesktopIconPos( 1 ).ObjectURL = GroupURL + "calc.url"
        		DesktopIconPos( 1 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 1 ).X = xCoord
				DesktopIconPos( 1 ).Y = 10

				DesktopIconPos( 2 ).ObjectURL = GroupURL + "impress.url"
        		DesktopIconPos( 2 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 2 ).X = xCoord * 2
				DesktopIconPos( 2 ).Y = 10

				DesktopIconPos( 3 ).ObjectURL = GroupURL + "draw.url"
        		DesktopIconPos( 3 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 3 ).X = xCoord * 3
				DesktopIconPos( 3 ).Y = 10

				DesktopIconPos( 4 ).ObjectURL = GroupURL + "web.url"
        		DesktopIconPos( 4 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 4 ).X = 0
				DesktopIconPos( 4 ).Y = 10 + yCoord

				DesktopIconPos( 5 ).ObjectURL = GroupURL + "mail.url"
        		DesktopIconPos( 5 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 5 ).X = xCoord
				DesktopIconPos( 5 ).Y = 10 + yCoord

				DesktopIconPos( 6 ).ObjectURL = GroupURL + "tasks.url"
        		DesktopIconPos( 6 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 6 ).X = xCoord * 2
				DesktopIconPos( 6 ).Y = 10 + yCoord

				DesktopIconPos( 7 ).ObjectURL = GroupURL + "events.url"
        		DesktopIconPos( 7 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 7 ).X = xCoord * 3
				DesktopIconPos( 7 ).Y = 10 + yCoord

				DesktopIconPos( 8 ).ObjectURL = GroupURL + "staroffi.url"
        		DesktopIconPos( 8 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 8 ).X = 0
				DesktopIconPos( 8 ).Y = 10 + (3 * yCoord)

				DesktopIconPos( 9 ).ObjectURL = GroupURL + "sun.url"
        		DesktopIconPos( 9 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 9 ).X = xCoord
				DesktopIconPos( 9 ).Y = 10 + (3 * yCoord)

				DesktopIconPos( 10 ).ObjectURL = GroupURL + "sforum.url"
				DesktopIconPos( 10 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 10 ).X = xCoord * 2
				DesktopIconPos( 10 ).Y = 10 + (3 * yCoord)

				DesktopIconPos( 11 ).ObjectURL = GroupURL + "psetup.url"
				DesktopIconPos( 11 ).Mode = com.sun.star.chaos.IconPosMode.NONE
				DesktopIconPos( 11 ).X = xCoord * 3
				DesktopIconPos( 11 ).Y = 10 + (3 * yCoord)

				Group.FolderWinIconPos = DesktopIconPos()
			End If
		End If
	End If

'--------------------------------language dependent part

  SamplesDir = SubstPathVars("$(insturl)") + "/share/samples/" + SubstPathVars("$(vlang)") + "/"

  GroupURL = SamplesDir + "menu"   'Samples-Menu
	If FileExists(GroupURL) Then
		Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
		BackGround = Group.FolderBackground
		If BackGround.Color = -1 OR DoIt Then			'only if macro is run first time in this language or overruled
			GroupURL = GroupDirURL + "bookmark.url"		'Bookmarks
			Group = MakeGroupObject( GroupURL )
			Group.GroupViewConfig = 1024 + 64			'Tree with Docs + Treestyle
			Group.UserSortCriterium = "UUU"
			Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
			BackGround = Group.FolderBackground
			BackGround.Color = RGB(230,230,230)			'Grey 10%
			Group.FolderBackground = BackGround



      		GroupURL = SamplesDir + "menu"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "sam_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If


			GroupURL = SamplesDir + "databases"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "base_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If


			GroupURL = SamplesDir + "drawings"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "draw_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If


			GroupURL = SamplesDir + "formulas"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "math_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If


			GroupURL = SamplesDir + "presentations"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "impr_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If


			GroupURL = SamplesDir + "spreadsheets"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "calc_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If


			GroupURL = SamplesDir + "texts"
			If FileExists(GroupURL) Then
				Folder = MakeExplorerFolderObject(GroupURL)
				BackGround = Folder.FolderBackground
				BackGround.ImageURL = ConfigDirURL + "writ_bck.gif"
				BackGround.Color = 16777215						'White
				BackGround.Style = 11							'bottom right
				Folder.FolderBackground = BackGround
			End If

		End If
	End If
End Sub

'-------------------------------------------------------------------------
'-------------------------------------------------------------------------
'-------------------------------------------------------------------------

dim CHAOS as Object
dim GroupWorkplaceURL as String
dim ExplorerWorkplaceURL as String


'-------------------------------------------------------------------------
Function InitChaos

	'---------------------------------------------------------------------
	' Get the CHAOS System object.
	'---------------------------------------------------------------------
	CHAOS = createUNOService( "com.sun.star.chaos.System" )

	'---------------------------------------------------------------------
	' Get/Create Workplace objects in config and explorer directory of
	' the Office installation.
	'---------------------------------------------------------------------
    ViewAnchor = GetView( DirToURL( Application.Pathsettings.Explorer ), ".chaos/fsys-box" )
    ExplorerWorkplaceURL = ViewAnchor.URL

' z.Z. benutzen Schwipp-Schwapp und Explorer-Arbeitsplatz dieselbe scc-Datei
'    ViewAnchor = GetView( DirToURL( Application.Pathsettings.Config ), ".chaos/fsys-box" )
    InitChaos = ViewAnchor.URL

End Function


'-------------------------------------------------------------------------
Function MakeExplorerObject( ExplorerURL ) as Object

	MakeExplorerObject = CHAOS.createAnchor( MakeViewURL( ExplorerWorkplaceURL, ExplorerURL ) )

End Function


'-------------------------------------------------------------------------
Function MakeExplorerFolderObject( ExplorerURL ) as Object

	do
		MakeExplorerFolderObject = CHAOS.createAnchor( MakeViewURL( ExplorerWorkplaceURL, ExplorerURL ) )

		' Is object a link?
		if ( MakeExplorerFolderObject.getPropertySetInfo().hasPropertyByName( "TargetURL" ) ) then
			TargetURL = MakeExplorerFolderObject.TargetURL
		else
			TargetURL = ""
		end if

		if len( TargetURL ) then
			' Resolve link.
			ExplorerURL = TargetURL
		end if
	loop while ( len( TargetURL ) > 0 )

End Function


'-------------------------------------------------------------------------
Function MakeGroupObject( GroupURL ) as Object

	MakeGroupObject = CHAOS.createAnchor( MakeViewURL( GroupWorkplaceURL, GroupURL ) )

End Function


'-------------------------------------------------------------------------
Function MakeGroupFolderObject( GroupURL, GroupWorkplaceURL ) as Object

	do
		MakeGroupFolderObject = CHAOS.createAnchor( MakeViewURL( GroupWorkplaceURL, GroupURL ) )

		' Is object a link?
		if ( MakeGroupFolderObject.getPropertySetInfo().hasPropertyByName( "TargetURL" ) ) then
			TargetURL = MakeGroupFolderObject.TargetURL
		else
			TargetURL = ""
		end if

		if len( TargetURL ) then
			' Resolve link.
			GroupURL = TargetURL
		end if
	loop while ( len( TargetURL ) > 0 )

End Function


'-------------------------------------------------------------------------
Function MakeViewURL( RootURL, URL ) as String

	MakeViewURL = RootURL + "#" + URL

End Function


'-------------------------------------------------------------------------
Function GetView( DirURL, ViewType ) As Object

	'---------------------------------------------------------------------
	' Try to get an object of given type in the specified directory.
	' If no such object exists, create one.
	'---------------------------------------------------------------------
	Views = CHAOS.queryViews( DirURL, ViewType )

	' Is array empty?
	' 	Sieht total falsch aus, ist aber lt. AB korrekt!!! ubound() einer
	'   Sequence ist -1 !!!
	count = ubound( Views ) + 1
	if count then
		' Use existing object
		GetView = CHAOS.createAnchor( Views( 0 ) )
	else
		' Create Workplace object and make it persistent
		FolderAnchor = CHAOS.createAnchor( DirURL )
		GetView = FolderAnchor.create( ViewType )
		GetView.execute( "insert", 0, NULL )
	end if
End Function


'-------------------------------------------------------------------------
Function DirToURL( sDosPath ) As String

	Dim iPos As Integer
	Dim sURLPath As String

	sURLPath = sDosPath
	If lCase( Left( sDosPath, 5 ) ) <> "file:" Then
		Do
			iPos = InStr( sURLPath, "\" )
			If iPos > 0 Then
				Mid( sURLPath, iPos, 1, "/" )
			End If
		Loop While iPos > 0

		If Instr( sURLPath, ":" ) > 0 Then
			sURLPath = "file:///" & Left( sURLPath, 1 ) & "|" & Mid( sURLPath, 3 )
		Else
			sURLPath = "file://" & sURLPath
		End If
	End If

	' Append final slash to directory URL.
	if Right( sURLPath, 1 ) <> "/" then
		sURLPath = sURLPath & "/"
	end if

	DirToURL = sURLPath

End Function
