'SBLLINK:MethodInfo=ReportView_Create0
'SBLLINK:MethodInfo=ReportView_CreateTableForGroup0
'SBLLINK:MethodInfo=ReportView_CreateTableForColumn0
'SBLLINK:MethodInfo=ReportView_TwipToCM0
'SBLLINK:MethodInfo=ReportView_createTempFilename0
Option Explicit

' Strings
const sDBGroupCount = "DBGroupCount", sDBGroupField = "DBGroupField_"
const sDBFieldCount = "DBFieldCount", sDBFieldName = "DBFieldName_"
const sDBName = "DB_Name", sDBTable = "DB_Table", sSQLStatement = "DB_SQLStatement"
const sDBQuery = "DB_Query_Name"
const sDBReport = "ReportStyle", sDBReportDefinied = "DB_ReportDefined"
const sTblReportBody = "body", sTblReportGroup = "group"
const sParaBehindTable = "ParaBehindTable", sParaBeforeTable = "ParaBeforeTable"
const sPageLandscape = "First Page Landscape", sPagePortrait = "First Page Portrait"
const sFrameStyleName = "Image_"
const sAutoTextGroupName = "$$repwiz$$tmp$$", sAutoTextName = "Report"
const sAutoTextBdyShort = "RepWizBdyTbl"

const cStyleTable = 1, cStyleColumn = 2                 ' == cTabular=1,cColumnar=2
const cStyleOutline1 = 5, cStyleOutline2 = 6            ' == cLeft1Justified=5,cLeft2Justified=6
const cStyleLeft1 = 7, cStyleLeft2 = 8                  ' == cStyle1=7,cStyle2=8
const cStyleStepped = 3, cStyleBlock = 4                        ' == cOrganized=3,cJustified=4

const cMaxGroups = 4
const cMaxFieldIndex% = 200
const cTwipPerChar% = 140

DIM aStyleNames$( 0 to cMaxFieldIndex% )

'       Page Setup
Const cLandscape = 1, cPortrait = 2

' ----------------------------------------------------

Function ReportView_Create( BYVAL nGroupCnt%, aGroups$(), aGroupChars(), _
		BYVAL nFldCnt%, aFields$(), aFieldChars(), BYVAL sDBNm$, _
		BYVAL sTblNm$, BYVAL sSQL$, BYVAL sFileStr$, BYVAL nStyle%, _
		BYVAL sReportTitle$, BYVAL nOrientation%, BYVAL sQuerName$ ) as string

	DIM n%, sFileName$, sTmp$, bUndo%, nOldMetric%
	DIM aTempFields$( 0 to nGroupCnt% + nFldCnt% )
	DIM aTempChars%( 0 to nGroupCnt% + nFldCnt% )

	select case nStyle%
	case cStyleTable
		sFileName$ = "repnrml"
	case cStyleBlock
		sFileName$ = "repblock"
	case cStyleColumn
		sFileName$ = "repclmn"
	case cStyleOutline1
		sFileName$ = "repoutl1"
	case cStyleOutline2
		sFileName$ = "repoutl2"
	case cStyleLeft1
		sFileName$ = "repleft1"
	case cStyleLeft2
		sFileName$ = "repleft2"
	case cStyleStepped
		sFileName$ = "repstep"
	case else
		sFileName$ = ""
	end select

	if( 0 <> len( sFileName$ ) ) then

		Application.EnterWait()

		documents.open( TemplatePath$ + GetPathSeparator() + "wizard" + GetPathSeparator() + sFileName$ + ".vor" )

		If ActiveDocument.ReadOnly=FALSE Then
			Application.DesignerDialog = FALSE
		End If
		Application.Navigator = FALSE

		bUndo% = Selection.UndoMode
		Selection.UndoMode = FALSE

		nOldMetric% = StarWriter.MetricUnit
		StarWriter.MetricUnit = 2               ' Unit to Centimeters

		' cg:15->11. Keine Seitenvorlagen laden
		ActiveDocument.LoadStyles( TemplatePath$ + GetPathSeparator() + "wizard" + GetPathSeparator() + sFileStr$, 11 )

		ActiveWindow.LockPaint( TRUE )
		ActiveWindow.ShowCursor = FALSE

		Selection.SetUserFieldValue( sDBGroupCount, trim( str( nGroupCnt% )) )
		for n% = 0 to nGroupCnt%-1
			Selection.SetUserFieldValue( sDBGroupField + trim( str( n% )), aGroups$(n%) )
		next n%

		Selection.SetUserFieldValue( sDBFieldCount, trim( str( nFldCnt% )) )
		for n% = 0 to nFldCnt%-1
			sTmp$ = trim( str( n% ))
			Selection.SetUserFieldValue( sDBFieldName + sTmp$, aFields$(n%) )
			if( "IMAGE" = Application.DataColumnType( aFields$(n%) )) then
				aStyleNames$( n% ) = sFrameStyleName + sTmp$
				ActiveDocument.NewStyle( aStyleNames$( n% ), 4 )
			else
				aStyleNames$( n% ) = ""
			end if
		next n%

		Selection.SetUserFieldValue( sDBName, sDBNm$ )
		Selection.SetUserFieldValue( sDBTable, sTblNm$ )
		Selection.SetUserFieldValue( sDBQuery, sQuerName$ )
		Selection.SetUserFieldValue( sSQLStatement, sSQL$ )
		Selection.SetUserFieldValue( sDBReport, nStyle% )

		' Turn off Layout Beeps
		Application.GetDocManPath( "~~~SetNoFrameBeep" )

	' Set correct page template
		if( cLandscape = nOrientation% ) then
			sTmp$ = sPageLandscape
		else
			sTmp$ = sPagePortrait
		endif
		ActiveWindow.PageStyleApply( sTmp$ )

		' Set up data in the header
		Selection.JumpToStartOfDoc()
		Selection.JumpToHeader()
		Selection.Insert( sReportTitle$ )

		select case nStyle%
		case cStyleBlock, cStyleTable, cStyleStepped

			for n% = 0 to nGroupCnt% - 1
				aTempFields$( n% ) = aGroups$( n% )
				aTempChars%( n% ) = aGroupChars( n% )
			next n%
			for n% = n% to nFldCnt% + nGroupCnt% - 1
				aTempFields$( n% ) = aFields$( n% - nGroupCnt%)
				aTempChars%( n% ) = aFieldChars( n% - nGroupCnt%)
			next n%

			if( cStyleStepped = nStyle% ) then
				ReportView_CreateTableForGroup( nStyle%, nGroupCnt%, nGroupCnt% + nFldCnt%, aTempFields$(), aTempChars%() )
			else
				ReportView_CreateTableForGroup( nStyle%, 0, nGroupCnt% + nFldCnt%, aTempFields$(), aTempChars%() )
			endif

		case cStyleOutline1, cStyleOutline2, cStyleLeft1        , cStyleLeft2
			ReportView_CreateTableForGroup( nStyle%, nGroupCnt%, nFldCnt%, aFields$(), aFieldChars() )

		case cStyleColumn
			ReportView_CreateTableForColumn( nFldCnt%, aFields$(), aFieldChars() )

		end select

		Selection.SetUserFieldValue( sDBReportDefinied, "Defined" )
		sFileName$ = application.pathsettings.database + GetPathSeparator() + ReportView_createTempFilename$ + ".sdw"

		Selection.UndoMode = bUndo%

		StarWriter.MetricUnit = nOldMetric%

		ActiveWindow.LockPaint( False ) 'cg:new
		activedocument.close( true, sFileName$ )
		Wait( 1 )

		ON local Error goto ErrHdl_ReportView_Create

		SetAttr( sFileName$, 1 )
		Application.LeaveWait()

	else
		sFileName$ = ""
	end if

	ReportView_Create = sFileName$
	exit function

ErrHdl_ReportView_Create:
	if( 53 = err ) then
		' Setting of ReadOnly unsuccessful, file is being accessed
		' wait until it works
		resume 0
	endif
End function


'*******************************************************************************************

sub ReportView_CreateTableForGroup( BYVAL nStyle%, BYVAL nGroupCnt%, _
							BYVAL nFldCnt%, aFields$(), aFieldChars())
	' ******************************************************************
	'       Divide the table into appropriate columns based on the entry
	'       parameters, depending on the relative field sizes
	' ******************************************************************
	Dim i%, n%, bBreak%

	Selection.GotoTable( sTblReportBody )

	if( cStyleStepped = nStyle% ) THEN

		for i% = 0 to nGroupCnt% - 1
			Selection.setcolumnwidth( i%, "1mm" )
'JP 10.07.97: ist in der Vorlage schon gesetzt
'                       if( "TEXT" = Application.DataColumnType( aFields$( i% ) ) ) then
'                               selection.GoDown( 1, TRUE )
'                               Selection.NumberFormat = "@"
'                               selection.GoUp( 1, FALSE )
'                       else
'                               Selection.NumberFormat = "@"
'                       endif
			Selection.Insert( aFields$( i% ) )
			Selection.JumpToNextCell()
		next i%

		if( i% < cMaxGroups ) then
			Selection.JumpToPrevCell()
			selection.insertbookmark( "_savepos" )

			for n% = i% to cMaxGroups - 1
				selection.jumptobookmark( "_savepos" )
				Selection.JumpToNextCell()
				selection.DeleteColumns()
			next n%

			selection.jumptobookmark( "_savepos" )
			selection.DeleteBookmark( "_savepos" )
			Selection.JumpToNextCell()
		endif

		for i% = i% to nFldCnt% - 1
			if(i% < nFldCnt% - 1) then

				selection.insertbookmark( "_savepos" )
				selection.godown( 1, TRUE )
				Selection.SplitCell(TRUE, 1)


				selection.jumptobookmark( "_savepos" )
				selection.deletebookmark( "_savepos" )
			endif

			if( 1 < nFldCnt% ) then selection.setcolumnwidth ( i%, "1mm" )

'JP 10.07.97: ist in der Vorlage schon gesetzt
'                       if( "TEXT" = Application.DataColumnType( aFields$( i% ) ) ) then
'                               selection.GoDown( 1, TRUE )
'                               Selection.NumberFormat = "@"
'                               selection.GoUp( 1, FALSE )
'                       else
'                               Selection.NumberFormat = "@"
'                       endif

			Selection.Insert(aFields$(i%))
			Selection.JumpToNextCell()

		next i%

	else

		for i% = 0 to nFldCnt% - 1
			if(i% < nFldCnt% - 1) then

				selection.insertbookmark( "_savepos" )
				selection.godown( 1, TRUE )
				Selection.SplitCell(TRUE, 1)

				selection.jumptobookmark( "_savepos" )
				selection.deletebookmark( "_savepos" )
			endif

			if( 1 < nFldCnt% ) then selection.setcolumnwidth        ( i%, "1mm" )

'JP 10.07.97: ist in der Vorlage schon gesetzt
'                       if( "TEXT" = Application.DataColumnType( aFields$( i% ) ) ) then
'                               selection.GoDown( 1, TRUE )
'                               Selection.NumberFormat = "@"
'                               selection.GoUp( 1, FALSE )
'                       else
'                               Selection.NumberFormat = "@"
'                       endif

			Selection.Insert(aFields$(i%))
			Selection.JumpToNextCell()

		next i%
	endif

	' new: The columns now have to be adjusted to the MinMax calculation of
	'               the first 10 data records. For this, take 10 data records in
    '           the table and then later remove them.
	Selection.ActionStart()
	Selection.GotoCell("A2")
	if( Application.DataFirstRecord() ) then
		i% = 0
		bBreak% = 0
		while( i% < 10 and 1 <> bBreak% )

			if i% <> 0 then         Selection.JumpToNextCell()

			for n% = 0 to nFldCnt% - 1

				Selection.InsertDBColumnContent( aFields$( n% ), aStyleNames$( n% ) )

				if n% <> nFldCnt%-1 then
					Selection.JumpToNextCell()
				end if
			next n%
			if( 0 = Application.DataNextRecord() ) then
				bBreak% = 1
			endif
			i% = i% + 1
		wend
	else
		i% = 1
	endif

	Selection.TableOptimizeMinMax()
	Selection.GotoCell("A2")

	i% = i% - 1
	while( 0 < i% )
		Selection.DeleteRows()
		i% = i% - 1
	wend

	Selection.ActionEnd()
	Selection.EntireRow()
	Selection.Delete()

	' Once the columns are to some extent divided up, the table is now relative
	Selection.WidthPercent = 100
    Selection.Alignment = 1 ' right alignment

	if( cStyleTable <> nStyle% AND cStyleBlock <> nStyle% AND cStyleStepped <> nStyle% ) then

		with Selection
			.GotoCell("A1")
			.leftmargin = ReportView_TwipToCM(nGroupCnt%  * 567)

			.GotoTable(sTblReportGroup)
'JP 10.07.97: ist in der Vorlage schon gesetzt
'                       .SelectAll()
'                       .NumberFormat = "@"
			.GotoCell("A1")

			.GoDown( nGroupCnt% )
			for i% = nGroupCnt% to cMaxGroups - 1
				Selection.DeleteRows()
			next i%
		end with
	endif

end sub

'*******************************************************************************************
'*******************************************************************************************

sub ReportView_CreateTableForColumn( BYVAL nFieldCnt%, aFields$(), aFieldChars())

	'       Insert a separate table for every column

	Dim i%, nMaxFldLen%, nTblWidth%, nAktChars%

	Selection.GotoTable(sTblReportGroup)

	for i% = 0 to nFieldCnt - 1
		if Len(aFields$(i%)) > nMaxFldLen% then
			nMaxFldLen = Len(aFields$(i%))
		endif
	next i%

	nMaxFldLen% = nMaxFldLen% * cTwipPerChar%
	' no more than 5 cm
	if nMaxFldLen% >  2835 then
		nMaxFldLen% = 2835
	endif

	for i% = 0 to nFieldCnt - 1

		if i% > 0 then
			if i% = 1 then
				' Now get the Body table
				Selection.GotoTable(sTblReportBody)
				Selection.Select()
				Selection.CreateGlossaryGroup( sAutoTextGroupName )
				Selection.NewGlossary( sAutoTextGroupName, sAutoTextName, sAutoTextBdyShort )
				Selection.GoRight()
			else
				Selection.ExpandGlossary( sAutoTextBdyShort )
				Selection.StyleApply( sParaBehindTable, 2 )
			endif
			Selection.jumptoPrevTable
		endif
		Selection.TableName = aFields(i%)
		nTblWidth% = Selection.Width
		nTblWidth% = nTblWidth%  * 567
		Selection.Alignment = 3 ' left alignment
		nAktChars% = aFieldChars(i%)

		if nAktChars% * cTwipPerChar + nMaxFldLen%  < nTblWidth% - 250 then
			Selection.RightMargin = ReportView_TwipToCM(nTblWidth% - nAktChars% * cTwipPerChar - nMaxFldLen%)
		else
			Selection.RightMargin= ReportView_TwipToCM(250)
		endif
		selection.setcolumnwidth        ( 0, ReportView_TwipToCM(nMaxFldLen%))

'JP 10.07.97: ist in der Vorlage schon gesetzt
'               if( "TEXT" = Application.DataColumnType( aFields$( i% ) ) ) then
'                       selection.GoRight( 1, TRUE )
'                       Selection.NumberFormat = "@"
'                       selection.GoLeft( 1, FALSE )
'               else
'                       Selection.NumberFormat = "@"
'               endif

		Selection.Insert(aFields(i%))
		Selection.GoDown()

	next i%
	Selection.DeleteGlossaryGroup( sAutoTextGroupName )
end sub

'*******************************************************************************************

'*******************************************************************************************

Function ReportView_TwipToCM( BYVAL nValue as long ) as String
	if( 56 > nValue ) then
		ReportView_TwipToCM = "0.1cm"
	else
		ReportView_TwipToCM = trim(str( nValue / 567 )) + "cm"
	endif
end function

function ReportView_createTempFilename$
	DIM sStr$, n%, cChar%
	DIM nDateVal, nTimeVal as long

	randomize()

	sStr$ = Date
	nDateVal = 0
	for n% = 1 to len( sStr$ )
		cChar% = asc(mid$( sStr$, n%, 1 ))
		if( 48 <= cChar and cChar <= 57  ) then
			nDateVal = nDateVal * 10 + ( cChar - 48 )
		endif
	next n%

	sStr$ = Time
	nTimeVal = 0
	for n% = 1 to len( sStr$ )
		cChar% = asc(mid$( sStr$, n%, 1 ))
		if( 48 <= cChar and cChar <= 57  ) then
			nTimeVal = nTimeVal * 10 + ( cChar - 48 )
		endif
	next n%
	if( 0 = nTimeVal ) then nTimeVal = 1

	ReportView_createTempFilename$ = Left(Trim(Str(Int(10000 * Rnd * nDateVal / nTimeVal ))),7)
end function

'*******************************************************************************************
