'SBLLINK:MethodInfo=SetFieldType0
'SBLLINK:MethodInfo=GetFieldTypeAsString0
'SBLLINK:MethodInfo=GetFieldTypeAsInteger0
'SBLLINK:MethodInfo=GetFieldTypeAsLong0
'SBLLINK:MethodInfo=GetFieldTypeAsBoolean0
'SBLLINK:MethodInfo=getFieldType_TextRows0
'SBLLINK:MethodInfo=getFieldType_TextColumns0
'SBLLINK:MethodInfo=getFieldType_StartTimeOnly0
'SBLLINK:MethodInfo=getFieldType_AMPM0
'SBLLINK:MethodInfo=getFieldType_FixTableHeight0
'SBLLINK:MethodInfo=getFieldType_CheckLocation0
'SBLLINK:MethodInfo=getFieldType_DayEventPoint0
'SBLLINK:MethodInfo=getFieldType_CheckAllDaysVisible0
'SBLLINK:MethodInfo=getFieldType_CheckCombined0
'SBLLINK:MethodInfo=getFieldType_CheckWeekEndCompressed0
'SBLLINK:MethodInfo=TranslateStyle0
'SBLLINK:MethodInfo=TranslateWeekDay0
'SBLLINK:MethodInfo=FillHeadAndFoot0
'SBLLINK:MethodInfo=SetDayTitle0
'SBLLINK:MethodInfo=calcPageHeight0
'SBLLINK:MethodInfo=PrintPreview0
'SBLLINK:MethodInfo=IndexToString0
'SBLLINK:MethodInfo=ReplaceString0
'SBLLINK:MethodInfo=rinstr0
'SBLLINK:MethodInfo=ClearDocument0
'SBLLINK:MethodInfo=SetDayEvent0
'SBLLINK:MethodInfo=SetEvent0
'SBLLINK:MethodInfo=ChapterTitle0
'SBLLINK:MethodInfo=InsertLastLine0
'SBLLINK:MethodInfo=HiddenLine0
'SBLLINK:MethodInfo=IsDebugMode0
'SBLLINK:MethodInfo=getFieldType_TitleHeight0
'SBLLINK:MethodInfo=getFieldType_PageHeightSub0
'SBLLINK:MethodInfo=deleteFilterEvents0
'SBLLINK:MethodInfo=deleteFilterTasks0
'SBLLINK:MethodInfo=DEL_CreateEventScheduleCursor0
'SBLLINK:MethodInfo=DEL_CreateTaskScheduleCursor0
'SBLLINK:MethodInfo=DEL_DropAll0
'SBLLINK:MethodInfo=DEL_Language0
'SBLLINK:MethodInfo=DEL_InitIndicator0
'SBLLINK:MethodInfo=DEL_CloseIndicator0
'SBLLINK:MethodInfo=DEL_SetIndicatorValue0
'SBLLINK:MethodInfo=GetWorkPath0
' OPTION EXPLICIT
' $Revision: 1.1.1.1 $

' Verschiedene Funktionen, die im SchedulePrint Modul Anwendung finden

' ------------------------------------------------------------------------------
' Setzen eines FeldTypen
' ------------------------------------------------------------------------------
Sub SetFieldType(aDoc as Object, aName as String, aValue as String)
	' POST: setzen eines Benutzerfeldes
	Dim aMaster as Object
	Dim aFieldName as String
	aMaster = aDoc.TextFieldMasters
	aFieldName = "com.sun.star.text.FieldMaster.User." + aName
	
	if (aMaster.HasByName(aFieldName)) then
		aUserField = aMaster.GetByName(aFieldName)
		aUserField.content = aValue
	else
		'die FieldMaster koennen erst verwendet werden, wenn sie einen Namen haben
		'dieser Name kann danach nicht mehr geaendert werden
		aUserField = aDoc.createinstance("com.sun.star.text.FieldMaster.User")
		aUserField.Name = aName
		aUserField.Content = aValue
	endif
End Sub
' ------------------------------------------------------------------------------
' Holen eines FeldTypen aus dem Dokument
' ------------------------------------------------------------------------------
Function GetFieldTypeAsString(aDoc as Object, aName as String, aDefault as String) as String
	Dim aMaster as Object
	Dim aFieldName as String
	aMaster = aDoc.TextFieldMasters
	aFieldName = "com.sun.star.text.FieldMaster.User." + aName
	
	if (aMaster.HasByName(aFieldName)) then
		aUserField = aMaster.GetByName(aFieldName)
		GetFieldTypeAsString = aUserField.content
	else
		GetFieldTypeAsString = aDefault
	endif
End Function
' --------------------------------------------------------------------------------
Function GetFieldTypeAsInteger(aDoc as Object, aName as String, nDefault as Integer) as Integer
	Dim aMaster as Object
	Dim aFieldName as String
	aMaster = aDoc.TextFieldMasters
	aFieldName = "com.sun.star.text.FieldMaster.User." + aName
	
	if (aMaster.HasByName(aFieldName)) then
		aUserField = aMaster.GetByName(aFieldName)
		GetFieldTypeAsInteger = aUserField.content
	else
		GetFieldTypeAsInteger = nDefault
	endif
End Function
' --------------------------------------------------------------------------------
Function GetFieldTypeAsLong(aDoc as Object, aName as String, nDefault as Long) as Long
	Dim aMaster as Object
	Dim aFieldName as String
	aMaster = aDoc.TextFieldMasters
	aFieldName = "com.sun.star.text.FieldMaster.User." + aName
	
	if (aMaster.HasByName(aFieldName)) then
		aUserField = aMaster.GetByName(aFieldName)
		GetFieldTypeAsLong = aUserField.content
	else
		GetFieldTypeAsLong = nDefault
	endif
End Function
' --------------------------------------------------------------------------------
Function GetFieldTypeAsBoolean(aDoc as Object, aName as String, bDefault as Boolean) as Boolean
	Dim aMaster as Object
	Dim aFieldName as String
	aMaster = aDoc.TextFieldMasters
	aFieldName = "com.sun.star.text.FieldMaster.User." + aName
	
	if (aMaster.HasByName(aFieldName)) then
		aUserField = aMaster.GetByName(aFieldName)
		GetFieldTypeAsBoolean = aUserField.content
	else
		GetFieldTypeAsBoolean = bDefault
	endif
End Function

' ------------------------------------------------------------------------------
Function getFieldType_TextRows(aDoc as Object) as Integer
	getFieldType_TextRows = GetFieldTypeAsInteger(aDoc, "TextRows", 1)
end Function
' --------------------------------------------------------------------------------
Function getFieldType_TextColumns(aDoc as Object) as Integer
	getFieldType_TextColumns = GetFieldTypeAsInteger(aDoc, "TextColumns", 1)
end function
' --------------------------------------------------------------------------------
Function getFieldType_StartTimeOnly(aDoc as Object) as Boolean
	' 0: 00:00		   nur Startzeit
	' 1: 00:00 - 01:00 Start und Endzeit
	getFieldType_StartTimeOnly= GetFieldTypeAsBoolean(aDoc, "bStartTimeOnly", FALSE)
end function
' --------------------------------------------------------------------------------
Function getFieldType_AMPM(aDoc as Object) as Boolean
	' 0 normal (AM, PM)
	' 1 Short (a/p)
	getFieldType_AMPM = GetFieldTypeAsBoolean(aDoc, "bAMPM", FALSE)
end function
' --------------------------------------------------------------------------------
Function getFieldType_FixTableHeight(aDoc as Object) as Boolean
	' 0: no
	getFieldType_FixTableHeight = GetFieldTypeAsBoolean(aDoc, "bCheckTableHeight", FALSE)
end function
' --------------------------------------------------------------------------------
Function getFieldType_CheckLocation(aDoc as Object) as Boolean
	' 0: Title
	' 1: Title(Location)
	getFieldType_CheckLocation = GetFieldTypeAsBoolean(aDoc, "bCheckLocation", TRUE)
end function
' --------------------------------------------------------------------------------
Function getFieldType_DayEventPoint(aDoc as Object) as String

	getFieldType_DayEventPoint = GetFieldTypeAsString(aDoc, "sDayEventPoint", chr$(149))
end function
' --------------------------------------------------------------------------------
Function getFieldType_CheckAllDaysVisible(aDoc as Object) as Boolean
	' 0: Tage auserhalb eines Monats werden nicht eingetragen
	' 1: gegenteil
	getFieldType_CheckAllDaysVisible = GetFieldTypeAsBoolean(aDoc, "bCheckAllDaysVisible", TRUE)
end function
' --------------------------------------------------------------------------------
Function getFieldType_CheckCombined(aDoc as Object) as Boolean
	' 0: no
	getFieldType_CheckCombined = GetFieldTypeAsBoolean(aDoc, "bCheckCombined", FALSE)
end function
' --------------------------------------------------------------------------------
Function getFieldType_CheckWeekEndCompressed(aDoc as Object) as Boolean
	' 0: no
	getFieldType_CheckWeekEndCompressed = GetFieldTypeAsBoolean(aDoc, "bCheckWeekEndCompress", FALSE)
end function

' --------------------------------------------------------------------------------
' ParaStyle / CharStyle uebersetzen
' --------------------------------------------------------------------------------
Function TranslateStyle(sStyle as String) as String
	' POST: uebersetzen des angegebenen Styles
	if (left(sStyle,1) = "_") then
		TranslateStyle = sStyle
	else
		if (sStyle = "ScheduleTime") then
			TranslateStyle = Sched_Style$(0)

		elseif (sStyle = "ScheduleStd") then
			TranslateStyle = Sched_Style$(1)

		elseif (sStyle = "ScheduleDayEvent") then
			TranslateStyle = Sched_Style$(2)

		elseif (sStyle = "ScheduleWeekdayNumber") then
			TranslateStyle = Sched_Style$(3)

		elseif (sStyle = "ScheduleWeekendNumber") then
			TranslateStyle = Sched_Style$(4)

		elseif (sStyle = "ScheduleOtherMonthNumber") then
			TranslateStyle = Sched_Style$(5)

		elseif (sStyle = "ScheduleHeadline") then
			TranslateStyle = Sched_Style$(6)

		elseif (sStyle = "ScheduleFootline") then
			TranslateStyle = Sched_Style$(7)

		elseif (sStyle = "ScheduleTask") then
			TranslateStyle = Sched_Style$(8)

		elseif (sStyle = "ScheduleTaskGrouping") then
			TranslateStyle = Sched_Style$(9)

		elseif (sStyle = "ScheduleTaskTitle") then
			TranslateStyle = Sched_Style$(10)

		elseif (sStyle = "ScheduleWeekdayTitle") then
			TranslateStyle = Sched_Style$(11)

		elseif (sStyle = "ScheduleDetailDesc") then
			TranslateStyle = Sched_Style$(13)

		elseif (sStyle = "ScheduleDetailTitle") then
			TranslateStyle = Sched_Style$(14)

		elseif (sStyle = "ScheduleDetail") then
			TranslateStyle = Sched_Style$(15)

		else
			TranslateStyle = "Standard"
		endif
	endif
end function


' --------------------------------------------------------------------------------
' Wochentag uebersetzen
' --------------------------------------------------------------------------------
Function TranslateWeekDay(aWeekDay as Integer) as String
	Dim sDay as String
	Select Case aWeekDay 
	case 1 
		sDay = Sched_weekday$(7) '"Sonntag" 
	case 2 
		sDay = Sched_weekday$(1) '"Montag" 
	case 3 
		sDay = Sched_weekday$(2) '"Dienstag" 
	case 4 
		sDay = Sched_weekday$(3) '"Mittwoch" 
	case 5 
		sDay = Sched_weekday$(4) '"Donnerstag" 
	case 6 
		sDay = Sched_weekday$(5) '"Freitag" 
	case 7 
		sDay = Sched_weekday$(6) '"Samstag" 
	End Select
	TranslateWeekDay = sDay
End Function

' --------------------------------------------------------------------------------
' Kopf und Fusszeile mit Daten fuellen
' --------------------------------------------------------------------------------
Sub FillHeadAndFoot(aDoc as Object, nType as Integer, nDays as Long, nMonth as Integer, nYear as Integer, aName as String)
	Dim aCrsr as Object, aCrsrF as Object, aCrsrH as Object, aFieldPageNum as Object
	Dim pageStyleName$, aDocPageStyle as Object
	Dim aFType as Object, aFieldStyle as Object
	
	aCrsr = aDoc.text.createTextCursor
	pageStyleName$ = aCrsr.pageStyle
	aDocPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(pageStyleName$)

	Dim nLeft as Long, nRight as Long
	nLeft = aDocPagestyle.LeftMargin
	nRight = aDocPagestyle.RightMargin

	nPWidth = aDocPagestyle.Size.Width - nLeft - nRight ' Papierbreite

	' -----------------------------------
	' Felder, die zu deuten sind
	' -----------------------------------
	Dim sTextHeader as String
	sTextHeader = GetFieldTypeAsString(aDoc, "TextHeader", "")

	Dim bCheckDate1 as Boolean
	bCheckDate1 = GetFieldTypeAsBoolean(aDoc,"bCheckDate1", TRUE)

	Dim bCheckUserName as Boolean
	bCheckUserName = GetFieldTypeAsBoolean(aDoc,"bCheckUserName", TRUE)

	Dim bCheckDate2 as Boolean
	bCheckDate2 = GetFieldTypeAsBoolean(aDoc,"bCheckDate2", TRUE)

	Dim bCheckTime as Boolean
	bCheckTime = GetFieldTypeAsBoolean(aDoc,"bCheckTime", TRUE)

	Dim bCheckNumber as Boolean
	bCheckNumber = GetFieldTypeAsBoolean(aDoc,"bCheckNumber", TRUE)

	Dim bCheckHeadFromDoc as Boolean
	bCheckHeadFromDoc = GetFieldTypeAsBoolean(aDoc, "bCheckHeadFromDoc", FALSE)

	Dim bCheckFootFromDoc as Boolean
	bCheckFootFromDoc = GetFieldTypeAsBoolean(aDoc, "bCheckFootFromDoc", FALSE)

	' Tabstops fuer Kopf und Fusszeile
	Dim aArrayTabStop(1) as new com.sun.star.style.TabStop
	Dim aTabstopM as new com.sun.star.style.TabStop
	aTabstopM.position = nPWidth / 2
	aTabstopM.Alignment = com.sun.star.style.TabAlign.CENTER
	aTabstopM.FillChar = ""
	aArrayTabStop(0) = aTabstopM
			
	Dim aTabstopR as new com.sun.star.style.TabStop
	aTabstopR.position = nPWidth
	aTabstopR.Alignment = com.sun.star.style.TabAlign.RIGHT
	aTabstopR.FillChar = ""
	aArrayTabStop(1) = aTabstopR
	
	' -----------------------------------
	' Feldbefehle fuer die Kopfzeile
	' -----------------------------------
	Dim aText as Object
	if (bCheckHeadFromDoc = FALSE) then
		if (aDocPagestyle.HeaderOn = TRUE) then
			if (aDocPagestyle.HeaderIsDynamicDistance = TRUE) then
				aDocPagestyle.HeaderIsDynamicDistance = FALSE
			endif
			
			aDocPagestyle.HeadershareContent = TRUE
			
			aText = aDocPagestyle.headertext
			aCrsrH = aText.createTextCursor

			aCrsrH.ParaStyle = TranslateStyle("ScheduleHeadline")
			' aDocPageStyle.HeaderTransparentBackground = aCrsrH.ParaBackTransparent
			' aDocPageStyle.HeaderBackColor = aCrsrH.ParaBackColor
			aCrsrH.gotoEnd(TRUE)
			aCrsrH.String = ""

			aText.insertString(aCrsrH, sTextHeader, false)
			aText.insertString(aCrsrH, chr$(9), false)
			
			if (bCheckUserName) then
				' Name des Calendar-Owners
				aText.insertString(aCrsrH, aName, false)
				'xField = aDoc.createInstance("com.sun.star.text.TextField.ExtendedUser")
				'xField.userdatatype = 2
				'xField.attach(aCrsrH)
			endif

			aText.insertString(aCrsrH, chr$(9), false)
			
			if (bCheckDate1) then
				xField = aDoc.createInstance("com.sun.star.text.TextField.Chapter")
				xField.Level = 1				' Headline 1
				xField.ChapterFormat = 1		' Format = Kapitelname
				' xField.attach(aCrsrH)
				aText.insertTextContent(aCrsrH, xField, FALSE)
			endif

			aCrsrH.ParaTabStops = aArrayTabStop()
		endif
	endif
	' -----------------------------------
	' Feldbefehle fuer die Fusszeile
	' -----------------------------------
	if (bCheckFootFromDoc = FALSE) then
		if (aDocPagestyle.FooterOn = TRUE) then
			if (aDocPagestyle.FooterIsDynamicDistance = TRUE) then
				aDocPagestyle.FooterIsDynamicDistance = FALSE
			endif
			
			aDocPagestyle.FootershareContent = TRUE
			
			aText = aDocPagestyle.footertext
			aCrsrF = aText.createTextCursor

			aCrsrF.ParaStyle = TranslateStyle("ScheduleFootline")
			' aDocPageStyle.FooterTransparentBackground = aCrsrF.ParaBackTransparent
			' aDocPageStyle.FooterBackColor = aCrsrF.ParaBackColor
			aCrsrF.gotoEnd(TRUE)
			aCrsrF.String = ""
			
			if (bCheckDate2) then
				xField = aDoc.createInstance("com.sun.star.text.TextField.DateTime")
				xField.NumberFormat = 31
				' xField.attach(aCrsrF)
				aText.insertTextContent(aCrsrF, xField, false)
				aText.insertString(aCrsrF, " ", false)
			endif
			if (bCheckTime) then
				xField = aDoc.createInstance("com.sun.star.text.TextField.DateTime")
				xField.NumberFormat = 40
				' xField.attach(aCrsrF)
				aText.insertTextContent(aCrsrF, xField, false)
			endif

			aText.insertString(aCrsrF, chr$(9), false)
			aText.insertString(aCrsrF, chr$(9), false)
			
			if (bCheckNumber) then
				sTempStr = Sched_page$ + " "
				aText.insertString(aCrsrF, sTempStr, false)

				' Seitennummer einfuegen
				xField = aDoc.createInstance("com.sun.star.text.TextField.PageNumber")
				xField.NumberingType = 4 ' Arabische Zahlen
				' xField.attach(aCrsrF)
				aText.insertTextContent(aCrsrF, xField, false)
			endif

			aCrsrF.ParaTabStops = aArrayTabStop()
		endif
	endif
End Sub

' --------------------------------------------------------------------------------
Sub SetDayTitle(aTables as Object, sTitleCell as String, nDays as Date, sStr as String)

	if (WeekDay(nDays) = 1 or WeekDay(nDays) = 7) then
		isWeekEnd = TRUE
	else
		isWeekEnd = FALSE
	endif
	
	Dim aCell as Object, aCellCrsr as Object
	aCell = aTables.getCellByName(sTitleCell)
	aCellCrsr = aCell.createTextCursor
	
	' Wir setzen den CellBackground auf die Farbe, die im ParaStyle eingestellt ist
	' so verhindern wir unschoene Raender.
	Dim nColor as Long
	if (isWeekEnd = FALSE) then
		aCellCrsr.ParaStyle = TranslateStyle("ScheduleWeekdayNumber")
		if (aCellCrsr.ParaBackTransparent = FALSE) then
			nColor = aCellCrsr.ParaBackColor
			aCell.backTransparent = FALSE
			aCell.BackColor = nColor
		endif
	else
		aCellCrsr.ParaStyle = TranslateStyle("ScheduleWeekendNumber")
		if (aCellCrsr.ParaBackTransparent = FALSE) then
			nColor = aCellCrsr.ParaBackColor
			aCell.backtransparent = FALSE
			aCell.BackColor = nColor
		endif
	endif
	' sParaStr$ = aCellCrsr.ParaStyle
	' nDay = Day(nDays)
	aCell.insertString(aCellCrsr, sStr, false)
end sub
' ------------------------------------------------------------------------------

Function calcPageHeight(aDocPageStyle as Object, aDoc as Object) as Double
	' -----------------------------------------------------
	' Noch bedruckbare hoehe berechnen
	' -----------------------------------------------------

	nPageHeight = aDocPagestyle.Size.Height		' Papierbreite
	if (aDocPagestyle.FooterOn = TRUE) then
		nFootHeight = aDocPagestyle.FooterHeight '+ aDocPagestyle.FooterBodyDistance
	endif
	if (aDocPagestyle.HeaderOn = TRUE) then
		nHeaderHeight = aDocPagestyle.HeaderHeight '+ aDocPagestyle.HeaderBodyDistance
	endif
	
	Dim nTop as Long, nBottom as Long
	nTop = aDocPagestyle.TopMargin
	nBottom = aDocPagestyle.BottomMargin
	nPageHeight = nPageHeight - nHeaderHeight - nFootHeight - nTop - nBottom
	
	if (IsDebugMode()) then
		calcPageHeight = nPageHeight - 1500
	else
		calcPageHeight = nPageHeight - getFieldType_PageHeightSub(aDoc) ' kleine Sicherheit
	endif
end function


' --------------------------------------------------------------------------------
' das Document auf dem Drucker ausgeben.
' --------------------------------------------------------------------------------
Sub PrintPreview (aDoc as Object, aPrinterDesc as Object, aPrintOptions as Object, _
				  bShowInWriter as Boolean, aIndi as Object)

	Dim aFieldType as Object, nWidthField as Long, nHeightField as Long
	Dim aPaperSize as Object, bOrientation as Integer
	Dim bPrinterBusy as Boolean, bIsDrin as Boolean

	Dim nRightMarginAdd as Long, nBottomMarginAdd as Long
	Dim nBottomMarginValue as Long
	Dim nRightMarginValue as Long

	' Indikator setzen, die letzten 10%
	if (NOT isnull(aIndi)) then
		aIndi.Value = 90
	endif

	nWidthField	 = GetFieldTypeAsLong(aDoc, "PageWidth", 21000)	 'FIELDTYPE_USER = 0
	nHeightField = GetFieldTypeAsLong(aDoc, "PageHeight", 29700)

	Dim nBottomMargin as Integer
	Dim nRightMargin as Integer
	Dim nLeftMargin as Integer
	Dim nTopMargin as Integer

	aPrtSett = aDoc.pagePrintSettings
	
	for i=0 to ubound(aPrtSett)
		if (aPrtSett(i).name = "IsLandscape") then
			bOrientation = aPrtSett(i).value
		endif
		if (aPrtSett(i).name = "BottomMargin") then
			nBottomMargin = i
		endif
		if (aPrtSett(i).name = "RightMargin") then
			nRightMargin = i
		endif
		if (aPrtSett(i).name = "LeftMargin") then
			nLeftMargin = i
		endif
		if (aPrtSett(i).name = "TopMargin") then
			nTopMargin = i
		endif
	next

	' Sollte die Seitengroesse des eingestellten Papieres NICHT
	' mit der Seitengroesse des Druckers zusammenpassen, wird es angepasst.
	if (nWidthField <> 0) AND (nHeightField <> 0) then
		aPaperSize = aPrinterDesc.PaperSize
		nRightMarginAdd = 0
		nBottomMarginAdd = 0
'		msgbox "Alte Gre" + aPaperSize.width +" x " + aPaperSize.height + chr$(13) +_
'		"Neue Gre" + aWidthField.Value +" x " + aHeightField.Value
		Dim aPaperSizeWidth as Long
		Dim aPaperSizeHeight as Long

		if (bOrientation = FALSE) then
			aPaperSizeWidth = aPaperSize.Width
			aPaperSizeHeight = aPaperSize.Height
		else
			aPaperSizeWidth = aPaperSize.Height
			aPaperSizeHeight = aPaperSize.Width
		endif

		if ( aPaperSizeWidth > nWidthField ) then
			nRightMarginAdd = aPaperSizeWidth - nWidthField
		endif	
		if ( aPaperSizeHeight > nHeightField ) then
			nBottomMarginAdd = aPaperSizeHeight - nHeightField
		endif
		
		'Einstellungen fuer die Seitenansicht
		nBottomMarginValue = aPrtSett(nBottomMargin).value
		if (bOrientation = 0) then
			aPrtSett(nBottomMargin).value = CLng(nBottomMarginValue + nBottomMarginAdd)
		else
			nRightMarginValue = aPrtSett(nRightMargin).value
			
			aPrtSett(nRightMargin).value = CLng(nRightMarginValue + nBottomMarginAdd)
			aPrtSett(nBottomMargin).value = CLng(nBottomMarginValue + nRightMarginAdd)
		endif
		aDoc.pagePrintSettings = aPrtSett
	endif

	' Test
	' aPrtSett2 = aDoc.PagePrintSettings
	' print "Landscapemode: " + aPrtSett2(nPosIsLandscape).value
	' print "LeftMargin: "   + aPrtSett2(nLeftMargin).value
	' print "RightMargin: "  + aPrtSett2(nRightMargin).value
	' print "TopMargin: "    + aPrtSett2(nTopMargin).value
	' print "BottomMargin: " + aPrtSett2(nBottomMargin).value

	aCrsr = aDoc.text.createTextCursor
	pageStyleName$ = aCrsr.PageStyle
	aPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(pageStyleName$)

	aPaperSize = aPagestyle.Size
	pw = aPaperSize.Width
	ph = aPaperSize.Height
	
	aPrinterDesc.PaperOrientation = bOrientation
	aDoc.Printer = aPrinterDesc.propertyValues
	aPagestyle.Size = aPaperSize

	' -----------------------------------------------------
	' Dokument als SDW Datei speichern, zum nacharbeiten.
	' -----------------------------------------------------
	Dim aNoArgs(), nr%
	if (IsDebugMode()) then
		nr% = 0
		sTemp$ = GetWorkPath() + GetPathSeparator() + "TestPrint" + nr% + ".sdw"
		while FileExists( sTemp$ )
			nr% = nr% + 1
			sTemp$ = GetWorkPath() + GetPathSeparator() + "TestPrint" + nr% + ".sdw"
			' Kill ( sTemp$ )
		wend
		aDoc.storeAsURL( sTemp$, aNoArgs )
		msgbox "Ausdruck als SDW Datei gespeichert: <" + sTemp$ + ">" + chr$(13) + " und gewaltausstieg."

		' Indikator abschalten
		if (NOT isnull(aIndi)) then
			aIndi.end
			aIndi.reset
		endif
		aDoc.dispose()
		end
	endif

	' Datei zum Bearbeiten im StarWriter oeffnen.
	if (bShowInWriter = TRUE) then
		'aController = aDoc.CurrentController
		'aController.ViewSettings.ShowHiddenParagraphs = FALSE
		'aController.Frame.Activate

		Dim sFileURL as String
		nr% = 0
		sTemp$ = GetWorkPath() + GetPathSeparator() + sched_unknown$ + nr% + ".sdw"
		while FileExists( sTemp$ )
			nr% = nr% + 1
			sTemp$ = GetWorkPath() + GetPathSeparator() + sched_unknown$ + nr% + ".sdw"
			' Kill ( sTemp$ )
		wend
		aDoc.storeAsURL( sTemp$, aNoArgs )
		' Indikator abschalten
		if (NOT isnull(aIndi)) then
			aIndi.end
			aIndi.reset
		endif
		aDoc.dispose()
		Wait(2)
		sFileURL = TransformFilename2URL(sTemp$)
		StarDesktop.loadComponentFromURL(sFileURL, "_blank", 0, NOARGS)
		exit sub
	endif

	' -----------------------------------------------------
	' Dokument drucken:
	' -----------------------------------------------------
	
	if (NOT isnull(aIndi)) then
		aIndi.Value = 100
	endif

	' Old Version until 5.0
	' aDoc.printpages

	' New Version since 5.1b
	' #57602# Drucken in eine Datei
	dim sFilename as String, nCopyCount as long

	nCopyCount = aPrintOptions.CopyCount
	sFilename = aPrintOptions.Filename

	' Code liegt hier doppelt vor, haengt damit zusammen, das ein
	' Fehler auftritt, wenn nicht alle dimensionierten Objekte 
	' Daten enthalten.
	Dim PrintOptions(0 to 1) as variant
	Dim Prop0 as new com.sun.star.beans.PropertyValue
	Dim Prop1 as new com.sun.star.beans.PropertyValue
	if (sFilename <> "") then
		prop0.name = "FileName"
		prop0.value = sFilename
		printoptions(0) = prop0
		prop1.name = "CopyCount"
		prop1.value = aPrintOptions.CopyCount
		PrintOptions(1) = prop1
	else
		prop0.name = "CopyCount"
		prop0.value = aPrintOptions.CopyCount
		PrintOptions(0) = prop0
		prop1.name = ""
		prop1.value = 0
		PrintOptions(1) = prop1
	endif

	aController = aDoc.CurrentController
	aController.ViewSettings.ShowHiddenParagraphs = FALSE

	aDoc.printpages(PrintOptions())

	bPrinterBusy = TRUE
	while bPrinterBusy = TRUE
		aPrinter = aDoc.Printer
		bIsDrin = FALSE
		for n% = lbound(aPrinter) to ubound(aPrinter)
			aProp = aPrinter(n%)
			if ( aProp.Name = "IsBusy" ) then
				if ( aProp.Value = TRUE ) then
					bIsDrin = TRUE
				endif
			endif
		next n%
		Wait(1)
		If bIsDrin = FALSE Then
			bPrinterBusy = FALSE
		EndIf
	wend
	Wait(1)
	aDoc.dispose()
End Sub 
' --------------------------------------------------------------------------------
' x,y Position uebergeben
' String A1,B1,C1,... so wie die Tabellenspalte heisst.
' (0,0) ==> A1
' --------------------------------------------------------------------------------
Function IndexToString (x as Integer, y as Integer) as String
	Dim temp$
	temp$ = chr$(65 + x) + (y + 1)
	IndexToString = temp$
End Function
' --------------------------------------------------------------------------------
Function ReplaceString( sValue as String, sSearchStr as String, sReplaceStr as String ) as String
	'
	' Ersetzen einen searchStr durch replaceStr
	'
	Dim oPos%
	Dim sLeft as String, sRight as String
	iPos% = instr(sValue , sSearchStr)

	if (iPos% > 0) then
		sLeft = Left(sValue, iPos% - 1)
		sRight = Mid(sValue, iPos% + Len(sSearchStr))
		ReplaceString = sLeft + sReplaceStr + sRight
	else
		Replacestring = sValue
	endif
End Function

' --------------------------------------------------------------------------------
Function rinstr(sValue as String, sSearch as String) as Integer

	iPos% = instr(sValue, sSearch)
	Dim char as String

	if (iPos% <> 0) then			  ' schnell pruefen, ob suche ueberhaupt lohnt.
		for l = len(sValue) - len(sSearch) to 0 step -1
			char = Mid(sValue, l, len(sSearch))
			if (char = sSearch) then
				rinstr = l
				exit for
			endif
		next
	else
		rinstr = 0
	endif
End Function
' ------------------------------------------------------------------------------
Sub ClearDocument(aDoc as Object)
	' POST: Alles was im Dokument steht markieren und ueberschreiben
	aCrsr = aDoc.text.createTextCursor

	aCrsr.gotoEnd(TRUE)
	aDoc.Text.insertString(aCrsr, "", true)
	aCrsr.gotoStart(TRUE)
End Sub

' ------------------------------------------------------------------------------
Sub SetDayEvent(aCell as Object, aCellCrsr as Object, sTitle$, sLocation$, sPoint$)
	Dim sTempString$
	sTempString$ = sTitle$
	if (sLocation$ <> "") Then
		sTempString$ = sTempString$ + " ( " + sLocation$ + " )"
	EndIf
	' aCellCrsr.CharStyle = TranslateStyle("ScheduleDayEvent")
	' aCell.insertString(aCellCrsr, sPoint$ + " " + sTempString$, false)
	' aCell.insertControlCharacter(aCellCrsr, 0, false)

	aCell.insertString(aCellCrsr, sPoint$ + " " + sTempString$, FALSE)
	aCell.insertControlCharacter(aCellCrsr, 0, FALSE)

	aCellCrsr.goLeft(1,FALSE) ' ueber ControlChar rueber
	aCellCrsr.goLeft(len(sTempString$) + len(sPoint$) + 1, TRUE)
	' aTempCrsr = aCellCrsr.CreateTextCursor
	' aTempCrsr.gotoEnd(TRUE)
	' aTempCrsr.gotoEndOfParagraph(TRUE)
	aCellCrsr.CharStyle = TranslateStyle("ScheduleDayEvent")
	aCellCrsr.gotoEnd(FALSE)
end sub
' ------------------------------------------------------------------------------
Sub SetEvent(aCell as Object, aCellCrsr as Object, sTime$, sTitle$, sLocation$)
	aCellCrsr.CharStyle = TranslateStyle("ScheduleTime")
	sTime$ = sTime$ + " "
	aCell.insertString(aCellCrsr, sTime$, false)

	Dim sTempString$
	sTempString$ = sTitle$
	if (sLocation$ <> "") Then
		sTempString$ = sTempString$ + " ( " + sLocation$ + " )"
	EndIf
	aCellCrsr.CharStyle = TranslateStyle("ScheduleStd")
	aCell.insertString(aCellCrsr, sTempString$, false)

	aCell.insertControlCharacter(aCellCrsr, 0, false)
end sub
' ------------------------------------------------------------------------------
' Erstellen einer Kapitelueberschrift
' ------------------------------------------------------------------------------
Sub ChapterTitle (aDoc as Object, aCrsr as Object, sTempStr as String)
	' Eine Kapitelueberschrift eintragen, es ist die einzige
	' Moeglichkeit auf jeder Seite eine andere Kopfzeile darzustellen.
	
	'	sHeadline$ = aDoc.chapternumberingproperties.headingstylenames(0)
	'	aCrsr.ParaStyle = sHeadline$

	Call HiddenLine(aDoc, aCrsr, "1")

	Dim aChapterStr as String

	aChapSett = aDoc.ChapterNumberingRules
	aLevel = aChapSett.getByIndex(1)
	for i = 0 to ubound(aLevel)
		if(aLevel(i).Name = "HeadingStyleName") then
			aChapterStr = aLevel(i).Value
		endif
	next i
	if (aChapterStr <> "") then
		' aOldStyle = aCrsr.Parastyle

		' Kapitelueberschrift
		' if (IsDebugMode()) then
		aCrsr.CharHeight = 10.0
		aCrsr.CharColor = RGB(80,80,80)
		'else
		'	aCrsr.CharHeight = 10
		'	aCrsr.CharColor = RGB(255,255,255)
		'endif
		aDoc.text.insertString(aCrsr, sTempStr, false)
		aCrsr.goLeft(len(sTempStr),true)
		aCrsr.Parastyle = aChapterStr
		aCrsr.gotoEnd(false)
		' aCrsr.ParaStyle = aOldStyle
		aDoc.text.insertControlCharacter(aCrsr, 0, false) ' Linefeed
		' aCrsr.goLeft(1, false)
	endif
End Sub

' ------------------------------------------------------------------------------
Sub InsertLastLine(aDoc as Object, aCrsr as Object)
	' Verhindern, das eine Leere Seite hinten angehaengt wird.

	Call HiddenLine(aDoc, aCrsr, "1")
	'if (IsDebugMode()) then
	aCrsr.CharHeight = 10.0
	aCrsr.CharColor = RGB(80,80,80)
	'else
	'	aCrsr.CharHeight = 10
	'	aCrsr.CharColor = RGB(255,255,255)
	'endif
	Dim sTmpStr as String
	sTmpStr = "printed with StarSchedule"
	aDoc.text.insertString(aCrsr,sTmpStr, false)
	aCrsr.gotoEnd(false)
	aDoc.text.insertControlCharacter(aCrsr, 0, false)
End Sub
' ------------------------------------------------------------------------------
Sub HiddenLine(aDoc as Object, aCrsr as Object, aCondition as String)
	' POST: Erstellt einen FeldBefehl fuer einen Versteckten Absatz
	Dim xField as Object
	xField = aDoc.createInstance("com.sun.star.text.TextField.HiddenParagraph")
	' BUG #62870#
	if (isnull(xField)) then
		xField = aDoc.createInstance("com.sun.star.text.TextField.HidenParagraph")
	endif
	xField.Condition = aCondition
	aText = aDoc.text
	aText.insertTextContent(aCrsr, xField, FALSE)
End Sub

' ------------------------------------------------------------------------------
Function IsDebugMode() as Boolean
	Dim sTemp$
	sTemp$ = GetWorkPath() + GetPathSeparator() + "SSPRINT_DEBUGMODE"
	if (FileExists(sTemp$)) then
		IsDebugMode = TRUE
	else
		IsDebugMode = FALSE
	endif
End Function
' --------------------------------------------------------------------------------
' Since 514G
Function getFieldType_TitleHeight(aDoc as Object) as Integer
	getFieldType_TitleHeight = GetFieldTypeAsInteger(aDoc, "TitleHeight", 650)
end Function
' ------------------------------------------------------------------------------
Function getFieldType_PageHeightSub(aDoc as Object) as Integer
	getFieldType_PageHeightSub = GetFieldTypeAsInteger(aDoc, "PageHeightSub", 700)
end Function


' ------------------------------------------------------------------------------
' Zusaetzliche Hilfsfunktionen fuer Schedule
' ------------------------------------------------------------------------------

Dim really_delete_tasks$
Dim really_delete_events$
Dim indicator_text$

Global _aScheduleComponent as Object
Global _aIndi as Object

' ------------------------------------------------------------------------------
Sub deleteFilterEvents()
	' POST: Alle sichtbaren Termine loeschen

	Call DEL_Language()

	nValue = msgbox(really_delete_events$, 4, "StarOffice")
	if (nValue = 6) then
		Dim aCursor as Object
		_aScheduleComponent = StarDesktop.currentComponent
		aCursor = DEL_CreateEventScheduleCursor()
		DEL_DropAll(aCursor)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub deleteFilterTasks()

	Call DEL_Language()
	nValue = msgbox(really_delete_tasks$, 4, "StarOffice")
	if (nValue = 6) then
		Dim aCursor as Object
		_aScheduleComponent = StarDesktop.currentComponent
		aCursor = DEL_CreateTaskScheduleCursor()
		DEL_DropAll(aCursor)
	endif
End Sub
' ------------------------------------------------------------------------------
Function DEL_CreateEventScheduleCursor() as Object
	' POST: Einen Cursor von der activen Scheduleansicht erstellen
	'       als Filter nur die Sortierung aendern.
	
	' Properties, die man sehen moechte, fuer Filter muessen die nicht angegeben werden.
	aNames = Array("Title")
	aManager = CreateUnoService("com.sun.star.schedule.ScheduleManager")
	
	aConfig = _aScheduleComponent.Configuration
	aEventCursorDescriptor = aConfig.EventCursorDescriptor.createClone
	aSession = _aScheduleComponent.Session

	' aEventCursorDescriptor.ContainerType = "Recurring.Client.Rights.Events" ' Alle Instanzen von Wiederholungsterminen zeigen
	aEventCursorDescriptor.PropertyNames = aNames
	aEventCursorDescriptor.Grouping.Clear

	' Cursor anlegen
	aCursor = aSession.createCursor( aEventCursorDescriptor, com.sun.star.schedule.ScheduleCursorType.SNAPSHOT )

	' Cursor auf StartPosition setzen
	aCursor.MoveToFirst()

	DEL_CreateEventScheduleCursor = aCursor
End Function
' ------------------------------------------------------------------------------
Function DEL_CreateTaskScheduleCursor() as Object
	' POST: Einen Cursor von der activen Scheduleansicht erstellen
	'       als Filter nur die Sortierung aendern.
	
	' Properties, die man sehen moechte, fuer Filter muessen die nicht angegeben werden.
	aNames = Array("Title")
	aManager = CreateUnoService("com.sun.star.schedule.ScheduleManager")
	
	aConfig = _aScheduleComponent.Configuration
	aTaskCursorDescriptor = aConfig.TaskCursorDescriptor.createClone
	aSession = _aScheduleComponent.Session

	' aTaskCursorDescriptor.ContainerType = "Recurring.Client.Rights.Events" ' Alle Instanzen von Wiederholungsterminen zeigen
	aTaskCursorDescriptor.PropertyNames = aNames
	aTaskCursorDescriptor.Grouping.Clear

	' Cursor anlegen
	aCursor = aSession.createCursor( aTaskCursorDescriptor, com.sun.star.schedule.ScheduleCursorType.SNAPSHOT )

	' Cursor auf StartPosition setzen
	aCursor.MoveToFirst()

	DEL_CreateTaskScheduleCursor = aCursor
End Function
' ------------------------------------------------------------------------------
Sub DEL_DropAll(aCursor as Object)
	' POST: Loeschen aller sichtbaren elemente
	' Zaehlen der Elemente
	Dim nRecordCount as Long
	aCursor.MoveToLast
	nRecordCount = aCursor.Position
	aCursor.MoveToFirst
	
	' Indikator aufbauen
	Call DEL_InitIndicator()

	' Schleife ueber den Cursor
	while aCursor.isValid
		aCursor.deleteRecord() ' Doppelten Datensatz entfernen
		aCursor.moveRelative( 1 )

		nCount = nCount + 1
		DEL_SetIndicatorValue(nCount)
	Wend
	Call DEL_CloseIndicator()

End Sub

' ------------------------------------------------------------------------------
Sub DEL_Language()
	Dim aObj as Object
	aObj = CreateUnoService("com.sun.star.schedule.StringTranslator")
	really_delete_events$ = aObj.getTranslatedName( "really delete events" )
	really_delete_tasks$ = aObj.getTranslatedName( "really delete tasks" )
	indicator_text$ = ""
End Sub
' ------------------------------------------------------------------------------
Sub DEL_InitIndicator()
	_aIndi = _aScheduleComponent.Frame.StatusIndicator
	if (NOT isnull(_aIndi)) then
		_aIndi.reset
		_aIndi.start(indicator_text$, nRecordCount)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub DEL_CloseIndicator()
	' Indikator abbauen
	if (NOT isnull(_aIndi)) then
		_aIndi.end
		_aIndi.reset
	endif
End Sub
' ------------------------------------------------------------------------------
Sub DEL_SetIndicatorValue(nValue as Long)
	if (NOT isnull(_aIndi)) then
		_aIndi.Value = nValue
	endif
End Sub
' ------------------------------------------------------------------------------
Function GetWorkPath() as String
	' POST: liefert den dereferenzierten Workpath
	'       std. ist file:///{document}/
	Dim aPath as String
	aPath = Application.Pathsettings.Work
	GetWorkPath =  ResolvePath(aPath)
End Function
