'SBLLINK:MethodInfo=Start0
'SBLLINK:MethodInfo=CreateScheduleTemplates0
'SBLLINK:MethodInfo=SetIndicatorMax0
'SBLLINK:MethodInfo=SetIndicatorBack0
'SBLLINK:MethodInfo=OpenTemplateDocument0
'SBLLINK:MethodInfo=GetTemplateFile0
'SBLLINK:MethodInfo=WriteTemplateDocument0
'SBLLINK:MethodInfo=CreateATemplateTask0
'SBLLINK:MethodInfo=CreateATemplateDay0
'SBLLINK:MethodInfo=CreateATemplateWeek0
'SBLLINK:MethodInfo=CreateATemplateMonth0
'SBLLINK:MethodInfo=CreateATemplateEvent0
'SBLLINK:MethodInfo=CreateATemplateAllTask0
'SBLLINK:MethodInfo=CreateATemplateAllEvent0
'SBLLINK:MethodInfo=CorrectPageSize0
' ------------------------------------------------------------------------------
' Erstellt die Vorlagen automatisch
' $Revision: 1.1.1.1 $
' ------------------------------------------------------------------------------
OPTION EXPLICIT
Sub Start
	CreateScheduleTemplates("")
End Sub
Sub CreateScheduleTemplates(aPath as String)

	' POST: Automatische erstellung der Vorlagen, funktioniert aus
	'       Termin und Aufgabenansicht.
	
	Dim nDays as Long
	Dim aComponent as Object
	Dim aScheduleComponent as Object
	aScheduleComponent = StarDesktop.currentComponent

	Dim aIndi as Object
	if (NOT isnull(aScheduleComponent)) then
		aIndi = aScheduleComponent.Frame.StatusIndicator
		SetIndicatorBack(aIndi)
	endif

	'aComponent = CreateUnoService("com.sun.star.schedule.ScheduleManager")
		
	Application.LoadLibrary( "ScheduleFunction" )
	LoadLanguage(false)
	
	clearNumberFormatter()

	nDays  = DateSerial(1999,4,5)

	' Die Vorlagen erstellen, wenn nicht vorhanden
	if (NOT FileExists(GetTemplateFile("ss01", FALSE))) then
		CreateATemplateTask(aScheduleComponent, aIndi)
		SetIndicatorBack(aIndi)
	endif
	if (NOT FileExists(GetTemplateFile("ss02", FALSE))) then
		CreateATemplateDay(aComponent , aIndi, nDays)
		SetIndicatorBack(aIndi)
	endif
	if (NOT FileExists(GetTemplateFile("ss03", FALSE))) then
		CreateATemplateWeek(aComponent , aIndi, nDays)
		SetIndicatorBack(aIndi)
	endif
	if (NOT FileExists(GetTemplateFile("ss04", FALSE))) then
		CreateATemplateMonth(aComponent , aIndi)
		SetIndicatorBack(aIndi)
	endif
	if (NOT FileExists(GetTemplateFile("ss05", FALSE))) then
		CreateATemplateEvent(aComponent , aIndi)
		SetIndicatorBack(aIndi)
	endif
	if (NOT FileExists(GetTemplateFile("ss09", FALSE))) then
		CreateATemplateAllTask(aComponent , aIndi)
		SetIndicatorBack(aIndi)
	endif
	if (NOT FileExists(GetTemplateFile("ss10", FALSE))) then
		CreateATemplateAllEvent(aComponent , aIndi)
		' SetIndicatorBack(aIndi)
	endif

	if (NOT isnull(aIndi)) then
		aIndi.reset
		aIndi.end
	endif
End Sub
' ------------------------------------------------------------------------------
Sub SetIndicatorMax(aIndi as Object)
	' POST: Indicator auf max setzen
	if (NOT isnull(aIndi)) then
		aIndi.value = 100
	endif
End Sub
' ------------------------------------------------------------------------------
Sub SetIndicatorBack(aIndi as Object)
	if (NOT isnull(aIndi)) then
		' aIndi.value = 0
		aIndi.reset
		aIndi.end
		aIndi.start(Sched_indicator$, 100)
	endif
End Sub
' ------------------------------------------------------------------------------
Function OpenTemplateDocument() as Object
	' POST: oeffnet die Datei ss00.vor als Dokument aus dem Template/wizard verzeichnis des Servers

	Dim sTemplateFile as String
	sTemplateFile = GetTemplateFile("ss00", TRUE)
	' OLD
	'aTempDocument = documents.open( sTemplateFile, "", "h" )
	'aDoc = aTempDocument.UNO

	' File in URL wandeln
	Dim aTransformer as Object, aURL as new com.sun.star.util.URL
	aTransformer = createUnoService( "com.sun.star.util.URLTransformer" )
	aURL = createUNOStruct( "com.sun.star.util.URL" )
	aURL.complete = sTemplateFile
	aTransformer.parsesmart( aURL, "file:" )

	Dim NOARGS()
	Dim aDoc as Object
	aDoc = StarDesktop.loadComponentFromURL(aURL.main, "_hidden", 0, NOARGS)
	initNumberFormatter(aDoc)
	OpenTemplateDocument = aDoc
End Function
' ------------------------------------------------------------------------------
Function GetTemplateFile(aName as String, bServer as Boolean) as String
	' POST: liefert den TemplatePfad
	'       je nach Bool bServer

	Dim sPath as String
	Dim iPos%, iPos2%, sServerPath as String, sClientPath as String
	Dim sTemplateFile as String

	sPath = Application.Pathsettings.Template
	' Gibt es ein ; in sPath, muessen wir den ersten Teil nehmen.

	iPos% = Instr(sPath, ";")
	iPos2% = rinstr(sPath, ";")

	if (iPos% > 0) then
		sServerPath = Left(sPath, iPos% - 1)
		sClientPath = Mid(sPath, iPos2% + 1)
	else
		sServerPath = sPath
		sClientPath = sPath
	endif
	if (bServer = TRUE) then
		sPath = sServerPath + GetPathSeparator() + "wizard" + GetPathSeparator()
	else
		sPath = sClientPath + GetPathSeparator() + "wizard" + GetPathSeparator()
	endif
	GetTemplateFile = sPath + aName + ".vor"
End Function

' ------------------------------------------------------------------------------
Sub WriteTemplateDocument(aDoc as Object, sName as String)
	' PRE: init Dokument, filled sName
	' POST: Dokument unter sName im CLIENT:Template/wizard Verzeichnis speichern.

	Call aDoc.TextFields.refresh()

	Dim sPath as String, sClientPath as String, sServerPath as String
	Dim iPos%, iPos2%

	sPath = Application.Pathsettings.Template
	' Gibt es ein ; in sPath, muessen wir zum schreiben den zweiten(Client) Teil nehmen.
	iPos% = Instr(sPath, ";")
	iPos2% = rinstr(sPath, ";")
	if (iPos% > 0) then
		sServerPath = Left(sPath, iPos% - 1)
		sClientPath = Mid(sPath, iPos2% + 1)
	else
		sServerPath = sPath
		sClientPath = sPath
	endif
	sClientPath = sClientPath + GetPathSeparator() + "wizard" + GetPathSeparator()

	Dim NOARGS()
	Dim sFilename as String
	sFilename = sClientPath + sName + ".vor"
	aDoc.storeAsURL(sFilename, NOARGS)
	aDoc.dispose()
End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateTask(aComponent as Object, aIndi as Object)
	' POST: erstellt ein Template fuer die Taskuebersicht

	Dim aDoc as Object, sName as String, aDocInfo as Object
	
	aDoc = OpenTemplateDocument()

	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformation fuer Taskansicht
		Dim sTaskView as String
		sTaskView = Sched_templateTitle_task$
	
		aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
		aDocInfo.Title = sTaskView
		aDocInfo.setUserFieldValue(0, "task")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "tasks,none")	' default auswahl/drucken
		aDocInfo.setUserFieldValue(2, "list")		' Detail ansicht
		
		SetFieldType(aDoc, "PrintType", "1")   		' Taskuebersicht
		sName = "ss01"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "bOptCol1", "True")
		SetFieldType(aDoc, "bOptTask", "True")
		SetFieldType(aDoc, "TextHeader", sTaskView)
		SetFieldType(aDoc, "TextTemplateTitle", sTaskView)

		SchedPrintTasks(aDoc, aComponent, aIndi, TRUE, TRUE)
		CorrectPageSize(aDoc, 100)
	
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateDay(aComponent as Object, aIndi as Object, nDays as Long)

	Dim aDoc as Object, sName as String
	aDoc = OpenTemplateDocument()
	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformationen
		Dim sDayView as String, aDocInfo as Object
		sDayView = Sched_templateTitle_day$
		aDocInfo = aDoc.DocumentInfo				' Titel der Vorlage
		aDocInfo.Title = sDayView
		aDocInfo.setUserFieldValue(0, "event")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "day")		' default auswahl/drucken
		
		SetFieldType(aDoc, "PrintType", "2")   		' Tagesbersicht
		sName = "ss02"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "bOptDay", "True")
		SetFieldType(aDoc, "TextHeader", sDayView)
		SetFieldType(aDoc, "TextTemplateTitle", sDayView)

		Call PrintOneDay(aDoc, aComponent, aIndi, _
						 nDays, Month(nDays), Year(nDays), _
						 1, 1, 10, 50, _
						 TRUE, TRUE)
		CorrectPageSize(aDoc, 100)
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif

End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateWeek(aComponent as Object, aIndi as Object, nDays as Long)

	Dim aDoc as Object, sName as String
	aDoc = OpenTemplateDocument()
	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformation fuer Wochenansichten
		Dim sWeekView as String, aDocInfo as Object
		sWeekView = Sched_templateTitle_week$
		aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
		aDocInfo.Title = sWeekView
		aDocInfo.setUserFieldValue(0, "event")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "week,multiweek,multiday")		' default auswahl/drucken
		
		SetFieldType(aDoc, "PrintType", "3")   		' Wochenuebersicht
		sName = "ss03"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "bOptWeek", "True")
		SetFieldType(aDoc, "TextHeader", sWeekView)
		SetFieldType(aDoc, "TextTemplateTitle", sWeekView)
	
		PrintOneWeek(aDoc, aComponent, aIndi,_
					 nDays, Month(nDays), Year(nDays), _
					 1, 1, 10, 12, _
					 TRUE, TRUE)

		CorrectPageSize(aDoc, 100)
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateMonth(aComponent as Object, aIndi as Object)
	Dim nStartDays as Long, nEndDays as Long

	Dim aDoc as Object, sName as String
	aDoc = OpenTemplateDocument()
	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformation fuer Monatsansicht
		Dim sMonthView as String, aDocInfo as Object
		sMonthView = Sched_templateTitle_month$
	
		aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
		aDocInfo.Title = sMonthView
		aDocInfo.setUserFieldValue(0, "event")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "month")		' default auswahl/drucken
		
		SetFieldType(aDoc, "PrintType", "4")   		' Monatsuebersicht
		sName = "ss04"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "bOptMonth", "True")
		SetFieldType(aDoc, "TextHeader", sMonthView)
		SetFieldType(aDoc, "TextTemplateTitle", sMonthView)
		SetFieldType(aDoc, "TextScale", "65")

		nStartDays = DateSerial(1999,3,1)
		nEndDays = DateSerial(1999,4,4)
	
		CorrectPageSize(aDoc, 65)
		PrintOneMonth(aDoc, aComponent, aIndi,_
					  nStartDays, nEndDays, 5, Month(nStartDays), Year(nStartDays),_
					  1, 1,_
					  TRUE, _
					  10, 3,_
					  TRUE)
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateEvent(aComponent as Object, aIndi as Object)
	' POST: erstellt ein Template fuer die Taskuebersicht

	Dim aDoc as Object, sName as String, aDocInfo as Object
	
	aDoc = OpenTemplateDocument()
	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformation fuer Terminuebersicht
		Dim sTaskView as String
		sTaskView = Sched_templateTitle_event$
	
		aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
		aDocInfo.Title = sTaskView
		aDocInfo.setUserFieldValue(0, "event")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "eventbrowser,none") ' default auswahl/drucken
		aDocInfo.setUserFieldValue(2, "list")     ' Listen ansicht
		
		SetFieldType(aDoc, "PrintType", "5")   		' Taskuebersicht
		sName = "ss05"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "bOptCol1", "True")
		SetFieldType(aDoc, "bOptEvent", "True")
		SetFieldType(aDoc, "TextHeader", sTaskView)
		SetFieldType(aDoc, "TextTemplateTitle", sTaskView)

		SchedPrintEvents(aDoc, aComponent, aIndi, TRUE, TRUE)
		CorrectPageSize(aDoc, 100)
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateAllTask(aComponent as Object, aIndi as Object)
	' POST: erstellt ein Template fuer die Komplett-Task-Uebersicht

	Dim aDoc as Object, sName as String, aDocInfo as Object
	
	aDoc = OpenTemplateDocument()
	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformation fuer Taskansicht
		Dim sTaskView as String
		sTaskView = Sched_templateTitle_detailtask$
	
		aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
		aDocInfo.Title = sTaskView
		aDocInfo.setUserFieldValue(0, "task")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "detail-tasks,none") ' default auswahl/drucken
		aDocInfo.setUserFieldValue(2, "detail")     ' Detail ansicht
		
		SetFieldType(aDoc, "PrintType", "7")   		' Taskuebersicht
		sName = "ss09"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "TextHeader", sTaskView)
		SetFieldType(aDoc, "TextTemplateTitle", sTaskView)

		SetFieldType(aDoc, "bXTitle", TRUE)
		SetFieldType(aDoc, "bXDescription", TRUE)
		SetFieldType(aDoc, "bXCategories", TRUE)
		SetFieldType(aDoc, "bXStartDate", TRUE)
		SetFieldType(aDoc, "bXAccessLevel", TRUE)
		SetFieldType(aDoc, "bXPriority", TRUE)
		SetFieldType(aDoc, "bXParticipants", TRUE)
		SetFieldType(aDoc, "bXLinks", TRUE)

		SetFieldType(aDoc, "bXDueDate", TRUE)
		SetFieldType(aDoc, "bXCompletionDate", TRUE)
		SetFieldType(aDoc, "bXCloseDate", TRUE)
		SetFieldType(aDoc, "bXTaskState", TRUE)
		SetFieldType(aDoc, "bXCompletionPercentage", TRUE)

		SetFieldType(aDoc, "nTabStopPos1", 4500)

		SchedPrintTasksAllInfo(aDoc, aComponent, aIndi, TRUE, TRUE)
		CorrectPageSize(aDoc, 100)
	
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateATemplateAllEvent(aComponent as Object, aIndi as Object)
	' POST: erstellt ein Template fuer die Komplett-Event-Uebersicht

	Dim aDoc as Object, sName as String, aDocInfo as Object
	
	aDoc = OpenTemplateDocument()
	if (NOT isnull(aDoc)) then
		' Setzen der Dokumentinformation fuer Taskansicht
		Dim sEventView as String
		sEventView = Sched_templateTitle_detailevent$
	
		aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
		aDocInfo.Title = sEventView
		aDocInfo.setUserFieldValue(0, "event")		' Anzeige bei EventAnsicht
		aDocInfo.setUserFieldValue(1, "detail-events,none") ' default auswahl/drucken
		aDocInfo.setUserFieldValue(2, "detail")     ' Detail ansicht
		
		SetFieldType(aDoc, "PrintType", "6")   		' Taskuebersicht
		sName = "ss10"
		SetFieldType(aDoc, "TemplateName", sName)	' Picture
		SetFieldType(aDoc, "TextHeader", sEventView)
		SetFieldType(aDoc, "TextTemplateTitle", sEventView)

		SetFieldType(aDoc, "bXTitle", TRUE)
		SetFieldType(aDoc, "bXDescription", TRUE)
		SetFieldType(aDoc, "bXCategories", TRUE)
		SetFieldType(aDoc, "bXStartDate", TRUE)
		SetFieldType(aDoc, "bXAccessLevel", TRUE)
		SetFieldType(aDoc, "bXPriority", TRUE)
		SetFieldType(aDoc, "bXParticipants", TRUE)
		SetFieldType(aDoc, "bXLinks", TRUE)

		SetFieldType(aDoc, "bXLocation", TRUE)
		SetFieldType(aDoc, "bXStartTime", TRUE)
		SetFieldType(aDoc, "bXEndDate", TRUE)
		SetFieldType(aDoc, "bXEndTime", TRUE)
		SetFieldType(aDoc, "bXDayEvent", TRUE)
		SetFieldType(aDoc, "bXBusyType", TRUE)
		SetFieldType(aDoc, "bXRecurrencies", TRUE)
		SetFieldType(aDoc, "bXReminders", TRUE)

		SchedPrintEventsAllInfo(aDoc, aComponent, aIndi, TRUE, TRUE)
		CorrectPageSize(aDoc, 100)
	
		SetIndicatorMax(aIndi)
		WriteTemplateDocument(aDoc, sName)
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CorrectPageSize(aDoc as Object, nScale as Double)
	' POST: Korrigiert die Blattgroesse entsprechend der Skalierung
	'       und entfernt die Aussenraender.
	Dim nPercentScale as Double
	nPercentScale = nScale / 100

	Dim aPagestyle as Object, pageStyleName$
	Dim aCrsrTemp as Object
	Dim nx as Long, ny as Long
		
	aCrsrTemp = aDoc.text.createTextCursor
	pageStyleName$ = aCrsrTemp.pageStyle
	aPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(pageStyleName$)
	nx = aPagestyle.Size.Width
	ny = aPagestyle.Size.Height
	
	Dim aSize as Object
	aSize = createUnoStruct("com.sun.star.awt.Size")
	aSize.Width = nx
	aSize.Height = ny
	
	Dim nCols as Integer
	Dim nRows as Integer
	
	nCols = 1
	nRows = 1

	Dim nTopMargin as Double, nBottomMargin as Double
	Dim nLeftMargin as Double, nRightMargin as Double
	Dim nInnerTopMargin as Double, nInnerBottomMargin as Double
	Dim nInnerLeftMargin as Double, nInnerRightMargin as Double
	
	nTopMargin =    Val_International(GetFieldTypeAsString(aDoc, "TextTopMarg", "1,27")) * 1000
	nLeftMargin =   Val_International(GetFieldTypeAsString(aDoc, "TextLeftMarg", "1,27")) * 1000
	nRightMargin =  Val_International(GetFieldTypeAsString(aDoc, "TextRightMarg", "1,27")) * 1000
	nBottomMargin = Val_International(GetFieldTypeAsString(aDoc, "TextBottomMarg", "1,27")) * 1000

	nInnerTopMargin    = Val_International(GetFieldTypeAsString(aDoc, "TextInnerTop", "0")) * 1000
	nInnerLeftMargin   = Val_International(GetFieldTypeAsString(aDoc, "TextInnerLeft", "0")) * 1000
	nInnerRightMargin  = Val_International(GetFieldTypeAsString(aDoc, "TextInnerRight", "0")) * 1000
	nInnerBottomMargin = Val_International(GetFieldTypeAsString(aDoc, "TextInnerBottom", "0")) * 1000
	
	Dim nVHeight as Long, nVWidth as Long
'	if (bOrientation = 0) then
	nVWidth = (aSize.Width - nLeftMargin - nRightMargin) / nCols
	nVHeight = (aSize.Height - nTopMargin - nBottomMargin) / nRows
'	else
'		nVWidth = (aSize.Height - nTopMargin - nBottomMargin) / nCols
'		nVHeight = (aSize.Width - nLeftMargin - nRightMargin) / nRows
'	endif
	nVWidth = nVWidth / nPercentScale
	nVHeight = nVHeight / nPercentScale

	' -----------------------------------
	' Innere Raender Skalieren
	' -----------------------------------
	nInnerLeftMargin	= nInnerLeftMargin	 / nPercentScale
	nInnerRightMargin	= nInnerRightMargin	 / nPercentScale
	nInnerTopMargin		= nInnerTopMargin	 / nPercentScale
	nInnerBottomMargin	= nInnerBottomMargin / nPercentScale

	' Innenraender setzen
	aPagestyle.LeftMargin = nInnerLeftMargin
	aPagestyle.RightMargin = nInnerRightMargin
	aPagestyle.TopMargin = nInnerTopMargin
	aPagestyle.BottomMargin = nInnerBottomMargin

'	aPagestyle.LeftBorder = nLeftMargin
'	aPagestyle.RightBorder = nRightMargin
'	aPagestyle.TopBorder = nTopMargin
'	aPagestyle.BottomBorder = nBottomMargin
	
	if ( nLeftMargin + nRightMargin > nVWidth ) then
		nVWidth = nLeftMargin + nRightMargin
	endif
	if ( nTopMargin + nBottomMargin > nVHeight ) then
		nVHeight = nTopMargin + nBottomMargin
	endif
	aSize.Width = nVWidth
	aSize.Height = nVHeight
	aPagestyle.Size = aSize

	SetFieldType(aDoc, "TextPaperWidth", nVWidth / 1000)
	SetFieldType(aDoc, "TextPaperHeight", nVHeight / 1000)
End Sub
