'SBLLINK:MethodInfo=SchedulePrint0
'SBLLINK:MethodInfo=SchedPrintEvents0
'SBLLINK:MethodInfo=SchedPrintTasks0
'SBLLINK:MethodInfo=SchedPrintTaskEvent0
'SBLLINK:MethodInfo=SizingCells0
'SBLLINK:MethodInfo=InsertTitle0
'SBLLINK:MethodInfo=InsertColumns0
'SBLLINK:MethodInfo=insertCheckBox0
'SBLLINK:MethodInfo=clearNumberFormatter0
'SBLLINK:MethodInfo=initNumberFormatter0
'SBLLINK:MethodInfo=GetBasicDateAsString0
'SBLLINK:MethodInfo=GetBasicTimeAsString0
' OPTION EXPLICIT
' --------------------------------------------------------------------------------
' Drucken Allgemein
' $Revision: 1.1.1.1 $
' --------------------------------------------------------------------------------
Global CellWidth0 as Long

Global _scheduleOperator_LOWER as Long
Global _scheduleOperator_GREATER as Long
Global _scheduleOperator_EQUAL as Long
Global _scheduleCursorType_SNAPSHOT as Long

Global _aPlaceHolder as Object
Global _xNumberFormatter
Global _nNFDateKey as Long
Global _nNFTimeKey as Long
Global _bNumberFormatter as Boolean

Global _bDoPrint as Boolean

sub SchedulePrint
	Dim aDoc as Object
	aDoc = thisComponent

	' on error goto global_problem

	Application.LoadLibrary( "ScheduleFunction" )
	' nActLanguage = nLoadLanguage% ( Application.LanguageID )
	Call LoadLanguage(false)

	Dim aFieldTypes as Object, aType as Object
	Dim aPrintContext as Object
	Dim aPrinterDesc as Object, aPrintOptions as Object
	Dim bShowInWriter as Boolean, sPrintType$
	Dim aScheduleComponent as Object
	
	' aManager = CreateUnoService("com.sun.star.schedule.ScheduleManager")

	aScheduleComponent = StarDesktop.currentComponent
	aPrintContext = aScheduleComponent.PrintContext

	Dim aIndi as Object
	aIndi = aScheduleComponent.Frame.StatusIndicator
	if (NOT isnull(aIndi)) then
		aIndi.start(Sched_indicator$, 100)
	endif

	_scheduleOperator_LOWER =      com.sun.star.schedule.ScheduleQueryOperator.LOWER
	_scheduleOperator_GREATER =    com.sun.star.schedule.ScheduleQueryOperator.GREATER
	_scheduleOperator_EQUAL =      com.sun.star.schedule.ScheduleQueryOperator.EQUAL
	_scheduleCursorType_SNAPSHOT = com.sun.star.schedule.ScheduleCursorType.SNAPSHOT
	
	aDoc.lockControllers

	' Infos holen, die im Dokument zwischengespeichert wurden.
	sPrintType$ = GetFieldTypeAsString(aDoc, "PrintType", "")
	bShowInWriter = aPrintContext.ShowInWriter

	clearNumberFormatter()
	initNumberFormatter(aDoc)

	_bDoPrint = TRUE
	' zu den entsprechenden Routinen verzweigen
	if (sPrintType$ = "1") then
		Call SchedPrintTasks(aDoc, aScheduleComponent, aIndi, TRUE, FALSE)
	elseif (sPrintType$ = "2") then
		Call SchedPrintDay(aDoc, aScheduleComponent, aIndi, TRUE)
	elseif (sPrintType$ = "3") then
		Call SchedPrintWeek(aDoc, aScheduleComponent, aIndi, TRUE)
	elseif (sPrintType$ = "4") then
		Call SchedPrintMonth(aDoc, aScheduleComponent, aIndi)
	elseif (sPrintType$ = "5") then
		Call SchedPrintEvents(aDoc, aScheduleComponent, aIndi, TRUE, FALSE)

	' Alle Informationen eines Termins/Aufgabe
	elseif (sPrintType$ = "6") then
		Call SchedPrintEventsAllInfo(aDoc, aScheduleComponent, aIndi, FALSE, FALSE)
	elseif (sPrintType$ = "7") then
		Call SchedPrintTasksAllInfo(aDoc, aScheduleComponent, aIndi, FALSE, FALSE)
	endif
	
	aDoc.unlockControllers
	Call aDoc.TextFields.refresh()

	' Setzen des Dokumentnames
	aDocInfo = aDoc.DocumentInfo	' Titel der Vorlage
	sPrintTitle$ = GetFieldTypeAsString(aDoc, "TextHeader", "")
	aDocInfo.Title = sPrintTitle$

	' Ergebnis ausdrucken
	if (_bDoPrint = TRUE) then
		aPrinterDesc = aPrintContext.PrinterDescriptor
		aPrintOptions = aPrintContext.PrinterOptions
		Call PrintPreview( aDoc, aPrinterDesc, aPrintOptions, bShowInWriter, aIndi )
	endif

	' Indikator abschalten
	if (NOT isnull(aIndi)) then
		' 	msgbox "#61816# Indikator geht nicht"
		aIndi.end
		aIndi.reset
	endif
	' Exit Sub

	' global_problem:
	' aDoc.dispose
End Sub
' --------------------------------------------------------------------------------
' Drucken von Aufgaben(Tasks/Events)
' --------------------------------------------------------------------------------
Sub SchedPrintEvents(aDoc as Object, aScheduleComponent as Object, _
				   aIndi as Object, bDeleteAll as Boolean,_
				   bCreateMode as Boolean)

	Dim aConfig as Object
	Dim aEventCursorDescriptor as Object
	Dim aEventStyleDescriptor as Object
	if (bCreateMode = FALSE) then
		aConfig = aScheduleComponent.Configuration
		aEventCursorDescriptor = aConfig.EventCursorDescriptor.createClone
		aEventStyleDescriptor = aConfig.EventStyleDescriptor.createClone
	endif
	
	Call SchedPrintTaskEvent(aDoc, aScheduleComponent, aIndi, bDeleteAll, bCreateMode,_
	                         aEventCursorDescriptor, aEventStyleDescriptor)
End Sub
' --------------------------------------------------------------------------------
Sub SchedPrintTasks(aDoc as Object, aScheduleComponent as Object, _
				    aIndi as Object, bDeleteAll as Boolean,_
				    bCreateMode as Boolean)

	Dim aConfig as Object
	Dim aTaskCursorDescriptor as Object
	Dim aTaskStyleDescriptor as Object
	if (bCreateMode = FALSE) then
		aConfig = aScheduleComponent.Configuration
		aTaskCursorDescriptor = aConfig.TaskCursorDescriptor.createClone
		aTaskStyleDescriptor = aConfig.TaskStyleDescriptor.createClone
	endif
	
	Call SchedPrintTaskEvent(aDoc, aScheduleComponent, aIndi, bDeleteAll, bCreateMode,_
	                         aTaskCursorDescriptor, aTaskStyleDescriptor)
End Sub
' --------------------------------------------------------------------------------

Sub SchedPrintTaskEvent(aDoc as Object, aScheduleComponent as Object, _
				   aIndi as Object, bDeleteAll as Boolean,_
				   bCreateMode as Boolean,_
				   aCursorDescriptor as Object, aStyleDescriptor as Object)

	if (NOT isnull(aIndi)) then
		aIndi.Value = 5
	endif

	Dim aSession as Object
	Dim aCursor as Object
	Dim aColumn as Object

	if (bCreateMode = FALSE) then
		aSession    = aScheduleComponent.Session
		aCursor = aSession.createCursor( aCursorDescriptor, _scheduleCursorType_SNAPSHOT )
		aColumn = aStyleDescriptor.Columns
	endif
	
	' aCrsr.gotoEnd(FALSE)			'Wird fuer die kombinierte Tages/Aufgabenansicht gebraucht
	' If  bMultiView = FALSE Then
	' 	  aCrsr = aDoc.text.createTextCursor
	' 	  aCrsr.gotoEnd(FALSE)			'Wird fuer die kombinierte Tages/Aufgabenansicht gebraucht
	' Else
	' 	  aCrsr = aFrame.createTextCursor
	' Endif

	if (bDeleteAll = TRUE) then
		ClearDocument(aDoc)
	endif

	Dim aCrsr as Object
	aCrsr = aDoc.text.start
	aCrsr.gotoEnd(false)

	Dim bCombined as Boolean
	bCombined = getFieldType_CheckCombined(aDoc)

	' Eine Kapitelueberschrift eintragen, es ist die einzige
	' Moeglichkeit auf jeder Seite eine andere Kopfzeile darzustellen.
	
	' if (bCombined = FALSE) then
	' 	  sTempStr = Sched_Month$(nMonth) + " " + nYear
	' 	  ChapterTitle(aDoc, aCrsr, sTempStr)
	' endif

	' -----------------------------------------------------
	' Tabelle erstellen
	' -----------------------------------------------------
	Dim aTables as Object
	Dim aCellCrsr as Object
	Dim aCell as Object
	
	aTables = aDoc.createinstance("com.sun.star.text.TextTable")

	Dim nRecordCount as Integer
	Dim nColumnCount as Integer
	
	if (bCreateMode = FALSE) then
		aCursor.MoveToLast
		nRecordCount = aCursor.Position
		aCursor.MoveToFirst
		' nRecord + 1 (fuer Anzahl) + 1 (fuer Titel)
		nColumnCount = aColumn.Count
	else
		nRecordCount = 1
		nColumnCount = 0
	endif

	aTables.initialize(nRecordCount + 2, nColumnCount + 1)
	' aTables.attach(aCrsr)
	aTables.repeatheadline = true
	aTables.split = true
	aCrsr.Text.insertTextContent(aCrsr, aTables, FALSE)

	Dim nIndicatorStep as Double, nIndicatorValue as Double
	nIndicatorValue = 10
	nIndicatorStep = (100-10-10) / (nRecordCount + 2)

	aCell = aTables.getCellByName("A1")
	aCellCrsr = aCell.createTextCursor
	
	InsertLastLine(aDoc, aCrsr)
	' -----------------------------------------------------
	' Kopf und Fusszeile erstellen
	' -----------------------------------------------------
	if (bCombined = FALSE) then
		if (bCreateMode) then
			FillHeadAndFoot(aDoc, 1, 0, 0, 0,"")
		else
			FillHeadAndFoot(aDoc, 1, 0, 0, 0,GetUserNameFromCalendar(aScheduleComponent))
		endif
	endif

	' Farbe der Tabelle aus dem ScheduleTaskTitle setzen
	Dim sOldStyle as String
	sOldStyle = aCellCrsr.ParaStyle
	aCellCrsr.ParaStyle = TranslateStyle("ScheduleTaskTitle")
	if (aCellCrsr.ParaBackTransparent = FALSE) then
		nColor = aCellCrsr.ParaBackColor
		aTables.Backtransparent = FALSE
		aTables.BackColor = nColor
	endif
	aCellCrsr.ParaStyle = sOldStyle
	' aTable.backColor = RGB(200, 200, 200)
	' aTable.transparentBackground = FALSE
	
	if (NOT isnull(aIndi)) then
		aIndi.Value = nIndicatorValue
	endif

	if (bCreateMode = FALSE) then
		Call InsertTitle (aDoc, aTables, aStyleDescriptor, aCursorDescriptor,bCreateMode)
		Call InsertColumns (aDoc, aTables, aCursor, aStyleDescriptor, aCursorDescriptor,_
							aIndi, nIndicatorStep, nIndicatorValue, bCreateMode)
	else
		' Titel setzen
		aCell = aTables.getCellByName("A1")
		aCellCursor = aCell.createTextCursor
		tableParaStyle$ = TranslateStyle("ScheduleTaskTitle") ' aCellCursor.paraStyle
		aTLCellCursor = aTables.getCellByName("A1").createtextcursor
		aTLCellCursor.paraStyle = tableparastyle$
		aCell.insertString(aCellCursor, Sched_templateTitle$, false)

		' Grouping setzen
		aCell = aTables.getCellByName("A2")
		aCellCrsr = aCell.createTextCursor
		aCellCrsr.ParaStyle = TranslateStyle("ScheduleTaskGrouping")
		aCell.insertString(aCellCrsr, Sched_templateGrouping$, false)

		' Datensatz setzen
		aCell = aTables.getCellByName("A3")
		aCellCrsr = aCell.createTextCursor
		aCellCrsr.ParaStyle = TranslateStyle("ScheduleTask")
		if (aCellCrsr.ParaBackTransparent = FALSE) then
			nColor = aCellCrsr.ParaBackColor
			aCell.backtransparent = FALSE
			aCell.BackColor = nColor
		else
			aCell.backtransparent = FALSE
			aCell.backColor = RGB(255, 255, 255)
		endif
		aCell.insertString(aCellCrsr, Sched_templateExample$, false)
	endif
End Sub

' --------------------------------------------------------------------------------
' Zellengroesse anpassen fuer Aufgaben
' --------------------------------------------------------------------------------
Sub SizingCells(aDoc as Object, aTable as Object, nColumnCount as Integer,_
		nMaxGrouping as Integer, aColumnWidth() as Long, aColumnFix() as Boolean)
	
	' PRE: Dokument, Tabelle, Anzahl der Zeilen, Groupinglevel(Aufgabenansicht)
	'      Spaltenbreite aller Spalten, Fixspalten

	Dim aPageStyle as Object
	Dim lrMargin as Object
	Dim aCrsr as Object
	Dim nPageWidth as Long
	Dim nFirstCell as Long
	Dim nActAdd as Long			'Temporaerer Column Seperator
	Dim nSumFixed as Long		'Fix Felder in Pixel
	Dim nSumRelative as Long	'Relative Felder in Pixel
	Dim nRelativeRemain as Long	'10000 - Das, was fuer die Fixed draufgeht
	Dim nFixCalc as Double		'Umrechnungsfaktor Fix
	Dim nRelativeCalc as Double	'Umrechnungsfaktor Relativ
	Dim aPageColumns as Object
	Dim nPageColumnCount as Integer
	
	' Tabellen bearbeiten

	aCrsr = aDoc.text.createTextCursor
	pageStyleName$ = aCrsr.pageStyle
	aPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(pageStyleName$)
	aPageColumns = aPagestyle.textColumns
	nPageColumnCount = aPageColumns.columnCount
	size = aPageStyle.size
	nPageWidth = size.width - aPageStyle.leftMargin - aPageStyle.rightMargin 'Seitenbreite ohne Raender

	' if (nPageWidth < 0) then
		' Sicherheit, PageBreite sollte Positiv sein.
	' endif
	
	if ( nPageColumnCount > 1) then 
		Dim nColMargin as Double
		nLeft = aPageColumns.Columns(1).LeftMargin
		nRight = aPageColumns.Columns(0).RightMargin

		' Abstaende zwischen den Spalten in 100tel mm umrechnen
		nColMargin = nPageWidth / aPageColumns.ReferenceValue * (nLeft + nRight)

		' Wenn Seite mehrspaltig, dann max Breite einzelne Spaltenbreite 
		nPageWidth = nPageWidth / nPageColumnCount - ((nPageColumnCount-1) * nColMargin )
	endif

	colseps = aTable.tableColumnSeparators
	nSumFixed = 0
	nSumRelative = 0
	nFixCalc = 15 / 0.567                           ' PixelTo100MM = x * 15 / 0.567
	
	If nMaxGrouping > 1 Then 
		nFirstCell = 10000/nPageWidth * 1000 * (nMaxGrouping-1) '100stel mm nach Tabellen Einheit
	Else
		nFirstCell = 1
	EndIf
	colseps(0).Position = nFirstCell

	For i% = 0 To (nColumnCount-1)
		If aColumnFix(i%) = TRUE Then
			nSumFixed = nSumFixed + aColumnWidth(i%)
		Else	
			nSumRelative = nSumRelative + aColumnWidth(i%)
		EndIf
	Next i%

	'Umrechnungsfaktor fuer die Relativen Felder
	nRelativeRemain = 10000 - nFirstCell - (10000 / nPageWidth * nFixCalc * nSumFixed)
	nRelativeCalc = nRelativeRemain / nSumRelative
	
	'Spaltemseperatoren der Tabelle setzen
	nActAdd = colseps(0).Position
	For i% = 0 To (nColumnCount-2)
		If aColumnFix(i%) = TRUE Then
			colseps(i%+1).Position = 10000 / nPageWidth * nFixCalc * aColumnWidth(i%) + nActAdd
			nActAdd = colseps(i%+1).Position
		Else	
			colseps(i%+1).Position = nRelativeCalc * aColumnWidth(i%) + nActAdd
			nActAdd = colseps(i%+1).Position
		EndIf
	Next i%

	CellWidth0 = nFirstCell * nPageWidth / 10000

	' Tabellengroesse anpassen
	aTable.tableColumnSeparators = colseps
End Sub

' --------------------------------------------------------------------------------
' Titel einfuegen von Aufgaben
' --------------------------------------------------------------------------------
Sub InsertTitle (aDoc as object, aTable as Object,_
				 aStyleDescriptor as Object, aCursorDescriptor as Object,_
				 bCreateMode as Boolean)

	Dim aCell as Object
	Dim aCellCursor as Object
	Dim aTLCellCursor as Object
	Dim aFirstLine as Object
	Dim aColumn as Object
	Dim aActColumn as Object
	Dim nColumnCount as Integer
	Dim aParaLineSpacing as Object
	Dim bNothingIn as Boolean
	Dim nValue as Double

	if (bCreateMode = FALSE) then
		aColumn = aStyleDescriptor.Columns
		nColumnCount = aColumn.Count
	endif
	Dim aColumnWidth (0 to (nColumnCount-1)) as Long
	Dim aColumnFix (0 to (nColumnCount-1)) as Boolean
	
	bNothingIn = FALSE
	If aTable.rows.Count < 2 Then
		aTable.rows.insertByIndex(1,1)		' Wenn die Tabelle < 2 Zeilen braucht man eine Dummy-Zeile
		bNothingIn = TRUE
	EndIf
	aCell = aTable.getCellByName("A2")
	aCellCursor = aCell.createTextCursor
	tableParaStyle$ = TranslateStyle("ScheduleTaskTitle") ' aCellCursor.paraStyle
	aTLCellCursor = aTable.getCellByName("A1").createtextcursor
	aTLCellCursor.paraStyle = tableparastyle$
	aFirstLine = aTable.rows.getByIndex(0)
	nValue = aTLCellCursor.CharHeight * 35.28 ' CharHeight in Point * 2540/72
	nValue = nValue * 1.35 + 200              ' 15% dazu + innenRaender der Tabelle

	'if ( GetGUIType() = 2 ) then						' unter OS/2 eine andere CharHeight einstellen
	'	aFirstLine.height = aTLCellCursor.CharHeight
	'else
	aFirstLine.height = nValue
	'endif
	aFirstLine.isAutoHeight = false
	For i% = 0 to (nColumnCount - 1)
		aActColumn = aColumn.getByIndex(i%)
		aValue = aActColumn.Width
		aColumnWidth(i%) = aActColumn.Width
		aValue = aActColumn.Fixed
		aColumnFix(i%) = aActColumn.Fixed
		aActIndex$ = IndexToString((i%+1), 0)
		aCell = aTable.getCellByName(aActIndex$)
		aCellCursor = aCell.createTextCursor
		aCellCursor.paraStyle = tableParaStyle$
		aParaLineSpacing = aCellCursor.paraLineSpacing
		aParaLineSpacing.Mode = 0
		aParaLineSpacing.Height = 200
		aCellCursor.paraLineSpacing = aParaLineSpacing
		If aActColumn.ShowAsText = TRUE Then
			aCell.insertString(aCellCursor, aActColumn.Header, false)
		EndIf
	next i%

	Call SizingCells(aDoc, aTable, nColumnCount, aCursorDescriptor.Grouping.Count,_
			 aColumnWidth(), aColumnFix())

	If bNothingIn = TRUE Then
		aTable.rows.removeByIndex(1,1)		' Dummy-Zeile loeschen
		Exit Sub
	EndIf

End Sub
' --------------------------------------------------------------------------------
' Alle Zeilen in die Aufgabentabelle setzen
' --------------------------------------------------------------------------------
Sub InsertColumns (aDoc as Object, aTable as Object, aCursor as Object,_
				   aStyleDescriptor as Object, aCursorDescriptor as Object,_
				   aIndi as Object, nIndicatorStep as Double, nIndicatorValue as Double,_
				   bCreateMode as Boolean)

	Dim aShape as Object
	Dim aForm as Object
	Dim aShapeDesc as Object
	Dim aFormcomp as object
	Dim aSize as Object
	Dim aCell as Object
	Dim aColumn as Object
	Dim aActGrouping as Object
	Dim aLRPMargin as Object
	Dim aTableCrsr as Object
	Dim aCellCrsr as Object
	Dim nActGroupLevel as Integer
	Dim nMaxGroupLevel as Integer

	aColumn = aStyleDescriptor.Columns
	nMaxGroupLevel = aCursorDescriptor.Grouping.Count

	' ueber alle Zeilen gehen
	Dim nCount%
	
	aCursor.MoveToFirst()
	while aCursor.isValid
		nActGroupLevel = aCursor.RecordGroupingLevel

		if (NOT isnull(aIndi)) then
			nIndicatorValue = nIndicatorValue + nIndicatorStep
			aIndi.Value = nIndicatorValue
		endif
		
		If (nActGroupLevel < nMaxGroupLevel) then
			'
			' graue Spalte
			'
			aActGrouping = aCursorDescriptor.Grouping.getByIndex( nActGroupLevel )
			aActIndex$ = IndexToString(0, nCount%+1)
			aActMergeIndex$ = IndexToString(aColumn.Count, nCount%+1)
			aTemp$ = aCursor.getTranslatedName( aActGrouping.PropertyName )+ ": " +_
				 aCursor.getGroupingPropertyValueAsString( nActGroupLevel )

			aCell = aTable.getCellByName(aActIndex$)
			aCellCrsr = aCell.createTextCursor
			aCellCrsr.ParaStyle = TranslateStyle("ScheduleTaskGrouping")
			aCell.insertString(aCellCrsr, aTemp$, false)

			aTableCrsr = aTable.createCursorByCellName(aActIndex$)
			aTableCrsr.gotoCellByName(aActMergeIndex$, TRUE)

'			aDoc.reformat
			aTableCrsr.mergerange
'			aDoc.reformat

			If nActGroupLevel > 0 then
				'
				' Grouping Rand setzen, wenn GroupingLevel vorhanden
				'
				aCell = aTable.getCellByName(aActIndex$)
				aCellCrsr = aCell.createTextCursor
				aCellCrsr.ParaStyle = TranslateStyle("ScheduleTaskGrouping")
				aCellCrsr.ParaLeftMargin = CellWidth0 * nActGroupLevel/(nMaxGroupLevel-1)
			EndIf
		Else
			'
			' Datenzeilen setzen
			'
			For i% = 0 to (aColumn.Count-1)
				aActIndex$ = IndexToString((i%+1), nCount%+1)
				aActColumn = aColumn.getByIndex( i% )
				aCell = aTable.getCellByName(aActIndex$)

				aCellCrsr = aCell.createTextCursor
				aCellCrsr.ParaStyle = TranslateStyle("ScheduleTask")
				if (aCellCrsr.ParaBackTransparent = FALSE) then
					nColor = aCellCrsr.ParaBackColor
					aCell.backtransparent = FALSE
					aCell.BackColor = nColor
				else
					aCell.backtransparent = FALSE
					aCell.backColor = RGB(255, 255, 255)
				endif

				aTemp$ = aCursor.getPropertyValueAsString( aActColumn.PropertyName )

				If (aActColumn.PropertyName="CompletionDate") And (aActColumn.ShowAsText=FALSE) then
					'
					' Kontroll am CellCursor einfuegen
					'
					If aTemp$ <> "" Then
						insertCheckBox(aDoc, aCellCrsr, 1)
					Else
						insertCheckBox(aDoc, aCellCrsr, 0)
					EndIf
				else
					'
					' Text in die Zelle schreiben
					'
					aCell.insertString(aCellCrsr, aTemp$, false)
				EndIf
			next i%
		endif
		nCount% = nCount% + 1
		aCursor.moveRelative( 1 )

		' Erzwungener Ausstieg, wenn wir im CreateMode sind.
		if (bCreateMode = TRUE and nCount% > 5) then
			exit Sub
		endif
	wend
End Sub
' ------------------------------------------------------------------------------
sub insertCheckBox(xDoc as Object, xCrsr as Object, nState as Integer)
	' POST: Einfuegen einer CheckBox an die Stelle des Cursors

	Dim xforms as Object, xDrawPage as Object, xControlShape as Object
	Dim xControl as Object, xForm as Object
	Dim aSz as Object
	xDrawPage = xDoc.DrawPage
	xforms = xDrawPage.Forms
				
	xControlShape = xDoc.createInstance("com.sun.star.drawing.ControlShape")
	xControl = xDoc.createInstance("com.sun.star.form.component.CheckBox")
	xControl.DefaultState = nState
	xControl.Label = " "
	xForm = xDoc.createInstance("com.sun.star.form.component.Form")

	if xforms.count = 0 then
		xforms.insertbyindex(0,xForm)
	endif
	aSz = xControlShape.Size
	aSz.Width = 400
	aSz.Height = 400

	xControlShape.Size = aSz
	xControlShape.Control = xControl

	xControlShape.TextRange = xCrsr.start
	xDrawPage.add(xControlShape)
End Sub
' ------------------------------------------------------------------------------
Sub clearNumberFormatter()
	' POST: Numberformatter Variablen zuruecksetzen.
	_bNumberFormatter = FALSE
End Sub
' ------------------------------------------------------------------------------
Sub initNumberFormatter(aDoc as Object)
	' POST: Number Formater initialisieren

	
End Sub
' ------------------------------------------------------------------------------
Function GetBasicDateAsString(aDoc as Object, nDate as Long) as String
	' POST: Ueber Numberformatter ein Datum erstellen
	Dim sPrintDate as String

	Dim xNumberFormatter as Object
	xNumberFormatter = createUnoService("com.sun.star.util.NumberFormatter")
	xNumberFormatter.attachNumberFormatsSupplier(aDoc)
	
	Dim nNumberFormats as Object
	nNumberFormats = aDoc.getNumberFormats()
	
	Dim nIndex as Long
	nIndex = com.sun.star.util.NumberFormat.DATE
	' Dim nLang as Long
	' nLang = Application.LanguageID
	Dim aDesktop as Object
	aDesktop = createUnoService("com.sun.star.frame.Desktop")

	Dim nNFDateKey as Long
	' since 567a Numberformats needs a locale
	on local error goto nochange1
	nNFDateKey = nNumberFormats.getStandardFormat(nIndex, aDesktop.ISOLocale)
nochange1:
	on local error goto 0
	sPrintDate = xNumberFormatter.convertNumberToString(nNFDateKey, nDate)
	GetBasicDateAsString = sPrintDate
End Function
' ------------------------------------------------------------------------------
Function GetBasicTimeAsString(aDoc as Object, nTime as Double) as String
	' POST: Ueber den NumberFormatter eine UhrZeit erstellen
	Dim sStartTime as String
	Dim bAMPM as Boolean
	bAMPM = getFieldType_AMPM(aDoc)

	Dim xNumberFormatter as Object
	xNumberFormatter = createUnoService("com.sun.star.util.NumberFormatter")
	xNumberFormatter.attachNumberFormatsSupplier(aDoc)
	
	Dim nNumberFormats as Object
	nNumberFormats = aDoc.getNumberFormats()
	
	Dim nIndex as Long

	Dim nLang as Long
	nLang = Application.LanguageID

	Dim nNFTimeKey as Long

'	nIndex = com.sun.star.util.NumberFormat.TIME
'	nNFTimeKey = nNumberFormats.getStandardFormat(nIndex, nLang)

	' Wert aus svtools/inc/zforlist.hxx
	if (nLang = 1033) then
		nIndex = 41
	else
		nIndex = 39
	endif

	Dim aDesktop as Object
	aDesktop = createUnoService("com.sun.star.frame.Desktop")

	on local error goto nochange2
	nNFTimeKey = nNumberFormats.GetFormatIndex(nIndex, aDesktop.ISOLocale)
nochange2:
	on local error goto 0
	sStartTime = xNumberFormatter.convertNumberToString(nNFTimeKey, nTime)
	
	if (bAMPM = TRUE) then
		sStartTime = ReplaceString(sStartTime, " PM", "pm")
		sStartTime = ReplaceString(sStartTime, " AM", "am")
	endif
	GetBasicTimeAsString = sStartTime
End Function
