'SBLLINK:MethodInfo=SchedPrintDay0
'SBLLINK:MethodInfo=PrintOneDay0
'SBLLINK:MethodInfo=TransformFilename2URL0
'SBLLINK:MethodInfo=LoadComponent0
'SBLLINK:MethodInfo=SaveComponent0
' --------------------------------------------------------------------------------
' Erstellen einer Tagesuebersicht
' $Revision: 1.1.1.1 $
' ------------------------------------------------------------------------------
Sub SchedPrintDay(aDoc as Object, aScheduleComponent as Object, _
				  aIndi as Object, bDeleteAll as Boolean)
	' PRE: ScheduleUNOObject
	'      ScheduleView (Aktueller Termin)

	Dim aPrintContext as Object, aEventViewState as Object
	aPrintContext = aScheduleComponent.PrintContext
	aEventViewState = aPrintContext.EventViewState

	' Dim aPrintArea as Object
	Dim nDaysToPrint as Integer
	aPrintArea = aEventViewState.ShownDays
	nDaysToPrint = uBound(aPrintArea) + 1

	Dim nIndicatorStep as Double, nIndicatorValue as Double

	if (NOT isnull(aIndi)) then
		aIndi.Value = 5
	endif
	Dim nTextRows as Integer, nTextCols as Integer

	nTextRows = getFieldType_TextRows(aDoc)
	nTextCols = getFieldType_TextColumns(aDoc)

	Dim nNumDays as Integer
	' nNumDays = nTextRows * nTextCols
	nNumDays = nDaysToPrint
	
	' -----------------------------------------------------
	' Suche den Start.
	' -----------------------------------------------------
	Dim nDay as Integer, nMonth as Integer, nYear as Integer
	
	' -----------------------------------------------------
	' -----------------------------------------------------
	Dim nDays as Long, nStartDays as Long, nEndDays as Long
	Dim nWeeks as Long
	Dim aTempDocument as Object, sTempFile as String, sTemplateFile as String
	sTempFile = GetWorkPath() + GetPathSeparator() + "SSPrint.sdw"	

	Dim nCounter as Integer
	while FileExists(sTempFile)
		On local error goto filefehler
		Kill ( sTempFile )							' Tempdokument schliessen
		goto nofehler
		
	filefehler:
		sTempFile = GetWorkPath() + GetPathSeparator() + "SSPrint" + nCounter + ".sdw"
		nCounter = nCounter + 1
	nofehler:
	wend
	on local error goto 0

	' sTemplateFile = aDoc.DocumentInfo.TemplateFileName
	sTemplateFile = aDoc.getURL()

	' nDays = DateSerial(nYear, nMonth, nDay)
	Dim i as Integer, bCombined as Boolean
	bCombined = getFieldType_CheckCombined(aDoc)

	Dim aTempDoc as Object
	aTempDoc = aDoc
	
	aCrsr = aDoc.text.createTextCursor
	for i = 1 to nNumDays
		nDay = aPrintArea(i - 1).Day
		nMonth = aPrintArea(i - 1).Month
		nYear = aPrintArea(i - 1).Year
		nDays = DateSerial(nYear, nMonth, nDay)
		
		if (i <> 1) then
			aTempDocument = documents.open( sTemplateFile, "", "h" )
			aTempDoc = aTempDocument.UNO
			' aTempDoc = loadComponent(sTemplateFile)
			aTempDoc.lockControllers
		endif

		nIndicatorValue = 10
		nIndicatorStep = (100-10) / nNumDays
		
		PrintOneDay(aTempDoc, aScheduleComponent, aIndi,_
					nDays, nMonth, nYear,_
					nTextRows, nTextCols,_
					nIndicatorValue, nIndicatorStep,_
					bDeleteAll, FALSE)

		if (bCombined = TRUE) then
			bCombined = FALSE
			Call SchedPrinttasks(aDoc, aScheduleComponent, aIndi, FALSE, FALSE)
		endif

		' nDays = nDays + 1

		if (i <> 1) then
			aTempDoc.unlockControllers
			aTempDocument.SaveAs sTempFile              ' TempDokument abspeichern
			aTempDocument.Close(false, sTempFile)
			' SaveComponent(aTempDoc, sTempFile)
			' aTempDoc.dispose()
			aCrsr.gotoEnd(FALSE)

			'
			' Newpage erzwingen
			'
			aDoc.Text.insertControlCharacter(aCrsr, 0, false)
			aCrsr.pagedescname = aCrsr.pagestyle
			aCrsr.gotoEnd(FALSE)

			aCrsr.insertDocumentFromURL(sTempFile, Array())	' am aktuellen Cursor anhaengen
			Wait(2)
			Kill ( sTempFile )							' Tempdokument schliessen
		endif
	next
End Sub

' --------------------------------------------------------------------------------
' Erstellen einer Tagesuebersicht
' --------------------------------------------------------------------------------
Sub PrintOneDay(aDoc as Object, _
				  aScheduleComponent as Object, aIndi as Object, _
				  nDays as Date, _
				  nMonth as Integer, nYear as Integer, _
				  nTextRows as Integer, nTextColumns as Integer, _
				  nIndicatorValue as Double, nIndicatorStep as Double, _
				  bDeleteAll as Boolean,_
				  bCreateMode as Boolean)

	Dim aCrsr as Object, aBody as Object, aCell as Object
	Dim aDocPagestyle as Object, sPageStyleName$
	aCrsr = aDoc.text.createTextCursor

	sPageStyleName$ = aCrsr.pageStyle
	aDocPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(spageStyleName$)

	if (bDeleteAll = TRUE) then
		ClearDocument(aDoc)
	endif
	
	' Eine Kapitelueberschrift eintragen, es ist die einzige
	' Moeglichkeit auf jeder Seite eine andere Kopfzeile darzustellen.
	
	Dim sTempStr as String
	sTempStr = Sched_Month$(Month(nDays)) + " " + Year(nDays)
	ChapterTitle(aDoc, aCrsr, sTempStr)

	' -----------------------------------------------------
	' Tabelle erstellen
	' -----------------------------------------------------
	Dim aTables as Object
	Dim aCellCrsr as Object
	Dim aCrsr2 as Object
	
	aCrsr2 = aDoc.text.start
	aCrsr2.gotoEnd(false)
	aTables = aDoc.createinstance("com.sun.star.text.TextTable")
	aTables.initialize(2,1)
	' aTables.attach(aCrsr2)
	aCrsr2.Text.insertTextContent(aCrsr2, aTables, FALSE)

	aCell = aTables.getCellByName("A2")
	aCellCrsr = aCell.createTextCursor
	
	aCrsr.ParaStyle = TranslateStyle("ScheduleTask")
	InsertLastLine(aDoc, aCrsr)

	' -----------------------------------------------------
	' Informationen, die am Dokument gespeichert wurden
	' -----------------------------------------------------
	Dim bAMPM as Boolean
	Dim bStartTimeOnly as Boolean
	Dim bFixTableHeight as Boolean
	Dim bCheckLocation as Boolean
	Dim sPoint as String

	bAMPM           = getFieldType_AMPM(aDoc)
	bStartTimeOnly  = getFieldType_StartTimeOnly(aDoc)
	bFixTableHeight = getFieldType_FixTableHeight(aDoc)
	bCheckLocation  = getFieldType_CheckLocation(aDoc)
	sPoint          = getFieldType_DayEventPoint(aDoc)

	' -----------------------------------------------------
	' Kopf und Fusszeile erstellen
	' -----------------------------------------------------
	if (bCreateMode) then
		FillHeadAndFoot(aDoc, 2, nDays, nMonth, nYear,"")
	else
		FillHeadAndFoot(aDoc, 2, nDays, nMonth, nYear,GetUserNameFromCalendar(aScheduleComponent))
	endif
	' -----------------------------------------------------
	' Noch bedruckbare hoehe berechnen
	' -----------------------------------------------------
	Dim nPageHeight as Long
	nPageHeight = calcPageHeight(aDocPageStyle, aDoc)

	' -----------------------------------------------------
	' Einstellen der Tabellenhoehe
	' -----------------------------------------------------
	Dim aRow as Object
	Dim i as Integer
	' alle Tabellenzeilen mit der selben hoehe initialisieren
	for i = 0 to 1
		aRow = aTables.rows.getByIndex(i)
		aRow.Height = getFieldType_TitleHeight(aDoc)
		aRow.SizeType = 1			' Tabellenhoehe fest
	next
	' Hoehe der Datentragenden Zeilen berechnen
	Dim nHeight as Double
	nHeight = (nPageHeight - (1 * aRow.Height))
	' nHeight = nHeight - 50 ' eine kleine Sicherheit

	' Hoehe der Datentragenden Zeilen setzen
	aRow = aTables.rows.getByIndex(1)
	aRow.Height = nHeight
	if (bFixTableHeight = FALSE) then
		'//! zu testzwecken entfernt
		aRow.SizeType = 2       ' Tabellenhoehe mindestens Height
	endif

	' -----------------------------------------------------
	' Die Tabelle mit Daten der einzelnen Tage fuellen
	' -----------------------------------------------------
	' i = nDays
	Dim nDay as Long
	nDay = nDays
	
	' Indicator setzen
	if (NOT isnull(aIndi)) then
		aIndi.Value = nIndicatorValue
		nIndicatorValue = nIndicatorValue + nIndicatorStep
	endif
		
	'Titelzeile
	Dim sWeekDayName$
	Dim sTitleCell as String
	Dim nFormatKey as Integer
	Dim sPrintDate as String
	Dim sTitleStr as String
		
	sTitleCell = IndexToString(0,0)
	sWeekDayName$ = TranslateWeekDay(WeekDay(nDay))
	' nFormatKey = aDoc.getStandardFormat(2,0)                        ' Datum, System
	' sPrintDate = aDoc.getOutputString(0, nDay, nFormatKey)

	' sPrintDate = _xNumberFormatter.convertNumberToString(_nNFDateKey, nDay)
	sPrintDate= GetBasicDateAsString(aDoc, nDay)
	sTitleStr = sWeekDayName$ + ", " + sPrintDate

	Call SetDayTitle(aTables, sTitleCell, nDay, sTitleStr)

	aCell = aTables.getCellByName(IndexToString(0, 1))

	if (bCreateMode = TRUE) then
		CreateExampleEvent(aDoc, aCell, nDay )
	else
		' aCell.text = "Week " + nWeek + " Day " + nDayOfWeek
		InsertTextInCell(aDoc, aCell, aScheduleComponent, nDay, _
		                 bAMPM, bStartTimeOnly, bCheckLocation, _
						 sPoint)
	endif
End Sub

' ------------------------------------------------------------------------------
Function TransformFilename2URL(sFilename as String) as String
	Dim aTransformer as Object, aURL as new com.sun.star.util.URL
	aTransformer = createUnoService( "com.sun.star.util.URLTransformer" )
	aURL = createUNOStruct( "com.sun.star.util.URL" )
	aURL.complete = sFilename
	aTransformer.parsesmart( aURL, "file:" )
	TransformFilename2URL = aURL.main
End Function

' ------------------------------------------------------------------------------
Function LoadComponent(sFilename as String) as Object

	Dim sFileURL as String
	sFileURL = TransformFilename2URL(sFilename)
	Dim NOARGS()
	LoadComponent = StarDesktop.loadComponentFromURL(sFileURL, "_hidden", 0, NOARGS)
End Function

' ------------------------------------------------------------------------------
Sub SaveComponent(aComponent as Object, sFilename as String)
	Dim sFileURL as String
	Dim NOARGS()
	sFileURL = TransformFilename2URL(sFilename)
	aComponent.storeAsURL(sFileURL, NOARGS)
End Sub
