'SBLLINK:MethodInfo=SchedPrintWeek0
'SBLLINK:MethodInfo=PrintOneWeek0
' --------------------------------------------------------------------------------
' Erstellen einer Wochenuebersicht
' $Revision: 1.1.1.1 $
' --------------------------------------------------------------------------------
Global _bWeekEndCompress as Boolean

Sub SchedPrintWeek(aDoc as Object, aScheduleComponent as Object, _
				   aIndi as Object, bDeleteAll as Boolean)
	' PRE: ScheduleUNOObject
	'      ScheduleView (Aktueller Termin)

	Dim aPrintContext as Object, aEventViewState as Object
	aPrintContext = aScheduleComponent.PrintContext
	aEventViewState = aPrintContext.EventViewState
	
	' Dim aPrintArea as Array
	Dim nDaysToPrint as Integer

	aPrintArea = aEventViewState.ShownDays
	nDaysToPrint = uBound(aPrintArea) + 1

	Dim nIndicatorStep as Double, nIndicatorValue as Double

	if (NOT isnull(aIndi)) then
		aIndi.Value = 5
	endif
	Dim nTextRows as Integer, nTextCols as Integer

	nTextRows = getFieldType_TextRows(aDoc)
	nTextCols = getFieldType_TextColumns(aDoc)

	Dim nNumWeeks as Integer
	' nNumWeeks = nTextRows * nTextCols
	' nNumWeeks = nDaysToPrint \ 7
	nNumWeeks = (uBound(aEventViewState.CurrentWeek) + 1) \ 7

	' -----------------------------------------------------
	' Suche des Monatsstarts, falls wir nicht am 1. eines Monats sind.
	' -----------------------------------------------------
	Dim nDay as Integer, nMonth as Integer, nYear as Integer
	
	' -----------------------------------------------------
	' Sind wir in einer Wochenansicht, nicht an der 1. Woche des Monats, 
	' muessen wir uns an den Monatsanfang jugglen
	' -----------------------------------------------------
	Dim nDays as Long, nStartDays as Long, nEndDays as Long
	Dim nWeekCount as Long
	Dim aTempDocument as Object, sTempFile as String, sTemplateFile as String
	sTempFile = GetWorkPath() + GetPathSeparator() + "SSPrint.sdw"	
	' sTemplateFile = aDoc.DocumentInfo.TemplateFileName
	sTemplateFile = aDoc.getURL()

	Dim i as Integer, bCombined as Boolean
	bCombined = getFieldType_CheckCombined(aDoc)

	Dim aTempDoc as Object
	aTempDoc = aDoc
	nWeekCount = 0
	
	' -----------------------------------------------------
	' Kompriemiertes Wochenende abchecken
	' -----------------------------------------------------
	_bWeekEndCompress = getFieldType_CheckWeekEndCompressed(aDoc)
	if (_bWeekEndCompress) then
		nDay = aEventViewState.CurrentWeek(0).Day
		nMonth = aEventViewState.CurrentWeek(0).Month
		nYear = aEventViewState.CurrentWeek(0).Year
		nDays = DateSerial(nYear, nMonth, nDay)

		if (WeekDay(nDays) = 1) then
			msgbox sched_warn_compweekend$
			_bDoPrint = FALSE
			exit sub
		endif
	endif

	aCrsr = aDoc.text.createTextCursor
	for i = 1 to nNumWeeks

		nDay = aEventViewState.CurrentWeek(nWeekCount).Day
		nMonth = aEventViewState.CurrentWeek(nWeekCount).Month
		nYear = aEventViewState.CurrentWeek(nWeekCount).Year
		nDays = DateSerial(nYear, nMonth, nDay)

		if (i <> 1) then
			aTempDocument = documents.open( sTemplateFile, "", "h" )
			aTempDoc = aTempDocument.UNO
		endif

		nIndicatorValue = 10
		nIndicatorStep = (100-10-10) / (7 * nNumWeeks)
		
		PrintOneWeek(aTempDoc, aScheduleComponent, aIndi,_
						nDays, nMonth, nYear,_
						nTextRows, nTextCols,_
						nIndicatorValue, nIndicatorStep,_
						bDeleteAll, FALSE)

		if (bCombined = TRUE) then
			bCombined = FALSE
			Call SchedPrinttasks(aDoc, aScheduleComponent, aIndi, FALSE, FALSE)
		endif

		' nDays = nDays + 7
		nWeekCount = nWeekCount + 7
		
		if (i <> 1) then
			aTempDocument.SaveAs sTempFile              ' TempDokument abspeichern
			aTempDocument.Close(false, sTempFile)
			aCrsr.gotoEnd(FALSE)

' //!			aDoc.insertString(aCrsr, " ", false) ' \newpage
			aDoc.Text.insertControlCharacter(aCrsr, 0, false)
			aCrsr.pagedescname = aCrsr.pagestyle
			aCrsr.gotoEnd(FALSE)

			aCrsr.insertDocumentFromURL(sTempFile, Array())	' am aktuellen Cursor anhaengen
			Wait(1)
			Kill ( sTempFile )							' Tempdokument schliessen
		endif
	next
End Sub
' --------------------------------------------------------------------------------
' Erstellen einer Wochenuebersicht einer Woche
' --------------------------------------------------------------------------------
Sub PrintOneWeek(aDoc as Object, _
				  aScheduleComponent as Object, aIndi as Object, _
				  nDays as Date, _
				  nMonth as Integer, nYear as Integer, _
				  nTextRows as Integer, nTextColumns as Integer, _
				  nIndicatorValue as Double, nIndicatorStep as Double, _
				  bDeleteAll as Boolean, bCreateMode as Boolean)

	Dim aCrsr as Object, aBody as Object, aCell as Object
	Dim aDocPagestyle as Object, sPageStyleName$
	aCrsr = aDoc.text.createTextCursor

	sPageStyleName$ = aCrsr.pageStyle
	aDocPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(sPageStyleName$)

	if (bDeleteAll = TRUE) then
		' Alles was im Dokument steht markieren und ueberschreiben
		ClearDocument(aDoc)
	endif

	Dim sTempStr as String
	sTempStr = Sched_Month$(Month(nDays)) + " " + Year(nDays)
	ChapterTitle(aDoc, aCrsr, sTempStr)
	
	' -----------------------------------------------------
	' Komprimiertes Wochenende
	' -----------------------------------------------------
	Dim nTabRows as Integer, nDayRows as Integer
	' _bWeekEndCompress = getFieldType_CheckWeekEndCompressed(aDoc)
	if (_bWeekEndCompress) then
		nTabRows = 8
		nDayRows = 3
	else
		nTabRows = 8
		nDayRows = 4
	endif
	' -----------------------------------------------------
	' Tabelle erstellen
	' -----------------------------------------------------
	Dim aTables as Object
	Dim aCellCrsr as Object
	Dim aCrsr2 as Object

	aCrsr2 = aDoc.text.start
	aCrsr2.gotoEnd(false)
	aTables = aDoc.createinstance("com.sun.star.text.TextTable")
	aTables.initialize(nTabRows,2)
	' aTables.attach(aCrsr2)
	aCrsr2.Text.insertTextContent(aCrsr2, aTables, FALSE)

	aCell = aTables.getCellByName("A2")
	aCellCrsr = aCell.createTextCursor
	
	' Letzte Zeile unterdrueckt eine Leere Seite
	aCrsr.ParaStyle = TranslateStyle("ScheduleTask")
	InsertLastLine(aDoc, aCrsr)

	' -----------------------------------------------------
	' Informationen, die am Dokument gespeichert wurden
	' -----------------------------------------------------
	Dim bAMPM as Boolean
	Dim bStartTimeOnly as Boolean
	Dim bFixTableHeight as Boolean
	Dim bCheckLocation as Boolean
	Dim sPoint as String

	bAMPM           = getFieldType_AMPM(aDoc)
	bStartTimeOnly  = getFieldType_StartTimeOnly(aDoc)
	bFixTableHeight = getFieldType_FixTableHeight(aDoc)
	bCheckLocation  = getFieldType_CheckLocation(aDoc)
	sPoint          = getFieldType_DayEventPoint(aDoc)

	' -----------------------------------------------------
	' Kopf und Fusszeile erstellen
	' -----------------------------------------------------
	if (bCreateMode) then
		FillHeadAndFoot(aDoc, 3, nDays, nMonth, nYear,"")
	else
		FillHeadAndFoot(aDoc, 3, nDays, nMonth, nYear,GetUserNameFromCalendar(aScheduleComponent))
	endif
	' -----------------------------------------------------
	' Noch bedruckbare hoehe berechnen
	' -----------------------------------------------------
	Dim nPageHeight as Long
	nPageHeight = calcPageHeight(aDocPageStyle, aDoc)

	' -----------------------------------------------------
	' Einstellen der Tabellenhoehe
	' -----------------------------------------------------

	Dim aRow as Object
	Dim i as Integer

	for i = 0 to (nTabRows - 1)
		aRow = aTables.rows.getByIndex(i)
		aRow.Height = getFieldType_TitleHeight(aDoc)
		aRow.SizeType = 1			' Tabellenhoehe fest
	next

	Dim nHeight as Double
	nHeight = (nPageHeight - (nDayRows * aRow.Height)) / nDayRows

	for i = 1 to (nTabRows - 1) step 2
		aRow = aTables.rows.getByIndex(i)
		aRow.Height = nHeight
		if (bFixTableHeight = FALSE) then
			aRow.SizeType = 2       ' Tabellenhoehe mindestens Height
		endif
	next

	if (_bWeekEndCompress) then
		nHeight2 = (nHeight - getFieldType_TitleHeight(aDoc)) / 2
		for i = 5 to (nTabRows - 1) step 2
			aRow = aTables.rows.getByIndex(i)
			aRow.Height = nHeight2
			aRow.SizeType = 2       ' Tabellenhoehe mindestens Height
		next
		aTabCursor = aTables.CreateCursorByCellName("A6")
		aTabCursor.gotoCellByName("A8", TRUE)
		aTabCursor.mergeRange()

		aRow = aTables.rows.getByIndex(5)
		aRow.Height = nHeight
		aRow.SizeType = 1			' Tabellenhoehe fest
	endif

	' Die Hoehe der Zeilen einer aufgespalteten Zelle kann nicht
	' richtig manipuliert werden.
	'if (_bWeekEndCompress) then
	'	NULL
	'endif
	' -----------------------------------------------------
	' Die Wochentagnamen in die Tabelle eintragen
	' -----------------------------------------------------

	Dim nDayOfWeek as Integer
	Dim sWeekDayName$
	Dim nValue as Double
	Dim nXDay as Integer
	Dim nYDay as Integer

	nXDay = 0
	nYDay = 0
	aCell = aTables.getCellByName(IndexToString(nXDay, nYDay))
	aCellCrsr = aCell.createTextCursor
	
	' -----------------------------------------------------
	' Die Tabelle mit Daten der einzelnen Tage fuellen
	' -----------------------------------------------------
	Dim sTitleCell as String
	Dim nDay as Long
	Dim nFormatKey as Integer
	Dim sPrintDate as String
	Dim sTitleStr as String
	Dim sCell as String

	for nDay = nDays to nDays + 6
		' Indicator setzen
		if (NOT isnull(aIndi)) then
			aIndi.Value = nIndicatorValue
			nIndicatorValue = nIndicatorValue + nIndicatorStep
		endif
		
		'Titelzeile position bestimmen
		
		if (_bWeekEndCompress) then
			if (WeekDay(nDay) = 7) then
				sTitleCell = "B5"
			elseif (WeekDay(nDay) = 1) then
				sTitleCell = "B6.1.2"
			else
				sTitleCell = IndexToString(nXDay, nYDay * 2)
			endif
		else
			sTitleCell = IndexToString(nXDay, nYDay * 2)
		endif

		' Titelzeile erstellen
		sWeekDayName$ = TranslateWeekDay(WeekDay(nDay))
		sPrintDate = GetBasicDateAsString(aDoc, nDay)
		sTitleStr = sWeekDayName$ + ", " + sPrintDate

		Call SetDayTitle(aTables, sTitleCell, nDay, sTitleStr)
		
		if (_bWeekEndCompress) then
			if (WeekDay(nDay) = 7) then
				sCell = "B6.1.1"
			elseif (WeekDay(nDay) = 1) then
				sCell = "B6.1.3"
			else
				sCell = IndexToString(nXDay, nYDay * 2 + 1)
			endif
		else
			sCell = IndexToString(nXDay, nYDay * 2 + 1)
		endif
		aCell = aTables.getCellByName(sCell)
		' aCell.text = "Week " + nWeek + " Day " + nDayOfWeek

		if (bCreateMode = TRUE) then
			' Hier den Beispieltag eintragen
			if (WeekDay(nDay) = 2) then   ' Montag
				CreateExampleEvent(aDoc, aCell, nDay )
			endif
			if (WeekDay(nDay) = 6) then    ' Samstag
				CreateExampleEvent(aDoc, aCell, nDay )
			endif
		else
			InsertTextInCell(aDoc, aCell, aScheduleComponent, nDay, _
		            	     bAMPM, bStartTimeOnly, bCheckLocation, _
							 sPoint)
		endif

		nXDay = nXDay + 1			' Counter fuer Positionierung
		if (nXDay = 2) then
			nXDay = 0
			nYDay = nYDay + 1
		endif
	next
	if (NOT _bWeekEndCompress) then
		'
		' Den 8. Tag fuellen, mit Notizen.
		'
		sTitleCell = IndexToString(nXDay, nYDay * 2)
		Call SetDayTitle(aTables, sTitleCell, 2, Sched_Note$)
	endif
End Sub
