'SBLLINK:MethodInfo=TempMain0
'SBLLINK:MethodInfo=GetAllInstalledNamesInDatabase0
'SBLLINK:MethodInfo=StrInStrings0
'SBLLINK:MethodInfo=SuggestTitleStr0
'SBLLINK:MethodInfo=CheckTitleUnique0
'SBLLINK:MethodInfo=PaintPicOnPreview0
'SBLLINK:MethodInfo=CheckDatabaseIdentifier0
'SBLLINK:MethodInfo=ReplaceStringInStrings0
'SBLLINK:MethodInfo=MoveOrderedSelectedListbox0
'SBLLINK:MethodInfo=CopyItemsListBox0
'SBLLINK:MethodInfo=MoveSelectedListBox0
'SBLLINK:MethodInfo=RemoveSelected0
'SBLLINK:MethodInfo=SelectionInListBox0
'SBLLINK:MethodInfo=ReplaceTokenInString0
'SBLLINK:MethodInfo=SetNewSelection0
Option Explicit

Sub TempMain()
	Call SubCreateTable()
End Sub

Sub GetAllInstalledNamesInDatabase(ByVal DatabaseName$, AvailNames As Strings)
	Dim Queries As New Strings
	Dim Reports As New Strings
	Dim Forms As New Strings
	Dim Tables As New Strings
	Dim nCount%

	Application.OpenDatabaseConnection(DatabaseName$)

	Queries = Application.GetQueryNames()
	Reports = Application.GetReportNames()
	Forms = Application.GetFormNames()
	For nCount% = 1 To Application.DataTableNumber(DatabaseName$)
		Tables.Add(UCase(Application.DataGetTableName(DatabaseName$, nCount%)))
	Next

	AvailNames.Clear()
	For nCount% = 1 To Queries.Count()
		AvailNames.Add(UCase(Queries.Item(nCount%)))
	Next
	For nCount% = 1 To Reports.Count()
		AvailNames.Add(UCase(Reports.Item(nCount%)))
	Next
	For nCount% = 1 To Forms.Count()
		AvailNames.Add(UCase(Forms.Item(nCount%)))
	Next
	For nCount% = 1 To Tables.Count()
		AvailNames.Add(UCase(Tables.Item(nCount%)))
	Next

	Erase Queries
	Erase Reports
	Erase Forms
	Erase Tables
End Sub

Function StrInStrings%(ByVal AvailNames As Strings, ByVal ActiveName$)
	Dim Result%, nCount%
	Dim bNotFound%
	
	bNotFound% = True
	nCount% = 1
	ActiveName$ = UCase(ActiveName$)
	While (nCount%<=AvailNames.Count() And bNotFound%)
		If (AvailNames.Item(nCount%)=ActiveName$) Then 
			bNotFound%=False
		Else
			nCount% = nCount% + 1
		End If
	Wend
	
	If (bNotFound%) Then
		StrInStrings% = -1
	Else
		StrInStrings% = nCount%
	End If	
End Function

Function SuggestTitleStr$(ByVal AvailNames As Strings, ByVal ActiveName$)
	Dim SuggestCount%, index%, nMaxTitleLen&
	Dim oldName$

	nMaxTitleLen& = Application.GetDatabaseLimits ( 1 )
	If ( ( 0 = nMaxTitleLen& ) Or ( 50 < nMaxTitleLen& ) ) Then nMaxTitleLen& = 50
	
	oldName$ = ActiveName$
	SuggestCount% = 1

    While ( ( -1 <> StrInStrings%(AvailNames, UCase ( ActiveName$ ) ) Or ( Len ( ActiveName$ ) > nMaxTitleLen& ) ) )
		ActiveName$ = Left ( oldName$, 1 + nMaxTitleLen& - Len ( Str ( Trim ( SuggestCount% ) ) ) )
		ActiveName$ = ActiveName$ + Trim(Str(SuggestCount%))
		SuggestCount% = SuggestCount% + 1
	Wend
	SuggestTitleStr$ = ActiveName$
End Function

Sub CheckTitleUnique(ByVal DatabaseTitles As Strings, txtNewTitle As Object)
	If (-1 <> StrInStrings%(DatabaseTitles, txtNewTitle.Text)) Then
		MsgBox( Table_gErrorUniqueTitle ( TableActiveLanguage% ), 64, Table_gWizardName ( TableActiveLanguage% ) )
		txtNewTitle.Text = SuggestTitleStr$(DatabaseTitles, txtNewTitle.Text)
		If (txtNewTitle.Text="") Then
			txtNewTitle.Text = txtNewTitle.Tag
		Else
			txtNewTitle.Tag = txtNewTitle.Text
		End If
		txtNewTitle.SetFocus()
	End if
End Sub

Sub PaintPicOnPreview(Preview As Object, ByVal Filename$, ByVal Width%, ByVal Height%, ByVal bDrawFrame%)

	Dim Bitmap As Object
	Dim TWIPSPicHeight%, TWIPSPicWidth%, StartX%, StartY%
	Dim bFittingX%, bFittingY%, DlgWidth%, DlgHeight%, nXMove%, nYMove%
	Dim x#, y#

	Set Bitmap = LoadPicture ( FileName$ )
	
	If ( 1 = GetGUIType() ) Then
		DlgHeight% = CInt ( Preview.Height * GetDialogZoomFactorY ( Preview.Height ) )
		DlgWidth% = CInt ( Preview.Width * GetDialogZoomFactorX ( Preview.Width ) )
		nXMove% = TwipsPerPixelX() * 3
		nYMove% = TwipsPerPixelX() * 3
	Else
		DlgHeight% = CInt ( ( Preview.Height - TwipsPerPixelY() * 3 ) * GetDialogZoomFactorY ( Preview.Height ) )
		DlgWidth% = CInt ( ( Preview.Width - TwipsPerPixelX() * 3 ) * GetDialogZoomFactorX ( Preview.Width ) )
		nXMove% = 0
		nYMove% = 0
	End If
	
	TWIPSPicWidth% = TwipsPerPixelX() * Width%
	TWIPSPicHeight% = TwipsPerPixelY() * Height%
	
	If ( Not ( ( TWIPSPicWidth% <= DlgWidth% ) And ( TWIPSPicHeight% <= DlgHeight% ) ) ) Then
		x# = ( TWIPSPicWidth% / DlgWidth% )
		y# = ( TWIPSPicHeight% / DlgHeight% )
		If ( x# > y# ) Then
			TWIPSPicWidth% = CInt ( DlgWidth% )
			TWIPSPicHeight% = CInt ( TWIPSPicHeight% / x# )
		Else
			TWIPSPicHeight% = CInt ( DlgHeight% )
			TWIPSPicWidth% = CInt ( TWIPSPicWidth% / y# )
		End If
	End If

	StartX% = CInt ( ( DlgWidth% / 2 ) - ( TWIPSPicWidth% / 2 ) ) - nXMove%
	StartY% = CInt ( ( DlgHeight% / 2 ) - ( TWIPSPicHeight% / 2 ) ) - nYMove%

	Preview.Cls ()
	Preview.DrawPicture ( Bitmap, StartX%, StartY%, StartX% + TWIPSPicWidth%, StartY% + TWIPSPicHeight% )
	IF ( bDrawFrame% ) Then
		Preview.DrawBox ( StartX%, StartY%, StartX% + TWIPSPicWidth%, StartY% + TWIPSPicHeight% )
	End If

End Sub

Sub CheckDatabaseIdentifier(txtBox As Object)

	Dim i%,ch$

	If (len(txtBox.text)<=2) Then
		txtBox.text = txtBox.tag
		MsgBox( Table_gErrorInvalidName ( TableActiveLanguage% ), 16, Table_gWizardName ( TableActiveLanguage% ) )
		txtBox.SetFocus()
		Exit Sub
	End If
	If ( len ( txtBox.Text ) > Application.GetDatabaseLimits ( 1 ) ) Then
		txtBox.text = txtBox.tag
		MsgBox( Table_gErrorNameExceedLimit ( TableActiveLanguage% ), 16, Table_gWizardName ( TableActiveLanguage% ) )
		txtBox.SetFocus()
		Exit Sub
	End If
			
	For i%=1 To len(txtBox.text)
		ch$ = Mid(txtBox.text,i%,1)
		If Not((ch$>="A" And ch<="Z")Or(ch$>="a" And ch<="z")Or(ch$>="0" And ch<="9")Or(ch$="_")Or(ch$=".")) Then
			MsgBox( Table_gNameSyntaxText ( TableActiveLanguage% ), 16, Table_gWizardName ( TableActiveLanguage% ) )
			txtBox.text = txtBox.tag
			txtBox.SetFocus()
			Exit Sub
		End If
	Next
End Sub

Sub ReplaceStringInStrings( aStrings As Strings, ByVal sFind$, ByVal sReplace$)

	Dim NewStrings As New Strings
	Dim nCount%
	
	NewStrings.Clear()
	For nCount% = 1 To aStrings.Count()
		NewStrings.Add( aStrings.Item ( nCount% ) )
	Next

	aStrings.Clear()
	For nCount% = 1 To NewStrings.Count()
		If ( NewStrings.Item ( nCount% ) = sFind$ ) Then
			aStrings.Add( sReplace$ )
		Else
			aStrings.Add( NewStrings.Item ( nCount%) )
		End If
	Next
	
	Erase NewStrings

End Sub

Sub MoveOrderedSelectedListbox( lbDest As Object, lbSource As Object, OriginalOrder As Strings, ByVal bMoveAll% )

	Dim nOriginalPos%, nSourcePos%, nSourceCount%
	Dim bFound%, nFirstSelected%
	Dim sSelected$, sActField$


	If ( bMoveAll% ) Then
	
		nFirstSelected% = -1
		
		lbSource.Clear()
		lbDest.Clear()
		
		For nSourceCount% = 1 To OriginalOrder.Count()
		
			lbDest.AddItem( OriginalOrder.Item( nSourceCount% ) )
		Next	
	Else
	
		nFirstSelected% = -1

		For nSourceCount% = 0 To lbSource.ListCount() - 1

			nSourcePos% = 0
			nOriginalPos% = 1

			If ( lbSource.Selected ( nSourceCount% ) ) Then

				If ( -1 = nFirstSelected% ) Then nFirstSelected% = nSourceCount%

				bFound% = False
				sSelected$ = lbSource.List( nSourceCount% )

				While ( ( Not bFound% ) And ( nOriginalPos% <= OriginalOrder.Count() ) )

					sActField$ = OriginalOrder.Item( nOriginalPos% )

					If ( sSelected$ = sActField$ ) Then
						bFound% = True
						lbDest.AddItem(sSelected$, nSourcePos%)
					Else
						If ( nSourcePos% < lbDest.ListCount() ) Then
							If ( lbDest.List( nSourcePos% ) = sActField$ ) Then 
								nSourcePos% = nSourcePos% + 1
							End If
						End If
					End If

					If ( Not bFound% ) Then nOriginalPos% = nOriginalPos% + 1
				Wend
			End If
		Next

		Call RemoveSelected ( lbSource )
	End If

	'	set selection
	Call SetNewSelection( lbSource, nFirstSelected% )

End Sub

Sub CopyItemsListBox(Source As Object, Dest As Object)

	Dim nCount%

	For nCount% = 0 To Source.ListCount() - 1
		Dest.AddItem ( Source.List( nCount% ) )
	Next

	Source.Clear()
	
	Dest.Selected ( 0 ) = ( 0 < Dest.ListCount() )

End Sub

Sub MoveSelectedListBox(Source As Object, Dest As Object)

	Dim nCount%, nFirstSelection%
	Dim sErrMsg$

	If ( 0 = SelectionInListBox%	 ( Source ) ) Then Exit Sub

	'	Copy and init of nFirstSelection%
	nFirstSelection% = -1
	For nCount% = 0 To Source.ListCount() - 1

		'	If selected copy to dest
		If ( Source.Selected ( nCount% ) ) Then

			If ( -1 = nFirstSelection% ) Then nFirstSelection% = nCount%
			Dest.AddItem( Source.List ( nCount% ) )

		End If
	
	Next

	'	Remove
	Call RemoveSelected ( Source )
	
	'	set selection
	Call SetNewSelection( Source, nFirstSelection% )
End Sub

Sub SetNewSelection( Source As Object, ByVal nFirstSelection% )

	'	Set alternative selection
	If ( 0 < Source.ListCount() ) Then

		If ( nFirstSelection% > ( Source.ListCount() - 1 ) ) Then

			Source.Selected ( Source.ListCount() - 1 ) = True
		Else

			Source.Selected ( nFirstSelection% ) = True
		End If
	End If
End Sub


Sub RemoveSelected ( lb As Object )

	Dim nCount%

	For nCount% = lb.ListCount() - 1 To 0 Step -1

		'	If selected remove item from listbox
		If ( lb.Selected ( nCount% ) ) Then
			lb.RemoveItem( nCount% )
		End If

	Next

End Sub

Function SelectionInListBox%(lb As Object)
	Dim n%,count%
	n%=0
	count%=0
	
	For n%=0 To lb.ListCount()-1
		If lb.Selected(n%) Then
			count% = count% + 1
		End If
	Next
	SelectionInListBox% = Count%
End Function

Sub ReplaceTokenInString ( ByVal TokenToReplace$, ByVal TokenToInsert$, sReplaceIn$ )

	Dim sLeft$, sRight$
	Dim nActSearchPos%
	
	nActSearchPos% = 1
	
	While ( 0 <> InStr ( nActSearchPos%, sReplaceIn$, TokenToReplace$ ) )

		sLeft$ = Left ( sReplaceIn$, InStr ( nActSearchPos%, sReplaceIn$, TokenToReplace$ ) - 1 )
		nActSearchPos% = Len ( sLeft$ ) + Len ( TokenToReplace$ ) + 1
		sRight = Mid ( sReplaceIn$, nActSearchPos% )

		sReplaceIn$ = sLeft$ + TokenToInsert$ + sRight$

	Wend

End Sub
