'SBLLINK:MethodInfo=LoadLanguage0
'SBLLINK:MethodInfo=SetDialogLanguage0
'SBLLINK:MethodInfo=InitResources0
'SBLLINK:MethodInfo=GetResText0

Global Const RID_DB_COMMON_START		= 1000
Global Const RID_DB_TABLE_WIZARD_START	= 2500

Const MAXLANG = 8
'	Language 1 = German
'	         2 = English
'	         3 = French
'	         4 = Italian
'			 5 = Spanish
'			 6 = Portuguese
'			 7 = Dutch
'			 8 = Swedish

'	Global Msg
Dim Table_gWizardName$ 
Dim Table_gErrorNoDatabaseInstalled$ 
Dim Table_gErrorGlobal$ 
Dim Table_gErrorItemAvailable$ 
Dim Table_gErrorCannotOpenDatabase$ 
Dim Table_gSuccessCreateTable$ 
Dim Table_gErrorCreateTable$ 
Dim Table_gErrorUniqueTitle$ 
Dim Table_gErrorInvalidName$ 
Dim Table_gNameSyntaxText$ 
Dim Table_gErrorNameExceedLimit$ 

'	Non const control-properties
Dim Table_Dlg_1Caption$ 
Dim Table_Dlg_2Caption$ 
Dim Table_Dlg_3Caption$ 
Dim Table_Dlg_4Caption$ 

'	Const control-properties
Dim Table_0_cmdCancel$ 
Dim Table_0_cmdPrev$ 
Dim Table_0_cmdNextOrReady$ 

Dim Table_1_frameDatabase$ 
Dim Table_1_frameTables$ 

Dim Table_2_lblSuggest$ 
Dim Table_2_lblAccepted$ 

Dim Table_3_frameControl2$ 
Dim Table_3_frameControl1$ 
Dim Table_3_cmdAcceptNewFieldName$ 

Dim Table_4_frameControl3$ 
Dim Table_4_optOpenTablleReadWrite$ 
Dim Table_4_optEdit$ 
Dim Table_4_cmdReady$ 

Sub LoadLanguage ()
	'	Global Msg
	Table_gWizardName = GetResText( RID_DB_TABLE_WIZARD_START + 0)
	Table_gErrorNoDatabaseInstalled = GetResText( RID_DB_TABLE_WIZARD_START + 1)
	Table_gErrorGlobal = GetResText( RID_DB_COMMON_START + 6)
	Table_gErrorItemAvailable = GetResText( RID_DB_TABLE_WIZARD_START + 2)
	Table_gErrorCannotOpenDatabase = GetResText( RID_DB_TABLE_WIZARD_START + 3)
	Table_gSuccessCreateTable = GetResText( RID_DB_TABLE_WIZARD_START + 4)
	Table_gErrorCreateTable = GetResText( RID_DB_TABLE_WIZARD_START + 5)
	Table_gErrorUniqueTitle = GetResText( RID_DB_COMMON_START + 10)
	Table_gErrorInvalidName = GetResText( RID_DB_COMMON_START + 11)

	'	Non const control-properties
	Table_Dlg_1Caption = Table_gWizardname + GetResText( RID_DB_TABLE_WIZARD_START + 6)
	Table_Dlg_2Caption = Table_gWizardname + GetResText( RID_DB_TABLE_WIZARD_START + 7)
	Table_Dlg_3Caption = Table_gWizardname + GetResText( RID_DB_TABLE_WIZARD_START + 8)
	Table_Dlg_4Caption = Table_gWizardname + GetResText( RID_DB_TABLE_WIZARD_START + 9)

	'	const control-properties
	Table_0_cmdCancel = GetResText( RID_DB_COMMON_START + 1)
	Table_0_cmdPrev = GetResText( RID_DB_COMMON_START + 2)
	Table_0_cmdNextOrReady = GetResText( RID_DB_COMMON_START + 3)
	Table_1_frameDatabase = GetResText( RID_DB_TABLE_WIZARD_START + 10)
	Table_1_frameTables = GetResText( RID_DB_TABLE_WIZARD_START + 11)
	Table_2_lblSuggest = GetResText( RID_DB_TABLE_WIZARD_START + 12)
	Table_2_lblAccepted = GetResText( RID_DB_TABLE_WIZARD_START + 13)
	Table_3_frameControl2 = GetResText( RID_DB_COMMON_START + 5)
	Table_3_frameControl1 = GetResText( RID_DB_TABLE_WIZARD_START + 14)
	Table_3_cmdAcceptNewFieldName = GetResText( RID_DB_TABLE_WIZARD_START + 15)
	Table_4_frameControl3 = GetResText( RID_DB_TABLE_WIZARD_START + 16)
	Table_4_optOpenTablleReadWrite = GetResText( RID_DB_TABLE_WIZARD_START + 17)
	Table_4_optEdit = GetResText( RID_DB_TABLE_WIZARD_START + 19)
	Table_4_cmdReady = GetResText( RID_DB_COMMON_START + 0)

	SetDialogLanguage()
End Sub

Sub SetDialogLanguage ()

	With DlgTable
		.cmdCancel.Caption = Table_0_cmdCancel$
		.cmdPrev.Caption = Table_0_cmdPrev$
		.cmdNextOrReady.Caption = Table_0_cmdNextOrReady$

		.frameDatabase.Caption = Table_1_frameDatabase$
		.frameTables.Caption = Table_1_frameTables$

		.lblSuggest.Caption = Table_2_lblSuggest$
		.label1.Caption = Table_2_lblAccepted$
		.lblAccepted.Caption = Table_2_lblAccepted$

		.frameControl2.Caption = Table_3_frameControl2$
		.frameControl1.Caption = Table_3_frameControl1$
		.cmdAcceptNewFieldName.Caption = Table_3_cmdAcceptNewFieldName$

		.frameControl3.Caption = Table_4_frameControl3$
		.optOpenTablleReadWrite.Caption = Table_4_optOpenTablleReadWrite$
		.optEdit.Caption = Table_4_optEdit$
		.cmdReady.Caption = Table_4_cmdReady$
	End With

End Sub

Dim gResSrv as Object

function InitResources() as boolean

	On Local Error Goto ErrorOcurred

	gResSrv = createUnoService( "com.sun.star.resource.VclStringResourceLoader" )

	if ( IsNull( gResSrv ) ) then
		InitResources = FALSE
		MsgBox( "FormWizard: No resource loader found" )
	else
		InitResources = TRUE
		gResSrv.FileName = "dbw"
	end if
	
	exit function

ErrorOcurred:
	InitResources = FALSE
	nSolarVer = GetSolarVersion()
	MsgBox "Resource file missing ( dbw" + trim(str(nSolarVer)) + "*.res )"

end function


function GetResText( nID as integer ) as string

	On Local Error Goto ErrorOcurred

	if not IsNull( gResSrv ) then
		GetResText = gResSrv.getString( nID )
	else
		GetResText = ""
	end if

	exit function

ErrorOcurred:
	GetResText = ""
	MsgBox "Resource with ID =" + str( nID ) + " not found!"
end function

