'SBLLINK:MethodInfo=Initialize0
'SBLLINK:MethodInfo=ModifyTemplate0
'SBLLINK:MethodInfo=ReshowDialog0
'SBLLINK:MethodInfo=NewTopic0
'SBLLINK:MethodInfo=FinishAgenda0
'SBLLINK:MethodInfo=CreateBookMarkCursor0
'SBLLINK:MethodInfo=DeleteButtons0
' All variables must be declared before use
Option Explicit

' Used for "disabling" the cancel button of the dialog
Dim DialogExited As Boolean


' Necessary bindings:
' Initialize -> CreateDocument
' DeleteButtons -> SaveDocument


Sub Initialize()
' User sets the type of minutes
	Application.LoadLibrary( "Tools" )

	DialogAgenda.Load

	LoadLanguageAgenda% (Application.LanguageID)
	
	DialogAgenda.BtnAgenda1.Value = TRUE
	DialogAgenda.BtnAgenda2.Value = FALSE

	DialogExited = FALSE

	While NOT DialogExited
		DialogAgenda.Show
	Wend

End Sub



Sub ModifyTemplate(CreateSample As Boolean)
Dim oDocument, oBookmarks, oBookmark, oBookmarkCursor, oTextField as Object
Dim i as Integer
	oDocument = ThisDocument.Uno
	oBookMarks = oDocument.Bookmarks

	If CreateSample Then
		Msgbox "Was soll jetzt passieren(createSample = true)?"
		Selection.SetCurField(0, "", AgendaType$)
	Else
		On Local Error Goto NOBOOKMARK
		DialogAgenda.Hide
		DialogExited = TRUE
		If DialogAgenda.BtnAgenda1.Value Then
			oBookmarkCursor = CreateBookmarkCursor(oDocument, "TOP2")
		Else
			oBookmarkCursor = CreateBookmarkCursor(oDocument, "TOP1")
		End If
		oBookmarkCursor.Text.insertString(oBookmarkCursor,"",True)
	
		' Delete all the Bookmarks except for the one named "NextTopic"
		For i = oBookmarks.Count-1 To 0 Step -1
			oBookMark = oBookMarks.GetByIndex(i)
			If oBookMark.Name <> "NextTopic" Then
				oBookMark.Dispose()
			End If
		Next i

		oBookMarkCursor = CreateBookmarkCursor(oDocument, "NextTopic")

		If Not IsNull(oBookMarkCursor) Then
			oTextField = oBookMarkCursor.TextField
			If DialogAgenda.BtnAgenda1.Value Then
				oTextField.TrueContent = "PT1"
			Else
				oTextField.TrueContent = "PT2"
			End If
		End If
		DialogAgenda.Unload
	End If

	NOBOOKMARK:
	If Err <> 0 Then
		RESUME NEXT
	End If
End Sub



Sub ReshowDialog
	MsgBox( DlgAgenda_gMsgNoCancel$, 16, DlgAgenda_gMyName$ )
End Sub



Sub NewTopic
' Add a new topic to the agenda
Dim oDocument, oBookmarks, oBookmark, oBookmarkCursor, oTextField as Object
Dim oBaustein, oAutoText, oAutoGroup as Object
Dim i as Integer
	
	oDocument = ThisDocument.Uno
	oBookMarkCursor = CreateBookMarkCursor(oDocument, "NextTopic")
	oTextField = oBookMarkCursor.TextField
	oAutoText = CreateUnoService("com.sun.star.text.AutoTextContainer")
	If oAutoText.HasbyName("template") Then
		oAutoGroup = oAutoText.GetbyName("template")
		If oAutoGroup.HasbyName(oTextField.TrueContent) Then
			oBaustein = oAutoGroup.GetbyName(oTextField.TrueContent)
			oBaustein.ApplyTo(oBookMarkCursor)
		Else
			Msgbox("AutoText '" & oTextField.TrueContent & "' is not existing. Cannot insert additional topic!")
		End If
	Else
		Msgbox("AutoGroupField template is not existing. Cannot insert additional topic!", 16, DlgAgenda_gMyName$ )
	End If
End Sub


' Add initials, date and time at bottom of agenda, disable and hide command buttons
Sub FinishAgenda
	' Necessary for accessing the buttons
Dim BtnAddAgendaTopic As Object
Dim BtnFinishAgenda As Object
Dim oUserField, oDateTimeField as Object
Dim oBookmarkCursor as Object
Dim oFormats, oLocale as Object
Dim iDateTimeKey as Integer

	' Load Tools library for getControlModel()
	Application.LoadLibrary( "Tools" )
	oDocument = ThisDocument.Uno

	oUserField = oDocument.CreateInstance("com.sun.star.text.TextField.ExtendedUser")
	oUserField.UserDatatype = com.sun.star.text.UserDataPart.SHORTCUT

	oDateTimeField = oDocument.CreateInstance("com.sun.star.text.TextField.DateTime")

	' Assign Standardformat to Datetime-Textfield
	oFormats = oDocument.Numberformats
	oLocale = oDocument.CharLocale
	iDateTimeKey = oFormats.GetStandardFormat(com.sun.star.util.NumberFormat.DATETIME,oLocale)
	oDateTimeField.NumberFormat = iDateTimeKey

	oBookmarkCursor = CreateBookmarkCursor(oDocument, "NextTopic")
	oBookmarkCursor.Text.InsertTextContent(oBookmarkCursor,oUserField,False)
	oBookmarkCursor.Text.InsertString(oBookmarkCursor," ",False)
	oBookmarkCursor.Text.InsertTextContent(oBookmarkCursor,oDateTimeField,False)

	' Disable and hide buttons
	BtnAddAgendaTopic = getControlModel(oDocument, "BtnAddAgendaTopic" )
	BtnFinishAgenda = getControlModel(oDocument, "BtnFinishAgenda" )
	If Not IsNull(BtnAddAgendaTopic) Then BtnAddAgendaTopic.Enabled = FALSE
	If Not IsNull(BtnFinishAgenda) Then BtnFinishAgenda.Enabled = FALSE
End Sub


Function CreateBookMarkCursor(oDocument as Object,sBookmarkName as String)
	oBookMarks = oDocument.Bookmarks
	If oBookmarks.HasbyName(sBookmarkName) Then
		oBookMark = oBookMarks.GetbyName(sBookmarkName)
		CreateBookMarkCursor = oBookMark.Anchor.Text.CreateTextCursorByRange(oBookMark.Anchor)
	Else
		Msgbox "Bookmark " & sBookmarkName &  " is not defined!"
	End If
End Function	




Sub DeleteButtons

	Dim AgendaFinished As Boolean
	' Necessary for accessing the buttons
	Dim BtnAddAgendaTopic As Object
	Dim BtnFinishAgenda As Object

	' Load Tools library for getControlModel()
	oDocument = ThisDocument.Uno

	' Access buttons
	BtnAddAgendaTopic = getControlModel(oDocument, "BtnAddAgendaTopic" )
	BtnFinishAgenda = getControlModel(oDocument, "BtnFinishAgenda" )

	' If buttons could be accessed: If at least one button is disabled, then agenda is finished
	AgendaFinished = FALSE
	If Not IsNull(BtnAddAgendaTopic) Then
		AgendaFinished = (AgendaFinished Or (BtnAddAgendaTopic.Enabled = FALSE))
	End If

	If Not IsNull(BtnFinishAgenda) Then
		AgendaFinished = (AgendaFinished Or (BtnFinishAgenda.Enabled = FALSE))
	End If

	' Delete Buttons, empty rows at end of document & macro bindings if agenda is finished
	If AgendaFinished Then
		disposeControl(oDocument, "BtnAddAgendaTopic")
		disposeControl(oDocument, "BtnFinishAgenda")
	
		oBookmarkCursor = CreateBookMarkCursor(oDocument,"NextTopic")
		oBookMarkCursor.GotoEnd(True)
		oBookmarkCursor.Text.insertString(oBookmarkCursor,"",True)

		ActiveDocument.OnCreate = ""
		ActiveDocument.OnSave = ""
		ActiveDocument.OnSaveAs = ""
		ActiveDocument.OnPrint = ""
	End If
End Sub
