'SBLLINK:MethodInfo=LoadLanguageAgenda0
'SBLLINK:MethodInfo=LoadLanguageCorrespondence0
'SBLLINK:MethodInfo=ExtractFieldName0
Option Explicit

Dim DlgAgenda_gMyName$
Dim DlgAgenda_gMsgNoCancel$



Sub LoadLanguageAgenda% ( ByVal nLanguage% )
' This Sub initialises the public language variables with the text from the resource

Const AgendaDlgName = 1200
Const AgendaDlgNoCancel = 1201
Const AgendaDlgFrame = 1202
Const AgendaDlgButton1 = 1203
Const AgendaDlgButton2 = 1204

	If Not InitResources("'Template'", "tpl") Then
		' Could not load resources -> Exit
		Exit Sub
	End If

	DlgAgenda_gMyName$ = GetResText( AgendaDlgName )
	DlgAgenda_gMsgNoCancel$ = GetResText( AgendaDlgNoCancel )
	DialogAgenda.FrameAgenda.Caption = GetResText( AgendaDlgFrame )
	DialogAgenda.BtnAgenda1.Caption = GetResText( AgendaDlgButton1 )
	DialogAgenda.BtnAgenda2.Caption = GetResText( AgendaDlgButton2 )
End Sub



'######################## Correspondence Module ##################################



Sub LoadLanguageCorrespondence

Const CorrespondenceNoTextmark = 1300
Const CorrespondenceMsgError = 1302
Const CorrespondenceDialog = 1303

Dim SpecConMan, Databases As Object
Dim AddressBookDB$, AddressBookFields$, peet$
Dim aLocale As New com.sun.star.lang.Locale

	If Not InitResources("'Template'", "tpl") Then
		' Could not load resources -> Exit
		Exit Sub
	End If

	' Neccessary for function "ConvertToURL"
	Application.LoadLibrary( "Tools" )

	' Read from Soffice.ini
	SpecConMan = CreateUnoService( "com.sun.star.config.SpecialConfigManager" ).RootKey
	AddressBookDB$ = SpecConMan.openKey( "Database/Addressbook" ).StringValue
	AddressBookFields$ = SpecConMan.openKey( "Common/AddressBookFields" ).StringValue

	' Address book
	Databases = createUnoService( "com.sun.star.sdb.DatabaseAccessContext" )
	dbfAddressBook$ = Left( AddressBookDB$, InStr( AddressBookDB$, ";" )-1 )
  	If Left(dbfAddressBook$, 10) <> "$(userurl)" Then dbfAddressBook$ = ConvertToURL( dbfAddressBook$ )
' Alias will not be used as alias field names can not be determined yet
'	' If the initial address book is used, use the alias
'	If InStr( dbfAddressBook$, "$(userurl)" ) <> 0 Then
'		dbfAddressBook$ = "$(insturl)/share/database/$(vlang)/lang_address.sdb"
'	End If
	aLocale = StarDesktop.ISOLocale
	dbfAddressBook$ = Databases.lookupProgrammatic( aLocale, dbfAddressBook$ )
	dbfTable$ = Mid( AddressBookDB$, InStr( AddressBookDB$, ";" )+1 )

	' Fields
	dbfCompany$ = ExtractFieldName$( AddressBookFields$, "Company:" )
	dbfFirstName$ = ExtractFieldName$( AddressBookFields$, "FirstName:" )
	dbfLastName$ = ExtractFieldName$( AddressBookFields$, "LastName:" )
	dbfStreet$ = ExtractFieldName$( AddressBookFields$, "Street:" )
	dbfPostalCode$ = ExtractFieldName$( AddressBookFields$, "Zip:" )
	dbfCity$ = ExtractFieldName$( AddressBookFields$, "City:" )
	dbfState$ = ExtractFieldName$( AddressBookFields$, "State:" )
	dbfInitials$ = ExtractFieldName$( AddressBookFields$, "Code:" )
	dbfPosition$ = ExtractFieldName$( AddressBookFields$, "Position:" )

	' Error message
	msgNoTextmark$ = GetResText( CorrespondenceNoTextmark ) & Chr(13) & Chr(10) & GetResText( CorrespondenceNoTextmark+1 )
	msgError$ = GetResText( CorrespondenceMsgError )

	' Dialog
	DialogCorrespondence.Caption = GetResText( CorrespondenceDialog )
	DialogCorrespondence.optSingle.Caption = GetResText( CorrespondenceDialog+1 )
	DialogCorrespondence.optMerge.Caption = GetResText( CorrespondenceDialog+2 )

End Sub



Function ExtractFieldName$( AllFields$, SearchField$ )
	Dim Occurrence%, Length%, NextSeparator%

	Occurrence% = InStr( AllFields$, SearchField$ )
	Length% = Len( SearchField$ )
	If Occurrence% = 0 Then
		ExtractFileName$ = ""
	Else
		NextSeparator% = InStr( Occurrence%+Length%, AllFields, ";" )
		If NextSeparator% = 0 Then
			NextSeparator% = Len( AllFields$ )+1
		End If
		ExtractFieldName$ = Mid( AllFields$, Occurrence%+Length%, NextSeparator%-Occurrence%-Length% )
	End If
End Function
