'SBLLINK:MethodInfo=PrepareForEditing0
'SBLLINK:MethodInfo=ShowStyles0
'SBLLINK:MethodInfo=SelectStyle0
'SBLLINK:MethodInfo=SaveCurrentStyles0
'SBLLINK:MethodInfo=RestoreCurrentStyles0
'SBLLINK:MethodInfo=CloseStyleDialog0
'SBLLINK:MethodInfo=KillTempFile0
'SBLLINK:MethodInfo=BubbleSortList0
'SBLLINK:MethodInfo=LoadLibrary0
Option Explicit

Const SAMPLES = 1000
Const STYLES = 1100
Const aTempFileName = "BC_IH_PT_STS_TV_VA.vor"
Public Const Twip = 425

Public oDocument as Object
Public oUCB as Object
Public StylesDir as String
Public PathSeparator as String
Public oFamilies  as Object
Public aOptions() as com.sun.star.beans.PropertyValue
Public sQueryPath as String
Public NoArgs()
Public aTempURL as String

Public CStyles(100) as String


'--------------------------------------------------------------------------------------
'Miscellaneous Section starts here

Sub PrepareForEditing
'This sub is called when sample documents are loaded (load event).
'It checks whether the documents is read-only, in which case it
'offers the user to create a new (writable) document using the original
'as a template.
Dim DocPath as String
Dim MMessage as String
Dim MTitle as String
Dim RValue as Integer
Dim oNewDocument as Object
Dim mFileProperties(0) as New com.sun.star.beans.PropertyValue


	LoadLibrary( "Tools" )

	If not InitResources("'Template'", "tpl") then
		' could not load resources -> exit
		Exit Sub
	End If
	oDocument = StarDesktop.CurrentFrame.Controller.Model
	
	If oDocument.IsReadOnly then
		'get strings from the resource
		MMessage = GetResText( SAMPLES )
		MTitle = GetResText( SAMPLES + 1)
		RValue = Msgbox(MMessage, (128+48+1), MTitle)
		If RValue = 1 Then
			DocPath = oDocument.URL
			mFileProperties(0).Name = "AsTemplate"
			mFileProperties(0).Value = True
			
			oNewDocument = StarDesktop.LoadComponentFromURL(DocPath,"_blank",0, mFileProperties())
    	End If
	End If
End Sub


'--------------------------------------------------------------------------------------
'Calc Style Section starts here

Sub ShowStyles
'This sub displays the style selection dialog if the current document is a calc document.
Dim fValue as String
Dim TemplateDir, ActFileTitle, DisplayDummy as String
Dim sFilterName(0) as String
Dim StyleNames(100, 1) as String
Dim t as Integer
	
	oDocument = StarDesktop.CurrentFrame.Controller.Model	
	oUCB = createUNOService("com.sun.star.ucb.SimpleFileAccess")
	If oDocument.SupportsService("com.sun.star.sheet.SpreadsheetDocument") Then
	    'Application.EnterWait()
		LoadLibrary("Tools")

		If not InitResources("'Template'", "tpl") then
			' could not load resources -> exit
			'Do While Application.IsWait()
			'	Application.LeaveWait()
			'Loop
			exit sub
		End If
		oFamilies = oDocument.StyleFamilies

		SaveCurrentStyles(oDocument)

		PathSeparator = GetPathSeparator()
		TemplateDir = GetPathSettings("Template", False, 0)          'Application.PathSettings.Template
		If InStr (TemplateDir, ";")<>0 Then
			TemplateDir = Left$(TemplateDir, InStr(TemplateDir, ";")-1)
		End If
		StylesDir = TemplateDir  & PathSeparator & "wizard" & PathSeparator & "styles"
		sQueryPath = TemplateDir & PathSeparator & "wizard" & PathSeparator & "bitmap" & PathSeparator

		DialogStyles.StyleData.Clear
		DialogStyles.Caption = GetResText( STYLES )
		DialogStyles.CancelButton.Caption = GetResText( STYLES+2 )
		DialogStyles.OKButton.Caption = GetResText( STYLES+3 )

		sFilterName(0) = "*"
		
		StyleNames() = ReadDirectories(ConvertToURL(StylesDir) , sFilterName(), False, False, True)

		'Add Titles/File names
		For t = 1 to Val(StyleNames(0,0))
			DialogStyles.StyleData.AddItem(StyleNames(t,1))
			CStyles(t-1) = StyleNames(t,0)
		Next t

		'Do While Application.IsWait()
		'	Application.LeaveWait()
		'Loop

		DialogStyles.Load
		DialogStyles.Show
	End If
End Sub



Sub SelectStyle
'This sub loads the specific styles from a style document and loads them into the
'current document.
Dim StylePath as String
Dim NewStyle as String
Dim Position as Integer

	Position = DialogStyles.StyleData.ListIndex
	If Position > -1 Then
		Application.EnterWait()
		StylePath = CStyles(Position) 'StylesDir & PathSeparator & CStyles(Position)
		NewStyle = ConverttoURL(StylePath)
		oFamilies.loadStylesFromURL(NewStyle, aOptions() )

		'Do While Application.IsWait()
		'	Application.LeaveWait()
		'Loop
	End If
End Sub


Sub SaveCurrentStyles(oDocument as Object)
'This sub stores the current document in the user work directory
	On Error Goto ErrorOcurred

	aTempURL = GetPathSettings("Work", False, 0)  'substpathvars("$(workdirurl)")
	'aTempURL = resolvePath(aTempURL)
	aTempURL = ConvertToURL(aTempURL)

	aTempURL = aTempURL & "/" & aTempFileName

	While oUCB.exists(aTempURL)
		aTempURL=Left(aTempURL,(Len(aTempURL)-4)) & "_1.vor"
	Wend
	oDocument.storeToURL(aTempURL,NoArgs)

	Exit Sub

ErrorOcurred:
	'Do While Application.IsWait()
	'	Application.LeaveWait()
	'Loop
	MsgBox(GetResText( STYLES+1 ), 16, GetResText( STYLES ))
End Sub


Sub RestoreCurrentStyles
'This sub retrieves the styles from the temporarily saved document
	'Application.EnterWait()

	If FileExists(aTempURL) Then
		oFamilies.loadStylesFromURL(aTempURL, aOptions() )
	End If

	'Do While Application.IsWait()
	'	Application.LeaveWait()
	'Loop
	DialogStyles.Hide
	DialogStyles.Unload
End Sub


Sub CloseStyleDialog
	DialogStyles.Hide
	DialogStyles.Unload
End Sub


Sub KillTempFile
	'The temp file must be killed
	If oUCB.exists(aTempURL) Then
		oUCB.kill(aTempURL)
	End If
End Sub


Function BubbleSortList(ByVal SortList())
Dim s, t, i as Integer
Dim DisplayDummy as String
	i = Val(SortList(0,0))
	'Bubble sort list
	For s = 1 to i - 1
		For t = 0 to i-s
			If SortList(t,0) > SortList(t+1, 0) Then
				DisplayDummy = SortList(t,0)
				SortList(t,0) = SortList(t+1,0)
				SortList(t+1,0) = DisplayDummy

				DisplayDummy = SortList(t,1)
				SortList(t,1) = SortList(t+1,1)
				SortList(t+1,1) = DisplayDummy	
			End If
		Next t
	Next s 
	BubbleSortList = SortList()		
End Function


Sub LoadLibrary(sLibname as String)
	Dim oArg(0) as new com.sun.star.beans.PropertyValue
	Dim oUrl as new com.sun.star.util.URL
	Dim oTrans as Object
	Dim oDisp as Object

	oArg(0).Name = "LibraryName"
	oArg(0).Value = sLibname

	oTrans = createUNOService("com.sun.star.util.URLTransformer")
	oUrl.Complete = "slot:6517"
	oTrans.parsestrict( oUrl )

	oDisp = StarDesktop.currentFrame.queryDispatch( oUrl, "_self", 0)	
	oDisp.dispatch( oUrl, oArg())
End Sub
