'SBLLINK:MethodInfo=ElimChar0
'SBLLINK:MethodInfo=DeleteStr0
'SBLLINK:MethodInfo=FindPartString0
'SBLLINK:MethodInfo=RTrimStr0
'SBLLINK:MethodInfo=LTRimChar0
'SBLLINK:MethodInfo=ArrayOutOfString0
'SBLLINK:MethodInfo=ClearArray0
'SBLLINK:MethodInfo=ClearMultiDimArray0
'SBLLINK:MethodInfo=FieldinArray0
'SBLLINK:MethodInfo=IndexinArray0
'SBLLINK:MethodInfo=ReplaceString0
'SBLLINK:MethodInfo=ConverttoURL0
'SBLLINK:MethodInfo=ConvertfromURL0
'SBLLINK:MethodInfo=FindSecondValue0
'SBLLINK:MethodInfo=Power0
'SBLLINK:MethodInfo=Round0
'SBLLINK:MethodInfo=FileNameoutofPath0
'SBLLINK:MethodInfo=RetrievePath0
'SBLLINK:MethodInfo=CountCharsinString0
Option Explicit


' Deletes out of a String 'BigString' all possible PartStrings, that are summed up
' in the Array 'ElimArray'
Function ElimChar(ByVal BigString as String, ElimArray() as String)
Dim i,n as integer
	For i = 0 to Ubound(ElimArray)
		BigString = DeleteStr(BigString,ElimArray(i)
	Next
	ElimChar = BigString
End Function



' Deletes out of a String 'BigString' a possible Partstring 'CompString'
Function DeleteStr(ByVal BigString,CompString as String) as String
Dim i, CompLen,BigLen as integer
	CompLen = Len(CompString)
	i = 1
	While i <> 0
		i = Instr(i, BigString,CompString)
		If i <> 0 then
			BigLen = Len(BigString)
			BigString = Mid(BigString,1,i-1) + Mid(BigString,i+CompLen,BigLen-i+1-CompLen)
		End If
	Wend
	DeleteStr = BigString
End Function



' Finds a PartString, that is framed by the Strings 'Prestring' and 'PostString'
Function FindPartString(BigString, PreString, PostString as String, SearchPos as Integer) as String
Dim StartPos, EndPos as Integer
Dim BigLen,PreLen,PostLen as integer
	StartPos = Instr(SearchPos,BigString,PreString)		
	If StartPos <> 0 Then
		PreLen = Len(PreString)
		EndPos = Instr(StartPos + PreLen,BigString,PostString)
		If EndPos <> 0 Then
			BigLen = Len(BigString)
			PostLen = Len(PostString)
			FindPartString = Mid(BigString,StartPos + PreLen, EndPos - (StartPos + PreLen))
			' Da diese Funktion daf?r programmiert wurde, in einer Schleife abgearbeitet zu werden
			' muss die initiale Suchposition hinter die Position des gefundenen Teilstrings gesetzt werden.
			SearchPos = EndPos + PostLen
		Else
			Msgbox("No final tag for '" & PreString & "' existing", 16, "StarOffice 6.0")
			FindPartString = ""
		End If
	Else
		FindPartString = ""
	End If
End Function



' Deletes the String 'SmallString' out of the String 'BigString'
' in case SmallString's Position in BigString is right at the end
Function RTrimStr(ByVal BigString, SmallString as String) as String
Dim SmallLen as integer
Dim BigLen as integer

	SmallLen = Len(SmallString)
	BigLen = Len(BigString)
	If Mid(BigString,BigLen + 1 - SmallLen, SmallLen) = SmallString Then
		RTrimStr = Mid(BigString,1,BigLen - SmallLen)
	Else
		RTrimStr = BigString
	End If
End Function



' Deletes the Char 'CompChar' out of the String 'BigString'
' in case CompChar's Position in BigString is right at the beginning
Function LTRimChar(ByVal BigString as String,CompChar as String) as String
Dim BigLen as integer
	BigLen = Len(BigString)
	If BigLen > 1 Then
		If Left(BigString,1) = CompChar then
	 		BigString = Mid(BigString,2,BigLen-1)
	 	End If
	ElseIf BigLen = 1 Then
	 	BigString = ""
	End If
	LTrimChar = BigString
End Function



' Retrieves an Array out of a String.
' The fields of the Array are separated by the parameter 'Separator', that is contained 
' in the Array
' The Array MaxLocindex delivers the highest Index of this Array
Function ArrayOutOfString(BigString, Separator as String, Optional MaxIndex as integer)

Dim i, OldPos, Pos, SepLen, BigLen as integer
Dim LocList(20) as string
Dim QuitLoop as Boolean

	OldPos = 1
	i = -1
	SepLen = Len(Separator)
	BigLen = Len(BigString)
	Do
		Pos = Instr(OldPos,BigString,Separator)
		i = i + 1
		If Pos = 0 Then
			QuitLoop = True
			LocList(i) = Mid(BigString,OldPos,BigLen - OldPos + 1 )

		Else
			LocList(i) = Mid(BigString,OldPos,Pos-OldPos )
			OldPos = Pos + SepLen
		End If

	Loop until QuitLoop
	If Vartype(Maxindex) <> 0 Then
		MaxIndex = i
	End If
	ArrayoutofString = LocList()
	
End Function



' Deletes all fieldvalues in one-dimensional Array
Sub ClearArray(BigArray)
Dim i as integer
	For i = Lbound(BigArray()) to Ubound(BigArray())
		BigArray(i) = ""		
	Next
End Sub



' Deletes all fieldvalues in a multidimensional Array
Sub ClearMultiDimArray(BigArray,DimCount as integer)
Dim n,m as integer

	For n = Lbound(BigArray(),1) to Ubound(BigArray(),1)
		For m = 0 to Dimcount - 1 
			BigArray(n,m) = ""		
		Next m
	Next n
End Sub



' Checks if a Field (LocField) is already defined in an Array
' Returns 'True' or 'False'
Function FieldinArray(LocArray(), MaxIndex as integer, LocField as String) As Boolean
Dim i as integer
	For i = Lbound(LocArray()) to MaxIndex
		If StrComp(LocArray(i),LocField) = 0 then
			FieldInArray = True
			Exit Function
		End if
	Next
	FieldInArray = False
End Function



' Retrieves the Index of the delivered String 'SearchString' in 
' the Array LocList()'
Function IndexinArray(SearchString as String, LocList()) as Integer
Dim i as integer
	For i = Lbound(LocList(),1) to Ubound(LocList(),1)
		If StrComp(LocList(i,0),SearchString) = 0 then
			IndexinArray = i
			Exit Function
		End if
	Next
	IndexinArray = -1
End Function



' Replaces the string "OldReplace" through the String "NewReplace" in the String
' 'BigString'
Function ReplaceString(ByVal Bigstring, NewReplace, OldReplace as String)  as String
Dim i,OldReplLen,BigLen as integer

	If NewReplace <> OldReplace Then
		OldReplLen = Len(OldReplace)
		i = 1
		Do
			Biglen = Len(BigString)	
			i = Instr(i,BigString,OldReplace)
			If i <> 0 then
				BigString = Mid(BigString,1,i-1) & NewReplace & Mid(BigString,i + OldReplLen,BigLen  - i + 1 - OldReplLen		
				i = i + Len(NewReplace)
			End If
		Loop until i = 0
	End If
	
	ReplaceString = BigString
End Function


' Converts an "ordinary" path to a "URL-Path"
Function ConverttoURL(ByVal BigString as String) as String
Dim Separator as String
	Separator = GetPathSeparator()
	' Is the delivered Path already a URL
	
	If Instr(1,UCase(BigString),"FILE:///") = 0 Then
		BigString = ReplaceString(BigString,"/",Separator)
		BigString = ReplaceString(BigString,"|",":")
		BigString = "file:///" & BigString
		BigString = ReplaceString(BigString,"///", "////")
	End If
	ConvertToURL = BigString
End Function


' Converts an "URL-Path" to an ordinary "Path"
Function ConvertfromURL(ByVal BigString as String) as String
Dim Separator as String
	Separator = GetPathSeparator()
	If Left(Ucase(BigString),8)= "FILE:///" Then
		BigString = Mid(BigString, 9, Len(BigString)-8)
		BigString = ReplaceString(BigString,Separator,"/")
		BigString = ReplaceString(BigString,":","|")
		ConvertFromUrl = BigString
	End If
End Function



' Retrieves the second value for a next to 'SearchString' in
' a two-dimensional string-Array
Function FindSecondValue(SearchString as String, TwoDimList() as String ) as String
Dim i as Integer
	For i = 0 To Ubound(TwoDimList,1)
		If Ucase(SearchString) = Ucase(TwoDimList(i,0)) Then
			FindSecondValue = TwoDimList(i,1)	
			Exit For
		End If
	Next
End Function


' raises a base to a certain power
Function Power(Basis as Double, Exponent as Double) as Double
	Power = Exp(Exponent*Log(Basis))
End Function

' rounds a Real to a given Number of Decimals
Function Round(BaseValue as Double, Decimals as Integer) as Double
Dim Multiplicator as Long
Dim DblValue, RoundValue as Double
	Multiplicator = Power(10,Decimals)
	RoundValue = Int(BaseValue * Multiplicator)
	Round = RoundValue/Multiplicator
End Function


'Retrieves the mere filename out of a whole path
Function FileNameoutofPath(Path, Separator as String) as String
Dim DirList(20) as String
Dim i as Integer
	DirList() = ArrayoutofString(Path,"/",i)		
	FileNameoutofPath = DirList(i)
End Function	



Function RetrievePath(ByVal Path as String) as String
Dim FirstNineChars as String
	FirstNineChars = Ucase(Mid(Path,1,9))
	If FirstNineChars = "FILE:///{" Then
		Path = ResolvePath(Path)
	End If
	RetrievePath = Path
End Function


Function CountCharsinString(BigString, LocChar as String, ByVal StartPos as Integer) as Integer
Dim bIsthere as Boolean
Dim LocCount, LocPos as Integer
	bIsThere  = True
	LocCount = 0
	Do 
		LocPos = Instr(StartPos,BigString,LocChar)
		If LocPos = 0 Then
			bIsThere = False
		Else
			LocCount = LocCount + 1
			StartPos = LocPos+1
		End If
	Loop until Not bIsThere 
	CountCharsInString = LocCount
End Function
	