'SBLLINK:MethodInfo=LoadLanguage0
'SBLLINK:MethodInfo=InitResources0
'SBLLINK:MethodInfo=GetResText0
Option Explicit



Const Res_WebWiz_gWizardName = 1000
Const Res_WebWiz_gErrContentNotFound = 1001
Const Res_WebWiz_gErrStyleNotFound = 1002
Const Res_WebWiz_gErrMainTemplateError = 1003
Const Res_WebWiz_gErrWhileReloading	= 1004
Const Res_WebWiz_gErrWhileLoadStyles = 1005
Const Res_WebWiz_gErrMainDocumentError = 1006
Const Res_WebWiz_gErrMsg = 1007
Const Res_WebWiz_Dlg_1Caption = 1008
Const Res_WebWiz_Dlg_2Caption = 1009
Const Res_MainDialog_cmdCancel_Caption = 1010
Const Res_MainDialog_cmdReady_Caption = 1011
Const Res_WebWiz_0_FrameControl = 1012
Const Res_MainDialog_cmdNextPage_Caption = 1013
Const Res_MainDialog_cmdPrevPage_Caption = 1014
Const Res_MainDialog_lblTemplate_Caption = 1015
Const Res_MainDialog_lblStyle_Caption = 1016
Const Res_MainDialog_chkSaveAsTemplate_Caption = 1017



Dim gResSrv as Object



Sub LoadLanguage()
' This Sub initialises the public language variables with the text from the resource
	If Not InitResources() Then
		' Could not load resources -> Exit
		Exit Sub
	End If
	
	WebWiz_gWizardName = GetResText( Res_WebWiz_gWizardName )
	WebWiz_gErrContentNotFound = GetResText( Res_WebWiz_gErrContentNotFound )
	WebWiz_gErrStyleNotFound = GetResText( Res_WebWiz_gErrStyleNotFound )
	WebWiz_gErrMainTemplateError = GetResText( Res_WebWiz_gErrMainTemplateError )
	WebWiz_gErrWhileReloading = GetResText( Res_WebWiz_gErrWhileReloading )
	WebWiz_gErrWhileLoadStyles = GetResText( Res_WebWiz_gErrWhileLoadStyles )
	WebWiz_gErrMainDocumentError = GetResText( Res_WebWiz_gErrMainDocumentError )
	WebWiz_gErrMsg = GetResText( Res_WebWiz_gErrMsg )
	WebWiz_Dlg_1Caption = GetResText( Res_WebWiz_Dlg_1Caption )
	WebWiz_Dlg_2Caption = GetResText( Res_WebWiz_Dlg_2Caption )
	MainDialog.cmdCancel.Caption = GetResText( Res_MainDialog_cmdCancel_Caption )
	MainDialog.cmdReady.Caption = GetResText( Res_MainDialog_cmdReady_Caption )
	WebWiz_0_FrameControl = GetResText( Res_WebWiz_0_FrameControl )
	MainDialog.cmdNextPage.Caption = GetResText( Res_MainDialog_cmdNextPage_Caption )
	MainDialog.cmdPrevPage.Caption = GetResText( Res_MainDialog_cmdPrevPage_Caption )
	MainDialog.lblTemplate.Caption = GetResText( Res_MainDialog_lblTemplate_Caption )
	MainDialog.lblStyle.Caption = GetResText( Res_MainDialog_lblStyle_Caption )
	MainDialog.chkSaveAsTemplate.Caption = GetResText( Res_MainDialog_chkSaveAsTemplate_Caption )

End Sub



Function InitResources() As Boolean
' This function initialises the resource loader and connects it to the correct resource file.
	On Error Goto ErrorOcurred

	gResSrv = createUnoService( "com.sun.star.resource.VclStringResourceLoader" )

	If ( IsNull( gResSrv ) ) Then
		InitResources = FALSE
		MsgBox( "WebWizard error: No resource loader found" )
	Else
		InitResources = TRUE
		gResSrv.FileName = "wwz"
	End If
	
	Exit Function

ErrorOcurred:
	Dim nSolarVer As Integer
	InitResources = FALSE
	nSolarVer = GetSolarVersion()
	Dim aErrTxt As String
	aErrTxt = "Resource file missing ( wwz" + trim(str(nSolarVer)) + "*.res )"
	MsgBox aErrTxt

End Function



Function GetResText( nID As Integer ) As String
' This function returns the string which corresponds to nID
On Error Goto ErrorOcurred

	If Not IsNull( gResSrv ) Then
		GetResText = gResSrv.getString( nID )
	Else
		GetResText = ""
	End If

	Exit Function

ErrorOcurred:
	GetResText = ""
	Dim aErrTxt As String
	aErrTxt = "Resource with ID =" + str( nID ) + " not found!"
	MsgBox aErrTxt

End Function
