'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=ReloadActualDocument0
'SBLLINK:MethodInfo=LoadNewStyles0
'SBLLINK:MethodInfo=SetBulletAndGraphics0
'SBLLINK:MethodInfo=InitTemplateListBox0
'SBLLINK:MethodInfo=InitStyleListBox0
'SBLLINK:MethodInfo=EndDialog0
'SBLLINK:MethodInfo=CancelHTMLWizard0
'SBLLINK:MethodInfo=ShowNextPage0
'SBLLINK:MethodInfo=ShowPrevPage0
'SBLLINK:MethodInfo=Cleanup0
'SBLLINK:MethodInfo=SetEvent0
'SBLLINK:MethodInfo=CopyGraphics0
'SBLLINK:MethodInfo=GetFileNameFromPath0
'SBLLINK:MethodInfo=GetPaths0
' Variables must be declared
Option Explicit

' Maximum number of coontent templates, style templates and bullets
Const MaxLayouts% = 50
Const MaxStyles% = 100
Const MaxBullets% = 10

' Actual number of styles and layouts
Public NumberOfLayouts%, NumberOfStyles%

' Filled with title, previous, next, home, top, bullet, background, file name
Public Style$( 8, MaxStyles% )

' Filled with title, file name
Public Layout$( 2, MaxLayouts% )

' Directories used
Public TextureDir$, BulletDir$, GraphicsDir$, TemplateDir$, GalleryDir$, PhotosDir$
Public CurrentBullet$, CurrentPrev$, CurrentNext$, CurrentHome$, CurrentTop$

' Path separator
Public PathSeparator$

' Error messages
Public WebWiz_gWizardName$, WebWiz_gErrContentNotFound$, WebWiz_gErrStyleNotFound$
Public WebWiz_gErrMainTemplateError$, WebWiz_gErrWhileReloading$
Public WebWiz_gErrWhileLoadStyles$, WebWiz_gErrMsg$, WebWiz_gErrMainDocumentError$

' Changing text in dialog
Public WebWiz_Dlg_1Caption$, WebWiz_Dlg_2Caption$
Public WebWiz_0_FrameControl$

' Progress bar
Public ProgressBar, ProgressValue As Long



Sub Main

'On Error Goto GlobalErrorHandler
	Dim Counter%, FileStr$

	' Create new HTML document
	Documents.Add ("swriter/web")
	ActiveModule.ViewSettings.TableBounds = False
	ActiveModule.ViewSettings.Bounds = False

	' Initialise progress bar
	ProgressBar = ActiveDocument.Uno.GetCurrentController.GetFrame.GetStatusIndicator
	ProgressBar.Start( "", 100 )
	ProgressValue = 0

	LoadLanguage

	' Change cursor to wait cursor
	Application.EnterWait()
	Wait( 0 )

	' Get path separator and paths for template, gallery, ...
	GetPaths()

	' Update progress bar, estimated 2%
	ProgressValue = 2
	ProgressBar.Value = ProgressValue

	' Load and initialise dialog pt. I
	MainDialog.Load()
	MainDialog.Caption = WebWiz_Dlg_1Caption$
	MainDialog.CurrentStep = 1
	InitTemplateListBox()

	' Update progress bar, estimated 32%
	ProgressValue = 32
	ProgressBar.Value = ProgressValue

	' Start showing first layout to shorten wait period
	For Counter% = 1 To NumberOfLayouts%
		If Layout$( 1, Counter% ) = MainDialog.lbTemplate.List( 0 ) Then
			FileStr$ = Layout$( 2, Counter% )
			Exit For
		End If
	Next
	Selection.InsertFile( FileStr$)

	' Update progress bar, estimated 34%
	ProgressValue = 34
	ProgressBar.Value = ProgressValue

	' Load and initialise dialog pt. II
	InitStyleListBox()
	MainDialog.lbTemplate.Listindex=0
	MainDialog.lbStyle.Listindex=0

	' Update progress bar, estimated 84%
	ProgressValue = 84
	ProgressBar.Value = ProgressValue

	' Create first document
	LoadNewStyles()

	' Update progress bar, estimated 98%
	ProgressBar.Value = 98

	' Show normal cursor and show dialog
	Do While Application.IsWait()
		Application.LeaveWait()
	Loop
	ProgressBar.End
	ProgressValue = 0
	MainDialog.Show()
	Exit Sub

GlobalErrorHandler:
	Cleanup()
	MsgBox ( WebWiz_gErrMsg$, 16, WebWiz_gWizardName$)
	Exit Sub
End Sub



Sub ReloadActualDocument()
	Dim actInd%, FileStr$, Counter%
'On Error Goto ErrorOcurred

	' Disable list in dialog
	MainDialog.lbTemplate.Enabled=False

	' Change cursor to wait cursor
	Application.EnterWait()
	Wait( 0 )

'       ActiveWindow.LockPaint( True )
	ActiveWindow.ShowCursor( False )
	Selection.ActionStart()

	' Start new progress bar
	ProgressBar.Start( "", 14 )

	' Get selected list entry and corresponding file name
	actInd% = MainDialog.lbTemplate.ListIndex()
	For Counter% = 1 To NumberOfLayouts%
		If Layout$( 1, Counter% ) = MainDialog.lbTemplate.List( actInd% ) Then
			FileStr$ = Layout$( 2, Counter% )
			Exit For
		End If
	Next

	' Delete current content of document
	Selection.SelectAll()
	Selection.SelectAll()
	Selection.SelectAll()
	Selection.Delete()
	Selection.ResetAttributes()

	' Get new content file
	Selection.InsertFile( FileStr$)
	Selection.GotoStartOfDoc( False )

	' Update progress bar
	ProgressValue = ProgressValue+2
	ProgressBar.Value = ProgressValue

	SetBulletAndGraphics

	' Enable list selection
	MainDialog.lbTemplate.Enabled=True

	Cleanup
	ProgressBar.End
	ProgressValue = 0
	Exit Sub

ErrorOcurred:
	Cleanup
	MsgBox(WebWiz_gErrWhileReloading$, 16, WebWiz_gWizardName$ )
End Sub



Sub LoadNewStyles()
	Dim FileStr$, BackGroundURL$, actInd%, Counter%

'       ActiveWindow.LockPaint( True )
	ActiveWindow.ShowCursor( False )
	Selection.ActionStart()

	' Disable list selection
	MainDialog.lbStyle.Enabled=False

	' Start new progress bar?
	If ProgressValue = 0 Then
		ProgressBar.Start( "", 14 )
	End If

'On Error Goto ErrorOcurred

	' Change cursor to wait cursor
	Application.EnterWait()
	Wait( 0 )

	' Get selected list entry
	actInd% = MainDialog.lbStyle.ListIndex()

	' Find field index for chosen list entry
	For Counter% = 1 To NumberOfStyles%
		If Style$( 1, Counter% ) = MainDialog.lbStyle.List(actInd%) Then
			Exit For
		End If
	Next
	actInd% = Counter%

	' Load text styles
	FileStr$ = Style$( 8, actInd% )
	ActiveDocument.LoadStyles( FileStr$, 9 )

	' Read array fields for background, bullet & graphics
	BackgroundURL$ = Style$( 7, actInd% )
	If Left( BackgroundURL$, 1 ) <> "#" Then
		BackgroundURL$ = TextureDir$ + BackgroundURL$
	End If
	CurrentBullet$ = BulletDir$ + Style$( 6, actInd% )
	CurrentPrev$ = GraphicsDir$ + Style$( 2, actInd% )
	CurrentNext$ = GraphicsDir$ + Style$( 3, actInd% )
	CurrentHome$ = GraphicsDir$ + Style$( 4, actInd% )
	CurrentTop$ = GraphicsDir$ + Style$( 5, actInd% )

	' Store file names for graphics in document properties
	ActiveDocument.DocumentInfo.Field1 = Left(Style$(2,actInd%),Len(Style$(2,actInd%))-4) _
			& " " & Left(Style$(3,actInd%),Len(Style$(3,actInd%))-4)
	ActiveDocument.DocumentInfo.Field2 = Left(Style$(4,actInd%),Len(Style$(4,actInd%))-4) _
			& " " & Left(Style$(5,actInd%),Len(Style$(5,actInd%))-4)
	ActiveDocument.DocumentInfo.Field3 = Style$( 6, actInd% )       ' Bullet
	ActiveDocument.DocumentInfo.Field4 = Style$( 7, actInd% )       ' Background

	' Set background
	If Left( BackgroundURL$, 1 ) = "#" Then
		' Remove graphic, set color
		ActiveWindow.Page.GrfFilename = ""
		BackgroundURL$ = Right( BackgroundURL$, Len( BackgroundURL$ )-1 )
		ActiveWindow.Page.Style = 1
		ActiveWindow.Page.BackColor = clng( "&H" & BackgroundURL$ )
	Else
		' Set graphic
		ActiveWindow.Page.GrfFilename = BackgroundURL$
		ActiveWindow.Page.GrfPosition = 11
	End If

	' Update progress bar
	ProgressValue = ProgressValue+2
	ProgressBar.Value = ProgressValue

	SetBulletAndGraphics

	Selection.GotoStartOfDoc(False)

	' Enable list selection
	MainDialog.lbStyle.Enabled=True

	Cleanup

	' Close Progress Bar?
	If ProgressValue = 14 Then
		ProgressBar.End
		ProgressValue = 0
	End If

	Exit Sub

ErrorOcurred:
	Cleanup
	MsgBox(WebWiz_gErrWhileLoadStyles$, 16, WebWiz_gWizardName$)
End Sub



Sub SetBulletAndGraphics

	Dim Counter%
	' For some unknown reason the test (Selection.Value=" ") only works properly
	' if Selection.Value has been assigned to a variable before :-(
	Dim Dummy

	' Set Bullets
	If FileExists( CurrentBullet$ ) Then
		For Counter%=1 to MaxBullets%
			If Selection.JumpToBookmark("Bullet"+Trim(Str(Counter%))) Then
				Selection.BulletImageURL = CurrentBullet$
			Else
				Exit For
			End If
		Next
	End If
	' Update progress bar
	ProgressValue = ProgressValue+4
	ProgressBar.Value = ProgressValue

	' Set "Previous" graphic
	If FileExists( CurrentPrev$ ) Then
		' No graphic yet?
		If Selection.JumpToBookmark("Prev") Then
			' Delete bookmark
			Selection.DeleteBookmark("Prev")
			' Delete dummy text
			Selection.GoRight(3,TRUE)
			Selection.Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentPrev$, , TRUE )
			Selection.GraphicName = "Prev"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		' Graphic found: Delete old one, insert new one
		Elseif Selection.GotoFrame("Prev") Then
			' Delete graphic
			ActiveWindow.Graphics("Prev").Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentPrev$, , TRUE )
			Selection.GraphicName = "Prev"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		End If
	End If
	' Update progress bar
	ProgressValue = ProgressValue+2
	ProgressBar.Value = ProgressValue

	' Set "Next" graphic
	If FileExists( CurrentNext$ ) Then
		' No graphic yet?
		If Selection.JumpToBookmark("Next") Then
			' Delete bookmark
			Selection.DeleteBookmark("Next")
			' Delete dummy text
			Selection.GoRight(3,TRUE)
			Selection.Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentNext$, , TRUE )
			Selection.GraphicName = "Next"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		' Graphic found: Delete old one, insert new one
		Elseif Selection.GotoFrame("Next") Then
			' Delete graphic
			ActiveWindow.Graphics("Next").Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentNext$, , TRUE )
			Selection.GraphicName = "Next"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		End If
	End If
	' Update progress bar
	ProgressValue = ProgressValue+2
	ProgressBar.Value = ProgressValue

	' Set "Home" graphic
	If FileExists( CurrentHome$ ) Then
		' No graphic yet?
		If Selection.JumpToBookmark("Home") Then
			' Delete bookmark
			Selection.DeleteBookmark("Home")
			' Delete dummy text
			Selection.GoRight(3,TRUE)
			Selection.Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentHome$, , TRUE )
			Selection.GraphicName = "Home"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		' Graphic found: Delete old one, insert new one
		Elseif Selection.GotoFrame("Home") Then
			' Delete graphic
			ActiveWindow.Graphics("Home").Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentHome$, , TRUE )
			Selection.GraphicName = "Home"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		End If
	End If
	' Update progress bar
	ProgressValue = ProgressValue+2
	ProgressBar.Value = ProgressValue

	' Set "Top" graphic
	If FileExists( CurrentTop$ ) Then
		' No graphic yet?
		If Selection.JumpToBookmark("Top") Then
			' Delete bookmark
			Selection.DeleteBookmark("Top")
			' Delete dummy text
			Selection.GoRight(3,TRUE)
			Selection.Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentTop$, , TRUE )
			Selection.GraphicName = "Top"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		' Graphic found: Delete old one, insert new one
		Elseif Selection.GotoFrame("Top") Then
			' Delete graphic
			ActiveWindow.Graphics("Top").Delete
			' Insert graphic
			Selection.InsertGraphic( CurrentTop$, , TRUE )
			Selection.GraphicName = "Top"
			Selection.AnchorType = 1
			Selection.Escape
			' If graphic is in new line, delete line break
			Selection.GoToEndOfLine( FALSE )
			Selection.GoLeft( 1, TRUE )
			Dummy=Selection.Value
			If Selection.Value = " " Then
				Selection.Insert " "
				Selection.Delete
			Else
				Selection.Escape
			End If
		End If
	End If
	' Update progress bar
	ProgressValue = ProgressValue+2
	ProgressBar.Value = ProgressValue
	' Go to start of document
	Selection.GoToStartOfDoc
End Sub



Sub InitTemplateListBox()
	Dim FileFilter$, ActFile$
	Dim ActFileInfo As New DocumentInfo
	Dim TemplateFound%
	Dim Description$

'On Error Goto ErrorOcurred

	' Change cursor to wait cursor
	Application.EnterWait()
	Wait( 0 )

	NumberOfLayouts% = 0

	FileFilter$ = TemplateDir$ + "cnt-*"
	TemplateFound% = False

	' Read all content templates, store infos in Layout$ array
	ActFile = Dir(FileFilter$)
	Do While (ActFile$<>"")
		ActFileInfo.Load(TemplateDir$ + ActFile$)
		NumberOfLayouts% = NumberOfLayouts% + 1
		Description$ = ActFileInfo.Title
		If (Description$<>"") Then
			MainDialog.lbTemplate.AddItem(Description$)
			Layout$ (1, NumberOfLayouts%) = Description$
		Else
			MainDialog.lbTemplate.AddItem(ActFile$)
			Layout$ (1, NumberOfLayouts%) = ActFile$
		End If
		Layout$ (2, NumberOfLayouts%) = TemplateDir$ + ActFile$
		TemplateFound% = True
		ActFile$=Dir
		' Update progress bar: Add estimated 2%
		ProgressValue = ProgressValue+2
		ProgressBar.Value = ProgressValue
	Loop
	Erase ActFileInfo

	' Change cursor to normal cursor
	Do While ( Application.IsWait() )
		Application.LeaveWait()
	Loop

	' No content template? Error message, close new empty document, stop execution
	If (TemplateFound%=False) Then
		MsgBox(WebWiz_gErrContentNotFound$ , 16, WebWiz_gWizardName$)
		ActiveDocument.Close( FALSE )
		Stop
	End If

	Exit Sub

ErrorOcurred:
	Cleanup
	MsgBox( InitXXListBox_MainError, 16, WebWiz_gWizardName$ )
End Sub



Sub InitStyleListBox()
	Dim FileFilter$, ActFile$
	Dim ActFileInfo As New DocumentInfo
	Dim StyleFound%
	Dim Description$

'On Error Goto ErrorOcurred

	' Change cursor to wait cursor
	Application.EnterWait()
	Wait( 0 )

	FileFilter$ = TemplateDir$ + "stl-*"
	StyleFound% = False

	NumberOfStyles% = 0

	' Read all style templates, store infos in Style$ array
	ActFile$ = Dir(FileFilter$)
	Do While (ActFile$<>"")
		ActFileInfo.Load( TemplateDir$ + ActFile$ )
		NumberOfStyles% = NumberOfStyles% + 1
		Description$ = ActFileInfo.Title
		If (Description$<>"") Then      ' Store title
			MainDialog.lbStyle.AddItem( Description$ )
			Style$(1,NumberOfStyles%) = Description$
		Else    ' Store file name
			MainDialog.lbStyle.AddItem( ActFile$ )
			Style$(1,NumberOfStyles%) = ActFile$
		End If
		Style$(2,NumberOfStyles%) = Left$(ActFileInfo.Field1, _
				InStr(ActFileInfo.Field1," ")-1)+".gif" ' Previous
		Style$(3,NumberOfStyles%) = Right$(ActFileInfo.Field1, _
				Len(ActFileInfo.Field1)-InStr(ActFileInfo.Field1," "))+".gif"   ' Next
		Style$(4,NumberOfStyles%) = Left$(ActFileInfo.Field2, _
				InStr(ActFileInfo.Field2," ")-1)+".gif" ' Home
		Style$(5,NumberOfStyles%) = Right$(ActFileInfo.Field2, _
				Len(ActFileInfo.Field2)-InStr(ActFileInfo.Field2," "))+".gif"   ' Top
		Style$(6,NumberOfStyles%) = ActFileInfo.Field3  ' Bullet
		Style$(7,NumberOfStyles%) = ActFileInfo.Field4  ' Background
		Style$(8,NumberOfStyles%) = TemplateDir$ + ActFile$     ' Filename, for loading text styles
			StyleFound% = True
		ActFile$=Dir
		' Update progress bar: Add estimated 2%
		ProgressValue = ProgressValue+2
		ProgressBar.Value = ProgressValue
	Loop
	Erase ActFileInfo

	' Change cursor to normal cursor
	Do While ( Application.IsWait() )
		Application.LeaveWait()
	Loop

	' No style template? Error message, close new empty document, stop execution
	If StyleFound%=False Then
		MsgBox( WebWiz_gErrStyleNotFound, 16, WebWiz_gWizardName$ )
		ActiveDocument.Close( FALSE )
		Stop
	End If

	Exit Sub

ErrorOcurred:
	Cleanup
	MsgBox(WebWiz_gErrMainTemplateError, 16, WebWiz_gWizardName$)
End Sub



Sub EndDialog()
	StarWriter.ViewSettings.TableBounds = TRUE
	StarWriter.ViewSettings.Bounds = True

	If chkSaveAsTemplate.Value Then
		' Generating template? Set events later!
		ActiveDocument.OnCreate = "SetEvent(WebWizard.HtmlAutoPilotBasic)"
		ActiveDocument.SaveAsTemplate()
	Else
		' Generating document? Set events now!
		SetEvent
	End If

	' Close dialog
	MainDialog.Hide()
	MainDialog.UnLoad()
End Sub



Sub CancelHTMLWizard()
	' Change cursor to normal cursor
	Do While Application.IsWait()
		Application.LeaveWait()
	Loop
	' Close new document
	ActiveDocument.Close( False )
	' Show table bounds and text bounds
	StarWriter.ViewSettings.TableBounds = TRUE
	StarWriter.ViewSettings.Bounds = True
	' Close dialog
	MainDialog.Hide()
	MainDialog.UnLoad()
End Sub



Sub ShowNextPage()
	' Switch dialog to slection of styles
	MainDialog.Caption = WebWiz_Dlg_2Caption
	MainDialog.cmdNextPage.Enabled=False
	MainDialog.cmdPrevPage.Enabled=True
	MainDialog.CurrentStep = 2
End Sub



Sub ShowPrevPage()
	' Switch dialog to selection of content
	MainDialog.Caption = WebWiz_Dlg_1Caption$
	MainDialog.cmdPrevPage.Enabled=False
	MainDialog.cmdNextPage.Enabled=True
	MainDialog.CurrentStep = 1
End Sub



Sub Cleanup
	' Change wait cursor to normal cursor
	Do While ( Application.IsWait() )
		Application.LeaveWait()
	Loop
	' Allow repainting, show cursor
	Selection.ActionEnd()
	ActiveWindow.ShowCursor( True )
	If ActiveWindow.IsPaintLocked Then ActiveWindow.LockPaint( False )
End Sub



Sub SetEvent
' This sub links the events OnSaveDone and OnSaveAsDone to the procedure
' CopyGraphics. It is invoked when a document is created, either directly
' from the AutoPilot or from a template. It is not possible to set these
' links for the template created by the AutoPilot because then it is not
' possible to modify the template.
	ActiveDocument.OnSaveDone = "CopyGraphics(WebWizard.HtmlAutoPilotBasic)"
	ActiveDocument.OnSaveAsDone = "CopyGraphics(WebWizard.HtmlAutoPilotBasic)"
End Sub



Sub CopyGraphics
' This sub copies all the graphics used in the document to the same directory the
' document has been copied into and changes the graphics links in the document.
	Dim SavePath$
	Dim GraphicFileName$
	Dim Counter%
	' For some unknown reason the test (Selection.Value=" ") only works properly
	' if Selection.Value has been assigned to a variable before :-(
	Dim Dummy

	ActiveWindow.ShowCursor( False )
	Selection.ActionStart()

	' Get path separator and paths for template, gallery, graphics
	GetPaths

	' Get path of file
	SavePath = ActiveDocument.Path & PathSeparator$

	' Copy "Previous" graphic
	CopyJob("Prev",1)

	' Copy "Next" graphic
	CopyJob("Next",1)

	' Copy "Home" graphic
	CopyJob("Home",1)

	' Copy "Top" graphic
	CopyJob("Top",1)

	CopyJob("Dummy1",2)

	' Copy "Next" graphic
	CopyJob("Dummy2",2)

	' Copy "Home" graphic
	CopyJob("Dummy3",2)

	' Copy "Top" graphic
	CopyJob("Dummy4",2)



	Selection.Escape
	Selection.GoToStartOfDoc

	' Copy bullet graphic
	If Selection.JumpToBookmark("Bullet1") Then
		' Get file name
		GraphicFileName$ = GetFileNameFromPath$( Selection.BulletImageURL )
		' Copy file
		FileCopy BulletDir$+GraphicFileName$, SavePath$+GraphicFileName$
		' Set new bullet links
		For Counter%=1 to MaxBullets%
			If Selection.JumpToBookmark("Bullet"+Trim(Str(Counter%))) Then
				Selection.BulletImageURL = SavePath$+GraphicFileName$
				Selection.DeleteBookmark("Bullet"+Trim(Str(Counter%)))
			Else
				Exit For
			End If
		Next
	End If

	' Copy background graphic
	If ActiveWindow.Page.GrfFilename<>"" Then
		' Get file name
		GraphicFileName$ = GetFileNameFromPath$( ActiveWindow.Page.GrfFilename )
		' Copy file
		FileCopy TextureDir$+GraphicFileName$, SavePath$+GraphicFileName$
		' Set new background graphic
		ActiveWindow.Page.GrfFilename = SavePath$+GraphicFileName$
		ActiveWindow.Page.GrfPosition = 11
	End If

	' Clear document info
	ActiveDocument.DocumentInfo.Field1 = ""
	ActiveDocument.DocumentInfo.Field2 = ""
	ActiveDocument.DocumentInfo.Field3 = ""
	ActiveDocument.DocumentInfo.Field4 = ""

	' Reset events
	ActiveDocument.OnSaveDone = ""
	ActiveDocument.OnSaveAsDone = ""
	ActiveDocument.OnCreate = ""

	' Save again as document has been modified
	ActiveDocument.Save

	Cleanup
End Sub



Function GetFileNameFromPath$( FullPath$ )
' Extracts a file name from a full path. It doesn't matter if the path is provided as a URL
' or in a system specific notation.
	Dim Start%, PathSep$

	' If path contains a "/", it is a URL. If not, find system specific path separator.
	If InStr( FullPath$, "/" )<>0 Then
		PathSep$ = "/"
	Else
		PathSep$ = GetPathSeparator$
	End If

	' Find last occurence of path separating character & return everything right of it.
	Start% = 1
	Do
		Start% = 1 +InStr( Start%, FullPath$, PathSep$ )
	Loop Until InStr( Start%, FullPath$, PathSep$ )=0
	GetFileNameFromPath$ = Right( FullPath$, Len( FullPath$ )-Start%+1 )
End Function



Sub GetPaths
' Initialises all global variables for path and path separator.
	PathSeparator$ = GetPathSeparator()

	' Get template directory. If system variable contains list of directories, take first directory
	TemplateDir$ = Application.PathSettings.Template
	If InStr (TemplateDir$, ";")<>0 Then
		TemplateDir$ = Left$(TemplateDir$, InStr(TemplateDir$, ";")-1)
	End If
	TemplateDir$ = TemplateDir$ & PathSeparator$ & "wizard" & PathSeparator$ & "web" & PathSeparator$
	' Get gallery directory. If system variable contains list of directories, take first directory
	GalleryDir$ = Application.PathSettings.Gallery
	If InStr (GalleryDir$, ";")<>0 Then
		GalleryDir$ = Left$(GalleryDir$, InStr(GalleryDir$, ";")-1)
	End If

	' Get directories for textures, graphics, bullets, photos
	TextureDir$ = GalleryDir$+PathSeparator$ +"www-back" +PathSeparator$
	GraphicsDir$ = GalleryDir$  +PathSeparator$ +"www-graf" +PathSeparator$
	BulletDir$ = GalleryDir$  +PathSeparator$ +"bullets" +PathSeparator$
	PhotosDir$ = GalleryDir$  +PathSeparator$
End Sub


Sub CopyJob(fname as String, ftype as integer)
	Dim SavePath$
	Dim GraphicFileName$
	Dim Counter%
	Dim Dummy
	Dim SourceDir$

	GetPaths
	SavePath = ActiveDocument.Path & PathSeparator$

	If Selection.GotoFrame(fname) Then
		' Get file name
		GraphicFileName$ = GetFileNameFromPath$( Selection.GrfLinkName )
		' Copy file
		select case ftype
		case 1
			SourceDir$ = GraphicsDir$
		case 2
			SourceDir$ = PhotosDir$
		end select

		FileCopy SourceDir$+GraphicFileName$, SavePath$+GraphicFileName$
		' Delete graphic
		ActiveWindow.Graphics(fname).Delete
		' Insert graphic
		Selection.InsertGraphic( SavePath +GraphicFileName$, , TRUE )
		Selection.GraphicName = fname
		Selection.AnchorType = 1
		Selection.Escape
		' If graphic is in new line, delete line break
		Selection.GoToEndOfLine( FALSE )
		Selection.GoLeft( 1, TRUE )
		Dummy=Selection.Value
		If Selection.Value = " " Then
			Selection.Insert " "
			Selection.Delete
		Else
			Selection.Escape
		End If
	End If
End Sub

