/*************************************************************************
 *
 *  $RCSfile: lst_desc.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:29:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef CPV_LST_DESC_H
#define CPV_LST_DESC_H


#include "cmpdescr.h"



typedef struct LCDElem
{
	ComponentDescription *
						pData;
	struct LCDElem *	pNext;
} LCDElem;


typedef struct LCDIterator
{
	LCDElem *       	pElement;
} LCDIterator;


typedef struct ListComponentDescription
{
	LCDElem *			dpStart;
	LCDElem *			pEnd;
} ListComponentDescription;






void				ListComponentDescription_CTOR( ListComponentDescription * pThis );
void				ListComponentDescription_DTOR( ListComponentDescription * pThis );

void				LCD_Add( ListComponentDescription * pThis,
						ComponentDescription *
											i_pData );
void				LCD_Empty( ListComponentDescription * pThis );

LCDIterator			LCD_Begin( ListComponentDescription * pThis );


void				LCDIterator_CTOR( LCDIterator * pThis,
						LCDElem *     		i_pElement );
void				LCDI_opp( LCDIterator * pThis );  	/** operator++() */

Bool				LCDI_obool( LCDIterator * pThis );
ComponentDescription *
					LCDI_optr( LCDIterator * pThis );  	/** operator->() */


void				LCDElem_CTOR( LCDElem * pThis,
						ComponentDescription *			i_pData );
void				LCDElem_DTOR( LCDElem * pThis );

ComponentDescription *
					LCDE_Data( LCDElem * pThis );
LCDElem *			LCDE_Next( LCDElem * pThis );

void				LCDE_SetNext( LCDElem * pThis,
						LCDElem *			i_pNext );


#endif
