/*************************************************************************
 *
 *  $RCSfile: nmspmap.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XMLOFF_NMSPMAP_HXX
#define _XMLOFF_NMSPMAP_HXX

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>

const USHORT XML_NAMESPACE_XMLNS  = (USHRT_MAX-2);
const USHORT XML_NAMESPACE_NONE  = (USHRT_MAX-1);
const USHORT XML_NAMESPACE_UNKNOWN  = (USHRT_MAX);

class OUStringsDtor_Impl;

class SvXMLNamespaceMap
{
	const ::rtl::OUString		sXMLNS;
	const ::rtl::OUString		sEmpty;
	
	OUStringsDtor_Impl	*pPrefixes;
	OUStringsDtor_Impl	*pNames;
	SvUShorts			aKeys;

public:

	SvXMLNamespaceMap();
	~SvXMLNamespaceMap();

	SvXMLNamespaceMap( const SvXMLNamespaceMap& );

	int operator ==( const SvXMLNamespaceMap& rCmp ) const;

	USHORT Add( const ::rtl::OUString& rPrefix,
				const ::rtl::OUString& rName,
				USHORT nKey=XML_NAMESPACE_UNKNOWN );
	BOOL AddAtIndex( USHORT nIdx, const ::rtl::OUString& rPrefix,
					 const ::rtl::OUString& rName,
					 USHORT nKey=XML_NAMESPACE_UNKNOWN );
	BOOL AddAtIndex( USHORT nIdx, const sal_Char *pPrefix,
					 const sal_Char *pName,
					 USHORT nKey=XML_NAMESPACE_UNKNOWN );

	USHORT GetIndexByKey( USHORT nKey ) const;
	USHORT GetIndexByPrefix( const ::rtl::OUString& rPrefix ) const;
	USHORT GetKeyByName( const ::rtl::OUString& rName ) const;

	const ::rtl::OUString& GetPrefixByIndex( USHORT nIdx ) const;
	const ::rtl::OUString& GetNameByIndex( USHORT nIdx ) const;
	USHORT GetKeyByIndex( USHORT nIdx ) const;

	::rtl::OUString GetAttrNameByIndex( USHORT nIdx ) const;
	inline ::rtl::OUString GetAttrNameByKey( USHORT nIdx ) const;

	::rtl::OUString GetQNameByIndex( USHORT nIdx,
							const ::rtl::OUString& rLocalName ) const;
	inline ::rtl::OUString GetQNameByKey( USHORT nKey, 
						   const ::rtl::OUString& rLocalName ) const;

	USHORT GetKeyByAttrName( const ::rtl::OUString& rAttrName,
							 ::rtl::OUString *pPrefix,
							 ::rtl::OUString *pLocalName,
							 ::rtl::OUString *pNamespace=0,
							 USHORT nIdxGuess=USHRT_MAX ) const;
	inline USHORT GetKeyByAttrName( const ::rtl::OUString& rAttrName,
							 ::rtl::OUString *pLocalName = 0,
							 USHORT nIdxGuess=USHRT_MAX ) const;

	USHORT GetFirstIndex() const;
	USHORT GetNextIndex( USHORT nOldIdx ) const;
};

inline ::rtl::OUString SvXMLNamespaceMap::GetAttrNameByKey(
															USHORT nKey ) const
{
	return GetAttrNameByIndex( GetIndexByKey(nKey) );
}

inline ::rtl::OUString SvXMLNamespaceMap::GetQNameByKey( USHORT nKey,
							const ::rtl::OUString& rLocalName ) const
{
	return GetQNameByIndex( GetIndexByKey(nKey), rLocalName );
}

inline USHORT SvXMLNamespaceMap::GetKeyByAttrName(
							const ::rtl::OUString& rAttrName,
							::rtl::OUString *pLocalName,
							USHORT nIdxGuess ) const
{
	return GetKeyByAttrName( rAttrName, 0, pLocalName, 0, nIdxGuess );
}


#endif	//  _XMLOFF_NMSPMAP_HXX
