/*************************************************************************
 *
 *  $RCSfile: pkgurl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _URLPACKER_HXX
#define _URLPACKER_HXX


#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XATTRIBUTELIST_HPP_
#include <com/sun/star/xml/sax/XAttributeList.hpp>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XLOCATOR_HPP_
#include <com/sun/star/xml/sax/XLocator.hpp>
#endif

#ifndef _GRFMGR_HXX
#include <goodies/grfmgr.hxx>
#endif

#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#ifndef _SVSTDARR_STRINGSSORTDTOR_DECL
#define _SVSTDARR_STRINGSSORTDTOR
#include <svtools/svstdarr.hxx>
#endif



class URLGraphicData
{
public:
	Graphic  	  aGraphic;
	GraphicObject aGrafObj;
	ByteString	  sOldID;
	
public:
	URLGraphicData ( ByteString &rID);
	~URLGraphicData();
};
DECLARE_LIST( URLGraphicListImpl, URLGraphicData*);

class URLGraphicList : public URLGraphicListImpl
{
public:
	GraphicObject* Contains( ByteString& rID);
};

class URLPacker : public ::cppu::WeakImplHelper1 < ::com::sun::star::xml::sax::XDocumentHandler >
{
private: 
	::rtl::OUString sMainXMLFile;
	::rtl::OUString sAbsolutePath;
	::com::sun::star::uno::Reference < ::com::sun::star::xml::sax::XDocumentHandler > xHandler;
	sal_Bool b2Absolute;
	sal_Bool bExport;
	URLGraphicList *pGrafList;
	SvStringsSortDtor *pIDList;

public:
	 URLPacker( const ::rtl::OUString& rBase,
				::com::sun::star::uno::Reference < ::com::sun::star::xml::sax::XDocumentHandler > xParent,  
				sal_Bool bIAbsolute,
				sal_Bool bIExport);
     /*
	 URLPacker(rtl::OUString& rBase, ::com::sun::star::uno::Reference <::com::sun::star::xml::sax::XDocumentHandler> xParent,  sal_Bool bIAbsolute) : 
		 sAbsolutePath(rBase),xHandler(xParent), sAbsolutePath(rBase), bAbsolute(bIAbsolute) {}*/
	 ~URLPacker();

public: //XDocumentHandler
    virtual void SAL_CALL startDocument(void)
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL endDocument(void)
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL startElement(const ::rtl::OUString& rElementName,
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > & xAttribs) 
		throw (::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL endElement(const ::rtl::OUString& aName)
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL characters(const ::rtl::OUString& aChars)
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL ignorableWhitespace(const ::rtl::OUString& aWhitespaces)
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL processingInstruction(const ::rtl::OUString& aTarget,
			const ::rtl::OUString& aData) 
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setDocumentLocator(const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > & xLocator)
		throw(::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException);

	void SaveImage( INetURLObject& rUrl );
	void LoadImage( INetURLObject& rURLObj, 
					Graphic& rGraphic, 
					GraphicObject& rGrafObj );

};
#endif
