/*************************************************************************
 *
 *  $RCSfile: shapeimport.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XMLOFF_SHAPEIMPORT_HXX_
#define _XMLOFF_SHAPEIMPORT_HXX_

#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XATTRIBUTELIST_HPP_
#include <com/sun/star/xml/sax/XAttributeList.hpp>
#endif

#ifndef _COM_SUN_STAR_DRAWING_XSHAPES_HPP_
#include <com/sun/star/drawing/XShapes.hpp>
#endif

#ifndef _UNIVERSALL_REFERENCE_HXX
#include "uniref.hxx"
#endif

class SvXMLImport;
class SvXMLImportContext;
class SvXMLTokenMap;
class SvXMLStylesContext;
class XMLSdPropHdlFactory;
class XMLPropertySetMapper;

//////////////////////////////////////////////////////////////////////////////

enum SdXMLGroupShapeElemTokenMap
{
	XML_TOK_GROUP_GROUP,
	XML_TOK_GROUP_RECT,
	XML_TOK_GROUP_LINE,
	XML_TOK_GROUP_CIRCLE,
	XML_TOK_GROUP_ELLIPSE,
	XML_TOK_GROUP_POLYGON,
	XML_TOK_GROUP_POLYLINE,
	XML_TOK_GROUP_PATH,
	XML_TOK_GROUP_TEXT_BOX,

	XML_TOK_GROUP_CONTROL,
	XML_TOK_GROUP_CONNECTOR,
	XML_TOK_GROUP_MEASURE,
	XML_TOK_GROUP_PAGE,
	XML_TOK_GROUP_CAPTION,

	XML_TOK_GROUP_CHART,
	XML_TOK_GROUP_IMAGE,
//	XML_TOK_GROUP_3D_CUBE,
//	XML_TOK_GROUP_3D_SPHERE,
//	XML_TOK_GROUP_3D_LATHE,
//	XML_TOK_GROUP_3D_EXTRUDE,
//	XML_TOK_GROUP_3D_POLYGON,

	XML_TOK_GROUP_LAST
};

enum SdXMLShapeAttrTokenMap
{
	XML_TOK_SHAPE_DRAWSTYLE_NAME_GRAPHICS,
	XML_TOK_SHAPE_PRESENTATION_CLASS,
	XML_TOK_SHAPE_DRAWSTYLE_NAME_PRESENTATION,
	XML_TOK_SHAPE_TRANSFORM,
	XML_TOK_SHAPE_IS_PLACEHOLDER,
	XML_TOK_SHAPE_IS_USER_TRANSFORMED
};

enum SdXMLRectShapeAttrTokenMap
{
	XML_TOK_RECTSHAPE_X,
	XML_TOK_RECTSHAPE_Y,
	XML_TOK_RECTSHAPE_WIDTH,
	XML_TOK_RECTSHAPE_HEIGHT,
	XML_TOK_RECTSHAPE_CORNER_RADIUS
};

enum SdXMLLineShapeAttrTokenMap
{
	XML_TOK_LINESHAPE_X1,
	XML_TOK_LINESHAPE_Y1,
	XML_TOK_LINESHAPE_X2,
	XML_TOK_LINESHAPE_Y2
};

enum SdXMLEllipseShapeAttrTokenMap
{
	XML_TOK_ELLIPSESHAPE_RX,
	XML_TOK_ELLIPSESHAPE_RY,
	XML_TOK_ELLIPSESHAPE_CX,
	XML_TOK_ELLIPSESHAPE_CY,
	XML_TOK_ELLIPSESHAPE_R
};

enum SdXMLPolygonShapeAttrTokenMap
{
	XML_TOK_POLYGONSHAPE_X,
	XML_TOK_POLYGONSHAPE_Y,
	XML_TOK_POLYGONSHAPE_WIDTH,
	XML_TOK_POLYGONSHAPE_HEIGHT,
	XML_TOK_POLYGONSHAPE_VIEWBOX,
	XML_TOK_POLYGONSHAPE_POINTS
};

enum SdXMLPathShapeAttrTokenMap
{
	XML_TOK_PATHSHAPE_X,
	XML_TOK_PATHSHAPE_Y,
	XML_TOK_PATHSHAPE_WIDTH,
	XML_TOK_PATHSHAPE_HEIGHT,
	XML_TOK_PATHSHAPE_VIEWBOX,
	XML_TOK_PATHSHAPE_D
};

enum SdXMLTextBoxShapeAttrTokenMap
{
	XML_TOK_TEXTBOXSHAPE_X,
	XML_TOK_TEXTBOXSHAPE_Y,
	XML_TOK_TEXTBOXSHAPE_WIDTH,
	XML_TOK_TEXTBOXSHAPE_HEIGHT
};

enum SdXMLControlShapeAttrTokenMap
{
	XML_TOK_CONTROLSHAPE_X,
	XML_TOK_CONTROLSHAPE_Y,
	XML_TOK_CONTROLSHAPE_WIDTH,
	XML_TOK_CONTROLSHAPE_HEIGHT
};

enum SdXMLPageShapeAttrTokenMap
{
	XML_TOK_PAGESHAPE_X,
	XML_TOK_PAGESHAPE_Y,
	XML_TOK_PAGESHAPE_WIDTH,
	XML_TOK_PAGESHAPE_HEIGHT
};

enum SdXMLGraphicObjectShapeAttrTokenMap
{
	XML_TOK_GOSHAPE_X,
	XML_TOK_GOSHAPE_Y,
	XML_TOK_GOSHAPE_WIDTH,
	XML_TOK_GOSHAPE_HEIGHT,
	XML_TOK_GOSHAPE_URL
};
//////////////////////////////////////////////////////////////////////////////

class XMLShapeImportHelper : public UniRefBase
{
	com::sun::star::uno::Reference< com::sun::star::frame::XModel > mxModel;

	// PropertySetMappers and factory
	XMLSdPropHdlFactory*		mpSdPropHdlFactory;
	XMLPropertySetMapper*		mpPropertySetMapper;
	XMLPropertySetMapper*		mpPresPagePropsMapper;

	// contexts for Style and AutoStyle import
	SvXMLStylesContext*			mpStylesContext;
	SvXMLStylesContext*			mpAutoStylesContext;

	// contexts for xShape contents TokenMaps
	SvXMLTokenMap*				mpGroupShapeElemTokenMap;
	SvXMLTokenMap*				mpShapeAttrTokenMap;
	SvXMLTokenMap*				mpRectShapeAttrTokenMap;
	SvXMLTokenMap*				mpLineShapeAttrTokenMap;
	SvXMLTokenMap*				mpEllipseShapeAttrTokenMap;
	SvXMLTokenMap*				mpPolygonShapeAttrTokenMap;
	SvXMLTokenMap*				mpPathShapeAttrTokenMap;
	SvXMLTokenMap*				mpTextBoxShapeAttrTokenMap;
	SvXMLTokenMap*				mpControlShapeAttrTokenMap;
	SvXMLTokenMap*				mpPageShapeAttrTokenMap;
	SvXMLTokenMap*				mpGraphicObjectShapeAttrTokenMap;

public:
	XMLShapeImportHelper(
		const com::sun::star::uno::Reference< com::sun::star::frame::XModel>& rModel);
	~XMLShapeImportHelper();

	SvXMLImportContext* CreateGroupChildContext( 
		SvXMLImport& rImport, sal_uInt16 nPrefix, const rtl::OUString& rLocalName,
		const com::sun::star::uno::Reference< com::sun::star::xml::sax::XAttributeList >& xAttrList,
		com::sun::star::uno::Reference< com::sun::star::drawing::XShapes >& rShapes);

	const SvXMLTokenMap& GetGroupShapeElemTokenMap();
	const SvXMLTokenMap& GetShapeAttrTokenMap();
	const SvXMLTokenMap& GetRectShapeAttrTokenMap();
	const SvXMLTokenMap& GetLineShapeAttrTokenMap();
	const SvXMLTokenMap& GetEllipseShapeAttrTokenMap();
	const SvXMLTokenMap& GetPolygonShapeAttrTokenMap();
	const SvXMLTokenMap& GetPathShapeAttrTokenMap();
	const SvXMLTokenMap& GetTextBoxShapeAttrTokenMap();
	const SvXMLTokenMap& GetControlShapeAttrTokenMap();
	const SvXMLTokenMap& GetPageShapeAttrTokenMap();
	const SvXMLTokenMap& GetGraphicObjectShapeAttrTokenMap();

	// Styles and AutoStyles contexts
	SvXMLStylesContext* GetStylesContext() const { return mpStylesContext; }
	void SetStylesContext(SvXMLStylesContext* pNew);
	SvXMLStylesContext* GetAutoStylesContext() const { return mpAutoStylesContext; }
	void SetAutoStylesContext(SvXMLStylesContext* pNew);

	// get factories and mappers
	XMLPropertySetMapper* GetPropertySetMapper() const { return mpPropertySetMapper; }
	XMLPropertySetMapper* GetPresPagePropsMapper() const { return mpPresPagePropsMapper; }
};


#endif // _XMLOFF_SHAPEIMPORT_HXX_
