/*************************************************************************
 *
 *  $RCSfile: txtparae.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _XMLOFF_TEXTPARAE_HXX_
#define _XMLOFF_TEXTPARAE_HXX_


#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_ 
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _UNIVERSALL_REFERENCE_HXX
#include "uniref.hxx"
#endif
#ifndef _XMLOFF_XMLEXPPR_HXX 
#include "xmlexppr.hxx"
#endif
#ifndef _XMLOFF_STYLEEXP_HXX
#include "styleexp.hxx"
#endif

class SvXMLExport;
class SvXMLAutoStylePoolP;
class XMLTextFieldExport;
class OUStrings_Impl;
class OUStringsSort_Impl;
class XMLTextNumRuleInfo;
class XMLTextListAutoStylePool;
class SvLongs;

namespace com { namespace sun { namespace star
{
	namespace beans { class XPropertySet; }
	namespace container { class XEnumeration; class XIndexAccess; }
	namespace text { class XTextContent; class XTextRange; class XText; 
                     class XFootnote; class XTextFrame; }
} } }
		
class XMLTextParagraphExport : public XMLStyleExport
{
//	SvXMLExport& rExport;
	SvXMLAutoStylePoolP& rAutoStylePool;
	UniReference < SvXMLExportPropertyMapper > xParaPropMapper;
	UniReference < SvXMLExportPropertyMapper > xTextPropMapper;
	UniReference < SvXMLExportPropertyMapper > xFramePropMapper;
	UniReference < SvXMLExportPropertyMapper > xAutoFramePropMapper;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexAccess > xTextFrames;
	::com::sun::star::uno::Reference <
		::com::sun::star::container::XIndexAccess > xGraphics;
	SvLongs 					*pPageTextFrameIdxs;
	SvLongs 					*pPageGraphicIdxs;
	SvLongs 					*pFrameTextFrameIdxs;
	SvLongs 					*pFrameGraphicIdxs;
	XMLTextFieldExport			*pFieldExport;
	OUStrings_Impl				*pListElements;
	OUStringsSort_Impl			*pExportedLists;
	XMLTextListAutoStylePool	*pListAutoPool;


protected:

	const ::rtl::OUString sParagraphService;
	const ::rtl::OUString sTableService;
	const ::rtl::OUString sTextFieldService;
	const ::rtl::OUString sTextFrameService;
	const ::rtl::OUString sTextEmbeddedService;
	const ::rtl::OUString sTextGraphicService;
	const ::rtl::OUString sTextEndnoteService;
	const ::rtl::OUString sTextContentService;
	const ::rtl::OUString sParaStyleName;
	const ::rtl::OUString sParaConditionalStyleName;
	const ::rtl::OUString sParaChapterNumberingLevel;
	const ::rtl::OUString sCharStyleName;
	const ::rtl::OUString sFrameStyleName;
	const ::rtl::OUString sTextField;
	const ::rtl::OUString sCategory;
	const ::rtl::OUString sNumberingRules;
	const ::rtl::OUString sNumberingStyleName;
	const ::rtl::OUString sPropertyTextPortionType;
	const ::rtl::OUString sPropertyFootnote;
	const ::rtl::OUString sPropertyBookmark;
	const ::rtl::OUString sPropertyReferenceMark;
	const ::rtl::OUString sPropertyIsCollapsed;
	const ::rtl::OUString sPropertyIsStart;
	const ::rtl::OUString sPropertyReferenceId;
	const ::rtl::OUString sPropertyCharStyleName;
	const ::rtl::OUString sPropertyNumberingType;
	const ::rtl::OUString sPropertyPageStyleName;
	const ::rtl::OUString sPropertyParagraphStyleName;
	const ::rtl::OUString sPropertyPrefix;
	const ::rtl::OUString sPropertyStartAt;
	const ::rtl::OUString sPropertySuffix;
	const ::rtl::OUString sPropertyPositionEndOfDoc;
	const ::rtl::OUString sPropertyFootnoteCounting;
	const ::rtl::OUString sPropertyEndNotice;
	const ::rtl::OUString sPropertyBeginNotice;
	const ::rtl::OUString sFrameWidthAbsolute;
	const ::rtl::OUString sFrameWidthPercent;
	const ::rtl::OUString sFrameHeightAbsolute;
	const ::rtl::OUString sFrameHeightPercent;
	const ::rtl::OUString sWidth;
	const ::rtl::OUString sRelativeWidth;
	const ::rtl::OUString sHeight;
	const ::rtl::OUString sRelativeHeight;
	const ::rtl::OUString sSizeType;
	const ::rtl::OUString sSizeRelative;
	const ::rtl::OUString sHoriOrient;
	const ::rtl::OUString sHoriOrientPosition;
	const ::rtl::OUString sVertOrient;
	const ::rtl::OUString sVertOrientPosition;
	const ::rtl::OUString sChainNextName;
	const ::rtl::OUString sAnchorType;
	const ::rtl::OUString sAnchorPageNo;
	const ::rtl::OUString sGraphicURL;
	const ::rtl::OUString sGraphicFilter;
	const ::rtl::OUString sAlternativeText;

//	SvXMLExport& GetExport() { return rExport; }
//	const SvXMLExport& GetExport() const  { return rExport; }

	UniReference < SvXMLExportPropertyMapper > GetParaPropMapper() const
	{
		return xParaPropMapper;
	}

	UniReference < SvXMLExportPropertyMapper > GetTextPropMapper() const
	{
		return xTextPropMapper;
	}

	UniReference < SvXMLExportPropertyMapper > GetFramePropMapper() const
	{
		return xFramePropMapper;
	}
	UniReference < SvXMLExportPropertyMapper > GetAutoFramePropMapper() const
	{
		return xAutoFramePropMapper;
	}

	SvXMLAutoStylePoolP& GetAutoStylePool() { return rAutoStylePool; }
	const SvXMLAutoStylePoolP& GetAutoStylePool() const { return rAutoStylePool; }

	void Add(
			sal_uInt16 nFamily,
			const ::com::sun::star::uno::Reference <
				::com::sun::star::beans::XPropertySet > & rPropSet);
	::rtl::OUString Find(
			sal_uInt16 nFamily,
			const ::com::sun::star::uno::Reference <
				::com::sun::star::beans::XPropertySet > & rPropSet,
			const ::rtl::OUString& rParent ) const;

	::rtl::OUString FindTextStyle(
			const ::com::sun::star::uno::Reference <
				::com::sun::star::beans::XPropertySet > & rPropSet ) const;

	void addTextFrameAttributes(
		const ::com::sun::star::uno::Reference < 
				::com::sun::star::beans::XPropertySet >& rPropSet );

	virtual void exportStyleAttributes( 
		const ::com::sun::star::uno::Reference<
				::com::sun::star::style::XStyle > & rStyle );

	void collectFrames();
	void exportPageFrames( sal_Bool bAutoStyles );

	void exportNumStyles( sal_Bool bUsed );

	void exportText( 
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XText > & rText,
		sal_Bool bAutoStyles );
	void exportTextContentEnumeration(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::container::XEnumeration > & rContentEnum,
		sal_Bool bAutoStyles );
	void exportParagraph(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles );
	virtual void exportTable(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles );
	void exportTextRangeEnumeration(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::container::XEnumeration > & rRangeEnum,
		sal_Bool bAutoStyles );

	void exportTextField(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextRange > & rTextRange,
		sal_Bool bAutoStyles );
	void exportTextFrame(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles );
	void exportTextGraphic(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles );
	void exportTextEmbedded(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextContent > & rTextContent,
		sal_Bool bAutoStyles );

	/// export a footnote and styles
	void exportTextFootnote(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet > & rPropSet,
		const ::rtl::OUString& sString,
		sal_Bool bAutoStyles);

	/// helper for exportTextFootnote
	void exportTextFootnoteHelper(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::text::XFootnote > & rPropSet,
		const ::com::sun::star::uno::Reference<
			::com::sun::star::text::XText> & rText,
		const ::rtl::OUString& sString,
		sal_Bool bAutoStyles,
		sal_Bool bIsEndnote);

	/// export footnote and endnote configuration elements
	void exportTextFootnoteConfiguration();

	void exportTextFootnoteConfigurationHelper(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & rFootnoteSupplier,
		sal_Bool bIsEndnote);

	void exportTextMark(
		const ::com::sun::star::uno::Reference<
			::com::sun::star::beans::XPropertySet> & xPropSet,
		const ::rtl::OUString sProperty,
		const sal_Char* pElements[],
		sal_Bool bAutoStyles);

	void exportTextRange(
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XTextRange > & rTextRange,
		sal_Bool bAutoStyles,
		sal_Bool& rPrevCharWasSpace	);
	void exportText(
		const ::rtl::OUString& rText,
		sal_Bool& rPrevCharWasSpace );

	void exportListChange( const XMLTextNumRuleInfo& rPrvInfo,
		    			   const XMLTextNumRuleInfo& rNextInfo );


public:

	XMLTextParagraphExport(
			SvXMLExport& rExp,
		   	SvXMLAutoStylePoolP & rASP );
	virtual ~XMLTextParagraphExport();
	

	// This methods exports all (or all used) styles
	void exportTextStyles( sal_Bool bUsed );

	// This method exports field declarations etc.
	void exportTextDeclarations();

	// This method collects all automatic styles for the given XText
	void collectTextAutoStyles( 
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XText > & rText )
	{
		exportText( rText, sal_True );
	}

	// This method collects all automatic styles that are bound to a page
	void collectFrameBoundToPageAutoStyles()
	{
		collectFrames();
		exportPageFrames( sal_True );
	}

	// This method exports all automatic styles that have been collected.
	void exportTextAutoStyles(); 
	
	// This method exports the given XText
	void exportText( 
		const ::com::sun::star::uno::Reference <
			::com::sun::star::text::XText > & rText )
	{
		exportText( rText, sal_False );
	}
	
	void exportFramesBoundToPage()
	{
		exportPageFrames( sal_False );
	}
	inline const XMLTextListAutoStylePool& GetListAutoStylePool() const;
};
	
inline const XMLTextListAutoStylePool& 
	XMLTextParagraphExport::GetListAutoStylePool() const
{
	return *pListAutoPool;
}


#endif
