/*************************************************************************
 *
 *  $RCSfile: txtprmap.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _XMLOFF_TEXTPRMAP_HXX_
#define _XMLOFF_TEXTPRMAP_HXX_


#ifndef _XMLOFF_PROPERTYSETMAPPER_HXX
#include "xmlprmap.hxx"
#endif

#define CTF_CHARHEIGHT				 1
#define CTF_CHARHEIGHT_REL			 2
#define CTF_PARALEFTMARGIN			 3
#define CTF_PARALEFTMARGIN_REL		 4
#define CTF_PARARIGHTMARGIN			 5
#define CTF_PARARIGHTMARGIN_REL		 6
#define CTF_PARAFIRSTLINE			 7
#define CTF_PARAFIRSTLINE_REL		 8
#define CTF_PARATOPMARGIN			 9
#define CTF_PARATOPMARGIN_REL		10
#define CTF_PARABOTTOMMARGIN		11
#define CTF_PARABOTTOMMARGIN_REL	12
#define CTF_ALLBORDERWIDTH			13
#define CTF_LEFTBORDERWIDTH			14
#define CTF_RIGHTBORDERWIDTH		15
#define CTF_TOPBORDERWIDTH			16
#define CTF_BOTTOMBORDERWIDTH		17
#define CTF_ALLBORDERDISTANCE		18
#define CTF_LEFTBORDERDISTANCE		19
#define CTF_RIGHTBORDERDISTANCE		20
#define CTF_TOPBORDERDISTANCE		21
#define CTF_BOTTOMBORDERDISTANCE	22
#define CTF_ALLBORDER				23
#define CTF_LEFTBORDER				24
#define CTF_RIGHTBORDER				25
#define CTF_TOPBORDER				26
#define CTF_BOTTOMBORDER			27
#define CTF_DROPCAPWHOLEWORD		28
#define CTF_DROPCAPFORMAT			29
#define CTF_DROPCAPCHARSTYLE		30
#define CTF_TABSTOP					31
#define CTF_NUMBERINGSTYLENAME		32
#define CTF_OLDTEXTBACKGROUND		33
#define CTF_FONTNAME				34
#define CTF_FONTSTYLENAME			35
#define CTF_FONTFAMILY				36
#define CTF_FONTPITCH				37
#define CTF_FONTCHARSET				38
#define CTF_FRAMEWIDTH_ABS			39
#define CTF_FRAMEWIDTH_REL			40
#define CTF_FRAMEHEIGHT_ABS			41
#define CTF_FRAMEHEIGHT_REL			42
#define CTF_FRAMEHEIGHT_MIN_ABS		43
#define CTF_FRAMEHEIGHT_MIN_REL		44
#define CTF_SIZETYPE				45
#define CTF_SYNCHEIGHT				46
#define CTF_WRAP					47
#define CTF_WRAP_CONTOUR			48
#define CTF_WRAP_CONTOUR_MODE		49
#define CTF_WRAP_PARAGRAPH_ONLY		50
#define CTF_ANCHORTYPE 				51
#define CTF_ANCHORPAGENUMBER		52
#define CTF_TEXTCOLUMNS				53
#define CTF_HORIZONTALPOS			54
#define CTF_HORIZONTALPOS_MIRRORED	55
#define CTF_HORIZONTALREL			56
#define CTF_HORIZONTALREL_FRAME		57
#define CTF_HORIZONTALMIRROR		58
#define CTF_VERTICALPOS				59
#define CTF_VERTICALREL				60
#define CTF_VERTICALREL_PAGE		61
#define CTF_VERTICALREL_FRAME		62
#define CTF_VERTICALREL_ASCHAR		63

#define TEXT_PROP_MAP_TEXT 0
#define TEXT_PROP_MAP_PARA 1
#define TEXT_PROP_MAP_FRAME 2
#define TEXT_PROP_MAP_AUTO_FRAME 3

class XMLTextPropertySetMapper : public XMLPropertySetMapper
{

protected:
	/** Application-specific filter. By default do nothing. */
	virtual void ContextFilter(
			::std::vector< XMLPropertyState >& rProperties,
		    ::com::sun::star::uno::Reference<
						::com::sun::star::beans::XPropertySet > rPropSet ) const;
public:

	XMLTextPropertySetMapper( sal_uInt16 nType );
	virtual ~XMLTextPropertySetMapper();
};


#endif
