/*************************************************************************
 *
 *  $RCSfile: xmlastpl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XMLOFF_XMLASTPL_HXX
#define _XMLOFF_XMLASTPL_HXX

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _RTL_MACROS_HXX_
#include <rtl/macros.hxx>
#endif

#ifndef _RSCSFX_HXX //autogen wg. SfxStyleFamily
#include <rsc/rscsfx.hxx>
#endif

namespace rtl { class OUString; }

class SfxItemSet;
class SvXMLExportItemMapper;
class SvXMLUnitConverter;
class SvXMLNamespaceMap;
class SvXMLAttributeList;
class SvXMLAutoStylePool_Impl;

class SvXMLAutoStylePool
{
	friend class SvXMLAutoStylePool_Impl;

	SvXMLAutoStylePool_Impl	*pImpl;

protected:

	virtual void exportXML( SvXMLAttributeList& rAttrList,
							SfxStyleFamily eFamily, const SfxItemSet& rItemSet,
							const SvXMLUnitConverter& rUnitConverter,
							const SvXMLNamespaceMap& rNamespaceMap ) const;

public:

	SvXMLAutoStylePool();
	virtual ~SvXMLAutoStylePool();

							

	// Register a name that must not be used as a generated name.
	void RegisterName( SfxStyleFamily eFamily,
					   const ::rtl::OUString& rName );

	// Add an item set to the pool and return its generated name.
	::rtl::OUString Add( SfxStyleFamily eFamily,
								 const SfxItemSet& rItemSet );
	::rtl::OUString Add( SfxStyleFamily eFamily, 
								 const ::rtl::OUString& rParent,
								 const SfxItemSet& rItemSet );
	
	// Find an item set's name.
	::rtl::OUString Find( SfxStyleFamily eFamily,
								  const SfxItemSet& rItemSet ) const;
	::rtl::OUString Find( SfxStyleFamily eFamily,
								  const ::rtl::OUString& rParent,
								  const SfxItemSet& rItemSet ) const;

	// Export all item sets ofs a certain class in the order in that they
	// have been added.
	void exportXML( SfxStyleFamily eFamily,
					const SvXMLExportItemMapper& rItemExp,
					const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
					const SvXMLUnitConverter& rUnitConverter,
					const SvXMLNamespaceMap& rNamespaceMap) const;
};


#endif	//  _XMLOFF_XMLASTPL_HXX

