/*************************************************************************
 *
 *  $RCSfile: xmlexppr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XMLOFF_XMLEXPPR_HXX
#define _XMLOFF_XMLEXPPR_HXX

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _XMLOFF_PROPERTYSETMAPPER_HXX
#include "xmlprmap.hxx"
#endif
#ifndef _UNIVERSALL_REFERENCE_HXX
#include <uniref.hxx>
#endif

namespace rtl { class OUString; }

class SvXMLUnitConverter;
class SvXMLAttributeList;
class SvXMLNamespaceMap;
class SvUShorts;

#define XML_EXPORT_FLAG_DEFAULTS	0x0001		// export also default items
#define XML_EXPORT_FLAG_DEEP		0x0002		// export also items from
												// parent item sets
#define XML_EXPORT_FLAG_EMPTY		0x0004		// export attribs element
												// even if its empty
#define XML_EXPORT_FLAG_IGN_WS		0x0008

class SvXMLExportPropertyMapper : public UniRefBase
{
protected:
	UniReference< XMLPropertySetMapper > maPropMapper;


	/** fills the given attribute list with the items in the given set */
	void _exportXML( SvXMLAttributeList& rAttrList,
		             const ::std::vector< XMLPropertyState >& rProperties,
					 const SvXMLUnitConverter& rUnitConverter,
					 const SvXMLNamespaceMap& rNamespaceMap,
					 sal_uInt16 nFlags,
					 SvUShorts* pIndexArray ) const;

	void _exportXML( SvXMLAttributeList& rAttrList,
		             const XMLPropertyState& rProperty,
					 const SvXMLUnitConverter& rUnitConverter,
					 const SvXMLNamespaceMap& rNamespaceMap,
					 sal_uInt16 nFlags ) const;
				     // const SfxItemSet *pSet ) const; Do we need this any more ?

	void exportElementItems(
			const ::com::sun::star::uno::Reference<
				::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			const ::std::vector< XMLPropertyState >& rProperties,
			sal_uInt16 nFlags,
			const SvUShorts& rIndexArray ) const;

public:

	SvXMLExportPropertyMapper(
			const UniReference< XMLPropertySetMapper >& rMapper );
	virtual ~SvXMLExportPropertyMapper();

	/** fills the given attribute list with the items in the given set */
	void exportXML(
		   SvXMLAttributeList& rAttrList,
		   const ::std::vector< XMLPropertyState >& rProperties,
		   const SvXMLUnitConverter& rUnitConverter,
		   const SvXMLNamespaceMap& rNamespaceMap,
		   sal_uInt16 nFlags = 0 ) const;

	/** fills the given attribute list with the representation of one item */
	void exportXML(
			SvXMLAttributeList& rAttrList,
		   const XMLPropertyState& rProperty,
		   const SvXMLUnitConverter& rUnitConverter,
		   const SvXMLNamespaceMap& rNamespaceMap,
		   sal_uInt16 nFlags = 0 ) const;

	void exportXML(
			const ::com::sun::star::uno::Reference<
					::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const ::std::vector< XMLPropertyState >& rProperties,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			sal_uInt16 nFlags = 0 ) const;

	/** this method is called for every item that has the MID_FLAG_NO_ITEM_EXPORT flag set */
	virtual void handleNoItem(
			SvXMLAttributeList& rAttrList,
		   	const XMLPropertyState& rProperty,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap ) const;

	/** this method is called for every item that has the MID_FLAG_ELEMENT_EXPORT flag set */
	virtual void handleElementItem(
			const ::com::sun::star::uno::Reference<
					::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
			const XMLPropertyState& rProperty,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap,
			sal_uInt16 nFlags ) const;

	/** this method is called for every item that has the MID_FLAG_SPECIAL_ITEM_EXPORT flag set */
	virtual void handleSpecialItem(
			SvXMLAttributeList& rAttrList,
			const XMLPropertyState& rProperty,
			const SvXMLUnitConverter& rUnitConverter,
			const SvXMLNamespaceMap& rNamespaceMap ) const;


	inline const UniReference< XMLPropertySetMapper >&
		getPropertySetMapper() const { return maPropMapper; }

};

#endif	//  _XMLOFF_XMLEXPPR_HXX
