/*************************************************************************
 *
 *  $RCSfile: xmlimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XMLOFF_XMLIMP_HXX
#define _XMLOFF_XMLIMP_HXX

#ifndef _COM_SUN_STAR_XML_SAX_SAXPARSEEXCEPTION_HPP_
#include <com/sun/star/xml/sax/SAXParseException.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XEXTENDEDDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XExtendedDocumentHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_SAXEXCEPTION_HPP_
#include <com/sun/star/xml/sax/SAXException.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XATTRIBUTELIST_HPP_
#include <com/sun/star/xml/sax/XAttributeList.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XLOCATOR_HPP_
#include <com/sun/star/xml/sax/XLocator.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HDL_
#include <com/sun/star/util/XNumberFormatsSupplier.hdl>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_ //autogen wg. OWeakObject
#include <cppuhelper/weak.hxx>
#endif
#ifndef _RTL_MACROS_HXX_
#include <rtl/macros.hxx>
#endif

#ifndef _XMLOFF_TEXTIMP_HXX_
#include <txtimp.hxx>
#endif

#ifndef _XMLOFF_SHAPEIMPORT_HXX_
#include "shapeimport.hxx"
#endif

#ifndef _XMLOFF_SCH_XMLIMPORTHELPER_HXX_
#include "SchXMLImportHelper.hxx"
#endif

#include <cppuhelper/implbase2.hxx>

namespace rtl { class OUString; }
namespace com { namespace sun { namespace tar { namespace frame {
	class XModel;
} } } }

class SvXMLNamespaceMap;
class SvXMLImportContext;
class SvXMLImportContexts_Impl;
class SvXMLImport_Impl;
class SvXMLUnitConverter;
class SvXMLNumFmtHelper;


class SvXMLImport : public ::cppu::WeakImplHelper2<
			 ::com::sun::star::xml::sax::XExtendedDocumentHandler,
			 ::com::sun::star::lang::XUnoTunnel>
{
	friend class SvXMLImportContext;

	::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > xLocator;
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > xModel;
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > xNumberFormatsSupplier;
	UniReference< XMLTextImportHelper > mxTextImport;
	UniReference< XMLShapeImportHelper > mxShapeImport;
	UniReference< SchXMLImportHelper > mxChartImport;

	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > xGradientHelper;
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > xHatchHelper;
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > xBitmapHelper;
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > xTransGradientHelper;
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > xMarkerHelper;
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > xDashHelper;

	SvXMLImport_Impl			*pImpl;			// dummy
	SvXMLNamespaceMap 			*pNamespaceMap;
	SvXMLUnitConverter			*pUnitConv;
	SvXMLImportContexts_Impl	*pContexts;
	SvXMLNumFmtHelper			*pNumImport;

	void _InitCtor();


protected:

	// This method is called after the namespace map has been updated, but
	// before a context for the current element has been pushed.
	virtual SvXMLImportContext *CreateContext( sal_uInt16 nPrefix,
									  const ::rtl::OUString& rLocalName,
									  const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList >& xAttrList );

	virtual XMLTextImportHelper* CreateTextImport();
	virtual XMLShapeImportHelper* CreateShapeImport();
	virtual SchXMLImportHelper* CreateChartImport();
public:
	SvXMLImport() throw();
	SvXMLImport( const ::com::sun::star::uno::Reference<
			::com::sun::star::frame::XModel > &) throw();
	virtual ~SvXMLImport() throw();

	static const ::com::sun::star::uno::Sequence< sal_Int8 > & getUnoTunnelId() throw();
	static SvXMLImport* getImplementation( ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > ) throw();

	// ::com::sun::star::xml::sax::XDocumentHandler
	virtual void SAL_CALL startDocument(void)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL endDocument(void)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL startElement(const ::rtl::OUString& aName,
							  const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > & xAttribs)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL endElement(const ::rtl::OUString& aName)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL characters(const ::rtl::OUString& aChars)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL ignorableWhitespace(const ::rtl::OUString& aWhitespaces)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL processingInstruction(const ::rtl::OUString& aTarget,
									   const ::rtl::OUString& aData)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL setDocumentLocator(const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > & xLocator)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );

	// ::com::sun::star::xml::sax::XExtendedDocumentHandler
	virtual void SAL_CALL startCDATA(void) throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL endCDATA(void) throw( ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL comment(const ::rtl::OUString& sComment)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL allowLineBreak(void)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL unknown(const ::rtl::OUString& sString)
		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException );

	// XUnoTunnel
    virtual sal_Int64 SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& aIdentifier ) throw(::com::sun::star::uno::RuntimeException);

	// get import helper for text
	inline UniReference< XMLTextImportHelper > GetTextImport();
	SvXMLNumFmtHelper* GetDataStylesImport() const { return pNumImport; }

	// get import helper for shapes
	inline UniReference< XMLShapeImportHelper > GetShapeImport();

	// get import helper for charts
	inline UniReference< SchXMLImportHelper > GetChartImport();

	SvXMLNamespaceMap& GetNamespaceMap() { return *pNamespaceMap; }
	const SvXMLNamespaceMap& GetNamespaceMap() const { return *pNamespaceMap; }
	const SvXMLUnitConverter& GetMM100UnitConverter() const { return *pUnitConv; }
		SvXMLUnitConverter& GetMM100UnitConverter() { return *pUnitConv; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > & GetLocator() const { return xLocator; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > &
	   		GetModel() const { return xModel; }

	const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & GetGradientHelper() const { return xGradientHelper; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & GetHatchHelper() const { return xHatchHelper; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & GetBitmapHelper() const { return xBitmapHelper; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & GetTransGradientHelper() const { return xTransGradientHelper; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & GetMarkerHelper() const { return xMarkerHelper; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & GetDashHelper() const { return xDashHelper; }
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > & GetNumberFormatsSupplier() { return xNumberFormatsSupplier; }
};

inline UniReference< XMLTextImportHelper > SvXMLImport::GetTextImport()
{
	if( !mxTextImport.is() )
		mxTextImport = CreateTextImport();

	return mxTextImport;
}

inline UniReference< XMLShapeImportHelper > SvXMLImport::GetShapeImport()
{
	if( !mxShapeImport.is() )
		mxShapeImport = CreateShapeImport();

	return mxShapeImport;
}

inline UniReference< SchXMLImportHelper > SvXMLImport::GetChartImport()
{
	if( !mxChartImport.is() )
		mxChartImport = CreateChartImport();

	return mxChartImport;
}


#endif	//  _XMLOFF_XMLIMP_HXX
