/*************************************************************************
 *
 *  $RCSfile: xmlastpl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _CNTRSRT_HXX
#include <svtools/cntnrsrt.hxx>
#endif

#ifndef _XMLOFF_XMLKYWD_HXX
#include "xmlkywd.hxx"
#endif

#ifndef _XMLOFF_ATTRLIST_HXX
#include "attrlist.hxx"
#endif

#ifndef _XMLOFF_XMLASTPL_HXX
#include "xmlastpl.hxx"
#endif

#ifndef _XMLOFF_NMSPMAP_HXX
#include "nmspmap.hxx"
#endif

#ifndef _XMLOFF_XMLEXPIT_HXX
#include "xmlexpit.hxx"
#endif

#ifndef _XMLOFF_XMLNMSPE_HXX
#include "xmlnmspe.hxx"
#endif

using namespace ::rtl;
using namespace ::com::sun::star;

// ---------------------------------------------------------------------

int SvXMLAutoStylePoolNamesCmp_Impl( const OUString& r1,
									 const OUString& r2 )
{
	return (int)r1.compareTo( r2 );
}

DECLARE_CONTAINER_SORT_DEL( SvXMLAutoStylePoolNames_Impl, 
							OUString )
IMPL_CONTAINER_SORT( SvXMLAutoStylePoolNames_Impl, 
					 OUString,
				     SvXMLAutoStylePoolNamesCmp_Impl )

// ---------------------------------------------------------------------

class SvXMLAutoStylePoolItemSet_Impl
{
	OUString	sName;
	SfxItemSet	aItemSet;
	sal_uInt32		nPos;
	
public:

	SvXMLAutoStylePoolItemSet_Impl( sal_uInt32 nPos, const SfxItemSet& rItemSet,
								 	const SvXMLAutoStylePoolNames_Impl& rNames,
									sal_Unicode cPrefix, sal_uInt32& rNumber );
									

	~SvXMLAutoStylePoolItemSet_Impl()
	{
	}
	
	const OUString& GetName() const { return sName; }
	const SfxItemSet& GetItemSet() const { return aItemSet; }
	sal_uInt32 GetPos() const { return nPos; }
};

SvXMLAutoStylePoolItemSet_Impl::SvXMLAutoStylePoolItemSet_Impl(
								sal_uInt32 nP, const SfxItemSet& rItemSet,
								const SvXMLAutoStylePoolNames_Impl& rNames,
								sal_Unicode cPrefix, sal_uInt32& rName ) :
								
	aItemSet( rItemSet ),
	nPos( nP )
{
	// create a name that hasn't been used before. The created name has not
	// to be added to the array, because it will never tried again
	OUStringBuffer sBuffer( 7 );
	do
	{
		rName++;
		sBuffer.append( cPrefix );
		sBuffer.append( (sal_Int32)rName );
		sName = sBuffer.makeStringAndClear();
	}
	while( rNames.Seek_Entry( &sName, 0 ) );
}

typedef SvXMLAutoStylePoolItemSet_Impl *SvXMLAutoStylePoolItemSetPtr;
DECLARE_LIST( SvXMLAutoStylePoolItemSets_Impl, SvXMLAutoStylePoolItemSetPtr )

// ---------------------------------------------------------------------

class SvXMLAutoStylePoolParent_Impl	
{
	OUString 						sParent;
	SvXMLAutoStylePoolItemSets_Impl	aItemSets;

public:

	SvXMLAutoStylePoolParent_Impl( const OUString & rParent ) :
		sParent( rParent )
	{
	}

	~SvXMLAutoStylePoolParent_Impl();

	sal_Bool Add( sal_uInt32 rPos, const SfxItemSet& rItemSet, 
			  const SvXMLAutoStylePoolNames_Impl& rNames,
			  sal_Unicode cPrefix, sal_uInt32& rNumber, OUString& rName );

	OUString Find( const SfxItemSet& rItemSet ) const;
	
	const OUString& GetParent() const { return sParent; }

	const SvXMLAutoStylePoolItemSets_Impl& GetItemSets() const
	{
		return aItemSets;
	}
};

int SvXMLAutoStylePoolParentCmp_Impl( const SvXMLAutoStylePoolParent_Impl& r1,
									  const SvXMLAutoStylePoolParent_Impl& r2)
{
	return (int)r1.GetParent().compareTo( r2.GetParent() );
}

SvXMLAutoStylePoolParent_Impl::~SvXMLAutoStylePoolParent_Impl()
{
	while( aItemSets.Count() )
		delete aItemSets.Remove( aItemSets.Count() -1 );
}

sal_Bool SvXMLAutoStylePoolParent_Impl::Add( sal_uInt32 nPos, const SfxItemSet& rItemSet,
			  						const SvXMLAutoStylePoolNames_Impl& rNames,
								   	sal_Unicode cPrefix, sal_uInt32& rNumber, 
									OUString& rName )
{
	sal_Bool bAdded = sal_False;

	sal_uInt16 nItems = rItemSet.Count();
	sal_uInt32 nCount = aItemSets.Count();
	SvXMLAutoStylePoolItemSet_Impl *pItemSet = 0;
	for( sal_uInt32 i=0; i < nCount; i++ )
	{
		SvXMLAutoStylePoolItemSet_Impl *pIS = aItemSets.GetObject( i );
		if( nItems > pIS->GetItemSet().Count() ) 
		{
			continue;
		}
		else if( nItems < pIS->GetItemSet().Count() )
		{
			break;
		}
		else if( pIS->GetItemSet().equalsXML( rItemSet ) )
		{
			pItemSet = pIS;
			break;
		}
	}
	
	if( !pItemSet )
	{
		pItemSet = new SvXMLAutoStylePoolItemSet_Impl( nPos, rItemSet, rNames,
													   cPrefix, rNumber );
		aItemSets.Insert( pItemSet, i );
		bAdded = sal_True;
	}
	
	rName = pItemSet->GetName();

	return bAdded;
}

OUString SvXMLAutoStylePoolParent_Impl::Find(
										const SfxItemSet& rItemSet ) const
{
	OUString sName;
	sal_uInt16 nItems = rItemSet.Count();
	sal_uInt32 nCount = aItemSets.Count();
	for( sal_uInt32 i=0; i < aItemSets.Count(); i++ )
	{
		SvXMLAutoStylePoolItemSet_Impl *pIS = aItemSets.GetObject( i );
		if( nItems > pIS->GetItemSet().Count() ) 
		{
			continue;
		}
		else if( nItems < pIS->GetItemSet().Count() )
		{
			break;
		}
		else if( pIS->GetItemSet().equalsXML( rItemSet ) )
		{
			sName = pIS->GetName();
			break;
		}
	}
	
	return sName;
}

DECLARE_CONTAINER_SORT_DEL( SvXMLAutoStylePoolParents_Impl, 
							SvXMLAutoStylePoolParent_Impl )
IMPL_CONTAINER_SORT( SvXMLAutoStylePoolParents_Impl, 
					 SvXMLAutoStylePoolParent_Impl,
				     SvXMLAutoStylePoolParentCmp_Impl )

// ---------------------------------------------------------------------

class SvXMLAutoStylePool_Impl
{
	const OUString		sCDATA;
	const OUString		sWS;
	SvXMLAttributeList	*pAttrList;
	uno::Reference< xml::sax::XAttributeList > 	xAttrList;

	SvXMLAutoStylePoolParents_Impl	aCharParents;
	SvXMLAutoStylePoolParents_Impl	aParaParents;
	SvXMLAutoStylePoolParents_Impl	aFrameParents;
	SvXMLAutoStylePoolParents_Impl	aPageParents;
	SvXMLAutoStylePoolParents_Impl	aPseudoParents;
	
	SvXMLAutoStylePoolNames_Impl	aCharNames;
	SvXMLAutoStylePoolNames_Impl	aParaNames;
	SvXMLAutoStylePoolNames_Impl	aFrameNames;
	SvXMLAutoStylePoolNames_Impl	aPageNames;
	SvXMLAutoStylePoolNames_Impl	aPseudoNames;
	
	sal_uInt32 nCharCount;
	sal_uInt32 nParaCount;
	sal_uInt32 nFrameCount;
	sal_uInt32 nPageCount;
	sal_uInt32 nPseudoCount;

	sal_uInt32 nCharName;
	sal_uInt32 nParaName;
	sal_uInt32 nFrameName;
	sal_uInt32 nPageName;
	sal_uInt32 nPseudoName;

	sal_Unicode cCharPrefix;
	sal_Unicode cParaPrefix;
	sal_Unicode cFramePrefix;
	sal_Unicode cPagePrefix;
	sal_Unicode cPseudoPrefix;

public:

	SvXMLAutoStylePool_Impl();
	~SvXMLAutoStylePool_Impl();

	void RegisterName( SfxStyleFamily eFamily, const OUString& rName );

	OUString Add( SfxStyleFamily eFamily, const OUString& rParent,
				  const SfxItemSet& rItemSet );
	OUString Find( SfxStyleFamily eFamily, const OUString& rParent,
		   	   	   const SfxItemSet& rItemSet ) const;

	void exportXML( SfxStyleFamily eFamily,
					const SvXMLExportItemMapper& rItemExp,
					const uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
					const SvXMLUnitConverter& rUnitConverter,
					const SvXMLNamespaceMap& rNamespaceMap,
					const SvXMLAutoStylePool *pAntiImpl ) const;
};

SvXMLAutoStylePool_Impl::SvXMLAutoStylePool_Impl() :
	sCDATA( OUString::createFromAscii( sXML_CDATA ) ),
	sWS( OUString::createFromAscii( sXML_WS ) ),
	aCharParents( 5, 5 ), aParaParents( 5, 5 ), aFrameParents( 5, 5 ),
	aPageParents( 5, 5 ), aPseudoParents( 5, 5 ),
	aCharNames( 5, 5 ), aParaNames( 5, 5 ), aFrameNames( 5, 5 ),
	aPageNames( 5, 5 ), aPseudoNames( 5, 5 ),
	nCharCount( 0 ), nParaCount( 0 ), nFrameCount( 0 ),
	nPageCount( 0 ), nPseudoCount( 0 ),
	nCharName( 0 ), nParaName( 0 ), nFrameName( 0 ),
	nPageName( 0 ), nPseudoName( 0 ),
	cCharPrefix( 'T' ), cParaPrefix( 'P' ), cFramePrefix( 'F' ),
	cPagePrefix( 'M' ), cPseudoPrefix( 'N' )
{
	pAttrList = new SvXMLAttributeList();
	xAttrList = pAttrList;
}
	
SvXMLAutoStylePool_Impl::~SvXMLAutoStylePool_Impl()
{
}

void SvXMLAutoStylePool_Impl::RegisterName( SfxStyleFamily eFamily,
								  	   		const OUString& rName )
{
	SvXMLAutoStylePoolNames_Impl *pNames = 0;

	switch( eFamily )
	{
	case SFX_STYLE_FAMILY_CHAR:
		pNames = &aCharNames;
		break;

	case SFX_STYLE_FAMILY_PARA:
		pNames = &aParaNames;
		break;

	case SFX_STYLE_FAMILY_FRAME:
		pNames = &aFrameNames;
		break;

	case SFX_STYLE_FAMILY_PAGE:
		pNames = &aPageNames;
		break;

	case SFX_STYLE_FAMILY_PSEUDO:
		pNames = &aPseudoNames;
		break;
	}
		
	DBG_ASSERT( pNames,
				"SvXMLAutoStylePool_Impl::RegisterName: unknown family" );
	if( pNames )
	{
		OUString *pName = new OUString( rName );
		if( !pNames->Insert( pName ) )
			delete pName;
	}
}

OUString SvXMLAutoStylePool_Impl::Add( SfxStyleFamily eFamily, 
									   const OUString& rParent,
									   const SfxItemSet& rItemSet )
{
	OUString sName;
	SvXMLAutoStylePoolParents_Impl *pParents = 0;
	SvXMLAutoStylePoolNames_Impl *pNames = 0;
	sal_uInt32 *pCount = 0;
	sal_uInt32 *pName = 0;
	sal_Unicode cPrefix;
	
	switch( eFamily )
	{
	case SFX_STYLE_FAMILY_CHAR:
		pParents = &aCharParents;
		pCount = &nCharCount;
		pNames = &aCharNames;
		cPrefix = cCharPrefix;
		pName = &nCharName;
		break;

	case SFX_STYLE_FAMILY_PARA:
		pParents = &aParaParents;
		pCount = &nParaCount;
		pNames = &aParaNames;
		cPrefix = cParaPrefix;
		pName = &nParaName;
		break;

	case SFX_STYLE_FAMILY_FRAME:
		pParents = &aFrameParents;
		pCount = &nFrameCount;
		pNames = &aFrameNames;
		cPrefix = cFramePrefix;
		pName = &nFrameName;
		break;

	case SFX_STYLE_FAMILY_PAGE:
		pParents = &aPageParents;
		pCount = &nPageCount;
		pNames = &aPageNames;
		cPrefix = cPagePrefix;
		pName = &nPageName;
		break;

	case SFX_STYLE_FAMILY_PSEUDO:
		pParents = &aPseudoParents;
		pCount = &nPseudoCount;
		pNames = &aPseudoNames;
		cPrefix = cPseudoPrefix;
		pName = &nPseudoName;
		break;
	}
		
	DBG_ASSERT( pParents, "SvXMLAutoStylePool_Impl::Add: unknown family" );
	if( pParents )
	{
		SvXMLAutoStylePoolParent_Impl aTmp( rParent );
		SvXMLAutoStylePoolParent_Impl *pParent = 0;
		sal_uInt32 nPos;
		if( pParents->Seek_Entry( &aTmp, &nPos ) )
		{
			pParent = pParents->GetObject( nPos );
		}
		else
		{
			pParent = new SvXMLAutoStylePoolParent_Impl( rParent );
			pParents->Insert( pParent );
		}
		if( pParent->Add( *pCount, rItemSet, *pNames, cPrefix, *pName, sName ) )
			(*pCount)++;
	}
	
	return sName;
}

OUString SvXMLAutoStylePool_Impl::Find( SfxStyleFamily eFamily,
										const OUString& rParent,
										const SfxItemSet& rItemSet ) const
{
	OUString sName;
	
	const SvXMLAutoStylePoolParents_Impl	*pParents = 0;
	
	switch( eFamily )
	{
	case SFX_STYLE_FAMILY_CHAR:
		pParents = &aCharParents;
		break;

	case SFX_STYLE_FAMILY_PARA:
		pParents = &aParaParents;
		break;

	case SFX_STYLE_FAMILY_FRAME:
		pParents = &aFrameParents;
		break;

	case SFX_STYLE_FAMILY_PAGE:
		pParents = &aPageParents;
		break;

	case SFX_STYLE_FAMILY_PSEUDO:
		pParents = &aPseudoParents;
		break;
	}
		
	DBG_ASSERT( pParents, "SvXMLAutoStylePool_Impl::Find: unknown family" );
	if( pParents )
	{
		SvXMLAutoStylePoolParent_Impl aTmp( rParent );
		sal_uInt32 nPos;
		if( pParents->Seek_Entry( &aTmp, &nPos ) )
			sName = pParents->GetObject( nPos )->Find( rItemSet );
	}
	
	return sName;
}

struct SvXMLAutoStylePoolExport_Impl
{
	const OUString							*pParent;
	const SvXMLAutoStylePoolItemSet_Impl	*pItemSet;
};

void SvXMLAutoStylePool_Impl::exportXML( SfxStyleFamily eFamily,
									const SvXMLExportItemMapper& rItemExp,
									const uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
									const SvXMLUnitConverter& rUnitConverter,
									const SvXMLNamespaceMap& rNamespaceMap,
									const SvXMLAutoStylePool *pAntiImpl ) const
{
	const SvXMLAutoStylePoolParents_Impl *pParents = 0;
	sal_uInt32 nCount = 0;
	
	switch( eFamily )
	{
	case SFX_STYLE_FAMILY_CHAR:
		pParents = &aCharParents;
		nCount = nCharCount;
		break;

	case SFX_STYLE_FAMILY_PARA:
		pParents = &aParaParents;
		nCount = nParaCount;
		break;

	case SFX_STYLE_FAMILY_FRAME:
		pParents = &aFrameParents;
		nCount = nFrameCount;
		break;

	case SFX_STYLE_FAMILY_PAGE:
		pParents = &aPageParents;
		nCount = nPageCount;
		break;

	case SFX_STYLE_FAMILY_PSEUDO:
		pParents = &aPseudoParents;
		nCount = nPseudoCount;
		break;
	}
		
	DBG_ASSERT( pParents,
				"SvXMLAutoStylePool_Impl::exportXML: unknown family" );
	if( pParents && nCount > 0 )
	{
		SvXMLAutoStylePoolExport_Impl* aExpStyles = 
			new SvXMLAutoStylePoolExport_Impl[nCount];

		sal_uInt32 i;
		for( i=0; i < nCount; i++ )
		{
			aExpStyles[i].pParent = 0;
			aExpStyles[i].pItemSet = 0;
		}

		sal_uInt32 nParents = pParents->Count();
		for( i=0; i < nParents; i++ )
		{
			const SvXMLAutoStylePoolParent_Impl* pParent =
				pParents->GetObject( i );
			sal_uInt32 nItemSets = pParent->GetItemSets().Count();
			for( sal_uInt32 j=0; j < nItemSets; j++ )
			{
				const SvXMLAutoStylePoolItemSet_Impl *pItemSet = 
					pParent->GetItemSets().GetObject( j );
				sal_uInt32 nPos = pItemSet->GetPos();
				DBG_ASSERT( nPos < nCount,
						"SvXMLAutoStylePool_Impl::exportXML: wrong position" );
				if( nPos < nCount )
				{
					DBG_ASSERT( !aExpStyles[nPos].pItemSet,
						"SvXMLAutoStylePool_Impl::exportXML: double position" );
					aExpStyles[nPos].pItemSet = pItemSet;
					aExpStyles[nPos].pParent = &pParent->GetParent();
				}
			}
		}
		
		for( i=0; i<nCount; i++ )
		{
			DBG_ASSERT( aExpStyles[i].pItemSet,
						"SvXMLAutoStylePool_Impl::exportXML: empty position" );

			if( aExpStyles[i].pItemSet )
			{
				OUString sName(
					rNamespaceMap.GetQNameByKey( XML_NAMESPACE_STYLE,
									 OUString::createFromAscii(sXML_name) ) );
				pAttrList->AddAttribute( sName, sCDATA,
										 aExpStyles[i].pItemSet->GetName() );
				
				const sal_Char *pStr = 0;
				switch( eFamily )
				{
				case SFX_STYLE_FAMILY_CHAR: 	pStr = sXML_text;		break;
				case SFX_STYLE_FAMILY_PARA: 	pStr = sXML_paragraph;	break;
				case SFX_STYLE_FAMILY_FRAME:	pStr = sXML_frame;		break;
				}
				DBG_ASSERT( pStr, 
					"SvXMLAutoStylePool_Impl::exportXML: unknown family" );
				if( pStr )
				{
					sName =
						rNamespaceMap.GetQNameByKey( XML_NAMESPACE_STYLE,
									 OUString::createFromAscii(sXML_family) );
					pAttrList->AddAttribute( sName, sCDATA,
										OUString::createFromAscii(pStr) );
				}
			
				if( aExpStyles[i].pParent->getLength() )
				{
					sName =
						rNamespaceMap.GetQNameByKey( XML_NAMESPACE_STYLE,
						 OUString::createFromAscii(sXML_parent_style_name) );
					pAttrList->AddAttribute( sName, sCDATA,
											 *aExpStyles[i].pParent );
				}
				sName =
					rNamespaceMap.GetQNameByKey( XML_NAMESPACE_STYLE,
									 OUString::createFromAscii(sXML_style) );

				pAntiImpl->exportXML( *pAttrList, eFamily,
									  aExpStyles[i].pItemSet->GetItemSet(),
									  rUnitConverter, rNamespaceMap );

				rHandler->ignorableWhitespace( sWS );
				rHandler->startElement( sName, xAttrList );
				pAttrList->Clear();
				rItemExp.exportXML( rHandler,
									aExpStyles[i].pItemSet->GetItemSet(),
									rUnitConverter,
									rNamespaceMap,
									XML_EXPORT_FLAG_IGN_WS );
				rHandler->ignorableWhitespace( sWS );
				rHandler->endElement( sName );
			}
		}
		
		delete aExpStyles;
	}
}

// ---------------------------------------------------------------------

void SvXMLAutoStylePool::exportXML( SvXMLAttributeList& rAttrList,
						SfxStyleFamily eFamily, const SfxItemSet& rItemSet,
						const SvXMLUnitConverter& rUnitConverter,
						const SvXMLNamespaceMap& rNamespaceMap ) const
{
}

SvXMLAutoStylePool::SvXMLAutoStylePool()
{
	pImpl = new SvXMLAutoStylePool_Impl;
}

SvXMLAutoStylePool::~SvXMLAutoStylePool()
{
	delete pImpl;
}

void SvXMLAutoStylePool::RegisterName( SfxStyleFamily eFamily,
								  	   const OUString& rName )
{
	pImpl->RegisterName( eFamily, rName );
}

OUString SvXMLAutoStylePool::Add( SfxStyleFamily eFamily,
								  const SfxItemSet& rItemSet )
{
	OUString sEmpty;
	return pImpl->Add( eFamily, sEmpty, rItemSet );
}

OUString SvXMLAutoStylePool::Add( SfxStyleFamily eFamily, 
								  const OUString& rParent,
								  const SfxItemSet& rItemSet )
{
	return pImpl->Add( eFamily, rParent, rItemSet );
}

OUString SvXMLAutoStylePool::Find( SfxStyleFamily eFamily,
							       const SfxItemSet& rItemSet ) const
{
	OUString sEmpty;
	return pImpl->Find( eFamily, sEmpty, rItemSet );
}

OUString SvXMLAutoStylePool::Find( SfxStyleFamily eFamily,
		                           const OUString& rParent,
							       const SfxItemSet& rItemSet ) const
{
	return pImpl->Find( eFamily, rParent, rItemSet );
}

void SvXMLAutoStylePool::exportXML( SfxStyleFamily eFamily,
									const SvXMLExportItemMapper& rItemExp,
									const uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler > & rHandler,
									const SvXMLUnitConverter& rUnitConverter,
								const SvXMLNamespaceMap& rNamespaceMap) const
{
	pImpl->exportXML( eFamily, rItemExp, rHandler, rUnitConverter,
					  rNamespaceMap, this );
}


