/*************************************************************************
 *
 *  $RCSfile: xp.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:07:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/*
 * defines needed
 */

#define XP_WARNING 0
#define XP_ERROR 1
#define XpPORTRAIT 1
#define XpLANDSCAPE 2

/*
 * types needed
 */

typedef struct {
	double llx, lly;
	double urx, ury;
} XpBox;

typedef struct {
	double origin_x, origin_y;
	double scale_x,scale_y;
	double rotate;
} XpEPS_trf;

typedef struct {
	char* name1;
	char* name2;
	int xamt, yamt;
} PairKernData;

typedef struct {
	int pointsize, b, numOfPairs;
	PairKernData* pkd;
} XpPairKernData;

typedef struct {
	int error_code, severity;
} XpErrorEvent;

typedef int XpOrientation_t;

typedef void(*prolog_callback)(void*, void*);
typedef void(*globalsetup_callback)(void*, void*);
typedef void(*pagesetup_callback)(void*, int, void* );

/* xprinter specific functions */
	int XpStretchPutImage( void*, int, void*, void*, int, int, unsigned int, unsigned int, int, int, unsigned int, unsigned int );
	XpBox* XpEPS_GetBoundingBox( void*, void* );
	void* XpEPS_Put( void*, void*, void* );
	void XpPSComment( const void*, const void* );
	void XpSetPrologCallback( void*, prolog_callback, void* );
	void XpSetGlobalSetupCallback( void*, globalsetup_callback, void* );
	void XpSetPageSetupCallback( void*, pagesetup_callback, void* );
	void XpGetErrorText( void*, int );
	int XpSetPageSize( void*, const void* );
	int XpSetOrientation( void*, int );
	int XpSetScale( void*, double );
	int XpSetCopies( void*, int );
	int XpSetPSLevel( void*, int );
	int XpSetPSColor( void*, int );
	int XpSetPaperTray( void*, const void* );
	int XpSetColorDepth( void*, int );
	_XDisplay* XpVaOpenPrinter(const void*, const void*, const void*, ... );
	int XpClosePrinter( void* );
	int XpStartDoc( void*, const void* );
	int XpStartPage( void* );
	int XpEndDoc( void* );
	int XpEndPage( void* );
	int XpAbortDoc( void* );

	/* display functions */
	int XpDefaultDepth( void*, int );
	unsigned long XpBlackPixel( void*, int );
	unsigned long XpWhitePixel( void*, int );
	long XpDefaultColormap( void*, int );
	int XpDefaultScreen( void* );
	int XpDisplayHeight( void*, int );
	int XpDisplayHeightMM( void*, int );
	int XpDisplayWidth( void*, int );
	int XpDisplayWidthMM( void*, int );
	int XpRootWindow( void*, int );
	int XpCreatePixmapFromBitmapData();
	int XpCreateBitmapFromData( void*, int, const void*, int, int );
	int XpCreatePixmap( void*, int, unsigned int, unsigned int, unsigned int );
	int XpFlush( void* );
	int XpFreeGC( void*, void* );
	int XpFreePixmap( void*, int );
	int XpUnlock( const void* );
	void XpSetErrorHandler( int(*)(XpErrorEvent*) );
	
	/* images */
	_XImage* XpCreateImage( void*, void*, unsigned int, int, int, void*, unsigned int, unsigned int, int, int );
	_XImage* XpGetImage( void*, int, int, int, unsigned int, unsigned int, unsigned long, int );
	_XImage* XpGetSubImage( void*, int, int, int, unsigned int, unsigned int, unsigned long, int, void*, int, int );
	int XpPutImage( void*, int, void*, void*, int, int, int, int, unsigned int, unsigned int );
	
	/* draw functions */
	int XpDrawRotString( void*, int, void*, int, int, const void*, int, int );
	int XpDrawRotImageString( void*, int, void*, int, int, const void*, int, int );
	int XpDrawString( void*, int, void*, int, int, const void*, int );
	int XpDrawImageString( void*, int, void*, int, int, const void*, int );
	int XpDrawString16( void*, int, void*, int, int, const void*, int );
	int XpDrawImageString16( void*, int, void*, int, int, const void*, int );
	int XpDrawText( void*, int, void*, int, int, const void*, int );
	int XpDrawLine( void*, int, void*, int, int, int, int );
	int XpDrawLines( void*, int, void*, void*, int, int );
	int XpDrawPoint( void*, int, void*, int, int );
	int XpDrawRectangle( void*, int, void*, int, int, unsigned int, unsigned int );
	int XpCopyArea( void*, int, int, void*, int, int, unsigned int, unsigned int, int, int );
	int XpFillPolygon( void*, int, void*, void*, int, int, int );
	int XpFillRectangle( void*, int, void*, int, int, unsigned int, unsigned int );

	/* font management */
	char** XpListFonts( void*, const void*, int, int* );
	int XpLoadFont( void*, const void* );
	XFontStruct* XpLoadQueryFont( void*, const void* );
	int XpFreeFont( void*, void* );
	int XpUnloadFont( void*, int );
	
	/* color management */
	int XpAllocColor( void*, int, void* );
	int XpAllocNamedColor( void*, int, const void*, void*, void* );
	int XpQueryColor( void*, int, void* );
	int XpQueryColors( void*, int, void*, int );

	/* GC functions */
	_XGC* XpCreateGC( void*, int, unsigned long, void* );
	int XpChangeGC( void*, void*, unsigned long, void* );
	int XpSetArcMode( void*, void*, int );
	int XpSetClipOrigin( void*, void*, int, int );
	int XpSetClipMask( void*, void*, int );
	int XpSetFillStyle( void*, void*, int );
	int XpSetFont( void*, void*, int );
	int XpSetForeground( void*, void*, int );
	int XpSetBackground( void*, void*, int );
	int XpSetFunction( void*, void*, int );
	int XpSetLineAttributes( void*, void*, unsigned int, int, int, int );
	int XpSetRegion( void*, void*, void* );
	int XpSetStipple( void*, void*, int );
	int XpSetTSOrigin( void*, void*, int, int );
	int XpSetTile( void*, void*, int );
	
#ifdef __cplusplus
}
#endif
