/*************************************************************************
 *
 *  $RCSfile: ja_sq_pg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/



#ifndef _SDB_JA_SQ_PG_HXX
#include <ja_sq_pg.hxx>
#endif

#ifndef _SDB_JA_MA_PG_HXX
#include <ja_ma_pg.hxx>
#endif

//**************************************************************
//************ Class: java.sql.Connection
//**************************************************************
jstring convertwchar_tToJavaString(JNIEnv *pEnv,const String* pTemp)
{
	if (pEnv)
	{
		::rtl::OString aT = ::rtl::OUStringToOString(*pTemp,RTL_TEXTENCODING_UTF8);
		jstring jStr = pEnv->NewString((const unsigned short *)aT.getStr(), aT.getLength());
		return jStr;
	}
	return NULL;
}

jclass java_sql_Connection::theClass = 0;

java_sql_Connection::~java_sql_Connection()
{}

jclass java_sql_Connection::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/Connection"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_Connection::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

String java_sql_Connection::getCatalog()
{
	jstring out(0);// = (jstring)0;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv )
	{

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getCatalog";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

java_sql_DatabaseMetaData * java_sql_Connection::getMetaData()
{
	jobject out(0);//(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/DatabaseMetaData;";
		char * cMethodName = "getMetaData";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_DatabaseMetaData( t.pEnv, out );
}

void java_sql_Connection::close()
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()V";
		char * cMethodName = "close";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID);
		} //mID
	} //t.pEnv
}

void java_sql_Connection::commit()
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()V";
		char * cMethodName = "commit";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID );
		} //mID
	} //t.pEnv
}

BOOL java_sql_Connection::isClosed()
{
	jboolean out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "isClosed";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_Connection::isReadOnly()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "isReadOnly";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

void java_sql_Connection::rollback()
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()V";
		char * cMethodName = "rollback";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID);
		} //mID
	} //t.pEnv
}

void java_sql_Connection::setAutoCommit( BOOL _par0 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "(Z)V";
		char * cMethodName = "setAutoCommit";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, (jboolean)_par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_Connection::setTransactionIsolation( INT32 _par0 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setTransactionIsolation";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
}

java_sql_Statement * java_sql_Connection::createStatement()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/Statement;";
		char * cMethodName = "createStatement";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID );
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Statement( t.pEnv, out );
}

java_sql_PreparedStatement * java_sql_Connection::prepareStatement( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/PreparedStatement;";
		char * cMethodName = "prepareStatement";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_PreparedStatement( t.pEnv, out );
}

java_sql_CallableStatement * java_sql_Connection::prepareCall( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/CallableStatement;";
		char * cMethodName = "prepareCall";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_CallableStatement( t.pEnv, out );
}

java_sql_SQLWarning * java_sql_Connection::getWarnings()
{
	jobject out(NULL);
	SDBThreadAttach t;
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/SQLWarning;";
		char * cMethodName = "getWarnings";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallObjectMethod( object, mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out ? new java_sql_SQLWarning( t.pEnv, out ) : 0;
}
//**************************************************************
//************ Class: java.sql.DriverManager
//**************************************************************

jclass java_sql_DriverManager::theClass = 0;

java_sql_DriverManager::~java_sql_DriverManager()
{}

jclass java_sql_DriverManager::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/DriverManager"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_DriverManager::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_sql_Connection * java_sql_DriverManager::getConnection( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/Connection;";
		char * cMethodName = "getConnection";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetStaticMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallStaticObjectMethod( getMyClass(), mID, args[0].l );
			// und aufraeumen
t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Connection( t.pEnv, out );
}

java_sql_Connection * java_sql_DriverManager::getConnection( const String* _par0, java_util_Properties * _par1 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[2];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;

		args[1].l = _par1 != 0 ? ((java_lang_Object *)_par1)->getJavaObject() : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/util/Properties;)Ljava/sql/Connection;";
		char * cMethodName = "getConnection";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetStaticMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallStaticObjectMethod( getMyClass(), mID, args[0].l,args[1].l );
			// und aufraeumen
t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Connection( t.pEnv, out );
}

java_sql_Connection * java_sql_DriverManager::getConnection( const String* _par0, const String* _par1, const String* _par2 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[3];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/Connection;";
		char * cMethodName = "getConnection";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetStaticMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallStaticObjectMethod( getMyClass(), mID, args[0].l,args[1].l,args[2].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
			t.pEnv->DeleteLocalRef((jstring)args[1].l);
			t.pEnv->DeleteLocalRef((jstring)args[2].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Connection( t.pEnv, out );
}

void java_sql_DriverManager::setLoginTimeout(INT32 _par0)
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	jobject out(0);
	if( t.pEnv )
	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setLoginTimeout";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			t.pEnv->CallStaticVoidMethod(getMyClass(), mID, _par0);
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
}

java_util_Enumeration * java_sql_DriverManager::getDrivers()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/util/Enumeration;";
		char * cMethodName = "getDrivers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetStaticMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallStaticObjectMethod( getMyClass(), mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!

	return out==0 ? 0 : new java_util_Enumeration( t.pEnv, out );
}

//**************************************************************
//************ Class: java.sql.ResultSet
//**************************************************************

jclass java_sql_ResultSet::theClass = 0;

java_sql_ResultSet::~java_sql_ResultSet()
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		char * cSignature = "()V";
		char * cMethodName = "close";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			t.pEnv->CallVoidMethod( object, mID);
	}
}

jclass java_sql_ResultSet::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/ResultSet"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_ResultSet::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

INT32 java_sql_ResultSet::findColumn( const String* _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)I";
		char * cMethodName = "findColumn";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

java_io_InputStream * java_sql_ResultSet::getAsciiStream( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/io/InputStream;";
		char * cMethodName = "getAsciiStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_io_InputStream( t.pEnv, out );
}

java_io_InputStream * java_sql_ResultSet::getAsciiStream( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/io/InputStream;";
		char * cMethodName = "getAsciiStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_io_InputStream( t.pEnv, out );
}

java_math_BigDecimal * java_sql_ResultSet::getBigDecimal( INT32 _par0, INT32 _par1 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(II)Ljava/math/BigDecimal;";
		char * cMethodName = "getBigDecimal";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i,args[1].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out ? new java_math_BigDecimal( t.pEnv, out ) : 0;
}

java_math_BigDecimal * java_sql_ResultSet::getBigDecimal( const String* _par0, INT32 _par1 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].i = (INT32)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;I)Ljava/math/BigDecimal;";
		char * cMethodName = "getBigDecimal";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[1].i );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_math_BigDecimal( t.pEnv, out );
}

java_io_InputStream * java_sql_ResultSet::getBinaryStream( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/io/InputStream;";
		char * cMethodName = "getBinaryStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_io_InputStream( t.pEnv, out );
}

java_io_InputStream * java_sql_ResultSet::getBinaryStream( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/io/InputStream;";
		char * cMethodName = "getBinaryStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_io_InputStream( t.pEnv, out );
}

BOOL java_sql_ResultSet::getBoolean( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "getBoolean";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_ResultSet::getBoolean( const String* _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Z";
		char * cMethodName = "getBoolean";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return out;
}

BYTE java_sql_ResultSet::getByte( INT32 _par0 )
{
	jbyte out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)B";
		char * cMethodName = "getByte";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallByteMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BYTE java_sql_ResultSet::getByte( const String* _par0 )
{
	jbyte out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)B";
		char * cMethodName = "getByte";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallByteMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
#ifndef OS2
	return static_cast<BYTE>( out );
#else
		return (BYTE)out;
#endif
}


BOOL java_sql_ResultSet::getBytes( INT32 _par0,  BYTE* &pData,INT32 &nLen)
{
	jbyteArray out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		char * cSignature = "(I)[B";
		char * cMethodName = "getBytes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jbyteArray)t.pEnv->CallObjectMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	if (out)
	{
		jboolean p = FALSE;
		pData = (BYTE*)t.pEnv->GetByteArrayElements(out,&p);
		nLen = t.pEnv->GetArrayLength(out);
		t.pEnv->DeleteLocalRef(out);
		return TRUE;
	}
	else
		return FALSE;
}

BOOL java_sql_ResultSet::getBytes(const String* _par0, BYTE* &pData,INT32 &nLen)
{
	jbyteArray out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)[B";
		char * cMethodName = "getBytes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jbyteArray)t.pEnv->CallObjectMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	if (out)
	{
		jboolean p = FALSE;
		pData = (BYTE*)t.pEnv->GetByteArrayElements(out,&p);
		nLen = t.pEnv->GetArrayLength(out);
		t.pEnv->DeleteLocalRef(out);
		return TRUE;
	}
	else
		return FALSE;
}

java_sql_Date * java_sql_ResultSet::getDate( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/sql/Date;";
		char * cMethodName = "getDate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Date( t.pEnv, out );
}

double java_sql_ResultSet::getDouble( INT32 _par0 )
{
	jdouble out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		jvalue args[1];
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)D";
		char * cMethodName = "getDouble";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallDoubleMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

double java_sql_ResultSet::getDouble( const String* _par0 )
{
	jdouble out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)D";
		char * cMethodName = "getDouble";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallDoubleMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return out;
}

float java_sql_ResultSet::getFloat( INT32 _par0 )
{
	jfloat out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)F";
		char * cMethodName = "getFloat";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallFloatMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

float java_sql_ResultSet::getFloat( const String* _par0 )
{
	jfloat out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)F";
		char * cMethodName = "getFloat";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallFloatMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return out;
}

INT32 java_sql_ResultSet::getInt( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "getInt";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_ResultSet::getInt( const String* _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)I";
		char * cMethodName = "getInt";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

jlong java_sql_ResultSet::getLong( INT32 _par0 )
{
	jlong out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)J";
		char * cMethodName = "getLong";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallLongMethod( object, mID, args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

jlong java_sql_ResultSet::getLong( const String* _par0 )
{
	jlong out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)J";
		char * cMethodName = "getLong";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallLongMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return out;
}

java_sql_ResultSetMetaData * java_sql_ResultSet::getMetaData()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/ResultSetMetaData;";
		char * cMethodName = "getMetaData";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID );
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSetMetaData( t.pEnv, out );
}

java_lang_Object * java_sql_ResultSet::getObject( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/lang/Object;";
		char * cMethodName = "getObject";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_lang_Object( t.pEnv, out );
}

java_lang_Object * java_sql_ResultSet::getObject( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/lang/Object;";
		char * cMethodName = "getObject";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_lang_Object( t.pEnv, out );
}

short java_sql_ResultSet::getShort( INT32 _par0 )
{
	jshort out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)S";
		char * cMethodName = "getShort";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallShortMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT16)out;
}

short java_sql_ResultSet::getShort( const String* _par0 )
{
	jshort out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)S";
		char * cMethodName = "getShort";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallShortMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return (INT16)out;
}

String java_sql_ResultSet::getString( INT32 _par0 )
{
	jstring out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/lang/String;";
		char * cMethodName = "getString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID, _par0 );
			if(out){
				jboolean bCopy(TRUE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				if(bCopy)
					t.pEnv->ReleaseStringChars(out,pChar);
				t.pEnv->DeleteLocalRef(out);
			}
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return 	aStr;
}

String java_sql_ResultSet::getString( const String* _par0)
{
	jstring out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/lang/String;";
		char * cMethodName = "getString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID, args[0].l);
			if(out){
				jboolean bCopy(FALSE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				if(bCopy)
					t.pEnv->ReleaseStringChars(out,pChar);


				t.pEnv->DeleteLocalRef(out);
			}
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return 	aStr;
}

java_sql_Time * java_sql_ResultSet::getTime( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/sql/Time;";
		char * cMethodName = "getTime";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Time( t.pEnv, out );
}

java_sql_Time * java_sql_ResultSet::getTime( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/Time;";
		char * cMethodName = "getTime";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Time( t.pEnv, out );
}

java_sql_Timestamp * java_sql_ResultSet::getTimestamp( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/sql/Timestamp;";
		char * cMethodName = "getTimestamp";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Timestamp( t.pEnv, out );
}

java_sql_Timestamp * java_sql_ResultSet::getTimestamp( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/Timestamp;";
		char * cMethodName = "getTimestamp";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Timestamp( t.pEnv, out );
}

java_io_InputStream * java_sql_ResultSet::getUnicodeStream( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/io/InputStream;";
		char * cMethodName = "getUnicodeStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_io_InputStream( t.pEnv, out );
}

java_io_InputStream * java_sql_ResultSet::getUnicodeStream( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/io/InputStream;";
		char * cMethodName = "getUnicodeStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_io_InputStream( t.pEnv, out );
}

BOOL java_sql_ResultSet::next()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "next";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_ResultSet::wasNull()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "wasNull";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID );
		} //mID
	} //t.pEnv
	return out;
}


//**************************************************************
//************ Class: java.sql.DatabaseMetaData
//**************************************************************

jclass java_sql_DatabaseMetaData::theClass				= 0;
int java_sql_Connection::TRANSACTION_NONE				= 0;
int java_sql_Connection::TRANSACTION_READ_UNCOMMITTED	= 1;
int java_sql_Connection::TRANSACTION_READ_COMMITTED		= 2;
int java_sql_Connection::TRANSACTION_REPEATABLE_READ	= 4;
int java_sql_Connection::TRANSACTION_SERIALIZABLE		= 8;

java_sql_DatabaseMetaData::~java_sql_DatabaseMetaData()
{}

jclass java_sql_DatabaseMetaData::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/DatabaseMetaData"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}


void java_sql_DatabaseMetaData::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getTypeInfo()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/ResultSet;";
		char * cMethodName = "getTypeInfo";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID );
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getCatalogs()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/ResultSet;";
		char * cMethodName = "getCatalogs";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID );
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

String java_sql_DatabaseMetaData::getCatalogSeparator()
{
	jstring out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getCatalogSeparator";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID );
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getTables(const String* _par0,const String* _par1,const String* _par2,const String &_par3){
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[4];
		xub_StrLen len = _par3.GetTokenCount(';');
		if(len)
		{
			jobjectArray pObjArray = t.pEnv->NewObjectArray((jsize) len, java_lang_String::getMyClass(), 0);
			for(xub_StrLen i=0;i<len;i++)
			{
				jstring aT = convertwchar_tToJavaString(t.pEnv,&_par3);
				t.pEnv->SetObjectArrayElement(pObjArray,(jsize)i,aT);
			}
			args[3].l = pObjArray;
		}else
			args[3].l = 0;
		// temporaere Variable initialisieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;

		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;[Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getTables";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
		{
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l, args[1].l,args[2].l,args[3].l);
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
			//for(INT16 i=0;i<len;i++)
			t.pEnv->DeleteLocalRef((jobjectArray)args[3].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out ? new java_sql_ResultSet( t.pEnv, out ) : 0;
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getProcedures( const String* _par0, const String* _par1, const String* _par2 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[3];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getProcedures";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[1].l,args[2].l);
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getVersionColumns( const String* _par0, const String* _par1, const String* _par2 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[3];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getVersionColumns";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[1].l,args[2].l);
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

INT32 java_sql_DatabaseMetaData::getMaxBinaryLiteralLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxBinaryLiteralLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID );
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxCatalogNameLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxCatalogNameLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID );
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxCharLiteralLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxCharLiteralLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxColumnNameLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxColumnNameLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID );
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxColumnsInIndex()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxColumnsInIndex";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxColumnsInTable()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxColumnsInTable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxStatementLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxStatementLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID );
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxTableNameLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxTableNameLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID );
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxTablesInSelect()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxTablesInSelect";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getPrimaryKeys( const String* _par0, const String* _par1, const String* _par2 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[3];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getPrimaryKeys";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[1].l,args[2].l);
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getIndexInfo( const String* _par0, const String* _par1, const String* _par2, BOOL _par3, BOOL _par4 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[5];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		args[3].z = _par3;
		args[4].z = _par4;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;ZZ)Ljava/sql/ResultSet;";
		char * cMethodName = "getIndexInfo";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[1].l,args[2].l,args[3].z,args[4].z );
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getTablePrivileges( const String* _par0, const String* _par1, const String* _par2 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[3];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getTablePrivileges";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[1].l,args[2].l);
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getCrossReference( const String* _par0, const String* _par1, const String* _par2, const String* _par3, const String* _par4, const String* _par5 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[6];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		args[3].l = _par3 ? convertwchar_tToJavaString(t.pEnv,_par3) : 0;
		args[4].l = _par4 ? convertwchar_tToJavaString(t.pEnv,_par4) : 0;
		args[5].l = _par5 ? convertwchar_tToJavaString(t.pEnv,_par5) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getCrossReference";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l,args[2].l,args[2].l,args[3].l,args[4].l,args[5].l );
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
			if(_par3)
				t.pEnv->DeleteLocalRef((jstring)args[3].l);
			if(_par4)
				t.pEnv->DeleteLocalRef((jstring)args[4].l);
			if(_par5)
				t.pEnv->DeleteLocalRef((jstring)args[5].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

BOOL java_sql_DatabaseMetaData::storesLowerCaseIdentifiers()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "storesLowerCaseIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 	t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::storesMixedCaseIdentifiers()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "storesMixedCaseIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 	t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::storesUpperCaseIdentifiers()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "storesUpperCaseIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsAlterTableWithAddColumn()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsAlterTableWithAddColumn";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsAlterTableWithDropColumn()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsAlterTableWithDropColumn";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

INT32 java_sql_DatabaseMetaData::getMaxIndexLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxIndexLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

BOOL java_sql_DatabaseMetaData::supportsNonNullableColumns()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsNonNullableColumns";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

String java_sql_DatabaseMetaData::getCatalogTerm()
{
	jstring out = (jstring)0;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getCatalogTerm";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getIdentifierQuoteString()
{
	jstring out = (jstring)0;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getIdentifierQuoteString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getExtraNameCharacters()
{
	jstring out = (jstring)0;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getExtraNameCharacters";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

BOOL java_sql_DatabaseMetaData::supportsDataDefinitionAndDataManipulationTransactions()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsDataDefinitionAndDataManipulationTransactions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsPositionedDelete()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsPositionedDelete";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsPositionedUpdate()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsPositionedUpdate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsOpenCursorsAcrossCommit()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsOpenCursorsAcrossCommit";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsOpenCursorsAcrossRollback()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsOpenCursorsAcrossRollback";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsTransactionIsolationLevel( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "supportsTransactionIsolationLevel";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSchemasInDataManipulation()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSchemasInDataManipulation";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsANSI92FullSQL()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsANSI92FullSQL";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsANSI92EntryLevelSQL()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsANSI92EntryLevelSQL";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsIntegrityEnhancementFacility()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsIntegrityEnhancementFacility";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID );
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSchemasInIndexDefinitions()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSchemasInIndexDefinitions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSchemasInTableDefinitions()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSchemasInTableDefinitions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCatalogsInTableDefinitions()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCatalogsInTableDefinitions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCatalogsInIndexDefinitions()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCatalogsInIndexDefinitions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCatalogsInDataManipulation()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCatalogsInDataManipulation";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsOuterJoins()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsOuterJoins";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getTableTypes()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/ResultSet;";
		char * cMethodName = "getTableTypes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

INT32 java_sql_DatabaseMetaData::getMaxStatements()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxStatements";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxSchemaNameLength()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxSchemaNameLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

BOOL java_sql_DatabaseMetaData::supportsTransactions()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsTransactions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}
BOOL java_sql_DatabaseMetaData::allProceduresAreCallable()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "allProceduresAreCallable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID );
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::allTablesAreSelectable()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "allTablesAreSelectable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID );
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::isReadOnly()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "isReadOnly";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::usesLocalFiles()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "usesLocalFiles";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::usesLocalFilePerTable()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "usesLocalFilePerTable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::nullPlusNonNullIsNull()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "nullPlusNonNullIsNull";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsColumnAliasing()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsColumnAliasing";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsTableCorrelationNames()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsTableCorrelationNames";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsConvert()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsConvert";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsConvert( INT32 _par0, INT32 _par1 )
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(II)Z";
		char * cMethodName = "supportsConvert";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID, args[0].i,args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsExpressionsInOrderBy()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsExpressionsInOrderBy";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsGroupBy()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsGroupBy";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsGroupByBeyondSelect()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsGroupByBeyondSelect";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsGroupByUnrelated()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsGroupByUnrelated";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsOrderByUnrelated()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsOrderByUnrelated";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsUnion()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsUnion";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsUnionAll()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsUnionAll";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsMixedCaseIdentifiers()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsMixedCaseIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsMixedCaseQuotedIdentifiers()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsMixedCaseQuotedIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::nullsAreSortedAtEnd()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "nullsAreSortedAtEnd";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::nullsAreSortedAtStart()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "nullsAreSortedAtStart";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::nullsAreSortedHigh()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "nullsAreSortedHigh";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::nullsAreSortedLow()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "nullsAreSortedLow";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSchemasInProcedureCalls()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSchemasInProcedureCalls";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSchemasInPrivilegeDefinitions()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSchemasInPrivilegeDefinitions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCatalogsInProcedureCalls()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCatalogsInProcedureCalls";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCatalogsInPrivilegeDefinitions()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCatalogsInPrivilegeDefinitions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCorrelatedSubqueries()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCorrelatedSubqueries";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSubqueriesInComparisons()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSubqueriesInComparisons";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSubqueriesInExists()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSubqueriesInExists";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSubqueriesInIns()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSubqueriesInIns";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsSubqueriesInQuantifieds()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsSubqueriesInQuantifieds";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsANSI92IntermediateSQL()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsANSI92IntermediateSQL";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

String java_sql_DatabaseMetaData::getURL()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getURL";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getDriverName()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getDriverName";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getDriverVersion()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getDriverVersion";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getDatabaseProductVersion()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getDatabaseProductVersion";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getDatabaseProductName()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getDatabaseProductName";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getProcedureTerm()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getProcedureTerm";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getSchemaTerm()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getSchemaTerm";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

INT32 java_sql_DatabaseMetaData::getDriverMajorVersion()
{
	jint out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getDriverMajorVersion";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getDriverMinorVersion()
{
	jint out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getDriverMinorVersion";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

String java_sql_DatabaseMetaData::getSQLKeywords()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getSQLKeywords";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getSearchStringEscape()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getSearchStringEscape";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getStringFunctions()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getStringFunctions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				if(bCopy)
					t.pEnv->ReleaseStringChars(out,pChar);
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getSystemFunctions()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getSystemFunctions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_sql_DatabaseMetaData::getNumericFunctions()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getNumericFunctions";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

BOOL java_sql_DatabaseMetaData::supportsExtendedSQLGrammar()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsExtendedSQLGrammar";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsCoreSQLGrammar()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsCoreSQLGrammar";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsMinimumSQLGrammar()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsMinimumSQLGrammar";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsFullOuterJoins()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsFullOuterJoins";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::supportsLimitedOuterJoins()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "supportsLimitedOuterJoins";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

INT32 java_sql_DatabaseMetaData::getMaxColumnsInGroupBy()
{
	jint out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxColumnsInGroupBy";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = 			t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxColumnsInOrderBy()
{
	jint out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxColumnsInOrderBy";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxColumnsInSelect()
{
	jint out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxColumnsInSelect";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_DatabaseMetaData::getMaxUserNameLength()
{
	jint out;
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxUserNameLength";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

//**************************************************************
//************ Class: java.sql.Date
//**************************************************************

jclass java_sql_Date::theClass = 0;

java_sql_Date::~java_sql_Date()
{}

jclass java_sql_Date::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/Date"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_Date::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}
//**************************************************************
//************ Class: java.sql.Date
//**************************************************************
java_sql_Date::java_sql_Date( INT32 _par0, INT32 _par1, INT32 _par2 ): java_util_Date( _par0,_par1,_par2){}
//--------------------------------------------------------------------------------
java_sql_Date* java_sql_Date::valueOf(const String& _par0)
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = convertwchar_tToJavaString(t.pEnv,&_par0);
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/Date;";
		char * cMethodName = "valueOf";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetStaticMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallStaticObjectMethod( getMyClass(), mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Date( t.pEnv, out );
}

//**************************************************************
//************ Class: java.sql.ResultSetMetaData
//**************************************************************

jclass java_sql_ResultSetMetaData::theClass = 0;

java_sql_ResultSetMetaData::~java_sql_ResultSetMetaData()
{}

jclass java_sql_ResultSetMetaData::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/ResultSetMetaData"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_ResultSetMetaData::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

INT32 java_sql_ResultSetMetaData::getColumnCount()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getColumnCount";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

BOOL java_sql_ResultSetMetaData::isCurrency( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "isCurrency";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			out = (BOOL)t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
	} //t.pEnv
	return out;
}

BOOL java_sql_ResultSetMetaData::isAutoIncrement( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "isAutoIncrement";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			out = (BOOL)t.pEnv->CallIntMethod( object, mID, _par0);
			// und aufraeumen
	} //t.pEnv
	return out;
}


INT32 java_sql_ResultSetMetaData::isNullable( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "isNullable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

BOOL java_sql_ResultSetMetaData::isSearchable( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "isSearchable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_ResultSetMetaData::isReadOnly( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t;
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "isReadOnly";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_ResultSetMetaData::isWritable( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "isWritable";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::isCatalogAtStart()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "isCatalogAtStart";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

INT32 java_sql_ResultSetMetaData::getScale( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "getScale";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_ResultSetMetaData::getPrecision( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "getPrecision";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_ResultSetMetaData::getColumnDisplaySize( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "getColumnDisplaySize";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_sql_ResultSetMetaData::getColumnType( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "getColumnType";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

String java_sql_ResultSetMetaData::getColumnName( INT32 _par0 )
{
	jstring out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/lang/String;";
		char * cMethodName = "getColumnName";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID, args[0].i );

			if(out)

			{
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				//if(bCopy)
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				t.pEnv->DeleteLocalRef(out);
			}
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

java_sql_ResultSet * java_sql_DatabaseMetaData::getColumns( const String* _par0, const String* _par1, const String* _par2, const String* _par3 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[4];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		args[2].l = _par2 ? convertwchar_tToJavaString(t.pEnv,_par2) : 0;
		args[3].l = _par3 ? convertwchar_tToJavaString(t.pEnv,_par3) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "getColumns";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethodA( object, mID, args);
			// und aufraeumen
			if(_par0)
				t.pEnv->DeleteLocalRef((jstring)args[0].l);
			if(_par1)
				t.pEnv->DeleteLocalRef((jstring)args[1].l);
			if(_par2)
				t.pEnv->DeleteLocalRef((jstring)args[2].l);
			if(_par3)
				t.pEnv->DeleteLocalRef((jstring)args[3].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out ? new java_sql_ResultSet( t.pEnv, out ) : 0;
}

BOOL java_sql_DatabaseMetaData::storesUpperCaseQuotedIdentifiers()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "storesUpperCaseQuotedIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::storesLowerCaseQuotedIdentifiers()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "storesLowerCaseQuotedIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_DatabaseMetaData::storesMixedCaseQuotedIdentifiers()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "storesMixedCaseQuotedIdentifiers";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}
//**************************************************************
//************ Class: java.sql.Time
//**************************************************************

jclass java_sql_Time::theClass = 0;

java_sql_Time::~java_sql_Time()
{}

jclass java_sql_Time::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/Time"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_Time::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_sql_Time::java_sql_Time( INT32 _hour, INT32 _minute, INT32 _seconds ): java_util_Date( NULL, (jobject)NULL ){
	SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[3];
		// Parameter konvertieren
		args[0].i = (INT32)_hour;
		args[1].i = (INT32)_minute;
		args[2].i = (INT32)_seconds;
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(III)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	// und aufraeumen
}

//**************************************************************
//************ Class: java.sql.Timestamp
//**************************************************************

jclass java_sql_Timestamp::theClass = 0;

java_sql_Timestamp::~java_sql_Timestamp()
{}

jclass java_sql_Timestamp::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/Timestamp"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_Timestamp::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_sql_Timestamp::java_sql_Timestamp(INT32 _year, INT32 _month, INT32 _day,
									   INT32 _hour, INT32 _minute,
									   INT32 _second, INT32 _nano)
				   :java_util_Date( NULL, (jobject)NULL )
{
		SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[7];
		// Parameter konvertieren
		args[0].i = (INT32)_year;
		args[1].i = (INT32)_month;
		args[2].i = (INT32)_day;
		args[3].i = (INT32)_hour;
		args[4].i = (INT32)_minute;
		args[5].i = (INT32)_second;
		args[6].i = (INT32)_nano;
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(IIIIIII)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	// und aufraeumen
}

INT32 java_sql_Timestamp::getNanos()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getNanos";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

void java_sql_Timestamp::setNanos( INT32 _par0 )
{
	SDBThreadAttach t;
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setNanos";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
}

//**************************************************************
//************ Class: java.sql.Statement
//**************************************************************

jclass java_sql_Statement::theClass = 0;

java_sql_Statement::~java_sql_Statement()
{}

jclass java_sql_Statement::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/Statement"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_Statement::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

void java_sql_Statement::cancel()
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()V";
		char * cMethodName = "cancel";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID);
		} //mID
	} //t.pEnv
}

void java_sql_Statement::close()
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()V";
		char * cMethodName = "close";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID);
		} //mID
	} //t.pEnv
}

BOOL java_sql_Statement::execute( const String* _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		//args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Z";
		char * cMethodName = "execute";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return out;
}

java_sql_ResultSet * java_sql_Statement::executeQuery( const String* _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		//args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/sql/ResultSet;";
		char * cMethodName = "executeQuery";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

INT32 java_sql_Statement::executeUpdate( const String* _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)I";
		char * cMethodName = "executeUpdate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

void java_sql_Statement::setMaxFieldSize(INT32 _par0 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setMaxFieldSize";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
		{
			t.pEnv->CallVoidMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

INT32 java_sql_Statement::getMaxRows()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMaxRows";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

java_sql_ResultSet * java_sql_Statement::getResultSet()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/ResultSet;";
		char * cMethodName = "getResultSet";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

INT32 java_sql_Statement::getUpdateCount()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getUpdateCount";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

void java_sql_Statement::setCursorName( const String* _par0 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 ? convertwchar_tToJavaString(t.pEnv,_par0) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)V";
		char * cMethodName = "setCursorName";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
}

void java_sql_Statement::setMaxRows( INT32 _par0 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setMaxRows";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
}
//**************************************************************
//************ Class: java.sql.PreparedStatement
//**************************************************************

jclass java_sql_PreparedStatement::theClass = 0;

java_sql_PreparedStatement::~java_sql_PreparedStatement()
{}

jclass java_sql_PreparedStatement::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/PreparedStatement"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_PreparedStatement::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

BOOL java_sql_PreparedStatement::execute()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "execute";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

INT32 java_sql_PreparedStatement::executeUpdate()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "executeUpdate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}
void java_sql_PreparedStatement::setString( INT32 _par0, const String* _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].l = _par1 ? convertwchar_tToJavaString(t.pEnv,_par1) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/lang/String;)V";
		char * cMethodName = "setString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[1].l);
		} //mID
	} //t.pEnv
}
java_sql_ResultSet * java_sql_PreparedStatement::executeQuery()
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/sql/ResultSet;";
		char * cMethodName = "executeQuery";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_ResultSet( t.pEnv, out );
}

void java_sql_PreparedStatement::setBigDecimal( INT32 _par0, java_math_BigDecimal * _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].l = _par1 != 0 ? ((java_math_BigDecimal *)_par1)->getJavaObject() : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/math/BigDecimal;)V";
		char * cMethodName = "setBigDecimal";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setBoolean( INT32 _par0, BOOL _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].z = _par1;
		// temporaere Variable initialisieren
		char * cSignature = "(IZ)V";
		char * cMethodName = "setBoolean";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].z);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setByte( INT32 _par0, BYTE _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].b =  _par1;
		// temporaere Variable initialisieren
		char * cSignature = "(IB)V";
		char * cMethodName = "setByte";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].b);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setDate( INT32 _par0, java_sql_Date * _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].l = _par1 != 0 ? ((java_lang_Object *)_par1)->getJavaObject() : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/sql/Date;)V";
		char * cMethodName = "setDate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setTime( INT32 _par0, java_sql_Time * _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].l = _par1 != 0 ? ((java_lang_Object *)_par1)->getJavaObject() : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/sql/Time;)V";
		char * cMethodName = "setTime";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setTimestamp( INT32 _par0, java_sql_Timestamp * _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].l = _par1 != 0 ? ((java_lang_Object *)_par1)->getJavaObject() : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/sql/Timestamp;)V";
		char * cMethodName = "setTimestamp";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
		} //mID
	} //t.pEnv
}



void java_sql_PreparedStatement::setDouble( INT32 _par0, double _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].d = _par1;
		// temporaere Variable initialisieren
		char * cSignature = "(ID)V";
		char * cMethodName = "setDouble";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].d);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setFloat( INT32 _par0, float _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].f = _par1;
		// temporaere Variable initialisieren
		char * cSignature = "(IF)V";
		char * cMethodName = "setFloat";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].f);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setInt( INT32 _par0, INT32 _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(II)V";
		char * cMethodName = "setInt";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setLong( INT32 _par0, jlong _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].j = _par1;
		// temporaere Variable initialisieren
		char * cSignature = "(IJ)V";
		char * cMethodName = "setLong";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].j);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setNull( INT32 _par0, INT32 _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(II)V";
		char * cMethodName = "setNull";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setObject( INT32 _par0, java_lang_Object * _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].l = _par1 != 0 ? ((java_lang_Object *)_par1)->getJavaObject() : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/lang/Object;)V";
		char * cMethodName = "setObject";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setShort( INT32 _par0, short _par1 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].s = (INT16)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(IS)V";
		char * cMethodName = "setShort";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].s);
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_sql_PreparedStatement::setBytes( INT32 _par0, BYTE* _par1,ULONG _par2 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		jbyteArray pByteArray = t.pEnv->NewByteArray(_par2);
		t.pEnv->SetByteArrayRegion(pByteArray,0,_par2,(jbyte*)_par1);
		args[1].l = pByteArray;
		// temporaere Variable initialisieren
		char * cSignature = "(I[B)V";
		char * cMethodName = "setBytes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].l);
			// und aufraeumen
		} //mID
		t.pEnv->DeleteLocalRef(pByteArray);
	} //t.pEnv
}

void java_sql_PreparedStatement::setBinaryStream( INT32 _par0, BYTE* _par1,ULONG _par2 )
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		jvalue args2[3];
		jbyteArray pByteArray = t.pEnv->NewByteArray(_par2);
		t.pEnv->SetByteArrayRegion(pByteArray,0,_par2,(jbyte*)_par1);
		args2[0].l =  pByteArray;
		args2[1].i =  0;
		args2[2].i =  (INT32)_par2;

		// temporaere Variable initialisieren
		char * cSignatureStream = "([BII)V";
		// Java-Call absetzen
		jclass aClass = t.pEnv->FindClass("java/io/ByteArrayInputStream");
		jmethodID mID2 = t.pEnv->GetMethodID( aClass, "<init>", cSignatureStream );
		jobject tempObj = NULL;
		if(mID2)
			tempObj = t.pEnv->NewObjectA( aClass, mID2, args2 );

		//
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(ILjava/io/InputStream;I)V";
		char * cMethodName = "setBinaryStream";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			t.pEnv->CallVoidMethod( object, mID, args[0].i,tempObj,(INT32)_par2);
			// und aufraeumen
		t.pEnv->DeleteLocalRef(pByteArray);
		t.pEnv->DeleteLocalRef(tempObj);
		t.pEnv->DeleteLocalRef(aClass);
	} //t.pEnv
}

void java_sql_PreparedStatement::clearParameters()
{
	SDBThreadAttach t;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()V";
		char * cMethodName = "clearParameters";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID);
		} //mID
	} //t.pEnv
}

//**************************************************************
//************ Class: java.sql.CallableStatement
//**************************************************************
BOOL java_sql_CallableStatement::wasNull()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "wasNull";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID );
		} //mID
	} //t.pEnv
	return out;
}

BOOL java_sql_CallableStatement::getBoolean( INT32 _par0 )
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Z";
		char * cMethodName = "getBoolean";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}
BYTE java_sql_CallableStatement::getByte( INT32 _par0 )
{
	jbyte out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)B";
		char * cMethodName = "getByte";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallByteMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}
BOOL java_sql_CallableStatement::getBytes( INT32 _par0, BYTE* &pData,INT32 &nLen)
{
	jbyteArray out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		char * cSignature = "(I)[B";
		char * cMethodName = "getBytes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jbyteArray)t.pEnv->CallObjectMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	if (out)
	{
		jboolean p = FALSE;
		pData = (BYTE*)t.pEnv->GetByteArrayElements(out,&p);
		nLen = t.pEnv->GetArrayLength(out);
		t.pEnv->DeleteLocalRef(out);
		return TRUE;
	}
	else
		return FALSE;
}
java_sql_Date * java_sql_CallableStatement::getDate( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/sql/Date;";
		char * cMethodName = "getDate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Date( t.pEnv, out );
}
double java_sql_CallableStatement::getDouble( INT32 _par0 )
{
	jdouble out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		jvalue args[1];
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)D";
		char * cMethodName = "getDouble";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallDoubleMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

float java_sql_CallableStatement::getFloat( INT32 _par0 )
{
	jfloat out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)F";
		char * cMethodName = "getFloat";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallFloatMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

INT32 java_sql_CallableStatement::getInt( INT32 _par0 )
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)I";
		char * cMethodName = "getInt";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT32)out;
}

jlong java_sql_CallableStatement::getLong( INT32 _par0 )
{
	jlong out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)J";
		char * cMethodName = "getLong";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallLongMethod( object, mID, args[0].i );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

java_lang_Object * java_sql_CallableStatement::getObject( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/lang/Object;";
		char * cMethodName = "getObject";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_lang_Object( t.pEnv, out );
}

short java_sql_CallableStatement::getShort( INT32 _par0 )
{
	jshort out;
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
	jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)S";
		char * cMethodName = "getShort";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallShortMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	return (INT16)out;
}

String java_sql_CallableStatement::getString( INT32 _par0 )
{
	jstring out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	String aStr;
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/lang/String;";
		char * cMethodName = "getString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID, _par0 );
			if(out){
				jboolean bCopy(TRUE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				if(bCopy)
					t.pEnv->ReleaseStringChars(out,pChar);
				t.pEnv->DeleteLocalRef(out);
			}
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return 	aStr;
}

java_sql_Time * java_sql_CallableStatement::getTime( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )

	{
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/sql/Time;";
		char * cMethodName = "getTime";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, _par0);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Time( t.pEnv, out );
}

java_sql_Timestamp * java_sql_CallableStatement::getTimestamp( INT32 _par0 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		// temporaere Variable initialisieren
		char * cSignature = "(I)Ljava/sql/Timestamp;";
		char * cMethodName = "getTimestamp";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? 0 : new java_sql_Timestamp( t.pEnv, out );
}
void java_sql_CallableStatement::registerOutParameter(INT32 _par0,INT32 _type)
{
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_type;
		// temporaere Variable initialisieren
		char * cSignature = "(II)V";
		char * cMethodName = "registerOutParameter";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			t.pEnv->CallVoidMethod( object, mID, args[0].i,args[1].i);
	}
}
java_math_BigDecimal * java_sql_CallableStatement::getBigDecimal( INT32 _par0, INT32 _par1 )
{
	jobject out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){
		jvalue args[2];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_par1;
		// temporaere Variable initialisieren
		char * cSignature = "(II)Ljava/math/BigDecimal;";
		char * cMethodName = "getBigDecimal";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID, args[0].i,args[1].i);
			// und aufraeumen
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out ? new java_math_BigDecimal( t.pEnv, out ) : 0;
}

jclass java_sql_CallableStatement::theClass = 0;

jclass java_sql_CallableStatement::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
		if( !t.pEnv ) return (jclass)0;
		jclass tempClass = t.pEnv->FindClass("java/sql/CallableStatement"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_CallableStatement::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==0  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

BOOL java_sql_CallableStatement::execute()
{
	jboolean out(FALSE);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "execute";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}
//**************************************************************
//************ Class: java.sql.SQLException
//**************************************************************

jclass java_sql_SQLException::theClass = 0;

java_sql_SQLException::~java_sql_SQLException()
{}

jclass java_sql_SQLException::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/sql/SQLException");
		DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		if(!tempClass)
		{
			t.pEnv->ExceptionDescribe();
			t.pEnv->ExceptionClear();
		}
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_SQLException::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

String java_sql_SQLException::getSQLState()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getSQLState";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)	t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);
				for(jsize i=0;i<len;i++)
					aStr += pChar[i];
				t.pEnv->ReleaseStringUTFChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}
INT32 java_sql_SQLException::getErrorCode()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv ){

		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getErrorCode";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}
//**************************************************************
//************ Class: java.sql.SQLWarning
//**************************************************************

jclass java_sql_SQLWarning::theClass = 0;

java_sql_SQLWarning::~java_sql_SQLWarning()
{}

jclass java_sql_SQLWarning::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/sql/SQLWarning" );
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_sql_SQLWarning::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

